/*$Id: avtprukr.c,v 5.30 2011-06-23 09:58:02 sasa Exp $*/
/*10.12.2010	16.11.2002	Белых А.И.	avtprukr.c
Подпрограмма автоматического выполнения проводок для "Учета командировочных расходов"
*/

#include        <time.h>
#include        <errno.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


void avtprukr(short dd,short md,short gd,
const char *nomdok)
{
FILE *ff_prot=NULL;
class iceb_tu_str vstr("");
char		strsql[512];
int		kolstr=0;
SQL_str		row;
char		kodop[32];
char		kodops[32];
char		shetu[32];
char		shetkr[32];
char		shetnds[32];
class iceb_tu_str kodu("");
class iceb_tu_str kodkr("");
class iceb_tu_str kodnds("");;
char		koment[512];
double		deb=0.;
double		kre=0.;
short		dp=0,mp=0,gp=0;
class iceb_tu_str kodkont("");
class iceb_tu_str kodr("");
struct OPSHET	shetv;
char		nomao[32]; //Номер авансового отчета
class iceb_tu_str kodkontr("");
SQLCURSOR curr;
int kekv=0;
class SPISOK sp_prov;
class masiv_din_double sum_prov_dk;
SQL_str row_alx;
class SQLCURSOR cur_alx;
int metka_vkontr=2; /*метка режима выполнения проводки для контрагента если его нет в списке счёта 0-запрос 2-автоматическая вставка*/

sprintf(strsql,"select shet,kolih,cena,snds,kontr,sn,ss,kodr from Ukrdok1 where \
datd='%04d-%d-%d' and nomd='%s'",gd,md,dd,nomdok);

SQLCURSOR cur;

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
if(kolstr == 0)
 return;

//Узнаем дату авансового отчета

sprintf(strsql,"select kont,vkom,nomao,datao from Ukrdok where god=%d and nomd='%s'",gd,nomdok);
if(sql_readkey(&bd,strsql,&row,&curr) == 1)
 {
  kodkont.new_plus(row[0]);
  strcpy(kodop,row[1]);
  strcpy(nomao,row[2]);
  rsdat(&dp,&mp,&gp,row[3],2);
 }
else
 return;
 
if(dp == 0)
 {
  VVOD VVOD1(2);
  VVOD1.VVOD_SPISOK_add_MD(gettext("Введите дату авансового отчета"));
  vstr.new_plus("");
  int kom=0;  
  if((kom=vvod1(&vstr,11,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
    return;
  if(kom == ESC)
    return;

  if(rsdat(&dp,&mp,&gp,vstr.ravno(),1) != 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата авансового отчета !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return;
   }

  sprintf(strsql,"update Ukrdok set datao='%04d-%d-%d' where god=%d and nomd='%s'",
  gp,mp,dp,gd,nomdok);
  
  sql_zapis(strsql,1,0);
  
 }

if(iceb_t_pvglkni(mp,gp) != 0)
 return;

sprintf(strsql,"select str from Alx where fil='avtprukr.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Не найдены настройки avtprukr.alx\n");
  return;
 }

memset(koment,'\0',sizeof(koment));
if(nomao[0] != '\0')
 sprintf(koment,"N%s",nomao);
 
while(cur.read_cursor(&row) != 0)
 {
  cur_alx.poz_cursor(0);
  while(cur_alx.read_cursor(&row_alx) != 0)
   {
    if(row_alx[0][0] == '#')
     continue;

    if(polen(row_alx[0],kodops,sizeof(kodops),1,'|') != 0)
     continue;

    if(polen(row_alx[0],&kodr,6,'|') == 0)
     {
      if(kodr.ravno_atoi() != 0)
       if(atoi(row[7]) != kodr.ravno_atoi())
        continue;
     }

    if(SRAV(kodop,kodops,0) != 0)
     continue;

    memset(shetu,'\0',sizeof(shetu));
    if(polen(row_alx[0],shetu,sizeof(shetu),2,'|') != 0)
     continue;

    if(SRAV(row[0],shetu,0) != 0)
     continue;

    memset(shetkr,'\0',sizeof(shetkr));
    if(polen(row_alx[0],shetkr,sizeof(shetkr),3,'|') != 0)
     continue;
    
    memset(shetnds,'\0',sizeof(shetnds));
    
    if(row[5][0] != '\0')
     strncpy(shetnds,row[5],sizeof(shetnds));
    else
     if(polen(row_alx[0],shetnds,sizeof(shetkr),4,'|') != 0)
       continue;

    polen(row_alx[0],&kekv,5,'|');

    kodu.new_plus(kodkont.ravno());
    if(provsh(&kodu,shetu,&shetv,metka_vkontr,0) != 0)
       continue;

    kodkr.new_plus(kodkont.ravno());
    if(provsh(&kodkr,shetkr,&shetv,metka_vkontr,0) != 0)
       continue;

    kodnds.new_plus(kodkont.ravno());
    if(provsh(&kodnds,shetnds,&shetv,metka_vkontr,0) != 0)
       continue;

    kodkontr.new_plus(row[4]);
    if(kodkontr.getdlinna() > 1)
     if(provsh(&kodkontr,shetkr,&shetv,metka_vkontr,0) != 0)
       continue;
    
    //Проводка на сумму без НДС
    kre=0.;
    deb=atof(row[2])+atof(row[6]);
    if(kodkontr.getdlinna() <= 1)            
      zapmpr(gp,mp,dp,shetu,shetkr,kodu.ravno(),kodkr.ravno(),deb,kre,koment,2,kekv,&sp_prov,&sum_prov_dk,ff_prot);
    else
     {
      zapmpr(gp,mp,dp,shetkr,shetkr,kodkr.ravno(),kodkontr.ravno(),deb,kre,koment,2,kekv,&sp_prov,&sum_prov_dk,ff_prot);
      zapmpr(gp,mp,dp,shetu,shetkr,kodkontr.ravno(),kodkontr.ravno(),deb,kre,koment,2,kekv,&sp_prov,&sum_prov_dk,ff_prot);
     }

    //Проводка на сумму НДС
    kre=0.;
    deb=atof(row[3]);
            
    zapmpr(gp,mp,dp,shetnds,shetkr,kodnds.ravno(),kodkr.ravno(),deb,kre,koment,2,kekv,&sp_prov,&sum_prov_dk,ff_prot);
   }

  
 }


/*Запись проводок из памяти в базу*/
int pod=0;
time_t vrem=0;
time(&vrem);
char tipd[8];
sprintf(tipd,gettext("УКР"));

zapmpr1(nomdok,kodop,pod,vrem,tipd,dd,md,gd,0,&sp_prov,&sum_prov_dk,ff_prot);


}
