/*$Id: b_ukrsoc.c,v 5.9 2011-03-28 06:53:58 sasa Exp $*/
/*09.06.2006	09.06.2006	Белых А.И.	b_ukrsoc.c
Экспорт платёжки для "Укрсоц" банка.

Формат файлов: текстовый; Кодировка:DOS(CP-866); Разделитель полей: "|" (пайп);

Имя файла "c_epd.txt"
1 Номер строки в файле (Начиная с 1)
2 Статус документа (всегда 0)
3 Дебет МФО
4 Дебет счёт
5 Дебет ОКПО
6 Кредит МФО
7 Кредит счёт
8 Кредит МФО
9 Дата документа (ДД.ММ.ГГГГ) (разделитель "точка" ASCII 46)
10 Номер документа
11 Название плательщика (до 38 символов)
12 Название получателя  (до 38 символов)
13 Сумма документа (формат например 210.00)
14 Дата акцепта (не заполняется)
15 Время акчепта (не заполняется)
16 Назначение платежа (до 160 символов)
17 Валюта (по умолчанию 980, если не заполнено)
18 Информационный (значение:F,T. По умолчанию F, если не заполнено)
19 Код назначения платежа НБУ (по умолчанию 0, если не заполнено)
*/
#include        <errno.h>
#include        <math.h>
#include        "buhg.h"
#include        "dok4.h"

extern struct REC rec;

void b_ukrsoc(const char *tabl)
{
char		imaf[32],imaf1[32];
FILE		*ff,*ff1;
char		stt[1024];
class iceb_tu_str koment("");
char		strsql[512];
short		d,m,g;
char		nomerdok[32];

sprintf(imaf,"platp.txt");
if((ff = fopen(imaf,"r")) == NULL)
 {
 if(errno == ENOENT)
  {
   return;
  }
 else
   {
    error_op_nfil(imaf,errno,"");
    return;
   }
 }
sprintf(imaf1,"plat.txt");
if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return;
 }
int nom_str=0;
while(fgets(stt,sizeof(stt),ff) != NULL)
 {
  polen(stt,strsql,sizeof(strsql),1,'|');
  rsdat(&d,&m,&g,strsql,1);
  polen(stt,nomerdok,sizeof(nomerdok),2,'|');

  if(readpdok(tabl,g,nomerdok) != 0)
     continue;

  /*Читаем комментарий*/
  readkom(tabl,rec.dd,rec.md,rec.gd,rec.nomdk,&koment);


  fprintf(ff1,"%d|0|%s|%s|%s|%s|%s|%s|%02d.%02d.%04d|%s|%.38s|%.38s|%.2f|||%s|980|\n",
  ++nom_str,
  rec.mfo,
  rec.nsh,
  rec.kod,
  rec.mfo1,
  rec.nsh1,
  rec.kod1,
  d,m,g,
  nomerdok, 
  rec.naior,
  rec.naior1,
  rec.sumd,
  koment.ravno());
  
  
 }

fclose(ff1);
fclose(ff);

}
