/*$Id: buh_rnr_v6_2.c,v 5.11 2011-01-13 13:43:21 sasa1 Exp $*/
/*15.12.2009	03.04.2007	Белых А.И.	buh_rnr_v6_2.c
Расчёт налоговых разниц - ведомость 6.1-п
*/
#include <math.h>
#include <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void buh_rnr_v6_2_rasmas(short dn,short mn,short gn,short dk,short mk,short gk,char *imaf,class SPISOK *kre_shet,class SPISOK *deb_shet_p,class SPISOK *kre_shet_p,class masiv_din_double *suma_za_mes,class masiv_din_double *suma_za_god);

extern char *organ;

int buh_rnr_v6_2(class spis_oth *oth)
{
static char dat1[11],dat2[11];
int kom=0;
char strsql[1024];

VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Расчет ведомости 6.1-п."));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала.(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца..(д.м.г).."));

VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2)); 

naz:;

clear();
 
helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F5",gettext("настройка"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

move(LINES-1,0);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
//   prosf(strsql);
   goto naz;

  case ESC:
  case FK10:
   return(1);

  case FK2:
  case PLU:
     break;



  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }

GDITE();

short           dn,mn,gn;
short           dk,mk,gk;

if(rsdatp(&dn,&mn,&gn,dat1,&dk,&mk,&gk,dat2) != 0)
 goto naz;

class SPISOK kre_shet;
class SPISOK deb_shet;

deb_shet.plus("80");
deb_shet.plus("81");
deb_shet.plus("82");
deb_shet.plus("83");
deb_shet.plus("84");

kre_shet.plus("10");
kre_shet.plus("11");
kre_shet.plus("12");
kre_shet.plus("13");
kre_shet.plus("14");
kre_shet.plus("15");
kre_shet.plus("16");
kre_shet.plus("17");
kre_shet.plus("18");
kre_shet.plus("20");
kre_shet.plus("22");
kre_shet.plus("23");
kre_shet.plus("24");
kre_shet.plus("25");
kre_shet.plus("26");
kre_shet.plus("28");
kre_shet.plus("30");
kre_shet.plus("31");
kre_shet.plus("33");
kre_shet.plus("34");
kre_shet.plus("35");
kre_shet.plus("36");
kre_shet.plus("37");
kre_shet.plus("38");
kre_shet.plus("39");
kre_shet.plus("47");
kre_shet.plus("50");
kre_shet.plus("51");
kre_shet.plus("54");
kre_shet.plus("60");
kre_shet.plus("62");
kre_shet.plus("63");
kre_shet.plus("64");
kre_shet.plus("65");
kre_shet.plus("66");
kre_shet.plus("68");

class SPISOK deb_shet_p;
class SPISOK kre_shet_p;

class SPISOK deb_shet_p_3z;
class SPISOK kre_shet_p_2z;

int kolstr=0;
SQL_str row;
class SQLCURSOR cur;
//создаём список дебетовых счетов
sprintf(strsql,"select distinct sh,shk from Prov where datp >= '%04d-%02d-01' and datp <= '%04d-%02d-%02d' and deb <> 0.",
gn,1,gk,mk,dk);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

while(cur.read_cursor(&row) != 0)
 {
  if(deb_shet.find(row[0],1) >= 0)
   if(kre_shet.find(row[1],1) >= 0)
    {
     if(deb_shet_p.find(row[0]) < 0)
       deb_shet_p.plus(row[0]);
     if(kre_shet_p.find(row[1]) < 0)
       kre_shet_p.plus(row[1]);
      
     memset(strsql,'\0',sizeof(strsql));
     strncpy(strsql,row[0],3);

     if(deb_shet_p_3z.find(strsql) < 0)
      deb_shet_p_3z.plus(strsql);

     memset(strsql,'\0',sizeof(strsql));
     strncpy(strsql,row[1],2);
     
     if(kre_shet_p_2z.find(strsql) < 0)
      kre_shet_p_2z.plus(strsql);
   }
 }

class masiv_din_double suma_za_mes;
class masiv_din_double suma_za_god;

class masiv_din_double suma_za_mes_o;
class masiv_din_double suma_za_god_o;

int kolih_deb=deb_shet_p.kolih();
int kolih_kre=kre_shet_p.kolih();

int kolih_deb_o=deb_shet_p_3z.kolih();
int kolih_kre_o=kre_shet_p_2z.kolih();

suma_za_mes.make_class(kolih_deb*kolih_kre);
suma_za_god.make_class(kolih_kre);

suma_za_mes_o.make_class(kolih_deb_o*kolih_kre_o);
suma_za_god_o.make_class(kolih_kre_o);

//смотрим проводки заполняем массивы

sprintf(strsql,"select datp,sh,shk,deb from Prov where datp >= '%04d-%02d-01' and datp <= '%04d-%02d-%02d' and deb <> 0. ",
gn,1,gk,mk,dk);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
int kolstr1=0;
int nomer_kre=0;
int nomer_deb=0;
int nomer_kre_o=0;
int nomer_deb_o=0;
double suma=0.;
short d,m,g;
printw("Смотрим проводки\n");

while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s %s %s\n",row[0],row[1],row[2],row[3]);
  
  strzag(LINES-1,0,kolstr,++kolstr1);
  
  if((nomer_kre=kre_shet_p.find(row[2])) < 0)
   continue;
  if((nomer_deb=deb_shet_p.find(row[1])) < 0)
   continue;

  nomer_kre_o=kre_shet_p_2z.find(row[2],1);
  nomer_deb_o=deb_shet_p_3z.find(row[1],1);
  if(nomer_deb_o < 0)
   {
    printw("nomer_deb_o = %d\n",nomer_deb_o);
    OSTANOV();
   }
  if(nomer_kre_o < 0)
   {
    printw("nomer_kre_o = %d\n",nomer_kre_o);
    OSTANOV();
   }
  suma=atof(row[3]);
  rsdat(&d,&m,&g,row[0],2);

  if(sravmydat(d,m,g,dn,mn,gn) >= 0)
   {
    suma_za_mes.plus(suma,nomer_deb*kolih_kre+nomer_kre); 
    suma_za_mes_o.plus(suma,nomer_deb_o*kolih_kre_o+nomer_kre_o); 
   }

  suma_za_god.plus(suma,nomer_deb); 
  suma_za_god_o.plus(suma,nomer_deb_o); 
 }

GDITE();
//Распечатываем шахматку с реальными номерами счетов
char imaf[56];
sprintf(imaf,"rnrv1p_%d.lst",getpid());

buh_rnr_v6_2_rasmas(dn,mn,gn,dk,mk,gk,imaf,&deb_shet,&kre_shet_p,&deb_shet_p,&suma_za_mes,&suma_za_god);

//Распечатываем шахматку с урезанными номерами счетов
char imaf_uns[50];
sprintf(imaf_uns,"rnrv1_%d.lst",getpid());

buh_rnr_v6_2_rasmas(dn,mn,gn,dk,mk,gk,imaf_uns,&deb_shet,&kre_shet_p_2z,&deb_shet_p_3z,&suma_za_mes_o,&suma_za_god_o);


//OSTANOV();
sprintf(strsql,"%s %s",imaf_uns,imaf);
oth->spis_imaf.plus(imaf_uns);
oth->spis_naim.plus(gettext("Расчёт ведомости 6.2-п по счетам"));
oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчёт ведомости 6.2-п по субсчетам"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);
}
/**************************/
/*Получение итога по колонке*/
/**************************/
double buh_rnr_v6_2_itogo_kol(int nomer_deb,int kolih_kre,int kolih_deb,class masiv_din_double *suma_mas,
const char *shet,
class SPISOK *kre_shet_p,
int metka_r)//0-получение суммы по колонке 1-проверить естьли в колонке хоть одна сумма
{
double suma_kol=0.;
for(int ii=0; ii <  kolih_kre; ii++)
 {
  if(shet[0] != '\0')
   if(SRAV(shet,kre_shet_p->ravno(ii),1) != 0)
    continue;
  
  suma_kol+=suma_mas->ravno(ii*kolih_deb+nomer_deb);
  if(metka_r == 1)
   if(suma_kol != 0.)
     return(1.);
 }
return(suma_kol);
}

/************************/
/*строка подчёркивания*/
/*************************/
int buh_rnr_v6_2_strpod(int metka,int kolih_deb,int kolih_kre,
class masiv_din_double *suma_mas,
FILE *ff)
{
int kol_shet=0;
if(metka == 0)
 {
  fprintf(ff,"--------------------------------");
  //          12345678901
  for(int ii=0; ii < kolih_deb; ii++)
   {
    //Если колонка с нолями - пропускаем
    if(buh_rnr_v6_2_itogo_kol(ii,kolih_kre,kolih_deb,suma_mas,"",NULL,1) == 0.)
     continue;

    fprintf(ff,"-----------");
  //           12345678901
    kol_shet++;
   }
  for(int ii=0; ii < 2; ii++)
    fprintf(ff,"-----------");

 }

if(metka == 1)
 {
  fprintf(ff,"................................");
  //          12345678901
  for(int ii=0; ii < kolih_deb; ii++)
   {
    //Если колонка с нолями - пропускаем
    if(ii < kolih_deb)
    if(buh_rnr_v6_2_itogo_kol(ii,kolih_kre,kolih_deb,suma_mas,"",NULL,1) == 0.)
     continue;
    fprintf(ff,"...........");
  //           12345678901
    kol_shet++;
   }
  for(int ii=0; ii < 2; ii++)
    fprintf(ff,"...........");
 }

//fprintf(ff,"\n");

return(kol_shet);
}

/**********************************/
/*Получение итога по строке*/
/*******************************/
void buh_rnr_v6_2_str_it(int kolih_deb,int kolih_kre,const char *shet,
class SPISOK *kre_shet_p,
class masiv_din_double *suma_za_mes,
class masiv_din_double *suma_za_god,
FILE *ff)
{
double itogo_gor=0.;
double suma=0.;

for(int nomer_deb=0; nomer_deb < kolih_deb; nomer_deb++)
 {
    //Если колонка с нолями - пропускаем
    if(buh_rnr_v6_2_itogo_kol(nomer_deb,kolih_kre,kolih_deb,suma_za_mes,"",NULL,1) == 0.)
     continue;

  suma=buh_rnr_v6_2_itogo_kol(nomer_deb,kolih_kre,kolih_deb,suma_za_mes,shet,kre_shet_p,0);
  fprintf(ff," %10.2f",suma);
  itogo_gor+=suma;  
 }

double itogo_za_god=0.;
for(int nomer_kre=0; nomer_kre < kolih_kre; nomer_kre++)
 {
  if(shet[0] != '\0')
   if(SRAV(shet,kre_shet_p->ravno(nomer_kre),1) != 0)
    continue;
  itogo_za_god+=suma_za_god->ravno(nomer_kre);
 }
fprintf(ff," %10.2f %10.2f\n",itogo_gor,itogo_za_god);
}

/***********************************/
/*Распечатка массивов*/
/**************************/
void buh_rnr_v6_2_rasmas(short dn,short mn,short gn,
short dk,short mk,short gk,
char *imaf,              
class SPISOK *deb_shet,
class SPISOK *kre_shet_p,
class SPISOK *deb_shet_p,
class masiv_din_double *suma_za_mes,
class masiv_din_double *suma_za_god)
{
FILE *ff;
if((ff=fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

int kolih_kre=kre_shet_p->kolih();
int kolih_deb=deb_shet_p->kolih();

fprintf(ff,"%s\n",organ);

fprintf(ff,"%40s ВІДОМІСТЬ 6.2-п аналітичного обліку витрат (рахунки 80,81,82,83,84)\n","");
fprintf(ff,"%60s за %02d.%02d.%d р. -> %02d.%02d.%d р.\n","",dn,mn,gn,dk,mk,gk);

class iceb_tu_str stroka_dop;
class iceb_tu_str imaf_v1("buh_rnr_ved6_1.alx");

//imafn("buh_rnr_ved6_1.alx",&imaf_v1);

int kolih_str_fil=iceb_t_kolstrfil(imaf_v1.ravno());

int kol_shet_ras=buh_rnr_v6_2_strpod(0,kolih_kre,kolih_deb,suma_za_mes,ff); //строка подчёркивания
int nomer_str_dop=0;
iceb_t_rstrf(++nomer_str_dop,imaf_v1.ravno(),&stroka_dop);
fprintf(ff,"%s",stroka_dop.ravno());
int dlinna_dop=stroka_dop.getdlinna();
/*********
fprintf(ff,"%-10s|%-20.20s|%-*.*s|%-10.10s|%-10.10s|",
gettext("Счёт"),
gettext("Дебет счетов"),
11*kol_shet_ras-1,
11*kol_shet_ras-1,
gettext("Кредит счетов"),
gettext("За месяц"),
gettext("С нач.года"));
**********/
fprintf(ff,"%-*s|%-*.*s|%-*.*s|%-*.*s|%-*.*s|",
iceb_tu_kolbait(10,gettext("Счёт")),gettext("Счёт"),
iceb_tu_kolbait(20,gettext("Дебет счетов")),
iceb_tu_kolbait(20,gettext("Дебет счетов")),
gettext("Дебет счетов"),
iceb_tu_kolbait(11*kol_shet_ras-1,gettext("Кредит счетов")),
iceb_tu_kolbait(11*kol_shet_ras-1,gettext("Кредит счетов")),
gettext("Кредит счетов"),
iceb_tu_kolbait(10,gettext("За месяц")),
iceb_tu_kolbait(10,gettext("За месяц")),
gettext("За месяц"),
iceb_tu_kolbait(10,gettext("С нач.года")),
iceb_tu_kolbait(10,gettext("С нач.года")),
gettext("С нач.года"));

iceb_t_rstrf(++nomer_str_dop,imaf_v1.ravno(),&stroka_dop);
fprintf(ff,"%s",stroka_dop.ravno());

//строка подчёркивания в шапке таблицы
fprintf(ff,"%10s|%20s|","","");
for(int ii=0; ii < kol_shet_ras; ii++)
 fprintf(ff,"-----------");
fprintf(ff,"%10s|%10s","",""); //под итогами
iceb_t_rstrf(++nomer_str_dop,imaf_v1.ravno(),&stroka_dop);
fprintf(ff,"%s",stroka_dop.ravno());


fprintf(ff,"%10s|%20s|","","");
//Распечатываем строку со счетами
for(int nomer_deb=0; nomer_deb < kolih_kre; nomer_deb++)
 {
    //Если колонка с нолями - пропускаем
    if(buh_rnr_v6_2_itogo_kol(nomer_deb,kolih_deb,kolih_kre,suma_za_mes,"",NULL,1) == 0.)
     continue;
  fprintf(ff,"%-10s|",kre_shet_p->ravno(nomer_deb));
 }

fprintf(ff,"%-10.10s|%-10.10s|","","");

iceb_t_rstrf(++nomer_str_dop,imaf_v1.ravno(),&stroka_dop);
fprintf(ff,"%s",stroka_dop.ravno());


int kol_str_ost=kolih_str_fil-nomer_str_dop;
for(int ii=0; ii < kol_str_ost-1; ii++)
 {
  fprintf(ff,"%10s|%20s|","","");
  for(int ii2=0; ii2 < kol_shet_ras; ii2++)
   fprintf(ff,"%10s|","");
  fprintf(ff,"%10s|%10s|","","");
  iceb_t_rstrf(++nomer_str_dop,imaf_v1.ravno(),&stroka_dop);
  fprintf(ff,"%s",stroka_dop.ravno());
 }

buh_rnr_v6_2_strpod(0,kolih_kre,kolih_deb,suma_za_mes,ff); //строка подчёркивания

iceb_t_rstrf(++nomer_str_dop,imaf_v1.ravno(),&stroka_dop);
fprintf(ff,"%s",stroka_dop.ravno());




//Распечатываем
double itogo_gor=0.;
char naim_shet[512];
char strsql[512];
SQL_str row;
class SQLCURSOR cur;
double suma=0.;
for(int ii=0; ii < deb_shet->kolih(); ii++)
 {
  for(int nomer_deb=0; nomer_deb < kolih_deb; nomer_deb++)
   {
    if(SRAV(deb_shet->ravno(ii),deb_shet_p->ravno(nomer_deb),1) != 0)
      continue;  
  
     memset(naim_shet,'\0',sizeof(naim_shet));
     //читаем наименование счёта
     sprintf(strsql,"select nais from Plansh where ns='%s'",deb_shet_p->ravno(nomer_deb));
     if(readkey(strsql,&row,&cur) == 1)
      strncpy(naim_shet,row[0],sizeof(naim_shet)-1);
      
//     fprintf(ff,"%10s %-20.20s",deb_shet_p->ravno(nomer_deb),naim_shet);
     fprintf(ff,"%*s %-*.*s",
     iceb_tu_kolbait(10,deb_shet_p->ravno(nomer_deb)),deb_shet_p->ravno(nomer_deb),
     iceb_tu_kolbait(20,naim_shet),iceb_tu_kolbait(20,naim_shet),naim_shet);
     
     itogo_gor=0.;   
     for(int nomer_kre=0; nomer_kre < kolih_kre; nomer_kre++)
      {
       //Если колонка с нолями - пропускаем
       if(buh_rnr_v6_2_itogo_kol(nomer_kre,kolih_deb,kolih_kre,suma_za_mes,"",NULL,1) == 0.)
        continue;

       suma=suma_za_mes->ravno(nomer_deb*kolih_kre+nomer_kre);
       fprintf(ff," %10.2f",suma);
       itogo_gor+=suma;
      }
     fprintf(ff," %10.2f %10.2f\n",itogo_gor,suma_za_god->ravno(nomer_deb));
   }
  buh_rnr_v6_2_strpod(1,kolih_kre,kolih_deb,suma_za_mes,ff); //строка подчёркивания
  for(int ii2=0; ii2 < dlinna_dop-2; ii2++) //Дополняем сроку подчёркивания 
   fprintf(ff,".");
  fprintf(ff,"\n"); 

  memset(naim_shet,'\0',sizeof(naim_shet));
  //читаем наименование счёта
  sprintf(strsql,"select nais from Plansh where ns='%s'",deb_shet->ravno(ii));
  if(readkey(strsql,&row,&cur) == 1)
   strncpy(naim_shet,row[0],sizeof(naim_shet)-1);

  sprintf(strsql,"%s %s",gettext("Итого"),deb_shet->ravno(ii));
//  fprintf(ff,"%10.10s %-20.20s",strsql,naim_shet);
  fprintf(ff,"%*.*s %-*.*s",
  iceb_tu_kolbait(10,strsql),iceb_tu_kolbait(10,strsql),strsql,
  iceb_tu_kolbait(20,naim_shet),iceb_tu_kolbait(20,naim_shet),naim_shet);

  buh_rnr_v6_2_str_it(kolih_kre,kolih_deb,deb_shet->ravno(ii),deb_shet_p,suma_za_mes,suma_za_god,ff);
  fprintf(ff,"\n");
 }

buh_rnr_v6_2_strpod(0,kolih_kre,kolih_deb,suma_za_mes,ff); //строка подчёркивания

for(int ii=0; ii < dlinna_dop-2; ii++) //Дополняем сроку подчёркивания 
 fprintf(ff,"-");
fprintf(ff,"\n"); 

fprintf(ff,"%*s",iceb_tu_kolbait(32,gettext("Итого")),gettext("Итого"));

buh_rnr_v6_2_str_it(kolih_kre,kolih_deb,"",deb_shet_p,suma_za_mes,suma_za_god,ff);


podpis(ff);

fclose(ff);

}
