/*$Id: buhkom.c,v 5.32 2011-01-13 13:43:21 sasa1 Exp $*/
/*17.02.2010	29.12.2004	Белых А.И.	buhkom.c
Отчёт по введенным комментариям
*/
#include <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

int prov_kom(class SPISOK *koment,char *row,int kol_koment);
void buhkom_sh(char *shet,char *naim,FILE *ff);
void buhkom_sh_deb(char *shet,char *naim,FILE *ff);
void buhkom_it(int metka_i,double deb,double kre,FILE *ff);
void buhkom_it_dk(int metka_i,double deb,FILE *ff);
void buhkom_sh_kre(char *shet,char *naim,FILE *ff);

extern char *organ;

int buhkom(class spis_oth *oth)
{
static  char    dat1[11],dat2[11];
static class iceb_tu_str sheta("");
int kom=0;
short dn,mn,gn;
short dk,mk,gk;
char strsql[512];

VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Отчёт по комментариям"));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала.(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца..(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Счет..........(,,)..."));

VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2)); 
VV.VVOD_SPISOK_add_data(sheta.ravno(),112);

naz:;

clear();
 
helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F4",gettext("очистить"),
"F5",gettext("настройка"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

move(LINES-1,0);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
sheta.new_plus(VV.data_ravno(2));

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("buhg5_6.txt");
   goto naz;

  case ESC:
  case FK10:
   return(1);

  case FK2:
  case PLU:
     break;


  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  case FK5:
    iceb_redfil("buhkom.alx",0);
    goto naz;

  default:
     goto naz;
 }


if(rsdatp(&dn,&mn,&gn,dat1,&dk,&mk,&gk,dat2) != 0)
 goto naz;


/********************************************/
GDITE();

//Запоминаем список комментариев
int kolstr;
SQL_str row;
class SQLCURSOR cur;

sprintf(strsql,"select str from Alx where fil='buhkom.alx' order by ns asc");
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  iceb_t_soob("Не найдены настройки buhkom.alx");
  return(1);
 }

class SPISOK koment;
char bros[1024];

while(cur.read_cursor(&row) != 0)
 {
  if(row[0][0] == '#')
   continue;
  if(polen(row[0],bros,sizeof(bros),1,'|') != 0) 
   continue;
  koment.plus(bros);
 }
 

int kol_koment=koment.kolih();
if(kol_koment == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной настройки !"));
  goto naz;
 }

sprintf(strsql,"select sh,shk,deb,kre,komen from Prov \
where val=0 and datp >= '%d-%02d-%02d' and \
datp <= '%d-%02d-%02d' and komen <> ''",gn,mn,dn,gk,mk,dk);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не найдено проводок !"));
  goto naz;
 }
int nomer=0;
int kolstr1=0;
class SPISOK sh_shk_kom;
double deb,kre;
masiv_din_double debet;
masiv_din_double kredit;
while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s %s %s %s\n",row[0],row[1],row[2],row[3],row[4]);
//  refresh();
  
  strzag(LINES-1,0,kolstr,++kolstr1);
  
  if(proverka(sheta.ravno(),row[0],0,0) != 0)
    continue;
//  if(proverka(sheta.ravno(),row[1],0,0) != 0)
//    continue;
  
  if((nomer=prov_kom(&koment,row[4],kol_koment)) < 0)
   continue;
//  printw("Подходит %s\n",koment.ravno(nomer));
//  OSTANOV();
  deb=atof(row[2]);
  kre=atof(row[3]);
  
  sprintf(strsql,"%s|%s|%s",row[0],koment.ravno(nomer),row[1]);
  if((nomer=sh_shk_kom.find(strsql)) < 0)
    sh_shk_kom.plus(strsql);
  debet.plus(deb,nomer);
  kredit.plus(kre,nomer);    
 }

int kol_shet=sh_shk_kom.kolih();
if(kol_shet == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной проводки с указанными комментариями !"));
  return(1);
 }
GDITE();
FILE *ff;
char imaf_sort[40];
sprintf(imaf_sort,"kom%d.tmp",getpid());

if((ff = fopen(imaf_sort,"w")) == NULL)
   {
    error_op_nfil(imaf_sort,errno,"");
    return(1);
   }

for(int i=0; i < kol_shet ; i++)
 fprintf(ff,"%s|%.2f|%.2f|\n",sh_shk_kom.ravno(i),debet.ravno(i),kredit.ravno(i));

fclose(ff);

//sprintf(strsql,"sort -o %s -t\\|  +0 -1 +1 -2  %s",imaf_sort,imaf_sort);
sprintf(strsql,"sort -o %s -t\\|  -k1,2 -k2,3 %s",imaf_sort,imaf_sort);

runsystem1(strsql,1);

FILE *ff_sort;
if((ff_sort = fopen(imaf_sort,"r")) == NULL)
   {
    error_op_nfil(imaf_sort,errno,"");
    return(1);
   }

unlink(imaf_sort);

time_t vrem;
time(&vrem);
struct tm *bf;
bf=localtime(&vrem);

char imaf[40];
sprintf(imaf,"kom%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return(1);
   }
zagolov(gettext("Отчёт по комментариям"),bf,dn,mn,gn,dk,mk,gk,organ,ff);

if(sheta.ravno()[0] != '\0')
  fprintf(ff,"%s:%s\n",gettext("Счёт"),sheta.ravno());

char shet[32];
char shet_z[30];
char shetk[30];
char komentar[100];
char komentar_z[100];
double ideb=0.,ikre=0.;
double idebk=0.,ikrek=0.;
char stroka[1024];
char naim[512];

memset(shet_z,'\0',sizeof(shet_z));
memset(komentar_z,'\0',sizeof(komentar_z));
//распечатываем дебет и кредит
while(fgets(stroka,sizeof(stroka),ff_sort) != NULL)
 {
  polen(stroka,shet,sizeof(shet),1,'|');
  polen(stroka,komentar,sizeof(komentar),2,'|');
  polen(stroka,shetk,sizeof(shetk),3,'|');
  polen(stroka,strsql,sizeof(strsql),4,'|');
  deb=atof(strsql);
  polen(stroka,strsql,sizeof(strsql),5,'|');
  kre=atof(strsql);
    
  if(SRAV(komentar_z,komentar,0) != 0)
   {
    if(komentar_z[0] != '\0')
      buhkom_it(0,idebk,ikrek,ff);
    idebk=ikrek=0.;
    strcpy(komentar_z,komentar);
   }

  if(SRAV(shet,shet_z,0) != 0)
   {
    if(shet_z[0] != '\0')
     {
      if(idebk != 0. || ikrek != 0.)
       {
        buhkom_it(0,idebk,ikrek,ff);
        idebk=ikrek=0.;
       }
      buhkom_it(1,ideb,ikre,ff);
     }
    memset(naim,'\0',sizeof(naim));
    sprintf(strsql,"select nais from Plansh where ns='%s'",shet);
    if(sql_readkey(&bd,strsql,&row,&cur) == 1)
     strncpy(naim,row[0],sizeof(naim)-1);

    buhkom_sh(shet,naim,ff);
     
    ideb=ikre=0.;
    strcpy(shet_z,shet);
   }

  fprintf(ff,"%-*s %-*s %10.2f %10.2f\n",
  iceb_tu_kolbait(10,komentar),komentar,
  iceb_tu_kolbait(7,shetk),shetk,
  deb,kre);
  
  ideb+=deb;
  ikre+=kre;
  idebk+=deb;
  ikrek+=kre;

 }
buhkom_it(0,idebk,ikrek,ff);
buhkom_it(1,ideb,ikre,ff);

podpis(ff);
fclose(ff);

rewind(ff_sort);

char imaf_deb[40];
sprintf(imaf_deb,"komd%d.lst",getpid());
if((ff = fopen(imaf_deb,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return(1);
   }
zagolov(gettext("Отчёт по комментариям"),bf,dn,mn,gn,dk,mk,gk,organ,ff);

if(sheta.ravno()[0] != '\0')
  fprintf(ff,"%s:%s\n",gettext("Счёт"),sheta.ravno());


memset(shet_z,'\0',sizeof(shet_z));
memset(komentar_z,'\0',sizeof(komentar_z));
//распечатываем дебет
while(fgets(stroka,sizeof(stroka),ff_sort) != NULL)
 {

  polen(stroka,strsql,sizeof(strsql),4,'|');
  deb=atof(strsql);
  if(deb == 0.)
   continue;

  polen(stroka,shet,sizeof(shet),1,'|');
  polen(stroka,komentar,sizeof(komentar),2,'|');
  polen(stroka,shetk,sizeof(shetk),3,'|');
    
  if(SRAV(komentar_z,komentar,0) != 0)
   {
    if(komentar_z[0] != '\0')
      buhkom_it_dk(0,idebk,ff);
    idebk=ikrek=0.;
    strcpy(komentar_z,komentar);
   }

  if(SRAV(shet,shet_z,0) != 0)
   {
    if(shet_z[0] != '\0')
     {
      if(idebk != 0. || ikrek != 0.)
       {
        buhkom_it_dk(0,idebk,ff);
        idebk=ikrek=0.;
       }
      buhkom_it_dk(1,ideb,ff);
     }
    memset(naim,'\0',sizeof(naim));
    sprintf(strsql,"select nais from Plansh where ns='%s'",shet);
    if(sql_readkey(&bd,strsql,&row,&cur) == 1)
     strncpy(naim,row[0],sizeof(naim)-1);

    buhkom_sh_deb(shet,naim,ff);
     
    ideb=ikre=0.;
    strcpy(shet_z,shet);
   }

//  fprintf(ff,"%-10s %-7s %10.2f\n",komentar,shetk,deb);
  fprintf(ff,"%-*s %-*s %10.2f\n",
  iceb_tu_kolbait(10,komentar),komentar,
  iceb_tu_kolbait(7,shetk),shetk,
  deb);
  
  ideb+=deb;
  idebk+=deb;

 }
buhkom_it_dk(0,idebk,ff);
buhkom_it_dk(1,ideb,ff);


podpis(ff);
fclose(ff);

rewind(ff_sort);

char imaf_kre[40];
sprintf(imaf_kre,"komk%d.lst",getpid());
if((ff = fopen(imaf_kre,"w")) == NULL)
   {
    error_op_nfil(imaf_kre,errno,"");
    return(1);
   }
zagolov(gettext("Отчёт по комментариям"),bf,dn,mn,gn,dk,mk,gk,organ,ff);

if(sheta.ravno()[0] != '\0')
  fprintf(ff,"%s:%s\n",gettext("Счёт"),sheta.ravno());


memset(shet_z,'\0',sizeof(shet_z));
memset(komentar_z,'\0',sizeof(komentar_z));
ikrek=0.;
ikre=0.;
//распечатываем кредит
while(fgets(stroka,sizeof(stroka),ff_sort) != NULL)
 {
  polen(stroka,strsql,sizeof(strsql),5,'|');
  kre=atof(strsql);
  if(kre == 0.)
   continue;

  polen(stroka,shet,sizeof(shet),1,'|');
  polen(stroka,komentar,sizeof(komentar),2,'|');
  polen(stroka,shetk,sizeof(shetk),3,'|');
    
  if(SRAV(komentar_z,komentar,0) != 0)
   {
    if(komentar_z[0] != '\0')
      buhkom_it_dk(0,ikrek,ff);
    ikrek=0.;
    strcpy(komentar_z,komentar);
   }

  if(SRAV(shet,shet_z,0) != 0)
   {
    if(shet_z[0] != '\0')
     {
      if(ikrek != 0.)
       {
        buhkom_it_dk(0,ikrek,ff);
        ikrek=0.;
       }
      buhkom_it_dk(1,ikre,ff);
     }
    memset(naim,'\0',sizeof(naim));
    sprintf(strsql,"select nais from Plansh where ns='%s'",shet);
    if(sql_readkey(&bd,strsql,&row,&cur) == 1)
     strncpy(naim,row[0],sizeof(naim)-1);

    buhkom_sh_kre(shet,naim,ff);
     
    ikre=0.;
    strcpy(shet_z,shet);
   }

//  fprintf(ff,"%-10s %-7s %10.2f\n",komentar,shetk,kre);
  fprintf(ff,"%-*s %-*s %10.2f\n",
  iceb_tu_kolbait(10,komentar),komentar,
  iceb_tu_kolbait(7,shetk),shetk,
  kre);
  
  ikre+=kre;
  ikrek+=kre;

 }
buhkom_it_dk(0,ikrek,ff);
buhkom_it_dk(1,ikre,ff);


podpis(ff);
fclose(ff);




//Распечатываем проводки

rewind(ff_sort);

char imaf_prov[40];
sprintf(imaf_prov,"komp%d.lst",getpid());
if((ff = fopen(imaf_prov,"w")) == NULL)
   {
    error_op_nfil(imaf_prov,errno,"");
    return(1);
   }
zagolov(gettext("Отчёт по комментариям"),bf,dn,mn,gn,dk,mk,gk,organ,ff);

if(sheta.ravno()[0] != '\0')
  fprintf(ff,"%s:%s\n",gettext("Счёт"),sheta.ravno());
short d,m,g;
char naikon[512];
SQL_str row1;
SQLCURSOR cur1; 
kolstr1=0;
ideb=ikre=0.;
memset(shet_z,'\0',sizeof(shet_z));
memset(komentar_z,'\0',sizeof(komentar_z));
char komentar_prov[200];

while(fgets(stroka,sizeof(stroka),ff_sort) != NULL)
 {
  strzag(LINES-1,0,kol_shet,++kolstr1);

  polen(stroka,shet,sizeof(shet),1,'|');
  polen(stroka,komentar,sizeof(komentar),2,'|');
  polen(stroka,shetk,sizeof(shetk),3,'|');

  if(SRAV(komentar_z,komentar,0) != 0)
   {
    if(komentar_z[0] != '\0')
      raspitog(idebk,ikrek,3,ff);
    idebk=ikrek=0.;
    strcpy(komentar_z,komentar);
   }

  if(SRAV(shet,shet_z,0) != 0)
   {
    if(shet_z[0] != '\0')
     {
      if(idebk != 0. || ikrek != 0.)
       {
        raspitog(idebk,ikrek,3,ff);
        idebk=ikrek=0.;
       }
      raspitog(ideb,ikre,4,ff);
     }
    memset(naim,'\0',sizeof(naim));
    sprintf(strsql,"select nais from Plansh where ns='%s'",shet);
    if(sql_readkey(&bd,strsql,&row,&cur) == 1)
     strncpy(naim,row[0],sizeof(naim)-1);

    fprintf(ff,"\n%s %s\n",shet,naim);
    rapsap(ff);
     
    ideb=ikre=0.;
    strcpy(shet_z,shet);
   }
    
  sprintf(strsql,"select * from Prov \
where val=0 and datp >= '%d-%02d-%02d' and \
datp <= '%d-%02d-%02d' and sh='%s' and shk='%s'  and komen <> ''",gn,mn,dn,gk,mk,dk,shet,shetk);
  int kolstr;
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

  if(kolstr == 0)
   continue;

  while(cur.read_cursor(&row) != 0)
   {
    if(row[13][0] == '\0')
     continue;
    if(strstrm(row[13],komentar) == 0)
      continue;
    rsdat(&d,&m,&g,row[1],2);
    deb=atof(row[9]);
    kre=atof(row[10]);
    ideb+=deb;
    ikre+=kre;
    idebk+=deb;
    ikrek+=kre;
    
    memset(naikon,'\0',sizeof(naikon));;
    
    if(row[4][0] != '\0')
     {  
      sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",
      row[4]);
      int i;
      if((i=sql_readkey(&bd,strsql,&row1,&cur1)) != 1)
       {
        printw("%02d.%02d.%d %-5s %-5s %-5s %-3s %-4s %10.2f %10.2f %s%-10.10s\n\
  Error %d\n",      
        d,m,g,row[2],row[3],row[4],row[5],row[6],
        deb,kre,row[8],row[13],i);
        beep();
        printw("\n%s %s\n",gettext("Не найден код контрагента"),row[4]);
        OSTANOV();
       }
      else
       strncpy(naikon,row1[0],sizeof(naikon)-1);
     }       

    sozkom(komentar_prov,sizeof(komentar_prov),row[13],row[5],row[8]);

    fprintf(ff,"%02d.%02d.%4d %-*s %-*s %-*s %-3s%4s %-*s %10s",
    d,m,g,
    iceb_tu_kolbait(6,row[2]),row[2],
    iceb_tu_kolbait(6,row[3]),row[3],
    iceb_tu_kolbait(5,row[4]),row[4],
    row[5],row[11],
    iceb_tu_kolbait(10,row[6]),row[6],
    prnbr(deb));

    fprintf(ff," %10s %s %-*s %s\n",
    prnbr(kre),
    row[8],
    iceb_tu_kolbait(32,komentar_prov),komentar_prov,
    naikon);
   }   
 }
raspitog(idebk,ikrek,3,ff);
raspitog(ideb,ikre,4,ff);


podpis(ff);
fclose(ff);

fclose(ff_sort);


oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Отчёт по комментариям"));

oth->spis_imaf.plus(imaf_deb);
oth->spis_naim.plus(gettext("Отчёт по комментариям (дебет)"));

oth->spis_imaf.plus(imaf_kre);
oth->spis_naim.plus(gettext("Отчёт по комментариям (кредит)"));

oth->spis_imaf.plus(imaf_prov);
oth->spis_naim.plus(gettext("Распечатка проводок"));
/*так захотел клиент из Шепетовки*/
for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),1);
return(0);
}
/**************************/
/*Проверка комментария*/
/***************************/
//Возвращаем номер комментария или -1 
int prov_kom(class SPISOK *koment,char *row,int kol_koment)
{
if(row[0] == '\0')
 return(-1);
for(int i=0; i < kol_koment;i++)
 {
//printw("проверяем %s | %s\n",row,koment->ravno(i));
  if(strstrm(row,koment->ravno(i)) != 0)
    return(i);
 }    
return(-1);

}
/***************************/
/*шапка*/
/**************************/

void buhkom_sh(char *shet,char *naim,FILE *ff)
{

fprintf(ff,"\n%s %s\n",shet,naim);
fprintf(ff,"\
-----------------------------------------\n");
fprintf(ff,gettext("\
Коментарий| Счёт  | Дебет    |  Кредит  |\n"));
fprintf(ff,"\
-----------------------------------------\n");

}
/***************************/
/*шапка*/
/**************************/

void buhkom_sh_deb(char *shet,char *naim,FILE *ff)
{

fprintf(ff,"\n%s %s\n",shet,naim);
fprintf(ff,"\
------------------------------\n");
fprintf(ff,gettext("\
Коментарий| Счёт  | Дебет    |\n"));
fprintf(ff,"\
------------------------------\n");

}
/***************************/
/*шапка*/
/**************************/

void buhkom_sh_kre(char *shet,char *naim,FILE *ff)
{

fprintf(ff,"\n%s %s\n",shet,naim);
fprintf(ff,"\
------------------------------\n");
fprintf(ff,gettext("\
Коментарий| Счёт  |  Кредит  |\n"));
fprintf(ff,"\
------------------------------\n");

}
/************************/
/*выдача итога*/
/*************************/
void buhkom_it(int metka_i,double deb,double kre,FILE *ff)
{
if(metka_i == 0)
  fprintf(ff,"%18s %10.2f %10.2f\n",gettext("Итого"),deb,kre);

if(metka_i == 1)
  fprintf(ff,"%18s %10.2f %10.2f\n",gettext("Итого по счёту"),deb,kre);
}

/************************/
/*выдача итога*/
/*************************/
void buhkom_it_dk(int metka_i,double deb,FILE *ff)
{
if(metka_i == 0)
  fprintf(ff,"%*s %10.2f\n",iceb_tu_kolbait(18,gettext("Итого")),gettext("Итого"),deb);

if(metka_i == 1)
  fprintf(ff,"%*s %10.2f\n",iceb_tu_kolbait(18,gettext("Итого по счёту")),gettext("Итого по счёту"),deb);
}
