/* $Id: dirtab.c,v 5.32 2011-01-13 13:43:21 sasa1 Exp $ */
/*09.12.2009	21.05.1999	Белых А.И.	dirtab.c
Просмотр списка табельных номеров
*/
#include        <pwd.h>
#include        <errno.h>
#include        <time.h>
#include        <ctype.h>
#include        "buhg.h"

class dirtab_poi
 {
  public:
  char		obr[512]; //фамилия
  char		inn[32]; //идентефикационный код
  char  karts[2];
  short metka_poi; //0-поиска нет 1-есть

  dirtab_poi()
   {
    clear_data();
   }   
  void clear_data()
   {
    memset(obr,'\0',sizeof(obr));
    memset(inn,'\0',sizeof(inn));
    memset(karts,'\0',sizeof(karts));
    metka_poi=0;
   }
 };
 
void		sapptab(int,int,int,int,class dirtab_poi*,short);
int		provp(int,class dirtab_poi*,int,char[],int,SQL_str row);

extern char     *organ;
extern short	mmm,ggg;

int dirtab(int *tbn,//Табельный номер
class iceb_tu_str *fio, //Фамилия
int podr, //Код подразделения
int reg)  //0-ввод и корректир 1-выбор
{
char strokamenu[1024];
FILE		*ff;
char		imaf[24];
struct  tm      *bf;
time_t          tmm;
int		kom,kom1;
long		pozz,pozz1;
long		kolstr;
SQL_str         row,row1;
char		strsql[512];
int		pod;
int		mp;  /*0-всех 1-работающих 2-уволенных*/
int		mp1;  /*0-всех 1-имеющих настр. запись 2-не имеющих*/
int		mprov; //0-всех 1-без проводок
int		i;
int		K;
int		prc;
long		tabel=0;
char		mpz[32];
double		sald,saldb;
short		pokz; /*0-не показывать сальдо 1 показывать*/
class iceb_t_mstr spis_menu(0);
short		ds,ms,gs;
short		msor; /*0-по фамилиям 1-по табельным номерам*/
short		mspz; /*метка соответствия первой записи*/
short		dnei,kdn;
double		has;
class dirtab_poi poi;
class spis_oth oth;
char  naimb[512];
int kodbanka=0;
//Создаем класс меню
VVOD VV(0);
mp=1;
msor=mp1=mprov=0;

pod=podr;
pokz=kom=pozz=pozz1=0;

/*Пpи получении 13 месяца ничего не меняем чтобы получить пpавильное сальдо*/
ds=1;
ms=mmm;
gs=ggg;

dpm(&ds,&ms,&gs,3);

naz1:;
clear();
GDITE();
short		kls=LINES-5;

K=0;
if(pod == 0)
 {
  if(msor == 0)
    sprintf(strsql,"select tabn,fio,datk,inn,sovm,bankshet,kb from Kartb order by fio asc");
  else
    sprintf(strsql,"select tabn,fio,datk,inn,sovm,bankshet,kb from Kartb order by tabn asc");
 }
else
 {
  if(msor == 0)
   sprintf(strsql,"select tabn,fio,datk,inn,sovm,bankshet,kb from Kartb where podr=%d \
order by fio asc",pod);
  else
   sprintf(strsql,"select tabn,fio,datk,inn,sovm,bankshet,kb from Kartb where podr=%d \
order by tabn asc",pod);
 } 
/*
printw("%s\n",strsql);
OSTANOV();
*/
SQLCURSOR cur,cur1;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {

lll:;

  sapptab(pod,mp,mp1,mprov,&poi,pokz);

  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  K=soobshw(&SOOB,stdscr,-1,-1,1,1);

  if(K == FK3 || K == FK5)
    goto lll;

  if(K == KEY_RESIZE)
   goto naz1;

  goto vper;

 }

naz:;
GDITE();
clear();

if(kolstr != 0 && pozz > kolstr)
  pozz = kolstr-1;

cur.poz_cursor(pozz);
mspz=2;
pozz1=0;
spis_menu.spis_str.free_class();
for(i=0; i < kls ;)
 {

  if(cur.read_cursor(&row) == 0)
    break;
//  printw("%s %s %s %s %s\n",row[0],row[1],row[2],row[3],row[4]);
  pozz1++;

  memset(mpz,'\0',sizeof(mpz));
  if(provp(mp,&poi,mp1,mpz,mprov,row) != 0)
    continue;
  
  if(row[4][0] == '1')
   strcat(mpz,"S");      
  memset(naimb,'\0',sizeof(naimb));
  if((kodbanka=atoi(row[6])) != 0)
   {
    sprintf(strsql,"select naik from Zarsb where kod=%d",kodbanka);
    if(readkey(strsql,&row1,&cur1) == 1)
     strncpy(naimb,row1[0],sizeof(naimb)-1);
   }
  /*Вычислям зарплату*/
  if(pokz == 1)
   {
    tabel=atol(row[0]);
    sald=zarsald(1,ms,gs,tabel,&saldb);
    vztb(tabel,mmm,ggg,&dnei,&has,&kdn,2,NULL);
    sprintf(strsql,"%-5s|%-*.*s|%8.2f|%2d|%1s",
    row[0],
    iceb_tu_kolbait(30,row[1]),iceb_tu_kolbait(30,row[1]),row[1],
    sald,dnei,mpz);
   }
  else
   sprintf(strsql,"%-5s|%-*.*s|%-2s|%s",
   row[0],
   iceb_tu_kolbait(40,row[1]),iceb_tu_kolbait(40,row[1]),row[1],
   mpz,naimb);

  sprintf(strokamenu,"%.*s",COLS-24,strsql);
  spis_menu.spis_str.plus(strokamenu);
  i++;

  if(pozz1 == 1) /*Первая запись удовлетворяет условиям поиска*/
     mspz=1;

 }

if(kom >= i)
  kom=i-1;

if(kom < 0)
 kom=0;
if(i == 0)
 {
  if(kolstr > 0 && pozz > 0)
   {
    pozz--;
    goto naz;
   }
  goto lll;
 }

if(i <= kls-1)
  spis_menu.spis_str.plus(gettext("Конец списка"));

sapptab(pod,mp,mp1,mprov,&poi,pokz);

prc=(pozz+pozz1)*100/kolstr;
memset(strsql,'\0',sizeof(strsql));
kom=spis_menu.menu(kom,2,0,NULL,strsql,prc,&K,"",0);


if(kom == -7) //Изменение размеров экрана
 goto naz1;
 
if(kom == -3) /*Стрелка вниз*/
 {
  if(i <kls)
   {
    beep();
    goto naz;
   }
  for(i=0; i < mspz  ; )
//  for(i=0; i<1  ; )
   {
    pozz++;

    cur.poz_cursor(pozz);
    if(cur.read_cursor(&row) == 0)
      break;

    if(provp(mp,&poi,mp1,mpz,mprov,row) != 0)
      continue;

    i++;
   }
  kom=kls;
  goto naz;
 }
if(kom == -2) /*Стрелка вверх*/
 {
  for(i=0; i < 1 ; )
   {

    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    cur.read_cursor(&row);


    if(provp(mp,&poi,mp1,mpz,mprov,row) != 0)
      continue;
    i++;
   }

  goto naz;
 }
 
if(kom == -5) /*Страница вниз*/
 {
/*
  printw("\n вперед pozz=%d kolst=%d kls=%d pozz1=%d\n",
  pozz,kolstr,kls,pozz1);
  OSTANOV();
*/
  if(pozz + kls == kolstr)
   {
    pozz=kolstr-1;
    beep();
    goto naz;  
   }
  if(i == kls)
    pozz+=pozz1;
  else
    beep();

  if(pozz >= kolstr)
   {
    pozz=kolstr-pozz1;
    beep();
    goto naz;  
   }
/*  
  printw("\n вперед pozz=%d\n",pozz);
  OSTANOV();
*/
  goto naz;

 }

if(kom == -4) /*Страница вверх*/
 {
/*
  printw("\npozz=%d\n",pozz);
  refresh();
*/
  for(i=0; i<kls ; )
   {
    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    cur.read_cursor(&row);


    if(provp(mp,&poi,mp1,mpz,mprov,row) != 0)
      continue;
    i++;
   }
  goto naz;
 }

if(kom >= 0)
 {
  if(SRAV(gettext("Конец списка"),spis_menu.spis_str.ravno(kom),0) == 0)
     goto naz;
  if(pozz+kom >= kolstr)
   goto naz;
  POLE(spis_menu.spis_str.ravno(kom),strsql,1,'|');
  tabel=atol(strsql);
  polen(spis_menu.spis_str.ravno(kom),fio,2,'|');
 }

vper:;

switch (K)
 {
  case FK10: /*Выход*/
  case ESC : /*Выход*/
     *tbn=tabel;
     return(1);

  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp2_5.txt");
   clear();
   if(kolstr > 0)
     goto naz;
   else
     goto lll;
     
  case ENTER : /*Проосмотр выбранного*/
     
     if(reg == 0)
      {
       vkart(tabel,1);
       goto naz1;
      }
     else
      {
       *tbn=tabel;
      }      
     return(0);
          
  case FK2 : /*Ввод*/
     vkart(0L,0);
     goto naz1;

  case FK3: /*Удалить карточку*/
    zarudkar(tabel);
    goto naz1;

  case FK4:       /*Поиск*/
    VV.VVOD_delete();
    VV.VVOD_SPISOK_add_MD(gettext("Фамилия................"));
    VV.VVOD_SPISOK_add_MD(gettext("Идентификационный код.."));
    VV.VVOD_SPISOK_add_MD(gettext("Карт счёт (+/-)........"));
    VV.VVOD_SPISOK_add_data(poi.obr,sizeof(poi.obr));
    VV.VVOD_SPISOK_add_data(poi.inn,11);
    VV.VVOD_SPISOK_add_data(poi.karts,2);
    
fk4:;

    helstr(LINES-1,0,"F2/+",gettext("поиск"),
    "F10",gettext("выход"),NULL);

    kom1=VV.vvod(0,1,1,-1,-1);

    strncpy(poi.obr,VV.VVOD_SPISOK_return_data(0),sizeof(poi.obr)-1);
    strncpy(poi.inn,VV.VVOD_SPISOK_return_data(1),sizeof(poi.inn)-1);
    strncpy(poi.karts,VV.VVOD_SPISOK_return_data(2),sizeof(poi.karts)-1);
    poi.metka_poi=0;

    switch(kom1)
     {
      case FK10:
      case ESC:
         break;                 
      case FK2:
      case PLU:
        poi.metka_poi=1;
        break;
      default:
        goto fk4;
     }   
    clear();
    if(kolstr > 0)
      goto naz; 
    else
      goto lll;
          
  case FK5:       /*Распечатать*/
   GDITE();
   sprintf(imaf,"pod%d.lst",podr);
   if((ff = fopen(imaf,"w")) == NULL)
    {
     error_op_nfil(imaf,errno,"");
     break;
    }
   time(&tmm);
   bf=localtime(&tmm);

   fprintf(ff,"%s\n\n%s\n\
%s %d.%d.%d%s %s: %d:%d\n",
   organ,
   gettext("Распечатка списка работников"),
   gettext("По состоянию на"),
   bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
   gettext("г."),
   gettext("Время"),
   bf->tm_hour,bf->tm_min);
   if(podr != 0)
    {
     SQL_str row1;
     SQLCURSOR cur1;
     char naim_podr[50];
     memset(naim_podr,'\0',sizeof(naim_podr));
     
     sprintf(strsql,"select naik from Podr where kod=%d",podr);
     if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
      strncpy(naim_podr,row1[0],sizeof(naim_podr)-1);

     fprintf(ff,"%s:%d %s\n",gettext("Подразделение"),podr,naim_podr);
    }
   fprintf(ff,"\
-----------------------------------------------------\n");
   fprintf(ff,gettext(" Т/н |   Фамилия, Имя, Отчество\n"));
   fprintf(ff,"\
-----------------------------------------------------\n");
   i=0;
   cur.poz_cursor(0);
   while(cur.read_cursor(&row) != 0)
    {
     if(provp(mp,&poi,mp1,mpz,mprov,row) != 0)
       continue;
     i++;
     fprintf(ff,"%-5s %s\n",row[0],row[1]);
    }
   cur.poz_cursor(pozz);
   fprintf(ff,"\
-----------------------------------------------------\n\
%s - %d\n",gettext("Общее количество"),i);
   podpis(ff);
   fprintf(ff,"\x1b\x6C%c",1); /*Установка левого поля*/
   fclose(ff);
   oth.clear();
   oth.spis_imaf.plus(imaf);
   oth.spis_naim.plus(gettext("Распечатка списка работников"));
   iceb_t_ustpeh(oth.spis_imaf.ravno(0),0);
   iceb_t_rabfil(&oth,"");
   clear();
   goto naz;

  case FK6: /*Смена режима просмотра*/
    mp++;
    if(mp == 3)
     mp=0;
    clear();
    if(kolstr > 0)
      goto naz;
    else
      goto lll;

  case FK7: /*Смена режима просмотра*/
    mprov++;
    if(mprov == 2)
     mprov=0;

    clear();
    if(kolstr > 0)
      goto naz;
    else
      goto lll;

  case SFK7: /*Смена режима просмотра*/
    mp1++;
    if(mp1 == 3)
     mp1=0;
    clear();
    if(kolstr > 0)
      goto naz;
    else
      goto lll;


  case FK8: /*Просмотр с расчетом зарплаты*/
    pokz++;
    if(pokz == 2)
     pokz=0;
    clear();
    if(kolstr > 0)
      goto naz;
    else
      goto lll;

  case FK9: //Смена сортировки
    msor++;
    if(msor == 2)
     msor=0;
    clear();
    goto naz1;

   default:
    if(kolstr > 0)
      goto naz;
    else
      goto lll;

 }  
return(1);
}

/*********************/
/*Шапка режима работы*/
/*********************/
void		sapptab(int pod,
int mp, //0-всех 1-только работающих 2-только уволеных
int mp1, //0-всех 1-имеющих настр. запись 2-не имеющих
int mprov, //0-всех 1-без проводок
class dirtab_poi *poi,
short pokz) //0-не показывать сальдо 1 показывать
{
int		Y=0,X=0;
move(0,0);

if(mp == 0)
 {
  attron(A_BLINK);
  printw(gettext("Просмотр всех табельных номеров"));
  attroff(A_BLINK);
 }
if(mp == 1)
 printw(gettext("Просмотр только работающих"));
if(mp == 2)
 {
  attron(A_BLINK);
  printw(gettext("Просмотр только уволенных"));
  attroff(A_BLINK);
 }

printw(" %s %d.%d%s",gettext("Текущая дата"),mmm,ggg,
gettext("г."));

if(pod != 0)
  printw(" %s %d",gettext("Подразделение"),pod);


move(1,0);
if(pokz == 0)
 {
  printw("    1                     2");
  move(Y=2,X=COLS-20);
  printw(gettext("Расшифровка полей:"));

  move(++Y,X);
  printw(gettext("1-табельный ном."));

  move(++Y,X);
  printw(gettext("2-фамилия"));

  move(++Y,X);
  printw(gettext("*-проводки"));

  move(++Y,X);
  printw(gettext("S-совместитель"));

  move(++Y,X);
  printw(gettext("V-был вход в карт."));

  move(++Y,X);
  printw(gettext("#-заблокирована"));
  
 }
if(pokz == 1)
 {
  printw("    1                  2                    3   4");
  move(Y=2,X=COLS-20);
  printw(gettext("Расшифровка полей:"));

  move(++Y,X);
  printw(gettext("1-табельный ном."));

  move(++Y,X);
  printw(gettext("2-фамилия"));

  move(++Y,X);
  printw(gettext("3-сальдо"));

  move(++Y,X);
  printw(gettext("4-дни"));

  move(++Y,X);
  printw(gettext("*-проводки"));

  move(++Y,X);
  printw(gettext("S-совместитель"));

  move(++Y,X);
  printw(gettext("V-был вход в карт."));

  move(++Y,X);
  printw(gettext("#-заблокирована"));
 }

if(poi->metka_poi != 0 || mprov == 1)
 {
  attron(A_BLINK);
  move(Y+=2,X);
  printw("%s:",gettext("Поиск"));
  if(poi->metka_poi != 0)
   {
    if(poi->obr[0] != '\0')
     {
      move(++Y,X);
      printw("%s",poi->obr);
     }
    if(poi->inn[0] != '\0')
     {
      move(++Y,X);
      printw("%s",poi->inn);
     }
    if(poi->karts[0] != '\0')
     {
      mvprintw(++Y,X,"%s",poi->karts);
     }
   }
  if(mprov == 1)
   {
    move(++Y,X);
    printw(gettext("без проводок"));
   }
  attroff(A_BLINK);
 }
helstr(LINES-1,0,"F1",gettext("помощь"),
"F2",gettext("запись"),
"F3",gettext("удалить"),
"F4",gettext("поиск"),
"F5",gettext("печать"),
"F6",gettext("увол."),
"F7","*",
"F8",gettext("сальдо"),
"F9",gettext("сорт."),
"F10",gettext("выход"),NULL);

}

/**********/
/*Проверка*/
/**********/
int		provp(int mp,class dirtab_poi *poi,
int mp1,char mpz[],int mprov,SQL_str rows)
{
SQL_str         row;
SQLCURSOR curr;
char		strsql[512];
short		mprov1;

if(mp == 2 && rows[2][0] == '0')
  return(1);
  
if(mp == 1 && rows[2][0] != '0')
  return(2);

if(poi->metka_poi == 1)
 {
  if(poi->obr[0] != '\0' )
   if(strstrm(rows[1],poi->obr) == 0)
    return(3);

  if(poi->inn[0] != '\0')
   if(strstrm(rows[3],poi->inn) == 0)
    return(4);

  if(poi->karts[0] == '+')
   if(rows[5][0] == '\0')
    return(5);

  if(poi->karts[0] == '-')
   if(rows[5][0] != '\0')
    return(6);
 }


mprov1=0;
/*Проверяем наличие промежуточной записи*/

sprintf(strsql,"select prov,blok from Zarn where god=%d and mes=%d \
and tabn=%s",ggg,mmm,rows[0]);

if(sql_readkey(&bd,strsql,&row,&curr) == 1)
 {
  strcpy(mpz,"V");    
  if(row[0][0] == '0')
   strcat(mpz,"*");
  else
   mprov1=1;
//  printw("row[0]=%s\n",row[0]);
  if(row[1][0] != '0')
   strcat(mpz,"#");
 }
else 
  strcpy(mpz,"*");    

if(mp1 == 2 && mpz[0] == 'V')
  return(4);

if(mp1 == 1 && mpz[0] == '*')
  return(5);

//printw("mprov=%d mprov1=%d \n",mprov,mprov1);
//OSTANOV();

if(mprov == 1 && mprov1 == 1)
  return(6);
  
return(0);

}
