/* $Id: dirtab1.c,v 5.16 2011-01-13 13:43:21 sasa1 Exp $ */
/*22.12.2009	05.06.2005	Белых А.И.	dirtab1.c
Просмотр списка табельных номеров без возможности работать с карточками
*/
#include        <pwd.h>
#include        <errno.h>
#include        <time.h>
#include        <ctype.h>
#include        "buhg.h"
class dirtab1_poi
 {
  public:
   char		obr[512];
   char		inn[32];
   int		mprov; //0-всех 1-без проводок
   int		mp;  /*0-всех 1-работающих 2-уволенных*/
   int		mp1;  /*0-всех 1-имеющих настр. запись 2-не имеющих*/
   int		pod;
   char		mpz[16];

  dirtab1_poi()
   {
    clear();
    mprov=0;
    mp=0;
    mp1=1;
    pod=0;
    memset(mpz,'\0',sizeof(mpz));
   }
  void clear()
   {
    memset(obr,'\0',sizeof(obr));
    memset(inn,'\0',sizeof(inn));
   }
 };
 
void		sapptab1(class dirtab1_poi*);
int provp1(SQL_str roww,class dirtab1_poi *poi);
void dirtar1_rs(class SQLCURSOR *cur,class dirtab1_poi *poi);

extern char     *organ;

int dirtab1(int *tbn,//Табельный номер
class iceb_tu_str *fio, //Фамилия
int podr) //Код подразделения
{
class dirtab1_poi poi;
int		kom,kom1;
long		pozz,pozz1;
long		kolstr;
SQL_str         row;
char		strsql[512];
int		i;
int		K;
int		prc;
int  	tabel=0;
short		msor; /*0-по фамилиям 1-по табельным номерам*/
short		mspz; /*метка соответствия первой записи*/
class iceb_t_mstr spis_menu(0);

//Создаем класс меню
VVOD VV(0);
msor=0;

poi.pod=podr;
kom=pozz=pozz1=0;

naz1:;
clear();
GDITE();
short		kls=LINES-5;

K=0;
if(poi.pod == 0)
 {
  if(msor == 0)
    sprintf(strsql,"select tabn,fio,datk,inn,sovm from Kartb order by fio asc");
  else
    sprintf(strsql,"select tabn,fio,datk,inn,sovm from Kartb order by tabn asc");
 }
else
 {
  if(msor == 0)
   sprintf(strsql,"select tabn,fio,datk,inn,sovm from Kartb where podr=%d \
order by fio asc",poi.pod);
  else
   sprintf(strsql,"select tabn,fio,datk,inn,sovm from Kartb where podr=%d \
order by tabn asc",poi.pod);
 } 
/*
printw("%s\n",strsql);
OSTANOV();
*/
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {

lll:;

  sapptab1(&poi);

  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  K=soobshw(&SOOB,stdscr,-1,-1,1,1);

  if(K == FK3 || K == FK5)
    goto lll;

  if(K == KEY_RESIZE)
   goto naz1;

  goto vper;

 }

naz:;
GDITE();
clear();

if(kolstr != 0 && pozz > kolstr)
  pozz = kolstr-1;

cur.poz_cursor(pozz);
mspz=2;
pozz1=0;
spis_menu.spis_str.free_class();
for(i=0; i < kls ;)
 {

  if(cur.read_cursor(&row) == 0)
    break;

  pozz1++;

  memset(poi.mpz,'\0',sizeof(poi.mpz));
  if(provp1(row,&poi) != 0)
    continue;

  if(row[4][0] == '1')
   strcat(poi.mpz,"S");      

  sprintf(strsql,"%-5s|%-*.*s|%1s",
  row[0],
  iceb_tu_kolbait(40,row[1]),iceb_tu_kolbait(40,row[1]),row[1],
  poi.mpz);

  spis_menu.spis_str.plus(strsql);
  i++;

  if(pozz1 == 1) /*Первая запись удовлетворяет условиям поиска*/
     mspz=1;

 }

if(kom >= i)
  kom=i-1;

if(kom < 0)
 kom=0;
if(i == 0)
 {
  if(kolstr > 0 && pozz > 0)
   {
    pozz--;
    goto naz;
   }
  goto lll;
 }

if(i <= kls-1)
  spis_menu.spis_str.plus(gettext("Конец списка"));

sapptab1(&poi);

prc=(pozz+pozz1)*100/kolstr;
memset(strsql,'\0',sizeof(strsql));
kom=spis_menu.menu(kom,2,0,NULL,strsql,prc,&K,"",0);


if(kom == -7) //Изменение размеров экрана
 goto naz1;
 
if(kom == -3) /*Стрелка вниз*/
 {
  if(i <kls)
   {
    beep();
    goto naz;
   }
  for(i=0; i < mspz  ; )
//  for(i=0; i<1  ; )
   {
    pozz++;

    cur.poz_cursor(pozz);
    if(cur.read_cursor(&row) == 0)
      break;

    if(provp1(row,&poi) != 0)
      continue;

    i++;
   }
  kom=kls;
  goto naz;
 }
if(kom == -2) /*Стрелка вверх*/
 {
  for(i=0; i < 1 ; )
   {

    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    cur.read_cursor(&row);


    if(provp1(row,&poi) != 0)
      continue;
    i++;
   }

  goto naz;
 }
 
if(kom == -5) /*Страница вниз*/
 {
/*
  printw("\n вперед pozz=%d kolst=%d kls=%d pozz1=%d\n",
  pozz,kolstr,kls,pozz1);
  OSTANOV();
*/
  if(pozz + kls == kolstr)
   {
    pozz=kolstr-1;
    beep();
    goto naz;  
   }
  if(i == kls)
    pozz+=pozz1;
  else
    beep();

  if(pozz >= kolstr)
   {
    pozz=kolstr-pozz1;
    beep();
    goto naz;  
   }
/*  
  printw("\n вперед pozz=%d\n",pozz);
  OSTANOV();
*/
  goto naz;

 }

if(kom == -4) /*Страница вверх*/
 {
/*
  printw("\npozz=%d\n",pozz);
  refresh();
*/
  for(i=0; i<kls ; )
   {
    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    cur.read_cursor(&row);


    if(provp1(row,&poi) != 0)
      continue;
    i++;
   }
  goto naz;
 }

if(kom >= 0)
 {
  if(SRAV(gettext("Конец списка"),spis_menu.spis_str.ravno(kom),0) == 0)
     goto naz;
  if(pozz+kom >= kolstr)
   goto naz;
  polen(spis_menu.spis_str.ravno(kom),strsql,sizeof(strsql),1,'|');
  tabel=atoi(strsql);
  polen(spis_menu.spis_str.ravno(kom),fio,2,'|');
 }

vper:;

switch (K)
 {
  case FK10: /*Выход*/
  case ESC : /*Выход*/
     *tbn=tabel;
     return(1);

  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp2_5.txt");
   clear();
   if(kolstr > 0)
     goto naz;
   else
     goto lll;
     
  case ENTER : /*Проосмотр выбранного*/
      *tbn=tabel;
      return(0);
          

  case FK4:       /*Поиск*/
    VV.VVOD_delete();
    poi.clear();
    VV.VVOD_SPISOK_add_MD(gettext("Фамилия................"));
    VV.VVOD_SPISOK_add_MD(gettext("Идентификационный код.."));
    VV.VVOD_SPISOK_add_data(sizeof(poi.obr));
    VV.VVOD_SPISOK_add_data(11);
    
fk4:;

    helstr(LINES-1,0,"F2/+",gettext("поиск"),
    "F10",gettext("выход"),NULL);

    kom1=VV.vvod(0,1,1,-1,-1);

    switch(kom1)
     {
      case FK10:
      case ESC:
         break;                 
      case FK2:
      case PLU:
        strncpy(poi.obr,VV.VVOD_SPISOK_return_data(0),sizeof(poi.obr)-1);
        strncpy(poi.inn,VV.VVOD_SPISOK_return_data(1),sizeof(poi.inn)-1);
        break;
      default:
        goto fk4;
     }   
    clear();
    if(kolstr > 0)
      goto naz; 
    else
      goto lll;
          
  case FK5:       /*Распечатать*/
   dirtar1_rs(&cur,&poi);
   clear();
   goto naz;

  case FK6: /*Смена режима просмотра*/
    poi.mp++;
    if(poi.mp == 3)
     poi.mp=0;
    clear();
    if(kolstr > 0)
      goto naz;
    else
      goto lll;

  case FK7: /*Смена режима просмотра*/
    poi.mprov++;
    if(poi.mprov == 2)
     poi.mprov=0;

    clear();
    if(kolstr > 0)
      goto naz;
    else
      goto lll;

  case SFK7: /*Смена режима просмотра*/
    poi.mp1++;
    if(poi.mp1 == 3)
     poi.mp1=0;
    clear();
    if(kolstr > 0)
      goto naz;
    else
      goto lll;



  case FK9: //Смена сортировки
    msor++;
    if(msor == 2)
     msor=0;
    clear();
    goto naz1;

   default:
    if(kolstr > 0)
      goto naz;
    else
      goto lll;

 }  
return(1);
}

/*********************/
/*Шапка режима работы*/
/*********************/
void		sapptab1(class dirtab1_poi *poi)
{
int		Y,X;
move(0,0);

if(poi->mp == 0)
 {
  attron(A_BLINK);
  printw(gettext("Просмотр всех табельных номеров"));
  attroff(A_BLINK);
 }
if(poi->mp == 1)
 printw(gettext("Просмотр только работающих"));
if(poi->mp == 2)
 {
  attron(A_BLINK);
  printw(gettext("Просмотр только уволенных"));
  attroff(A_BLINK);
 }
short d,m,g;
poltekdat(&d,&m,&g);
printw(" %s %d.%d.%d%s",gettext("Текущая дата"),d,m,g,
gettext("г."));

if(poi->pod != 0)
  printw(" %s %d",gettext("Подразделение"),poi->pod);


move(1,0);

  printw("    1                     2");
  move(Y=2,X=COLS-20);
  printw(gettext("Расшифровка полей:"));

  move(++Y,X);
  printw(gettext("1-табельный ном."));

  move(++Y,X);
  printw(gettext("2-фамилия"));

  move(++Y,X);
  printw(gettext("*-проводки"));

  move(++Y,X);
  printw(gettext("S-совместитель"));

  move(++Y,X);
  printw(gettext("V-был вход в карт."));

  move(++Y,X);
  printw(gettext("#-заблокирована"));
  

if(poi->obr[0] != '\0' || poi->inn[0] != '\0' || poi->mprov == 1)
 {
  attron(A_BLINK);
  move(Y+=2,X);
  printw("%s:",gettext("Поиск"));
  if(poi->obr[0] != '\0')
   {
    move(++Y,X);
    printw("%s",poi->obr);
   }
  if(poi->inn[0] != '\0')
   {
    move(++Y,X);
    printw("%s",poi->inn);
   }
  if(poi->mprov == 1)
   {
    move(++Y,X);
    printw(gettext("без проводок"));
   }
  attroff(A_BLINK);
 }
helstr(LINES-1,0,"F1",gettext("помощь"),
"F4",gettext("поиск"),
"F5",gettext("печать"),
"F6",gettext("увол."),
"F7","*",
"F9",gettext("сорт."),
"F10",gettext("выход"),NULL);

}

/**********/
/*Проверка*/
/**********/
//  if(provp1(mp,row[2],obr,row[1],row[0],mp1,mpz,inn,row[3],mprov) != 0)
//int		provp1(int mp,char row2[],char obr[],char row1[],
//char row0[],int mp1,char mpz[],char inn[],char inn1[],int mprov)
int provp1(SQL_str roww,class dirtab1_poi *poi)
{
SQL_str         row;
SQLCURSOR curr;
char		strsql[512];
short		mprov1;

if(poi->mp == 2 && roww[2][0] == '0')
  return(1);
  
if(poi->mp == 1 && roww[2][0] != '0')
  return(2);


if(poi->obr[0] != '\0' )
 if(strstrm(roww[1],poi->obr) == 0)
  return(3);

if(poi->inn[0] != '\0')
 if(strstrm(roww[3],poi->inn) == 0)
  return(4);


if(poi->mp1 == 2 && poi->mpz[0] == '\0')
  return(4);

if(poi->mp1 == 1 && poi->mpz[0] == '*')
  return(5);

mprov1=0;
/*Проверяем наличие промежуточной записи*/
short d,m,g;
poltekdat(&d,&m,&g);
sprintf(strsql,"select prov,blok from Zarn where god=%d and mes=%d \
and tabn=%s",g,m,roww[0]);

if(sql_readkey(&bd,strsql,&row,&curr) == 1)
 {
  strcpy(poi->mpz,"V");    
  if(row[0][0] == '0')
   strcat(poi->mpz,"*");
  else
   mprov1=1;
//  printw("row[0]=%s\n",row[0]);
  if(row[1][0] != '0')
   strcat(poi->mpz,"#");
 }
else 
  strcpy(poi->mpz,"*");    

//printw("mprov=%d mprov1=%d \n",mprov,mprov1);
//OSTANOV();

if(poi->mprov == 1 && mprov1 == 1)
  return(6);
  
return(0);

}
/**********************************/
/*Распечатка списка*/
/****************************/

void dirtar1_rs(class SQLCURSOR *cur,class dirtab1_poi *poi)
{
struct  tm      *bf;
time_t          tmm;
char imaf[56];
FILE *ff;

GDITE();
sprintf(imaf,"pod%d.lst",poi->pod);
if((ff = fopen(imaf,"w")) == NULL)
 {
    error_op_nfil(imaf,errno,"");
  return;
 }
time(&tmm);
bf=localtime(&tmm);

fprintf(ff,"%s\n\n%s\n\
%s %d.%d.%d%s %s: %d:%d\n",
organ,
gettext("Распечатка списка работников"),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);
char strsql[512];
if(poi->pod != 0)
 {
   SQL_str row1;
   SQLCURSOR cur1;
   char naim_podr[50];
   memset(naim_podr,'\0',sizeof(naim_podr));
   
   sprintf(strsql,"select naik from Podr where kod=%d",poi->pod);
   if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
    strncpy(naim_podr,row1[0],sizeof(naim_podr)-1);

   fprintf(ff,"%s:%d %s\n",gettext("Подразделение"),poi->pod,naim_podr);
 }
fprintf(ff,"\
-----------------------------------------------------\n");
fprintf(ff,gettext(" Т/н |   Фамилия, Имя, Отчество\n"));
fprintf(ff,"\
-----------------------------------------------------\n");
int i=0;
SQL_str row;
cur->poz_cursor(0);

while(cur->read_cursor(&row) != 0)
 {
   if(provp1(row,poi) != 0)
     continue;
   i++;
   fprintf(ff,"%-5s %s\n",row[0],row[1]);
 }
fprintf(ff,"\
-----------------------------------------------------\n\
%s - %d\n",gettext("Общее количество"),i);
podpis(ff);
fclose(ff);

class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Распечатка списка работников"));
iceb_t_ustpeh(oth.spis_imaf.ravno(0),0);
iceb_t_rabfil(&oth,"");

}
