/* $Id: doocsum.c,v 5.26 2011-01-13 13:43:22 sasa1 Exp $ */
/*15.12.2009	30.5.2001	Белых А.И.	doocsum.c
Получение суммы дооценки выполненой в автоматическом режиме 
по документам
*/
#include        <errno.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

int doocsumr(short,short,short,short,short,short,char*,class spis_oth*);

extern char	*organ;

void	doocsum(void)
{
static char	dat1[11];
static char	dat2[11];
static char	sklad[100];
short		dn,mn,gn,dk,mk,gk;
int		kom=0;
class iceb_tu_str kod("");
class iceb_tu_str naims("");
VVOD VV(0);

VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(dat2,11);
VV.VVOD_SPISOK_add_data(sklad,50);

VV.VVOD_SPISOK_add_MD(gettext("Дата начала.(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца..(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Склад..(,,).........."));

VV.VVOD_SPISOK_add_ZAG(gettext("Расчет суммы выполненых дооценок"));


naz1:;
clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("склады"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(sklad,VV.VVOD_SPISOK_return_data(2),sizeof(sklad)-1);

switch (kom)
 {
  case ESC:
  case FK10:
     return;
     break;

  case FK1:
    GDITE();
    iceb_t_pdoc("matu5_16.txt");
    clear();
    goto naz1;

  case PLU:
  case FK2:
     break;

  case FK3:
    //vibrek("Sklad",sklad,sizeof(sklad),naim);
    kod.new_plus("");
    naims.new_plus("");
    if(dirsklad(1,&kod,&naims) == 0)
       VV.data_z_plus(2,kod.ravno());
    goto naz1;


  default:
    goto naz1;
    break;
 }

if(rsdatp(&dn,&mn,&gn,VV.VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
  goto naz1;
class spis_oth oth;
if(doocsumr(dn,mn,gn,dk,mk,gk,sklad,&oth) == 0)
 iceb_t_rabfil(&oth,"");

}
/*****************************/
/*  Расчет дооценки           */
/*******************************/

int doocsumr(short dn,short mn,short gn,
short dk,short mk,short gk,
char *sklad,class spis_oth *oth)
{
char	kodopdooc[20];
SQL_str	row,row1;
char	strsql[512];
int	kolstr=0,kolstr1=0;
short	d,m,g;
short	vt; //возвратная тара
double	sum=0.,sum1=0.;
double  sumkor=0.;
double  suma=0.;
double  sumabn=0.;
int	mnds=0;
FILE	*ff;
char	imaf[40];
char	bros[512];
struct  tm      *bf;
time_t	   	tmm;
double	sumi[3];
char	osnov[512];
double  nds=0.;

clear();
printw("%d.%d.%d%s => %d.%d.%d%s\n",
dn,mn,gn,
gettext("г."),
dk,mk,gk,
gettext("г."));
GDITE();

memset(kodopdooc,'\0',sizeof(kodopdooc));

if(iceb_t_poldan("Код операции автоматической дооценки",kodopdooc,"matnast.alx") != 0)
 {
kkkk:;
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("В файле настройки не введен код операции автоматической дооценки !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
if(kodopdooc[0] == '\0')
  goto kkkk;
//Проверяем есть ли код операции в списке приходов и расходов
sprintf(strsql,"select prov from Prihod where kod='%s'",kodopdooc);
if(sql_readkey(&bd,strsql) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Не найден код %s в списке операций приходов !"),kodopdooc);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);

 }

sprintf(strsql,"select prov from Rashod where kod='%s'",kodopdooc);
if(sql_readkey(&bd,strsql) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Не найден код %s в списке операций расходов !"),kodopdooc);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);

 }



sprintf(strsql,"select datd,sklad,nomd,nomon,pn from Dokummat where \
datd >= '%04d-%d-%d' and datd <= '%04d-%d-%d' and kodop='%s' and \
tip=1",gn,mn,dn,gk,mk,dk,kodopdooc);

SQLCURSOR cur;
SQLCURSOR cur1;

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }


vt=0;
memset(bros,'\0',sizeof(bros));
iceb_t_poldan("Код группы возвратная тара",bros,"matnast.alx");
vt=(short)ATOFM(bros);

sprintf(imaf,"dooc%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }
startfil(ff);
time(&tmm);
bf=localtime(&tmm);

fprintf(ff,"%s\n\n\
%s\n\
%s %d.%d.%d%s %s %d.%d.%d%s\n\
%s %d.%d.%d%s  %s: %d:%d\n\n",
organ,
gettext("Расчет суммы выполненых дооценок."),
gettext("Период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);
if(sklad[0] != '\0')
  fprintf(ff,"%s:%s\n",gettext("Склад"),sklad);

fprintf(ff,"\
-------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
Склад|   Дата   |Номер док.|Номер док.|        Сумма        |  Сумма   |Основание\n"));
fprintf(ff,gettext("\
     |          | приход   |  расход  |  приход  |  расход  | дооценки |\n"));
fprintf(ff,"\
-------------------------------------------------------------------------------------\n");
memset(&sumi,'\0',sizeof(sumi));
float pnds=0.;
double kolih=0.;
while(cur.read_cursor(&row) != 0)
 {
  printw("%s %s %s\n",row[0],row[1],row[2]);
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(sklad,row[1],0,0) != 0)
    continue;
    
  rsdat(&d,&m,&g,row[0],2);
  pnds=atof(row[4]);
  /*Узнаем НДС документа*/
  mnds=0;
  sprintf(strsql,"select sodz from Dokummat2 where god=%d and nomd='%s' \
and sklad=%s and nomerz=11",g,row[2],row[1]);

  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
   {
    mnds=atoi(row1[0]);
   }  
  //Узнаем основание документа
  memset(osnov,'\0',sizeof(osnov));
  sprintf(strsql,"select sodz from Dokummat2 where god=%d and sklad=%s \
and nomd='%s' and nomerz=3",g,row[1],row[2]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
    strncpy(osnov,row1[0],sizeof(osnov)-1);
    
  sumzap1(d,m,g,row[2],atoi(row[1]),&suma,&sumabn,mnds,vt,&sumkor,1,&kolih);

  if(mnds == 0)
    nds=(suma+sumkor)*pnds/100.;
  else
   nds=0.;

  sum=suma+sumkor+nds+sumabn;
  
  sumzap1(d,m,g,row[3],atoi(row[1]),&suma,&sumabn,mnds,vt,&sumkor,2,&kolih);

  if(mnds == 0)
    nds=(suma+sumkor)*pnds/100.;
  else
   nds=0.;

  sum1=suma+sumkor+nds+sumabn;
  sumi[0]+=sum;
  sumi[1]+=sum1;
  sumi[2]+=sum-sum1;
  fprintf(ff,"%-5s %02d.%02d.%d %-10s %-10s %10.2f %10.2f %10.2f %s\n",
  row[1],d,m,g,row[2],row[3],sum,sum1,sum-sum1,osnov);
 }
fprintf(ff,"\
-------------------------------------------------------------------------------------\n");
fprintf(ff,"%38s:%10.2f %10.2f %10.2f\n",
gettext("Итого"),sumi[0],sumi[1],sumi[2]);

podpis(ff);
fclose(ff);
//rabfil(gettext("Расчет суммы выполненых дооценок."),imaf);
oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчет суммы выполненых дооценок."));
return(0);
}
