/*$Id: dvos.c,v 5.37 2011-01-13 13:43:22 sasa1 Exp $*/
/*12.03.2010	03.07.2001	Белых А.И.	dvos.c
Распечатка списка записей в документах за любой период времени
*/
#include        <time.h>
#include        <math.h>
#include        <errno.h>
#include        "buhg.h"
#include        "uos.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void	sapdvos(FILE*,char*,char*,char*,char*,char*,char*,char*);

extern char     *organ;

int dvos(class spis_oth *oth)
{
static char     dat1[11];
static char     dat2[11];
static char     podrz[112]; /*Код подразделения*/
static char	kodolz[112]; /*Коды ответственных лиц*/
static char	kodop[112]; /*Коды операции*/
static char	vidop[5]; /*Вид операции*/
static char	grupabuh[112]; /*Группа бух. учета*/
static char	grupanal[112]; /*Группа налогового учета*/
static char	shetu_p[112]; //Счёт учёта
short		mz,gz;
short           dn,mn,gn;
short           dk,mk,gk;
int		kom=0,kom1=0;
char		strsql[512];
int		kolstr=0,kolstr1=0;
SQL_str		row,row1;
char		imaf[32],imafsort[32],imafgrbuh[32],imafgrnal[32];
FILE		*ff,*ffsort;
time_t 		tmm;
struct  tm      *bf;
double		bsn,izn,bsb,izb;
double		ibsn=0.,iizn=0.,ibsb=0.,iizb=0.;
double		ibsnp=0.,iiznp=0.,ibsbp=0.,iizbp=0.;
double		ibsnr=0.,iiznr=0.,ibsbr=0.,iizbr=0.;
double		ibsngr=0.,iizngr=0.,ibsbgr=0.,iizbgr=0.;
double		ibsngro=0.,iizngro=0.,ibsbgro=0.,iizbgro=0.;
short		d,m,g;
struct 	UOS uos;
int		tipz=0;
char		stroka[1024];

char		datadok[11];
char		invnom[32];
char		vidopt[5];
char		naim[512];
char 		nalbs[32];
char		naliz[32];
char 		buhbs[32];
char		buhiz[32];
char		nomd[32];
char		kodoper[32];
char		podr[32];
char		matot[32];
char		grbuh[32],grbuhz[32];
char		grnal[32],grnalz[32];

memset(&uos,'\0',sizeof(uos));
VVOD VV(0);
VVOD MENU(3);

VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(dat2,11);
VV.VVOD_SPISOK_add_data(podrz,sizeof(podr));
VV.VVOD_SPISOK_add_data(kodolz,sizeof(kodolz));
VV.VVOD_SPISOK_add_data(kodop,sizeof(kodop));
VV.VVOD_SPISOK_add_data(vidop,2);
VV.VVOD_SPISOK_add_data(grupabuh,sizeof(grupabuh));
VV.VVOD_SPISOK_add_data(grupanal,sizeof(grupanal));
VV.VVOD_SPISOK_add_data(shetu_p,sizeof(shetu_p));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала...(д.м.г)..."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца....(д.м.г)..."));
VV.VVOD_SPISOK_add_MD(gettext("Подразделение.....(,,).."));
VV.VVOD_SPISOK_add_MD(gettext("Мат.ответственный.(,,).."));
VV.VVOD_SPISOK_add_MD(gettext("Код операции......(,,).."));
VV.VVOD_SPISOK_add_MD(gettext("Вид операции.....(+/-).."));
VV.VVOD_SPISOK_add_MD(gettext("Группа бух. учета.(,,).."));
VV.VVOD_SPISOK_add_MD(gettext("Группа нал. учета.(,,).."));
VV.VVOD_SPISOK_add_MD(gettext("Счёт учёта........(,,).."));

VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка реестра документов движения основных средств"));
VV.VVOD_SPISOK_add_ZAG(gettext("Введите данные"));

naz:;

clear();


helstr(LINES-1,0,"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);

memset(podrz,'\0',sizeof(podrz));
strncpy(podrz,VV.VVOD_SPISOK_return_data(2),sizeof(podrz)-1);
memset(kodolz,'\0',sizeof(kodolz));
strncpy(kodolz,VV.VVOD_SPISOK_return_data(3),sizeof(kodolz)-1);
strncpy(kodop,VV.VVOD_SPISOK_return_data(4),sizeof(kodop)-1);
strncpy(vidop,VV.VVOD_SPISOK_return_data(5),sizeof(vidop)-1);
strncpy(grupabuh,VV.VVOD_SPISOK_return_data(6),sizeof(grupabuh)-1);
strncpy(grupanal,VV.VVOD_SPISOK_return_data(7),sizeof(grupanal)-1);
strncpy(shetu_p,VV.VVOD_SPISOK_return_data(8),sizeof(shetu_p)-1);

class iceb_tu_str kod_v("");
class iceb_tu_str naim_v("");

switch(kom)
 {
  case FK10:
  case ESC:
   return(1);
  case FK2:
  case PLU:
   break;

  case FK3:  /*Просмотр реквизитов*/
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка мат.-ответственны"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп налогового учета"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп бухгалтерского учета"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций приходов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций расходов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);
    switch (kom1)
     {
      case 6 :
      case -1:
       goto naz;

      case 0 :
        if(diruospod(1,&kod_v,&naim_v,0) == 0)
         VV.data_z_plus(2,kod_v.ravno());
        goto naz;

      case 1 :

        //vibrek("Uosol",kodolz,sizeof(kodolz),naim);
        if(dirmatot(1,&kod_v,&naim_v,0) == 0)
         VV.data_z_plus(3,kod_v.ravno());
        goto naz;

      case 2 :
        vibrek("Uosgrup",grupanal,sizeof(grupanal),naim);
        VV.VVOD_SPISOK_zapis_data(7,grupanal);
        goto naz;

      case 3 :
        vibrek("Uosgrup1",grupabuh,sizeof(grupabuh),naim);
        VV.VVOD_SPISOK_zapis_data(6,grupabuh);
        goto naz;

      case 4 :
        vibrek("Uospri",kodop,sizeof(kodop),naim);
        VV.VVOD_SPISOK_zapis_data(4,kodop);
        goto naz;

      case 5 :
        vibrek("Uosras",kodop,sizeof(kodop),naim);
        VV.VVOD_SPISOK_zapis_data(4,kodop);
        goto naz;


     }
    goto naz;
    

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
 }

if(rsdatp(&dn,&mn,&gn,VV.VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
  goto naz;

GDITE();
clear();

printw("%s %d.%d.%d => %d.%d.%d\n",
gettext("Распечатка записей документов"),
dn,mn,gn,dk,mk,gk);

time(&tmm);
bf=localtime(&tmm);

sprintf(strsql,"select datd,tipz,innom,nomd,podr,kodol,bs,iz,kodop,\
bsby,izby from Uosdok1 where datd >= '%d-%d-%d' and datd <= '%d-%d-%d' \
order by datd asc",
gn,mn,dn,gk,mk,dk);

SQLCURSOR cur;
SQLCURSOR curr;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);  
 }

sprintf(imafsort,"dvos%d.tmp",getpid());

if((ffsort = fopen(imafsort,"w")) == NULL)
 {
  error_op_nfil(imafsort,errno,"");
  return(1);
 }

sprintf(imaf,"dvos%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }
zagolov(gettext("Реестр документов движения основных средств"),bf,dn,mn,gn,dk,mk,gk,organ,ff);

sapdvos(ff,kodolz,podrz,kodop,vidop,grupabuh,grupanal,shetu_p);

kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(podrz,row[4],0,0) != 0)
    continue;
  if(proverka(kodolz,row[5],0,0) != 0)
    continue;
  if(proverka(kodop,row[8],0,0) != 0)
    continue;
   
  if(vidop[0] == '-')
    if(row[1][0] == '1')
     continue;

  if(vidop[0] == '+')
    if(row[1][0] == '2')
     continue;
//  printw("%s %s %s vidop=%s\n",row[0],row[1],row[2],vidop);
  rsdat(&d,&m,&g,row[0],2);
  poiinpd(atol(row[2]),m,g,uos.shetu,uos.hzt,uos.hau,uos.hna,&uos.popkf,&uos.soso,uos.nomz,&mz,&gz,uos.hnaby,&uos.popkfby);

  if(proverka(shetu_p,uos.shetu,1,0) != 0)
       continue;
  if(proverka(grupabuh,uos.hnaby,0,0) != 0)
       continue;
  if(proverka(grupanal,uos.hna,0,0) != 0)
       continue;

  tipz=atoi(row[1]);
  if(tipz == 1)
   strcpy(vidopt,"+");
  if(tipz == 2)
   strcpy(vidopt,"-");
   
  bsn=atof(row[6]);  
  izn=atof(row[7]);  
  bsb=atof(row[9]);  
  izb=atof(row[10]);  
  memset(naim,'\0',sizeof(naim));
  sprintf(strsql,"select naim from Uosin where innom=%s",row[2]);
  if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
    strncpy(naim,row1[0],sizeof(naim)-1);

  fprintf(ff,"%02d.%02d.%d %s %-*s %-*.*s %11.2f %11.2f %11.2f %11.2f \
%-*s %-*s %-5s %-5s %-*s %-*s\n",
  d,m,g,
  vidopt,
  iceb_tu_kolbait(8,row[2]),row[2],
  iceb_tu_kolbait(20,naim),iceb_tu_kolbait(20,naim),naim,
  bsn,izn,bsb,izb,
  iceb_tu_kolbait(5,row[3]),row[3],
  iceb_tu_kolbait(5,row[8]),row[8],
  row[4],
  row[5],
  iceb_tu_kolbait(6,uos.hnaby),uos.hnaby,
  iceb_tu_kolbait(6,uos.hna),uos.hna);

  fprintf(ffsort,"%s|%s|%d-%d-%d|%s|%s|%s|%.2f|%.2f|%.2f|%.2f|\
%s|%s|%s|%s|\n",
  uos.hnaby,uos.hna,g,m,d,vidopt,row[2],naim,bsn,izn,bsb,izb,
  row[3],row[8],row[4],row[5]);

  ibsn+=bsn;
  iizn+=izn;
  ibsb+=bsb;
  iizb+=izb;
  if(tipz == 1)
   {
    ibsnp+=bsn;
    iiznp+=izn;
    ibsbp+=bsb;
    iizbp+=izb;
   }  
  if(tipz == 2)
   {
    ibsnr+=bsn;
    iiznr+=izn;
    ibsbr+=bsb;
    iizbr+=izb;
   }  
 }
GDITE();
fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,"%*s:%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(42,gettext("Итого")),gettext("Итого"),ibsn,iizn,ibsb,iizb);

fprintf(ff,"\n%*s+:%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(41,gettext("Итого")),gettext("Итого"),ibsnp,iiznp,ibsbp,iizbp);

fprintf(ff,"%*s-:%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(41,gettext("Итого")),gettext("Итого"),ibsnr,iiznr,ibsbr,iizbr);

fprintf(ff,"%*s-:%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(41,gettext("Разница")),gettext("Разница"),ibsnp-ibsnr,iiznp-iiznr,ibsbp-ibsbr,iizbp-iizbr);

printw("%s :%11.2f %11.2f %11.2f %11.2f\n",
gettext("Итого"),ibsn,iizn,ibsb,iizb);
printw("\n%s+:%11.2f %11.2f %11.2f %11.2f\n",
gettext("Итого"),ibsnp,iiznp,ibsbp,iizbp);
printw("%s :%11.2f %11.2f %11.2f %11.2f\n",
gettext("Итого"),ibsnr,iiznr,ibsbr,iizbr);

podpis(ff);

fclose(ff);
fclose(ffsort);

//Сортировка по группам бухгалтерского учета

//sprintf(strsql,"sort -o %s -t\\| +0n -1 +2 -3 %s",imafsort,imafsort);
sprintf(strsql,"sort -o %s -t\\| -k1,2n -k3,4 %s",imafsort,imafsort);
runsystem(strsql);

if((ffsort = fopen(imafsort,"r")) == NULL)
 {
  error_op_nfil(imafsort,errno,"");
  return(1);
 }

sprintf(imafgrbuh,"dvosbh%d.lst",getpid());

if((ff = fopen(imafgrbuh,"w")) == NULL)
 {
  error_op_nfil(imafgrbuh,errno,"");
  return(1);
 }
zagolov(gettext("Распечатка записей документов"),bf,dn,mn,gn,dk,mk,gk,organ,ff);

fprintf(ff,"%s.\n",gettext("Сортировка по группам бухгалтерского учета"));

sapdvos(ff,kodolz,podrz,kodop,vidop,grupabuh,grupanal,shetu_p);
memset(grbuhz,'\0',sizeof(grbuhz));

double ibsnpo=0.,iiznpo=0.,ibsbpo=0.,iizbpo=0.;
double ibsnro=0.,iiznro=0.,ibsbro=0.,iizbro=0.;
ibsnp=iiznp=ibsbp=iizbp=0.;
ibsnr=iiznr=ibsbr=iizbr=0.;

while(fgets(stroka,sizeof(stroka),ffsort) != 0)
 {
  polen(stroka,grbuh,sizeof(grbuh),1,'|');
  if(SRAV(grbuhz,grbuh,0) != 0)
   {
    if(grbuhz[0] != '\0')
     {
      sprintf(strsql,"%s %s",gettext("Итого по группе"),grbuhz);
      fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
      fprintf(ff,"%*s:%11.2f %11.2f %11.2f %11.2f\n",
      iceb_tu_kolbait(42,strsql),strsql,ibsngr,iizngr,ibsbgr,iizbgr);
      
      ibsngro+=ibsngr;
      iizngro+=iizngr;
      ibsbgro+=ibsbgr;
      iizbgro+=iizbgr;
      
      fprintf(ff,"\n%*s+:%11.2f %11.2f %11.2f %11.2f\n",
      iceb_tu_kolbait(41,gettext("Итого по группе")),gettext("Итого по группе"),ibsnp,iiznp,ibsbp,iizbp);

      fprintf(ff,"%*s-:%11.2f %11.2f %11.2f %11.2f\n",
      iceb_tu_kolbait(41,gettext("Итого по группе")),gettext("Итого по группе"),ibsnr,iiznr,ibsbr,iizbr);

      fprintf(ff,"%*s :%11.2f %11.2f %11.2f %11.2f\n\n",
      iceb_tu_kolbait(41,gettext("Разница")),gettext("Разница"),ibsnp-ibsnr,iiznp-iiznr,ibsbp-ibsbr,iizbp-iizbr);
     }
    strcpy(grbuhz,grbuh);
    ibsngr=iizngr=ibsbgr=iizbgr=0.;
    ibsnp=iiznp=ibsbp=iizbp=0.;
    ibsnr=iiznr=ibsbr=iizbr=0.;
   }

  polen(stroka,grnal,sizeof(grnal),2,'|');
  polen(stroka,datadok,sizeof(datadok),3,'|');
  rsdat(&d,&m,&g,datadok,2);
  polen(stroka,vidopt,sizeof(vidopt),4,'|');
  polen(stroka,invnom,sizeof(invnom),5,'|');
  polen(stroka,naim,sizeof(naim),6,'|');
  polen(stroka,nalbs,sizeof(nalbs),7,'|');
  polen(stroka,naliz,sizeof(naliz),8,'|');
  polen(stroka,buhbs,sizeof(buhbs),9,'|');
  polen(stroka,buhiz,sizeof(buhiz),10,'|');
  polen(stroka,nomd,sizeof(nomd),11,'|');
  polen(stroka,kodoper,sizeof(kodoper),12,'|');
  polen(stroka,podr,sizeof(podr),13,'|');
  polen(stroka,matot,sizeof(matot),14,'|');

  fprintf(ff,"%02d.%02d.%d %s %-8s %-*.*s %11s %11s %11s %11s \
%-*s %-*s %-5s %-5s %-6s %-6s\n",
  d,m,g,vidopt,invnom,
  iceb_tu_kolbait(20,naim),iceb_tu_kolbait(20,naim),naim,
  nalbs,naliz,buhbs,buhiz,
  iceb_tu_kolbait(5,nomd),nomd,
  iceb_tu_kolbait(5,kodoper),kodoper,
  podr,matot,grbuh,grnal);

  ibsngr+=atof(nalbs);
  iizngr+=atof(naliz);
  ibsbgr+=atof(buhbs);
  iizbgr+=atof(buhiz);
  if(vidopt[0] == '+')
   {
    ibsnp+=atof(nalbs);
    iiznp+=atof(naliz);
    ibsbp+=atof(buhbs);
    iizbp+=atof(buhiz);

    ibsnpo+=atof(nalbs);
    iiznpo+=atof(naliz);
    ibsbpo+=atof(buhbs);
    iizbpo+=atof(buhiz);
   }  
  if(vidopt[0] == '-')
   {
    ibsnr+=atof(nalbs);
    iiznr+=atof(naliz);
    ibsbr+=atof(buhbs);
    iizbr+=atof(buhiz);

    ibsnro+=atof(nalbs);
    iiznro+=atof(naliz);
    ibsbro+=atof(buhbs);
    iizbro+=atof(buhiz);
   }  

 }
sprintf(strsql,"%s %s",gettext("Итого по группе"),grbuhz);
fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,"%*s:%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(42,strsql),strsql,ibsngr,iizngr,ibsbgr,iizbgr);

      ibsngro+=ibsngr;
      iizngro+=iizngr;
      ibsbgro+=ibsbgr;
      iizbgro+=iizbgr;

      fprintf(ff,"\n%*s+:%11.2f %11.2f %11.2f %11.2f\n",
      iceb_tu_kolbait(41,gettext("Итого по группе")),gettext("Итого по группе"),ibsnp,iiznp,ibsbp,iizbp);

      fprintf(ff,"%*s-:%11.2f %11.2f %11.2f %11.2f\n",
      iceb_tu_kolbait(41,gettext("Итого по группе")),gettext("Итого по группе"),ibsnr,iiznr,ibsbr,iizbr);

      fprintf(ff,"%*s :%11.2f %11.2f %11.2f %11.2f\n\n",
      iceb_tu_kolbait(41,gettext("Разница")),gettext("Разница"),ibsnp-ibsnr,iiznp-iiznr,ibsbp-ibsbr,iizbp-iizbr);

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,"%*.*s:%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(42,gettext("Итого по всем группам")),iceb_tu_kolbait(42,gettext("Итого по всем группам")),gettext("Итого по всем группам"),
ibsngro,iizngro,ibsbgro,iizbgro);

fprintf(ff,"\n%*s+:%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(41,gettext("Итого")),gettext("Итого"),ibsnpo,iiznpo,ibsbpo,iizbpo);

fprintf(ff,"%*s-:%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(41,gettext("Итого")),gettext("Итого"),ibsnro,iiznro,ibsbro,iizbro);

fprintf(ff,"%*s :%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(41,gettext("Разница")),gettext("Разница"),ibsnpo-ibsnro,iiznpo-iiznro,ibsbpo-ibsbro,iizbpo-iizbro);

podpis(ff);

fclose(ff);
fclose(ffsort);

//Сортировка по группам налогового учета

//sprintf(strsql,"sort -o %s -t\\| +1n -2 +2 -3 %s",imafsort,imafsort);
sprintf(strsql,"sort -o %s -t\\| -k2,3n -k3,4 %s",imafsort,imafsort);
runsystem(strsql);

if((ffsort = fopen(imafsort,"r")) == NULL)
 {
  error_op_nfil(imafsort,errno,"");
  return(1);
 }

sprintf(imafgrnal,"dvosnl%d.lst",getpid());

if((ff = fopen(imafgrnal,"w")) == NULL)
 {
  error_op_nfil(imafgrnal,errno,"");
  return(1);
 }
zagolov(gettext("Распечатка записей документов"),bf,dn,mn,gn,dk,mk,gk,organ,ff);

fprintf(ff,"%s.\n",gettext("Сортировка по группам налогового учета"));

sapdvos(ff,kodolz,podrz,kodop,vidop,grupabuh,grupanal,shetu_p);
memset(grnalz,'\0',sizeof(grnalz));

ibsngr=iizngr=ibsbgr=iizbgr=0.;
ibsngro=iizngro=ibsbgro=iizbgro=0.;
ibsnpo=0.,iiznpo=0.,ibsbpo=0.,iizbpo=0.;
ibsnro=0.,iiznro=0.,ibsbro=0.,iizbro=0.;
ibsnp=iiznp=ibsbp=iizbp=0.;
ibsnr=iiznr=ibsbr=iizbr=0.;

while(fgets(stroka,sizeof(stroka),ffsort) != 0)
 {
  polen(stroka,grbuh,sizeof(grbuh),1,'|');

  polen(stroka,grnal,sizeof(grnal),2,'|');
  if(SRAV(grnalz,grnal,0) != 0)
   {
    if(grnalz[0] != '\0')
     {
      sprintf(strsql,"%s %s",gettext("Итого по группе"),grnalz);
      fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
      fprintf(ff,"%*s:%11.2f %11.2f %11.2f %11.2f\n",
      iceb_tu_kolbait(42,strsql),strsql,ibsngr,iizngr,ibsbgr,iizbgr);

      ibsngro+=ibsngr;
      iizngro+=iizngr;
      ibsbgro+=ibsbgr;
      iizbgro+=iizbgr;

      fprintf(ff,"\n%*s+:%11.2f %11.2f %11.2f %11.2f\n",
      iceb_tu_kolbait(41,gettext("Итого по группе")),gettext("Итого по группе"),ibsnp,iiznp,ibsbp,iizbp);

      fprintf(ff,"%*s-:%11.2f %11.2f %11.2f %11.2f\n",
      iceb_tu_kolbait(41,gettext("Итого по группе")),gettext("Итого по группе"),ibsnr,iiznr,ibsbr,iizbr);

      fprintf(ff,"%*s :%11.2f %11.2f %11.2f %11.2f\n\n",
      iceb_tu_kolbait(41,gettext("Разница")),gettext("Разница"),ibsnp-ibsnr,iiznp-iiznr,ibsbp-ibsbr,iizbp-iizbr);
     }
    strcpy(grnalz,grnal);
    ibsngr=iizngr=ibsbgr=iizbgr=0.;
    ibsnp=iiznp=ibsbp=iizbp=0.;
    ibsnr=iiznr=ibsbr=iizbr=0.;
   }
  polen(stroka,datadok,sizeof(datadok),3,'|');
  rsdat(&d,&m,&g,datadok,2);
  polen(stroka,vidopt,sizeof(vidopt),4,'|');
  polen(stroka,invnom,sizeof(invnom),5,'|');
  polen(stroka,naim,sizeof(naim),6,'|');
  polen(stroka,nalbs,sizeof(nalbs),7,'|');
  polen(stroka,naliz,sizeof(naliz),8,'|');
  polen(stroka,buhbs,sizeof(buhbs),9,'|');
  polen(stroka,buhiz,sizeof(buhiz),10,'|');
  polen(stroka,nomd,sizeof(nomd),11,'|');
  polen(stroka,kodoper,sizeof(kodoper),12,'|');
  polen(stroka,podr,sizeof(podr),13,'|');
  polen(stroka,matot,sizeof(matot),14,'|');

  fprintf(ff,"%02d.%02d.%d %s %-8s %-*.*s %11s %11s %11s %11s \
%-*s %-*s %-5s %-5s %-6s %-6s\n",
  d,m,g,vidopt,invnom,
  iceb_tu_kolbait(20,naim),iceb_tu_kolbait(20,naim),naim,
  nalbs,naliz,buhbs,buhiz,
  iceb_tu_kolbait(5,nomd),nomd,
  iceb_tu_kolbait(5,kodoper),kodoper,
  podr,matot,grbuh,grnal);

  ibsngr+=atof(nalbs);
  iizngr+=atof(naliz);
  ibsbgr+=atof(buhbs);
  iizbgr+=atof(buhiz);
  if(vidopt[0] == '+')
   {
    ibsnp+=atof(nalbs);
    iiznp+=atof(naliz);
    ibsbp+=atof(buhbs);
    iizbp+=atof(buhiz);

    ibsnpo+=atof(nalbs);
    iiznpo+=atof(naliz);
    ibsbpo+=atof(buhbs);
    iizbpo+=atof(buhiz);
   }  
  if(vidopt[0] == '-')
   {
    ibsnr+=atof(nalbs);
    iiznr+=atof(naliz);
    ibsbr+=atof(buhbs);
    iizbr+=atof(buhiz);

    ibsnro+=atof(nalbs);
    iiznro+=atof(naliz);
    ibsbro+=atof(buhbs);
    iizbro+=atof(buhiz);
   }  

 }
sprintf(strsql,"%s %s",gettext("Итого по группе"),grnalz);
fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,"%*s:%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(42,strsql),strsql,ibsngr,iizngr,ibsbgr,iizbgr);

      ibsngro+=ibsngr;
      iizngro+=iizngr;
      ibsbgro+=ibsbgr;
      iizbgro+=iizbgr;

      fprintf(ff,"\n%*s+:%11.2f %11.2f %11.2f %11.2f\n",
      iceb_tu_kolbait(41,gettext("Итого по группе")),gettext("Итого по группе"),ibsnp,iiznp,ibsbp,iizbp);

      fprintf(ff,"%*s-:%11.2f %11.2f %11.2f %11.2f\n",
      iceb_tu_kolbait(41,gettext("Итого по группе")),gettext("Итого по группе"),ibsnr,iiznr,ibsbr,iizbr);

      fprintf(ff,"%*s :%11.2f %11.2f %11.2f %11.2f\n\n",
      iceb_tu_kolbait(41,gettext("Разница")),gettext("Разница"),ibsnp-ibsnr,iiznp-iiznr,ibsbp-ibsbr,iizbp-iizbr);

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,"%*.*s:%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(42,gettext("Итого по всем группам")),iceb_tu_kolbait(42,gettext("Итого по всем группам")),gettext("Итого по всем группам"),ibsngro,iizngro,ibsbgro,iizbgro);

fprintf(ff,"\n%*s+:%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(41,gettext("Итого")),gettext("Итого"),ibsnpo,iiznpo,ibsbpo,iizbpo);

fprintf(ff,"%*s-:%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(41,gettext("Итого")),gettext("Итого"),ibsnro,iiznro,ibsbro,iizbro);

fprintf(ff,"%*s :%11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(41,gettext("Разница")),gettext("Разница"),ibsnpo-ibsnro,iiznpo-iiznro,ibsbpo-ibsbro,iizbpo-iizbro);

podpis(ff);

fclose(ff);
fclose(ffsort);


unlink(imafsort);
printw_vr(tmm);


OSTANOV();
oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Реестр документов движения основных средств"));

oth->spis_imaf.plus(imafgrbuh);
oth->spis_naim.plus(gettext("Реестр документов с сортировкой по группам бух.уч"));
oth->spis_imaf.plus(imafgrnal);
oth->spis_naim.plus(gettext("Реестр документов с сортировкой по группам нал.уч"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);
 
}
/**************/
/*Шапка файлов*/
/***************/
void	sapdvos(FILE *ff,char *kodolz,char *podrz,char *kodop,
char *vidop,char *grupabuh,char *grupanal,char *shetu_p)
{


if(kodolz[0] != '\0')
  fprintf(ff,"%s: %s\n",gettext("Мат.-ответственный"),kodolz);
if(podrz[0] != '\0')
  fprintf(ff,"%s: %s\n",gettext("Подразделение"),podrz);
if(kodop[0] != '\0')
  fprintf(ff,"%s: %s\n",gettext("Код операции"),kodop);
if(vidop[0] != '\0')
  fprintf(ff,"%s: %s\n",gettext("Вид операции"),vidop);
if(grupabuh[0] != '\0')
  fprintf(ff,"%s: %s\n",gettext("Группа бухгалтерского учета"),grupabuh);
if(grupanal[0] != '\0')
  fprintf(ff,"%s: %s\n",gettext("Группа налогового учета"),grupanal);
if(shetu_p[0] != '\0')
  fprintf(ff,"%s: %s\n",gettext("Счёт учёта"),shetu_p);

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
Дата докум. |Инвент. |  Наименование      |  Налоговый учет       |Бухгалтерский учет     |Ном. |Код. |Подр-|Мат. |Группа|Группа|\n"));
fprintf(ff,gettext("\
            | номер  |                    |Бал.стоим. |   Износ   |Бал.стоим. |   Износ   |докум|опер.|аздел|отвец|бух.уч|нал.уч|\n"));
fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
}
