/* $Id: dvtmcf2.c,v 5.57 2011-01-13 13:43:22 sasa1 Exp $ */
/*15.10.2010    04.07.1994      Белых А.И.      dvtmcf2.c
Движение товарно-материальных ценностей в развернутом виде
для сверки поступлений или расходов за определенный период времени
*/
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif



void  dvtmcf2ot(char imafsort[],short dn,short mn,short gn,
short dk,short mk,short gk,int kolstr2,char shetz[],
char nabor[],char kodmz[],char grz[],const char *kodop,char korz[],
char sklz[],short tipz,FILE *ff,FILE *ff_l,
char nomdokp[],
short metoth,char ndsc[],short metka_ceni);

void sozshgr(masiv_din_int*,SPISOK*,int*,int*);
void rasgrsh(char *imaf,short dn,short mn,short gn,short dk,short mk,short gk,masiv_din_int *GRUP,SPISOK *SHET,int kolgrup,
int kolshet,double *sumshgr,char *shetz,char *nabor,char *kodmz,char *grz,const char *kodop,char *korz,char *sklz,char *nomdokp,char *ndsc,short metka_ceni);

void rasgshshk(short dn,short mn,short gn,short dk,short mk,short gk,const char *shetz,const char *nabor,const char *kodmz,const char *grz,const char *kodop,const char *korz,
const char *sklz,const char *nomdokp,const char *ndsc,const char *imaf,SPISOK *GSHSHK,masiv_din_double *SUMGSHSHK,short metka_ceni);

void dvtmcf2_sap(short dn,short mn,short gn,short dk,short mk,short gk,int *sl,int *kst,FILE *ff);

extern char     *organ;/*Наименование организации*/
extern char	*maskmat; /*Массив кодов отмеченных материалов*/
extern double	okrg1;  /*Округление 1*/
extern int kol_strok_na_liste; //Количество строк на листе в ориентации портрет
extern int kol_strok_na_liste_l; //Количесво строк на стандартном листе в ориентации ландшафт

int dvtmcf2(class spis_oth *oth)
{
FILE            *ff,*ff1;
char		bros[512];
struct  tm      *bf;
time_t          tmm;
static char     dat1[11],dat2[11];
static char     sklz[112];
static char     grz[112];
static char	kodmz[112];
static char	nabor[112];
static char     korz[112];
static class iceb_tu_str kodop("");
static char     prr[4];
static char     shetz[112];
static char	nomdokp[112];
static char	ndsc[5];
double		cena;
char		ei[32];
int             kom,kom1;
short           dn,mn,gn;
short           dk,mk,gk;
char		kop[32];
char            imaf[32],imafsort[32];
int             skl,nk;
char		nm[512];
int		kgr,kodm;
long		kolstr,kolstr1,kolstr2;
SQL_str         row,row1;
char		strsql[512];
short		tipz;
char		kor[32];
char		shu[32];
char		naim[512];
short		kgrm;
double		nds;
int		sortir=0;
short		nomgrup,nomshet;
char		shetsp[32]; //Счет списания
int		nomel;

float pnds=iceb_t_pnds();


VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Движение материальных ценностей (форма 2)"));
VV.VVOD_SPISOK_add_ZAG(gettext("Введите нужные реквизиты"));

VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(dat2,11);

VV.VVOD_SPISOK_add_data(sklz,sizeof(sklz));
VV.VVOD_SPISOK_add_data(korz,sizeof(korz));
VV.VVOD_SPISOK_add_data(grz,sizeof(grz));
VV.VVOD_SPISOK_add_data(kodop.ravno(),112);
VV.VVOD_SPISOK_add_data(kodmz,sizeof(kodmz));
VV.VVOD_SPISOK_add_data(prr,2);
VV.VVOD_SPISOK_add_data(nabor,sizeof(nabor));
VV.VVOD_SPISOK_add_data(shetz,sizeof(shetz));
VV.VVOD_SPISOK_add_data(nomdokp,sizeof(nomdokp));
VV.VVOD_SPISOK_add_data(ndsc,sizeof(ndsc));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала.........."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца..........."));
VV.VVOD_SPISOK_add_MD(gettext("Склад.........(,,)..."));
VV.VVOD_SPISOK_add_MD(gettext("Код контрагента.(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Группа........(,,)..."));
VV.VVOD_SPISOK_add_MD(gettext("Код операции..(,,)..."));
VV.VVOD_SPISOK_add_MD(gettext("Код материалла.(,,*)."));
VV.VVOD_SPISOK_add_MD(gettext("Приход/расход.(+/-).."));
VV.VVOD_SPISOK_add_MD(gettext("Набор операций......."));
VV.VVOD_SPISOK_add_MD(gettext("Счет учета.....(,,).."));
VV.VVOD_SPISOK_add_MD(gettext("Номер документа.(,,)."));
sprintf(strsql,gettext("НДС (0,%2.f,+)........."),pnds);
VV.VVOD_SPISOK_add_MD(strsql);

naz:;

clear();

move(LINES-5,0);
printw(gettext("\
Если НДС не ввели - все карточки.\n\
Если НДС = 0      - карточки с нулевым НДС.\n\
Если НДС = %2.f     - карточки с %2.f%% НДС.\n\
Если НДС = +      - карточки с НДС в том числе.\n"),pnds,pnds);

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("поиск"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,0,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(sklz,VV.VVOD_SPISOK_return_data(2),sizeof(sklz)-1);
strncpy(korz,VV.VVOD_SPISOK_return_data(3),sizeof(korz)-1);
strncpy(grz,VV.VVOD_SPISOK_return_data(4),sizeof(grz)-1);
kodop.new_plus(VV.VVOD_SPISOK_return_data(5));
strncpy(kodmz,VV.VVOD_SPISOK_return_data(6),sizeof(kodmz)-1);
strncpy(prr,VV.VVOD_SPISOK_return_data(7),sizeof(prr)-1);
strncpy(nabor,VV.VVOD_SPISOK_return_data(8),sizeof(nabor)-1);
strncpy(shetz,VV.VVOD_SPISOK_return_data(9),sizeof(shetz)-1);
strncpy(nomdokp,VV.VVOD_SPISOK_return_data(10),sizeof(nomdokp)-1);
strncpy(ndsc,VV.VVOD_SPISOK_return_data(11),sizeof(ndsc)-1);

class iceb_tu_str kods("");
class iceb_tu_str naims("");
switch (kom)
 {

  case FK10:
  case ESC:
   return(1);

  case FK1:
    GDITE();
    iceb_t_pdoc("matu5_5.txt");
    clear();
    goto naz;

  case FK2:
  case PLU:
    break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка складов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка контрагентов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций приходов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций расходов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка материалов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр наборов операций"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 8 :
      case -1:
       goto naz;

      case 0 :
        //vibrek("Sklad",sklz,sizeof(sklz),nm);
        if(dirsklad(1,&kods,&naims) == 0)
         VV.data_z_plus(2,kods.ravno());
        goto naz;

      case 1 :
        vibrek("Kontragent",korz,sizeof(korz),nm);
        VV.VVOD_SPISOK_zapis_data(3,korz);
        goto naz;

      case 2 :
        vibrek("Grup",grz,sizeof(grz),nm);
        VV.VVOD_SPISOK_zapis_data(4,grz);
        goto naz;

      case 3 :
        vibrek("Prihod",&kodop);
        VV.VVOD_SPISOK_zapis_data(5,kodop.ravno());
        goto naz;

      case 4 :
        vibrek("Rashod",&kodop);
        VV.VVOD_SPISOK_zapis_data(5,kodop.ravno());
        goto naz;
        
      case 5 :
        bros[0]='\0';
        if(dirmatr(&kgr,&kodm,&naims,1,0,bros,0,0) == 0)
         {
          VV.data_z_plus(6,kodm);
         }
        
        goto naz;

      case 6 :
        vibrek("Plansh",shetz,sizeof(shetz),nm);
        VV.VVOD_SPISOK_zapis_data(9,shetz);
        goto naz;

      case 7 :
        iceb_redfil("nabopr.alx",0);
        goto naz;

     }
    goto naz;

  case FK4:
    VV.VVOD_clear_data();
    goto naz;
     
  default:
    goto naz;
 }

if(VV.VVOD_SPISOK_return_data(8)[0] != '\0')
 {
  class iceb_tu_str nabor("");
  if(iceb_t_poldan(VV.VVOD_SPISOK_return_data(8),&nabor,"nabopr.alx") != 0)
   {
    VVOD SOOB(1);
    sprintf(strsql,gettext("Не найден набор операций %s !"),VV.VVOD_SPISOK_return_data(8));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
  else
   VV.data_plus(5,nabor.ravno());
 }

if(kodmz[0] == '*' && maskmat == NULL)
 { 
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не сделан список материалов !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 } 

if(rsdatp(&dn,&mn,&gn,VV.VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
  goto naz;


MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите вид сортировки"));

MENU.VVOD_SPISOK_add_MD(gettext("Сортировка:Счет-склад-контрагент-группа-дата подтверждения"));
MENU.VVOD_SPISOK_add_MD(gettext("Сортировка:Cклад-контрагент-дата подтверждения"));
MENU.VVOD_SPISOK_add_MD(gettext("Сортировка:Счет-cклад-группа"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

sortir=0;
while(menu3w(stdscr,&MENU,&sortir,-1,-1,0) != 0);

switch (sortir)
 {
  case 3 :
  case -1 :
    goto naz;
  
 }


tipz=0;
if(VV.VVOD_SPISOK_return_data(7)[0] == '+')
  tipz=1;
if(VV.VVOD_SPISOK_return_data(7)[0] == '-')
  tipz=2;

short metka_ceni=2; //2-по ценам карточек 1-по ценам в документах

if(tipz == 2 || tipz == 0)
 {
  VVOD DANET(1);
  DANET.VVOD_SPISOK_add_MD(gettext("В ценах реализации ?"));
  metka_ceni=danet(&DANET,2,stdscr);
 }


time(&tmm);
bf=localtime(&tmm);

clear();
GDITE();

sprintf(strsql,"select * from Zkart where datdp >= '%04d-%02d-%02d' and \
datdp <= '%04d-%02d-%02d' order by sklad,nomk,datdp asc",
gn,mn,dn,gk,mk,dk);
SQLCURSOR cur;
SQLCURSOR cur1;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной записи !"));
  return(1);
 }

printw("%s %d.%d.%d %s %d.%d.%d\n",
gettext("Период с"),
dn,mn,gn,
gettext("до"),
dk,mk,gk);


masiv_din_int GRUP(0); //Массив количества групп
SPISOK SHET(0);        //Список счетов
int	kolgrup=0;
int     kolshet=0;
SPISOK GSHSHK(0);      //Список группа-счет-счет корреспондент
masiv_din_double SUMGSHSHK(0); //Суммы к списку  группа-счет-счет корреспондент

//Создаем список счетов и массив групп
sozshgr(&GRUP,&SHET,&kolgrup,&kolshet);

double sumshgr[kolshet*kolgrup]; //Массив сумм группа-счет
memset(sumshgr,'\0',sizeof(sumshgr));

sprintf(imafsort,"sort%d.tmp",getpid());

if((ff1 = fopen(imafsort,"w")) == NULL)
 {
  error_op_nfil(imafsort,errno,"");
  return(1);
 }

/*Открываем заранее, чтобы иметь возможность выгрузить ошибки*/
if(sortir == 0)
  sprintf(imaf,"dv%d.lst",getpid());
if(sortir == 1)
  sprintf(imaf,"dv1_%d.lst",getpid());
if(sortir == 2)
  sprintf(imaf,"dv2_%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

FILE *ff_l;
char imaf_l[50];
sprintf(imaf_l,"dv2l%d.lst",getpid());

if((ff_l = fopen(imaf_l,"w")) == NULL)
 {
  error_op_nfil(imaf_l,errno,"");
  return(1);
 }
/*ландшафтная ориентация распечатки*/

kolstr2=kolstr1=0;
float pnds_dok=0.;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);  
  skl=atoi(row[0]);
  nk=atoi(row[1]);

  if(proverka(sklz,row[0],0,0) != 0)
    continue;  

  if(tipz != 0)
   if(tipz != atoi(row[5]))
       continue;

  if(proverka(nomdokp,row[2],0,0) != 0)
    continue;  

  pnds_dok=0.;
  /*Читаем накладную*/
  sprintf(strsql,"select kontr,kodop,pn from Dokummat \
where datd='%s' and sklad=%d and nomd='%s'",
  row[4],skl,row[2]);
  
  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найден документ !"));
    sprintf(strsql,gettext("Дата=%s Документ=%s Склад=%d"),
    row[4],row[2],skl);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);

    fprintf(ff,gettext("Не найден документ !"));
    fprintf(ff,gettext("Дата=%s Документ=%s Склад=%d"),
    row[4],row[2],skl);
    fprintf(ff,"\n");
    
    fprintf(ff_l,gettext("Не найден документ !"));
    fprintf(ff_l,gettext("Дата=%s Документ=%s Склад=%d"),
    row[4],row[2],skl);
    fprintf(ff_l,"\n");
    
    continue;
   }
  
  strncpy(kor,row1[0],sizeof(kor)-1);
  strncpy(kop,row1[1],sizeof(kop)-1);
  pnds_dok=atof(row1[2]);
  
  if(proverka(korz,kor,0,0) != 0)
    continue;  

  if(proverka(kodop.ravno(),kop,0,0) != 0)
    continue;  

  /*Читаем карточку материалла*/
  sprintf(strsql,"select kodm,shetu,ei,cena,mnds,nds from Kart where sklad=%d and nomk=%d",skl,nk);
  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    beep();
    printw(gettext("Не нашли карточку !  Склад %d Номер карточки %d\n"),skl,nk);
    fprintf(ff,gettext("Не нашли карточку !  Склад %d Номер карточки %d\n"),skl,nk);
    fprintf(ff_l,gettext("Не нашли карточку !  Склад %d Номер карточки %d\n"),skl,nk);
    OSTANOV();
    continue;
   }
  nds=atof(row1[5]);

  if(ndsc[0] != '\0')
   {
    //Карточки с нулевым НДС
    if(ndsc[0] == '0' && atof(row1[5]) != 0.)
        continue;
    //Карточки с НДС нужного значения
    if(ndsc[0] != '+' && ndsc[0] != '0' && (fabs(nds - atof(ndsc)) > 0.009 || atoi(row1[4]) != 0))
        continue;
    //Карточки в цене которых включено НДС нужного значения
    if(ndsc[0] == '+' && ndsc[1] != '\0' && (fabs(nds - atof(ndsc)) > 0.009 || atoi(row1[4]) != 1) )
        continue;
    //Карточки в цене которых НДС любого значения
    if(ndsc[0] == '+' && ndsc[1] == '\0' &&  atoi(row1[4]) != 1 )
        continue;
   }

  kodm=atoi(row1[0]);
  strncpy(shu,row1[1],sizeof(shu)-1);
  strncpy(ei,row1[2],sizeof(ei)-1);
  if(metka_ceni == 2)
    cena=atof(row1[3]);
  else
   {
    cena=0.;
    //Читаем цену в документе
    sprintf(strsql,"select cena from Dokummat1 where datd='%s' and sklad=%s and \
nomd='%s' and nomkar=%s",row[4],row[0],row[2],row[1]);
    if(readkey(strsql,&row1,&cur1) == 1)
      cena=atof(row1[0]);
    short mnds=0;
    short d,m,g;
    rsdat(&d,&m,&g,row[4],2);

    //читаем метку НДС
    sprintf(strsql,"select sodz from Dokummat2 where god=%d and nomd='%s' and \
sklad=%s and nomerz=11",g,row[2],row[0]);

    if(readkey(strsql,&row1,&cur1) == 1)
      mnds=atoi(row1[0]);

    if(mnds == 0 && pnds_dok != 0.)
     {
      cena=cena+cena*pnds_dok/100.;    
      cena=okrug(cena,okrg1);
     }
   }

  if(kodmz[0] != '\0')
   {
    sprintf(bros,"%d",kodm); 
    if(kodmz[0] == '*' && maskmat != NULL)
     {
      if(proverka(maskmat,bros,0,0) != 0)
        continue;  
     }
    else
      if(proverka(kodmz,bros,0,0) != 0)
        continue;  
   }

  if(proverka(shetz,shu,1,0) != 0)
    continue;  

  /*Узнаем наименование материалла*/
  sprintf(strsql,"select naimat,kodgr from Material where kodm=%d",
  kodm);
  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    fprintf(ff,"%s %d !\n",gettext("Не найден код материалла"),kodm);
    fprintf(ff_l,"%s %d !\n",gettext("Не найден код материалла"),kodm);
    printw("%s %d !\n",gettext("Не найден код материалла"),kodm);
    OSTANOV();
    continue;
   }

  strncpy(naim,row1[0],sizeof(naim));
  kgrm=atoi(row1[1]);
  
  if(proverka(grz,row1[1],0,0) != 0)
    continue;  

  memset(shetsp,'\0',sizeof(shetsp));

  //Читаем дополнение к наименованию материалла
  sprintf(strsql,"select shet,dnaim from Dokummat1 where datd='%s' and sklad=%s \
and nomd='%s' and kodm=%d and nomkar=%s",
  row[4],row[0],row[2],kodm,row[1]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
   {
    strcpy(shetsp,row1[0]);
    strcat(naim," ");
    strcat(naim,row1[1]);
   }  
  else
   {
    printw("Не найдена запись !!!\n");
    OSTANOV();
   }

  kolstr2++;
  fprintf(ff1,"%s|%d|%s|%d|%s|%s|%d|%s|%s|%.10g|%s|%s|%s|%d|%s|%s|\n",
  shu,skl,kor,kgrm,row[3],naim,kodm,ei,kop,cena,row[4],row[6],row[5],
  nk,row[2],shetsp);
  
  nomgrup=GRUP.find(kgrm);
  nomshet=SHET.find(shu);
  sumshgr[nomgrup*kolshet+nomshet]+=cena*atof(row[6]);
  
  sprintf(strsql,"%d#%s#%s",kgrm,shu,shetsp);
  if((nomel=GSHSHK.find(strsql)) >= 0) //Есть в списке
   {
    SUMGSHSHK.plus(cena*atof(row[6]),nomel);
   }
  else //Нет в списке
   {
    GSHSHK.plus(strsql);
    SUMGSHSHK.plus(cena*atof(row[6]),-1);
   }
 }

GDITE();

fclose(ff1);

/*****************************************/
if(sortir == 0)
 {
  printw("\n%s.\n",gettext("Сортировка:Счет-склад-контрагент-группа-дата подтверждения"));
  refresh();

  /*Сортировка Счет-склад-контрагент-группа-дата подтверждения*/ 
//  sprintf(strsql,"sort -o %s -t\\| +0 -1 +1n -2 +2 -3 +3n -4 %s",imafsort,imafsort);
  sprintf(strsql,"sort -o %s -t\\| -k1,2 -k2,3n -k3,4 -k4,5n %s",imafsort,imafsort);
  runsystem(strsql);

  dvtmcf2ot(imafsort,dn,mn,gn,dk,mk,gk,kolstr2,shetz,nabor,kodmz,
  grz,kodop.ravno(),korz,sklz,tipz,ff,ff_l,nomdokp,sortir,ndsc,metka_ceni);

 }
/*****************************************/
if(sortir == 1)
 {

  printw("\n%s.\n",gettext("Сортировка:Cклад-контрагент-дата подтверждения"));
  GDITE();

  /*Сортировка склад-контрагент-дата подтверждения*/ 
//  sprintf(strsql,"sort -o %s -t\\|  +1n -2 +2 -3 +4 -5 %s",imafsort,imafsort);
  sprintf(strsql,"sort -o %s -t\\| -k2,3n -k3,4 -k5,6 %s",imafsort,imafsort);
  runsystem(strsql);

  dvtmcf2ot(imafsort,dn,mn,gn,dk,mk,gk,kolstr2,shetz,nabor,kodmz,
  grz,kodop.ravno(),korz,sklz,tipz,ff,ff_l,nomdokp,sortir,ndsc,metka_ceni);

 }
/*****************************************/
if(sortir == 2)
 {

  printw("\n%s.\n",gettext("Сортировка:Счет-cклад-группа"));
  GDITE();

//  sprintf(strsql,"sort -o %s -t\\| +0 -1 +1n -2 +3n -4 %s",imafsort,imafsort);
  sprintf(strsql,"sort -o %s -t\\| -k1,2 -k2,3n -k4,5n %s",imafsort,imafsort);
  runsystem(strsql);


  dvtmcf2ot(imafsort,dn,mn,gn,dk,mk,gk,kolstr2,shetz,nabor,kodmz,
  grz,kodop.ravno(),korz,sklz,tipz,ff,ff_l,nomdokp,sortir,ndsc,metka_ceni);

 }
GDITE();
podpis(ff);
fclose(ff);
podpis(ff_l);
fclose(ff_l);

unlink(imafsort);

char	imafshgr[32];
sprintf(imafshgr,"grsh%d.lst",getpid());

rasgrsh(imafshgr,dn,mn,gn,dk,mk,gk,&GRUP,&SHET,kolgrup,kolshet,sumshgr,shetz,
nabor,kodmz,grz,kodop.ravno(),korz,sklz,nomdokp,ndsc,metka_ceni);

char	imafgshshk[32];

sprintf(imafgshshk,"grshk%d.lst",getpid());

rasgshshk(dn,mn,gn,dk,mk,gk,shetz,nabor,kodmz,grz,kodop.ravno(),korz,sklz,
nomdokp,ndsc,imafgshshk,&GSHSHK,&SUMGSHSHK,metka_ceni);

sprintf(strsql,"%s %s %s",imaf,imafshgr,imafgshshk);

OSTANOV();

oth->spis_imaf.plus(imaf_l);
oth->spis_naim.plus(gettext("Движение товарно-материальных ценностей (форма 2 - ландшафт)"));
iceb_t_ustpeh(oth->spis_imaf.ravno(0),2);

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Движение товарно-материальных ценностей (форма 2 - портрет)"));
iceb_t_ustpeh(oth->spis_imaf.ravno(1),1);

oth->spis_imaf.plus(imafshgr);
oth->spis_naim.plus(gettext("Движение материальных ценностей по группам и счетам учёта"));
iceb_t_ustpeh(oth->spis_imaf.ravno(2),0);

oth->spis_imaf.plus(imafgshshk);
oth->spis_naim.plus(gettext("Движение материальных ценностей по группам и счетам списания/получения"));
iceb_t_ustpeh(oth->spis_imaf.ravno(3),0);


return(0);
}
/*******/
/*Шапка*/
/*******/
void            gsapp1(short dn,short mn,short gn,short dk,short mk,
short gk,
int *sl, //Счетчик листов
int *kst, //Счетчик строк
FILE *ff,
int metka_l) //0-портрет 1-ландшафт
{
*kst+=1;

if(metka_l == 0)
 if(*kst <= kol_strok_na_liste)
  return;
if(metka_l == 1)
 if(*kst <= kol_strok_na_liste_l)
  return;

fprintf(ff,"\f");
*kst=1;
 

dvtmcf2_sap(dn,mn,gn,dk,mk,gk,sl,kst,ff);

}

/*******************/
/*Распечатка итогов*/
/********************/

void		rasitogo(int metka,//  1-итого по группе
                                   //  2-итого по контр
                                   //  3-итого по склад
                                   //  4-итого по счету
double mas[2],int *klst,char kod[],
FILE *ff,short metoth,
short dn,short mn,short gn,
short dk,short mk,short gk,
int *sli,int metka_l)
{
char		strsql[512];
char		naim[512];
SQL_str         row;
SQLCURSOR       cur;
char		bros[512];

if(mas[0] == 0.)
  return;

if(metoth == 1 && (metka == 1 || metka == 4))
  return;
if(metoth == 2 && metka == 2)
  return;

memset(naim,'\0',sizeof(naim));
if(metka == 1)
 {
  sprintf(strsql,"select naik from Grup where kod=%s",kod);
  if(sql_readkey(&bd,strsql,&row,&cur) != 1)
   {
    beep();
    printw("%s %s !\n",gettext("Не найдена группа"),kod);
    OSTANOV();
   }
  else
   strncpy(naim,row[0],sizeof(naim)-1);
  sprintf(strsql,"%s %s %s",gettext("Итого по группе"),kod,naim);
 }

if(metka == 2)
 {
  if(kod[0] == '0' && POLE(kod,bros,2,'-') == 0)
   {
    sprintf(strsql,"select naik from Sklad where kod=%s",bros);
   }
  else
   {
    strcpy(bros,kod);   
    sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",
    bros);
   }

//  sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",bros);
  if(sql_readkey(&bd,strsql,&row,&cur) != 1)
   {
    beep();
    printw("%s %s !\n",gettext("Не найден контрагент"),bros);
    OSTANOV();
   }
  else
   strncpy(naim,row[0],sizeof(naim)-1);
  sprintf(strsql,"%s %s %s",gettext("Итого по контрагенту"),kod,naim);
 }
if(metka == 3)
 {
  sprintf(strsql,"select naik from Sklad where kod=%s",kod);
  if(sql_readkey(&bd,strsql,&row,&cur) != 1)
   {
    beep();
    printw(gettext("Не найден склад %d в списке складов !"),atoi(kod));
    printw("\n");
    OSTANOV();
   }
  else
   strncpy(naim,row[0],sizeof(naim)-1);
  sprintf(strsql,"%s %s %s",gettext("Итого по складу"),kod,naim);
 }

if(metka == 4)
 {
  sprintf(strsql,"select nais from Plansh where ns='%s'",kod);
  if(sql_readkey(&bd,strsql,&row,&cur) != 1)
   {
    beep();
    printw(gettext("Не найден счет %s в плане счетов !"),kod);
    printw("\n");
    OSTANOV();
   }
  else
   strncpy(naim,row[0],sizeof(naim)-1);
  sprintf(strsql,"%s %s %s",gettext("Итого по счету"),kod,naim);
 }

gsapp1(dn,mn,gn,dk,mk,gk,sli,klst,ff,metka_l);
fprintf(ff,"%*s:%12.12g %15.2f\n",iceb_tu_kolbait(77,strsql),strsql,mas[0],mas[1]);

mas[0]=0.;
mas[1]=0.;

}                        

/*******************/
/*Распечатка отчета*/
/*******************/

void  dvtmcf2ot(char imafsort[],short dn,short mn,short gn,
short dk,short mk,short gk,int kolstr2,char shetz[],
char nabor[],char kodmz[],char grz[],const char *kodop,char korz[],
char sklz[],short tipz,FILE *ff,FILE *ff_l,
char nomdokp[],
short metoth,char ndsc[],short metka_ceni)
{
struct  tm      *bf;
time_t		tmm;
char		bros[512];
int		kodm;
short           dp,mp,gp;
short           d,m,g;
double		its,itk,br;
char		nomdok[32];
char		poi[56];
char		str[512];
int		i;
double		itgrup[2];
double		itkontr[2];
double		itsklad[2];
double		itshet[2];
short           mvstr; /*Метка выдачи строки*/
int             sli=0,kst=0;
int             sli_l=0,kst_l=0;
char		strsql[512];
double		kolih,cena;
char		shu[32],shuz[32];
short		kgrm,kgrmz;
int             skl,skll,nk,nkk;
char		kop[32];
char		kor[32],korzz[32];
char		naim[512];
char            nomn[34];
FILE		*ff1;
SQL_str         row1;
SQLCURSOR       cur1;
char            org[512];
char		ei[32];
int		kolstr1;
char		shetsp[32];

its=itk=0;

time(&tmm);
bf=localtime(&tmm);

if((ff1 = fopen(imafsort,"r")) == NULL)
 {
  error_op_nfil(imafsort,errno,"");
  return;
 }



fprintf(ff,"%s\n\n\
		      %s %d.%d.%d%s %s %d.%d.%d%s\n\
				     %s %d.%d.%d  %s:%02d:%02d\n",
organ,
gettext("Движение товарно-материальных ценностей за период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("Время"),
bf->tm_hour,bf->tm_min);



fprintf(ff_l,"%s\n\n\
		      %s %d.%d.%d%s %s %d.%d.%d%s\n\
				     %s %d.%d.%d  %s:%02d:%02d\n",
organ,
gettext("Движение товарно-материальных ценностей за период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("Время"),
bf->tm_hour,bf->tm_min);

kst_l=kst=4;

//шапка документа
dvtmcf2_sap(dn,mn,gn,dk,mk,gk,&sli,&kst,ff);
dvtmcf2_sap(dn,mn,gn,dk,mk,gk,&sli_l,&kst_l,ff_l);


if(tipz == 0)
 {
  fprintf(ff,"				     %s\n",gettext("Перечень приходов/расходов"));
  fprintf(ff_l,"				     %s\n",gettext("Перечень приходов/расходов"));
  kst++;
  kst_l++;
 }

if(tipz == 1)
 {
  fprintf(ff,"				     %s\n",gettext("Перечень приходов"));
  kst++;
  fprintf(ff_l,"				     %s\n",gettext("Перечень приходов"));
  kst_l++;
 }
if(tipz == 2)
 {
  fprintf(ff,"				     %s\n",gettext("Перечень расходов"));
  kst++;
  fprintf(ff_l,"				     %s\n",gettext("Перечень расходов"));
  kst_l++;
 }

if(metka_ceni == 2)
 {
  fprintf(ff,gettext("Отчёт по учётным ценам.\n"));
  kst++;
  fprintf(ff_l,gettext("Отчёт по учётным ценам.\n"));
  kst_l++;
 }
if(metka_ceni == 1)
 {
  fprintf(ff,gettext("Отчёт в ценах реализации.\n"));
  kst++;
  fprintf(ff_l,gettext("Отчёт в ценах реализации.\n"));
  kst_l++;
 }
if(sklz[0] != 0)
 {
  fprintf(ff,gettext("Склад %s\n"),sklz);
  kst++;
 }
if(korz[0] != '\0')
 {
  fprintf(ff,gettext("Код контрагента - %s\n"),korz);
  kst++;
  fprintf(ff_l,gettext("Код контрагента - %s\n"),korz);
  kst_l++;
 }
if(kodop[0] != '\0')
 {
  fprintf(ff,"%s - %s\n",gettext("Код операции"),kodop);
  kst++;
  fprintf(ff_l,"%s - %s\n",gettext("Код операции"),kodop);
  kst_l++;
 }
if(grz[0] != 0)
 {
  fprintf(ff,gettext("Группа - %s\n"),grz);
  kst++;
  fprintf(ff_l,gettext("Группа - %s\n"),grz);
  kst_l++;
 }
if(kodmz[0] != 0)
 {
  fprintf(ff,gettext("Материал - %s\n"),kodmz);
  kst++;
  fprintf(ff_l,gettext("Материал - %s\n"),kodmz);
  kst_l++;
 }
if(nabor[0] != '\0')
 {
  fprintf(ff,gettext("Набор операций - %s\n"),nabor);
  kst++;
  fprintf(ff_l,gettext("Набор операций - %s\n"),nabor);
  kst_l++;
 }
if(shetz[0] != '\0')
 {
  fprintf(ff,gettext("Счета учета - %s\n"),shetz);
  kst++;
  fprintf(ff_l,gettext("Счета учета - %s\n"),shetz);
  kst_l++;
 }
if(nomdokp[0] != '\0')
 {
  fprintf(ff,"%s - %s\n",gettext("Документ"),nomdokp);
  kst++;
  fprintf(ff_l,"%s - %s\n",gettext("Документ"),nomdokp);
  kst_l++;
 }
if(ndsc[0] != '\0')
 { 
  fprintf(ff,gettext("ПДВ: %s\n"),ndsc);
  kst++;
  fprintf(ff_l,gettext("ПДВ: %s\n"),ndsc);
  kst_l++;
 }

for(i=0; i < 2 ; i++)
 itgrup[i]=itkontr[i]=itsklad[i]=itshet[i]=0.;
  
memset(shuz,'\0',sizeof(shuz));
kgrmz=skl=0;
nkk=mvstr=skll=0;
kolstr1=0;

while(fgets(str,sizeof(str),ff1) != NULL)
 {
//  printw("%s",str);
  strzag(LINES-1,0,kolstr2,kolstr1++);  
  polen(str,shu,sizeof(shu),1,'|');
  polen(str,strsql,sizeof(strsql),2,'|');
  skl=atoi(strsql);
  polen(str,kor,sizeof(kor),3,'|');
  polen(str,strsql,sizeof(strsql),4,'|');
  kgrm=atoi(strsql);
  polen(str,strsql,sizeof(strsql),14,'|');
  nk=atoi(strsql);

  if(kgrmz != kgrm && (metoth == 0 || metoth == 2))
   {
    if(kgrmz != 0)
     {
      sprintf(bros,"%d",kgrmz);
      rasitogo(1,itgrup,&kst,bros,ff,metoth,dn,mn,gn,dk,mk,gk,&sli,0);
      rasitogo(1,itgrup,&kst_l,bros,ff_l,metoth,dn,mn,gn,dk,mk,gk,&sli_l,1);
     }
    kgrmz=kgrm;
   }

  if(SRAV(korzz,kor,0) != 0)
   {
    if(korzz[0] != '\0')
     {
      rasitogo(2,itkontr,&kst,korzz,ff,metoth,dn,mn,gn,dk,mk,gk,&sli,0);
      rasitogo(2,itkontr,&kst_l,korzz,ff_l,metoth,dn,mn,gn,dk,mk,gk,&sli_l,1);
     }
    strcpy(korzz,kor);
   }     
  if(skll != skl)
   {
    if(skll != 0)
     {
      sprintf(bros,"%d",kgrmz);
      rasitogo(1,itgrup,&kst,bros,ff,metoth,dn,mn,gn,dk,mk,gk,&sli,0);
      rasitogo(1,itgrup,&kst_l,bros,ff_l,metoth,dn,mn,gn,dk,mk,gk,&sli_l,1);

      rasitogo(2,itkontr,&kst,korzz,ff,metoth,dn,mn,gn,dk,mk,gk,&sli,0);
      rasitogo(2,itkontr,&kst_l,korzz,ff_l,metoth,dn,mn,gn,dk,mk,gk,&sli_l,1);

      sprintf(bros,"%d",skll);
      rasitogo(3,itsklad,&kst,bros,ff,metoth,dn,mn,gn,dk,mk,gk,&sli,0);
      rasitogo(3,itsklad,&kst_l,bros,ff_l,metoth,dn,mn,gn,dk,mk,gk,&sli_l,1);
            
     } 
    nkk=0;
    skll=skl;
   } 
  if(SRAV(shuz,shu,0) != 0 && (metoth == 0 || metoth == 2))
   {
    if(shuz[0] != '\0')
     {
      sprintf(bros,"%d",kgrmz);
      rasitogo(1,itgrup,&kst,bros,ff,metoth,dn,mn,gn,dk,mk,gk,&sli,0);
      rasitogo(1,itgrup,&kst_l,bros,ff_l,metoth,dn,mn,gn,dk,mk,gk,&sli_l,1);

      rasitogo(2,itkontr,&kst,korzz,ff,metoth,dn,mn,gn,dk,mk,gk,&sli,0);
      rasitogo(2,itkontr,&kst_l,korzz,ff_l,metoth,dn,mn,gn,dk,mk,gk,&sli_l,1);

      sprintf(bros,"%d",skll);
      rasitogo(3,itsklad,&kst,bros,ff,metoth,dn,mn,gn,dk,mk,gk,&sli,0);
      rasitogo(3,itsklad,&kst_l,bros,ff_l,metoth,dn,mn,gn,dk,mk,gk,&sli_l,1);

      rasitogo(4,itshet,&kst,shuz,ff,metoth,dn,mn,gn,dk,mk,gk,&sli,0);
      rasitogo(4,itshet,&kst_l,shuz,ff_l,metoth,dn,mn,gn,dk,mk,gk,&sli_l,1);
     }
    strcpy(shuz,shu);
   }
  polen(str,naim,sizeof(naim),6,'|');
  polen(str,kop,sizeof(kop),9,'|');

  polen(str,strsql,sizeof(strsql),7,'|');
  kodm=atoi(strsql);
  polen(str,shu,sizeof(shu),1,'|');
  polen(str,ei,sizeof(ei),8,'|');
  polen(str,strsql,sizeof(strsql),10,'|');
  cena=atof(strsql);


       
  mvstr=0;
  
  polen(str,strsql,sizeof(strsql),5,'|');
  rsdat(&dp,&mp,&gp,strsql,2);
  polen(str,strsql,sizeof(strsql),11,'|');
  rsdat(&d,&m,&g,strsql,2);
  polen(str,strsql,sizeof(strsql),12,'|');
  kolih=atof(strsql);

  polen(str,shetsp,sizeof(strsql),16,'|');
  
  itgrup[0]+=kolih;  
  itkontr[0]+=kolih;
  itsklad[0]+=kolih;
  itshet[0]+=kolih;
  itk+=kolih;

  br=cena*kolih;
  br=okrug(br,0.01);
  itgrup[1]+=br;  
  itkontr[1]+=br;
  itsklad[1]+=br;
  itshet[1]+=br;
  its+=br;
  
  /*Узнаем наименование контрагента*/
  if(kor[0] == '0' && POLE(kor,bros,2,'-') == 0)
   {
    strcpy(poi,bros);   
    sprintf(strsql,"select naik from Sklad where kod=%s",poi);
   }
  else
   {
    strcpy(poi,kor);   
    sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",
    poi);
   }

  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
     fprintf(ff,"%s %s !\n",gettext("Не найден код контрагента"),kor);
     fprintf(ff_l,"%s %s !\n",gettext("Не найден код контрагента"),kor);
     printw("%s %s %s !\n",gettext("Не найден код контрагента"),kor,poi);
     printw(gettext("Склад %d Ном. кар. %d Док.%s\n"),
     skl,nk,nomdok);
     fprintf(ff,gettext("Склад %d Ном. кар. %d Док.%s\n"),skl,nk,nomdok);
     fprintf(ff_l,gettext("Склад %d Ном. кар. %d Док.%s\n"),skl,nk,nomdok);
     OSTANOV();
   }
  else
    strncpy(org,row1[0],sizeof(org)-1);


  polen(str,strsql,sizeof(strsql),13,'|');
  if(atoi(strsql) == 1)
     strcat(kop,"+");
  if(atoi(strsql) == 2)
     strcat(kop,"-");
  polen(str,nomdok,sizeof(nomdok),15,'|');
 
  gsapp1(dn,mn,gn,dk,mk,gk,&sli,&kst,ff,0);
  gsapp1(dn,mn,gn,dk,mk,gk,&sli_l,&kst_l,ff_l,1);
  if(mvstr == 0)
   {
    sprintf(nomn,"%d.%s.%d.%d",skl,shu,kgrm,
    nk);
     
    fprintf(ff,"\
%-4d %-*.*s %-*s %-*s %14.10g %12.12g %15.2f %-15s %02d.%02d.%d %02d.%02d.%d %-7s %3s %s %s\n",
    kodm,
    iceb_tu_kolbait(35,naim),iceb_tu_kolbait(35,naim),naim,
    iceb_tu_kolbait(15,nomn),nomn,
    iceb_tu_kolbait(5,ei),ei,
    cena,kolih,br,nomdok,d,m,g,dp,mp,gp,kop,kor,org,shetsp);

    fprintf(ff_l,"\
%-4d %-*.*s %-*s %-*s %14.10g %12.12g %15.2f %-15s %02d.%02d.%d %02d.%02d.%d %-7s %3s %s %s\n",
    kodm,
    iceb_tu_kolbait(35,naim),
    iceb_tu_kolbait(35,naim),
    naim,
    iceb_tu_kolbait(15,nomn),
    nomn,
    iceb_tu_kolbait(5,ei),
    ei,
    cena,kolih,br,nomdok,d,m,g,dp,mp,gp,kop,kor,org,shetsp);

    if(iceb_tu_strlen(naim) > 35)
     {
      gsapp1(dn,mn,gn,dk,mk,gk,&sli,&kst,ff,0);
      fprintf(ff,"%4s %s\n"," ",iceb_tu_adrsimv(35,naim));
      gsapp1(dn,mn,gn,dk,mk,gk,&sli_l,&kst_l,ff_l,1);
      fprintf(ff_l,"%4s %s\n"," ",iceb_tu_adrsimv(35,naim));
     }
   }
  else
   {
    fprintf(ff,"\
%4s %-35s %-15s %-5s %14.10g %12.12g %15.2f %-15s %02d.%02d.%d %02d.%02d.%d %-7s %3s %s %s\n",
    " "," "," "," ",cena,kolih,br,nomdok,d,m,g,dp,mp,gp,kop,kor,org,shetsp);
    fprintf(ff_l,"\
%4s %-35s %-15s %-5s %14.10g %12.12g %15.2f %-15s %02d.%02d.%d %02d.%02d.%d %-7s %3s %s %s\n",
    " "," "," "," ",cena,kolih,br,nomdok,d,m,g,dp,mp,gp,kop,kor,org,shetsp);
   }  
  
  mvstr++;

 }

fclose(ff1);

sprintf(bros,"%d",kgrmz);
rasitogo(1,itgrup,&kst,bros,ff,metoth,dn,mn,gn,dk,mk,gk,&sli,0);
rasitogo(1,itgrup,&kst_l,bros,ff_l,metoth,dn,mn,gn,dk,mk,gk,&sli_l,1);

rasitogo(2,itkontr,&kst,korzz,ff,metoth,dn,mn,gn,dk,mk,gk,&sli,0);
rasitogo(2,itkontr,&kst_l,korzz,ff_l,metoth,dn,mn,gn,dk,mk,gk,&sli_l,1);

sprintf(bros,"%d",skll);
rasitogo(3,itsklad,&kst,bros,ff,metoth,dn,mn,gn,dk,mk,gk,&sli,0);
rasitogo(3,itsklad,&kst_l,bros,ff_l,metoth,dn,mn,gn,dk,mk,gk,&sli_l,1);

rasitogo(4,itshet,&kst,shuz,ff,metoth,dn,mn,gn,dk,mk,gk,&sli,0);
rasitogo(4,itshet,&kst_l,shuz,ff_l,metoth,dn,mn,gn,dk,mk,gk,&sli_l,1);

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n\
%*s:%12.12g %15.2f\n",iceb_tu_kolbait(77,gettext("Общий итог")),gettext("Общий итог"),itk,its);

fprintf(ff_l,"\
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n\
%77s:%12.12g %15.2f\n",gettext("Общий итог"),itk,its);


printw("%s:\n\
%-10s %12.12g\n\
%-10s %12.2f%s\n",
gettext("Итого"),
gettext("количество"),
itk,
gettext("сумма"),
its,
gettext("грн.")); 


}

/*********************************************/
/*Создание массивов счетов и групп материалов*/
/*********************************************/
void	sozshgr(masiv_din_int *GRUP, //Массив количества групп
SPISOK *SHET,        //Список счетов
int *kolgrup, //Количество групп
int *kolshet) //Количество счетов
{
SQL_str		row;
char		strsql[512];


sprintf(strsql,"select kod from Grup");

SQLCURSOR cur;
if((*kolgrup=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

while(cur.read_cursor(&row) != 0)
 {
  GRUP->plus(atoi(row[0]),-1);
 }

sprintf(strsql,"select distinct shetu from Kart");

if((*kolshet=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

while(cur.read_cursor(&row) != 0)
 {
  SHET->plus(row[0]);
 }

}
/******************************************/
/*Распечатка массива группа-счет          */
/******************************************/

void rasgrsh(char *imaf,
short dn,short mn,short gn,
short dk,short mk,short gk,
masiv_din_int *GRUP, //Массив количества групп
SPISOK *SHET, //Список счетов
int kolgrup, //Количество групп
int kolshet, //Количество счетов
double *sumshgr,
char *shetz,
char *nabor,char *kodmz,char *grz,const char *kodop,char *korz,
char *sklz,char *nomdokp,char *ndsc,
short metka_ceni)
{
FILE	*ff;
time_t	tmm;
struct  tm      *bf;
int	i,i1,i2;
int	nomgrup;
char	shet[32];
char	strsql[512];
SQL_str	row;
SQLCURSOR cur;
char	naimgrup[512];
char	stroka[1024];
double	itogkol=0.;
double  itogo=0.;

time(&tmm);
bf=localtime(&tmm);

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

zagolov(gettext("Движение товарно-материалных ценностей по группам и счетам"),bf,dn,mn,gn,dk,mk,gk,organ,ff);

if(metka_ceni == 2)
 fprintf(ff,gettext("Отчёт по учётным ценам.\n"));
if(metka_ceni == 1)
 fprintf(ff,gettext("Отчёт в ценах реализации.\n"));
if(sklz[0] != 0)
  fprintf(ff,gettext("Склад %s\n"),sklz);
if(korz[0] != '\0')
  fprintf(ff,gettext("Код контрагента - %s\n"),korz);
if(kodop[0] != '\0')
  fprintf(ff,"%s - %s\n",gettext("Код операции"),kodop);
if(grz[0] != 0)
  fprintf(ff,gettext("Группа - %s\n"),grz);
if(kodmz[0] != 0)
  fprintf(ff,gettext("Материал - %s\n"),kodmz);
if(nabor[0] != '\0')
  fprintf(ff,gettext("Набор операций - %s\n"),nabor);
if(shetz[0] != '\0')
  fprintf(ff,gettext("Счета учета - %s\n"),shetz);
if(nomdokp[0] != '\0')
  fprintf(ff,"%s - %s\n",gettext("Документ"),nomdokp);
if(ndsc[0] != '\0')
  fprintf(ff,gettext("ПДВ: %s\n"),ndsc);


memset(stroka,'\0',sizeof(stroka));
sprintf(stroka,"-----------------------------------"); //Строка на наименованием

for(i1=0; i1 < kolshet+1;i1++)
 {
  itogkol=0.;
  for(i=0; i < kolgrup;i++)
   {
    itogkol+=sumshgr[i*kolshet+i1];
   }
  if(itogkol == 0.)
    continue;
  strcat(stroka,"-----------");
 }
fprintf(ff,"%s\n",stroka);  

fprintf(ff,"Код|  Наименование группы         |");

for(i1=0; i1 < kolshet;i1++)
 {
  itogkol=0.;
  for(i=0; i < kolgrup;i++)
   {
    itogkol+=sumshgr[i*kolshet+i1];
   }
  if(itogkol == 0.)
    continue;
  strcpy(shet,SHET->ravno(i1));
  fprintf(ff,"%*s|",iceb_tu_kolbait(10,shet),shet);
 }
fprintf(ff,"%*s|\n",iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"));

fprintf(ff,"%s\n",stroka);  

for(i=0; i < kolgrup; i++)
 {
  itogkol=0.;
  for(i1=0; i1 < kolshet;i1++)
      itogkol+=sumshgr[i*kolshet+i1];
  if(itogkol == 0.)
    continue;

  nomgrup=GRUP->ravno(i);  
  memset(naimgrup,'\0',sizeof(naimgrup));
  sprintf(strsql,"select naik from Grup where kod=%d",nomgrup);
  if(sql_readkey(&bd,strsql,&row,&cur) == 1)
    strncpy(naimgrup,row[0],sizeof(naimgrup)-1);
  fprintf(ff,"%3d %-*.*s",nomgrup,iceb_tu_kolbait(30,naimgrup),iceb_tu_kolbait(30,naimgrup),naimgrup);    
  itogo=0.;
  for(i1=0; i1 < kolshet;i1++)
   {
    itogkol=0.;
    for(i2=0; i2 < kolgrup;i2++)
     {
      itogkol+=sumshgr[i2*kolshet+i1];
     }
    if(itogkol == 0.)
      continue;
    fprintf(ff," %10.2f",sumshgr[i*kolshet+i1]);
    itogo+=sumshgr[i*kolshet+i1];
   }

  fprintf(ff," %10.2f\n",itogo);
 }

fprintf(ff,"%s\n",stroka);  
fprintf(ff,"%*s:",iceb_tu_kolbait(33,gettext("Итого")),gettext("Итого"));
itogo=0.;
for(i1=0; i1 < kolshet; i1++)
 {
  itogkol=0.;
  for(i=0; i < kolgrup;i++)
   {
    itogkol+=sumshgr[i*kolshet+i1];
   }
  if(itogkol == 0.)
    continue;
  fprintf(ff," %10.2f",itogkol);
  itogo+=itogkol;
 }

fprintf(ff," %10.2f\n",itogo);

podpis(ff);
fclose(ff);

}

/***********************************************/
/*Распечатка группа-счет-счет корреспондент    */
/***********************************************/
void rasgshshk(short dn,short mn,short gn,
short dk,short mk,short gk,
const char *shetz,
const char *nabor,const char *kodmz,const char *grz,const char *kodop,const char *korz,
const char *sklz,const char *nomdokp,const char *ndsc,
const char *imaf,
SPISOK *GSHSHK,      //Список группа-счет-счет корреспондент
masiv_din_double *SUMGSHSHK, //Суммы к списку  группа-счет-счет корреспондент
short metka_ceni)
{
FILE	*ff;
time_t	tmm;
struct  tm      *bf;
char	strsql[512];
SQL_str	row;
int	kolstr=0;
int	kolelem=0;
int	i=0;
short   metkavgr=0;
char	kod[32];
char	shet[32];
char	shetk[32];
double	itoggr=0.;

time(&tmm);
bf=localtime(&tmm);

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

zagolov(gettext("Движение товарно-материалных ценностей по группам и счетам"),bf,dn,mn,gn,dk,mk,gk,organ,ff);

if(metka_ceni == 2)
 fprintf(ff,gettext("Отчёт по учётным ценам.\n"));
if(metka_ceni == 1)
 fprintf(ff,gettext("Отчёт в ценах реализации.\n"));
if(sklz[0] != 0)
  fprintf(ff,gettext("Склад %s\n"),sklz);
if(korz[0] != '\0')
  fprintf(ff,gettext("Код контрагента - %s\n"),korz);
if(kodop[0] != '\0')
  fprintf(ff,"%s - %s\n",gettext("Код операции"),kodop);
if(grz[0] != 0)
  fprintf(ff,gettext("Группа - %s\n"),grz);
if(kodmz[0] != 0)
  fprintf(ff,gettext("Материал - %s\n"),kodmz);
if(nabor[0] != '\0')
  fprintf(ff,gettext("Набор операций - %s\n"),nabor);
if(shetz[0] != '\0')
  fprintf(ff,gettext("Счета учета - %s\n"),shetz);
if(nomdokp[0] != '\0')
  fprintf(ff,"%s - %s\n",gettext("Документ"),nomdokp);
if(ndsc[0] != '\0')
  fprintf(ff,gettext("ПДВ: %s\n"),ndsc);

sprintf(strsql,"select kod,naik from Grup order by kod asc");

SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

kolelem=GSHSHK->kolih();
while(cur.read_cursor(&row) != 0)
 {
  if(itoggr != 0)
   {
    fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(13,gettext("Итого")),gettext("Итого"),itoggr);
    itoggr=0.;
   }

  metkavgr=0;  
  for(i=0; i < kolelem; i++)
   {
    POLE(GSHSHK->ravno(i),kod,1,'#');
    if(SRAV(kod,row[0],0) == 0)
     {
      if(metkavgr == 0)
       {
        fprintf(ff,"\n%s %s\n",row[0],row[1]);

        fprintf(ff,"\
------------------------------\n");
        fprintf(ff,gettext("\
Дебет |Кредит|    Сумма      |\n"));
        fprintf(ff,"\
------------------------------\n");

//        sapitsh(ff); //rppvo.c
        metkavgr=1;
       }
      POLE(GSHSHK->ravno(i),shet,2,'#');
      POLE(GSHSHK->ravno(i),shetk,3,'#');
      if(shetk[0] == '\0')
       strcpy(shetk,"???");
      fprintf(ff,"%-*s %-*s %10.2f\n",
      iceb_tu_kolbait(6,shet),shet,
      iceb_tu_kolbait(6,shetk),shetk,
      SUMGSHSHK->ravno(i));
      itoggr+=SUMGSHSHK->ravno(i);
     }            

   }  

 }

if(itoggr != 0)
  fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(13,gettext("Итого")),gettext("Итого"),itoggr);


podpis(ff);
fclose(ff);

}
/**************************************/
/*Вывод шапки*/
/***************************/
void dvtmcf2_sap(short dn,short mn,short gn,short dk,short mk,
short gk,
int *sl, //Счетчик листов
int *kst, //Счетчик строк
FILE *ff)
{
*sl+=1;

fprintf(ff,"\
%s %02d.%02d.%4d%s %s %02d.%02d.%4d%s %*sN%d\n",
gettext("Период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
iceb_tu_kolbait(100,gettext("Лист")),gettext("Лист"),*sl);

 fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,gettext("Код |        Наименование               |   Номенкла-   |Един.|              |            |               |               | Д а т а  | Д а т а  | Код   |\n"));
fprintf(ff,gettext("    |    товара или материалла          | турный номер  |изме-|   Ц е н а    | Количество |     Сумма     |Номер документа| выписки  |подтверж- |опера- |         К о н т р а г е н т\n"));
fprintf(ff,gettext("    |                                   |               |рения|              |            |               |               |документа | дения    | ции   |\n"));

  fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
  *kst+=6;
}
