/*$Id: f1df_xml_kon.c,v 5.8 2011-05-06 08:29:23 sasa Exp $*/
/*15.04.2009	23.04.2007	Белых А.И.	f1df_xml_kon.c
Концовка xml файла формы 1ДФ
*/

#include <buhg.h>

void f1df_xml_kon(double isumadn,
double isumad,
double isumann,
double isuman,
int nomer_xml_str,
int kolr,
int klls,
const char *naim_kontr,
const char *telef_kontr,
int TYP,
FILE *ff_xml)
{
fprintf(ff_xml,"  <R01G03A>%.2f</R01G03A>\n",isumadn);
fprintf(ff_xml,"  <R01G03>%.2f</R01G03>\n",isumad);
fprintf(ff_xml,"  <R01G04A>%.2f</R01G04A>\n",isumann);
fprintf(ff_xml,"  <R01G04>%.2f</R01G04>\n",isuman);

fprintf(ff_xml,"  <R02G01I>%d</R02G01I>\n",nomer_xml_str);
fprintf(ff_xml,"  <R02G02I>%d</R02G02I>\n",kolr);
fprintf(ff_xml,"  <R02G03I>%d</R02G03I>\n",klls);

char bros[512];
char fioruk[512];
char telef[512];
  
//class iceb_tu_str imaf_nzar;
//imafn("zarnast.alx",&imaf_nzar);

iceb_t_poldan("Табельный номер руководителя",bros,"zarnast.alx");
char inn[20];
char strsql[512];
SQL_str row1;
class SQLCURSOR curr;
memset(fioruk,'\0',sizeof(fioruk));
memset(inn,'\0',sizeof(inn));
memset(telef,'\0',sizeof(telef));
if(bros[0] != '\0')
 {
  sprintf(strsql,"select fio,inn,telef from Kartb where tabn=%s",bros);
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    beep();
    printw("Не знайдено табельного номера %s керівника !\n",bros);
    OSTANOV();
   }
  else
   {
    strncpy(fioruk,row1[0],sizeof(fioruk)-1);
    strncpy(inn,row1[1],sizeof(inn)-1);
    strncpy(telef,row1[2],sizeof(telef)-1);
    ud_simv(telef,"-/.()+,");
   }
 } 
if(inn[0] != '\0')
  fprintf(ff_xml,"  <HKBOS>%s</HKBOS>\n",inn);
if(fioruk[0] != '\0')
  fprintf(ff_xml,"  <HBOS>%s</HBOS>\n",iceb_tu_filtr_xml(fioruk));
if(telef[0] != '\0')
  fprintf(ff_xml,"  <HTELBOS>%s</HTELBOS>\n",iceb_tu_filtr_xml(telef));

bros[0]='\0';
iceb_t_poldan("Табельный номер бухгалтера",bros,"zarnast.alx");
char fio[512];
memset(fio,'\0',sizeof(fio));
memset(inn,'\0',sizeof(inn));
memset(telef,'\0',sizeof(telef));

if(bros[0] != '\0')
 {
  sprintf(strsql,"select fio,inn,telef from Kartb where tabn=%s",bros);
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    beep();
    printw("Не знайдено табельного номера %s головного бухгалтера!\n",bros);
    OSTANOV();
   }
  else
   {
    strncpy(fio,row1[0],sizeof(fio)-1);
    strncpy(inn,row1[1],sizeof(inn)-1);
    strncpy(telef,row1[2],sizeof(telef)-1);
    ud_simv(telef,"-/.()+,");

   }
 }

if(inn[0] != '\0')
  fprintf(ff_xml,"  <HKBUH>%s</HKBUH>\n",inn);
if(fio[0] != '\0')
  fprintf(ff_xml,"  <HBUH>%s</HBUH>\n",iceb_tu_filtr_xml(fio));
if(telef[0] != '\0')
  fprintf(ff_xml,"  <HTELBUH>%s</HTELBUH>\n",iceb_tu_filtr_xml(telef));

short dt,mt,gt;
poltekdat(&dt,&mt,&gt);

fprintf(ff_xml,"  <HFILL>%02d%02d%d</HFILL>\n",dt,mt,gt);


if(TYP == 1)
 {
  if(naim_kontr[0] != '\0')
    fprintf(ff_xml,"  <HFO>%s<HFO>\n",iceb_tu_filtr_xml(naim_kontr));
  if(telef_kontr[0] != '\0')
    fprintf(ff_xml,"  <HTELFO>%s<HTELFO>\n",iceb_tu_filtr_xml(telef_kontr));
 }

fprintf(ff_xml," </DECLARBODY>\n");
fprintf(ff_xml,"</DECLAR>\n");
fclose(ff_xml);

}


