/* $Id: fbezr.c,v 5.42 2011-01-13 13:43:22 sasa1 Exp $ */
/*21.12.2010	03.08.2000	Белых А.И.   	fbezr.c
Расчет отчислений в фонд безработицы
*/
#include        <math.h>
#include        "buhg.h"


extern short	metkarnb; //Расчет налогов для бюджета пропорциональный 1-последовательный
extern short    kodbzr;  /*Код отчисления на безработицу*/
extern float    procbez; /*Процент отчисления на безработицу*/
extern double   ogrzp[2]; /*Ограничение на начисление пенсионного отчисления*/
extern double   okrg; /*Округление*/
extern char	*shetb; /*Бюджетные счета*/
extern char	*shpnb;   /*Бюджетный счет подоходного налога*/
extern char	*shetfb; /*Счета фонда безработицы*/
extern short	*kodbzrnv; //Коды не входящие в расчет отчислений на безработицу
extern short    *kodmp;   /*Коды материальной помощи*/

void fbezr(long tabn,short mp,short gp,
int podr, //Подразделение
double *fbezr, //Общая сумма фонда безработицы с чистой зарплаты
double *fbezrb, //Сумма безработицы по бюджету с чистой зарплаты
int metka_zap, //0-записывать 1-не записывать
int metka_ras, //0-смотреть в массиве 1-в базе
double suma_boln,
double *i_bezr, //Общая сумма отчисления в форд безработицы
double *i_bezrb, //Общая сумма отчисления в фонд безработицы для бюджета
const char *uder_only,
FILE *ff_prot)
{
char		bros[512];
SQL_str         row;
SQLCURSOR curr;
char		strsql[512];
char		shet[32];
double		bbpn;
double		sumanb,sumabu;
double		sumab=0.;
double		bb1,bb2;
short		den;
struct ZARP     zp;
double          suma_zarp_o; //Сумма чистой зарплаты общая
double          suma_zarp_b; //Сумма чистой зарплаты бюджетная
double suma_boln_rm=0.; 
*fbezr=*fbezrb=*i_bezr=*i_bezrb=0.;
dpm(&den,&mp,&gp,5);

zp.dz=den;
zp.mesn=mp; zp.godn=gp;
zp.nomz=0;
zp.podr=podr;


if(ff_prot != NULL)
   fprintf(ff_prot,"\n%s-Розсчёт утдеражания в фонд безроботицы\n\
-----------------------------------------------------\n",__FUNCTION__);
if(proverka(uder_only,kodbzr,0,0) != 0)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Код %d исключён из расчёта\n",kodbzr);
  return;
 }
/*Проверяем есть ли код удержания отчисления в фонд безработицы*/

memset(strsql,'\0',sizeof(strsql));
sprintf(strsql,"select shet from Zarn1 where tabn=%ld and prn='2' and \
knah=%d",tabn,kodbzr);
double suma_ndfnz,suma_ndfnz_b;
if(sql_readkey(&bd,strsql,&row,&curr) >= 1)
 {
  strncpy(shet,row[0],sizeof(shet)-1);

/*Пока кодов нет*/
/*Пересчитываем чтобы учесть больничный если он есть берется с общей
  суммы так как нет диапазона процентов*/
  if(metka_ras == 0)
    bbpn=findnahm(mp,4,kodbzrnv,ff_prot,&sumanb,&sumabu,&suma_ndfnz,&suma_ndfnz_b,&suma_zarp_o,&suma_zarp_b,&suma_boln_rm);
  else
   {
    bbpn=findnahm(mp,gp,tabn,4,kodbzrnv,ff_prot,&sumanb,&sumabu,&suma_ndfnz,&suma_ndfnz_b,&suma_zarp_o,&suma_zarp_b,&suma_boln_rm);
    //если есть сyмма больничного значит делаем перерасчёт подоходного для больничных на которые 
    //распространяется социальная льгота 
    if(suma_boln != 0.)
     if(ff_prot != NULL)
      fprintf(ff_prot,"Увеличиваем на сумму больничного\n");
    bbpn+=suma_boln;
    sumanb+=suma_boln;
    suma_zarp_o+=suma_boln;
   }

//  rudnfv(&bbpn,suma_ndfnz,ff_prot);

//  rudnfv(&suma_zarp_o,suma_ndfnz,ff_prot);

//  rudnfv(&suma_zarp_b,suma_ndfnz_b,ff_prot);

  if(ff_prot != NULL)
    fprintf(ff_prot,"С общей суммы\n");
  *i_bezr=bb1=fbezr_sumnal(bbpn);

  if(ff_prot != NULL)
    fprintf(ff_prot,"Сумма=%.2f Безробіття: %.2f\n",bbpn,bb1);

  if(ff_prot != NULL)
    fprintf(ff_prot,"Только с зарплаты\n");

  *fbezr=fbezr_sumnal(suma_zarp_o);

  if(ff_prot != NULL)
    fprintf(ff_prot,"Сумма=%.2f Безробіття: %.2f\n",suma_zarp_o,*fbezr);


  
  memset(bros,'\0',sizeof(bros));
  if(shetb == NULL || shetfb == NULL)
   {
    strcpy(zp.shet,shet);
    if(ff_prot != NULL)
      fprintf(ff_prot,"Не бюджетная организация. %f\n",bb1);   
    if(metka_zap == 0)
     zapzarp(den,mp,gp,tabn,2,kodbzr,bb1,shet,mp,gp,0,0,bros,podr,"",zp);
   }
  else
   {
    if(ff_prot != NULL)
      fprintf(ff_prot,"Бюджетная организация.\n");   
    bb2=0.;
    if(metkarnb == 1) //Последовательный расчет бюджет/хозрасчет
     { 
      //Считаем налог для бюджета
           
      sumab=sumabu;
      if(ff_prot != NULL)
       fprintf(ff_prot,"suma_ndfnz_b=%f\n",suma_ndfnz_b);
//      rudnfv(&sumab,suma_ndfnz_b,ff_prot);            
      if(ff_prot != NULL)
          fprintf(ff_prot,"С общей суммы\n");

      bb2=fbezr_sumnal(sumab);
      
      if(ff_prot != NULL)
        fprintf(ff_prot,"Бюджет последовательный %.2f (%f)\n",bb2,sumabu);            

      if(ff_prot != NULL)
       fprintf(ff_prot,"Только с зарплаты\n");

      *fbezrb=fbezr_sumnal(suma_zarp_b);
      if(ff_prot != NULL)
        fprintf(ff_prot,"Бюджет последовательный %.2f (%f)\n",*fbezrb,suma_zarp_b);            
     }

/*****************************************/

    if(metkarnb == 0) //Пропорциональный расчет налога
     { 
      
      if(ff_prot != NULL)
       fprintf(ff_prot,"Разбивка суммы: не бюджет=%.2f бюджет:%.2f\n",sumanb,sumabu);

      if(sumabu != 0.)
       {
        //Узнаем долю бюджета в оставшейся сумме к расчету
        //Если хозрасчет не равен нолю то долю определять надо
        if(sumanb != 0.)
          bb2=bb1*sumabu/bbpn;
        else
          bb2=bb1;

        if(suma_zarp_b != 0.)
          *fbezrb=*fbezr*suma_zarp_b/suma_zarp_o;
        else
          *fbezrb=0.;

//        *fbezrb=bb2;
       }
     }

    *i_bezrb=bb2=okrug(bb2,okrg);
  
    polen(shetfb,shet,sizeof(shet),2,',');
    if(ff_prot != NULL)
       fprintf(ff_prot,"Бюджет %.2f\n",bb2);            
        
    if(shet[0] != '\0')
     {
      strcpy(bros,gettext("Бюджет."));
      if(ff_prot != NULL)
        fprintf(ff_prot,"%s %.2f\n",bros,bb2);
      strcpy(zp.shet,shet);
     
      if(metka_zap == 0)
        zapzarp(den,mp,gp,tabn,2,kodbzr,bb2,shet,mp,gp,0,0,bros,podr,"",zp);
     }


     polen(shetfb,shet,sizeof(shet),1,',');
     bb2=bb1-bb2;
        
     bb2=okrug(bb2,okrg);
     if(shet[0] != '\0')
      {
       strcpy(bros,gettext("Хозрасчет"));
        if(ff_prot != NULL)
           fprintf(ff_prot,"%s %.2f\n",bros,bb2);
        strcpy(zp.shet,shet);
       if(metka_zap == 0)
        zapzarp(den,mp,gp,tabn,2,kodbzr,bb2,shet,mp,gp,0,0,bros,podr,"",zp);
      }
   }
 }
else
 if(ff_prot != NULL)
  fprintf(ff_prot,"Не введен код отчисления в фонд безработицы !\n");
}
/***************************************/
/*Определение cуммы налога*/
/***************************************/
double fbezr_sumnal(double suma)
{
double nalog=0.;

double bbpr=0.;
if(procbez != 0.)
    bbpr=procbez/100.;

if(suma <= ogrzp[1])
  nalog=suma*bbpr;
else
  nalog=ogrzp[1]*bbpr;

nalog=okrug(nalog,okrg)*(-1);

return(nalog);

}
