/* $Id: gurorr.c,v 5.61 2011-01-13 13:43:22 sasa1 Exp $ */
/*09.11.2009    22.09.1993      Белых А.И.      gurorr.c
Получение оборотной ведомости по счетам с развернутым сальдо
Необходимо получить обороты по организациям.
Заряжаем организации в массив организаций
Определяем перечень счетов по дебету и кредиту
Определяем начальное сальдо
Просматроиваем период и записываем данные в массив
Распечатываем данные организации, с нулевыми результатами
не распечатываем
*/
#include        <errno.h>
#include        <math.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

int gurorrp(const char*,short,short,short,short,short,short,short,const char*,const char*,int metka_sort,class spis_oth*);
int gosrs(const char *shet,short dn,short mn,short gn,short dk,short mk,short gk,short vds,const char *kodgr,int metkasort,class spis_oth *oth);

extern char     *organ;
extern short	startgodb; /*Стартовый год*/
extern short	vplsh; /*0-двух уровневый план счетов 1-многоуровневый*/

int gurorr(const char *sh, //Номер счета
short dn,short mn,short gn, //Дата начала периода
short dk,short mk,short gk, //Дата конца периода
short vds, //0-счет 1-субсчет
const char *naim,
const char *mos, //Код группы контрагентов
class spis_oth *oth)
{
int             kom=0;
short           dp,mp,gp;
int             sub;
short		godn;
int metkasort=0;

godn=startgodb;
if(startgodb == 0 || startgodb > gn)
 godn=gn;


clear(); /*Очистить экран и закрасить фоновым цветом*/
VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите форму распечатки"));

MENU.VVOD_SPISOK_add_MD(gettext("Распечатка журнала-ордера"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Распечатка проводок по контрагентам"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//4
kom=0;
while(menu3(&MENU,&kom,1,-1,-1) != 0);
 
if(kom == 2 || kom == -1)
 return(1);
dp=dn;
mp=mn;
gp=gn;
dpm(&dp,&mp,&gp,2);


MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите режим"));

MENU.VVOD_SPISOK_add_MD(gettext("Расчитать по субсчетам"));
MENU.VVOD_SPISOK_add_MD(gettext("Расчитать по счетам"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

sub=0;
while(menu3(&MENU,&sub,1,-1,-1) != 0);
 
if(sub == 2 || sub == -1)
 return(1);



MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите режим"));

MENU.VVOD_SPISOK_add_MD(gettext("Без сортироки"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Сортировка по коду контрагента в символьном виде"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Сортировка по коду контрагента в цифровом виде"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Сортировка по наименованию контрагента"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Сортировка по группе контрагента"));//4
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//5
metkasort=0;
while(menu3(&MENU,&metkasort,1,-1,-1) != 0);
 
if(metkasort == 5 || metkasort == -1)
  return(1);



clear();
GDITE();

if(kom == 1)
  return(gurorrp(sh,dn,mn,gn,dk,mk,gk,vds,naim,mos,metkasort,oth));
else
 return(gosrs(sh,dn,mn,gn,dk,mk,gk,vds,mos,metkasort,oth));

}
