/*$Id: hap_act_vr.c,v 5.8 2011-01-13 13:43:22 sasa1 Exp $*/
/*12.12.2010	19.04.2006	Белых А.И.	hap_act_vr.c
Распечатка шапки акта выполненых работ
*/
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


int hap_act_vr(short dd,short md,short gd,
const char *nomdok,
const char *naim_kontr,
const char *dover,
const char *ispolnitel,
FILE *ff)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];

char bros[512];
memset(bros,'\0',sizeof(bros));
int kol_str_ots=0;
//читаем количество сторок отступа для логотипа
if(iceb_t_poldan("Количество строк отступа для счёта с логотипом",bros,"uslnast.alx") == 0)
  kol_str_ots=atoi(bros);

for(int i=0; i < kol_str_ots; i++)
 fprintf(ff,"\n");

sprintf(strsql,"select str from Alx where fil='usl_act_vr.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"usl_act_vr.alx");
  iceb_t_soob(strsql);
  return(1);
 }

char stroka[1024];
int nomer_str=0;
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  memset(stroka,'\0',sizeof(stroka));
  strncpy(stroka,row_alx[0],sizeof(stroka)-1);
//  printw("%s",stroka);
  nomer_str++;
  switch(nomer_str)
   {
    case 2:
     BSTAB(stroka,nomdok,39,76,1);
     break;

    case 5:
     BSTAB(stroka,naim_kontr,10,43,1);
     BSTAB(stroka,dover,58,76,1);
     break;

    case 6:
     BSTAB(stroka,&naim_kontr[33],1,43,1);
     break;

    case 7:
     BSTAB(stroka,ispolnitel,12,43,1);
     break;

    case 8:
     BSTAB(stroka,&ispolnitel[31],1,43,1);
     break;

    case 9:
     sprintf(bros,"%02d.%02d.%d",dd,md,gd);
     BSTAB(stroka,bros,17,37,1);
     break;
     
   }
  fprintf(ff,"%s",stroka);
 }
return(0);
}
