/*$Id: imp_ks.c,v 5.21 2011-02-02 11:55:43 sasa1 Exp $*/
/*06.12.2010	04.04.2004	Белых А.И.	imp_ks.c
Импорт карт-счетов в подсистему "Расчет зарплаты"
*/
#include        <errno.h>
#include        <sys/types.h>
#include        <sys/stat.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void imp_ukrsoc(char *imafim);



void imp_ks()
{
struct stat work;
int kom=0;
static class iceb_tu_str imafim(""); 
static char imafprom[40];
FILE		*ff,*ffprom;
char            strsql[512];
SQL_str row;
class SQLCURSOR cur;

VVOD VVOD1(2);
clear();
VVOD1.VVOD_SPISOK_add_ZAG(gettext("Импорт карт-счетов из файла"));
VVOD1.VVOD_SPISOK_add_MD(gettext("Введите имя файла"));

naz:;

clear();

helstr(LINES-1,0,
"F1",gettext("помощь"),
"F2/+",gettext("загруз."),
"F3",gettext("просмотр"),
"F10",gettext("выход"),NULL);

if((kom=vvod1(&imafim,112,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
  return;
if(kom == ESC)
  return;

switch(kom)
 {
  case FK1:
    GDITE();
    iceb_t_pdoc("zarp2_13.txt");
    clear();
    goto naz;

  case ENTER:
  case FK2:
  case PLU:
    if(imafim.ravno()[0] == '\0')
     {
      dirkatl(&imafim);
      goto naz;
     }
    break;

  case FK3:
   GDITE();
   if(stat(imafim.ravno(),&work) != 0)
    {
     VVOD SOOB(1);
     sprintf(strsql,"%s !",gettext("Нет такого файла"));
     SOOB.VVOD_SPISOK_add_MD(strsql);
     soobshw(&SOOB,stdscr,-1,-1,0,1);
     goto naz;
    }
    vizred(imafim.ravno());
    goto naz;

  default:
    goto naz;
 }


//imp_ukrsoc(imafim.ravno());
//return;

clear();
move(LINES-1,0);
GDITE();
time_t tmm;
struct tm *bf;

time(&tmm);
bf=localtime(&tmm);

if(stat(imafim.ravno(),&work) != 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s !",gettext("Нет такого файла"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
int kod_banka=zarvbank();
/*******************
class iceb_tu_str kod_banka("");
class iceb_tu_str naim_banka("");

sprintf(strsql,"select kod from Zarsb");
if((kolstr=readkey(strsql,&row,&cur)) > 0)
 {
  if(kolstr == 1)
   kod_banka.new_plus(row[0]);
  else
    if(dirsb(2,&kod_banka,&naim_banka) != 0)
      goto naz;
 }
**************************/
if((ff = fopen(imafim.ravno(),"r")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s:%d !",
  gettext("Ошибка окрытия файла"),imafim.ravno(),errno);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
sprintf(imafprom,"prom%d.tmp",getpid());
if((ffprom = fopen(imafprom,"w")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s:%d !",
  gettext("Ошибка окрытия файла"),imafprom,errno);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

int razmer=0;
char strok[1024];
int  i=0;
char inn[312];
char kartshet[112];
class iceb_tu_str fio("");
class iceb_tu_str imq("");
class iceb_tu_str oth("");

while(fgets(strok,sizeof(strok),ff) != NULL)
 {
  i=strlen(strok);
  razmer+=i;
  if(strok[i-2] == '\r') //Возврат каретки меняем на пробел
   strok[i-2]=' ';

  printw("%s",strok);
  strzag(LINES-1,0,work.st_size,razmer);

  if(polen(strok,inn,sizeof(inn),1,' ') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }

  //Ищем табельный номер
  sprintf(strsql,"select tabn from Kartb where inn='%s' order by tabn desc",inn);
  if(sql_readkey(&bd,strsql,&row,&cur) == 0)
   {
    polen(strok,&fio,3,' ');
    polen(strok,&imq,4,' ');
    polen(strok,&oth,5,' ');

    sprintf(strsql,"select tabn,inn from Kartb where fio='%s %s %s'",
    fio.ravno_filtr(),
    imq.ravno_filtr(),
    oth.ravno_filtr());
    
    if(readkey(strsql,&row,&cur) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s:%s",\
      gettext("Не найден идентефикационный код"),inn);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);

      fprintf(ffprom,"%s",strok);
      continue;
     }
    if(row[1][0] != '\0')
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s:%s",\
      gettext("Не найден идентефикационный код"),inn);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);

      fprintf(ffprom,"%s",strok);
      continue;
     }
    sprintf(strsql,"update Kartb set inn='%s' where tabn=%s",inn,row[0]);
    printw("%s\n",strsql);  
    sql_zapis(strsql,1,0);
   }
  polen(strok,kartshet,sizeof(kartshet),2,' ');

  sprintf(strsql,"update Kartb set bankshet='%s',kb=%d where inn='%s'",kartshet,kod_banka,inn);
//  printw("%s\n",strsql);  
  sql_zapis(strsql,1,0);

  sprintf(strsql,"replace into Zarkh values(%s,%d,'%s',%d,%ld)",row[0],kod_banka,kartshet,iceb_t_getuid(),time(NULL));
  sql_zapis(strsql,1,0);
      
 }

fclose(ff);
fclose(ffprom);
unlink(imafim.ravno());

rename(imafprom,imafim.ravno());

}
/*************************************/
/*Загрузка для Укрсоцбанка*/
/***************************/

void imp_ukrsoc(char *imafim)
{
struct stat work;
char strsql[512];
char	imafprom[40];


clear();
move(LINES-1,0);
GDITE();
time_t tmm;
struct tm *bf;

time(&tmm);
bf=localtime(&tmm);

if(stat(imafim,&work) != 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s !",gettext("Нет такого файла"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

FILE *ff;
FILE *ffprom;

if((ff = fopen(imafim,"r")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s:%d !",
  gettext("Ошибка окрытия файла"),imafim,errno);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }
sprintf(imafprom,"prom%d.tmp",getpid());
if((ffprom = fopen(imafprom,"w")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s:%d !",
  gettext("Ошибка окрытия файла"),imafprom,errno);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

int razmer=0;
char strok[1024];
int  i=0;
char inn[300];
char kartshet[100];
SQLCURSOR cur;
SQL_str   row;

while(fgets(strok,sizeof(strok),ff) != NULL)
 {
  i=strlen(strok);
  razmer+=i;
  if(strok[i-2] == '\r') //Возврат каретки меняем на пробел
   strok[i-2]=' ';

  printw("%s",strok);
  strzag(LINES-1,0,work.st_size,razmer);

  if(polen(strok,inn,sizeof(inn),1,',') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }

  //Проверяем налоговый номер
  sprintf(strsql,"select inn from Katrb where inn='%s'",inn);
  if(sql_readkey(&bd,strsql,&row,&cur) < 1)
   {
    fprintf(ffprom,"%s",strok);
   }

  if(polen(strok,kartshet,sizeof(kartshet),8,',') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }

  sprintf(strsql,"update Kartb set bankshet='%s' where inn='%s'",
  kartshet,inn);
  
  sql_zapis(strsql,1,0);
    
 }

fclose(ff);
fclose(ffprom);
unlink(imafim);

rename(imafprom,imafim);


}
