/*$Id: impuosdok.c,v 5.19 2011-01-13 13:43:22 sasa1 Exp $*/
/*19.06.2010	18.11.2002	Белых А.И. 	impuosdok.c
Импорт документов для "Учета основных средств"
*/
#include        <errno.h>
#include        <math.h>
#include        <time.h>
#include        <sys/types.h>
#include        <sys/stat.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

int	impuosdokz(int,const char*);

extern char     *organ;
extern double	okrcn;  /*Округление цены*/

void	impuosdok(void)
{
struct stat     work;
time_t 		tmm;
struct tm	*bf;
int         	kom=0;
static class iceb_tu_str imafim("");
char		strsql[512];


VVOD VVOD1(2);
VVOD1.VVOD_SPISOK_add_ZAG(gettext("Импорт документов из файла"));
VVOD1.VVOD_SPISOK_add_MD(gettext("Введите имя файла с документами"));

naz:;

clear();

helstr(LINES-1,0,
"F1",gettext("помощь"),
"F2/+",gettext("загруз."),
"F3",gettext("просмотр"),
"F10",gettext("выход"),NULL);

if((kom=vvod1(&imafim,COLS-6,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
  return;
if(kom == ESC)
  return;

switch(kom)
 {
  case FK1:
    GDITE();
    iceb_t_pdoc("uos2_4.txt");
    clear();
    goto naz;

  case ENTER:
    if(imafim.ravno()[0] == '\0')
     {
      dirkatl(&imafim);
      goto naz;
     }
    break;

  case FK3:
   GDITE();
   if(stat(imafim.ravno(),&work) != 0)
    {
     VVOD SOOB(1);
     sprintf(strsql,"%s !",gettext("Нет такого файла"));
     SOOB.VVOD_SPISOK_add_MD(strsql);
     soobshw(&SOOB,stdscr,-1,-1,0,1);
     goto naz;
    }
    vizred(imafim.ravno());
    goto naz;

  default:
    goto naz;
 }


clear();
move(LINES-1,0);
GDITE();
time(&tmm);
bf=localtime(&tmm);

if(stat(imafim.ravno(),&work) != 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s !",gettext("Нет такого файла"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
printw("%s\n",gettext("Проверяем записи в файле"));
int koloh=impuosdokz(0,imafim.ravno());
if(koloh != 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s:%d",gettext("Количество ошибок"),koloh);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  sprintf(strsql,gettext("Импорт документов осуществляется если нет ни одной ошибки"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }
else
 {
  printw("\n\n%s\n\n",gettext("Загружаем документы из файла"));
  int koldok = impuosdokz(1,imafim.ravno());

  VVOD SOOB(1);
  sprintf(strsql,"%s",gettext("Загрузка завершена"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  sprintf(strsql,"%s:%d",gettext("Количество документов"),koldok);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }
}
/*****************************************/
/*Проверка-загрузка                      */
/*****************************************/

int	impuosdokz(int metka, //0-проверять 1-грузить
const char *imaf)
{
int		koloh=0;
FILE		*ff;
char		strok[1024];
char		strsql[512];
short		dd,md,gd;
int		tipz=0;
char		kodop[32];
char		kontr[32];
char		nomdok[32];
char		podr[20];
char		motv[20];
time_t		vrem;
char		innom[20];
double		bsnu=0.;
double		iznu=0.;
double		bsbu=0.;
double		izbu=0.;
char		shetu[32];
struct OPSHET	shetv;
char		hzatrat[32];
char		hanuh[32];
char		grupnu[32];
char		grupbu[32];
double		popkfnu=0.;
double		popkfbu=0.;
char		sost[32];
char		naim[512];
short		dv,mv,gv;
int		kol=0;
int		koldok=0;
int		i=0,razmer=0;

double dpnds=0.; /*Действующий процент НДС действующий на момент создания документа*/

if((ff = fopen(imaf,"r")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %d !",gettext("Ошибка окрытия файла"),errno);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(-1);
 }
time(&vrem);

memset(nomdok,'\0',sizeof(nomdok));
while(fgets(strok,sizeof(strok),ff) != NULL)
 {
  i=strlen(strok);
  razmer+=i;
  if(strok[i-2] == '\r') //Возврат каретки меняем на пробел
   strok[i-2]=' ';

  printw("%s",strok);
  refresh();


/**************************************/
  if(SRAV(strok,"DOC|",1) == 0)
   {
    memset(nomdok,'\0',sizeof(nomdok));
    dd=md=gd=0;
    tipz=0;
    kol=0;
    
    polen(strok,strsql,sizeof(strsql),2,'|');
    if(rsdat(&dd,&md,&gd,strsql,1) != 0)
     {
      iceb_t_soob(gettext("Не верно введена дата!"));
      koloh++;
      continue;
     }

    polen(strok,strsql,sizeof(strsql),3,'|');

    tipz=0;
    if(strsql[0] == '+')
     {
      tipz=1;
      kol=1;
     }
    if(strsql[0] == '-')
     {
      tipz=2;
      kol=-1;
     }
    if(tipz == 0)
     {
      iceb_t_soob(gettext("Не определен вид документа (приход/расход) !"));
      koloh++;
      continue;
     }
    polen(strok,kodop,sizeof(kodop),4,'|');
    if(tipz == 1)
      sprintf(strsql,"select kod from Uospri where kod='%s'",kodop);
    if(tipz == 2)
      sprintf(strsql,"select kod from Uosras where kod='%s'",kodop);

    if(readkey(strsql) != 1)
     {
      sprintf(strsql,gettext("Не найден код операции %s !"),kodop);
      iceb_t_soob(strsql);
      koloh++;
      continue;
     }

    polen(strok,kontr,sizeof(kontr),5,'|');
    sprintf(strsql,"select kodkon from Kontragent where kodkon='%s'",kontr);
    if(readkey(strsql) != 1)
     {
      sprintf(strsql,"%s %s !",gettext("Не найден код контрагента"),kontr);
      iceb_t_soob(strsql);
      koloh++;
      continue;
     }

    polen(strok,podr,sizeof(podr),7,'|');
    sprintf(strsql,"select kod from Uospod where kod=%s",podr);
    if(readkey(strsql) != 1)
     {
      sprintf(strsql,"%s %s !",gettext("Не найден код подразделения"),podr);
      iceb_t_soob(strsql);
      koloh++;
      continue;
     }

    polen(strok,motv,sizeof(motv),8,'|');
    sprintf(strsql,"select kod from Uosol where kod=%s",
    motv);
    if(readkey(strsql) != 1)
     {
      sprintf(strsql,"%s %s !",gettext("Не найден мат. ответственный"),motv);
      iceb_t_soob(strsql);
      koloh++;
      continue;
     }

    polen(strok,&dpnds,9,'|');

    //Номер документа определяем последним так как он является индикатором
    //наличия шапки документа
    polen(strok,nomdok,sizeof(nomdok),6,'|');
    if(SRAV(nomdok,"авто",0) == 0 || nomdok[0] == '\0')
      uosnd(gd,tipz,nomdok);

    sprintf(strsql,"select nomd from Uosdok where tipz=%d and \
datd >= '%04d-01-01' and datd <= '%04d-12-31' and nomd='%s'",
    tipz,gd,gd,nomdok);
    if(readkey(strsql) >= 1)
     {
      sprintf(strsql,gettext("С номером %s документ уже есть !"),nomdok);
      iceb_t_soob(strsql);
      koloh++;
      continue;
     }

    //Запись в базу
    if(metka != 0 && nomdok[0] != '\0' && koloh == 0)
     {
      sprintf(strsql,"insert into Uosdok (datd,tipz,kodop,kontr,nomd,podr,kodol,prov,ktoz,vrem,pn) \
values ('%04d-%02d-%02d',%d,'%s','%s','%s',%s,%s,%s,%d,%ld,%.10g)",
      gd,md,dd,tipz,kodop,kontr,nomdok,podr,motv,"1",iceb_t_getuid(),vrem,dpnds);

      if(sql_zap(&bd,strsql) != 0)
       {
        msql_error(&bd,gettext("Ошибка записи !"),strsql);
        koloh++;
       }
      else
        koldok++;

     }        
     

   }

/**************************************/
  if(SRAV(strok,"ZP1|",1) == 0)
   {
    polen(strok,innom,sizeof(innom),2,'|');
    sprintf(strsql,"select innom from Uosin where innom=%s",innom);
    if(readkey(strsql) >= 1)
     {
      if(tipz == 1)
       {
        VVOD SOOB(1);
        sprintf(strsql,"%s %s",innom,gettext("Такой инвентарный номер уже есть !"));
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        koloh++;
        continue;
       }
     }
    else
     if(tipz == 2)
      {
        VVOD SOOB(1);
        sprintf(strsql,"%s %s",gettext("Не найден инвентарный номер"),innom);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        koloh++;
        continue;

      }

    polen(strok,strsql,sizeof(strsql),3,'|');
    bsnu=ATOFM(strsql);

    polen(strok,strsql,sizeof(strsql),4,'|');
    iznu=ATOFM(strsql);

    polen(strok,strsql,sizeof(strsql),5,'|');
    bsbu=ATOFM(strsql);

    polen(strok,strsql,sizeof(strsql),6,'|');
    izbu=ATOFM(strsql);

    polen(strok,shetu,sizeof(shetu),7,'|');
    if(prsh1(shetu,&shetv) != 0)
     {
      koloh++;
      continue;
     }

    polen(strok,hzatrat,sizeof(hzatrat),8,'|');

    sprintf(strsql,"select kod from Uoshz where kod='%s'",hzatrat);

    if(readkey(strsql) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s %s %s",innom,gettext("Не найден шифр производственных затрат"),hzatrat);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }

    polen(strok,hanuh,sizeof(hanuh),9,'|');

    sprintf(strsql,"select kod from Uoshau where kod='%s'",hanuh);

    if(readkey(strsql) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s %s %s",innom,gettext("Не найден шифр аналитаческого учета"),hanuh);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }

    polen(strok,grupnu,sizeof(grupnu),10,'|');

    sprintf(strsql,"select kod from Uosgrup where kod='%s'",grupnu);

    if(readkey(strsql) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s %s %s",innom,gettext("Не найден код группы"),grupnu);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }

    polen(strok,strsql,sizeof(strsql),11,'|');
    popkfnu=ATOFM(strsql);
    
    polen(strok,grupbu,sizeof(grupbu),12,'|');

    sprintf(strsql,"select kod from Uosgrup1 where kod='%s'",grupbu);

    if(readkey(strsql) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s %s %s",innom,gettext("Не найден код группы"),grupbu);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }

    polen(strok,strsql,sizeof(strsql),13,'|');
    popkfbu=ATOFM(strsql);

    polen(strok,sost,sizeof(sost),14,'|');

    polen(strok,naim,sizeof(naim),15,'|');
    sqlfiltr(naim,sizeof(naim));
    
    polen(strok,strsql,sizeof(strsql),16,'|');
    rsdat(&dv,&mv,&gv,strsql,1);

    //Запись в базу
    if(metka != 0 && nomdok[0] != '\0' && innom[0] != '\0' && koloh == 0)
     {
      if(tipz == 1)
       {
        sprintf(strsql,"insert into Uosin \
values (%s,%s,'%s','%s','%s','%s','%s','%04d-%d-%d',%d,%ld)",
        innom,"0",naim,"","","","",gv,mv,dv,iceb_t_getuid(),vrem);
        if(sql_zapis(strsql,1,0) != 0)
          continue;
       }      

      sprintf(strsql,"insert into Uosdok1 \
values ('%04d-%02d-%02d',%d,%s,%s,'%s',%s,%s,%d,%.2f,%.2f,%.2f,'%s',%d,%ld,\
%.2f,%.2f,%.2f,'%s')",
      gd,md,dd,tipz,"0",innom,nomdok,podr,motv,kol,bsnu,iznu,1.,kodop,iceb_t_getuid(),vrem,\
      bsbu,izbu,0.,"");
      
      
      if(sql_zapis(strsql,1,0) != 0)
       continue;

      if(tipz == 1)
       { 
        sprintf(strsql,"insert into Uosinp \
values (%s,%d,%d,'%s','%s','%s','%s',%.2f,%s,'%s',%d,%ld,'%s',%.2f)",
        innom,md,gd,shetu,hzatrat,hanuh,grupnu,popkfnu,sost,"",iceb_t_getuid(),vrem,\
        grupbu,popkfbu);

      
        sql_zapis(strsql,1,0);
       }
     }
   }

 }
fclose(ff);

if(metka == 0)
  return(koloh);
if(metka == 1)
  return(koldok);
return(0);
}



