/*$Id: impzarnu.c,v 5.27 2011-01-13 13:43:22 sasa1 Exp $*/
/*10.03.2009	02.07.2002	Белых А.И.	impzarnu.c
Импорт начислений/удержаний в базу данных "Расчета зарплаты".
*/
#include        <errno.h>
#include        <math.h>
#include        <time.h>
#include        <sys/types.h>
#include        <sys/stat.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char     *organ;

void	impzarnu(short prn,short knah,
short mz,short gz)
{
struct stat work;
char		strsql[512];
SQL_str		row,row1;
SQLCURSOR curr;
static class iceb_tu_str imafim("");
static char imafprom[40];
int		kom=0;
int		razmer=0;
FILE		*ff,*ffprom;
char		strok[1024];
char		bros[512];
time_t 		tmm;
struct tm	*bf;
int		i;
long		tabnom=0; //Табельный номер
char		naim[512];
struct ZARP     zp;
short           prov;   //0-не выполнены 1-выполнены
short		dzz=1,mzz=mz,gzz=gz;
short		metkadat=0;

memset(&zp,'\0',sizeof(zp));

VVOD VVOD1(2);

clear();

if(prn == 1)
 {
  sprintf(strok,"%s %s. %s:%d.%d%s",
  gettext("Импорт"),gettext("начислений"),
  gettext("Дата"),
  mz,gz,gettext("г."));  

  sprintf(strsql,"select naik from Nash where kod=%d",knah);
  
 }
if(prn == 2)
 {
  sprintf(strok,"%s %s. %s:%d.%d%s",
  gettext("Импорт"),gettext("удержаний"),
  gettext("Дата"),
  mz,gz,gettext("г."));   
  sprintf(strsql,"select naik from Uder where kod=%d",knah);
 }

VVOD1.VVOD_SPISOK_add_ZAG(strok);

memset(naim,'\0',sizeof(naim));

if(sql_readkey(&bd,strsql,&row,&curr) == 1)
  strncpy(naim,row[0],sizeof(naim)-1);  

sprintf(strok,"%d %s",knah,naim);
VVOD1.VVOD_SPISOK_add_ZAG(strok);

VVOD1.VVOD_SPISOK_add_MD(gettext("Введите имя файла"));

naz:;

clear();

helstr(LINES-1,0,
"F1",gettext("помощь"),
"F2/+",gettext("загруз."),
"F3",gettext("просмотр"),
"F10",gettext("выход"),NULL);

if((kom=vvod1(&imafim,112,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
  return;
if(kom == ESC)
  return;

switch(kom)
 {
  case FK1:
    GDITE();
    iceb_t_pdoc("zarp2_8_1_2.txt");
    clear();
    goto naz;

  case ENTER:
  case FK2:
  case PLU:
    if(imafim.ravno()[0] == '\0')
     { 
      dirkatl(&imafim);
      goto naz;
     }
    break;

  case FK3:
   GDITE();
   if(stat(imafim.ravno(),&work) != 0)
    {
     VVOD SOOB(1);
     sprintf(strsql,"%s !",gettext("Нет такого файла"));
     SOOB.VVOD_SPISOK_add_MD(strsql);
     soobshw(&SOOB,stdscr,-1,-1,0,1);
     goto naz;
    }
    vizred(imafim.ravno());
    goto naz;

  default:
    goto naz;
 }


clear();
move(LINES-1,0);
GDITE();
time(&tmm);
bf=localtime(&tmm);

if(stat(imafim.ravno(),&work) != 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s !",gettext("Нет такого файла"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }


if((ff = fopen(imafim.ravno(),"r")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s:%d !",
  gettext("Ошибка окрытия файла"),imafim.ravno(),errno);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
sprintf(imafprom,"prom%d.tmp",getpid());
if((ffprom = fopen(imafprom,"w")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s:%d !",
  gettext("Ошибка окрытия файла"),imafprom,errno);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

short den=0;
char  shet[40];
short mvr,gvr;
int   podr=0;
short nomzap;
double suma=0.;
char koment[512];
short denp=0;
struct OPSHET	shetv;
dpm(&denp,&mz,&gz,5);
razmer=0;
short dn,mn,gn;
short du,mu,gu;
char	shetkar[20];
int podrkar=0;
int kateg;
int sovm;
int zvan;
char lgot[40];
char dolg[60];

while(fgets(strok,sizeof(strok),ff) != NULL)
 {
  i=strlen(strok);
  razmer+=i;
  if(strok[i-2] == '\r') //Возврат каретки меняем на пробел
   strok[i-2]=' ';

  printw("%s",strok);

  strzag(LINES-1,0,work.st_size,razmer);
   
  if(polen(strok,bros,sizeof(bros),1,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }

 
  if(SRAV(bros,"Дата",0) == 0)
   {
    fprintf(ffprom,"%s",strok); //Всегда записываем
    metkadat=0;
    polen(strok,bros,sizeof(bros),2,'|');    
    dzz=1;
    if(rsdat1(&mzz,&gzz,bros) != 0)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не верно введена дата !"));
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      metkadat=1;      
      continue;
     }
    denp=1;
    dpm(&denp,&mzz,&gzz,5);
    continue;
   }

  if(metkadat == 1)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }
  
  if((tabnom=atol(bros)) == 0)
   {
    fprintf(ffprom,"%s%s\n",strok,"Табельный номер равен нолю");
    continue;
   }

  //Проверяем есть ли такой табельный номер  
  sprintf(strsql,"select datn,datk,shet,podr,kodg,kateg,\
sovm,zvan,lgoti,dolg from Kartb where tabn=%ld",tabnom);
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    printw("%s %ld !\n",gettext("Не найден табельный номер"),tabnom);
    OSTANOV();    
    fprintf(ffprom,"%s",strok);
    continue;
   }

  rsdat(&dn,&mn,&gn,row1[0],2);
  rsdat(&du,&mu,&gu,row1[1],2);
  strncpy(shetkar,row1[2],sizeof(shetkar)-1);
  podrkar=atoi(row1[3]);
  kateg=atoi(row1[5]);
  sovm=atoi(row1[6]);
  zvan=atoi(row1[7]);
  memset(lgot,'\0',sizeof(lgot));
  strncpy(lgot,row1[8],sizeof(lgot)-1);
  memset(dolg,'\0',sizeof(dolg));
  strncpy(dolg,row1[9],sizeof(dolg)-1);

  if(polen(strok,bros,sizeof(bros),3,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }

  den=atoi(bros);

  if(den < 1 && den > denp)
   {
    printw("%s\n",gettext("Не верно введен день начисления/удержания !"));
    OSTANOV();
    fprintf(ffprom,"%s",strok);
    continue;
   }
  if(polen(strok,shet,sizeof(shet),4,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }

   
  //Проверить есть ли счет в плане счетов
  if(prsh1(shet,&shetv) != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }

  //Дата в счет какого месяца
  if(polen(strok,bros,sizeof(bros),5,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }

  if(rsdat1(&mvr,&gvr,bros) != 0)
   {
    printw("%s\n",gettext("Не верно введена дата !"));
    OSTANOV();
    fprintf(ffprom,"%s",strok);
    continue;
   }
  
  //Подразделение     
  if(polen(strok,bros,sizeof(bros),6,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }
  podr=atoi(bros);
  //Проверяем код подразделения
  sprintf(strsql,"select naik from Podr where kod=%d",podr);

  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)  
   {
    printw("%s %d !\n",
    gettext("Не найден код подразделения"),podr);
    OSTANOV();
    fprintf(ffprom,"%s",strok);
    continue;
   }

  //Номер записи
  if(polen(strok,bros,sizeof(bros),7,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }
  nomzap=atoi(bros);

  //Сумма
  if(polen(strok,bros,sizeof(bros),8,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }
  suma=ATOFM(bros);
  if(suma == 0.)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }
   
  if(prn == 2)
   suma*=-1;
   
  //Коментарий
  if(polen(strok,koment,sizeof(koment),9,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }
      
  if(zapzarpv(den,mzz,gzz,tabnom,prn,knah,suma,shet,mvr,gvr,0,nomzap,koment,podr,0,0,0,"",zp) != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }   

  if(prn == 1)
   zarsoc(mzz,gzz,tabnom,NULL);
  zaravpr(tabnom,mzz,gzz,NULL);
  prov=0;
  
  //Проверяем есть ли запись карточки по этой дате и если нет делаем запись
  sprintf(strsql,"select god from Zarn where tabn=%ld and god=%d and mes=%d",tabnom,gzz,mzz);
  if(readkey(strsql) == 0)  
    zapzarn(mzz,gzz,podrkar,tabnom,kateg,sovm,zvan,shetkar,lgot,dn,mn,gn,du,mu,gu,prov,dolg);

 }

fclose(ff);
fclose(ffprom);
unlink(imafim.ravno());

rename(imafprom,imafim.ravno());
}
