/*$Id: kasothcn.c,v 5.16 2011-01-13 13:43:22 sasa1 Exp $*/
/*31.10.2009	25.09.2006	Белых А.И.	kasothcn.c
Расчёт журналов по кодам целевого назначения
*/
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void kasothcn_sap(class masiv_din_int *mkcn,FILE *ff);
void kasothcn_rm(int kolih,double *prihod,double *rashod,FILE *ff);

extern char *organ;

int kasothcn(class spis_oth *oth)
{

static char	dat1[11];
static char	dat2[11];
static char	shet[112];
static char	kassa[112];
static char	kodop[112];
static char	vpr[4];
static char     kod_cn[112];
int		kom,kom1;
char		naimp[512];
short		dn,mn,gn,dk,mk,gk;
class iceb_tu_str kodcn;
class iceb_tu_str naim_kcn;

VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка целевой кассовой книги"));

VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(dat2,11);
VV.VVOD_SPISOK_add_data(kassa,sizeof(kassa));
VV.VVOD_SPISOK_add_data(kodop,sizeof(kodop));
VV.VVOD_SPISOK_add_data(shet,sizeof(shet));
VV.VVOD_SPISOK_add_data(vpr,2);
VV.VVOD_SPISOK_add_data(kod_cn,sizeof(kod_cn));


VV.VVOD_SPISOK_add_MD(gettext("Дата начала..(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца...(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Код кассы....(,,)....."));
VV.VVOD_SPISOK_add_MD(gettext("Код операции.(,,)....."));
VV.VVOD_SPISOK_add_MD(gettext("Счет.........(,,)....."));
VV.VVOD_SPISOK_add_MD(gettext("Приход/расход.(+/-)..."));
VV.VVOD_SPISOK_add_MD(gettext("Код цел.назначения..."));

naz:;
clear(); 

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(kassa,VV.VVOD_SPISOK_return_data(2),sizeof(kassa)-1);
strncpy(kodop,VV.VVOD_SPISOK_return_data(3),sizeof(kodop)-1);
strncpy(shet,VV.VVOD_SPISOK_return_data(4),sizeof(shet)-1);
strncpy(vpr,VV.VVOD_SPISOK_return_data(5),sizeof(vpr)-1);
strncpy(kod_cn,VV.VVOD_SPISOK_return_data(6),sizeof(kod_cn)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("kas4_2.txt");
   goto naz;

  case FK10:
  case ESC:
   return(1);

  case FK5:
  case FK2:
  case PLU:
   break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка касс"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций приходов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций расходов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка кодов целевого назначения"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;   
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 5 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Kas",kassa,sizeof(kassa),naimp);      
        VV.VVOD_SPISOK_zapis_data(2,kassa);
        goto naz;

      case 1 :
        vibrek("Kasop1",kodop,sizeof(kodop),naimp);      
        VV.VVOD_SPISOK_zapis_data(3,kodop);
        goto naz;

      case 2 :
        vibrek("Kasop2",kodop,sizeof(kodop),naimp);      
        VV.VVOD_SPISOK_zapis_data(3,kodop);
        goto naz;
      
      case 3 :
        vibrek("Plansh",shet,sizeof(shet),naimp);      
        VV.VVOD_SPISOK_zapis_data(4,shet);
        goto naz;

      case 4 :
        kodcn.new_plus("");
        naim_kcn.new_plus("");
        if(dirkcn(1,&kodcn,&naim_kcn) == 0)
          VV.data_z_plus(6,kodcn.ravno());
        goto naz;
               
     }
    goto naz;

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
    goto naz;
 }
GDITE();
if(rsdatp(&dn,&mn,&gn,VV.VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
 goto naz;







char strsql[512];
int kolstr=0;
SQL_str row,row1;
class SQLCURSOR cur,cur1;

class masiv_din_int mkcn; //массив кодов целевого назначения
class masiv_din_double mscn; //массив сумм сальдо целевого назначения

//читаем список кодов целевого назначения
sprintf(strsql,"select kod from Kascn");
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

while(cur.read_cursor(&row) != 0)
 {
  if(proverka(kod_cn,row[0],0,0) != 0)
   continue;
  mkcn.plus(atoi(row[0]));
 }

//Читаем сальдо по кодам целевого назначения
sprintf(strsql,"select kod,ks,saldo from Kascnsl where god=%d",gn);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

int kolih_kcn=mkcn.kolih();

mscn.make_class(kolih_kcn);

int nomer=0;
while(cur.read_cursor(&row) != 0)
 {
  if(proverka(kassa,row[0],0,0) != 0)
   continue;
  if(proverka(kod_cn,row[1],0,0) != 0)
   continue;

  nomer=mkcn.find(atoi(row[0]));
  mscn.plus(atof(row[2]),nomer);
 }


//читаем документы

sprintf(strsql,"select kassa,tp,datd,nomd,shetk,kodop from Kasord where \
datd >= '%04d-%02d-%02d' and datd <= '%04d-%02d-%02d' order by datd,tp asc",
gn,mn,dn,gk,mk,dk);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

FILE *ff;
char imaf[56];
sprintf(imaf,"kokcn%d.lst",getpid());
if((ff=fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(strsql,errno,"");
  return(1);
 }
 
zagolov(gettext("Целевая кассовая книга"),dn,mn,gn,dk,mk,gk,organ,ff);

if(shet[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Счёт"),shet);
if(kassa[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Касса"),kassa);
if(kodop[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Код операции"),kodop);
if(vpr[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Приход/расход"),vpr);
if(kod_cn[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Код целевого назначения"),kod_cn);
 

kasothcn_sap(&mkcn,ff);
int kolstr1=0;
short d,m,g;
double prihod[kolih_kcn];
double rashod[kolih_kcn];
memset(prihod,'\0',sizeof(prihod));
memset(rashod,'\0',sizeof(rashod));

double suma=0.,sumapod=0.;
double prih_itogo=0.;
double rash_itogo=0.;

int tipz=0;
short metka_saldo=0;

while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(kassa,row[0],0,0) != 0)
   continue;
  
  if(proverka(shet,row[4],0,0) != 0)
   continue;

  if(proverka(kodop,row[5],0,0) != 0)
   continue;
  
  tipz=atoi(row[1]);
  if(vpr[0] == '+' && tipz == 2)
   continue;

  if(vpr[0] == '-' && tipz == 1)
   continue;

  //читаем код целевого назначения этой операции
  if(tipz == 1)
    sprintf(strsql,"select kcn from Kasop1 where kod='%s'",row[5]);
  if(tipz == 2)
    sprintf(strsql,"select kcn from Kasop2 where kod='%s'",row[5]);
  if(readkey(strsql,&row1,&cur1) == 1)
   {
   if(atoi(row1[0]) != 0)
    {
     if(proverka(kod_cn,row1[0],0,0) != 0)
      continue;
    }
   else 
    continue;
   }
  if((nomer=mkcn.find(atoi(row1[0]))) < 0)
   {
    VVOD SOOB(1);
    sprintf(strsql,"Не найден код %d в массиве кодов целевого назначения !",atoi(row1[0]));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    continue;
   }
  rsdat(&d,&m,&g,row[2],2);
  
  sumkasor(row[0],tipz,row[3],g,&suma,&sumapod);
  
  if(sravmydat(d,m,g,dn,mn,gn) < 0) //до начала периода
   {
    if(tipz == 2)
      sumapod*=-1; 
    mscn.plus(sumapod,nomer);
   }
  else //период
   {
    if(metka_saldo == 0)
     {
      memset(prihod,'\0',sizeof(prihod));
      memset(rashod,'\0',sizeof(rashod));
      for(int ii=0; ii < kolih_kcn; ii++)
       {
        if(mscn.ravno(ii) < 0)
         rashod[ii]=mscn.ravno(ii);
        else
         prihod[ii]=mscn.ravno(ii);
       }

      fprintf(ff,"%*s ",iceb_tu_kolbait(19,gettext("Сальдо")),gettext("Сальдо"));
      
      kasothcn_rm(kolih_kcn,prihod,rashod,ff);
      if(mscn.suma() > 0)
       {
        fprintf(ff,"%8.2f\n",mscn.suma());
        prih_itogo+=mscn.suma();
       }
      else 
       {
        fprintf(ff,"%8s %8.2f\n","",mscn.suma());
        rash_itogo+=mscn.suma();
       }
      metka_saldo=1;
     }

    memset(prihod,'\0',sizeof(prihod));
    memset(rashod,'\0',sizeof(rashod));
    if(tipz == 1)
     {
      prihod[nomer]=sumapod;    
      prih_itogo+=sumapod;
     }
    if(tipz == 2)
     {
      rashod[nomer]=sumapod;    
      rash_itogo+=sumapod;
     }
    
    fprintf(ff,"%02d.%02d.%04d %-7s ",d,m,g,row[3]);

    kasothcn_rm(kolih_kcn,prihod,rashod,ff);
    if(tipz == 1)
      fprintf(ff,"%8.2f\n",sumapod);
    if(tipz == 2)
      fprintf(ff,"%8s %8.2f\n","",sumapod);
    
    if(tipz == 2)
      sumapod*=-1; 
    mscn.plus(sumapod,nomer);
   }

 }

memset(prihod,'\0',sizeof(prihod));
memset(rashod,'\0',sizeof(rashod));

for(int ii=0; ii < kolih_kcn; ii++)
 {
  if(mscn.ravno(ii) < 0)
   rashod[ii]=mscn.ravno(ii);
  else
   prihod[ii]=mscn.ravno(ii);
 }

fprintf(ff,"%*s ",iceb_tu_kolbait(19,gettext("Сальдо")),gettext("Сальдо"));

kasothcn_rm(kolih_kcn,prihod,rashod,ff);

if(prih_itogo > rash_itogo)
 fprintf(ff,"%8.2f\n",prih_itogo-rash_itogo);
else
 fprintf(ff,"%8s %8.2f\n","",prih_itogo-rash_itogo);
 

podpis(ff);
fclose(ff);

iceb_t_ustpeh(imaf,0);

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Целевая кассовая книга"));

iceb_t_ustpeh(oth->spis_imaf.ravno(0),1);
return(0);
}





/************************/
/*Распечатка шапки*/
/**********************/

void kasothcn_sap(class masiv_din_int *mkcn,FILE *ff)
{
SQL_str row;
class SQLCURSOR cur;
char strsql[512];

int kol_kcn=mkcn->kolih();

class iceb_tu_str strok_p;
strok_p.plus("--------------------");
for(int ii=0; ii <= kol_kcn; ii++)
 strok_p.plus("------------------");

fprintf(ff,"%s\n",strok_p.ravno());

fprintf(ff,"%s",gettext("  Дата    | Номер  |"));
char naim[512];
for(int ii=0; ii < kol_kcn; ii++)
 {
  memset(naim,'\0',sizeof(naim));
  sprintf(strsql,"select naik from Kascn where kod=%d",mkcn->ravno(ii));
  if(readkey(strsql,&row,&cur) == 1)
   strncpy(naim,row[0],sizeof(naim)-1);
  fprintf(ff,"%-*.*s|",iceb_tu_kolbait(17,naim),iceb_tu_kolbait(17,naim),naim);
 }
fprintf(ff,"%-*.*s|\n",iceb_tu_kolbait(17,gettext("Итого")),iceb_tu_kolbait(17,gettext("Итого")),gettext("Итого"));

fprintf(ff,"%s",gettext("          |докумен.|"));
for(int ii=0; ii <= kol_kcn; ii++) 
 {
  fprintf(ff,"%s",gettext(" Приход | Расход |"));
 }
fprintf(ff,"\n");

fprintf(ff,"%s\n",strok_p.ravno());

}
/*****************************/
/*распечатка массива*/
/***********************/

void kasothcn_rm(int kolih,double *prihod,double *rashod,FILE *ff)
{
for(int ii=0; ii < kolih; ii++)
 {
  if(prihod[ii] == 0.)
   fprintf(ff,"%8s ","");
  else
   fprintf(ff,"%8.2f ",prihod[ii]);

  if(rashod[ii] == 0.)
   fprintf(ff,"%8s ","");
  else
   fprintf(ff,"%8.2f ",rashod[ii]);
  
 }

}
