/*$Id: kprik.c,v 5.12 2011-01-13 13:43:22 sasa1 Exp $*/
/*15.12.2009	13.09.2003	Белых А.И. 	kprik.c
Распечатка командировочных приказов
*/
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char     *organ;

int kprik(class spis_oth *oth)
{
char   strsql[512];
static  char    dat1[11],dat2[11];
short		dn,mn,gn,dk,mk,gk;
int		kom=0;
SQLCURSOR curr;
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка приказов на командировки."));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала.(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца..(д.м.г).."));

VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2)); 

naz:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("ukr4_3.txt");
   goto naz;

  case ESC:
  case FK10:
   return(1);

  case FK2:
  case PLU:
     break;

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }


if(rsdatp(&dn,&mn,&gn,dat1,&dk,&mk,&gk,dat2) != 0)
 goto naz;

GDITE();

int	kolstr=0;
SQL_str row,row1;
SQLCURSOR cur;
char    imaf[30];
FILE	*ff;
char	nompr[30];
short   d,m,g;
char    fio[512];
int     kolprik=0;
short   dnp,mnp,gnp;
short   dkp,mkp,gkp;
char    kodruk[50];
short   metkaruk=0;
char	tabnom[20];
char    prist[20];
short   dlinnapr=0;
char	dolgn[40];
short   dlinnakont=0;
int     i=0,i2=0;
char    tabnomruk[60];
class iceb_t_fioruk_rk rekruk;

iceb_t_fioruk(1,&rekruk);


memset(nompr,'\0',sizeof(nompr));

sprintf(strsql,"select kont,pnaz,organ,celk,datn,datk,nompr,datp from Ukrdok \
where datp >= '%d-%d-%d' and datp <= '%d-%d-%d' order by nompr asc",
gn,mn,dn,gk,mk,dk);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

//sprintf(strsql,"%s",iceb_t_imafnsi("zarnast.alx"));
iceb_t_poldan("Табельный номер руководителя",tabnomruk,"zarnast.alx");
iceb_t_poldan("Приставка к табельному номеру",prist,"zarnast.alx");
dlinnapr=strlen(prist);
sprintf(kodruk,"%s%s",prist,tabnomruk);

sprintf(imaf,"pkr%d.tmp",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

int nomer=0;
int kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(SRAV(kodruk,row[0],0) == 0)
   {
    metkaruk++;
    continue;
   }

  if(SRAV(nompr,row[6],0) != 0 || (kolstr1 == 1 && row[6][0] == '\0'))
   {
    if(kolprik != 0)
     {
      fprintf(ff,"\n%10s %s___________________%s\n"," ",rekruk.dolg.ravno(),rekruk.fio.ravno());
      fprintf(ff,"\f");
     }

    fprintf(ff,"%s\n\n",organ);
    fprintf(ff,"%25s%s %s\n"," ",gettext("ПРИКАЗ НОМЕР"),row[6]);

    rsdat(&d,&m,&g,row[7],2);

    fprintf(ff,"%25s%s %02d.%02d.%d%s\n\n"," ",gettext("от"),d,m,g,
    gettext("г."));

    fprintf(ff,"%s\n",gettext("Про командировку"));
    fprintf(ff,"%s:\n",gettext("Откомандировать"));

    strcpy(nompr,row[6]);
    nomer=0;    
    kolprik++;    
   }  

  rsdat(&dnp,&mnp,&gnp,row[4],2);
  rsdat(&dkp,&mkp,&gkp,row[5],2);

  memset(dolgn,'\0',sizeof(dolgn));
    
  if(SRAV(prist,row[0],1) == 0)
   {
   
    memset(tabnom,'\0',sizeof(tabnom));
    dlinnakont=strlen(row[0]);
    i2=0;
    for(i=dlinnapr; i < dlinnakont; i++)
      tabnom[i2++]=row[0][i];     

    //Узнаем должность
    sprintf(strsql,"select dolg from Kartb where tabn=%s",tabnom);
//    printw("\n%s\n",strsql);
//    OSTANOV();
    if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
      strncpy(dolgn,row1[0],sizeof(dolgn)-1);

   }
  
  memset(fio,'\0',sizeof(fio));
  //Читаем наименование контрагента
  sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",row[0]);
  if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
    strncpy(fio,row1[0],sizeof(fio)-1);
    
  fprintf(ff,"\n%d. %s %s\n",++nomer,fio,dolgn);
  fprintf(ff,"%10s %s %s\n"," ",row[1],row[2]);
  fprintf(ff,"%10s %s %s %02d.%02d.%d%s %s %02d.%02d.%d%s\n",
  " ",row[3],
  gettext("с"),dnp,mnp,gnp,gettext("г."),
  gettext("по"),dkp,mkp,gkp,gettext("г."));
  fprintf(ff,"\n%10s%s________________________\n"," ",gettext("с приказом ознакомлен"));
 }

fprintf(ff,"\n%10s %s___________________%s\n"," ",rekruk.dolg.ravno(),rekruk.fio.ravno());

if(metkaruk != 0)
 {
  short kolprik1=0;
  
  sprintf(strsql,"select kont,pnaz,organ,celk,datn,datk,nompr,datp from Ukrdok \
where datp >= '%d-%d-%d' and datp <= '%d-%d-%d' and kont='%s' order by nompr asc",
  gn,mn,dn,gk,mk,dk,kodruk);

  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  
  if(kolstr > 0)
  while(cur.read_cursor(&row) != 0)
   {
    if(SRAV(nompr,row[6],0) != 0 || (kolstr1 == 1 && row[6][0] == '\0'))
     {
      if(kolprik != 0 || kolprik1 != 0)
        fprintf(ff,"\f");

      if(kolprik1 != 0)
          fprintf(ff,"\n%10s %s___________________%s\n"," ",rekruk.dolg.ravno(),rekruk.fio.ravno());

      fprintf(ff,"%s\n\n",organ);
      fprintf(ff,"%25s%s %s\n"," ",gettext("ПРИКАЗ НОМЕР"),row[6]);

      rsdat(&d,&m,&g,row[7],2);

      fprintf(ff,"%25s%s %02d.%02d.%d%s\n\n"," ",gettext("от"),d,m,g,
      gettext("г."));

      fprintf(ff,"%s\n",gettext("Про командировку"));
      fprintf(ff,"%s:\n",gettext("Отбываю в командировку"));

      strcpy(nompr,row[6]);
      nomer=0;    
      kolprik1++;    
     }  
    rsdat(&dnp,&mnp,&gnp,row[4],2);
    rsdat(&dkp,&mkp,&gkp,row[5],2);
    
    memset(fio,'\0',sizeof(fio));
    //Читаем наименование контрагента
    sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",row[0]);
    if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
      strncpy(fio,row1[0],sizeof(fio)-1);
      
    fprintf(ff,"\n%s %s\n",rekruk.fio.ravno(),rekruk.dolg.ravno());
    fprintf(ff,"%10s %s %s\n"," ",row[1],row[2]);
    fprintf(ff,"%10s %s %s %02d.%02d.%d%s %s %02d.%02d.%d%s\n",
    " ",row[3],
    gettext("с"),dnp,mnp,gnp,gettext("г."),
    gettext("по"),dkp,mkp,gkp,gettext("г."));
   }
  fprintf(ff,"\n%10s %s___________________%s\n"," ",rekruk.dolg.ravno(),rekruk.fio.ravno());
   
 }



fclose(ff);

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Распечатка приказов на командировки."));
iceb_t_ustpeh(oth->spis_imaf.ravno(0),1);
return(0);
}
