/*$Id: matnastp.c,v 5.7 2010-06-28 05:29:33 sasa1 Exp $*/
/*31.08.2005	20.01.2000	Белых А.И.	matnastp.c
Просмотр настроек для материального учета
*/
#include        "buhg.h"


void		matnastp()
{
extern char            *mtsh;  /*Перечень материальных счетов*/
extern double		okrcn;  /*Округление цены*/
extern double		okrg1;  /*Округление 1*/
extern short           mfnn; /*Метка формирования номера накладной
                      -1 - Автоматическая нумерация выключена
                       0 - Приходы и расходы - нумерация общая
                       1 - Приходы отдельно расходы отдельно
                       */
extern short		srtnk; /*0-не включена 1-включена сортировка записей в накладной*/
extern short		vtara; /*Код группы возвратная тара*/
extern char		*bnds1; /*0% НДС реализация на територии Украины.*/
extern char            *bnds2; /*0% НДС экспорт.*/
extern char            *bnds3; /*0% Освобождение от НДС статья 5.*/
extern short           obzap; /*0-не объединять записи 1-обединять*/
extern double		kursue;/*Курс условной единицы*/
extern char		*shrt;    /*Счета розничной торговли*/
extern short		konost;   /*Контроль остатка 0-включен 1-выключен*/
extern short		startgod; /*Стартовый год просмотров*/
extern short		mborvd;    /*0-многопользовательская работа в документе разрешена 1- запрещена*/
extern char		*kodopsrvc; //Код операции расчета средневзвешенной цены
extern char		*kodopsp; //Коды операций сторнирования для приходов
extern char		*kodopsr; //Коды операций сторнирования для расходов
char		bros[512];

clear();

printw("Округление цены:%f Округление 1:%f\n",
okrcn,okrg1);
printw("Перечень мат-ых счетов:%s\n",mtsh);

memset(bros,'\0',sizeof(bros));

if(mfnn == -1)
 strcpy(bros,"Выключена ав. нум.");
if(mfnn == 0)
 strcpy(bros,"Включена общая нумерация.");
if(mfnn == 1)
 strcpy(bros,"Включена раздельная нумерация.");
printw("Раздельная нумерация накладных:%d %s\n",mfnn,bros);
/***************
memset(bros,'\0',sizeof(bros));
if(cnsnds == 0)
 strcpy(bros,"Выключена");
if(cnsnds == 1)
 strcpy(bros,"Включена");
printw("Цена материалла с НДС: %d %s\n",cnsnds,bros);
**************/
memset(bros,'\0',sizeof(bros));
if(srtnk == 0)
 strcpy(bros,"Выключена");
if(srtnk == 1)
 strcpy(bros,"Включена");

printw("Сортировка записей в накладной: %d %s\n",srtnk,bros);
printw("Код группы возвратной тары: %d\n",vtara);
printw("0% НДС реализация на територии Украины: %s\n",bnds1);
printw("0% НДС экспорт: %s\n",bnds2);
printw("0% Освобождение от НДС статья 5: %s\n",bnds3);

memset(bros,'\0',sizeof(bros));
if(obzap == 0)
 strcpy(bros,"Выключено");
if(obzap == 1)
 strcpy(bros,"Включено");

printw("Объединение одинаковых материалов в накладной: %d %s\n",
obzap,bros);

printw("Курс УЕ: %f\n",kursue);
printw("Счета розничной торговли: %s\n",shrt);

memset(bros,'\0',sizeof(bros));
if(konost == 0)
 strcpy(bros,"Включен");
if(konost == 1)
 strcpy(bros,"Выключен");

printw("Контроль остатка на выписке: %d %s\n",konost,bros);

memset(bros,'\0',sizeof(bros));
if(mborvd == 1)
 strcpy(bros,"Включена");
if(mborvd == 0)
 strcpy(bros,"Выключена");

printw("Блокировка многопользовательской работы в документе: %d %s\n",mborvd,bros);

printw("Стартовый год: %d\n",startgod);
printw("Код операции расчета средневзвешенной цены: %s\n",kodopsrvc);
printw("Коды операций сторнирования для приходов: %s\n",kodopsp);
printw("Коды операций сторнирования для расходов: %s\n",kodopsr);

OSTANOV();

}
