/*$Id: matulk.c,v 1.22 2011-01-13 13:43:22 sasa1 Exp $*/
/*21.09.2007	08.09.2001	Белых А.И.	matulk.c
Контроль логической корректности базы данных
*/
#include        <time.h>
#include        <math.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char *imabaz;
extern char	*organ;

void	matulk()
{
char		strsql[512];
SQLCURSOR	cur;
SQLCURSOR	cur1;
SQL_str		row,row1;
int		kolstr,kolstr1;
WINDOW		*win1;
WINDOW		*win2;
int		Y,X;
int		kolerror=0;
time_t		tmm,tmmk;
struct  tm      *bf;
FILE		*ff;
char		imaf[40];

VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите режим"));

MENU.VVOD_SPISOK_add_MD(gettext("Проверка логической целосности базы данных"));
MENU.VVOD_SPISOK_add_MD(gettext("Проверка логической целосности базы данных с удалением нелогичных записей"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

int metka=0; //без удаления записей
while(menu3w(stdscr,&MENU,&metka,-1,-1,0) != 0);
 
if(metka == -1 || metka == 2)
 return;




time(&tmm);
bf=localtime(&tmm);

clear();
sprintf(imaf,"matulk%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

zagolov(gettext("Проверка логической целосности базы данных"),bf,0,0,0,0,0,0,organ,ff);

printw("%s\n",gettext("Проверка логической целосности базы данных"));
printw("%s:%s %s\n",gettext("База данных"),imabaz,organ);
fprintf(ff,"%s:%s %s\n",gettext("База данных"),imabaz,organ);

fprintf(ff,"\
--------------------------------------\n");
fprintf(ff,"%s\n",
gettext("  Дата    |Склад|+/-|Номер документа"));
fprintf(ff,"\
--------------------------------------\n");

printw("\
------------------------------------------------------------------------\n");
printw("%s\n",
gettext("  Дата    |Склад|+/-|Номер док.        |  Дата    |Склад|+/-|Номер док."));

printw("\
------------------------------------------------------------------------");
GDITE();

Y=5;X=0;

//if((win1=newwin(LINES-Y-1,COLS/2,Y,X)) == (WINDOW*)ERR)
if((win1=subwin(stdscr,LINES-Y-1,COLS/2,Y,X)) == (WINDOW*)ERR)
 {
  printw("Ошибка создания окна win1!\n");
//  perror("*******");
  OSTANOV();
  return;
 }
scrollok(win1,TRUE); /*Разрешение ролинга на экране*/

//if((win2=newwin(LINES-Y-1,COLS/2,Y,COLS-COLS/2)) == (WINDOW*)ERR)
if((win2=subwin(stdscr,LINES-Y-1,COLS/2,Y,COLS-COLS/2)) == (WINDOW*)ERR)
 {
  printw("Ошибка создания окна win2!\n");
//  perror("*******");
  OSTANOV();
  return;
 }
scrollok(win2,TRUE); /*Разрешение ролинга на экране*/

wclear(win1);
wclear(win2);

wprintw(win2,"%s Dokummat1.\n",gettext("Проверка таблицы"));
wrefresh(win2);
fprintf(ff,"%s\n",
gettext("Проверка записей в документах не имеющих шапки документа"));

sprintf(strsql,"select distinct datd,sklad,nomd,tipz,nomkar from Dokummat1 \
order by datd asc");

GDITE();
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }  

kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  wprintw(win1,"%s %-5s %-3s %s\n",row[0],row[1],row[3],row[2]);
  wrefresh(win1);
  strzag(LINES-1,0,kolstr,++kolstr1);

  sprintf(strsql,"select tip from Dokummat where tip=%s and \
datd='%s' and sklad=%s and nomd='%s'",row[3],row[0],row[1],row[2]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) <= 0)
   {
    beep();
    wprintw(win2,"%s %-5s %-3s %s\n",row[0],row[1],row[3],row[2]);
    wrefresh(win2);
    fprintf(ff,"%s %-5s %-3s %s\n",row[0],row[1],row[3],row[2]);
    kolerror++;

    if(metka == 1) 
     {
      sprintf(strsql,"delete from Dokummat1 where datd='%s' and sklad=%s and nomd='%s' and \
tipz=%s and nomkar=%s",row[0],row[1],row[2],row[3],row[4]);
      if(sql_zap(&bd,strsql) != 0)      
        msql_error(&bd,gettext("Ошибка удаления записи !"),strsql);
     }
   }
  if(row[4][0] == '0')
   continue;
  sprintf(strsql,"select nomk from Kart where sklad=%s and \
nomk=%s",row[1],row[4]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) <= 0)
   {
    beep();
    wprintw(win2,"%s %-5s %-3s %s\n",row[0],row[1],row[3],row[2]);
    wprintw(win2,"%s %s %s %s !\n",
    gettext("Не найдена карточка"),row[4],
    gettext("на складе"),row[3]);
    wrefresh(win2);
    fprintf(ff,"%s %-5s %-3s %s\n",row[0],row[1],row[3],row[2]);
    fprintf(ff,"%s %s %s %s !",
    gettext("Не найдена карточка"),row[4],
    gettext("на складе"),row[3]);
    kolerror++;
   }
 }

wclear(win1);

wprintw(win2,"%s Dokummat2.\n",gettext("Проверка таблицы"));
wrefresh(win2);

fprintf(ff,"%s\n","Проверка дополнительных записей к шапке документа не имеющих шапки документа");

sprintf(strsql,"select distinct god,sklad,nomd from Dokummat2 order by god asc");

GDITE();
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }  

kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  wprintw(win1,"%-10s %-5s %-3s %s\n",row[0],row[1],"",row[2]);
  wrefresh(win1);
  strzag(LINES-1,0,kolstr,++kolstr1);

  sprintf(strsql,"select tip from Dokummat where \
datd >='%s-01-01' and datd <= '%s-12-31' and sklad=%s and nomd='%s'",row[0],row[0],row[1],row[2]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) <= 0)
   {
    beep();
    wprintw(win2,"%10s %-5s %-3s %s\n",row[0],row[1],"",row[2]);
    wrefresh(win2);
    fprintf(ff,"%s %-5s %-3s %s\n",row[0],row[1],"",row[2]);
    kolerror++;

    if(metka == 1) 
     {
      sprintf(strsql,"delete from Dokummat2 where god='%s' and sklad=%s and nomd='%s'",
      row[0],row[1],row[2]);
      if(sql_zap(&bd,strsql) != 0)      
        msql_error(&bd,gettext("Ошибка удаления записи !"),strsql);
     }
   }
 }

wclear(win1);

wprintw(win2,"%s Dokummat3.\n",gettext("Проверка таблицы"));
wrefresh(win2);

fprintf(ff,"%s\n","Проверка записей услуг в документах не имеющих шапки документа");

sprintf(strsql,"select distinct datd,sklad,nomd from Dokummat3 \
order by datd asc");

GDITE();
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }  

kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  wprintw(win1,"%s %-5s %-3s %s\n",row[0],row[1],"",row[2]);
  wrefresh(win1);
  strzag(LINES-1,0,kolstr,++kolstr1);

  sprintf(strsql,"select tip from Dokummat where \
datd='%s' and sklad=%s and nomd='%s'",row[0],row[1],row[2]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) <= 0)
   {
    beep();
    wprintw(win2,"%s %-5s %-3s %s\n",row[0],row[1],"",row[2]);
    wrefresh(win2);
    fprintf(ff,"%s %-5s %-3s %s\n",row[0],row[1],"",row[2]);
    kolerror++;

    if(metka == 1) 
     {
      sprintf(strsql,"delete from Dokummat3 where datd='%s' and sklad=%s and nomd='%s'",
      row[0],row[1],row[2]);
      if(sql_zap(&bd,strsql) != 0)      
        msql_error(&bd,gettext("Ошибка удаления записи !"),strsql);
     }
   }
 }

wclear(win1);

wprintw(win2,"\n%s Zkart.\n",gettext("Проверка таблицы"));
wrefresh(win2);
fprintf(ff,"\n%s.\n",gettext("Проверка записей в карточках"));

sprintf(strsql,"select distinct sklad,nomk,nomd,datd,tipz from Zkart \
order by datd asc");

GDITE();
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }  

kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  wprintw(win1,"%s %-5s %-3s %s\n",row[3],row[0],row[4],row[2]);
  wrefresh(win1);
  strzag(LINES-1,0,kolstr,++kolstr1);
  sprintf(strsql,"select tip from Dokummat where tip=%s and \
datd='%s' and sklad=%s and nomd='%s'",row[4],row[3],row[0],row[2]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) <= 0)
   {
    beep();
    wprintw(win2,"%s %-5s %-3s %s\n",row[3],row[0],row[4],row[2]);
    wprintw(win2,"%s !\n",gettext("Не найдена шапка документа"));
    wrefresh(win2);
    fprintf(ff,"%s %-5s %-3s %s\n",row[3],row[0],row[4],row[2]);
    fprintf(ff,"%s !\n",gettext("Не найдена шапка документа"));
    kolerror++;

    if(metka == 1) 
     {
      sprintf(strsql,"delete from Zkart where datd='%s' and sklad=%s and nomd='%s' and \
tipz=%s and nomk=%s",row[3],row[0],row[2],row[4],row[1]);
      if(sql_zap(&bd,strsql) != 0)      
        msql_error(&bd,gettext("Ошибка удаления записи !"),strsql);
     }
   }

  sprintf(strsql,"select tipz from Dokummat1 where tipz=%s and \
datd='%s' and sklad=%s and nomd='%s'",row[4],row[3],row[0],row[2]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) <= 0)
   {
    beep();
    wprintw(win2,"%s %-5s %-3s %s\n",row[3],row[0],row[4],row[2]);
    wprintw(win2,"%s !\n",gettext("Не найдена запись в документе"));
    wrefresh(win2);
    fprintf(ff,"%s %-5s %-3s %s\n",row[3],row[0],row[4],row[2]);
    fprintf(ff,"%s !\n",gettext("Не найдена запись в документе"));
    kolerror++;

    if(metka == 1) 
     {
      sprintf(strsql,"delete from Zkart where datd='%s' and sklad=%s and nomd='%s' and \
tipz=%s and nomk=%s",row[3],row[0],row[2],row[4],row[1]);
      if(sql_zap(&bd,strsql) != 0)      
        msql_error(&bd,gettext("Ошибка удаления записи !"),strsql);
     }
   }
  sprintf(strsql,"select sklad from Kart where sklad=%s and nomk=%s",
  row[0],row[1]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) <= 0)
   {
    beep();
    wprintw(win2,"%s %-5s %-3s %s\n",row[3],row[0],row[4],row[2]);
    wprintw(win2,"%s !\n",gettext("Не найдена карточка"));
    wrefresh(win2);
    fprintf(ff,"%s %-5s %-3s %s\n",row[3],row[0],row[4],row[2]);
    fprintf(ff,"%s !\n",gettext("Не найдена карточка"));
    kolerror++;

    if(metka == 1) 
     {
      sprintf(strsql,"delete from Zkart where datd='%s' and sklad=%s and nomd='%s' and \
tipz=%s and nomk=%s",row[3],row[0],row[2],row[4],row[1]);
      if(sql_zap(&bd,strsql) != 0)      
        msql_error(&bd,gettext("Ошибка удаления записи !"),strsql);
     }
   }
 }

move(0,0);
printw("%s\n",gettext("Проверка логической целосности базы данных"));
printw("%s:%s %s\n",gettext("База данных"),imabaz,organ);
wclear(win1);
//wclear(win2);
printw("\
------------------------------------------------------------------\n");
printw("%s\n",
gettext("Склад|Номер карточки                   |Склад|Номер карточки"));

printw("\
------------------------------------------------------------------");

fprintf(ff,"\n%s.\n",gettext("Проверка карточек без ссылок"));
fprintf(ff,"\
--------------------\n");
fprintf(ff,"%s\n",
gettext("Склад|Номер карточки"));

fprintf(ff,"\
--------------------\n");


sprintf(strsql,"select sklad,nomk from Kart \
order by sklad asc");

GDITE();
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }  
wprintw(win2,"\nПроверка таблицы Kart.\n");
wrefresh(win2);

kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  wprintw(win1,"%-5s %s\n",row[0],row[1]);
  wrefresh(win1);
  strzag(LINES-1,0,kolstr,++kolstr1);

  sprintf(strsql,"select tipz from Dokummat1 where \
sklad=%s and nomkar=%s limit 1",row[0],row[1]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) <= 0)
   {
    beep();
    wprintw(win2,"%-5s %s\n",row[0],row[1]);
    wrefresh(win2);
    fprintf(ff,"%-5s %s\n",row[0],row[1]);
    kolerror++;

    if(metka == 1) 
     {
      sprintf(strsql,"delete from Kart where sklad=%s and nomk=%s",row[0],row[1]); 
      if(sql_zap(&bd,strsql) != 0)      
        msql_error(&bd,gettext("Ошибка удаления записи !"),strsql);
     }
   }
 }

fclose(ff);
delwin(win2);

time(&tmmk);

double s1=0.;
double k1=(tmmk-tmm)/60.;
k1=modf(k1,&s1);

mvprintw(LINES-2,0,"%s %.f%s %.f%s\n",
gettext("Время расчета"),
s1,
gettext("мин."),
k1*60.,
gettext("сек."));

if(kolerror == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Порядок, ошибок не обнаружено !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  unlink(imaf);
 }
else
 {
  VVOD SOOB(1);
  if(metka == 0)
    sprintf(strsql,"%s: %d",gettext("База не корректна ! Количество ошибок"),
    kolerror);
  if(metka == 1)
    sprintf(strsql,"%s: %d",gettext("Количество исправленых ошибок"),
    kolerror);

  SOOB.VVOD_SPISOK_add_MD(strsql);
  sprintf(strsql,"%s %s",gettext("Распечатку выгружено в файл"),imaf);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);

  class spis_oth oth;
  oth.spis_imaf.plus(imaf);
  oth.spis_naim.plus(gettext("Протокол найденных ошибок"));
  iceb_t_ustpeh(imaf,0);
  iceb_t_rabfil(&oth,"");
    
 }


}
