/* $Id: motpk.c,v 5.37 2011-01-13 13:43:22 sasa1 Exp $ */
/*14.01.2010    17.04.1997      Белых А.И.      motpk.c
Материальный отчет по карточкам материалов
*/
#include        <math.h>
#include        <time.h>
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif
#define         PL      50  /*Количество строк на первом листе*/
#define         VL      55  /*Количество строк на втором листе*/

int		matstat(short,short,short,short,short,short);
void            rasmoth(VVOD*,short tr,char skll[],char kodml[],char kodol[],
short dn,short mn,short gn,short dk,short mk,short gk,short tipzl,
double cenal,char kopl[],short kk1,short kk2,short kk3,short kk4,
short mo,FILE *ff,FILE *ff2);
void            matspor(int kolopp,int kolopr,int kolmat,int kolgru,
FILE *kaw,FILE *ff1,short mo);
short		matstatr(VVOD*,short dn,short mn,short gn,short dk,short mk,
short gk,char imaf[]);

struct  tm      *bf;
extern char     *organ;

int motpk(class spis_oth *oth)
{
extern double	okrcn;
char            bros[512];
extern char	*maskmat; /*Массив кодов отмеченных материалов*/
FILE            *ff,*ff1,*ff2;
time_t		tmm=0;
char		imaf[24],imaf1[24],imaf2[24],imaf3[24];
static  char    dat1[11],dat2[11];
short           dn,mn,gn,dk,mk,gk;
short		d,m,g;
int           kom,kom1;
static short    tipzz;     /*Приход/расход*/
static char     kodmz[112]; /*Код материалла*/
static char     kopz[112];  /*Код операции*/
static double   cenaz;     /*цена*/
static char     kodoz[112]; /*Код организации*/
static char     sklz[112];      /*Код склада*/
static char	nabop[112]; /*Набор операций*/
static char     kodgr[112]; /*Код группы материалла*/
static char	shum[112];
static char	kodgrkon[112]; /*Код группы контрагентов*/
double		cenak,cenad;
int             kk1,kk2,kk3,kk4;
short		mo; /*0-полный отчет 1-только таблица c весом 2-с прибылью*/
short		mc; /*Метка цен*/
char		nm[512];
int		kgr,kodm;
long		kolstr,kolstr1;
SQL_str         row,row1;
char		strsql[512];
char		shu[32],kor[32],kop[32];
int		kgrm;
char		naimat[512];
char		ei[32];
double		fas;
short           tr=0; /*0-развернутая форма 1-короткая*/
int		klst=0;

VVOD MENU(3);
VVOD VV(0);

VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(dat2,11);

VV.VVOD_SPISOK_add_data(sklz,sizeof(sklz));
VV.VVOD_SPISOK_add_data(2);
if(tipzz == 1)
  VV.VVOD_SPISOK_zapis_data(3,"+");
if(tipzz == 2)
  VV.VVOD_SPISOK_zapis_data(3,"-");

VV.VVOD_SPISOK_add_data(kopz,sizeof(kopz));

VV.VVOD_SPISOK_add_data(kodmz,sizeof(kodmz));
VV.VVOD_SPISOK_add_data(10);
if(cenaz > 0.)
 {
  sprintf(strsql,"%.10g",cenaz);
  VV.VVOD_SPISOK_zapis_data(6,strsql);
 }
VV.VVOD_SPISOK_add_data(kodoz,sizeof(kodoz));

VV.VVOD_SPISOK_add_data(kodgr,sizeof(kodgr));

VV.VVOD_SPISOK_add_data(nabop,sizeof(nabop));
VV.VVOD_SPISOK_add_data(shum,sizeof(shum));
VV.VVOD_SPISOK_add_data(kodgrkon,sizeof(kodgrkon));

VV.VVOD_SPISOK_add_ZAG(gettext("Движение товарно-материальных ценностей (форма 3)."));
VV.VVOD_SPISOK_add_ZAG(gettext("Введите нужные реквизиты."));
VV.VVOD_SPISOK_add_ZAG(gettext("По невведеным реквизитам поиск не выполняется."));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала..........."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца............"));
VV.VVOD_SPISOK_add_MD(gettext("Склад........(,,)....."));
VV.VVOD_SPISOK_add_MD(gettext("Приход/Расход.(+/-)..."));
VV.VVOD_SPISOK_add_MD(gettext("Код операции.(,,)....."));
VV.VVOD_SPISOK_add_MD(gettext("Код материалла.(,,/*)."));
VV.VVOD_SPISOK_add_MD(gettext("Отпускная цена........"));
VV.VVOD_SPISOK_add_MD(gettext("Код контрагента.(,,).."));
VV.VVOD_SPISOK_add_MD(gettext("Код группы материалла."));
VV.VVOD_SPISOK_add_MD(gettext("Набор операций........"));
VV.VVOD_SPISOK_add_MD(gettext("Счет учета.(,,)......."));
VV.VVOD_SPISOK_add_MD(gettext("Код группы контр.(,,)."));

naz:;
clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("итог.таблица"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F5",gettext("пол.отч."),
"F6",gettext("доход"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);
mo=0;

strcpy(dat1,VV.VVOD_SPISOK_return_data(0));
strcpy(dat2,VV.VVOD_SPISOK_return_data(1));

strcpy(sklz,VV.VVOD_SPISOK_return_data(2));
tipzz=0;
if(VV.VVOD_SPISOK_return_data(3)[0] != '\0' )
 {
  if(SRAV(VV.VVOD_SPISOK_return_data(3),"+",1) == 0)
    tipzz=1;
  if(SRAV(VV.VVOD_SPISOK_return_data(3),"-",1) == 0)
    tipzz=2;
  if(tipzz == 0)
   {
    error2(20,1,1,"Не вірно уведено Прибуток/Видаток !");
    goto naz;
   }
 }

strncpy(kopz,VV.VVOD_SPISOK_return_data(4),sizeof(kopz)-1);
strncpy(kodmz,VV.VVOD_SPISOK_return_data(5),sizeof(kodmz)-1);
cenaz=ATOFM(VV.VVOD_SPISOK_return_data(6));
if(VV.VVOD_SPISOK_return_data(6)[0] == '\0')
 cenaz=-1.;
 
strncpy(kodoz,VV.VVOD_SPISOK_return_data(7),sizeof(kodoz)-1);
strncpy(kodgr,VV.VVOD_SPISOK_return_data(8),sizeof(kodgr)-1);
strncpy(nabop,VV.VVOD_SPISOK_return_data(9),sizeof(nabop)-1);
strncpy(shum,VV.VVOD_SPISOK_return_data(10),sizeof(shum)-1);
strncpy(kodgrkon,VV.VVOD_SPISOK_return_data(11),sizeof(kodgrkon)-1);
class iceb_tu_str kods("");
class iceb_tu_str naims("");

switch (kom)
 {

  case FK10:
  case ESC:
   return(1);

  case FK1:
    GDITE();
    iceb_t_pdoc("matu5_6.txt");
    clear();
    goto naz;
    
  case FK2:
  case PLU:
    mo=1;
    break;


  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка складов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка контрагентов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций приходов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций расходов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка материалов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр наборов операций."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп контрагентов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 9 :
      case -1:
       goto naz;

      case 0 :
        //vibrek("Sklad",sklz,sizeof(sklz),nm);
        if(dirsklad(1,&kods,&naims) == 0)
          VV.data_z_plus(2,kods.ravno());
        goto naz;

      case 1 :
        vibrek("Kontragent",kodoz,sizeof(kodoz),nm);
        VV.VVOD_SPISOK_zapis_data(7,kodoz);
        goto naz;

      case 2 :
        vibrek("Grup",kodgr,sizeof(kodgr),nm);
        VV.VVOD_SPISOK_zapis_data(8,kodgr);
        goto naz;

      case 3 :
        vibrek("Prihod",kopz,sizeof(kopz),nm);
        VV.VVOD_SPISOK_zapis_data(4,kopz);
        goto naz;

      case 4 :
        vibrek("Rashod",kopz,sizeof(kopz),nm);
        VV.VVOD_SPISOK_zapis_data(4,kopz);
        goto naz;
        
      case 5 :
        memset(nm,'\0',sizeof(nm));
        bros[0]='\0';
        if(dirmatr(&kgr,&kodm,&naims,1,0,bros,0,0) == 0)
         {
          VV.data_z_plus(5,kodm);
         }
        
        goto naz;

      case 6 :
        vibrek("Plansh",shum,sizeof(shum),nm);
        VV.VVOD_SPISOK_zapis_data(10,shum);
        goto naz;
               
      case 7 :
        iceb_redfil("nabopr.alx",0);
        goto naz;

      case 8 :
        vibrek("Gkont",kodgrkon,sizeof(kodgrkon),nm);
        VV.VVOD_SPISOK_zapis_data(11,kodgrkon);
        goto naz;

     }
    goto naz;

  case FK4:
    VV.VVOD_clear_data();    
    goto naz;

  case FK5:
     mo=0;
     break;

  case FK6:
     mo=2;
     break;
      
  default:
    goto naz;
 }

if(rsdatp(&dn,&mn,&gn,dat1,&dk,&mk,&gk,dat2) != 0)
 goto naz;
 
if(kodmz[0] == '*' && maskmat == NULL)
 { 
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не создан список материалов !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 } 

if(VV.VVOD_SPISOK_return_data(9)[0] != '\0')
 {
  class iceb_tu_str nabor("");
  if(iceb_t_poldan(VV.VVOD_SPISOK_return_data(9),&nabor,"nabopr.alx") != 0)
   {
    VVOD SOOB(1);
    sprintf(strsql,gettext("Не найден набор операций %s"),VV.VVOD_SPISOK_return_data(9));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
  else
   VV.data_plus(4,nabor.ravno());
 }

mc=1;
if(mo != 2 && (tipzz == 2 || tipzz == 0))
 {
  VVOD DANET(1);
  DANET.VVOD_SPISOK_add_MD(gettext("В ценах реализации ?"));
  mc=danet(&DANET,2,stdscr);
 }

clear(); /*Очистить экран и закрасить фоновым цветом*/
GDITE();
time(&tmm);
bf=localtime(&tmm);
move(0,0);
printw(gettext("Расчет материального отчета за период с %d.%d.%dг. до %d.%d.%dг.\n"),
dn,mn,gn,dk,mk,gk);

/*Создаем массивы операций-материалов*/
matspo(&kk1,&kk2,&kk3,&kk4);
matstat(dn,mn,gn,dk,mk,gk);
printw("Масиви створені.\n");
refresh();


sprintf(strsql,"select sklad,nomk,nomd,datdp,datd,tipz,kolih,cena \
from Zkart where \
datdp >= '%d-%02d-%02d' and datdp <= '%d-%02d-%02d'",
gn,mn,dn,gk,mk,dk);
/*printw("strsql=%s\n",strsql);*/
SQLCURSOR cur;
SQLCURSOR cur1;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  printw("%s\n",sql_error(&bd));
  OSTANOV();
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }

printw(gettext("Поиск нужных записей.\n"));
refresh();

sprintf(imaf3,"mot%d.tmp",getpid());
if((ff2 = fopen(imaf3,"w")) == NULL)
   {
    error_op_nfil(imaf3,errno,"");
    return(1);
   }
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
/*
  printw("%s %s %s %s %s %s %s %s\n",
  row[0],row[1],row[2],row[3],row[4],row[5],row[6],row[7]);
  refresh();
*/
  if(proverka(sklz,row[0],0,0) != 0)
    continue;

   /*Читаем реквизиты карточки материалла*/
   sprintf(strsql,"select shetu,kodm,cena,ei,fas from Kart where \
sklad=%s and nomk=%s",
   row[0],row[1]);
   shu[0]='\0';
   kodm=0;   
   if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
    {
     beep();
     printw(gettext("Не нашли карточку ! Склад %d Номер карточки %d\n"),
     atoi(row[0]),atoi(row[1]));
     OSTANOV();
     continue;
    }
  memset(shu,'\0',sizeof(shu));
  strncpy(shu,row1[0],sizeof(shu)-1);
  kodm=atoi(row1[1]);

  cenak=atof(row1[2]);
  cenak=okrug(cenak,okrcn);
  if(mc == 2)
   cenad=cenak;
  else
   {
    cenad=atof(row[7]);
    cenad=okrug(cenad,okrcn);
   }

  memset(ei,'\0',sizeof(ei));
  strncpy(ei,row1[3],sizeof(ei)-1);
  fas=atof(row1[4]);
  
      
  if(kodmz[0] != '\0')
   {
    sprintf(bros,"%d",kodm);
    if(kodmz[0] == '*' && maskmat != NULL)
     {
      if(proverka(maskmat,bros,0,0) != 0)
         continue;
     }
    else
      if(proverka(kodmz,bros,0,0) != 0)
         continue;
   }

  if(proverka(shum,shu,0,0) != 0)
    continue;

  /*Читаем шапку документа*/
  rsdat(&d,&m,&g,row[4],2);
  sprintf(strsql,"select kontr,kodop from Dokummat \
  where datd='%d-%02d-%02d' and sklad=%s and nomd='%s'",
  g,m,d,row[0],row[2]);

  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    beep();
    printw(gettext("Не нашли документа ! Склад %s Ном.кар. %s Док.%s\n"),
    row[0],row[1],row[2]);
    OSTANOV();
    continue;
   }

  strncpy(kor,row1[0],sizeof(kor)-1);
  strncpy(kop,row1[1],sizeof(kop)-1);
    
  if(proverka(kodoz,kor,0,0) != 0)
    continue;

  if(kodgrkon[0] != '\0')
   {
    if(kor[0] == '0' && kor[1] == '0' && kor[2] == '-')
      strcpy(bros,"00");
    else
      strcpy(bros,kor);
      
    sprintf(strsql,"select grup from Kontragent where kodkon='%s'",bros);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
     {
      if(proverka(kodgrkon,row1[0],0,0) != 0)
        continue;
     }
    else
     {
      beep();
      printw("%s %s !\n",gettext("Не найден код контрагента"),
      kor);
      OSTANOV();
     }
   }


  if(tipzz != 0 && tipzz != atoi(row[5]))
   continue;

  if(cenaz != -1. && cenaz != cenad)
   continue;

  if(proverka(kopz,kop,0,0) != 0)
        continue;

  /*Читаем наименование материалла*/
  memset(naimat,'\0',sizeof(naimat));
  sprintf(strsql,"select kodgr,naimat from Material where kodm=%d",
  kodm);
  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    beep();
    printw("%s %d !\n",gettext("Не найден код материалла"),kodm);
    OSTANOV();             
    continue;      
   }
 
  kgrm=atoi(row1[0]);
  strncpy(naimat,row1[1],sizeof(naimat)-1);

  if(proverka(kodgr,row1[0],0,0) != 0)
        continue;
  rsdat(&d,&m,&g,row[3],2);
  fprintf(ff2,"%s|%s|%s|%d|%.10g|%s|%s|%s|%.10g|%s|%s|%d.%d.%d|%d|%.10g\n",
  row[5],row[0],kop,kodm,cenad,kor,row[6],naimat,cenak,ei,row[2],
  d,m,g,kgrm,fas);


 }
GDITE();

fclose(ff2);
printw(gettext("Сортируем записи"));
printw("\n");
refresh();

//sprintf(bros,"sort -o %s -t\\| +1n +2n %s",imaf3,imaf3);
sprintf(bros,"sort -o %s -t\\| -k2,3n -k3,4n %s",imaf3,imaf3);
runsystem(bros);

printw(gettext("Конец сортировки\n"));
refresh();

if((ff2 = fopen(imaf3,"r")) == NULL)
   {
    error_op_nfil(imaf3,errno,"");
    return(1);
   }


sprintf(imaf,"ko%d.lst",getpid());
sprintf(imaf1,"kog%d.lst",getpid());

bf=localtime(&tmm);

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }
if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return(1);
 }

fprintf(ff,gettext("Движение материалов.\n"));
fprintf(ff1,gettext("Рух по групам матеріалів.\n"));

fprintf(ff,gettext("Отчет по карточкам материалов.\n"));
fprintf(ff1,gettext("Отчет по карточкам материалов.\n"));
if(mo == 2)
 {
  fprintf(ff,"%s\n",gettext("Отчет по доходу (цена реализации - учетная цена)."));
  fprintf(ff1,"%s\n",gettext("Отчет по доходу (цена реализации - учетная цена)."));
 }
else
 {
  if(mc == 2)
   {
    fprintf(ff,gettext("Отчет по учетным ценам.\n"));
    fprintf(ff1,gettext("Отчет по учетным ценам.\n"));
   }

  if(mc == 1)
   { 
    fprintf(ff,gettext("Отчет по ценам реализации.\n"));
    fprintf(ff1,gettext("Отчет по ценам реализации.\n"));
   }
 }
fprintf(ff1,"%s\n\n\
%s %d.%d.%d%s %s %d.%d.%d%s\n\
%s %d.%d.%d%s %s - %d:%d\n",
organ,
gettext("Движение товарно-материалных ценностей за период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

if(VV.VVOD_SPISOK_return_data(2)[0] != '\0')
  fprintf(ff1,gettext("Склад - %s\n"),VV.VVOD_SPISOK_return_data(2));

if(VV.VVOD_SPISOK_return_data(3)[0] != '\0')
  fprintf(ff1,gettext("Приход/расход - %s\n"),VV.VVOD_SPISOK_return_data(3));

if(VV.VVOD_SPISOK_return_data(4)[0] != '\0')
  fprintf(ff1,"%s - %s\n",gettext("Код операции"),VV.VVOD_SPISOK_return_data(4));

if(VV.VVOD_SPISOK_return_data(5)[0] != '\0')
  fprintf(ff1,gettext("Материал - %s\n"),VV.VVOD_SPISOK_return_data(5));

if(VV.VVOD_SPISOK_return_data(6)[0] != '\0')
  fprintf(ff1,gettext("Отпускная цена - %s\n"),VV.VVOD_SPISOK_return_data(6));

if(VV.VVOD_SPISOK_return_data(7)[0] != '\0')
  fprintf(ff1,gettext("Код контрагента - %s\n"),VV.VVOD_SPISOK_return_data(7));

if(VV.VVOD_SPISOK_return_data(8)[0] != '\0')
  fprintf(ff1,gettext("Группа - %s\n"),VV.VVOD_SPISOK_return_data(8));

if(VV.VVOD_SPISOK_return_data(9)[0] != '\0')
  fprintf(ff1,gettext("Набор операций - %s\n"),VV.VVOD_SPISOK_return_data(9));

if(VV.VVOD_SPISOK_return_data(10)[0] != '\0')
  fprintf(ff1,gettext("Счета - %s\n"),VV.VVOD_SPISOK_return_data(10));

if(VV.VVOD_SPISOK_return_data(11)[0] != '\0')
 {
  fprintf(ff1,"%s:\n",gettext("Группы контрагентов"));
  printcod(ff1,"Gkont","kod","naik",0,VV.VVOD_SPISOK_return_data(11),&klst);
 }


rasmoth(&VV,tr,sklz,kodmz,kodoz,dn,mn,gn,dk,mk,gk,tipzz,cenaz,kopz,kk1,kk2,kk3,kk4,mo,ff,ff2);

/*Распечатываем и закрываем массивы операций-материалов*/

matspor(kk1,kk2,kk3,kk4,ff,ff1,mo);

matstatr(&VV,dn,mn,gn,dk,mk,gk,imaf2);

podpis(ff);
podpis(ff1);


fclose(ff);
fclose(ff1);
fclose(ff2);
unlink(imaf3);

printw_vr(tmm);

OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Движение материальных ценностей по материаллам и операциям"));
oth->spis_imaf.plus(imaf1);
oth->spis_naim.plus(gettext("Движение материальных ценностей по группам материалов и операциям"));
oth->spis_imaf.plus(imaf2);
oth->spis_naim.plus(gettext("Сравнительный график движения по датам"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);
}
