/*$Id: nastspec.c,v 1.12 2011-01-13 13:43:22 sasa1 Exp $*/
/*31.10.2009	27.10.2001	Белых А.И.	nastspec.c
Чтение настроек
*/
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif


char		*kodopsp=NULL; //Коды операций сторнирования для приходов
char		*kodopsr=NULL; //Коды операций сторнирования для расходов

int	nastspec()
{
char		bros[512];
char            str[1024];
FILE            *ff;
char            st1[512];
short           i;
char		imaf[512];

if(kodopsp != NULL)
 {
  delete [] kodopsp;
  kodopsp=NULL;
 }
if(kodopsr != NULL)
 {
  delete [] kodopsp;
  kodopsp=NULL;
 }

memset(imaf,'\0',sizeof(imaf));
sprintf(imaf,"%s","matnast.alx");

if((ff = fopen(imaf,"r")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(bros,"%s:%d !",gettext("Ошибка открытия файла"),errno);
  SOOB.VVOD_SPISOK_add_MD(bros);
  SOOB.VVOD_SPISOK_add_MD(imaf);
  SOOB.VVOD_SPISOK_add_MD(gettext("Аварийное завершение работы программы !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }    

while(fgets(str,sizeof(str),ff) != NULL)
 {
  if(SRAV(st1,"Коды операций сторнирования для приходов",0) == 0)
   {
     polen(str,bros,sizeof(bros),2,'|');
     i=strlen(bros)+1;
     if((kodopsp=new char[i*sizeof(char)]) == NULL)
       error2(20,0,1,"Не могу выделить пямять для kodopsp !");
     strcpy(kodopsp,bros);
     continue;
   }
  if(SRAV(st1,"Коды операций сторнирования для расходов",0) == 0)
   {
     polen(str,bros,sizeof(bros),2,'|');
     i=strlen(bros)+1;
     if((kodopsr=new char[i*sizeof(char)]) == NULL)
       error2(20,0,1,"Не могу выделить пямять для kodopsr !");
     strcpy(kodopsr,bros);
     continue;
   }
 }
fclose(ff);
unlink(imaf);
return(0);
}
