/* $Id: pld.c,v 5.94 2011-03-28 06:53:58 sasa Exp $ */
/*12.12.2010     18.06.1997       Белых А.И.      pld.c
Просмотр готового платежного поручения
Если вернули 0 - платежка не записана
             1 - записана
*/
#include        <pwd.h>
#include        <math.h>
#include        <time.h>
#include        <errno.h>
#include        "buhg.h"
#include        "dok4.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

int		udpld(const char*,short,short,short,const char*,short,const char*,int,int);
int		zappdok(const char*);
void		printpp(char*,char*,char*,char*,char*,double,short,short,FILE*);
int             dirprpd(const char*);
void            dirpzpd(const char*);
void		klient(const char*,short,short,short,const char*);
int	        vibshbn(char*,const char*);

extern struct REC rec;
extern double   okrg1; /*Округление*/
extern char     *imafkomtmp; //Имя файла куда выгружается комментарий для редактирования

void pld(short kp, //Количество повторов
const char *tabl) //Таблица документа
{
class iceb_tu_str printer("lpr -r");
class iceb_tu_str printerloc("prterm -r");
char dt2[32]; //дата платежа
char            bros[512];
char            pr[112];
char            prom[112];
char            str[512];
extern short    rzk;       /*0-преобразование числа с тире 1-со вставкой запятой*/
extern short    mvs;       /*1-с разбивкой суммы по счетам 0-без*/
extern double   smp0,smp1; /*Суммы за переводы внутри банка и вне банка*/
char            shban[32];   /*Счет банка за услуги*/
FILE            *ff=NULL;
int           K,kom,kom1;
short           i;
char            imaf[40];
short           kolp;  /*Количество повторов*/
short		d,m,g;
short		dp,mp,gp;
time_t		vrem;
double		sump,sumpp;   /*Подтвержденная сумма*/
char            mescc[32];
class iceb_tu_str kodd("");
class iceb_tu_str naim("");
double		sh;
SQL_str         row;
int		poz,komv;
char		poi[32];
SQLCURSOR       cur;
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];
double nds1=iceb_t_pnds(rec.dd,rec.md,rec.gd);
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);

//imafn("nastsys.alx",&imaf_nast);
iceb_t_poldan("Системный принтер",&printer,"nastsys.alx");
iceb_t_poldan("Приэкранный принтер",&printerloc,"nastsys.alx");


VVOD MENU(3);
VVOD VV(0);
VVOD SOOB(1);
VVOD DANET(1);

d=m=g=dp=mp=gp=0;

if(rec.nomdk_i[0] == '\0')
 {
  dp=mp=gp=0;
  memset(shban,'\0',sizeof(shban));
  iceb_t_poldan("Банковский счет",shban,"nastdok.alx");
  strcpy(rec.shbzu,shban);
 }
else
 {
  dp=rec.dd; mp=rec.md; gp=rec.gd;
  memset(shban,'\0',sizeof(shban));
  strcpy(shban,rec.shbzu);
 }

naz:;

if(rec.nomdk_i[0] == '\0')
 {
  rec.uslb=smp0;
  if(SRAV(rec.mfo,rec.mfo1,0) != 0)
    rec.uslb=smp1;
 }

naz1:;

clear(); /*Очистить экран и закрасить фоновым цветом*/
refresh();
//Месяц платежа преобразуем в название
memset(dt2,'\0',sizeof(dt2));
if(rec.dd != 0) //Для типовых документов будет равен 0
 {
  memset(mescc,'\0',sizeof(mescc));
  mesc(rec.md,1,mescc);
  sprintf(dt2,"%02d %s %d%s",rec.dd,mescc,rec.gd,gettext("г."));
 }
if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
 {

  sprintf(strsql,"select str from Alx where fil='pp.alx' order by ns asc");
  if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    return;
   }

  if(kolstr == 0)
   {
    sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"pp.alx");
    iceb_t_soob(strsql);
    return;
   }

 }
if(SRAV(tabl,"Pltt",0) == 0 || SRAV(tabl,"Tpltt",0) == 0)
 {

  sprintf(strsql,"select str from Alx where fil='pt.alx' order by ns asc");
  if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    return;
   }

  if(kolstr == 0)
   {
    sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"pt.alx");
    iceb_t_soob(strsql);
    return;
   }
 }
memset(str,'\0',sizeof(str));
//attron(A_ALTCHARSET); /*Альтернативная таблица*/
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  /*Такой сложный алгоритм нужен для коректного вывода на экран маленького размера*/
  
  memset(strsql,'\0',sizeof(strsql));
  sprintf(strsql,"%.*s",iceb_tu_kolbait(COLS-1,row_alx[0]),row_alx[0]);
  
  printw("%s",strsql);
    
  if(pole2(strsql,'\n') == 0)
   printw("\n");  
  
  memset(str,'\0',sizeof(str));
 }
//attroff(A_ALTCHARSET); /*Альтернативная таблица*/


if(rec.prov == 1)
 {
  move(0,COLS-25);
  attron(A_BLINK); /*Влючение мерцания*/
  printw(gettext("Проводки не сделаны !"));
  attroff(A_BLINK); /*Выключение мерцания*/
 }

move(1,COLS-25);
printw("%s%d %s:%.2f",gettext("Кол.копий:"),
kp,gettext("НДС"),rec.nds);

sump=0;
if(rec.ddi != 0 && (SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Pltt",0) == 0))
  sump=sumpzpd(tabl,&dp,&mp,&gp,&sumpp);

if(fabs(sump-(rec.sumd+rec.uslb)) > 0.0099)
  attron(A_BLINK); /*Влючение мерцания*/
move(2,COLS-25);
printw("%s%.2f",gettext("Сумма подт.:"),sump);
attroff(A_BLINK); /*Выключение мерцания*/

move(3,COLS-25);
printw("%s%s",gettext("Операция :"),rec.kodop);
move(4,COLS-25);
printw("Коди конт.:%s / %s",rec.kodor,rec.kodor1);

move(0,39);
printw("%s",rec.nomdk);
if(SRAV(tabl,"Tpltp",0) == 0 || SRAV(tabl,"Tpltt",0) == 0)
  printw("  (типова)");
move(1,18);
printw("%s",dt2);

move(2,8);
if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
  printw("%.*s",iceb_tu_kolbait(40,rec.naior),rec.naior);
else
  printw("%.*s",iceb_tu_kolbait(40,rec.naior1),rec.naior1);

move(4,11);
if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
  printw("%s",rec.kod);
else
  printw("%s",rec.kod1);

if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
  sprintf(prom,"%s в м.%s",rec.naiban,rec.gorod);
else
  sprintf(prom,"%s в м.%s",rec.naiban1,rec.gorod1);

sh=rec.sumd+rec.uslb;

if(rzk == 0)
    prnb(sh,pr);
if(rzk == 1)
    prnb1(sh,pr);

move(7,0);
printw("%-*.*s",
iceb_tu_kolbait(29,prom),
iceb_tu_kolbait(29,prom),
prom);

move(7,30);
if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
  printw("%s",rec.mfo);
else
  printw("%s",rec.mfo1);

move(7,48);
if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
  printw("%s",rec.nsh);
else
  printw("%s",rec.nsh1);

move(7,65);
printw("%s",pr);

move(9,10);
if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
  printw("%s",rec.naior1);
else
  printw("%s",rec.naior);

move(11,11);
if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
  printw("%s",rec.kod1);
else
  printw("%s",rec.kod);

pr[0]='\0';
if(rec.uslb != 0. && mvs == 1)
 {
    sh=rec.sumd;
    if(rzk == 0)
       prnb(sh,pr);
 
    if(rzk == 1)
       prnb1(sh,pr);
 }

move(12,48);
if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
  printw("%s",rec.nsh1);
else
  printw("%s",rec.nsh);

move(12,65);
printw("%s",pr);

if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
  sprintf(prom,"%s в м.%s",rec.naiban1,rec.gorod1);
else
  sprintf(prom,"%s в м.%s",rec.naiban,rec.gorod);

pr[0]='\0';

if(rec.uslb != 0. && mvs == 1)
 {
  if(rzk == 0)
    prnb(rec.uslb,pr);

  if(rzk == 1)
    prnb1(rec.uslb,pr);

 }
move(14,0);
printw("%-*.*s",
iceb_tu_kolbait(29,prom),
iceb_tu_kolbait(29,prom),
prom);
move(14,30);

if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
  printw("%s",rec.mfo1);
else
  printw("%s",rec.mfo);

move(14,48);
printw("%s",shban);

move(14,65);
printw("%s",pr);

sh=rec.sumd+rec.uslb;

memset(str,'\0',sizeof(str));
preobr(sh,str,0);

move(17,0);
printw("%s",str);

/*Файл назначения платежа на экран*/
if((ff = fopen(imafkomtmp,"r")) == NULL)
 {
  error_op_nfil(imafkomtmp,errno,"");
  return;
 }

move(19,0);
for(i=0; i < LINES-20 && i < 5 ; i++)
 {
  if(fgets(str,sizeof(str),ff) == NULL)
   break;
  if(str[0] == '#')
   continue;

  sprintf(strsql,"%.*s",iceb_tu_kolbait(COLS-1,str),str);
  printw("%s",strsql);
  if(pole2(strsql,'\n') == 0)
   printw("\n");
//  printw("%.80s",str);

 }
fclose(ff);
/*
move(23,0);
if(SRAV(rec.mfo,rec.mfo1,0) == 0)
  printw("МФО равны %.2f  %d (%.2f/%.2f)",smp,mvs,smp0,smp1);
else
  printw("МФО неравны %.2f %d (%.2f/%.2f)",smp,mvs,smp0,smp1);
  */

helstr(LINES-1,0,
"F1",gettext("пом."),
"F2",gettext("корек."),
"F3",gettext("удалить"),
"F4",gettext("пров."),
"F5",gettext("печать"),
"F6",gettext("смена сче."),
"F7",gettext("подтв."),
"F8",gettext("нов.док."),
"F9",gettext("пас"),
"F10",gettext("выход"),NULL);

K=getch();

if(K == KEY_MOUSE)
 {
  int N=0;
  int PY=0,PX=0;
  int KLST=0,MDLS=0;  
  K=mouseklic(&N,PY,PX,MDLS,KLST,stdscr);
 }
switch (K)
 {
  case ESC:
  case FK10:

    if(rec.ddi != 0 && (SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Pltt",0) == 0))
       provpd(tabl);

    return;
    break;

  case FK1:   /*Помощь*/
    GDITE();
    iceb_t_pdoc("dokum2_1_1.txt");
    clear();
    goto naz;

  case FK2:
//   printw("\ndt2z=%s\n",dt2z);
//   OSTANOV();
//    sprintf(strsql,"%s",iceb_t_imafnsi("blokdok.alx"));
    if(iceb_t_pbpds(rec.md,rec.gd) != 0)
      goto naz;
    if(iceb_t_pbpds(rec.mdi,rec.gdi) != 0)
      goto naz;
    
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Корректировать реквизиты документа"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Корректировать комментарий к документу"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Корректировать контрагента из списка базы"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Корректировать контрагента из списка файла"));//3
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));


    kom=0;
    while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

    switch (kom)
     {
      case -1 :
	goto naz;
	break;

      case 0 :

        VV.VVOD_delete();

	VV.VVOD_SPISOK_add_MD(gettext("Сyмма платежа............"));//0
	VV.VVOD_SPISOK_add_MD(gettext("Счет банка 1............."));//1
	VV.VVOD_SPISOK_add_MD(gettext("Счет банка 2............."));//2
	VV.VVOD_SPISOK_add_MD(gettext("Сумма за услуги банка...."));//3
	VV.VVOD_SPISOK_add_MD(gettext("Номер документа.........."));//4
	VV.VVOD_SPISOK_add_MD(gettext("Дата платежа............."));//5
	VV.VVOD_SPISOK_add_MD(gettext("Операция................."));//6
	VV.VVOD_SPISOK_add_MD(gettext("НДС......................"));//7
        VV.VVOD_SPISOK_add_MD(gettext("Номер счета плательщика.."));//8
        VV.VVOD_SPISOK_add_MD(gettext("МФО плательщика.........."));//9
        VV.VVOD_SPISOK_add_MD(gettext("Дата валютирования......."));//10
        VV.VVOD_SPISOK_add_MD(gettext("Код нерезидента.........."));//11
        VV.VVOD_SPISOK_add_MD(gettext("Количество копий........."));//12
        VV.VVOD_SPISOK_add_MD(gettext("Код ЕГРПОУ получателя...."));//13
        VV.VVOD_SPISOK_add_MD(gettext("МФО получателя..........."));//14

        VV.VVOD_SPISOK_add_data(20);//0
        VV.VVOD_SPISOK_add_data(30);//1
        VV.VVOD_SPISOK_add_data(30);//2
        VV.VVOD_SPISOK_add_data(20);//3
        VV.VVOD_SPISOK_add_data(10);//4
        VV.VVOD_SPISOK_add_data(20);//5
        VV.VVOD_SPISOK_add_data(12);//6
        VV.VVOD_SPISOK_add_data(10);//7
        VV.VVOD_SPISOK_add_data(20);//8
        VV.VVOD_SPISOK_add_data(10);//9
        VV.VVOD_SPISOK_add_data(11);//10
        VV.VVOD_SPISOK_add_data(10);//11
        VV.VVOD_SPISOK_add_data(4); //12
        VV.VVOD_SPISOK_add_data(20);//13
        VV.VVOD_SPISOK_add_data(10);//14

	sprintf(strsql,"%.2f",rec.sumd);
	VV.data_plus(0,strsql);
	VV.data_plus(1,rec.nsh1);
	VV.data_plus(2,shban);
	if(rec.uslb != 0.)
	  VV.data_plus(3,rec.uslb);

	VV.data_plus(4,rec.nomdk);
	
	sprintf(strsql,"%d.%d.%d",rec.dd,rec.md,rec.gd);
	VV.data_plus(5,strsql);
	
	VV.data_plus(6,rec.kodop);
        if(rec.nds != 0.)
          VV.data_plus(7,rec.nds);
        VV.data_plus(8,rec.nsh);
        VV.data_plus(9,rec.mfo);
        if(rec.dv != 0)
         {
          sprintf(strsql,"%d.%d.%d",rec.dv,rec.mv,rec.gv);
          VV.data_plus(10,strsql);
         }
        VV.data_plus(11,rec.kodnr);
        VV.data_plus(12,kp);
        VV.data_plus(13,rec.kod1);
        VV.data_plus(14,rec.mfo1);

obr:;

        helstr(LINES-1,0,"F2/+",gettext("запись"),
        "F3",gettext("операции"),
        "F4",gettext("НДС"),
        "F10",gettext("выход"),NULL);
        

        kom1=VV.vvod(0,1,1,-1,-1);

        switch(kom1)
         {
          case FK10:
          case ESC:
             goto naz;

          case FK2:
          case PLU:
            break;
            
          case FK3:
            clear();
            kodd.new_plus("");
            naim.new_plus("");

            if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
              strcpy(bros,"Opltp");
            if(SRAV(tabl,"Pltt",0) == 0 || SRAV(tabl,"Tpltt",0) == 0)
              strcpy(bros,"Opltt");
            poz=komv=0;
            poi[0]='\0';
            if(dirmat1(bros,&kodd,&naim,LINES-5,0,2,1,&poz,&komv,poi,"\0") == 0)
             {
              VV.data_plus(6,kodd.ravno());
              clear();
              goto obr;
             }
            clear();
            goto obr;

          case FK4:

            rec.nds=ATOFM(VV.VVOD_SPISOK_return_data(0))*nds1/(nds1+100);
            rec.nds=okrug(rec.nds,okrg1);
            if(rec.nds != 0.)
               VV.data_plus(7,rec.nds);
            goto obr;

          default:
            goto obr;
                                
         }

        if((SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Pltt",0) == 0) &&
         VV.VVOD_SPISOK_return_data(5)[0] == '\0')
         {
          SOOB.VVOD_delete();;
          SOOB.VVOD_SPISOK_add_MD(gettext("Не введена дата !"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto obr;
         }  
        
        if(VV.VVOD_SPISOK_return_data(5)[0] != '\0')  
        if(rsdat(&d,&m,&g,VV.VVOD_SPISOK_return_data(5),0) != 0)
         {
          SOOB.VVOD_delete();;
          SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto obr;
         }  
        rec.dd=d;
        rec.md=m;
        rec.gd=g;
        
//        if(sravmydat(rec.dd,rec.md,rec.gd,rec.ddi,rec.mdi,rec.gdi) != 0)/*Если есть проводки по старой дате и они заблокированы, то менять дату нельзя*/
        if(rec.mdi != rec.md || rec.gdi != rec.gd) 
        if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Pltt",0) == 0 )
         {
          int metka_t=0;
          if(SRAV(tabl,"Pltt",0) == 0 )
           metka_t=5;
          if(SRAV(tabl,"Pltp",0) == 0 )
           metka_t=4;
          /*Проверяем заблокированы ли проводки по обоим датам*/ 
          if(iceb_t_pvkdd(metka_t,rec.ddi,rec.mdi,rec.gdi,rec.md,rec.gd,0,rec.nomdk_i,rec.tipz) != 0)
           goto obr;
         }

        if(VV.VVOD_SPISOK_return_data(10)[0] != '\0')  
         {
          if(rsdat(&d,&m,&g,VV.VVOD_SPISOK_return_data(10),0) != 0)
           {
            SOOB.VVOD_delete();;
            SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата валютирования !"));
            soobshw(&SOOB,stdscr,-1,-1,0,1);
            goto obr;
           }  

          rec.dv=d;
          rec.mv=m;
          rec.gv=g;
         }

        if((SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Pltt",0) == 0) &&
         VV.VVOD_SPISOK_return_data(6)[0] == '\0')
         {
          SOOB.VVOD_delete();;
          SOOB.VVOD_SPISOK_add_MD(gettext("Не введена операция !"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto obr;
         }  

        if(VV.VVOD_SPISOK_return_data(6)[0] != '\0')
         {
          if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
           sprintf(strsql,"select naik from Opltp where kod='%s'",
           VV.VVOD_SPISOK_return_data(6));

          if(SRAV(tabl,"Pltt",0) == 0 || SRAV(tabl,"Tpltt",0) == 0)
           sprintf(strsql,"select naik from Opltp where kod='%s'",
           VV.VVOD_SPISOK_return_data(6));

          if(sql_readkey(&bd,strsql,&row,&cur) != 1)
           {
            SOOB.VVOD_delete();;
            sprintf(strsql,gettext("Не найден код операции %s !"),VV.VVOD_SPISOK_return_data(6));
            SOOB.VVOD_SPISOK_add_MD(strsql);
            soobshw(&SOOB,stdscr,-1,-1,0,1);
            goto obr;
           }
         }
        if(VV.VVOD_SPISOK_return_data(8)[0] == '\0')
         {
          SOOB.VVOD_delete();;
          SOOB.VVOD_SPISOK_add_MD(gettext("Не введен номер счета плательщика !"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto obr;
         }  

        if(SRAV(VV.VVOD_SPISOK_return_data(4),rec.nomdk_i,0) != 0)
         {
          if(rec.nomdk_i[0] != '\0')
          if(SRAV(tabl,"Tpltt",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
           {
            SOOB.VVOD_delete();;
            SOOB.VVOD_SPISOK_add_MD(gettext("Для типовых документов номер документа корректировать нельзя !"));
            soobshw(&SOOB,stdscr,-1,-1,0,1);
            goto obr;
           }
          /*Проверяем может документ с таким номером уже есть*/
          sprintf(strsql,"select nomd from %s where datd >= '%04d-01-01' and \
datd <= '%04d-12-31' and nomd='%s'",tabl,rec.gd,rec.gd,VV.VVOD_SPISOK_return_data(4));
          if(sql_readkey(&bd,strsql,&row,&cur) >= 1)
           {
            SOOB.VVOD_delete();;
            sprintf(strsql,gettext("Номер документа %s уже есть !"),VV.VVOD_SPISOK_return_data(4));
            SOOB.VVOD_SPISOK_add_MD(strsql);
            soobshw(&SOOB,stdscr,-1,-1,0,1);
            goto obr;
           }          
         }

       if(rec.nomdk_i[0] != '\0') //Корректировка уже записаного документа
        {
         if(udpld(tabl,rec.ddi,rec.mdi,rec.gdi,rec.nomdk_i,1,rec.kodop_i,0,rec.tipz) != 0)
          goto obr;
         zappdok(tabl);
        }

        kp=(short)ATOFM(VV.VVOD_SPISOK_return_data(12));
        strcpy(rec.kod1,VV.VVOD_SPISOK_return_data(13));
        strcpy(rec.mfo1,VV.VVOD_SPISOK_return_data(14));
	strncpy(rec.nomdk,VV.VVOD_SPISOK_return_data(4),sizeof(rec.nomdk)-1);

        rec.sumd=ATOFM(VV.VVOD_SPISOK_return_data(0));
	strncpy(rec.nsh1,VV.VVOD_SPISOK_return_data(1),sizeof(rec.nsh1)-1);

	strncpy(shban,VV.VVOD_SPISOK_return_data(2),sizeof(shban)-1);
	strncpy(rec.shbzu,VV.VVOD_SPISOK_return_data(2),sizeof(rec.shbzu)-1);

	rec.uslb=ATOFM(VV.VVOD_SPISOK_return_data(3));
         

	strcpy(dt2,VV.VVOD_SPISOK_return_data(5));
	strcpy(rec.kodop,VV.VVOD_SPISOK_return_data(6));
        rec.nds=ATOFM(VV.VVOD_SPISOK_return_data(7));
        rec.nds=okrug(rec.nds,0.01);
	strncpy(rec.nsh,VV.VVOD_SPISOK_return_data(8),sizeof(rec.nsh)-1);
	strncpy(rec.mfo,VV.VVOD_SPISOK_return_data(9),sizeof(rec.mfo)-1);
	strncpy(rec.kodnr,VV.VVOD_SPISOK_return_data(11),sizeof(rec.kodnr)-1);

	goto naz1;

      case 1 :

        vizred(imafkomtmp);
        if(rec.nomdk_i[0] != '\0') //Корректировка уже записаного документа
         {
          if(udpld(tabl,rec.ddi,rec.mdi,rec.gdi,rec.nomdk_i,1,rec.kodop_i,1,rec.tipz) == 0)
            zappdok(tabl);
         }
	goto naz;

      case 2 :
        vzrkbz();          
        if(rec.nomdk_i[0] != '\0') //Корректировка уже записаного документа
         {
          if(udpld(tabl,rec.ddi,rec.mdi,rec.gdi,rec.nomdk_i,1,rec.kodop_i,0,rec.tipz) == 0)
            zappdok(tabl);
         }
        goto naz;

      case 3 :
        if(iceb_redfil("platpor.alx",0) == 0)
          vzrkf();
        if(rec.nomdk_i[0] != '\0') //Корректировка уже записаного документа
         {
          if(udpld(tabl,rec.ddi,rec.mdi,rec.gdi,rec.nomdk_i,1,rec.kodop_i,0,rec.tipz) == 0)
            zappdok(tabl);
         }
        goto naz;

      default :
	goto naz;
     }
    goto naz;
    break;

  case FK3: //Удаление 
   
 //   sprintf(strsql,"%s",iceb_t_imafnsi("blokdok.alx"));
    if(iceb_t_pbpds(rec.md,rec.gd) != 0)
      goto naz;
   

    if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Pltt",0) == 0 )
     {
      int metka_ps=0;
      if(SRAV(tabl,"Pltp",0) == 0)
       metka_ps=4;
      if(SRAV(tabl,"Pltt",0) == 0)
       metka_ps=5;
      /*Смотрим заблокированы ли проводки к этому документа*/
      if(iceb_t_pbp(metka_ps,rec.dd,rec.md,rec.gd,rec.nomdk,0,rec.tipz,gettext("Удалить документ невозможно!")) != 0)
       goto naz;
     }


    DANET.VVOD_delete();
    DANET.VVOD_SPISOK_add_MD(gettext("Удалить документ ? Вы уверены ?"));

    if(danet(&DANET,2,stdscr) == 1)
     {
      if(udpld(tabl,rec.dd,rec.md,rec.gd,rec.nomdk,0,rec.kodop,1,rec.tipz) == 0)
        return;
     }
    goto naz;

  case FK4:  /* Проводки по платежке*/
     if(rec.nomdk_i[0] == '\0')
     {
      SOOB.VVOD_delete();;
      SOOB.VVOD_SPISOK_add_MD(gettext("Документ не записан !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }

    if(sump == 0.)
     {
      SOOB.VVOD_delete();;
      SOOB.VVOD_SPISOK_add_MD(gettext("Документ не подтвержден !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }

    if(dirprpd(tabl) == 0)
      return;

    goto naz;
               

  case FK7:
    if(SRAV(tabl,"Tpltp",0) == 0 || SRAV(tabl,"Tpltt",0) == 0)
     {
      SOOB.VVOD_delete();;
      SOOB.VVOD_SPISOK_add_MD(gettext("Для типовых документов не бывает подтверждающих записей !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }
    if(rec.nomdk_i[0] == '\0')
     {
      SOOB.VVOD_delete();;
      SOOB.VVOD_SPISOK_add_MD(gettext("Документ не записан !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }

    VV.VVOD_delete();
    VV.VVOD_SPISOK_add_data(11);
    VV.VVOD_SPISOK_add_data(20);
    if(sump == 0.)
     {
      sprintf(strsql,"%d.%d.%d",rec.dd,rec.md,rec.gd);
      VV.data_plus(0,strsql);
     }
    VV.data_plus(1,rec.sumd+rec.uslb-sump);
    
    VV.VVOD_SPISOK_add_MD(gettext("Дата...."));
    VV.VVOD_SPISOK_add_MD(gettext("Сумма..."));
nz:;

    helstr(LINES-1,0,"F2/+",gettext("запись"),
    "F10",gettext("выход"),NULL);

    kom1=VV.vvod(0,1,1,-1,-1);
    switch(kom1)
     {
      case FK10:
      case ESC:
        goto naz;   

      case FK2:
      case PLU:
        if(rsdat(&d,&m,&g,VV.VVOD_SPISOK_return_data(0),0) != 0)
         {
          SOOB.VVOD_delete();;
          SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
  	  goto nz;
         }

    //    sprintf(strsql,"%s",iceb_t_imafnsi("blokdok.alx"));
        if(iceb_t_pbpds(m,g) != 0)
          goto naz;

        if(SRAV1(g,m,d,rec.gd,rec.md,rec.dd) > 0)
         {
          SOOB.VVOD_delete();;
          SOOB.VVOD_SPISOK_add_MD(gettext("Дата меньше чем дата документа ! Подтверждение невозможно !"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
  	  goto nz;
         }

        if(ATOFM(VV.VVOD_SPISOK_return_data(1)) == 0.)
         {
          SOOB.VVOD_delete();;
          SOOB.VVOD_SPISOK_add_MD(gettext("Сумма равна нолю ! Подтверждение невозможно !"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
  	  goto nz;
         }

        time(&vrem);

        if(SRAV(tabl,"Pltp",0) == 0)
         sprintf(strsql,"insert into Pzpd \
  values (0,'%d-%02d-%02d','%d-%02d-%02d','%s',%s,%d,%ld)",
         rec.gd,rec.md,rec.dd,g,m,d,rec.nomdk,VV.VVOD_SPISOK_return_data(1),iceb_t_getuid(),vrem);   

        if(SRAV(tabl,"Pltt",0) == 0)
         sprintf(strsql,"insert into Pzpd \
  values (1,'%d-%02d-%02d','%d-%02d-%02d','%s',%s,%d,%ld)",
         rec.gd,rec.md,rec.dd,g,m,d,rec.nomdk,VV.VVOD_SPISOK_return_data(1),iceb_t_getuid(),vrem);

        GDITE();
        if(sql_zap(&bd,strsql) != 0)
         {
          sprintf(strsql,"Ошибка ввода записи !\n%s\n",sql_error(&bd));
          error2(20,0,1,strsql);
          goto nz;
         }

        provpd(tabl);

        break;    

      default:
        goto nz;

     }

    goto naz;

  case FK6: //Выбор счета
    char kontr[32];
    memset(kontr,'\0',sizeof(kontr));
    
    if(vibshbn(kontr,tabl) == 0)
     {
//      printw("\n%s %s %s\n",novshet,novmfo,novshbn);
//      OSTANOV();

//        printw("\nЧитаем из базы код=%s\n",kontr);
//        OSTANOV();
      sprintf(strsql,"select naikon,kod,naiban,mfo,nomsh,adresb from \
Kontragent where kodkon='%s'",kontr);
      if(sql_readkey(&bd,strsql,&row,&cur) != 1)
       {
        SOOB.VVOD_delete();;
        sprintf(strsql,"%s %s !",gettext("Не найден код контрагента"),kontr);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
       }
      else
       {
        if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
         {
          memset(rec.kodor,'\0',sizeof(rec.kodor));
          strcpy(rec.kodor,kontr);

          if(POLE(row[0],rec.naior,1,'(') != 0)    
           strcpy(rec.naior,row[0]);
          strncpy(rec.kod,row[1],sizeof(rec.kod)-1);
          strncpy(rec.naiban,row[2],sizeof(rec.naiban)-1);
          strncpy(rec.mfo,row[3],sizeof(rec.mfo)-1);
          strncpy(rec.nsh,row[4],sizeof(rec.nsh)-1);
          strncpy(rec.gorod,row[5],sizeof(rec.gorod)-1);
         }
        else
         {
          memset(rec.kodor1,'\0',sizeof(rec.kodor1));
          strcpy(rec.kodor1,kontr);

          if(POLE(row[0],rec.naior1,1,'(') != 0)    
           strcpy(rec.naior1,row[0]);
          strncpy(rec.kod1,row[1],sizeof(rec.kod1)-1);
          strncpy(rec.naiban1,row[2],sizeof(rec.naiban1)-1);
          strncpy(rec.mfo1,row[3],sizeof(rec.mfo1)-1);
          strncpy(rec.nsh1,row[4],sizeof(rec.nsh1)-1);
          strncpy(rec.gorod1,row[5],sizeof(rec.gorod1)-1);
         }
       }


     }
    goto naz;

  case SFK6: //Замена на спец счета НДС
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Замена на спец счета НДС"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Замена на спец счет НДС счет плательщика"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));


    kom=0;
    while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

    switch (kom)
     {
      case -1 :
	break;

      case 0 :
        if(rec.rsnds[0] == '\0')
         {        
          sprintf(strsql,"select rsnds from Kontragent where kodkon='%s'",rec.kodor);
          if(sql_readkey(&bd,strsql,&row,&cur) == 1)
            strncpy(rec.nsh,row[0],sizeof(rec.nsh1)-1);
         }
        else
         strncpy(rec.nsh,rec.rsnds,sizeof(rec.nsh1)-1);
         
        if(rec.rsnds1[0] == '\0')
         {        
          sprintf(strsql,"select rsnds from Kontragent where kodkon='%s'",rec.kodor1);
          if(sql_readkey(&bd,strsql,&row,&cur) == 1)
            strncpy(rec.nsh1,row[0],sizeof(rec.nsh1)-1);
         }
        else
         strncpy(rec.nsh1,rec.rsnds1,sizeof(rec.nsh1)-1);

	break;

      case 1 :
        if(rec.rsnds[0] == '\0')
         {        
          sprintf(strsql,"select rsnds from Kontragent where kodkon='%s'",rec.kodor);
          if(sql_readkey(&bd,strsql,&row,&cur) == 1)
            strncpy(rec.nsh,row[0],sizeof(rec.nsh1)-1);
         }
        else
         strncpy(rec.nsh,rec.rsnds,sizeof(rec.nsh1)-1);

	break;
     }
    goto naz;

  case SFK7:
    if(SRAV(tabl,"Tpltp",0) == 0 || SRAV(tabl,"Tpltt",0) == 0)
     {
      SOOB.VVOD_delete();;
      SOOB.VVOD_SPISOK_add_MD(gettext("Для типовых документов не бывает подтверждающих записей !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }

    dirpzpd(tabl);

    provpd(tabl);

    goto naz;

  case FK8:
    clear();
    move(10,0);
    sprintf(rec.nomdk,"%d",nomdok(gt,tabl));
//    strcpy(dt0,rec.nomdk);
//    strcpy(dt0z,dt0);
    memset(mescc,'\0',sizeof(mescc));
    mesc(mt,1,mescc);
    sprintf(dt2,"%d %s %d%s",dt,mescc,gt,gettext("г."));
    rec.dd=dt;
    rec.md=mt;
    rec.gd=gt;
    
    rec.ddi=0;
    rec.mdi=0;
    rec.gdi=0;
    memset(rec.nomdk_i,'\0',sizeof(rec.nomdk_i));
    
    SOOB.VVOD_delete();;
    sprintf(strsql,gettext("Делаем новый документ ! N %s Дата %s"),rec.nomdk,dt2);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;

  case FK9: /*Установить метку передачи платёжки в банк-клиент*/

    if(SRAV(tabl,"Tpltp",0) == 0)
     {
      SOOB.VVOD_delete();;
      SOOB.VVOD_SPISOK_add_MD(gettext("Типовые платежки не передаются !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }
    if(SRAV(tabl,"Tpltt",0) == 0)
     {
      SOOB.VVOD_delete();;
      SOOB.VVOD_SPISOK_add_MD(gettext("Типовые требования не передаются !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }
    
    if(rec.nomdk_i[0] == '\0')
     {
      SOOB.VVOD_delete();;
      SOOB.VVOD_SPISOK_add_MD(gettext("Документ не записан в журнал !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }
    sprintf(strsql,"update %s set vidpl='1' where datd='%04d-%02d-%02d' and nomd='%s'",
    tabl,rec.gd,rec.md,rec.dd,rec.nomdk);
    sql_zapis(strsql,1,0);
    iceb_t_soob(gettext("Документ отмечен для передачи в банк"));
//    klient(rec.nomdk,rec.dd,rec.md,rec.gd,tabl);
    goto naz;
    
  case FK5:
    MENU.VVOD_delete();
    memset(strsql,'\0',sizeof(strsql));
    if(getenv("PRINTER") != NULL)
     sprintf(strsql,"%s:%-20.20s",gettext("Принтер"),getenv("PRINTER"));
    else
     sprintf(strsql,"%s:%-20.20s",gettext("Принтер"),gettext("По умолчанию"));

    MENU.VVOD_SPISOK_add_ZAG(strsql);

    MENU.VVOD_SPISOK_add_MD(gettext("Распечатка на системном принтере"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Распечатка на приэкранном принтере"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Запись в журнал регистрации"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Сделать файл распечатки"));//3
    MENU.VVOD_SPISOK_add_MD(gettext("Записать на DOS дискету"));//4
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр перед печатью"));//5
    MENU.VVOD_SPISOK_add_MD(gettext("Сменить принтер"));//6
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//7

fff5:;
    kom=0;
   while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

    if(kom == -1 || kom == 7)
     goto naz;

    GDITE();

   if(kom == 6) //Смена принтера
    {
     mprintcap();
     goto fff5;
    }
  
    /*Проверяем номер платежного поручения*/
    if(SRAV(rec.nomdk,rec.nomdk_i,0) != 0)
     {

proverka:;

      sprintf(strsql,"select nomd from %s where datd >= '%04d-01-01' and \
datd <= '%04d-12-31' and nomd='%s'",tabl,rec.gd,rec.gd,rec.nomdk);   

      if(sql_readkey(&bd,strsql,&row,&cur) >= 1)
       {
        helstr(LINES-1,0,
        "F4",gettext("номер докум."),
        "F10",gettext("выход"),NULL);
        VVOD VVOD1(2);
        sprintf(strsql,gettext("С номером %s документ уже есть !"),rec.nomdk);
        VVOD1.VVOD_SPISOK_add_ZAG(strsql);
        VVOD1.VVOD_SPISOK_add_MD(gettext("Введите новый номер документа"));

vvodnomer:;
        class iceb_tu_str vvstr(rec.nomdk);

        if((kom1=vvod1(&vvstr,16,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
          goto naz;
        strncpy(rec.nomdk,vvstr.ravno(),sizeof(rec.nomdk)-1);       
        if(kom1 == FK4)
         {
          sprintf(rec.nomdk,"%d",nomdok(gt,tabl));
          goto vvodnomer;
         }

        goto proverka;          

       }
     }

  //  sprintf(strsql,"%s",iceb_t_imafnsi("blokdok.alx"));
    if(iceb_t_pbpds(rec.md,rec.gd) == 0)
     {
      //Удаляем предыдущий документ 
      if(rec.nomdk_i[0] != '\0')
       udpld(tabl,rec.ddi,rec.mdi,rec.gdi,rec.nomdk_i,1,rec.kodop_i,0,rec.tipz);
      
      zappdok(tabl);
      dp=mp=gp=0;
      
      if(kom == 2)
        goto naz;
     }      

    
    i=(short)ATOFM(rec.nomdk);
    sprintf(imaf,"pp%d.lst",i);
    
    if((ff = fopen(imaf,"w")) == NULL)
     {
      error_op_nfil(imaf,errno,"");
      return;
     }
    startfil(ff);
    for(kolp=0; kolp <kp ; kolp++)
     {
      if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
       if(platp(imafkomtmp,kp,kolp,ff,0) != 0)
        {
         fclose(ff);
         goto naz;
        }
      if(SRAV(tabl,"Pltt",0) == 0 || SRAV(tabl,"Tpltt",0) == 0)
       if(platp(imafkomtmp,kp,kolp,ff,1) != 0)
        {
         fclose(ff);
         goto naz;
        }
     }
   fclose(ff);
   
   if(kom == 3)
    {
     sprintf(strsql,"%s %s",gettext("Распечатка выгружена в файл"),imaf);
     iceb_t_soob(strsql);
     goto naz;
    }

   if(kom == 4)
    {
     clearstr(LINES-1,0); //очистить строку ждите !!!
     if(mydoscopy(imaf) != 0)
      goto naz;
     
     SOOB.VVOD_delete();;
     sprintf(strsql,"%s %s",gettext("Распечатка выгружена в файл"),imaf);
     SOOB.VVOD_SPISOK_add_MD(strsql);
     sprintf(strsql,gettext("Файл записан на дискету"));
     SOOB.VVOD_SPISOK_add_MD(strsql);
     soobshw(&SOOB,stdscr,-1,-1,0,1);
     goto naz;
    }
   if(kom == 5) //Просмотр перед печатью
    {
     pros_fil(imaf,"");
     goto naz;
    }
   memset(bros,'\0',sizeof(bros));
   if(kom == 0)
     sprintf(bros,"%s",printer.ravno());
   if(kom == 1)
     sprintf(bros,"%s",printerloc.ravno());

   pehf(imaf,1,bros);
   clear();
   goto naz;


  default:
    goto naz;
    break;
 }

}

/*************************************************************/
/*Работа с файлом платежек для передачи в систему Клиент-банк*/
/*************************************************************/
void	klient(const char *nomdok,short dd,short md,short gd,const char *tabl)
{
char	stt[2048];
FILE	*ff,*ff1;
char	imaf1[32];
char	imaf[32];
char	bros[512];
short	d,m,g;
char	nomdok1[24];
int	mt=0;
char	strsql[512];
class iceb_tu_str koment("");
/*
printw("\nklient-%s %d.%d.%d\n",nomdok,dd,md,gd);
refresh();
*/

/*
Читаем комментарий, внутри подпрограммы проверка на длинну комментария и 
выдача предупреждающего сообщения
*/
readkom(tabl,rec.dd,rec.md,rec.gd,rec.nomdk,&koment);

/*Проверяем нет ли платежки с таким номером*/

sprintf(imaf,"platp.txt");
if((ff = fopen(imaf,"r")) == NULL)
 {
 if(errno == ENOENT)
   goto vp;
  else
   {
    error_op_nfil(imaf,errno,"");
    return;
   }
 }
sprintf(imaf1,"ttt%d.tmp",getpid());
if((ff1 = fopen(imaf1,"w")) == NULL)
   {
    error_op_nfil(imaf1,errno,"");
    return;
   }

mt=0;
while(fgets(stt,sizeof(stt),ff) != NULL)
 {
  polen(stt,bros,sizeof(bros),1,'|');
  polen(stt,nomdok1,sizeof(bros),2,'|');
  rsdat(&d,&m,&g,bros,1);      
  if(sravmydat(d,m,g,dd,md,gd) == 0 && SRAV(nomdok,nomdok1,0) == 0)
   {
    VVOD SOOB(1);;
    sprintf(strsql,gettext("Документ %s уже есть !"),rec.nomdk);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    sprintf(strsql,gettext("Удаляем старую запись"));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    mt=1;
    continue;
   }   
  fprintf(ff1,"%s",stt);
 }

fclose(ff);
fclose(ff1);

if(mt == 1)
 {
  unlink(imaf);
  if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }

  if((ff1 = fopen(imaf1,"r")) == NULL)
   {
    error_op_nfil(imaf1,errno,"");
    return;
   }
  while(fgets(stt,sizeof(stt),ff1) != NULL)
    fprintf(ff,"%s",stt);

  fclose(ff);
  fclose(ff1);
 }

unlink(imaf1);

vp:;
/*
printw(gettext("Запись документа N%s в файл для передачи.\n"),rec.nomdk);
refresh();
*/

if((ff = fopen(imaf,"a")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }

fprintf(ff,"%02d.%02d.%d|%s\n",dd,md,gd,nomdok);

fclose(ff);

VVOD SOOB(1);;
sprintf(strsql,gettext("Документ выгружен в файл %s !"),imaf);
SOOB.VVOD_SPISOK_add_MD(strsql);
soobshw(&SOOB,stdscr,-1,-1,0,1);

}
