/* $Id: poifl.c,v 5.18 2011-01-13 13:43:22 sasa1 Exp $ */
/*29.11.2010    06.07.1995      Белых А.И.      poifl.c
Поиск в файле заданного табельного номера
*/
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

int poifil(int tbn,const char *imaf,const char *zagl,FILE *ff);

void            poifl(long tbn)
{
char		imafo[32];
FILE		*ff;

GDITE();
sprintf(imafo,"znast%d.lst",getpid());
if((ff = fopen(imafo,"w")) == NULL)
 {
  error_op_nfil(imafo,errno,"");
  return;
 }
startfil(ff);
fprintf(ff,"%s %ld\n\
----------------------------------------------------\n",
gettext("Просмотр настройки по табельному номеру"),tbn);

poifil(tbn,"zardolhn.alx",gettext("Имеет оклад"),ff);

poifil(tbn,"zaralim.alx",gettext("Имеет алименты"),ff);

poifil(tbn,"zarkredit.alx",gettext("Имеет кредит"),ff);

poifil(tbn,"zarinv.alx",gettext("Записан у файл инвалидов"),ff);

poifil(tbn,"zardog.alx",gettext("Записан у файл работающих по договору"),ff);

poifil(tbn,"zarproc.alx",gettext("Записан у файл автоматизированного расчета начислений"),ff);

poifil(tbn,"zarpens.alx",gettext("Записан у файл пенсионеров"),ff);

poifil(tbn,"zarlgot.alx",gettext("Записан у файл льгот для подоходного налога"),ff);

poifil(tbn,"zarsppo.alx",gettext("Записан у файл персональных процентов отчисления в пенсионный фонд"),ff);

fclose(ff);

prosf(imafo);
unlink(imafo);
}

/****************************************/
/*Поиск в файле заданного табельного номера*/
/****************************************/
int poifil(int tbn,const char *imaf,const char *zagl,FILE *ff)
{
short           voz=0;
char		strsql[512];
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;


sprintf(strsql,"select str from Alx where fil='%s' order by ns asc",imaf);
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(0);
 }

if(kolstr == 0)
 {
  return(0);
 }


while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;

  if( tbn == atoi(row_alx[0]))
   {
    voz++;
    if(voz == 1)
     fprintf(ff,"%s\n",zagl);
    fprintf(ff,"%s",row_alx[0]);     
   }
 }
return(voz);
}
