/* $Id: praisl.c,v 5.33 2011-01-13 13:43:22 sasa1 Exp $ */
/*12.12.2010    06.08.1998      Белых А.И.      praisl.c
Программа печати прайс листа
*/
#define	   KOLST  80 /*Количество строк на листе*/
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void            kols2(char[],char[]);
void            sstr(short*,short*,short,char[],FILE*);
void            sprais(short,FILE*);

extern double   ostg[4],ostm[4];
char		nvc[20][20]; /*Наименование видов цен*/
extern double	kursue;/*Курс условной единицы*/

void            praisl()
{
char		bros[512];
extern char     *organ;
struct  tm      *bf;
time_t          tmm;
int		km;
int		kom=0,kom1=0;
char		imaf[32],imaf1[32];
short		kc; /*Количество цен*/
double		cena;
FILE		*ff;
int		i;
int		kodm,kgrm,kgrmz;
char		sut[512];
double		ost;
short		msh; /*0-нет товара с нужным счетом >0 есть*/
short		kst; /*Количество строк*/
short		kli; /*Количество листов*/
char		podsh[512];
short		mec;
long		kolstr,kolstr1,kolstr2;
SQL_str         row,row1;
char		strsql[512];
int		skl,sklz;
char		naimgr[512];
char		skladi[56],grup[56];
short		kvc[32];
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);

VVOD MENU(3);

MENU.VVOD_SPISOK_add_ZAG(gettext("Формирование прайс листа"));
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать только товары которые имеются в наличии"));
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать весь список товаров"));
MENU.VVOD_SPISOK_add_MD(gettext("Работа с файлом настройки"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));


naz:;
clear();

while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

switch (kom)
 {
  case 3 :
  case -1 :
   return;
   break;

  case 2 :
    iceb_redfil("prais.alx",0);
    goto naz;
 }

MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_MD(gettext("Распечатка с ценами в гривнях"));
MENU.VVOD_SPISOK_add_MD(gettext("Распечатка с ценами в У.Е."));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

if(kom1 == 2 || kom1 == -1)
  return;

memset(skladi,'\0',sizeof(skladi));
memset(grup,'\0',sizeof(grup));

VVOD VV(0);
VV.VVOD_SPISOK_add_MD(gettext("Группа..(,,)."));
if(kom == 0)
   VV.VVOD_SPISOK_add_MD(gettext("Склад..(,,).."));
VV.VVOD_SPISOK_add_data(sizeof(grup));
VV.VVOD_SPISOK_add_data(sizeof(skladi));
naz1:;


helstr(LINES-1,0,"F2/+",gettext("расчет"),
"F10",gettext("выход"),NULL);

i=VV.vvod(0,1,1,-1,-1);

switch(i)
 {
  case FK2:
  case PLU:
   break;
  case FK10:
  case ESC:
    return;
  default:
   goto naz1;
 }

strncpy(skladi,VV.VVOD_SPISOK_return_data(1),sizeof(skladi)-1);
strncpy(grup,VV.VVOD_SPISOK_return_data(0),sizeof(grup)-1);


GDITE();
clear();

sprintf(imaf1,"prais%d.tmp",getpid());

SQL_str row_alx;
class SQLCURSOR cur_alx;

sprintf(strsql,"select str from Alx where fil='prais.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"prais.alx");
  iceb_t_soob(strsql);
  return;
 }

memset(nvc,'\0',sizeof(nvc));
memset(&kvc,'\0',sizeof(kvc));

kc=0;
memset(sut,'\0',sizeof(sut));
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  printw("%s",row_alx[0]);
  
  if(POLE(row_alx[0],bros,1,'|') != 0)
    continue;
  if(SRAV("Счета учета товаров",bros,0) == 0)
   {
    POLE(row_alx[0],sut,2,'|');
    continue;
   }   

  kvc[kc]=(short)ATOFM(bros);

  POLE(row_alx[0],nvc[kc],2,'|');
  kc++;
  if(kc == 20)
   break;
 }

printw("\n");

if(kc == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено в файле ни одной цены !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
if(sut[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены счета учета товаров !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
time(&tmm);
bf=localtime(&tmm);
printw(gettext("Готовим распечатку прайс листа.\n"));

GDITE();

sprintf(strsql,"select * from Material order by kodgr asc");
SQLCURSOR cur;
if((kolstr2=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }



if(kolstr2 == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }
printw(gettext("Печатаем.\n"));
refresh();

sprintf(imaf,"prais%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

fprintf(ff,"%s\n\n%s\n",gettext("ПРАЙС ЛИСТ"),organ);

kst=7;
if(kom == 0)
 {
  kst++;
  fprintf(ff,gettext("Товары есть на складе\n")); 
 }
if(kom1 == 1)
 {
  kst++;
  fprintf(ff,gettext("Цены указаны в У.Е. Курс %.6g\n"),kursue); 
 }
if(skladi[0] != '\0')
 {
  kst++;
  fprintf(ff,gettext("Склады %s\n"),skladi); 
 }
if(grup[0] != '\0')
 {
  kst++;
  fprintf(ff,gettext("Группа: %s\n"),grup); 
 }

fprintf(ff,"\
%s %d.%d.%d%s %s: %d:%d\n",
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

sprais(kc,ff);

/*полка над наименованием*/
memset(podsh,'\0',sizeof(podsh));
sprintf(podsh,"-------------------------------------");
/*полка над ценой*/
for(i=0; i< kc; i++)
  strcat(podsh,"---------");

kli=1;
kolstr1=kgrm=kgrmz=km=0;
while(cur.read_cursor(&row) != 0)
 {
  
/*
  printw("%s %s %s\n",row[0],row[1],row[2]);
  refresh();
*/  

 kolstr1++;
 strzag(LINES-1,0,kolstr2,kolstr1);

 if(atof(row[6]) < 0.01) //Товары с нулевой ценой в прайс не попадут
  continue;

  printw("%s %s %s\n",row[0],row[1],row[2]);
  refresh();
  

 if(proverka(grup,row[1],0,0) != 0)
   continue;

  /*Смотрим на каких счетах учета товар и если нужно проверяем
  остаток*/
  sprintf(strsql,"select sklad,nomk,shetu from Kart where kodm=%s \
order by sklad asc",row[0]);
  SQLCURSOR cur1;
  if((kolstr=cur1.make_cursor(&bd,strsql)) < 0)
   {
    printw("%s\n",sql_error(&bd));
    OSTANOV();
   }

  ost=0.; 
  sklz=msh=0;
  if(kolstr != 0)
   while(cur1.read_cursor(&row1) != 0)
    {
     if(proverka(sut,row1[2],1,0) != 0)
        continue;
     if(proverka(skladi,row1[0],0,0) != 0)
        continue;

     skl=atoi(row1[0]);
     if(kom == 0 && sklz != skl)
      {
       ost+=ostdok1(dt,mt,gt,skl,atoi(row[0]));

       sklz=skl;
      }
     msh++;
    } 

  
  if(msh == 0)
    continue;
  if(kom == 0 && ost < 0.00001)
    continue;
    
  km++;

  kgrm=atoi(row[1]);
  kodm=atoi(row[0]);
  if(kgrmz != kgrm)
   {
    /*Читаем код группы материалла*/
    sprintf(strsql,"select naik from Grup where kod=%s",
    row[1]);
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
        beep();
        printw("Не нашли наименование группы материалов по коду %d",kgrm);
        OSTANOV();
        continue;
     }
    strncpy(naimgr,row1[0],sizeof(naimgr)-1);
    if(kgrmz != 0)
     {
      sstr(&kst,&kli,kc,podsh,ff);
      fprintf(ff,"%s\n",podsh);
     }

    sstr(&kst,&kli,kc,podsh,ff);
    fprintf(ff,"       <<< %s >>>\n",naimgr);
    kgrmz=kgrm;
   }
  
  if(atof(row[7]) != 0.)
    fprintf(ff,"|%-*.*s|%4.4g|",iceb_tu_kolbait(30,row[2]),iceb_tu_kolbait(30,row[2]),row[2],atof(row[7]));
  else
    fprintf(ff,"|%-30.30s|    |",
    row[2]);

  /*Печатаем цены*/
  for(i=0; i< kc ; i++)
   {
    mec=0;
    cena=0.;
    if(kvc[i] == 0)
      cena=atof(row[6]);
    if(kom1 == 1 && kursue != 0.)
     {
      cena=cena/kursue;
      cena=okrug(cena,0.01);
     } 

    if(cena == 0.)
     fprintf(ff,"%8s|"," ");    
    else
     {
      if(mec == 0)
        fprintf(ff,"%8.2f|",cena);    
      if(mec == 1)
        fprintf(ff,"%7.2f%%|",cena);    

     }
   } 

  fprintf(ff,"\n"); 
  sstr(&kst,&kli,kc,podsh,ff);

 }


fprintf(ff,"%s\n",podsh);

fclose(ff);

kols2(imaf,imaf1);
unlink(imaf1);
printw_vr(tmm);

printw(gettext("Количество материалов %d\n"),km);
printw(gettext("Количество листов %d\n"),kli/2);
OSTANOV();

class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Распечатка прайс листа"));

iceb_t_ustpeh(oth.spis_imaf.ravno(0),1);

iceb_t_rabfil(&oth,"");

}

/**********/
/*Шапка*/
/**********/
void            sprais(short kc,
FILE *ff)
{
short		i;


/*Верхняя полка над наименованием*/
fprintf(ff,"\
-------------------------------------");
/*полка под ценой*/
for(i=0; i< kc; i++)
  fprintf(ff,"---------");
fprintf(ff,"\n");

fprintf(ff,gettext("|    Н а и м е н о в а н и е   |Крат|"));

for(i=0; i< kc; i++)
  fprintf(ff,"%-*.*s|",iceb_tu_kolbait(8,nvc[i]),iceb_tu_kolbait(8,nvc[i]),nvc[i]);
fprintf(ff,"\n");

/*Нижняя полка над наименованием*/
fprintf(ff,"\
-------------------------------------");
/*полка под ценой*/
for(i=0; i< kc; i++)
  fprintf(ff,"---------");
fprintf(ff,"\n");

}

/************************/
/*Счетчик строк и листов*/
/************************/
void            sstr(short *kst, //Количество строк
short *kli, //Количество листов
short kc, 
char podsh[],FILE *ff)
{
*kst=*kst+1;
if(*kst >= KOLST)
 {
  fprintf(ff,"%s\n",podsh);
  fprintf(ff,"\f");
  sprais(kc,ff);
  *kli=*kli+1;
  *kst=3;
 }  
}

/*************************************/
/*Преобразование файла в две колонки*/
/*************************************/
void		kols2(char imaf[],char imaf1[])
{
char		nmo[40],gor[30],nsh[20],grb[40],mfo[20],pkod[20],tel[40];
short		i;
FILE		*ff,*ff1;
char		mas1[KOLST+5][80];
char		mas2[KOLST+5][80];
short		shet;
short		kls,kr;
char		str1[300];
char		str[300];
SQL_str         row;
SQLCURSOR       cur;
char		bros[512];

iceb_t_cp(imaf,imaf1,0);
/*Читаем реквизиты организации свои */
memset(nmo,'\0',sizeof(nmo));
memset(gor,'\0',sizeof(gor));
memset(pkod,'\0',sizeof(pkod));
memset(mfo,'\0',sizeof(mfo));
memset(nsh,'\0',sizeof(nsh));
memset(grb,'\0',sizeof(grb));
memset(tel,'\0',sizeof(tel));

sprintf(bros,"select * from Kontragent where kodkon='00'");
if(sql_readkey(&bd,bros,&row,&cur) != 1)
 {
  error2(20,0,1,"Не найдены свои реквизиты !");
 }
else
 {
  strncpy(nmo,row[1],sizeof(nmo)-1);
  strncpy(gor,row[3],sizeof(gor)-1);
  strncpy(pkod,row[5],sizeof(pkod)-1);
  strncpy(mfo,row[6],sizeof(mfo)-1);
  strncpy(nsh,row[7],sizeof(nsh)-1);
  strncpy(grb,row[4],sizeof(grb)-1);
  strncpy(tel,row[10],sizeof(tel)-1);
 } 

if((ff1 = fopen(imaf1,"r")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return;
 }

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

fprintf(ff,"\x1B\x33%c",28); /*Уменьшаем межстрочный интервал*/
memset(mas1,'\0',sizeof(mas1));
memset(mas2,'\0',sizeof(mas2));
kr=kls=shet=0;
while(FGETSS(str,sizeof(str),ff1) != 0)
 {
  if(str[0] == '\f')
   {
    POLE(str,str1,2,'\f');
    strcpy(str,str1);

    if(shet == 0)
      shet++;
    else
     {
      for(i=0; i < kr; i++)
       {
 /*       printw("%s\n",mas1[i]);*/
         fprintf(ff,"%-70s %s\n",mas1[i],mas2[i]);
       }
 
fprintf(ff,gettext("%s %s. Р/с %s в %s МФО %s Код ОКПО %s Тел. %s\n"),
nmo,gor,nsh,grb,mfo,pkod,tel);

      fprintf(ff,"\f");
      memset(mas1,'\0',sizeof(mas1));
      memset(mas2,'\0',sizeof(mas2));
      kr=shet=0;
     }
    kls=0;
   }   

  if(shet == 0)
   {
    strncpy(mas1[kls],str,sizeof(mas1[0]));
    kr++;
    if(kr >= KOLST+5)
     {
      beep();
      printw("Криминал !!!\n");      
      OSTANOV();
      break;
     }
    kls++;
   }

  if(shet == 1)
   {
    strncpy(mas2[kls],str,sizeof(mas2[0]));
    kls++;
   }
 }

for(i=0; i < kr; i++)
   fprintf(ff,"%-70s %s\n",mas1[i],mas2[i]);

fprintf(ff,gettext("%s %s. Р/с %s в %s МФО %s Код ОКПО %s Тел. %s\n"),
nmo,gor,nsh,grb,mfo,pkod,tel);


fclose(ff);
fclose(ff1);

}
