/*$Id: ras_soc.c,v 5.13 2011-04-14 16:07:34 sasa Exp $*/
/*10.02.2010	17.02.2005	Белых А.И.	ras_soc.c
Расчёт соц-стаха для работника
*/
#include        "buhg.h"

extern short	metkarnb; //0-Расчет налогов для бюджета пропорциональный 1-последовательный
extern short	*kodsocstrnv; //Коды не входящие в расчет соцстраха
extern short    kodsocstr;
extern char	*shetb; /*Бюджетные счета*/
extern char	*shetsoc; //Счета фонда соц-страха
extern double   okrg; /*Округление*/


void ras_soc(long tn, //Табельный номер*/
short mp,short gp,
int podr,
double *sumaos, //Сумма отчисления на соц-страх только с зарплаты
double *sumaosb, //Сумма отчисления на соц-страх бюджет только с зарплаты
int metka_zap, //0-делать запись 1-нет
int metka_ras, //0-смотреть начисления в массиве 1-в базе
double suma_boln, 
double *i_soc, //Соц-отчисления со всей суммы
double *i_socb,//Соц-отчисление со всей суммы бюджета
const char *uder_only,
FILE *ff_prot)
{
char strsql[512];
SQL_str row;
SQLCURSOR curr;
char shet[32];
double suma_boln_rm=0.;
struct ZARP     zp;
short		d;

dpm(&d,&mp,&gp,5);

zp.dz=d;
zp.mesn=mp; zp.godn=gp;
zp.nomz=0;
zp.podr=podr;
*i_soc=*i_socb=*sumaos=*sumaosb=0.;

/*Проверяем есть ли код удержания отчисления в соцстах*/
sprintf(strsql,"select shet from Zarn1 where tabn=%ld and prn='2' and \
knah=%d",tn,kodsocstr);
if(sql_readkey(&bd,strsql,&row,&curr) <= 0)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"\nНе введен код отчисления в соц-страх %d !\n",kodsocstr);
  return;
 }
if(proverka(uder_only,kodsocstr,0,0) != 0)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Код %d исключён из расчёта\n",kodsocstr);
  return; 
 }
strncpy(shet,row[0],sizeof(shet)-1);
double sumanb=0.;
double sumabu=0.;
double suma_ndfnz=0.;
double suma_ndfnz_b=0.;
double suma_zarp_o=0.;
double suma_zarp_b=0.;

if(ff_prot != NULL)
 fprintf(ff_prot,"\n%s-Расчет отчисления на соц-страх.\n\
---------------------------------------------------\n",__FUNCTION__);
double soc_suma=0.;
if(metka_ras == 0)
  soc_suma=findnahm(mp,5,kodsocstrnv,ff_prot,&sumanb,&sumabu,&suma_ndfnz,&suma_ndfnz_b,&suma_zarp_o,&suma_zarp_b,&suma_boln_rm);
else
 {
  soc_suma=findnahm(mp,gp,tn,5,kodsocstrnv,ff_prot,&sumanb,&sumabu,&suma_ndfnz,&suma_ndfnz_b,&suma_zarp_o,&suma_zarp_b,&suma_boln_rm);
  //если есть сyмма больничного значит делаем перерасчёт подоходного для больничных на которые 
  //распространяется социальная льгота 
  if(suma_boln != 0.)
   if(ff_prot != NULL)
    fprintf(ff_prot,"Увеличиваем на сумму больничного\n");
  soc_suma+=suma_boln;
  sumanb+=suma_boln;
  suma_zarp_o+=suma_boln;
 }
 
if(ff_prot != NULL)
fprintf(ff_prot,"findnahm - nah=%f Хозрасчет=:%.2f Бюджет=%.2f\n",
  soc_suma,sumanb,sumabu);

//rudnfv(&soc_suma,suma_ndfnz,ff_prot);

double soc_suma_b=sumabu;

if(ff_prot != NULL)
 fprintf(ff_prot,"С общей суммы\n");

class zar_read_tn1h nastr;
zar_read_tn1(1,mp,gp,&nastr,ff_prot);
 
*i_soc=zar_rsoc(soc_suma,nastr.prog_min_tek,ff_prot);
if(ff_prot != NULL)
 fprintf(ff_prot,"Только с зарплаты\n");
*sumaos=zar_rsoc(suma_zarp_o,nastr.prog_min_tek,ff_prot);

if(ff_prot != NULL)
  fprintf(ff_prot,"Налог=%.2f\n",*i_soc);

//  printw("*i_soc=%f\n",*i_soc);
char bros[512];
memset(bros,'\0',sizeof(bros));
if(shetb == NULL || shetsoc == NULL)
 {
  
  if(ff_prot != NULL)
    fprintf(ff_prot,"*i_soc=%f kodsocsrt=%d\n",*i_soc,kodsocstr);
  
  strcpy(zp.shet,shet);
  if(metka_zap == 0)
    zapzarp(d,mp,gp,tn,2,kodsocstr,*i_soc,shet,mp,gp,0,0,bros,podr,"",zp);
 }
else
 {
  double bb2=0.;
  if(metkarnb == 1) //Последовательный метод расчетa налогов
   {
    if(ff_prot != NULL)
     fprintf(ff_prot,"Расчёт для бюджетных начислений.\n");
//    rudnfv(&soc_suma_b,suma_ndfnz_b,ff_prot);
    if(ff_prot != NULL)
      fprintf(ff_prot,"С общей суммы.\n");

    bb2=zar_rsoc(soc_suma_b,nastr.prog_min_tek,ff_prot);
    if(ff_prot != NULL)
     fprintf(ff_prot,"Только с зарплаты.\n");
    *sumaosb=zar_rsoc(suma_zarp_b,nastr.prog_min_tek,ff_prot);
   } 

  if(metkarnb == 0) //Пропорциональный метод расчет налогов
   {
    if(ff_prot != NULL)
     {
      fprintf(ff_prot,"Расчёт для бюджетных начислений.\n");
      fprintf(ff_prot,"Разбивка суммы:%.2f не бюджет=%.2f бюджет:%.2f \
Налог:%.2f Счета:%s\n",
      soc_suma,sumanb,sumabu,*i_soc,shetsoc);
     }
    if(sumabu != 0.)
     {
      bb2=0.;
      //Если хозрасчет не равен нолю то долю определять надо
      if(sumanb != 0.)
       {
        if(soc_suma != 0.)
         bb2=*i_soc*sumabu/soc_suma;
       }
      else
       bb2=*i_soc;
     }
    bb2=okrug(bb2,okrg);

    if(suma_zarp_b != 0.)
       *sumaosb=*sumaos*suma_zarp_b/suma_zarp_o;
    else 
       *sumaosb=0.;  
    *sumaosb=okrug(*sumaosb,okrg);
   }
  
  if(ff_prot != NULL)
    fprintf(ff_prot,"Налог бюджет=%.2f\n",bb2);
  *i_socb=bb2;
    
  polen(shetsoc,shet,sizeof(shet),2,',');
  if(shet[0] != '\0')
   {
    strcpy(bros,gettext("Бюджет"));
    strcpy(zp.shet,shet);
    if(metka_zap == 0)
      zapzarp(d,mp,gp,tn,2,kodsocstr,bb2,shet,mp,gp,0,0,bros,podr,"",zp);
   }

  polen(shetsoc,shet,sizeof(shet),1,',');
  bb2=*i_soc-bb2;
  bb2=okrug(bb2,okrg);
  if(ff_prot != NULL)
    fprintf(ff_prot,"Налог хозрасчет=%.2f\n",bb2);
  if(shet[0] != '\0')
   {
    strcpy(bros,gettext("Хозрасчёт"));
    strcpy(zp.shet,shet);
    if(metka_zap == 0)
      zapzarp(d,mp,gp,tn,2,kodsocstr,bb2,shet,mp,gp,0,0,bros,podr,"",zp);
   }
 }
 


}

