/*$Id: rasactmu.c,v 5.13 2011-01-13 13:43:22 sasa1 Exp $*/
/*11.01.2010	19.07.2003	Белых А.И.	rasactmu.c
Распечатка акта приема передачи материалов
*/
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern double	okrg1;

void rasactmu(short dd,short md,short gd, //дата документа
int skl,  //Склад
const char *nomdok) //Номер документа
{
char		strsql[512];
SQL_str		row,row1;
int 		kolstr=0;
char		imaf[32],imaftmp[32];
FILE		*ff,*fftmp;
char		shetu[32];
char            shetz[32];
char		naim[512];
char		stroka[1024];
int		kolstrok=0;
int		kollist=0;
char		datv[11];
char		innom[32];
char		regnom[32];

//printw("\nrasactmu %d.%d.%d %d %s\n",dd,md,gd,skl,nomdok);
//OSTANOV();
GDITE();

sprintf(strsql,"select sklad,nomkar,kodm,kolih,cena,ei from Dokummat1 where datd='%04d-%02d-%02d' and \
sklad=%d and nomd='%s'",gd,md,dd,skl,nomdok);
SQLCURSOR cur;
SQLCURSOR cur1;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 { 
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,1,1);
  return;
 } 

sprintf(imaftmp,"actm%d.tmp",getpid());

if((fftmp = fopen(imaftmp,"w")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return;
 }

while(cur.read_cursor(&row) != 0)
 {
  //Узнаем счет учета материалла
  sprintf(strsql,"select shetu,datv,innom,rnd from Kart where sklad=%s and nomk=%s",row[0],row[1]);
  memset(shetu,'\0',sizeof(shetu));
  memset(regnom,'\0',sizeof(regnom));
  memset(innom,'\0',sizeof(innom));
  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
   {
    strncpy(shetu,row1[0],sizeof(shetu)-1);
    strcpy(datv,row[1]);
    strcpy(innom,row1[2]);
    strncpy(regnom,row1[3],sizeof(row1[3])-1);
   }
  //Узнаем наименование материалла
  memset(naim,'\0',sizeof(naim));
  sprintf(strsql,"select naimat from Material where kodm=%s",row[2]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
   strncpy(naim,row1[0],sizeof(naim)-1);

  fprintf(fftmp,"%s|%s|%s|%s|%s|%s|%s|%s|\n",
  shetu,naim,row[3],row[4],row[5],datv,innom,regnom);

 }

fclose(fftmp);

//sprintf(strsql,"sort -o %s -t\\|  +0 -1 +1 -2  %s",imaftmp,imaftmp);
sprintf(strsql,"sort -o %s -t\\|  -k1,2 -k2,3  %s",imaftmp,imaftmp);

runsystem1(strsql,1);


sprintf(imaf,"actm%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

hrasact(&kolstrok,&kollist,ff);

if((fftmp = fopen(imaftmp,"r")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return;
 }

double kolih=0.;
double cena=0.;
char ei[32];
int  nomerstr=0;
double summa=0;
double kolihi=0.;
double sumai=0.;
char   naimshet[512];
double kolihshet=0.;
double sumashet=0.;
short dv,mv,gv;
char	dopstr[300];

memset(shetz,'\0',sizeof(shetz));

while(fgets(stroka,sizeof(stroka),fftmp) != NULL)
 {
//  printw("%s",stroka);
//  refresh();
  polen(stroka,shetu,sizeof(shetu),1,'|');
  polen(stroka,naim,sizeof(naim),2,'|');

  polen(stroka,strsql,sizeof(strsql),3,'|');
  kolih=atof(strsql);

  polen(stroka,strsql,sizeof(strsql),4,'|');
  cena=atof(strsql);

  polen(stroka,ei,sizeof(ei),5,'|');

  polen(stroka,datv,sizeof(datv),6,'|');
  rsdat(&dv,&mv,&gv,datv,2);
  
  polen(stroka,innom,sizeof(innom),7,'|');

  polen(stroka,regnom,sizeof(regnom),8,'|');
  
  cena=okrug(cena,okrg1);
  summa=kolih*cena;
  
  if(SRAV(shetz,shetu,0) != 0)
   {

    if(shetz[0] != '\0')
     {
      sapkk1iv(&kolstrok,&kollist,ff);
      sprintf(strsql,"%s %s %s",gettext("Итого по счету"),shetz,naimshet);
      fprintf(ff,"%*.*s %10.10g %10.2f\n",
      iceb_tu_kolbait(62,strsql),iceb_tu_kolbait(62,strsql),strsql,kolihshet,sumashet);
     }

    memset(naimshet,'\0',sizeof(naimshet));
    sprintf(strsql,"select nais from Plansh where ns=%s",shetu);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
     strncpy(naimshet,row1[0],sizeof(naimshet)-1);

    sapkk1iv(&kolstrok,&kollist,ff);
    fprintf(ff,"%20s ******%s %s %s*******\n"," ",gettext("Счет учета"),shetu,naimshet);

    strcpy(shetz,shetu);
    kolihshet=0.;
    sumashet=0.;
   }  
  
  
  sumai+=summa;
  kolihi+=kolih;
  sumashet+=summa;
  kolihshet+=kolih;  
  
  sapkk1iv(&kolstrok,&kollist,ff);
  
  fprintf(ff,"%3d|%-*.*s|%-*s|%10.10g|%10.10g|%10.2f|%10s|%10s|%10s|%10s|\n",
  ++nomerstr,
  iceb_tu_kolbait(40,naim),iceb_tu_kolbait(40,naim),naim,
  iceb_tu_kolbait(6,ei),ei,
  cena,kolih,summa," "," "," "," ");
  memset(dopstr,'\0',sizeof(dopstr));
  if(innom[0] != '\0')
   {
    if( regnom[0] == '\0')
     {
      sprintf(dopstr,"%s:%s",gettext("Инвентарный номер"),innom);
      if(dv != 0)
       {
        memset(strsql,'\0',sizeof(strsql));
        sprintf(strsql," %s:%d.%d.%d%s",
        gettext("Дата ввода в эксплуатацию"),
        dv,mv,gv,gettext("г."));
        strcat(dopstr,strsql);
       }
     }        
    else
     {
      sprintf(dopstr,"%s:%s",gettext("Регистрационный номер"),regnom);
      memset(strsql,'\0',sizeof(strsql));
      sprintf(strsql," %s:%s",gettext("Серия"),innom);
      strcat(dopstr,strsql);
      if(dv != 0)
       {
        memset(strsql,'\0',sizeof(strsql));
        sprintf(strsql," %s:%d.%d.%d%s",
        gettext("Дата регистрации"),
        dv,mv,gv,gettext("г."));
        strcat(dopstr,strsql);
       }
     }
   }
  if(dopstr[0] != '\0')
   {
    sapkk1iv(&kolstrok,&kollist,ff);
    fprintf(ff,"%3s %s\n"," ",dopstr);
   }
  sapkk1iv(&kolstrok,&kollist,ff);
  fprintf(ff,"\
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");
    
 }
krasact(shetz,naimshet,kolihshet,sumashet,kolihi,sumai,ff);
fclose(ff);
fclose(fftmp);

unlink(imaftmp);

class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Акт приема-передачи товароматериальных ценностей"));
iceb_t_ustpeh(oth.spis_imaf.ravno(0),1);
iceb_t_rabfil(&oth,"");

}
