/* $Id: rasamortby.c,v 5.15 2011-01-13 13:43:22 sasa1 Exp $ */
/*01.11.2009    06.12.2000      Белых А.И.      rasamortby.c
Расчет амортизаци по организации для бухгалтерского учета
*/
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


void    rasamortby()
{
time_t          tmm,tmmk;
double          dii,kii;
class iceb_tu_str dr("");
short           m,g;
long		kolstr,kolstr1;
SQL_str         row;
char		strsql[512];
long		in;
int		kom;

clear();
m=g=0;
VVOD VVOD1(2);

VVOD1.VVOD_SPISOK_add_ZAG(gettext("Расчет амортизации по организации для бухгалтерского учета"));
VVOD1.VVOD_SPISOK_add_MD(gettext("Введите дату расчета (м.г)"));

naz:;

helstr(LINES-1,0," F10 ",gettext("выход"),NULL);


if((kom=vvod1(&dr,8,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
  return;
if(kom == ESC)
  return;

if(rsdat1(&m,&g,dr.ravno()) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

//sprintf(strsql,"%s",iceb_t_imafnsi("bluos.alx"));
if(iceb_t_pbpds(m,g) != 0)
  goto naz;

clear();
printw("%s %d.%d%s\n",gettext("Расчет за"),m,g,
gettext("г."));

refresh();

time(&tmm);

sprintf(strsql,"select innom from Uosin order by innom asc");
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  printw("%s\n",sql_error(&bd));
  OSTANOV();
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
  
 }
 
unlink("amort.lst");
kolstr1=0;
short mz,gz;
char shetu[32];
char hzt[32];
char hna[32];
char hau[20];
float popkf,popkfby;
int soso=0;
char nomz[100];
char hnaby[32];

while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  in=atol(row[0]);
  poiinpd(in,m,g,shetu,hzt,hau,hna,&popkf,&soso,nomz,&mz,&gz,hnaby,&popkfby);
  
  amortby(in,m,g,0,hnaby,NULL);
 }


time(&tmmk);
dii=(tmmk-tmm)/60.;
dii=modf(dii,&kii);
printw("\n%s %.f%s %.f%s\n",
gettext("Время расчета"),
kii,
gettext("мин."),
dii*60.,
gettext("сек."));

OSTANOV();
}
