/* $Id: rasf8dr.c,v 5.54 2011-08-29 07:08:59 sasa Exp $ */
/*05.12.2009	13.07.2000	Белых А.И.	rasf8dr.c
Вигрузка в *.dbf или *.lst файл формы 8ДР
*/
#include        <errno.h>
#include        <ctype.h>
#include        <math.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


#define         KSNL 63 /*Количество строк на листе*/
#define		SH1L 34 /*Шапка первого листа*/
#define		SHPL 6 /*Шапка последующих листов*/

extern char     *organ;/*Наименование организации*/
extern int      kol_strok_na_liste;
extern float ppn;


int rasf8dr(const char *nomd,
int metka_oth, //0-звітний 1-новий звітний 2-уточнюючий
class spis_oth *oth)
{
int		kolstr;
SQL_str         row,row1;
char		strsql[512];
char		inn[11];
double		sumad,suman,isumad,isuman;
double		sumadn,sumann,isumadn,isumann;
char		priz[4];
short		lgota=0;
char		lgotach[20];
char		data1[11];
char		data2[11];
char		data11[11];
char		data21[11];
char		data12[11];
char		data22[11];
int		npp1;
char		imaf[32],imafdbf[32],imaffam[32];
FILE		*ff1=NULL,*ff4=NULL,*fffam=NULL;
FILE *ff_xml;
short		d,m,g;
int		kolr; /*Количество физических лиц*/
int 	klst=0; /*Количество строк*/
short		klls=1; /*Количество листов*/
short		god;
int		kvrt=0;
int		vidd;
char		bros[512];
char kod[32];
short		TYP; /*Метка 0-юридическая особа 1-физическая особа*/
char            priznak[16];
char kolih_v_htate[32];
char kolih_po_sovm[32];

class SQLCURSOR curr;
char imaf_xml[100];
memset(imaf_xml,'\0',sizeof(imaf_xml));
memset(kolih_v_htate,'\0',sizeof(kolih_v_htate));
memset(kolih_po_sovm,'\0',sizeof(kolih_po_sovm));


/*Читаем шапку документа*/

sprintf(strsql,"select * from F8dr where nomd='%s'",nomd);
if(sql_readkey(&bd,strsql,&row,&curr) < 1)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найден документ !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 } 
god=atoi(row[0]);
kvrt=atoi(row[1]);
vidd=atoi(row[3]);

//class iceb_tu_str imaf_nf1df;
//imafn("zarsdf1df.alx",&imaf_nf1df);

sprintf(imafdbf,"da0000%02d.%d",1,kvrt);
if(iceb_t_poldan("Имя DBF файла",bros,"zarsdf1df.alx") == 0)
  sprintf(imafdbf,"%s%02d.%d",bros,1,kvrt);

GDITE();

sprintf(strsql,"select inn,sumad,suman,priz,datap,datau,lgota,fio,sumadn,sumann,pr \
from F8dr1 where nomd='%s' order by inn asc,pr desc",nomd);

SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

memset(kod,'\0',sizeof(kod));
TYP=0;
char telef_kontr[512];
char naim_kontr[512];
memset(naim_kontr,'\0',sizeof(naim_kontr));
memset(telef_kontr,'\0',sizeof(telef_kontr));
sprintf(bros,"select naikon,kod,telef from Kontragent where kodkon='00'");
if(sql_readkey(&bd,bros,&row,&curr) == 1)
 {
  strncpy(naim_kontr,row[0],sizeof(naim_kontr)-1);
  strncpy(kod,row[1],sizeof(kod)-1);
  strncpy(telef_kontr,row[2],sizeof(telef_kontr)-1);
 }
if(iceb_t_poldan("Физическое лицо",bros,"zarsdf1df.alx") == 0)
 if(SRAV(bros,"Вкл",1) == 0)
  {
   TYP=1;
  }

kolrab(nomd,&kolr);


  VVOD VV(0);
  sprintf(strsql,"%s %d",gettext("Количество физических лиц"),kolr);
  VV.VVOD_SPISOK_add_ZAG(strsql);
  
  VV.VVOD_SPISOK_add_MD(gettext("Работало в штате.............."));
  VV.VVOD_SPISOK_add_MD(gettext("Работало по совместительству.."));

  VV.VVOD_SPISOK_add_data(kolih_v_htate,sizeof(kolih_v_htate));
  VV.VVOD_SPISOK_add_data(kolih_po_sovm,sizeof(kolih_po_sovm)); 

naz:;

   
  helstr(LINES-1,0,
//  "F1",gettext("помощь"),
  "F2/+",gettext("ввод"),
  "F4",gettext("очистить"),
  "F10",gettext("выход"),NULL);

  int kom=VV.vvod(0,1,1,-1,-1);

  move(LINES-1,0);

  strcpy(kolih_v_htate,VV.VVOD_SPISOK_return_data(0));
  strcpy(kolih_po_sovm,VV.VVOD_SPISOK_return_data(1));

  switch(kom)
   {
    case FK1:   /*Помощь*/
     GDITE();
//     prosf(strsql);
     goto naz;

    case ESC:
    case FK10:
     return(1);

    case FK2:
    case PLU:
       break;


    case FK4: /*Очистить меню*/
      VV.VVOD_clear_data();  
      goto naz;

    default:
       goto naz;
   }





sprintf(imaf,"dov%d_%d.lst",kvrt,getpid());
if((ff1 = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

sprintf(imaffam,"dovf%d_%d.lst",kvrt,getpid());
if((fffam = fopen(imaffam,"w")) == NULL)
 {
  error_op_nfil(imaffam,errno,"");
  return(1);
 }

//Заголовок распечаток

zagf1df(atoi(kolih_v_htate),atoi(kolih_po_sovm),kvrt,kod,TYP,&klst,vidd,0,0,god,0,0,0,metka_oth,ff1,fffam);

spkvd(&klst,ff1);



creatheaddbf(imafdbf,kolstr+3);
if((ff4 = fopen(imafdbf,"a")) == NULL)
 {
  error_op_nfil(imafdbf,errno,"");
  return(1);
 }

f1df_xml_zag(kvrt,god,kod,TYP,metka_oth,atoi(kolih_v_htate),atoi(kolih_po_sovm),naim_kontr,imaf_xml,&ff_xml);


isumad=isuman=0.;
isumadn=isumann=0.;
npp1=0;
int kolstr1=0;
int nomer_xml_str=0;
while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s\n",row[0],row[1]);
//  refresh();
  strzag(LINES-1,0,kolstr,++kolstr1);  
  memset(inn,'\0',sizeof(inn));
  strncpy(inn,row[0],sizeof(inn)-1);

  sumad=atof(row[1]);
  sumad=okrug(sumad,0.01);

  suman=atof(row[2]);
  suman=okrug(suman,0.01);

  sumadn=atof(row[8]);
  sumadn=okrug(sumadn,0.01);

  sumann=atof(row[9]);
  sumann=okrug(sumann,0.01);

  isumad+=sumad;
  isuman+=suman;

  isumadn+=sumadn;
  isumann+=sumann;

  memset(priz,'\0',sizeof(priz));
  strcpy(priz,row[3]);

  d=m=g=0;
  rsdat(&d,&m,&g,row[4],2);
  memset(data1,'\0',sizeof(data1));
  memset(data11,'\0',sizeof(data11));
  memset(data12,'\0',sizeof(data12));
  if(d != 0)
   {
    sprintf(data1,"%04d%02d%02d",g,m,d);
    sprintf(data11,"%02d.%02d.%4d",d,m,g);
    sprintf(data12,"%02d%02d%4d",d,m,g);
   }
  d=m=g=0;
  rsdat(&d,&m,&g,row[5],2);
  memset(data2,'\0',sizeof(data2));
  memset(data21,'\0',sizeof(data21));
  memset(data22,'\0',sizeof(data22));
  if(d != 0)
   {
    sprintf(data2,"%04d%02d%02d",g,m,d);
    sprintf(data21,"%02d.%02d.%04d",d,m,g);
    sprintf(data22,"%02d%02d%04d",d,m,g);
   }

  lgota=atoi(row[6]);
  memset(lgotach,'\0',sizeof(lgotach));
  if(lgota != 0)
   sprintf(lgotach,"%02d",lgota);  

  memset(priznak,'\0',sizeof(priznak));
  if(vidd != 0)
    strcpy(priznak,row[10]);

  ssf8dr(&klst,&klls,ff1);
  npp1++;    

    
  fprintf(ff1,"%-5d|%-10s|%10.2f|%10.2f|%10.2f|%10.2f|  %-4s|%-10s|%-10s|%-10s|%6s|\n",
  npp1,inn,sumadn,sumad,sumann,suman,priz,data11,data21,lgotach,priznak);

    //Узнаем инвентарный номер
    char fam[512];    
    char tabn[20];
    memset(fam,'\0',sizeof(fam));
    memset(tabn,'\0',sizeof(tabn));
    if(row[7][0] == '\0')
     {
      sprintf(strsql,"select tabn,fio from Kartb where inn='%s'",row[0]);
      if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
       {
        strncpy(tabn,row1[0],sizeof(tabn)-1);
        strncpy(fam,row1[1],sizeof(fam)-1);
       }
     }
    else
     {
      strncpy(fam,row[7],sizeof(fam)-1);      
     }

  fprintf(fffam,"%-5d %-10s %10.2f %10.2f %10.2f %10.2f %-6s %10s %10s %-10s %6s %-5s %s\n",
  npp1,inn,sumadn,sumad,sumann,suman,priz,data11,data21,lgotach,priznak,tabn,fam);   
  zapf8dr(npp1,kvrt,god,kod,TYP,inn,sumadn,sumad,sumann,suman,priz,data1,data2,lgota,atoi(row[10]),ff4);

  f1df_xml_str(&nomer_xml_str,inn,sumadn,sumad,sumann,suman,priz,data12,data22,lgotach,row[10],ff_xml);
 }

koncf8dr(kvrt,god,kod,TYP,isumad,isumadn,isuman,isumann,isumad,isumadn,isuman,isumann,kolr,klls,&npp1,2,ff1,fffam,ff4);

fclose(ff1);
fclose(fffam);

fputc(26, ff4);
fclose(ff4);

f1df_xml_kon(isumadn,isumad,isumann,isuman,nomer_xml_str,kolr,klls,naim_kontr,telef_kontr,TYP,ff_xml);


oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчет формы 1ДФ"));

sprintf(strsql,"%s+%s",
gettext("Расчет формы 1ДФ."),
gettext("Фамилия"));
oth->spis_naim.plus(strsql);
oth->spis_imaf.plus(imaffam);

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),1);

oth->spis_naim.plus(gettext("Документ в формате dbf"));
oth->spis_imaf.plus(imafdbf);

oth->spis_imaf.plus(imaf_xml);
oth->spis_naim.plus(gettext("Документ в формате xml"));

return(0);
}

/***********************/
/*Счетчик строк        */
/***********************/

void	ssf8dr(int *klst,short *kollist,FILE *ff)
{
*klst+=1;
if(*klst < kol_strok_na_liste)
  return; 
fprintf(ff,"\f");
*klst=0;
spkvd(klst,ff);
*kollist+=1;
}
