/* $Id: rasmoth.c,v 5.19 2011-01-13 13:43:23 sasa1 Exp $ */
/*01.11.2009    15.05.1997      Белых А.И.      rasmoth.c
Просмотр отсортированного файла и распечатка отчета
*/
#include        <math.h>
#include        <time.h>
#include        <errno.h>
#include	"buhg.h"

#define         PL      50  /*Количество строк на первом листе*/
#define         VL      65  /*Количество строк на втором листе*/

extern void     hmoth(short,short,short,short,short,short,short *,short *,short,short,FILE*,struct tm *);


extern char     *organ;
extern char            *spoprp;/*Массив с перечнем операций приходов*/
extern char            *spoprr;/*Массив с перечнем операций расходов*/
extern int             *mko;  /*Массив кодов материалов*/
extern double          *mkm1p; /*Массив количества материалла для прихода*/
extern double          *mkm2p; /*Массив веса материалла для прихода*/
extern double          *mkm3p; /*Массив суммы (kol*cena) материалла для прихода*/
extern double          *mkm1r; /*Массив количества материалла для расхода*/
extern double          *mkm2r; /*Массив веса материалла для расхода*/
extern double          *mkm3r; /*Массив суммы (kol*cena) материалла для расхода*/
extern double          *mko1r; /*Массив количества отхода материалла для расхода*/
extern double          *mko2r; /*Массив веса отхода материалла для расхода*/
extern double          *mko3r; /*Массив цены отхода материалла для расхода*/

extern int             *mkg;  /*Массив кодов групп материалов*/
extern double          *mkg1p; /*Массив количества материалла по группе для прихода*/
extern double          *mkg2p; /*Массив веса материалла по группе для прихода*/
extern double          *mkg3p; /*Массив цены материалла по группе для прихода*/
extern double          *mkg1r; /*Массив количества материалла по группе для прихода*/
extern double          *mkg2r; /*Массив веса материалла по группе для прихода*/
extern double          *mkg3r; /*Массив цены материалла по группе*/
extern double		*mkdp; /*Массив динамики приходов*/
extern double		*mkdr; /*Массив динамики расходов*/

void            rasmoth(VVOD *VV,
short tr,//*0-развернутая форма 1-короткая*/
char skll[],//*Код склада*/
char kodml[], //*Код материалла*/
char kodol[], //*Код контрагента
short dn,short mn,short gn,short dk,short mk,short gk,short tipzl,
double cenal,char kopl[],short kk1,short kk2,short kk3,short kk4,
short mo, //*0-полный отчет 1-только таблица c весом 2-с прибылью
FILE *ff,FILE *ff2)
{
struct  tm      *bf;
SQL_str         row;
char		strsql[512];
char            bros[512];
short           kodmz; /*Код материалла*/
short           sklz;      /*Код склада*/
char            kodoz[32]; /*Код контрагента*/
time_t          tmm;
short           sli,kst;
short           tipzz,tp;     /*Приход/расход*/
char            kopz[32];  /*Код операции*/
double          cenaz;     /*цена*/
double          ittip[4],ittips[3];  /*Приход/расход*/
double          itkodm[4],itkodms[3]; /*Код материалла*/
double          itcena[4],itcenas[3]; /*цена*/
double          itkodo[4],itkodos[3]; /*Код контрагента*/
double          itskl[4],itskls[3];   /*Код склада*/
double          itkop[4],itkops[3];   /*Код операции*/
double          bb,bb1;
char            naior[512];
char		oper[512];
short		to;
int		i;
int             i1,i2,i3;
char		kor[32],kop[32];
double		cena,cenau,kolih,voz,oth,fas;
char		str[1024];
int		kodm;
extern double	okrcn;
int		skl;
char		naim[512];
char		ei[32];
char		nn[32];
short		d,m,g;
int		kgrm;
int		klst=0;

//iceb_t_poldan("Н.Д.С.",bros,"matnast.alx");
//float pnds=ATOFM(bros);
float pnds=iceb_t_pnds();

voz=oth=0.;

time(&tmm);
bf=localtime(&tmm);

printw(gettext("Распечатываем.\n"));
refresh();

oper[0]='\0';

fprintf(ff,"%s\n\n\
%s %d.%d.%d%s %s %d.%d.%d%s\n\
%s %d.%d.%d%s %s - %d:%d\n",
organ,
gettext("Движение товарно-материалных ценностей за период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);


if(skll[0] != '\0')
 fprintf(ff,gettext("Склад - %s.\n"),skll);
if(kodml[0] != '\0' )
  fprintf(ff,gettext("Код материала - %s\n"),kodml);

if(tipzl != 0 )
 {
  if(tipzl == 1)
     fprintf(ff,gettext("Вид операции - приход\n"));
  if(tipzl == 2)
     fprintf(ff,gettext("Вид операции - расход\n"));
 }

if(cenal != -1.)
 fprintf(ff,"%s - %.2f.\n",gettext("Цена"),cenal);

if(kopl[0] != '\0')
 fprintf(ff,"%s - %s\n",gettext("Код операции"),kopl);

if(VV->VVOD_SPISOK_return_data(7)[0] != '\0')
  fprintf(ff,gettext("Код контрагента - %s\n"),VV->VVOD_SPISOK_return_data(7));

if(VV->VVOD_SPISOK_return_data(8)[0] != '\0')
  fprintf(ff,gettext("Код группы материалла - %s\n"),VV->VVOD_SPISOK_return_data(8));

if(VV->VVOD_SPISOK_return_data(9)[0] != '\0')
  fprintf(ff,gettext("Набор операций - %s\n"),VV->VVOD_SPISOK_return_data(9));

if(VV->VVOD_SPISOK_return_data(10)[0] != '\0')
  fprintf(ff,gettext("Счета - %s\n"),VV->VVOD_SPISOK_return_data(10));
if(VV->VVOD_SPISOK_return_data(11)[0] != '\0')
 {
  fprintf(ff,"%s:\n",gettext("Группы контрагентов"));
  printcod(ff,"Gkont","kod","naik",0,VV->VVOD_SPISOK_return_data(11),&klst);
 }
    
fprintf(ff,"\n");

for(i=0; i<4;i++)
 {
  itkop[i]=itskl[i]=ittip[i]=itkodm[i]=itcena[i]=itkodo[i]=0.;
 }
for(i=0; i<3; i++)
 {
  itkops[i]=itskls[i]=ittips[i]=itkodms[i]=itcenas[i]=itkodos[i]=0.;
 }

tipzz=0;
sli=0;
kst=-1;
to=sklz=0;
kodmz=0;
cenaz=-1.; /*Цена может быть нулевой*/
kopz[0]='\0';
kodoz[0]='\0';

while(fgets(str,sizeof(str),ff2) != NULL) 
 {
//  printw("%s",str);
  
  POLE(str,bros,1,'|');
  tp=atoi(bros);
  POLE(str,bros,2,'|');
  skl=atoi(bros);

  POLE(str,kop,3,'|');

  POLE(str,bros,4,'|');
  kodm=atoi(bros);

  POLE(str,bros,5,'|');
  cena=atof(bros);
  cena=okrug(cena,okrcn);

  POLE(str,kor,6,'|');

  POLE(str,bros,7,'|');
  kolih=atof(bros);

  POLE(str,naim,8,'|');

  POLE(str,bros,9,'|');
  cenau=atof(bros);
  cenau=okrug(cenau,okrcn);

  POLE(str,ei,10,'|');

  POLE(str,nn,11,'|');

  POLE(str,bros,12,'|');
  rsdat(&d,&m,&g,bros,0);

  POLE(str,bros,13,'|');
  kgrm=atoi(bros);
   
  POLE(str,bros,14,'|');
  fas=atof(bros);
  if( mo != 0)
   {
    goto vp;
   }
  
  to=0;
  if(oper[0] != '\0' && tp == 2)
    if(pole1(oper,kop,',',0,&i1) == 0 || SRAV(oper,kop,0) == 0)
      to=1;

  /*Приход расход*/
  if(tipzz != tp)
   {

    if(tipzz != 0)
     {
      itogi(7,itkodo,itkodos,naior,0,0.,to,tr,ff);
      itogi(6,itcena,itcenas,"  ",0,cenaz,to,tr,ff);
      itogi(5,itkodm,itkodms,naim,0,0.,to,tr,ff);
      itogi(4,itkop,itkops,kopz,0,0.,to,tr,ff);
      itogi(3,itskl,itskls,"  ",sklz,0.,to,tr,ff);
      itogi(tipzz,ittip,ittips," ",0,0.,to,tr,ff);
      kst=-1;
      sli=0;
      fprintf(ff,"\f");
     }
    if(tp == 1 && tipzz == 0)
     {
      fprintf(ff,"%s\n",gettext("Приходы"));
      printw("%s\n",gettext("Приходы"));
     }
    if(tp == 2 && tipzz == 1)
     { 
      fprintf(ff,"%s\n",gettext("Расходы"));
      printw("%s\n",gettext("Расходы"));
     }
    hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
    tipzz=tp;
    sklz=0;
    kodmz=0;
    cenaz=-1.; /*Цена может быть нулевой*/
    kopz[0]='\0';
    kodoz[0]='\0';
   }

  /*Склад*/
  if(sklz != skl)
   {
    if(sklz != 0)
     {
        if(itkodo[0] != 0.)
         itogi(7,itkodo,itkodos,naior,0,0.,to,tr,ff);
        if(itcena[0] != 0.)
         itogi(6,itcena,itcenas,"  ",0,cenaz,to,tr,ff);
        if(itkodm[0] != 0.)
	 itogi(5,itkodm,itkodms,naim,0,0.,to,tr,ff);
        if(itkop[0] != 0.)
         itogi(4,itkop,itkops,kopz,0,0.,to,tr,ff);
        if(itskl[0] != 0.)
         itogi(3,itskl,itskls,"  ",sklz,0.,to,tr,ff);
      kst=-1;
      sli=0;
      fprintf(ff,"\f");
     }
    fprintf(ff,gettext("Склад - %d.\n"),skl);
    hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
    printw(gettext("Склад - %d.\n"),skl);
    sklz=skl;
    sli=0;
    kodmz=0;
    cenaz=-1.; /*Цена может быть нулевой*/
    kopz[0]='\0';
    kodoz[0]='\0';

   }

  /*Код операции*/
  if(SRAV(kopz,kop,0) != 0)
   {
    if(kopz[0] != '\0')
     {
	if(itkodo[0] != 0.)
	 { 
	  itogi(7,itkodo,itkodos,naior,0,0.,to,tr,ff);
          hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
         }
	if(itcena[0] != 0.)
         {
     	  itogi(6,itcena,itcenas,"  ",0,cenaz,to,tr,ff);
          hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
         }
	if(itkodm[0] != 0.)
         {
	  itogi(5,itkodm,itkodms,naim,0,0.,to,tr,ff);
          hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
         }
	if(itkop[0] != 0.)
         {
	  itogi(4,itkop,itkops,kopz,0,0.,to,tr,ff);
          hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
         }
      kst=-1;
      sli=0;
      fprintf(ff,"\f");
     }
    strcpy(kopz,kop);
    fprintf(ff,"Операція - %s\n",kopz);
    hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
    printw("%s - %s\n",gettext("Операция"),kopz);
    kodmz=0;
    cenaz=-1.; /*Цена может быть нулевой*/
    kodoz[0]='\0';
   }

  /*Код материалла*/
  if(kodmz != kodm)
   {
    if(kodmz != 0)
     {
	if(itkodo[0] != 0.)
         {
	  itogi(7,itkodo,itkodos,naior,0,0.,to,tr,ff);
          hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
         }
	if(itcena[0] != 0.)
         {
	  itogi(6,itcena,itcenas,"  ",0,cenaz,to,tr,ff);
          hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
         }
        if(itkodm[0] != 0.)
         {
	  itogi(5,itkodm,itkodms,naim,0,0.,to,tr,ff);
          hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
         }
     }

    hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
    fprintf(ff,"%s - %s ********\n",gettext("Материал"),naim);
    printw("******** %s ********\n",naim);
    kodmz = kodm;
    cenaz=-1.; /*Цена может быть нулевой*/
    kodoz[0]='\0';
   }

  /*Цена*/
  if(cenaz != cena)
   {
    if(cenaz > -1.)
     {
	if(itkodo[0] != 0.)
         {
	  itogi(7,itkodo,itkodos,naior,0,0.,to,tr,ff);
          hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
         }
	if(itcena[0] != 0.)
         {
	  itogi(6,itcena,itcenas,"  ",0,cenaz,to,tr,ff);
          hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
         }
     }
    cenaz=cena;
    kodoz[0]='\0';
   }

  /*Код контрагента*/
  if(SRAV(kodoz,kor,0) != 0)
   {
    if(kodoz[0] != '\0')
     {
      if(itkodo[0] != 0.)
       {    
        itogi(7,itkodo,itkodos,naior,0,0.,to,tr,ff);
        hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
       }
     }

     memset(bros,'\0',sizeof(bros));
     if(ATOFM(kor) == 0. && kor[0] == '0')
	strncpy(bros,"00",sizeof(bros)-1);
      else
        sprintf(bros,"%s",kor);

     naior[0]='\0';
     SQLCURSOR cur;
     sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",
     bros);
     if(sql_readkey(&bd,strsql,&row,&cur) != 1)
      {
       beep();
       printw("Не знайден контрагент %s !\n,kor");
       OSTANOV();
      }
     else
       strncpy(naior,row[0],sizeof(naior)-1);
     
    strcpy(kodoz,kor);
   }
  itkop[0]=itskl[0]=ittip[0]=itkodm[0]=itcena[0]=itkodo[0]=1.;


  ittip[1]+=kolih;
  itskl[1]+=kolih;
  itkodm[1]+=kolih;
  itcena[1]+=kolih;
  itkodo[1]+=kolih;
  itkop[1]+=kolih;

  ittip[2]+=kolih-voz-oth;
  itskl[2]+=kolih-voz-oth;
  itkodm[2]+=kolih-voz-oth;
  itcena[2]+=kolih-voz-oth;
  itkodo[2]+=kolih-voz-oth;
  itkop[2]+=kolih-voz-oth;

  ittip[3]+=oth;
  itskl[3]+=oth;
  itkodm[3]+=oth;
  itcena[3]+=oth;
  itkodo[3]+=oth;
  itkop[3]+=oth;
  if(mo == 2)
    bb=kolih*(cena-cenau);
  else  
    bb=kolih*cena;
  bb=okrug(bb,0.01);
  
  ittips[0]+=bb;
  itskls[0]+=bb;
  itkodms[0]+=bb;
  itcenas[0]=itcenas[0]+bb;
  itkodos[0]+=bb;
  itkops[0]+=bb;

  bb1=(kolih-voz-oth)*cena;
  bb1=okrug(bb1,0.01);

  ittips[1]+=bb1;
  itskls[1]+=bb1;
  itkodms[1]+=bb1;
  itcenas[1]+=bb1;
  itkodos[1]+=bb1;
  itkops[1]+=bb1;

  if(tr == 0)
   {
    hmoth(dn,mn,gn,dk,mk,gk,&sli,&kst,to,tr,ff,bf);
    if(to == 0)
     {
      fprintf(ff,"%3d %-*s %-*s %-*s %8.5f %8.8g %10.2f %10.2f %-5s %02d.%02d.%d %s %s\n",
      kodm,
      iceb_tu_kolbait(30,naim),naim,
      iceb_tu_kolbait(4,ei),ei,
      iceb_tu_kolbait(4,kop),kop,
      cena,kolih,
      bb,bb+bb*pnds/100.,nn,d,m,g,kodoz,naior);
     }
    if(to == 1)
      fprintf(ff,"%3d %-*s %-*s %-*s %8.5f %8.8g %10.2f %8.8g %10.2f %8.8g %-5s %02d.%02d.%d %s %s\n",
      kodm,
      iceb_tu_kolbait(30,naim),naim,
      iceb_tu_kolbait(4,ei),ei,
      iceb_tu_kolbait(4,kop),kop,
      cena,kolih,
      bb,kolih-voz-oth,bb1,oth,nn,
      d,m,g,kodoz,naior);
   }

vp:;

  /*Заполняем массивы*/

  for(i1=0; i1< kk3; i1++)
   {
/*  printw("mko[i1] = %d\n",mko[i1]);*/
    if(mko[i1] == kodm)
     break;
   }
  if(i1 == kk3)
   {
    beep();
    printw(gettext("rasmoth-Не найден код материалла %d в массиве материалов ! (%d %d) \n"),kodm,i1,kk3);
    fprintf(ff,gettext("rasmoth-Не найден код материалла %d в массиве материалов ! (%d %d) \n"),kodm,i1,kk3);
    OSTANOV();
    continue;
   }

  for(i3=0; i3< kk4; i3++)
   {

//    printw("mkg[i3] = %d i3=%d kk4=%d kgrm=%d\n",mkg[i3],i3,kk4,kgrm);

    if(mkg[i3] == kgrm)
     break;
   }
  if(i3 == kk4)
   {
    beep();
    printw(gettext("rasmoth-Не найдена группа материалла %d в массиве групп ! Код мат. %d\n"),
    kgrm,kodm);
    fprintf(ff,gettext("rasmoth-Не найдена группа материалла %d в массиве групп ! Код мат. %d\n"),
    kgrm,kodm);
    OSTANOV();
    continue;
   }

  if(tp == 1)
   {
    if(pole1(spoprp,kop,'#',0,&i2) != 0)
     {
      beep();
      printw(gettext("Не найден код операции прихода %s в массиве операций !\n"),kop);
      fprintf(ff,gettext("Не найден код операции прихода %s в массиве операций !\n"),kop);
      OSTANOV();
     }
    /*printw("%s\n%d %s\n",spoprp,i2,kop);*/

    /*Материалы*/
    mkm1p[i2+i1*kk1]+=kolih;

    if(fas > 0.0000001)
      mkm2p[i2+i1*kk1]+=kolih*fas;
    else
      if(SRAV(ei,"Кг",0) == 0 || SRAV(ei,"кг",0) == 0 || SRAV(ei,"КГ",0) == 0)
        mkm2p[i2+i1*kk1]+=kolih;
     
    mkm3p[i2+i1*kk1]+=kolih*cenau;

    /*Группы материалов*/
    mkg1p[i2+i3*kk1]+=kolih;

    if(fas > 0.0000001)
      mkg2p[i2+i3*kk1]+=kolih*fas;
    else
      if(SRAV(ei,"Кг",0) == 0 || SRAV(ei,"кг",0) == 0 || SRAV(ei,"КГ",0) == 0)
        mkg2p[i2+i3*kk1]+=kolih;
     
    mkg3p[i2+i3*kk1]+=kolih*cenau;

    /*Заполняем массив динамики приходов*/
    mkdp[d+(m-1)*31 + (31*12)*(g-gn)]+=kolih;

   }

  if(tp == 2)
   {
    if(pole1(spoprr,kop,'#',0,&i2) != 0)
     {
      beep();
      printw(gettext("Не найден код операции расхода %s в массиве операций !\n"),kop);
      fprintf(ff,gettext("Не найден код операции расхода %s в массиве операций !\n"),kop);
      OSTANOV();
     }
    /*printw("%s\n%d %s\n",spoprr,i2,kop);*/

    /*Материалы*/
    mkm1r[i2+i1*kk2]+=kolih-voz-oth;
    if(mo != 2)
     {
     if(fas > 0.0000001)
       mkm2r[i2+i1*kk2]+=(kolih-voz-oth)*fas;
     else
      if(SRAV(ei,"Кг",0) == 0 || SRAV(ei,"кг",0) == 0 || SRAV(ei,"КГ",0) == 0)
        mkm2r[i2+i1*kk2]+=kolih-voz-oth;
     }
    if(mo != 2)
      bb=(kolih-voz-oth)*cena;
    else
      bb=(kolih-voz-oth)*(cena-cenau);

    bb=okrug(bb,0.01);
    mkm3r[i2+i1*kk2]+=bb;

    /*Группы материалов*/
    mkg1r[i2+i3*kk2]+=kolih-voz-oth;
    if(mo != 2)
     {
     if(fas > 0.0000001)
       mkg2r[i2+i3*kk2]+=(kolih-voz-oth)*fas;
     else
      if(SRAV(ei,"Кг",0) == 0 || SRAV(ei,"кг",0) == 0 || SRAV(ei,"КГ",0) == 0)
        mkg2r[i2+i3*kk2]+=kolih-voz-oth;
     }
    if(mo == 2)
      mkg2r[i2+i3*kk2]+=kolih*(cena-cenau);
    
    if(mo == 2)
     bb=(kolih-voz-oth)*(cena-cenau);
    else
     bb=(kolih-voz-oth)*cena;
    bb=okrug(bb,0.01);
    mkg3r[i2+i3*kk2]+=bb;

    /*Отходы*/
    mko1r[i2+i1*kk2]+=oth;
    if(fas > 0.0000001)
      mko2r[i2+i1*kk2]+=oth*fas;
    else
      if(SRAV(ei,"Кг",0) == 0 || SRAV(ei,"кг",0) == 0 || SRAV(ei,"КГ",0) == 0)
         mko2r[i2+i1*kk2]+=oth;
    bb=oth*cena;
    bb=okrug(bb,0.01);
    mko3r[i2+i1*kk2]+=bb;

    /*Заполняем массив динамики расходов*/
    mkdr[d+(m-1)*31 + (31*12)*(g-gn)]+=kolih;
   }
/*
   printw("i1=%d i2=%d kk1=%d kk2=%d\n",i1,i2,kk1,kk2);
   refresh();
  */

 }

if(mo == 0)
 {
  itogi(7,itkodo,itkodos,naior,0,0.,to,tr,ff);
  itogi(6,itcena,itcenas,"  ",0,cenaz,to,tr,ff);
  itogi(5,itkodm,itkodms,naim,0,0.,to,tr,ff);
  itogi(4,itkop,itkops,kopz,0,0.,to,tr,ff);
  itogi(3,itskl,itskls,"  ",sklz,0.,to,tr,ff);
  itogi(tipzz,ittip,ittips," ",0,0.,to,tr,ff);
 }
//printw("makraso - закончила работу.\n");
refresh();
}

/***************************/
/*Шапка материального отчета*/
/**************************/

void            hmoth(short dn,short mn,short gn,short dk,short mk,
short gk,short *sl,short *kst,
short tsh, //0-для об.опер 1-реал на рынке
short tr,FILE *ff,struct tm *bf)
{
*kst=*kst+1;

if((*kst >= VL && *sl > 1) || (*kst >= PL && *sl == 1) ||
(*kst == 0 && *sl == 0))
 {
  if((*kst >= VL && *sl > 1) ||  (*kst >= PL && *sl == 1))
      fprintf(ff,"\f");

  *sl=*sl+1;
  *kst=1;

  if(tr == 0)
   {
    if(tsh == 0)
     {
      fprintf(ff,"\
%s %d.%d.%d%s %s - %d:%d %50s%s%d\n",
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min,
"",gettext("Лист N"),
*sl);
    fprintf(ff,"\
------------------------------------------------------------------------------------------------------------------------------------------\n");
    fprintf(ff,gettext("К/М|  Наименование материалла     |Е.и.|К/О | Цена   |Количес.| Сумма    |Сум. с НДС| Н/Д |  Дата    | Наименование контрагента          |\n"));
    fprintf(ff,"\
------------------------------------------------------------------------------------------------------------------------------------------\n");
     }
    if(tsh == 1)
     {
      fprintf(ff,"\
%s %d.%d.%d%s %s - %d:%d %50s%s%d\n",
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min,
"",gettext("Лист N"),
*sl);
      fprintf(ff,"\
------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
      fprintf(ff,gettext("К/М|  Наименование материалла     |Е.и.|К/О | Цена   |Количес.| Сумма    |Кол.реа.|Сум. реал.|Кол.отх.| Н/Д |  Дата    | Наименование контрагента          |\n"));
      fprintf(ff,"\
------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
     }
   }

  if(tr == 1)
   {
    if(tsh == 0)
     {
      fprintf(ff,"\
%s %d.%d.%d%s %s - %d:%d %50s%s%d\n",
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min,
"",gettext("Лист N"),
*sl);
      fprintf(ff,"\
--------------------------------------------------------------------------\n");
      fprintf(ff,gettext("                                                     |Количес.| Сумма    |\n"));
      fprintf(ff,"\
--------------------------------------------------------------------------\n");
     }
    if(tsh == 1)
     {
      fprintf(ff,"\
%s %d.%d.%d%s %s - %d:%d %50s%s%d\n",
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min,
"",gettext("Лист N"),
*sl);
      fprintf(ff,"\
-------------------------------------------------------------------------------------------------------\n");
      fprintf(ff,gettext("                                                     |Количес.| Сумма    |Кол.реа.|Сумма реал|Кол.отх.|\n"));
      fprintf(ff,"\
-------------------------------------------------------------------------------------------------------\n");
     }
   }

 }

}

/****************/
/*Выдача итогов*/
/***************/

void itogi(short it,double kol[],double sum[],const char *rp,
short sk,double cn,
short to, //0-об. опер 1-виездная торговля
short tr, //0-развернутая форма 1-короткая
FILE *ff)
{
char		bros[512];

if(it == 1)
 {
  if(tr == 0)
    fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------------\n");
    sprintf(bros,gettext("Итого по приходу:"));
 }

if(it == 2)
 {
  if(tr == 0)
    fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------------\n");
    sprintf(bros,gettext("Итого по расходу:"));
 }

if(it == 3)
 {
  if(tr == 0)
    fprintf(ff,"\
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");
    sprintf(bros,gettext("Итого по складу %d:"),sk);
 }

if(it == 4)
 {
  if(tr == 0)
    fprintf(ff,"\
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .\n");
    sprintf(bros,gettext("Итого по операции %s:"),rp);
 }

if(it == 5)
 {
  sprintf(bros,gettext("Итого по мат-лу %s:"),rp);
 }

if(it == 6)
 {
  sprintf(bros,gettext("Итого по цене %.2f:"),cn);
 }

if(it == 7)
 {
  sprintf(bros,gettext("Итого по кон-ту %s:"),rp);
 }
 
if(to == 0)
 { 
  fprintf(ff,"%*s %8.8g %10.2f\n",
  iceb_tu_kolbait(53,bros),bros,kol[1],sum[0]);
/*
  printw("%-30.30s %8.8g %10.2f\n",
  bros,kol[1],sum[0]);
  */
 }
if(to == 1)
 {
  fprintf(ff,"%*s %8.8g %10.2f %8.8g %10.2f %8.8g\n",
  iceb_tu_kolbait(53,bros),bros,kol[1],sum[0],kol[2],sum[1],kol[3]);
/*
  printw("%-30.30s %8.8g %8.2f %8.8g %8.2f %8.8g\n",
  bros,kol[1],sum[0],kol[2],sum[1],kol[3]);
  */
 }

refresh();

kol[0]=kol[1]=kol[2]=kol[3]=0.;
sum[0]=sum[1]=sum[2]=0.;

}

