/* $Id: rasoskr.c,v 5.74 2011-01-13 13:43:23 sasa1 Exp $ */
/*26.11.2010    01.02.1994      Белых А.И.      rasoskr.c
Распечатка перечня карточек с остатками
*/
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern int      kol_strok_na_liste;

#define		IMAFDPI "inventm.alx"

void 		sapkk1(short,short,short,short,FILE*,int*,int*);
void 		sapkk(short,short,short,short,int,FILE*);

extern char     *organ;
extern double	okrg1;  /*Округление 1*/
extern double	okrcn;  /*Округление цены*/

int rasoskr(class spis_oth *oth)
{
class ostatokt ost;
char            str[512];
char		bros[512];
extern char	*maskmat; /*Массив кодов отмеченных материалов*/
struct  tm      *bf;
time_t          tmm;
FILE            *ff1,*ff2;
char            imaf1[32],imafiv[32];
short		nkp;
char		naiskl[512];
int		skl,skk,sklz;
int		nk;
char		grup[32],grupz[32];
double		itgk,itgs; /*Итоги по группе*/
double		itogshk,itogshs; //Итоги по счету
double		itok,itos; //Итоги по складу
double		itk=0.,its=0.; /*Итоги по общие*/
double		bb=0.;
int		i,kgr;
int             i1;
char		mnds=' ';
int		srt; 
char		shet[32],shetz[32];
short		dos,mos,gos;
short		d,m,g;
int		par,kom1;
static char	dat1[11];
static char	skladi[112];
static class iceb_tu_str grupi("");
static class iceb_tu_str sheta("");
static char	kodm[112];
static char	nds[5];
static char     kon_dat_is[11]; //Конечная дата использования
static class iceb_tu_str invnomp("");
static iceb_tu_str naim_mat("");
short		mns=0;
char		sklad[40];
char		nomkar[40];
long		kolstr,kolstr1;
SQL_str         row,row1,rowtmp;
char		strsql[512];
int		kgrm;
char		ei[32];
class iceb_tu_str naim("");
char		naimgr[512];
char		naish[512];
int		kolstrlist;
int		kollist=0,kollistiv=0;
char		mesqc[24];
char		innom[16];
char		regnom[20];
short		dv,mv,gv;
char		dopstr[512];
int		metkainnom=0;
int             kolstriv=0;

//iceb_t_poldan("Н.Д.С.",bros,"matnast.alx");
//float pnds=ATOFM(bros);
float pnds=iceb_t_pnds();

if(dat1[0] == '\0')
 {
  short dt,mt,gt;
  poltekdat(&dt,&mt,&gt);
  sprintf(dat1,"%d.%d.%d",dt,mt,gt);
 }
VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_data(skladi,sizeof(skladi));//0
VV.VVOD_SPISOK_add_data(grupi.ravno(),112);//1
VV.VVOD_SPISOK_add_data(sheta.ravno(),112);//2
VV.VVOD_SPISOK_add_data(kodm,sizeof(kodm));//3
VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));//4
VV.VVOD_SPISOK_add_data(nds,sizeof(nds));//5
VV.VVOD_SPISOK_add_data(kon_dat_is,sizeof(kon_dat_is));//6
VV.VVOD_SPISOK_add_data(naim_mat.ravno(),112);//7
VV.VVOD_SPISOK_add_data(invnomp.ravno(),112);//8

VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка карточек с остатками"));

VV.VVOD_SPISOK_add_MD(gettext("Склад.(,,)......................"));//0
VV.VVOD_SPISOK_add_MD(gettext("Группа..(,,)...................."));//1
VV.VVOD_SPISOK_add_MD(gettext("Счет....(,,)...................."));//2
VV.VVOD_SPISOK_add_MD(gettext("Материал.(,,/*)................."));//4
VV.VVOD_SPISOK_add_MD(gettext("Дата остатка...................."));//5
sprintf(strsql,gettext("НДС (0,%2.f,+)...................."),pnds);//5
VV.VVOD_SPISOK_add_MD(strsql);
VV.VVOD_SPISOK_add_MD(gettext("Конечная дата использования по.."));//6
VV.VVOD_SPISOK_add_MD(gettext("Наименование материалла...(,,).."));//7
VV.VVOD_SPISOK_add_MD(gettext("Инвентарный номер.........(,,).."));//8

naz:;

clear();

move(LINES-6,0);
printw(gettext("Если НДС не ввели - все карточки.\n\
Если НДС = 0      - карточки с нулевым НДС.\n\
Если НДС = %2.f     - карточки с %2.f%% НДС.\n\
Если НДС = +      - карточки цена в которых вместе с НДС.\n"),pnds,pnds);

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+/-",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F5",gettext("доп.инфор."),
"F6",gettext("расчитать"),
"F10",gettext("выход"),NULL);

par=VV.vvod(0,1,1,-1,-1);

strncpy(skladi,VV.VVOD_SPISOK_return_data(0),sizeof(skladi)-1);
grupi.new_plus(VV.VVOD_SPISOK_return_data(1));
sheta.new_plus(VV.VVOD_SPISOK_return_data(2));
strncpy(kodm,VV.VVOD_SPISOK_return_data(3),sizeof(kodm)-1);
strncpy(dat1,VV.VVOD_SPISOK_return_data(4),sizeof(dat1)-1);
strncpy(nds,VV.VVOD_SPISOK_return_data(5),sizeof(nds)-1);
strncpy(kon_dat_is,VV.VVOD_SPISOK_return_data(6),sizeof(kon_dat_is)-1);
naim_mat.new_plus(VV.VVOD_SPISOK_return_data(7));
invnomp.new_plus(VV.data_ravno(8));

class iceb_tu_str kod_v("");
class iceb_tu_str naim_v("");
switch(par)
 {
  case ESC:
  case FK10:
    return(1);
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("matu5_1.txt");
   clear();
   goto naz;

  case FK2:
  case PLU:
  case OTN:
    break;

  case FK6: //Только карточки с инвентарными номеррами
    metkainnom=1;
    break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка складов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка материалов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);
    switch (kom1)
     {
      case 4 :
      case -1:
       goto naz;

      case 0 :
        if(dirsklad(1,&kod_v,&naim_v) == 0)
         VV.data_z_plus(0,kod_v.ravno());
        goto naz;

      case 1 :
        vibrek("Grup",&grupi,&naim);
        VV.VVOD_SPISOK_zapis_data(1,grupi.ravno());
        goto naz;

      case 2 :
        bros[0]='\0';
        if(dirmatr(&kgr,&i,&naim_v,1,0,bros,0,0) == 0)
         {
          VV.data_z_plus(3,i);
         }
        
        goto naz;

      case 3 :
        vibrek("Plansh",&sheta,&naim);
        VV.VVOD_SPISOK_zapis_data(2,sheta.ravno());
        goto naz;
     }

  case FK4: /*Очистка меню*/
    VV.VVOD_clear_data();
    goto naz;    

  case FK5: /*Ввод дополнительной информации в шапку инвентаризационной ведомости*/
    iceb_redfil(IMAFDPI,0);
    goto naz;    

  default:
    goto naz;    
 }


if(dat1[0] == '\0' || rsdat(&dos,&mos,&gos,dat1,0) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
short dki=0,mki=0,gki=0;

if(kon_dat_is[0] != '\0')
if(rsdat(&dki,&mki,&gki,kon_dat_is,1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конечного использования !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

skl=0;
skl=(int)ATOFM(VV.VVOD_SPISOK_return_data(0));

SQLCURSOR cur,curtmp;

SQLCURSOR cur1;

char matot[40];
memset(matot,'\0',sizeof(matot));
if(skl != 0)
 {
  sprintf(strsql,"select naik,fmol from Sklad where kod=%d",
  skl);
  if(sql_readkey(&bd,strsql,&row,&cur) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,gettext("Не найден склад %d в списке складов !"),skl);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }

  strncpy(naiskl,row[0],sizeof(naiskl)-1);
  strncpy(matot,row[1],sizeof(matot)-1);
 }

/*Определяем количество складов в строке*/
mns=pole2(skladi,',');
if(skladi[0] != '\0' && mns == 0)
  mns=1; /*Только один склад в списке*/
else
  mns=0;
    
if(kodm[0] == '*' && maskmat == NULL)
 { 
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не создан список материалов !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 } 

MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите вид сортировки"));
MENU.VVOD_SPISOK_add_MD(gettext("Сортировать группа материалла-склад"));
MENU.VVOD_SPISOK_add_MD(gettext("Сортировать счет учета материалла-склад"));
MENU.VVOD_SPISOK_add_MD(gettext("Сортировать счет-группа материалла"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
srt=0;

while(menu3w(stdscr,&MENU,&srt,-1,-1,0) != 0);

if(srt == -1 || srt == 3 )
  return(1);

VVOD DANET(1);

DANET.VVOD_SPISOK_add_MD(gettext("Карточки с нулевыми остатками распечатывать ?"));

nkp=danet(&DANET,2,stdscr);

clear();
GDITE();





sprintf(strsql,"select * from Kart");
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной карточки !"));
  return(1);
 }

class iceb_t_tmptab tabtmp;
const char *imatmptab={"rasoskr"};

char zaprostmp[512];
memset(zaprostmp,'\0',sizeof(zaprostmp));

sprintf(zaprostmp,"CREATE TEMPORARY TABLE %s (\
shu char(24) not null,\
kgrm int not null,\
skl int not null,\
nk int not null,\
km int not null,\
naim char(112) not null,\
cena double(15,6) not null,\
nds char(32) not null,\
ei char(24) not null,\
ost double(16,6) not null,\
suma double(16,6) not null,\
datki char(10) not null,\
innom char(56) not null)",imatmptab);


if(tabtmp.create_tab(imatmptab,zaprostmp) != 0)
 return(-1);
time(&tmm);
bf=localtime(&tmm);

if(skl != 0 && mns == 1)
 {
  printw("%s\n\n%s N%d %s\n",organ,gettext("Перечень карточек по складу"),skl,naiskl);
 }
if(skl == 0)
 {
  printw("%s\n\n%s\n",organ,gettext("Перечень карточек по всем складам"));
 }

char data_k_is[32];
class iceb_tu_str invnom("");
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
/*
  printw("mt4.mz=%d mt4.sttr-%s\n",mt4.mz,mt4.sttr);
  refresh();
  */
  strzag(LINES-1,0,kolstr,++kolstr1);  

  if(proverka(skladi,row[0],0,0) != 0)
    continue;
  if(proverka(invnomp.ravno(),row[15],0,0) != 0)
    continue;

  if(kodm[0] != '\0')
   {
    if(kodm[0] == '*' && maskmat != NULL)
     {
      if(proverka(maskmat,row[2],0,0) != 0)
        continue;
     }
    else
      if(proverka(kodm,row[2],0,0) != 0)
        continue;
   }

  if(provnds(nds,row) != 0)
    continue;

  if(proverka(sheta.ravno(),row[5],0,0) != 0)
    continue;
  if(metkainnom == 1)
   if(row[15][0] == '\0')
     continue;

  naim.new_plus("");
  kgrm=0;
  /*Узнаем наименование материалла*/
  sprintf(strsql,"select * from Material where kodm=%s",row[2]);
  if(readkey(strsql,&row1,&cur1) != 1)
    {
     beep();
     printw("Не знайшли найменування матеріалу по коду %s\n",row[2]);
     OSTANOV();
    }
  else
   {
    naim.new_plus(row1[2]);
    kgrm=atoi(row1[1]);
    if(proverka(naim_mat.ravno(),row1[2],4,0) != 0)
     continue;
   }


  if(grupi.getdlinna() > 1)
   {
    sprintf(bros,"%d",kgrm);
    if(pole1(grupi.ravno(),bros,',',0,&i1) != 0)
     if(SRAV(grupi.ravno(),bros,0) != 0)
        continue;
   }

  rsdat(&d,&m,&g,row[18],2);
  memset(data_k_is,'\0',sizeof(data_k_is));
  if(dki != 0 )
   {
    if(d == 0)
     continue;
    if(sravmydat(d,m,g,dki,mki,gki) > 0)
     continue;    
   }
  if(d != 0)
   sprintf(data_k_is,"%02d.%02d.%04d",d,m,g);
  nk=atoi(row[1]);

  memset(ei,'\0',sizeof(ei));
  strncpy(ei,row[4],sizeof(ei)-1);
  ostkar(1,1,gos,dos,mos,gos,atoi(row[0]),nk,&ost);

  if(ost.ostg[3] < -0.0000001)
   {

    VVOD SOOB(1);
    sprintf(strsql,"%s !!!",gettext("Внимание"));
    SOOB.VVOD_SPISOK_add_MD(strsql);

    sprintf(strsql,"%s:%s %s:%d",gettext("Склад"),
    row[0],gettext("Карточка"),nk);
    SOOB.VVOD_SPISOK_add_MD(strsql);

    SOOB.VVOD_SPISOK_add_MD(gettext("Отрицательный остаток"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);

   }

  if(nkp == 1 || (nkp == 2 && (ost.ostg[3] > 0.0000001 || ost.ostg[3] < -0.0000001 )))
   {
    if(row[3][0] == '0')
     mnds=' ';    
    if(row[3][0] == '1')
     mnds='+';    

    bb=ost.ostg[3]*atof(row[6]);
    bb=okrug(bb,okrg1);

    invnom.new_plus("");
    if(row[15][0] != '\0')
     {
      invnom.new_plus(row[15]);
      if(row[14][0] != '\0')
       {
        char bros[512];
        short d,m,g;
        rsdat(&d,&m,&g,row[14],2);
        sprintf(bros," %d.%d.%d",d,m,g);
        invnom.plus(" ",bros);
       }
     }

    sprintf(strsql,"insert into %s values ('%s',%d,%s,%d,%s,'%s',%s,'%c%2.2g','%s',%.10g,%.10g,'%s','%s')",
    imatmptab,
    row[5],kgrm,row[0],nk,row[2],
    naim.ravno_filtr(),
    row[6],
    mnds,
    atof(row[9]),
    ei,
    ost.ostg[3],
    bb,
    data_k_is,
    invnom.ravno_filtr());

    sql_zapis(strsql,1,0);    

   }

 }

GDITE();
//fclose(ff);


printw(gettext("Сортируем записи"));
printw("\n");
refresh();

/*Сортировка по группе материала*/
if(srt == 0)
  sprintf(strsql,"select * from %s order by kgrm asc,skl asc,naim asc",imatmptab);

/*Сортировка по счету учета материала*/
if(srt == 1)
  sprintf(strsql,"select * from %s order by shu asc,skl asc,naim asc",imatmptab);
//Сортировка счет, группа
if(srt == 2) //Сортировка счет, группа
  sprintf(strsql,"select * from %s order by shu asc,kgrm asc,skl asc,naim asc",imatmptab);

int kolstrtmp=0;
if((kolstrtmp=curtmp.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }



printw(gettext("Распечатываем\n"));
refresh();

sprintf(imaf1,"sk%d_%d.lst",skl,getpid());

if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return(1);
 }

sprintf(imafiv,"inv%d_%d.lst",skl,getpid());

if((ff2 = fopen(imafiv,"w")) == NULL)
 {
  error_op_nfil(imafiv,errno,"");
  return(1);
 }



d=dos; m=mos; g=gos;
dpm(&d,&m,&g,1); //Увеличить на день
memset(mesqc,'\0',sizeof(mesqc));
mesc(m,1,mesqc);

kolstriv=0;
sapvin(matot,mesqc,g,gos,&kolstriv,&kollistiv,"",ff2);

kolstrlist=0;
if(skladi[0] != '\0')
 {
  if(skl != 0 && mns == 1)
   {
    fprintf(ff1,"%s\n\n%s %s %s\n\
%s %d.%d.%d%s  %s - %d:%d\n",
    organ,
    gettext("Перечень карточек по складу"),
    skladi,naiskl,
    gettext("По состоянию на"),
    bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
    gettext("г."),
    gettext("Время"),
    bf->tm_hour,bf->tm_min);
    kolstrlist=4;
   }
  else
   {
    fprintf(ff1,"%s\n\n%s %s\n\
%s %d.%d.%d%s  %s - %d:%d\n",
    organ,
    gettext("Перечень карточек по складу"),
    skladi,
    gettext("По состоянию на"),
    bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
    gettext("г."),
    gettext("Время"),
    bf->tm_hour,bf->tm_min);
    kolstrlist=4;
   }
 }

if(skladi[0] == '\0')
 {
  fprintf(ff1,"%s\n\n%s\n\
%s %d.%d.%d%s  %s - %d:%d\n",
  organ,
  gettext("Перечень карточек по всем складам"),
  gettext("По состоянию на"),
  bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
  gettext("г."),
  gettext("Время"),
  bf->tm_hour,bf->tm_min);
  kolstrlist=4;
 }

if(grupi.getdlinna() > 1)
 {
  fprintf(ff1,gettext("Групы: %s\n"),grupi.ravno());
  kolstrlist++;
 }
if(sheta.getdlinna() > 1)
 {
  fprintf(ff1,gettext("Счета учета: %s\n"),sheta.ravno());
  kolstrlist++;
 }
if(kodm[0] != '\0')
 {
  fprintf(ff1,gettext("Код материалла: %s\n"),kodm);
  kolstrlist++;
 }
if(naim_mat.ravno()[0] != '\0')
 {
  fprintf(ff1,"%s:%s\n",gettext("Наименование материалла"),naim_mat.ravno());
  kolstrlist++;
 }
if(invnom.ravno()[0] != '\0')
 {
  fprintf(ff1,"%s:%s\n",gettext("Инвентарный номер"),invnom.ravno());
  kolstrlist++;
 }
if(nds[0] != '\0')
 {
  fprintf(ff1,"%s:%s\n",gettext("НДС"),nds);
  kolstrlist++;
 }

if(kon_dat_is[0] != '\0')
 {
  fprintf(ff1,"%s:%s\n",gettext("Конечная дата использования"),kon_dat_is);
  kolstrlist++;
 }
 
if(nkp == 2)
 {
  fprintf(ff1,gettext("Карточки с нулевыми остатками не показаны !\n"));
  kolstrlist++;
 }
if(srt == 0)
 {
  fprintf(ff1,"%s\n",gettext("Сортировка по группам материалов"));
  kolstrlist++;
 }
if(srt == 1)
 {
  fprintf(ff1,"%s\n",gettext("Сортировка по счетам учета материалов"));
  kolstrlist++;
 }
if(srt == 2)
 {
  fprintf(ff1,"%s\n",gettext("Сортировка по счетам, группам"));
  kolstrlist++;
 }
if(metkainnom == 1)
 {
  fprintf(ff1,"%s\n",gettext("Только карточки с инвентарными номерами !"));
  kolstrlist++;
 }

shet[0]=shetz[0]=grup[0]=grupz[0]='\0';
itogshk=itogshs=0.;
itk=its=itgk=itgs=itok=itos=0.; 
kolstr1=sklz=0;

kolstrlist+=4;
kollist=1;
sapkk(dos,mos,gos,par,kollist,ff1);

int nomerstr=0;
int kodmat=0;
double cena=0.;
double kolih=0.,summa=0.;
char nds_str[32];
while(curtmp.read_cursor(&rowtmp) != 0)
 {
  strzag(LINES-1,0,kolstrtmp,++kolstr1);  

  strncpy(shet,rowtmp[0],sizeof(shet)-1);
  strncpy(grup,rowtmp[1],sizeof(grup)-1);
  skk=atoi(rowtmp[2]);
  nk=atoi(rowtmp[3]);
  kodmat=atoi(rowtmp[4]);
  naim.new_plus(rowtmp[5]);
  cena=atof(rowtmp[6]);
  strncpy(nds_str,rowtmp[7],sizeof(nds_str)-1);
  strncpy(ei,rowtmp[8],sizeof(ei)-1);
  kolih=atof(rowtmp[9]);
  summa=atof(rowtmp[10]);
  strncpy(data_k_is,rowtmp[11],sizeof(data_k_is)-1);
  invnom.new_plus(rowtmp[12]);





  if((srt == 1 || srt == 2) && SRAV(shetz,shet,0) != 0)
   {
    
    if(shetz[0] != '\0')
     {
      if(srt == 1 && par != OTN)
       { 
        if(mns != 1)
         {
          sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
          fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n");
          sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
          fprintf(ff1,"%-*s %10.10g  %10.2f\n",
          iceb_tu_kolbait(88,gettext("Итого по складу")),gettext("Итого по складу"),itok,itos);
         }
        itk+=itok;
        its+=itos;
        itok=itos=0.;
       }

      if(par != OTN)
       {
        sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
        fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n");
        sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
        fprintf(ff1,"%-*s %10.10g  %10.2f\n",
        iceb_tu_kolbait(88,gettext("Итого по счету")),gettext("Итого по счету"),
        itogshk,itogshs);

        sapkk1iv(&kolstriv,&kollistiv,ff2);
        fprintf(ff2,"\
---------------------------------------------------------------------------------------------------------------------------------\n");

        sapkk1iv(&kolstriv,&kollistiv,ff2);
        fprintf(ff2,"%-*s %10.10g %10.2f\n",
        iceb_tu_kolbait(62,gettext("Итого по счету")),gettext("Итого по счету"),
        itogshk,itogshs);
       }

      itogshk=itogshs=0.;

     }
    /*Определяем наименование счета*/
    memset(naish,'\0',sizeof(naish));
    sprintf(strsql,"select nais from Plansh where ns='%s'",shet);
    if(readkey(strsql,&row1,&cur1) != 1)
     {
      beep();
      printw(gettext("Не найден счет %s в плане счетов !"),shet);         
      printw("\n");
      OSTANOV();
     }
    else
     strncpy(naish,row1[0],sizeof(naish)-1);

    sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
    fprintf(ff1,"\n");
    sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
    fprintf(ff1,"%s: %s %s\n",gettext("Счет"),shet,naish);

    sapkk1iv(&kolstriv,&kollistiv,ff2);
    fprintf(ff2,"\n");
    sapkk1iv(&kolstriv,&kollistiv,ff2);
    fprintf(ff2,"%s: %s %s\n",gettext("Счет"),shet,naish);

    strcpy(shetz,shet);    
    sklz=0;
   }
      
  if((srt == 0 || srt == 2) && SRAV(grupz,grup,0) != 0)
   {
    
    if(grupz[0] != '\0')
     {

      if(par != OTN)
       {
        if(itok != 0. || itos != 0.)
         {
          sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
          fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n");
          sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
          fprintf(ff1,"%-*s %10.10g  %10.2f\n",
          iceb_tu_kolbait(88,gettext("Итого по складу")),gettext("Итого по складу"),itok,itos);
          itk+=itok;
          its+=itos;
          itok=itos=0.;
         }
        sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
        fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n");
        sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
        fprintf(ff1,"%-*s %10.10g  %10.2f\n",
        iceb_tu_kolbait(88,gettext("Итого по группе")),gettext("Итого по группе"),itgk,itgs);

        sapkk1iv(&kolstriv,&kollistiv,ff2);
        fprintf(ff2,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
        sapkk1iv(&kolstriv,&kollistiv,ff2);
        fprintf(ff2,"%-*s %10.10g %10.2f\n",
        iceb_tu_kolbait(62,gettext("Итого по группе")),gettext("Итого по группе"),itgk,itgs);
       }
      itgk=itgs=0.; 


     }
    /*Узнаем наименование группы*/
    sprintf(strsql,"select naik from Grup where kod=%s",grup);
    if(readkey(strsql,&row1,&cur1) != 1)
     {
       beep();
       printw("Нет группы %s\n",grup);
       refresh();
       strcpy(naimgr,"Не найдена группа !!!");
     }
    else
     strncpy(naimgr,row1[0],sizeof(naimgr)-1);
     
    sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
    fprintf(ff1,"\n");
    sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
    fprintf(ff1,"%s: %s %s\n",gettext("Группа"),grup,naimgr);

    sapkk1iv(&kolstriv,&kollistiv,ff2);
    fprintf(ff2,"\n");
    sapkk1iv(&kolstriv,&kollistiv,ff2);
    fprintf(ff2,"%s: %s %s\n",gettext("Группа"),grup,naimgr);

    strcpy(grupz,grup);
    sklz=0;
   }


  if(sklz != skk)
   {
    if(sklz != 0 && par != OTN)
     {

      if(mns != 1)
       {
        sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
        fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n");
        sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
        fprintf(ff1,"%-*s %10.10g  %10.2f\n",
        iceb_tu_kolbait(88,gettext("Итого по складу")),gettext("Итого по складу"),itok,itos);

       }      
      itk+=itok;
      its+=itos;
      itok=itos=0.;

      
     }
    memset(matot,'\0',sizeof(matot));
    memset(naimgr,'\0',sizeof(naimgr));
    /*Узнаем наименование Склада*/
    sprintf(strsql,"select naik,fmol from Sklad where kod=%d",skk);
    if(readkey(strsql,&row1,&cur1) != 1)
     {
       beep();
       printw("Нет склада %d\n",skk);
       refresh();
       strcpy(naimgr,"Не найден склад !!!");
     }
    else
     {
      strncpy(naimgr,row1[0],sizeof(naimgr)-1);
      strncpy(matot,row1[1],sizeof(matot)-1);
     }

    sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
    fprintf(ff1,"\n");
    sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
    fprintf(ff1,"%s: %d %s\n",gettext("Склад"),skk,naimgr);
    sklz=skk;    


   }
  itgk+=kolih;
  itgs+=summa;

  itogshk+=kolih;
  itogshs+=summa;

  itok+=kolih;
  itos+=summa;
   

  if(par == OTN)
   {

    sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
    fprintf(ff1,"%-*s|",iceb_tu_kolbait(7,shet),shet);
    fprintf(ff1,"%-2s|",grup);

    fprintf(ff1,"%-2d|",skk);

    fprintf(ff1,"%-5d|",nk);
    fprintf(ff1,"%-6d|",kodmat);
    fprintf(ff1,"%-*.*s|",iceb_tu_kolbait(37,naim.ravno()),iceb_tu_kolbait(37,naim.ravno()),naim.ravno());

    polen(str,bros,sizeof(bros),9,'|');
    fprintf(ff1," %-*s|",iceb_tu_kolbait(6,ei),ei);

    polen(str,bros,sizeof(bros),10,'|');
    fprintf(ff1,"%10.10g |",kolih);

    /*Остаток по документам*/
    class ostatokt ost;
    ostdok(1,1,gos,dos,mos,gos,skk,nk,&ost);
    fprintf(ff1,"%10.10g |",ost.ostg[3]);
    
    fprintf(ff1,"          |          |          |\n");

    sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);
    fprintf(ff1,"\
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");

   }
  else
   {
    //Читаем инвентарный номер
    memset(dopstr,'\0',sizeof(dopstr));
    memset(innom,'\0',sizeof(innom));
    memset(regnom,'\0',sizeof(regnom));
    dv=mv=gv=0;
    
    polen(str,sklad,sizeof(sklad),3,'|');
    polen(str,nomkar,sizeof(nomkar),4,'|');

    sprintf(strsql,"select datv,innom,rnd from Kart where sklad=%s and nomk=%s",sklad,nomkar);
    if(sql_readkey(&bd,strsql,&row,&cur1) == 1)
     {
      rsdat(&dv,&mv,&gv,row[0],2);
      strncpy(innom,row[1],sizeof(innom)-1);
      strncpy(regnom,row[2],sizeof(regnom)-1);
     }   

    if(innom[0] != '\0')
     {
      if( regnom[0] == '\0')
       {
        sprintf(dopstr,"%s:%s",gettext("Инвентарный номер"),innom);
        if(dv != 0)
         {
          memset(bros,'\0',sizeof(bros));
          sprintf(bros," %s:%d.%d.%d%s",
          gettext("Дата ввода в эксплуатацию"),
          dv,mv,gv,gettext("г."));
          strcat(dopstr,bros);
         }
       }        
      else
       {
        sprintf(dopstr,"%s:%s",gettext("Регистрационный номер"),regnom);
        memset(bros,'\0',sizeof(bros));
        sprintf(bros," %s:%s",gettext("Серия"),innom);
        strcat(dopstr,bros);
        if(dv != 0)
         {
          memset(bros,'\0',sizeof(bros));
          sprintf(bros," %s:%d.%d.%d%s",
          gettext("Дата регистрации"),
          dv,mv,gv,gettext("г."));
          strcat(dopstr,bros);
         }
       }
     }    


    sapkk1(dos,mos,gos,par,ff1,&kolstrlist,&kollist);

    fprintf(ff1,"%-*s |%2d|%-2d|%-5d|%-6d|%-*.*s|%10s ",
    iceb_tu_kolbait(6,shet),shet,
    atoi(grup),skk,nk,kodmat,
    iceb_tu_kolbait(37,naim.ravno()),iceb_tu_kolbait(37,naim.ravno()),naim.ravno(),
    prcn(cena));

    fprintf(ff1,"|%-3s| %-*s|%10.10g |%10.2f|%10s|%s\n",
    nds_str,
    iceb_tu_kolbait(6,ei),ei,
    kolih,summa,data_k_is,invnom.ravno());


    sapkk1iv(&kolstriv,&kollistiv,ff2);

    fprintf(ff2,"%3d|%-*.*s|%-*s|%10.10g|%10.10g|%10.2f|%10s|%10s|%10s|%10s|\n",
    ++nomerstr,
    iceb_tu_kolbait(40,naim.ravno()),iceb_tu_kolbait(40,naim.ravno()),naim.ravno(),
    iceb_tu_kolbait(6,ei),ei,
    cena,kolih,summa," "," "," "," ");
    if(dopstr[0] != '\0')
     {
      sapkk1iv(&kolstriv,&kollistiv,ff2);
      fprintf(ff2,"%s\n",dopstr);
     }
    sapkk1iv(&kolstriv,&kollistiv,ff2);
    fprintf(ff2,"\
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");
   }


 }

itk+=itok;
its+=itos;

if(par != OTN)
 {
  if(mns == 1)
   {
    if(srt == 0)
     {
      fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g  %10.2f\n",iceb_tu_kolbait(88,gettext("Итого по группе")),gettext("Итого по группе"),itgk,itgs);

      fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g  %10.2f\n",iceb_tu_kolbait(88,gettext("Общий итог")),gettext("Общий итог"),itk,its);

      fprintf(ff2,"\
---------------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g %10.2f\n",iceb_tu_kolbait(62,gettext("Итого по группе")),gettext("Итого по группе"),itgk,itgs);

      fprintf(ff2,"\
---------------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g %10.2f\n",iceb_tu_kolbait(62,gettext("Общий итог")),gettext("Общий итог"),itk,its);
     }

    if(srt == 1)
     {
      fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g  %10.2f\n",iceb_tu_kolbait(88,gettext("Итого по счету")),gettext("Итого по счету"),
       itogshk,itogshs);

      fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g  %10.2f\n",iceb_tu_kolbait(88,gettext("Общий итог")),gettext("Общий итог"),itk,its);

      fprintf(ff2,"\
---------------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g %10.2f\n",iceb_tu_kolbait(62,gettext("Итого по счету")),gettext("Итого по счету"),
       itogshk,itogshs);

      fprintf(ff2,"\
---------------------------------------------------------------------------------------------------------------------------------\n\
%-62s %10.10g %10.2f\n",gettext("Общий итог"),itk,its);
     }

    if(srt == 2)
     {

      fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g  %10.2f\n",iceb_tu_kolbait(88,gettext("Итого по складу")),gettext("Итого по складу"),itok,itos);

      fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g  %10.2f\n",iceb_tu_kolbait(88,gettext("Итого по группе")),gettext("Итого по группе"),itgk,itgs);

      fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g  %10.2f\n",iceb_tu_kolbait(88,gettext("Итого по счету")),gettext("Итого по счету"),itgk,itgs);

      fprintf(ff2,"\
---------------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g  %10.2f\n",iceb_tu_kolbait(88,gettext("Итого по группе")),gettext("Итого по группе"),itgk,itgs);

      fprintf(ff2,"\
---------------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g %10.2f\n",iceb_tu_kolbait(62,gettext("Итого по счету")),gettext("Итого по счету"),itgk,itgs);

     }
   }

  if(mns != 1)
   {
     fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g  %10.2f\n",iceb_tu_kolbait(88,gettext("Итого по складу")),gettext("Итого по складу"),itok,itos);

    if(srt == 0 || srt == 2)
     {
      fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g  %10.2f\n",iceb_tu_kolbait(88,gettext("Итого по группе")),gettext("Итого по группе"),itgk,itgs);
      fprintf(ff2,"\
---------------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g %10.2f\n",iceb_tu_kolbait(62,gettext("Итого по группе")),gettext("Итого по группе"),itgk,itgs);
     }
    if(srt == 1 || srt == 2)
     {
      fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g  %10.2f\n",iceb_tu_kolbait(88,gettext("Итого по счету")),gettext("Итого по счету"),
       itogshk,itogshs);
      fprintf(ff2,"\
---------------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g %10.2f\n",iceb_tu_kolbait(62,gettext("Итого по счету")),gettext("Итого по счету"),
       itogshk,itogshs);
     }
    fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g  %10.2f\n",iceb_tu_kolbait(88,gettext("Общий итог")),gettext("Общий итог"),itk,its);
    fprintf(ff2,"\
---------------------------------------------------------------------------------------------------------------------------------\n\
%-*s %10.10g %10.2f\n",iceb_tu_kolbait(62,gettext("Общий итог")),gettext("Общий итог"),itk,its);
   }
}

printw("%*s %8.8g %8.2f\n",iceb_tu_kolbait(47,gettext("Общий итог")),gettext("Общий итог"),itk,its);

koncinv(mesqc,gos,ff2);

fclose(ff1);

fclose(ff2);

printw("\n\n%s %s %s\n\n",
gettext("Распечатка выгружена в файл"),
imaf1,imafiv);
printw("%s:%d/%d\n",gettext("Количество листов"),
kollist,kollistiv);

OSTANOV();

oth->spis_imaf.plus(imaf1);
oth->spis_naim.plus(gettext("Распечатка карточек на складе"));
oth->spis_imaf.plus(imafiv);
oth->spis_naim.plus(gettext("Инвентаризационная ведомость"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),1);

return(0);
}

/***************/
/*Счетчик строк*/
/****************/
void		sapkk1(short dos,short mos,short gos,
short par,FILE *ff1,int *kolstrlist,int *kollist)
{

*kolstrlist+=1;

if(*kolstrlist <= kol_strok_na_liste)
 return;

*kollist+=1;
fprintf(ff1,"\f");

*kolstrlist=4; //Размер шапки
*kolstrlist+=1; //СТРОКА которая должна быть выведена

sapkk(dos,mos,gos,par,*kollist,ff1);


}


/*************/
/*Шапка*/
/*************/

void sapkk(short dos,short mos,short gos, //дата остатка
short par,int kollist,FILE *ff1)
{

 
if(par == OTN)
 {
  fprintf(ff1,"%100s %s%d\n\
----------------------------------------------------------------------------------------------------------------------------------\n",
  " ",gettext("Лист N"),kollist);
  fprintf(ff1,gettext("  Счет |Гр|Ск| Н/К |  Код |            Наименование             |  Е.и. | Остаток   |Остаток док|          |          |          |\n"));

  fprintf(ff1,"\
----------------------------------------------------------------------------------------------------------------------------------\n");
 }
else
 {

  fprintf(ff1,"%s:%02d.%02d.%04d %s %s %50s %s%d\n\
---------------------------------------------------------------------------------------------------------------------------\n",
  gettext("Остатки вычислены на"),
  dos,mos,gos,gettext("г."),
  gettext("включительно"),
  " ",gettext("Лист N"),kollist);

  fprintf(ff1,gettext(" Счет  |Гр|Ск| Н/К |  Код |            Наименование             |    Цена   |НДС|  Е.и. | Остаток   |  Сумма   |К.дата исп|\n"));
  fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------\n");
 }
}

