/* $Id: rasprov.c,v 5.36 2011-01-13 13:43:23 sasa1 Exp $ */
/*17.04.2010	27.04.1999	Белых А.И.	rasprov.c
Распечатка проводок в файл
*/
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void raspitog(double,double,int,FILE*);

extern char	*organ;

int rasprov(SQLCURSOR *cur,
int kolstr,
class poiprov_rek *poi)
{
SQL_str         row,row1;
char		imaf[56],imafden[56],imafsvod[56];
FILE		*ff1,*ffden,*ffsvod;
time_t		tmm;
struct  tm      *bf;
double		dbt,krt;
double		dbtden=0.,krtden=0.;
double		dbtmes=0.,krtmes=0.;
char		naikon[512];
char		strsql[512];
char		shet[32];
char		shetk[32];
long		kol;
short		d,m,g;
short		denz,mesz;
int		i;
double		debet,kredit;
int		nomer=0;
char		koment[512];
short dn,mn,gn;
short dk,mk,gk;
rsdat(&dn,&mn,&gn,poi->dat1,1);
rsdat(&dk,&mk,&gk,poi->dat2,1);


SQLCURSOR       cur1;
VVOD SOOBN(1);
SOOBN.VVOD_SPISOK_add_MD(gettext("Выгружаем проводки в файл."));
soobsh(&SOOBN,-1,-1,1);

move(LINES-1,0);
GDITE();

sprintf(imaf,"prov%d.lst",getpid());
if((ff1 = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

sprintf(imafden,"provd%d.lst",getpid());
if((ffden = fopen(imafden,"w")) == NULL)
 {
  error_op_nfil(imafden,errno,"");
  return(1);
 }

sprintf(imafsvod,"provs%d.lst",getpid());
if((ffsvod = fopen(imafsvod,"w")) == NULL)
 {
  error_op_nfil(imafsvod,errno,"");
  return(1);
 }

time(&tmm);
bf=localtime(&tmm);

zagolov(gettext("Распечатка проводок"),bf,dn,mn,gn,dk,mk,gk,organ,ff1);
zagolov(gettext("Распечатка проводок"),bf,dn,mn,gn,dk,mk,gk,organ,ffden);
zagolov(gettext("Свод по счетам"),bf,dn,mn,gn,dk,mk,gk,organ,ffsvod);


fprintf(ff1,gettext("Реквизиты поиска:\n"));
fprintf(ffden,gettext("Реквизиты поиска:\n"));
fprintf(ffsvod,gettext("Реквизиты поиска:\n"));
if(poi->sh[0] != '\0')
 {
  fprintf(ff1,gettext("Счет %s\n"),poi->sh);
  fprintf(ffden,gettext("Счет %s\n"),poi->sh);
  fprintf(ffsvod,gettext("Счет %s\n"),poi->sh);
 }
if(poi->shk[0] != '\0')
 {
  fprintf(ff1,gettext("Счет корреспондент %s\n"),poi->shk);
  fprintf(ffden,gettext("Счет корреспондент %s\n"),poi->shk);
  fprintf(ffsvod,gettext("Счет корреспондент %s\n"),poi->shk);
 }
if(poi->kor[0] != '\0')
 {
  fprintf(ff1,gettext("Код контрагента %s\n"),poi->kor);
  fprintf(ffden,gettext("Код контрагента %s\n"),poi->kor);
  fprintf(ffsvod,gettext("Код контрагента %s\n"),poi->kor);
 }
if(poi->raz[0] != '\0')
 {
  fprintf(ff1,gettext("Коментарий %s\n"),poi->raz);
  fprintf(ffden,gettext("Коментарий %s\n"),poi->raz);
  fprintf(ffsvod,gettext("Коментарий %s\n"),poi->raz);
 }
if(poi->deb[0] != '\0')
 {
  fprintf(ff1,gettext("Дебет %s\n"),poi->deb);
  fprintf(ffden,gettext("Дебет %s\n"),poi->deb);
  fprintf(ffsvod,gettext("Дебет %s\n"),poi->deb);
 }
if(poi->kre[0] != '\0')
 {
  fprintf(ff1,gettext("Кредит %s\n"),poi->kre);
  fprintf(ffden,gettext("Кредит %s\n"),poi->kre);
  fprintf(ffsvod,gettext("Кредит %s\n"),poi->kre);
 }
if(poi->kto[0] != '\0')
 {
  fprintf(ff1,gettext("Метка проводки %s\n"),poi->kto);
   fprintf(ffden,gettext("Метка проводки %s\n"),poi->kto);
  fprintf(ffsvod,gettext("Метка проводки %s\n"),poi->kto);
 }
if(poi->nn[0] != '\0')
 {
  fprintf(ff1,gettext("Номер документа %s\n"),poi->nn);
  fprintf(ffden,gettext("Номер документа %s\n"),poi->nn);
  fprintf(ffsvod,gettext("Номер документа %s\n"),poi->nn);
 }
if(poi->kop[0] != '\0')
 {
  fprintf(ff1,gettext("Код операции %s\n"),poi->kop);
  fprintf(ffden,gettext("Код операции %s\n"),poi->kop);
  fprintf(ffsvod,gettext("Код операции %s\n"),poi->kop);
 }  
if(poi->grupa[0] != '\0')
 {
  fprintf(ff1,"%s:%s\n",gettext("Группа"),poi->grupa);
  fprintf(ffden,"%s:%s\n",gettext("Группа"),poi->grupa);
  fprintf(ffsvod,"%s:%s\n",gettext("Группа"),poi->grupa);
 }  

if(poi->status[0] != '\0')
 {
  fprintf(ff1,"%s:%s\n",gettext("Статус счетов"),poi->status);
  fprintf(ffden,"%s:%s\n",gettext("Статус счетов"),poi->status);
  fprintf(ffsvod,"%s:%s\n",gettext("Статус счетов"),poi->status);
 }  

if(poi->kekv_poi[0] != '\0')
 {
  fprintf(ff1,"%s:%s\n",gettext("КЭКЗ"),poi->kekv_poi);
  fprintf(ffden,"%s:%s\n",gettext("КЭКЗ"),poi->kekv_poi);
  fprintf(ffsvod,"%s:%s\n",gettext("КЭКЗ"),poi->kekv_poi);
 }  
if(poi->dat1z[0] != '\0')
 {
  fprintf(ff1,"%s:%s => %s\n",gettext("Поиск по дате записи"),poi->dat1z,poi->dat2z);
  fprintf(ffden,"%s:%s => %s\n",gettext("Поиск по дате записи"),poi->dat1z,poi->dat2z);
  fprintf(ffsvod,"%s:%s => %s\n",gettext("Поиск по дате записи"),poi->dat1z,poi->dat2z);
 }  

rapsap(ff1);

rapsap(ffden);

SPISOK SHET(0);
masiv_din_double DEB(0); //Массив содержимого кодов начислений
masiv_din_double KRE(0); //Массив содержимого кодов начислений

mesz=denz=0;
kol=0;
dbt=krt=0.;
cur->poz_cursor(0);
while(cur->read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kol);
  if(provprov(row,poi) != 0)
    continue;

  rsdat(&d,&m,&g,row[1],2);
  debet=atof(row[9]);
  kredit=atof(row[10]);

  sprintf(strsql,"%s|%s",row[2],row[3]);
  if((nomer=SHET.find(strsql)) != -1)
   {
    DEB.plus(debet,nomer);
    KRE.plus(kredit,nomer);
   }  
  else
   {
    SHET.plus(strsql);
    DEB.plus(debet,-1);
    KRE.plus(kredit,-1);
   }
  if(denz != d)
   {
    if(denz != 0)
      raspitog(dbtden,krtden,1,ffden);
    
    dbtden=krtden=0.;
    denz=d;
   }
  if(mesz != m)
   {
    if(mesz != 0)
      raspitog(dbtmes,krtmes,2,ffden);
    
    dbtmes=krtmes=0.;
    mesz=m;
   }
  memset(naikon,'\0',sizeof(naikon));;
  
  if(row[4][0] != '\0')
   {  
    sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",
    row[4]);
    if((i=readkey(strsql,&row1,&cur1)) != 1)
     {
      printw("%02d.%02d.%d %-5s %-5s %-5s %-3s %-4s %10.2f %10.2f %s%-10.10s\n\
Error %d\n",      
      d,m,g,row[2],row[3],row[4],row[5],row[6],
      debet,kredit,row[8],row[13],i);
      beep();
      printw("\n%s %s\n",gettext("Не найден код контрагента"),row[4]);
      OSTANOV();
     }
    else
     strncpy(naikon,row1[0],sizeof(naikon)-1);
   }       

  sozkom(koment,sizeof(koment),row[13],row[5],row[8]);

  fprintf(ff1,"%02d.%02d.%4d %-*s %-*s %-*s %-*s%*s %-*s %10s",
  d,m,g,
  iceb_tu_kolbait(6,row[2]),row[2],
  iceb_tu_kolbait(6,row[3]),row[3],
  iceb_tu_kolbait(5,row[4]),row[4],
  iceb_tu_kolbait(3,row[5]),row[5],
  iceb_tu_kolbait(4,row[11]),row[11],
  iceb_tu_kolbait(10,row[6]),row[6],
  prnbr(debet));

  fprintf(ff1," %10s %*s %s %-*s %s\n",
  prnbr(kredit),
  iceb_tu_kolbait(4,row[16]),row[16],
  row[8],
  iceb_tu_kolbait(32,koment),koment,
  naikon);

  fprintf(ffden,"%02d.%02d.%4d %-*s %-*s %-*s %-*s%*s %-*s %10s",
  d,m,g,
  iceb_tu_kolbait(6,row[2]),row[2],
  iceb_tu_kolbait(6,row[3]),row[3],
  iceb_tu_kolbait(5,row[4]),row[4],
  iceb_tu_kolbait(3,row[5]),row[5],
  iceb_tu_kolbait(4,row[11]),row[11],
  iceb_tu_kolbait(10,row[6]),row[6],
  prnbr(debet));

  fprintf(ffden," %10s %*s %s %-*s %s\n",
  prnbr(kredit),
  iceb_tu_kolbait(4,row[16]),row[16],
  row[8],
  iceb_tu_kolbait(32,koment),koment,
  naikon);


  if(poi->dat1z[0] != '\0')
   {
    tmm=atoi(row[12]);
    bf=localtime(&tmm);

    fprintf(ff1,"%s: %d.%d.%d%s %s: %d:%d:%d\n",
    gettext("Дата записи проводки"),
    bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
    gettext("г."),
    gettext("Время"),
    bf->tm_hour,bf->tm_min,bf->tm_sec);

    fprintf(ffden,"%s: %d.%d.%d%s %s: %d:%d:%d\n",
    gettext("Дата записи проводки"),
    bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
    gettext("г."),
    gettext("Время"),
    bf->tm_hour,bf->tm_min,bf->tm_sec);

   }

  dbt+=debet;
  krt+=kredit;
  dbtden+=debet;
  krtden+=kredit;
  dbtmes+=debet;
  krtmes+=kredit;
 }

raspitog(dbt,krt,0,ff1);
raspitog(dbtden,krtden,1,ffden);
raspitog(dbtmes,krtmes,2,ffden);
raspitog(dbt,krt,0,ffden);

podpis(ff1);
fclose(ff1);


podpis(ffden);
fclose(ffden);

/*******************************/
//Распечатка свода по счетам

fprintf(ffsvod,"\n");
fprintf(ffsvod,"\
----------------------------------------\n");
fprintf(ffsvod,gettext("\
  Счет  |Счет кор|  Дебет   |  Кредит  |\n"));
fprintf(ffsvod,"\
----------------------------------------\n");

int kolelem=SHET.kolih();

for(nomer=0; nomer < kolelem; nomer++)
 {
  strcpy(strsql,SHET.ravno(nomer));
  POLE(strsql,shet,1,'|');
  POLE(strsql,shetk,2,'|');
  
  fprintf(ffsvod,"%-*s %-*s %10.2f %10.2f\n",
  iceb_tu_kolbait(8,shet),shet,
  iceb_tu_kolbait(8,shetk),shetk,
  DEB.ravno(nomer),
  KRE.ravno(nomer));
  
 }
fprintf(ffsvod,"\
----------------------------------------\n");
fprintf(ffsvod,"%*s %10.2f %10.2f\n",
iceb_tu_kolbait(17,gettext("Итого")),gettext("Итого"),dbt,krt);

podpis(ffsvod);
fclose(ffsvod);

class spis_oth oth;

oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Распечатка проводок"));

oth.spis_imaf.plus(imafden);
oth.spis_naim.plus(gettext("Распечатка проводок с дневными итогами"));

oth.spis_imaf.plus(imafsvod);
oth.spis_naim.plus(gettext("Свод по счетам"));

for(int nom=0; nom < oth.spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth.spis_imaf.ravno(nom),0);

iceb_t_rabfil(&oth,"");

return(0);
}

/*******/
/*Шапка*/
/*******/
void	rapsap(FILE *ff1)
{

fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff1,gettext("\
  Дата    | Счет.|Сч.к-т|Конт.| Кто   |Номер док.|   Дебет  |  Кредит  |КЭКЗ|      К о м е н т а р и й       |Наименование контрагента|\n"));

fprintf(ff1,"\
---------------------------------------------------------------------------------------------------------------------------------------\n");

}
/************************************/
/*Формирование комментария           */
/************************************/

void	sozkom(char *koment,
int razmk, //размер комментрария
char *komentprov, //Коментарий из проводки
char *kto, //Из какой подсистемы сделана проводка
char *kodop) //Код операции
{
char   strsql[512];
SQL_str row1;
SQLCURSOR cur1;
memset(koment,'\0',razmk);
strncpy(koment,komentprov,razmk-1);
if(koment[0] != '\0')
  return;
  
if(koment[0] == '\0' && kto[0] == '\0' )
  return;

memset(strsql,'\0',sizeof(strsql));
if(SRAV(kto,gettext("МУ"),0) == 0)
 {
  sprintf(strsql,"select naik from Prihod where kod='%s'",kodop);
  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
    strncpy(koment,row1[0],razmk-1);
  else
   {
    sprintf(strsql,"select naik from Rashod where kod='%s'",kodop);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
      strncpy(koment,row1[0],razmk-1);
   }
 }

if(SRAV(kto,gettext("ПЛТ"),0) == 0)
 {
  sprintf(strsql,"select naik from Opltp where kod='%s'",kodop);
  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
    strncpy(koment,row1[0],razmk-1);
 }

if(SRAV(kto,gettext("КО"),0) == 0)
 {
  sprintf(strsql,"select naik from Кasop1 where kod='%s'",kodop);
  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
    strncpy(koment,row1[0],razmk-1);
  else
   {
    sprintf(strsql,"select naik from Kasop2 where kod='%s'",kodop);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
      strncpy(koment,row1[0],razmk-1);
   }
 }

if(SRAV(kto,gettext("УСЛ"),0) == 0)
 {
  sprintf(strsql,"select naik from Usloper1 where kod='%s'",kodop);
  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
    strncpy(koment,row1[0],razmk-1);
  else
   {
    sprintf(strsql,"select naik from usloper2 where kod='%s'",kodop);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
      strncpy(koment,row1[0],razmk-1);
   }
 }
   

}
