/* $Id: rasspdok.c,v 5.44 2011-01-13 13:43:23 sasa1 Exp $ */
/*23.12.2010    29.05.1997      Белых А.И.      rasspdok.c
Получение списка документов в материальном учете
*/
#include        <math.h>
#include        <time.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif
#define         PL      50  /*Количество строк на первом листе*/
#define         VL      55  /*Количество строк на втором листе*/

void		rasnak(int,short,short,short,char[],double*,double*,
double*,double*,short,double*,int,FILE*,FILE*,double*,float);

extern char     *organ;
extern double   okrg1;
extern double	okrcn;

int rasspdok(class spis_oth *oth)
{
char		str[1024];
char            bros[512];
int		srt; 
struct  tm      *bf;
FILE            *ff,*ff1,*ff2,*ffnp;
time_t		tmm;
char		imaf[24],imaf1[24],imaf2[24],imafnp[32];
static  char    dat1[11],dat2[11];
short           dn,mn,gn,dk,mk,gk;
short 	        d,m,g;
static char     kopz[112];
static char     kodoz[112];
static char     sklz[112];
static char     prra[8];
static char     grupk[112]; 
char            naior[512];
int           kom,kom1;
short           i;
double          suma,sumabn;
double		sp,spbn;
double		bb,bb1;
double		itog,itogsk,itognds;
char            kop[32]; /*код операции*/
char            kor[32],kor1[32]; /*код контрагента*/
char            nn[32],nnn[32];  /*номер накладной*/
char            telefon[112];

int		tipzz;
unsigned int    ndpp;
int		vidd;
short		vt;
char		otsr[24];
double		sumkor;
long		kolstr,kolstr1,kolstr2;
SQL_str         row,row1;
char		strsql[512];
int		skl;
int		lnds;
char		nm[512];
double		sumsnds=0.;
double		isumsnds=0.;
short		shek;
double		sumndspr=0.;
double		ndssum=0.;

VVOD MENU(3);
VVOD VV(0);

VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка списка документов"));
VV.VVOD_SPISOK_add_ZAG(gettext("Введите нужные реквизиты"));
VV.VVOD_SPISOK_add_ZAG(gettext("По не введенным реквизитам поиск не выполняется"));

VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(dat2,11);
VV.VVOD_SPISOK_add_data(kopz,sizeof(kopz));
VV.VVOD_SPISOK_add_data(kodoz,sizeof(kodoz));
VV.VVOD_SPISOK_add_data(sklz,sizeof(sklz));
VV.VVOD_SPISOK_add_data(prra,2);
VV.VVOD_SPISOK_add_data(grupk,sizeof(grupk));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала..(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца...(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Код операции..(,,)...."));
VV.VVOD_SPISOK_add_MD(gettext("Код контрагента..(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Склад (,,)............"));
VV.VVOD_SPISOK_add_MD(gettext("Приход/расход. (+/-).."));
VV.VVOD_SPISOK_add_MD(gettext("Код группы контр.(,,)."));

naz:;

clear();


helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("поиск"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strcpy(dat1,VV.VVOD_SPISOK_return_data(0));
strcpy(dat2,VV.VVOD_SPISOK_return_data(1));

kopz[0]='\0';
kodoz[0]='\0';
strncpy(kopz,VV.VVOD_SPISOK_return_data(2),sizeof(kopz)-1);
strncpy(kodoz,VV.VVOD_SPISOK_return_data(3),sizeof(kodoz)-1);
strncpy(sklz,VV.VVOD_SPISOK_return_data(4),sizeof(sklz)-1);
strncpy(prra,VV.VVOD_SPISOK_return_data(5),sizeof(prra)-1);
strncpy(grupk,VV.VVOD_SPISOK_return_data(6),sizeof(grupk)-1);
class iceb_tu_str kods("");
class iceb_tu_str naims("");
switch (kom)
 {

  case FK10:
  case ESC:
   return(1);

  case FK1:
    GDITE();
    iceb_t_pdoc("matu5_8.txt");
    clear();
    goto naz;

  case FK2:
  case PLU:
    break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка складов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка контрагентов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций приходов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций расходов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 5 :
      case -1:
       goto naz;

      case 0 :
        if(dirsklad(1,&kods,&naims) == 0)
         VV.data_z_plus(4,kods.ravno());
        goto naz;

      case 1 :
        vibrek("Kontragent",kodoz,sizeof(kodoz),nm);
        VV.VVOD_SPISOK_zapis_data(3,kodoz);
        goto naz;

      case 2 :
        vibrek("Prihod",kopz,sizeof(kopz),nm);
        VV.VVOD_SPISOK_zapis_data(2,kopz);
        goto naz;

      case 3 :
        vibrek("Rashod",kopz,sizeof(kopz),nm);
        VV.VVOD_SPISOK_zapis_data(2,kopz);
        goto naz;

      case 4 :
        vibrek("Gkont",grupk,sizeof(grupk),nm);
        VV.VVOD_SPISOK_zapis_data(6,grupk);
        goto naz;

     }
    goto naz;

  case FK4:
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
 }

if(rsdatp(&dn,&mn,&gn,dat1,&dk,&mk,&gk,dat2) != 0)
  goto naz;

tipzz=0;
if(VV.VVOD_SPISOK_return_data(5)[0] == '+')
  tipzz=1;
if(VV.VVOD_SPISOK_return_data(5)[0] == '-')
  tipzz=2;
  

MENU.VVOD_delete();

MENU.VVOD_SPISOK_add_MD(gettext("Сортировка по датам"));
MENU.VVOD_SPISOK_add_MD(gettext("Сортировка по номерам документов"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

srt=0;
while(menu3w(stdscr,&MENU,&srt,-1,-1,0) != 0);
if(srt == -1 || srt == 2)
  return(1);

MENU.VVOD_delete();

MENU.VVOD_SPISOK_add_MD(gettext("Только подтвержденные документы"));
MENU.VVOD_SPISOK_add_MD(gettext("Только не подтвержденные документы"));
MENU.VVOD_SPISOK_add_MD(gettext("Все документы"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

vidd=0;
while(menu3w(stdscr,&MENU,&vidd,-1,-1,0) != 0);
if(vidd == -1 || vidd == 3)
  return(1);

clear(); /*Очистить экран*/
GDITE();
time(&tmm);
bf=localtime(&tmm);

vt=0;
memset(bros,'\0',sizeof(bros));
//sprintf(strsql,"%s",iceb_t_imafnsi("matnast.alx"));
iceb_t_poldan("Код группы возвратная тара",bros,"matnast.alx");
vt=(short)ATOFM(bros);

move(0,0);
printw("%s %d.%d.%d%s %s %d.%d.%d%s\n",
gettext("Распечатка документов за период c"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."));
refresh();

/*Готовим файл для сортировки*/
sprintf(strsql,"select * from Dokummat where datd >= '%d-%02d-%02d' \
and datd <= '%d-%02d-%02d'",gn,mn,dn,gk,mk,dk);
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

sprintf(imaf1,"sp%d.tmp",getpid());

if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return(1);
 }

char data_nal_nak[11];
short dnn,mnn,gnn;
SQLCURSOR cur1;

kolstr2=kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  kolstr1++;
  strzag(LINES-1,0,kolstr,kolstr1);
/*
  printw("%d.%d.%d %d %s %s\n",mk1.d,mk1.m,mk1.g,mk1.tp,mk1.kop,mk1.kor);
*/

  if(tipzz != 0)
   if(tipzz != atoi(row[0]))
       continue;

  if(vidd == 0)
   if(atoi(row[7]) != 1 )
       continue;

  if(vidd == 1)
   if(atoi(row[7]) != 0 )
       continue;

  if(proverka(kodoz,row[3],0,0) != 0)
     continue;

  if(proverka(kopz,row[6],0,0) != 0)
     continue;

  if(proverka(sklz,row[2],0,0) != 0)
     continue;

  if(grupk[0] != '\0')
   {
    if(SRAV(row[3],"00-",1) == 0) 
      sprintf(strsql,"select grup from Kontragent where kodkon='%s'","00");
    else
      sprintf(strsql,"select grup from Kontragent where kodkon='%s'",row[3]);
    if(readkey(strsql,&row1,&cur1) == 1)
     {
      if(proverka(grupk,row1[0],0,0) != 0)
       continue;
    
     }
   }

  /* Период*/

  if(POLE(row[4],bros,2,'-') != 0)
   if(POLE(row[4],bros,2,'+') != 0)
    strcpy(bros,row[4]);
  ndpp=(unsigned int)ATOFM(bros);
  
  rsdat(&d,&m,&g,row[1],2);

  rsdat(&dnn,&mnn,&gnn,row[12],2);
  memset(data_nal_nak,'\0',sizeof(data_nal_nak));
  if(dnn > 0)
   sprintf(data_nal_nak,"%02d.%02d.%d",dnn,mnn,gnn);


  kolstr2++;    
  fprintf(ff1,"%s|%d|%d|%d|%d|%s|%s|%s|%s|%s|%s|%s|%s|\n",
  row[2],g,m,d,ndpp,row[4],row[3],row[6],row[5],row[13],data_nal_nak,row[11],row[0]);

 }

fclose(ff1);

printw("%s\n",gettext("Сортируем"));
refresh();
/*Сортировка файла*/

if(srt == 0)
 sprintf(bros,"sort -o %s -t\\| -k2,3n -k3,4n -k4,5n -k5,6n -k6,7n %s",imaf1,imaf1);
// sprintf(bros,"sort -o %s -t\\| +1n +2n +3n +4n +5n %s",imaf1,imaf1);
if(srt == 1)
 sprintf(bros,"sort -o %s -t\\| -k1,2n -k5,6n %s",imaf1,imaf1);
// sprintf(bros,"sort -o %s -t\\| +0n -1 +4n -5 %s",imaf1,imaf1);
runsystem(bros);

printw(gettext("Печатаем\n"));
refresh();

if((ff1 = fopen(imaf1,"r")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return(1);
 }


sprintf(imaf,"sp%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

sprintf(imaf2,"spn%d.lst",getpid());
if((ff2 = fopen(imaf2,"w")) == NULL)
 {
  error_op_nfil(imaf2,errno,"");
  return(1);
 }

sprintf(imafnp,"spnp%d.lst",getpid());
if((ffnp = fopen(imafnp,"w")) == NULL)
 {
  error_op_nfil(imafnp,errno,"");
  return(1);
 }

fprintf(ff,"%s\n%s %d.%d.%d%s %s %d.%d.%d%s\n",
organ,
gettext("Распечатка документов за период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."));

fprintf(ff2,"%s\n%s %d.%d.%d%s %s %d.%d.%d%s\n",
organ,
gettext("Распечатка документов за период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."));

fprintf(ffnp,"%s\n%s %d.%d.%d%s %s %d.%d.%d%s\n",
organ,
gettext("Распечатка документов за период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."));

fprintf(ffnp,"\n%s !\n",gettext("Только не подтвержденные записи в документах"));

if(tipzz == 1)
 {
  fprintf(ff,gettext("ТОЛЬКО ПРИХОДЫ.\n"));
  fprintf(ff2,gettext("ТОЛЬКО ПРИХОДЫ.\n"));
  fprintf(ffnp,gettext("ТОЛЬКО ПРИХОДЫ.\n"));
 }
if(tipzz == 2)
 {
  fprintf(ff,gettext("ТОЛЬКО РАСХОДЫ.\n"));
  fprintf(ff2,gettext("ТОЛЬКО РАСХОДЫ.\n"));
  fprintf(ffnp,gettext("ТОЛЬКО РАСХОДЫ.\n"));
 }
if(vidd == 0)
 {
  fprintf(ff,gettext("ТОЛЬКО ПОДТВЕРЖДЕННЫЕ ДОКУМЕНТЫ.\n"));
  fprintf(ff2,gettext("ТОЛЬКО ПОДТВЕРЖДЕННЫЕ ДОКУМЕНТЫ.\n"));
  fprintf(ffnp,gettext("ТОЛЬКО ПОДТВЕРЖДЕННЫЕ ДОКУМЕНТЫ.\n"));
 }
if(vidd == 1)
 {
  fprintf(ff,gettext("ТОЛЬКО НЕ ПОДТВЕРЖДЕННЫЕ ДОКУМЕНТЫ.\n"));
  fprintf(ff2,gettext("ТОЛЬКО НЕ ПОДТВЕРЖДЕННЫЕ ДОКУМЕНТЫ.\n"));
  fprintf(ffnp,gettext("ТОЛЬКО НЕ ПОДТВЕРЖДЕННЫЕ ДОКУМЕНТЫ.\n"));
 }
if(vidd == 3)
 {
  fprintf(ff,gettext("ВСЕ ДОКУМЕНТЫ.\n"));
  fprintf(ff2,gettext("ВСЕ ДОКУМЕНТЫ.\n"));
  fprintf(ffnp,gettext("ВСЕ ДОКУМЕНТЫ.\n"));
 }

if(kopz[0] != '\0')
 {
  fprintf(ff,"%s - %s\n",gettext("Код операции"),kopz);
  fprintf(ff2,"%s - %s\n",gettext("Код операции"),kopz);
  fprintf(ffnp,"%s - %s\n",gettext("Код операции"),kopz);
 }
if(kodoz[0] != '\0')
 {
  fprintf(ff,gettext("Код контрагента - %s\n"),kodoz);
  fprintf(ff2,gettext("Код контрагента - %s\n"),kodoz);
  fprintf(ffnp,gettext("Код контрагента - %s\n"),kodoz);
 }

if(sklz[0] != '\0')
 {
  fprintf(ff,gettext("Склад - %s\n"),sklz);
  fprintf(ff2,gettext("Склад - %s\n"),sklz);
  fprintf(ffnp,gettext("Склад - %s\n"),sklz);
 }

if(grupk[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Код группы контрагента"),grupk);
  fprintf(ff2,"%s:%s\n",gettext("Код группы контрагента"),grupk);
  fprintf(ffnp,"%s:%s\n",gettext("Код группы контрагента"),grupk);
 }

fprintf(ff,"\
%s %d.%d.%d%s %s - %d:%d\n",
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

fprintf(ff,"\
-------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("  Дата    |Дата отср.|Ном.док. |Нал. накл.|Дата н.нак|  Сумма  |Сум.кop.|Сумма с НДС|  По кассе |Контр.|  Наименование контрагента    |Код оп.|   Телефон   |\n"));

fprintf(ff,"\
-------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
itog=itogsk=itognds=0.;
sp=spbn=0.;
kolstr1=0;
float pnds=0.;
class iceb_tu_str nomdokp("");
int tipz=0;
while(fgets(str,sizeof(str),ff1) != NULL)
 {
  kolstr1++;
  strzag(LINES-1,0,kolstr2,kolstr1);
  POLE(str,bros,1,'|');
  skl=atoi(bros);

  POLE(str,bros,2,'|');
  g=atoi(bros);

  POLE(str,bros,3,'|');
  m=atoi(bros);

  POLE(str,bros,4,'|');
  d=atoi(bros);

  POLE(str,nn,6,'|');
  POLE(str,kor,7,'|');
  POLE(str,kop,8,'|');
  POLE(str,nnn,9,'|');
  POLE(str,bros,10,'|');
  pnds=atof(bros);
  
  polen(str,data_nal_nak,sizeof(data_nal_nak),11,'|');
  polen(str,&nomdokp,12,'|');
  polen(str,&tipz,13,'|');
      
  memset(naior,'\0',sizeof(naior));
  memset(telefon,'\0',sizeof(telefon));
  memset(kor1,'\0',sizeof(kor1));
  if(kor[0] == '0' && kor[1] == '0' && POLE(kor,kor1,2,'-') == 0)
   {
    sprintf(strsql,"select naik from Sklad where kod='%s'",kor1);
   }
  else
    sprintf(strsql,"select naikon,telef from Kontragent where kodkon='%s'",kor);

  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    beep();
    if(kor1[0] == '\0')
     {
      printw("%s %s\n",gettext("Не найден контрагент"),kor);
      fprintf(ff,"%s - %s\n",gettext("Не найден контрагент"),kor);
     }
    else
     {
      printw(gettext("Не найден склад %d в списке складов !"),atoi(kor1));
      printw("\n");
      fprintf(ff,gettext("Не найден склад %d в списке складов !"),atoi(kor1));
      fprintf(ff,"\n");
     }
    OSTANOV();
   }
  else
   {
    strncpy(naior,row1[0],sizeof(naior)-1);
    if(kor1[0] == '\0')
      strncpy(telefon,row1[1],sizeof(telefon)-1);
   }
 
  /*Узнаем дату отсрочки платежа*/

  sprintf(strsql,"select sodz from Dokummat2 \
  where god=%d and nomd='%s' and sklad=%d and nomerz=9",
  g,nn,skl);
  memset(otsr,'\0',sizeof(otsr));

  if((i=sql_readkey(&bd,strsql,&row1,&cur1)) == 1)
    strncpy(otsr,row1[0],sizeof(otsr)-1);   

  /*Узнаем НДС документа*/
  sprintf(strsql,"select sodz from Dokummat2 \
  where god=%d and nomd='%s' and sklad=%d and nomerz=11",
  g,nn,skl);
  lnds=0;
  if((i=sql_readkey(&bd,strsql,&row1,&cur1)) == 1)
     lnds=atoi(row1[0]);

  /*Узнаем Был ли распечатан кассовый чек*/
  sprintf(strsql,"select sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d and nomerz=5",
  g,nn,skl);
  shek=0;
  if((i=sql_readkey(&bd,strsql,&row1,&cur1)) == 1)
     shek=atoi(row1[0]);

  sumndspr=0.;

  //Читаем введенную сумму НДС для приходного документа
  sprintf(strsql,"select sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d and nomerz=6",
  g,nn,skl);
  if((i=sql_readkey(&bd,strsql,&row1,&cur1)) == 1)
     sumndspr=atoi(row1[0]);

  /*Узнаем сумму записей по накладной*/
  
  fprintf(ff2,"\n%d.%d.%d %s(%s) %s %s\n",d,m,g,nn,nomdokp.ravno(),kor,naior);

  fprintf(ffnp,"\n%d.%d.%d %s(%s) %s %s\n",d,m,g,nn,nomdokp.ravno(),kor,naior);

  rasnak(skl,d,m,g,nn,&suma,&sumabn,&sp,&spbn,vt,&sumkor,lnds,ff2,ffnp,
  &sumsnds,pnds);

  if(lnds == 0)
   {
    if(sumndspr != 0.)
     ndssum=sumndspr;
    else
     ndssum=(suma+sumkor)*pnds/100.;
    bb=suma+sumkor+sumabn+ndssum;
   }
  else
    bb=suma+sumkor+sumabn;

  bb=okrug(bb,okrg1);
  bb1=suma+sumabn;
  itog+=bb1;
  itognds+=bb;

  if(shek != 0)
   {
    isumsnds+=sumsnds;
   }
  else
   sumsnds=0.;  
  itogsk+=sumkor;

  printw("%02d.%02d.%d %-*s %-*.*s %-*s %8.2f %8.8g %8.2f %8.2f\n",
  d,m,g,
  iceb_tu_kolbait(5,kor),kor,
  iceb_tu_kolbait(15,naior),iceb_tu_kolbait(15,naior),naior,
  iceb_tu_kolbait(9,nn),nn,
  bb1,sumkor,bb,sumsnds);
  
   
  fprintf(ff,"%02d.%02d.%d %*.*s %-*s %-*s %10s %9.2f %8.8g %11.2f %11.2f %-*s %-*.*s %-*s %s\n",
  d,m,g,
  iceb_tu_kolbait(10,otsr),iceb_tu_kolbait(10,otsr),otsr,
  iceb_tu_kolbait(9,nn),nn,
  iceb_tu_kolbait(10,nnn),nnn,
  data_nal_nak,bb1,sumkor,bb,sumsnds,
  iceb_tu_kolbait(6,kor),kor,
  iceb_tu_kolbait(30,naior),iceb_tu_kolbait(30,naior),naior,
  iceb_tu_kolbait(7,kop),kop,
  telefon);

  if(tipz == 1)  
   {
    sprintf(strsql,"select vido from Prihod where kod='%s'",kop);
    if(readkey(strsql,&row1,&cur1) == 1)
     if(atoi(row1[0]) == 0)    
      if(nomdokp.getdlinna() > 1)
        fprintf(ff,"%10s %10s %-*s\n","","",iceb_tu_kolbait(9,nomdokp.ravno()),nomdokp.ravno());
   }
 }

fprintf(ff,"\
-------------------------------------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,"%*s: %10.2f %8.8g %11.2f %11.2f\n",
iceb_tu_kolbait(51,gettext("Итого")),gettext("Итого"),itog,itogsk,itognds,isumsnds);

printw("%*s: %8.2f %8.8g %8.2f %8.2f\n",
iceb_tu_kolbait(30,gettext("Итого")),gettext("Итого"),itog,itogsk,itognds,isumsnds);

podpis(ff);


fprintf(ff2,"%s:\n\
-----------------------------------------------------------------------------------------------\n",
gettext("Общий итог"));

fprintf(ff2,"%*s: %10.2f %10s %10.2f\n",
iceb_tu_kolbait(60,gettext("Итого")),gettext("Итого"),itog," ",sp+spbn);

bb=sp+spbn+sp*pnds/100.;
bb=okrug(bb,okrg1);
fprintf(ff2,"%*s %10.2f %10s %10.2f\n",
iceb_tu_kolbait(61,gettext("Итого")),gettext("Итого с НДС:"),itognds," ",bb);

podpis(ff2);
podpis(ffnp);


fclose(ff);
fclose(ff1);
fclose(ff2);
fclose(ffnp);
unlink(imaf1);

printw_vr(tmm);

OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Список документов"));

oth->spis_imaf.plus(imaf2);
oth->spis_naim.plus(gettext("Содержимое документов"));
oth->spis_imaf.plus(imafnp);
oth->spis_naim.plus(gettext("Неподтверждённые записи в документах"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),3);
 
return(0);
}

/*********************************************************************/

void		rasnak(int skl,short d,short m,short g,char nn[],
double *suma,double *sumabn,double *sp,double *spbn,
short vt,double *sumkor,int lnds,FILE *ff,FILE *ffnp,double *sumsnds,float pnds)
{
long		kolstr;
SQL_str         row,row1;
char		strsql[512];
double		bb,bb1;
short		ks;
double		kol;
double		itog[2];
double		sumap,sumapbn;
char		naim[512];
char		ei[56];
short		vtr;
double		kolih,cena;
int		nk;
short		kgrm;
char		bros[512];
short		mnds; /*1-НДС в том числе*/
char		nomn[56]; /*Номенклатурный номер*/
char		shu[56];
double		sumands=0.;
double		sumandspod=0.;
double		sumandspr=0.; //Сумма НДС для приходного документа введенная вручную
SQLCURSOR cur;
SQLCURSOR cur1;


/*Узнаем сумму скидки*/
sprintf(strsql,"select sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d and nomerz=13",
g,nn,skl);

*sumkor=0.;
if(sql_readkey(&bd,strsql,&row,&cur) == 1)
  *sumkor=atof(row[0]);

//Узнаем сумму НДС
sprintf(strsql,"select sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d and nomerz=6",
g,nn,skl);

if(sql_readkey(&bd,strsql,&row,&cur) == 1)
  sumandspr=atof(row[0]);


/*Узнаем сумму всех записей*/
*sumsnds=*suma=*sumabn=0.;
sumap=sumapbn=0.;

sprintf(strsql,"select kodm,kolih,cena,voztar,ei,nomkar,mnds \
from Dokummat1 where datd='%04d-%02d-%02d' and sklad=%d and nomd='%s' \
order by kodm asc",g,m,d,skl,nn);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  return;
 }

fprintf(ff,"-----------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext(" N |       Наименование продукции |Ед. |Количество|  Ц е н а | С у м м а|Количество|Сума под-|\n"));
fprintf(ff,gettext("   |              (товару)        |изм.|          |          |          |подтвержд.|тверждена |\n"));
fprintf(ff,"-----------------------------------------------------------------------------------------------\n");

fprintf(ffnp,"-----------------------------------------------------------------------------------------------\n");
fprintf(ffnp,gettext(" N |       Наименование продукции |Ед. |Количество|  Ц е н а | С у м м а|Количество|Сумма под-|\n"));
fprintf(ffnp,gettext("   |              (товару)        |изм.|          |          |          |подтвержд.|тверждена |\n"));
fprintf(ffnp,"-----------------------------------------------------------------------------------------------\n");

ks=0;
memset(nomn,'\0',sizeof(nomn));
itog[0]=itog[1]=0.;
while(cur.read_cursor(&row) != 0)
 {
/*   printw("*%d %d %s\n",mk2.g,mk2.skl,mk2.nn);*/
  kolih=atof(row[1]);
  cena=atof(row[2]);
//Для вложенного налога
  if(lnds == 0)
    bb=cena+cena*pnds/100.;
  else
    bb=cena;

  bb=okrug(bb,okrg1);
 
  bb=bb*kolih;

  *sumsnds+=okrug(bb,okrg1);

  cena=okrug(cena,okrcn);
  vtr=atoi(row[3]);
  strncpy(ei,row[4],sizeof(ei)-1);
  nk=atoi(row[5]);
  mnds=atoi(row[6]);  
  bb=cena*kolih;
  bb=okrug(bb,okrg1);

  /*Узнаем код группы*/
  sprintf(strsql,"select naimat,kodgr from Material where kodm=%s",
  row[0]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    beep();
    printw("%s %s !\n",gettext("Не найден код материалла"),row[0]);
    OSTANOV();
   }
  strcpy(naim,row1[0]);
  kgrm=atoi(row1[1]);
  
  if(vtr == 1 || kgrm == vt || lnds > 0 || mnds == 1)
    *sumabn=*sumabn+bb;
  else
    *suma=*suma+bb;

  kol=readkolk(skl,nk,d,m,g,nn);  
    
  bb=cena*kolih;
  bb=okrug(bb,okrg1);

  bb1=cena*kol;
  bb1=okrug(bb1,okrg1);

  ks++;
  /*Узнаем счет учета для номенклатурного номера*/
  memset(nomn,'\0',sizeof(nomn));
  if(nk != 0)
   {
    memset(shu,'\0',sizeof(shu));
    sprintf(strsql,"select shetu from Kart where sklad=%d and nomk=%d",
    skl,nk);
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
      beep();
      printw("Не найдена карточка %d на складе %d !\n",nk,skl);
      OSTANOV();
     }
    else
     {
      strncpy(shu,row1[0],sizeof(shu)-1);
     }
    sprintf(nomn,"%d.%s.%s.%d",skl,shu,row[0],nk);
   }

  fprintf(ff,"%3d %-*.*s %-*.*s %10.10g %10.10g %10.2f %10.10g %10.2f %s\n",
  ks,
  iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim,
  iceb_tu_kolbait(4,ei),iceb_tu_kolbait(4,ei),ei,
  kolih,cena,bb,kol,bb1,nomn);

  if(kol == 0.)
   fprintf(ffnp,"%3d %-*.*s %-*.*s %10.10g %10.10g %10.2f %10.10g %10.2f %s\n",
   ks,
   iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim,
   iceb_tu_kolbait(4,ei),iceb_tu_kolbait(4,ei),ei,
   kolih,cena,bb,kol,bb1,nomn);

  if(vtr == 1 || kgrm == vt || lnds > 0 || mnds == 1)
    sumapbn+=bb1;
  else
    sumap+=bb1;

 }

/*Читаем услуги*/

sprintf(strsql,"select * from Dokummat3 where datd='%04d-%02d-%02d' and \
sklad=%d and nomd='%s'",g,m,d,skl,nn);
/*printw("\nstrsql=%s\n",strsql);*/
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr != 0)
while(cur.read_cursor(&row) != 0)
 {

  kolih=atof(row[4]);
  cena=atof(row[5]);
  cena=okrug(cena,okrcn);

//Для вложенного налога
  bb=cena+cena*pnds/100.;
  bb=okrug(bb,okrg1);
  bb=bb*kolih;
  *sumsnds+=okrug(bb,okrg1);
  
  if(kolih > 0)
    bb=kolih*cena;
  else
    bb=cena;
  bb=okrug(bb,okrg1);
  *suma=*suma+okrug(bb,okrg1);

  ks++;
  fprintf(ff,"%3d %-*.*s %-*.*s %10.10g %10s",
  ks,
  iceb_tu_kolbait(30,row[7]),iceb_tu_kolbait(30,row[7]),row[7],
  iceb_tu_kolbait(4,row[3]),iceb_tu_kolbait(4,row[3]),row[3],
  kolih,prcn(cena));
  fprintf(ff," %10s\n",prcn(bb));

 }


itog[0]=*suma+*sumabn;
itog[1]=sumap+sumapbn;
fprintf(ff,"%*s: %10.2f %10s %10.2f\n",
iceb_tu_kolbait(60,gettext("Итого")),gettext("Итого"),itog[0]," ",itog[1]);

if(*sumkor != 0)
 {
  bb=*sumkor*100./itog[0];
  bb=okrug(bb,0.01);
  if(*sumkor < 0)
      sprintf(bros,"%s %.6g%% :",gettext("Снижка"),bb*(-1));
  if(*sumkor > 0)
      sprintf(bros,"%s %.6g%% :",gettext("Надбавка"),bb);

   fprintf(ff,"%*s %10.2f\n",iceb_tu_kolbait(61,bros),bros,*sumkor);

  if(*sumkor < 0)
      sprintf(bros,gettext("Итого со снижкой :"));
  if(*sumkor > 0)
      sprintf(bros,gettext("Итого с надбавкой :"));

   fprintf(ff,"%*s %10.2f\n",iceb_tu_kolbait(61,bros),bros,*sumkor+itog[0]);

 }
sumandspod=sumands=0.;
if(lnds == 0)
 {
  if(sumandspr != 0.)
   sumands=sumandspr;
  else 
   sumands=( *suma + *sumkor)*pnds/100.;
 }

bb=*suma+*sumkor+*sumabn+sumands;
bb=okrug(bb,okrg1);
if(lnds == 0)
  sumandspod=sumap*pnds/100.;

bb1=sumap+sumapbn+sumandspod;
bb1=okrug(bb1,okrg1);

fprintf(ff,"%*s: %10.2f %10s %10.2f\n",
iceb_tu_kolbait(60,gettext("НДС")),gettext("НДС"),sumands," ",sumandspod);

fprintf(ff,"%*s %10.2f %10s %10.2f\n",
iceb_tu_kolbait(61,gettext("Итого с НДС:")),gettext("Итого с НДС:"),bb," ",bb1);
*sp=*sp+sumap;
*spbn=*spbn+sumapbn;

}
