/* $Id: rastab.c,v 5.29 2011-01-13 13:43:23 sasa1 Exp $ */
/*17.03.2010    30.12.1995      Белых А.И.      rastab.c
Расчет свода отработанного времени по работникам.
*/
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void saptbn(short,char[],long,long,long,class masiv_din_double*,short[],int,FILE*);
void rasvtn(short,short,short,short,short,short,short,class masiv_din_double*,class masiv_din_int*,short[],int,FILE*);

extern short    mmm,ggg;
extern char     *organ;

int rastab(class spis_oth *oth)
{
char            bros[512];
struct  tm      *bf;
time_t          tmm;
short		par;
short		mn,gn,mk,gk;
short		kolvt;  /*Колличество видов табеля*/
long		koltn; /*Количество табельных номеров*/
static char tabnom[112];
static char	podr[112];
static char	dat1[11],dat2[11];
char		imaf[56],imafn[56];;
FILE		*ff;
int		i,tabn;
int		i1;
long		kolstr;
SQL_str         row,row1;
char		strsql[512];
short		m,g;
float		dnei,has,kdnei;
short		vt;
char		naim[512];
VVOD VV(0);

VV.VVOD_SPISOK_add_data(dat1,8);
VV.VVOD_SPISOK_add_data(dat2,8);
VV.VVOD_SPISOK_add_data(podr,sizeof(podr));
VV.VVOD_SPISOK_add_data(tabnom,sizeof(tabnom));


VV.VVOD_SPISOK_add_MD(gettext("Начальная дата...(м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Конечная дата....(м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения.(,,).."));
VV.VVOD_SPISOK_add_MD(gettext("Табельный номер...(,,).."));

VV.VVOD_SPISOK_add_ZAG(gettext("Расчет свода отработанного времени по работникам"));

naz:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("подразделения"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

par=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(podr,VV.VVOD_SPISOK_return_data(2),sizeof(podr)-1);
strncpy(tabnom,VV.VVOD_SPISOK_return_data(3),sizeof(tabnom)-1);

switch(par)
 {
  case FK1:
   GDITE();
   iceb_t_pdoc("zarp4_3_5.txt");
   clear();
   goto naz;

  case FK10:
  case ESC:
    return(1);
  case FK2:
  case PLU:
    break;   

  case FK3:
    vibrek("Podr",podr,sizeof(podr),naim);
    goto naz;

  case FK4:
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
 }

if(rsdat1(&mn,&gn,dat1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(dat2[0] == '\0')
 {
  mk=mn; gk=gn;
 }
else
 if(rsdat1(&mk,&gk,dat2) != 0)
  {
   VVOD SOOB(1);
   SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конца !"));
   soobshw(&SOOB,stdscr,-1,-1,0,1);
   goto naz;
  }

time(&tmm);
bf=localtime(&tmm);


clear();
printw("%s %d.%d%s %s %d.%d%s %s\n",
gettext("Период с"),
mn,gn,
gettext("г."),
gettext("до"),
mk,gk,
gettext("г."),
podr);
GDITE();

/*Создаем массив видов табеля*/
sprintf(strsql,"select kod from Tabel");
SQLCURSOR cur;
SQLCURSOR curr;
if((kolvt=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolvt == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены виды табеля !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

short	mkt[kolvt]; /*Массив кодов табелей*/

i=0;
while(cur.read_cursor(&row) != 0)
  mkt[i++]=atoi(row[0]);


/*Создаем файл табельных номеров для последующей сортировки*/
if(gn != gk)
  sprintf(strsql,"select tabn,mes,god from Ztab where \
(god > %d and god < %d) or \
(god = %d and mes >= %d) or \
(god = %d and mes <= %d)",
gn,gk,
gn,mn,
gk,mk);
else
  sprintf(strsql,"select tabn,mes,god from Ztab where \
god = %d and mes >= %d and mes <= %d",
gn,mn,mk);
/*
printw("%s\n",strsql);
refresh();
*/
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
 
sprintf(imaf,"vtn%d.tmp",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

while(cur.read_cursor(&row) != 0)
 {
  if(proverka(tabnom,row[0],0,0) != 0)
   continue;
  tabn=atoi(row[0]);
  if(podr[0] != '\0')
   {
    m=atoi(row[1]);
    g=atoi(row[2]);
    /*определяем подразделение*/
    sprintf(strsql,"select podr from Zarn where god=%d and mes=%d and \
tabn=%d",g,m,tabn);

    if(readkey(strsql,&row1,&curr) != 1)
       continue;

    if(proverka(podr,row1[0],0,0) != 0)
      continue;
   }

  fprintf(ff,"%d\n",tabn);

 }
fclose(ff);

sprintf(bros,"sort -o %s -n -u %s",imaf,imaf);
runsystem(bros);

/*Определяем количество табельных номеров*/

if((ff = fopen(imaf,"r")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

class masiv_din_int mtn;

while(fscanf(ff,"%d\n",&tabn) != EOF)
 {
  mtn.plus(tabn,-1);
 /* printw("%ld\n",mtn[i]);*/
 }
fclose(ff);
unlink(imaf);

koltn=mtn.kolih();

printw("%s %ld\n",gettext("Количество табельных номеров"),koltn);

if(koltn == 0)
 {
  OSTANOV();
  return(1);
 } 
/*Открывем массив для видов табелей*/
class masiv_din_double mtab;
mtab.make_class(koltn*kolvt*3);

/*Заряжаем массив табельных номеров*/


/*Заряжаем массив видов табелей*/
if(gn != gk)
  sprintf(strsql,"select tabn,kodt,dnei,has,kdnei from Ztab where \
(god > %d and god < %d) or \
(god = %d and mes >= %d) or \
(god = %d and mes <= %d)",
  gn,gk,
  gn,mn,
  gk,mk);
else
  sprintf(strsql,"select tabn,kodt,dnei,has,kdnei from Ztab where \
god = %d and mes >= %d and mes <= %d",
  gn,mn,mk);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
while(cur.read_cursor(&row) != 0)
 {
  if(proverka(tabnom,row[0],0,0) != 0)
   continue;
  tabn=atoi(row[0]);
  vt=atoi(row[1]);
  dnei=atof(row[2]);
  has=atof(row[3]);
  kdnei=atof(row[4]);
  
  if((i=mtn.find(tabn)) < 0)
   {

    beep();
    printw(gettext("Не найден табельный номер %d в массиве табельных номеров !"),
    tabn);
    printw("\n");
    OSTANOV();
    continue;
   }         
  for(i1=0; i1 < kolvt; i1++)
    if(vt == mkt[i1])
      break;

  if(i1 == kolvt)
   {
    beep();
    printw(gettext("Не найден код табеля %d в массиве видов табелей !"),
    vt);
    printw("\n");
    OSTANOV();
    continue;
   }         
  mtab.plus(dnei,i*kolvt*3+i1*3);
  mtab.plus(has,i*kolvt*3+i1*3+1);
  mtab.plus(kdnei,i*kolvt*3+i1*3+2);
 }

sprintf(imaf,"vtn%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

short dk=0;
dpm(&dk,&mk,&gk,5);
zagolov(gettext("Свод видов табеля"),bf,1,mn,gn,dk,mk,gk,organ,ff);

if(podr[0] != '\0')
  fprintf(ff,"%s : %s\n",gettext("Подразделение"),podr);
if(tabnom[0] != '\0')
  fprintf(ff,"%s : %s\n",gettext("Табельный номер"),tabnom);
  
rasvtn(1,mn,gn,dk,mk,gk,kolvt,&mtab,&mtn,mkt,0,ff);


fclose(ff);

//Распечатываем с начислениями
sprintf(imafn,"vtnn%d.lst",getpid());
if((ff = fopen(imafn,"w")) == NULL)
 {
  error_op_nfil(imafn,errno,"");
  return(1);
 }

zagolov(gettext("Свод видов табеля"),bf,1,mn,gn,dk,mk,gk,organ,ff);

if(podr[0] != '\0')
  fprintf(ff,"%s : %s\n",gettext("Подразделение"),podr);
if(tabnom[0] != '\0')
  fprintf(ff,"%s : %s\n",gettext("Табельный номер"),tabnom);
  
rasvtn(1,mn,gn,dk,mk,gk,kolvt,&mtab,&mtn,mkt,1,ff);


fclose(ff);


printw_vr(tmm);

OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Свод видов табеля"));
oth->spis_imaf.plus(imafn);
oth->spis_naim.plus(gettext("Свод по видам табеля с дополнительной информацией"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
  iceb_t_ustpeh(oth->spis_imaf.ravno(nom),3);

return(0);
}

/*********************************/
/*Расапечатка результатов расчета*/
/*********************************/

void rasvtn(short dn,short mn,short gn,
short dk,short mk,short gk,
short kka, //Количество видов табелей
class masiv_din_double *nao,
class masiv_din_int *tn, //Массив табельных номеров
short mkt[],
int metkar, //0-без начислений 1-с начислениями
FILE *kaw)
{
int  koltb=tn->kolih(); //Количество табельных номеров
long		i,i1,i2,ii,skn;
short           kkol=12; /*Количество колонок в распечатке*/
double		br1,br2;
short           korr;
double          sn1,sn2,sn3;
char		st[1024];
unsigned short	porn; /*Порядковый номер*/
double		it1,it2,it3;
char		fio[512];
SQL_str         row1;
char		strsql[512];
char            dolg[512];
double		suman=0.;
char		kodpodr[32];
char		naimpodr[512];
SQLCURSOR curr;
if(metkar == 1)
 kkol=9999;

/*Распечатываем*/
printw("%s %d\n-------------------------\n",
gettext("Распечатываем"),metkar);
refresh();
porn=korr=0;
sn1=sn2=sn3=0.;
for(ii=0 ; ii < kka; ii += kkol)
 {
  /*printw("ii-%d kka-%d korr-%d\n",ii,kka,korr);*/
  /*Проверяем если все равно нулю то печатаем следующюю группу столбиков*/
  i2=0; br2=0.;
  for(i=ii*3; i<ii*3+kkol+i2 && i < kka*3;i+=3)
   {
    br1=0.;
    for(skn=i;skn< kka*3*koltb+ii*3+kkol && skn<kka*3*koltb; skn+=kka*3)
      if(fabs((br1=nao->ravno(skn)+nao->ravno(skn+1)+nao->ravno(skn+2))) > 0.009)
        break;
    if(fabs(br1) < 0.01)
     i2++;
    br2+=br1;
   }
  if(fabs(br2) < 0.01)
    continue;
  
  memset(st,'\0',sizeof(st));
  saptbn(kka,st,ii,ii+kkol,koltb,nao,mkt,metkar,kaw);
  br1=0.;
  for(i=0 ; i<koltb;i++)
   {
    /*Проверяем если нет равных нолю позиций печатаем*/
    br1=0.;
    for(skn=0;skn< kka*3 ; skn++)
      if(fabs(nao->ravno(skn+i*kka*3)) > 0.009)
        break;

    if(fabs(nao->ravno(skn+i*kka*3)) < 0.01)
      continue;

    memset(naimpodr,'\0',sizeof(naimpodr));
    memset(kodpodr,'\0',sizeof(kodpodr));
    
    sprintf(strsql,"select fio,dolg,podr from Kartb where tabn=%d",tn->ravno(i));
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      beep();
      printw("%s %d !\n",gettext("Не найден табельный номер"),tn->ravno(i));
      OSTANOV();
      continue;
     }
       
    strncpy(fio,row1[0],sizeof(fio)-1);
    strncpy(dolg,row1[1],sizeof(dolg)-1);
    strncpy(kodpodr,row1[2],sizeof(kodpodr)-1);

    if(metkar == 1) //Читаем должность и сумму начислений
     {
      sprintf(strsql,"select dolg,podr from Zarn where tabn=%d and god=%d and mes=%d",
      tn->ravno(i),gn,mn);
      if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
       {
        memset(kodpodr,'\0',sizeof(kodpodr));
        memset(dolg,'\0',sizeof(dolg));
        strncpy(dolg,row1[0],sizeof(dolg)-1);
        strncpy(kodpodr,row1[1],sizeof(kodpodr)-1);
       }
      sprintf(strsql,"select naik from Podr where kod=%s",kodpodr);
      if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
        strncpy(naimpodr,row1[0],sizeof(naimpodr)-1);
      
      sprintf(strsql,"%d",tn->ravno(i));
      suman=sosnsum(strsql,dn,mn,gn,dk,mk,gk);
     }

    porn++;
    if(metkar == 0)
     fprintf(kaw,"%4d %5d %-*.*s",porn,tn->ravno(i),iceb_tu_kolbait(30,fio),iceb_tu_kolbait(30,fio),fio);
    if(metkar == 1)
     fprintf(kaw,"%4d %5d %-*.*s %-*.*s %-3s %-20.20s %10.2f",
     porn,tn->ravno(i),
     iceb_tu_kolbait(30,fio),iceb_tu_kolbait(30,fio),fio,
     iceb_tu_kolbait(20,dolg),iceb_tu_kolbait(20,dolg),dolg,
     kodpodr,naimpodr,suman);

    /*Предыдущая информация*/
    it1=it2=it3=0.;
    if(ii > 0 )
     {
      for(skn=i*kka*3; skn<i*kka*3+ii*3 && skn < kka*3*koltb ;skn+=3)
       {
	/*printw(" skn=%d",skn);*/
	 it1+=nao->ravno(skn);
	 it2+=nao->ravno(skn+1);
	 it3+=nao->ravno(skn+1);
       }
     }

    i2=0;
    for(skn=i*kka*3+ii*3; skn<i*kka*3+ii*3+kkol*3+i2*3 && skn < i*kka*3+kka*3 ;skn+=3)
     {
      /*Если колонка нулевая не печатать*/
      br2=0.;
      for(i1=skn-(i*kka*3); i1< kka*3*koltb ; i1+=kka*3)
	if(fabs((br2+=nao->ravno(i1)+nao->ravno(i1+1)+nao->ravno(i1+2))) > 0.01)
	  break;

      if(fabs(br2) > 0.01)
       {
	fprintf(kaw," %5.5g %6.6g %5.5g",nao->ravno(skn),nao->ravno(skn+1),nao->ravno(skn+2));
        it1+=nao->ravno(skn);
        it2+=nao->ravno(skn+1);
        it3+=nao->ravno(skn+2);
       }
      else
       {
	i2++;
       }

     }
/*    printw("skn=%d i=%d kka=%d  %d koltb=%ld\n",skn,i,kka,i*kka*3+kka*3-1-8,koltb);*/
    if(skn == (i+1)*kka*3)
     {
      fprintf(kaw," %5.5g %6.6g %5.5g\n",it1,it2,it3);
     }
    else
      fprintf(kaw,"\n");
   }

  fprintf(kaw,"%s\n",st);
  if(metkar == 0)
    fprintf(kaw,"%-*s",iceb_tu_kolbait(41,gettext("Итого")),gettext("Итого"));
  if(metkar == 1)
    fprintf(kaw,"%-*s",iceb_tu_kolbait(98,gettext("Итого")),gettext("Итого"));
  porn=0;
  i2=0;
  /*printw("kkol=%d ii=%d kka=%d koltb=%d\n",kkol,ii,kka,koltb);*/
  for(i=ii; i<ii+kkol+i2 && i < kka ;i++)
   {
    it1=it2=it3=0.;
/*    for(skn=i*3;skn < kka*3*(koltb-1)+ii*3+kkol+i2 && skn< kka*3*koltb ; skn+=kka*3)*/
    for(skn=i*3; skn < kka*3*koltb ; skn+=kka*3)
     {
      it1+=nao->ravno(skn);
      it2+=nao->ravno(skn+1);
      it3+=nao->ravno(skn+2);
     }

    if(fabs(it1+it2+it3) > 0.01)
      fprintf(kaw," %5.5g %6.6g %5.5g",it1,it2,it3);
    else
      i2++;

    sn1+=it1;
    sn2+=it2;
    sn3+=it3;
   }
  if(i == kka)
   {
    fprintf(kaw," %5.5g %6.6g %5.5g\n",sn1,sn2,sn3);
   }
  else
   {
    fprintf(kaw,"\n");
   }
  fprintf(kaw,"%s\n",st);

  if(i == kka)
   break;
  ii+=i2;
 }

//printw("Розпечать завершено.\n");
refresh();

}

/***************/
/*Шапка таблицы*/
/***************/
void            saptbn(short kka, //Количество видов табелей
char st[],
long pn, //Позиция начала
long pk, //Позиция конца
long konu, //Количество людей
class masiv_din_double *nao,
short ka[], //Массив видов табелей
int metkar, //0-без начислений 1-с начислениями
FILE *kaw)
{
int             i,i1,i2;
char            nai[512];
double          br2;
SQL_str         row1;
char		strsql[512];
SQLCURSOR curr;
//printw("Печатьуем шапку\n");

/*printw("kka=%d pn=%d pk=%d konu=%ld\n",kka,pn,pk,konu);*/

refresh();

/*Формируем строку подчеркивания*/
/*Полка над наименованием*/
if(metkar == 0)
  strcpy(st,"------------------------------------------");
if(metkar == 1)
  strcpy(st,"---------------------------------------------------------------------------------------------------");
i2=0;
for(i=pn; i< pk+i2 && i < kka; i++)
 {
  /*Если колонка нулевая не печатать*/
  br2=0.;
  for(i1=i*3; i1< kka*3*konu ; i1+=kka*3)
    if(fabs((br2=nao->ravno(i1)+nao->ravno(i1+1)+nao->ravno(i1+2))) > 0.01)
     break;

  if(fabs(br2) > 0.01 )
    strcat(st,"-------------------");
  else
   i2++;
 }

/*Полка над ИТОГО*/
if(i == kka)
  strcat(st,"-------------------");

fprintf(kaw,"\n%s\n",st);
if(metkar == 0)
 fprintf(kaw,gettext("Н/п | Т/н | Фамилия Имя Отчество         "));
if(metkar == 1)
 fprintf(kaw,gettext("Н/п | Т/н | Фамилия Имя Отчество         |    Должность       |К.п|Наим. подразделения |  Сумма   "));

i2=0;
for(i=pn; i< pk+i2 && i < kka; i++)
 {
  /*Если колонка нулевая не печатать*/
  br2=0.;
  for(i1=i*3; i1 < kka*3*konu ; i1+=kka*3)
    if(fabs((br2=nao->ravno(i1)+nao->ravno(i1+1)+nao->ravno(i1+2))) > 0.01)
     break;
  if(fabs(br2) < 0.01)
   {
    i2++;
    continue;
   }
  sprintf(strsql,"select naik from Tabel where kod=%d",ka[i]);
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    beep();
    printw("%s %d !\n",gettext("Не найден код табеля"),ka[i-1]);
    OSTANOV();
   }
  strncpy(nai,row1[0],sizeof(nai)-1);
  fprintf(kaw,"| %-*.*s",iceb_tu_kolbait(17,nai),iceb_tu_kolbait(17,nai),nai);
 }

if(i == kka)
  fprintf(kaw,"| %-*.*s|\n",iceb_tu_kolbait(17,gettext("Итого")),iceb_tu_kolbait(17,gettext("Итого")),gettext("Итого"));
else
  fprintf(kaw,"|\n");

if(metkar == 0)
  fprintf(kaw,"    |     |%-30s"," ");
if(metkar == 1)
  fprintf(kaw,"    |     |%-30s|%20s|%3s|%20s|%10s"," "," "," "," "," ");

i2=0;
for(i=pn; i< pk+i2 && i < kka; i++)
 {
  /*Если колонка нулевая не печатать*/
  br2=0.;
  for(i1=i*3; i1< kka*3*konu ; i1+=kka*3)
    if(fabs((br2=nao->ravno(i1)+nao->ravno(i1+1)+nao->ravno(i1+2))) > 0.01)
     break;
  if(fabs(br2) > 0.01)
   {
    fprintf(kaw,"| %-17d",ka[i]);
   }
  else
    i2++;
 }

if(i == kka)
  fprintf(kaw,"| %-17.17s|\n"," ");
else
  fprintf(kaw,"|\n");

fprintf(kaw,"%s\n",st);

}
