/* $Id: raszpodr.c,v 5.20 2011-01-13 13:43:23 sasa1 Exp $ */
/*02.11.2009	17.04.2000	Белых А.И.	raszpodr.c
Расчет свода начислений и удержаний по подразделениям
с учетом начисления зарплаты по соответствующему подразделению
*/
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void raszpodrr(short,short,char[],char[],char[],FILE*,FILE*);


extern short	mmm,ggg;

int raszpodr(class spis_oth *oth)
{
static char	dat1[11];
static char     podr[112];
static char     kategr[112];
static char     tabnom[112];
int		kom,kom1;
char		naimp[512];
short		mn,gn;
FILE		*ff,*ffsh;
char		imaf[32],imafsh[32];
time_t		tmm;

if(dat1[0] == '\0')
 sprintf(dat1,"%d.%d",mmm,ggg);
VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Расчет свода начислений и удержаний по подразделениям."));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала.....(м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения.(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Код категории.....(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Табельный номер...(,,)."));

VV.VVOD_SPISOK_add_data(dat1,8);
VV.VVOD_SPISOK_add_data(podr,50);
VV.VVOD_SPISOK_add_data(kategr,50);
VV.VVOD_SPISOK_add_data(tabnom,50);

naz:;

clear(); 

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(podr,VV.VVOD_SPISOK_return_data(1),sizeof(podr)-1);
strncpy(kategr,VV.VVOD_SPISOK_return_data(2),sizeof(kategr)-1);
strncpy(tabnom,VV.VVOD_SPISOK_return_data(3),sizeof(tabnom)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp4_8.txt");
   goto naz;

  case FK10:
  case ESC:
   return(1);

  case FK2:
  case PLU:
   break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка категорий."));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 2 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Podr",podr,sizeof(podr),naimp);
        VV.VVOD_SPISOK_zapis_data(1,podr);
        goto naz;      

      case 1 :
        vibrek("Kateg",kategr,sizeof(kategr),naimp);
        VV.VVOD_SPISOK_zapis_data(2,kategr);
        goto naz;      

     }

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
 }

if(rsdat1(&mn,&gn,dat1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }


time(&tmm);
clear();

sprintf(imaf,"podr%d.lst",getpid());
sprintf(imafsh,"podrsh%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return(1);
   }
if((ffsh = fopen(imafsh,"w")) == NULL)
   {
    error_op_nfil(imafsh,errno,"");
    return(1);
   }

raszpodrr(mn,gn,podr,kategr,tabnom,ff,ffsh);



fclose(ff);
fclose(ffsh);
printw_vr(tmm);

OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчет свода начислений и удержаний по подразделениям"));
oth->spis_imaf.plus(imafsh);
oth->spis_naim.plus(gettext("Расчет свода начислений и удержаний по подразделениям"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
  iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);
}
