/* $Id: readpdok.c,v 5.25 2011-01-13 13:43:23 sasa1 Exp $ */
/*17.02.2008	07.05.1998	Белых А.И.	readpdok.c
Чтение реквизитов платежного документа
Вернули 0- если нашли
        1- не найден документ
        2- не найдены свои реквизиты
        3- не найдены чужие реквизиты
        4- не найден комментарий
*/
#include        <errno.h>
#include        "buhg.h"
#include        "dok4.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern struct REC rec;
extern char     *imafkomtmp; //Имя файла куда выгружается комментарий для редактирования

short readpdok(const char *tabl,short god,const char *npp)
{
FILE		*ff;
long		kolstr;
SQL_str         row;
SQLCURSOR cur;
char		strsql[512];
//printw("readpdok-%s %d %s\n",tabl,god,npp);
//OSTANOV();
memset(&rec,'\0',sizeof(rec));

if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Tpltp",0) == 0)
  rec.tipz=2;
if(SRAV(tabl,"Pltt",0) == 0 || SRAV(tabl,"Tpltt",0) == 0)
  rec.tipz=1;
/*Читаем платежку*/
if(SRAV(tabl,"Pltp",0) == 0 || SRAV(tabl,"Pltt",0) == 0)
 {
   sprintf(strsql,"select * from %s where datd >= '%04d-01-01' and \
datd <= '%04d-12-31' and nomd='%s'",
    tabl,god,god,npp);    
 }
else
 {
  sprintf(strsql,"select * from %s where nomd='%s'",
  tabl,npp);    
 }

if(sql_readkey(&bd,strsql,&row,&cur) == 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Не найден документ %s %d в таблице %s !"),npp,god,tabl);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);   
 }
rsdat(&rec.dd,&rec.md,&rec.gd,row[0],2);
rec.ddi=rec.dd;
rec.mdi=rec.md;
rec.gdi=rec.gd;

strncpy(rec.nomdk,row[1],sizeof(rec.nomdk)-1);
strncpy(rec.nomdk_i,row[1],sizeof(rec.nomdk_i)-1);

strncpy(rec.kodop,row[2],sizeof(rec.kodop)-1);
strncpy(rec.kodop_i,row[2],sizeof(rec.kodop_i)-1);

rec.sumd=atof(row[3]);
rec.nds=atof(row[4]);
rec.uslb=atof(row[5]);

strncpy(rec.shbzu,row[6],sizeof(rec.shbzu)-1);
if(row[14][0] != '\0')
 rsdat(&rec.dv,&rec.mv,&rec.gv,row[14],2);
strncpy(rec.kodnr,row[15],sizeof(rec.kodnr)-1);



/*Читаем реквизиты свои*/
POLE(row[7],rec.kodor,1,'#');
POLE(row[7],rec.naior,2,'#');
POLE(row[7],rec.gorod,3,'#');
POLE(row[7],rec.kod,4,'#');
POLE(row[7],rec.naiban,5,'#');
POLE(row[7],rec.mfo,6,'#');
POLE(row[7],rec.nsh,7,'#');

/*Читаем реквизиты чужие*/
POLE(row[8],rec.kodor1,1,'#');
POLE(row[8],rec.naior1,2,'#');
POLE(row[8],rec.gorod1,3,'#');
POLE(row[8],rec.kod1,4,'#');
POLE(row[8],rec.naiban1,5,'#');
POLE(row[8],rec.mfo1,6,'#');
POLE(row[8],rec.nsh1,7,'#');

rec.podt=atoi(row[9]);
rec.prov=atoi(row[10]);

/*********************
memset(rec.vidpl,'\0',sizeof(rec.vidpl));
strncpy(rec.vidpl,row[11],sizeof(rec.vidpl)-1);
***************/
rec.ktoz=atoi(row[12]);
rec.vremz=atol(row[13]);

/*Пишем комментарий*/
//sprintf(imaf,"pl%d.tmp",getpid());
if((ff = fopen(imafkomtmp,"w")) == NULL)
   {
    error_op_nfil(imafkomtmp,errno,"");
    return(1);
   }

sprintf(strsql,"select zapis from %sz where datd='%04d-%02d-%02d' and \
nomd='%s' and mz=0 order by nz asc",tabl,rec.gd,rec.md,rec.dd,rec.nomdk);
/*printw("\n%s",strsql);*/
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(4);
 }

short i=0;

if(kolstr != 0)
while(cur.read_cursor(&row) != 0)
 {
/*  printw("%s\n",row[0]);*/
  i++;
  fprintf(ff,"%s\n",row[0]);
 }

for(; i < 5 ; i++)
    fprintf(ff,"\n");

fprintf(ff,"\
#----------------------------------------------------------------------------\n\
#%s\n",
gettext("Введите назначение платежа и другую необходимую информацию."));

fclose(ff);

return(0);   

}






