/*$Id: ree_nast.c,v 5.12 2011-08-29 07:08:59 sasa Exp $*/
/*22.07.2011	30.08.2005	Белых А.И.	ree_nast.c
Чтение необходимых настроек для работы реестра налоговых накладных
*/
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif



double		okrcn=0.;  /*Округление цены*/
double		okrg1=0.;  /*Округление 1*/
short           startgodb=0; //Стартовый год для подсистемы "Главная книга"
short		vplsh; /*0-двух уровневый план счетов 1-многоуровневый*/
class iceb_rnfxml_data rek_zag_nn; /*Класс с данными для создания xml файлов*/

short dp=0,mp=0,gp=0; //Дата начала просмотра реестров

int ree_nast()
{
char st1[1024];
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];

okrg1=okrcn=0.;

memset(st1,'\0',sizeof(st1));
startgodb=0;
if(iceb_t_poldan("Стартовый год",st1,"nastrb.alx") == 0)
 {
  startgodb=(short)ATOFM(st1);
 }

vplsh=0;
memset(st1,'\0',sizeof(st1));
iceb_t_poldan("Многопорядковый план счетов",st1,"nastrb.alx");
if(SRAV(st1,"Вкл",1) == 0)
 vplsh=1;

sprintf(strsql,"select str from Alx where fil='matnast.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"matnast.alx");
  iceb_t_soob(strsql);
  return(1);
 }

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  polen(row_alx[0],st1,sizeof(st1),1,'|');

  if(SRAV(st1,"Округление 1",0) == 0)
    {
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     okrg1=ATOFM(st1);
     continue;
    }
  if(SRAV(st1,"Округление цены",0) == 0)
    {
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     okrcn=ATOFM(st1);
     continue;
    }
 }


sprintf(strsql,"select str from Alx where fil='rnn_nast.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"rnn_nast.alx");
  iceb_t_soob(strsql);
  return(1);
 }

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;

  polen(row_alx[0],st1,sizeof(st1),1,'|');

  if(SRAV(st1,"Дата начала просмотра реестра",0) == 0)
    {
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     rsdat(&dp,&mp,&gp,st1,1);
     continue;
    }
 }
iceb_t_rnfxml(&rek_zag_nn);
return(0);

}
