/*$Id: rppvokr1.c,v 5.20 2011-01-13 13:43:23 sasa1 Exp $*/
/*03.11.2008	28.10.2002	Белых А.И.	rppvokr1.c
Реестр проводок по видам операций для учета командировочных расходов
*/
#include        <time.h>
#include        <math.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void	saprppvo(short,short,short,short,short,short,int*,int*,FILE*);
void	shetrppvo(short,short,short,short,short,short,int*,int*,FILE*);
void	itdok(double,FILE*);
void	itrppvo(int,const char*,short,short,short,short,short,short,int*,int*,SPISOK*,masiv_din_double*,FILE*);

extern char     *organ;/*Наименование организации*/
extern int kol_strok_na_liste;

int rppvokr1(short dn,short mn,short gn,
short dk,short mk,short gk,
char *kontrp,
char *vkomp,
char *sheta,
class spis_oth *oth)
{
char		strsql[512];
int		kolstr=0,kolstr1=0,kolstr2=0;
SQL_str		row,row1;
FILE		*ff,*fftmp;
char		imaf[32];
char		imaftmp[32];
char		kontr[32];
char		vkom[512];
time_t		tmmn;
struct  tm      *bf;
char		stroka[1024];
int		i=0;
SQLCURSOR 	curr;
time(&tmmn);

printw("%s %d.%d.%d > %d.%d.%d\n",gettext("Даты поиска:"),dn,mn,gn,dk,mk,gk);
printw(gettext("Сортируем проводки\n"));

GDITE();


sprintf(strsql,"select datp,sh,shk,nomd,pod,deb,datd,komen from Prov \
where val=0 and \
datp >= '%04d-%02d-%02d' and \
datp <= '%04d-%02d-%02d' and kto='%s' and deb != 0.",
gn,mn,dn,gk,mk,dk,gettext("УКР"));
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }    

sprintf(imaftmp,"vidop%d.tmp",getpid());
if((fftmp = fopen(imaftmp,"w")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }

kolstr2=kolstr1=0;

while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);  

  /*Счет*/
  if(proverka(sheta,row[1],0,0) != 0)
    continue;
   
  /*Читаем документ*/
  sprintf(strsql,"select kont,vkom from Ukrdok where datd='%s' and \
nomd='%s'",row[6],row[3]);
/*  printw("strsql=%s\n",strsql);*/
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    printw("Не найден документ N %s Дата=%s\n",
    row[3],row[6]);
    printw("%s %s %s %s\n",gettext("Проводка"),
    row[1],row[2],row[3]);
    OSTANOV();
    continue;
   }
  memset(kontr,'\0',sizeof(kontr));
  strncpy(kontr,row1[0],sizeof(kontr)-1);
  memset(vkom,'\0',sizeof(vkom));
  strncpy(vkom,row1[1],sizeof(vkom)-1);

  if(proverka(kontrp,kontr,0,0) != 0)
    continue;

  if(proverka(vkomp,vkom,0,0) != 0)
    continue;
  kolstr2++;
  fprintf(fftmp,"%s|%s|%s|%s|%s|%s|%s|%s|%s|\n",
  vkom,kontr,row[3],row[0],row[1],row[2],row[6],row[5],row[7]);  

 }
fclose(fftmp);

//sprintf(strsql,"sort -o %s -t\\| +0 -1 +1 -2 +2n -3 +3 %s",imaftmp,imaftmp);
sprintf(strsql,"sort -o %s -t\\| -k1,2 -k2,3 -k3,4n %s",imaftmp,imaftmp);
runsystem(strsql);

short	dd,md,gd; //Дата документа
short	dp,mp,gp; //Дата проводки
char	nomdok[32];
char	shet[20],shetk[32];
double	deb=0.;
char	koment[512];
int 	nlist=1;
int	kolst=0;
int	kom=0;

if((fftmp = fopen(imaftmp,"r")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }

sprintf(imaf,"rpkr%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

bf=localtime(&tmmn);

if(kontrp[0] != '\0')
 { 
  fprintf(ff,"%s: %s\n",gettext("Контрагент"),kontrp);
  kolst++;
 }

if(vkomp[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Вид командировки"),vkomp);
  kolst++;
 }

if(sheta[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Счет"),sheta);
  kolst++;
 }

//saprppvo(dn,mn,gn,dk,mk,gk,&nlist,&kolst,ff);

SPISOK PARSH; //Список пар счетов
masiv_din_double oper; //Суммы по операциям
masiv_din_double kont; //Суммы по конрагентам
masiv_din_double itog; //Суммы по всему расчету

char  vkom1[20];
char  kontr1[20];
char  shett[40];
char  naikont[512];
char  nomdok1[20];
char  naivkom[80];
double itogd=0.;
vkom1[0]='\0';
kontr1[0]='\0';
nomdok1[0]='\0';

kolstr1=0;
while(fgets(stroka,sizeof(stroka),fftmp) != NULL)
 {
  
  strzag(LINES-1,0,kolstr2,++kolstr1);

  polen(stroka,vkom,sizeof(vkom),1,'|');
  polen(stroka,kontr,sizeof(kontr),2,'|');
  polen(stroka,nomdok,sizeof(nomdok),3,'|');
  polen(stroka,strsql,sizeof(strsql),4,'|');
  rsdat(&dp,&mp,&gp,strsql,2);
  polen(stroka,shet,sizeof(shet),5,'|');
  polen(stroka,shetk,sizeof(shetk),6,'|');
  polen(stroka,strsql,sizeof(strsql),7,'|');
  rsdat(&dd,&md,&gd,strsql,2);
  polen(stroka,strsql,sizeof(strsql),8,'|');
  deb=atof(strsql);    
  polen(stroka,koment,sizeof(koment),9,'|');

  if(SRAV(nomdok,nomdok1,0) != 0)
   {
    if(nomdok1[0] != '\0')
     {
      shetrppvo(dn,mn,gn,dk,mk,gk,&nlist,&kolst,ff);
      itdok(itogd,ff);
     }
    strcpy(nomdok1,nomdok);
    itogd=0.;
   }

  if(SRAV(kontr,kontr1,0) != 0)
   {
    if(kontr1[0] != '\0')
      itrppvo(0,kontr1,dn,mn,gn,dk,mk,gk,&nlist,&kolst,&PARSH,&kont,ff);

    memset(naikont,'\0',sizeof(naikont));
    sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",kontr);
    if(sql_readkey(&bd,strsql,&row,&curr) == 1)
      strncpy(naikont,row[0],sizeof(naikont)-1);    

    kom=1;
    strcpy(kontr1,kontr);
   }

  if(SRAV(vkom,vkom1,0) != 0)
   {
    if(vkom1[0] != '\0')
     {
      itrppvo(1,vkom1,dn,mn,gn,dk,mk,gk,&nlist,&kolst,&PARSH,&oper,ff);
      fprintf(ff,"\f");
      kolst=0;
     }    

    zagolov(gettext("Реестр проводок по виду командировок."),bf,dn,mn,gn,dk,mk,gk,organ,ff);
    kolst+=5;

    memset(naivkom,'\0',sizeof(naivkom));
    sprintf(strsql,"select naik from Ukrvkr where kod='%s'",vkom);
    if(sql_readkey(&bd,strsql,&row,&curr) == 1)
     strncpy(naivkom,row[0],sizeof(naivkom)-1);   

    fprintf(ff,"%s:%s %s\n",gettext("Вид командировки"),
    vkom,naivkom);
    kolst++;

    saprppvo(dn,mn,gn,dk,mk,gk,&nlist,&kolst,ff);
    kom=1;
    strcpy(vkom1,vkom);
   }

  sprintf(shett,"%s,%s",shet,shetk);

  if((i=PARSH.find(shett)) == -1)
    PARSH.plus(shett);

  oper.plus(deb,i);
  kont.plus(deb,i);
  itog.plus(deb,i);
  itogd+=deb;

  printw("%02d.%02d.%4d %02d.%02d.%4d %-*s %-*s %15.2f\n",
  dp,mp,gp,dd,md,gd,
  iceb_tu_kolbait(11,nomdok),nomdok,
  iceb_tu_kolbait(11,shett),shett,
  deb);

  shetrppvo(dn,mn,gn,dk,mk,gk,&nlist,&kolst,ff);

  if(kom == 1)
     fprintf(ff,"\
%-7s %-40.40s %02d.%02d.%4d %02d.%02d.%4d %-*s %-6s %-*s %20s %s\n",
     kontr,naikont,dd,md,gd,dp,mp,gp,
     iceb_tu_kolbait(11,nomdok),nomdok,
     "",
     iceb_tu_kolbait(10,shett),shett,
     prnbr(deb),koment);

  if(kom == 0)
     fprintf(ff,"\
%48s %02d.%02d.%4d %02d.%02d.%4d %-*s %-6s %-*s %20s %s\n",
    " ",dd,md,gd,dp,mp,gp,
     iceb_tu_kolbait(11,nomdok),nomdok,
    "",
     iceb_tu_kolbait(10,shett),shett,
    prnbr(deb),koment);

  kom=0;
   
 }

itdok(itogd,ff);
itrppvo(0,kontr1,dn,mn,gn,dk,mk,gk,&nlist,&kolst,&PARSH,&kont,ff);
itrppvo(1,vkom1,dn,mn,gn,dk,mk,gk,&nlist,&kolst,&PARSH,&oper,ff);
itrppvo(2,"",dn,mn,gn,dk,mk,gk,&nlist,&kolst,&PARSH,&itog,ff);

podpis(ff);

fclose(ff);
fclose(fftmp);
unlink(imaftmp);

printw_vr(tmmn);

OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Реестр проводок по видам командировок."));
iceb_t_ustpeh(imaf,1);
return(0);
}

/***************************************/
/*Счетчик строк                        */
/***************************************/
void	shetrppvo(short dn,short mn,short gn,
short dk,short mk,short gk,
int *nlist,int *kolst,FILE *ff)
{
*kolst+=1;
if(*kolst < kol_strok_na_liste)
  return; 

fprintf(ff,"\f");
*kolst=0;
saprppvo(dn,mn,gn,dk,mk,gk,nlist,kolst,ff);

}

/****************************************/
/*  Шапка документа                     */
/****************************************/
void	saprppvo(
short dn,short mn,short gn,
short dk,short mk,short gk,
int *nlist,int *kolst,
FILE *ff)
{
fprintf(ff,"\
%s %02d.%02d.%4d%s %s %02d.%02d.%4d%s %*s%d\n",
gettext("Период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
iceb_tu_kolbait(30,gettext("Лист N")),gettext("Лист N"),
*nlist);

fprintf(ff,"\
------------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,gettext("\
	Контрагент                              |Дата док. |Дата пров.|N документа|Nнал.н|  Счета   |       Сумма         |Коментарий\n"));

fprintf(ff,"\
------------------------------------------------------------------------------------------------------------------------------------\n");
*nlist+=1;
*kolst+=4;
}
/**************************************/
/*Распечатка итога                    */
/**************************************/

void	itrppvo(int metka, //0-по контрагенту 1-по виду командировки 2-общий итог
const char *kod,
short dn,short mn,short gn,
short dk,short mk,short gk,
int *nlist,int *kolst,
SPISOK *PARSH,masiv_din_double *kontr,FILE *ff)
{
SQLCURSOR curr;
double itog=0.;
int	kolih=PARSH->kolih();
char	naim[512];
char	strsql[512];
SQL_str row;
double	suma=0;
char    naimitog[50];

memset(naim,'\0',sizeof(naim));

if(kolih > 0)
 {
  memset(naimitog,'\0',sizeof(naimitog));
  if(metka == 0)
   {
    sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",kod);
    if(sql_readkey(&bd,strsql,&row,&curr) == 1)
      strncpy(naim,row[0],sizeof(naim)-1);    
    strcpy(naimitog,gettext("Итого по контрагенту"));
   }     
  if(metka == 1)
   {
    sprintf(strsql,"select naik from Ukrvkr where kod='%s'",kod);
    if(sql_readkey(&bd,strsql,&row,&curr) == 1)
      strncpy(naim,row[0],sizeof(naim)-1);    
    strcpy(naimitog,gettext("Итого по виду командировки"));
   }
  if(metka == 2)
    strcpy(naimitog,gettext("Общий итог"));

  shetrppvo(dn,mn,gn,dk,mk,gk,nlist,kolst,ff);
  fprintf(ff,"%s %s:\n",naimitog,naim);
 }
/*printw("kso- %d\n",kso);*/

for(int i=0; i< kolih ;i++)
 {
  suma=kontr->ravno(i);
  if(suma == 0.)
   continue;

  shetrppvo(dn,mn,gn,dk,mk,gk,nlist,kolst,ff);
  fprintf(ff,"%-*s - %20s\n",
  iceb_tu_kolbait(10,PARSH->ravno(i)),PARSH->ravno(i),
  prnbr(suma));
  itog+=suma;
 }
if(itog != 0.)
 {
  shetrppvo(dn,mn,gn,dk,mk,gk,nlist,kolst,ff);
  fprintf(ff,"%-*s - %20s\n",
  iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),prnbr(itog));

  shetrppvo(dn,mn,gn,dk,mk,gk,nlist,kolst,ff);
  fprintf(ff,"\
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .\n");
 }
kontr->clear_class();
}
/****************************************/
/*Итог по документа                     */
/****************************************/
void	itdok(double itogd,FILE *ff)
{
fprintf(ff,"%*s %20s\n",iceb_tu_kolbait(100,gettext("Итого по документа:")),gettext("Итого по документа:"),prnbr(itogd));
}
