/* $Id: saldogk.c,v 5.31 2011-01-13 13:43:23 sasa1 Exp $ */
/*10.02.2010    06.12.1993      Белых А.И.      saldogk.c
Программа переноса сальдо для "Главной книги"
*/
#include        <math.h>
#include        <errno.h>
#include        <time.h>
#include        <pwd.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void		saldonbs(short,short,short,short,short,short);
void ras2(const char *sh,const char *nash,double *dns,double *kns,double *dpp,double *kpp,double *di,double *ki,class SPISOK *ns_kontr,
class masiv_din_double *ns_kontr_debs,class masiv_din_double *ns_kontr_kres,class masiv_din_double *ns_kontr_debp,class masiv_din_double *ns_kontr_krep);
void ras1(int i,const char *ns,const char *nash,class GLKTMP *PROM,double *dns,double *kns,double *dpp,double *kpp,double *di,double *ki);

//SQL_baza	bd;

struct  tm      *bf;
extern char     *organ;
extern struct  passwd  *ktoz; /*Кто записал*/
extern short		startgodb;

void            saldogk()
{
double          dns,kns,dpp,kpp;
double          di,ki;
double          sd,sk,dpe,kpe;
short           dn,mn,gn;
short           dk,mk,gk;
time_t          tmmn;
int             i,sb;
char            sh[32];
SQL_str         row;
char		strsql[512];
char		nais[512];
int		X,Y;
short		godp;
//char		bros[512];
int		vids;
char            sgod[112];
SQLCURSOR curr;
memset(sgod,'\0',sizeof(sgod));
int kom=0;

if(iceb_t_prn() != 0) /*Проверка возможности изменять настройки*/
 return;

startgodb=0;
if(iceb_t_poldan("Стартовый год",sgod,"nastrb.alx") == 0)
 {
  startgodb=(short)ATOFM(sgod);
 }

if(startgodb == 0)
 {
  iceb_t_soob(gettext("Не введён стартовый год!"));
  return;
 }
/***************
VVOD VVOD1(2);

VVOD1.VVOD_SPISOK_add_ZAG("Перенос сальдо по всем счетам из плана счетов");
sprintf(strsql,"Стартовый год:%d",startgodb);
VVOD1.VVOD_SPISOK_add_ZAG(strsql);

VVOD1.VVOD_SPISOK_add_MD("Введите год на который перенести сальдо");
     
sprintf(bros,"%d",startgodb+1);





naz:;

clear();
helstr(LINES-1,0,"F10",gettext("выход"),NULL);
     
if((i=vvod1(bros,5,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
  return;
if(i == ESC)
  return;
if(i == KEY_RESIZE)
  goto naz;
godp=(short)ATOFM(bros);
************************/
VVOD VV(0);

VV.VVOD_SPISOK_add_ZAG(gettext("Главная книга"));
VV.VVOD_SPISOK_add_ZAG(gettext("Перенос сальдо"));
sprintf(strsql,"%s:%d",gettext("Стартовый год"),startgodb);
VV.VVOD_SPISOK_add_ZAG(strsql);

VV.VVOD_SPISOK_add_MD(gettext("С какого года.."));
VV.VVOD_SPISOK_add_MD(gettext("На какой год..."));
VV.VVOD_SPISOK_add_data(startgodb,5);
VV.VVOD_SPISOK_add_data(startgodb+1,5);

naz:;
clear();


helstr(LINES-1,0,"F2/+",gettext("расчет"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

switch(kom)
 {
  case FK2:
  case PLU:
    break;
  case FK10:
    return;
  default:
   goto naz;
 }

gn = (short)VV.data_ravno_atoi(0);
godp = (short)VV.data_ravno_atoi(1);

if(gn == 0 || gn < 1900 || gn > 3000)
 { 
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD("Не верно веден год с котрого нужно перенести !");
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 } 

if(godp == 0 || godp < 1900 || godp > 3000)
 { 
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD("Не верно веден год на который нужно перенести !");
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 } 
dn=1;
mn=1;
dk=31;
mk=12;
gk=godp-1;

if(iceb_t_pvglkni(1,godp) != 0)
 goto naz;

clear();
VVOD DANET(1);
DANET.VVOD_SPISOK_add_ZAG("Перенос сальдо по счетам в \"Главной книге\"");
sprintf(strsql,"Перенести сальдо с %dг. на %dг. ? Вы уверены ?",gn,godp);
DANET.VVOD_SPISOK_add_MD(strsql);

if(danet(&DANET,2,stdscr) == 2)
  return;

sb=1; /*Расчитать по субсчетам*/

time(&tmmn);
clear();

printw("Перенос остатков с %d на %d\n",
gn,godp);
GDITE();

GLKTMP PROM;
/*******************************************************/
printw(gettext("Формируем массив счетов\n"));
refresh();
int msrv=0;
if(sb == 0)
 msrv=1;
//printw("msrw=%d\n",msrv);
//OSTANOV();
/*************************/
/*Формируем массив счетов*/
/*************************/
SQLCURSOR cur;
SQLCURSOR cur1;
int kolstr=0;
sprintf(strsql,"select ns,vids,saldo from Plansh where stat=0 order by ns asc");
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не введен план счетов !"));
  return;
 }

int pozz=0;
while(cur.read_cursor(&row) != 0)
 {
  pozz++;

//  printw("%s %s %s\n",row[0],row[1],row[2]);
//  refresh();
//  getch();
  
  if(atoi(row[1]) == 1 && sb == 0)
    continue;
  strncpy(sh,row[0],sizeof(sh));
  if(sb == 1 && atoi(row[1]) == 0 && pozz < kolstr-1)
   {
    cur.read_cursor(&row);
    /*Если нет субсчетов запоминаем счет*/
    if(SRAV(sh,row[0],1) != 0)
     {
      cur.poz_cursor(pozz-1);
      cur.read_cursor(&row);
     }
    else
     pozz++;
   }
  PROM.masf.plus(row[0]);

  if(atoi(row[2]) == 3)
     PROM.msr.plus(row[0]);
 }
int ks=PROM.masf.kolih();
printw("%s: %d\n",gettext("Количество счетов"),ks);
printw("%s:",gettext("Счета"));
for(int ish=0; ish < PROM.masf.kolih() ; ish++)
  printw("%s ",PROM.masf.ravno(ish));
printw("\n");
refresh();




int ll1=ks*ks; /*Шахматка для заполнения*/
PROM.ssd.make_class(ks);
PROM.ssk.make_class(ks);
PROM.deb_end.make_class(ks);
PROM.kre_end.make_class(ks);
PROM.sl.make_class(ll1);
PROM.pe.make_class(ll1);

int ksrs=PROM.msr.kolih();
printw(gettext("Количество счетов с развернутым сальдо - %d\n"),ksrs);
/*создаём список контрагентов*/
class SPISOK ns_kontr[ksrs];
class masiv_din_double ns_kontr_debs[ksrs];
class masiv_din_double ns_kontr_kres[ksrs];
class masiv_din_double ns_kontr_debp[ksrs];
class masiv_din_double ns_kontr_krep[ksrs];

/***********************************/
/*Узнаем стартовые сальдо по счетам*/
/***********************************/
printw(gettext("Вычисляем стартовые сальдо по счетам\n"));
refresh();
int nomer_sheta_srs=0;
int nom_k=0;
double deb,kre;
for(i=0; i < ks ; i++)
 {
  memset(sh,'\0',sizeof(sh));
  strncpy(sh,PROM.masf.ravno(i),sizeof(sh)-1);
  sprintf(strsql,"select saldo,vids from Plansh where ns='%s'",sh);
  
  if(sql_readkey(&bd,strsql,&row,&cur) != 1)
   {
    sprintf(strsql,gettext("Не найден счет %s в плане счетов !"),sh);
    iceb_t_soob(strsql);
    continue;
   }

  int ts=0;
  if(atoi(row[0]) == 3)
    ts=1;
  vids=atoi(row[1]);
  
  if(vids == 0) /*Счет*/
   sprintf(strsql,"select kodkon,deb,kre from Saldo where kkk='%d' and gs=%d \
and ns like '%s%%'",ts,gn,sh);
  if(vids == 1) /*Субсчет*/
   sprintf(strsql,"select kodkon,deb,kre from Saldo where kkk='%d' and gs=%d \
and ns='%s'",ts,gn,sh);

  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
      msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

  if(kolstr <= 0)
     continue;

  while(cur.read_cursor(&row) != 0)
   {
    deb=atof(row[1]);
    kre=atof(row[2]);

    if(row[0][0] != '\0')
     if((nomer_sheta_srs=PROM.msr.find(sh,msrv)) >= 0)
      {
       if((nom_k=ns_kontr[nomer_sheta_srs].find_r(row[0])) < 0)
        {
         ns_kontr[nomer_sheta_srs].plus(row[0]);
        }
       ns_kontr_debs[nomer_sheta_srs].plus(deb,nom_k);
       ns_kontr_kres[nomer_sheta_srs].plus(kre,nom_k);
       ns_kontr_debp[nomer_sheta_srs].plus(0.,nom_k);
       ns_kontr_krep[nomer_sheta_srs].plus(0.,nom_k);
      }        

    PROM.ssd.plus(deb,i);
    PROM.ssk.plus(kre,i);
   }
/*  
  printw("%s %.2f %.2f\n",sh,ssd[i],ssk[i]);
  getch();
*/
  if(ts == 0)  /*Счета с не развернутым сальдо*/
   {
    if(PROM.ssd.ravno(i) >= PROM.ssk.ravno(i))
     {
      PROM.ssd.plus(PROM.ssk.ravno(i)*-1,i);
      PROM.ssk.new_plus(0.,i);
     }
    else
     {
      PROM.ssk.plus(PROM.ssd.ravno(i)*-1,i);
      PROM.ssd.new_plus(0.,i);
     }
   }
 }

/******************************************/
/*Просматриваем записи и заполняем массивы*/
/******************************************/

printw("%s\n",gettext("Просматриваем проводки, заполняем массивы"));
GDITE();
sprintf(strsql,"select datp,sh,shk,kodkon,deb,kre from Prov \
where val=0 and datp >= '%d-%02d-%02d' and \
datp <= '%d-%02d-%02d'",gn,1,1,gk,mk,dk);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не найдено проводок !"));
 }
else
 {
  double cel=kolstr;
  double drob=0.;

  drob=modf(cel,&drob);
  if(drob > 0.000001)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s !!!",gettext("Внимание"));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не парное количество проводок."));
    SOOB.VVOD_SPISOK_add_MD(gettext("Проверте базу данных на логическую целосность."));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
 }
printw("%s:%d\n",gettext("Количество проводок"),kolstr);
refresh();

int mpe=0;
short den,mes,god;
int kolstr1=0;
char shk[24];
double sm=0.;
int i1=0;
if(kolstr > 0)
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);

  rsdat(&den,&mes,&god,row[0],2);
  deb=atof(row[4]);   
  kre=atof(row[5]);
  
  if(sravmydat(den,mes,god,dn,mn,gn)  < 0) /*до периода*/
   {
     mpe=0;
   }

  if(sravmydat(den,mes,god,dn,mn,gn)  >= 0) /*период*/
  if(sravmydat(den,mes,god,dk,mk,gk)  <= 0)
   {
    mpe=1;
   }

  if(row[3][0] != '\0')
   if((nomer_sheta_srs=PROM.msr.find(row[1],msrv)) >= 0)
    {
     if((nom_k=ns_kontr[nomer_sheta_srs].find_r(row[3])) < 0)
      ns_kontr[nomer_sheta_srs].plus(row[3]);

     if(mpe == 0)
      {
       ns_kontr_debs[nomer_sheta_srs].plus(deb,nom_k);
       ns_kontr_kres[nomer_sheta_srs].plus(kre,nom_k);
       if(nom_k < 0)
        {
         ns_kontr_debp[nomer_sheta_srs].plus(0.,nom_k);
         ns_kontr_krep[nomer_sheta_srs].plus(0.,nom_k);
        }
      }
     else
      {
       if(nom_k < 0)
        {
         ns_kontr_debs[nomer_sheta_srs].plus(0.,nom_k);
         ns_kontr_kres[nomer_sheta_srs].plus(0.,nom_k);
        }
       ns_kontr_debp[nomer_sheta_srs].plus(deb,nom_k);
       ns_kontr_krep[nomer_sheta_srs].plus(kre,nom_k);
      }
    }

  memset(sh,'\0',sizeof(sh));
  memset(shk,'\0',sizeof(shk));
  if(fabs(deb) > 0.009)
   {
    strcpy(sh,row[1]);
    strcpy(shk,row[2]);
    sm=deb;
   }
  else
   {
    strcpy(sh,row[2]);
    strcpy(shk,row[1]);
    sm=kre;
   }
  if(sh[0] == '\0')
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %s %s %s %s %s",
    row[0],row[1],row[2],row[3],row[4],row[5]);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не введен счет !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);

    continue;
   }
  if(shk[0] == '\0')
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %s %s %s %s %s",
    row[0],row[1],row[2],row[3],row[4],row[5]);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не введен коресподирующий счет !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);

    continue;
   }

  if((i=PROM.masf.find(sh,msrv)) == -1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %s %s %s %s %s",
    row[0],row[1],row[2],row[3],row[4],row[5]);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    sprintf(strsql,gettext("Не найден счет %s в массиве счетов !"),sh);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);

    continue;
   }

  if((i1=PROM.masf.find(shk,msrv)) == -1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %s %s %s %s %s",
    row[0],row[1],row[2],row[3],row[4],row[5]);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    sprintf(strsql,gettext("Не найден счет корреспондент %s в масиве счетов !"),shk);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    SOOB.VVOD_SPISOK_add_MD("rozrax");
    soobshw(&SOOB,stdscr,-1,-1,0,1);

    continue;
   }

  if(mpe == 0)
    PROM.sl.plus(sm,i*ks+i1);
  else
    PROM.pe.plus(sm,i*ks+i1);
  
/*Проверяем есть ли неправильные проводки*/
  if(ksrs != 0)
   if(PROM.msr.find(row[2],msrv) >= 0)
   {

    if(row[3][0] == '\0')
     {

      VVOD SOOB(1);
      sprintf(strsql,"%d.%d.%d %-5s %-5s %-5s %10s %10s",
      den,mes,god,row[1],row[2],row[3],row[4],row[5]);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      SOOB.VVOD_SPISOK_add_MD(gettext("В проводке нет кода контрагента !"));
      SOOB.VVOD_SPISOK_add_MD("rozrax");
      soobshw(&SOOB,stdscr,-1,-1,0,1);

     } 
   }

  /*Проверяем есть ли счет в списке счетов с развернутым сальдо*/
  if(ksrs != 0)
   if(PROM.msr.find(row[1],msrv) >= 0)
   {
   
    if(row[3][0] == '\0')
     {

      VVOD SOOB(1);
      sprintf(strsql,"%d.%d.%d %-5s %-5s %-5s %10s %10s",
      den,mes,god,row[1],row[2],row[3],row[4],row[5]);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      SOOB.VVOD_SPISOK_add_MD(gettext("В проводке нет кода контрагента !"));
      SOOB.VVOD_SPISOK_add_MD("rozrax");
      soobshw(&SOOB,stdscr,-1,-1,0,1);

     } 

    //Проверяем есть ли код контрагента в списке счета
/***************
    sprintf(strsql,"select kodkon from Skontr where ns='%s' and kodkon='%s'",row[1],row[3]);
    if(sql_readkey(&bd,strsql) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,"%d.%d.%d %-5s %-5s %-5s %10s %10s",
      den,mes,god,row[1],row[2],row[3],row[4],row[5]);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      sprintf(strsql,gettext("Не найден код %s в списке счета %s !"),row[3],row[1]);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      SOOB.VVOD_SPISOK_add_MD("rozrax");
      soobshw(&SOOB,stdscr,-1,-1,0,1);

     }
********************/
//    PROM.GLKTMP_zapis(row[1],row[3],mpe,deb,kre);      

   }



 }

/*************************************************************/

printw(gettext("Расчет закончен\n"));
refresh();

/*Чистим нулевой год куда будут записаны сальдо*/
sprintf(strsql,"delete from Saldo where gs=0");

sql_zapis(strsql,0,0);



/************************/
/*Распечатка результатов*/
/************************/
/*Так как все проводки встречаются дважды то все делим на 2*/
for(i=0;i<ks*ks;i++)
  {
   if(PROM.sl.ravno(i) != 0.)
    PROM.sl.new_plus(PROM.sl.ravno(i)/2.,i);
   if(PROM.pe.ravno(i) != 0.)
    PROM.pe.new_plus(PROM.pe.ravno(i)/2.,i);
   /*printw("sl[%d]=%.2f ",i,sl[i]);*/
  }

printw(gettext("Распечатываем результат\n"));
refresh();


di=ki=sd=sk=dpe=kpe=0.;
dns=kns=dpp=kpp=0.;
getyx(stdscr,Y,X);
short metkasaldo=0;
for(i=0; i <ks ; i++)
 {
  strzag(LINES-1,0,ks,i);
  
  memset(sh,'\0',sizeof(sh));
  strncpy(sh,PROM.masf.ravno(i),sizeof(sh)-1);
  sprintf(strsql,"select saldo,nais,vids from Plansh where ns='%s'",sh);
  
  if(sql_readkey(&bd,strsql,&row,&curr) != 1)
   {
    sprintf(strsql,gettext("Нет счета %s в плане счетов !"),sh);
    iceb_t_soob(strsql);
    continue;
   }
  metkasaldo=atoi(row[0]);
  strncpy(nais,row[1],sizeof(nais)-1);  
  vids=atoi(row[2]);
  move(Y,X);
  printw("%-5s %s\n",sh,nais);
  refresh();
  
  if(metkasaldo == 3)
   {
//    ras2(gn,i,sh,nais,vids,&PROM);
    nomer_sheta_srs=PROM.msr.find(sh,msrv);
    ras2(sh,nais,&dns,&kns,&dpp,&kpp,&di,&ki,
    &ns_kontr[nomer_sheta_srs],
    &ns_kontr_debs[nomer_sheta_srs],
    &ns_kontr_kres[nomer_sheta_srs],
    &ns_kontr_debp[nomer_sheta_srs],
    &ns_kontr_krep[nomer_sheta_srs]);

   }
  else
   ras1(i,sh,nais,&PROM,&dns,&kns,&dpp,&kpp,&di,&ki);

 }

printw("\n\
%*s:%15s",iceb_tu_kolbait(20,gettext("Сальдо начальное")),
gettext("Сальдо начальное"),prnbr(dns));
refresh();

printw(" %15s\n",prnbr(kns));
printw("%*s:%15s",iceb_tu_kolbait(20,gettext("Оборот за период")),gettext("Оборот за период"),prnbr(dpp));

printw(" %15s\n",prnbr(kpp));
printw("%*s:%15s",iceb_tu_kolbait(20,gettext("Сальдо конечное ")),gettext("Сальдо конечное "),prnbr(di));
printw(" %15s\n",prnbr(ki));

printw_vr(tmmn);

sprintf(strsql,"select ns from Plansh where stat=1");
if(sql_readkey(&bd,strsql,&row,&curr) > 0)
 {

  DANET.VVOD_delete();
  DANET.VVOD_SPISOK_add_MD("Перенести сальдо по небалансовым счетам ?");

  if(danet(&DANET,2,stdscr) == 1)
   {
    time(&tmmn);

    saldonbs(dn,mn,gn,dk,mk,gk);

    printw("\nБалансовые счета:\n\
%*s:%15s",iceb_tu_kolbait(20,gettext("Сальдо начальное")),gettext("Сальдо начальное"),prnbr(dns));
    refresh();

    printw(" %15s\n",prnbr(kns));
    printw("%*s:%15s",iceb_tu_kolbait(20,gettext("Оборот за период")),gettext("Оборот за период"),prnbr(dpp));

    printw(" %15s\n",prnbr(kpp));
    printw("%*s:%15s",iceb_tu_kolbait(20,gettext("Сальдо конечное ")),gettext("Сальдо конечное "),prnbr(di));
    printw(" %15s\n",prnbr(ki));
    printw_vr(tmmn);
   }
 }
printw("Чистим перед записью\n");
refresh();

/*Чистим год куда будут записаны сальдо*/

sprintf(strsql,"delete from Saldo where gs=%d",godp);
sql_zapis(strsql,0,0);

printw("Устанавливаем год\n");
refresh();

/*Устанавливаем год куда будут записаны сальдо*/
sprintf(strsql,"update Saldo set gs=%d where gs=0",godp);
sql_zapis(strsql,0,0);


OSTANOV();
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);
if(godp <= gt)
 {
  sprintf(strsql,"update Alx set str='Стартовый год|%d\n' where fil='nastrb.alx' and str like 'Стартовый год|%d%%'",
  godp,gn);

  sql_zapis(strsql,0,0);
 }
}

/***************************/
/*Распечатка обычных счетов*/
/***************************/

void ras1(int i,
const char *ns, //Счет
const char *nash,  //Наименование
class GLKTMP *PROM,
double *dns,
double *kns,
double *dpp,
double *kpp,
double *di,
double *ki)
{
short           i1;
short		mos; /*Метка оборотов по счетам*/
double		deb,kre;
char		strsql[512];
time_t		vrem;

deb=kre=0.;
mos=0;
double sd=0.,sk=0.;
double dpe=0.,kpe=0.;
int ks=PROM->masf.kolih();

for(i1=0;i1<ks;i1++)
 {
  sd+=PROM->sl.ravno(i*ks+i1);
  sk+=PROM->sl.ravno(i+ks*i1);

  dpe+=PROM->pe.ravno(i*ks+i1);
  kpe+=PROM->pe.ravno(i+ks*i1);
  if(fabs(PROM->pe.ravno(i*ks+i1)) > 0.009 || fabs(PROM->pe.ravno(i+ks*i1)) > 0.009)
    mos=1;
 }

if(mos == 0)
 {
  if(fabs(sd) < 0.01 && fabs(sk) < 0.01 && fabs(dpe) < 0.01 && fabs(kpe) < 0.01
  && fabs(PROM->ssd.ravno(i)) < 0.01 && fabs(PROM->ssk.ravno(i)) < 0.01)
    return;

  if(fabs(sd+PROM->ssd.ravno(i)-sk-PROM->ssk.ravno(i)) < 0.01 && fabs(dpe) < 0.01 && fabs(kpe) < 0.01)
   return;
 }

*dpp+=dpe;
*kpp+=kpe;
double dii,kii;
if(PROM->ssd.ravno(i)+sd + dpe >= PROM->ssk.ravno(i)+sk+kpe)
 {
  if(PROM->ssd.ravno(i)+sd >= PROM->ssk.ravno(i)+sk)
   {
    *dns+=(PROM->ssd.ravno(i)+sd)-(PROM->ssk.ravno(i)+sk);
   }
  else
   {
    *kns+=(PROM->ssk.ravno(i)+sk)-(PROM->ssd.ravno(i)+sd);
   }
  *di=*di+PROM->ssd.ravno(i)+sd+dpe - (PROM->ssk.ravno(i)+sk+kpe);
  deb=PROM->ssd.ravno(i)+sd+dpe - (PROM->ssk.ravno(i)+sk+kpe);
 }
else
 {
  if(PROM->ssd.ravno(i)+sd >= PROM->ssk.ravno(i)+sk)
   {
    *dns+=(PROM->ssd.ravno(i)+sd)-(PROM->ssk.ravno(i)+sk);
    kii=(PROM->ssd.ravno(i)+sd)-(PROM->ssk.ravno(i)+sk);
    dii=(PROM->ssk.ravno(i)+sk+kpe)-(PROM->ssd.ravno(i)+sd + dpe);
   }
  else
   {
    *kns+=(PROM->ssk.ravno(i)+sk)-(PROM->ssd.ravno(i)+sd);
    kii=(PROM->ssk.ravno(i)+sk)-(PROM->ssd.ravno(i)+sd);
    dii=(PROM->ssk.ravno(i)+sk+kpe)-(PROM->ssd.ravno(i)+sd + dpe);
   }
  *ki=*ki+PROM->ssk.ravno(i)+sk+kpe-(PROM->ssd.ravno(i)+sd+dpe);
  kre=PROM->ssk.ravno(i)+sk+kpe-(PROM->ssd.ravno(i)+sd+dpe);
 }

if(fabs(deb) > 0.009 || fabs(kre) > 0.009) 
 {

  time(&vrem);

  sprintf(strsql,"insert into Saldo \
  values ('%s',%d,'%s','%s',%.2f,%.2f,%d,%ld)",
  "0",0,ns,"",deb,kre,iceb_t_getuid(),vrem);   

  sql_zapis(strsql,0,0);
 }
}

/******************************************/
/*Работаем со счетами с развернутым сальдо*/
/******************************************/
void ras2(const char *sh,
const char *nash,  //Наименование счета
double *dns,
double *kns,
double *dpp,
double *kpp,
double *di,
double *ki,
class SPISOK *ns_kontr,
class masiv_din_double *ns_kontr_debs,
class masiv_din_double *ns_kontr_kres,
class masiv_din_double *ns_kontr_debp,
class masiv_din_double *ns_kontr_krep)
{
double          d1=0.,k1=0.;
double		debs=0.,kres=0.;
double		debp=0.,krep=0.;
double          sd=0.,sk=0.,dpe=0.,kpe=0.;
char strsql[512];
SQLCURSOR cur;
double deb,kre;

for(int nomer_kontr=0; nomer_kontr < ns_kontr->kolih(); nomer_kontr++)
 {
  debs=ns_kontr_debs->ravno(nomer_kontr);
  kres=ns_kontr_kres->ravno(nomer_kontr);
  debp=ns_kontr_debp->ravno(nomer_kontr);
  krep=ns_kontr_krep->ravno(nomer_kontr);

  if(debs > kres)
   sd+=debs-kres;
  else
   sk+=kres-debs;
  deb=kre=0.;  
  if(debs+debp > kres+krep)
   {
    d1+=debs+debp-kres-krep;  
    deb=debs+debp-kres-krep;  
   }
  else
   {
    k1+=kres+krep-debs-debp;
    kre=kres+krep-debs-debp;
   }

  if(fabs(deb) > 0.009 || fabs(kre) > 0.009) 
    {
     sprintf(strsql,"insert into Saldo \
values ('%s',%d,'%s','%s',%.2f,%.2f,%d,%ld)",
     "1",0,sh,ns_kontr->ravno(nomer_kontr),deb,kre,iceb_t_getuid(),time(NULL));   

     sql_zapis(strsql,0,0);
    }

  dpe+=debp;
  kpe+=krep;
 }


*dns+=sd;
*kns+=sk;

*dpp+=dpe;
*kpp+=kpe;
/*printw("dpp=%f kpp=%d\n",dpp,kpp);*/

*di+=d1; 
*ki+=k1;


}

