/* $Id: saldomu.c,v 5.30 2011-02-22 14:33:34 sasa Exp $*/
/*16.12.2009    26.10.1999      Белых А.И.      saldomu.c
Программа переноса стартовых остатков для "Материального учета"
*/
#include        <math.h>
#include        <errno.h>
#include        <time.h>
#include        <pwd.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern struct  passwd  *ktoz; /*Кто записал*/

void		saldomu()
{
class ostatokt ost;
time_t          tmm;
time_t		vrem;
short           god,god1;
int		skl,nkk;
double		ccn;
double		nds;
int		sklz;
int		mnds;
//char		sklad[40];
short		par;
SQL_str         row;
long		kolstr,kolstr1;
char		strsql[512];
char		ostmat[16];
char		ei[32];
int		kodm;
char            sgod[112];
SQLCURSOR curr;

if(iceb_t_prn() != 0) /*Проверка возможности изменять настройки*/
 return;

memset(sgod,'\0',sizeof(sgod));

iceb_t_poldan("Стартовый год",sgod,"matnast.alx");
god1=atoi(sgod);

if(god1 == 0)
 {
  iceb_t_soob(gettext("Не введён стартовый год!"));
  return;
 }

VVOD VV(0);

VV.VVOD_SPISOK_add_ZAG(gettext("Материальный учёт"));
VV.VVOD_SPISOK_add_ZAG(gettext("Перенос стартовых остатков по карточкам"));
sprintf(strsql,"%s:%d",gettext("Стартовый год"),god1);
VV.VVOD_SPISOK_add_ZAG(strsql);

VV.VVOD_SPISOK_add_MD(gettext("С какого года.."));
VV.VVOD_SPISOK_add_MD(gettext("На какой год..."));
VV.VVOD_SPISOK_add_data(god1,5);
VV.VVOD_SPISOK_add_data(god1+1,5);

naz:;
clear();


helstr(LINES-1,0,"F2/+",gettext("расчет"),
"F10",gettext("выход"),NULL);

par=VV.vvod(0,1,1,-1,-1);

switch(par)
 {
  case FK2:
  case PLU:
    break;
  case FK10:
    return;
  default:
   goto naz;
 }

god1 = (short)ATOFM(VV.VVOD_SPISOK_return_data(0));
god = (short)ATOFM(VV.VVOD_SPISOK_return_data(1));
if(god1 == 0)
 god1=god-1;

if(god1 < 1900 || god1 > 3000)
 {
  move(20,0);
  beep();
  printw("Не правильно введен год начала !\n");
  OSTANOV();
  goto naz;
 }

if(god < 1900 || god > 3000)
 {
  move(20,0);
  beep();
  printw("Не правильно введен год на который переносим остатки !\n");
  OSTANOV();
  goto naz;
 }

if(iceb_t_pbpds(1,god) != 0)
 goto naz;
 
//memset(sklad,'\0',sizeof(sklad));
//strcpy(sklad,VV.VVOD_SPISOK_return_data(2));

clear();

VVOD DANET(1);
DANET.VVOD_SPISOK_add_ZAG("Перенос стартовых остатков по карточкам материалов");
sprintf(strsql,"Перенести остатки с %dг. на %dг. ? Вы уверены ?",god1,god);
DANET.VVOD_SPISOK_add_MD(strsql);

if(danet(&DANET,2,stdscr) == 2)
  return;

clear();
time(&tmm);

if(matnast() != 0)
 return;

printw("Год %d %d\n",god1,god);

strcpy(ostmat,gettext("ОСТ"));
/*Проверяем есть ли операция стартовый остаток и если нет то записываем ее*/
sprintf(strsql,"select kod from Prihod where kod='%s'",ostmat);

if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  sprintf(strsql,"insert into Prihod \
values ('%s','%s',%d,%ld,0,1)",ostmat,gettext("Стартовый остаток"),\
  iceb_t_getuid(),tmm);   

  sql_zapis(strsql,0,0);
 }

sprintf(strsql,"select sklad,nomk,kodm,cena,nds,mnds,ei from Kart \
order by sklad asc");
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

kolstr1=sklz=0;

while(cur.read_cursor(&row) != 0)
 {
  kolstr1++;
  strzag(LINES-1,0,kolstr,kolstr1);
/*************
  if(sklad[0] != '\0')
   {
    if(sklad[0] != '-')
    if(pole1(sklad,row[0],',',0,&i1) != 0)
      if(SRAV(sklad,row[0],0) != 0)
        continue;
    if(sklad[0] == '-')
    if(pole1(sklad,row[0],',',0,&i1) == 0 || SRAV(sklad,row[0],0) == 0)
       continue;
   }
******************/
  skl=atoi(row[0]);
  nkk=atoi(row[1]);  
  ostkar(1,1,god1,31,12,god-1,skl,nkk,&ost);

  printw("Склад - %-5d Карточка - %-5d Остаток - %.2f\n",
  skl,nkk,ost.ostg[3]);

  if(ost.ostg[3] > 0.0000001 )
   {
    if(sklz != skl)
     {
      //На всякий случай удаляем, возможно это повторный перенос остатков
      sprintf(strsql,"delete from Zkart where datd='%04d-01-01' and nomd='000' and sklad=%d",god,skl);
      sql_zapis(strsql,0,0);

      sprintf(strsql,"delete from Dokummat1 where datd='%04d-01-01' and nomd='000' and sklad=%d",god,skl);
      sql_zapis(strsql,0,0);

      sprintf(strsql,"delete from Dokummat where datd='%04d-01-01' and nomd='000' and sklad=%d",god,skl);
      sql_zapis(strsql,0,0);
      
      time(&vrem);

      if(zap_s_mudok(1,1,1,god,skl,"00","000","",ostmat,1,1,"",0,0,0,1) != 0)
       return;

      sklz=skl;
     }
    kodm=atoi(row[2]);
    ccn=atof(row[3]);
    nds=atof(row[4]);
    mnds=atoi(row[5]);
    strncpy(ei,row[6],sizeof(ei)-1);
    
    zapvdok(1,1,god,skl,nkk,kodm,"000",ost.ostg[3],ccn,ei,nds,mnds,0,1,0,"","");
    zapvkr(1,1,god,"000",skl,nkk,1,1,god,1,ost.ostg[3],ccn);

   }

 }

printw_vr(tmm);
/*********************
VVOD SOOB(1);
SOOB.VVOD_SPISOK_add_MD("Не забудьте ввести новый стартовый год в файле:");
sprintf(strsql,"%s","matnast.alx");
SOOB.VVOD_SPISOK_add_MD(strsql);
soobshw(&SOOB,stdscr,-1,-1,0,1);
******************/

short dt,mt,gt;
poltekdat(&dt,&mt,&gt);
if(god <= gt)
 {
  sprintf(strsql,"update Alx set str='Стартовый год|%d\n' where fil='matnast.alx' and str like 'Стартовый год|%d%%'",
  god,god1);

  sql_zapis(strsql,0,0);
 }

}
