/* $Id: smesh.c,v 5.13 2011-01-13 13:43:23 sasa1 Exp $ */
/*10.09.2003    18.11.1993      Белых А.И.      smesh.c
Подпрограмма смены в проводках одного номера счета на другой
*/
#include        <pwd.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif


void            smesh()
{
class iceb_tu_str sh1("");
class iceb_tu_str sh2("");
struct OPSHET	shetv;
struct OPSHET	shetv1;
long		kolstr;
SQL_str         row,row1;
char		strsql[512];
time_t		vrem;
struct  tm      *bf;

clear(); /*Очистить экран и закрасить фоновым цветом*/
VVOD VVOD1(2);
VVOD1.VVOD_SPISOK_add_ZAG(gettext("Смена одного счета на другой во всех проводках."));


helstr(LINES-1,0," F10 ",gettext("выход"),NULL);


VVOD1.VVOD_SPISOK_add_MD(gettext("Введите номер счета, который нужно заменить."));

if(vvod1(&sh1,16,&VVOD1,NULL,stdscr,-1,-1) == FK10)
  return;

helstr(LINES-1,0," F10 ",gettext("выход"),NULL);

VVOD1.VVOD_delete();

VVOD1.VVOD_SPISOK_add_MD(gettext("Введите номер счета, на который нужно заменить."));


if(vvod1(&sh2,16,&VVOD1,NULL,stdscr,-1,-1) == FK10)
  return;


if(sh1.getdlinna() <= 1 || sh2.getdlinna() <= 1)
  return;

move(20,0);

if(prsh(sh1.ravno(),&shetv) == 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Нет счета %s в плане счетов !"),sh1.ravno());
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

if(prsh(sh2.ravno(),&shetv1) == 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Нет счета %s в плане счетов !"),sh2.ravno());
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

if(shetv.saldo == 3 && shetv1.saldo != 3)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Счет %s c развернутым сальдо, а счет %s нет !"),sh1.ravno(),sh2.ravno());
  SOOB.VVOD_SPISOK_add_MD(strsql);
  SOOB.VVOD_SPISOK_add_MD(gettext("Такая замена не возможна !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }
if(shetv1.saldo == 3 && shetv.saldo != 3)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Счет %s c развернутым сальдо, а счет %s нет !"),sh2.ravno(),sh1.ravno());
  SOOB.VVOD_SPISOK_add_MD(strsql);
  SOOB.VVOD_SPISOK_add_MD(gettext("Такая замена не возможна !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

VVOD DANET(1);

DANET.VVOD_SPISOK_add_MD(gettext("Выполнить корректировку ? Вы уверены ?"));

if(danet(&DANET,2,stdscr) == 2)
   return;

time(&vrem);
bf=localtime(&vrem);

VVOD PAR(2);

PAR.VVOD_SPISOK_add_MD(gettext("Введите пароль."));

if(parolv(&PAR,bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,0) != 0)
  return;


clear();
printw(gettext("Запущен режим смены счета %s в проводках на счет %s\n"),sh1.ravno(),sh2.ravno());
GDITE();
SQLCURSOR cur;
SQLCURSOR cur1;

if(shetv.saldo == 3)
 {
  printw(gettext("Проверяем, есть ли контрагенты в списке счета и если нет делаем запись.\n"));
  sprintf(strsql,"select kodkon from Prov where sh='%s' or shk='%s'",
  sh1.ravno(),sh1.ravno());
  
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

  if(kolstr == 0)
   {
    printw(gettext("Не найдено ни одной записи !"));
    OSTANOV();
    return;
   }

  printw(gettext("Количество проводок для корректировки %ld\n"),kolstr);
  refresh();
  while(cur.read_cursor(&row) != 0)
   {
    sprintf(strsql,"select kodkon from Skontr where ns='%s' and \
kodkon='%s'",sh2.ravno(),row[0]);
   if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
    {
     sprintf(strsql,"insert into Skontr values ('%s','%s',%d,%ld)",
     sh2.ravno(),row[0],iceb_t_getuid(),vrem);
     if(sql_zap(&bd,strsql) != 0)
      {
       sprintf(strsql,"Ошибка ввода записи !\n%s\n",sql_error(&bd));
       error2(20,0,1,strsql);
      }

    }
   
   }
 }

printw(gettext("Меняем дебетовые счета.\n"));
refresh();

sprintf(strsql,"update Prov \
set \
sh='%s',\
ktoi=%d,\
vrem=%ld \
where sh='%s'",sh2.ravno(),iceb_t_getuid(),vrem,sh1.ravno());
if(sql_zap(&bd,strsql) != 0)
  msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

printw(gettext("Меняем кредитовые счета.\n"));
refresh();
sprintf(strsql,"update Prov \
set \
shk='%s',\
ktoi=%d,\
vrem=%ld \
where shk='%s'",sh2.ravno(),iceb_t_getuid(),vrem,sh1.ravno());
if(sql_zap(&bd,strsql) != 0)
  msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

/*Меняем счет в стартовых сальдо*/
printw(gettext("Проверяем стартовые сальдо.\n"));
refresh();

if(shetv.saldo == 3)
 {
  printw(gettext("Проверяем, есть ли контрагенты в списке счета и если нет делаем запись.\n"));
  sprintf(strsql,"select kodkon from Saldo where ns='%s'",
  sh1.ravno());
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

  if(kolstr == 0)
   {
    printw(gettext("Не найдено ни одной записи !"));
    OSTANOV();
    goto bh3;
   }

  printw(gettext("Количество проводок для корректировки %ld\n"),kolstr);
  refresh();
  while(cur.read_cursor(&row) != 0)
   {
    sprintf(strsql,"select kodkon from Skontr where ns='%s' and \
kodkon='%s'",sh2.ravno(),row[0]);
   if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
    {
     sprintf(strsql,"insert into Skontr values ('%s','%s',%d,%ld)",
     sh2.ravno(),row[0],iceb_t_getuid(),vrem);
     if(sql_zap(&bd,strsql) != 0)
      {
       sprintf(strsql,"Ошибка ввода записи !\n%s\n",sql_error(&bd));
       error2(20,0,1,strsql);
      }

    }
   
   }
 }


bh3:;

printw(gettext("Меняем стартовые сальдо.\n"));
refresh();

sprintf(strsql,"update Saldo \
set \
ns='%s',\
ktoi=%d,\
vrem=%ld \
where ns='%s'",sh2.ravno(),iceb_t_getuid(),vrem,sh1.ravno());
if(sql_zap(&bd,strsql) != 0)
  msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

if(shetv.saldo == 3)
 {

  printw(gettext("Удаляем список контрагентов по сменяемому счету.\n"));
  refresh();
  sprintf(strsql,"delete from Skontr where ns='%s'",sh1.ravno());
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
 }

printw(gettext("Все замены сделаны.\n"));

OSTANOV();
}
