/*$Id: snu.c,v 5.13 2011-01-13 13:43:23 sasa1 Exp $*/
/*03.11.2009	23.03.2005	Белых А.И.	snu.c
Свод по начислениям и удержаниям зарплаты
*/
#include        <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void snu_ras(int metka,masiv_din_int *kod,double *suma,FILE *ff);

extern char *organ;

int snu(class spis_oth *oth)
{
class iceb_tu_str fiov("");
static char	dat1[11];
static char	dat2[11];
static char     podr[112];
static char	tabnom[122];
static char	shet[122];
static char kategor[112];
short dt,mt,gt;
int kom=0;
int kom1=0;
char naimp[512];
char strsql[512];
int tabn;

VVOD VV(0);
VVOD MENU(3);
poltekdat(&dt,&mt,&gt);
if(dat1[0] == '\0')
 sprintf(dat1,"%d.%d",mt,gt);

VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка свода начислений и удержаний"));

VV.VVOD_SPISOK_add_data(dat1,8);
VV.VVOD_SPISOK_add_data(dat2,8);
VV.VVOD_SPISOK_add_data(podr,sizeof(podr));
VV.VVOD_SPISOK_add_data(tabnom,sizeof(tabnom));
VV.VVOD_SPISOK_add_data(shet,sizeof(shet));
VV.VVOD_SPISOK_add_data(kategor,sizeof(kategor));


VV.VVOD_SPISOK_add_MD(gettext("Дата начала.....(м.г).."));//0
VV.VVOD_SPISOK_add_MD(gettext("Дата конца......(м.г).."));//1
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения.(,,)."));//2
VV.VVOD_SPISOK_add_MD(gettext("Табельный номер..(,,).."));//3
VV.VVOD_SPISOK_add_MD(gettext("Счет.............(,,).."));//4
VV.VVOD_SPISOK_add_MD(gettext("Категории........(,,).."));//5



naz:;

clear(); 

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(podr,VV.VVOD_SPISOK_return_data(2),sizeof(podr)-1);
strncpy(tabnom,VV.VVOD_SPISOK_return_data(3),sizeof(tabnom)-1);
strncpy(shet,VV.VVOD_SPISOK_return_data(4),sizeof(shet)-1);
strncpy(kategor,VV.VVOD_SPISOK_return_data(5),sizeof(kategor)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp4_9.txt");
   goto naz;

  case FK10:
  case ESC:
   return(1);

  case FK2:
  case PLU:
   break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка табельных номеров"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка категорий"));//3
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//4

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 4 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Podr",podr,sizeof(podr),naimp);
        VV.VVOD_SPISOK_zapis_data(2,podr);
        goto naz;

      case 1 :
      
        fiov.new_plus("");
        tabn=0;
        if(dirtab(&tabn,&fiov,0,1) == 0)
         {
          if(tabnom[0] == '\0')
            sprintf(tabnom,"%d",tabn);
          else
           {
            sprintf(strsql,"%d",tabn);
            if(strlen(tabnom)+strlen(strsql)+1 < sizeof(tabnom)-1)
             {
              strcat(tabnom,",");
              strcat(tabnom,strsql);
             }
           }
          VV.VVOD_SPISOK_zapis_data(3,tabnom);
         }
        goto naz;

      case 2 :
        vibrek("Plansh",shet,sizeof(shet),naimp);
        VV.VVOD_SPISOK_zapis_data(4,shet);
        goto naz;
      
      case 3 :
        vibrek("Kateg",kategor,sizeof(kategor),naimp);
        VV.VVOD_SPISOK_zapis_data(5,kategor);
        goto naz;


     }

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
    goto naz;
 }
GDITE();
short mn,gn;
short mk,gk;

if(rsdat1(&mn,&gn,VV.VVOD_SPISOK_return_data(0)) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(VV.VVOD_SPISOK_return_data(1)[0] == '\0')
 {
  mk=mn; gk=gn;
 }
else
 if(rsdat1(&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
  {
   VVOD SOOB(1);
   SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конца !"));
   soobshw(&SOOB,stdscr,-1,-1,0,1);
   goto naz;
  }
/************расчёт********************/

int kolstr;
SQL_str row;
SQLCURSOR cur;
masiv_din_int nahis;
masiv_din_int uder;

//формируем масив начислений
sprintf(strsql,"select kod from Nash");

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены начисления !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
 
while(cur.read_cursor(&row) != 0)
  nahis.plus(atoi(row[0]),-1);

double suma_nahis[nahis.kolih()];
memset(&suma_nahis,'\0',sizeof(suma_nahis));
//формируем масив удержаний
sprintf(strsql,"select kod from Uder");

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены удержания !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

while(cur.read_cursor(&row) != 0)
  uder.plus(atoi(row[0]),-1);

double suma_uder[uder.kolih()];
memset(&suma_uder,'\0',sizeof(suma_uder));


sprintf(strsql,"select tabn,prn,knah,suma,shet,podr,datz from Zarp where \
datz >= '%04d-%02d-%02d' and datz <= '%04d-%02d-%02d' and suma <> 0. \
order by tabn asc",gn,mn,1,gk,mk,31);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

int kolstr1=0;
int prn=0;
double suma=0.;
int knah=0;
int nomer=0;
short dz,mz,gz;
SQL_str row1;
class SQLCURSOR cur1;
while(cur.read_cursor(&row) != 0)
 {

  strzag(LINES-1,0,kolstr,++kolstr1);

  if(proverka(podr,row[5],0,0) != 0)
    continue;
  if(proverka(tabnom,row[0],0,0) != 0)
    continue;
  if(proverka(shet,row[4],0,0) != 0)
    continue;
  if(kategor[0] != '\0')
   {
    rsdat(&dz,&mz,&gz,row[6],2);    
    sprintf(strsql,"select kateg from Zarn where tabn=%s and god=%d and mes=%d",row[0],gz,mz);
    if(readkey(strsql,&row1,&cur1) == 1)
     {
      if(proverka(kategor,row1[0],0,0) != 0)
       continue;
     }
    else
     {
      printw("%s\n",strsql);
      printw("Не найдена категория для %s\n",row[0]);
      OSTANOV();
     }
   }

  prn=atoi(row[1]);
  knah=atoi(row[2]);
  suma=atof(row[3]);  
  if(prn == 1)//начисления
   {
    if((nomer=nahis.find(knah)) < 0)
     continue;
    suma_nahis[nomer]+=suma;
   }

  if(prn == 2) //удержания
   {
    if((nomer=uder.find(knah)) < 0)
     continue;
    suma_uder[nomer]+=suma;
   }
  
 }

char imaf[40];
FILE *ff;
sprintf(imaf,"snu%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

zagolov(gettext("Рacчёт свода начислений и удержаний"),1,mn,gn,31,mk,gk,organ,ff);

if(shet[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Счёт"),shet);

if(podr[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Подразделение"),podr);

if(tabnom[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Табельный номер"),tabnom);
if(kategor[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Категория"),kategor);

fprintf(ff,"\n");

snu_ras(1,&nahis,suma_nahis,ff);

fprintf(ff,"\n");

snu_ras(2,&uder,suma_uder,ff);

podpis(ff);

fclose(ff);

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Рacчёт свода начислений и удержаний"));
iceb_t_ustpeh(imaf,1);
return(0);
}
/*******************************/
/*Распечатка*/
/*******************************/

void snu_ras(int metka,//1-Начисления 2-Удержания
masiv_din_int *kod,
double *suma,
FILE *ff)
{
char strsql[512];
char naim[512];
SQL_str row;
SQLCURSOR cur;

if(metka == 1)
 fprintf(ff,"%s.\n",gettext("Начисления")); 
if(metka == 2)
 fprintf(ff,"%s.\n",gettext("Удержания")); 

fprintf(ff,"\
----------------------------------------------\n");

fprintf(ff,"\
Код|     Наименование             |  Сумма   |\n");

fprintf(ff,"\
----------------------------------------------\n");
double itogo=0.;
for(int i=0; i < kod->kolih() ; i++)
 {
  if(suma[i] == 0.)
   continue;
  if(metka == 1)
   sprintf(strsql,"select naik from Nash where kod=%d",kod->ravno(i));
  if(metka == 2)
   sprintf(strsql,"select naik from Uder where kod=%d",kod->ravno(i));
  memset(naim,'\0',sizeof(naim));
  if(readkey(strsql,&row,&cur) == 1)
    strncpy(naim,row[0],sizeof(naim)-1);
    
  fprintf(ff,"%3d %-*.*s %10.2f\n",
  kod->ravno(i),
  iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim,
  suma[i]);
  itogo+=suma[i];
 }
fprintf(ff,"\
----------------------------------------------\n");
fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(34,gettext("Итого")),gettext("Итого"),itogo);

}
