/* $Id: socstrm.c,v 5.28 2011-03-28 06:53:58 sasa Exp $ */
/*24.05.2009	05.04.2000	Белых А.И.	socstrm.c
Меню для запуска расчета свода социальных отчислений с
фонда зарплаты
*/
#include        <math.h>
#include        <time.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void	socstr(short,short,short,short,const char*,const char*,const char*,char*,FILE*,FILE*);

extern short	mmm,ggg;

int socstrm(class spis_oth *oth)
{
static char	kodf[50];
static char	tabnom[50];
static char	podr[50];
static char	dat1[11];
static char	dat2[11];
int		kom,kom1;
char		naim[512];
char		kod[32];
short		mn,gn;
short		mk,gk;
time_t		tmm;
char		imaf[32],imaf1[32];
FILE		*ff,*ff1;
int		tabn;
class iceb_tu_str fiov("");
if(dat1[0] == '\0')
 sprintf(dat1,"%d.%d",mmm,ggg);

VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Расчет отчислений в соц. фонды."));

VV.VVOD_SPISOK_add_data(dat1,8);
VV.VVOD_SPISOK_add_data(dat2,8);
VV.VVOD_SPISOK_add_data(podr,sizeof(podr));
VV.VVOD_SPISOK_add_data(tabnom,sizeof(tabnom));
VV.VVOD_SPISOK_add_data(kodf,sizeof(kodf));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала (м.г)...."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца (м.г)....."));
VV.VVOD_SPISOK_add_MD(gettext("Подразделение.(,,)..."));
VV.VVOD_SPISOK_add_MD(gettext("Табельный номер (,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Код соц. фонда..(,,)."));

naz:;
clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F5",gettext("настройка"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(podr,VV.VVOD_SPISOK_return_data(2),sizeof(podr)-1);
strncpy(tabnom,VV.VVOD_SPISOK_return_data(3),sizeof(tabnom)-1);
strncpy(kodf,VV.VVOD_SPISOK_return_data(4),sizeof(kodf)-1);

switch (kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp4_7_4.txt");
   goto naz;
  case ESC:
  case FK10:
     return(1);
     break;

  case PLU:
  case FK2:
     break;

  case FK3:

    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка табельных номеров."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка соц. фондов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Podr",podr,sizeof(podr),naim);
        VV.VVOD_SPISOK_zapis_data(2,podr);
        goto naz;

      case 1 :

        tabn=0;
        if(dirtab(&tabn,&fiov,0,1) == 0)
         {
          sprintf(kod,"%d",tabn);
          if(tabnom[0] == '\0')
            sprintf(tabnom,"%s",kod);
          else
           {
            if(strlen(tabnom)+strlen(kod)+1 < sizeof(tabnom)-1)
             {
              strcat(tabnom,",");
              strcat(tabnom,kod);
             }
           }
          VV.VVOD_SPISOK_zapis_data(3,tabnom);
         }
        goto naz;

      case 2 :
        vibrek("Zarsoc",kodf,sizeof(kodf),naim);
        VV.VVOD_SPISOK_zapis_data(4,kodf);
        goto naz;

     }    
  case FK4:
    VV.VVOD_clear_data();
    goto naz;

  case FK5:
    iceb_redfil("socstr.alx",0);
    goto naz;
    
  default:
    goto naz;
    break;
 }

if(rsdat1(&mn,&gn,dat1) != 0)
 { 
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала!"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 } 
if(dat2[0] == '\0')
 {
  mk=mn; gk=gn;
 }
else
 if(rsdat1(&mk,&gk,dat2) != 0)
  {
   VVOD SOOB(1);
   SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конца !"));
   soobshw(&SOOB,stdscr,-1,-1,0,1);
   goto naz;
  }

clear(); /*Очистить экран и закрасить фоновым цветом*/
printw("%s\n",gettext("Расчет отчислений в соц. фонды."));
printw("%d.%d%s => %d.%d%s\n",
mn,gn,gettext("г."),
mk,gk,gettext("г."));
GDITE();

time(&tmm);

sprintf(imaf,"fond%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

sprintf(imaf1,"fondr%d.lst",getpid());

if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return(1);
 }
char imaf_dol[64];
memset(imaf_dol,'\0',sizeof(imaf_dol));
socstr(mn,gn,mk,gk,podr,tabnom,kodf,imaf_dol,ff,ff1);

podpis(ff);
podpis(ff1);

fclose(ff);
fclose(ff1);
printw_vr(tmm);

OSTANOV();

oth->spis_imaf.plus(imaf1);
oth->spis_naim.plus(gettext("Расчет отчислений в соц. фонды"));
oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Общие итоги"));
if(imaf_dol[0] != '\0')
 {
  oth->spis_imaf.plus(imaf_dol);
  oth->spis_naim.plus(gettext("Расчёт долей в соц. отчислениях"));
 }

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);
 
return(0);
}
