/*$Id: specras.c,v 5.27 2011-01-13 13:43:23 sasa1 Exp $*/
/*19.07.2007	19.01.2000	Белых А.И.	specras.c
Расчет количества деталей на определенное количество 
изделий
*/
#include        <errno.h>
#include        <time.h>
#include        "buhg.h"

extern double	okrg1;  /*Округление 1*/
extern char     *organ;

void		specras(int kodiz) //Код изделия
{
double		koliz;
int		i;

SQL_str         row1;
char		strsql[512];
FILE		*ff;
char		imaf[32];
int		kolnuz=0; /*Количество наименований узлов*/
int		kolndet; /*Количество наименований деталей*/
char		naim[512];
int		sss;
int		kolstr1;
char		ei[32];
int		kodm=0;
struct  tm      *bf;
class iceb_tu_str vstr("");
time_t          vrem;
VVOD VVOD1(2);

helstr(LINES-1,0,"F10",gettext("выход"),NULL);
VVOD1.VVOD_SPISOK_add_MD(gettext("Введите количество изделий"));
     
     
if((i=vvod1(&vstr,16,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
   return;
if(i == ESC)
  return;
  
koliz=vstr.ravno_atof();

if(koliz == 0)
 {
  return;
 }

GDITE();
class iceb_t_razuz_data data;
data.kod_izd=kodiz;

if((kolndet=iceb_t_razuz_kod(&data)) == 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %d !",gettext("Не найдено ни одной детали для изделия"),kodiz);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;  
 }

clear();
GDITE();
SQLCURSOR cur1;
memset(naim,'\0',sizeof(naim));
sprintf(strsql,"select naimat from Material where kodm=%d",kodiz);
if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %d !",gettext("Не найден код материалла"),kodiz);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }  
else
 strncpy(naim,row1[0],sizeof(naim)-1);

printw("%s %d %s\n\
%s:%.10g\n\
---------------------------------------------------------------------\n",
gettext("Расчет входимости в изделие"),
kodiz,naim,
gettext("Количество изделий"),
koliz);

sprintf(imaf,"specr%d.lst",kodiz);
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

startfil(ff);

time(&vrem);
bf=localtime(&vrem);


short ddd=bf->tm_mday;
short mmm=bf->tm_mon+1;
short ggg=bf->tm_year+1900;

sprintf(strsql,"%s %d %s",
gettext("Расчет входимости в изделие"),
kodiz,naim);

zagolov(strsql,bf,0,0,0,0,0,0,organ,ff);

fprintf(ff,"%s:%.10g\n",gettext("Количество изделий"),koliz);


fprintf(ff,"\x1B\x4D"); /*12-знаков*/

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
Kod |   Наименование   соcтавляющей          |Ед.из|Количество| Цена   |  Сумма   |  Остаток |  Разница |\n"));
fprintf(ff,"\
---------------------------------------------------------------------------------------------------------\n");

double koliho=0.;
double kolihr=0.;
double cena=0.;
double suma=0.;
double isuma=0.;
double ostatok=0.;

kolstr1=0;
int kolih_kod_ei=data.kod_det_ei.kolih();
for(sss=0; sss < kolih_kod_ei; sss++)
 {
  strzag(LINES-1,0,kolndet,++kolstr1);
  memset(naim,'\0',sizeof(naim));
  memset(ei,'\0',sizeof(ei));

//  kodm=kodd.ravno(sss);
  polen(data.kod_det_ei.ravno(sss),&kodm,1,'|');
  polen(data.kod_det_ei.ravno(sss),ei,sizeof(ei),2,'|');
  cena=suma=0.;
  
  if(data.metka_mu.ravno(sss) == 0)
    sprintf(strsql,"select naimat,cenapr from Material where kodm=%d",kodm);

  if(data.metka_mu.ravno(sss) == 1)
    sprintf(strsql,"select naius,cena from Uslugi where kodus=%d",kodm);

  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    beep();
    printw("%s\n",strsql);
    printw("%s %d !\n",gettext("Не найден код записи"),kodm);
    OSTANOV();
   }  
  else
   {
    strncpy(naim,row1[0],sizeof(naim)-1);
    if(row1[1] != NULL)
     cena=atof(row1[1]);
    if(cena != 0.)
     cena=okrug(cena,okrg1);
   }
//  printw("sss=%d kodm=%d kolih=%f\n",sss,kodm,kold.ravno(sss));
  
  suma=koliho=kolihr=0.;
  kolihr=data.kolih_det_ei.ravno(sss)*koliz;

  suma=cena*kolihr;
  if(suma != 0.)
   suma=okrug(suma,okrg1); 
  isuma+=suma;
  ostatok=0.;
  
  if(data.metka_mu.ravno(sss) == 0)
   {
    koliho=ostdok1(ddd,mmm,ggg,0,kodm);
    ostatok=koliho-kolihr;
   }
    
  printw("%-4d %-*.*s %10.10g %8.8g %10.2f %10.10g %10.10g\n",
  kodm,
  iceb_tu_kolbait(20,naim),iceb_tu_kolbait(20,naim),naim,
  kolihr,
  cena,suma,koliho,ostatok);

  fprintf(ff,"%-4d %-*s %*s %10.10g %8.8g %10.2f %10.10g %10.10g\n",
  kodm,
  iceb_tu_kolbait(40,naim),naim,
  iceb_tu_kolbait(5,ei),ei,
  kolihr,cena,suma,koliho,ostatok);
  
 }
fprintf(ff,"\
---------------------------------------------------------------------------------------------------------\n");
fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(71,gettext("Итого")),gettext("Итого"),isuma);
printw("%45s:%10.2f\n",iceb_tu_kolbait(45,gettext("Итого")),gettext("Итого"),isuma);

kolnuz=data.kod_uz.kolih();

if(kolnuz != 0)
 {
  printw("\n%s:\n\
----------------------------------------------------------\n",
  gettext("Входимость узлов"));
  fprintf(ff,"\n%s:\n\
-------------------------------------------------------------------------\n",
  gettext("Входимость узлов"));  
  kolstr1=0;
  for(sss=0; sss < kolnuz; sss++)
   {
    kolstr1++;
    strzag(LINES-1,0,kolndet,kolstr1);
    memset(naim,'\0',sizeof(naim));
    memset(ei,'\0',sizeof(ei));
    for(int metka=0; metka < 2; metka++)
     {
      if(metka == 0)
       sprintf(strsql,"select naimat,ei from Material where kodm=%d",data.kod_uz.ravno(sss));
      if(metka == 1)
       sprintf(strsql,"select naius,ei from Uslugi where kodus=%d",data.kod_uz.ravno(sss));
      if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
       {
        if(metka == 1)
         {        
          beep();
          printw("%s %d !\n",gettext("Не найден код записи"),data.kod_uz.ravno(sss));
          OSTANOV();
         }
       }  
      else
       {
        strncpy(naim,row1[0],sizeof(naim)-1);
        strncpy(ei,row1[1],sizeof(ei)-1);
        break;
       }
     }

    printw("%-4d %-*s %10.10g\n",
    data.kod_uz.ravno(sss),
    iceb_tu_kolbait(30,naim),naim,
    data.kolih_uz.ravno(sss)*koliz);
    
    fprintf(ff,"%-4d %-*s %*s %10.10g\n",
    data.kod_uz.ravno(sss),
    iceb_tu_kolbait(40,naim),naim,
    iceb_tu_kolbait(5,ei),ei,
    data.kolih_uz.ravno(sss)*koliz);
    
   }

 }
fprintf(ff,"\x1B\x50"); /*10-знаков*/
podpis(ff);
fclose(ff);

OSTANOV();

class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Спецификация на изделие"));
iceb_t_rabfil(&oth,"");

}
