/*$Id: sprmatpom.c,v 5.21 2011-01-13 13:43:23 sasa1 Exp $*/
/*03.11.2009	02.02.2003	Белых А.И.	sprmatpom.c
Получение отчета о выплаченной материальной помощи
*/
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void	sprmatpoms(FILE*);

extern short    *kodmp;   /*Коды материальной помощи*/
extern char	*organ;

int sprmatpom(short mn,short gn,short mk,short gk,
char *podr,char *kategr,char *tabnom,class spis_oth *oth)
{
char		strsql[512];
char		bros[512];
int		kolstr=0,kolstr1=0;
SQL_str		row,row1;
time_t		tmmn=0;
char		imaf[32];
FILE		*ff=NULL;
short		d,m,g;
struct  tm      *bf;
char		tabnomz[112];
char		fio[512];
double		suma=0.;
double		sumatab=0.;
double		itogo=0.;
char		naimn[40];
double		sumano=0.;
double		sumanoi=0.;
double		matpomb=0.;
double suma_blag_pom,suma_blag_pom_b;
SQLCURSOR curr;
time(&tmmn);
bf=localtime(&tmmn);

clear();
printw("%s\n",gettext("Распечатка списка работников, которым начислена материальная помощь."));
printw("%d.%d => %d.%d\n",mn,gn,mk,gk);
GDITE();

if(kodmp == NULL)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены коды благотворительной помощи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
if(kodmp[0] == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены коды благотворительной помощи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }


sprintf(strsql,"select datz,tabn,knah,suma,shet,kom,podr from Zarp where \
datz >= '%d-%d-1' and datz <= '%d-%d-31' and prn='1' and suma <> 0. and (",gn,mn,gk,mk);

for(int i1=1; i1 <= kodmp[0] ; i1++)
 {
  if(i1 == 1)
   sprintf(bros,"knah=%d",kodmp[i1]);
  else
   sprintf(bros," or  knah=%d",kodmp[i1]);
  strcat(strsql,bros);
 }

strcat(strsql,") order by tabn,datz asc");
//printw("%s\n",strsql);

SQLCURSOR cur;



if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
 

sprintf(imaf,"matp%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

d=1; m=mk; g=gk;
dpm(&d,&m,&g,5);

zagolov(gettext("Распечатка списка работников, которым начислена материальная помощь."),bf,1,mn,gn,d,mk,gk,organ,ff);

short	knah=0;
kolstr1=0;
memset(tabnomz,'\0',sizeof(tabnomz));
short mesz=0,godz=0;
int metkapropuska=0;
char kateg[20];
double  matpom[kodmp[0]]; //Массив сумм мат-помощи по кодам на работника за месяц
double  imatpom[kodmp[0]]; //Массив сумм мат-помощи по кодам на работника
double  inmp[kodmp[0]]; //Массив сумм необлагаемой мат-помощи по кодам всего
memset(&matpom,'\0',sizeof(matpom));
memset(&imatpom,'\0',sizeof(imatpom));
memset(&inmp,'\0',sizeof(inmp));
double bb=0;

while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s %s %s %s\n",row[0],row[1],row[2],row[3],row[4]);
//OSTANOV();  
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(proverka(tabnom,row[1],0,0) != 0)
    continue;

  if(proverka(podr,row[6],0,0) != 0)
    continue;

  if(SRAV(tabnomz,row[1],0) != 0)
   {

    memset(fio,'\0',sizeof(fio));
    //Читаем карточку табельного номера
    sprintf(strsql,"select fio,kateg from Kartb where tabn=%s",row[1]);
    if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
     {
      strncpy(fio,row1[0],sizeof(fio)-1);
      strncpy(kateg,row1[1],sizeof(kateg)-1);
     }
    metkapropuska=0;
    if(proverka(kategr,kateg,0,0) != 0)
     {
      metkapropuska=1;
      continue;
     }

    if(tabnomz[0] != '\0')
     {
      
      sumano+=bb=matpom1(atol(tabnomz),mesz,godz,kodmp,NULL,1,&matpomb,0,&suma_blag_pom,&suma_blag_pom_b);
      
      fprintf(ff,"%51s:%10.2f %10.2f\n",gettext("Итого"),sumatab,sumano);
      sumanoi+=sumano;
      if(bb != 0.)
       for(int i1=0; i1 < kodmp[0] ; i1++)
        {
         if(matpom[i1] == 0.)
          continue;
         if(matpom[i1] > bb)
          {
           inmp[i1]+=bb;
           bb=0.;
           break;
          }
         else
          {
           inmp[i1]+=matpom[i1]; 
           bb-=matpom[i1];
          }
        }
     }

    strcpy(tabnomz,row[1]);
    mesz=0;
    sumano=0.;
    sumatab=0.;


    fprintf(ff,"\n%5s %s\n",row[1],fio);

    sprmatpoms(ff);

    memset(&matpom,'\0',sizeof(matpom));

   }

  if(metkapropuska == 1)
   continue;
   
  //Читаем наименование начисления
  memset(naimn,'\0',sizeof(naimn));
  sprintf(strsql,"select naik from Nash where kod=%s",row[2]);
  if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
    strncpy(naimn,row1[0],sizeof(naimn)-1);
    
  rsdat(&d,&m,&g,row[0],2);
  if(mesz != m)
   {
    if(mesz != 0)
     {
      sumano+=bb=matpom1(atol(tabnomz),mesz,godz,kodmp,NULL,1,&matpomb,0,&suma_blag_pom,&suma_blag_pom_b);

      sumanoi+=sumano;
      if(bb != 0.)
       for(int i1=0; i1 < kodmp[0] ; i1++)
        {
         if(matpom[i1] == 0.)
          continue;
         if(matpom[i1] > bb)
          {
           inmp[i1]+=bb;
           bb=0.;
           break;
          }
         else
          {
           inmp[i1]+=matpom[i1]; 
           bb-=matpom[i1];
          }
        }
      memset(&matpom,'\0',sizeof(matpom));
     }
    mesz=m; godz=g;
   }

  suma=atof(row[3]);
  itogo+=suma;
  sumatab+=suma;
  knah=atoi(row[2]);

  for(int i1=1; i1 <= kodmp[0] ; i1++)
   if(knah == kodmp[i1])
    {
     matpom[i1-1]+=suma;
     imatpom[i1-1]+=suma;
    }                 

  fprintf(ff,"%3s %-*.*s %02d.%02d.%d %-5s %10.2f %10s %s\n",
  row[2],
  iceb_tu_kolbait(30,naimn),iceb_tu_kolbait(30,naimn),naimn,
  d,m,g,row[4],suma," ",row[5]);  
 }

sumano+=bb=matpom1(atol(tabnomz),mesz,godz,kodmp,NULL,1,&matpomb,0,&suma_blag_pom,&suma_blag_pom_b);
if(bb != 0.)
 for(int i1=0; i1 < kodmp[0] ; i1++)
  {
   if(matpom[i1] == 0.)
    continue;
   if(matpom[i1] > bb)
    {
     inmp[i1]+=bb;
     bb=0.;
     break;
    }
   else
    {
     inmp[i1]+=matpom[i1]; 
     bb-=matpom[i1];
    }
  }

fprintf(ff,"%*s:%10.2f %10.2f\n",iceb_tu_kolbait(51,gettext("Итого")),gettext("Итого"),sumatab,sumano);
sumanoi+=sumano;

fprintf(ff,"\
--------------------------------------------------------------------------------------------\n");
fprintf(ff,"%*s:%10.2f %10.2f\n",iceb_tu_kolbait(51,gettext("Общий итог")),gettext("Общий итог"),itogo,sumanoi);
fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(51,gettext("Разница")),gettext("Разница"),itogo-sumanoi);

if(kodmp[0] > 1)
 {
  fprintf(ff,"\n");
  for(int i1=1; i1 <= kodmp[0] ; i1++)
   {
    memset(naimn,'\0',sizeof(naimn));
    sprintf(strsql,"select naik from Nash where kod=%d",kodmp[i1]);
    if(sql_readkey(&bd,strsql,&row,&curr) == 1)
     strncpy(naimn,row[0],sizeof(naimn)-1);    
    fprintf(ff,"%d %-*.*s %10.2f %10.2f %10.2f\n",
    kodmp[i1],
    iceb_tu_kolbait(30,naimn),iceb_tu_kolbait(30,naimn),naimn,
    imatpom[i1-1],inmp[i1-1],imatpom[i1-1]-inmp[i1-1]);
   }                 
 }

podpis(ff);

fclose(ff);
printw_vr(tmmn);

OSTANOV();
  
oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Распечатка списка работников, которым начислена материальная помощь."));
iceb_t_ustpeh(imaf,1);
return(0);
}

/********/
/*Шапка*/
/********/

void	sprmatpoms(FILE *ff)
{

fprintf(ff,"\
--------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
Код|        Наименование          |  Дата    | Счет|  Сумма   |Не обл.сум| Коментарий\n"));
fprintf(ff,"\
--------------------------------------------------------------------------------------------\n");

}
