/* $Id: sprpen1.c,v 5.54 2011-01-13 13:43:23 sasa1 Exp $ */
/*14.01.2010 	01.12.1999	sprpen1.c	Белых А.И.
Подпрограмма получения справок для пенсионного фонда по
начисленной зарплате
*/
#include        <time.h>
#include        <math.h>
#include        <errno.h>
#include        "buhg.h"
#include        "zar11.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void	zapstr1(char*,FILE*,double,double,double,double,short);
void    zardod91(char*,char*,char*,double[],double[],double[],
	double[],short[],short[],double,short,short,char*,char*,char*,
	short,short,short,char*,char*,char*,FILE*,FILE*,FILE*,const char*);
int	masinv(class iceb_tu_int *,const char*);
void zardod13(const char *inn,const char *fio,const char *kodor,const char *naimor,const char *rukov,int *kol,int *nomst,short dd,short md,short gd,short dr,short mr,short gr,short pol_slug,int *nomzap,FILE *ff13r,FILE *ff13w,FILE *ffvv,FILE *ff_zvit_anket);

extern short	kodpenf; /*Код пенсионного фонда*/
extern char	*organ;
extern short 	ddd,mmm,ggg;
extern double   okrg; /*Округление*/
extern short    kodpen;  /*Код пенсионных отчислений*/
extern short    *kodbl;  /*Код начисления больничного*/
extern char	*shetb; /*Бюджетные счета начислений*/
extern char	*shetbu; /*Бюджетные счета удержаний*/

int sprpen1(class spis_oth *oth)
{
struct  tm      *bf;
time_t		tmm;
long		kolstr,kolstr1,kolstr2;
SQL_str         row,row1;
char		strsql[512];
int 		i,kom;
char		mpr[2]; /*Метка периода*/
class iceb_tu_int inval; /*Массив с табельными номерами инвалидов*/
class iceb_tu_int dogp;  /*Массив работающих по договору подряда*/
char		rukov[512]; /*Фамилия руководителя*/
char		glavb[512]; /*Фамилия главного бухгалтера*/
char		knvp[112]; /*Коды не входящие в расчет пенсионного отчисления*/
char		bros[512];
char		kodor[32];
short		dd,md,gd;
static short	mn,mk,godr;
static char	tabnom[112];
static char	datdok[11];
char		imafdod9[24],imafdod13[24];
char		imafv[24],imafvv[24];
FILE		*ff1,*ff2,*ff13r,*ff13w,*ffv,*ffvv;
double		bb=0.;
SQLCURSOR curr;
double		sumano[12]; /*Начисленная сумма*/
double		suman[12]; /*Сумма с которой взяты пенсионные*/
double          sumanvdp[12]; //Сумма не входящая в расчет для пенсии
double		sumapen[12]; /*Сумма пенсионного*/
double		sumapzg=0.;     //Сумма перечисленная за год
double		boln[12]; /*Сумма больничных*/
short		kold[12]; /*Количество дней больничных*/
short		kolds[12]; /*Количество дней стажа*/
char		kodnvdp[512];
class iceb_tu_str fiov("");

int		tbn;
short		d,m,g,prn;
short		mff=0;/*Метка установки на начало следующего листа*/
short		knah;
int		kol,nomst;
int		koltbn=0,koldp=0;
short		mesn,godn;
int             metka_bd=0; //0-общий результат 1-бюджет 2-хозрасчёт
short		kodts; /*Код типа ставки страхового сбора
                        1-на общих основаниях для юридических и физических особ
                        2-для инвалидов
                        3- для особ, которые работают по договорам гражданского правового характера
                        4-для особ, которые делают добровольные взносы
                        5-для владельцев патента
                        */

VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG("Розсчёт довідки для ПФУ.");

VV.VVOD_SPISOK_add_MD("Місяць початку.(м).......");//0
VV.VVOD_SPISOK_add_MD("Місяць кінця...(м).......");//1
VV.VVOD_SPISOK_add_MD("Рік............(р).......");//2
VV.VVOD_SPISOK_add_MD("Табельний номер (,,).....");//3
VV.VVOD_SPISOK_add_MD("Дата документів (д.м.р)..");//4

VV.VVOD_SPISOK_add_data(3);
VV.VVOD_SPISOK_add_data(3);
VV.VVOD_SPISOK_add_data(5);
VV.VVOD_SPISOK_add_data(sizeof(tabnom));
VV.VVOD_SPISOK_add_data(11);

if(mn != 0)
 {
  sprintf(strsql,"%d",mn);
  VV.VVOD_SPISOK_zapis_data(0,strsql);
 }
if(mk != 0)
 VV.data_plus(1,mk);
if(godr == 0)
  VV.data_plus(2,ggg-1);
else
  VV.data_plus(2,godr);
VV.data_plus(3,tabnom);

time(&tmm);
bf=localtime(&tmm);
if(datdok[0] == '\0')
 {
  sprintf(strsql,"%d.%d.%d",bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900);
  VV.data_plus(4,strsql);
 }
else
 VV.VVOD_SPISOK_zapis_data(4,datdok);
   
naz:;
clear();


helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F4",gettext("очистить"),
"F3",gettext("таб.номер"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

mn=(short)ATOFM(VV.VVOD_SPISOK_return_data(0));
mk=(short)ATOFM(VV.VVOD_SPISOK_return_data(1));
godr=(short)ATOFM(VV.VVOD_SPISOK_return_data(2));
strncpy(tabnom,VV.VVOD_SPISOK_return_data(3),sizeof(tabnom)-1);
strncpy(datdok,VV.VVOD_SPISOK_return_data(4),sizeof(datdok)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp4_7_3.txt");
   goto naz;
  case FK2:
  case PLU:
    break;

  case FK3:
    fiov.new_plus("");  
    if(dirtab(&tbn,&fiov,0,1) == 0)
     {
      sprintf(strsql,"%d",tbn);
      if(strlen(tabnom) == 0)
        strcpy(tabnom,strsql);
      else
       {
        strcat(tabnom,",");
        strcat(tabnom,strsql);
       }
      VV.VVOD_SPISOK_zapis_data(3,tabnom);
     }

    goto naz;
      
  case FK10:
  case ESC:
    return(1);
  case FK4:
    VV.VVOD_clear_data();
    goto naz;
    
  default:
    goto naz;
 }


if(rsdat(&dd,&md,&gd,datdok,1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD("Не вірно введена дата документа !");
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
if(mn < 1 || mn > 12)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD("Не вірно введен місяць початку розрахунку !");
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(mk < 1 || mk > 12)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD("Не вірно введен місяць кінця розрахунку !");
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(mn > mk)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD("Місяць початку більше місяця кінця !");
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(godr < 1900)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD("Не вірно задан рік розрахунку !");
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }


if(shetb != NULL)
 {
  VVOD MENU(3);

  MENU.VVOD_SPISOK_add_MD("Госпрозсчёт і бюджет.");
  MENU.VVOD_SPISOK_add_MD("Бюджет");
  MENU.VVOD_SPISOK_add_MD("Госпрозсчёт");
  MENU.VVOD_SPISOK_add_MD(gettext("Выход."));

  clearstr(LINES-1,0);
  if(menu3w(stdscr,&MENU,&metka_bd,-1,-1,0) != 0)
   goto naz;
 }
 
time(&tmm);
bf=localtime(&tmm);
clear();
GDITE();
/*Читаем наименование организации*/
memset(kodor,'\0',sizeof(kodor));
sprintf(bros,"select kod from Kontragent where kodkon='00'");
if(sql_readkey(&bd,bros,&row,&curr) != 1)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найден код организации 00 !"));  
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }
else
 strncpy(kodor,row[0],sizeof(kodor)-1);

printw("Період розрахунку %d > %d Рік %d\n",mn,mk,godr);



memset(kodnvdp,'\0',sizeof(kodnvdp));
iceb_t_poldan("Коды не входящие в расчет для начисления пенсии",kodnvdp,"zarnast.alx");
printw("Коды не входящие в расчет для начисления пенсии:%s\n",kodnvdp);

memset(knvp,'\0',sizeof(knvp));
sprintf(strsql,"select kodn from Zarsoc where kod=%d",kodpenf);
if(sql_readkey(&bd,strsql,&row,&curr) == 1)
 {  
  strncpy(knvp,row[0],sizeof(knvp)-1);
 }

printw("Коды не входящие в расчет отчисления в пенсионный фонд:%s\n",knvp);


iceb_t_poldan("Табельный номер руководителя",bros,"zarnast.alx");

memset(rukov,'\0',sizeof(rukov));
if(bros[0] != '\0')
 {
  sprintf(strsql,"select fio from Kartb where tabn=%s",bros);
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    beep();
    printw("Не знайдено табельного номера %s керівника !\n",bros);
    OSTANOV();
   }
  else
   {
    strncpy(rukov,row1[0],sizeof(rukov)-1);
   }
 } 

iceb_t_poldan("Табельный номер бухгалтера",bros,"zarnast.alx");

memset(glavb,'\0',sizeof(glavb));

if(bros[0] != '\0')
 {
  sprintf(strsql,"select fio from Kartb where tabn=%s",bros);
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    beep();
    printw("Не знайдено табельного номера %s головного бухгалтера!\n",bros);
    OSTANOV();
   }
  else
   {
    strncpy(glavb,row1[0],sizeof(glavb)-1);
   }
 }

printw("Создаем массив табельных номеров инвалидов.\n");
refresh();

koltbn=masinv(&inval,"zarinv.alx");

printw("Создаем массив работающих по договорам подряда.\n");
refresh();

koldp=masinv(&dogp,"zardog.alx");

printw("Массивы созданы.\n");
refresh();

memset(mpr,'\0',sizeof(mpr));
mpr[0]='0'; 
if(mn == 1 && mk == 3)
 mpr[0]='1';
if(mn == 4 && mk == 6)
 mpr[0]='2';
if(mn == 7 && mk == 9)
 mpr[0]='3';
if(mn == 10 && mk == 12)
 mpr[0]='4';
if(mn == 1 && mk == 6)
 mpr[0]='5';
if(mn == 7 && mk == 12)
 mpr[0]='6';
if(mn == 1 && mk == 9)
 mpr[0]='7';


sprintf(strsql,"select tabn,fio,datn,datk,sovm,inn,denrog,pl from Kartb");
class SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одного табельного номера !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
printw("Кількість табельних номерів - %ld\n",kolstr);
refresh();


sprintf(imafdod9,"dod9_%d.lst",getpid());
if((ff1=fopen(imafdod9,"w")) == NULL)
 {
  error_op_nfil(imafdod9,errno,"");
  return(1);
 }
sprintf(strsql,"%s","zardod9.alx");
if(iceb_t_alxout(strsql) != 0)
 return(1);
if((ff2=fopen(strsql,"r")) == NULL)
 {
  error_op_nfil(strsql,errno,"");
  return(1);
 }

sprintf(imafdod13,"dod13_%d.lst",getpid());
if((ff13w=fopen(imafdod13,"w")) == NULL)
 {
  error_op_nfil(imafdod13,errno,"");
  return(1);
 }

sprintf(strsql,"%s","zardod13.alx");
if(iceb_t_alxout(strsql) != 0)
 return(1);
if((ff13r=fopen(strsql,"r")) == NULL)
 {
  error_op_nfil(strsql,errno,"");
  return(1);
 }

sprintf(imafv,"apm_i%d.txt",godr);
if((ffv=fopen(imafv,"w")) == NULL)
 {
  error_op_nfil(imafv,errno,"");
  return(1);
 }

sprintf(imafvv,"apm_a%d.txt",godr);
if((ffvv=fopen(imafvv,"w")) == NULL)
 {
  error_op_nfil(imafvv,errno,"");
  return(1);
 }

/*создаём каталог для выгрузки файлов для системы Бест-звит*/

class iceb_tu_str kat_for_zvit;
if(iceb_t_make_kat(&kat_for_zvit,"best_zvit") != 0)
 return(1);
//Чистим каталог от файлов
iceb_t_delfil(kat_for_zvit.ravno(),"zdi");

FILE *ff_zvit_anket;
char imaf_zvit_anket[50];

sprintf(imaf_zvit_anket,"zvit_ank.zdi");


if((ff_zvit_anket=fopen(imaf_zvit_anket,"w")) == NULL)
 {
  error_op_nfil(imaf_zvit_anket,errno,"");
  return(1);
 }


fprintf(ff_zvit_anket,"\
PerType=%s\n\
Year=%d\n\
Encoding=ANSI\n","Y",godr);

fprintf(ff_zvit_anket,"\n\
ФПЕН5.FIRM_EDRPOU=%s\n\
ФПЕН5.FIRM_NAME=%s\n\
ФПЕН5.REP_DATE=%02d.%02d.%04d\n\
ФПЕН5.FIRM_RUK=%s\n\
ФПЕН5.REP_NAZV=%s\n\
ФПЕН5.REP_PERTYP=%s\n",
kodor,
organ,
dd,md,gd,
rukov,
"INDANI",
"Y");

fprintf(ff_zvit_anket,"GROUP \"ФПЕН5.1\"\n");



kol=mff=kolstr1=0;
nomst=1;
char inn[20];
short dr,mr,gr;
short pol_slug=0;
int nomzap=0;
double suma_per=0;
while(cur.read_cursor(&row) != 0)
 {
  kolstr1++;
  strzag(LINES-1,0,kolstr,kolstr1);
  if(proverka(tabnom,row[0],0,0) != 0)
    continue;

  tbn=atol(row[0]);


  /*Смотрим былили начисления */

  sprintf(strsql,"select datz,prn,knah,suma,kdn,godn,mesn,shet from Zarp where \
datz >= '%04d-%d-01' and datz <= '%04d-%d-31' and tabn=%d and suma <> 0.",
  godr,mn,godr,mk,tbn);

  SQLCURSOR cur1;
  if((kolstr2=cur1.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }

  if(kolstr2 == 0)
   {
    //если не уволен грузить
    if(row[3][0] != '0')
      continue;        
   }
  memset(&sumano,'\0',sizeof(sumano));
  memset(&sumanvdp,'\0',sizeof(sumanvdp));
  memset(&sumapen,'\0',sizeof(sumapen));
  memset(&kolds,'\0',sizeof(kolds));
  memset(&kold,'\0',sizeof(kold));
  memset(&boln,'\0',sizeof(boln));
  while(cur1.read_cursor(&row1) != 0)
   {
    prn=atoi(row1[1]);
    if(metka_bd == 1) //Бюджет
     {    
      if(prn == 1)
        if(proverka(shetb,row1[7],0,1) != 0)
         continue;
      if(prn == 2)
        if(proverka(shetbu,row1[7],0,1) != 0)
         continue;
     }
    if(metka_bd == 2) //Хозрасчёт
     {    
      if(prn == 1)
        if(proverka(shetb,row1[7],0,1) == 0)
         continue;
      if(prn == 2)
        if(proverka(shetbu,row1[7],0,1) == 0)
         continue;
     }

    rsdat(&d,&m,&g,row1[0],2);
    godn=atoi(row1[5]);
    mesn=atoi(row1[6]);
    
    knah=atoi(row1[2]);
    bb=atof(row1[3]);
    suma_per=0.;
    if(prn == 1)
     {
      /*Для госстандарта*/
      if(knah == 61 && m == 9)
       {
        suma_per+=bb;
       }
     /****************/
      if(godr == godn && provkod(kodbl,knah) >= 0)
       {
        boln[mesn-1]+=bb;
        kold[mesn-1]+=atoi(row1[4]);
        sumano[mesn-1]+=bb;
        continue;
       }

      if(proverka(knvp,row1[2],0,1) != 0)
       sumano[m-1]+=bb;

      if(proverka(kodnvdp,row1[2],0,1) == 0)
        sumanvdp[m-1]+=bb;
     }
    if(prn == 2)
     {
      if(godr == godn && knah == kodpen)
        sumapen[mesn-1]+=bb*(-1);
     }
   }
  //Смотрим отчисления в соц-фонд

  memset(&suman,'\0',sizeof(suman));
  sumapzg=0.;
  sprintf(strsql,"select datz,sumas,sumap,sumapb,sumasb from Zarsocz where tabn=%d \
and datz >= '%04d-%d-01' and datz <= '%04d-%d-31' and kodz=%d",
  tbn,godr,mn,godr,mk,kodpenf);

  
  if((kolstr2=cur1.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }
  
  if(kolstr2 == 0)
   {
    //У предприятий на едином налоге нет начисления на фонд зарплаты
//    printw("%d Нет соц. отчислений !\n",tbn);
//    continue;        
   }
  while(cur1.read_cursor(&row1) != 0)
   {
    rsdat(&d,&m,&g,row1[0],2);

    if(metka_bd == 0) //Всё
     {
            
      suman[m-1]+=atof(row1[1])-sumanvdp[m-1];
      
      if(fabs(sumanvdp[m-1]) > 0.009)
       {
        sumapen[m-1]=pens(tbn,m,g,suman[m-1],NULL);
        bb=atof(row1[1])-boln[m-1]-sumanvdp[m-1];
        bb=bb*.32;
        bb=okrug(bb,0.01);
        sumapzg+=bb;
       }
      else    
        sumapzg+=atof(row1[2]);
     }
    if(metka_bd == 1) //Бюджет
     {
      
      suman[m-1]+=atof(row1[4])-sumanvdp[m-1];

      if(fabs(sumanvdp[m-1]) > 0.009)
       {
        sumapen[m-1]=pens(tbn,m,g,suman[m-1],NULL);
        bb=atof(row1[4])-boln[m-1]-sumanvdp[m-1];
        bb=bb*.32;
        bb=okrug(bb,0.01);
        sumapzg+=bb;
       }
      else    
        sumapzg+=atof(row1[3]);
     }
    if(metka_bd == 2) //Хозрасчёт
     {
      
      suman[m-1]+=(atof(row1[1])-atof(row1[4]))-sumanvdp[m-1];

      if(fabs(sumanvdp[m-1]) > 0.009)
       {
        sumapen[m-1]=pens(tbn,m,g,suman[m-1],NULL);
        bb=(atof(row1[1])-atof(row1[4]))-boln[m-1]-sumanvdp[m-1];
        bb=bb*.32;
        bb=okrug(bb,0.01);
        sumapzg+=bb;
       }
      else    
        sumapzg+=atof(row1[2])-atof(row1[3]);
     }
   }
  
  sprintf(strsql,"select mes,kdnei from Ztab where \
god = %d and mes >= %d and mes <= %d and tabn=%d order by mes asc",
  godr,mn,mk,tbn);

  if((kolstr2=cur1.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }

  if(kolstr2 != 0)
  while(cur1.read_cursor(&row1) != 0)
   {
    m=atoi(row1[0]);
    i=atoi(row1[1]);
/********************** 
//если не вводили календарніе дни
    if(mz != m)
     {
      if( i == 0 )
       {
        d=1;
        dpm(&d,&m,&godr,5);
        i=d;
       }
      mz=m;
     }
********************/
    kolds[m-1]+=i;
   }

  kodts=1;

  if(koltbn != 0)
   if(inval.find(tbn) >= 0)
     kodts=2;
  if(koldp != 0)
   if(dogp.find(tbn) >= 0 )
    kodts=3;
  
  rsdat(&dr,&mr,&gr,row[6],2);
  pol_slug=atoi(row[7]);
  
  mff++;
  memset(inn,'\0',sizeof(inn));
  strncpy(inn,row[5],sizeof(inn)-1);
  if(inn[0] == '\0')
   sprintf(inn,"%010d",tbn);

  if(mff > 1)
    fprintf(ff1,"\f");
  
  if(suma_per != 0.)
   {
    double pens=suma_per*2./100.;
    pens=okrug(pens,0.01);

    sumano[9]-=suma_per;
    suman[9]-=suma_per;
    sumapen[9]-=pens;

    sumano[11]+=suma_per;
    suman[11]+=suma_per;
    sumapen[11]+=pens;
        
   }

  zardod91(row[1],inn,row[4],sumano,suman,sumapen,boln,kold,kolds,sumapzg,\
  kodts,godr,rukov,glavb,mpr,dd,md,gd,kodor,row[2],row[3],ff1,ff2,ffv,kat_for_zvit.ravno());

  zardod13(inn,row[1],kodor,organ,rukov,&kol,&nomst,dd,md,gd,dr,mr,gr,pol_slug,&nomzap,ff13r,ff13w,ffvv,ff_zvit_anket);

 }
zardod13("","",kodor,organ,rukov,&kol,&nomst,dd,md,gd,0,0,0,0,&nomzap,ff13r,ff13w,ffvv,ff_zvit_anket);

fprintf(ff_zvit_anket,"GROUP \"ФПЕН5.1\" END\n");



fclose(ff1);
fclose(ff2);
fclose(ff13r);
fclose(ff13w);
fclose(ffv);
fclose(ffvv);
fclose(ff_zvit_anket);
unlink("zardod9.alx");
unlink("zardod13.alx");

printw_vr(tmm);

OSTANOV();

oth->spis_imaf.plus(imafdod9);
oth->spis_naim.plus("Додаток 9");
oth->spis_imaf.plus(imafdod13);
oth->spis_naim.plus("Додаток 13");

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),1);
 
oth->spis_imaf.plus(imafv);
oth->spis_naim.plus("Нарахування в електронному вигляді");
oth->spis_imaf.plus(imafvv);
oth->spis_naim.plus("Анкети в електоронному вигляді");

oth->spis_imaf.plus(imaf_zvit_anket);
oth->spis_naim.plus("Анкети для завантаження в систему ЗВІТ");

return(0);
}

/**************************/
/*Распечатка приложения N9*/
/**************************/

void zardod91(char fio[], //Фамилия имя отчество
char inn[], //Индетификационный номер
char sovm[], //0-нет 1-метка совместителя
double sumano[], //Начисленная сумма
double suman[], //Сумма с которой взяты пенсионные
double sumapen[], //Сумма пенсионного
double boln[],    //Сумма больничных
short kold[],   //Количество дней больничных
short kolds[],  //Количество дней стажа
double sumapzg,
short kodts, //Код типа ставки страхового збора
short godr,  //Год расчета
char rukov[],
char glavb[],
char mpr[],  //Метка периода
short dd,short md,short gd,
char kodor[], //Код роботодавця
char datn[], //Дата приема на работу
char datk[], //Дата увольнения
FILE *ff1,FILE *ff2,FILE *ffv,
const char *kat_for_zvit)
{
short		nomstr;
char		bros[512];
char		str[512];
double		drob,cel,isumno,isumn,ipens,iboln;
int		ikolds;
int		i;
double		sumsb=0.; /*Сумма страхового сбора уплаченного заработника*/
short		dn,mn,gn;
short		dk,mk,gk;
short		kolpm,kolpd;
short		d,m,g;

rsdat(&dn,&mn,&gn,datn,2);
if(gn < godr)
 {
  gn=godr;
  dn=mn=1;
 }

rsdat(&dk,&mk,&gk,datk,2);
if(gk == 0 || gk > godr) 
 {
  gk=godr;
  dk=31;
  mk=12;
 } 

ipens=isumn=isumno=0.;
ikolds=0;
iboln=0.;
for(i=0; i < 12 ; i++)
 {
  iboln+=boln[i];
  isumno+=sumano[i];
  ikolds+=kolds[i];
  isumn+=suman[i];
  ipens+=sumapen[i];
 }

d=dn;
m=mn;
g=gn;
dpm(&d,&m,&g,5);
kolpd=0;
kolpm=mk-mn+1;
if(dn != 1 )
 {
  kolpm--;
  kolpd=d-dn+1;
 }

if(mn != mk)
 {
  d=dk;
  m=mk;
  g=gk;


  dpm(&d,&m,&g,5);
  if(dk < d)
   {
    kolpm--;
    kolpd+=dk;
   }
 }

if(mn == mk && gn == gk)
 kolpd=dk -dn+1; 
for(nomstr=1; fgets(str,sizeof(str),ff2) != NULL ; nomstr++)
 {
  switch(nomstr)
   {
    case 12: 
      BSTAB(str,inn,25,46,2);
      fprintf(ff1,"%s",str);
      break;

  /*Фамилия*/
    case 14: 
      POLE(fio,bros,1,' ');
      BSTAB(str,bros,14,54,1);
      fprintf(ff1,"%s",str);
      break;

  /*Имя*/
    case 15: 
      POLE(fio,bros,2,' ');
      BSTAB(str,bros,14,54,1);
      fprintf(ff1,"%s",str);
      break;

  /*Отчество*/    
    case 16: 
      POLE(fio,bros,3,' ');
      BSTAB(str,bros,14,54,1);
      fprintf(ff1,"%s",str);
      break;

    case 18: 
      sprintf(bros,"%d",godr);
      BSTAB(str,bros,37,46,2);
      BSTAB(str,mpr,64,65,1);
      fprintf(ff1,"%s",str);
      break;

    case 22: 
      sprintf(bros,"%d",godr);
      BSTAB(str,bros,40,48,2);
      fprintf(ff1,"%s",str);
      break;

    case 24: 
      BSTAB(str,organ,19,65,1);
      fprintf(ff1,"%s",str);
      break;

    case 25: 
      memset(bros,'\0',sizeof(bros));
      if(sovm[0] == '0')
       bros[0]='X';
      BSTAB(str,bros,68,69,1);
      fprintf(ff1,"%s",str);
      break;

    case 27: /*Код типа ставки страхового сбора*/
      sprintf(bros,"%d",kodts);
      BSTAB(str,bros,34,36,1);
      fprintf(ff1,"%s",str);
      break;

    /*Сумма страхового сбора уплаченных за работника*/
    case 30: 
             
      sumsb=sumapzg;
      drob=modf(sumsb,&cel);

      sprintf(bros,"%5.f",cel);
      BSTAB(str,bros,51,61,2);
      sprintf(bros,"%02.f",drob*100.);
      BSTAB(str,bros,66,70,2);
      fprintf(ff1,"%s",str);
      break;

    /*Сумма страхового сбора из заработка работника*/
    case 32: 
      drob=modf(ipens,&cel);

      sprintf(bros,"%5.f",cel);
      BSTAB(str,bros,51,61,2);
      sprintf(bros,"%02.f",drob*100.);
      BSTAB(str,bros,66,70,2);
      fprintf(ff1,"%s",str);
      break;
  
    /*1 Январь*/
    case 42: 
      sprintf(bros,"%02d",dn);
      BSTAB(str,bros,82,86,2);
      zapstr1(str,ff1,sumano[0],suman[0],sumapen[0],boln[0],kolds[0]);
      
      break;
  
  /*2 Февраль*/
    case 43: 
      zapstr1(str,ff1,sumano[1],suman[1],sumapen[1],boln[1],kolds[1]);
      break;

    /*3 Март*/
    case 44: 
      sprintf(bros,"%02d",mn);
      BSTAB(str,bros,82,86,2);
      zapstr1(str,ff1,sumano[2],suman[2],sumapen[2],boln[2],kolds[2]);
      break;

    /*4 Апрель*/
    case 45: 
      zapstr1(str,ff1,sumano[3],suman[3],sumapen[3],boln[3],kolds[3]);
      break;

    /*5 Май*/
    case 46: 
      if(gn < 2000)
       sprintf(bros,"%02d",gn-1900);
      else
       sprintf(bros,"%02d",gn-2000);
      BSTAB(str,bros,82,86,2);
      zapstr1(str,ff1,sumano[4],suman[4],sumapen[4],boln[4],kolds[4]);
      break;

    /*6 Июнь*/
    case 47: 
      zapstr1(str,ff1,sumano[5],suman[5],sumapen[5],boln[5],kolds[5]);
      break;

    /*7 Июль*/
    case 48: 
      zapstr1(str,ff1,sumano[6],suman[6],sumapen[6],boln[6],kolds[6]);
      break;

    /*8 Август*/
    case 49: 
      zapstr1(str,ff1,sumano[7],suman[7],sumapen[7],boln[7],kolds[7]);
      break;

    /*9 Сентябрь*/
    case 50: 
      sprintf(bros,"%02d",dk);
      BSTAB(str,bros,82,86,2);
      zapstr1(str,ff1,sumano[8],suman[8],sumapen[8],boln[8],kolds[8]);
      break;

    /*10 Октябрь*/
    case 51: 
      zapstr1(str,ff1,sumano[9],suman[9],sumapen[9],boln[9],kolds[9]);
      break;

    /*11 Ноябрь*/
    case 52: 
      sprintf(bros,"%02d",mk);
      BSTAB(str,bros,82,86,2);
      zapstr1(str,ff1,sumano[10],suman[10],sumapen[10],boln[10],kolds[10]);
      break;

    /*12 Декабрь*/
    case 53: 
      zapstr1(str,ff1,sumano[11],suman[11],sumapen[11],boln[11],kolds[11]);
      break;

    case 54: 
      if(gn < 2000)
       sprintf(bros,"%02d",gn-1900);
      else
       sprintf(bros,"%02d",gn-2000);
      BSTAB(str,bros,82,86,2);
      fprintf(ff1,"%s",str);
      break;
      
    /*Итого*/
    case 55: 
      zapstr1(str,ff1,isumno,isumn,ipens,iboln,ikolds);
      break;

    /*Количество полных дней и месяцев*/
    case 59: 
      sprintf(bros,"%02d",kolpm);
      BSTAB(str,bros,64,68,2);
      sprintf(bros,"%02d",kolpd);
      BSTAB(str,bros,77,81,2);
      fprintf(ff1,"%s",str);
      break;
    
    /*Подпись руководителя*/
    case 76: 
      sprintf(bros,"/%s/",rukov);
      BSTAB(str,bros,70,100,1);
      fprintf(ff1,"%s\n",str);
      break;

    /*Подпись главбуха*/
    case 78: 
      sprintf(bros,"/%s/",glavb);
      BSTAB(str,bros,70,100,1);
      fprintf(ff1,"%s\n",str);
      break;
    /*Дата документа*/
    case 80:
      sprintf(bros,"%02d",dd);
      BSTAB(str,bros,6,10,2);
      sprintf(bros,"%02d",md);
      BSTAB(str,bros,13,17,2);
      sprintf(bros,"%d",gd);
      BSTAB(str,bros,20,27,2);
      fprintf(ff1,"%s",str);
      break;

    default :
      fprintf(ff1,"%s",str);
      break;
   }
  memset(str,'\0',sizeof(str));
}
rewind(ff2);

memset(bros,'\0',sizeof(bros));

if(sovm[0] == '0')
 bros[0]='1';
if(sovm[0] == '1')
 bros[0]='0';
 
fprintf(ffv,"\"%s\",\"%s\",%d,\"%s\",%d,\"%s\",\"%s\",\"%d\",\
%.2f,%.2f",
"1",inn,godr,mpr,godr,kodor,bros,kodts,sumsb,ipens);

for(i=0 ; i < 12; i++)
  fprintf(ffv,",%.2f,%.2f,%.2f,%.2f,%d",sumano[i],suman[i],boln[i],sumapen[i],kolds[i]);


 
fprintf(ffv,",%.2f,%.2f,%.2f,%.2f,%d,%d%02d%02d,%d%02d%02d,%d,%d",
isumno,isumn,iboln,ipens,ikolds,gn,mn,dn,gk,mk,dk,kolpm,kolpd);

for(i=0; i < 4 ; i++)
 fprintf(ffv,",\"%s\",%d,\"%s\",%d,%d,%d,%d,%d,%d,%d,\"%s\"",
 "",0,"0",0,0,0,0,0,0,0,"0");
 
fprintf(ffv,",%d,%d%02d%02d,%d,%d%02d%02d,\"%s\",\"%s\",\"\",\"\"\n",
0,gd,md,dd,0,gd,md,dd,"","");




class iceb_tu_str imaf_zvit(kat_for_zvit);
imaf_zvit.plus("/nah");
imaf_zvit.plus(inn);
imaf_zvit.plus(".zdi");

FILE *ff_zvit_nahisl=NULL;
if((ff_zvit_nahisl=fopen(imaf_zvit.ravno(),"w")) == NULL)
 {
  error_op_nfil(imaf_zvit.ravno(),errno,"");
  return;
 }


fprintf(ff_zvit_nahisl,"\
PerType=%s\n\
Year=%d\n\
Encoding=ANSI\n","Y",godr);

char fam[512];
char ima[56];
char oth[56];
memset(fam,'\0',sizeof(fam));
memset(ima,'\0',sizeof(ima));

polen(fio,fam,sizeof(fam),1,' ');
polen(fio,ima,sizeof(ima),2,' ');
polen(fio,oth,sizeof(oth),3,' ');

fprintf(ff_zvit_nahisl,"\n\
ФПЕН4.FIRM_EDRPOU=%s\n\
ФПЕН4.FIRM_NAME=%s\n\
ФПЕН4.REP_NYEAR=%d\n\
ФПЕН4.KPU_INN=%s\n\
ФПЕН4.KPU_FAM=%s\n\
ФПЕН4.KPU_IMJ=%s\n\
ФПЕН4.KPU_OTC=%s\n\
ФПЕН4.N5=ПОЧАТКОВА\n\
ФПЕН4.N10=%d\n",
kodor,
organ,
godr,
inn,
fam,
ima,
oth,
godr);

fprintf(ff_zvit_nahisl,"\
ФПЕН4.N12=1\n\
ФПЕН4.N13=%.2f\n\
ФПЕН4.N14=%.2f\n\
ФПЕН4.N15=%d\n\
ФПЕН4.N16=%d\n\
ФПЕН4.N17=%d\n\
ФПЕН4.N18=%d\n\
ФПЕН4.N19=%d\n\
ФПЕН4.N20=%d\n\
ФПЕН4.N21=%d\n\
ФПЕН4.N22=%d\n\
ФПЕН4.N23=\n",
sumsb,
ipens,
dn,
mn,
gn,
dk,
mk,
gk,
kolpm,
kolpd);

for(int nom_mes=1; nom_mes <= 12; nom_mes++)
  fprintf(ff_zvit_nahisl,"\
ФПЕН4.A%d=%.2f\n\
ФПЕН4.B%d=%.2f\n\
ФПЕН4.C%d=%.2f\n\
ФПЕН4.D%d=%.2f\n\
ФПЕН4.E%d=%d\n",
  nom_mes,sumano[nom_mes-1],
  nom_mes,suman[nom_mes-1],
  nom_mes,boln[nom_mes-1],
  nom_mes,sumapen[nom_mes-1],
  nom_mes,kolds[nom_mes-1]);




fprintf(ff_zvit_nahisl,"\
ФПЕН4.A13=%.2f\n\
ФПЕН4.B13=%.2f\n\
ФПЕН4.C13=%.2f\n\
ФПЕН4.D13=%.2f\n\
ФПЕН4.E13=%d\n",
isumno,isumn,iboln,ipens,ikolds);

fprintf(ff_zvit_nahisl,"\
ФПЕН4.REP_DATE=%02d.%02d.%04d\n",
dd,md,gd);

if(rukov[0] != '\0')
  fprintf(ff_zvit_nahisl,"ФПЕН4.REP_RUK=%s\n",rukov);
if(glavb[0] != '\0')
  fprintf(ff_zvit_nahisl,"ФПЕН4.REP_BUH=%s\n",glavb);
 
fclose(ff_zvit_nahisl);

}

/******************************/
/*******************************/
void	zapstr1(char str[],FILE *ff1,double xsumno,double xsumn,
double xpens,double boln,short kold)
{
double		drob,cel;
char		bros[512];

if(xsumn > 0.009 || xsumno > 0.009)
 {
  drob=modf(xsumno,&cel);
  sprintf(bros,"%5.f%02.f",cel,drob*100);
  BSTAB(str,bros,4,18,2);
  drob=modf(xsumn,&cel);
  sprintf(bros,"%5.f%02.f",cel,drob*100);
  BSTAB(str,bros,18,32,2);
  if(boln > 0.009)
   {
    drob=modf(boln,&cel);
    sprintf(bros,"%4.f%02.f",cel,drob*100);
    BSTAB(str,bros,32,44,2);
   }
  drob=modf(xpens,&cel);
  sprintf(bros,"%5.f%02.f",cel,drob*100);
  BSTAB(str,bros,44,58,2);
  sprintf(bros,"%03d",kold);
  BSTAB(str,bros,58,64,2);
 }

fprintf(ff1,"%s",str);

}
