/* $Id: sumprz.c,v 5.12 2011-03-09 08:16:55 sasa Exp $ */
/*03.11.2009	29.05.1998	Белых А.И.	sumprz.c
Определение суммы выполненных проводок для определенного табельного
номера.
*/
#include        <math.h>
#include        "buhg.h"

extern double   okrg; /*Округление*/
extern char	shrpz[16]; /*Счет расчетов по зарплате*/
extern char	shrpzbt[16]; /*Счет расчетов по зарплате бюджет*/
extern class SPISOK dop_zar_sheta; //Дополнительные зарплатные счёта

double		sumprz(short m,short g,char nn[],int podr,
double *sumd,double *sumk)
{
double		sum;
long		kolstr;
SQL_str         row;
char		strsql[512];
double		deb;

*sumd=0.;
*sumk=0.;
sum=0.;

/*Суммиреум выполненные проводки*/
sprintf(strsql,"select sh,shk,deb,kre from Prov \
where kto='%s' and pod=%d and nomd='%s' and datd>='%d-%02d-01' and \
datd <= '%d-%02d-31'",
gettext("ЗП"),podr,nn,g,m,g,m);
/*
printw("\n%s\n",strsql);
OSTANOV();  
*/
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  if(sql_nerror(&bd) != ER_TABLEACCESS_DENIED_ERROR) //Запрет команды select  
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(0.);
 }

if(kolstr == 0)
 {
  return(0.);
 }

while(cur.read_cursor(&row) != 0)
 {
  deb=atof(row[2]);  

  if(SRAV(shrpz,row[1],0) == 0 || SRAV(shrpzbt,row[1],0) == 0 || dop_zar_sheta.find(row[1]) == 0)
    *sumd=*sumd+deb;
  if(SRAV(shrpz,row[0],0) == 0 || SRAV(shrpzbt,row[0],0) == 0 || dop_zar_sheta.find(row[1]) == 0) 
    *sumk=*sumk+deb;
  sum+=deb;

 }

sum=okrug(sum,okrg);
*sumd=okrug(*sumd,okrg);
*sumk=okrug(*sumk,okrg);

return(sum);
}
