/*$Id: ukrnast.c,v 5.19 2011-01-13 13:43:23 sasa1 Exp $*/
/*12.12.2010	22.10.2002	Белых А.И.	ukrnast.c
Чтение настроечной информации для подсистемы "Учет командировочных расходов."
*/
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


short		vplsh; /*0-двух уровневый план счетов 1-многоуровневый*/
short		startgod=0;
short		startgodb=0; /*Стартовый год просмотров главной книги*/
short           mfnn=0; //Метка формирования номера в этой подсистеме не задействована
double		okrcn=0.01;  /*Округление цены*/
double		okrg1=0.01;  /*Округление 1*/
//double          nds1=20.; /*Н.Д.С.*/

int		ukrnast(void)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];
char		bros[1024];
char            st1[1024];

startgodb=startgod=0;

sprintf(strsql,"select str from Alx where fil='ukrnast.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"ukrnast.alx");
  iceb_t_soob(strsql);
  return(1);
 }

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  
  polen(row_alx[0],st1,sizeof(st1),1,'|');

  if(SRAV(st1,"Стартовый год",0) == 0)
   {
    polen(row_alx[0],st1,sizeof(st1),2,'|');
    startgod=(short)ATOFM(st1); 
    continue;
   }
 }

 
iceb_t_poldan("Многопорядковый план счетов",bros,"nastrb.alx");
if(SRAV(bros,"Вкл",1) == 0)
 vplsh=1;

memset(bros,'\0',sizeof(bros));
startgodb=0;
if(iceb_t_poldan("Стартовый год",bros,"nastrb.alx") == 0)
  startgodb=(short)ATOFM(bros);

sprintf(strsql,"select str from Alx where fil='matnast.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"matnast.alx");
  iceb_t_soob(strsql);
  return(1);
 }
okrg1=0.01;
okrcn=0.01;
//nds1=20.;

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  polen(row_alx[0],st1,sizeof(st1),1,'|');

  if(SRAV(st1,"Округление 1",0) == 0)
   {
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     okrg1=ATOFM(st1);
     continue;
   }
/**************
  if(SRAV(st1,"Н.Д.С.",0) == 0)
   {
    polen(row_alx[0],st1,sizeof(st1),2,'|');
    nds1=ATOFM(st1);
    nds1=okrug(nds1,0.01);
    continue;
   }
*************/
  if(SRAV(st1,"Округление цены",0) == 0)
   {
    polen(row_alx[0],st1,sizeof(st1),2,'|');
    okrcn=ATOFM(st1);
    continue;
   }
 }
return(0); 
}
