/*$Id: uos_sp.c,v 5.7 2011-01-13 13:43:23 sasa1 Exp $*/
/*03.11.2009	09.09.2007	Белых А.И.	uos_sp.c
Расчёт списания/получения основных средств по счетам списания/получения
Если вернули 0- расчёт выполнен
             1- нет
*/
#include <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char     *organ;/*Наименование организации*/


int uos_sp(int metka, /*1-по счетам приобретения 2-по счетам списания*/
class spis_oth *oth)
{
static char     dat1[11],dat2[11];
static char shets_p[112]; //Счёт списания /получения
static char shetu_p[112]; //Счёт учёта
static char kodop_p[112];
static char kontr_p[112];
static char kod_podr[112];
static char kod_mo[112];

char naim[512];
int kom=0,kom1=0;
char strsql[512];

VVOD MENU(3);
VVOD VV(0);

VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(dat2,11);
VV.VVOD_SPISOK_add_data(shets_p,sizeof(shets_p));
VV.VVOD_SPISOK_add_data(shetu_p,sizeof(shets_p));
VV.VVOD_SPISOK_add_data(kodop_p,sizeof(kodop_p));
VV.VVOD_SPISOK_add_data(kontr_p,sizeof(kontr_p));
VV.VVOD_SPISOK_add_data(kod_podr,sizeof(kod_podr));
VV.VVOD_SPISOK_add_data(kod_mo,sizeof(kod_mo));


if(metka == 1)
 VV.VVOD_SPISOK_add_ZAG(gettext("Движение основных средств по счетам приобретения."));
if(metka == 2)
 VV.VVOD_SPISOK_add_ZAG(gettext("Движение основных средств по счетам списания."));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала...(д.м.г)..."));//0
VV.VVOD_SPISOK_add_MD(gettext("Дата конца....(д.м.г)..."));//1

if(metka == 1)
VV.VVOD_SPISOK_add_MD(gettext("Счет получения.(,,)....."));//2
if(metka == 2)
VV.VVOD_SPISOK_add_MD(gettext("Счет списания.(,,)......"));//2

VV.VVOD_SPISOK_add_MD(gettext("Счет учёта..(,,)........"));//3
VV.VVOD_SPISOK_add_MD(gettext("Код операции....(,,)...."));//4
VV.VVOD_SPISOK_add_MD(gettext("Код контрагента.(,,)...."));//5
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения.(,,).."));//6
VV.VVOD_SPISOK_add_MD(gettext("Код мат.ответств. (,,).."));//7



naz:;
clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,0,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(shets_p,VV.VVOD_SPISOK_return_data(2),sizeof(shets_p)-1);
strncpy(shetu_p,VV.VVOD_SPISOK_return_data(3),sizeof(shetu_p)-1);
strncpy(kodop_p,VV.VVOD_SPISOK_return_data(4),sizeof(kodop_p)-1);
strncpy(kontr_p,VV.VVOD_SPISOK_return_data(5),sizeof(kontr_p)-1);
strncpy(kod_podr,VV.VVOD_SPISOK_return_data(6),sizeof(kod_podr)-1);
strncpy(kod_mo,VV.VVOD_SPISOK_return_data(7),sizeof(kod_mo)-1);

class iceb_tu_str kods("");
class iceb_tu_str naims("");
switch (kom)
 {

  case FK10:
  case ESC:
   return(1);

  case FK1:
    GDITE();
    iceb_t_pdoc("matu5_19.txt");
    clear();
    goto naz;

  case FK2:
  case PLU:
    break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка контрагентов.")); //0
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций приходов."));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операцій расходов."));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов."));//3
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));//4

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 4 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Kontragent",kontr_p,sizeof(kontr_p),naim);
        VV.VVOD_SPISOK_zapis_data(5,kontr_p);
        goto naz;

      case 1 :
        vibrek("Uospri",kodop_p,sizeof(kodop_p),naim);
        VV.VVOD_SPISOK_zapis_data(4,kodop_p);
        goto naz;

      case 2 :
        vibrek("Uosras",kodop_p,sizeof(kodop_p),naim);
        VV.VVOD_SPISOK_zapis_data(4,kodop_p);
        goto naz;
        

      case 3 :
        memset(strsql,'\0',sizeof(strsql));    
        vibrek("Plansh",strsql,sizeof(strsql),naim);
//        VV.VVOD_SPISOK_zapis_data(9,shetz);
        goto naz;

     }
    goto naz;

  case FK4:
    VV.VVOD_clear_data();
    goto naz;
     
  default:
    goto naz;
 }
GDITE();

short dn,mn,gn;
short dk,mk,gk;

if(rsdatp(&dn,&mn,&gn,VV.VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
  goto naz;


sprintf(strsql,"select datd,innom,nomd,podr,kodol,bs,iz,kodop,bsby,izby,shs from Uosdok1 \
where datd >= '%04d-%02d-%02d' and datd <= '%04d-%02d-%02d' and tipz=%d and podt=1 order by shs,datd asc",
gn,mn,dn,gk,mk,dk,metka);

int kolstr=0;
class SQLCURSOR cur;
class SQLCURSOR cur1;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

FILE *ff;
char imaf[56];
sprintf(imaf,"uos_sp%d.lst",getpid());
if((ff=fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }
if(metka == 1)
 zagolov(gettext("Движение основных средств по счетам приобретения."),dn,mn,gn,dk,mk,gk,organ,ff);
if(metka == 2)
 zagolov(gettext("Движение основных средств по счетам списания."),dn,mn,gn,dk,mk,gk,organ,ff);
 
fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
Инв.номер |      Наименование            |Счёт спис.|Счёт учёта|Бал.с.н.у.|Износ н.у.|Бал.с.б.у.|Износ б.у.|Дата доку.|Номер доку|Подраздел.|Мат.отв.л.|Код оп.|Контраген.|\n"));

/*************
1234567890 123456789012345678901234567890 1234567890 1234567890 1234567890 1234567890 1234567890 1234567890 1234567890 1234567890 1234567890 1234567890 1234567 1234567890 
**********/

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");


SQL_str row;
SQL_str row1;
int kolstr1=0;
long in_nom;
short d,m,g;
char shetu[40];
char hzt[40];
char hau[40];
char hna[40];
float popkf=0.;
int soso=0;
char nomz[112];
short mz,gz;
char hnaby[40];
float popkfby=0.;
char naim_uos[200];
double bs,iz,bsbu,izbu;
double ibs=0.,iiz=0.,ibsbu=0.,iizbu=0.;
double ibs_shet=0.,iiz_shet=0.,ibsbu_shet=0.,iizbu_shet=0.;
int podr=0;
int kodol=0;
char podr_char[100];
char kodol_char[100];
char kontr[50];
char shet_sp[50];
char shet_sp_zap[50];
memset(shet_sp_zap,'\0',sizeof(shet_sp_zap));

while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(proverka(shets_p,row[10],0,0) != 0)
    continue;

  if(proverka(kodop_p,row[7],0,0) != 0)
    continue;

  if(proverka(kod_podr,row[3],0,0) != 0)
    continue;

  if(proverka(kod_mo,row[4],0,0) != 0)
    continue;
  
  memset(kontr,'\0',sizeof(kontr));
  sprintf(strsql,"select kontr from Uosdok where datd='%s' and nomd='%s'",row[0],row[2]);
  if(readkey(strsql,&row1,&cur1) == 1)
   strncpy(kontr,row1[0],sizeof(kontr)-1);
   
  if(kontr_p[0] != '\0')
   {
    if(proverka(kontr_p,kontr,0,0) != 0)
      continue;    
   }
  in_nom=atol(row[1]);
  rsdat(&d,&m,&g,row[0],2);
  
  poiinpd(in_nom,m,g,shetu,hzt,hau,hna,&popkf,&soso,nomz,&mz,&gz,hnaby,&popkfby);

  if(proverka(shetu_p,shetu,0,0) != 0)
    continue;
  
  poiin(atol(row[1]),d,m,g,&podr,&kodol);
  
  memset(naim_uos,'\0',sizeof(naim_uos));
  sprintf(strsql,"select naim from Uosin where innom=%s",row[1]);
  if(readkey(strsql,&row1,&cur1) == 1)
   strncpy(naim_uos,row1[0],sizeof(naim_uos)-1);

  memset(podr_char,'\0',sizeof(podr_char));
  sprintf(podr_char,"%d ",podr);
  sprintf(strsql,"select naik from Uospod where kod=%d",podr);
  if(readkey(strsql,&row1,&cur1) == 1)
   strcat(podr_char,row1[0]);

  memset(kodol_char,'\0',sizeof(kodol_char));
  sprintf(kodol_char,"%d ",kodol);
  sprintf(strsql,"select naik from Uosol where kod=%d",kodol);
  if(readkey(strsql,&row1,&cur1) == 1)
   strcat(kodol_char,row1[0]);
  
  memset(shet_sp,'\0',sizeof(shet_sp));
  strcpy(shet_sp,row[10]);
  if(row[10][0] == '\0')
   strcpy(shet_sp,"???");  
  
  bs=atof(row[5]);
  iz=atof(row[6]);  
  bsbu=atof(row[8]);
  izbu=atof(row[9]);  
  
  ibs+=bs;
  iiz+=iz;
  ibsbu+=bsbu;
  iizbu+=izbu;

  ibs_shet+=bs;
  iiz_shet+=iz;
  ibsbu_shet+=bsbu;
  iizbu_shet+=izbu;
    
  if(SRAV(shet_sp_zap,shet_sp,0) != 0)
   {
    if(shet_sp_zap[0] != '\0')
     {
      sprintf(strsql,"%s %s",gettext("Итого по счёту"),shet_sp);
      fprintf(ff,"%*s %10.2f %10.2f %10.2f %10.2f\n",
      iceb_tu_kolbait(63,strsql),strsql,ibs_shet,iiz_shet,ibsbu_shet,iizbu_shet);
      ibs_shet=0.;
      iiz_shet=0.;
      ibsbu_shet=0.;
      iizbu_shet=0.;
      
     }
   }

  fprintf(ff,"%10s %-*.*s %-*s %-*s %10.2f %10.2f %10.2f %10.2f %02d.%02d.%04d %-10s %-10.10s %-10.10s %-7s %s\n",
  row[1],
  iceb_tu_kolbait(30,naim_uos),iceb_tu_kolbait(30,naim_uos),naim_uos,
  iceb_tu_kolbait(10,shet_sp),shet_sp,
  iceb_tu_kolbait(10,shetu),shetu,
  bs,iz,bsbu,izbu,d,m,g,row[2],podr_char,kodol_char,row[7],kontr);

 }

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
sprintf(strsql,"%s %s",gettext("Итого по счёту"),shet_sp);

fprintf(ff,"%*s %10.2f %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(63,strsql),strsql,ibs_shet,iiz_shet,ibsbu_shet,iizbu_shet);

fprintf(ff,"%*s %10.2f %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(63,gettext("Итого")),gettext("Итого"),
ibs,iiz,ibsbu,iizbu);

podpis(ff);

fclose(ff);

oth->spis_imaf.plus(imaf);
if(metka == 1)
 oth->spis_naim.plus(gettext("Движение основных средств по счетам приобретения"));
if(metka == 2)
 oth->spis_naim.plus(gettext("Движение основных средств по счетам списания"));

iceb_t_ustpeh(imaf,3);

return(0);

}
