/*$Id: uosdoo.c,v 5.9 2011-06-07 08:47:13 sasa Exp $*/
/*11.01.2010	18.12.2006	Белых А.И.	uosdoo.c
Дооценка основных средств (бухгалтерский учёт)
*/
#include <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


void uosdoo()
{
char strsql[512];
static char dat1[11];
static char proc_doo[16];
static char inv_nom[112];

VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Дооценка ос-них средств с нулевой остаточной стоимостью (бух.учёт)"));

VV.VVOD_SPISOK_add_MD(gettext("Дата расчёта...(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Процент дооценки........"));
VV.VVOD_SPISOK_add_MD(gettext("Инвентарный номер.(,,).."));

VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(proc_doo,sizeof(proc_doo)); 
VV.VVOD_SPISOK_add_data(inv_nom,sizeof(inv_nom)); 

naz:;

clear();
 
helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F4",gettext("очистить"),
//"F5",gettext("настройка"),
"F10",gettext("выход"),NULL);

int kom=VV.vvod(0,1,1,-1,-1);

move(LINES-1,0);

strcpy(dat1,VV.VVOD_SPISOK_return_data(0));
strcpy(proc_doo,VV.VVOD_SPISOK_return_data(1));
strcpy(inv_nom,VV.VVOD_SPISOK_return_data(2));

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("uos2_6.txt");
   goto naz;

  case ESC:
  case FK10:
   return;

  case FK2:
  case PLU:
     break;



  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }

time_t vrem;
time(&vrem);

GDITE();
short dr,mr,gr;
if(rsdat(&dr,&mr,&gr,dat1,1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(atof(proc_doo) == 0.)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Процент не введено !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 
 }

char kod_op_doo[64];
memset(kod_op_doo,'\0',sizeof(kod_op_doo));
if(iceb_t_poldan("Код операции дооценки",kod_op_doo,"uosnast.alx") != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("В файле настройки не нашли \"Код операции дооценки\" !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 
 }
//iceb_t_poldan("Н.Д.С.",strsql,"uosnast.alx");
//float proc_nds=atof(strsql);
float proc_nds=iceb_t_pnds();


//проверяем есть ли код операции в списке операций
sprintf(strsql,"select naik from Uospri where kod='%s'",kod_op_doo);
if(readkey(strsql) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Не нашли код операции %s !"),kod_op_doo);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }


clear();

float proc_d=atof(proc_doo);


//Сортируем основные средства по родраздениям и материально-ответственным
sprintf(strsql,"select innom from Uosin");
class SQLCURSOR cur;
int kolstr=0;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

FILE *ff_tmp;
char imaf_tmp[64];
sprintf(imaf_tmp,"uosdo%d.tmp",getpid());

if((ff_tmp = fopen(imaf_tmp,"w")) == NULL)
 {
  error_op_nfil(imaf_tmp,errno,"");
  return;
 }




int kolstr1=0;
SQL_str row;
long inn;
int podr;
int kod_mo;
double sbs,siz,bs,iz,iz1,sbsby,sizby,bsby,izby,iz1by;
double ost_b_s=0.; //Остаточная балансовая стоимость



int kolih=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(inv_nom,row[0],0,0) != 0)
   continue;
  inn=atol(row[0]);
  if(poiin(inn,dr,mr,gr,&podr,&kod_mo) != 0) 
     continue; //Произошел расход или на эту дату небыло прихода

  if(bsiz(inn,podr,dr,mr,gr,&sbs,&siz,&bs,&iz,&iz1,&sbsby,&sizby,&bsby,&izby,&iz1by,0) != 0)
   continue;
  ost_b_s=sbsby-sizby+bsby-izby-iz1by;
  
  if(ost_b_s > 0.)
   continue;
  
  fprintf(ff_tmp,"%d|%d|%ld|%.2f\n",podr,kod_mo,inn,sbsby+bsby);
  kolih++;  
 }

fclose(ff_tmp);


//sprintf(strsql,"sort -o %s -t\\|  +0n +1n %s",imaf_tmp,imaf_tmp);
sprintf(strsql,"sort -o %s -t\\|  -k1,2n -k2,3n %s",imaf_tmp,imaf_tmp);

runsystem1(strsql,1);
char stroka[1024];

if((ff_tmp = fopen(imaf_tmp,"r")) == NULL)
 {
  error_op_nfil(imaf_tmp,errno,"");
  return;
 }

int podr_zap=0;
int kod_mo_zap=0;
kolstr1=0;
char nomdok[32];
double suma_doo=0.;
while(fgets(stroka,sizeof(stroka),ff_tmp) != NULL)
 {
//  printw("%s",stroka);
  strzag(LINES-1,0,kolih,++kolstr1);

  polen(stroka,&podr,1,'|');
  polen(stroka,&kod_mo,2,'|');
  polen(stroka,&inn,3,'|');
  polen(stroka,&sbsby,4,'|');
  suma_doo=sbsby*proc_d/100.;
  suma_doo=okrug(suma_doo,0.01);  
  if(podr_zap != podr || kod_mo_zap != kod_mo)//делаем шапку документа
   {
    class lock_tables kkkk("LOCK TABLE Uosdok READ,icebuser READ");
    uosnd(gr,1,nomdok);

    printw("%s\n",nomdok);
    
    sprintf(strsql,"insert into Uosdok (datd,tipz,kodop,kontr,nomd,podr,kodol,prov,podt,ktoz,vrem,nds,pn) \
values ('%04d-%d-%d',%d,'%s','%s','%s',%d,%d,%d,%d,%d,%ld,%d,%.2f)",
    gr,mr,dr,
    1,
    kod_op_doo,
    "00",
    nomdok,
    podr,
    kod_mo,
    1,
    0,
    iceb_t_getuid(),
    vrem,
    3,
    proc_nds);

    if(sql_zapis(strsql,1,0) != 0)
      break;   

    podr_zap=podr;
    kod_mo_zap=kod_mo;
   
   }

  sprintf(strsql,"insert into Uosdok1 \
values ('%04d-%d-%d',%d,%d,%ld,'%s',%d,%d,%d,%.2f,%.2f,%.2f,'%s',%d,%ld,%.2f,%.2f,%.2f,'%s')",\
  gr,mr,dr,1,0,inn,nomdok,podr,kod_mo,0,0.,0.,0.,
  kod_op_doo,iceb_t_getuid(),vrem,suma_doo,0.,0.,"");

  sql_zapis(strsql,1,0);
  
 }

fclose(ff_tmp);
unlink(imaf_tmp);

printw_vr(vrem);

OSTANOV();

}




