/*$Id: uosinved.c,v 1.55 2011-04-14 16:07:34 sasa Exp $*/
/*12.10.2010	12.11.2001	Белых А.И.	uosinved.c
Рапечатка инвентаризационной ведомости в учете основных 
средств
*/
#include	<errno.h>
#include        <math.h>
#include        <time.h>
#include        <ctype.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

class drag_met
 {
  public:
  class SPISOK dm_ei; /*Список драг металлов-единиц измерения*/
  class masiv_din_double ves_dm; /*Массив для итоговых весов по горизонтали*/
  class masiv_din_double ves_dmv; /*Массив для итоговых весов по вертикали*/
  class masiv_din_int sp_in; /*Список инвентарных номеров*/
  class masiv_din_double ves_hax; /*Шахматка основное средство-вес*/
 };

void	uosinsap(int*,int*,FILE*);
void  uosinvedsh(int *kolst,int *kollist,int *kolstr_ff_gos,int *kollist_ff_gos,FILE *ff,FILE *ff_gos);
void uosinved_sbu(short dost,short most,short gost,int *kollist,int *kolst,FILE *ff);
void uosinved_pl(short di,short mi,short gi,char *ikod,int *kollist,int *kolstr,FILE *ffbu);
void  uosinvedsh_bu(short di,short mi,short gi,int *kolst,int *kollist,FILE *ff);
void uosinved_end_bu(FILE *ffbu);
void uosinved_sap(short mi,short gi,int podr,int kodotl,int *kollist,int *kolst,int *kollist_ff_gos,int *kolstr_ff_gos,FILE *ff,FILE *ff_gos);
void uosinved_ips(short di,short mi,short gi,char *shetuz,int *kolst,int *kollist,int *kostr_ff_gos,int *kollist_ff_gos,int *kolst_bu,int *kollist_bu,int *shethiksh,double *balstsh,double *iznossh,FILE *ff,FILE *ffbu,FILE *ff_gos);
void uosinved_konec(short mi,short gi,char *shetuz,int *shethik,double *itogo,double *itogo_iznos,int *shethiksh,double *balstsh,double *iznossh,FILE *ff,FILE *ffbu,FILE *ff_gos);
int uosinved_dm(int innom,class SPISOK *dm_ei,double *ves);
int uosinved_rdm(short di,short mi,short gi,class drag_met *dragm,class iceb_tu_str *imaf);
void uosinsap_gos(int *kollist_ff_gos,int *kolstr_ff_gos,FILE *ff_gos);

extern short	ddd,mmm,ggg;
extern char	*organ;
extern int kol_strok_na_liste;

int uosinved(class spis_oth *oth)
{
static char 	dat1[11];
static char	podraz[112];
static char	matot[112];
static char	sheta[112];
static char invent_nom[112];
char		naim[512];
char		naimshet[512];
char		model[512];
char zav_nomer[32];
char nom_pasp[56];

int		kom=0,kom1=0;
short		di,mi,gi; //Дата инвентаризации
char		imaf[56],imafsort[56];
FILE		*ff,*ffsort;
char		strsql[512];
int		kolstr=0,kolstr1=0;
SQL_str		row;
int		poddz=0,kodotl=0;
long		innom=0;
char		bros[512];
int		shethik=0,shethiksh=0;
double          sbs,siz,bs,iz,iz1,sbsby,sizby,bsby,izby,iz1by;
int		kolst=0,kollist=0;
int kolstr_ff_gos=0,kollist_ff_gos=0;
double		itogo=0,itogo_iznos=0.;
int		vbs=0; //1-балансовая стоимость налогового учета 0 -бухгалтерского
double balst=0.;
double iznos=0.;
double balstsh=0.;
double iznossh=0.;
time_t		tmmn=0;
char		god[10];
SQLCURSOR curr;
/*Переменные данные по инвентарному номеру*/
char		shetu[32],shetuz[32]; /*Счет учета*/
char		hzt[32];   /*Шифр затрат*/
char		hau[32];   /*Шифр аналитического учета*/
char		hna[32];   /*Шифр нормы амортотчислений*/
float		popkf;   /*Поправочный коэффициент*/
char		hnaby[32];   /*Шифр нормы амортотчислений*/
float		popkfby;   /*Поправочный коэффициент*/
int		soso;    /*Состояние объекта*/
char		nomz[112];  /*Номерной знак*/
short		m1,g1;
char            fiomatot[512];
char ikod[32];

VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(podraz,sizeof(podraz));
VV.VVOD_SPISOK_add_data(matot,sizeof(matot));
VV.VVOD_SPISOK_add_data(sheta,sizeof(sheta));
VV.VVOD_SPISOK_add_data(invent_nom,sizeof(invent_nom));

VV.VVOD_SPISOK_add_MD(gettext("Дата инвентаризации....."));//0
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения.(,,).."));//1
VV.VVOD_SPISOK_add_MD(gettext("Код мат.от-нного..(,,).."));//2
VV.VVOD_SPISOK_add_MD(gettext("Счет учета........(,,).."));//3
VV.VVOD_SPISOK_add_MD(gettext("Инвентарний номер.(,,).."));//43

VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка инвентаризационных описей"));

naz:;

clear();

helstr(LINES-1,0,
//"F1",gettext("помощь"),
"F2/+",gettext("поиск"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F5",gettext("доп.инфор."),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(podraz,VV.VVOD_SPISOK_return_data(1),sizeof(podraz)-1);
strncpy(matot,VV.VVOD_SPISOK_return_data(2),sizeof(matot)-1);
strncpy(sheta,VV.VVOD_SPISOK_return_data(3),sizeof(sheta)-1);
strncpy(invent_nom,VV.VVOD_SPISOK_return_data(4),sizeof(invent_nom)-1);
class iceb_tu_str kod_v("");
class iceb_tu_str naim_v("");
switch (kom)
 {

  case FK10:
  case ESC:
   return(1);

  case FK1:
    GDITE();
//    prosf(bros);
//    clear();
    goto naz;

  case FK2:
  case PLU:
    break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите  нужное и нажмите Enter"));

    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка мат.-ответственных"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;

      case 0 :
        if(diruospod(1,&kod_v,&naim_v,0) == 0)
          VV.data_z_plus(1,kod_v.ravno());
        goto naz;

      case 1 :
        if(dirmatot(1,&kod_v,&naim_v,0) == 0)
          VV.data_z_plus(2,kod_v.ravno());
        goto naz;

      case 2 :
        vibrek("Plansh",sheta,sizeof(sheta),naim);
        VV.VVOD_SPISOK_zapis_data(3,sheta);
        goto naz;
     }
  case FK4:
    VV.VVOD_clear_data();
    goto naz;

  case FK5: /*Ввод дополнительной информации в шапку инвентаризационной ведомости*/
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите  нужное и нажмите Enter"));

    MENU.VVOD_SPISOK_add_MD(gettext("Настройка начала документа"));
    MENU.VVOD_SPISOK_add_MD(gettext("Настройка конца документа Приложения 12"));
    MENU.VVOD_SPISOK_add_MD(gettext("Настройка конца инвентаризационной описи"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;

      case 0 :
        iceb_redfil("inventuos.alx",0);
        goto naz;

      case 1 :
        iceb_redfil("in_d12_end.alx",0);
        goto naz;

      case 2 :
        iceb_redfil("inved_end.alx",0);
        goto naz;

     }
    goto naz;    

  default:
    goto naz;
 }

if(rsdat(&di,&mi,&gi,dat1,1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата инвентаризации"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

memset(fiomatot,'\0',sizeof(fiomatot));

if(matot[0] != '\0')
 {
  if(pole2(matot,',') == 0)
   {
    sprintf(strsql,"select naik from Uosol where kod=%s",matot);
    if(sql_readkey(&bd,strsql,&row,&curr) == 1)
     strncpy(fiomatot,row[0],sizeof(fiomatot)-1);
   }
 }
 
MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите какая балансовая стоимости должна быть в документе"));

MENU.VVOD_SPISOK_add_MD(gettext("Балансовая стоимость для бухгалтерского учета"));
MENU.VVOD_SPISOK_add_MD(gettext("Балансовая стоимость для налогового учета"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
vbs=0;
while(menu3w(stdscr,&MENU,&vbs,-1,-1,0) != 0);

if(vbs == -1 || vbs == 2)
  goto naz;





time(&tmmn);

GDITE();

SQLCURSOR cur;

//читаем код
memset(ikod,'\0',sizeof(ikod));
sprintf(strsql,"select kod from Kontragent where kodkon='00'");
if(readkey(strsql,&row,&cur) == 1)
 strncpy(ikod,row[0],sizeof(ikod)-1);

class drag_met dragm;


int kolih_dm=0;
/*Читаем списко драг.металлов*/
sprintf(strsql,"select distinct kod,ei from Uosindm");
if((kolih_dm=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
while(cur.read_cursor(&row) != 0)
 {
  sprintf(strsql,"%s|%s",row[0],row[1]);
  dragm.dm_ei.plus(strsql);
 }
if(kolih_dm > 0)
 dragm.ves_dm.make_class(kolih_dm);

sprintf(strsql,"select innom,god,naim,model,pasp,zavnom,datvv from Uosin order by innom asc");
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }


sprintf(imafsort,"inv%s_%d.tmp",podraz,getpid());

if((ffsort = fopen(imafsort,"w")) == NULL)
 {
  error_op_nfil(imafsort,errno,"");
  return(1);
 }

kolstr1=0;
int kolstr_p=0;
while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s %s %s %s %s %s\n",row[0],row[1],row[2],row[3],row[4],row[5],row[6]);
  
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(invent_nom,row[0],0,0) != 0)
   continue;
  innom=atol(row[0]);

  if(poiin(innom,di,mi,gi,&poddz,&kodotl) != 0) //Произошел расход или оно пришло позже даты
    continue;
    
  sprintf(bros,"%d",poddz);
  if(proverka(podraz,bros,0,0) != 0)
    continue;
  sprintf(bros,"%d",kodotl);
  if(proverka(matot,bros,0,0) != 0)
    continue;

  poiinpd(innom,mi,gi,shetu,hzt,hau,hna,&popkf,&soso,nomz,&m1,&g1,hnaby,&popkfby);

  if(proverka(sheta,shetu,0,0) != 0)
    continue;
  kolstr_p++;
  fprintf(ffsort,"%d|%s|%s|%s|%s|%d|%s|%s|%s|%s|\n",kodotl,shetu,row[0],row[1],row[2],poddz,row[3],row[4],row[5],row[6]);
  dragm.sp_in.plus(row[0]);
 }
fclose(ffsort);

if(kolih_dm > 0)
 {
  dragm.ves_hax.make_class(kolih_dm*dragm.sp_in.kolih());
  dragm.ves_dmv.make_class(dragm.sp_in.kolih());
 } 
//sprintf(strsql,"sort -o %s -t\\| -n +0 -1 +1 -2 +2 -3 %s",imafsort,imafsort);
//runsystem(strsql);
sprintf(strsql,"sort -o %s -t\\| -n -k1,2 -k2,3 -k3,4 %s",imafsort,imafsort);
iceb_t_system(strsql,0);



if((ffsort = fopen(imafsort,"r")) == NULL)
 {
  error_op_nfil(imafsort,errno,"");
  return(1);
 }




char imafbu[32];

sprintf(imafbu,"invb%s_%d.lst",podraz,getpid());
FILE *ffbu;
if((ffbu = fopen(imafbu,"w")) == NULL)
 {
  error_op_nfil(imafbu,errno,"");
  return(1);
 }
int kollist_bu=0;
int kolst_bu=0;

//uosinved_pl(di,mi,gi,ikod,&kollist_bu,&kolst_bu,ffbu);

sprintf(imaf,"inv%s_%d.lst",podraz,getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }
char imaf_gos[64];
FILE *ff_gos;
sprintf(imaf_gos,"invg%s_%d.lst",podraz,getpid());

if((ff_gos = fopen(imaf_gos,"w")) == NULL)
 {
  error_op_nfil(imaf_gos,errno,"");
  return(1);
 }

char imaf_ipsh[64];
FILE *ffipsh;
sprintf(imaf_ipsh,"dod%d.lst",getpid());
if((ffipsh = fopen(imaf_ipsh,"w")) == NULL)
 {
  error_op_nfil(imaf_ipsh,errno,"");
  return(1);
 }

in_d12_start(ffipsh);

class SPISOK sp_shet;
class masiv_din_double sum_shet;
class masiv_din_double kol_shet;

memset(shetuz,'\0',sizeof(shetuz));
short dvv,mvv,gvv;
int kod_otv_z=-1; //может равняться нулю
int nomer_sheta=0;
kolstr1=0;
while(fgets(strsql,sizeof(strsql),ffsort) != NULL)
 {
  strzag(LINES-1,0,kolstr_p,++kolstr1);

  polen(strsql,&kodotl,1,'|');

  polen(strsql,shetu,sizeof(shetu),2,'|');
  polen(strsql,&innom,3,'|');
  polen(strsql,god,sizeof(god),4,'|');
  polen(strsql,naim,sizeof(naim),5,'|');

  polen(strsql,&poddz,6,'|');
  polen(strsql,model,sizeof(model),7,'|');
  polen(strsql,nom_pasp,sizeof(nom_pasp),8,'|');
  polen(strsql,zav_nomer,sizeof(zav_nomer),9,'|');
  polen(strsql,bros,sizeof(bros),10,'|');
  rsdat(&dvv,&mvv,&gvv,bros,2);

  if(kod_otv_z != kodotl)
   {
    if(kod_otv_z != -1)
     {
      uosinved_konec(mi,gi,shetuz,&shethik,&itogo,&itogo_iznos,&shethiksh,&balstsh,&iznossh,ff,ffbu,ff_gos);

      fprintf(ff,"\f");
      fprintf(ffbu,"\f");
      fprintf(ff_gos,"\f");
      
     }
    uosinved_pl(di,mi,gi,ikod,&kollist_bu,&kolst_bu,ffbu);
    uosinved_sap(mi,gi,poddz,kodotl,&kollist,&kolst,&kollist_ff_gos,&kolstr_ff_gos,ff,ff_gos);
    
    kod_otv_z=kodotl;
    
   }

  if(SRAV(shetu,shetuz,0) != 0)
   {
    if(shetuz[0] != '\0')
     {
      if(balstsh != 0.)
        uosinved_ips(di,mi,gi,shetuz,&kolst,&kollist,&kolstr_ff_gos,&kollist_ff_gos,&kolst_bu,&kollist_bu,&shethiksh,&balstsh,&iznossh,ff,ffbu,ff_gos);

     }
    memset(naimshet,'\0',sizeof(naimshet));    
    sprintf(strsql,"select nais from Plansh where ns='%s'",shetu);
    if(sql_readkey(&bd,strsql,&row,&curr) > 0)
      strncpy(naimshet,row[0],sizeof(naimshet)-1);

    //Счетчик строк
    uosinvedsh(&kolst,&kollist,&kolstr_ff_gos,&kollist_ff_gos,ff,ff_gos);
    fprintf(ff,"%s:%s %s\n",gettext("Счет"),shetu,naimshet);
    fprintf(ff_gos,"%s:%s %s\n",gettext("Счет"),shetu,naimshet);

    uosinvedsh_bu(di,mi,gi,&kolst_bu,&kollist_bu,ffbu);
    fprintf(ffbu,"%s:%s %s\n",gettext("Счет"),shetu,naimshet);
  
    shethiksh=0;
    balstsh=0.;
    iznossh=0.;
    strcpy(shetuz,shetu);
   }


  bsiz(innom,poddz,di,mi,gi,&sbs,&siz,&bs,&iz,&iz1,&sbsby,&sizby,&bsby,&izby,&iz1by,0);

  if(vbs == 1)
   {
    balst=bs+sbs;
    iznos=siz+iz+iz1;
   }
  if(vbs == 0)
   {
    balst=bsby+sbsby;
    iznos=sizby+izby+iz1by;
   }
  //Счетчик строк
  uosinvedsh(&kolst,&kollist,&kolstr_ff_gos,&kollist_ff_gos,ff,ff_gos);

  fprintf(ff,"%4d %-11ld %-*.*s %4s %02d.%02d.%04d %-10.10s|%4s|%10.2f|    |          |    |          |\n",
  ++shethik,innom,
  iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim,
  god,dvv,mvv,gvv,model,"1",balst);

  fprintf(ff_gos,"%4d|%-11ld|%-*.*s|%10.2f|%10.2f|%10.2f|%10s|%02d.%02d.%04d|     |          |          |          |          |\n",
  shethik,innom,
  iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim,
  balst,iznos,balst-iznos,"",dvv,mvv,gvv);


  uosinvedsh_bu(di,mi,gi,&kolst_bu,&kollist_bu,ffbu);

  fprintf(ffbu,"%4d %-*.*s %4s %-11ld %-9.9s %-*.*s|%4s|%10s|%4s|%10.2f|\n",
  shethik,
  iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim,
  god,innom,zav_nomer,
  iceb_tu_kolbait(8,nom_pasp),iceb_tu_kolbait(8,nom_pasp),nom_pasp,
  "","","1",balst);

  if(iceb_tu_strlen(naim) > 30)
   {
    //Счетчик строк
    uosinvedsh(&kolst,&kollist,&kolstr_ff_gos,&kollist_ff_gos,ff,ff_gos);
    fprintf(ff,"%4s %-11s %s\n"," "," ",iceb_tu_adrsimv(30,naim));

    fprintf(ff_gos,"%4s|%-11s|%-*.*s|          |          |          |          |          |     |          |          |          |          |\n",
    " "," ",
    iceb_tu_kolbait(30,iceb_tu_adrsimv(30,naim)),
    iceb_tu_kolbait(30,iceb_tu_adrsimv(30,naim)),
    iceb_tu_adrsimv(30,naim));

    uosinvedsh_bu(di,mi,gi,&kolst_bu,&kollist_bu,ffbu);
    fprintf(ffbu,"%4s %s\n","",iceb_tu_adrsimv(30,naim));

   }

  //Счетчик строк
  uosinvedsh(&kolst,&kollist,&kolstr_ff_gos,&kollist_ff_gos,ff,ff_gos);
  fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------\n");
  fprintf(ff_gos,"\
---------------------------------------------------------------------------------------------------------------------------------------------------------\n");

  if(kolih_dm > 0)
   {
    double ves[kolih_dm];
    memset(ves,'\0',sizeof(ves));        
    if(uosinved_dm(innom,&dragm.dm_ei,ves) == 0)
     {

      int nomer_os=dragm.sp_in.find(innom);      
      for(int ii=0; ii < kolih_dm; ii++)
       {
        dragm.ves_dm.plus(ves[ii],ii);
        dragm.ves_hax.plus(ves[ii],kolih_dm*nomer_os+ii);
        dragm.ves_dmv.plus(ves[ii],nomer_os);
       }

     }    
   }

  if((nomer_sheta=sp_shet.find(shetu)) < 0)
   sp_shet.plus(shetu);
  kol_shet.plus(1,nomer_sheta);
  sum_shet.plus(balst,nomer_sheta);
  
  itogo+=balst;
  itogo_iznos+=iznos;
  balstsh+=balst;
  iznossh+=iznos;
  shethiksh++;
 }

fclose(ffsort);
unlink(imafsort);

uosinved_konec(mi,gi,shetuz,&shethik,&itogo,&itogo_iznos,&shethiksh,&balstsh,&iznossh,ff,ffbu,ff_gos);


/*Распечатка формы додаток 12*/
in_d12_it(&sp_shet,&kol_shet,&sum_shet,ffipsh);

iceb_t_insfil("in_d12_end.alx",ffipsh);

podpis(ff);
podpis(ffbu);
podpis(ffipsh);
podpis(ff_gos);

fclose(ff);
fclose(ffbu);
fclose(ffipsh);
fclose(ff_gos);

class iceb_tu_str imaf_dragm;

if(kolih_dm > 0)
  uosinved_rdm(di,mi,gi,&dragm,&imaf_dragm);

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Инвентаризационная опись"));

oth->spis_imaf.plus(imafbu);
oth->spis_naim.plus(gettext("Приложение 1"));

oth->spis_imaf.plus(imaf_ipsh);
oth->spis_naim.plus(gettext("Приложение 12"));

oth->spis_imaf.plus(imaf_gos);
oth->spis_naim.plus(gettext("Инвентаризационная опись форма 2"));

if(kolih_dm > 0)
 {
  oth->spis_imaf.plus(imaf_dragm.ravno());
  oth->spis_naim.plus(gettext("Инвентаризационная опись драгоценных металлов"));
 } 

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),1);
return(0);

}

/******************/
/*Шапка распечатки*/
/******************/

void uosinsap(int *kollist,int *kolst,FILE *ff)
{

*kollist+=1;
*kolst+=5;
fprintf(ff,"%65s %s%d\n"," ",gettext("Лист N"),*kollist);
fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,gettext("\
Nп-п|Инвентарный|        Наименование          |Год |Дата ввода|  Модель  |   Бухучет     | Факт. наличие |    Разница    |\n"));
fprintf(ff,gettext("\
    |  номер    |                              |вып.|в эксплуа.|          |Кол.|Стоимость |Кол.|Стоимость |Кол.|Стоимость |\n"));
fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------\n");
}
/***********************************/
/*шапка для отчёта для госстандарта*/
/***********************************/
void uosinsap_gos(int *kollist_ff_gos,int *kolstr_ff_gos,FILE *ff_gos)
{
*kollist_ff_gos+=1;
*kolstr_ff_gos+=6;

fprintf(ff_gos,"%65s %s%d\n"," ",gettext("Лист N"),*kollist_ff_gos);
fprintf(ff_gos,"\
---------------------------------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff_gos,"\
Nп-п|Інвентарний|                              |Балансова |  Знос    |Залишкова |Ліквідацій|Дата ввода|Група|Термін кор|Мінімальни|          |          |\n\
    |  номер    |      Найменування            |вартість  |          |вартість  |на вартіст|в експлуат|     |исного вик|й термін  | Примітка | Примітка |\n\
    |           |                              |          |          |          |ь         |ацію      |     |ористання |використ. |          |          |\n");
/*******
1234 12345678901 123456789012345678901234567890 1234567890 1234567890 1234567890 1234567890 1234567890 12345
***********/
       
fprintf(ff_gos,"\
---------------------------------------------------------------------------------------------------------------------------------------------------------\n");
}
/***************/
/*Счетчик строк*/
/****************/
void  uosinvedsh(int *kolst,int *kollist,int *kolstr_ff_gos,int *kollist_ff_gos,FILE *ff,FILE *ff_gos)
{

*kolst+=1;
if(*kolst >= kol_strok_na_liste)
 {
  fprintf(ff,"\f");
  *kolst=1;
  uosinsap(kollist,kolst,ff);
 }

*kolstr_ff_gos+=1;
if(*kolstr_ff_gos >= kol_strok_na_liste)
 {
  fprintf(ff_gos,"\f");
  *kolstr_ff_gos=1;
  uosinsap_gos(kollist_ff_gos,kolstr_ff_gos,ff_gos);
 }
}
/***************/
/*Счетчик строк для бюджетной распечатки*/
/****************/
void  uosinvedsh_bu(short di,short mi,short gi,
int *kolst,int *kollist,FILE *ff)
{

*kolst+=1;
if(*kolst >= kol_strok_na_liste)
 {
  fprintf(ff,"\f");
  *kolst=1;
  uosinved_sbu(di,mi,gi,kollist,kolst,ff);
 }
}
/**************************************/
/*Шапка для бюджетных организиций*/
/*********************************/

void uosinved_sbu(short dost,short most,short gost,int *kollist,int *kolst,FILE *ff)
{
*kollist+=1;
*kolst+=6;

fprintf(ff,"%80s %s N%d\n"," ",gettext("Лист"),*kollist);
fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,"\
 N  |        Найменування          |Рік |            Номер             |    Станом   на %02d.%02d.%04dг.   |Відмітка о |\n\
з/п |                              |    |Інвентарний|заводсь- |паспорта|Факт. наявність|   Бухоблік    |вибутії    |\n\
    |                              |    |           |  кий    |        |Кіл.|Вартість  |Кіл.|Вартість  |           |\n",
dost,most,gost);
//   123456789012345678901234567890 1234 12345678901 123456789 12345678 1234 1234567890 1234 1234567890
fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------------\n");

}
/****************************************/
/*Первый лист бюджетного документа*/
/***********************************/

void uosinved_pl(short di,short mi,short gi,
char *ikod,
int *kollist,
int *kolstr,
FILE *ffbu)
{
*kollist=*kolstr=0;

fprintf(ffbu,"\
                                                            Додаток 1\n\
                                                            до інструкції з інвентаризації матеріальних цінностей,\n\
                                                            розрахунків та інших статей балансу бюджених установ.\n");
fprintf(ffbu,"%s\n",organ);
fprintf(ffbu,"Індентифікаційний код за ЄДРПОУ %s\n",ikod);
                                                                          
fprintf(ffbu,"                                        ІНВЕТАРИЗАЦІЙНИЙ ОПИС ОСНОВНИХ ЗАСОБІВ\n");
fprintf(ffbu,"                                                  %02d.%02d.%04d\n",di,mi,gi);
fprintf(ffbu,"Основні засоби_______________________________________________________________________________\n\n");
fprintf(ffbu,"Місце знаходження____________________________________________________________________________\n");

fprintf(ffbu,gettext("\
                          РАСПИСКА\n\
 К началу проведения инвентаризации все расходные и приходные документы\n\
на ценности сданы в бухгалтерию и все ценности, поступившие на мою\n\
(нашу) ответственность, оприходованы, а выбывшие списаны в расход.\n\n"));

fprintf(ffbu,"\
______________________________   _____________________________   _______________________________\n\
   (посада, підпис)                   (посада, підпис)               (посада, підпис)\n\n\
______________________________   _____________________________   _______________________________\n\
(призвище, ім'я, по батькові)    (призвище, ім'я, по батькові)   (призвище, ім'я, по батькові)\n\n");

fprintf(ffbu,"На підставі (розпорядження) від \"____\"_____________________р.\n\n");
fprintf(ffbu,"Виконано знімання фактичних залишків__________________________________________\n\n");
fprintf(ffbu,"що значаться на обліку станом на \"____\"____________________р.\n\n");
fprintf(ffbu,"Інвентаризація: розпочата \"___\"____________________р.\n\n");
fprintf(ffbu,"                закінчена \"___\"____________________p.\n");

fprintf(ffbu,"\n\%s:\n",gettext("При инвентаризации установлено следующее"));
*kolstr+=32;
uosinved_sbu(di,mi,gi,kollist,kolstr,ffbu);

}
/*******************************/
/*Концовка отчёта для бюджета*/
/*******************************/
void uosinved_end_bu(FILE *ffbu)
{
fprintf(ffbu,"\
Разом за описом : а) кількість порядкових номерів____________________________\n\
                                                          (прописом)\n\
                  б) загальна кількість лдиниць, фактично____________________\n\
                                                          (прописом)\n\
                  в) на суму, грн., фактично_________________________________\n\
                                                          (прописом)\n\n");
fprintf(ffbu,"\
Голова комісії ______________________  ___________________  ______________________________\n\
                  (посада)                 (підпис)         (призвище, ім'я, по батькові)\n\n\
Члени комісії: ______________________  ___________________  ______________________________\n\
                  (посада)                 (підпис)         (призвище, ім'я, по батькові)\n\n\
               ______________________  ___________________  ______________________________\n\
                  (посада)                 (підпис)         (призвище, ім'я, по батькові)\n\n\
              ______________________  ___________________  ______________________________\n\
                  (посада)                 (підпис)         (призвище, ім'я, по батькові)\n\n\
 Усі цінності, пойменовані в цьому інвентаризаційному описі з N__________ до N___________,\n\
перевірені комісією в натурі за моєї (нашої) присутності та внесені в опис, у зв'язку з чим\n\
претензій до інвентаризаційної комісії не маю (не маємо). Цінності, перелічені в описі,\n\
знаходяться на моєму (нашому) відповідальному зберіганні.\n\n\
Особа(и), відповідальна(і) за збереження основних засобів:\n\n\
\"____\"_____________________р.\n\n\
____________________________________________________________________________________________\n\n\
 Вказані у данному описі дані превірив ____________________  ______________________\n\
                                             (посада)            (підпис)\n\n\
\"____\"_____________________р.\n");

}
/******************************************/
/*                                         */
/******************************************/
void uosived_sap1(short mi,short gi,int podr,int kodotl,int *kolst,FILE *ff)
{
char strsql[512];
char naipod[512];
char fiootv[512];
SQL_str row;
class SQLCURSOR curr;
memset(fiootv,'\0',sizeof(fiootv));
if(kodotl != 0)
 {
  sprintf(strsql,"select naik from Uosol where kod=%d",kodotl);
  if(sql_readkey(&bd,strsql,&row,&curr) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %d !",
    gettext("Не найден мат.-ответственный"),kodotl);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else 
   strncpy(fiootv,row[0],sizeof(fiootv)-1);
 }

memset(naipod,'\0',sizeof(naipod));
if(podr != 0)
 {
  sprintf(strsql,"select naik from Uospod where kod=%d",podr);
  if(sql_readkey(&bd,strsql,&row,&curr) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %d !",gettext("Не найден код подразделения"),podr);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else 
    strncpy(naipod,row[0],sizeof(naipod)-1);
 }

fprintf(ff,"%s\n\n",organ);
fprintf(ff,gettext("ИНВЕНТАРИЗАЦИОННАЯ ОПИСЬ N_____ ОСНОВНЫХ СРЕДСТВ.\n"));
fprintf(ff,"%s %s\n",gettext("Подразделение"),naipod);
fprintf(ff,gettext("\
                          РАСПИСКА\n\
 К началу проведения инвентаризации все расходные и приходные документы\n\
на ценности сданы в бухгалтерию и все ценности, поступившие на мою\n\
(нашу) ответственность, оприходованы, а выбывшие списаны в расход.\n\n"));

fprintf(ff,"\n\
%s __________________________%s\n\n",
gettext("Материально-ответственное лицо (лица)"),
fiootv);

*kolst=12;
*kolst+=iceb_t_insfil("inventuos.alx",ff);

char mesqc[64];
memset(mesqc,'\0',sizeof(mesqc));
mesc(mi,1,mesqc);

fprintf(ff,"\n\
%*s:%*s \"______\" %s %d%s\n\
%15s %*s \"______\" %s %d%s\n",
iceb_tu_kolbait(15,gettext("Инвентаризация")),gettext("Инвентаризация"),
iceb_tu_kolbait(10,gettext("начата")),gettext("начата"),
mesqc,gi,
gettext("г."),
" ",
iceb_tu_kolbait(10,gettext("окончена")),gettext("окончена"),
mesqc,gi,
gettext("г."));

fprintf(ff,"\n\%s:\n",gettext("При инвентаризации установлено следующее"));
*kolst+=5;

}


/*****************************/
/*Шапка */
/******************************/
void uosinved_sap(short mi,short gi,int podr,int kodotl,int *kollist,int *kolst,int *kollist_ff_gos,int *kolstr_ff_gos,FILE *ff,FILE *ff_gos)
{

uosived_sap1(mi,gi,podr,kodotl,kolst,ff);
uosived_sap1(mi,gi,podr,kodotl,kolstr_ff_gos,ff_gos);

*kollist=0;
*kollist_ff_gos=0;
uosinsap(kollist,kolst,ff);
uosinsap_gos(kollist_ff_gos,kolstr_ff_gos,ff_gos);

}
/**********************************/
/*Итого по счёту*/
/*******************************/

void uosinved_ips(short di,short mi,short gi,
char *shetuz,
int *kolst,int *kollist,
int *kolstr_ff_gos,int *kollist_ff_gos,
int *kolst_bu,int *kollist_bu,
int *shethiksh,
double *balstsh,
double *iznossh,
FILE *ff,FILE *ffbu,FILE *ff_gos)
{
char bros[512];

sprintf(bros,"%s %s",gettext("Итого по счету"),shetuz);

uosinvedsh(kolst,kollist,kolstr_ff_gos,kollist_ff_gos,ff,ff_gos);
fprintf(ff,"%*s:%4d %10.2f\n",iceb_tu_kolbait(74,bros),bros,*shethiksh,*balstsh);
fprintf(ff_gos,"%*s|%10.2f|%10.2f|%10.2f|\n",iceb_tu_kolbait(47,bros),bros,*balstsh,*iznossh,*balstsh-*iznossh);

uosinvedsh_bu(di,mi,gi,kolst_bu,kollist_bu,ffbu);

fprintf(ffbu,"\
--------------------------------------------------------------------------------------------------------------------\n");
sprintf(bros,"%s %s",gettext("Итого по счету"),shetuz);

uosinvedsh_bu(di,mi,gi,kolst_bu,kollist_bu,ffbu);
fprintf(ffbu,"%*s:%4s %10s %4d %10.2f\n",iceb_tu_kolbait(71,bros),bros,"","",*shethiksh,*balstsh);
*balstsh=0.;
*iznossh=0.;
*shethiksh=0;
}

/*******************************/
/*концовка распечатки*/
/*****************************/
void uosinved_konec(short mi,short gi,char *shetuz,int *shethik,double *itogo,double *itogo_iznos,int *shethiksh,double *balstsh,double *iznossh,FILE *ff,FILE *ffbu,FILE *ff_gos)
{
char bros[512];


sprintf(bros,"%s %s",gettext("Итого по счету"),shetuz);
fprintf(ff,"%*s:%4d %10.2f\n",iceb_tu_kolbait(74,bros),bros,*shethiksh,*balstsh);

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,"%*s:%4d %10.2f\n",iceb_tu_kolbait(74,gettext("Итого")),gettext("Итого"),*shethik,*itogo);

fprintf(ff_gos,"%*s|%10.2f|%10.2f|%10.2f|\n",iceb_tu_kolbait(47,bros),bros,*balstsh,*iznossh,*balstsh-*iznossh);

fprintf(ff_gos,"\
---------------------------------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff_gos,"%*s|%10.2f|%10.2f|%10.2f|\n",iceb_tu_kolbait(47,gettext("Итого")),gettext("Итого"),*itogo,*itogo_iznos,*itogo-*itogo_iznos);

fprintf(ffbu,"\
--------------------------------------------------------------------------------------------------------------------\n");
sprintf(bros,"%s %s",gettext("Итого по счету"),shetuz);
fprintf(ffbu,"%*s:%4s %10s %4d %10.2f\n",iceb_tu_kolbait(71,bros),bros,"","",*shethiksh,*balstsh);

fprintf(ffbu,"\
--------------------------------------------------------------------------------------------------------------------\n");
fprintf(ffbu,"%*s:%4s %10s %4d %10.2f\n",iceb_tu_kolbait(71,gettext("Итого")),gettext("Итого"),"","",*shethik,*itogo);

char mesqc[64];
memset(mesqc,'\0',sizeof(mesqc));
mesc(mi,1,mesqc);

koncinv(mesqc,gi,ff);

koncinv(mesqc,gi,ff_gos);

uosinved_end_bu(ffbu);
*balstsh=0.;
*shethik=0;
*shethiksh=0;
*itogo=0.;
*itogo_iznos=0.;
*iznossh=0.;
}

/*************************/
/*Чтение записей по драг.металлам*/
/*********************************/
/*Если вернули 0-драг.металлы есть 1-нет*/
int uosinved_dm(int innom,class SPISOK *dm_ei,double *ves)
{
int kolih=0;
class SQLCURSOR cur;
SQL_str row;
char strsql[512];
sprintf(strsql,"select kod,ei,ves from Uosindm where innom=%d",innom);

if((kolih=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolih == 0)
 return(1);
int nomer=0;
while(cur.read_cursor(&row) != 0)
 {
  sprintf(strsql,"%s|%s",row[0],row[1]);
  if((nomer=dm_ei->find(strsql)) < 0)
   {
    iceb_t_soob("Не найдена нужная запись в списке!!!");
    continue;
   }
  ves[nomer]+=atof(row[2]);
 }
return(0);
}

/****************************************/
/*Распечатка по драгоценным металлам*/
/****************************************/
int uosinved_rdm(short di,short mi,short gi,
class drag_met *dragm,
class iceb_tu_str *imaf)
{
SQL_str row;
class SQLCURSOR cur;
char strsql[512];
FILE *ff_dm;
char imaf_dm[56];
sprintf(imaf_dm,"indm%d.lst",getpid());
imaf->new_plus(imaf_dm);
if((ff_dm = fopen(imaf_dm,"w")) == NULL)
 {
  error_op_nfil(imaf_dm,errno,"");
  return(1);
 }

//zagolov(gettext("Инвентаризационная опись драгоценных металлов"),0,0,0,di,mi,gi,organ,ff_dm);

fprintf(ff_dm,"%s\n\n",organ);
fprintf(ff_dm,gettext("ИНВЕНТАРИЗАЦИОННАЯ ОПИСЬ N_____ ДРАГОЦЕННЫХ МЕТАЛЛОВ В ОСНОВНЫХ СРЕДСТВАХ\n"));
fprintf(ff_dm,"%s %s\n",gettext("Подразделение"),"");
fprintf(ff_dm,gettext("\
                          РАСПИСКА\n\
 К началу проведения инвентаризации все расходные и приходные документы\n\
на ценности сданы в бухгалтерию и все ценности, поступившие на мою\n\
(нашу) ответственность, оприходованы, а выбывшие списаны в расход.\n\n"));

fprintf(ff_dm,"\n\
%s __________________________%s\n\n",
gettext("Материально-ответственное лицо (лица)"),
"");

iceb_t_insfil("inventuos.alx",ff_dm);

char mesqc[30];
memset(mesqc,'\0',sizeof(mesqc));
mesc(mi,1,mesqc);

fprintf(ff_dm,"\n\
%*s:%*s \"______\" %s %d%s\n\
%15s %*s \"______\" %s %d%s\n",
iceb_tu_kolbait(15,gettext("Инвентаризация")),gettext("Инвентаризация"),
iceb_tu_kolbait(10,gettext("начата")),gettext("начата"),
mesqc,gi,
gettext("г."),
" ",
iceb_tu_kolbait(10,gettext("окончена")),gettext("окончена"),
mesqc,gi,
gettext("г."));

fprintf(ff_dm,"\n\%s:\n",gettext("При инвентаризации установлено следующее"));


class iceb_tu_str liniq;

int kolih_dm=dragm->dm_ei.kolih();

liniq.plus("-----------------------------------------------------------------------");
for(int ii=0; ii < kolih_dm; ii++)
 {
  if(dragm->ves_dm.ravno(ii) == 0.)
   continue;
  liniq.plus("-----------");
 }
fprintf(ff_dm,"%s\n",liniq.ravno());
  
fprintf(ff_dm,gettext("\
Номер|Инвентарный|        Наименование          | Модель   |Заводской |"));
char drm[24];
char naim_dm[112];
for(int ii=0; ii < kolih_dm; ii++)
 {
  if(dragm->ves_dm.ravno(ii) == 0.)
   continue;
  memset(drm,'\0',sizeof(drm));
  memset(naim_dm,'\0',sizeof(naim_dm));
  polen(dragm->dm_ei.ravno(ii),drm,sizeof(drm),1,'|');
  sprintf(strsql,"select naik from Uosdm where kod=%d",atoi(drm));
  if(readkey(strsql,&row,&cur) == 1)
   strncpy(naim_dm,row[0],sizeof(naim_dm)-1);    
  sprintf(strsql,"%s %s",drm,naim_dm);
  fprintf(ff_dm,"%-*.*s|",iceb_tu_kolbait(10,strsql),iceb_tu_kolbait(10,strsql),strsql);
 }
fprintf(ff_dm,"\n");

fprintf(ff_dm,gettext("\
 п-п | номер     |                              |          |  номер   |"));
/*
12345 12345678901 123456789012345678901234567890 1234567890 1234567890
*/
for(int ii=0; ii < kolih_dm; ii++)
 {
  if(dragm->ves_dm.ravno(ii) == 0.)
   continue;
  polen(dragm->dm_ei.ravno(ii),drm,sizeof(drm),2,'|');
  fprintf(ff_dm,"%-*.*s|",iceb_tu_kolbait(10,drm),  iceb_tu_kolbait(10,drm),drm);
 }

fprintf(ff_dm,"\n%s\n",liniq.ravno());
char naim[512];
char model[112];
char zav_nomer[112];
int nomer_pp_dm=0;
for(int nom_in=0; nom_in < dragm->sp_in.kolih(); nom_in++)
 {
  if(dragm->ves_dmv.ravno(nom_in) == 0.)
   continue;
  memset(naim,'\0',sizeof(naim));
  memset(model,'\0',sizeof(model));
  memset(zav_nomer,'\0',sizeof(zav_nomer));
 
  sprintf(strsql,"select naim,model,zavnom from Uosin where innom=%d",dragm->sp_in.ravno(nom_in));
  if(readkey(strsql,&row,&cur) == 1)
   {
    strncpy(naim,row[0],sizeof(naim)-1);
    strncpy(model,row[1],sizeof(model)-1);
    strncpy(zav_nomer,row[2],sizeof(zav_nomer)-1);
   }
  fprintf(ff_dm,"%5d|%-11d|%-*.*s|%-*.*s|%-*.*s|",
  ++nomer_pp_dm,
  dragm->sp_in.ravno(nom_in),
  iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim,
  iceb_tu_kolbait(10,model),iceb_tu_kolbait(10,model),model,
  iceb_tu_kolbait(10,zav_nomer),iceb_tu_kolbait(10,zav_nomer),zav_nomer);
  for(int nom_dm=0; nom_dm < kolih_dm; nom_dm++)
   {
    if(dragm->ves_dm.ravno(nom_dm) == 0.)
     continue;
    fprintf(ff_dm,"%10.10g|",dragm->ves_hax.ravno(kolih_dm*nom_in+nom_dm));
   }
  fprintf(ff_dm,"\n");
  
 }

fprintf(ff_dm,"%s\n",liniq.ravno());
fprintf(ff_dm,"%*s|",iceb_tu_kolbait(70,gettext("Итого")),gettext("Итого"));
for(int ii=0; ii < kolih_dm; ii++)
 {
  if(dragm->ves_dm.ravno(ii) == 0.)
     continue;
  fprintf(ff_dm,"%10.10g|",dragm->ves_dm.ravno(ii));
 }
fprintf(ff_dm,"\n%s\n",liniq.ravno());

koncinv(mesqc,gi,ff_dm);

podpis(ff_dm);
fclose(ff_dm);

return(0);

}
