/* $Id: uosnast.c,v 5.27 2011-01-13 13:43:24 sasa1 Exp $ */
/*23.04.2010    08.04.1996      Белых А.И.   	uosnast.c
Чтение настpойки для учета основных сpедств
*/
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

float           nemi; /*Необлагаемый минимум*/
short		startgoduos=0; /*Стартовый год для Учёта основных средств*/
short		startgodb; /*Стартовый год просмотров главной книги*/
short		vplsh; /*0-двух-порядковый план счетов 1-многопорядковый*/
char		*bnds1=NULL; /*0% НДС реализация на територии Украины.*/
char            *bnds2=NULL; /*0% НДС экспорт.*/
char            *bnds3=NULL; /*0% Освобождение от НДС статья 5.*/
short		metkabo=0; //Если 1 то организация бюджетная
double okrg1=1.;
double okrcn=1.;

short		startgod=0; /*Стартовый год просмотров в Материальном учёте*/
short           mfnn=-1; /*Метка формирования номера накладной для материального учёта
                      -1 - Автоматическая нумерация выключена
                       0 - Приходы и расходы - нумерация общая
                       1 - Приходы отдельно расходы отдельно
                       */

int            uosnast()
{
char            st1[1024];
char		bros[1024];
int		i;
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];

metkabo=vplsh=0;
nemi=0.;
mfnn=(-1);
startgod=0;
if(bnds1 != NULL)
 {
  delete [] bnds1;
  bnds1=NULL;
 }

if(bnds2 != NULL)
 {
  delete [] bnds2;
  bnds2=NULL;
 }

if(bnds3 != NULL)
 {
  delete [] bnds3;
  bnds3=NULL;
 }

sprintf(strsql,"select str from Alx where fil='uosnast.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"uosnast.alx");
  iceb_t_soob(strsql);
  return(1);
 }



while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
   
  polen(row_alx[0],st1,sizeof(st1),1,'|');

  if(SRAV(st1,"Бюджетная организация",0) == 0)
   {
    polen(row_alx[0],st1,sizeof(st1),2,'|');
    if(SRAV(st1,"Вкл",1) == 0)
     metkabo=1;
    continue;
   }
  if(SRAV(st1,"Необлагаемый минимум",0) == 0)
   {
    polen(row_alx[0],st1,sizeof(st1),2,'|');
    nemi=(float)ATOFM(st1);
    continue;
   }

  if(SRAV(st1,"Стартовый год",0) == 0)
   {
    polen(row_alx[0],st1,sizeof(st1),2,'|');
    startgoduos=(short)ATOFM(st1);
    continue;
   }

  if(SRAV(st1,"0% НДС реализация на територии Украины",0) == 0)
    {
     memset(bros,'\0',sizeof(bros));
     polen(row_alx[0],bros,sizeof(bros),2,'|');
     i=strlen(bros)+1;
     if((bnds1=new char[i*sizeof(char)]) == NULL)
       error2(20,0,1,"Не могу выделить пямять для bnds1 !");
     strcpy(bnds1,bros);
     continue;
    }

  if(SRAV(st1,"0% НДС экспорт",0) == 0)
    {
     memset(bros,'\0',sizeof(bros));
     polen(row_alx[0],bros,sizeof(bros),2,'|');
     i=strlen(bros)+1;
     if((bnds2=new char[i*sizeof(char)]) == NULL)
       error2(20,0,1,"Не могу выделить пямять для bnds2 !");
     strcpy(bnds2,bros);
     continue;
    }

  if(SRAV(st1,"0% Освобождение от НДС статья 5",0) == 0)
    {
     memset(bros,'\0',sizeof(bros));
     polen(row_alx[0],bros,sizeof(bros),2,'|');
     i=strlen(bros)+1;
     if((bnds3=new char[i*sizeof(char)]) == NULL)
       error2(20,0,1,"Не могу выделить пямять для bnds3 !");
     strcpy(bnds3,bros);
     continue;
    }

 }


memset(st1,'\0',sizeof(st1));

iceb_t_poldan("Многопорядковый план счетов",st1,"nastrb.alx");
if(SRAV(st1,"Вкл",1) == 0)
 vplsh=1;

if(iceb_t_poldan("Округление 1",st1,"matnast.alx") == 0)
  okrg1=ATOFM(st1);
if(iceb_t_poldan("Округление цены",st1,"matnast.alx") == 0)
  okrcn=ATOFM(st1);
if(iceb_t_poldan("Стартовый год",st1,"matnast.alx") == 0)
  startgod=atoi(st1);
if(iceb_t_poldan("Раздельная нумерация накладных",st1,"matnast.alx") == 0)
 {
  mfnn=0;

  if(st1[0] == '\0')
   mfnn=-1;

  if(SRAV(st1,"Вкл",1) == 0)
    mfnn=1;
 }
return(0);
}
