/* $Id: uosrem.c,v 5.19 2011-01-13 13:43:24 sasa1 Exp $ */
/*07.06.2010    30.05.1997      Белых А.И.      uosrem.c
Распечатка акта ремонта/модернизации основных средств
*/
#include        <ctype.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char     *organ;/*Наименование организации*/

void            uosrem(short d,short m,short g, //Дата документа
char ndk[]) //Номер документа
{
char            str[512];
char            bros[512];
FILE            *ff,*ff1;
char            imaf[56],imaf1[56];
short           i;
long            in;
int             pdr;
double          sbs=0.,siz=0.,bs=0.,iz=0.,iz1=0.;
double          sbsby,sizby,bsby,izby;
double		pbs,piz;
long		kolstr;
SQL_str         row,row1;
SQLCURSOR curr;
char		strsql[512];
char		shetu[32]; /*Счет учета*/
char		hzt[32];   /*Шифр затрат*/
char		hau[32];   /*Шифр аналитического учета*/
char		hna[32];   /*Шифр нормы амортотчислений*/
float		popkf;   /*Поправочный коэффициент*/
char		hnaby[32];   /*Шифр нормы амортотчислений*/
float		popkfby;   /*Поправочный коэффициент*/
int		soso;    /*Состояние объекта*/
char		nomz[112];  /*Номерной знак*/
short		mz,gz;   /*дата записи*/
float		kof;
short		dv,mv,gv;
short		god;
char		pasp[512];
char		naim[512];
char		model[512];
short		tipz;
char		osnov[512];
char		kpos[32];
char		datpr[11];
char		kprr[32];
char		zavnom[512];

/*Читаем шапку документа*/
sprintf(strsql,"select tipz,kontr,osnov,kodop from Uosdok where datd='%d.%02d.%02d' and \
nomd='%s'",g,m,d,ndk);

if(readkey(strsql,&row1,&curr) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s %d.%d.%d%s",
  gettext("Не найден документ !"),ndk,d,m,g,
  gettext("г."));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }
tipz=atoi(row1[0]);
strncpy(kpos,row1[1],sizeof(kpos)-1);
strncpy(osnov,row1[2],sizeof(osnov)-1);
strncpy(kprr,row1[3],sizeof(kprr)-1);

//imafl(ndk,bros);
sprintf(bros,"%d",getpid());
if(tipz == 1)
  sprintf(imaf1,"arp%s.lst",bros);
if(tipz == 2)
  sprintf(imaf1,"arr%s.lst",bros);

errno=0;
if((ff1 = fopen(imaf1,"r")) == NULL)
 if(errno != ENOENT)
   {
    error_op_nfil(imaf1,errno,"");
    return;
   }

if(errno != ENOENT) /*Файл сущесвует*/
 {
  VVOD DANET(1);
  
  fclose(ff1);
  DANET.VVOD_SPISOK_add_MD(gettext("Распечатка уже есть. Переформировать ?"));

  if(danet(&DANET,2,stdscr) == 2)
   {
    class spis_oth oth;
    oth.spis_imaf.plus(imaf1);
    oth.spis_naim.plus(gettext("Распечатка акта ремонта/модернизации основного средства."));
    iceb_t_rabfil(&oth,"");
    return;
   }
 }


sprintf(strsql,"select innom,podr,bs,iz from Uosdok1 where datd='%d.%02d.%02d' and \
nomd='%s'",g,m,d,ndk);
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

memset(imaf,'\0',sizeof(imaf));
sprintf(imaf,"%s","uosrem.alx");
if(iceb_t_alxout(imaf) != 0)
 return;
if((ff = fopen(imaf,"r")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return;
 }

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff);
BSTAB(str,organ,0,40,1);
fprintf(ff1,"%s",str);
for(i=0; i< 19;i++)
 {
  memset(str,'\0',sizeof(str));
  fgets(str,sizeof(str),ff);
  fprintf(ff1,"%s",str);
 }

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff);
BSTAB(str,ndk,47,57,1);
sprintf(datpr,"%d.%d.%d",d,m,g);
BSTAB(str,datpr,59,69,1);
BSTAB(str,kprr,88,98,1);
fprintf(ff1,"%s",str);

for(i=0; i< 13;i++)
 {
  memset(str,'\0',sizeof(str));
  fgets(str,sizeof(str),ff);
  fprintf(ff1,"%s",str);
 }


while(cur.read_cursor(&row) != 0)
 {
  in=atol(row[0]);
  pdr=atoi(row[1]);
  pbs=atof(row[2]);
  piz=atof(row[3]);
  
  bsiz(in,pdr,d,m,g,&sbs,&siz,&bs,&iz,&iz,&sbsby,&sizby,&bsby,&izby,&izby,0);
  bs+=sbs;
  iz+=siz;
  iz+=iz1;
  /*Читаем переменные данные*/
  poiinpd(in,m,g,shetu,hzt,hau,hna,&popkf,&soso,nomz,&mz,&gz,hnaby,&popkfby);

  /*Читаем поправочный коэффициент*/
  kof=0.;
  sprintf(strsql,"select kof from Uosgrup where kod='%s'",hna);

  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    beep();
    printw("%s %s !\n",gettext("Не найден код группы"),hna);
    OSTANOV();
   }
  else
   kof=atof(row1[0]);

  god=0;
  memset(pasp,'\0',sizeof(pasp));
  dv=mv=gv=0;
  memset(zavnom,'\0',sizeof(zavnom));
  memset(naim,'\0',sizeof(naim));
  memset(model,'\0',sizeof(model));

  /*Читаем постоянную часть*/   
  sprintf(strsql,"select god,pasp,datvv,zavnom,naim,model from Uosin \
where innom=%ld",in);

  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    beep();
    printw("%s %ld !\n",gettext("Не найден инвентарный номер"),in);
    OSTANOV();
   }
  else
   {
    god=atoi(row1[0]);
    strncpy(pasp,row1[1],sizeof(pasp)-1);
    rsdat(&dv,&mv,&gv,row[2],2);
    strncpy(zavnom,row1[3],sizeof(zavnom)-1);
    strncpy(naim,row1[4],sizeof(naim)-1);
    strncpy(model,row1[5],sizeof(model)-1);
   }

  if(tipz == 1)
   fprintf(ff1," %*s %*.*s %*.*s %5.5s %9.9s %9.9g %10ld %*.*s\n",
   iceb_tu_kolbait(30,kpos),kpos,
   iceb_tu_kolbait(5,shetu),iceb_tu_kolbait(5,shetu),shetu,
   iceb_tu_kolbait(9,hau),iceb_tu_kolbait(9,hau),hau,
   " "," ",bs,in,
   iceb_tu_kolbait(10,zavnom),iceb_tu_kolbait(10,zavnom),zavnom);

  if(tipz == 2)
   fprintf(ff1," %-30d %5.5s %9.9s %*.*s %*.*s %9.9g %10ld %*.*s\n",
   pdr," "," ",
   iceb_tu_kolbait(5,shetu),iceb_tu_kolbait(5,shetu),shetu,
   iceb_tu_kolbait(9,hau),iceb_tu_kolbait(9,hau),hau,
   pbs*(-1),in,
   iceb_tu_kolbait(10,zavnom),iceb_tu_kolbait(10,zavnom),zavnom);

 }

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff);
fprintf(ff1,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff);
sprintf(bros,"%s %s",naim,model);
BSTAB(str,bros,20,100,1);
fprintf(ff1,"%s",str);

for(;;)
 {
  memset(str,'\0',sizeof(str));
  fgets(str,sizeof(str),ff);
  if(str[0] == '=')
   break;
  fprintf(ff1,"%s",str);

 }
fprintf(ff1,"\f\n");
memset(str,'\0',sizeof(str));
while(fgets(str,sizeof(str),ff) != NULL)
  fprintf(ff1,"%s",str);

fclose(ff);
fclose(ff1);
unlink(imaf);

class spis_oth oth;
oth.spis_imaf.plus(imaf1);
oth.spis_naim.plus(gettext("Распечатка акта ремонта/модернизации основного средства"));
iceb_t_ustpeh(imaf1,0);
iceb_t_rabfil(&oth,"");
}
