/* $Id: uosvamot.c,v 5.78 2011-08-29 07:08:59 sasa Exp $ */
/*28.02.2010    12.07.1996      Белых А.И.      uosvamot.c
Получение ведомости амортизационных отчислений для налогового учета
*/
#include        <time.h>
#include        <math.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern void shvam(short mn,short gn,short mk,short gk,int *sl,int *kst,int orient,int mr,FILE *ff,struct tm *bf);
extern void itamh(short mn,short gn,short mk,short gk,double itg[],char *kod,char *nai,short mr,int orient,double maotph[12],FILE *ff,FILE *ffi,int metkaitog,int *sli,int *kst,struct tm *bf);
extern void itam(short mn,short gn,short mk,short gk,double itg[],char nai[],short mr,int orient,double maotp[12],FILE *ff,FILE *ffi,int *sli,int *kst,struct tm *bf);

extern void     itamo(short,short,double*,short,double[12],FILE*,FILE*);

void shvam(short mn,short gn,short mk,short gk,int *sl,int *kst,int orient,int mr,FILE *ff,struct tm *bf);
void itamh(short mn,short gn,short mk,short gk,double itg[],char *kod,char *nai,short mr,int orient,double maotph[12],FILE *ff,FILE *ffi,int metkaitog,int *sli,int *kst,struct tm *bf);
void itam(short mn,short gn,short mk,short gk,double itg[],char nai[],short mr,int orient,double maotp[12],FILE *ff,FILE *ffi,int *sli,int *kst,struct tm *bf);


void            strms(short,short,short,FILE*);
void            strpod(short,short,short,FILE*);
void            rasmes(short,short,double[],double,char[],FILE*);
void uosvamot_prp(const char *hnaz,const char *podd,const char *hzt,const char *invnom,const char *shetup,const char *sost,int *kol_str,FILE *ff);

extern char     *organ;/*Наименование организации*/
extern float    nemi; /*Необлагаемый минимум*/
extern short    metkabo; //Если равна 1-бюджетная организация
extern int      kol_strok_na_liste;
extern int      kol_strok_na_liste_l;
extern class iceb_tu_str spis_print_a3;

int uosvamot(class spis_oth *oth)
{
struct  tm      *bf;
double          maotp[12];
double          maotph[12];
double          maotpo[12];
FILE            *ff,*ffi;
char            bros[512];
double          maot[32];
time_t          tmm;
int           kom,kom1;
short           d,mn,gn,mk,gk,mp,gp;
int             pod,pod1;
char            imaf[32],imafi[32];
int           sli=0,kst=0;
int           sli_bp=0,kst_bp=0;
int           slii=0,ksti=0;
int           slii_bp=0,ksti_bp=0;
long            innom,in1;
int             i;
double          sbs,siz,bs,iz,iz0,bs1,iz1,iz11;
double          sbsby,sizby,bsby,izby,iz0by;
double          god=0,mes=0;
short           mvr=0; /*Метка выдачи результата*/
const int RAZMER_MAS=6;
double          itg[RAZMER_MAS];
double          itg1[RAZMER_MAS];
double          itg2[RAZMER_MAS];
static char     dat1[8],dat2[8];
char            naimhz[512];
char            naipod[512];
double          ostt=0.;
short           mpg; /*0-не было первой группы 1-была*/
char		hna[24],hnaz1[24];
static char     hnaz[112];
static char     hzt[112];
static char     podd[112];
static char	godd[5];
static char     invnom[112];
static char	matot[112];
static char     sost[2];
static char     shetup[112];
SQLCURSOR 	curr;
char		filnast[1024];
short		mr; /*Метка распечатки*/
char		naios[512]; /*Наименование основного средства*/
char		bros1[512];
char		invn[32];
float		kof;
short		m1,g1;
short		m,g;
long		kolstr,kolstr1;
SQL_str         row,row1;
char		strsql[512];
double		sao;
int		metka23=0; //1-по группе 2-по каждому
int		kolos=0; //Количество основных средств попавших в отчет

/*Переменные данные по инвентарному номеру*/
char		shetu[32]; /*Счет учета*/
char		hztp[32];   /*Шифр затрат*/
char		haup[32];   /*Шифр аналитического учета*/
char		hnap[32];   /*Шифр нормы амортотчислений*/
float		ppkf;   /*Поправочный коэффициент*/
char		hnapby[32];   /*Шифр нормы амортотчислений*/
float		ppkfby;   /*Поправочный коэффициент*/
int		soso;    /*Состояние объекта*/
char		nomz[112];  /*Номерной знак*/

short dt,mt,gt;
poltekdat(&dt,&mt,&gt);
VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка ведомости амортотчислений"));

VV.VVOD_SPISOK_add_data(dat1,3);
VV.VVOD_SPISOK_add_data(dat2,3);
if(godd[0] == '\0')
  sprintf(godd,"%d",gt);
VV.VVOD_SPISOK_add_data(godd,5);
VV.VVOD_SPISOK_add_data(hzt,sizeof(hzt));
VV.VVOD_SPISOK_add_data(podd,sizeof(podd));
VV.VVOD_SPISOK_add_data(hnaz,sizeof(hnaz));
VV.VVOD_SPISOK_add_data(invnom,sizeof(invnom));
VV.VVOD_SPISOK_add_data(matot,sizeof(matot));
VV.VVOD_SPISOK_add_data(sost,sizeof(sost));
VV.VVOD_SPISOK_add_data(shetup,sizeof(shetup));

VV.VVOD_SPISOK_add_MD(gettext("Месяц начала.......(м)..."));
VV.VVOD_SPISOK_add_MD(gettext("Месяц конца........(м)..."));
VV.VVOD_SPISOK_add_MD(gettext("Год......................"));
VV.VVOD_SPISOK_add_MD(gettext("Шифр затрат.........(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Подразделение.......(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Группа..............(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Инв-ный номер.......(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Мат.отве-нный.......(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Состояние объекта.(+/-).."));
VV.VVOD_SPISOK_add_MD(gettext("Счёт учёта.........(,,).."));

naz:;

clear();

helstr(LINES-1,0,"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(godd,VV.VVOD_SPISOK_return_data(2),sizeof(godd)-1);
memset(hzt,'\0',sizeof(hzt));
strncpy(hzt,VV.VVOD_SPISOK_return_data(3),sizeof(hzt)-1);

memset(podd,'\0',sizeof(podd));
strncpy(podd,VV.VVOD_SPISOK_return_data(4),sizeof(podd)-1);

memset(hnaz,'\0',sizeof(hnaz));
strncpy(hnaz,VV.VVOD_SPISOK_return_data(5),sizeof(hnaz)-1);
strncpy(invnom,VV.VVOD_SPISOK_return_data(6),sizeof(invnom)-1);
strncpy(matot,VV.VVOD_SPISOK_return_data(7),sizeof(matot)-1);
strncpy(sost,VV.VVOD_SPISOK_return_data(8),sizeof(sost)-1);
strncpy(shetup,VV.VVOD_SPISOK_return_data(9),sizeof(shetu)-1);
class iceb_tu_str kod_v("");
class iceb_tu_str naim_v("");
switch(kom)
 {
  case FK10:
  case ESC:
   return(1);
  case FK2:
  case PLU:
   break;

  case FK3:  /*Просмотр реквизитов*/
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка шифров затрат"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр материально-ответственных"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 4 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Uosgrup",hnaz,sizeof(hnaz),naipod);
        VV.VVOD_SPISOK_zapis_data(5,hnaz);
        goto naz;

      case 1 :
        if(diruospod(1,&kod_v,&naim_v,0) == 0)
         VV.data_z_plus(4,kod_v.ravno());
        goto naz;

      case 2 :
        vibrek("Uoshz",hzt,sizeof(hzt),naipod);
        VV.VVOD_SPISOK_zapis_data(3,hzt);
        goto naz;

      case 3 :
        /*vibrek("Uosol",hzt,sizeof(hzt),naipod);*/
        if(dirmatot(1,&kod_v,&naim_v,0) == 0)
         VV.data_z_plus(7,kod_v.ravno());
        goto naz;

     }
    goto naz;
    

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
 }

sprintf(bros,"%s.%s",VV.VVOD_SPISOK_return_data(0),VV.VVOD_SPISOK_return_data(2));
if(rsdat1(&mn,&gn,bros) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
if(VV.VVOD_SPISOK_return_data(1)[0] != '\0')
 {
  sprintf(bros,"%s.%s",VV.VVOD_SPISOK_return_data(1),VV.VVOD_SPISOK_return_data(2));
  if(rsdat1(&mk,&gk,bros) != 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конца !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
 }
else
 {
  mk=mn; gk=gn;
 }

sprintf(strsql,"select ta from Uosgrup where ta=1 limit 1");

if(readkey(strsql) >= 1)
  metka23=1; /*Есть группы с амартизацией в целом по группе*/
else
 metka23=2; /*Все группы с пообъектной амортизацией*/
 
time(&tmm);
bf=localtime(&tmm);

clear();

GDITE();



int kol_mes_v_per=period(1,mn,gn,1,mk,gk,1);

if(kol_mes_v_per <=3)
 mr=1;
else
 mr=0;

int max_dlin_str=0;
 
if(mr == 1)
 max_dlin_str=136+(kol_mes_v_per+1)*11;
else
 max_dlin_str=67+(kol_mes_v_per+1)*11;

if(kol_mes_v_per == 1)
  max_dlin_str=136+11;

d=1;
mp=mn; gp=gn;
dpm(&d,&mp,&gp,2);


printw("%s %d.%d%s %s %d.%d%s (%d.%d)\n",
gettext("Период с"),
mn,gn,
gettext("г."),
gettext("до"),
mk,gk,
gettext("г."),
mp,gp);
refresh();

sprintf(strsql,"select innom,mes,god,podr,hzt,hna,suma from Uosamor \
where god = %d and mes >= %d and mes <= %d order by \
hna,podr,innom,god,mes asc",
gn,mn,mk);
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);  
 }
short pdm=0;
dpm(&pdm,&mk,&gk,5);
FILE *ff_prot=NULL;
char imaf_prot[56];

sprintf(imaf_prot,"uospra%d.lst",getpid());
if((ff_prot = fopen(imaf_prot,"w")) == NULL)
 {
  error_op_nfil(imaf_prot,errno,"");
  return(1);
 }

int orient=1;
if(proverka(spis_print_a3.ravno(),getenv("PRINTER"),0,1) == 0)
  orient=0; /*Если принтер А4 то ориентация портрет*/

zagolov(gettext("Ведомость амортизационных отчислений"),1,mn,gn,pdm,mk,gk,organ,ff_prot);

sprintf(imaf,"vao%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }


zagolov(gettext("Ведомость амортизационных отчислений"),1,mn,gn,pdm,mk,gk,organ,ff);

fprintf(ff,"%s\n",gettext("Налоговый учет"));
kst=6;

uosvamot_prp(hnaz,podd,hzt,invnom,shetup,sost,&kst,ff);

sprintf(imafi,"vaoi%d.lst",getpid());

if((ffi = fopen(imafi,"w")) == NULL)
 {
  error_op_nfil(imafi,errno,"");
  return(1);
 }


zagolov(gettext("Ведомость амортизационных отчислений"),1,mn,gn,pdm,mk,gk,organ,ffi);

fprintf(ffi,"%s\n",gettext("Налоговый учет"));

int kkkk=0;
uosvamot_prp(hnaz,podd,hzt,invnom,shetup,sost,&kkkk,ffi);
uosshap(mn,gn,mk,gk,bf,&slii,mr,ffi,&ksti);


/*****************отчёты без подразделений*******************/

FILE *ff_bp;
char imaf_bp[64];

sprintf(imaf_bp,"vaobp%d.lst",getpid());
if((ff_bp = fopen(imaf_bp,"w")) == NULL)
   {
    error_op_nfil(imaf_bp,errno,"");
    return(1);
   }


zagolov(gettext("Ведомость амортизационных отчислений"),1,mn,gn,pdm,mk,gk,organ,ff_bp);

fprintf(ff_bp,"%s\n",gettext("Налоговый учет"));
kst_bp=6;

uosvamot_prp(hnaz,podd,hzt,invnom,shetup,sost,&kst_bp,ff_bp);



FILE *ffi_bp;
char imafi_bp[64];
sprintf(imafi_bp,"vaoibp%d.lst",getpid());

if((ffi_bp = fopen(imafi_bp,"w")) == NULL)
 {
  error_op_nfil(imafi_bp,errno,"");
  return(1);
 }

zagolov(gettext("Ведомость амортизационных отчислений"),1,mn,gn,pdm,mk,gk,organ,ffi_bp);

fprintf(ffi_bp,"%s\n",gettext("Налоговый учет"));

kkkk=0;
uosvamot_prp(hnaz,podd,hzt,invnom,shetup,sost,&kkkk,ffi_bp);
uosshap(mn,gn,mk,gk,bf,&slii_bp,mr,ffi_bp,&ksti_bp);


innom=0;
for(i=0; i< 12; i++)
    maot[i]=maotp[i]=maotph[i]=maotpo[i]=0.;
mpg=0;

for(i=0;i<RAZMER_MAS;i++)
  itg[i]=itg1[i]=itg2[i]=0.;
naipod[0]=naimhz[0]='\0';
strncpy(naipod,organ,sizeof(naipod)-1);
memset(nomz,'\0',sizeof(nomz));
pod1=0;
kolstr1=in1=mvr=0;
memset(hnaz1,'\0',sizeof(hnaz1));

sprintf(filnast,"%s","uosnast.alx");

while(cur.read_cursor(&row) != 0)
 {
/*
  printw("metka23=%d spgnunpa=%s\n%s %s %s %s %s %s %s\n",
  metka23,spgnunpa,row[0],row[1],row[2],
  row[3],row[4],row[5],row[6]);
  OSTANOV();
*/
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(proverka(invnom,row[0],0,0) != 0)
    continue;

  if(proverka(hzt,row[4],0,0) != 0)
    continue;

  if(proverka(podd,row[3],0,0) != 0)
    continue;

  if(proverka(hnaz,row[5],0,0) != 0)
    continue;

  innom=atol(row[0]);

  if(metka23 == 1)  /*есть группы с амортизацией в целом по группе*/
   if(uosprovgr(row[5]) == 1) /*амортизация в целом по группе*/
     if(innom > 0)
      continue;

  if(metka23 == 2 ) /*все группы с пообъектной амортизацией*/
    if(uosprovgr(row[5]) == 0) /*амортизация в группе пообъектная*/
     if(innom < 0)
      continue;
     
  if(matot[0] != '\0')
   {
    int pdd=0;
    int kol=0;
    poiin(innom,1,mn,gn,&pdd,&kol);
    char kodot[20];
    sprintf(kodot,"%d",kol);
    if(proverka(matot,kodot,0,0) != 0)
      continue;
   }

  if(ff_prot != NULL)
   fprintf(ff_prot,"%s %s %s %s %s %s %s\n",row[0],row[1],row[2],row[3],row[4],row[5],row[6]);
   
  mvr++;

  m=atoi(row[1]);
  g=atoi(row[2]);
  pod=atoi(row[3]);
  strncpy(hna,row[5],sizeof(hna)-1);
  sao=atof(row[6]);

  if(mpg == 0)  
   if(SRAV(hna,"1",0) == 0)
    mpg=1;

  if(SRAV(hnaz1,hna,0) != 0)
   {

    if(hnaz1[0] != '\0')
     {
      if(mvr > 0)
       {
        rasmes(mn,mk,maot,ostt,hnaz1,ff);
        rasmes(mn,mk,maot,ostt,hnaz1,ff_bp);
     
        if(uosprovgr(hnaz1) == 0)
         {
          itam(mn,gn,mk,gk,itg1,naipod,mr,orient,maotp,ff,ffi,&sli,&kst,bf);
          pod1=0;
         }
        mvr=0;
       }
      itamh(mn,gn,mk,gk,itg2,hnaz1,naimhz,mr,orient,maotph,ff,ffi,0,&sli,&kst,bf);
      itamh(mn,gn,mk,gk,itg2,hnaz1,naimhz,mr,orient,maotph,ff_bp,ffi_bp,0,&sli_bp,&kst_bp,bf);
      for(i=0;i<RAZMER_MAS;i++)
	itg1[i]=itg2[i]=0.;

      fprintf(ff,"\f");
      fprintf(ff_bp,"\f");
      kst=0;
     }

    /*Читаем группу налогового учета*/
    memset(naimhz,'\0',sizeof(naimhz));
    sprintf(strsql,"select naik from Uosgrup where kod='%s'",hna);
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      beep();
      printw("%s %s !\n",gettext("Не найдена группа"),hna);
      OSTANOV();
     }
    else
     strncpy(naimhz,row1[0],sizeof(naimhz)-1);
          
    printw("%s: %s %s\n",gettext("Группа"),hna,naimhz);

    shvam(mn,gn,mk,gk,&sli,&kst,orient,mr,ff,bf);
    shvam(mn,gn,mk,gk,&sli_bp,&kst_bp,orient,mr,ff_bp,bf);

    fprintf(ff,"%s: %s %s\n",gettext("Группа"),hna,naimhz);
    fprintf(ff_bp,"%s: %s %s\n",gettext("Группа"),hna,naimhz);

    uosshap(mn,gn,mk,gk,bf,&sli,mr,ff,&kst);
    uosshap(mn,gn,mk,gk,bf,&sli_bp,mr,ff_bp,&kst_bp);

    for(i=0; i< 12; i++)
     maotp[i]=maotph[i]=0.;

    strcpy(hnaz1,hna);
   }

  if(pod1 != pod)
   {
    if(pod1 != 0 )
     {
      rasmes(mn,mk,maot,ostt,hnaz1,ff);
      rasmes(mn,mk,maot,ostt,hnaz1,ff_bp);
      mvr=0;
      if(uosprovgr(hnaz1) == 0)
       {
         itam(mn,gn,mk,gk,itg1,naipod,mr,orient,maotp,ff,ffi,&sli,&kst,bf);
       }
      for(i=0;i< RAZMER_MAS;i++)
	itg1[i]=0.;
     }
    /*Читаем наименование подразделения*/
    memset(naipod,'\0',sizeof(naipod));
    if(innom > 0)
     {
      sprintf(strsql,"select naik from Uospod where kod=%d",pod);
      if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
       {
        beep();
        printw("%s %d !\n",gettext("Не найден код подразделения"),pod);
        OSTANOV();
       }
      else
       strncpy(naipod,row1[0],sizeof(naipod)-1);
     }
    else
      strncpy(naipod,organ,sizeof(naipod)-1);

    printw("%s %d %s\n",gettext("Подразделение"),pod,naipod);

    shvam(mn,gn,mk,gk,&sli,&kst,orient,mr,ff,bf);
    fprintf(ff,"%s %d %s\n",gettext("Подразделение"),pod,naipod);

    for(i=0; i< 12; i++)
      maotp[i]=0.;

    pod1=pod;
   }

    if(innom > 0)
     {
      /*Узнаем поправочный коэффициент счёт учёта состояние объекта в расчётном месяце*/
      if(poiinpd(innom,m,g,shetu,hztp,haup,hnap,&ppkf,&soso,nomz,&m1,&g1,hnapby,&ppkfby) != 0)
       {

        shvam(mn,gn,mk,gk,&sli,&kst,orient,mr,ff,bf);
        fprintf(ff,"%ld инвентарный номер не числится %d.%dг. !!!\n",innom,m,g);

        shvam(mn,gn,mk,gk,&sli_bp,&kst_bp,orient,mr,ff_bp,bf);
        fprintf(ff_bp,"%ld инвентарный номер не числится %d.%dг. !!!\n",innom,m,g);

        VVOD SOOB(1);
        sprintf(strsql,"%ld инвентарный номер не числится %d.%dг. !!!",innom,m,g);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
       }

      if(proverka(shetup,shetu,0,0) != 0)
       {
        if(ff_prot != NULL)
         fprintf(ff_prot,"не подходит счёт учёта %s != %s\n",shetup,shetu);
        continue;
       }
      if(sost[0] == '+')
       if(soso == 1 || soso == 2)
        {
         if(ff_prot != NULL)
          fprintf(ff_prot,"не подходит состояние объекта! +");
      
         continue;
        }
      if(sost[0] == '-')
       if(soso == 0 || soso == 3)
        {
         if(ff_prot != NULL)
          fprintf(ff_prot,"не подходит состояние объекта! -");

         continue;
        }         
    }

  if(in1 != innom)
   {
    if(mvr > 0 && in1 != 0)
     {
      rasmes(mn,mk,maot,ostt,hnaz1,ff);
      rasmes(mn,mk,maot,ostt,hnaz1,ff_bp);
      mvr=0;
     }
    in1=innom;

    for(i=0; i< 12; i++)
     maot[i]=0.;

    memset(naios,'\0',sizeof(naios));

    if(innom > 0)
     {

      /*Читаем наименование объекта*/
      memset(naios,'\0',sizeof(naios));
      sprintf(strsql,"select naim from Uosin where innom=%ld",innom);
      if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
       {
        VVOD SOOB(1);
        sprintf(strsql,"%s %ld !",gettext("Не найден инвентарный номер"),innom);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
       }
      else
       strncpy(naios,row1[0],sizeof(naios)-1);

     }
    else
     {
      sprintf(bros,"Поправочный коэффициент для группы %ld",innom*-1);
      
      if(iceb_t_poldan(bros,bros1,filnast ) != 0)
       {
        VVOD SOOB(1);
        sprintf(strsql,"Не найден %s !!!",bros);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        sprintf(strsql,"%s %s",gettext("В файле"),filnast);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
       }
      ppkf=ATOFM(bros1); 
      if(ff_prot != NULL)
        fprintf(ff_prot,"Поправочный коэффициент для группы %ld=%f",innom*-1,ppkf);
     } 

    /*Читаем коэффициент*/

    if(innom < 0)
     sprintf(hnap,"%ld",innom*(-1));

    sprintf(bros,"%s",hnap);

    sprintf(strsql,"select naik,kof from Uosgrup where kod='%s'",bros);

    kof=0;
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      printw("%s %s !\n",gettext("Не найдено группу"),bros);
      OSTANOV();
      continue;
     }
    else
     {
      kof=atof(row1[1]);
      if(innom < 0)
       strncpy(naios,row1[0],sizeof(naios)-1);
     }

    /*На начало периода*/
    bs=iz=bs1=iz1=0.;
    if(innom > 0)
     {
      bsiz(innom,pod1,1,mn,gn,&sbs,&siz,&bs,&iz,&iz0,&sbsby,&sizby,&bsby,&izby,&iz0by,0);
      
      bs+=sbs;
      iz+=iz0+siz;
     }
    if(innom < 0)
     {
      sprintf(bros,"Стартовая балансовая стоимость для группы %ld",innom*-1);
      if(iceb_t_poldan(bros,bros1,filnast) != 0)
         {
          VVOD SOOB(1);
          sprintf(strsql,"Не найдена %s",bros);
          SOOB.VVOD_SPISOK_add_MD(strsql);
          SOOB.VVOD_SPISOK_add_MD(filnast);
          soobshw(&SOOB,stdscr,-1,-1,0,1);
         }
      bs=ATOFM(bros1);
      if(ff_prot != NULL)
        fprintf(ff_prot,"Стартовая балансовая стоимость для группы %ld=%.2f",innom*-1,bs);

      sprintf(bros,"Стартовый износ для группы %ld",innom*-1);
      if(iceb_t_poldan(bros,bros1,filnast) != 0)
         {
          VVOD SOOB(1);
          sprintf(strsql,"Не найден %s",bros);
          SOOB.VVOD_SPISOK_add_MD(strsql);
          soobshw(&SOOB,stdscr,-1,-1,0,1);
         }
       iz=ATOFM(bros1);
       printw("Группа 2 bs=%f iz=%f\n",bs,iz);
       if(ff_prot != NULL)
         sprintf(bros,"Стартовый износ для группы %ld=%.2f",innom*-1,iz);

      bsiz23(hnap,1,mn,gn,&bs1,&iz1,&iz11,0);
      iz+=iz1+iz11;
      bs+=bs1;
//      printw("hnap=%s bs1=%f iz1=%f iz11=%f iz=%f\n",hnap,bs1,iz1,iz11,iz);
//    OSTANOV();
     }
    double lik_st=uosgetls(innom,1,mn,gn,0);

    if(uosprovar(hnap,0) == 1)
     {
      ostt=bs-iz;
      if(metkabo == 0)
       god=(bs-iz)*kof/100.;
      if(metkabo == 1)
        god=(bs-lik_st)*kof/100.;
     }
    else
     {
      ostt=bs-iz;
      god=(bs-lik_st)*kof/100.;
     }
   
    mes=0.;
    if(god != 0.)
      mes=god/12.;
    itg[0]+=bs;
    itg[1]+=iz;
    itg[2]+=ostt;
    itg[3]+=lik_st;  
    itg[4]+=god;
    itg[5]+=mes;

    itg1[0]+=bs;
    itg1[1]+=iz;
    itg1[2]+=ostt;
    itg1[3]+=lik_st;
    itg1[4]+=god;
    itg1[5]+=mes;

    itg2[0]+=bs;
    itg2[1]+=iz;
    itg2[2]+=ostt;
    itg2[3]+=lik_st;
    itg2[4]+=god;
    itg2[5]+=mes;

    if(innom > 0)
     sprintf(invn,"%ld",innom);
    else
     {
      sprintf(invn,"%ld %s",innom*(-1),gettext("группа"));
//      printw("invn=%s\n",invn);
     }     

    shvam(mn,gn,mk,gk,&sli,&kst,orient,mr,ff,bf);
    shvam(mn,gn,mk,gk,&sli_bp,&kst_bp,orient,mr,ff_bp,bf);

    fprintf(ff,"%-8s|%-*.*s|%-*.*s|%-*s|",
    invn,
    iceb_tu_kolbait(40,naios),iceb_tu_kolbait(40,naios),naios,
    iceb_tu_kolbait(10,nomz),iceb_tu_kolbait(10,nomz),nomz,
    iceb_tu_kolbait(5,hnap),hnap);
  
    fprintf(ff_bp,"%-8s|%-*.*s|%-*.*s|%-*s|",
    invn,
    iceb_tu_kolbait(40,naios),iceb_tu_kolbait(40,naios),naios,
    iceb_tu_kolbait(10,nomz),iceb_tu_kolbait(10,nomz),nomz,
    iceb_tu_kolbait(5,hnap),hnap);
  
    if(mr == 1)
     {
      fprintf(ff,"%5.2f|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5.2f|",kof,bs,iz,ostt,lik_st,god,mes,ppkf);
      fprintf(ff_bp,"%5.2f|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5.2f|",kof,bs,iz,ostt,lik_st,god,mes,ppkf);
     }
    kolos++;
/*
    printw("*************mr=%d\n",mr);
    OSTANOV();
*/    
   }

  maot[m-1]=sao;
  maotp[m-1]=maotp[m-1]+sao;
  maotph[m-1]=maotph[m-1]+sao;
  maotpo[m-1]=maotpo[m-1]+sao;

 }

rasmes(mn,mk,maot,ostt,hnaz1,ff);
rasmes(mn,mk,maot,ostt,hnaz1,ff_bp);

if(uosprovgr(hnaz1) == 0)
   itam(mn,gn,mk,gk,itg1,naipod,mr,orient,maotp,ff,ffi,&sli,&kst,bf);

itamh(mn,gn,mk,gk,itg2,hnaz1,naimhz,mr,orient,maotph,ff,ffi,0,&sli,&kst,bf);
itamo(mn,mk,itg,mr,maotpo,ff,ffi);

itamh(mn,gn,mk,gk,itg2,hnaz1,naimhz,mr,orient,maotph,ff_bp,ffi_bp,0,&sli_bp,&kst_bp,bf);
itamo(mn,mk,itg,mr,maotpo,ff_bp,ffi_bp);

if(mpg == 1)
 {
  fprintf(ff,gettext("* Остаточная стоимость меньше (равняется) 100 необлагаемых минимумов.\n"));
  fprintf(ff_bp,gettext("* Остаточная стоимость меньше (равняется) 100 необлагаемых минимумов.\n"));
 }

printw("\n%s:%d\n",gettext("Количество основных средств"),kolos);

fprintf(ff,"\n%s:%d\n",gettext("Количество основных средств"),kolos);
fprintf(ffi,"\n%s:%d\n",gettext("Количество основных средств"),kolos);
fprintf(ff_bp,"\n%s:%d\n",gettext("Количество основных средств"),kolos);
fprintf(ffi_bp,"\n%s:%d\n",gettext("Количество основных средств"),kolos);

podpis(ff);
fclose(ff);

podpis(ffi);
fclose(ffi);

podpis(ff_bp);
fclose(ff_bp);

podpis(ffi_bp);
fclose(ffi_bp);
if(ff_prot != NULL)
 {
  podpis(ff_prot);
  fclose(ff_prot);
 }
printw_vr(tmm);

OSTANOV();


oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Распечатка ведомости амортотчислений"));
oth->spis_imaf.plus(imaf_bp);
oth->spis_naim.plus(gettext("Ведомоть амортотчислений без распределения по подразделениям"));
oth->spis_imaf.plus(imafi);
oth->spis_naim.plus(gettext("Общие итоги"));
oth->spis_imaf.plus(imafi_bp);
oth->spis_naim.plus(gettext("Общие итоги без распределения по подразделениям"));
if(ff_prot != NULL)
 {
  oth->spis_imaf.plus(imaf_prot);
  oth->spis_naim.plus("Протокол хода расчёта");
 }

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),3);
 
return(0);

}
/*****************/
/*Шапка документа*/
/*****************/
void shvam(short mn,short gn,short mk,short gk,int *sl,
int *kst,int orient,int mr,FILE *ff,struct tm *bf)
{

*kst+=1;
if(orient == 0) /*портрет*/
 {
  if(*kst <= kol_strok_na_liste)
    return;
 }
else /*ландшафт*/
  if(*kst <= kol_strok_na_liste_l)
    return;
    
fprintf(ff,"\f");

*kst=1;

uosshap(mn,gn,mk,gk,bf,sl,mr,ff,kst);

}
/**********************/
/*строка подчеркивания*/
/**********************/

void            strpod(short mn,short mk,short dlu,FILE *ff)
{
short           i;
char		bros[512];

memset(bros,'\0',sizeof(bros));
for(i=0; i< dlu ; i++)
 strcat(bros,"-");
for(i=mn-1; i<mk ;i++)
  fprintf(ff,"%s",bros);
if(mn != mk)
  fprintf(ff,"%s",bros);
fprintf(ff,"\n");
}

/****************/
/*Строка месяцев*/
/****************/
void            strms(short mt, //0-с номером месяца 1 - без
short mn,short mk,FILE *ff)
{
short           i;
char		bros[512];

memset(bros,'\0',sizeof(bros));
if(mt == 0)
 {
  for(i=mn-1; i< mk ; i++)
    fprintf(ff,"    %-6d|",i+1);

  if(mn != mk)
   fprintf(ff,"%-*s|",iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"));
 }
if(mt == 1)
 {
  for(i=mn-1; i< mk ; i++)
   fprintf(ff,"%10s|"," ");

  if(mn != mk)
    fprintf(ff,"%10s|"," ");
 }
fprintf(ff,"\n");
}

/*******************************/
/*Выдача итога по подразделению*/
/*******************************/
void itam(short mn,short gn,short mk,short gk,double itg[],char nai[],short mr,int orient,
double maotp[12],FILE *ff,FILE *ffi,int *sli,int *kst,
struct tm *bf)
{
short           i;
double          vs;
char		bros[512];

shvam(mn,gn,mk,gk,sli,kst,orient,mr,ff,bf);
fprintf(ff,"\
-------------------------------------------------------------------");
fprintf(ffi,"\
-------------------------------------------------------------------");
if(mr == 1)
 {
  fprintf(ff,"\
--------------------------------------------------------------------------------");
  fprintf(ffi,"\
--------------------------------------------------------------------------------");
 }

strpod(mn,mk,11,ff);
strpod(mn,mk,11,ffi);

memset(bros,'\0',sizeof(bros));
sprintf(bros,"%s %s",gettext("Итого по подразделению"),nai);

shvam(mn,gn,mk,gk,sli,kst,orient,mr,ff,bf);

fprintf(ff,"%-*.*s|",iceb_tu_kolbait(66,bros),iceb_tu_kolbait(66,bros),bros);

fprintf(ffi,"%-*.*s|",iceb_tu_kolbait(66,bros),iceb_tu_kolbait(66,bros),bros);

if(mr == 1)
 {
  fprintf(ff,"%5s|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5s|",
" ",itg[0],itg[1],itg[2],itg[3],itg[4],itg[5]," ");
  fprintf(ffi,"%5s|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5s|",
" ",itg[0],itg[1],itg[2],itg[3],itg[4],itg[5]," ");
 }
vs=0.;
for(i=mn-1 ;i<mk ;i++)
 {
  vs+=maotp[i];
  fprintf(ff,"%10.2f|",maotp[i]);
  fprintf(ffi,"%10.2f|",maotp[i]);
 }
if(mn != mk)
 {
  fprintf(ff,"%10.2f|",vs);
  fprintf(ffi,"%10.2f|",vs);
  printw("%s: %.2f\n",gettext("Итого по подразделению"),vs);
 }
else
  printw("%s: %.2f\n",gettext("Итого по подразделению"),maotp[mn-1]);

fprintf(ff,"\n");
fprintf(ffi,"\n");

}
/*******************************/
/*Выдача итога по шифру нормы амортотчислений или группе*/
/*******************************/
void itamh(short mn,short gn,short mk,short gk,double itg[],
char *kod,
char *nai,
short mr,
int orient,
double maotph[12],FILE *ff,FILE *ffi,
int metkaitog,  //0-по группе 1-по шифру
int *sli,int *kst,
struct tm *bf)
{
short           i;
double          vs;
char		bros[512];

shvam(mn,gn,mk,gk,sli,kst,orient,mr,ff,bf);
fprintf(ff,"\
-------------------------------------------------------------------");
fprintf(ffi,"\
-------------------------------------------------------------------");

if(mr == 1)
 {
  fprintf(ff,"\
--------------------------------------------------------------------------------");
  fprintf(ffi,"\
--------------------------------------------------------------------------------");
 }
strpod(mn,mk,11,ff);
strpod(mn,mk,11,ffi);
if(metkaitog == 0)
  sprintf(bros,"%s %s %s",gettext("Итого по группе"),kod,nai);
if(metkaitog == 1)
  sprintf(bros,"%s %s %s",gettext("Итого по шифру"),kod,nai);

shvam(mn,gn,mk,gk,sli,kst,orient,mr,ff,bf);

fprintf(ff,"%-*.*s|",iceb_tu_kolbait(66,bros),iceb_tu_kolbait(66,bros),bros);

fprintf(ffi,"%-*.*s|",iceb_tu_kolbait(66,bros),iceb_tu_kolbait(66,bros),bros);


if(mr == 1)
 {
  fprintf(ff,"%5s|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5s|",
" ",itg[0],itg[1],itg[2],itg[3],itg[4],itg[5]," ");
  fprintf(ffi,"%5s|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5s|",
" ",itg[0],itg[1],itg[2],itg[3],itg[4],itg[5]," ");
 }
vs=0.;
for(i=mn-1 ;i<mk ;i++)
 {
  vs+=maotph[i];
  fprintf(ff,"%10.2f|",maotph[i]);
  fprintf(ffi,"%10.2f|",maotph[i]);
 }

if(mn != mk)
 {
  fprintf(ff,"%10.2f|",vs);
  fprintf(ffi,"%10.2f|",vs);
  printw("%s: %.2f\n",bros,vs);
 }
else
  printw("%s: %.2f\n",bros,maotph[mn-1]);

fprintf(ff,"\n");
fprintf(ffi,"\n");

}
/*******************************/
/*Выдача итога по организации*/
/*******************************/
void itamo(short mn,short mk,double itg[],short mr,
double maotpo[12],FILE *ff,FILE *ffi)
{
short           i;
double          vs;
char		bros[512];

fprintf(ff,"\
-------------------------------------------------------------------");
fprintf(ffi,"\
-------------------------------------------------------------------");
if(mr == 1)
 {
  fprintf(ff,"\
--------------------------------------------------------------------------------");
  fprintf(ffi,"\
--------------------------------------------------------------------------------");
 }
strpod(mn,mk,11,ff);
strpod(mn,mk,11,ffi);

sprintf(bros,gettext("Общий итог"));


fprintf(ff,"%-*.*s|",iceb_tu_kolbait(66,bros),iceb_tu_kolbait(66,bros),bros);

fprintf(ffi,"%-*.*s|",iceb_tu_kolbait(66,bros),iceb_tu_kolbait(66,bros),bros);

if(mr == 1)
 {
  fprintf(ff,"%5s|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5s|",
" ",itg[0],itg[1],itg[2],itg[3],itg[4],itg[5]," ");
  fprintf(ffi,"%5s|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5s|",
" ",itg[0],itg[1],itg[2],itg[3],itg[4],itg[5]," ");
 }
vs=0.;
for(i=mn-1 ;i<mk ;i++)
 {
  vs+=maotpo[i];
  fprintf(ff,"%10.2f|",maotpo[i]);
  fprintf(ffi,"%10.2f|",maotpo[i]);
 }

if(mn != mk)
 {
  fprintf(ff,"%10.2f|",vs);
  fprintf(ffi,"%10.2f|",vs);
  printw("%s: %.2f\n",bros,vs);
 }
else
  printw("%s: %.2f\n",bros,maotpo[mn-1]);

fprintf(ff,"\n");
fprintf(ffi,"\n");

}

/***********************/
/*Выдача строки месяцев*/
/***********************/
void rasmes(short mn,short mk,double maot[],double ostt,
char hnaz[],FILE *ff)
{
short           i;
double          vs;
vs=0.;

for(i=mn-1 ;i<mk ;i++)
 {
  vs+=maot[i];
  fprintf(ff,"%10.2f|",maot[i]);
 }
if(mn != mk)
   fprintf(ff,"%10.2f|",vs);
if(ostt <= 100*nemi && ostt > 0.001 && SRAV(hnaz,"1",0) == 0)
   fprintf(ff,"*");
fprintf(ff,"\n");
}

/*************************************************/
/*Шапка*/
/*************************************************/

void uosshap(short mn,short gn,short mk,short gk,struct tm *bf,
int *sl,short mr,FILE *ffi,int *kst)
{
*sl+=1;
*kst+=5;

fprintf(ffi,"\
%s %d.%d.%d %s %s %d:%d %90s%s N%d\n",
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min,
"",gettext("Лист"),
*sl);

  fprintf(ffi,"\
-------------------------------------------------------------------");
  if(mr == 1)
    fprintf(ffi,"\
--------------------------------------------------------------------------------");

  strpod(mn,mk,11,ffi);

  fprintf(ffi,gettext("\
Инв-рный|        Н а и м е н о в а н и е         | Номерной |Шифр |"));

  if(mr == 1)
    fprintf(ffi,gettext("\
Норма|Балансовая|  Износ   |Остаточная|Ликвидаци.|Годов. сумма|Мес. сумма|Коэфи|"));

  strms(0,mn,mk,ffi);

  fprintf(ffi,gettext("\
 номер  |             объекта                    |   знак   |н.ам.|"));

  if(mr == 1)
    fprintf(ffi,gettext("\
а.отч|стоимость |          |бал. с-сть|стоимость |амортотчисл.|амортотчи.|циент|"));

  strms(1,mn,mk,ffi);

  fprintf(ffi,"\
-------------------------------------------------------------------");
  if(mr == 1)
    fprintf(ffi,"\
--------------------------------------------------------------------------------");
  strpod(mn,mk,11,ffi);
}
/***************************/
/****************************/
void uosvamot_prp(const char *hnaz,
const char *podd,
const char *hzt,
const char *invnom,
const char *shetup,
const char *sost,
int *kol_str,
FILE *ff)
{

if(hnaz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Група"),hnaz);
  *kol_str+=1;
 }
if(podd[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Подразделение"),podd);
  *kol_str+=1;
 }
if(hzt[0] != '\0')
 {
  *kol_str+=1;
  fprintf(ff,"%s: %s\n",gettext("Шифр затрат"),hzt);
 }
if(invnom[0] != '\0')
 {
  *kol_str+=1;
  fprintf(ff,"%s: %s\n",gettext("Инвентарный номер"),invnom);
 }
if(shetup[0] != '\0')
 {
  *kol_str+=1;
  fprintf(ff,"%s: %s\n",gettext("Счёт"),shetup);
 }
if(sost[0] != '\0')
 {
  *kol_str+=1;
  fprintf(ff,"%s: %s\n",gettext("Состояние объекта"),sost);
 }
}
