/* $Id: uosvos.c,v 5.21 2011-08-29 07:08:59 sasa Exp $ */
/*16.03.2010	19.11.1999	Белых А.И.	uosvos.c
Получение ведомости остаточной стоимости
*/
#include        <time.h>
#include        <math.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern int      kol_strok_na_liste; //Количество строк на стандартном листе
#define         KOLSTSH  6  /*Количество строк в шапке*/

void            uosvos_ithz(const char*,double,double,short,int*,double*,class bsiz_per *data_hz,FILE*,FILE*);
void            uosvos_gsap(short,short,short,int *,int *,int,const char*,short,FILE*);
void            uosvos_hhap(short,short,short,int,int*,int,const char*,short,FILE*);
void uosvos_porgup(char *kodgr,short dk,short mk,short gk,double*,FILE *ff,FILE*);
void uosvos_pogurp_s(short dk,short mk,short gk,short sli,int *kst,char*,double*,FILE *ff,FILE*);

void uosvosii_start(short dk,short mk,short gk,int viduh,int metr,int metka_sort,
int *kst,char *podrz,char *hnaz,char *hnabyz,char *kodolz,char *hauz,char *shetupoi,char *innomp,char *hztz,char*,int,FILE *ff);

extern char	*organ;
extern short	startgoduos; /*Стартовый год*/

int uosvos(int viduh, //0-налоговый учет 1-бухгалтерский
class spis_oth *oth)
{
char		naimos[512];
char		strr[512];
struct  tm      *bf;
time_t          tmm;
FILE		*ff,*ff1,*ffhpz;
char		bros[512];
static char     dat1[16];
int           kom,kom1;
static char     podrz[112]; /*Код подразделения*/
static char	kodolz[112]; /*Коды ответственных лиц*/
static char	hnaz[112];
static char	hnabyz[112];
static char	hauz[112];
static char	shetupoi[112];
static char	innomp[112];
static char	hztz[112];
static char  sosob[2];
short           dk,mk,gk;
char            imaf[32],imaftmp[32],imafhpz[32];;
long		kolstr,kolstr1,kolstr3;
SQL_str         row,row1;
char		strsql[512];
int		pod=0,podz=0;
long		in;
int		metr=0; /*0-по подразделениям 1-по мат.-ответственным*/
double          bs1=0.;
double		s1=0.;
double          ss1=0.;
double		s11=0.;
double		bs11=0.;
double          bss1;
double		osts;
double		bsn=0.,izn=0.;
double		pr1=0.,pr2=0.;
char		hna1[64];
char		naipod[512];
int		sli,kst;
char		naigrup[512];
short		mvsh; /*0-шапку не печатать, если больше печатать*/
short		mvsi; /*0-шифр не печатать*/
int             poddz,kodotl;
int		podrp=0;
int 		kolos=0; //Количество основных средств попавших в отчет
SQLCURSOR curr;
/*Переменные данные по инвентарному номеру*/
char		shetu[32]; /*Счет учета*/
char		hzt[32];   /*Шифр затрат*/
char		hau[32];   /*Шифр аналитического учета*/
char		hna[32];   /*Шифр нормы амортотчислений*/
float		popkf;   /*Поправочный коэффициент*/
char		hnaby[32];   /*Шифр нормы амортотчислений*/
float		popkfby;   /*Поправочный коэффициент*/
int		soso;    /*Состояние объекта*/
char		nomz[112];  /*Номерной знак*/
short		m1,g1;
int             metka_sort=0; //0-сортировка по группам 1-по счетам учёта

VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(hnaz,sizeof(hnaz));
VV.VVOD_SPISOK_add_data(hnabyz,sizeof(hnabyz));
VV.VVOD_SPISOK_add_data(podrz,sizeof(podrz));
VV.VVOD_SPISOK_add_data(kodolz,sizeof(kodolz));
VV.VVOD_SPISOK_add_data(hauz,sizeof(hauz));
VV.VVOD_SPISOK_add_data(shetupoi,sizeof(shetupoi));
VV.VVOD_SPISOK_add_data(innomp,sizeof(innomp));
VV.VVOD_SPISOK_add_data(hztz,sizeof(hztz));
VV.VVOD_SPISOK_add_data(sosob,sizeof(sosob));

VV.VVOD_SPISOK_add_MD(gettext("Дата остатка..(д.м.г)..."));//0
VV.VVOD_SPISOK_add_MD(gettext("Группа нал.учета..(,,).."));//1
VV.VVOD_SPISOK_add_MD(gettext("Группа бух.учета..(,,).."));//2
VV.VVOD_SPISOK_add_MD(gettext("Подразделение (,,)......"));//3
VV.VVOD_SPISOK_add_MD(gettext("Мат.ответственный (,,).."));//4
VV.VVOD_SPISOK_add_MD(gettext("Шифр анал. учета..(,,).."));//5
VV.VVOD_SPISOK_add_MD(gettext("Счет учета........(,,).."));//6
VV.VVOD_SPISOK_add_MD(gettext("Инвентарный номер.(,,).."));//7
VV.VVOD_SPISOK_add_MD(gettext("Шифр затрат.......(,,).."));//8
VV.VVOD_SPISOK_add_MD(gettext("Состояние объекта.(+/-)."));//9

if(viduh == 0)
 VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка ведомости остаточной стоимости (налоговый учет)"));
if(viduh == 1)
 VV.VVOD_SPISOK_add_ZAG(gettext("Рапечатка ведомости остаточной стоимости (бухгалтерский учет)"));
VV.VVOD_SPISOK_add_ZAG(gettext("Введите данные"));

naz:;

clear();

helstr(LINES-1,0,"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);

memset(hnaz,'\0',sizeof(hnaz));
strncpy(hnaz,VV.VVOD_SPISOK_return_data(1),sizeof(hnaz)-1);

memset(hnabyz,'\0',sizeof(hnabyz));
strncpy(hnabyz,VV.VVOD_SPISOK_return_data(2),sizeof(hnabyz)-1);

memset(podrz,'\0',sizeof(podrz));
strncpy(podrz,VV.VVOD_SPISOK_return_data(3),sizeof(podrz)-1);
memset(kodolz,'\0',sizeof(kodolz));
strncpy(kodolz,VV.VVOD_SPISOK_return_data(4),sizeof(kodolz)-1);
strncpy(hauz,VV.VVOD_SPISOK_return_data(5),sizeof(hauz)-1);
strncpy(shetupoi,VV.VVOD_SPISOK_return_data(6),sizeof(shetupoi)-1);
strncpy(innomp,VV.VVOD_SPISOK_return_data(7),sizeof(innomp)-1);
strncpy(hztz,VV.VVOD_SPISOK_return_data(8),sizeof(hztz)-1);
strncpy(sosob,VV.VVOD_SPISOK_return_data(9),sizeof(sosob)-1);
class iceb_tu_str kod_v("");
class iceb_tu_str naim_v("");

switch(kom)
 {
  case FK10:
  case ESC:
   return(1);
  case FK2:
  case PLU:
   break;

  case FK3:  /*Просмотр реквизитов*/
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп налогового учета"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп бухгалтерского учета"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка мат.-ответственны"));//3
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка шифров аналитического учета"));//4
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка шифров затрат"));//5
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//6

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 6:
      case -1:
       goto naz;

      case 0 :
        vibrek("Uosgrup",hnaz,sizeof(hnaz),naipod);
        VV.VVOD_SPISOK_zapis_data(2,hnaz);
        goto naz;

      case 1 :
        vibrek("Uosgrup1",hnabyz,sizeof(hnabyz),naipod);
        VV.VVOD_SPISOK_zapis_data(3,hnabyz);
        goto naz;

      case 2 :
        if(diruospod(1,&kod_v,&naim_v,0) == 0)
          VV.data_z_plus(4,kod_v.ravno());
        goto naz;

      case 3 :
        if(dirmatot(1,&kod_v,&naim_v,0) == 0)
          VV.data_z_plus(5,kod_v.ravno());
        goto naz;

      case 4 :
        vibrek("Uoshau",hauz,sizeof(hauz),naipod);
        VV.VVOD_SPISOK_zapis_data(6,hauz);
        goto naz;

      case 5 :
        vibrek("Uoshz",hztz,sizeof(hztz),naipod);
        VV.VVOD_SPISOK_zapis_data(9,hztz);
        goto naz;

     }
    goto naz;
    

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
 }


if(rsdat(&dk,&mk,&gk,VV.VVOD_SPISOK_return_data(0),1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Неправильно введена дата остатка !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
 

MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите нужное и нажмите Enter"));

MENU.VVOD_SPISOK_add_MD(gettext("Расчитать по подразделениям"));
MENU.VVOD_SPISOK_add_MD(gettext("Расчитать по мат.-ответственным"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
metr=0;
while(menu3w(stdscr,&MENU,&metr,-1,-1,0) != 0);
if(metr == -1 || metr == 2)
 return(1);

MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите нужное и нажмите Enter"));

MENU.VVOD_SPISOK_add_MD(gettext("Все основные средства"));
MENU.VVOD_SPISOK_add_MD(gettext("Основные средства с нулевой остаточной стоимостью"));
MENU.VVOD_SPISOK_add_MD(gettext("Основные средства с ненулевой остаточной стоимостью"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

int metkaost=0;

while(menu3w(stdscr,&MENU,&metkaost,-1,-1,0) != 0);

if(metkaost == -1 || metkaost == 3)
 return(1);

MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите нужное и нажмите Enter"));
MENU.VVOD_SPISOK_add_MD(gettext("Сортировка по группам"));
MENU.VVOD_SPISOK_add_MD(gettext("Сортировать по счетам учёта"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
while(menu3w(stdscr,&MENU,&metka_sort,-1,-1,0) != 0);
if(metka_sort == -1 || metka_sort == 2)
 return(1);
 
clear();
refresh();
printw(" %d.%d.%d%s\n",
dk,mk,gk,
gettext("г."));
printw("%s\n",gettext("Сортируем"));
time(&tmm);
bf=localtime(&tmm);

GDITE(); 
sprintf(strsql,"select innom,naim from Uosin");

SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);  
 }

sprintf(imaftmp,"uos%d.tmp",getpid());

if((ff = fopen(imaftmp,"w")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }
char pole1[56];
kolstr3=kolstr1=0;
class SQLCURSOR cur1;
while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s\n",row[0],row[1]);
  strzag(LINES-1,0,kolstr,++kolstr1);  
  if(proverka(innomp,row[0],0,0) != 0)
    continue;
    
  in=atol(row[0]);

  if(poiin(in,dk,mk,gk,&poddz,&kodotl) != 0) 
     continue; //Произошел расход или на эту дату небыло прихода
  
  if(proverka(podrz,poddz,0,0) != 0)
    continue;

  if(proverka(kodolz,kodotl,0,0) != 0)
    continue;

  poiinpd(in,mk,gk,shetu,hzt,hau,hna,&popkf,&soso,nomz,&m1,&g1,hnaby,&popkfby);

  if(viduh == 0 ) //Пропускаем все основные средства если для них амортизазия считается в целом по группе
   if(uosprovgr(hna) == 1)
    continue;

  if(viduh == 0 ) //Налоговый учёт
   {
    if(soso == 0 || soso == 3) //амортизация считается
     if(sosob[0] == '-')
      continue;
    if(soso == 1 || soso == 2) //амортизация не считаетcя
     if(sosob[0] == '+')
      continue;
    
   }
  if(viduh == 1 ) //Бух.учёт
   {
    if(soso == 0 || soso == 2) //амортизация считается
     if(sosob[0] == '-')
      continue;
    if(soso == 1 || soso == 3) //амортизация не считаестя
     if(sosob[0] == '+')
      continue;
    
   }
  if(proverka(shetupoi,shetu,0,0) != 0)
    continue;

  if(proverka(hztz,hzt,0,0) != 0)
    continue;

  if(proverka(hnaz,hna,0,0) != 0)
    continue;

  if(proverka(hnabyz,hnaby,0,0) != 0)
    continue;

  if(proverka(hauz,hau,0,0) != 0)
    continue;

  kolstr3++;

  memset(pole1,'\0',sizeof(pole1));      
  if(metr == 0) //По подразделениям
   {
      
      if(metka_sort == 0)
       {
        if(viduh == 0) //налоговый учёт
          strcpy(pole1,hna);
        if(viduh == 1) //бухгалтерский учёт
          strcpy(pole1,hnaby);

        if(pole1[0] == '\0')
         strcpy(pole1,"???");
        fprintf(ff,"%s|%d|%s|%s|%d|%s|\n",pole1,poddz,row[0],row[1],kodotl,nomz);
       }
      if(metka_sort == 1)
        fprintf(ff,"%s|%d|%s|%s|%d|%s|\n",shetu,poddz,row[0],row[1],kodotl,nomz);
    
   }

  if(metr == 1) //По материально-ответственным
   {

      if(metka_sort == 0)
       {
        if(viduh == 0) //Налоговый учет
          strcpy(pole1,hna);
        if(viduh == 1) //Бухгалтерский учет
          strcpy(pole1,hnaby);

        if(pole1[0] == '\0')
         strcpy(pole1,"???");

        fprintf(ff,"%s|%d|%s|%s|%d|%s|\n",pole1,kodotl,row[0],row[1],poddz,nomz);
       }
      if(metka_sort == 1)
        fprintf(ff,"%s|%d|%s|%s|%d|%s|\n",shetu,kodotl,row[0],row[1],poddz,nomz);
     
   }

 }
GDITE(); 
fclose(ff);

//sprintf(strsql,"sort -o %s -t\\| +0 -1 +1 -2 %s",imaftmp,imaftmp);
sprintf(strsql,"sort -o %s -t\\| -k1,2 -k2,3 %s",imaftmp,imaftmp);
runsystem(strsql);
printw("%s.\n",gettext("Сортировка завершена"));
GDITE(); 

if((ff1 = fopen(imaftmp,"r")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }

sprintf(imaf,"vos%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

sprintf(imafhpz,"vosi%d.lst",getpid());

if((ffhpz = fopen(imafhpz,"w")) == NULL)
 {
  error_op_nfil(imafhpz,errno,"");
  return(1);
 }


char imaf_br[32];

sprintf(imaf_br,"vosbr%d.lst",getpid());
FILE *ff_br;

if((ff_br = fopen(imaf_br,"w")) == NULL)
 {
  error_op_nfil(imaf_br,errno,"");
  return(1);
 }


uosvosii_start(dk,mk,gk,viduh,metr,metka_sort,&kst,podrz,
hnaz,hnabyz,kodolz,hauz,shetupoi,innomp,hztz,sosob,metkaost,ff);

uosvosii_start(dk,mk,gk,viduh,metr,metka_sort,&kst,podrz,
hnaz,hnabyz,kodolz,hauz,shetupoi,innomp,hztz,sosob,metkaost,ffhpz);


int kolstr_br=0;
int kol_list_br=1;

uosvosii_start(dk,mk,gk,viduh,metr,metka_sort,&kolstr_br,podrz,
hnaz,hnabyz,kodolz,hauz,shetupoi,innomp,hztz,sosob,metkaost,ff_br);

 
int kstt=0;
uosvos_hhap(dk,mk,gk,1,&kstt,0,"",2,ffhpz);

uosvos_hhap(dk,mk,gk,kol_list_br,&kolstr_br,0,"",2,ff_br);

bs1=bss1=0.;
s1=ss1=0.;
bs11=s11=0.;
mvsi=mvsh=in=0;
sli=1;
podz=kolstr1=0;
memset(hna1,'\0',sizeof(hna1));
memset(naipod,'\0',sizeof(naipod));
memset(hna,'\0',sizeof(hna));
double iznos_per[2];
double i_iznos_per[2];
double iznos_per_pod[2];
double iznos_per_hna[2];
memset(&i_iznos_per,'\0',sizeof(i_iznos_per));
memset(&iznos_per,'\0',sizeof(iznos_per));
memset(&iznos_per_pod,'\0',sizeof(iznos_per_pod));
memset(&iznos_per_hna,'\0',sizeof(iznos_per_hna));

class bsiz_per data_podr; //Итоги по подразделению
class bsiz_per data_hz;   //Итоги по шифру затрат
class bsiz_per data_oi;   //Общий итог по всему отчёту
class bsiz_per data_shet; //Итог по счёту

while(fgets(strr,sizeof(strr),ff1) != NULL)
 {

//  printw("%s",strr);
//  OSTANOV();

  strzag(LINES-1,0,kolstr3,++kolstr1);
  polen(strr,hna,sizeof(hna),1,'|');
  polen(strr,bros,sizeof(bros),2,'|');
  podrp=pod=atoi(bros);
  polen(strr,bros,sizeof(bros),3,'|');
  in=atol(bros);
  polen(strr,naimos,sizeof(naimos),4,'|');
  if(metr == 1) /*По мат-отв*/
   {
    polen(strr,bros,sizeof(bros),5,'|');
    podrp=atoi(bros);
   }

  polen(strr,nomz,sizeof(nomz),6,'|');

  memset(&iznos_per,'\0',sizeof(iznos_per));

  
  class bsiz_data data_per;
  
  bsizp(in,podrp,dk,mk,gk,dk,mk,gk,&data_per,NULL);
  
  pr1=pr2=0.;  
  if(viduh == 0)
   {
    pr1=data_per.nu.bs_nah_per; //Балансовая стоимость на начало периода
    pr2=data_per.nu.izmen_iznosa_nah_per+data_per.nu.amort_nah_per;  //Износ на начало периода
      
   }
  
  if(viduh == 1)
   {
    pr1=data_per.bu.bs_nah_per; //Балансовая стоимость на начало периода
    pr2=data_per.bu.izmen_iznosa_nah_per+data_per.bu.amort_nah_per;  //Износ на начало периода
    
   }
    
  
    
  if(fabs(pr1) < 0.01 ) //Значит уже продан или списан или передан в другое подразделение
   {
/***********
    if(in == 7001090)
     { 
      printw("in=%d %d.%d.%d\n",in,dk,mk,gk);
      printw("pr1=%.2f pr2=%.2f\n",pr1,pr2);
      OSTANOV();
     }
*************/
    continue;
   }


  if(podz != pod)
   {
    if(podz != 0)
     {
      sprintf(bros,"%d",podz);
      uosvos_ithz(bros,bss1,ss1,0,&kst,iznos_per_pod,&data_podr,ff,ffhpz);
      memset(&iznos_per_pod,'\0',sizeof(iznos_per_pod));
      bss1=0.;
      ss1=0.;
     }

    if(metr == 0)
     {
      /*Читаем наименование подразделения*/
      memset(naipod,'\0',sizeof(naipod));
      sprintf(strsql,"select naik from Uospod where kod=%d",pod);
      if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
       {
        beep();
        printw("%s %d !\n",gettext("Не найден код подразделения"),pod);
        fprintf(ff,"%s %d !\n",gettext("Не найден код подразделения"),pod);
        OSTANOV();
       }
      else
        strncpy(naipod,row1[0],sizeof(naipod)-1);
     }

    if(metr == 1)
     {
      /*Читаем мат.-ответственного*/
      memset(naipod,'\0',sizeof(naipod));
      sprintf(strsql,"select naik from Uosol where kod=%d",pod);
      if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
       {
        beep();
        printw("%s %d !\n",gettext("Не найден мат.-ответственный"),pod);
        fprintf(ff,"%s %d !\n",gettext("Не найден мат.-ответственный"),pod);
        OSTANOV();
       }
      else
        strncpy(naipod,row1[0],sizeof(naipod)-1);
     }

    mvsh++;
             
    podz=pod;
    if(metr == 0)
     printw("\n%s - %d/%s\n",gettext("Подразделение"),podz,naipod);
    if(metr == 1)
     printw("\n%s - %d/%s\n",gettext("Мат.-ответственный"),podz,naipod);
   }

  if(SRAV(hna1,hna,0) != 0)
   {
    if(hna1[0] != '\0')
     {
      if(metka_sort == 0)
       uosvos_ithz(hna1,bs1,s1,1,&kst,iznos_per_hna,&data_hz,ff,ffhpz);
      if(metka_sort == 1)
       uosvos_ithz(hna1,bs1,s1,3,&kst,iznos_per_hna,&data_shet,ff,ffhpz);
      memset(&iznos_per_hna,'\0',sizeof(iznos_per_hna));
      bs1=s1=0.;
     }
    
    if(metka_sort == 0)
     {
      /*Уэнаем наименование шифра нормы аморт. отчисления*/
      memset(naigrup,'\0',sizeof(naigrup));
      if(SRAV(hna,"???",0) != 0)
       {
        if(viduh == 0)
          sprintf(strsql,"select naik from Uosgrup where kod='%s'",hna);
        if(viduh == 1)
          sprintf(strsql,"select naik from Uosgrup1 where kod='%s'",hna);

        if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
         {
          beep();
          printw("%s %s !\n",gettext("Не найдено группу"),hna);
          fprintf(ff,"%s %s !\n",gettext("Не найдено группу"),hna);
          OSTANOV();
         }
        else
          strncpy(naigrup,row1[0],sizeof(naigrup)-1);
       }
      else
       strcpy(naigrup,"Не введена в карточку группа");
      printw("\n%s %s \"%s\"\n",
      gettext("Группа"),hna,naigrup);
     }
    if(metka_sort == 1)
     {
      sprintf(strsql,"select nais from Plansh where ns='%s'",hna);
      memset(naigrup,'\0',sizeof(naigrup));
      if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
        strncpy(naigrup,row1[0],sizeof(naigrup)-1);
     
      printw("\n%s %s \"%s\"\n",
      gettext("Счёт учёта"),hna,naigrup);
     }
    mvsi++;


    strcpy(hna1,hna);

   }
  if(mvsh > 0 || mvsi > 0) 
   {  
    if(kst > kol_strok_na_liste-KOLSTSH-5)
     {
      fprintf(ff,"\f");
      sli++;
      kst=0;
     }
    if(mvsi > 0)
     {
      if(metka_sort == 0)
       {
        fprintf(ff,"\n%s %s \"%s\"\n",gettext("Группа"),hna,naigrup);
       }
      if(metka_sort == 1)
       {
        fprintf(ff,"\n%s %s \"%s\"\n",
        gettext("Счёт учёта"),hna,naigrup);
       }
      mvsi=0;
      kst+=2;
     } 
    uosvos_hhap(dk,mk,gk,sli,&kst,pod,naipod,metr,ff);
    mvsh=0;
   }

  if(viduh == 0)
   {
    data_podr.plus(&data_per.nu);
    data_oi.plus(&data_per.nu);
    data_hz.plus(&data_per.nu);
    data_shet.plus(&data_per.nu);
   }
  if(viduh == 1)
   {
    data_podr.plus(&data_per.bu);
    data_oi.plus(&data_per.bu);
    data_hz.plus(&data_per.bu);
    data_shet.plus(&data_per.bu);
   }
  izn=pr2;
  bsn=pr1;
  osts=bsn-izn;

  if(osts >  0.009 && metkaost == 1)
   continue;

  if(osts ==  0. && metkaost == 2)
   continue;

  bss1+=bsn;
  ss1+=izn;
  
  bs1+=bsn;
  s1+=izn;
  
  bs11+=bsn;
  s11+=izn;

  if(fabs(bsn+izn+osts) > 0.009)
   {

    uosvos_gsap(dk,mk,gk,&sli,&kst,pod,naipod,metr,ff);
    fprintf(ff,"%11ld %-*.*s %-*.*s %12.2f %12.2f %12.2f\n",
    in,
    iceb_tu_kolbait(30,naimos),iceb_tu_kolbait(30,naimos),naimos,
    iceb_tu_kolbait(10,nomz),iceb_tu_kolbait(10,nomz),nomz,
    bsn,izn,osts);

    uosvos_gsap(dk,mk,gk,&kol_list_br,&kolstr_br,0,"",2,ff_br);
    
    fprintf(ff_br,"%11ld %-*.*s %-*.*s %12.2f %12.2f %12.2f\n",
    in,
    iceb_tu_kolbait(30,naimos),iceb_tu_kolbait(30,naimos),naimos,
    iceb_tu_kolbait(10,nomz),iceb_tu_kolbait(10,nomz),nomz,
    bsn,izn,osts);

    if(iceb_tu_strlen(naimos) > 30)
     {
    
      uosvos_gsap(dk,mk,gk,&sli,&kst,pod,naipod,metr,ff);
      fprintf(ff,"%11s %s\n","",iceb_tu_adrsimv(30,naimos));
  
      uosvos_gsap(dk,mk,gk,&kol_list_br,&kolstr_br,0,"",2,ff_br);
      fprintf(ff_br,"%11s %s\n","",iceb_tu_adrsimv(30,naimos));
     }
    kolos++;
   }
 }

GDITE();

fclose(ff1);

unlink(imaftmp);


sprintf(bros,"%d",pod);
uosvos_ithz(bros,bss1,ss1,0,&kst,iznos_per_pod,&data_podr,ff,ffhpz);

if(metka_sort == 0)
  uosvos_ithz(hna,bs1,s1,1,&kst,iznos_per_hna,&data_hz,ff,ffhpz);
if(metka_sort == 1)
  uosvos_ithz(hna,bs1,s1,3,&kst,iznos_per_hna,&data_shet,ff,ffhpz);

/*Итог Общий*/
uosvos_ithz(" ",bs11,s11,2,&kst,i_iznos_per,&data_oi,ff,ffhpz);
uosvos_ithz(" ",bs11,s11,2,&kst,i_iznos_per,&data_oi,ff_br,NULL);


if(viduh == 0) //распечатка по группам с общегрупповой амортизацией
 {
  double suma_pogr[3];
  memset(suma_pogr,'\0',sizeof(suma_pogr));

  uosvos_pogurp_s(dk,mk,gk,sli,&kst,hnaz,suma_pogr,ff,ffhpz);

  suma_pogr[0]+=bs11;
  suma_pogr[1]+=s11;
  suma_pogr[2]+=bs11-s11;
  
  char str[200];
  memset(str,'\0',sizeof(str));
  memset(str,'-',93);

  fprintf(ff,"%s\n",str);
  fprintf(ff,"\
%*s %12.2f %12.2f %12.2f\n",
  iceb_tu_kolbait(53,gettext("Общий итог")),gettext("Общий итог"),
  suma_pogr[0],
  suma_pogr[1],
  suma_pogr[2]);


  fprintf(ffhpz,"%s\n",str);
  fprintf(ffhpz,"\
%*s %12.2f %12.2f %12.2f\n",
  iceb_tu_kolbait(53,gettext("Общий итог")),gettext("Общий итог"),
  suma_pogr[0],
  suma_pogr[1],
  suma_pogr[2]);

 }





printw("\n%s:%d\n",gettext("Количество основных средств"),kolos);
fprintf(ff,"\n%s:%d\n",gettext("Количество основных средств"),kolos);
fprintf(ffhpz,"\n%s:%d\n",gettext("Количество основных средств"),kolos);

podpis(ff);
podpis(ffhpz);
podpis(ff_br);

fclose(ff);
fclose(ff_br);
fclose(ffhpz);

printw_vr(tmm);




oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Ведомость остаточной стоимости с сортировкой"));
oth->spis_imaf.plus(imafhpz);
oth->spis_naim.plus(gettext("Общие итоги"));
oth->spis_imaf.plus(imaf_br);
oth->spis_naim.plus(gettext("Ведомость остаточной стоимости без сортировки"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),1);

OSTANOV();

return(0);

}
/****************/
/*Итого по шифру и подразделению для износа*/
/****************/
void uosvos_ithz(const char *sh,double k1,double s1,
short mt,  //0-по подразделению 1- по шифру 2-общий итог 3-по счету учёта
int *kst,
double *iznos_per,
class bsiz_per *data_i,
FILE *ff,FILE *ffhpz)
{
char		bros[512];
char		str[300];

memset(str,'\0',sizeof(str));
memset(str,'-',93);

if(mt == 2)
 {
  sprintf(bros,gettext("Общий итог"));
 }

if(mt == 1)
 {
  if(sh[0] == '\0')
   return;
  sprintf(bros,"%s %s",gettext("Итого по шифру"),sh);
  if(ffhpz != NULL)
   fprintf(ffhpz,"%s\n\
%11s %-*s %10s %12.2f %12.2f %12.2f\n",
str," ",
iceb_tu_kolbait(30,bros),bros,
" ",k1,s1,k1-s1);
 }

if(mt == 0)
 {
  if(k1+s1+(k1-s1) < 0.0001)
   return;
  sprintf(bros,"%s %s",gettext("Итого по подразделению"),sh);
 }

if(mt == 3)
 {
  if(k1+s1+(k1-s1) < 0.0001)
   return;
  sprintf(bros,"%s %s",gettext("Итого по счёту"),sh);
 }

fprintf(ff,"%s\n\
%11s %-*s %10s %12.2f %12.2f %12.2f\n",str," ",iceb_tu_kolbait(30,bros),bros," ",k1,s1,k1-s1);

 
if(mt == 2 || mt == 3)
 if(ffhpz != NULL)
  fprintf(ffhpz,"%s\n\
%11s %-*s %10s %12.2f %12.2f %12.2f\n",str," ",iceb_tu_kolbait(30,bros),bros," ",k1,s1,k1-s1);

*kst=*kst+2;

printw("\n%s:\n\
%s %12.2f %12.2f %12.2f\n",
bros,
gettext("Баланс. ст./Износ/Ост.ст.:"),
k1,s1,k1-s1);

data_i->clear_data(); //обнуляем массив

}

/*******/
/*Счетчик строк*/
/*******/
void uosvos_gsap(short dk,short mk,short gk,
int *sl,  //Счетчик листов
int *kst, //Счетчик строк
int skl,const char *nai,
short mt,   //0-по подразделению 1-по материально-ответств
FILE *ff)
{

*kst=*kst+1;

if(*kst <= kol_strok_na_liste)
 return;

*sl+=1;
*kst=1;
fprintf(ff,"\f");

uosvos_hhap(dk,mk,gk,*sl,kst,skl,nai,mt,ff);


}

/********/
/*Шапка*/
/*******/

void uosvos_hhap(short dk,short mk,short gk,
int sl, //Счетчик листов
int *kst,  //Счетчик строк
int skl,
const char *nai,
short mt,  //0-по подразделению 1-по материально-ответств 
FILE *ff)
{
char		str[300];
char		bros[512];

if(mt == 0)
 sprintf(bros,"%s %d %s",gettext("Подразделение"),skl,nai);

if(mt == 1)
 sprintf(bros,"%s %d %s",gettext("Мат.-ответственный"),skl,nai);

if(mt == 2)
 sprintf(bros,"%s",nai);

memset(str,'\0',sizeof(str));
memset(str,'-',93);

fprintf(ff,"\
%-*s %s N%d\n\%s\n",
iceb_tu_kolbait(71,bros),bros,
gettext("Лист"),
sl,str);

fprintf(ff,gettext("\
Инвентарный|     Наименование             |          | Балансовая |   Износ    | Остаточная |\n\
  номер    |                              |  Номер   |стоимость на|    на      |стоимость на|\n\
	   |                              |          |%02d.%02d.%dг.|%02d.%02d.%dг.|%02d.%02d.%dг.|\n"),
dk,mk,gk,dk,mk,gk,dk,mk,gk);

fprintf(ff,"%s\n",str);

 
*kst+=KOLSTSH;

}
/********************************/
/*Распечатка в целом по группе по списку групп*/
/*******************************/

void uosvos_pogurp_s(short dk,short mk,short gk,
short sli,
int *kst,
char *hnaz,
double *suma_pogr,
FILE *ff,FILE *ffhpz)
{
char strsql[512];
SQL_str row;
class SQLCURSOR cur;

sprintf(strsql,"select kod from Uosgrup where ta=1");
int kolstr=0;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
  return;  
fprintf(ff,"\n\n");
uosvos_hhap(dk,mk,gk,sli,kst,0,"Группы с амортизацией в целом по группе",2,ff);

fprintf(ffhpz,"\n\n");
uosvos_hhap(dk,mk,gk,sli,kst,0,"Группы с амортизацией в целом по группе",2,ffhpz);

while(cur.read_cursor(&row) != 0)
 {
  if(proverka(hnaz,row[0],0,0) != 0)
   continue;
  uosvos_porgup(row[0],dk,mk,gk,suma_pogr,ff,ffhpz);
 }

char str[200];
memset(str,'\0',sizeof(str));
memset(str,'-',93);

fprintf(ff,"%s\n",str);
fprintf(ff,"\
%*s %12.2f %12.2f %12.2f\n",
iceb_tu_kolbait(53,gettext("Итого")),gettext("Итого"),
suma_pogr[0],
suma_pogr[1],
suma_pogr[2]);

fprintf(ffhpz,"%s\n",str);
fprintf(ffhpz,"\
%*s %12.2f %12.2f %12.2f\n",
iceb_tu_kolbait(53,gettext("Итого")),gettext("Итого"),
suma_pogr[0],
suma_pogr[1],
suma_pogr[2]);
 


}
/****************/
/*Распечатка одной группы налогового учёта для которой амортизация считается в целом по группе*/
/******************************************/

void uosvos_porgup(char *kodgr,
short dk,short mk,short gk,
double *suma_pogr,
FILE *ff,FILE *ffhpz)
{
char naigrup[512];
SQL_str row;
SQLCURSOR cur;
char strsql[512];

memset(naigrup,'\0',sizeof(naigrup));

sprintf(strsql,"select naik from Uosgrup where kod='%s'",kodgr);
if(sql_readkey(&bd,strsql,&row,&cur) == 1)
 strncpy(naigrup,row[0],sizeof(naigrup)-1);
  
class bsiz_data data;
bsiz23p(kodgr,dk,mk,gk,dk,mk,gk,&data);

fprintf(ff,"\
%11s %-*.*s %-10.10s %12.2f %12.2f %12.2f\n",
kodgr,
iceb_tu_kolbait(30,naigrup),iceb_tu_kolbait(30,naigrup),naigrup,
"",
data.nu.bs_nah_per,
data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per,
data.nu.bs_nah_per-(data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per));




fprintf(ffhpz,"\
%11s %-*.*s %-10.10s %12.2f %12.2f %12.2f\n",
kodgr,
iceb_tu_kolbait(30,naigrup),iceb_tu_kolbait(30,naigrup),naigrup,
"",
data.nu.bs_nah_per,
data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per,
data.nu.bs_nah_per-(data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per));


suma_pogr[0]+=data.nu.bs_nah_per;
suma_pogr[1]+=data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per;
suma_pogr[2]+=data.nu.bs_nah_per-(data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per);

}
/**********************************/
/*Начало отчётов*/
/***********************************/

void uosvosii_start(short dk,short mk,short gk,
int viduh,
int metr,
int metka_sort,
int *kst,
char *podrz,
char *hnaz,
char *hnabyz,
char *kodolz,
char *hauz,
char *shetupoi,
char *innomp,
char *hztz,
char *sosob,
int metkaost,
FILE *ff)
{

*kst=5;

zagolov(gettext("Ведомость остаточной стоимости основных средств"),0,0,0,dk,mk,gk,organ,ff);

*kst+=1;

if(viduh == 0)
 {
  fprintf(ff,"%s.\n",gettext("Налоговый учет"));
 }
if(viduh == 1)
 {
  fprintf(ff,"%s.\n",gettext("Бухгалтерский учет"));
 }

int klst=0;
if(podrz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Подразделение"),podrz);
  printcod(ff,"Uospod","kod","naik",0,podrz,&klst);
  *kst+=klst+1;
 }

if(hnaz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Группа налогового учета"),hnaz);
  printcod(ff,"Uosgrup","kod","naik",1,hnaz,&klst);
  *kst+=klst+1;
 }
if(hnabyz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Группа бухгалтерского учета"),hnabyz);
  printcod(ff,"Uosgrup1","kod","naik",1,hnabyz,&klst);
  *kst+=klst+1;
 }
if(kodolz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Мат.-ответственный"),kodolz);
  printcod(ff,"Uosol","kod","naik",1,kodolz,&klst);
  *kst+=klst+1;
 }
if(hauz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Шифр аналитического учета"),hauz);
  printcod(ff,"Uoshau","kod","naik",0,hauz,&klst);
  *kst+=klst+1;
 }
if(shetupoi[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Счет"),shetupoi);
  *kst+=1;
 }

if(innomp[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Инвентарный номер"),innomp);
  *kst+=1;
 }

if(hztz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Шифр затрат"),hztz);
  *kst+=1;
 }

if(sosob[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Состояние объекта"),sosob);
  *kst+=1;
 }

if(metkaost == 1)
 {
  fprintf(ff,"%s\n",gettext("Основные средства с нулевою остаточной стоимостью"));
  *kst+=1;
 }
if(metkaost == 2)
 {
  fprintf(ff,"%s\n",gettext("Основные средства с ненулевой остаточной стоимостью"));
  *kst+=1;
 }
*kst+=1;
if(metr == 0)
 fprintf(ff,"%s\n",gettext("По подразделениям"));
if(metr == 1)
 fprintf(ff,"%s\n",gettext("По материально-ответственным"));

*kst+=1;
if(metka_sort == 0)
 fprintf(ff,"%s\n",gettext("Сортировка по группам"));
if(metka_sort == 1)
 fprintf(ff,"%s\n",gettext("Сортировать по счетам учёта"));

}
