/*$Id: uplvst_kg.c,v 5.17 2011-01-13 13:43:24 sasa1 Exp $*/
/*17.12.2009	24.05.2005	Белых А.И.	uplvst_kg.c
Ведомость движения топлива в киллограммах
*/
#include        <time.h>
#include        <math.h>
#include        <string.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void  itogvst_kg(int,char*,int,double,double,FILE*);
void     shetvst_kg(int*,int*,FILE*);
void     svst_kg(int*,int*,FILE*);
void uplvst_kg_it(int metka,double *itog,FILE *ff);


extern char     *organ;
extern int      kol_strok_na_liste;

int uplvst_kg(class spis_oth *oth)
{
static char	dat1[11];
static char	dat2[11];
static char	toplivo[112];
static char	voditel[112];
static char	shet[112];
int		kom=0,kom1=0;
short		dn,mn,gn;
short		dk,mk,gk;
char		naim[512];
char	strsql[512];
class iceb_tu_str kod("");
class iceb_tu_str naimk("");

SQLCURSOR curr;

VVOD VV(0);
VVOD MENU(3);

VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2));
VV.VVOD_SPISOK_add_data(toplivo,sizeof(toplivo));
VV.VVOD_SPISOK_add_data(voditel,sizeof(voditel));
VV.VVOD_SPISOK_add_data(shet,sizeof(shet));

VV.VVOD_SPISOK_add_ZAG(gettext("Распечатать ведомость списания топлива по счетам в киллограммах"));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала.(д.м.г)."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца..(д.м.г)."));
VV.VVOD_SPISOK_add_MD(gettext("Марка топлива..(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Код водителя...(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Счет...........(,,)."));

naz:;

clear();


helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(toplivo,VV.VVOD_SPISOK_return_data(2),sizeof(toplivo)-1);
strncpy(voditel,VV.VVOD_SPISOK_return_data(3),sizeof(voditel)-1);
strncpy(shet,VV.VVOD_SPISOK_return_data(4),sizeof(shet)-1);

switch(kom)
 {
  case FK1:
    GDITE();
    iceb_t_pdoc("upl4_3.txt");
    clear();
    goto naz;
  case FK10:
  case ESC:
   return(1);
  case FK2:
  case PLU:
   break;

  case FK3:  /*Просмотр реквизитов*/
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка марок топлива"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка водителей"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//3

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Uplmt",toplivo,sizeof(toplivo),naim);
        VV.VVOD_SPISOK_zapis_data(2,toplivo);
        goto naz;

      case 1:
        naimk.new_plus("");
        if(dirout(&kod,&naimk,1,2) == 0)
          VV.data_z_plus(3,kod.ravno());
        goto naz;

      case 2:
        vibrek("Plansh",shet,sizeof(shet),naim);
        VV.VVOD_SPISOK_zapis_data(4,shet);
        goto naz;

     }
    goto naz;
    

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
 }

if(rsdatp(&dn,&mn,&gn,VV.VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
  goto naz;

clear();
printw("%s:%d.%d.%d => %d.%d.%d \n",
gettext("Диапазон поиска"),
dn,mn,gn,dk,mk,gk);

time_t 		tmm;
time(&tmm);

GDITE();

long	kolstr=0;
SQL_str row,row1;
FILE    *ff;
char    imaf[30];
int	kollist=0;
int	kolstrok=0;

sprintf(strsql,"select datd,nomd,kt,shet,pr,przg,prgr,vrrd from Upldok2 where datd >= '%d-%d-%d' and \
datd <= '%d-%d-%d' order by shet asc",gn,mn,dn,gk,mk,dk);


SQLCURSOR cur;
SQLCURSOR cur1;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);  
 }



char kodmt[32];
char shetz[32];

memset(kodmt,'\0',sizeof(kodmt));
memset(shetz,'\0',sizeof(shetz));

class SPISOK shet_kodt; //Список счёт->код топлива
class masiv_din_double suma_shet_kodt; //Расход топлива в литрах

long kolstr1=0;
int nomer=0;
double suma;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(proverka(toplivo,row[2],0,0) != 0)
   continue;

  if(proverka(voditel,row[9],0,0) != 0)
   continue;

  if(proverka(shet,row[3],0,0) != 0)
   continue;

  suma=0.;
  sprintf(strsql,"select nst,nstzg,ztvsn,ztvrn from Upldok \
where datd = '%s' and nomd='%s'",row[0],row[1]);
  if(readkey(strsql,&row1,&cur1) == 1)
   {
    suma+=atof(row[4])*atof(row1[0])/100.;
    suma+=atof(row[5])*atof(row1[1])/100.;
    suma+=atof(row[6])*atof(row1[2])/100.;
    suma+=atof(row[7])*atof(row1[3]);
    suma=okrug(suma,0.001);
   }  
  else
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдена шапка документа !"));
    sprintf(strsql,"%s %s",row[0],row[1]);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    continue;    
   }
  
  sprintf(strsql,"%s|%s",row[3],row[2]);

  if((nomer=shet_kodt.find(strsql)) == -1)
   shet_kodt.plus(strsql);

  suma_shet_kodt.plus(suma,nomer);
 }

sprintf(imaf,"vstkg%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }


kolstrok=5;
zagolov(gettext("Ведомость списания топлива по счетам в киллограммах"),dn,mn,gn,dk,mk,gk,organ,ff);

if(toplivo[0] != '\0')
 {
  kolstrok++;
  fprintf(ff,"%s:%s\n",gettext("Код топлива"),toplivo);  
 }

if(voditel[0] != '\0')
 {
  kolstrok++;
  fprintf(ff,"%s:%s\n",gettext("Код водителя"),voditel);  
 }

if(shet[0] != '\0')
 {
  kolstrok++;
  fprintf(ff,"%s:%s\n",gettext("Счет"),shet);  
 }

svst_kg(&kollist,&kolstrok,ff);
char shet_sp[32];
char kod_top[32];
double koef=0.;
double cn_suma=0.;
char shet_sp_z[32];
double srcn=0.;
double itog_shet[3];

memset(&itog_shet,'\0',sizeof(itog_shet));

double itog[3];
memset(&itog,'\0',sizeof(itog));

memset(shet_sp,'\0',sizeof(shet_sp));
memset(shet_sp_z,'\0',sizeof(shet_sp_z));
for(int i=0; i < shet_kodt.kolih() ; i++)
 {
  polen(shet_kodt.ravno(i),shet_sp,sizeof(shet_sp),1,'|');  
  polen(shet_kodt.ravno(i),kod_top,sizeof(kod_top),2,'|');  
  if(SRAV(shet_sp,shet_sp_z,0) != 0)
   {
    if(shet_sp_z[0] != '\0')
     uplvst_kg_it(0,itog_shet,ff);
    
    memset(&itog_shet,'\0',sizeof(itog_shet));
    strcpy(shet_sp_z,shet_sp);
   }  


  //читаем среднюю цену и коэффициент перевода
  koef=0.;
  srcn=0.;
  sprintf(strsql,"select srcn,kp from Uplmtsc where datsc <= '%04d-%02d-%02d' and kodt='%s' \
order by datsc desc",
  gn,mn,dn,kod_top);
  if(readkey(strsql,&row,&cur) > 0)
   {
    srcn=atof(row[0]);
    koef=atof(row[1]);
   }  
  suma=koef*suma_shet_kodt.ravno(i);
  suma=okrug(suma,0.001);
  
  shetvst_kg(&kolstrok,&kollist,ff);
  
  cn_suma=srcn*suma;
  
  itog_shet[0]+=suma_shet_kodt.ravno(i);
  itog_shet[1]+=suma;
  itog_shet[2]+=cn_suma;

  itog[0]+=suma_shet_kodt.ravno(i);
  itog[1]+=suma;
  itog[2]+=cn_suma;
  
  fprintf(ff,"%-*s %-*s %14.14g %11.11g %14.14g %7.2f %7.2f\n",
  iceb_tu_kolbait(6,shet_sp),shet_sp,
  iceb_tu_kolbait(11,kod_top),kod_top,
  suma_shet_kodt.ravno(i),koef,suma,srcn,cn_suma);
  
 }
uplvst_kg_it(0,itog_shet,ff);
fprintf(ff,"\
-----------------------------------------------------------------------------\n");
uplvst_kg_it(1,itog,ff);

podpis(ff);
fclose(ff);

printw("%s: %d\n",gettext("Количество листов"),kollist);

printw_vr(tmm);


OSTANOV();
oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Ведомость списания топлива по счетам в киллограммах"));

iceb_t_ustpeh(imaf,0);

return(0);
}
/*************************************/
/*Шапка                              */
/*************************************/

void    svst_kg(int *kollist,int *kolstrok,FILE *ff)
{
*kollist+=1;
*kolstrok+=5;

fprintf(ff,"%70s%s%d\n","",gettext("Лист N"),*kollist);

fprintf(ff,"\
-----------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
 Счет |Код топлива|Расход топлива|Коэффициент|Расход топлива|Средняя| Сумма |\n\
      |           |   в литрах   | перевода  |в киллограммах| цена  |       |\n"));
fprintf(ff,"\
-----------------------------------------------------------------------------\n");
//123456 12345678901 12345678901234 12345678901 12345678901234 1234567 1234567
}

/********************************/
/*Счетчик                       */
/********************************/
void     shetvst_kg(int *kolstrok,int *kollist,FILE *ff)
{
*kolstrok+=1;
if(*kolstrok > kol_strok_na_liste)
 {
  fprintf(ff,"\f");
  *kolstrok=0;
  svst_kg(kollist,kolstrok,ff);
 }  

}
/****************************/
/*Выдача итоговой строки*/
/**************************/
void uplvst_kg_it(int metka, //0-итог по счёту 1-общий
double *itog,FILE *ff)
{

char strsql[112];
if(metka == 0)
 sprintf(strsql,"%s",gettext("Итого по счёту"));
if(metka == 1)
 sprintf(strsql,"%s",gettext("Общий итог"));

fprintf(ff,"%*s:%11.11g %11s %14.14g %7s %7.2f\n",
iceb_tu_kolbait(21,strsql),strsql,itog[0]," ",itog[1]," ",itog[2]);



}

