/*$Id: usldopnal.c,v 5.11 2011-01-13 13:43:24 sasa1 Exp $*/
/*04.11.2000	21.03.2002	Белых А.И.	usldopnal.c
Определение процента и наименования дополнительного налога
Если вернули 0 нашли налог
             1 нет
*/

#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif


int	usldopnal(int tipz, // 1+ 2 -
char *kodop, //Код операции
float *procent,
char *naim,
int razmer) //Размер naim
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
char strsql[512];
int kolstr=0;
char	bros[1024];
int	vozvr=1;

*procent=0.;

sprintf(strsql,"select str from Alx where fil='uslnast.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"uslnast.alx");
  iceb_t_soob(strsql);
  return(1);
 }

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  
  if(polen(row_alx[0],bros,sizeof(bros),2,'|') != 0)
    continue;
  if(tipz == 1 && strstrm(bros,"+") != 1)
    continue;
  if(tipz == 2 && strstrm(bros,"-") != 1)
    continue;
    
  if(polen(row_alx[0],bros,sizeof(bros),3,'|') != 0)
    continue;
  if(proverka(bros,kodop,0,1) != 0)
    continue;

  memset(bros,'\0',sizeof(bros));
  if(polen(row_alx[0],bros,sizeof(bros),4,'|') != 0)
    continue;
  *procent=ATOFM(bros);
  if(polen(row_alx[0],bros,sizeof(bros),5,'|') != 0)
    continue;
  strncpy(naim,bros,razmer-1);
  vozvr=0;
  break;  
 }
 
return(vozvr);
}
