/*$Id: vvodkr1.c,v 5.32 2011-01-13 13:43:24 sasa1 Exp $*/
/*05.08.2010	25.10.2002	Белых А.И.	vvodkr1.c
Ввод и корректировка записи в документ командировочных расходов
*/
#include        <time.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern double	okrcn;  /*Округление цены*/
extern double	okrg1;  /*Округление 1*/

void	vvodkr1(short dd,short md,short gd,
const char *nomdok,
const char *kodkr,
const char *shetz,
int metkareg, //0-ввод новой записи 1-редактирование
int nomz)
{
char	strsql[512];
SQL_str row;
char kodgr[32];
char naimgr[512];
char naimkr[512];
class iceb_tu_str eiz("");
char shet[32];
class iceb_tu_str naimeiz("");
char naimshet[512];
int  poz,komv;
char poi[32];
struct OPSHET	shetv;
short mnds=1;
double suma_dok=0.; /*Общая сумма по документу*/
double	kolih=0.;
double  snds=0.;
char	kontr[32];
char    naimkont[512];
char    naimkont_r[512];
char ndrnn[32];
int ktoz=0;
time_t vremz=0;
char shet_nds[32];
char naim_shet_nds[512];
short dvnn=0,mvnn=0,gvnn=0;
double strah_sbor=0.; 
memset(shet_nds,'\0',sizeof(shet_nds));

char kdrnn[20]; //Код контрагента для реестра налоговых накладных
memset(kdrnn,'\0',sizeof(kdrnn));
memset(ndrnn,'\0',sizeof(ndrnn));

SQLCURSOR curr;
memset(kontr,'\0',sizeof(kontr));

if(metkareg == 0) //Ввод новой записи
 {
  sprintf(strsql,"select * from Ukrkras where kod=%s",kodkr);
  if(sql_readkey(&bd,strsql,&row,&curr) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s:%s",gettext("Не найден код"),kodkr);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return;
   }

  strncpy(naimkr,row[1],sizeof(naimkr)-1);
  strncpy(shet,row[3],sizeof(shet)-1);
  strncpy(kodgr,row[4],sizeof(kodgr)-1);
  eiz.new_plus(row[5]);
  mnds=atoi(row[6]);
  suma_dok=atof(row[2]);
 }

if(metkareg == 1) //Корректировка записи
 {
  sprintf(strsql,"select shet,kolih,cena,ediz,snds,kontr,kdrnn,ndrnn,ktoz,vrem,sn,dvnn,ss from Ukrdok1 where \
datd='%04d-%d-%d' and nomd='%s' and kodr=%s and shet='%s' and nomz=%d",
  gd,md,dd,nomdok,kodkr,shetz,nomz);
  printw("\n%s\n",strsql);
  if(readkey(strsql,&row,&curr) != 1)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдена запись для корректировки !"));
    sprintf(strsql,"%d.%d.%d %s %s %s",dd,md,gd,nomdok,kodkr,shetz);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return;
   }
  kolih=atof(row[1]);
  eiz.new_plus(row[3]);
  strncpy(shet,row[0],sizeof(shet)-1);
  snds=atof(row[4]);
  snds=okrug(snds,0.01);
  strah_sbor=atof(row[12]);
  suma_dok=atof(row[2])+snds+strah_sbor;//Общая сумма по документу
  suma_dok=okrug(suma_dok,okrcn);
  strncpy(kontr,row[5],sizeof(kontr)-1);
  strncpy(kdrnn,row[6],sizeof(kdrnn)-1);
  strncpy(ndrnn,row[7],sizeof(ndrnn)-1);
  ktoz=atoi(row[8]);
  vremz=atol(row[9]);
  strncpy(shet_nds,row[10],sizeof(shet_nds));
  rsdat(&dvnn,&mvnn,&gvnn,row[11],2);
    
  sprintf(strsql,"select naim,kgr from Ukrkras where kod=%s",kodkr);
  if(sql_readkey(&bd,strsql,&row,&curr) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s:%s",gettext("Не найден код"),kodkr);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return;
   }

  strncpy(naimkr,row[0],sizeof(naimkr)-1);
  strncpy(kodgr,row[1],sizeof(kodgr)-1);
  
 }
 
memset(naimgr,'\0',sizeof(naimgr));
sprintf(strsql,"select naik from Ukrgrup where kod=%s",kodgr);
if(sql_readkey(&bd,strsql,&row,&curr) == 1)
  strncpy(naimgr,row[0],sizeof(naimgr)-1);

naimeiz.new_plus("");
if(eiz.getdlinna() > 1)
 {
  sprintf(strsql,"select naik from Edizmer where kod='%s'",eiz.ravno());
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    naimeiz.new_plus(row[0]);
 }

memset(naimshet,'\0',sizeof(naimshet));
if(shet[0] != '\0')
 {
  sprintf(strsql,"select nais from Plansh where ns='%s'",shet);
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strncpy(naimshet,row[0],sizeof(naimshet)-1);
 }

memset(naim_shet_nds,'\0',sizeof(naim_shet_nds));
if(shet_nds[0] != '\0')
 {
  sprintf(strsql,"select nais from Plansh where ns='%s'",shet_nds);
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strncpy(naim_shet_nds,row[0],sizeof(naim_shet_nds)-1);
 }

memset(naimkont,'\0',sizeof(naimkont));
if(kontr[0] != '\0')
 {
  sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",kontr);
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strncpy(naimkont,row[0],sizeof(naimkont)-1);
 }
memset(naimkont_r,'\0',sizeof(naimkont_r));
if(kdrnn[0] != '\0')
 {
  sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",kdrnn);
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strncpy(naimkont_r,row[0],sizeof(naimkont_r)-1);
 }

int	N=0,K=0;
    
VVOD VV(0);

if(metkareg == 0)
 VV.VVOD_SPISOK_add_ZAG(gettext("Ввод новой записи"));

if(metkareg == 1)
 {
  VV.VVOD_SPISOK_add_ZAG(gettext("Корректировка записи"));
  kzvz(ktoz,vremz,&VV);
  sprintf(strsql,"%s:%s %s:%d.%d.%d%s",gettext("Номер документа"),
  nomdok,gettext("Дата"),dd,md,gd,gettext("г."));
  VV.VVOD_SPISOK_add_ZAG(strsql);
 }
sprintf(strsql,"%s:%s %s",gettext("Расход"),kodkr,naimkr);
VV.VVOD_SPISOK_add_ZAG(strsql);

sprintf(strsql,"%s:%s %s",gettext("Группа"),kodgr,naimgr);
VV.VVOD_SPISOK_add_ZAG(strsql);

VV.VVOD_SPISOK_add_MD(gettext("Количество......................................."));//0
VV.VVOD_SPISOK_add_MD(gettext("Сумма с НДС......................................"));//1
VV.VVOD_SPISOK_add_MD(gettext("Сумма НДС........................................"));//2
VV.VVOD_SPISOK_add_MD(gettext("Единица измерения................................"));//3
VV.VVOD_SPISOK_add_MD(gettext("Счет............................................."));//4
VV.VVOD_SPISOK_add_MD(gettext("Код контрагента (часное лицо)...................."));//5
VV.VVOD_SPISOK_add_MD(gettext("Код контрагента для реестра налогових накладных.."));//6
VV.VVOD_SPISOK_add_MD(gettext("Номер документа.................................."));//7
VV.VVOD_SPISOK_add_MD(gettext("Счет НДС........................................."));//8
VV.VVOD_SPISOK_add_MD(gettext("Дта виписки налоговой накладной (д.м.г).........."));//9
VV.VVOD_SPISOK_add_MD(gettext("Страховой сбор..................................."));//10

sprintf(strsql,"%.10g",kolih);
VV.VVOD_SPISOK_add_data(strsql,20);//0

sprintf(strsql,"%.10g",suma_dok);
VV.VVOD_SPISOK_add_data(strsql,20);//1

sprintf(strsql,"%.10g",snds);
VV.VVOD_SPISOK_add_data(strsql,20);//2

VV.VVOD_SPISOK_add_data(80);//3
VV.VVOD_SPISOK_add_data(80);//4
VV.VVOD_SPISOK_add_data(80);//5
VV.VVOD_SPISOK_add_data(80);//6
VV.VVOD_SPISOK_add_data(ndrnn,sizeof(ndrnn));//7
VV.VVOD_SPISOK_add_data(80);//8
VV.VVOD_SPISOK_add_data(11);//9
VV.VVOD_SPISOK_add_data(10);//10

if(strah_sbor != 0.)
 VV.data_plus(10,strah_sbor);

naz:;

clear();
if(eiz.getdlinna() > 1)
 {
  sprintf(strsql,"%s|%s",eiz.ravno(),naimeiz.ravno());
  VV.VVOD_SPISOK_zapis_data(3,strsql);
 }
if(shet[0] != '\0')
 {
  sprintf(strsql,"%s|%s",shet,naimshet);
  VV.VVOD_SPISOK_zapis_data(4,strsql);
 }

if(kontr[0] != '\0')
 {
  sprintf(strsql,"%s|%s",kontr,naimkont);
  VV.VVOD_SPISOK_zapis_data(5,strsql);
 }
if(kdrnn[0] != '\0')
 {
  sprintf(strsql,"%s|%s",kdrnn,naimkont_r);
  VV.VVOD_SPISOK_zapis_data(6,strsql);
 }
if(shet_nds[0] != '\0')
 {
  sprintf(strsql,"%s|%s",shet_nds,naim_shet_nds);
  VV.VVOD_SPISOK_zapis_data(8,strsql);
 }
if(dvnn != 0)
 {
  sprintf(strsql,"%d.%d.%d",dvnn,mvnn,gvnn);
  VV.VVOD_SPISOK_zapis_data(9,strsql);
 } 

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("запись"),
"F3",gettext("реквизиты"),
"F10",gettext("выход"),NULL);

VV.vramka(-1,-1,0);


for(;;)
 {
  attron(VV.VVOD_return_cs(iceb_CFS)); 

  if(N > VV.KLST-1)
   {
    N=0;
   }
  if(N < 0)
   {
    N=VV.KLST-1;
   }

  VV.vprintw(N,stdscr);
  
  K=getch();

  attroff(VV.VVOD_return_cs(iceb_CFS));
  attron(VV.VVOD_return_cs(iceb_CFM));

  VV.vprintw(N,stdscr);
  if(K == KEY_RESIZE)
   goto naz;
  if(K == KEY_MOUSE)
    K=mouseklic(&N,VV.PY,VV.PX,VV.MDLS,VV.KLST,stdscr);

  if(K == ENTER)
   {
    attroff(VV.VVOD_return_cs(iceb_CFM));
    attron(VV.VVOD_return_cs(iceb_CFV));

    VV.vprintw_clear(N,stdscr);

    if(N == 3) //Единица измерения
     {
      naimeiz.new_plus("");
      poz=komv=0;
      poi[0]='\0';
      if(dirmat1("Edizmer",&eiz,&naimeiz,-1,-1,-1,2,&poz,&komv,poi,"\0") == 0)
        VV.VVOD_SPISOK_zapis_data(N,eiz.ravno());
      N++;
      goto naz;

     }

//    if(mygetstr(VV.VVOD_SPISOK_return_data(N),dlinastr+1,stdscr) == KEY_RESIZE)
    if(VV.vgetstr(N,stdscr) == KEY_RESIZE)
     goto naz;

    if(N == 0) //Количество
     {
      kolih=ATOFM(VV.VVOD_SPISOK_return_data(N));
     }


    if(N == 1) //Цена
     {
      suma_dok=ATOFM( VV.VVOD_SPISOK_return_data(N));
      suma_dok=okrug(suma_dok,0.01);
     }

    if(N == 2) 
     {
      snds=ATOFM(VV.VVOD_SPISOK_return_data(N));
      snds=okrug(snds,0.01);
     }

    if(N == 4) //Счет
     {
      if(VV.VVOD_SPISOK_return_data(N)[0] != '\0') //Счет
       { 
        memset(naimshet,'\0',sizeof(naimshet));
        if(POLE(VV.VVOD_SPISOK_return_data(N),shet,1,'|') != 0)
         strncpy(shet,VV.VVOD_SPISOK_return_data(N),sizeof(shet)-1);

        if(prsh1(shet,&shetv) != 0)
          goto naz;

        strncpy(naimshet,shetv.naim,sizeof(naimshet)-1);
        N++;
        goto naz;
       }
      else
       memset(shet,'\0',sizeof(shet));
     }
     
    if(N == 5) //Контрагент физическое лицо
     {
      if(VV.VVOD_SPISOK_return_data(N)[0] != '\0') //Контрагент
       {
        memset(naimkont,'\0',sizeof(naimkont));
        if(POLE(VV.VVOD_SPISOK_return_data(N),kontr,1,'|') != 0)
         strncpy(kontr,VV.VVOD_SPISOK_return_data(N),sizeof(kontr)-1);
        sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",kontr);
        if(sql_readkey(&bd,strsql,&row,&curr) != 1)
         {
          VVOD SOOB(1);
          sprintf(strsql,"%s %s !",gettext("Не найден код контрагента"),kontr);
          SOOB.VVOD_SPISOK_add_MD(strsql);
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto naz;
         }            
        strncpy(naimkont,row[0],sizeof(naimkont)-1); 
        goto naz;
       }
      else
        memset(kontr,'\0',sizeof(kontr));
     }
    if(N == 6) //Контрагент для реестра налоговых накладных
     {
      if(VV.VVOD_SPISOK_return_data(N)[0] != '\0') //Контрагент
       {
        memset(naimkont_r,'\0',sizeof(naimkont_r));
        if(POLE(VV.VVOD_SPISOK_return_data(N),kdrnn,1,'|') != 0)
         strncpy(kdrnn,VV.VVOD_SPISOK_return_data(N),sizeof(kdrnn)-1);
        sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",kdrnn);
        if(sql_readkey(&bd,strsql,&row,&curr) != 1)
         {
          VVOD SOOB(1);
          sprintf(strsql,"%s %s !",gettext("Не найден код контрагента"),kdrnn);
          SOOB.VVOD_SPISOK_add_MD(strsql);
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto naz;
         }            
        strncpy(naimkont_r,row[0],sizeof(naimkont_r)-1); 
        goto naz;
       }
      else
        memset(kdrnn,'\0',sizeof(kdrnn));
     }

    if(N == 8 ) //Счет НДС
     {
      if(VV.VVOD_SPISOK_return_data(N)[0] != '\0') //Счет
       { 
        memset(naim_shet_nds,'\0',sizeof(naim_shet_nds));
        if(POLE(VV.VVOD_SPISOK_return_data(N),shet_nds,1,'|') != 0)
         strncpy(shet_nds,VV.VVOD_SPISOK_return_data(N),sizeof(shet_nds)-1);

        if(prsh1(shet_nds,&shetv) != 0)
          goto naz;

        strncpy(naim_shet_nds,shetv.naim,sizeof(naim_shet_nds)-1);
        N++;
        goto naz;
       }
      else
       memset(shet_nds,'\0',sizeof(shet_nds));
     }
      
    attroff(VV.VVOD_return_cs(iceb_CFV));
    attron(VV.VVOD_return_cs(iceb_CFM));

    VV.vprintw(N,stdscr);
    N++;
   }
  if(K==SDN) /*Стрелка вниз*/
   {
    N++;
   }
  if(K==SUP) /*Стрелка вверх*/
   {
    N--;
   }

  if(K == ESC || K == FK10)
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    attron(VV.VVOD_return_cs(iceb_CFM));
    N=-1;
    break;
   }
  if(K == FK1) /*Помощь*/
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    GDITE();
    iceb_t_pdoc("ukr2_2_2.txt");
    clear();
    goto naz;
   }

  if(K == FK2 || K == PLU ) //Записываем
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    attron(VV.VVOD_return_cs(iceb_CFM));

    if(VV.VVOD_SPISOK_return_data(0)[0] == '\0' || 
     VV.VVOD_SPISOK_return_data(1)[0] == '\0' || \
     VV.VVOD_SPISOK_return_data(2)[0] == '\0' || \
     VV.VVOD_SPISOK_return_data(3)[0] == '\0')
      {     
       VVOD SOOB(1);
       SOOB.VVOD_SPISOK_add_MD(gettext("Не введены все обязательные реквизиты !"));
       soobshw(&SOOB,stdscr,-1,-1,0,1);
       goto naz;
      }

     if(prsh1(shet,&shetv) != 0)
        goto naz;

     if(shet_nds[0] != '\0')
      if(prsh1(shet_nds,&shetv) != 0)
        goto naz;

     if(kdrnn[0] != '\0')
      {
       sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",kdrnn);
       if(readkey(strsql) != 1)
        {
         VVOD SOOB(1);
         SOOB.VVOD_SPISOK_add_MD(gettext("Не найден код контрагента для реестра налоговых накладных !"));
         SOOB.VVOD_SPISOK_add_MD(kdrnn);
         soobshw(&SOOB,stdscr,-1,-1,0,1);
         goto naz;
        }
      }

     if(VV.data_ravno(9)[0] != '\0')
      {
       if(rsdat(&dvnn,&mvnn,&gvnn,VV.data_ravno(9),1) != 0)
        {
         VVOD SOOB(1);
         SOOB.VVOD_SPISOK_add_MD(gettext("Неправильно ввели дату виписки!"));
         SOOB.VVOD_SPISOK_add_MD(kdrnn);
         soobshw(&SOOB,stdscr,-1,-1,0,1);
         goto naz;
        
        }
      }

     if(metkareg == 1)
      {
       sprintf(strsql,"delete from Ukrdok1 where \
datd='%04d-%d-%d' and nomd='%s' and kodr=%s and shet='%s' and nomz=%d",
       gd,md,dd,nomdok,kodkr,shetz,nomz);
       if(sql_zap(&bd,strsql) != 0)
         msql_error(&bd,"Ошибка ввода записи !",strsql);

      }
     
     memset(ndrnn,'\0',sizeof(ndrnn));
     strncpy(ndrnn,VV.data_ravno(7),sizeof(ndrnn)-1);
     sqlfiltr(ndrnn,sizeof(ndrnn));
     strah_sbor=VV.data_ravno_atof(10);
     strah_sbor=okrug(strah_sbor,0.01);
     time_t vrem;
     time(&vrem);
     
snova:;
               
     sprintf(strsql,"insert into Ukrdok1 values \
('%04d-%d-%d','%s',%s,'%s',%.10g,%.10g,'%s',%.2f,%d,%ld,%d,'%s','%s','%s','%s','%04d-%d-%d',%.2f)",
     gd,md,dd,nomdok,kodkr,shet,kolih,
     suma_dok-snds-strah_sbor,eiz.ravno(),snds,iceb_t_getuid(),vrem,nomz,kontr,kdrnn,ndrnn,shet_nds,gvnn,mvnn,dvnn,strah_sbor);

     if(sql_zap(&bd,strsql) != 0)
      {
       if(sql_nerror(&bd) == ER_DUP_ENTRY) //Запись уже есть
        {
         nomz++;
         goto snova;
/********
         VVOD SOOB(1);
         SOOB.VVOD_SPISOK_add_MD(gettext("Такая запись уже есть !"));
         soobshw(&SOOB,stdscr,-1,-1,0,1);
         goto naz;
**********/
        }
       else
        {
         msql_error(&bd,gettext("Ошибка записи !"),strsql);
         goto naz;
        }
      }
    break;
   }

  if(K == FK3 ) //Реквизиты
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    attron(VV.VVOD_return_cs(iceb_CFM));

    VVOD MENU(3);

    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка единиц измерения"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка контрагентов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    
    int kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);
    char kod[32];
    memset(kod,'\0',sizeof(kod));
    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;


      case 0 :
        
        if(vibrek("Edizmer",kod,sizeof(kod),strsql) == 0)
         {
          VV.VVOD_SPISOK_zapis_data(3,kod);
          eiz.new_plus(kod);
          naimeiz.new_plus(strsql);
         }
        break;

      case 1 :
        
        if(vibrek("Plansh",kod,sizeof(kod),naimshet) == 0)
         {
          VV.VVOD_SPISOK_zapis_data(4,kod);
          strcpy(shet,kod);
         }
        break;

      case 2 :
        
        if(vibrek("Kontragent",kod,sizeof(kod),strsql) == 0)
         {
          VVOD DANET(1);
          DANET.VVOD_SPISOK_add_MD(gettext("Код контрагента для реестра налоговых накладных ?"));

          if(danet(&DANET,2,stdscr) == 2)
           {
//            VV.VVOD_SPISOK_zapis_data(5,kod);
            strcpy(kontr,kod);
            strncpy(naimkont,strsql,sizeof(naimkont)-1);
           }
          else
           {
//            VV.VVOD_SPISOK_zapis_data(6,kod);
            strcpy(kdrnn,kod);
            strncpy(naimkont_r,strsql,sizeof(naimkont_r)-1);
           }
          
         }
        break;
     }
    goto naz;
   }
 }
attroff(VV.VVOD_return_cs(iceb_CFS));
attron(VV.VVOD_return_cs(iceb_CB));
clear();
refresh();
return;
}
