/*$Id: xdkbanks.c,v 5.16 2011-01-13 13:43:24 sasa1 Exp $*/
/*29.12.2010	20.02.2008	Белых А.И.	xdkbanks.c
Автоматическое выполнение проводок для платёжного поручения
на основе сальдо контрагентов по счёту
*/

#include "buhg.h"
#include "dok4.h"

int xdkbanks(const char *kontr);

extern short	startgodb; /*Стартовый год*/

extern struct REC rec;

void xdkbanks(const char *tabl,short dd,short md,short gd,char *nomdok,char *kodop)
{
char strsql[1024];
int kolstr;
int kolkontr=0,kolstr1=0;
SPISOK KONT;
SQLCURSOR cur;
short dk,mk,gk;
static char shet[32];
static char kontr[112];
static char dat2[11];
static char grupk[112];
static char shet_kor[32];
static char data_prov[11];

char naim[512];
int kom=0,kom1=0;
short       gods=startgodb;

int metkadk=0;

VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Автоматическое выполнение проводок"));

VV.VVOD_SPISOK_add_MD(gettext("Счет........................"));//0
VV.VVOD_SPISOK_add_MD(gettext("Дата сальдо........(д.м.г).."));//1
VV.VVOD_SPISOK_add_MD(gettext("Код контрагента........(,,)."));//2
VV.VVOD_SPISOK_add_MD(gettext("Код группы контрагента.(,,)."));//3
VV.VVOD_SPISOK_add_MD(gettext("Счёт корреспондент..........."));//4
VV.VVOD_SPISOK_add_MD(gettext("Дата проводки......(д.м.г).."));//5

VV.VVOD_SPISOK_add_data(shet,sizeof(shet));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2)); 
VV.VVOD_SPISOK_add_data(kontr,sizeof(kontr)); 
VV.VVOD_SPISOK_add_data(grupk,sizeof(grupk)); 
VV.VVOD_SPISOK_add_data(shet_kor,sizeof(shet_kor)); 
VV.VVOD_SPISOK_add_data(data_prov,sizeof(data_prov)); 

naz:;
clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strcpy(shet,VV.VVOD_SPISOK_return_data(0));
strcpy(dat2,VV.VVOD_SPISOK_return_data(1));
strcpy(kontr,VV.VVOD_SPISOK_return_data(2));
strcpy(grupk,VV.VVOD_SPISOK_return_data(3));
strcpy(shet_kor,VV.VVOD_SPISOK_return_data(4));
strcpy(data_prov,VV.VVOD_SPISOK_return_data(5));

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("dokum2_1_2_1.txt");
   goto naz;

  case ESC:
  case FK10:
   return;

  case FK2:
  case PLU:
     break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп контрагентов"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка контрагентов"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));//3

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Gkont",grupk,sizeof(grupk),naim);
        VV.VVOD_SPISOK_zapis_data(3,grupk);
      
        goto naz;


      case 1 :
        vibrek("Plansh",shet,sizeof(shet),naim);
        VV.VVOD_SPISOK_zapis_data(0,shet);
        goto naz;

      case 2 :
        vibrek("Kontragent",kontr,sizeof(kontr),naim);
        VV.VVOD_SPISOK_zapis_data(2,kontr);
        goto naz;
     }


  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }

if(shet[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введен счет !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(rsdat(&dk,&mk,&gk,dat2,1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Неправильно ввели дату сальдо!"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
short dr=0,mr=0,gr=0;
if(rsdat(&dr,&mr,&gr,data_prov,1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Неправильно ввели дату проводки!"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
 
struct OPSHET rek_shet;
if(prsh1(shet,&rek_shet) != 0)
 goto naz;

if(rek_shet.saldo != 3)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Счёт имеет свёрнутое сальдо!"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(prsh1(shet_kor,&rek_shet) != 0)
 goto naz;

if(iceb_t_pvglkni(mr,gr) != 0)
 goto naz;
if(iceb_t_pbsh(mr,gr,shet,shet_kor,"") != 0)
 goto naz;

if(gods == 0)
 gods=gk;

MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите нужное и нажмите Enter"));

MENU.VVOD_SPISOK_add_MD(gettext("Дебет"));
MENU.VVOD_SPISOK_add_MD(gettext("Кредит"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
metkadk=0;
while(menu3w(stdscr,&MENU,&metkadk,-1,-1,0) != 0);
switch (metkadk)
 {
  case  2 :
  case -1 :
   goto naz;

 }


GDITE();

/*проверяем список банков в таблице. Если их больше одного то нужно проверять есть ли карточка 
этого банка у работкика или нет*/
sprintf(strsql,"select kod from Zarsb");
int kolbank=readkey(strsql);
int kod_banka=0;

if(kolbank > 1)
 if((kod_banka=xdkbanks(rec.kodor)) < 0)
  {
   sprintf(strsql,"Не найден код банка для кода контрагента %s в настройках zarbanks.alx!",rec.kodor);
   iceb_t_soob(strsql);
   goto naz;
  }

//Составляем список всех контрагентов
sprintf(strsql,"select ns,kodkon from Skontr where ns='%s'",shet);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной записи !"));
  return;
 }

SQL_str row;
kolkontr=0;
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(shet,row[0],0,0) != 0)
    continue;
  if(proverka(kontr,row[1],0,0) != 0)
    continue;
  if(KONT.find_r(row[1]) < 0)
   {
    kolkontr++;
    KONT.plus(row[1]);
   }
 }
GDITE();
double deb[kolkontr];
double kre[kolkontr];
memset(&deb,'\0',sizeof(deb));
memset(&kre,'\0',sizeof(kre));

//Читаем сальдо
sprintf(strsql,"select ns,kodkon,deb,kre from Saldo where kkk=1 and gs=%d and ns='%s'",gods,shet);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
int nomer=0;
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(shet,row[0],0,0) != 0)
    continue;
  if(proverka(kontr,row[1],0,0) != 0)
    continue;
//  printw("%s %s %s %s\n",row[0],row[1],row[2],row[3]);

  nomer=KONT.find_r(row[1]);
  deb[nomer]+=atof(row[2]);
  kre[nomer]+=atof(row[3]);
 }
GDITE();
//Читаем все проводки
sprintf(strsql,"select sh,kodkon,deb,kre from Prov where datp >= '%d-%d-%d' \
and datp <= '%d-%d-%d' and kodkon <> '' and sh='%s'",gods,1,1,gk,mk,dk,shet);

//printw("%s\n",strsql);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(shet,row[0],0,0) != 0)
    continue;
  if(proverka(kontr,row[1],0,0) != 0)
    continue;

  nomer=KONT.find_r(row[1]);
  deb[nomer]+=atof(row[2]);
  kre[nomer]+=atof(row[3]);
 }

GDITE();


int dlpris;
char  pris[64];
iceb_t_poldan("Приставка к табельному номеру",pris,"zarnast.alx");
dlpris=strlen(pris);

char  bankshet[32];
char  fio[512];
char tabnom[24];
char inn[32];
double sum=0.;
double debp=0.;
double krep=0.;
char kontr1[24];
char kontr2[24];
class iceb_tu_str koment("");
char podsyst[16];

int tipz=0;
if(SRAV(tabl,"Pltp",0) == 0)
 {
  sprintf(podsyst,gettext("ПЛТ"));
  tipz=2;
 }
if(SRAV(tabl,"Pltt",0) == 0)
 {
  sprintf(podsyst,gettext("ТРЕ"));
  tipz=1;
 }

for(int snom=0 ; snom < kolkontr; snom++)
 {
  memset(fio,'\0',sizeof(fio));
  memset(bankshet,'\0',sizeof(bankshet));
  memset(inn,'\0',sizeof(inn));
  memset(tabnom,'\0',sizeof(tabnom));
  
  if(pvbanks_kprov(&KONT,snom,pris,metkadk,&sum,tabnom,deb,kre,dlpris,fio,bankshet,inn,grupk,kod_banka) != 0)
   continue;

  debp=0.;
  krep=0.;
  memset(kontr1,'\0',sizeof(kontr1));
  strncpy(kontr1,KONT.ravno(snom),sizeof(kontr1)-1);
  strncpy(kontr2,KONT.ravno(snom),sizeof(kontr2)-1);

  if(metkadk == 0) /*Дебет*/
   krep=sum;
  if(metkadk == 1) /*кредит*/
   debp=sum;

  koment.new_plus(gettext("Перечислено"));
  koment.plus(" ");
  koment.plus(fio);   
  zapprov(0,gr,mr,dr,shet,shet_kor,kontr1,kontr2,podsyst,nomdok,kodop,debp,krep,koment.ravno_filtr(),2,0,time(NULL),gd,md,dd,tipz,0);

 }

}
/****************************/
/*определяем код банка для заданного кода контрагента*/
/****************************/
int xdkbanks(const char *kontr)
{
class iceb_tu_str kod_kontr("");
class SQLCURSOR cur_alx;
SQL_str row_alx;
int kolstr=0;
char strsql[512];
int kod_banka=0;
sprintf(strsql,"select str from Alx where fil='zarbanks.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(-1);
 }

if(kolstr == 0)
 {
  iceb_t_soob("Не найдены настройки zarbanks.alx");
  return(-1);
 }

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;

  if(polen(row_alx[0],&kod_kontr,3,'|') != 0)
   continue;
  if(SRAV(kod_kontr.ravno(),kontr,0) != 0)
   continue;
  int voz=0;
  if((voz=polen(row_alx[0],&kod_banka,4,'|')) == 0)
   return(kod_banka);
   
 }

return(-1);
}
