/*$Id: xrnn_poi.h,v 5.9 2011-02-21 07:31:25 sasa Exp $*/
/*17.02.2011	19.02.2007	Белых А.И.	xrnn_poi.h
Реквизиты поиска нужных записей в реестрах выданных и полученных налоговых накладных
*/


class xrnn_poi
 {
  public:
   short dn,mn,gn;
   short dk,mk,gk;
   
   char nnn[124];  //Номер налоговой накладной
   char nomdok[124]; //Номер документа первоисточника
   char inn[124];
   char naim_kontr[512];
   char koment[512];
   char kodgr[112];  // для распечатки полученных документов
   char kodgr1[124]; //для поиска выданных документов
   char podsistema[124];
   char kodop[124]; //Код операции в документе
   short dvnn,mvnn,gvnn; /*Дата выписки налоговой накладной- начало периода*/
   short dvnk,mvnk,gvnk; /*Дата выписки налоговой накладной - конец периода*/
   char proc_dot[64]; /*Процент дотации*/
   class iceb_tu_str viddok; /*Вид документа*/
   short metka_poi; //0-нет поиска 1-есть   

   short metka_sort; //0-по номерам налоговых накладных 1 по номерам записей (только для выданых накладных)

   char nom_p_zp[16]; //Номер первой записи для полученных документов (для распечатки)
   char nom_p_zm[16]; //Номер первой записи для выданных документов (для распечатки)
   char pr_ras[2];

   double suma[2];
  xrnn_poi()
   {
    clear_data();    
   }

 void clear_data()
  {
   viddok.new_plus("");
   memset(podsistema,'\0',sizeof(podsistema));   
   memset(kodgr,'\0',sizeof(kodgr));  
   memset(kodgr1,'\0',sizeof(kodgr1));  
   memset(nomdok,'\0',sizeof(nomdok));  
   metka_poi=0;
   dn=mn=gn=dk=mk=gk=0;
   dvnn=mvnn=gvnn=0;
   dvnk=mvnk=gvnk=0;
   memset(nnn,'\0',sizeof(nnn));
   memset(inn,'\0',sizeof(inn));
   memset(naim_kontr,'\0',sizeof(naim_kontr));
   memset(koment,'\0',sizeof(koment));
   memset(nom_p_zp,'\0',sizeof(nom_p_zp));
   memset(nom_p_zm,'\0',sizeof(nom_p_zm));
   memset(pr_ras,'\0',sizeof(pr_ras));
   memset(kodop,'\0',sizeof(kodop));
   memset(proc_dot,'\0',sizeof(proc_dot));
   metka_sort=0;  
  }
 };
