/*$Id: xupl.c,v 5.130 2011-01-13 13:43:24 sasa1 Exp $*/
/*11.10.2010	21.03.2003	Балых А.И.	xupl.c
Подсистема "Учет путевых листов"
*/
#define DVERSIQ "11.10.2010"
#include        "buhg.h"

void		vnsi(void);
int		uplnast(void);
void		dirupls(void);
void		rabdok(void);
void		diruplds(short,short,short);
void		poiupldok(void);
int uplrpl(int,class spis_oth*);
void		rasoth(void);
int uplvst(class spis_oth*);
int uplvst_kg(class spis_oth*);
void            dirscmt(void);
int upl_obvm(class spis_oth*);
void upl_plc(void);
void saldo_upl();
void saldo_upl();

extern char     *organ;/*Наименование организации*/
extern int	iscolor;
extern char	*imabaz;
extern char	*host;
extern char	*parol_pol;
SQL_baza	bd;
extern char	*nameprinter;
extern short    startgod;
extern int iceb_kod_podsystem;

int             main(int argc,char **argv,char **envp)
{
iceb_kod_podsystem=ICEB_PS_UPL;
int             kom=0;
char            bros1[512];

icebstart(argc,argv);

VVOD MENU(4);

/*Ищем настройку*/

if(nastsys() != 0)
  exit_iceb(1);
if(uplnast() != 0)
  exit_iceb(1);

iceb_t_perzap(1); /*Проверка на первичный запуск в текущем дне и удаление *.lst */
int uid=0;
class iceb_tu_str fioop;

uid=iceb_t_getuid();
fioop.plus(iceb_t_getfioop());

for(;;)
 {

  clear(); /*Очистить экран и закрасить фоновым цветом*/
  MENU.VVOD_delete();

  MENU.VVOD_SPISOK_add_ZAG(gettext("Учет путевых листов"));
  if(organ != NULL)
   {
    sprintf(bros1,"%.*s",iceb_tu_kolbait(40,organ),organ);
    MENU.VVOD_SPISOK_add_ZAG(bros1);
   }

  MENU.VVOD_SPISOK_add_MD(gettext("Работа с документами"));//0
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод нормативно-справочной информации"));//1
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать отчеты"));//2
  MENU.VVOD_SPISOK_add_MD(gettext("Работа с файлами распечаток"));//3
  MENU.VVOD_SPISOK_add_MD(gettext("Сменить базу"));//4
  MENU.VVOD_SPISOK_add_MD(gettext("Сменить принтер"));//5
  MENU.VVOD_SPISOK_add_MD(gettext("Конец работы"));//6

  znak(0,COLS-26);
  infosys(12,COLS-27,host,VERSION,DVERSIQ,0,0,0,imabaz,nameprinter,uid,fioop.ravno());


  if(menu3(&MENU,&kom,1,0,0) != 0)
   continue;

  switch (kom)
   {

    case 6:
    case -1 :
      goto kon;
      break;

    case 0:
      rabdok();
      break;


    case 1:
      vnsi();
      break;

    case 2:
      rasoth();
      break;

    case 3:

      strcpy(bros1,"lst");
      dirlst(bros1);
      break;

    case 4:
      if(smenabaz(1) == 0)
       {
        if(nastsys() != 0)
         goto kon;
        if(uplnast() != 0)
         goto kon;
       }
      break;

    case 5:
       mprintcap();
       break;
      
    default:
       kom=0;
       break;   
   }
 }

kon:;

sql_closebaz(&bd);

VVOD SOOBN(1);
SOOBN.VVOD_SPISOK_add_MD(gettext("База закрыта. Программа закончила работу"));
soobsh(&SOOBN,-1,-1,1);

refresh();
endwin();
}

/*******************************************************/
/*Ввод и корриктировка нормативно-справочной информации*/
/*******************************************************/

void	vnsi()
{
int		kom=0;
class iceb_tu_str kodn("");
class iceb_tu_str naimn("");
int		poz,komv;
char		poi[32];

VVOD VVOD1(2);

VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Учет путевых листов"));
MENU.VVOD_SPISOK_add_ZAG(gettext("Ввод и корректировка нормативно-справочной информации"));

MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем подразделений"));          //0
MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем марок топлива"));         //1
MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем объектов учета топлива"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем автомобилей"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Работа со стартовыми сальдо"));//4
MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем групп объектов списания топлива"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем объектов списания топлива"));//6
MENU.VVOD_SPISOK_add_MD(gettext("Работа с файлом настройки"));//7
MENU.VVOD_SPISOK_add_MD(gettext("Работа со справочником средних цен на топливо"));//8 
MENU.VVOD_SPISOK_add_MD(gettext("Перенос стартовых остатков топлива"));//9
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//10

for(;;)
 {
  clear();

  while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

  switch (kom)
   {
    case 10:
    case -1:
      return;
      break;

    case 0:
      clear();
      naimn.new_plus("");
      poz=komv=0;
      poi[0]='\0';
      dirmat1("Uplpodr",&kodn,&naimn,LINES-5,0,2,0,&poz,&komv,poi,"\0");
      break;

    case 1:
      kodn.new_plus("");
      dirmt(&kodn,0);
      break;

    case 2:
      clear();
      naimn.new_plus("");
      dirout(&kodn,&naimn,0,0);
      break;
      
    case 3:
      clear();
      naimn.new_plus("");
      diravt(&kodn,&naimn,0);
      break;
      
    case 4:
      dirupls();
      break;

    case 5:
      clear();
      naimn.new_plus("");
      poz=komv=0;
      poi[0]='\0';
      dirmat1("Uplgost",&kodn,&naimn,LINES-5,0,2,0,&poz,&komv,poi,"\0");
      break;

    case 6:
      clear();
      naimn.new_plus("");
      dirost(&kodn,&naimn,0);
      break;
      
      
    case 7 :
      iceb_redfil("uplnast.alx",0);
      break;

    case 8 :
      dirscmt();
      break;

    case 9 :
      saldo_upl();
      break;

    default:
      kom=0;
      break;
   }
 }
}
/**********************************/
/*Работа с документами            */
/**********************************/

void   rabdok()
{
char	bros[512];
int     kom=0;
short dd=0,md=0,gd=0;
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);

class iceb_tu_str nomd("");
class iceb_tu_str podr("");

VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Работа с документами"));

MENU.VVOD_SPISOK_add_MD(gettext("Ввод нового путевого листа"));       //0
MENU.VVOD_SPISOK_add_MD(gettext("Поиск введеного документа"));          //1
MENU.VVOD_SPISOK_add_MD(gettext("Просмотр всех введеных документов"));  //2
sprintf(bros,"%s %d.%d.%d%s",gettext("Просмотр документов начиная с"),   //3
dt,mt,gt,gettext("г."));
MENU.VVOD_SPISOK_add_MD(bros);
MENU.VVOD_SPISOK_add_MD(gettext("Установить/снять блокировку дат"));    //4
MENU.VVOD_SPISOK_add_MD(gettext("Проверка логической целосности базы данных"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));                               //6

for(;;)
 {
  clear();

  while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

  switch (kom)
   {
    case 6:
    case -1:
      return;
      break;

    case 0:
      dd=md=gd=0;
      nomd.new_plus("");
      podr.new_plus("");
      if(vdupl(&dd,&md,&gd,&nomd,&podr) == 0)
        dirupld(dd,md,gd,&nomd,&podr);
      break;

    case 1:
      poiupldok();
      break;

    case 2 :
      diruplds(0,0,0);
      break;

    case 3 :
      diruplds(dt,mt,gt);
      break;

    case 4 :
      iceb_tl_blok();
      break;

    case 5:
      upl_plc();
      return;

    default:
      kom=0;
      break;
   }
 }
}
/*****************************/
/*распечатка отчетов         */
/*****************************/

void        rasoth()
{
int		kom=0;

VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(organ,40);

MENU.VVOD_SPISOK_add_MD(gettext("Распечатать реестр путевых листов по водителям"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать реестр путевых листов по автомобилям"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать оборотную ведомость движения топлива по автомобилям"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать ведомость списания топлива по водителям и счетам"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать ведомость списания топлива по счетам в киллограммах"));//4
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать оборотную ведомость движения топлива"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//6

for(;;)
 {
  clear();

  while(menu3w(stdscr,&MENU,&kom,-1,-1,1) != 0);
  class spis_oth oth;

  switch (kom)
   {
    case 6 :
    case -1 :
      return;

    case 0 :
      if(uplrpl(0,&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;
    case 1 :
      if(uplrpl(2,&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 2 :
      if(uplrpl(1,&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 3 :
      if(uplvst(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 4 :
      if(uplvst_kg(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 5 :
      if(upl_obvm(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

      
    default:
      break;
   }
 }
}
