/* $Id: xzp.c,v 5.644 2011-08-29 07:09:00 sasa Exp $ */
/*06.05.2011    09.11.1992      Белых А.И.      xzp.c
Программа расчета зарплаты
*/
#define DVERSIQ "16.08.2011"
#include        <time.h>
#include        "buhg.h"

#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif

void            konrz(void);
void            clearzar(void);
void            dirzarsl(void);
int  rasved(short,class spis_oth*);
int  zarspi(class spis_oth *);
void            zarsend(void);
int  rspis(class spis_oth*);
int  spiin(class spis_oth*);
int  spininu(class spis_oth*);
int  rastab(class spis_oth*);
int  svodnu(class spis_oth*);
int  zarppn(class spis_oth*);
int  sprsov1(class spis_oth*);
int  rasdolgi(class spis_oth*);
int  rasdolgi1(class spis_oth*);
int  reestal(class spis_oth*);
int  vedprz1(class spis_oth*);
int  zarstomn(class spis_oth*);
void            raspp(void);
void		rabkar(void);
int		zarnast(void);
int zarnast(void);
int		zarnastp(void);
int otrshd(class spis_oth*);
void		kategor(int);
void		form8dr(void);
void            dirsdf8dr(void);
void            dirtabelo(short,short);
int raszpodr(class spis_oth*);
int zarrasp(class spis_oth*);
int socstrm(class spis_oth*);
int sprpen1(class spis_oth*);
int zarspek(class spis_oth*);
void            zarspek1(void);
void            tabel(void);
void		raszall(int);
void		viknu(void);
int rasnash(class spis_oth*);
int raspol(class spis_oth*);
void		zarkart(int);
int zarsprsoc(class spis_oth*);
int zarsocd(class spis_oth*);
void		impzkart(void);
void		sprtab(int);
int nahpodr(class spis_oth*);
void            imp_ks(void);
int  snu(class spis_oth*);
int  zar_sdpf(class spis_oth*);
void xzp_fn(void);
int  dolizs(class spis_oth*);
void dirzardk(void);
int  zarszk(class spis_oth*);
void zar_rp(void);
int  zar_srn(class spis_oth*);
int  zartarokl(class spis_oth*);
int  zartarrozrs(class spis_oth*);
void poizardok();
void xzp_dok();
int zartarrozrs(class spis_oth *oth);
int zarkdpen(class spis_oth *oth);
int zarpensm(class spis_oth *oth);
int zarpensm1(class spis_oth *oth);
void zarsbka();
void saldozr();
void dirzarsoc();
int zarbesv(class spis_oth *oth);
int zaresvo(class spis_oth *oth);
int zarpd(class spis_oth *oth);
int zarkvrt(class spis_oth *oth);
int zarboln(class spis_oth *oth);

short           ddd,mmm,ggg; /*Месяц год*/
extern char    	*organ;/*Наименование организации*/
float           dnei; /*Количество рабочих дней в текущем месяце*/
float           hasov; /*Количество рабочих часов в текущем месяце*/
extern char	*imabaz;
extern char	*host;
extern char	*parol_pol;
SQL_baza	bd;
extern char	*nameprinter;
extern int iceb_kod_podsystem;

int main(int argc,char **argv,char **envp)
{
class iceb_tu_str bros("");
struct  tm      *bf;
time_t          tmm;
char            bros1[512];
int             kom,kom1;
unsigned int    i;
int uid=0;
class iceb_tu_str fioop;

iceb_kod_podsystem=ICEB_PS_ZP;

icebstart(argc,argv);


VVOD MENU(4);
VVOD VVOD1(2);
/*Ищем настройку*/
if(nastsys() != 0)
 goto kon;
if(zarnast() != 0)
 goto kon;

iceb_t_perzap(1); /*Проверка на первичный запуск в текущем дне и удаление *.lst */

time(&tmm);
bf=localtime(&tmm);

ddd=bf->tm_mday;
if(bf->tm_mday > 14)
   mmm=bf->tm_mon+1;
else
   mmm=bf->tm_mon+1-1;
ggg=bf->tm_year+1900;
if(mmm == 0)
 {
  mmm=12;
  ggg-=1;
 }

sprintf(bros1,"%d.%d%s",mmm,ggg,gettext("г."));
bros.new_plus(bros1);
i=0;

VVOD1.VVOD_SPISOK_add_MD(gettext("Исправте дату если нужно и нажмите \"Enter\" для продолжения"));

naz1:;

clear();

vvod1(&bros,11,&VVOD1,NULL,stdscr,-1,-1);

if(rsdat1(&mmm,&ggg,bros.ravno()) != 0)
 {
  i++;
  if(i == 2)
   goto kon;
   
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));  
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz1;
 }

uid=iceb_t_getuid();
fioop.plus(iceb_t_getfioop());

kom = 0;

for(;;)
 {

  clear(); /*Очистить экран и закрасить фоновым цветом*/

  MENU.VVOD_delete();

  MENU.VVOD_SPISOK_add_ZAG(gettext("Программа расчета заработной платы"));
  if(organ != NULL)
    MENU.VVOD_SPISOK_add_ZAG(organ,40);

  MENU.VVOD_SPISOK_add_MD(gettext("Работа с карточками"));//0
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод нормативно-справочной информации"));//1
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать отчеты"));//2
  MENU.VVOD_SPISOK_add_MD(gettext("Работа с файлами распечаток"));//3
  MENU.VVOD_SPISOK_add_MD(gettext("Сменить текущую дату"));//4
  MENU.VVOD_SPISOK_add_MD(gettext("Удалить ненужные данные по зарплате"));//5
  MENU.VVOD_SPISOK_add_MD(gettext("Сменить базу"));//6
  MENU.VVOD_SPISOK_add_MD(gettext("Сменить имя принтера"));//7
  MENU.VVOD_SPISOK_add_MD(gettext("Конец работы"));//8

  znak(0,COLS-26);
  infosys(12,COLS-27,host,VERSION,DVERSIQ,0,mmm,ggg,imabaz,nameprinter,uid,fioop.ravno());

  if(menu3(&MENU,&kom,1,0,0) != 0)
   continue;

  switch (kom)
   {
    case 8 :
    case -1 :
	   goto kon;
	   break;

    case 0 :
      rabkar();
      break;

    case 1 :
      vnsi(-1);
      break;
    case 2 :
      raspp();
      break;

    case 3:

      bros.new_plus("lst");
      dirlst(bros.ravno());
      break;

    case 4:

naz:;
      helstr(LINES-1,0," F10 ",gettext("выход"),NULL);
      
      bros.new_plus("");
      VVOD1.VVOD_delete();
      VVOD1.VVOD_SPISOK_add_MD(gettext("Введите новую дату (м.[г])"));
      if((kom1=vvod1(&bros,11,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
        break;
      if(kom1 == ESC)
        break;


      if(POLE(bros.ravno(),bros1,1,'.') == 0)
       {
        if(rsdat1(&mmm,&ggg,bros.ravno()) != 0)
         {
          VVOD SOOB(1);
          SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));  
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto naz;
         }
       }
      else
       {
        mmm=bros.ravno_atoi();
        if(mmm < 1 || mmm > 12)
         {
          VVOD SOOB(1);
          SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введен месяц !"));  
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto naz;
         }
       }
      break;

    case 5:
      clearzar();
      break;


    case 6:
      if(smenabaz(1) == 0)
       {

        if(nastsys() != 0)
         goto kon;

        if(zarnast() != 0)
         goto kon;
       

       }


      break;

    case 7:
      mprintcap();
      break;

    default:
      kom=0;
      break;
   }
 }

kon:;

sql_closebaz(&bd);

VVOD SOOBN(1);
SOOBN.VVOD_SPISOK_add_MD(gettext("База закрыта. Программа закончила работу"));
soobsh(&SOOBN,-1,-1,1);

refresh();
endwin();
return(0);
}


/*********************************************/
/*Меню ввода нормативно-справочной информации*/
/*********************************************/

void            vnsi(int rr)
{
int             kom=0;
int		poz,komv;
char		poi[32];
class iceb_tu_str kodn("");
class iceb_tu_str naim("");
VVOD MENU(3);

kom=0;
if(rr == -1)
 {
  MENU.VVOD_SPISOK_add_MD(gettext("Настройка программы"));
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод данных для автоматизированного расчета"));
  MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
  rr=0;
  while(menu3w(stdscr,&MENU,&rr,-1,-1,0) != 0); 

  if(rr == -1 || rr == 2 || rr == KEY_RESIZE)
   return;
  
 }

kom=0;
for(;;)
 {
  if(rr == 0)
   {
    clear();
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_ZAG(organ,40);
    MENU.VVOD_SPISOK_add_ZAG(gettext("Настройка программы"));

    MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем групп подразделений"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем подразделений"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем категорий"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем начислений"));//3
    MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем удержаний"));//4
    MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем званий"));//5
    MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем видов табелей"));//6
    MENU.VVOD_SPISOK_add_MD(gettext("Работа с настройками для автоматизированнного расчёта"));//7
    MENU.VVOD_SPISOK_add_MD(gettext("Работа со стартовыми сальдо"));//8
    MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем городов налоговых инспекций"));//9
    MENU.VVOD_SPISOK_add_MD(gettext("Работа с перечнем соц. отчислений"));//10
    MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка контрагентов"));//11
    MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка банков"));//12
    MENU.VVOD_SPISOK_add_MD(gettext("Перенос сальдо по работникам"));//13
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//14

    while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

    class iceb_tu_str kodd("");
    class iceb_tu_str naim("");

    switch (kom)
     {
      case 14:
      case -1:
	   return;
	   break;

      case 0 :  //Ввод групп подразделений
        clear();
       kodn.new_plus("");
       naim.new_plus("");
        poz=komv=0;
        poi[0]='\0';
        dirmat1("Zargrupp",&kodn,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
        break;

      case 1 :
        /*Ввод подразделений*/
        clear();
       kodn.new_plus("");
       naim.new_plus("");
        poz=komv=0;
        poi[0]='\0';
        dirmat1("Podr",&kodn,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
        break;

      case 2 :
	   /*Ввод категорий*/
        clear();
       kodn.new_plus("");
       naim.new_plus("");
        poz=komv=0;
        poi[0]='\0';
        dirmat1("Kateg",&kodn,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
        break;

      case 3 :
       /*Ввод начислений*/
        clear();
       kodn.new_plus("");
       naim.new_plus("");
        poz=komv=0;
        poi[0]='\0';
        dirmat1("Nash",&kodn,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
        break;
      case 4 :

        /*Ввод удержаний*/
        diruder(0,&kodd,&naim);
        break;
      case 5 :
        /*Ввод званий*/
        clear();
       kodn.new_plus("");
       naim.new_plus("");
        poz=komv=0;
        poi[0]='\0';
        dirmat1("Zvan",&kodn,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
        break;

      case 6 :
        /*Ввод видов табеля*/
        clear();
       kodn.new_plus("");
       naim.new_plus("");
        poz=komv=0;
        poi[0]='\0';
        dirmat1("Tabel",&kodn,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
        break;

      case 7 :
        xzp_fn();
	 break;


      case 8 :
	   dirzarsl();
	   break;



      case 9 :
	   /*Ввод городов налоговых инспекций*/
        clear();
       kodn.new_plus("");
       naim.new_plus("");
        poz=komv=0;
        poi[0]='\0';
        dirmat1("Gnali",&kodn,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
        break;

      case 10:
	   /*Ввод соц. перечислений*/
        dirzarsoc();
        break;
        
      case 11 :
       clear();
       kodn.new_plus("");
       naim.new_plus("");
       dirkontr(&kodn,&naim,0);

       break;

      case 12 :
       clear();

       dirsb(0,&kodd,&naim);

       break;

      case 13 :
       saldozr();
       break;

      default:
        kom=0;
        break;
     }
  }

 if(rr == 1)
  {
   char flag_edit[50];
   memset(flag_edit,'\0',sizeof(flag_edit));
   class icebt_sql_flag flagedit;

    clear();
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_ZAG(organ,40);
    MENU.VVOD_SPISOK_add_ZAG(gettext("Ввод и корректировка данных для автоматизованого расчета"));

    MENU.VVOD_SPISOK_add_MD(gettext("Ввести данные для удержания кредита"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Ввести данные для удержания алиментов"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Ввести перечень должностных окладов"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Ввести данные для автоматизированного расчета начислений"));//3
    MENU.VVOD_SPISOK_add_MD(gettext("Ввести данные для начисления за званние"));//4
    MENU.VVOD_SPISOK_add_MD(gettext("Ввести список инвалидов"));//5
    MENU.VVOD_SPISOK_add_MD(gettext("Ввести список работников работающих по договорам"));//6
    MENU.VVOD_SPISOK_add_MD(gettext("Ввести процент выполнения плана по подразделениям"));//7
    MENU.VVOD_SPISOK_add_MD(gettext("Ввести данные для расчета индексации начислений"));//8
    MENU.VVOD_SPISOK_add_MD(gettext("Ввести данные для расчета индексации на невовремя выплаченную зарплату"));//9
    MENU.VVOD_SPISOK_add_MD(gettext("Ввести перечень пенсионеров"));//10
    MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка льгот для расчета подоходного налога"));//11
    MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка персональных процентов отчисления до пенс.фонда"));//12
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//13

    while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

    switch (kom)
     {
      case 13 :
      case -1 :
	   return;

      case 0 :
         iceb_redfil("zarkredit.alx",0);
	 break;

      case 1 :
         iceb_redfil("zaralim.alx",0);
	 break;
      case 2 :
         sprintf(flag_edit,"%szaroklad_edit",imabaz); /* если два подчёркивания флаг не выставляется*/
         if(flagedit.flag_on(flag_edit) != 0)
          {
           char bros[512];
           VVOD SOOB(1);
           SOOB.VVOD_SPISOK_add_MD(gettext("С файлом уже работает другой оператор !"));
           sprintf(bros,"%s","zardolhn.alx");
           SOOB.VVOD_SPISOK_add_MD(bros);
           soobshw(&SOOB,stdscr,-1,-1,0,1);
           break;
          }
         
         iceb_redfil("zardolhn.alx",0);
         flagedit.flag_off();
	 break;

      case 3 :
         sprintf(flag_edit,"%szarnrn_edit",imabaz);
         if(flagedit.flag_on(flag_edit) != 0)
          {
           char bros[512];
           VVOD SOOB(1);
           SOOB.VVOD_SPISOK_add_MD(gettext("С файлом уже работает другой оператор !"));
           sprintf(bros,"%s","zarproc.alx");
           SOOB.VVOD_SPISOK_add_MD(bros);
           soobshw(&SOOB,stdscr,-1,-1,0,1);
           break;
          }
         iceb_redfil("zarproc.alx",0);
         flagedit.flag_off();
	 break;



      case 4 :
         iceb_redfil("zarzvanie.alx",0);
	 break;

      case 5 :
         iceb_redfil("zarinv.alx",0);
	 break;

      case 6 :
         iceb_redfil("zardog.alx",0);
	 break;

      case 7 :
         iceb_redfil("zarpodpr.alx",0);
	 break;

      case 8 :
         iceb_redfil("zarindex.alx",0);
	 break;

      case 9 :
         iceb_redfil("zarindexv.alx",0);
	 break;

      case 10 :
         iceb_redfil("zarpens.alx",0);
	 break;

      case 11 :
         iceb_redfil("zarlgot.alx",0);
 	 break;

      case 12:
        iceb_redfil("zarsppo.alx",0);
        break;
        
      default:
        kom=0;
        break;
    }
   }
 }
}
/*****************************************/
void xzp_pens()
{
int kom=0;
VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Распечатать справки для Пенсионного фонда Украины"));

MENU.VVOD_SPISOK_add_MD(gettext("Расчет единого социального взноса"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Расчет суммы ЕСВ на выплаченную зарплату"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Расчет месячного отчётa для пенсионного персонифицированного учёта"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Расчет годового отчётa для пенсионного персонифицированного учёта"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//4

for(;;)
 {
  clear();

  if(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0)
   continue;
  class spis_oth oth;   
  switch (kom)
   {
    case 4:
    case -1 :
      return;


    case 0 :
      if(zarpensm1(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 1 :
      if(zaresvo(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 2 :
      if(zarpensm(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 3 :
      if(sprpen1(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;
   }
 }
}
/***************************/
/*Отчёты в соц фонды*/
/****************************/
void xzp_socf()
{
int kom1=0;
VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Распечатать своды отчислений в гос. фонды"));

MENU.VVOD_SPISOK_add_MD(gettext("Распечатать отчёты в налоговую инспекцию"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать спектр распределения зарплаты"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать справки для Пенсионного фонда Украины"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод отчислений в социальные фонды"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать расчет отчислений на выданную зарплату"));//4
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать справки имеющих льготы на соц. отчисления"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать базы налогообложения для соц. отчислений"));//6
MENU.VVOD_SPISOK_add_MD(gettext("Расчет статистической формы 1-ПВ"));//7
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать отчёт по пенсионерам и инвалидам"));//8
MENU.VVOD_SPISOK_add_MD(gettext("Расчёт календарных дней для пенсионного стажа"));//9
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать базы налогообложения для единого соц. взноса"));//10
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать справку по больничным"));//11
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//12

for(;;)
 {
  clear();

  while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);
  class spis_oth oth;
      
  switch (kom1)
   {
    case 12:
    case -1:
      return;

    case 0:
      form8dr();
      break;

    case 1:
      if(zarspek(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 2:
      xzp_pens();
      break;

    case 3:
      if(socstrm(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 4:
      if(zarrasp(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;          

    case 5:
      if(zarsprsoc(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 6:
      if(zarsocd(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 7:
      zarspek1();
      break;

    case 8:
      if(zar_sdpf(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 9:
      if(zarkdpen(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 10:
      if(zarbesv(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 11:
      if(zarboln(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;
   }
 }

}






/****************************/
/*Меню для выбора распечатки*/
/****************************/
void            raspp()
{
int             kom,kom1,kom2;

VVOD MENU(3);

kom=0;
for(;;)
 {
  clear();
  MENU.VVOD_delete();
  MENU.VVOD_SPISOK_add_ZAG(organ,40);
  MENU.VVOD_SPISOK_add_ZAG(gettext("Распечатка отчетов"));

  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать ведомость заработной платы"));//0
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод по категориям"));//1
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать отчеты по работникам"));//2
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать реестр почтовых переводов алиментов"));//3
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать отчеты по балансовым счетам"));//4
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать заготовку для заполнения табеля"));//5
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать своды отчислений в гос. фонды"));//6
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать отчеты по подразделениям"));//7
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список годов за которые введена информация"));//8
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод начислений и удeржаний"));//9
  MENU.VVOD_SPISOK_add_MD(gettext("Расчет частей зарплатных счетов"));//10
  MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//11

  while(menu3(&MENU,&kom,1,1,0) != 0);
  
  class spis_oth oth;
  
  switch (kom)
   {
    case 11 :
    case -1 :
      return;


    case 0 :

      MENU.VVOD_delete();

      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать по подразделению в порядке возростания табельных номеров"));
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать по подразделению в алфавитном порядке"));
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать по произвольному списку"));
      MENU.VVOD_SPISOK_add_MD(gettext("Автоматическая розноска выплаченной зарплаты"));
      MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
      kom1=0;
      while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);
      
      switch (kom1)
       {
	case 4 :
	case -1 :
	  break;

	case 0 :
	   if(rasved(0,&oth) == 0)
	    iceb_t_rabfil(&oth,"");
	   break;

	case 1 :
	   if(rasved(1,&oth) == 0)
	    iceb_t_rabfil(&oth,"");
	   break;

	case 2 :
	   if(zarspi(&oth) == 0)
	    iceb_t_rabfil(&oth,"");
	   
	   break;
	case 3 :
	   zarsend();
	   break;
        default:
          break;
       }
      break;

    case 1 :
      MENU.VVOD_delete();

      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод начислений и удержаний по категориям"));
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод начислений/счет и удержаний/счет по категориям"));
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод отработанного времени по категориям"));
      MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
      kom1=0;
      while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);
             
      switch (kom1)
       {
	case 3 :
	case -1 :
	  break;

	case 0 :
          kategor(0);
          break;

	case 1 :
          kategor(1);
          break;

	case 2 :
          if(otrshd(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          break;

        default:
          break;        
       }
      break;

    case 2 :
      kom1=0;
nazc2:;
      clear();
      MENU.VVOD_delete();
      MENU.VVOD_SPISOK_add_ZAG(organ,40);

      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список работников"));//0
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать справки о зарплате"));//1
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список работников, которые имеют начисления или удержания"));//2
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список работников, которые не имеют начисления или удержания"));//3
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод отработанного времени по работникам"));//4
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод начислений и удержаний по работникам"));//5
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать перерасчет подоходного налога"));//6
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать справку по совместителям"));//7
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать долги предприятия перед работниками"));//8
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать долги работников за месяц"));//9
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод начислений по работникам"));//10
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать распределение зарплаты мужчины/женщины"));//11
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать карточки начислений/удержаний по работникам"));//12
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список работников, которым начислена благотворительная помощь"));//13
      MENU.VVOD_SPISOK_add_MD(gettext("Расчёт общей суммы доходов"));//14
      MENU.VVOD_SPISOK_add_MD(gettext("Расчёт премии"));//15
      MENU.VVOD_SPISOK_add_MD(gettext("Перерасчёт налогов"));//16
      MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//17

      while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);
      oth.clear();
      switch (kom1)
       {
	case 17:
	case -1:
	  break;

	case 0 :
          if(rspis(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto nazc2;

	case 1 :
          kom2=0;
          for(;;)
           {
            clear();
            MENU.VVOD_delete();

            MENU.VVOD_SPISOK_add_ZAG(organ,40);

            MENU.VVOD_SPISOK_add_MD(gettext("Распечатать справку о доходах"));//0
            MENU.VVOD_SPISOK_add_MD(gettext("Распечатать расчет средней зарплаты для начисления больничного"));//1
            MENU.VVOD_SPISOK_add_MD(gettext("Распечатать расчет средней зарплаты для социальной помощи"));//2
            MENU.VVOD_SPISOK_add_MD(gettext("Распечатать справку о доходах в счет месяцев начисления"));//3
            MENU.VVOD_SPISOK_add_MD(gettext("Распечатать расчет отпускных"));//4
            MENU.VVOD_SPISOK_add_MD(gettext("Расчёт окладов на базе тарифной сетки для бюджетных организаций"));//5
            MENU.VVOD_SPISOK_add_MD(gettext("Расчёт тарифов на базе тарифной сетки"));//6
            MENU.VVOD_SPISOK_add_MD(gettext("Распечатать расчет больничного по беременности и родам"));//7
            MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//8

            while(menu3w(stdscr,&MENU,&kom2,-1,-1,0) != 0);
            
            oth.clear();
            switch(kom2)
             {
              case 8:
              case -1 :
                goto nazc2;
              case 0:
                sprtab(1);
                break;
              case 1:
                sprtab(2);
                break;
              case 2:
                sprtab(3);
                break;
              case 3:
                sprtab(4);
                break;
            
              case 4:
                sprtab(6);
                break;
              case 5:
                if(zartarokl(&oth) == 0)
                  iceb_t_rabfil(&oth,"");
                break;
              case 6:
                if(zartarrozrs(&oth) == 0)
                  iceb_t_rabfil(&oth,"");
                break;

              case 7:
                sprtab(5);
                break;
             }
           }
          break;
          
        case 2 :
          if(spiin(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto nazc2;

        case 3 :
          if(spininu(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto nazc2;

        case 4:
          if(rastab(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto nazc2;

        case 5:
          if(svodnu(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto nazc2;

        case 6:
          if(zarppn(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          zarnast(); //Перечитываем настройки потому, что они менялись в предыдыдущей подпрограмме
          goto nazc2;

        case 7:
          if(sprsov1(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto nazc2;

	case 8 :
          if(rasdolgi(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto nazc2;

	case 9 :
          if(rasdolgi1(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto nazc2;

	case 10 :
          if(rasnash(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto nazc2;

	case 11 :
          if(raspol(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto nazc2;

	case 12 :
          zarkart(0);
          goto nazc2;

	case 13 :
          zarkart(1);
          goto nazc2;

	case 14 :
          if(zarszk(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto nazc2;

	case 15 :
          zar_rp();
          goto nazc2;

	case 16 :
          if(zar_srn(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto nazc2;

        default:
          goto nazc2;
          
       }
      break;
      
    case 3 :
       if(reestal(&oth) == 0)
        iceb_t_rabfil(&oth,"");
       break;
       
    case 4 :
      MENU.VVOD_delete();

      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать ведомость производственных затрат"));//0
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать доли бюджетных счетов"));//1
      MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//2
      kom1=0;
      while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);
      
      switch (kom1)
       {
	case 2 :
	case -1 :
          break;
	case 0 :
          if(vedprz1(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          break;

        case 1:
          if(zarstomn(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          break;
        default:
          break;          
       }
      break;


    case 5:
      tabel();
      break;

    case 6:
      xzp_socf();
      break;

    case 7:

      MENU.VVOD_delete();

      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод начислений и удержаний по подразделениям (форма 1)"));
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод начислений и удержаний по подразделениям (форма 2)"));
      MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
      kom1=0;
      while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);
      
      switch (kom1)
       {
	case 2 :
	case -1 :
          break;
	case 0 :
          if(nahpodr(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          break;
          
	case 1 :
          if(raszpodr(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          break;
       }
      break;

    case 8:
      poigod(3);
      break;

    case 9:
      if(snu(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;
     
    case 10:
      if(dolizs(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;
     
    default:
      kom=0;
      break;
   }
 }
}
/************************/
/* Режимы работы с карточками */
/*******************************/
void		rabkar()
{
int             kom,kom1;
int		tabn;
class iceb_tu_str fio("");
int		pod;
char		bros[512];
char		kod[32];
char		naim[512];
class iceb_tu_str vstr("");
VVOD MENU(3);
VVOD VVOD1(2);

kom=0;

naz:;
clear();

MENU.VVOD_delete();

MENU.VVOD_SPISOK_add_ZAG(organ,40);

sprintf(bros,"%s %s %d.%d%s",gettext("Работа с карточками работников"),
gettext("Текущая дата"),
mmm,ggg,gettext("г."));

MENU.VVOD_SPISOK_add_ZAG(bros);

MENU.VVOD_SPISOK_add_MD(gettext("Поиск по табельному номеру"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Просмотр работников отдельного подразделения"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Просмотр всех работников"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Ввод нового работника"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Ввод отработанного времени"));//4
MENU.VVOD_SPISOK_add_MD(gettext("Автоматизированный расчет зарплат по всем карточкам"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка начисления или удержания"));//6
MENU.VVOD_SPISOK_add_MD(gettext("Контроль расчета зарплаты"));//7
MENU.VVOD_SPISOK_add_MD(gettext("Установить/снять блокировку дат"));//8
MENU.VVOD_SPISOK_add_MD(gettext("Импорт карточек из файла"));//9
MENU.VVOD_SPISOK_add_MD(gettext("Импорт карт-счетов из файла"));//10
MENU.VVOD_SPISOK_add_MD(gettext("Работа с документами"));//11
MENU.VVOD_SPISOK_add_MD(gettext("Автоматическая розноска выплаченной зарплаты"));//12
MENU.VVOD_SPISOK_add_MD(gettext("Автоматическая смена банка в карточках"));//13
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//14

while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

switch (kom)
 {
  case 14 :
  case -1 :
    return;

  case 0 :
    helstr(LINES-1,0," F10 ","вихід",NULL);
    
    bros[0]='\0';
    
    VVOD1.VVOD_delete();
    VVOD1.VVOD_SPISOK_add_MD(gettext("Введите табельный номер"));
    vstr.new_plus("");
    if((kom1=vvod1(&vstr,10,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
      goto naz;
    if(kom1 == ESC)
      goto naz;
    if((tabn=atol(vstr.ravno())) == 0)
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Табельный номер не может быть нулевым !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }
    GDITE();
    vkart(tabn,1);
    goto naz;

  case 1 :
   if(vibkod(kod,"Podr",naim) == 0)
    {
     pod=atoi(kod);
     tabn=0;
     dirtab(&tabn,&fio,pod,0);
    }
   goto naz;

  case 2 :
   tabn=0;
   pod=0;
   dirtab(&tabn,&fio,pod,0);
   goto naz;

  case 3 :
    vkart(0,0);
    goto naz;

  case 4 :
    dirtabelo(mmm,ggg);
    goto naz;

  case 5 :

    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_ZAG(gettext("Автоматизированный расчет зарплат по всем карточкам"));

    MENU.VVOD_SPISOK_add_MD(gettext("Расчет только удержаний по всем карточкам"));
    MENU.VVOD_SPISOK_add_MD(gettext("Расчет только начислений по всем карточкам"));
    MENU.VVOD_SPISOK_add_MD(gettext("Расчет начислений и удержаний по всем карточкам"));
    MENU.VVOD_SPISOK_add_MD(gettext("Расчет только начислений на фонд оплаты труда"));
    MENU.VVOD_SPISOK_add_MD(gettext("Расчет только проводок"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);
    
    switch (kom1)
     {
      case 5 :
      case -1 :
        break;
      case 0:
        raszall(2);
        break;
      case 1:
        raszall(1);
        break;
      case 2:
        raszall(3);
        break;
      case 3:
        raszall(4);
        break;
      case 4:
        raszall(5);
        break;
     }
    goto naz;

  case 6 :
    viknu();
    goto naz;

  case 7:
    konrz();
    goto naz;

  case 8 :
    iceb_tl_blok();
    goto naz;

  case 9 :
    impzkart();
    goto naz;

  case 10 :
    imp_ks();
    goto naz;

  case 11 :
    xzp_dok();
    goto naz;

  case 12:
    zarsend();
    goto naz;

  case 13:
    zarsbka();
    goto naz;

  default:
    kom=0;
    goto naz;
 }
}
/*********************/
/*Работа с формой 8др*/
/*********************/

void		form8dr()
{
int		kom;

VVOD MENU(3);

kom=0;


MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Отчёты в налоговую"));

MENU.VVOD_SPISOK_add_MD(gettext("Расчет подоходного на выданную зарплату"));
MENU.VVOD_SPISOK_add_MD(gettext("Расчет формы 1ДФ"));
MENU.VVOD_SPISOK_add_MD(gettext("Работа с архивом документов формы 1ДФ"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

naz:;

clear();

while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);
class spis_oth oth;
switch (kom)
 {
  case 3 :
  case -1 :
    return;
  case 0:
    if(zarpd(&oth) == 0)
     iceb_t_rabfil(&oth,"");
    goto naz;
  case 1:
   if(zarkvrt(&oth) == 0)
     iceb_t_rabfil(&oth,"");
    goto naz;
  case 2:
    dirsdf8dr();
    goto naz;

  default:
    kom=0;
    goto naz;
 }
}
/*********************/
/*Работа с настроечными файлами*/
/*********************/

void xzp_fn()
{
int		kom;

VVOD MENU(3);

kom=0;


MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Работа с файлами настройки"));

MENU.VVOD_SPISOK_add_MD(gettext("Работа с файлом настройки"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка количества рабочих дней и часов"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Настройка выполнения проводок"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Работа со списком праздничных и выходных дней"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка минимальной зарплаты, прожиточного минимума"));//4
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка тарифных розрядов и коэффициентов для бюджетных организаций"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка тарифной сетки"));//6
MENU.VVOD_SPISOK_add_MD(gettext("Настройка списка банков для перечисления сумм на картсчета"));//7
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//8

naz:;

clear();

while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

switch (kom)
 {
  case 8 :
  case -1 :
    return;

  case 0:
    if(iceb_redfil("zarnast.alx",0) == 0)
       zarnast();
    goto naz;
  case 1:
    iceb_redfil("zarkalndr.alx",0);
    goto naz;

  case 2:
//    iceb_redfil("zarnpr.alx",0);
    zarnvp();
    goto naz;

  case 3:
    iceb_redfil("kalend.alx",0);
    goto naz;

  case 4:
    iceb_redfil("zar_mz_pm.alx",0);
    goto naz;

  case 5:
    iceb_redfil("zartarroz.alx",0);
    goto naz;

  case 6:
    iceb_redfil("zartarroz1.alx",0);
    goto naz;

  case 7:
    iceb_redfil("zarbanks.alx",0);
    goto naz;

  default:
    kom=0;
    goto naz;
 }
}
/***********************/
/*Ввод нового документа*/
/*************************/
void xzp_vdok()
{
VVOD MENU(3);
short prn=0;

MENU.VVOD_SPISOK_add_MD(gettext("Ввод начислений"));
MENU.VVOD_SPISOK_add_MD(gettext("Ввод удержаний"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));


int kom1=0;
while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

switch (kom1)
 {
  case 2 :
  case -1:
    return;

  case 0 :
    prn=1;
    break;

  case 1 :
    prn=2;
    break;
 }

short dv=0;
short mv=0;
short gv=0;
class iceb_tu_str nomdok_v("");



if(dirzardk_vvod(prn,&dv,&mv,&gv,&nomdok_v) == 0)
  dirzardkz(prn,dv,mv,gv,&nomdok_v);
 

}





/*********************/
/*Работа с документами*/
/*********************/

void xzp_dok()
{
int		kom;

VVOD MENU(3);

kom=0;



MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Работа с документами"));

MENU.VVOD_SPISOK_add_MD(gettext("Ввод нового документа"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Поиск документов"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Просмотр всех введённых документов"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//3

naz:;

clear();

while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

switch (kom)
 {
  case 3 :
  case -1 :
    return;

  case 0 :
    xzp_vdok();
    goto naz;

  case 1:
    poizardok();
    goto naz;

  case 2:
    dirzardk();
    goto naz;
    
  default:
    kom=0;
    goto naz;
 }
}



