/*$Id: zar_rsoc.c,v 5.7 2011-04-14 16:07:34 sasa Exp $*/
/*12.04.2011	09.11.2004	Белых А.И.	zar_rsoc.c
Расчет суммы на соц-страх
*/
#include        "buhg.h"

extern float    procsoc; /*Процент отчисления в соц-страх*/
extern float    procsoc1; /*Процент отчисления в соц-страх*/
//extern float    prog_min_tek; //Прожиточный минимум тукущий
extern double   ogrzp[2]; /*Ограничение на начисление пенсионного отчисления*/
extern double   okrg; /*Округление*/

double zar_rsoc(double soc_suma,float prog_min_tek,FILE *ff)
{


double koef=0.;
double nalog=0.;

if(soc_suma <= prog_min_tek)
 {
  if(procsoc != 0.)
     koef=procsoc/100.;  
  if(ff != NULL)
    fprintf(ff,"%.2f <= %.2f(прожиточный минимум) -> %.2f\n",soc_suma,prog_min_tek,koef);
 }
else
 {
  if(procsoc1 != 0.)
     koef=procsoc1/100.;  
  if(ff != NULL)
    fprintf(ff,"%.2f > %.2f(прожиточный минимум) -> %.2f\n",soc_suma,prog_min_tek,koef);
 }

if(soc_suma <= ogrzp[1])
 {
  nalog=soc_suma*koef;
  if(ff != NULL)
      fprintf(ff,"*%s:%.2f %.2f-%.2f%% %s %.2f %s %.2f\n",
      "Соц-страх с суммы",soc_suma,nalog,koef,
      gettext("Сумма"),soc_suma,
      gettext("Ограничение"), ogrzp[1]);
 }
else
 {
  nalog=koef*ogrzp[1];
  if(ff != NULL)
       fprintf(ff,"Превышение. %.2f > %.2f/%.2f\n",soc_suma,ogrzp[1],koef);
 }      

nalog=okrug(nalog,okrg)*(-1);

return(nalog);
}
