/*$Id: zar_srn.c,v 5.9 2011-01-13 13:43:25 sasa1 Exp $*/
/*04.11.2009	24.05.2007	Белых А.И.	zar_srn.c
Сравнительный расчёт налогов
*/

#include        <errno.h>
#include        <math.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void zar_srn_rekpoi(char *podr,char *tabnom,FILE *ff);
void zar_srn_sap(FILE *ff);
void zar_srn_str(char *tabnom,char *fio,double nalog,double nalog_p,FILE *ff);
double zar_srn_readnal(short kodud,int tabnom,short mr,short gr);
void zar_srn_itogostr(double itogo,double itogop,FILE *ff);


extern short	mmm,ggg;
extern short    kodbzr;  /*Код отчисления на безработицу*/
extern char *organ;
extern short           kodpn;   /*Код подоходного налога*/
extern short           kodpen;  /*Код пенсионных отчислений*/
extern short           kodsocstr;  /*Код отчисления на соц-страх*/
extern short           kodbzr;  /*Код отчисления на безработицу*/



int zar_srn(class spis_oth *oth)
{
static char	dat1[8];
static char	podr[112];
static char	tabnom[112];
char naimp[512];
char strsql[512];

if(dat1[0] == '\0')
 sprintf(dat1,"%d.%d",mmm,ggg);

VVOD VV(0);

VV.VVOD_SPISOK_add_ZAG(gettext("Перерасчёт налогов"));

VV.VVOD_SPISOK_add_MD(gettext("Дата.............(м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения..(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Табельный номер....(,,)."));

VV.VVOD_SPISOK_add_data(dat1,8);
VV.VVOD_SPISOK_add_data(podr,sizeof(podr));
VV.VVOD_SPISOK_add_data(tabnom,sizeof(tabnom));

naz:;

clear(); 

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+/-",gettext("расчет"),
"F3",gettext("подразделения"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

int kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(podr,VV.VVOD_SPISOK_return_data(1),sizeof(podr)-1);
strncpy(tabnom,VV.VVOD_SPISOK_return_data(2),sizeof(tabnom)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp4_3_16.txt");
   goto naz;

  case FK10:
  case ESC:
   return(1);

  case FK2:
  case PLU:
   break;


  case FK3:
    if(vibrek("Podr",podr,sizeof(podr),naimp) == 0)
      VV.VVOD_SPISOK_zapis_data(1,podr);
      
    goto naz;

  case FK4:
   VV.VVOD_clear_data();
   goto naz;

  default:
    goto naz;
 }
short mn,gn;

if(rsdat1(&mn,&gn,dat1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
clear();
GDITE();
time_t tmmn=time(NULL);

int kolstr=0;
SQL_str row;
class SQLCURSOR cur;
sprintf(strsql,"select podr,tabn from Zarn where god=%d and mes=%d",gn,mn);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

FILE *ff_bezr,*ff_pens,*ff_soc,*ff_podoh,*ff_prot;
char imaf_bezr[50];
char imaf_pens[50];
char imaf_soc[50];
char imaf_podoh[50];
char imaf_prot[50];

sprintf(imaf_bezr,"bezr%d.lst",getpid());
sprintf(imaf_pens,"pens%d.lst",getpid());
sprintf(imaf_soc,"soc%d.lst",getpid());
sprintf(imaf_podoh,"podoh%d.lst",getpid());
sprintf(imaf_prot,"prot%d.lst",getpid());

if((ff_prot = fopen(imaf_prot,"w")) == NULL)
 {
  error_op_nfil(imaf_prot,errno,"");
  return(1);
 }
zagolov(gettext("Протокол расчёта"),0,0,0,0,mn,gn,organ,ff_prot);

if((ff_bezr = fopen(imaf_bezr,"w")) == NULL)
 {
  error_op_nfil(imaf_bezr,errno,"");
  return(1);
 }

zagolov(gettext("Перерасчёт отчисления в фонд безработицы с работника"),0,0,0,0,mn,gn,organ,ff_bezr);
zar_srn_rekpoi(podr,tabnom,ff_bezr);
zar_srn_sap(ff_bezr);



if((ff_pens = fopen(imaf_pens,"w")) == NULL)
 {
  error_op_nfil(imaf_pens,errno,"");
  return(1);
 }

zagolov(gettext("Перерасчёт отчисления в пенсионный фонд с работника"),0,0,0,0,mn,gn,organ,ff_pens);
zar_srn_rekpoi(podr,tabnom,ff_pens);
zar_srn_sap(ff_pens);



if((ff_soc = fopen(imaf_soc,"w")) == NULL)
 {
  error_op_nfil(imaf_soc,errno,"");
  return(1);
 }

zagolov(gettext("Перерасчёт отчисления в соц-фонд с работника"),0,0,0,0,mn,gn,organ,ff_soc);
zar_srn_rekpoi(podr,tabnom,ff_soc);
zar_srn_sap(ff_soc);





if((ff_podoh = fopen(imaf_podoh,"w")) == NULL)
 {
  error_op_nfil(imaf_podoh,errno,"");
  return(1);
 }

zagolov(gettext("Перерасчёт подоходного налога"),0,0,0,0,mn,gn,organ,ff_podoh);
zar_srn_rekpoi(podr,tabnom,ff_podoh);
zar_srn_sap(ff_podoh);

int kolstr1=0;

zar_read_tn(1,mn,gn,NULL); //читаем настрой
long t_nomer;
int podrr;
double i_fbezr=0.;
double i_fbezrb=0.;
double fbezrab=0.,fbezrabb=0.;

double sumapo=0; //Общая сумма пенсионного отчисления только с зарплаты 
double sumapob=0.; //Сумма пенсинного отчисления с бюджетных начислений только с зарплаты
double i_pens=0.;
double i_pensb=0.;

double sumaos=0.; //Сумма отчисления на соц-страх только с зарплаты
double sumaosb=0.; //Сумма отчисления на соц-страх бюджет только с зарплаты
double i_soc=0.;
double i_socb=0.;
char fio[512];
SQL_str row1;
class SQLCURSOR cur1;    
double podoh=0.;
double nalog=0.;

double itogo_podoh=0.;
double itogo_podohp=0.;

double itogo_pens=0.;
double itogo_pensp=0.;

double itogo_soc=0.;
double itogo_socp=0.;

double itogo_bezr=0.;
double itogo_bezrp=0.;

while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  
  if(proverka(podr,row[0],0,0) != 0)
   continue;
  
  if(proverka(tabnom,row[1],0,0) != 0)
   continue;
  
  t_nomer=atol(row[1]);  
  podrr=atoi(row[0]);
  
  memset(fio,'\0',sizeof(fio));
  sprintf(strsql,"select fio from Kartb where tabn=%s",row[1]);
  
  if(readkey(strsql,&row1,&cur1) == 1)
   strncpy(fio,row1[0],sizeof(fio)-1);
  
  printw("%5s %s\n",row[1],fio);
  refresh();
  
  fprintf(ff_prot,"\n\n%s %s\n===========================================================\n",
  row[1],fio);
    
  if(zapmas(t_nomer,mn,gn) != 0)
   {
    printw("%s\n",gettext("Не найдено начислений !"));
    fprintf(ff_prot,"%s\n",gettext("Не найдено начислений !"));
    continue;
   }
  
  //расчёт отчисления в фонд безработицы
  fbezr(t_nomer,mn,gn,podrr,&fbezrab,&fbezrabb,1,0,0.,&i_fbezr,&i_fbezrb,"",ff_prot);

  //расчёт пенсионного отчисления
  ras_pens(t_nomer,mn,gn,podrr,&sumapo,&sumapob,1,0,0.,&i_pens,&i_pensb,"",ff_prot);

  //расчёт отчисления на соц-страх
  
  ras_soc(t_nomer,mn,gn,podrr,&sumaos,&sumaosb,1,0,0.,&i_soc,&i_socb,"",ff_prot);

  //расчёт подоходного налога
  podoh=ras_podoh(t_nomer,mn,gn,podrr,fbezrab,fbezrabb,sumapo,sumapob,sumaos,sumaosb,1,0,0.,"",ff_prot);

  nalog=zar_srn_readnal(kodpn,t_nomer,mn,gn);
  zar_srn_str(row[1],fio,nalog,podoh,ff_podoh);
  itogo_podoh+=nalog;
  itogo_podohp+=podoh;
  
  nalog=zar_srn_readnal(kodpen,t_nomer,mn,gn);
  zar_srn_str(row[1],fio,nalog,i_pens,ff_pens);
  itogo_pens+=nalog;
  itogo_pensp+=i_pens;
  
  nalog=zar_srn_readnal(kodsocstr,t_nomer,mn,gn);
  zar_srn_str(row[1],fio,nalog,i_soc,ff_soc);
  itogo_soc+=nalog;
  itogo_socp+=i_soc;
  
  nalog=zar_srn_readnal(kodbzr,t_nomer,mn,gn);
  zar_srn_str(row[1],fio,nalog,i_fbezr,ff_bezr);
  itogo_bezr+=nalog;
  itogo_bezrp+=i_fbezr;
  
 }
zar_srn_itogostr(itogo_podoh,itogo_podohp,ff_podoh);
zar_srn_itogostr(itogo_soc,itogo_socp,ff_soc);
zar_srn_itogostr(itogo_pens,itogo_pensp,ff_pens);
zar_srn_itogostr(itogo_bezr,itogo_bezr,ff_bezr);

podpis(ff_bezr);
podpis(ff_prot);
podpis(ff_pens);
podpis(ff_soc);
podpis(ff_podoh);

fclose(ff_bezr);
fclose(ff_pens);
fclose(ff_soc);
fclose(ff_podoh);
fclose(ff_prot);



sprintf(strsql,"%s %s %s %s %s",imaf_podoh,imaf_bezr,imaf_soc,imaf_pens,imaf_prot);

printw_vr(tmmn);

OSTANOV();

oth->spis_imaf.plus(imaf_podoh);
oth->spis_naim.plus(gettext("Перерасчёт подоходного налога"));

oth->spis_imaf.plus(imaf_bezr);
oth->spis_naim.plus(gettext("Перерасчёт отчислений в фонд безработицы"));

oth->spis_imaf.plus(imaf_soc);
oth->spis_naim.plus(gettext("Перерасчёт отчислений в фонд социального страхования"));

oth->spis_imaf.plus(imaf_pens);
oth->spis_naim.plus(gettext("Перерасчёт отчислений в пенсионный фонд"));

oth->spis_imaf.plus(imaf_prot);
oth->spis_naim.plus(gettext("Протокол расчёта"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++) 
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);
}

/***************************/
/*Реквизиты поиска*/
/***************************/
void zar_srn_rekpoi(char *podr,char *tabnom,FILE *ff)
{
if(podr[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Подразделение"),podr);
 
if(tabnom[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Табельный номер"),tabnom);
}
/**************************/
/*шапка*/
/**************************/
void zar_srn_sap(FILE *ff)
{

fprintf(ff,"\
-----------------------------------------------------------------------\n");
fprintf(ff,"\
 Т/н  |        Фамилия               |Начислено |Пересчита.|Разница   |\n");

fprintf(ff,"\
-----------------------------------------------------------------------\n");

}
/********************************/
/*Строка */
/********************************/
void zar_srn_str(char *tabnom,char *fio,double nalog,double nalog_p,FILE *ff)
{

fprintf(ff,"%6s %-30.30s %10.2f %10.2f %10.2f\n",tabnom,fio,nalog,nalog_p,nalog_p-nalog);


}
/************************/
/*Чтение нужного удержания*/
/****************************/

double zar_srn_readnal(short kodud,int tabnom,short mr,short gr)
{
char strsql[512];
SQL_str row;
class SQLCURSOR cur;
double suma=0.;

sprintf(strsql,"select suma from Zarp where datz >= '%04d-%02d-01' and \
datz <= '%04d-%02d-31' and tabn=%d and prn='2' and knah=%d and godn=%d and mesn=%d",gr,mr,gr,mr,tabnom,kodud,gr,mr);

int kolstr=0;

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(0.);
 }

while(cur.read_cursor(&row) != 0)
 {
  suma+=atof(row[0]); 
 }

return(suma);


}
/***********************/
/*Итоговая строка*/
/*********************/
void zar_srn_itogostr(double itogo,double itogop,FILE *ff)
{
fprintf(ff,"\
-----------------------------------------------------------------------\n");
fprintf(ff,"%*s %10.2f %10.2f %10.2f",iceb_tu_kolbait(37,gettext("Итого")),gettext("Итого"),itogo,itogop,itogop-itogo);

}
