/*$Id: zarbesv.c,v 5.7 2011-05-06 08:29:23 sasa Exp $*/
/*25.01.2011	25.01.2011	Белых А.И.	zarbesv.c
Расчёт баз удержания единого социального взноса
*/
#include <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif

int zarbesv_r(int metka_r,
short mr,short gr,
double itogo_nah,
double itogo_suma_nvr,
double suma_prev,
double itogo_suma,
double itogo_suma_p,
double suma_esv_ob,
double itogo_suma_inv,
double itogo_suma_inv_p,
double suma_esv_inv,
double itogo_suma_dog,
double itogo_suma_dog_p,
double suma_esv_dog,
double itogo_suma_bol,
double suma_esv_bol,
double prog_min_tek,
const char *imaf);

extern short	mmm,ggg;
extern char	*organ;
extern char *shetb; /*Бюджетные счета начислений*/
extern char *shetbu; /*Бюджетные счета удержаний*/
extern short *kodbl;  /*Код начисления больничного*/
//extern float  max_sum_for_soc; //Максимальная сумма с которой начисляются соц.отчисления
extern int kod_esv;
extern int kod_esv_bol;
extern int kod_esv_inv;
extern int kod_esv_dog;

extern class iceb_tu_str knvr_esv_r; /*Коды не входящие в расчёт единого социального взноса с работника*/

int zarbesv(class spis_oth *oth)
{
static class iceb_tu_str dat1("");
int		kom1;
char		imaf[64],imaf_hoz[64],imaf_bud[64];
char		strsql[512];
short		mr,gr;
if(dat1.ravno()[0] == '\0')
 {
  sprintf(strsql,"%d.%d",mmm,ggg);
  dat1.new_plus(strsql);
 }
VVOD VVOD1(2);
VVOD1.VVOD_SPISOK_add_ZAG(gettext("Расчет баз налогообложения для удержания единого социального взноса"));
VVOD1.VVOD_SPISOK_add_MD(gettext("Введите дату (м.г)."));
 
naz:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"Enter",gettext("расчитать"),
"F10",gettext("выход"),NULL);

kom1=vvod1(&dat1,8,&VVOD1,NULL,stdscr,-1,-1);

switch(kom1)
 {
  case FK1:
   GDITE();
//   iceb_t_pdoc("zarp4_7_8.txt");
   goto naz;
  
  case FK10:
  case ESC:
   return(1);

  case FK2:
  case ENTER:
   break;

  default:
    goto naz;   
 }

if(rsdat1(&mr,&gr,dat1.ravno()) != 0)
 {
  iceb_t_soob(gettext("Не верно введена дата !"));
  goto naz;
 }

GDITE();
double itogo_nah[2]={0.,0.}; /*общая сумма всех начилений*/
double itogo_suma_nvr[2]={0.,0.}; /*сумма не вошедшая в расчёт*/
double itogo_suma[2]={0.,0.};
double itogo_suma_bol[2]={0.,0.};
double itogo_suma_inv[2]={0.,0.};
double itogo_suma_dog[2]={0.,0.};

double itogo_suma_p[2]={0.,0.}; /*Cумма превышения*/
double itogo_suma_inv_p[2]={0.,0.};
double itogo_suma_dog_p[2]={0.,0.};

double suma_esv_ob[2]={0.,0.};
double suma_esv_bol[2]={0.,0.};
double suma_esv_inv[2]={0.,0.};
double suma_esv_dog[2]={0.,0.};
double suma_zap=0.;
double suma_tab[2]={0.,0.};
double suma_prev[2]={0.,0.};
int metka_inv=0;
int metka_dog=0;
int kod_zap=0;

class zar_read_tn1h nastr;
zar_read_tn1(1,mr,gr,&nastr,NULL);

int kolstr=0,kolstr1=0,kolstr2=0;
SQL_str row,row1;
class SQLCURSOR cur,cur1;
sprintf(strsql,"select tabn from Zarn where god=%d and mes=%d",gr,mr);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной записи !"));
  return(1);
 }

/*чтение величины минимальной зарплаты и прожиточного минимума*/
zar_read_tn(1,mr,gr,NULL); 
/*Чтение настроек для расчёта единого социального взноса*/
zarrnesv(NULL);


while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);

  sprintf(strsql,"select prn,knah,suma,shet,godn,mesn from Zarp \
where tabn=%s and datz >= '%04d-%d-01' and datz <= '%04d-%d-31' \
and suma <> 0.",row[0],gr,mr,gr,mr);

  if((kolstr2=cur1.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }

  if(kolstr2 == 0)
   continue;
  
  memset(suma_tab,'\0',sizeof(suma_tab));
  memset(suma_prev,'\0',sizeof(suma_prev));
  metka_inv=metka_dog=0;  
  while(cur1.read_cursor(&row1) != 0)
   {
    kod_zap=atoi(row1[1]);
    suma_zap=atof(row1[2]);    

    if(atoi(row1[0]) == 1) /*Начисления*/
     {
      itogo_nah[0]+=suma_zap;
      if(proverka(shetb,row1[3],0,0) == 0)
        itogo_nah[1]+=suma_zap;
       
      if(proverka(knvr_esv_r.ravno(),row1[1],0,1) == 0)
       {
        itogo_suma_nvr[0]+=suma_zap;
        if(proverka(shetb,row1[3],0,0) == 0)
          itogo_suma_nvr[1]+=suma_zap;
        continue;
       }
  
      suma_tab[0]+=suma_zap;
      if(proverka(shetb,row1[3],0,0) == 0)
        suma_tab[1]+=suma_zap;

      if(provkod(kodbl,kod_zap) >= 0)
       {
        itogo_suma_bol[0]+=suma_zap;
        if(proverka(shetb,row1[3],0,0) == 0)
          itogo_suma_bol[1]+=suma_zap;
        continue;
       }              

     if((metka_inv=zarprtn(mr,gr,atoi(row[0]),"zarinv.alx",NULL)) == 1)
      {
       itogo_suma_inv[0]+=suma_zap;
       if(proverka(shetb,row1[3],0,0) == 0)
         itogo_suma_inv[1]+=suma_zap;
       continue;
      }

     if((metka_dog=zarprtn(mr,gr,atoi(row[0]),"zardog.alx",NULL)) == 1)
      {
       itogo_suma_dog[0]+=suma_zap;
       if(proverka(shetb,row1[3],0,0) == 0)
         itogo_suma_dog[1]+=suma_zap;
       continue;
      }

     itogo_suma[0]+=suma_zap;
     if(proverka(shetb,row1[3],0,0) == 0)
       itogo_suma[1]+=suma_zap;

     }
    else /*удержания*/
     {
      if(kod_zap == kod_esv)
       suma_esv_ob[0]+=suma_zap;

      if(kod_zap == kod_esv_bol)
       suma_esv_bol[0]+=suma_zap;

      if(kod_zap == kod_esv_inv)
       suma_esv_inv[0]+=suma_zap;

      if(kod_zap == kod_esv_dog)
       suma_esv_dog[0]+=suma_zap;

      if(proverka(shetbu,row1[3],0,0) == 0)
       {
        if(kod_zap == kod_esv)
         suma_esv_ob[1]+=suma_zap;

        if(kod_zap == kod_esv_bol)
         suma_esv_bol[1]+=suma_zap;

        if(kod_zap == kod_esv_inv)
         suma_esv_inv[1]+=suma_zap;

        if(kod_zap == kod_esv_dog)
         suma_esv_dog[1]+=suma_zap;

       }
     }
     
   }

  if(suma_tab[0] > nastr.max_sum_for_soc)
   {
    suma_prev[0]+=suma_tab[0]-nastr.max_sum_for_soc;
    if(metka_inv == 1)
     itogo_suma_inv_p[0]+=suma_tab[0]-nastr.max_sum_for_soc;
    if(metka_dog == 1)
     itogo_suma_dog_p[0]+=suma_tab[0]-nastr.max_sum_for_soc;
    if(metka_dog == 0 && metka_inv == 0)
     itogo_suma_p[0]+=suma_tab[0]-nastr.max_sum_for_soc;
   }

  if(suma_tab[1] > nastr.max_sum_for_soc)
   {
    suma_prev[1]+=suma_tab[1]-nastr.max_sum_for_soc;
    if(metka_inv == 1)
     itogo_suma_inv_p[1]+=suma_tab[1]-nastr.max_sum_for_soc;
    if(metka_dog == 1)
     itogo_suma_dog_p[1]+=suma_tab[1]-nastr.max_sum_for_soc;
    if(metka_dog == 0 && metka_inv == 0)
     itogo_suma_p[1]+=suma_tab[1]-nastr.max_sum_for_soc;
   }
 }
/*Общая сумма*/
sprintf(imaf,"esv%d.lst",getpid());

zarbesv_r(0,mr,gr,itogo_nah[0],itogo_suma_nvr[0],suma_prev[0],
itogo_suma[0],itogo_suma_p[0],suma_esv_ob[0],
itogo_suma_inv[0],itogo_suma_inv_p[0],suma_esv_inv[0],
itogo_suma_dog[0],itogo_suma_dog_p[0],suma_esv_dog[0],
itogo_suma_bol[0],suma_esv_bol[0],nastr.max_sum_for_soc,imaf);

if(shetb != NULL)
 {

  sprintf(imaf_hoz,"hesv%d.lst",getpid());
  zarbesv_r(1,mr,gr,itogo_nah[0]-itogo_nah[1],itogo_suma_nvr[0]-itogo_suma_nvr[1],suma_prev[0]-suma_prev[1],
  itogo_suma[0]-itogo_suma[1],itogo_suma_p[0]-itogo_suma_p[1],suma_esv_ob[0]-suma_esv_ob[1],
  itogo_suma_inv[0]-itogo_suma_inv[1],itogo_suma_inv_p[0]-itogo_suma_inv_p[1],suma_esv_inv[0]-suma_esv_inv[1],
  itogo_suma_dog[0]-itogo_suma_dog[1],itogo_suma_dog_p[0]-itogo_suma_dog_p[1],suma_esv_dog[0]-suma_esv_dog[1],
  itogo_suma_bol[0]-itogo_suma_bol[1],suma_esv_bol[0]-suma_esv_bol[1],nastr.max_sum_for_soc,imaf_hoz);

  sprintf(imaf_bud,"besv%d.lst",getpid());
  zarbesv_r(2,mr,gr,itogo_nah[1],itogo_suma_nvr[1],suma_prev[1],
  itogo_suma[1],itogo_suma_p[1],suma_esv_ob[1],
  itogo_suma_inv[1],itogo_suma_inv_p[1],suma_esv_inv[1],
  itogo_suma_dog[1],itogo_suma_dog_p[1],suma_esv_dog[1],
  itogo_suma_bol[1],suma_esv_bol[1],nastr.max_sum_for_soc,imaf_bud);
 }
oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчет баз налогообложения для удержания единого социального взноса"));
if(shetb != NULL)
 {
  oth->spis_imaf.plus(imaf_hoz);
  sprintf(strsql,"%s %s",gettext("Расчет баз налогообложения для удержания единого социального взноса"),gettext("Хозрасчёт"));
  oth->spis_naim.plus(strsql);

  oth->spis_imaf.plus(imaf_bud);
  sprintf(strsql,"%s %s",gettext("Расчет баз налогообложения для удержания единого социального взноса"),gettext("Бюджет"));
  oth->spis_naim.plus(strsql);
 }

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),3);

return(0);
}


/***********************************/
/*Распечатка*/
/**************************/
int zarbesv_r(int metka_r,
short mr,short gr,
double itogo_nah,
double itogo_suma_nvr,
double suma_prev,
double itogo_suma,
double itogo_suma_p,
double suma_esv_ob,
double itogo_suma_inv,
double itogo_suma_inv_p,
double suma_esv_inv,
double itogo_suma_dog,
double itogo_suma_dog_p,
double suma_esv_dog,
double itogo_suma_bol,
double suma_esv_bol,
double max_sum_for_soc,
const char *imaf)
{
char strsql[512];
FILE *ff;

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }


if(metka_r == 0)
 zagolov(gettext("Расчет баз налогообложения для удержания единого социального взноса"),0,mr,gr,0,0,0,organ,ff);

if(metka_r == 1)
 {
  sprintf(strsql,"%s %s",gettext("Расчет баз налогообложения для удержания единого социального взноса"),gettext("Хозрасчёт"));
  zagolov(strsql,0,mr,gr,0,0,0,organ,ff);
 }
if(metka_r == 2)
 {
  sprintf(strsql,"%s %s",gettext("Расчет баз налогообложения для удержания единого социального взноса"),gettext("Бюджет"));
  zagolov(strsql,0,mr,gr,0,0,0,organ,ff);
 }
fprintf(ff,"\
%s:%d\n\
%s:%d\n\
%s:%d\n\
%s:%d\n\
%s:%s\n",
gettext("Код удержания единого социального взноса"),kod_esv,
gettext("Код удержания единого социального взноса для больничных"),kod_esv_bol,
gettext("Код удержания единого социального взноса для инвалидов"),kod_esv_inv,
gettext("Код удержания единого социального взноса для договоров"),kod_esv_dog,
gettext("Коды начислений не входящие в расчёт удержания единого социального взноса"),knvr_esv_r.ravno());

sprintf(strsql,"%s %.2f",gettext("Cумма больще"),max_sum_for_soc);

fprintf(ff,"\n\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n",
iceb_tu_kolbait(30,gettext("Начислено")),gettext("Начислено"),itogo_nah,
iceb_tu_kolbait(30,gettext("Не вошло в расчёт")),gettext("Не вошло в расчёт"),itogo_suma_nvr,
iceb_tu_kolbait(30,strsql),strsql,suma_prev,
iceb_tu_kolbait(30,gettext("Сумма взятая в расчёт")),gettext("Сумма взятая в расчёт"),itogo_nah-itogo_suma_nvr-suma_prev);

class zarrnesvp_rek esvp;

zarrnesvp(mr,gr,&esvp,NULL);
 
fprintf(ff,"\n%s %.2f%%\n\
----------------------------------------------------------------\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n",
gettext("Единый социальный взнос"),esvp.proc_esv,
iceb_tu_kolbait(30,gettext("Начислено")),gettext("Начислено"),itogo_suma,
iceb_tu_kolbait(30,gettext("Сумма превышения")),gettext("Сумма превышения"),itogo_suma_p,
iceb_tu_kolbait(30,gettext("Взято в расчёт")),gettext("Взято в расчёт"),itogo_suma-itogo_suma_p,
iceb_tu_kolbait(30,gettext("Сумма удержания")),gettext("Сумма удержания"),suma_esv_ob);

fprintf(ff,"\n%s %.2f%%\n\
----------------------------------------------------------------\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n",
gettext("Единый социальный взнос c инвалидов"),esvp.proc_esv_inv,
iceb_tu_kolbait(30,gettext("Начислено")),gettext("Начислено"),itogo_suma_inv,
iceb_tu_kolbait(30,gettext("Сумма превышения")),gettext("Сумма превышения"),itogo_suma_inv_p,
iceb_tu_kolbait(30,gettext("Взято в расчёт")),gettext("Взято в расчёт"),itogo_suma_inv-itogo_suma_inv_p,
iceb_tu_kolbait(30,gettext("Сумма удержания")),gettext("Сумма удержания"),suma_esv_inv);

fprintf(ff,"\n%s %.2f%%\n\
----------------------------------------------------------------\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n",
gettext("Единый социальный взнос c работающих по договорам"),esvp.proc_esv_dog,
iceb_tu_kolbait(30,gettext("Начислено")),gettext("Начислено"),itogo_suma_dog,
iceb_tu_kolbait(30,gettext("Сумма превышения")),gettext("Сумма превышения"),itogo_suma_dog_p,
iceb_tu_kolbait(30,gettext("Взято в расчёт")),gettext("Взято в расчёт"),itogo_suma_dog-itogo_suma_dog_p,
iceb_tu_kolbait(30,gettext("Сумма удержания")),gettext("Сумма удержания"),suma_esv_dog);
fprintf(ff,"\n%s %.2f%%\n\
----------------------------------------------------------------\n\
%*s:%10.2f\n\
%*s:%10.2f\n",
gettext("Единый социальный взнос c больничных"),esvp.proc_esv_bol,
iceb_tu_kolbait(30,gettext("Начислено")),gettext("Начислено"),itogo_suma_bol,
iceb_tu_kolbait(30,gettext("Сумма удержания")),gettext("Сумма удержания"),suma_esv_bol);


podpis(ff);
fclose(ff);
return(0);
}
