/* $Id: zardod13.c,v 5.11 2011-01-13 13:43:25 sasa1 Exp $ */
/*21.01.2010	23.10.1999	Белых А.И.	zardod13.c
Подпрограмма распечатки приложения 13 для пенсионного фонда
*/
#include        <errno.h>
#include        "buhg.h"


void zardod13(const char *inn,/*Индивидуальный налоговый номер*/
const char *fio, /*Фамилия, имя, отчество*/
const char *kodor, /*Индетификационный код организации*/
const char *naimor, /*Наименование организации*/
const char *rukov, /*Руководитель*/
int *kol,     /*Количество записаных в страницу*/
int *nomst,   /*Номер страницы*/
short dd,short md,short gd,/*дата документа*/
short dr,short mr,short gr,//День рождения
short pol_slug, //0-мужчина 1-женщина
int *nomzap, /*номер записи*/
FILE *ff13r,FILE *ff13w,FILE *ffvv,
FILE *ff_zvit_anket)
{
short		nomstr;
char		fam[512];
char		ima[512];
char		oth[512];
char		str[1024];
char		bros[512];
char		pol[16];

/*
printw("zardod13 kol=%d nomst=%d\n",*kol,*nomst);
refresh();
*/
if(fio[0] == '\0' && *kol == 0)
  return;

if(fio[0] == '\0' && *kol > 0)
  goto vp;

if(*kol == 0)
 {
  for(nomstr=1; nomstr <= 25; nomstr++)
   {
    memset(str,'\0',sizeof(str));
    fgets(str,sizeof(str),ff13r);
    switch(nomstr)
     {
      case 16:
        BSTAB(str,kodor,1,21,2);
        break;
      case 19:
        BSTAB(str,naimor,14,68,1);
        break;
      default:
        break;
     }
    fprintf(ff13w,"%s",str);
   }  
 }

*kol=*kol+1;

memset(fam,'\0',sizeof(fam));
memset(ima,'\0',sizeof(ima));
memset(oth,'\0',sizeof(oth));

pole3(fio,fam,1,' ');
pole3(fio,ima,2,' ');
pole3(fio,oth,3,' ');

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff13r);
BSTAB(str,inn,4,24,2);

BSTAB(str,fam,24,45,1);
BSTAB(str,ima,45,66,1);
BSTAB(str,oth,66,87,1);
fprintf(ff13w,"%s",str);

fgets(str,sizeof(str),ff13r);
fprintf(ff13w,"%s",str);
memset(pol,'\0',sizeof(pol));
/********
if(pol_slug == 1)
  pol[0]='Ж';
if(pol_slug == 0)
  pol[0]='Ч';
***********/
if(pol_slug == 1)
  strcpy(pol,"Ж");
if(pol_slug == 0)
  strcpy(pol,"Ч");

fprintf(ffvv,"\"%s\",\"%s\",\"%s\",\"%s\",%d%02d%02d,\"%s\",%d%02d%02d,\"%s\",\"\",\
\"\",\"\",\"\"\n",inn,fam,ima,oth,gr,mr,dr,pol,gd,md,dd,kodor);



*nomzap+=1;
fprintf(ff_zvit_anket,"{\n\
ФПЕН5.TAB1_A1=%d\n\
ФПЕН5.KPU_INN=%s\n\
ФПЕН5.KPU_FAM=%s\n\
ФПЕН5.KPU_IMJ=%s\n\
ФПЕН5.KPU_OTC=%s\n\
ФПЕН5.STAT=%s\n\
ФПЕН5.DATA_ROD=%02d.%02d.%d\n}\n",
*nomzap,
inn,
fam,
ima,
oth,
pol,
dr,mr,gr);

if(*kol == 25)
 {
vp:;
  for(nomstr=76-(25-*kol)*2; fgets(str,sizeof(str),ff13r) != NULL ; nomstr++)
   {
    switch(nomstr)
     {
      case 78:
        sprintf(bros,"%4d",*kol);
        BSTAB(str,bros,1,9,2);
        break;

      case 80:
        sprintf(bros,"%4d",*nomst);
        BSTAB(str,bros,1,9,2);
        break;

      case 83:
        BSTAB(str,rukov,58,96,1);
        break;

      case 85:
        sprintf(bros,"%02d %02d %d",dd,md,gd);
        BSTAB(str,bros,45,65,2);
        break;

      default:
        break;
     }
    fprintf(ff13w,"%s",str);
   }
  *nomst=*nomst+1;
  *kol=0;
  rewind(ff13r);
 }
}
