/*$Id: zarreadn.c,v 5.14 2011-04-14 16:07:34 sasa Exp $*/
/*14.04.2011	23.01.2009	Белых А.И.	zarreadn.c
Чтение настроек перед автоматическим расчётом начислений и удерданий*/
#include <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif
#include "read_nast_ind.h"

int read_nast_ind(short mr,short gr,class index_ua *data);
void zar_mpsl();

extern float procent_fb_dog; /*Прочент начисления на фонд зарплаты для фонда безработицы для работающий по договору*/
extern float    dnei; /*Количество рабочих дней в текущем месяце*/
extern float    hasov; /*Количество рабочих часов в текущем месяце*/

class index_ua tabl_ind; /*Таблица для индексации зарплаты*/
float pnds=20.;




void zarreadn(short dr,short mr,short gr,
int metka_r,  //1-начисления 2-удержания 3-начисления и удержания
            //4-соц-отчисления
            //5-проводки
FILE *ff_prot)
{
/*Чтение процента налога на добавленную стоимость*/
pnds=iceb_t_pnds(dr,mr,gr);
//Читаем повторно-может их ктото изменил
redkal(mr,gr,&dnei,&hasov);


/*Читаем таблицу разрядов-коэффициентов*/
zartarroz();
zartarroz1();

class iceb_tu_str znah("");

if(iceb_t_poldan("Процент начисления для фонда безработицы",&znah,"zardog.alx") == 0)
 {
  
  procent_fb_dog=znah.ravno_atof();
 }
if(ff_prot != NULL)
   fprintf(ff_prot,"Процент на фонд зарплаты для фонда безработицы для работающих по договорам=%.2f\n",procent_fb_dog);


/*Чтение настроек для расчёта индексации зарплаты*/
read_nast_ind(mr,gr,&tabl_ind);

/*Чтение кодов единого социального взноса*/
zarrnesv(ff_prot);

if(metka_r == 2 || metka_r == 3)
  zar_mpsl(); /*Определяем применять социальную льготу при расчёте или нет*/


}
