/* $Id: zarsend.c,v 5.75 2011-03-09 08:16:56 sasa Exp $ */
/*29.03.2010	24.05.2000	Белых А.И.	zarsend.c
Автоматическая розноска зарплаты по карточкам
*/
#include        <errno.h>
#include        <math.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void	hpzrs(short mr,short gr,FILE *ff1);
void	strsen(int nomer,char *inn,char *bankshet,char *fio,double bbr,FILE *ff1);
double zarpv(short mr,short gr,int tabnom,double *sumab);


extern double   okrg; /*Округление*/
extern char	*shetb; /*Бюджетные счета начислений*/
extern char	*shetbu; /*Бюджетные счета удержаний*/
extern short	mmm,ggg;
extern short	*obud; /*Обязательные удержания*/
extern char	*organ;
short   	mfnn=1; /*Метка формирования номера накладной
                      -1 - Автоматическая нумерация выключена
                       0 - Приходы и расходы - нумерация общая
                       1 - Приходы отдельно расходы отдельно
                      */

void		zarsend()
{
struct  tm      *bf;
char		imafprot[56];
int		kolz;
FILE		*ff1;
char		bros[512];
long		kolstr,kolstr1,kolstr2;
SQL_str         row,row1;
char		strsql[512];
char		fio[512];
short		prn;
int		knah;
static char	tabel[112];
static char	kodn[112];
static char	podrz[112];
static char	dat1[16];
static char	kateg[112];
static char	maxsum[24];
static char     grupap[112];
static char     proc_vip[24];
short		mr,gr;
int		kom,kom1;
double		itsal,ins,iu,inah,in1;
double          ius=0.,ius1=0.;   /*Итого удержано без учета сальдо*/
double		nahshet=0.; //Итого начислено бюджет
double          iub=0.;   /*Итого удержано бюджета с учетом сальдо*/
double          iusb=0.;   /*Итого удержано без учета сальдо бюджета*/
double		iusb1=0.;  /*Итого удержано без учета сальдо бюджета */
char		naim[512];
int		tabb=0;
short		uhsl;
time_t          tmm;
int		podr=0;
double		sal;
double		itogo,itogoo;
int		im;
double		sym=0.,bbr=0.,bb=0.;
short		mz,gz;
short		dp,mp,gp; /*Дата перечисления зарплаты*/
char		bankshet[32];
double		saldb;
int		kodper=0;    //Код перечисления на карт-счёт
int             kod_v_kas=0; //Код выдачи из кассы
char		shet_per[32],shet_per_b[32];
char            shet_v_kas[32],shet_v_kas_b[32];
int		nomer=0;
char		platpor[32];
char		dataper[16];
short		uder;
char		inn[16];
double		dmaxsum=0.;
struct ZARP     zp;
int		metkaras=0; //0-все 1-только хозрасчет 2-только бюджет
class iceb_tu_str fiov("");

memset(shet_v_kas,'\0',sizeof(shet_v_kas));
memset(shet_v_kas_b,'\0',sizeof(shet_v_kas_b));
memset(shet_per_b,'\0',sizeof(shet_per_b));
memset(shet_per,'\0',sizeof(shet_per));

if(dat1[0] == '\0')
 sprintf(dat1,"%d.%d",mmm,ggg);
if(proc_vip[0] == '\0')
 strcpy(proc_vip,"100");
 
kodper=0;
itsal=ins=ius=iu=inah=in1=0.;

memset(platpor,'\0',sizeof(platpor));
memset(dataper,'\0',sizeof(dataper));
VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Автоматическая розноска полученной зарплаты."));
VV.VVOD_SPISOK_add_data(dat1,8);
VV.VVOD_SPISOK_add_data(podrz,sizeof(podrz));
VV.VVOD_SPISOK_add_data(kodn,sizeof(kodn));
VV.VVOD_SPISOK_add_data(tabel,sizeof(tabel));
VV.VVOD_SPISOK_add_data(kateg,sizeof(kateg));
VV.VVOD_SPISOK_add_data(dataper,11);
VV.VVOD_SPISOK_add_data(platpor,sizeof(platpor));
VV.VVOD_SPISOK_add_data(maxsum,20);
VV.VVOD_SPISOK_add_data(grupap,sizeof(grupap));
VV.VVOD_SPISOK_add_data(proc_vip,sizeof(proc_vip));

VV.VVOD_SPISOK_add_MD(gettext("Дата зарплаты..(м.г)......."));//0
VV.VVOD_SPISOK_add_MD(gettext("Подразделение...(,,)......."));//1
VV.VVOD_SPISOK_add_MD(gettext("Код начисления..(,,)......."));//2
VV.VVOD_SPISOK_add_MD(gettext("Табельный номер.(,,)......."));//3
VV.VVOD_SPISOK_add_MD(gettext("Код категории...(,,)......."));//4
VV.VVOD_SPISOK_add_MD(gettext("Дата перечисления.(д.м.г).."));//5
VV.VVOD_SPISOK_add_MD(gettext("Номер пла-ного документа..."));//6
VV.VVOD_SPISOK_add_MD(gettext("Максимальная сумма........."));//7
VV.VVOD_SPISOK_add_MD(gettext("Группа подразделения.(,,).."));//8
VV.VVOD_SPISOK_add_MD(gettext("Процент выплати............"));//9

naz:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(podrz,VV.VVOD_SPISOK_return_data(1),sizeof(podrz)-1);
strncpy(kodn,VV.VVOD_SPISOK_return_data(2),sizeof(kodn)-1);
strncpy(tabel,VV.VVOD_SPISOK_return_data(3),sizeof(tabel)-1);
strncpy(kateg,VV.VVOD_SPISOK_return_data(4),sizeof(kateg)-1);
strncpy(dataper,VV.VVOD_SPISOK_return_data(5),sizeof(dataper)-1);
strncpy(platpor,VV.VVOD_SPISOK_return_data(6),sizeof(platpor)-1);
strncpy(maxsum,VV.VVOD_SPISOK_return_data(7),sizeof(maxsum)-1);
strncpy(grupap,VV.VVOD_SPISOK_return_data(8),sizeof(grupap)-1);
strncpy(proc_vip,VV.VVOD_SPISOK_return_data(9),sizeof(proc_vip)-1);

switch (kom)
 {
  case ESC:
  case FK10:
     return;
     break;

  case FK1:
    GDITE();
    iceb_t_pdoc("zarp4_1_3.txt");
    goto naz;

  case PLU:
  case FK2:
     break;



  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка начислений."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка работников."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка категорий."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп."));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 5 :
      case -1:
       goto naz;


      case 0 :
        vibrek("Podr",podrz,sizeof(podrz),naim);
        VV.VVOD_SPISOK_zapis_data(1,podrz);
        goto naz;

      case 1 :
        vibrek("Nash",kodn,sizeof(kodn),naim);
        VV.VVOD_SPISOK_zapis_data(2,kodn);
        goto naz;

      case 2 :

        clear();
        tabb=0;
        fiov.new_plus("");
        if(dirtab(&tabb,&fiov,0,1) == 0)
         {
          if(tabel[0] == '\0')
            sprintf(tabel,"%d",tabb);
          else
           {
            sprintf(bros,"%d",tabb);
            if(strlen(tabel)+strlen(bros)+1 < sizeof(tabel)-1)
             {
              strcat(tabel,",");
              strcat(tabel,bros);
             }
           }
          VV.VVOD_SPISOK_zapis_data(3,tabel);

         }
        goto naz;

      case 3 :
        if(vibrek("Kateg",kateg,sizeof(kateg),naim) == 0)
          VV.VVOD_SPISOK_zapis_data(4,kateg);

      case 4 :
        if(vibrek("Zargrupp",grupap,sizeof(grupap),naim) == 0)
          VV.VVOD_SPISOK_zapis_data(8,grupap);
        goto naz;

     }
  case FK4:
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
    break;
 }

dmaxsum=ATOFM(maxsum);

if(rsdat1(&mr,&gr,dat1) != 0)
 { 
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 } 
double proc_vipl=ATOFM(proc_vip);

SQLCURSOR curr;
dp=mp=gp=0;
if(VV.VVOD_SPISOK_return_data(5)[0] != '\0')
 {
  if(rsdat(&dp,&mp,&gp,VV.VVOD_SPISOK_return_data(5),1) != 0)
   { 
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата перечисления !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   } 

  /*Читаем код перечисления*/
  memset(bros,'\0',sizeof(bros));
  if(iceb_t_poldan("Код перечисления зарплаты на счет",bros,"zarnast.alx") != 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найден код перечисления !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
  kodper=atoi(bros);

  if(iceb_t_poldan("Код получения зарплаты в кассе",bros,"zarnast.alx") != 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найден код получения зарплаты в кассе !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
  kod_v_kas=atoi(bros);

  if(kod_v_kas == 0 && kodper == 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Код получения зарплаты в кассе и код перечисления на счёт равны нолю !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }

   
/*
  printw("kodper=%d\n",kodper);
  OSTANOV();
*/
  
  //Читаем счет перечисления на карт-счёт
  sprintf(strsql,"select shet from Uder where kod=%d",kodper);
  if(sql_readkey(&bd,strsql,&row,&curr) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %d !",gettext("Не найден код удержания"),kodper);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
  strncpy(shet_per,row[0],sizeof(shet_per)-1);

  //*Читаем счет 
  sprintf(strsql,"select shet from Uder where kod=%d",kod_v_kas);
  if(sql_readkey(&bd,strsql,&row,&curr) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %d !",gettext("Не найден код удержания"),kod_v_kas);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
  strncpy(shet_v_kas,row[0],sizeof(shet_v_kas)-1);

  if(shetbu != NULL)
   {
    memset(bros,'\0',sizeof(bros));
    if(iceb_t_poldan("Счета перечисления на карт-счёт",bros,"zarnast.alx") == 0)
     {
      polen(bros,shet_per,sizeof(shet_per),1,',');
      polen(bros,shet_per_b,sizeof(shet_per),2,',');
     }     

    //Проверяем есть ли счета в плане счетов
    sprintf(strsql,"select ns from Plansh where ns='%s'",shet_per);
    int i;
    if((i=sql_readkey(&bd,strsql,&row,&curr)) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не найден счет %s в плане счетов !"),shet_per);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      SOOB.VVOD_SPISOK_add_MD("Счет хозрасчетной кассы, введен в файле настройки.");
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }

    sprintf(strsql,"select ns from Plansh where ns='%s'",shet_per_b);
    if(sql_readkey(&bd,strsql,&row,&curr) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не найден счет %s в плане счетов !"),shet_per_b);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      SOOB.VVOD_SPISOK_add_MD("Счет бюджетной кассы, введен в файле настройки.");
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }
    memset(bros,'\0',sizeof(bros));

    if(iceb_t_poldan("Счета выдачи из кассы",bros,"zarnast.alx") == 0)
     {
      polen(bros,shet_v_kas,sizeof(shet_per),1,',');
      polen(bros,shet_v_kas_b,sizeof(shet_per),2,',');
     }     

    //Проверяем есть ли счета в плане счетов
    sprintf(strsql,"select ns from Plansh where ns='%s'",shet_v_kas);
    if((i=sql_readkey(&bd,strsql,&row,&curr)) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не найден счет %s в плане счетов !"),shet_v_kas);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      SOOB.VVOD_SPISOK_add_MD("Счет хозрасчетного перечисленя, введен в файле настройки.");
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }

    sprintf(strsql,"select ns from Plansh where ns='%s'",shet_v_kas_b);
    if(sql_readkey(&bd,strsql,&row,&curr) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не найден счет %s в плане счетов !"),shet_v_kas_b);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      SOOB.VVOD_SPISOK_add_MD("Счет бюджетного перечисления, введен в файле настройки.");
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }

    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Хозрасчет и бюджет."));
    MENU.VVOD_SPISOK_add_MD(gettext("Только хозрасчет."));
    MENU.VVOD_SPISOK_add_MD(gettext("Только бюджет."));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));

    metkaras=0;
    while(menu3w(stdscr,&MENU,&metkaras,-1,-1,0) != 0);
    if(metkaras == 3 || metkaras == -1)
      goto naz;    
   
   }
  
  if(kodper <= 0)
   {
    strcpy(shet_per,shet_v_kas);
    strcpy(shet_per_b,shet_v_kas_b);
    kodper=kod_v_kas;
   }

  if(kod_v_kas <= 0)
   {
    strcpy(shet_v_kas,shet_per);
    strcpy(shet_v_kas_b,shet_per_b);
    kod_v_kas=kodper;
   }
/*
  printw("shet=%s shet_per_b=%s\n",shet,shet_per_b);
  OSTANOV();
  return;
*/
 }
memset(bros,'\0',sizeof(bros));

uhsl=0; /*Учет сальдо включен*/
if(iceb_t_poldan("Учет сальдо в распечатке",bros,"zarnast.alx") == 0)
 if(SRAV(bros,"Вкл",1) != 0)
   uhsl=1;  /*Учет сальдо выключен*/

VVOD DANET(1);
DANET.VVOD_SPISOK_add_MD(gettext("С учетом сальдо ?"));

if(uhsl == 1)
 {
 if(danet(&DANET,2,stdscr) == 1)
  uhsl=0; /*Учет сальдо включен*/
 }
else
 if(danet(&DANET,2,stdscr) == 2)
  uhsl=1;/*Учет сальдо выключен*/

uder=2; /*Удержания не выполнять*/
if(dp != 0)
 {
  
  DANET.VVOD_delete();
  DANET.VVOD_SPISOK_add_MD(gettext("Выполнить удержания ?"));
  uder=danet(&DANET,2,stdscr);

  if(iceb_t_pbpds(mp,gp) != 0)
   goto naz;

 }
 
clear();

time(&tmm);
bf=localtime(&tmm);
printw("%s:%.2f\n",gettext("Максимальная сумма"),dmaxsum);  
printw("%s\n",gettext("Сортируем записи."));
refresh();
sprintf(strsql,"select tabn,podr,kateg from Zarn where god=%d and mes=%d \
order by podr,tabn asc",
gr,mr);
SQLCURSOR cur;
if((kolstr2=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr2 == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }


sprintf(imafprot,"send%d.lst",getpid());


if((ff1 = fopen(imafprot,"w")) == NULL)
 {
  error_op_nfil(imafprot,errno,"");
  return;
 }
startfil(ff1);


//Вывод шапки
hpzrs(mr,gr,ff1);

kolstr1=0;
podr=0;
sal=itogo=itogoo=0.;
nomer=kolz=kolstr1=0;
double viplata=0.;
double vid_zar=0.; //Уже выданная зарплата при расчёте с учётом сальдо
double vid_zar_b=0.; //Уже выданная бюджетная зарплата при расчёте с учётом сальдо
int kod_zap=0;
char shet_zap[20];
char shet_zap_b[20];
class SQLCURSOR cur1;

while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr2,++kolstr1);

  if(proverka(tabel,row[0],0,0) != 0)
    continue;

  if(proverka(podrz,row[1],0,0) != 0)
    continue;

  if(proverka(kateg,row[2],0,0) != 0)
    continue;

  if(grupap[0] != '\0')
   {
    sprintf(strsql,"select grup from Podr where kod=%s",row[1]);
    if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
     if(proverka(grupap,row1[0],0,0) != 0)
       continue;
   }

  tabb=atol(row[0]);
  podr=atoi(row[1]);


  memset(inn,'\0',sizeof(inn));

  sprintf(strsql,"select fio,bankshet,inn from Kartb where tabn=%d",tabb);
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    beep();
    printw("%s %d !\n",gettext("Не найден табельный номер"),tabb);
    OSTANOV();
    continue;
   }
  strncpy(fio,row1[0],sizeof(fio)-1);
  strncpy(inn,row1[2],sizeof(inn)-1);
  strncpy(bankshet,row1[1],sizeof(bankshet)-1);
  if(bankshet[0] == '\0')
   {
    strcpy(shet_zap,shet_v_kas);
    strcpy(shet_zap_b,shet_v_kas_b); //это пока не сделано
    kod_zap=kod_v_kas;
   }
  else
   {
    strcpy(shet_zap,shet_per);
    strcpy(shet_zap_b,shet_per_b);
    kod_zap=kodper;
   }   
  sal=0.;
  /*Читаем сальдо*/

  sal=zarsald(1,mr,gr,tabb,&saldb);
  itsal+=sal;
  if(sal < 0. && uhsl == 1)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Внимание ! Отрицательное сальдо !"));
    sprintf(strsql,"%s:%d %s",gettext("Табельный номер"),tabb,fio);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }


  sprintf(strsql,"select datz,prn,knah,suma,godn,mesn,shet \
from Zarp where datz >= '%04d-%02d-01' and datz <= '%04d-%02d-31' and \
tabn=%d and suma != 0. order by prn,knah asc",
  gr,mr,gr,mr,tabb);
  if((kolstr=cur1.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }

  if(kolstr == 0)
    continue;

  in1=inah=nahshet=iu=ins=ius=ius1=iub=iusb=0.;

  vid_zar=0.; //Уже выданная зарплата при расчёте с учётом сальдо
  vid_zar_b=0.; //Уже выданная бюджетная зарплата при расчёте с учётом сальдо
  im=0;
  while(cur1.read_cursor(&row1) != 0)
   {

/*
    printw("%s %s %s %s %s %s %s %s\n",
    row[0],row[1],row[2],row[3],row[4],row[5],row[6],row[7]);
*/
    
    prn=atoi(row1[1]);

    if(prn == 1)
     {
      if(proverka(kodn,row1[2],0,1) == 0)
        continue;
     }

    knah=atoi(row1[2]);
    sym=atof(row1[3]);
    gz=atoi(row1[4]);
    mz=atoi(row1[5]);

    if(prn == 1)
     {
      in1+=sym;
      inah+=sym;
      ins+=sym;
      if(proverka(shetb,row1[6],0,1) == 0)
         nahshet+=sym;
     }

    if(prn == 2)
     {
      iu+=sym;
      if(proverka(shetbu,row1[6],0,1) == 0)
         iub+=sym;
      
      if(gz == gr && mz == mr)
       {
	ius+=sym;
        if(proverka(shetbu,row1[6],0,1) == 0)
          iusb+=sym;
       }
      else
       {
        if(provkod(obud,knah) >= 0)
         {
          ius+=sym;
          if(proverka(shetbu,row1[6],0,1) == 0)
            iusb+=sym;
         }
       }


     }


    im++;

   }

  if(im > 0 || sal != 0.)
   {



    if(uhsl == 0) /*Без учёта сальдо*/
     {
      //При расчёте ведомости этой проверки на выданную зарплату нет так как
      //нам нужно получить ведомость без учёта уже выданной зарплаты
//      vid_zar=prbper(mr,gr,bf->tm_mon+1,bf->tm_year+1900,tabb,&vid_zar_b,1);
      vid_zar=zarpv(mr,gr,(int)tabb,&iusb1);
      bbr=in1+iu+sal+vid_zar;
//      printw("%f+%f+%f+%f=%f\n",in1,iu,sal,vid_zar,bbr);

     }

    if(uhsl == 1) /*C yчётом сальдо*/
     {
      ius1=prbper(mr,gr,bf->tm_mon+1,bf->tm_year+1900,tabb,&iusb1,0,NULL);

//      ius1=zarpv(mr,gr,(int)tabb,&iusb1);

      bbr=in1+ius+ius1;
     }

    if(bbr > 0.009)
     {


      viplata=bbr;
      if(proc_vipl != 100.)
       {
        viplata=bbr*proc_vipl/100.;
        viplata=okrug(viplata,okrg);
        }
      if(dmaxsum > 0.009) 
       if(viplata > dmaxsum)
        viplata=dmaxsum;

      kolz++;
      printw("%4d %-5ld %8.2f %-20s %s\n",podr,tabb,viplata,bankshet,fio);
      refresh();

      itogo+=viplata;
            
      strsen(++nomer,inn,bankshet,fio,viplata,ff1);

      if(dp != 0 && uder == 1)
       {
        /*Проверяем записан ли стандартный набор*/
        provzzag(mp,gp,tabb,2,podr);
        zp.dz=dp;
        zp.mesn=mr; zp.godn=gr;
        zp.nomz=0;
        zp.podr=podr;
       }

      bb=0.;     

      if(shetbu != NULL && dmaxsum < 0.01 && shet_zap_b[0] != '\0')
       {
       
        if(uhsl == 0 ) /*С учетом сальдо*/
         {
          bb=bbr-(nahshet+iub+saldb+vid_zar_b);

         }               
       
        if(uhsl == 1 ) /*Без учета сальдо*/
         {
          bb=in1-nahshet+(ius-iusb)+(ius1-iusb1);
         }

        bb=bbr-bb;
        if(bb != 0.)
         {
          fprintf(ff1,"%4s %-5s %8.2f/%.2f %s/%s\n",
          " "," ",bb,bbr-bb,shet_zap_b,shet_zap);
         }       

        if(metkaras == 0 || metkaras == 2)
        if(dp != 0 && uder == 1)
        if(bb > 0.)
         {
          strcpy(zp.shet,shet_zap_b);
          viplata=bb;
          if(proc_vipl != 100.)
           {
            viplata=bb*proc_vipl/100.;
            viplata=okrug(viplata,okrg);
            }

          if(dmaxsum > 0.009) 
           if(viplata > dmaxsum)
            viplata=dmaxsum;
         
          zapzarp(dp,mp,gp,tabb,2,kod_zap,viplata*-1,shet_zap_b,mr,gr,0,0,"***",podr,"",zp); 
         }
       }
      if(metkaras == 0 || metkaras == 1)
      if(dp != 0 && uder == 1)
       {
        bb=bbr-bb;
     
        /*Записываем код перечисления*/
        if(bb > 0.)
         {
//          printw("%d.%d.%d %d %d.%d %f\n",dp,mp,gp,tabb,mr,gr,bb);
          strcpy(zp.shet,shet_zap);
          viplata=bb;
          if(proc_vipl != 100.)
           {
            viplata=bb*proc_vipl/100.;
            viplata=okrug(viplata,okrg);
           }

          if(dmaxsum > 0.009) 
           if(viplata > dmaxsum)
            viplata=dmaxsum;

          if(zapzarp(dp,mp,gp,tabb,2,kod_zap,viplata*-1,shet_zap,mr,gr,0,0,"***",podr,"",zp) != 0)
            printw("Ошибка ввода записи !!!\n");

         }
       }
      //Делаем проводки
      zaravpr(tabb,mp,gp,NULL);

     }

   }


 }

GDITE();

itogoo+=itogo;

//Вывод концовки файла
zsitog(nomer,itogoo,ff1);


printw("%s: %.2f\n",
gettext("Общий итог"),itogoo);
printw_vr(tmm);

OSTANOV();
//rabfil(gettext("Протокол разноски заработной платы."),imafprot);
class spis_oth oth;
oth.spis_imaf.plus(imafprot);
oth.spis_naim.plus(gettext("Протокол разноски заработной платы."));
iceb_t_rabfil(&oth,"");

}


/**********************************/
/*Шапка                           */
/**********************************/

void	hpzrs(short mr,short gr,FILE *ff1)
{

fprintf(ff1,"\x1b\x6C%c",5); /*Установка левого поля*/
fprintf(ff1,"\x1B\x4D"); /*12-знаков*/
//fprintf(ff1,"\x0F");  /*Ужатый режим*/

zagolov(gettext("Протокол разноски заработной платы."),0,0,0,0,mr,gr,organ,ff1);
/*************
fprintf(ff1,"\
                            С П И С О К   N     від        \n\
           на зарахуванння заробітної плати робітників %s\n\
         за            перерахованої в БВ N3 філії \n\
        \"Вінницьке Центральне відділення Промінвестбанку\"\n\
           згідно платіжного доручення N %s від %02d.%02d.%dр.\n\n",
organ,platpor,dp,mp,gp);
****************/

fprintf(ff1,"\
-------------------------------------------------------------------------------\n");

fprintf(ff1,gettext("\
Ном.|Идентефик.|     Номер          |   Фамилия Имя Отчество       |  Сумма   |\n\
п/п |  номер   | карточного счёта   |                              |          |\n"));
//              12345678901234567890 123456789012345678901234567890 

fprintf(ff1,"\
-------------------------------------------------------------------------------\n");


}

/*************/
/*Вывод строки*/
/**************/

void	strsen(int nomer,char *inn,char *bankshet,char *fio,double bbr,FILE *ff1)
{

fprintf(ff1,"%4d %-10s %-20s %-30.30s %10.2f\n",
nomer,inn,bankshet,fio,bbr);

}

/****************************/
/*Вывод концовки распечатки */
/****************************/

void    zsitog(int nomer,double itogoo,FILE *ff1)
{

fprintf(ff1,"\
-------------------------------------------------------------------------------\n");
fprintf(ff1,"%67s:%10.2f\n",gettext("Итого"),itogoo);

/**********
fprintf(ff1,"Кількість одержувачів коштів: %d чоловік\n",nomer);

memset(strsql,'\0',sizeof(strsql));
preobr(itogoo,strsql,0);

fprintf(ff1,"На суму:%s\n\n",strsql);
***************/

podpis(ff1);

fprintf(ff1,"\x1b\x6C%c",1); /*Установка левого поля в ноль*/
fprintf(ff1,"\x12");
fprintf(ff1,"\x1B\x50"); /*10-знаков*/

fclose(ff1);

}
