/* $Id: zarspek.c,v 5.40 2011-02-04 11:32:38 sasa1 Exp $ */
/*23.12.2010	15.12.1998 	Белых А.И.	zarspek.c
Получение спектра начисления зарплаты
*/
#include        <time.h>
#include        <errno.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


extern short    mmm,ggg; /*Месяц год*/
extern char     *organ;
extern short    *knvr;/*Коды начислений не входящие в расчет подоходного налога*/
extern short	*kodnvpen; /*Коды не входящие в расчет пенсионного отчисления*/
extern short    kodpen;  /*Код пенсионных отчислений*/
extern double	ogrzp[2]; /*Разграниечение зарплаты для расчета пенсионных*/
extern short    kodsocstr;  /*Код отчисления на соц-страх*/
extern short	*kodsocstrnv; //Коды не входящие в расчет соцстраха
extern short    *kodmp;   /*Коды материальной помощи*/

int zarspek(class spis_oth *oth)
{
char		bros[512];
short		par;
short		kold;/*Количество диапазонов*/
int		nd,ndz;  /*Номер диапазона*/
double		*md; /*Массив диапазонов*/
short		m,g;
int		i,i1;
char		imaf[32],imaf1[32],imaf2[32];
FILE		*ff,*ff1,*ff2;
double		sumn,itog;
long		tabn,tbn;
long		np;
struct  tm      *bf;
time_t          tmm;
static char	spek[1024];
static char     kodnr[512];
static char	podr[512];
static char	dat1[8];
char		kodnr1[56];
char		naimp[512];
long		kolstr,kolstr1,kolstr2;
SQL_str         row,row1;
char		strsql[512];
int		kom1;
int		knah;
double		sym;
short		metkanvr=0;
short		metkaras=0;
double		sumapens=0.;
double		nmatpom=0.,inmatpom=0.,matpom=0.;
double		matpomb=0.;
int		klst=0;

if(dat1[0] == '\0')
 sprintf(dat1,"%d.%d",mmm,ggg);
VVOD MENU(3);
VVOD VV(0);

VV.VVOD_SPISOK_add_MD(gettext("Спектр..(,,)................"));
VV.VVOD_SPISOK_add_MD(gettext("Дата..(м.г)................."));
VV.VVOD_SPISOK_add_MD(gettext("Подразделение..........(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Коды не вход. в расчет.(,,)."));

VV.VVOD_SPISOK_add_ZAG(gettext("Расчет спектра распределения зарплаты"));
VV.VVOD_SPISOK_add_data(spek,128);
VV.VVOD_SPISOK_add_data(dat1,8);

VV.VVOD_SPISOK_add_data(podr,sizeof(podr));
VV.VVOD_SPISOK_add_data(kodnr,sizeof(kodnr));

naz:;

clear();


helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F5/-",gettext("расчет"),
"F10",gettext("выход"),NULL);

//par=vvod(&LL,0,1,3);
par=VV.vvod(0,1,1,-1,-1);

strncpy(spek,VV.VVOD_SPISOK_return_data(0),sizeof(spek)-1);
strncpy(dat1,VV.VVOD_SPISOK_return_data(1),sizeof(dat1)-1);
strncpy(podr,VV.VVOD_SPISOK_return_data(2),sizeof(podr)-1);
strncpy(kodnr,VV.VVOD_SPISOK_return_data(3),sizeof(kodnr)-1);
sprintf(kodnr1,"-,%s",kodnr);

switch(par)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp4_7_2.txt");
   goto naz;

  case FK10:
  case ESC:
    return(1);

  case FK2:
  case PLU:
    metkanvr=0;
    break;   

  case FK5:
  case OTN:
    metkanvr=1;
    break;   

  case FK3:
    MENU.VVOD_delete();

    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка начислений"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 2 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Podr",podr,sizeof(podr),naimp);
        VV.VVOD_SPISOK_zapis_data(2,podr);
        goto naz;

      case 1 :
        vibrek("Nash",kodnr,sizeof(kodnr),naimp);
        VV.VVOD_SPISOK_zapis_data(3,kodnr);
        goto naz;

     }
    goto naz;

  case FK4:
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
 }

if(metkanvr == 0)
if(ATOFM(dat1) == 0.)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введен спектр распределения зарплаты !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 } 
if(rsdat1(&m,&g,dat1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

//читаем настройки
zar_read_tn(1,m,g,NULL);

if(metkanvr == 1)
 {
  clearstr(LINES-1,0);
  MENU.VVOD_delete();

  MENU.VVOD_SPISOK_add_MD(gettext("Рассчет спектра рапределения пенсионного начисления"));
  MENU.VVOD_SPISOK_add_MD(gettext("Рассчет спектра рапределения начисления соц-страха"));
  MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
pov:;
  kom1=0;
  while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);
  switch (kom1)
   {
    case 2 :
    case -1 :
     goto naz;

    case 0 :
     metkaras=kom1+1;
     sprintf(spek,"%.2f,%.2f",ogrzp[0],ogrzp[1]);
     break;

    case 1 :
     metkaras=kom1+1;
     sprintf(spek,"%.2f,%.2f",ogrzp[0],ogrzp[1]);
     break;

    default:
      goto pov;
   }
 }
 
time(&tmm);
bf=localtime(&tmm);


clear();
GDITE();
if(metkaras == 1)
  printw("%s\n",gettext("Рассчет спектра рапределения пенсионного начисления"));
if(metkaras == 2)
  printw("%s\n",gettext("Рассчет спектра рапределения начисления соц-страха"));

kold=pole2(spek,',');
if(kold == 0)
 kold=2;
else
 kold++;
  
printw("Кількість діапазонів - %d\n",kold);
refresh();
if((md=(double *)calloc(kold,sizeof(double))) == NULL)
 {
  beep();
  printw("Не могу выделить память для md !!!");
  OSTANOV();
  return(1);
 }

/*Заряжаем массив*/
if(kold == 2)
 {
  md[0]=ATOFM(spek);
  printw("%d %.2f\n",1,md[0]);
 }
else 
 for(i=0; i < kold ;i++ )
  {
   if(POLE(spek,bros,i+1,',') != 0)
    break;
   md[i]=ATOFM(bros);
   printw("%d %.2f\n",i+1,md[i]);
  }
sprintf(strsql,"select tabn,podr from Zarn where god=%d and mes=%d",
g,m);
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

sprintf(imaf,"spk%d.tmp",getpid());

if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return(1);
   }
SQLCURSOR curr;
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  
  if(proverka(podr,row[1],0,0) != 0)
    continue;

  tbn=atol(row[0]);  

  if(metkanvr == 1)
   {
    if(metkaras == 1)
     sprintf(strsql,"select knah from Zarp where \
datz >= '%d-%02d-01' and datz <= '%d-%02d-31' and tabn=%ld and prn='2' \
and knah=%d",g,m,g,m,tbn,kodpen);

    if(metkaras == 2)
     sprintf(strsql,"select suma from Zarp where \
datz >= '%d-%02d-01' and datz <= '%d-%02d-31' and tabn=%ld and prn='2' \
and knah=%d",g,m,g,m,tbn,kodsocstr);
    if(sql_readkey(&bd,strsql,&row1,&curr) == 0)
     {
      char fio[512];
      memset(fio,'\0',sizeof(fio));
      sprintf(strsql,"select fio from Kartb where tabn=%ld",tbn);
      if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
        strncpy(fio,row1[0],sizeof(fio)-1);

      printw("%s %s нет удержания\n",row[0],fio);

      if(metkaras == 2)
       {
        if(zarprtn(m,g,tabn,"zarpens.alx",NULL) != 0)
         {
          printw("Пенсионер !\n");
          goto vpered;
         }
       }
      continue;
     }
    if(atof(row1[0]) == 0.)
     {
      char fio[512];
      memset(fio,'\0',sizeof(fio));
      sprintf(strsql,"select fio from Kartb where tabn=%ld",tbn);
      if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
        strncpy(fio,row1[0],sizeof(fio)-1);
      printw("%s %s Нулевая сумма !\n",row[0],fio);
     }
   }

vpered:;

  sumn=0.;

  sprintf(strsql,"select knah,suma from Zarp where datz >= '%d-%02d-01' and \
datz <= '%d-%02d-31' and tabn=%ld and prn='1' and suma <> 0.",
  g,m,g,m,tbn);
  SQLCURSOR cur1;
  if((kolstr2=cur1.make_cursor(&bd,strsql)) < 0)
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

  if(kolstr2 == 0)
    continue;
  matpom=0.;
  while(cur1.read_cursor(&row1) != 0)
   {
    if(proverka(kodnr1,row1[0],0,0) != 0)
     continue;
    knah=atoi(row1[0]);
    sym=atof(row1[1]);
   
    if(metkanvr == 1)
     {
      if(kodmp != NULL)
      for(i1=1; i1<= kodmp[0]; i1++)
       if(kodmp[i1] == knah)
         matpom+=sym;

      if(knvr != NULL)
      for(i1=1; i1<= knvr[0]; i1++)
       if(knvr[i1] == knah)
         goto vper;

      if(metkaras == 1)
       if(kodnvpen != NULL)
        for(i1=1; i1<= kodnvpen[0]; i1++)
         if(kodnvpen[i1] == knah)
          goto vper;

      if(metkaras == 2)
       if(kodsocstrnv != NULL)
        for(i1=1; i1<= kodsocstrnv[0]; i1++)
         if(kodsocstrnv[i1] == knah)
          goto vper;
      }              
    sumn+=sym;
vper:;

   }

  if(sumn != 0)
   {
    nmatpom=0.;
    if(metkanvr == 1 && matpom != 0.)
     {
      nmatpom=0.;
      double suma_blag_pom,suma_blag_pom_b;
      nmatpom=matpom1(tbn,m,g,kodmp,NULL,1,&matpomb,0,&suma_blag_pom,&suma_blag_pom_b);
      sumn-=nmatpom;
      inmatpom+=nmatpom;
     }
    for(nd=0; nd < kold; nd++)
     {
      if(md[nd] == 0.)
        break;
      if(sumn <= md[nd])
       break;
     }  
    fprintf(ff,"%d %.2f %ld\n",nd,sumn,tbn);
    if(nmatpom != 0.)
      printw("%ld %s:%.2f\n",
      tbn,
      gettext("Не облагаемая материальная помощь"),
      nmatpom);
      
    if(zarprtn(m,g,tbn,"zarpens.alx",NULL) != 0)
     {
/******************
      char fio[512];
      memset(fio,'\0',sizeof(fio));
      sprintf(strsql,"select fio from Kartb where tabn=%ld",tbn);
      if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
        strncpy(fio,row1[0],sizeof(fio)-1);
      printw("Пенсионер %ld %s = %.2f\n",tbn,fio,sumn);
*****************/
      sumapens+=sumn;
     }
   }
 }

fclose(ff);

//sprintf(bros,"sort -o %s -n +0 -1 +1 -2 %s",imaf,imaf);
sprintf(bros,"sort -o %s -n -k1,2 -k2,3 %s",imaf,imaf);
runsystem(bros);


if((ff = fopen(imaf,"r")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return(1);
   }

sprintf(imaf1,"spk%d.lst",getpid());
if((ff1 = fopen(imaf1,"w")) == NULL)
   {
    error_op_nfil(imaf1,errno,"");
    return(1);
   }

sprintf(imaf2,"spki%d.lst",getpid());
if((ff2 = fopen(imaf2,"w")) == NULL)
   {
    error_op_nfil(imaf2,errno,"");
    return(1);
   }


fprintf(ff1,"%s\n",organ);
fprintf(ff2,"%s\n",organ);

if(spek[0] != '\0')
 {
  fprintf(ff1,"Спектр : %s\n",spek);
  fprintf(ff2,"Спектр : %s\n",spek);
 }

if(VV.VVOD_SPISOK_return_data(1)[0] != '\0')
 {
  fprintf(ff1,"Дата : %s\n",VV.VVOD_SPISOK_return_data(1));
  fprintf(ff2,"Дата : %s\n",VV.VVOD_SPISOK_return_data(1));
 }
if(podr[0] != '\0')
 {
  fprintf(ff1,"%s:%s\n",gettext("Коды подразделений вошедшие в расчет"),podr);
  printcod(ff1,"Podr","kod","naik",0,podr,&klst);
  fprintf(ff2,"%s:%s\n",gettext("Коды подразделений вошедшие в расчет"),podr);
  printcod(ff2,"Podr","kod","naik",0,podr,&klst);
 }
else
 {
  fprintf(ff1,gettext("По всем подразделениям.\n"));
  fprintf(ff2,gettext("По всем подразделениям.\n"));
 }
if(VV.VVOD_SPISOK_return_data(3)[0] != '\0')
 {
  fprintf(ff1,"%s: %s\n",
  gettext("Коды не вошедшие в расчет"),VV.VVOD_SPISOK_return_data(3));
  fprintf(ff2,"%s: %s\n",
  gettext("Коды не вошедшие в расчет"),VV.VVOD_SPISOK_return_data(3));
 }

if(metkanvr == 1)
 {
  if(metkaras == 1)
   {
    fprintf(ff2,"%s\n",gettext("Рассчет спектра рапределения пенсионного начисления"));
    fprintf(ff1,"%s\n",gettext("Рассчет спектра рапределения пенсионного начисления"));
   }
  if(metkaras == 2)
   {
    fprintf(ff2,"%s\n",gettext("Рассчет спектра рапределения начисления соц-страха"));
    fprintf(ff1,"%s\n",gettext("Рассчет спектра рапределения начисления соц-страха"));
   }
  fprintf(ff1,"%s:\n",
  gettext("Коды не вошедшие в расчет"));
  fprintf(ff2,"%s:\n",
  gettext("Коды не вошедшие в расчет"));

  memset(strsql,'\0',sizeof(strsql));
  
  if(knvr != NULL)
   for(i=1; i <= knvr[0]; i++)
    {
     sprintf(bros,"%d,",knvr[i]);
     strcat(strsql,bros);
    }  

  if(metkaras == 1)
   if(kodnvpen != NULL)
    for(i=1; i <= kodnvpen[0]; i++)
     {
      sprintf(bros,"%d,",kodnvpen[i]);
      strcat(strsql,bros);
     }  

  if(strsql[0] != '\0')
   {
    printcod(ff1,"Nash","kod","naik",0,strsql,&klst);
    printcod(ff2,"Nash","kod","naik",0,strsql,&klst);
   }
 }
fprintf(ff1,"\
%s %d.%d.%d%s  %s: %d:%d\n",
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

fprintf(ff1,"----------------------------------------------------------\n");

fprintf(ff2,"\
%s %d.%d.%d%s  %s: %d:%d\n",
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

fprintf(ff2,"----------------------------------------------------------\n");
 
itog=0.;
ndz=-1;
nd=np=0;
kolstr1=0;

while(fscanf(ff,"%d %lf %ld\n",&nd,&sumn,&tabn) != EOF)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(nd != ndz)
   {
    if(ndz != -1)
     { 
      printw("%s: %ld %s: %.2f\n",
      gettext("Количество работников"),
      np,gettext("Сумма (грн)"),itog);
      fprintf(ff2,"%s: %ld %s: %.2f\n",
      gettext("Количество работников"),
      np,gettext("Сумма (грн)"),itog);

      fprintf(ff1,"%50s: %10.2f\n",gettext("Итого"),itog);
     }
    if(md[nd] != 0)
     {
      if(nd == 0)
       {
        printw(gettext("Диапазон до %.2f включительно"),md[nd]);
        fprintf(ff2,gettext("Диапазон до %.2f включительно"),md[nd]);
        fprintf(ff1,gettext("Диапазон до %.2f включительно"),md[nd]);
       }
      if(nd != 0 )
       {
        printw(gettext("Диапазон от %.2f до %.2f включительно"),
        md[nd-1],md[nd]);
        fprintf(ff2,gettext("Диапазон от %.2f до %.2f включительно"),
        md[nd-1],md[nd]);
        fprintf(ff1,gettext("Диапазон от %.2f до %.2f включительно"),
        md[nd-1],md[nd]);
       }
      fprintf(ff1,"\n");
      fprintf(ff2,"\n");
      printw("\n");
       
     }
    else
     {
      printw("%s %.2f\n",gettext("Диапазон больше"),md[nd-1]);
      fprintf(ff1,"%s %.2f\n",
      gettext("Диапазон больше"),md[nd-1]);
      fprintf(ff2,"%s %.2f\n",
      gettext("Диапазон больше"),md[nd-1]);
     }
    ndz=nd;
    itog=0.;
    np=0;
   }  

  sprintf(strsql,"select fio from Kartb where tabn=%ld",tabn);
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    beep();
    printw("%s %ld !\n",
    gettext("Не найден табельный номер"),tabn);
    OSTANOV();
    continue;
   }
  np++;
  fprintf(ff1,"%4ld %-5ld %-*s %10.2f\n",
  np,tabn,
  iceb_tu_kolbait(40,row1[0]),row1[0],
  sumn);
  itog+=sumn;
 }

printw("%s: %d %s: %.2f\n",
gettext("Количество работников"),
np,gettext("Сумма (грн)"),itog);

fprintf(ff2,"%s: %ld %s: %.2f\n",
gettext("Количество работников"),
np,gettext("Сумма (грн)"),itog);

if(metkanvr == 1)
 {
  printw("%s:%.2f\n",
  gettext("Не облагаемая материальная помощь"),  
  inmatpom);
  fprintf(ff2,"%s:%.2f\n",
  gettext("Не облагаемая материальная помощь"),
  inmatpom);
 }
if(metkaras == 2)
 {
  printw("Пенсионеры:%.2f\n",sumapens);
  fprintf(ff2,"Пенсионеры:%.2f\n",sumapens);
 }
fprintf(ff1,"%*s: %10.2f\n",iceb_tu_kolbait(50,gettext("Итого")),gettext("Итого"),itog);

fclose(ff1);
fclose(ff2);
fclose(ff);

unlink(imaf);
OSTANOV();

oth->spis_imaf.plus(imaf1);
oth->spis_naim.plus(gettext("Спектр распределения зарплаты"));
oth->spis_imaf.plus(imaf2);
oth->spis_naim.plus(gettext("Общие итоги"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),3);

return(0);
}
