/* $Id: zarsprpr.c,v 5.60 2011-03-28 06:53:59 sasa Exp $ */
/*11.11.2010    31.08.1994      Белых А.И.      zarsprpr.c
получение справки всех начислений и удержаний
за любой период
*/
#include        <errno.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void             rekvizkon(SQL_str,FILE*);
int zarsprpr_sub_start(short god,const char *kedrpou,const char *fio,const char *inn,const char *dolg,const char *adres,FILE *ff_ras);
int zarsprpr_sub_end(short mn,short gn,short mk,short gk,double suma,FILE *ff_ras);
void zarsprpr_zag(short mn,short gn,short mk,short gk,const char *harac,const char *fam,const char *inn,const char *dolg,const char *podr,int sovm,FILE *ff2);

extern short    ddd,mmm,ggg;
extern char     *organ;/*Наименование организации*/
//extern short    kodpn;   /*Код подоходного налога*/
extern class iceb_tu_str kodpn_all;
extern short    kodpen;  /*Код пенсионных отчислений*/
extern short    *kodmp;   /*Коды материальной помощи*/
extern double   snmpz; /*Сумма не облагаемой материальной помощи заданная*/
extern char     *shetb; /*Бюджетные счета начислений*/
extern char	*shetbu; /*Бюджетные счета удержаний*/
extern short    kodbzr;  /*Код отчисления на безработицу*/
extern short	*obud; /*Обязательные удержания*/
extern short    kodsocstr;  /*Код отчисления на соц-страх*/
extern short	kodindex;  /*Код индексации*/

int zarsprpr(long tabn,
short mn,short gn,
short mk,short gk,class spis_oth *oth)
{
struct  tm      *bf;
time_t		tmr;
char            bros[512];
char            str[1024];
short           koltb; /*Количество видов табелей*/
FILE            *ff,*ff1,*ff2,*ff3,*ff_stud;
char            imaf[32],imaf1[32],imaf2[32],imafpen[32],imafshet[40];
char imaf_stud[32];
short           m,g;
double          inah,iuder;
double		inahb; //Итого начислено без кодов не входящих в расчет подоходного налога
double          ino,inob,iuo,bb;
short           kon;     /*Количество статей начисления*/
short           kou;     /*Количество статей удержания*/
char            nai[512];
long            ll;
int             i,i1;
double		peno;  /*Пенсионное отчисление*/
double		ipeno;  /*Итого Пенсионное отчисление*/
double          podoh; /*Подоходный налог за месяц*/
double          ipodoh; /*Подоходный налог за год*/
char            fam[512];
char            fambuh[512];
double          sld;
double          skm,iskm;
double          alim,ialim;
double		fbezr,ifbezr;
short           idn,ikdn;
double          ihas;
short           fo;
short           sovm; /*0-нет 1- Совместитель*/
double		sal;
long		kolstr;
SQL_str         row,row1;
char		strsql[512];
int		kodt;
float		dnei,has,kdnei;
short		prn;
int		knah;
double		sym;
short		dz,mz,gz;
char		inn[32];
short		ots=5;
char		dolg[512];
char		mescc[32];
short		kodalim;
double		saldb;
char		harac[512];
char		shet[32];
char		kodnvrspr[312];
double          soc_strax=0.;
double          isoc_strax=0.;
double suma_indeks=0.;
double isuma_indeks=0.;
class iceb_tu_str kedrpou("");
char podr[32];
char naim_mes[64];
SQLCURSOR curr;

sprintf(strsql,"select fio,sovm,inn,dolg,harac,podr from Kartb where tabn=%ld",tabn);
if(readkey(strsql,&row,&curr) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %ld !",
  gettext("Не найден табельный номер"),tabn);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }


strncpy(fam,row[0],sizeof(fam)-1);
strncpy(inn,row[2],sizeof(inn)-1);
strncpy(dolg,row[3],sizeof(dolg)-1);

memset(harac,'\0',sizeof(harac));
strncpy(harac,row[4],sizeof(harac)-1);

strncpy(podr,row[5],sizeof(podr)-1);

sovm=0;
if(row[1][0] == '1')
     sovm=1;

VVOD DANET(1);
fo=0;
DANET.VVOD_SPISOK_add_MD(gettext("Развернутый отчет ?"));

fo=danet(&DANET,2,stdscr);

clear();
GDITE();

bros[0]='\0';

iceb_t_poldan("Код удержания алиментов",bros,"zaralim.alx");

kodalim=atoi(bros);

kodnvrspr[0]='\0';
iceb_t_poldan("Коды начислений не входящие в справку о доходах",kodnvrspr,"zarnast.alx");

printw("%ld %s.\n",tabn,fam);
printw("%s\n",gettext("Создаем нужные массивы"));
refresh();
/*Определяем количество начислений и удержаний*/
sprintf(strsql,"select kod from Nash");
class SQLCURSOR cur;
if((kon=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kon == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены начисления !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

masiv_din_int MKN; //Массив кодов начислений
i=0;
while(cur.read_cursor(&row) != 0)
  MKN.plus(atoi(row[0]),-1);

sprintf(strsql,"select kod from Uder");

if((kou=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kou == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены удержания !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

masiv_din_int MKU; //Массив кодов удержаний

i=0;
while(cur.read_cursor(&row) != 0)
  MKU.plus(atoi(row[0]),-1);

sprintf(strsql,"select kod from Tabel");

if((koltb=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(koltb == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены виды табеля !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

masiv_din_int MKVT; //Массив кодов видов табеля

i=0;
while(cur.read_cursor(&row) != 0)
  MKVT.plus(atoi(row[0]),-1);


ll=kon;
masiv_din_double MSKN; //Массив содержимого кодов начислений
masiv_din_double MSKU; //Массив содержимого кодов удержаний
MSKN.make_class(kon);
MSKU.make_class(kou);

masiv_din_double DNI; //Массив количества рабочих дней
masiv_din_double KDNI; //Массив количества календарных дней
masiv_din_double HASI; //Массив количества отработанных часов
DNI.make_class(koltb);
KDNI.make_class(koltb);
HASI.make_class(koltb);

double suma_obud=0.; //Сумма обязательных удержаний за месяц
double suma_obudi=0.; //Сумма обязательных удержаний за период

char imaf_sub[56];

FILE *ff_sub;
sprintf(imaf_sub,"sub%ld.lst",tabn);
if((ff_sub = fopen(imaf_sub,"w")) == NULL)
 {
  error_op_nfil(imaf_sub,errno,"");
  return(1);
 }


sprintf(imaf,"sp1%ld.lst",tabn);
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

sprintf(imaf1,"sp2%ld.lst",tabn);
if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return(1);
 }

sprintf(imaf2,"sp3%ld.lst",tabn);
if((ff2 = fopen(imaf2,"w")) == NULL)
 {
  error_op_nfil(imaf2,errno,"");
  return(1);
 }
sprintf(imaf_stud,"sp_stud%ld.lst",tabn);
if((ff_stud = fopen(imaf_stud,"w")) == NULL)
 {
  error_op_nfil(imaf_stud,errno,"");
  return(1);
 }

sprintf(imafpen,"sp4%ld.lst",tabn);
if((ff3 = fopen(imafpen,"w")) == NULL)
 {
  error_op_nfil(imafpen,errno,"");
  return(1);
 }

char imaf_podoh[56];
FILE *ff_podoh;
sprintf(imaf_podoh,"spodoh%d.lst",getpid());
if((ff_podoh = fopen(imaf_podoh,"w")) == NULL)
 {
  error_op_nfil(imaf_podoh,errno,"");
  return(1);
 }

class iceb_tu_str adres("");
/*Читаем реквизиты организации*/
sprintf(bros,"select * from Kontragent where kodkon='00'");
if(readkey(bros,&row,&cur) != 1)
 {
  beep();
  printw("%s\n",gettext("Не найден контрагент с кодом 00 !"));
  OSTANOV();
 }
else
 {
  adres.new_plus(row[3]);
  rekvizkon(row,ff1);
  rekvizkon(row,ff2);
  rekvizkon(row,ff_stud);
  rekvizkon(row,ff3);
  rekvizkon(row,ff_podoh);
  kedrpou.new_plus(row[5]);
 }

zarsprpr_sub_start(gn,kedrpou.ravno(),fam,inn,dolg,adres.ravno(),ff_sub);
zarsprpr_zag(mn,gn,mk,gk,harac,fam,inn,dolg,podr,sovm,ff1);
zarsprpr_zag(mn,gn,mk,gk,harac,fam,inn,dolg,podr,sovm,ff3);
zarsprpr_zag(mn,gn,mk,gk,harac,fam,inn,dolg,podr,sovm,ff_podoh);
zarsprpr_zag(mn,gn,mk,gk,harac,fam,inn,dolg,podr,sovm,ff2);
zarsprpr_zag(mn,gn,mk,gk,harac,fam,inn,dolg,podr,sovm,ff_stud);

fprintf(ff1,"\
--------------------------------------------------------------------------------------\n");
fprintf(ff1,gettext("Месяц  | Начислено |В том числе|В том числе|Отчисления |Отчисл.в|Отчисл.в|Подоходный |\n"));
fprintf(ff1,gettext("       |           |благ.помощь|  алименты |в фонд без.|пенс.ф. |ф.соц-ст|   налог   |\n"));
fprintf(ff1,"\
--------------------------------------------------------------------------------------\n");
fprintf(ff3,"\
---------------------------------------------------------\n");
fprintf(ff3,gettext("Месяц  |   Начислено   |В том числе    |Пенсионное отчи-|\n"));
fprintf(ff3,gettext("       |               |мат. помощь    |   сление       |\n"));
fprintf(ff3,"\
---------------------------------------------------------\n");


fprintf(ff_podoh,"\
-----------------------------------------\n");
fprintf(ff_podoh,gettext("\
Месяц  |   Начислено   |Подоходный налог|\n"));
fprintf(ff_podoh,"\
-----------------------------------------\n");

fprintf(ff2,"\
%*s---------------------------------------------\n\
%*s%s\n\
%*s---------------------------------------------\n",
ots," ",
ots," ",gettext("|  Дата |   Начислено   |Удержано| Получено |"),
ots," ");

fprintf(ff_stud,"\
--------------------------------------\n");
fprintf(ff_stud,"\
|  Дата |   Начислено   | В том числe|\n\
|       |               | индексация |\n");
/*       123456789012345 123456789010*/
fprintf(ff_stud,"\
--------------------------------------\n");

if(fo == 1)
  fprintf(ff,"%ld %s\n\
%s %d.%d%s %s %d.%d%s\n",tabn,fam,
gettext("Период с"),
mn,gn,
gettext("г."),
gettext("до"),
mk,gk,
gettext("г."));

printw("\n%ld %s\n",tabn,fam);

//Создаем класс
masiv_din_char NASH('#');
masiv_din_double NASHD(0);
masiv_din_char UDER('#');
masiv_din_double UDERD(0);

ipodoh=ipeno=ihas=iskm=ialim=ifbezr=sld=ino=inob=iuo=0.;
idn=ikdn=0;
m=mn;
for(g=gn; g <=gk ; g++)
for(;  ; m++)
 {
  if(g == gk && m > mk)
   {
    break;
   }
  if(m == 13)
   {
    m=1;
    break;
   }

//NASH.print_masiv_char();

  soc_strax=peno=podoh=0.;
  if(fo == 1)
   fprintf(ff,"\
==========================================================\n\
%d.%d%s\n",m,g,gettext("г."));

  /*Ищем табель за месяц*/
  sprintf(strsql,"select kodt,dnei,has,kdnei from Ztab where god=%d and \
  mes=%d and tabn=%ld",g,m,tabn);
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }
  suma_obud=0.;
  if(kolstr != 0)
  while(cur.read_cursor(&row) != 0)
   {
    kodt=atoi(row[0]);
    dnei=atof(row[1]);
    has=atof(row[2]);
    kdnei=atof(row[3]);
    
    /*Читаем наименование табеля*/
    memset(nai,'\0',sizeof(nai));
    sprintf(strsql,"select naik from Tabel where kod=%d",
    kodt);
    nai[0]='\0';    
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      beep();
      printw("%s %s !\n",gettext("Не найден код табеля"),row[0]);
      OSTANOV();
     }
    else
      strncpy(nai,row1[0],sizeof(nai)-1);
    
    if(fo == 1)
     fprintf(ff,"%d %-*s %s%2.f %s%3.2f %s%2.f\n",
     kodt,
     iceb_tu_kolbait(40,nai),nai,
     gettext("д"),dnei,
     gettext("ч"),has,
     gettext("кд"),kdnei);

    if((i=MKVT.find(kodt)) != -1)
     {
      if((i=MKVT.find(kodt)) == -1)
       {
        beep();
        printw("%s %d %s ТН %ld %s %d.%d%s\n",
        gettext("Не найден код табеля"),kodt,
        gettext("для"),tabn,
        gettext("за"),m,g,
        gettext("г."));
        if(fo == 1)
         fprintf(ff,"%s %d %s ТН %ld %s %d.%d%s\n",
         gettext("Не найден код табеля"),kodt,
         gettext("для"),tabn,
         gettext("за"),m,g,
         gettext("г."));
        refresh();
       }
      else
       {
        DNI.plus((int)dnei,i);
        KDNI.plus((int)kdnei,i);
        HASI.plus(has,i);
       }
     }
   }

  if(fo == 1)
    fprintf(ff,"\
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");

  printw("%d.%d%s\n",m,g,gettext("г."));
  refresh();

  sal=zarsald(1,m,g,tabn,&saldb);

  sprintf(strsql,"select prn,knah,suma,datz,mesn,godn,kom,shet from \
Zarp where datz >= '%04d-%02d-01' and datz <= '%04d-%02d-31' and tabn=%ld \
and suma <> 0. order by prn,knah asc",
  g,m,g,m,tabn);

  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }


  if(m == 1)
   {
    sld=sal;
   }

  fbezr=alim=skm=inah=iuder=inahb=0.;

  suma_indeks=0.;
  if(kolstr != 0)
  while(cur.read_cursor(&row) != 0)
   {
    prn=atoi(row[0]);
    knah=atoi(row[1]);
    sym=atof(row[2]);
    rsdat(&dz,&mz,&gz,row[3],2);
    if(prn == 1)
     {
      if(kodindex == knah)
       {
        suma_indeks+=sym;
        isuma_indeks+=sym;
       }
      sprintf(strsql,"%d,%s",knah,row[7]);
      if((i1=NASH.find_masiv_char(strsql)) == -1)
       {
        NASH.add_masiv_char(strsql);
        NASHD.plus(sym,-1);
       }      
      else
       {
        NASHD.plus(sym,i1);
       }
      if((i=MKN.find(knah)) != -1)
        MSKN.plus(sym,i);

      inah+=sym;
      if(proverka(kodnvrspr,row[1],0,1) != 0)
        inahb+=sym;

      if(provkod(kodmp,knah) >= 0)
       {
	skm+=sym;
	iskm+=sym;
       }

     }

    if(prn == 2)
     {
      sprintf(strsql,"%d,%s",knah,row[7]);
      if((i1=UDER.find_masiv_char(strsql)) == -1)
       {
        UDER.add_masiv_char(strsql);
        UDERD.plus(sym,-1);
       }      
      else
       {
        UDERD.plus(sym,i1);
       }
      if((i=MKU.find(knah)) != -1)
        MSKU.plus(sym,i);

      iuder+=sym;
//      if(knah == kodpn)
      if(proverka(kodpn_all.ravno(),knah,0,1) == 0)
	podoh+=sym;
      if(knah == kodpen)
	peno+=sym;

      if(knah == kodsocstr)
       soc_strax+=sym;
       
      if(knah == kodalim)
       {
	alim+=sym;
	ialim+=sym;
       }

      if(knah == kodbzr)
       {
	fbezr+=sym;
	ifbezr+=sym;
       }

      if(provkod(obud,knah) >= 0)
       {
        suma_obud+=sym;
        suma_obudi+=sym;
       }
     }

    if(fo == 1)
     {
      /*Читаем наименование начисления*/
      if(prn == 1)
        sprintf(strsql,"select naik from Nash where kod=%d",knah);
      if(prn == 2)
        sprintf(strsql,"select naik from Uder where kod=%d",knah);
         
      if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
       {
        beep();
        if(prn == 1)
         printw("%s %s !\n",
         gettext("Не найден код начисления"),row[3]);
        if(prn == 2)
         printw("%s %s !\n",
         gettext("Не найден код удержания"),row[3]);
        OSTANOV();
        memset(nai,'\0',sizeof(nai));
       }
      else
        strncpy(nai,row1[0],sizeof(nai)-1);

      fprintf(ff,"%3d/%02d/%2s.%s %-*s : %10.2f %-*s %s\n",
      knah,dz,row[4],row[5],
      iceb_tu_kolbait(30,nai),nai,
      sym,
      iceb_tu_kolbait(6,row[7]),row[7],row[6]);

     }
/*
    printw("%-30s: %15.2f\n",zr4.nan,zr4.sym);
    refresh();
  */

   }


  sprintf(strsql,"select tabn from Zarn where god=%d and mes=%d and \
 tabn=%ld",g,m,tabn);
     
  if(strstrm(harac,gettext("Студент")) == 0)
   {
    if(sql_readkey(&bd,strsql,&row,&curr) == 1)
     {
      fprintf(ff1,"%02d.%d %11.2f %11.2f %11.2f %11.2f %8.2f %8.2f %11.2f\n",m,g,inahb,skm,alim*(-1),fbezr*-1,peno*-1,soc_strax*-1,podoh*(-1));
      fprintf(ff3,"%02d.%d %15.2f %15.2f %15.2f\n",m,g,inahb,skm,peno*(-1));
      fprintf(ff_podoh,"%02d.%d %15.2f %15.2f\n",m,g,inahb,podoh*(-1));
      fprintf(ff2,"%*s|%02d.%d|%15.2f|%8.2f|%10.2f|\n",ots," ",m,g,inahb,suma_obud,inahb+suma_obud);
      fprintf(ff_stud,"|%02d.%d|%15.2f|%12.2f|\n",m,g,inahb,suma_indeks);
     }
   }
  else
   {
    fprintf(ff1,"%02d.%d %11.2f %11.2f %11.2f %11.2f %8.2f %8.2f %11.2f\n",m,g,inahb,skm,alim*(-1),fbezr*-1,peno*-1,soc_strax*-1,podoh*(-1));
    fprintf(ff3,"%02d.%d %15.2f %15.2f %15.2f\n",m,g,inahb,skm,peno*(-1));
    fprintf(ff_podoh,"%02d.%d %15.2f %15.2f\n",m,g,inahb,podoh*(-1));
    fprintf(ff2,"%*s|%02d.%d|%15.2f|%8.2f|%10.2f|\n",ots," ",m,g,inahb,suma_obud,inahb+suma_obud);
    fprintf(ff_stud,"|%02d.%d|%15.2f|%12.2f|\n",m,g,inahb,suma_indeks);
   }
  memset(naim_mes,'\0',sizeof(naim_mes));
  mesc(m,0,naim_mes);

  fprintf(ff_sub,"|%-*.*s|%20.2f|%18.2f|%20.2f|\n",
  iceb_tu_kolbait(8,naim_mes),iceb_tu_kolbait(8,naim_mes),naim_mes,
  inahb,0.,alim*(-1));

  fprintf(ff_sub,"\
-----------------------------------------------------------------------\n");  

  if(fo == 1)
    fprintf(ff,"\
     %s %15.2f\n\
     %s %15.2f\n\
     %s %15.2f\n\
     %s %15.2f\n",
     gettext("Сальдо         :"),sal,
     gettext("Итого начислено:"),inah,
     gettext("Итого удержано :"),iuder,
     gettext("К выдаче       :"),inah+iuder+sal);
  ino+=inah;
  inob+=inahb;
  iuo+=iuder;
  ipodoh+=podoh;
  ipeno+=peno;
  isoc_strax+=soc_strax;
 }

printw("\
-------------------------------------------------\n\
%s %15.2f\n\
%s %15.2f\n\
%s %15.2f\n\
%s %15.2f\n",
gettext("Сальдо         :"),sld,
gettext("Итого начислено:"),ino,
gettext("Итого удержано :"),iuo,
gettext("К выдаче       :"),ino+iuo+sld);
refresh();

fprintf(ff_sub,"|%*.*s|%20.2f|%18.2f|%20.2f|\n",
iceb_tu_kolbait(8,gettext("Итого")),
iceb_tu_kolbait(8,gettext("Итого")),
gettext("Итого"),
ino,0.,ialim*(-1));

fprintf(ff_sub,"\
-----------------------------------------------------------------------\n");  

memset(str,'\0',sizeof(str));
preobr(inob,str,0);


fprintf(ff1,"\
--------------------------------------------------------------------------------------\n");

fprintf(ff1,"%*s %11.2f %11.2f %11.2f %11.2f %8.2f %8.2f %11.2f\n\n\
%s\n%-.*s\n",
iceb_tu_kolbait(7,gettext("Итого")),gettext("Итого"),inob,iskm,ialim*(-1),ifbezr*-1,ipeno*-1,isoc_strax*-1,ipodoh*(-1),
gettext("Общая сумма доходов:"),
iceb_tu_kolbait(60,str),str);

fprintf(ff3,"==========================================================\n\
%*s %15.2f %15.2f %15.2f\n\n\
%s\n%-.*s\n",
iceb_tu_kolbait(7,gettext("Итого")),gettext("Итого"),inob,iskm,ipeno*(-1),
gettext("Общая сумма доходов:"),
iceb_tu_kolbait(60,str),str);

fprintf(ff_podoh,"\
-----------------------------------------\n");
fprintf(ff_podoh,"%*s %15.2f %15.2f\n\n\
%s\n%-.*s\n",
iceb_tu_kolbait(7,gettext("Итого")),gettext("Итого"),inob,ipodoh*(-1),
gettext("Общая сумма доходов:"),
iceb_tu_kolbait(60,str),str);

if(iceb_tu_strlen(str) > 60)
 {
  fprintf(ff1,"%s\n",iceb_tu_adrsimv(60,str));
  fprintf(ff3,"%s\n",iceb_tu_adrsimv(60,str));
  fprintf(ff_podoh,"%s\n",iceb_tu_adrsimv(60,str));
 }

fprintf(ff2,"\
%*s---------------------------------------------\n\
%*s %*s %15.2f %8.2f %10.2f\n\n\
%s\n%s\n",
ots," ",
ots," ",
iceb_tu_kolbait(7,gettext("Итого")),gettext("Итого"),
inob,suma_obudi,inob+suma_obudi,
gettext("Общая сумма доходов:"),str);


fprintf(ff_stud,"\
--------------------------------------\n");
fprintf(ff_stud,"%*s %15.2f %12.2f\n\n\
%s\n%s\n",
iceb_tu_kolbait(8,gettext("Итого")),gettext("Итого"),
inob,isuma_indeks,
gettext("Общая сумма доходов:"),str);


bros[0]='\0';
iceb_t_poldan("Табельный номер руководителя",bros,"zarnast.alx");
if(bros[0] != '\0')
 {
  sprintf(strsql,"select fio from Kartb where tabn=%s",bros);
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
   strncpy(bros,row[0],sizeof(bros)-1);
 }

memset(fambuh,'\0',sizeof(fam));
iceb_t_poldan("Табельный номер бухгалтера",fambuh,"zarnast.alx");
if(fambuh[0] != '\0')
 {
  sprintf(strsql,"select fio from Kartb where tabn=%s",fambuh);
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
   strncpy(fambuh,row[0],sizeof(fambuh)-1);
 }

time(&tmr);
bf=localtime(&tmr);
memset(mescc,'\0',sizeof(mescc));
mesc(bf->tm_mon+1,1,mescc);

fprintf(ff1,"\n\
Прибутковий податок і відрахування в соціальні фонди утримані і перераховані повністю.\n");

fprintf(ff1,"\n\n\
    %s %s\n\n\
    %s %s\n\n",
gettext("Руководитель................"),bros,
gettext("Главный бухгалтер..........."),fambuh);

fprintf(ff1,"\
    %02d.%02d.%d%s\n",
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,gettext("г."));
/*********
fprintf(ff1,"\
   \"%02d\" %s %d%s\n",
bf->tm_mday,mescc,bf->tm_year+1900,gettext("г."));
************/
fprintf(ff3,"\n\n\
    %s %s\n\n\
    %s %s\n\n\
    %02d.%02d.%d%s\n",
gettext("Руководитель................"),bros,
gettext("Главный бухгалтер..........."),fambuh,
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,gettext("г."));

fprintf(ff_podoh,"\n\n\
    %s %s\n\n\
    %s %s\n\n\
    %02d.%02d.%d%s\n",
gettext("Руководитель................"),bros,
gettext("Главный бухгалтер..........."),fambuh,
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,gettext("г."));

fprintf(ff2,"\n\n\
    %s %s\n\n\
    %s %s\n\n\
    %02d.%02d.%d%s\n",
gettext("Руководитель................"),bros,
gettext("Главный бухгалтер..........."),fambuh,
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,gettext("г."));

fprintf(ff_stud,"\n\n\
    %s %s\n\n\
    %s %s\n\n\
    %02d.%02d.%d%s\n",
gettext("Руководитель................"),bros,
gettext("Главный бухгалтер..........."),fambuh,
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,gettext("г."));

if(fo == 1)
  fprintf(ff,"\
-------------------------------------------------\n\
%s %15.2f\n\
%s %15.2f\n\
%s %15.2f\n\
%s %15.2f\n",
gettext("Сальдо         :"),sld,
gettext("Итого начислено:"),ino,
gettext("Итого удержано :"),iuo,
gettext("К выдаче       :"),ino+iuo+sld);

fprintf(ff,"%ld %s\n\
%s %d.%d%s %s %d.%d%s\n",tabn,fam,
gettext("Период с"),
mn,gn,
gettext("г."),
gettext("до"),
mk,gk,
gettext("г."));

printw("\n%s:\n",gettext("Начисления"));
fprintf(ff,"\n%s:\n",gettext("Начисления"));
bb=0.;
for(i=0 ; i<kon;i++)
 {
  knah=MKN.ravno(i);
  sym=MSKN.ravno(i);
  if(sym == 0.)
    continue;
  sprintf(strsql,"select naik from Nash where kod=%d",knah);
  memset(nai,'\0',sizeof(nai));
     
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    printw("%s %d !\n",
    gettext("Не найден код начисления"),knah);
    OSTANOV();
   }
  else
    strncpy(nai,row1[0],sizeof(nai)-1);

  printw("%3d %-*s %15.2f\n",knah,iceb_tu_kolbait(30,nai),nai,sym);
  fprintf(ff,"%3d %-*s %15.2f\n",knah,iceb_tu_kolbait(30,nai),nai,sym);

  bb+=sym;
 }

if(fo == 1)
 {
  printw("----------------------------------------------------\n\
%3s %*s %15.2f\n%s:\n"," ",iceb_tu_kolbait(30,gettext("Итого")),gettext("Итого"),
  bb,gettext("Удержания"));
  refresh();
  fprintf(ff,"----------------------------------------------------\n\
%3s %*s %15.2f\n%s:\n"," ",iceb_tu_kolbait(30,gettext("Итого")),gettext("Итого"),
  bb,gettext("Удержания"));
  bb=0.;
  for(i=0 ; i<kou;i++)
   {
    sym=MSKU.ravno(i);
    if(sym == 0.)
      continue;
    knah=MKU.ravno(i);

    sprintf(strsql,"select naik from Uder where kod=%d",knah);
       
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      printw("%s %d !\n",
      gettext("Не найден код удержания"),knah);
      OSTANOV();
      memset(nai,'\0',sizeof(nai));
     }
    else
      strncpy(nai,row1[0],sizeof(nai)-1);

    printw("%3d %-*s %15.2f\n",knah,iceb_tu_kolbait(30,nai),nai,sym);
    fprintf(ff,"%3d %-*s %15.2f\n",knah,iceb_tu_kolbait(30,nai),nai,sym);
    bb+=sym;
   }

  printw("----------------------------------------------------\n\
%3s %*s %15.2f\n"," ",iceb_tu_kolbait(30,gettext("Итого")),gettext("Итого"),bb);
 }

/*Распечатываем суммы по табелям*/

printw("%s: %d\n",gettext("Количество видов табеля"),koltb);

fprintf(ff,"----------------------------------------------------\n\
%3s %*s %15.2f\n%s\n"," ",iceb_tu_kolbait(30,gettext("Итого")),gettext("Итого"),bb,
gettext("Табель:"));

fprintf(ff,"\
-----------------------------------------------------------------\n");
fprintf(ff,gettext("Код|           Наименование табеля          |Дни | Часы   |К.дни|\n"));
fprintf(ff,"\
-----------------------------------------------------------------\n");

for(i=0 ; i<koltb;i++)
 {
  dnei=DNI.ravno(i);
  kdnei=KDNI.ravno(i);
  has=HASI.ravno(i);
  if(dnei == 0 && kdnei == 0. && has == 0)
   continue;  

  knah=MKVT.ravno(i);
  memset(nai,'\0',sizeof(nai));
  sprintf(strsql,"select naik from Tabel where kod=%d",
  knah);
  nai[0]='\0';    
  if(readkey(strsql,&row1,&curr) != 1)
   {
    beep();
    printw("%s %d !\n",
    gettext("Не найден код табеля"),knah);
    OSTANOV();
   }
  else
    strncpy(nai,row1[0],sizeof(nai)-1);

  fprintf(ff,"%3d %-*s %4.f %8.8g %4.f\n",knah,iceb_tu_kolbait(40,nai),nai,dnei,has,kdnei);

  idn+=(int)dnei;
  ikdn+=(int)kdnei;
  ihas+=has;
 }
fprintf(ff,"\
-----------------------------------------------------------------\n\
%3s %*s %4d %8.8g %4d\n"," ",iceb_tu_kolbait(40,gettext("Итого")),gettext("Итого"),idn,ihas,ikdn);




m=mn;
for(g=gn; g <=gk ; g++)
for(;  ; m++)
 {
  if(g == gk && m > mk)
   {
    break;
   }
  if(m == 13)
   {
    m=1;
    break;
   }
  fprintf(ff,"----------------- %d.%d%s -----------------\n",
  m,g,gettext("г."));
  vztb(tabn,m,g,&kon,&ihas,&kou,1,ff);
 }



zarsprpr_sub_end(mn,gn,mk,gk,ino+ialim,ff_sub);

podpis(ff);
podpis(ff1);
podpis(ff2);
podpis(ff3);
podpis(ff_podoh);
podpis(ff_sub);
podpis(ff_stud);


fclose(ff);
fclose(ff_stud);
fclose(ff_sub);
fclose(ff1);
fclose(ff2);
fclose(ff3);
fclose(ff_podoh);

//Распечатка начислений/удержаний по счетам

sprintf(imafshet,"sp5%ld.lst",tabn);
if((ff = fopen(imafshet,"w")) == NULL)
   {
    error_op_nfil(imafshet,errno,"");
    return(1);
   }

fprintf(ff,"%ld %s\n\
%s %d.%d%s %s %d.%d%s\n",tabn,fam,
gettext("Период с"),
mn,gn,
gettext("г."),
gettext("до"),
mk,gk,
gettext("г."));

fprintf(ff,"\n%s:\n",gettext("Начисления"));
i=1;
bb=0.;
while(NASH.pol_masiv_char(i++,bros) == 0)
 {
  if(bros[0] == '\0')
   break;
  POLE(bros,str,1,',');
  POLE(bros,shet,2,',');
  sprintf(strsql,"select naik from Nash where kod=%s",str);
  memset(nai,'\0',sizeof(nai));
     
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    printw("%s %s !\n",
    gettext("Не найден код начисления"),str);
    OSTANOV();
   }
  else
    strncpy(nai,row1[0],sizeof(nai)-1);
  fprintf(ff,"%2s %-*s %*s %8.2f\n",str,iceb_tu_kolbait(30,nai),nai,iceb_tu_kolbait(5,shet),shet,NASHD.ravno(i-2));
  bb+=NASHD.ravno(i-2);
 }

fprintf(ff,"----------------------------------------------------\n\
%2s %*s: %8.2f\n%s:\n"," ",iceb_tu_kolbait(35,gettext("Итого")),gettext("Итого"),
bb,gettext("Удержания"));
i=1;
bb=0.;

while(UDER.pol_masiv_char(i++,bros) == 0)
 {
  if(bros[0] == '\0')
   break;
  POLE(bros,str,1,',');
  POLE(bros,shet,2,',');
  sprintf(strsql,"select naik from Uder where kod=%s",str);
  memset(nai,'\0',sizeof(nai));
     
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    printw("%s %s !\n",
    gettext("Не найден код удержания"),str);
    OSTANOV();
   }
  else
    strncpy(nai,row1[0],sizeof(nai)-1);
  fprintf(ff,"%2s %-*s %*s %8.2f\n",str,iceb_tu_kolbait(30,nai),nai,iceb_tu_kolbait(5,shet),shet,UDERD.ravno(i-2));
  bb+=UDERD.ravno(i-2);
 }
fprintf(ff,"----------------------------------------------------\n\
%2s %*s: %8.2f\n"," ",iceb_tu_kolbait(35,gettext("Итого")),gettext("Итого"),bb);

//Распечатка бюджет/не бюджет

if(shetb != NULL)
 {
  fprintf(ff,"\n%s:\n",gettext("Начисления"));
  fprintf(ff,"%s.\n",gettext("Бюджет"));
  i=1;
  bb=0.;
  while(NASH.pol_masiv_char(i++,bros) == 0)
   {
    if(bros[0] == '\0')
     break;
    POLE(bros,str,1,',');
    POLE(bros,shet,2,',');

    if(pole1(shetb,shet,',',0,&i1) != 0)
      if(SRAV(shetb,shet,0) != 0)
       continue;


    sprintf(strsql,"select naik from Nash where kod=%s",str);
    memset(nai,'\0',sizeof(nai));
       
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      printw("%s %s !\n",
      gettext("Не найден код начисления"),str);
      OSTANOV();
     }
    else
      strncpy(nai,row1[0],sizeof(nai)-1);
    fprintf(ff,"%2s %-*s %*s %8.2f\n",
    str,
    iceb_tu_kolbait(30,nai),nai,
    iceb_tu_kolbait(5,shet),shet,
    NASHD.ravno(i-2));
    bb+=NASHD.ravno(i-2);
   }


  fprintf(ff,"----------------------------------------------------\n\
%2s %*s: %8.2f\n\n%s.\n"," ",iceb_tu_kolbait(35,gettext("Итого")),gettext("Итого"),
  bb,
  gettext("Не бюджет"));


  i=1;
  bb=0.;
  while(NASH.pol_masiv_char(i++,bros) == 0)
   {
    if(bros[0] == '\0')
     break;
    POLE(bros,str,1,',');
    POLE(bros,shet,2,',');

    if(pole1(shetb,shet,',',0,&i1) == 0 || SRAV(shetb,shet,0) == 0)
       continue;


    sprintf(strsql,"select naik from Nash where kod=%s",str);
    memset(nai,'\0',sizeof(nai));
       
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      printw("%s %s !\n",
      gettext("Не найден код начисления"),str);
      OSTANOV();
     }
    else
      strncpy(nai,row1[0],sizeof(nai)-1);
    fprintf(ff,"%2s %-*s %*s %8.2f\n",str,iceb_tu_kolbait(30,nai),nai,iceb_tu_kolbait(5,shet),shet,NASHD.ravno(i-2));
    bb+=NASHD.ravno(i-2);
   }


  fprintf(ff,"----------------------------------------------------\n\
%2s %*s: %8.2f\n"," ",iceb_tu_kolbait(35,gettext("Итого")),gettext("Итого"),bb);

 }

if(shetbu != NULL)
 {
  fprintf(ff,"\n%s:\n",gettext("Удержания"));
  fprintf(ff,"%s.\n",gettext("Бюджет"));
  i=1;
  bb=0.;
  while(UDER.pol_masiv_char(i++,bros) == 0)
   {
    if(bros[0] == '\0')
     break;
    POLE(bros,str,1,',');
    POLE(bros,shet,2,',');

    if(pole1(shetbu,shet,',',0,&i1) != 0)
      if(SRAV(shetbu,shet,0) != 0)
       continue;


    sprintf(strsql,"select naik from Uder where kod=%s",str);
    memset(nai,'\0',sizeof(nai));
       
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      printw("%s %s !\n",
      gettext("Не найден код удержания"),str);
      OSTANOV();
     }
    else
      strncpy(nai,row1[0],sizeof(nai)-1);
    fprintf(ff,"%2s %-*s %*s %8.2f\n",str,iceb_tu_kolbait(30,nai),nai,iceb_tu_kolbait(5,shet),shet,UDERD.ravno(i-2));
    bb+=UDERD.ravno(i-2);
   }


  fprintf(ff,"----------------------------------------------------\n\
%2s %*s: %8.2f\n\n%s.\n"," ",iceb_tu_kolbait(35,gettext("Итого")),gettext("Итого"),
  bb,
  gettext("Не бюджет"));


  i=1;
  bb=0.;
  while(UDER.pol_masiv_char(i++,bros) == 0)
   {
    if(bros[0] == '\0')
     break;
    POLE(bros,str,1,',');
    POLE(bros,shet,2,',');

    if(pole1(shetbu,shet,',',0,&i1) == 0 || SRAV(shetbu,shet,0) == 0)
       continue;


    sprintf(strsql,"select naik from Uder where kod=%s",str);
    memset(nai,'\0',sizeof(nai));
       
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      printw("%s %s !\n",
      gettext("Не найден код удержания"),str);
      OSTANOV();
     }
    else
      strncpy(nai,row1[0],sizeof(nai)-1);
    fprintf(ff,"%2s %-*s %*s %8.2f\n",str,iceb_tu_kolbait(30,nai),nai,iceb_tu_kolbait(5,shet),shet,UDERD.ravno(i-2));
    bb+=UDERD.ravno(i-2);
   }


  fprintf(ff,"----------------------------------------------------\n\
%2s %*s: %8.2f\n"," ",iceb_tu_kolbait(35,gettext("Итого")),gettext("Итого"),bb);

 }

podpis(ff);

fclose(ff);

OSTANOV();


oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Развёрнутая справка"));

oth->spis_imaf.plus(imaf1);
oth->spis_naim.plus(gettext("Справка с отчислениями в соц. фонды"));
oth->spis_imaf.plus(imaf2);
oth->spis_naim.plus(gettext("Свёрнутая справка"));
oth->spis_imaf.plus(imafpen);
oth->spis_naim.plus(gettext("Справка с отчислением в пенсионный фонд"));
oth->spis_imaf.plus(imafshet);
oth->spis_naim.plus(gettext("Справка начиcлений/удержаний по счетам"));
oth->spis_imaf.plus(imaf_podoh);
oth->spis_naim.plus(gettext("Справка с подоходным налогом"));
oth->spis_imaf.plus(imaf_sub);
oth->spis_naim.plus(gettext("Справка для оформления социальной помощи (жилищной субсидии)"));
oth->spis_imaf.plus(imaf_stud);
oth->spis_naim.plus(gettext("Справка для студентов"));

for(int nomer=0; nomer < oth->spis_imaf.kolih(); nomer++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nomer),3);

return(0);

}
/***********************/
/*Реквизиты организации*/
/***********************/
void  rekvizkon(SQL_str row,FILE *ff)
{
int otstup=30;
int hag=37;
fprintf(ff,"%*s %s\n",otstup,"",row[1]);
int hag1=hag-strlen(gettext("Адрес"))-1;

//fprintf(ff,"%*s %s %-*.*s\n",otstup,"",gettext("Адрес"),hag1,hag1,row[3]);
fprintf(ff,"%*s %s %-*.*s\n",
otstup,"",
gettext("Адрес"),
iceb_tu_kolbait(hag1,row[3]),
iceb_tu_kolbait(hag1,row[3]),
row[3]);

for(int ii=hag1; ii < iceb_tu_strlen(row[3]); ii+=hag)
 fprintf(ff,"%*s %-*.*s\n",
 otstup,"",
 iceb_tu_kolbait(hag,iceb_tu_adrsimv(ii,row[3])),
 iceb_tu_kolbait(hag,iceb_tu_adrsimv(ii,row[3])),
 iceb_tu_adrsimv(ii,row[3]));
// fprintf(ff,"%*s %-*.*s\n",otstup,"",hag,hag,&row[3][ii]);

fprintf(ff,"%*s %s %s\n",otstup,"",gettext("Код ЕГРПОУ"),row[5]);
fprintf(ff,"%*s %s %s\n",otstup,"",gettext("Р/С"),row[7]);
fprintf(ff,"%*s %s %s\n",otstup,"",gettext("МФО"),row[6]);

char bros[512];

sprintf(bros,"%s %s %s %s",gettext("в"),row[2],gettext("г."),row[4]);
for(int ii=0; ii < iceb_tu_strlen(bros); ii+=hag)
  fprintf(ff,"%*s %-*.*s\n",
  otstup," ",
  iceb_tu_kolbait(hag,iceb_tu_adrsimv(ii,bros)),
  iceb_tu_kolbait(hag,iceb_tu_adrsimv(ii,bros)),
  iceb_tu_adrsimv(ii,bros));
//  fprintf(ff,"%*s %-*.*s\n",otstup," ",hag,hag,&bros[ii]);
  
fprintf(ff,"%*s %s %s\n",otstup,"",gettext("Налоговый номер"),row[8]);
fprintf(ff,"%*s %s %s\n",otstup,"",gettext("Номер свидетельства плательщика НДС"),row[9]);
fprintf(ff,"%*s %s %s\n",otstup,"",gettext("Телефон"),row[10]);
}
/*******************************************/
/*Заголовок справки для получения субсидии*/
/********************************************/
int zarsprpr_sub_start(short god,const char *kedrpou,const char *fio,const char *inn,const char *dolg,
const char *adres,
FILE *ff_ras)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];
char stroka[1024];
char stroka1[1024];

sprintf(strsql,"select str from Alx where fil='zarsns_start.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"zarsns_start.alx");
  iceb_t_soob(strsql);
  return(1);
 }


int nomer_str=0;
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  nomer_str++;
  memset(stroka,'\0',sizeof(stroka));
  strncpy(stroka,row_alx[0],sizeof(stroka)-1);
  switch(nomer_str)
   {
    case 7:
     sprintf(stroka1,"\x1B\x45%.*s\x1B\x46",iceb_tu_kolbait(52-4,organ),organ); /*включение/выключение режима выделенной печати*/
     BSTAB(stroka,stroka1,20,72,1);
     break;

    case 9: /*адрес*/
     sprintf(stroka1,"\x1B\x45%.*s\x1B\x46",iceb_tu_kolbait(55-4,adres),adres); /*включение/выключение режима выделенной печати*/
     BSTAB(stroka,stroka1,17,72,1);
     break;

    case 10:
     sprintf(stroka1,"\x1B\x45%s\x1B\x46",kedrpou); /*включение/выключение режима выделенной печати*/
     BSTAB(stroka,stroka1,31,72,1);
     break;
    case 15:
     sprintf(stroka1,"\x1B\x45%.*s\x1B\x46",iceb_tu_kolbait(61-4,fio),fio); /*включение/выключение режима выделенной печати*/
     BSTAB(stroka,stroka1,11,72,1);
     break;
    case 17:
     sprintf(stroka1,"\x1B\x45%.*s\x1B\x46",iceb_tu_kolbait(71-4,organ),organ); /*включение/выключение режима выделенной печати*/
     BSTAB(stroka,stroka1,1,72,1);
     break;
    case 19:
     sprintf(stroka1,"\x1B\x45%.*s\x1B\x46",iceb_tu_kolbait(58-4,dolg),dolg); /*включение/выключение режима выделенной печати*/
     BSTAB(stroka,stroka1,14,72,1);
     break;
    case 20:
     sprintf(stroka1,"\x1B\x45%s\x1B\x46",inn); /*включение/выключение режима выделенной печати*/
     BSTAB(stroka,stroka1,23,72,1);
     break;
    case 23:
     BSTAB(stroka,god,1,5,1);
     break;
   }
  fprintf(ff_ras,"%s",stroka);
 }

return(0);
}
/*************************/
/*концовка справки на субсидию*/
/******************************/
int zarsprpr_sub_end(short mn,short gn,short mk,short gk,double suma,FILE *ff_ras)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
class iceb_t_fioruk_rk rukov;
class iceb_t_fioruk_rk glavbuh;

char strsql[512];
char stroka[1024];
short dk=0;

dpm(&dk,&mk,&gk,5);

sprintf(strsql,"select str from Alx where fil='zarsns_end.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"zarsns_end.alx");
  iceb_t_soob(strsql);
  return(1);
 }

iceb_t_fioruk(1,&rukov);
iceb_t_fioruk(2,&glavbuh);

int nomer_str=0;
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  nomer_str++;
  memset(stroka,'\0',sizeof(stroka));
  strncpy(stroka,row_alx[0],sizeof(stroka)-1);
  switch(nomer_str)
   {
    case 1:
     sprintf(strsql,"01.%02d.%04d %s %s %02d.%02d.%04d %s",
     mn,gn,
     gettext("г."),
     gettext("по"),
     dk,mk,gk,
     gettext("г."));
     
     BSTAB(stroka,strsql,33,63,1);
     break;

    case 2:
     memset(strsql,'\0',sizeof(strsql));
     preobr(suma,strsql,0);
     BSTAB(stroka,strsql,20,72,1);
     
     break;

    case 9:
     BSTAB(stroka,rukov.dolg.ravno(),0,34,1);
     sprintf(strsql,"%s %s",rukov.famil.ravno(),rukov.inic);
     BSTAB(stroka,strsql,52,72,1);
     break;
    case 14:
     sprintf(strsql,"%s %s",glavbuh.famil.ravno(),glavbuh.inic);
     BSTAB(stroka,strsql,52,72,1);
     break;
   }
  fprintf(ff_ras,"%s",stroka);
 }
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);
fprintf(ff_ras,"%02d.%02d.%d %s N______\n",dt,mt,gt,gettext("г."));

return(0);

}
/****************************************/
/*Заголовок*/
/*******************************/
void zarsprpr_zag(short mn,short gn,
short mk,short gk,
const char *harac,
const char *fam,
const char *inn,
const char *dolg,
const char *podr,
int sovm,
FILE *ff2)
{
char strsql[512];

if(strstrm(harac,gettext("Студент")) == 0)
 {
  fprintf(ff2,"\n\
	      %s\n\
%s %d.%d%s %s %d.%d%s\n\
%s %s %s",
gettext("С п р а в к а"),
gettext("о заработной плате за период с"),
mn,gn,
gettext("г."),
gettext("до"),
mk,gk,
gettext("г."),
gettext("Работник"),
fam,
gettext("работает"));

  if(sovm == 0)
   {
    if(harac[0] == '\0')
      fprintf(ff2," %s\n",gettext("постоянно."));
    else
      fprintf(ff2," %s.\n",harac);
   }
  else
   fprintf(ff2," %s\n",gettext("по совместительству."));

  fprintf(ff2,"%s %s\n",gettext("Идентификационный код"),inn);
  fprintf(ff2,"%s: %s\n",gettext("Должность"),dolg);
 }
else
 {
  SQL_str row;
  class SQLCURSOR cur;
  char	naipodr[512];
  memset(naipodr,'\0',sizeof(naipodr));
  
  sprintf(strsql,"select naik from Podr where kod=%d",atoi(podr));
  if(sql_readkey(&bd,strsql,&row,&cur) == 1)
    strncpy(naipodr,row[0],sizeof(naipodr)-1);
    
  fprintf(ff2,"\n\
	      %s\n\
%s %d.%d%s %s %d.%d%s\n",
gettext("С п р а в к а"),
gettext("о начислении стипендии за период с"),
mn,gn,
gettext("г."),
gettext("до"),
mk,gk,
gettext("г."));
  fprintf(ff2,"%s. %s %s\n",
  gettext("Учится на дневном отделении"),
  gettext("Группа"),naipodr);
  
  fprintf(ff2,"%s %s\n",gettext("Студент"),fam);

  fprintf(ff2,"%s %s\n",gettext("Идентификационный код"),inn);

 }
}


