/*$Id: zarsprvmn.c,v 5.25 2011-01-13 13:43:25 sasa1 Exp $*/
/*04.11.2009	08.04.2002	Белых А.И.	zarsprvmn.c
Получение справки о доходах по датам в счет которых были 
сделаны начисления
*/
#include        <errno.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void             rekvizkon(SQL_str,FILE*);

extern char     *organ;/*Наименование организации*/

void	zarsprvmn(long tabn,
short mn,short gn,
short mk,short gk)
{
char		dolg[512];
char            fam[512];
char		strsql[512];
SQL_str		row;
SQLCURSOR curr;

/****************Расчет*********************/


int		kolstr=0,kolstr1=0;
char		imaf[32];
FILE		*ff;
char		naipodr[40];
char 		podr[32];
char		harac[512];
short           sovm=0; /*0-нет 1- Совместитель*/
char		inn[16];
short		mes,god;
short           mesz=0,godz=0;

sprintf(strsql,"select fio,sovm,inn,dolg,harac,podr from Kartb where tabn=%ld",tabn);
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %ld !",
  gettext("Не найден табельный номер"),tabn);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

strncpy(podr,row[5],sizeof(podr)-1);
strncpy(fam,row[0],sizeof(fam)-1);
strncpy(dolg,row[3],sizeof(dolg)-1);
memset(harac,'\0',sizeof(harac));
strncpy(harac,row[4],sizeof(harac)-1);
memset(inn,'\0',sizeof(inn));
strncpy(inn,row[2],sizeof(inn)-1);


clear();
printw("%s\n",gettext("Расчет справок о зарплате."));
printw("%s\n",fam);
printw("%s %d.%d%s %s %d.%d%s\n",
gettext("Период с"),
mn,gn,gettext("г."),
gettext("до"),
mk,gk,gettext("г."));
GDITE();



sprintf(strsql,"select suma,godn,mesn from Zarp where tabn=%ld and \
prn='1' and suma <> 0. and \
((godn = %d && mesn >= %d) or \
(godn = %d && mesn <= %d) or \
(godn > %d && godn < %d)) \
order by godn,mesn asc",
tabn,gn,mn,gk,mk,gn,gk);

//printw("\n%s\n",strsql);
//OSTANOV();

SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены начисления !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

sprintf(imaf,"sprdm%ld_%d.lst",tabn,getpid());
if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }

/*Читаем реквизиты организации*/
sprintf(strsql,"select * from Kontragent where kodkon='00'");
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  beep();
  printw("%s\n",gettext("Не найден контрагент с кодом 00 !"));
  OSTANOV();
 }
else
 {
  rekvizkon(row,ff);
 }
memset(naipodr,'\0',sizeof(naipodr));

sprintf(strsql,"select naik from Podr where kod=%s",podr);
if(sql_readkey(&bd,strsql,&row,&curr) == 1)
  strncpy(naipodr,row[0],sizeof(naipodr)-1);
  
  fprintf(ff,"\n\
	      %s\n\
%s %d.%d%s %s %d.%d%s\n\
%s %s %s ",
gettext("С п р а в к а."),
gettext("о заработной плате за период с"),
mn,gn,
gettext("г."),
gettext("до"),
mk,gk,
gettext("г."),
gettext("Работник"),
fam,
gettext("работает"));

if(sovm == 0)
   fprintf(ff," %s\n",gettext("постоянно."));
else
   fprintf(ff," %s\n",gettext("по совместительству."));
fprintf(ff,"%s %s\n",gettext("Идентификационный код"),inn);
fprintf(ff,"%s: %s\n",gettext("Должность"),dolg);


short		ots=10;
fprintf(ff,"\
%*s-------------------------\n\
%*s%s\n\
%*s-------------------------\n",
ots," ",
ots," ","|  Дата |   Начислено   |",
ots," ");


godz=mesz=0;
double suma=0.;
double sumames=0.;
double sumaitog=0.;

while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  suma=atof(row[0]);
  god=atoi(row[1]);
  mes=atoi(row[2]);
  
  if(mesz != mes)
   {
    if(mesz != 0)
     {
      printw("%02d.%d %15.2f\n",mesz,godz,sumames);
      fprintf(ff,"%*s|%02d.%d %15.2f|\n",ots," ",mesz,godz,sumames);
     }
    sumames=0.;
    mesz=mes;
    godz=god;
   }  
  sumames+=suma;
  sumaitog+=suma;
  
 }
printw("%02d.%d %15.2f\n",mesz,godz,sumames);
printw("%*s %15.2f\n",iceb_tu_kolbait(7,gettext("Итого")),gettext("Итого"),sumaitog);

fprintf(ff,"%*s|%02d.%d %15.2f|\n",ots," ",mesz,godz,sumames);
memset(strsql,'\0',sizeof(strsql));
preobr(sumaitog,strsql,0);

fprintf(ff,"%*s-------------------------\n\
%*s %7s %15.2f\n\n\
%s\n%s\n",
ots," ",
ots," ",gettext("Итого"),
sumaitog,
gettext("Общая сумма доходов:"),strsql);

podpis(ff);
fclose(ff);
OSTANOV();
class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Справки про зарплату"));
iceb_t_ustpeh(imaf,3);

iceb_t_rabfil(&oth,"");

}
