/*$Id: zarstfn53.c,v 5.13 2011-01-13 13:43:25 sasa1 Exp $*/
/*05.11.2009	17.03.2004	Белых А.И.	zarstfn53.c
Шапка типовой формы N53 - платежная ведомость
*/
#include <errno.h>
#include <buhg.h>
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif

extern char *organ;

int  zarstfn53_0(const char *naipodr,char *mesqc,short gr,const char *shet,int *kolstr,FILE *ff);
int  zarstfn53_1(const char *naipodr,char *mesqc,short gr,const char *shet,const char *nomerved,int *kolstr,FILE *ff);


int  zarstfn53(const char *naipodr,short mr,short gr,
const char *shet,
const char *nomerved,
int *kolstr,
FILE *ff)
{
char mesqc[56];
memset(mesqc,'\0',sizeof(mesqc));

mesc(mr,0,mesqc);

if(sravmydat(16,6,2009,30,mr,gr) > 0)
  return(zarstfn53_0(naipodr,mesqc,gr,shet,kolstr,ff));
else
  return(zarstfn53_1(naipodr,mesqc,gr,shet,nomerved,kolstr,ff));

}
/***************************/
/************************/
int  zarstfn53_0(const char *naipodr,char *mesqc,short gr,
const char *shet,
int *kolstr,
FILE *ff)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr1=0;
char strsql[512];
char stroka[1024];
char kod[32];
SQLCURSOR cur;
SQL_str   row;

memset(kod,'\0',sizeof(kod));

//читаем код 
sprintf(stroka,"select kod from Kontragent where kodkon='00'");
if(sql_readkey(&bd,stroka,&row,&cur) == 1)
  strncpy(kod,row[0],sizeof(kod)-1);



sprintf(strsql,"select str from Alx where fil='zarspv.alx' order by ns asc");
if((kolstr1=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr1 == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"zarspv.alx");
  iceb_t_soob(strsql);
  return(1);
 }


int nomstr=0;
char bros[512];
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  nomstr++;
  memset(stroka,'\0',sizeof(stroka));
  strncpy(stroka,row_alx[0],sizeof(stroka)-1);
  switch(nomstr)
   {
    case 1:
     //в первых двух символах команды для принтера
     BSTAB(stroka,organ,3,40,1);
     break;

    case 2:
     BSTAB(stroka,kod,32,48,1);
     break;

    case 4:
     BSTAB(stroka,naipodr,0,47,1);
     break;

    case 10:
     sprintf(bros,"%d%s",gr,gettext("г."));
     
     BSTAB(stroka,bros,21,35,1);
     break;

    case 14:
     BSTAB(stroka,shet,42,50,1);
     break;

    case 16:
     sprintf(bros,"%d%s",gr,gettext("г."));
     
     BSTAB(stroka,bros,14,23,1);
     break;

    case 18:
     sprintf(bros,"%s %d%s",mesqc,gr,gettext("г."));
     
     BSTAB(stroka,bros,28,51,1);
     break;
        
   }
  *kolstr+=1;     
  fprintf(ff,"%s",stroka);
  
 }
 
return(0);

}
/*************************************/
/**************************************/
int  zarstfn53_1(const char *naipodr,char *mesqc,short gr,
const char *shet,
const char *nomerved,
int *kolstr,
FILE *ff)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr1=0;
char strsql[512];
char stroka[1024];
char kod[32];
SQLCURSOR cur;
SQL_str   row;

memset(kod,'\0',sizeof(kod));

//читаем код 
sprintf(stroka,"select kod from Kontragent where kodkon='00'");
if(sql_readkey(&bd,stroka,&row,&cur) == 1)
  strncpy(kod,row[0],sizeof(kod)-1);



sprintf(strsql,"select str from Alx where fil='zarspv2.alx' order by ns asc");
if((kolstr1=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr1 == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"zarspv2.alx");
  iceb_t_soob(strsql);
  return(1);
 }

int nomstr=0;
char bros[512];
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  nomstr++;
  memset(stroka,'\0',sizeof(stroka));
  strncpy(stroka,row_alx[0],sizeof(stroka)-1);
  switch(nomstr)
   {
    case 1:
     //в первых двух символах команды для принтера
     BSTAB(stroka,organ,3,40,1);
     break;

    case 2:
     BSTAB(stroka,kod,32,48,1);
     break;

    case 4:
     BSTAB(stroka,naipodr,0,47,1);
     break;

    case 10:
     sprintf(bros,"%d%s",gr,gettext("г."));
     
     BSTAB(stroka,bros,21,35,1);
     break;

    case 14:
     BSTAB(stroka,shet,42,50,1);
     break;

    case 16:
     sprintf(bros,"%d%s",gr,gettext("г."));
     
     BSTAB(stroka,bros,14,23,1);
     break;

    case 18:
     BSTAB(stroka,nomerved,43,53,1);
     break;

    case 19:
     sprintf(bros,"%s %d%s",mesqc,gr,gettext("г."));
     
     BSTAB(stroka,bros,28,51,1);
     break;
        
   }
  *kolstr+=1;     
  fprintf(ff,"%s",stroka);
  
 }
 
return(0);

}
