/*$Id: dirf.c,v 5.12 2011-01-13 13:43:30 sasa1 Exp $*/
/*23.10.2009    15.12.1992      Белых А.И.   dirf.c
Подпрограмма поиска файлов заданных по трафарету
Вызывает dirfajl
Если вернули 0 - выбрали файл
	    -1 - нет
*/
#ifdef	HAVE_CONFIG_H
#include	<iceb.h>
#endif
#include        <stdio.h>
#include        <sys/types.h>
#include        <sys/stat.h>
#include        <time.h>
#include        <string.h>
#ifdef	STDC_HEADERS
#include	<stdlib.h>
#endif
#include	"buhl.h"


int dirf(char *tif, //Имя файла
int mp, //Метка поиска 1-до точки , 2-росле точки, 3 полное имя файла
int y,int x, //Координаты вывода меню
int kk)      //Номер строки
{
struct  tm      *bf;
struct stat work;
class SPISOK	mfa; /*Массив с именами файлов*/
int		prc;
int             nf; /*Номер файла в массиве*/
int             ns; /*Номер строки меню*/
int             voz;
char            name[512];
int             kf; /*Количество файлов*/
int		ii;
int		K;
char strsql[512];
class iceb_t_mstr spis_menu(0);



voz=0;
kf=0;
kf=dirfajl(tif,mp,&mfa);

if(kf == 0)
 {
  attron(A_BLINK); /*Включить мигание*/
  move(5,45);
  printw(gettext("Не найдено ни одного файла !"));
  beep();
  attroff(A_BLINK); /*Выключить мигание*/
  return(1);
 }

nf=1;

naz:;


int ks=LINES-4-y;

spis_menu.spis_str.free_class();

if(kf > 0 && nf > kf)
 nf=kf;
if(nf < 1)
 nf=1; 

ns=0;
char bros[512];
for(ii=nf ; ii <= kf && ns<ks ; ii++)
 {
  strcpy(name,mfa.ravno(ii-1));
  if(stat(name,&work))
   {
    continue;
   }
  bf=localtime(&work.st_mtime);

  sprintf(bros,"%-*.*s %6ld %02d:%02d %02d.%02d.%d",
  iceb_tu_kolbait(12,name),iceb_tu_kolbait(12,name),name,
  work.st_size,bf->tm_hour,
  bf->tm_min,bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900);

  ns++;
  spis_menu.spis_str.plus(bros);
 }

if(kk >= ns)
  kk=ns-1;

if(kk != -10 && kk < 0)
 kk=0;

 
if(ns < ks)
  spis_menu.spis_str.plus(gettext("Конец списка"));

prc=nf*100/kf;
memset(strsql,'\0',sizeof(strsql));
kk=spis_menu.menu(kk,y,x,NULL,strsql,prc,&K,"",0);


if(kk == -7) //Изменение размеров экрана
 goto naz;
 
if(kk == -5)  /*Экран вниз*/
 {
  nf+=ks;
  if(nf > kf)
   {
    beep();
    nf=kf;
   }
  goto naz;
 }

if(kk == -3 )  /*Стрелка вниз*/
 {
  nf++;
  
  if(nf > kf)
   {
    beep();
    nf=kf;
   }

  kk=ks;

  goto naz;
 }

if(kk == -2 ) /*Стрелка вверх*/
 {

  nf--;
  if(nf <1)
    nf=1;

  if(nf == 1)
   beep();
  goto naz;
 }

if(kk == -4) /*Экран в верх*/
 {
  nf-=ks;
  if(nf < 1)
   {
    beep();
    nf=1;
   }
  goto naz;
 } 


if(kk == -1 || kk == -10)
  voz=1;
else
 {
  if(SRAV(gettext("Конец списка."),spis_menu.spis_str.ravno(kk),0) == 0)
     goto naz;
/********
  if(kf > 1)
    strcpy(
   POLE(mfa,tif,nf+kk,' ');
  else
   strcpy(tif,mfa);
**************/
  strcpy(tif,mfa.ravno(nf+kk-1));
 }

return(voz);
}
