/*$Id: iceb_t_ko1.c,v 5.8 2011-01-13 13:43:30 sasa1 Exp $*/
/*24.11.2008	09.01.2008	Белых А.И.	iceb_t_ko1.c
Распечатка приходного кассового ордера на бланке строгой отчётности
*/


#include        <errno.h>
#include	"buhl.h"


void iceb_t_ko1(const char *imaf,
const char *nomd,
short dd,short md,short gd,
const char *shet,
const char *shetkas,
double suma,const char *fio,const char *osnov,const char *dopol,FILE *ff_f)
{
SQL_str		row;
SQLCURSOR       cur;
char		strsql[512];
char		naim[512];
char		kodedrp[32];
char		sumac[200];
FILE		*ff=ff_f;


memset(naim,'\0',sizeof(naim));
memset(kodedrp,'\0',sizeof(kodedrp));
memset(sumac,'\0',sizeof(sumac));

preobr(suma,sumac,0);
sprintf(strsql," (%.2f)",suma);
strcat(sumac,strsql);
/*Читаем реквизиты организации*/

sprintf(strsql,"select naikon,kod from Kontragent where kodkon='00'");

if(sql_readkey(&bd,strsql,&row,&cur) == 1)
 {
  strncpy(naim,row[0],sizeof(naim)-1);
  strncpy(kodedrp,row[1],sizeof(kodedrp)-1);
 }

if(imaf[0] != '\0')
 {
  if((ff = fopen(imaf,"w")) == NULL)
    {
     error_op_nfil(imaf,errno,"");
     return;
    }
  startfil(ff);
 }

fprintf(ff,"\x1b\x6C%c",7); /*Установка левого поля*/
fprintf(ff,"\x1B\x4D"); /*12-знаков*/
fprintf(ff,"\x0F");  /*Ужатый режим*/
fprintf(ff,"\x1B\x33%c\n",30); /*Уменьшаем межстрочный интервал*/


fprintf(ff,"%-50.50s %46s %.50s\n",naim,"",naim);


fprintf(ff,"\n%s\n",kodedrp);

fprintf(ff,"\n");

fprintf(ff,"%100s %s:%s\n","","Номер документу",nomd); 

for(int i=0; i < 3; i++)
 fprintf(ff,"\n");


fprintf(ff,"%100s %14s %-30.30s\n\n","","",fio); 
if(strlen(fio) > 30)
 fprintf(ff,"%100s %-40.40s\n","",&fio[30]);
else
 fprintf(ff,"\n");

fprintf(ff,"\n");
fprintf(ff,"\n");

fprintf(ff,"%100s %10s %-34.34s\n\n","","",osnov);
  
fprintf(ff,"%-9s %02d.%02d.%04d        %-10s  %-10s %-20.2f",
nomd,dd,md,gd,shet,shetkas,suma);

if(strlen(osnov) > 38)
 fprintf(ff,"%28s %.40s","",&osnov[38]);
 
fprintf(ff,"\n\n\n");

fprintf(ff,"%15s %.80s\n","",fio);

fprintf(ff,"%100s %.40s\n","",sumac);

if(strlen(sumac) > 40)
  fprintf(ff,"%100s %.40s\n","",&sumac[40]);
else
  fprintf(ff,"\n");

char mesqc[20];
mesc(md,1,mesqc);
   
fprintf(ff,"%10s %-80.80s\n","",osnov);
if(strlen(osnov) > 80)
 fprintf(ff,"%-80.80s %20s %02d %s %02d р.\n",&osnov[80],"",dd,mesqc,gd);
else 
 fprintf(ff,"%100s  %02d %s %02d р.\n","",dd,mesqc,gd);
   
fprintf(ff,"\n\n\n%s\n\n",sumac);

fprintf(ff,"%10s %.80s\n","",dopol);
if(strlen(dopol) > 80)
 fprintf(ff,"%.80s\n",&dopol[80]);
else 
 fprintf(ff,"\n");


if(imaf[0] != '\0') 
 {
  fclose(ff);
 }
}
