/*$Id: iceb_t_ko2.c,v 5.8 2011-01-13 13:43:30 sasa1 Exp $*/
/*24.11.2008	09.01.2008	Белых А.И. 	iceb_t_ko2.c
Распечатка расходного кассового ордера на бланке строгой отчётности
*/
#include        <errno.h>
#include	"buhl.h"
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif


void iceb_t_ko2(const char *imaf, //Имя файла
const char *nomd, //Номер документа
short dd,short md,short gd, //Дата
const char *shet, //Счет кореспондент
const char *shetkas, //Счет кассы ,Шифр аналитического учета
double suma, //Сумма
const char *fio, //Фамилия имя отчество
const char *osnov, //Основание
const char *dopol, //Дополнение
const char *dokum, //Реквизита документа по которому выданы деньги
const char *hcn, //Шифр целевого назначения
FILE *ff_f)
{
SQL_str		row;
SQLCURSOR       cur;
char		strsql[512];
char		naim[512];
char		strf[312];
char		sumac[200];
char kod[40];
FILE *ff=ff_f;

memset(naim,'\0',sizeof(naim));
memset(sumac,'\0',sizeof(sumac));
memset(kod,'\0',sizeof(kod));
preobr(suma,sumac,0);

/*Читаем реквизиты организации*/

sprintf(strsql,"select naikon,kod from Kontragent where kodkon='00'");

if(readkey(strsql,&row,&cur) == 1)
 {
  strncpy(naim,row[0],sizeof(naim)-1);
  strncpy(kod,row[1],sizeof(kod)-1);
 }

short metka_sum_prop=0;
if(iceb_t_poldan("Печатать сумму прописью в расходном документе",strf,"kasnast.alx") == 0)
 if(SRAV("Вкл",strf,1) == 0)
  metka_sum_prop=1;

if(imaf[0] != '\0')
 {
  if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }
 }
 
startfil(ff);
fprintf(ff,"\x1B\x4D"); /*12-знаков*/
//fprintf(ff,"\x0F");  /*Ужатый режим*/
fprintf(ff,"\x1b\x6C%c",7); /*Установка левого поля*/

fprintf(ff,"%s\n\n",naim);
fprintf(ff,"\n%s\n",kod);

for(int i=0; i<5; i++)
 fprintf(ff,"\n");
 
fprintf(ff,"%-9s %02d.%02d.%04d       %-10s   %-10s  %-20.2f %s\n\n",
nomd,dd,md,gd,shet,shetkas,suma,hcn);

fprintf(ff,"%5s %s\n\n","",fio);
fprintf(ff,"%5s %s\n\n\n","",osnov);
fprintf(ff,"%s\n\n",sumac);
fprintf(ff,"%7s %s\n","",dopol);

for(int i=0; i< 4; i++)
 fprintf(ff,"\n");

if(metka_sum_prop == 1)
  fprintf(ff,"%5s %s\n","",sumac);
else
  fprintf(ff,"\n");
  
for(int i=0; i< 3; i++)
 fprintf(ff,"\n");

fprintf(ff,"%2s %.85s\n","",dokum);
if(strlen(dokum) > 85)
 fprintf(ff,"%s\n",&dokum[85]);

if(imaf[0] != '\0')
 {
  
  fclose(ff);
 }
}






