/*$Id: iceb_t_ustpeh.c,v 5.8 2010-11-24 11:58:24 sasa1 Exp $*/
/*25.06.2010	05.09.2009	Белых А.И.	iceb_t_ustpeh.c
Определение максимально длинной строки в файле
и установка команд для печати файла с нужным ужатием и ориентацией
*/
#include <errno.h>
#include "buhl.h"

void iceb_t_ustpeh(const char *imaf,int orient) /*0-любая 1-только портрет 2-только ландшафт 3-сначала портрет если не подходит ландшафт*/
{
char stroka[10240];
class iceb_tu_str imaf_tmp(imaf);
imaf_tmp.plus(".tmp");

FILE *ff;
FILE *ff_tmp;

if((ff=fopen(imaf,"r")) == NULL)
 {
  error_op_nfil(imaf,errno,"iceb_t_ustpeh");
  return;
 }
int max_dlina_str=0;
int dlina_str=0;
int kor=0;
memset(stroka,'\0',sizeof(stroka));
while(fgets(stroka,sizeof(stroka),ff) != NULL)
 {
  kor=0;
  if(stroka[0] == '\f')
   kor=1;
  dlina_str=iceb_tu_strlen(stroka)-1-kor;
  if(max_dlina_str < dlina_str)
    max_dlina_str=dlina_str;
 }

if((ff_tmp=fopen(imaf_tmp.ravno(),"w")) == NULL)
 {
  error_op_nfil(imaf_tmp.ravno(),errno,__FUNCTION__);
  return;
 }
startfil(ff_tmp);

iceb_tu_ustpeh(max_dlina_str,orient,ff_tmp);

rewind(ff);
while(fgets(stroka,sizeof(stroka),ff) != NULL)
 fprintf(ff_tmp,"%s",stroka);

/*******************
На матричных принтерах если не отменить предыдущие установки
то они остаются и будут применяться для следующей распечатки
*******************/
//fprintf(ff_tmp,"\x1b\x6C%c",1); /*Установка левого поля*/
//fprintf(ff_tmp,"\x1B\x32"); /*Межстрочный интервал 1/6 дюйма*/

fclose(ff);
fclose(ff_tmp);

rename(imaf_tmp.ravno(),imaf);

}

