/*$Id: mprintcap.c,v 5.6 2011-01-13 13:43:31 sasa1 Exp $*/
/*13.09.2008	02.04.2001	Белых А.И.	mprintcap.c
Просмотр файла настройки принтeров /etc/printcap и создание
меню выбора файла
Если имя принтера начинается с точки то он в список принтеров не 
попадает
Если вернули 0 - принтер сменили
             1 - нет
*/
#include        <errno.h>
#include	"buhl.h"

extern char	*nameprinter;

int	mprintcap()
{
char		imafil[40];
FILE		*ff;
char		stroka[1024];
SPISOK	masiv;
char		bros[512];
char		sprinter[56];
char		naiprinter[512];
int		i;

errno=0;
strcpy(imafil,"/etc/printcap");

if((ff = fopen(imafil,"r")) == NULL)
 if(errno != ENOENT)
   {
    error_op_nfil(imafil,errno,"");
    return(1);
   }

if(errno == ENOENT) /*Файл не существует*/
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено файл:"));
  SOOB.VVOD_SPISOK_add_MD(imafil);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }



while(fgets(stroka,sizeof(stroka),ff) != NULL)
 {
  if(stroka[0] == '#' || stroka[0] == ' ' || stroka[0] == '\t' ||
  stroka[0] == '\n')
   continue;
  if(polen(stroka,bros,sizeof(bros),1,':') == 0)
   {
    memset(sprinter,'\0',sizeof(sprinter));
    memset(naiprinter,'\0',sizeof(naiprinter));
    if(polen(bros,sprinter,sizeof(sprinter),1,'|') == 0)
      polen(bros,naiprinter,sizeof(naiprinter),2,'|');
    else
      strncpy(sprinter,bros,sizeof(sprinter)-1);

    if(naiprinter[0] == '.')
      continue;
      
    sprintf(bros,"%-10s|%s",sprinter,naiprinter);    
    masiv.plus(bros);
//    sozdmas(bros,&masiv,&dlmas,'^');
   }
 }

fclose(ff);

if(masiv.kolih() != 0)
 {
  helstr(LINES-1,0,"Enter",gettext("выбор нужного"),
  "F10",gettext("выход"),NULL);
  int kod_kl=0;
  int voz=dirmasiv(&masiv, -1, -1,0,gettext("Выберите нужный принтер"),1,&kod_kl);
  if(voz == -1 || kod_kl != ENTER)
    return(1);

  strncpy(bros,masiv.ravno(voz),sizeof(bros)-1);

  polen(bros,sprinter,sizeof(sprinter),1,'|');
  
  if(setenv("PRINTER",sprinter,1) != 0)
   {
    printw("Ошибка переустановки переменной !\n");
    OSTANOV();
    return(1);
   }

  if((nameprinter = getenv("PRINTER")) == NULL)
   {
    beep();
    printw("\nОшибка чтения переменной !\n");
    OSTANOV();
    return(1);
   }
  
 }
else
 {
  helstr(LINES-1,0,"F10","выход",NULL);

  class iceb_tu_str imapr("");
  VVOD  VVOD1(2);
  VVOD1.VVOD_SPISOK_add_MD(gettext("Введите имя принтера"));

  if((i=vvod1(&imapr,56,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
    return(1);
  if(i == ESC)
   return(1);
  if(setenv("PRINTER",imapr.ravno(),1) != 0)
   {
    printw("Ошибка переустановки переменной !\n");
    OSTANOV();
    return(1);
   }

  if((nameprinter = getenv("PRINTER")) == NULL)
   {
    beep();
    printw("\nОшибка чтения переменной !\n");
    OSTANOV();
    return(1);
   }

 }

return(0);

}
