/*$Id: rasnaln1.c,v 5.13 2011-06-07 08:47:19 sasa Exp $*/
/*07.04.2010	08.11.2005	Белых А.И.	rasnaln1.c
Формирование шапки налоговой накладной
*/

#include        <errno.h>
#include "buhl.h"


void rasnaln1(const char *imaf,
int *nomer_str,
int *kor,
short dd,short md,short gd, //дата документа
short dnn,short mnn,short gnn, //Дата налоговой накладной
const char *nomnn, //Номер налоговой накладной
const char *osnov, //Основание
const char *uspr,  //Условие продажи
const char *frop,//Код формы оплаты
const char *kpos,
int tipz,  /*1-приход 2-расход*/
FILE **f1,FILE **f2)
{
char strsql[512];
char strsql1[512];
SQL_str row;
SQLCURSOR cur;
char            nmo[512],nmo1[512];  /*Наименование организации*/
char            gor[512],gor1[512]; /*Адрес*/
char            inn[32],inn1[32];  /*Индивидуальный налоговый номер*/
char            nspdv[32],nspdv1[32]; /*Номер свидетельства плательщика НДС*/
char            telef[112],telef1[112]; /*Номер телефона*/
short		ots; /*Отступ от левого края*/
char nai_for_opl[512];

memset(nai_for_opl,'\0',sizeof(nai_for_opl));

*kor=0;

memset(strsql,'\0',sizeof(strsql)); 
iceb_t_poldan("Корректор межстрочного растояния",strsql,"matnast.alx");
*kor=(short)ATOFM(strsql);

ots=10;
memset(strsql,'\0',sizeof(strsql)); 
if(iceb_t_poldan("Отступ налоговой накладной",strsql,"matnast.alx") == 0)
    ots=(short)ATOFM(strsql);

if(frop[0] != '\0')
 {
  /*Читаем форму оплаты*/
  sprintf(strsql,"select naik from Foroplat \
where kod='%s'",frop);

  if(sql_readkey(&bd,strsql,&row,&cur) != 1)
   {
    sprintf(strsql,"Не знайдена форма оплаты %s !",frop);  
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
    strncpy(nai_for_opl,row[0],sizeof(nai_for_opl)-1);  
 }

/*Читаем реквизиты организации свои */

memset(nmo,'\0',sizeof(nmo));
memset(gor,'\0',sizeof(gor));
memset(inn,'\0',sizeof(inn));
memset(telef,'\0',sizeof(telef));
memset(nspdv,'\0',sizeof(nspdv));

memset(nmo1,'\0',sizeof(nmo1));
memset(gor1,'\0',sizeof(gor1));
memset(inn1,'\0',sizeof(inn1));
memset(nspdv1,'\0',sizeof(nspdv1));
memset(telef1,'\0',sizeof(telef1));

sprintf(strsql,"select * from Kontragent where kodkon='00'");
if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s !",
  gettext("Не найден код контрагента"),"00");
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }
else
 {
  if(tipz == 2)
   {
    if(row[16][0] == '\0')
      strncpy(nmo,row[1],sizeof(nmo)-1);
    else
      strncpy(nmo,row[16],sizeof(nmo)-1);

    strncpy(gor,row[3],sizeof(gor)-1);
    strncpy(inn,row[8],sizeof(inn)-1);
    strncpy(nspdv,row[9],sizeof(nspdv)-1);
    strncpy(telef,row[10],sizeof(telef)-1);
   }
  if(tipz == 1)
   {
    if(row[16][0] == '\0')
      strncpy(nmo1,row[1],sizeof(nmo1)-1);
    else
      strncpy(nmo1,row[16],sizeof(nmo1)-1);

    strncpy(gor1,row[3],sizeof(gor1)-1);
    strncpy(inn1,row[8],sizeof(inn1)-1);
    strncpy(nspdv1,row[9],sizeof(nspdv1)-1);
    strncpy(telef1,row[10],sizeof(telef1)-1);
   }

 } 


/*Читаем реквизиты организации чужие*/
/*При внутреннем перемещении не читать*/
if(ATOFM(kpos) != 0. || kpos[0] != '0')
 {
  sprintf(strsql,"select * from Kontragent where kodkon='%s'",kpos);
  if(sql_readkey(&bd,strsql,&row,&cur) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %s !",
    gettext("Не найден код контрагента"),kpos);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    if(tipz == 2)
     {
      if(row[16][0] == '\0')
        strncpy(nmo1,row[1],sizeof(nmo1)-1);
      else
        strncpy(nmo1,row[16],sizeof(nmo1)-1);

      strncpy(gor1,row[3],sizeof(gor1)-1);
      strncpy(inn1,row[8],sizeof(inn1)-1);
      strncpy(nspdv1,row[9],sizeof(nspdv1)-1);
      strncpy(telef1,row[10],sizeof(telef1)-1);
     }
    if(tipz == 1)
     {
      if(row[16][0] == '\0')
        strncpy(nmo,row[1],sizeof(nmo)-1);
      else
        strncpy(nmo,row[16],sizeof(nmo)-1);

      strncpy(gor,row[3],sizeof(gor)-1);
      strncpy(inn,row[8],sizeof(inn)-1);
      strncpy(nspdv,row[9],sizeof(nspdv)-1);
      strncpy(telef,row[10],sizeof(telef)-1);
     }
    
   }
  VVOD SOOB(1);
  int i=0;  
  if(inn1[0] == '\0')
   {
    i++;
    sprintf(strsql,gettext("Для контрагента %s не введен индивидуальный налоговый номер !"),kpos);
    SOOB.VVOD_SPISOK_add_MD(strsql);
   }
  if(nspdv1[0] == '\0')
   {
    i++;
    sprintf(strsql,gettext("Для контрагента %s не введен номер свидетельства плательщика НДС !"),kpos);
    SOOB.VVOD_SPISOK_add_MD(strsql);
   }
  if(i != 0)
    soobshw(&SOOB,stdscr,-1,-1,0,1);
 }

//imafn("nakl.alx",strsql);
if(iceb_t_alxout("nakl.alx") != 0)
 return;
if((*f2 = fopen("nakl.alx","r")) == NULL)
 {
  if(errno != ENOENT)
   {
    error_op_nfil("nakl.alx",errno,"");
    return;
   }

  if(errno == ENOENT)
   {
    iceb_t_soob("Не найден файл заготовки накладной nakl.alx !");
    return;
   }
 }
if((*f1 = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }
startfil(*f1);
fprintf(*f1,"\x1b\x6C%c",ots); /*Установка левого поля*/
fprintf(*f1,"\x1B\x33%c",20-*kor); /*Уменьшение межстрочного интервала*/
fprintf(*f1,"\x1B\x4D"); /*12 знаков на дюйм*/
fprintf(*f1,"\x0F");     /*Ужатый режим*/
memset(strsql,'\0',sizeof(strsql));
if(dnn != 0)
 {
  mesc(mnn,1,strsql);
  sprintf(strsql1,"%d %s %d%s",dnn,strsql,gnn,gettext("г."));
 }
else
 {
  mesc(md,1,strsql);
  sprintf(strsql1,"%d %s %d%s",dd,strsql,gd,gettext("г."));
 }
char str[1024];

for(*nomer_str=1; *nomer_str <= 47; *nomer_str+=1)
 {
  
  memset(str,'\0',sizeof(str));
  fgets(str,sizeof(str),*f2);
  if(*nomer_str == 11)
   {
    BSTAB(str,strsql1,34,60,1);
    BSTAB(str,nomnn,73,83,1);
   }

  if(*nomer_str == 12)
   BSTAB(str,kpos,106,126,1);

  if(*nomer_str == 14)
   {
    BSTAB(str,nmo,19,61,1);
    BSTAB(str,nmo1,95,135,1);
   }
  if(*nomer_str == 15) //Вторая строка длинного наименования контрагента
   {
    if(iceb_tu_strlen(nmo) > 42)
      BSTAB(str,iceb_tu_adrsimv(42,nmo),19,61,1);
    if(iceb_tu_strlen(nmo1) > 40)
      BSTAB(str,iceb_tu_adrsimv(40,nmo1),95,135,1);
   }
  if(*nomer_str == 16) //Третья строка длинного наименования контрагента
   {
    if(iceb_tu_strlen(nmo) > 84)
      BSTAB(str,iceb_tu_adrsimv(84,nmo),19,61,1);
    if(iceb_tu_strlen(nmo1) > 80)
      BSTAB(str,iceb_tu_adrsimv(80,nmo1),95,135,1);
   }
  if(*nomer_str == 19)
   {
    BSTAB(str,inn,6,29,2);
    BSTAB(str,inn1,103,126,2);
   }
  if(*nomer_str == 23)
   {
    BSTAB(str,gor,13,13+50,1);
    BSTAB(str,gor1,87,87+50,1);
   }
  if(*nomer_str == 24)
   {
    if(iceb_tu_strlen(gor) > 50)
      BSTAB(str,iceb_tu_adrsimv(50,gor),13,50,1);
    if(iceb_tu_strlen(gor1) > 50)
      BSTAB(str,iceb_tu_adrsimv(50,gor1),87,87+50,1);
   }
  if(*nomer_str == 25)
   {
    BSTAB(str,telef,15,15+sizeof(telef),1);
    BSTAB(str,telef1,91,91+sizeof(telef1),1);
   }
  if(*nomer_str == 28)
   {
    BSTAB(str,nspdv,32,32+sizeof(nspdv),1);
    BSTAB(str,nspdv1,108,108+sizeof(nspdv1),1);
   }
  if(*nomer_str == 30)
   {
    memset(strsql,'\0',sizeof(strsql));
    sprintf(strsql,"%s %s",osnov,uspr);
    BSTAB(str,strsql,20,30+iceb_tu_strlen(strsql),1);
   }
  if(*nomer_str == 33)
   {
    BSTAB(str,nai_for_opl,30,30+sizeof(nai_for_opl),1);
   }
  fprintf(*f1,"%s",str);
 }

fprintf(*f1,"\x1B\x33%c",24-*kor);

}
