/*$Id: readkey_par.c,v 5.6 2011-01-13 13:43:31 sasa1 Exp $*/
/*10.11.2009	22.12.1999	Белых А.И.	readkey_par.c
Чтение ключей запуска программы
*/
#include	"buhl.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

int iceb_t_vb(const char *host,const char *parol,char **imabaz);


extern int optind, opterr, optopt;
extern char *optarg;

void readkey_par(int argc,char **argv,
char **parol, //Паpоль
char **imabaz, //Имя базы
char **host, //Хост
int *regim) //Режим pаботы пpогpаммы
{
int		i;
char		bros[256];

/* Просмотр ключей    */
/*
b - имя базы
h - хост
p - пароль
r - режим работы программы, для разных подсистем по разному
*/
*regim=0;
while ((i = getopt(argc, argv, "b:h:p:r:")) != EOF) 
 {
  switch (i) 
   {
    case 'b': /* Имя базы*/
      (*imabaz)=new char[strlen(optarg)+1];
      strcpy(*imabaz,optarg);
      break;

    case 'h': /* Хост*/
      (*host)=new char[strlen(optarg)+1];
      strcpy(*host,optarg);
      break;

    case 'p': /* Пароль*/
      (*parol)=new char[strlen(optarg)+1];
      strcpy(*parol,optarg);
      break;

    case 'r': /* Режим работы программы*/
      *regim=(int)ATOFM(optarg);
      break;

   }
 }

if(*parol == NULL)
 {
  if((*parol = getenv("PAROLICEB")) == NULL)
   {
    memset(bros,'\0',sizeof(bros));

    VVOD VPR(2);
    VPR.VVOD_SPISOK_add_MD(gettext("Введите пароль"));
    
    vparol(&VPR,bros,20,stdscr,-1,-1,1);
    if(bros[0] != '\0')
     {
      (*parol)=new char[strlen(bros)+1];
      strcpy((*parol),bros);
     }
   }

 }
if(*host == NULL)
 {
  strcpy(bros,"localhost");
  (*host)=new char[strlen(bros)+1];
  strcpy(*host,bros);
 }

if(*parol == NULL)
 {
  *parol=new char[4];
  strcpy((*parol),"aaa");
 }

if(*imabaz == NULL)
 {
  if(iceb_t_vb(*host,*parol,&*imabaz) != 0)
   {
    refresh();
    endwin();
    exit(0);
/***********
    memset(bros,'\0',sizeof(bros));
    VVOD VVOD1(2);
    VVOD1.VVOD_SPISOK_add_MD(gettext("Введите имя базы данных"));
    vvod1(bros,20,&VVOD1,NULL,stdscr,-1,-1);
    if(bros[0] != '\0')
     {
      (*imabaz)=new char[strlen(bros)+1];
      strcpy(*imabaz,bros);
     }
*********/
   }  
 }


if(*imabaz == NULL)
 {
  strcpy(bros,"bx");
  (*imabaz)=new char[strlen(bros)+1];
  strcpy(*imabaz,bros);
 }
/*
printw("readkey parol=%s\n",*parol);
OSTANOV();
*/
//clear();
//refresh();
}
/************************************************/
//Если вернули 0 - все в порядке
//             1 - не все впорядке       

int	readkey(int argc,char **argv,
char **parol, //Паpоль
char **imabaz, //Имя базы
char **host, //Хост
int *regim, //Режим pаботы пpогpаммы
FILE *ff) //Файл в который выгружаются сообщения
{
int		i;
char		bros[256];

/* Просмотр ключей    */
/*
b - имя базы
h - хост
p - пароль
r - режим работы программы, для разных подсистем по разному
*/
*regim=0;
while ((i = getopt(argc, argv, "b:h:p:r:")) != EOF) 
 {
  switch (i) 
   {
    case 'b': /* Имя базы*/
      (*imabaz)=new char[strlen(optarg)+1];
      strcpy(*imabaz,optarg);
      break;

    case 'h': /* Хост*/
      (*host)=new char[strlen(optarg)+1];
      strcpy(*host,optarg);
      break;

    case 'p': /* Пароль*/
      (*parol)=new char[strlen(optarg)+1];
      strcpy(*parol,optarg);
      break;

    case 'r': /* Режим работы программы*/
      *regim=(int)ATOFM(optarg);
      break;

   }
 }

if(*parol == NULL)
 {
  if((*parol = getenv("PAROLICEB")) == NULL)
   {
    if(ff != NULL)
     fprintf(ff,"Не задан пароль доступа к базе данных !\n");
    return(1);
   }

 }
if(*imabaz == NULL)
 {
  if(ff != NULL)
   fprintf(ff,"Не задано имя базы данных !\n");
  return(1);
 }

if(*host == NULL)
 {
  strcpy(bros,"localhost");
  (*host)=new char[strlen(bros)+1];
  strcpy(*host,bros);
 }
if(ff != NULL)
 fprintf(ff,"Хост:%s\n",*host);
return(0); 
}
