/* $Id: salorok.c,v 5.68 2011-01-13 13:43:31 sasa1 Exp $ */
/*13.03.2010    27.08.1997      Белых А.И.      salorok.c
Получение сальдо по организации по всем счетам
*/
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include        "buhl.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void saloro1(const char*,short,short,short,short,short,short,const char*,const char*,FILE*,FILE*,FILE*,FILE*,FILE*,double*,double*,short,class SPISOK*,class masiv_din_double*,const char*,const char*,FILE*,FILE*,FILE*);
void            obit(double,double,short,int,FILE*);
void potf(const char*,const char*,short,short,short,short,short,short,char*,char*,class SPISOK*,class masiv_din_double*);
void		vsali(double,double,short,short,FILE*,class masiv_din_double*);

extern char	*organ;

int salorok(const char *kodo,const char *nai,class spis_oth *oth)
{
char            bros[512];
static char     dat1[11],dat2[11];
static char	sheta[112];
short           par;
int             ks;
short           dn,mn,gn;
short           dk,mk,gk;
int             i;
char            sh[32];
FILE            *ff1,*ff2,*ff3,*ff4,*ffact;
char            imaf[32],imaf1[32],imaf2[32],imaf4[30],imafacts[30];
time_t          tmm;
struct  tm      *bf;
double          db,kr;
double          db1,kr1;
char		strsql[512];
SQL_str         row,row1;
long		kolstr;
short	dt,mt,gt;

clear();
if(dat1[0] == '\0')
 {
  poltekdat(&dt,&mt,&gt);
  sprintf(dat1,"01.01.%d",gt);
  sprintf(dat2,"%02d.%02d.%d",dt,mt,gt);
 }

VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Расчет сальдо по всем счетам с развернутым сальдо"));

sprintf(strsql,"%s %s",kodo,nai);
VV.VVOD_SPISOK_add_ZAG(strsql);
VV.VVOD_SPISOK_add_MD(gettext("Начальная дата.."));
VV.VVOD_SPISOK_add_MD(gettext("Конечная дата..."));
VV.VVOD_SPISOK_add_MD(gettext("Счет......(,,).."));

VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2));
VV.VVOD_SPISOK_add_data(sheta,sizeof(sheta));

naz:;

helstr(LINES-1,0,"F2/+",gettext("расчитать"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

par=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(sheta,VV.VVOD_SPISOK_return_data(2),sizeof(sheta)-1);

switch(par)
 {
  case FK10:
  case ESC:
    return(1);
  case FK2:
  case PLU:
    break;
  case FK4:
    VV.VVOD_clear_data();  
    goto naz;

  default:
    goto naz;
 }

if(rsdatp(&dn,&mn,&gn,dat1,&dk,&mk,&gk,dat2) != 0)
  goto naz;

char kodgr[32];
char naimgr[112];
memset(kodgr,'\0',sizeof(kodgr));
memset(naimgr,'\0',sizeof(naimgr));
SQLCURSOR cur,cur1;

sprintf(strsql,"select grup from Kontragent where kodkon='%s'",kodo);
if(readkey(strsql,&row,&cur) == 1)
 strncpy(kodgr,row[0],sizeof(kodgr)-1);

if(kodgr[0] != '\0')
 {
  sprintf(strsql,"select naik from Gkont where kod=%s",kodgr);
  if(readkey(strsql,&row,&cur) == 1)
   strncpy(naimgr,row[0],sizeof(naimgr)-1);
 }
 
par=0;
VVOD DANET(1);
DANET.VVOD_SPISOK_add_MD(gettext("Встречные проводки учесть ?"));
if(danet(&DANET,1,stdscr) == 2)
  par=1;

clear();
GDITE();

time(&tmm);
bf=localtime(&tmm);


short	startgodb=0; /*Стартовый год*/

if(iceb_t_poldan("Стартовый год",strsql,"nastrb.alx") == 0)
 startgodb=atoi(strsql);

short godn=startgodb;
if(startgodb == 0 || startgodb > gn)
 godn=gn;

class SPISOK sheta_srs; /*Список счетов с развёрнутым сальдо*/
/*Смотрим по каким счетам введено сальдо*/
sprintf(strsql,"select ns from Saldo where kkk=1 and gs=%d and kodkon='%s' order by ns asc",
godn,kodo);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

while(cur.read_cursor(&row) != 0)
 {
  sheta_srs.plus(row[0]);
 }

/*Смотрим по каким счетам были сделаны проводки*/
sprintf(strsql,"select distinct sh from Prov where datp >= '%04d-1-1' and \
datp <= '%04d-%02d-%02d' and kodkon='%s' order by sh asc",godn,gk,mk,dk,kodo);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }


while(cur.read_cursor(&row) != 0)
 {
  sprintf(strsql,"select saldo from Plansh where ns='%s'",row[0]);
  if(readkey(strsql,&row1,&cur1) != 1)
   {
    sprintf(strsql,gettext("Не найден счёт %s в плане счетов!"),row[0]);
    iceb_t_soob(strsql);
    continue;
   }
  if(atoi(row1[0]) != 3)
   continue;  
  if(sheta_srs.find(row[0]) < 0)
    sheta_srs.plus(row[0]);
 }


ks=sheta_srs.kolih();
if(ks == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной проводки!"));
  return(1);
 }

printw("%s\n",gettext("Расчет сальдо по всем счетам с развернутым сальдо"));
printw("%s %s.\n",kodo,nai);
printw("\n%s %d.%d.%d %s %d.%d.%d\n",
gettext("Период с"),
dn,mn,gn,
gettext("до"),
dk,mk,gk);
printw(gettext("Количество счетов с развернутым сальдо:%d\n"),ks);
for(int ii=0; ii < ks ; ii++)
 printw(" %s",sheta_srs.ravno(ii));
printw("\n");


class masiv_din_double mdo;
mdo.make_class(ks*2);

char imaf_spr[56];
sprintf(imaf_spr,"sprk%d.lst",getpid());
FILE *ff_spr;
if((ff_spr = fopen(imaf_spr,"w")) == NULL)
 {
  error_op_nfil(imaf_spr,errno,"");
  return(1);
 }

sprintf(imaf,"sl%d.lst",getpid());
if((ff1 = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

sprintf(imaf1,"sla%d.lst",getpid());
if((ff2 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return(1);
 }

sprintf(imaf2,"slb%d.lst",getpid());
if((ff3 = fopen(imaf2,"w")) == NULL)
 {
  error_op_nfil(imaf2,errno,"");
  return(1);
 }

sprintf(imaf4,"slbc%d.lst",getpid());
if((ff4 = fopen(imaf4,"w")) == NULL)
 {
  error_op_nfil(imaf4,errno,"");
  return(1);
 }

sprintf(imafacts,"acts%d.lst",getpid());
if((ffact = fopen(imafacts,"w")) == NULL)
 {
  error_op_nfil(imafacts,errno,"");
  return(1);
 }

char imaf_acts[56];
sprintf(imaf_acts,"asv%d.lst",getpid());
FILE *ff_act;
if((ff_act = fopen(imaf_acts,"w")) == NULL)
 {
  error_op_nfil(imaf_acts,errno,"");
  return(1);
 }

char imaf_acts_bi[56];
sprintf(imaf_acts_bi,"asvbi%d.lst",getpid());
FILE *ff_act_bi;
if((ff_act_bi = fopen(imaf_acts_bi,"w")) == NULL)
 {
  error_op_nfil(imaf_acts_bi,errno,"");
  return(1);
 }

zagacts(dn,mn,gn,dk,mk,gk,bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,kodo,nai,ffact);
zagacts(dn,mn,gn,dk,mk,gk,bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,kodo,nai,ff_act);
zagacts(dn,mn,gn,dk,mk,gk,bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,kodo,nai,ff_act_bi);

db=kr=0.;
for(i=0; i < ks; i++)
 {
  strzag(LINES-1,0,ks,i);
  strncpy(sh,sheta_srs.ravno(i),sizeof(sh)-1);
  
  if(proverka(sheta,sh,0,0) != 0)
    continue;

  /*Проверяем есть ли код организации в списке данного счета*/
/**************
  sprintf(strsql,"select kodkon from Skontr where ns='%s' and \
kodkon='%s'",sh,kodo);
  if(readkey(strsql) != 1)
    continue;
****************/
  printw("%s\n",sh);
  refresh();
  db1=kr1=0.;
  saloro1(sh,dn,mn,gn,dk,mk,gk,kodo,nai,ff1,ff2,ff3,ff4,ffact,&db1,&kr1,par,&sheta_srs,&mdo,kodgr,naimgr,ff_act,ff_act_bi,ff_spr);
  obit(db1,kr1,0,0,ff1);
  obit(db1,kr1,0,1,ff4);
  db+=db1; kr+=kr1;
 }
obit(db,kr,1,0,ff1);
obit(db,kr,1,1,ff4);
podpis(ff1);
podpis(ff4);
fclose(ff1);
fclose(ff2);
fclose(ff3);
fclose(ff4);
//Концовка распечатки
konact(ffact);
fclose(ffact);
konact(ff_act);
fclose(ff_act);

konact(ff_act_bi);
fclose(ff_act_bi);

fclose(ff_spr);

printw(gettext("Сортируем проводки.\n"));
refresh();

//sprintf(bros,"sort -o %s -t\\| +0n -1 +1 -2 +3n +4n +5n -6 %s",imaf1,imaf1);
sprintf(bros,"sort -o %s -t\\| -k1n -k2 -k3n -k4n -k5n %s",imaf1,imaf1);
//runsystem(bros);
iceb_t_system(bros,0);
//sprintf(bros,"sort -o %s -t\\| +0n +1n +2n +3n +4b -5 %s",imaf2,imaf2);
sprintf(bros,"sort -o %s -t\\| -k1n -k2n -k3n -k4n -k5b %s",imaf2,imaf2);
//runsystem(bros);
iceb_t_system(bros,0);

potf(kodo,nai,dn,mn,gn,dk,mk,gk,imaf1,imaf2,&sheta_srs,&mdo);


printw_vr(tmm);


OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Распечатка проводок з дневными итогами по контрагенту"));

oth->spis_imaf.plus(imaf1);
oth->spis_naim.plus(gettext("Распечатка проводок по контрагенту с итогами по документам"));

oth->spis_imaf.plus(imaf2);
oth->spis_naim.plus(gettext("Распечатка проводок по контрагенту с итогами по комментариям"));

oth->spis_imaf.plus(imaf4);
oth->spis_naim.plus(gettext("Распечатка проводок по контрагенту"));

oth->spis_imaf.plus(imafacts);
oth->spis_naim.plus(gettext("Акт сверки"));

oth->spis_imaf.plus(imaf_acts);
oth->spis_naim.plus(gettext("Акт сверки с общими суммами по документам"));

oth->spis_imaf.plus(imaf_acts_bi);
oth->spis_naim.plus(gettext("Акт сверки с общими суммами по документам без месячных итогов"));

oth->spis_imaf.plus(imaf_spr);
oth->spis_naim.plus(gettext("Справка про сальдо по контаргенту"));

for(int nomer=0; nomer < oth->spis_imaf.kolih(); nomer++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nomer),1);
return(0);
}

/*************************************/
/*Получение сальдо по заданному счету*/
/*************************************/
void saloro1(const char *sh,short dn,short mn,short gn,
short dk,short mk,short gk,const char *kor,const char *nai,FILE *ff1,
FILE *ff2,FILE *ff3,FILE *ff4,FILE *ffact,
double *db,double *kr,
short mks, //0-все проводки 1-без взаимно кореспондирующих
class SPISOK *sheta_srs,class masiv_din_double *mdo,
const char *kodgr,
const char *naimgr,
FILE *ff_act,
FILE *ff_act_bi,
FILE *ff_spr)
{
time_t          tmm;
struct  tm      *bf;
double          ddn,kkn;
short           mvs;
short           d,m,g;
char		shh[10];
double		dd,kk;
int		nm;
long		kolstr;
SQL_str         row;
SQLCURSOR       cur;
char		strsql[512];
char		naish[512];
short		godn;
short		mes=0,god=0;
short		shet=0;
double		deb=0.,kre=0.;
double		debm=0.,krem=0.;
int		val=0;
char		koment[512];
short	startgodb=0; /*Стартовый год*/

if(iceb_t_poldan("Стартовый год",strsql,"nastrb.alx") == 0)
 startgodb=atoi(strsql);

godn=startgodb;
if(startgodb == 0 || startgodb > gn)
 godn=gn;

strcpy(shh,sh);

memset(naish,'\0',sizeof(naish));

sprintf(strsql,"select nais,stat from Plansh where ns='%s'",sh);
if(sql_readkey(&bd,strsql,&row,&cur) == 1)
 {
  strncpy(naish,row[0],sizeof(naish)-1);
  val=atoi(row[1]);
 }
if(val == 1)
 val=-1;
 
ddn=kkn=0.;
dd=kk=0.;
sprintf(strsql,"select deb,kre from Saldo where kkk='1' and gs=%d and \
ns='%s' and kodkon='%s'",godn,shh,kor);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

while(cur.read_cursor(&row) != 0)
 {
  ddn+=atof(row[0]);
  kkn+=atof(row[1]);
 }
if(ddn > kkn)
 {
  ddn=ddn-kkn; 
  kkn=0.;
 }
else
 {
  kkn=kkn-ddn;
  ddn=0;
 }
time(&tmm);
bf=localtime(&tmm);

fprintf(ff1,"%s\n\
%s: %s %s\n\
%s %s %s %s\n\
%s %d.%d.%d%s %s %d.%d.%d%s\n\
%s %d.%d.%d  %s - %d:%d\n",
organ,
gettext("Счет"),sh,naish,
gettext("Распечатка проводок"),
gettext("для контрагента"),
kor,nai,
gettext("Период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("Время"),
bf->tm_hour,bf->tm_min);

if(kodgr[0] != '\0')
 fprintf(ff1,"%s:%s %s\n",gettext("Группа"),kodgr,naimgr);
 
fprintf(ff1,"\
--------------------------------------------------------------------------------------------\n");

fprintf(ff1,gettext("\
  Дата    |Сче.к.|Записал|Номер док. |    Дебет   |   Кредит   |    К о м е н т а р и й    |\n"));
/********
                                                                123456789012345678901234567
*********/

fprintf(ff1,"\
--------------------------------------------------------------------------------------------\n");

fprintf(ff4,"%s\n\
%s: %s %s\n\
%s %s %s %s\n\
%s %d.%d.%d%s %s %d.%d.%d%s\n\
%s %d.%d.%d  %s - %d:%d\n",
organ,
gettext("Счет"),sh,naish,
gettext("Распечатка проводок"),
gettext("для контрагента"),
kor,nai,
gettext("Период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("Время"),
bf->tm_hour,bf->tm_min);

fprintf(ff4,"\
--------------------------------------------------------------------------------------------\n");

fprintf(ff4,gettext("\
  Дата    |Сче.к.|Записал|Номер док. |    Дебет   |   Кредит   |    К о м е н т а р и й    |\n"));

fprintf(ff4,"\
--------------------------------------------------------------------------------------------\n");

zagsh(sh,ffact);

class akt_sverki akt_svr;
strncpy(akt_svr.shet,sh,sizeof(akt_svr.shet)-1);

mvs=0;
g=godn;
d=1;
m=1;
int nomer=0;
int kolbsn37=iceb_tu_kolbait(37,gettext("Сальдо начальное"));
int kolbsn20=iceb_tu_kolbait(20,gettext("Сальдо начальное"));
while(sravmydat(d,m,g,dk,mk,gk) <= 0)
 {

  if(sravmydat(d,m,g,dn,mn,gn) >= 0 && mvs == 0)
   {
    nm=sheta_srs->find(sh);
    akt_svr.dn=d;
    akt_svr.mn=m;
    akt_svr.gn=g;

    if(ddn > kkn)    
     {
      akt_svr.start_saldo_deb=ddn-kkn;
      ddn=ddn-kkn;
      mdo->plus(ddn,nm*2);
      kkn=0.;
      printw("%20s\n",prnbr(ddn));
      
      fprintf(ff1,"%*s:%12s\n",kolbsn37,gettext("Сальдо начальное"),prnbr(ddn));
      
      fprintf(ff4,"%*s:%12s\n",kolbsn37,gettext("Сальдо начальное"),prnbr(ddn));

      fprintf(ffact,"%02d.%02d.%4d %-*.*s %10.2f %10s| |\n",
      d,m,g,kolbsn20,kolbsn20,gettext("Сальдо начальное"),ddn," ");

      fprintf(ffact,"\
------------------------------------------------------ ---------------------------------------------------\n");

     }
    else
     {
      akt_svr.start_saldo_kre=kkn-ddn;
      kkn=kkn-ddn;
      mdo->plus(kkn,nm*2+1);
      ddn=0.;
      printw("%20s %20s\n"," ",prnbr(kkn));

      fprintf(ff1,"%*s:%12s %12s\n",kolbsn37,
      gettext("Сальдо начальное")," ",prnbr(kkn));

      fprintf(ff4,"%*s:%12s %12s\n",kolbsn37,
      gettext("Сальдо начальное")," ",prnbr(kkn));

      fprintf(ffact,"%02d.%02d.%4d %-*.*s %10s %10.2f| |\n",
      d,m,g,kolbsn20,kolbsn20,gettext("Сальдо начальное")," ",kkn);

      fprintf(ffact,"\
------------------------------------------------------ ---------------------------------------------------\n");
     }
      mvs=1;
   }

  sprintf(strsql,"select * from Prov \
where val=%d and datp='%04d-%02d-%02d' and sh='%s' and kodkon='%s' order by sh asc",
  val,g,m,d,shh,kor);

  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    dpm(&d,&m,&g,1);
    continue;
   }

  if(kolstr == 0)
   {
    dpm(&d,&m,&g,1);
    continue;
   }
  shet=0;
  while(cur.read_cursor(&row) != 0)
   {
/*
      printw("%s %s %s %s %s deb=%s kre=%s\n",
      row[0],row[1],row[2],row[3],row[4],row[9],row[10]);
      refresh();
*/ 
    if(mks == 1)
     if(SRAV(sh,row[3],1) == 0 || sheta_srs->find(row[3]) == 0)
       continue;
    deb=atof(row[9]);
    kre=atof(row[10]);


    if(sravmydat(d,m,g,dn,mn,gn) >= 0)
    if(sravmydat(dk,mk,gk,d,m,g) >= 0)
     {
      if(shet == 0)
       {
        if(sravmydat(1,m,g,1,mes,god) != 0)
         {
          if(mes != 0)
           {
            salorksl(dd,kk,ddn,kkn,debm,krem,ff1,ffact);
            debm=krem=0.;
           }
          mes=m;
          god=g;
         }
        shet=1;
       }
      dd+=deb;
      kk+=kre;
      debm+=deb;
      krem+=kre;

      int kbsh=iceb_tu_kolbait(6,row[3]);
      int kbkto=iceb_tu_kolbait(3,row[5]);
      int kbnomd=iceb_tu_kolbait(11,row[6]);
      int kbkom=iceb_tu_kolbait(27,row[13]);
      
      fprintf(ff1,"%02d.%02d.%4d %-*s %-*s%4s %-*s %12s",
      d,m,g,kbsh,row[3],kbkto,row[5],row[11],kbnomd,row[6],prnbr(deb));

      fprintf(ff1," %12s %-*.*s\n",prnbr(kre),kbkom,kbkom,row[13]);
      for(int nom=27; nom < iceb_tu_strlen(row[13]); nom+=27)
        fprintf(ff1,"%63s %.*s\n","",iceb_tu_kolbait(27,iceb_tu_adrsimv(nom,row[13])),iceb_tu_adrsimv(nom,row[13]));

      fprintf(ff4,"%02d.%02d.%4d %-*s %-*s%4s %-*s %12s",
      d,m,g,kbsh,row[3],kbkto,row[5],row[11],kbnomd,row[6],prnbr(deb));

      fprintf(ff4," %12s %-*.*s\n",prnbr(kre),kbkom,kbkom,row[13]);
      for(int nom=27; nom < iceb_tu_strlen(row[13]); nom+=27)
        fprintf(ff4,"%63s %.*s\n","",iceb_tu_kolbait(27,iceb_tu_adrsimv(nom,row[13])),iceb_tu_adrsimv(nom,row[13]));

      fprintf(ff2,"%s|%s|%d|%d|%d|%s|%s|%s|%s|%s\n",
      row[2],row[6],g,m,d,row[3],row[5],row[9],row[10],row[13]);

      fprintf(ff3,"%s|%d|%d|%d|%s|%s|%s|%s|%s|%s|\n",
      row[2],g,m,d,row[13],row[6],row[3],row[5],row[9],row[10]);

      memset(koment,'\0',sizeof(koment));
      strcpy(koment,row[6]);
      strcat(koment," ");
      strcat(koment,row[13]);
      
      fprintf(ffact,"%02d.%02d.%4d %-20.20s %10.2f %10.2f| |\n",
      d,m,g,koment,deb,kre);

      //заряжаем массивы
      sprintf(strsql,"%d.%d.%d|%s",d,m,g,row[6]);
      if(row[6][0] == '\0')
         nomer=-1;
      else
         nomer=akt_svr.data_nomd.find(strsql);

      if(nomer < 0)
       {
        akt_svr.data_nomd.plus(strsql);
        if(strstrm(koment,"-ПДВ") == 1) //есть образец в строке
         {
          iceb_tu_cpbstr(&akt_svr.koment,koment,"-ПДВ");
         }
        else
          akt_svr.koment.plus(koment);
       }
      akt_svr.suma_deb.plus(deb,nomer);
      akt_svr.suma_kre.plus(kre,nomer);

      fprintf(ffact,"\
------------------------------------------------------ ---------------------------------------------------\n");

     }


    if(sravmydat(d,m,g,dn,mn,gn) < 0)
     {
      ddn+=deb;
      kkn+=kre;
     }

   }
  dpm(&d,&m,&g,1);
 }

printw("%20s",prnbr(dd));
printw(" %20s\n",prnbr(kk));

salorksl(dd,kk,ddn,kkn,debm,krem,ff1,ffact);
salorksl(dd,kk,ddn,kkn,0.,0.,ff4,NULL);

iceb_t_spk(dk,mk,gk,sh,naish,kor,nai,kk+kkn-dd-ddn,ff_spr);
fprintf(ff_spr,"\n\n");

*db+=dd+ddn;
*kr+=kk+kkn;

akt_sv(&akt_svr,ff_act,ff_act_bi);

}
/*********************/
/*Выдача общего итога*/
/*********************/
void obit(double db,double kr,
short mt, //0-пром. итог 1- общий
int metkascr, //0-выводить на экран 1-нет
FILE *ff1)
{
double          brr;

if(mt == 1 && metkascr == 0)
  printw("--------------------------------------------\n");

if(mt == 1)
 {
  fprintf(ff1,"\
---------------------------------------------------------------------------------------\n\
%*s:%12s",
  iceb_tu_kolbait(37,gettext("Общий итог")),gettext("Общий итог"),prnbr(db));
  fprintf(ff1," %12s\n",prnbr(kr));
 }

if(db >= kr)
 {
  brr=db-kr;
  if(metkascr == 0)
    printw("%20s\n",prnbr(brr));
  if(mt == 1)
      fprintf(ff1,"%38s%12s\n"," ",prnbr(brr));
 }
else
 {
  brr=kr-db;
  if(metkascr == 0)
    printw("%20s %20s\n"," ",prnbr(brr));
  if(mt == 1)
      fprintf(ff1,"%38s%12s %12s\n"," "," ",prnbr(brr));
 }

}

/*********************************/
/*Работа с отсортированным файлом*/
/*********************************/
void potf(const char *kor,const char *nai,short dn,short mn,short gn,
short dk,short mk,short gk,char *imaf1,char *imaf2,class SPISOK *sheta_srs,class masiv_din_double *mdo)
{
time_t          tmm;
struct  tm      *bf;
char		imaf3[32];
FILE		*ff1,*ff2;
short		d,m,g;
short		dd=0,md=0,gd=0;
char		sh[32],shz[32];
char		shk[32];
char		nn[32],nnz[32];
double		deb,deb1=0.,debo,debs;
double		kre,kre1=0.,kreo,kres;
char		kom[512],komz[512];
char		kto[16];
short		kop;
int		nm;
char		naish[512];
char		strsql[512];
SQL_str         row;
char		str[1024];
char		bros[512];

time(&tmm);
bf=localtime(&tmm);

//Дополнительная сортировка 
if((ff1 = fopen(imaf1,"r")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return;
 }

sprintf(imaf3,"sl%d.tmp",getpid());
if((ff2 = fopen(imaf3,"w")) == NULL)
 {
  error_op_nfil(imaf3,errno,"");
  return;
 }

memset(nnz,'\0',sizeof(nnz));
int nomdpp=0; //Номер документа по порядку
while(fgets(str,sizeof(str),ff1) != NULL)
 {
  POLE(str,sh,1,'|');

  POLE(str,nn,2,'|');

  POLE(str,bros,3,'|');
  g=(short)ATOFM(bros);

  POLE(str,bros,4,'|');
  m=(short)ATOFM(bros);

  POLE(str,bros,5,'|');
  d=(short)ATOFM(bros);

  if(SRAV(nn,nnz,0) != 0 || nn[0] == '\0') //Проводки без номеров документов  понимаем как отдельные документы
   {
    dd=d; md=m; gd=g;
    nomdpp++;
    strcpy(nnz,nn);
   }
  else
   {
    if(gd != g)
     {
      dd=d; md=m; gd=g;
      nomdpp++;
     }
   }
  fprintf(ff2,"%s|%d|%d|%d|%d|%s",sh,gd,md,dd,nomdpp,str);
 }


fclose(ff1);
fclose(ff2);

//sprintf(bros,"sort  -o %s -t\\| +0 -1 +1n -2 +2n -3 +3n -4 +4n -5 %s",imaf3,imaf3);
sprintf(bros,"sort -o %s -t\\| -k1n -k2n -k3n -k4n %s",imaf3,imaf3);
//runsystem(bros);
iceb_t_system(bros,0);


if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return;
 }
if((ff2 = fopen(imaf3,"r")) == NULL)
 {
  error_op_nfil(imaf3,errno,"");
  return;
 }

fprintf(ff1,gettext("Проводки по одному документу просумированы.\n"));

fprintf(ff1,"%s\n\
%s %s %s %s\n\
     %s %d.%d.%d%s %s %d.%d.%d%s\n\
%s %d.%d.%d  %s - %d:%d\n",
organ,
gettext("Распечатка проводок"),
gettext("для контрагента"),
kor,nai,
gettext("Период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("Время"),
bf->tm_hour,bf->tm_min);

shz[0]='\0';
memset(nnz,'\0',sizeof(nnz));
kre=deb=debo=kreo=debs=kres=0.;
nm=kop=0;
SQLCURSOR curr;
while(fgets(str,sizeof(str),ff2) != NULL)
 {
  POLE(str,sh,6,'|');

  POLE(str,nn,7,'|');

  POLE(str,bros,8,'|');
  g=(short)ATOFM(bros);

  POLE(str,bros,9,'|');
  m=(short)ATOFM(bros);

  POLE(str,bros,10,'|');
  d=(short)ATOFM(bros);

  POLE(str,shk,11,'|');
  POLE(str,kto,12,'|');
  POLE(str,bros,13,'|');
  deb1=ATOFM(bros);
  POLE(str,bros,14,'|');
  kre1=ATOFM(bros);
  POLE(str,kom,15,'|');

 
  if(SRAV(nn,nnz,0) != 0)
   {
    sprintf(bros,gettext("Итог по документу %s:"),nnz);
    fprintf(ff1,"%*s %12s",iceb_tu_kolbait(32,bros),bros,prnbr(deb));
    fprintf(ff1," %12s\n\n",prnbr(kre));
    kop=0;
    strcpy(nnz,nn);
    deb=kre=0.;
   }

  if(SRAV(sh,shz,0) != 0)
   {
    if(shz[0] != '\0')
     {
      if(deb != 0. || kre != 0.)
       {
        sprintf(bros,gettext("Итог по документу %s:"),nnz);
        fprintf(ff1,"%*s %12s",iceb_tu_kolbait(32,bros),bros,prnbr(deb));
        fprintf(ff1," %12s\n\n",prnbr(kre));
        deb=kre=0.;
        
       }
      vsali(debs,kres,nm,0,ff1,mdo);
      debs=kres=0.;
     }

    nm=sheta_srs->find(sh);
    debo+=mdo->ravno(nm*2);
    kreo+=mdo->ravno(nm*2+1);

    memset(naish,'\0',sizeof(naish));

    sprintf(strsql,"select nais from Plansh where ns='%s'",sh);
    if(sql_readkey(&bd,strsql,&row,&curr) == 1)
      strncpy(naish,row[0],sizeof(naish)-1);
    
    fprintf(ff1,"\n%s: %s %s\n\
---------------------------------------------------------------------------------------\n",
    gettext("Счет"),sh,naish);
    if(mdo->ravno(nm*2) > mdo->ravno(nm*2+1) )
      {
       fprintf(ff1,"%*s:%12s\n",iceb_tu_kolbait(32,gettext("Сальдо начальное")),gettext("Сальдо начальное"),prnbr(mdo->ravno(nm*2)));
      }
     else
      {
       fprintf(ff1,"%*s:%12s %12s\n",iceb_tu_kolbait(32,gettext("Сальдо начальное")),gettext("Сальдо начальное")," ",prnbr(mdo->ravno(nm*2+1)));
      }

    strcpy(shz,sh);
   }

  fprintf(ff1,"%02d.%02d.%4d %-*s %-*s %-*s %12s",
  d,m,g,
  iceb_tu_kolbait(8,shk),shk,
  iceb_tu_kolbait(7,nn),nn,
  iceb_tu_kolbait(4,kto),kto,
  prnbr(deb1));

  fprintf(ff1," %12s %.*s\n",prnbr(kre1),iceb_tu_kolbait(27,kom),kom);

  for(int nom=27; nom < iceb_tu_strlen(kom); nom+=27)
        fprintf(ff1,"%58s %.*s\n","",iceb_tu_kolbait(27,iceb_tu_adrsimv(nom,kom)),iceb_tu_adrsimv(nom,kom));

  if(nn[0] != '\0' )
   {
    kop++;
   }
  deb+=deb1;
  kre+=kre1;
  debs+=deb1;
  kres+=kre1;
  debo+=deb1;
  kreo+=kre1;
 }
sprintf(bros,gettext("Итог по документу %s:"),nnz);
fprintf(ff1,"%*s %12s",iceb_tu_kolbait(32,bros),bros,prnbr(deb));
fprintf(ff1," %12s\n\n",prnbr(kre));

vsali(debs,kres,nm,0,ff1,mdo);
vsali(debo,kreo,nm,1,ff1,mdo);
podpis(ff1);

fclose(ff1);
fclose(ff2);
unlink(imaf3);


sprintf(imaf3,"sl%d.tmp",getpid());
rename(imaf2,imaf3);
unlink(imaf2);


if((ff1 = fopen(imaf2,"w")) == NULL)
 {
  error_op_nfil(imaf2,errno,"");
  return;
 }
if((ff2 = fopen(imaf3,"r")) == NULL)
 {
  error_op_nfil(imaf3,errno,"");
  return;
 }
fprintf(ff1,gettext("Проводки по одному комментарию просумированы\n"));

fprintf(ff1,"%s\n\
%s %s %s %s\n\
     %s %d.%d.%d%s %s %d.%d.%d%s\n\
%s %d.%d.%d  %s - %d:%d\n",
organ,
gettext("Распечатка проводок"),
gettext("для контрагента"),
kor,nai,
gettext("Период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("Время"),
bf->tm_hour,bf->tm_min);


shz[0]='\0';
komz[0]='\0';
kre=deb=debo=kreo=debs=kres=0.;
kop=0;
while(fgets(str,sizeof(str),ff2) != NULL)
 {

  POLE(str,sh,1,'|');

  POLE(str,bros,2,'|');
  g=(short)ATOFM(bros);

  POLE(str,bros,3,'|');
  m=(short)ATOFM(bros);

  POLE(str,bros,4,'|');
  d=(short)ATOFM(bros);

  POLE(str,kom,5,'|');

  POLE(str,nn,6,'|');
  POLE(str,shk,7,'|');
  POLE(str,kto,8,'|');
  POLE(str,bros,9,'|');
  deb1=ATOFM(bros);
  POLE(str,bros,10,'|');
  kre1=ATOFM(bros);
 
 
  if(SRAV(kom,komz,0) != 0)
   {
    sprintf(bros,gettext("Итог по комментарию %.10s:"),komz);
    fprintf(ff1,"%*s %12s",iceb_tu_kolbait(32,bros),bros,prnbr(deb));
    fprintf(ff1," %12s\n\n",prnbr(kre));
    kop=0;
    strcpy(komz,kom);
    deb=kre=0.;
   }

  if(SRAV(sh,shz,0) != 0)
   {
    if(shz[0] != '\0')
     {
      vsali(debs,kres,nm,0,ff1,mdo);
      debs=kres=0.;
     }

    nm=sheta_srs->find(sh);
    debo+=mdo->ravno(nm*2);
    kreo+=mdo->ravno(nm*2+1);
    
    fprintf(ff1,"\n%s %s\n\
---------------------------------------------------------------------------------------\n",gettext("Счёт"),sh);
    if(mdo->ravno(nm*2) > mdo->ravno(nm*2+1))    
       fprintf(ff1,"%*s:%12s\n",iceb_tu_kolbait(32,gettext("Сальдо начальное")),gettext("Сальдо начальное"),prnbr(mdo->ravno(nm*2)));
     else
       fprintf(ff1,"%*s:%12s %12s\n",iceb_tu_kolbait(32,gettext("Сальдо начальное")),gettext("Сальдо начальное")," ",prnbr(mdo->ravno(nm*2+1)));
    strcpy(shz,sh);
   }

  fprintf(ff1,"%02d.%02d.%4d %-*s %-*s %-*s %12s",
  d,m,g,
  iceb_tu_kolbait(8,shk),shk,
  iceb_tu_kolbait(7,nn),nn,
  iceb_tu_kolbait(4,kto),kto,
  prnbr(deb1));

  fprintf(ff1," %12s %.*s\n",prnbr(kre1),iceb_tu_kolbait(27,kom),kom);

  for(int nom=27; nom < iceb_tu_strlen(kom); nom+=27)
        fprintf(ff1,"%58s %.*s\n","",iceb_tu_kolbait(27,iceb_tu_adrsimv(nom,kom)),iceb_tu_adrsimv(nom,kom));

  if(kom[0] != '\0' )
    kop++;
  deb+=deb1;
  kre+=kre1;
  debo+=deb1;
  kreo+=kre1;
  debs+=deb1;
  kres+=kre1;
  
 }
sprintf(bros,gettext("Итог по комментарию %.10s:"),komz);
fprintf(ff1,"%*s %12s",iceb_tu_kolbait(32,bros),bros,prnbr(deb));
fprintf(ff1," %12s\n\n",prnbr(kre));

vsali(debs,kres,nm,0,ff1,mdo);
vsali(debo,kreo,nm,1,ff1,mdo);

podpis(ff1);
fclose(ff1);
fclose(ff2);
unlink(imaf3);

}


/*********************/
/*Выдача итога в файл*/
/*********************/
void		vsali(double debs,double kres,short nm,short met,FILE *ff1,class masiv_din_double *mdo)
{
double		brr;

if(met == 1)
 {
  fprintf(ff1,"\n\
---------------------------------------------------------------------------------------\n\
%*s:%12s",iceb_tu_kolbait(32,gettext("Общий итог")),gettext("Общий итог"),prnbr(debs));

  fprintf(ff1," %12s\n",prnbr(kres));

  if(debs >= kres)
   {
    brr=debs -kres;
    fprintf(ff1,"%33s%12s\n"," ",prnbr(brr));
   }
  else
   {
    brr=kres-debs;
    fprintf(ff1,"%33s%12s %12s\n"," "," ",prnbr(brr));
   }

  return;
 }

fprintf(ff1,"\
---------------------------------------------------------------------------------------\n\
%*s:%12s",iceb_tu_kolbait(32,gettext("Оборот за период")),gettext("Оборот за период"),prnbr(debs));

fprintf(ff1," %12s\n",prnbr(kres));

brr=debs+mdo->ravno(nm*2);
fprintf(ff1,"%*s:%12s",iceb_tu_kolbait(32,gettext("Сальдо развернутое")),gettext("Сальдо развернутое"),prnbr(brr));

brr=kres+mdo->ravno(nm*2+1);
fprintf(ff1," %12s\n",prnbr(brr));
 
if(mdo->ravno(nm*2)+ debs >= mdo->ravno(nm*2+1)+kres)
 {
  brr=mdo->ravno(nm*2)+ debs - (mdo->ravno(nm*2+1)+kres);
  fprintf(ff1,"%*s:%12s\n",iceb_tu_kolbait(32,gettext("Сальдо конечное")),gettext("Сальдо конечное"),prnbr(brr));
 }
else
 {
  brr=mdo->ravno(nm*2+1)+kres-(mdo->ravno(nm*2)+ debs) ;
  fprintf(ff1,"%*s:%12s %12s\n",iceb_tu_kolbait(32,gettext("Сальдо конечное")),gettext("Сальдо конечное")," ",prnbr(brr));
 }

}
