/*$Id: smenabaz.c,v 5.38 2011-02-21 07:31:32 sasa Exp $*/
/*31.10.2010	29.01.2000	Белых А.И.	smenabaz.c
Смена базы данных
Возвращаем 0 если базу сменили успешно
	  -1 если базу не меняли
*/
#include       <errno.h>
#include        <pwd.h>
#include        "buhl.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


extern char *host;
extern char *parol_pol;
extern char *imabaz;
extern char *organ;

int smenabaz(int mopen) //0-открыть и закрыть 1-закрыть и открыть
{
int kod_kl=0;
char host_v[1024];
char bros[512];
class iceb_tu_str imabaz_v("");
memset(host_v,'\0',sizeof(host_v));
int i=0;

FILE *ff;
if((ff = fopen(".spisokbaz.alx","r")) == NULL)
 {
  if(errno != ENOENT)
   {
    error_op_nfil(".spisokbaz.alx",errno,"");
    return(1);
   }

  if(errno == ENOENT) /*Файл не существует*/
   {
    strncpy(host_v,host,sizeof(host_v)-1);

    if(smenabaz_mysql(&imabaz_v,0) != 0)
     {
      return(1);
     }
   }
 }
else
 {
  char bros1[512];
  char str_menu[512];
  char stroka[1024];
  class SPISOK masiv;
  class SPISOK sp_host;
  while(fgets(stroka,sizeof(stroka),ff) != NULL)
   {
  //  printw("%s\n",stroka);
  //  refresh();
    if(stroka[0] == '#')
      continue;
    if(polen(stroka,bros,sizeof(bros),1,'|') != 0)
      continue;

    polen(stroka,bros1,sizeof(bros1),2,'|');
    sprintf(str_menu,"%-*s|%s",iceb_tu_kolbait(6,bros),bros,bros1);
    masiv.plus(str_menu);


    polen(stroka,bros1,sizeof(bros1),3,'|');
    sp_host.plus(bros1);    
   }

  fclose(ff);

  helstr(LINES-1,0,"Enter",gettext("выбор нужного"),
  "F10",gettext("выход"),NULL);

  int voz=dirmasiv(&masiv, -1,-1, 0,gettext("Выберите нужную базу данных"),1,&kod_kl);

  if(voz < 0 || kod_kl != ENTER)
    return(-1);

  strncpy(bros1,masiv.ravno(voz),sizeof(bros1)-1);
  polen(bros1,&imabaz_v,1,'|');
  strncpy(host_v,sp_host.ravno(voz),sizeof(host_v)-1);
 }

 
struct  passwd  *ktor; /*Кто работает*/
ktor=getpwuid(getuid());
/**********
char *host_open;
if(host_v[0] == '\0')
  host_open=*host;
else
 {
  host_open=(char*)&host_v;
 }
*********/
class iceb_tu_str host_open;
if(host_v[0] == '\0')
  host_open.plus(host);
else
 {
  host_open.plus(host_v);
 }
//printw("\nhost_open=%s\n",host_open);
//OSTANOV();
if(mopen == 0)
 if(sql_openbaz(&bd,imabaz_v.ravno(),host_open.ravno(),ktor->pw_name,parol_pol) != 0)
  {
   eropbaz(imabaz_v.ravno(),ktor->pw_uid,ktor->pw_name,1);
   return(-1);
  }

if(mopen == 1)
 {
  sql_closebaz(&bd);

  if(sql_openbaz(&bd,imabaz_v.ravno(),host_open.ravno(),ktor->pw_name,parol_pol) != 0)
   {
    eropbaz(imabaz_v.ravno(),ktor->pw_uid,ktor->pw_name,1);

    if(sql_openbaz(&bd,imabaz,host,ktor->pw_name,parol_pol) != 0)
     {
    /*  printw("%s\n",sql_error(&bd));*/
    /*  OSTANOV();*/
     }

    return(-1);
   }

 }


if(host_v[0] != '\0')
 {
  delete [] host;
  host=new char[strlen(host_v)+1];
  strcpy(host,host_v);
 }

delete [] imabaz;

imabaz=new char[strlen(imabaz_v.ravno())+1];
strcpy(imabaz,imabaz_v.ravno());

/*читаем после присвоения имени базы*/
icebstart_rf(); //чтение и выполнение запросов к базе сразу после открытия

/*Читаем наименование организации*/
if(organ != NULL)
 {
  free(organ);
  organ=NULL;
 }
char strsql[512];
SQL_str row;
SQLCURSOR cur;
sprintf(strsql,"select naikon from Kontragent where kodkon='00'");

if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  iceb_t_vkk00();
/**********
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено наименование организации по коду 00 !"));  
  soobshw(&SOOB,stdscr,-1,-1,0,1);

  class VVOD  VVOD1(2);
  class iceb_tu_str naim_kontr("");

  if(vvod1(&naim_kontr,40,&VVOD1,NULL,stdscr,-1,-1) == FK10)
   {  
    i=1+strlen(gettext("Не введено код контрагента 00 !"));
    if((organ=(char *)malloc(i*sizeof(char))) == NULL)
       error2(20,0,1,"Не могу выделить пямять для organ !");
    strcpy(organ,gettext("Не введено код контрагента 00 !"));
   }
  else
   {
    sprintf(strsql,"insert into Kontragent (naikon,ktoz,vrem) values ('%s',%d,%ld)",naim_kontr.ravno(),getuid(),time(NULL));
    sql_zapis(strsql,1,0);
    if((organ=(char *)malloc(naim_kontr.getdlinna()*sizeof(char))) == NULL)
       error2(20,0,1,"Не могу выделить пямять для organ !");
    strcpy(organ,naim_kontr.ravno());
   }    
**********************/
 }
else
 {
  strcpy(strsql,row[0]);   
  i=strlen(strsql)+1;
  if((organ=(char *)malloc(i*sizeof(char))) == NULL)
       error2(20,0,1,"Не могу выделить пямять для organ !");

  strcpy(organ,strsql);
 }
if(mopen == 0)
 sql_closebaz(&bd);

return(0);
 

}
/*************************************/
/*просмотр списка баз в Mysql*/
/********************************/

int smenabaz_mysql(class iceb_tu_str *imabazv,
int metka) /* 0 - показать список если база только одна 1- не показывать а установить ее как выбаранную*/
{
char strsql[512];
class SQLCURSOR cur,cur1;
SQL_str row,row1;
int kolstr;
class SPISOK masiv;
class iceb_tu_str naim_org("");
class iceb_tu_str imaendbaz("");
int mdib=0; /*Максимальная длинна имени базы*/
GDITE();

/*Смотрим имя последей базы с которой работал оператор*/
poldan("NAMEBAZ",&imaendbaz,".iceb.dat");

if((kolstr=cur.make_cursor(&bd,"SHOW DATABASES")) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной базы !"));
  return(1);
 }
int nom_baz=0;
int kol_db=0; /*Количество доступных баз*/
int kodv=0;

while(cur.read_cursor(&row) != 0)
 {
  sprintf(strsql,"select naikon from %s.Kontragent where kodkon='00'",row[0]);

  if((kodv=sql_readkey(&bd,strsql,&row1,&cur1)) < 0)
    continue;
  if(mdib < (int)strlen(row[0]))
   mdib=strlen(row[0]);
 }

cur.poz_cursor(0);
while(cur.read_cursor(&row) != 0)
 {
  sprintf(strsql,"select naikon from %s.Kontragent where kodkon='00'",row[0]);
  naim_org.new_plus("");

  if((kodv=sql_readkey(&bd,strsql,&row1,&cur1)) < 0)
    continue;
 
  if(kodv == 1)
   naim_org.new_plus(row1[0]);


  sprintf(strsql,"%-*s|%s",iceb_tu_kolbait(mdib,row[0]),row[0],naim_org.ravno());
  masiv.plus(strsql);
  if(proverka(imaendbaz.ravno(),row[0],0,1) == 0)
   nom_baz=kol_db;
  kol_db++;
 }

if(kol_db == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной базы, к которой вам разрешён доступ!"));
  return(1);
 }

if(kol_db == 1 && metka == 1)
 {
  polen(masiv.ravno(0),imabazv,1,'|');
 
  return(0);
  
 }

helstr(LINES-1,0,"Enter",gettext("выбор нужного"),
"F10",gettext("выход"),NULL);
int kod_kl=0;
int voz=dirmasiv(&masiv, -1,-1,nom_baz,gettext("Выберите нужную базу данных"),1,&kod_kl);

if(voz < 0 || kod_kl != ENTER)
    return(-1);
  
polen(masiv.ravno(voz),imabazv,1,'|');

return(0);

}
