/* $Id: amort.c,v 5.35 2011-03-28 06:53:58 sasa Exp $ */
/*28.09.2010    08.07.1996      Белых А.И.      amort.c
Расчет амортзационных отчислений
для заданного инвентарного номера за заданный месяц
Определить числиться ли инвентарны номер и в каком подразделении
он находиться на заданную дату. Если не числится расчет не проводим
Если числится смотрим настройку и делаем расчет
В месяце убытия амортизация считается в подразделении
где числился. В подразделении где прибыл амотизация считается со
следующего месяца
Если вернули 0 - расчитали
	     1 - нет
*/
#include        <time.h>
#include        <pwd.h>
#include        <errno.h>
#include        "buhg.h"
#include        "uos.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void	amortbo(long,int,double,short,double,double);

extern float      nemi; /*Необлагаемый минимум*/
extern struct UOS uos;
extern short metkabo;  //Если 1 то организация бюджетная

short amort(long in,
short mr,short gr,
short mra, //0-расчет в потоке 1-нет
short kvrt,  //Квартал
const char *grupa,
FILE *ff_prot)

{
int             i,i1;
double		sbs,siz;
double          bs,iz,iz1;
double		sbsby,sizby;
double          bsby,izby,iz1by;
double		amort[4];
double		kof;
int		podr;
short		m1,g1;
SQL_str         row;
SQLCURSOR curr;
char		strsql[512];
time_t		vrem;
int		kodotl;

podr=0;
if(metkabo == 1)
  mr=1;
  

memset(&amort,'\0',sizeof(amort));
 
if(kvrt != 0)
 {
  if(kvrt == 1)
    mr=1;
  if(kvrt == 2)
    mr=4;
  if(kvrt == 3)
    mr=7;
  if(kvrt == 4)
    mr=10;
 }

if(mra == 0)
  printw("in-%ld %d.%d\n",in,mr,gr);
if(ff_prot != NULL)
  fprintf(ff_prot,"Расчёт амортизации для налогового учёта.\nin-%ld %d.%d\n",in,mr,gr);


if(metkabo == 1)
 {
  if((i=poiin(in,1,1,gr+1,&podr,&kodotl)) != 0)
   {
    printw("%s %ld %s %d.%d ! %s %d.\n",
    gettext("Инвентарный номер"),in,
    gettext("не числится по дате"),1,gr+1,
    gettext("Код ошибки"),i);

    if(ff_prot != NULL)
     fprintf(ff_prot,"%s %ld %s %d.%d ! %s %d.\n",
    gettext("Инвентарный номер"),in,
    gettext("не числится по дате"),1,gr+1,
    gettext("Код ошибки"),i);
    return(1);
   }   
 }
else
 if((i=poiin(in,1,mr,gr,&podr,&kodotl)) != 0)
  {
   printw("%s %ld %s %d.%d ! %s %d.\n",
   gettext("Инвентарный номер"),in,
   gettext("не числится по дате"),mr,gr,
   gettext("Код ошибки"),i);


   if(ff_prot != NULL)
     fprintf(ff_prot,"%s %ld %s %d.%d ! %s %d.\n",
   gettext("Инвентарный номер"),in,
   gettext("не числится по дате"),mr,gr,
   gettext("Код ошибки"),i);
   return(1);
  }   


if(metkabo == 1)
 {
  if((i=poiinpd(in,1,gr+1,uos.shetu,uos.hzt,uos.hau,uos.hna,&uos.popkf,&uos.soso,uos.nomz,&m1,&g1,uos.hnaby,&uos.popkfby)) != 0)
   {
    printw("%s %ld %s %d.%d ! %s %d.\n",
    gettext("Инвентарный номер"),in,
    gettext("не найдено настройки на дату"),1,gr+1,
    gettext("Код ошибки"),i);
    

   if(ff_prot != NULL)
     fprintf(ff_prot,"%s %ld %s %d.%d ! %s %d.\n",
    gettext("Инвентарный номер"),in,
    gettext("не найдено настройки на дату"),1,gr+1,
    gettext("Код ошибки"),i);

    return(1);
   }  
 }
else
if((i=poiinpd(in,mr,gr,uos.shetu,uos.hzt,uos.hau,uos.hna,&uos.popkf,&uos.soso,uos.nomz,&m1,&g1,uos.hnaby,&uos.popkfby)) != 0)
 {
  printw("%s %ld %s %d.%d ! %s %d.\n",
  gettext("Инвентарный номер"),in,
  gettext("не найдено настройки на дату"),mr,gr,
  gettext("Код ошибки"),i);

  if(ff_prot != NULL)
   fprintf(ff_prot,"%s %ld %s %d.%d ! %s %d.\n",
  gettext("Инвентарный номер"),in,
  gettext("не найдено настройки на дату"),mr,gr,
  gettext("Код ошибки"),i);

  return(1);
 }  

if(proverka(grupa,uos.hna,0,0) != 0 || uosprovgr(uos.hna) != 0)
 {
  printw("%s %s %s.\n",
  gettext("Инвентарный номер в группе"),uos.hna,
  gettext("(амортизация не считается)"));

  if(ff_prot != NULL)
   fprintf(ff_prot,"%s %s %s.\n",
  gettext("Инвентарный номер в группе"),uos.hna,
  gettext("(амортизация не считается)"));
  if(mra == 1)
     OSTANOV();
  return(1);
 }

if(uos.soso == 1 || uos.soso == 2  )
 {


  if(ff_prot != NULL)
   fprintf(ff_prot,"%s %ld %s.\n",
  gettext("Инвентарный номер"),in,
  gettext("не эксплуатируется"));
  refresh();
  if(mra == 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %ld %s.",
    gettext("Инвентарный номер"),in,
    gettext("не эксплуатируется"));

    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  goto vp;
 }

//printw("in=%d podr=%d %d.%d\n",in,podr,mr,gr);
sbs=siz=bs=iz=iz1=0.;
sbsby=sizby=bsby=izby=iz1by=0.;
if(metkabo != 1)
  bsiz(in,podr,1,mr,gr,&sbs,&siz,&bs,&iz,&iz1,&sbsby,&sizby,&bsby,&izby,&iz1by,ff_prot);
else
  bsiz(in,podr,1,1,gr+1,&sbs,&siz,&bs,&iz,&iz1,&sbsby,&sizby,&bsby,&izby,&iz1by,ff_prot);
bs+=sbs-uosgetls(in,1,mr,gr,0);
iz+=siz;
iz+=iz1;

if(bs <= iz)
 {
//  map=1;
  beep();
  printw("%s %ld %s. %.2f <= %.2f\n",
  gettext("Инвентарный номер"),in,
  gettext("амортизирован полностью"),bs,iz);

  if(ff_prot != NULL)
   fprintf(ff_prot,"%s %ld %s. bs=%.2f <= iz=%.2f\n",
  gettext("Инвентарный номер"),in,
  gettext("амортизирован полностью"),bs,iz);
  if(mra == 1)
     OSTANOV();
  refresh();
 }

/*Читаем коэффициент*/
sprintf(strsql,"select kof from Uosgrup where kod='%s'",uos.hna);
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  beep();
  printw("%s %ld - %s %s !\n",
  gettext("Инвентарный номер"),in,
  gettext("не нашли кода группы"),uos.hna);


  if(ff_prot != NULL)
    fprintf(ff_prot,"%s %ld - %s %s !\n",
  gettext("Инвентарный номер"),in,
  gettext("не нашли кода группы"),uos.hna);
  refresh();
  if(mra == 1)
     OSTANOV();
  return(1);
 }

kof=atof(row[0]);
/*
printw("bs=%f iz=%f popkf=%f kof=%f nemi=%f\n",bs,iz,uos.popkf,kof,nemi);
OSTANOV();    
*/

if(metkabo == 1)
 {
  amortbo(in,podr,kof,gr,bs,iz);
  return(0);
 }

if(uosprovar(uos.hna,0) == 1) /*Амортизация от остаточной балансовой стоимости*/
 {
  if(kvrt == 0)
   {
    return(1);
   }   
  if(SRAV(uos.hna,"1",0) == 0 && bs-iz <= 100*nemi)
   {
    amort[1]=bs-iz;
   }
  else
   {      
    
    amort[0]=(bs-iz)*uos.popkf*3*kof/100/12.;

    if(ff_prot != NULL)
      fprintf(ff_prot,"%s=(%.2f-%.2f)*%.2f/100/12*3*%.2f=%.2f\n",
    gettext("Амортизация"),
    bs,iz,kof,uos.popkf,amort[0]);
    if(mra == 1)
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Амортизация"));
      sprintf(strsql,"(%.2f-%.2f)*%.2f/100/12*3*%.2f=%.2f",
      bs,iz,kof,uos.popkf,amort[0]);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
     }

    amort[0]=okrug(amort[0],0.01);
    amort[1]=amort[0]/3;
    amort[1]=okrug(amort[1],0.01);
    amort[2]=amort[1];
    amort[3]=amort[0]-amort[1]-amort[2];


   }
 }
else  /*Амортизация от начальной балансовой стоимости*/
 {

  if(kvrt != 0 )
   {
    return(1); 
   }
  amort[1]=bs*uos.popkf*kof/100/12.;
  if(amort[1] > bs-iz)
    amort[1]=bs-iz;
  amort[0]=okrug(amort[0],0.01);
  if(mra == 1)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Амортизация"));
    sprintf(strsql,"%.2f*%.2f/100/12.*%.2f=%.2f",
    bs,kof,uos.popkf,amort[1]);

    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
 }

if(mra == 1 && bs == 0.)
 {
  printw("%ld-%s\n",in,
  gettext("Балансовая стоимость равна нолю !"));
  if(ff_prot != NULL)
    fprintf(ff_prot,"%ld-%s\n",in,
    gettext("Балансовая стоимость равна нолю !"));
  OSTANOV();
 }

 
if(iz + amort[0] > bs)
 {
  beep();
  printw("%s %ld %s.\n",
  gettext("Инвентарный номер"),in,
  gettext("остаточная амортизация"));

  if(ff_prot != NULL)
   fprintf(ff_prot,"%s %ld %s.\n",
  gettext("Инвентарный номер"),in,
  gettext("остаточная амортизация"));
  if(mra == 1)
     OSTANOV();
 }

vp:;

/*Удаляем старую запись если она есть*/
sprintf(strsql,"delete from Uosamor where innom=%ld and god=%d and mes=%d",in,gr,mr);
sql_zapis(strsql,1,0);
 
if(kvrt != 0)
 for(i=mr+1 ; i < mr+3; i++)
  {
   sprintf(strsql,"delete from Uosamor where innom=%ld and god=%d and mes=%d",in,gr,i);
   sql_zapis(strsql,1,0);
  }

printw("%s: %5.2f %s: %.2f\n",
gettext("Амортизация"),amort[1],
gettext("Балансовая стоимость"),bs);

if(ff_prot != NULL)
 fprintf(ff_prot,"%s: %5.2f %s: %.2f\n",
gettext("Амортизация"),amort[1],
gettext("Балансовая стоимость"),bs);

time(&vrem);

sprintf(strsql,"insert into Uosamor \
values (%ld,%d,%d,%d,'%s','%s',%.2f,%d,%ld)",
in,mr,gr,podr,uos.hzt,uos.hna,amort[1],iceb_t_getuid(),vrem);

sql_zapis(strsql,1,0);

i1=2;
if(kvrt != 0)
 for(i=mr+1 ; i < mr+3; i++)
  {
   sprintf(strsql,"insert into Uosamor \
values (%ld,%d,%d,%d,'%s','%s',%.2f,%d,%ld)",
   in,i,gr,podr,uos.hzt,uos.hna,amort[i1++],iceb_t_getuid(),vrem);

   sql_zapis(strsql,1,0);
  }

return(0);
}
/*************************/
/*Амортизация для бюджетных организаций*/
/***************************************/

void	amortbo(long in,
int podr,
double kof,
short gr,
double bs,
double iz)
{
time_t  vrem;
char	strsql[512];

double amort=bs*uos.popkf/100*kof;
if(amort > bs-iz)
  amort=bs-iz;

amort=okrug(amort,1.); //Округляем до гривны

/*Удаляем старую запись если она есть*/
sprintf(strsql,"delete from Uosamor where innom=%ld and god=%d",in,gr);
if(sql_zap(&bd,strsql) != 0)
 {
  sprintf(strsql,"amortbo-Ошибка видалення запису !\n%s\n",sql_error(&bd));
  error2(20,0,1,strsql);
 }

time(&vrem);

sprintf(strsql,"insert into Uosamor \
values (%ld,%d,%d,%d,'%s','%s',%.2f,%d,%ld)",
in,12,gr,podr,uos.hzt,uos.hna,amort,iceb_t_getuid(),vrem);

sql_zapis(strsql,0,0);

}
