/*$Id: buh_rnr_sh.c,v 5.14 2011-01-13 13:43:21 sasa1 Exp $*/
/*15.12.2009	16.07.2007	Белых А.И.	buh_rnr_sh.c
Расчёт шахматки по заданному счёту
*/
#include <math.h>
#include <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void buh_hps(class SPISOK *deb,class SPISOK *kre,class masiv_din_double *suma,class SPISOK *debsh,class SPISOK *kresh,class masiv_din_double *sumash);

extern char *organ;


int buh_rnr_sh(class spis_oth *oth)
{
static char shet[32];
static char     dat1[11],dat2[11];
char naim[512];
char strsql[512];

VVOD VV(0);

VV.VVOD_SPISOK_add_ZAG(organ,40);
VV.VVOD_SPISOK_add_ZAG(gettext("Расчет шахматки по счёту"));

VV.VVOD_SPISOK_add_MD(gettext("Номер счета.................."));
VV.VVOD_SPISOK_add_MD(gettext("Дата начала........(д.м.г)..."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца.........(д.м.г)..."));

VV.VVOD_SPISOK_add_data(shet,sizeof(shet));
VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2));

naz:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);      


int kom=VV.vvod(0,1,1,-1,-1);

strncpy(shet,VV.VVOD_SPISOK_return_data(0),sizeof(shet)-1);
strncpy(dat1,VV.VVOD_SPISOK_return_data(1),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(2),sizeof(dat2)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
//   prosf(strsql);
   goto naz;
 
  case FK2:
  case PLU:
    break;

  case FK3:
        vibrek("Plansh",shet,sizeof(shet),naim);
        break;

    goto naz;

  case FK4:
   VV.VVOD_clear_data();         
   goto naz;

  case FK10:
  case ESC:
    return(1);
 
  default:
   kom=0;
   goto naz;
 }

GDITE();

if(shet[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введен счет !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

short dn,mn,gn;
short dk,mk,gk;

if(rsdatp(&dn,&mn,&gn,dat1,&dk,&mk,&gk,dat2) != 0)
  goto naz;

SQL_str row;
class SQLCURSOR cur;

sprintf(strsql,"select nais,saldo,vids,stat from Plansh where ns='%s'",shet);

if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Не найден счет %s в плане счетов !"),shet);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }


int kolstr=0;
//узнаём список субсчетов заданого счёта
class SPISOK shet_r;

sprintf(strsql,"select distinct sh from Prov where datp >= '%04d-%02d-%02d' and datp <= '%04d-%02d-%02d' \
and sh like '%s%%' order by sh asc",gn,mn,dn,gk,mk,dk,shet);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
int kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(shet_r.find(row[0]) < 0)
   shet_r.plus(row[0]);  
 }

GDITE();
//узнаём список счетов корреспондентов по дебету
class SPISOK shet_rd;

sprintf(strsql,"select distinct shk from Prov where datp >= '%04d-%02d-%02d' and datp <= '%04d-%02d-%02d' \
and sh like '%s%%' and deb <> 0. and kre = 0. order by shk asc",gn,mn,dn,gk,mk,dk,shet);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(shet_rd.find(row[0]) < 0)
   shet_rd.plus(row[0]);  
 }

GDITE();
//узнаём список счетов корреспондентов по кредиту
class SPISOK shet_rk;

sprintf(strsql,"select distinct shk from Prov where datp >= '%04d-%02d-%02d' and datp <= '%04d-%02d-%02d' \
and sh like '%s%%' and kre <> 0. and deb = 0. order by shk asc",gn,mn,dn,gk,mk,dk,shet);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(shet_rk.find(row[0]) < 0)
   shet_rk.plus(row[0]);  
 }

//создаём массивы дебетов и кредитов
class masiv_din_double sum_deb;
class masiv_din_double sum_kre;

sum_deb.make_class(shet_r.kolih()*shet_rd.kolih());
sum_kre.make_class(shet_r.kolih()*shet_rk.kolih());

//заполняем массивы
GDITE();
sprintf(strsql,"select sh,shk,deb,kre from Prov where datp >= '%04d-%02d-%02d' and datp <= '%04d-%02d-%02d' \
and sh like '%s%%'",gn,mn,dn,gk,mk,dk,shet);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

kolstr1=0;
double deb=0.,kre=0.;
int nomer_shet_r;
int nomer_shet_k;

while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s %s %s\n",row[0],row[1],row[2],row[3]);
  strzag(LINES-1,0,kolstr,++kolstr1);

  deb=atof(row[2]);
  kre=atof(row[3]);

  if(deb == 0. && kre == 0.) //бывает и такое
   continue;

  nomer_shet_r=shet_r.find(row[0]);

  if(deb != 0. && fabs(deb) > 0.009)
   {
    if((nomer_shet_k=shet_rd.find(row[1])) < 0)
     {
      sprintf(strsql,"Не найден счёт %s в списке дебетовых счетов !",row[1]);
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      continue;
     }
    
//    printw("дебет %d\n",nomer_shet_k*shet_rd.kolih()+nomer_shet_r);
    sum_deb.plus(deb,nomer_shet_k*shet_r.kolih()+nomer_shet_r);
   }  
  else
   {
    if((nomer_shet_k=shet_rk.find(row[1])) < 0)
     {
      printw("%s %s %s %s\n",row[0],row[1],row[2],row[3]);
      sprintf(strsql,"Не найден счёт %s в списке кредитовых счетов !",row[1]);
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      continue;
     }
//    printw("кредит %d nomer_shet_k=%d kolih=%d nomer_shet_r=%d\n",nomer_shet_k*shet_rk.kolih()+nomer_shet_r,
//    nomer_shet_k,shet_rk.kolih(),nomer_shet_r);
    
    sum_kre.plus(kre,nomer_shet_k*shet_r.kolih()+nomer_shet_r);
   }  
 }

GDITE();

/*Распечатываем шахматку--------------------------------*/ 
char imaf_hax[50];
sprintf(imaf_hax,"haxg%d.lst",getpid());
FILE *ff_hax;
if((ff_hax=fopen(imaf_hax,"w")) == NULL)
 {
  error_op_nfil(imaf_hax,errno,"");
  return(1);
 }

zagolov(gettext("Расчет шахматки по счёту"),dn,mn,gn,dk,mk,gk,organ,ff_hax);

fprintf(ff_hax,"%s %s\n",gettext("Дебет счёта"),shet);


buh_rh(0,&shet_rd,&shet_r,&sum_deb,ff_hax);

fprintf(ff_hax,"\n\n%s %s\n",gettext("Кредит счёта"),shet);


buh_rh(0,&shet_rk,&shet_r,&sum_kre,ff_hax);



podpis(ff_hax);

fclose(ff_hax);



char imaf_hax1[50];
sprintf(imaf_hax1,"haxv%d.lst",getpid());
if((ff_hax=fopen(imaf_hax1,"w")) == NULL)
 {
  error_op_nfil(imaf_hax1,errno,"");
  return(1);
 }

zagolov(gettext("Расчет шахматки по счёту"),dn,mn,gn,dk,mk,gk,organ,ff_hax);

fprintf(ff_hax,"%s %s\n",gettext("Дебет счёта"),shet);


buh_rh(1,&shet_rd,&shet_r,&sum_deb,ff_hax);

fprintf(ff_hax,"\n\n%s %s\n",gettext("Кредит счёта"),shet);


buh_rh(1,&shet_rk,&shet_r,&sum_kre,ff_hax);



podpis(ff_hax);

fclose(ff_hax);

/*Распечатка шахматки по счетам*/
class SPISOK shet_r_s;

class SPISOK shet_rd_s;
class masiv_din_double suma_deb_s;

class SPISOK shet_rk_s;
class masiv_din_double suma_kre_s;

/*получение шахматки по счетам*/
buh_hps(&shet_rd,&shet_r,&sum_deb,&shet_rd_s,&shet_r_s,&suma_deb_s);

shet_r_s.free_class(); /*повторно создаётся*/

buh_hps(&shet_rk,&shet_r,&sum_kre,&shet_rk_s,&shet_r_s,&suma_kre_s);



char imaf_haxs[50];
sprintf(imaf_haxs,"haxs%d.lst",getpid());
if((ff_hax=fopen(imaf_haxs,"w")) == NULL)
 {
  error_op_nfil(imaf_haxs,errno,"");
  return(1);
 }

zagolov(gettext("Расчет шахматки по счёту"),dn,mn,gn,dk,mk,gk,organ,ff_hax);

fprintf(ff_hax,"%s %s\n",gettext("Дебет счёта"),shet);

buh_rh(0,&shet_rd_s,&shet_r_s,&suma_deb_s,ff_hax);

fprintf(ff_hax,"\n\n%s %s\n",gettext("Кредит счёта"),shet);


buh_rh(0,&shet_rk_s,&shet_r_s,&suma_kre_s,ff_hax);



podpis(ff_hax);

fclose(ff_hax);






oth->spis_imaf.plus(imaf_hax);

sprintf(strsql,"%s %s %s 1 (%s)",
gettext("Шахматка по счёту"),
shet,
gettext("форма"),
gettext("по субсчетам"));

oth->spis_naim.plus(strsql);

oth->spis_imaf.plus(imaf_hax1);

sprintf(strsql,"%s %s %s 2 (%s)",
gettext("Шахматка по счёту"),
shet,
gettext("форма"),
gettext("по субсчетам"));

oth->spis_naim.plus(strsql);


oth->spis_imaf.plus(imaf_haxs);

sprintf(strsql,"%s %s (%s)",
gettext("Шахматка по счёту"),
shet,
gettext("по счетам"));

oth->spis_naim.plus(strsql);

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);
}



