/*$Id: buhf7.c,v 5.9 2011-01-13 13:43:21 sasa1 Exp $*/
/*15.12.2009	07.12.2007	Белых А.И.	buhf7.c
Расчёт формы 7 Приложение к примечаниям к годовой финансовой отчётности
"Расчёт налоговых разниц по данным бухгалтерского учёта"
*/
#include <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char     *organ;

int buhf7(class spis_oth *oth)
{
static char dat1[11],dat2[11];
int kom=0;
char strsql[1024];

VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Расчёт формы 7"));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала.(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца..(д.м.г).."));

VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2)); 

naz:;

clear();
 
helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F5",gettext("настройка"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

move(LINES-1,0);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
//   prosf(strsql);
   goto naz;

  case ESC:
  case FK10:
   return(1);

  case FK2:
  case PLU:
     break;



  case FK5:
    iceb_redfil("buhf7.alx",0);
    goto naz;

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }

short           dn,mn,gn;
short           dk,mk,gk;

if(rsdatp(&dn,&mn,&gn,dat1,&dk,&mk,&gk,dat2) != 0)
 goto naz;

class iceb_tu_str imaf_nastr;
imafn("buhf7.alx",&imaf_nastr);

class iceb_tu_file fil;
if((fil.ff=fopen(imaf_nastr.ravno(),"r")) == NULL)
 {
  error_op_nfil(imaf_nastr.ravno(),errno,"");
  return(1);
 }

class SPISOK sp_kod;
class SPISOK sp_nai_kod;

class SPISOK sp_kod_deb;
class SPISOK sp_deb;
class SPISOK sp_kre;

char stroka[1024];
char kod[100];
memset(kod,'\0',sizeof(kod));
while(fgets(stroka,sizeof(stroka),fil.ff) != NULL)
 {
  if(stroka[0] == '#')
   continue;
  if(polen(stroka,strsql,sizeof(strsql),1,'|') != 0)
   continue;

  if(strsql[0] == '\0')
    continue; 

  if(SRAV(strsql,"Код",0) == 0)
   {
    polen(stroka,kod,sizeof(kod),2,'|');
    if(kod[0] == '\0')
     continue;
    sp_kod.plus(kod);
    continue;
   }

  if(kod[0] == '\0')
   continue;
  
  if(SRAV(strsql,"Наименование",0) == 0)
   if(kod[0] != '\0')
    {
     polen(stroka,strsql,sizeof(strsql),2,'|');
     sp_nai_kod.plus(strsql);
     continue;
    }
  
  sp_kod_deb.plus(kod);
  sp_deb.plus(strsql);
  polen(stroka,strsql,sizeof(strsql),2,'|');
  sp_kre.plus(strsql);    
 }
fil.close();

class SQLCURSOR cur;
SQL_str row;

sprintf(strsql,"select sh,shk,deb from Prov \
where val=0 and datp >= '%d-%02d-%02d' and \
datp <= '%d-%02d-%02d' and deb <> 0.",gn,mn,dn,gk,mk,dk);
int kolstr;

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено проводок !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
int kolnast=sp_deb.kolih();

class masiv_din_double mas_sum;
mas_sum.make_class(kolnast);
int kolstr1=0;
double suma=0.;
while(cur.read_cursor(&row) != 0)
 {
  
  strzag(LINES-1,0,kolstr,++kolstr1);
  
  suma=atof(row[2]);    
  
  for(int ii=0; ii < kolnast; ii++)
   {

    if(proverka(sp_deb.ravno(ii),row[0],1,0) == 0)
     if(proverka(sp_kre.ravno(ii),row[1],1,0) == 0)
      mas_sum.plus(suma,ii);   
    
   }
 }
GDITE();
char imaf[56];
sprintf(imaf,"f7_%d.lst",getpid());

if((fil.ff=fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

zagolov(gettext("Расчет формы 7"),dn,mn,gn,dk,mk,gk,organ,fil.ff);

int kolih_kod=sp_kod.kolih();
for(int ii=0; ii < kolih_kod; ii++)
 {
  fprintf(fil.ff,"\n%s %s\n",sp_kod.ravno(ii),sp_nai_kod.ravno(ii));
  
  fprintf(fil.ff,"\
--------------------------------------------------------\n");
  fprintf(fil.ff,"\
   Сумма    |  Счета \n");
  fprintf(fil.ff,"\
--------------------------------------------------------\n");
 
  suma=0.;
  for(int ss=0; ss < kolnast; ss++)
   {
    if(SRAV(sp_kod.ravno(ii),sp_kod_deb.ravno(ss),0) != 0)
     continue;
    fprintf(fil.ff,"%12.2f %s -> %s\n",mas_sum.ravno(ss),sp_deb.ravno(ss),sp_kre.ravno(ss));
    suma+=mas_sum.ravno(ss);
   }

  fprintf(fil.ff,"\
--------------------------------------------------------\n");
  fprintf(fil.ff,"%12.2f %s\n",suma,gettext("Итого"));
 }

podpis(fil.ff);
fil.close();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчёт формы 7"));
iceb_t_ustpeh(imaf,0);

return(0);
}
