/* $Id: buhnast.c,v 5.18 2011-01-13 13:43:21 sasa1 Exp $ */
/*30.09.2009    21.12.1993      Белых А.И.      buhnast.c
Чтение настройки для бугалтерии
Если вернули 0-файл прочитан
	     1-нет
*/
#include        <stdio.h>
#include        <stdlib.h>
#include        <string.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

double		okrcn=0.;  /*Округление цены*/
double		okrg1=0.;  /*Округление 1*/
short		startgoduos=0; /*Стартовый год для Учёта основных средств*/
short		startgod=0; /*Стартовый год просмотров в Материальном учёте*/
short		startgodb=0; /*Стартовый год главной книги*/
short		zkhp;  /*0-запрещено корректировать чужие проводки 1-разрешено*/
short		vplsh; /*0-двух уровневый план счетов 1-многоуровневый*/
char		*sbshet=NULL; //Список бюджетных счетов

int             buhnast()
{
char            st1[1024];
char		bros[1024];
char strsql[512];

vplsh=startgodb=zkhp=0;

if(sbshet != NULL)
 {
  delete [] sbshet;
  sbshet=NULL;
 }

int kolstr;
SQL_str row;
class SQLCURSOR cur;

sprintf(strsql,"select str from Alx where fil='nastrb.alx' order by ns asc");
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  iceb_t_soob("Не найдены настройки nastrb.alx");
  return(1);
 }


while(cur.read_cursor(&row) != 0)
 {
  if(row[0][0] == '#')
   continue;

  polen(row[0],st1,sizeof(st1),1,'|');

  if(SRAV(st1,"Корректировка чужих проводок",0) == 0)
    {
     polen(row[0],st1,sizeof(st1),2,'|');
     if(SRAV(st1,"Вкл",1) == 0)
       zkhp=1;
     continue;
    }
  if(SRAV(st1,"Многопорядковый план счетов",0) == 0)
    {
     polen(row[0],st1,sizeof(st1),2,'|');
     if(SRAV(st1,"Вкл",1) == 0)
       vplsh=1;
     continue;
    }
  if(SRAV(st1,"Стартовый год",0) == 0)
    {
     polen(row[0],st1,sizeof(st1),2,'|');
     startgodb=(short)ATOFM(st1); 
     continue;
    }

  if(SRAV(st1,"Список бюджетных счетов",0) == 0)
   {
    memset(bros,'\0',sizeof(bros));
    POLE(row[0],bros,2,'|');
    if(bros[0] == '\0')
     continue;
    sbshet=new char[strlen(bros)+1];
    strcpy(sbshet,bros);
   }

 }


//printw("startgodb=%d\n",startgodb);
//OSTANOV();

startgod=0;

okrg1=okrcn=0.;

sprintf(strsql,"select str from Alx where fil='matnast.alx' order by ns asc");
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  iceb_t_soob("Не найдены настройки matnast.alx");
  return(1);
 }


while(cur.read_cursor(&row) != 0)
 {
  if(row[0][0] == '#')
   continue;

  polen(row[0],st1,sizeof(st1),1,'|');

  if(SRAV(st1,"Стартовый год",0) == 0)
    {
     polen(row[0],st1,sizeof(st1),2,'|');
     startgod=(short)ATOFM(st1); 
     continue;
    }

  if(SRAV(st1,"Округление цены",0) == 0)
    {
     polen(row[0],st1,sizeof(st1),2,'|');
     okrcn=ATOFM(st1);
     continue;
    }

  if(SRAV(st1,"Округление 1",0) == 0)
    {
     polen(row[0],st1,sizeof(st1),2,'|');
     okrg1=ATOFM(st1);
     continue;
    }

 }

startgoduos=0;

sprintf(strsql,"select str from Alx where fil='uosnast.alx' order by ns asc");
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  iceb_t_soob("Не найдены настройки uosnast.alx");
  return(1);
 }

while(cur.read_cursor(&row) != 0)
 {
  if(row[0][0] == '#')
   continue;
  polen(row[0],st1,sizeof(st1),1,'|');

  if(SRAV(st1,"Стартовый год",0) == 0)
    {
     polen(row[0],st1,sizeof(st1),2,'|');
     startgoduos=(short)ATOFM(st1); 
     continue;
    }
 }
return(0);
}



