/*$Id: buhrznp.c,v 5.17 2011-01-13 13:43:21 sasa1 Exp $*/
/*15.12.2009	13.07.2006	Белых А.И.	buhrznp.c
Расчёт распределения административных затрат и расходов на прибыли
*/
#include <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

int buhrznp_prov(const char *sp_shet,const char *shet_prov,const char *shet_provk,char *shet_vib);
int buhrznp(class iceb_tu_str *sp_shet_d,class iceb_tu_str *sp_shet_z,class iceb_tu_str *naim_ras);

extern char *organ;

int buhrznp(class spis_oth *oth)
{
char strsql[512];
static  char    dat1[11],dat2[11];
int kom=0;

VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Расчёт распределения административных затрат на доходы"));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала.....(д.м.г).."));//0
VV.VVOD_SPISOK_add_MD(gettext("Дата конца......(д.м.г).."));//1 

VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2)); 

naz:;

clear();
 
helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
//"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F5",gettext("настройка"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("buhg5_9.txt");
   goto naz;

  case ESC:
  case FK10:
   return(1);

  case FK2:
  case PLU:
     break;

  case FK5:
     iceb_redfil("buhrznp.alx",0);
     goto naz;

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }
time_t time_n;
time(&time_n);

clear();
GDITE();

short dn,mn,gn;
short dk,mk,gk;

if(rsdatp(&dn,&mn,&gn,dat1,&dk,&mk,&gk,dat2) != 0)
 goto naz;

class iceb_tu_str doh_sheta("");
class iceb_tu_str zat_sheta("");
char imaf_nastr[200];
class iceb_tu_str naim_ras("");
memset(imaf_nastr,'\0',sizeof(imaf_nastr));


buhrznp(&doh_sheta,&zat_sheta,&naim_ras);


if(zat_sheta.getdlinna() <= 1)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены \"Затратные счета\" !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(doh_sheta.getdlinna() <= 1)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены \"Доходные счета\" !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

int kolstr;
SQL_str row;
class SQLCURSOR cur;

sprintf(strsql,"select sh,shk,deb from Prov where datp >= '%04d-%02d-%02d' and \
datp <= '%04d-%02d-%02d' and val=0 and deb <> 0. order by sh asc",gn,mn,dn,gk,mk,dk);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
class SPISOK sp_doh;
class SPISOK sp_zat;
class masiv_din_double sum_doh;
class masiv_din_double sum_zat;
int nomer=0;
double suma=0.;
char shet_vib[56];

while(cur.read_cursor(&row) != 0)
 {
  suma=atof(row[2]);
  memset(shet_vib,'\0',sizeof(shet_vib));
    
//  if(proverka(doh_sheta,row[0],0,0) == 0)
  if(buhrznp_prov(doh_sheta.ravno(),row[0],row[1],shet_vib) == 0)
   {
    if((nomer=sp_doh.find(shet_vib)) < 0)
     sp_doh.plus(shet_vib);
    sum_doh.plus(suma,nomer);
   
    continue;
   }
  
//  if(proverka(zat_sheta,row[0],0,0) == 0)
  if(buhrznp_prov(zat_sheta.ravno(),row[0],row[1],shet_vib) == 0)
   {
    if((nomer=sp_zat.find(shet_vib)) < 0)
     sp_zat.plus(shet_vib);
    sum_zat.plus(suma,nomer);
   
    continue;
   }
 } 


char imaf[56];
sprintf(imaf,"rznp%d.lst",getpid());
FILE *ff;
if((ff=fopen(imaf,"w")) == NULL) 
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

if(naim_ras.getdlinna() <= 1)
 zagolov(gettext("Расчёт распределения административных затрат на доходы"),dn,mn,gn,dk,mk,gk,organ,ff);
else
 zagolov(naim_ras.ravno(),dn,mn,gn,dk,mk,gk,organ,ff);

fprintf(ff,"%s:%s\n",gettext("Доходные счета"),doh_sheta.ravno());
fprintf(ff,"%s:%s\n",gettext("Затратные счета"),zat_sheta.ravno());

double itogo_doh=sum_doh.suma();

//создаём массив для коэффициентов

double koef[sp_zat.kolih()];
fprintf(ff,"\n%s\n",gettext("Расчёт коэффициентов"));

for(int ii=0; ii < sp_zat.kolih(); ii++)
 {
  if(itogo_doh != 0.)
    koef[ii]=sum_zat.ravno(ii)/itogo_doh;
  else
    koef[ii]=0.;
  
  fprintf(ff,"%-*s %.2f/%.2f=%f\n",
  iceb_tu_kolbait(7,sp_zat.ravno(ii)),sp_zat.ravno(ii),sum_zat.ravno(ii),itogo_doh,koef[ii]);
 }

fprintf(ff,"\n");

class iceb_tu_str liniq("----------------------");
for(int ii=0; ii < sp_zat.kolih()+1; ii++)
 liniq.plus("-----------");

fprintf(ff,"%s\n",liniq.ravno());
 
fprintf(ff,"%s",gettext("Счёт дохо.|Сумма дох.|"));
for(int ii=0; ii < sp_zat.kolih(); ii++)
 fprintf(ff,"%-*.*s|",iceb_tu_kolbait(10,sp_zat.ravno(ii)),iceb_tu_kolbait(10,sp_zat.ravno(ii)),sp_zat.ravno(ii));
fprintf(ff,"%-*.*s|\n",iceb_tu_kolbait(10,gettext("Итого")),iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"));

fprintf(ff,"%s\n",liniq.ravno());

double itogo=0.;
for(int ii=0; ii < sp_doh.kolih() ; ii++)
 {
  fprintf(ff,"%-*.*s|%10.2f|",
  iceb_tu_kolbait(10,sp_doh.ravno(ii)),iceb_tu_kolbait(10,sp_doh.ravno(ii)),sp_doh.ravno(ii),
  sum_doh.ravno(ii));
  itogo=0.;
  for(int kk=0; kk < sp_zat.kolih() ; kk++)
   {
    suma=sum_doh.ravno(ii)*koef[kk];
    suma=okrug(suma,0.01);
    fprintf(ff,"%10.2f|",suma);
    itogo+=suma;
   }
  fprintf(ff,"%10.2f|\n",itogo);
 }

fprintf(ff,"%s\n",liniq.ravno());

fprintf(ff,"%*.*s|%10.2f|",
iceb_tu_kolbait(10,gettext("Итого")),
iceb_tu_kolbait(10,gettext("Итого")),
gettext("Итого"),itogo_doh);
//Вычисляем итоги по колонкам
double itogo_ob=0.;

for(int ii=0; ii < sp_zat.kolih(); ii++)
 {
  itogo=0.;
  for(int kk=0; kk < sp_doh.kolih(); kk++)
   {
    suma=sum_doh.ravno(kk)*koef[ii];
    suma=okrug(suma,0.01);
    itogo+=suma;
   } 
  fprintf(ff,"%10.2f|",itogo);
  itogo_ob+=itogo;
 }
fprintf(ff,"%10.2f|\n",itogo_ob);

podpis(ff);
fclose(ff);

iceb_t_ustpeh(imaf,0);

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчёт распределения административных затрат на доходы"));

return(0);
}
/**********************************/
/*Проверка счёта*/
/*********************/
int buhrznp_prov(const char *sp_shet,const char *shet_prov,const char *shet_provk,char *shet_vib)
{
char shet_shetk[56];
char shet[40];
char shetk[40];

int kol=pole2(sp_shet,',');
for(int ii=0; ii < kol; ii++)
 {
  memset(shet,'\0',sizeof(shet));
  memset(shetk,'\0',sizeof(shetk));
  
  polen(sp_shet,shet_shetk,sizeof(shet_shetk),ii+1,',');
  if(shet_shetk[0] == '\0')
   continue;

  if(polen(shet_shetk,shet,sizeof(shet_shetk),1,'>') != 0)
   strcpy(shet,shet_shetk);
  else
   polen(shet_shetk,shetk,sizeof(shet_shetk),2,'>');

  if(proverka(shet,shet_prov,0,0) == 0)
   {
    if(shetk[0] != '\0')
     {
      if(proverka(shetk,shet_provk,0,0) == 0)
       {
        strcpy(shet_vib,shet_shetk);
        return(0);
       }
     }
    else
     {
      strcpy(shet_vib,shet_shetk);
      return(0);
     }
   }      
 }
return(1);
}

/*******************************/
/*Чтение файла настроек*/
/****************************/
int buhrznp(class iceb_tu_str *sp_shet_d,
class iceb_tu_str *sp_shet_z,
class iceb_tu_str *naim_ras)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];

sprintf(strsql,"select str from Alx where fil='buhrznp.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  iceb_t_soob("Не найдены настройки buhrznp.alx");
  return(1);
 }

char stroka1[10240];

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  if(polen(row_alx[0],stroka1,sizeof(stroka1),2,'|') != 0)
   continue;
 
  if(SRAV("Доходные счета",row_alx[0],1) == 0)
   {
    iceb_t_fplus(stroka1,sp_shet_d,&cur_alx);
    continue;
   }
  if(SRAV("Затратные счета",row_alx[0],1) == 0)
   {
    iceb_t_fplus(stroka1,sp_shet_z,&cur_alx);
    continue;
   }

  if(SRAV("Наименование расчёта",row_alx[0],1) == 0)
   {
    naim_ras->new_plus(stroka1);
    continue;
   }

 }
return(0); 

}
