/*$Id: cennikd.c,v 5.13 2011-01-13 13:43:21 sasa1 Exp $*/
/*02.11.2009	07.05.2003	Белых А.И.	cennikd.c
Распечатка ценников для документа
*/
#include        <errno.h>
#include        <time.h>
#include	<buhg.h>
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern double	okrg1;  /*Округление 1*/
extern char     *organ;

void   cennikd(short dd,short md,short gd, //дата документа
int skl,  //Склад
const char *nomdok) //Номер документа
{
char 	strsql[512];
SQL_str	row,row1;
int 	kolstr=0;

GDITE();

sprintf(strsql,"select distinct kodm from Dokummat1 where datd='%04d-%02d-%02d' and \
sklad=%d and nomd='%s'",
gd,md,dd,skl,nomdok);
SQLCURSOR cur;
SQLCURSOR cur1;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
  return;

FILE *ff;
char imaf[40];

sprintf(imaf,"cen%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

char naim[512];
double cena=0.;
char   kodtv[40];
char   strihkod[32];
time_t          tmm;
struct  tm      *bf;
time(&tmm);
bf=localtime(&tmm);


while(cur.read_cursor(&row) != 0)
 {
  cena=0.;
  memset(naim,'\0',sizeof(naim));
  memset(strihkod,'\0',sizeof(strihkod));
  memset(kodtv,'\0',sizeof(kodtv));

  //Читаем цену продажи и наименование товара
  sprintf(strsql,"select naimat,strihkod,cenapr from Material where kodm=%s",row[0]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
   {
    strncpy(naim,row1[0],sizeof(naim)-1);
    strncpy(strihkod,row1[1],sizeof(strihkod)-1);

    cena=atof(row1[2]);
    cena=okrug(cena,okrg1);
   }  
  strcpy(kodtv,row[0]);
  cennik(bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,kodtv,naim,cena,strihkod,organ,ff);
 }

fclose(ff);

cenniks(imaf); //Преобразование в колонки

class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Ценники на товары"));
iceb_t_ustpeh(imaf,0);

iceb_t_rabfil(&oth,"");
}
