/* $Id: devices.c,v 5.4 2010-06-28 05:29:33 sasa1 Exp $ */
/*01.03.1999	01.03.1999	Белых А.И.	readscan.c
Чтение со сканера
*/
#include	<ncurses.h>
#include	<sys/types.h>
#ifdef HAVE_TORGDEV
#include	<libconfig.h>
#include	<libdev.h>
#endif
#include	"buhg.h"


#define CONFIG_INI "iceb.ini"

char *cassa_port = { "" };
char *cassa_ps = {"1111111111"};
char *scanner_port = {""};
double scanner_tim = { 30.0 };
char *scale_port = { "" };
double scale_tim = { 10.0 };
int scale_att = { 5 };

void read_ini() 
{
#ifdef HAVE_TORGDEV
   char *p;
   char bros[512];
   config_t 	foo;

   if((p=getenv("HOME")) == NULL) p = ".";
   strncpy(bros,p,sizeof(bros));
   strcat(bros, "/");
   strncat(bros, CONFIG_INI, sizeof(bros)-strlen(p)-1);
   config_new(&foo);
   if(config_read(&foo, bros, CS_INI, NULL)) {
   perror(bros);
   } else {
#ifdef DEBUG
     fprintf(stderr, "Reading config file ...\n");
#endif
     read_vars(&foo, "GLOBAL", 
   	     "workno", INT_T, &kassa,
              NULL);
     read_vars(&foo, "CASSA", 
   	     "device", CHARPTR_T, &cassa_port,
   	     "password", CHARPTR_T, &cassa_ps,
              NULL);
     read_vars(&foo, "SCANNER", 
   	   "device", CHARPTR_T, &scanner_port,
              "timeout", FLOAT_T, &scanner_tim,
              NULL);
     read_vars(&foo, "SCALES", 
   	   "device", CHARPTR_T, &scale_port,
              "timeout", FLOAT_T, &scale_tim,
              "attempts", INT_T, &scale_att,
              NULL);
     
     config_destroy(&foo);
   }
#endif
}


/***************************/
int	voz1()
{
 return(1);
}
/*******************************/
int readscan(char *cod) 
{
int i = 0;
#ifdef HAVE_TORGDEV
char	buff[300];

if ((scanner_port == NULL) || (strlen(scanner_port) == 0))
    return(-1);

if(cod != NULL) /*Чтение сканера*/
   i=scan((unsigned char*)scanner_port,scanner_tim,(unsigned char*)cod,&voz1);
else        /*Сброс сканера*/
  i=scan((unsigned char*)scanner_port,0.05,(unsigned char*)buff,&voz1);
/*
 printw("i=%d cod=%s\n",i,cod);
 OSTANOV();
*/
#endif
 return(i);

}

/*************************/
int	readves(double *rves)
{
int	i = 0;
#ifdef HAVE_TORGDEV
if ((scale_port == NULL) || (strlen(scale_port) == 0))
    return(-1);
i=ves((unsigned char*)scale_port,scale_att,scale_tim,rves,&voz1);
/* printw("rves=%f\n",*rves); */
#endif
return(i);
}

void	show_error(unsigned char *ll)
{
#ifdef HAVE_TORGDEV
move(LINES-8,0);
printw("%s\n",ll);
refresh();
#endif
}
