/* $Id: diramort.c,v 5.50 2011-08-29 07:08:59 sasa Exp $ */
/*27.06.2010    03.07.1996      Белых А.И.      diramort.c
Просмотр амортизации для налогового учета
*/
#include        <pwd.h>
#include        <errno.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void vus7(VVOD*,short,long,short,short,int,const char*,const char*);
void shus7(long,int,double,double,double,double,double,double,short,short,short);
void uosrsd(long);
void diramort_vp(const char *imafprot,const char *imafprot_am);

extern char      *organ;/*Наименование организации*/
extern short	startgoduos; /*Стартовый год*/
extern short	metkabo; //Если 1 то организация бюджетная

void diramort(long in,int podd,const char *hzt,
const char *hna)
{
class spis_oth oth;
char            bros[512];
char            bros1[512];
short           i;
short           x=0,y=4;
struct  tm      *bf;
time_t          tmm;
FILE            *ff=NULL;
int             K;
short           kom=0,kom1=0;
double          sao=0.;
char            imaf[56];
short           d1,m1,g1,kvrt;
double		sumzap;
double          bs,iz;
double          bs1,iz1,iz11;
class iceb_tu_str vvstr("");
double          bsby,izby;
double          bs1by,iz1by,iz11by;
long		pozz,pozz1;
long		kolstr;
SQL_str         row;
class iceb_t_mstr spis_menu(0);
char		strsql[512];
int		prc;
char		imafprot[56];
char		imafprot_am[56];
short metka_ras_amort=0;
int podraz=0,kodol=0;
short dt,mt,gt;

poltekdat(&dt,&mt,&gt);
dt=1;

VVOD VV(0);
VVOD  VVOD1(2);
VVOD		DANET(1);
DANET.VVOD_SPISOK_add_MD(gettext("Удалить ? Вы уверены ?"));

 
iz11=pozz=0;
bs=iz=sumzap=0.;

sprintf(imafprot,"bsiz%d.lst",getpid());
sprintf(imafprot_am,"bsiza%d.lst",getpid());

unlink(imafprot);
unlink(imafprot_am);

naz1:;

clear();
GDITE();
short           kls=LINES-8;
time_t vremz[kls];
int ktozap[kls];

ff=NULL; //обязательно

if(metka_ras_amort == 0)
 {
  if((ff = fopen(imafprot,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }
  startfil(ff);

 }

if(in < 0)
 { 
  bs=iz=0.;
  sprintf(bros1,"Стартовая балансовая стоимость для группы %ld",in*-1);
  memset(bros,'\0',sizeof(bros));
  if(iceb_t_poldan(bros1,bros,"uosnast.alx") != 0)
   {
    VVOD SOOB(1);
    sprintf(strsql,"Не найдена %s !!",bros1);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    
   }
  else
    bs=atof(bros);

  memset(bros,'\0',sizeof(bros));
  sprintf(bros1,"Стартовый износ для группы %ld",in*-1);
  if(iceb_t_poldan(bros1,bros,"uosnast.alx") != 0)
   {
    VVOD SOOB(1);
    sprintf(strsql,"Не найден %s !!",bros1);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    
   }
  else
    iz=atof(bros);

   
  bsiz23(hna,dt,mt,gt,&bs1,&iz1,&iz11,ff);
 }
else
 {
  bsiz(in,podd,dt,mt,gt,&bs,&iz,&bs1,&iz1,&iz11,&bsby,&izby,&bs1by,&iz1by,&iz11by,ff);
 }

if(metka_ras_amort == 0)
  fclose(ff);
metka_ras_amort=0;

K=0;

sprintf(strsql,"select * from Uosamor where innom=%ld and god >= %d order by god,mes asc",in,startgoduos);
/*
printw("\n%s\n",strsql);
refresh();
*/
class SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {  
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
lll:;

  shus7(in,podd,sumzap,bs,iz,bs1,iz1,iz11,dt,mt,gt);

  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  K=soobshw(&SOOB,stdscr,-1,-1,1,1);

  if(K == SFK2 || K == FK3 || K == FK5)
      goto lll;
  goto vper;
 }
else
 {
  sumzap=0.;
  while(cur.read_cursor(&row) != 0)
   sumzap+=atof(row[6]);
 }
naz:;
GDITE();
clear();

if(kolstr != 0 && pozz > kolstr)
  pozz = kolstr-1;

cur.poz_cursor(pozz);
pozz1=0;
spis_menu.spis_str.free_class();
for(i=0;i<=kls-1; )
 {
  if(cur.read_cursor(&row) == 0)
    break;
  pozz1++;
  
  ktozap[i]=atoi(row[7]);
  vremz[i]=atol(row[8]);
    
  sprintf(strsql,"%2s.%s|%10.2f|%-3s|%-*s|%-4s|%s",
  row[1],row[2],
  atof(row[6]),
  row[3],
  iceb_tu_kolbait(4,row[4]),
  row[4],row[5],row[7]);

  spis_menu.spis_str.plus(strsql);
  i++;

 }
/***************
if(i == 0)
 goto lll;

if(i <=kls-1)
  spis_menu.spis_str.plus(gettext("Конец списка"));

if(i == 0)
 {
  if(kolstr != 0 && pozz != 0)
   {
    //Если записи есть но не подходят по условиям поиска
    pozz--;
    goto naz;
   }
  goto lll;
 }

if(kom >= i)
  kom=i-1;

if(kom < 0)
 kom=0;
*********************************/
if(kom >= i)
  kom=i-1;

if(kom < 0)
 kom=0;

if(i <=kls-1)
  spis_menu.spis_str.plus(gettext("Конец списка"));

if(i == 0)
 {
  if(kolstr != 0 && pozz != 0)
   {
    //Если записи есть но не подходят по условиям поиска
    pozz--;
    goto naz;
   }
  goto lll;
 }


shus7(in,podd,sumzap,bs,iz,bs1,iz1,iz11,dt,mt,gt);

prc=(pozz+pozz1)*100/kolstr;
memset(strsql,'\0',sizeof(strsql));
kom=spis_menu.menu(kom,y,x,NULL,strsql,prc,&K,"",0);


if(kom == -7) //Изменение размеров экрана
 goto naz1;
 
if(kom == -3) /*Стрелка вниз*/
 {
  if(i < kls)
   {
    beep();
    goto naz;
   }
  if(i == kls)
    pozz++;
  kom=kls;
  goto naz;
 }
if(kom == -2) /*Стрелка вверх*/
 {
  if(pozz == 0)
   {
    beep();
    goto naz;
   }
  if(pozz != 0)
    pozz--;
  goto naz;
 }
 
if(kom == -5) /*Страница вниз*/
 {
  if(i == kls)
    pozz+=kls;
  else
    beep();
/*
  printw("\n вперед pozz=%d\n",pozz);
  OSTANOV();
*/
  goto naz;

 }

if(kom == -4) /*Страница вверх*/
 {
  pozz-=kls;
  if(pozz < 0)  
   {
    beep();
    pozz=0;
   }
/*
  printw("\n назад pozz=%d\n",pozz);
  OSTANOV();
*/
  goto naz;
 }

if(kom >= 0)
 {
  if(SRAV(gettext("Конец списка"),spis_menu.spis_str.ravno(kom),0) == 0)
     goto naz;
  if(pozz+kom >= kolstr)
   goto naz; /*Стали на конец списка*/
  polen(spis_menu.spis_str.ravno(kom),bros,sizeof(bros),1,'|');
  rsdat1(&m1,&g1,bros);
  polen(spis_menu.spis_str.ravno(kom),&sao,2,'|');
  //sao=ATOFM(bros);
 }

vper:;

switch (K)
 {
  case FK10: /*Выход*/
  case ESC: /*Выход*/
     unlink(imafprot);
     unlink(imafprot_am);
     return;

  case FK1: /*помощь*/
    GDITE();
    iceb_t_pdoc("uos8.txt");
    clear();
    goto naz1;


  case FK2:    /*Ввести запись*/
  case PLU:    /*Ввести запись*/
    VV.VVOD_delete();
    VV.VVOD_SPISOK_add_data(8);
    VV.VVOD_SPISOK_add_data(20);
 
    vus7(&VV,0,in,0,0,podd,hzt,hna);
    goto naz1;

  case ENTER: /*Корректировать запись*/
  case SFK2: /*Корректировать запись*/

    VV.VVOD_delete();
    kzvz(ktozap[kom],vremz[kom],&VV);
    
    sprintf(strsql,"%d.%d",m1,g1);
    VV.VVOD_SPISOK_add_data(strsql,8);

    sprintf(strsql,"%.2f",sao);
    VV.VVOD_SPISOK_add_data(strsql,20);

    vus7(&VV,1,in,m1,g1,podd,hzt,hna);
    goto naz1;

  case FK3:   /*Удалить запись*/
//    sprintf(strsql,"%s",iceb_t_imafnsi("bluos.alx"));
    if(iceb_t_pbpds(m1,g1) != 0)
      goto naz;

    if(danet(&DANET,2,stdscr) == 1)
     {
      sprintf(strsql,"delete from Uosamor where innom=%ld and god=%d \
and mes=%d",in,g1,m1);
/*    printw("\nstrsql=%s\n",strsql);*/
      if(sql_zap(&bd,strsql) != 0)
       {
        sprintf(strsql,"Ошибка удаления записи !\n%s\n",sql_error(&bd));
        error2(20,0,1,strsql);
       }
      goto naz1;
     }

    goto naz;


  case FK4:   /*Расчет амортизации*/

    memset(bros,'\0',sizeof(bros));
    kvrt=m1=g1=0;

nazz:;
    helstr(LINES-1,0,"F10",gettext("выход"),NULL);
    if(uosprovar(hna,0) == 1)    
     {
      if(metkabo == 0)
       {
        helstr(LINES-1,0," F10 ",gettext("выход"),NULL);
        
        
        VVOD1.VVOD_delete();
        VVOD1.VVOD_SPISOK_add_MD(gettext("Введите квартал (1,2,3,4)"));
        vvstr.new_plus("");
        if((kom1=vvod1(&vvstr,2,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
         {
          if(kolstr > 0)
           goto naz;
          else
           goto lll;
         }

        if(kom1 == ESC)
         {
          if(kolstr > 0)
           goto naz;
          else
           goto lll;
         }

        kvrt=vvstr.ravno_atoi();
        if(kvrt < 1 || kvrt > 4)
         {
          VVOD SOOB(1);
          SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введен квартал !"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto nazz;
         } 
       }
      helstr(LINES-1,0," F10 ",gettext("выход"),NULL);
      
      sprintf(bros,"%d",gt);
      vvstr.new_plus(bros);      
      VVOD1.VVOD_delete();
      VVOD1.VVOD_SPISOK_add_MD(gettext("Введите год"));

      if((kom1=vvod1(&vvstr,5,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
       {
        if(kolstr > 0)
         goto naz;
        else
         goto lll;
       }
      if(kom1 == ESC)
       {
        if(kolstr > 0)
         goto naz;
        else
         goto lll;
       }

      g1=vvstr.ravno_atoi();
      if(g1 < 1997 || g1 > 3000)
       {
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введен год !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        goto nazz;
       } 
    }
   else
    {
nazz1:;
      helstr(LINES-1,0," F10 ",gettext("выход"),NULL);
      
      sprintf(bros,"%d.%d",mt,gt);
      vvstr.new_plus(bros);
      VVOD1.VVOD_delete();
      VVOD1.VVOD_SPISOK_add_MD(gettext("Введите дату (м.г)"));

      if((kom1=vvod1(&vvstr,8,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
       {
        if(kolstr > 0)
         goto naz;
        else
         goto lll;
       }
      if(kom1 == ESC)
       {
        if(kolstr > 0)
         goto naz;
        else
         goto lll;
       }


      if(rsdat1(&m1,&g1,vvstr.ravno()) != 0)
       {
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        goto nazz1;
       }
    }

    if(kvrt == 1)
      m1=1;
    if(kvrt == 2)
      m1=4;
    if(kvrt == 3)
      m1=7;
    if(kvrt == 4)
     m1=10;
    if(metkabo == 1)
      m1=1;
      
//    sprintf(strsql,"%s",iceb_t_imafnsi("bluos.alx"));

    for(i=m1 ; i < m1+3; i++)
    if(iceb_t_pbpds(i,g1) != 0)
     {
      if(kolstr > 0)
       goto naz;
      else
       goto lll;
     }
    
    metka_ras_amort=1;
    
    if(in > 0)
     {
      if((ff = fopen(imafprot_am,"w")) == NULL)
       {
        error_op_nfil(imaf,errno,"");
        return;
       }
      startfil(ff);

      if(amort(in,m1,g1,1,kvrt,hna,ff) != 0)
	OSTANOV();
      fclose(ff);
     }
    else
     {
      if((ff = fopen(imafprot_am,"w")) == NULL)
       {
        error_op_nfil(imaf,errno,"");
        return;
       }
      startfil(ff);
      
      amort23(in,podd,kvrt,g1,hzt,ff);
      fclose(ff);
     } 
    goto naz1;

  case FK5:   /*Распечатать*/

    clear();

    sprintf(imaf,"amort%d.lst",getpid());
    if((ff = fopen(imaf,"w")) == NULL)
     {
      error_op_nfil(imaf,errno,"");
      return;
     }

    time(&tmm);
    bf=localtime(&tmm);

    fprintf(ff,"%s\n\n%s\n\
%s %ld %s %d\n\
%s %d.%d.%d%s %s: %d:%d\n\
---------------------------------------------------\n",
    organ,
    gettext("Амортотчисления"),
    gettext("Инвентарный номер"),
    in,
    gettext("Подразделение"),
    podd,
    gettext("По состоянию на"),
    bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
    gettext("г."),
    gettext("Время"),
    bf->tm_hour,bf->tm_min);
    
    i=0;
    cur.poz_cursor(0);
    while(cur.read_cursor(&row) != 0)
     {
      i++;
      fprintf(ff,"%2s.%s %10.2f\n",row[1],row[2],atof(row[6]));
     }
    fprintf(ff,"\
---------------------------------------------------\n\
%s %d\n",gettext("Количество записей"),i);
    fclose(ff);

    oth.clear();
    oth.spis_imaf.plus(imaf);
    oth.spis_naim.plus(gettext("Распечатка амортотчислений"));
    iceb_t_ustpeh(imaf,3);
    iceb_t_rabfil(&oth,"");

    goto naz;


  case FK6:   /*Распечатка документов*/

    uosrsd(in);

    if(kolstr > 0)
      goto naz;
    else
      goto lll;

  case FK7:   /*Просмотр протокола расчета амортизации*/
    diramort_vp(imafprot,imafprot_am);

    if(kolstr > 0)
      goto naz;
    else
      goto lll;

  case FK8:   //Смена даты получения остатка

    VVOD1.VVOD_delete();
    VVOD1.VVOD_SPISOK_add_MD(gettext("Введите дату, на которую рассчитать остаток (д.м.г)"));
    vvstr.new_plus("");
    if((kom1=vvod1(&vvstr,11,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
     {
      if(kolstr > 0)
       goto naz;
      else
       goto lll;
     }
    if(kom1 == ESC)
     {
      if(kolstr > 0)
       goto naz;
      else
       goto lll;
     }
     

    if(rsdat(&d1,&m1,&g1,vvstr.ravno(),1) != 0)
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
     }
    else
     {
      dt=d1; mt=m1; gt=g1;
     }     
    /*Узанём где числится на эту дату*/
    if(poiin(in,dt,mt,gt,&podraz,&kodol) == 0)
     podd=podraz;
     
    goto naz1;

  default:
    if(kolstr > 0)
      goto naz;
    else
      goto lll;
 }
}

/*******/
/*Ввод */
/*******/

void vus7(VVOD *VV,short mt, //0-ввести новое 1-корректировать
long in,short m,short g,int podd,
const char *hzt,const char *hna)
{
int             par;
short           m1,g1;
char		strsql[512];
time_t		vrem;

VV->VVOD_SPISOK_add_MD(gettext("Дата....(м.г).........."));
VV->VVOD_SPISOK_add_MD(gettext("Сумма амортотчислений.."));

naz:;


helstr(LINES-1,0,"F2/+",gettext("запись"),
"F10",gettext("выход"),NULL);

par=VV->vvod(0,1,1,-1,-1);

switch(par)
 {
  
  case FK2:
  case PLU:
    break;
  case FK10:
  case ESC:
    return;
  default:
   goto naz;
 }

if(VV->VVOD_SPISOK_return_data(0)[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введен месяц !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }


if(rsdat1(&m1,&g1,VV->VVOD_SPISOK_return_data(0)) != 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Неверно введена дата !"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
//sprintf(strsql,"%s",iceb_t_imafnsi("bluos.alx"));
if(iceb_t_pbpds(m1,g1) != 0)
  goto naz;

if(VV->VVOD_SPISOK_return_data(1)[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введена сумма амортотчислений !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

time(&vrem);

if(mt == 0)
 {
  sprintf(strsql,"insert into Uosamor \
values (%ld,%d,%d,%d,'%s','%s',%.2f,%d,%ld)",
  in,m1,g1,podd,hzt,hna,ATOFM(VV->VVOD_SPISOK_return_data(1)),iceb_t_getuid(),vrem);
 }


if(mt == 1)
 {
//  sprintf(strsql,"%s",iceb_t_imafnsi("bluos.alx"));
  if(iceb_t_pbpds(m,g) != 0)
    goto naz;
  sprintf(strsql,"update Uosamor \
set \
god=%d,\
mes=%d,\
podr=%d,\
hzt='%s',\
hna='%s',\
suma=%.2f,\
ktoz=%d,\
vrem=%ld \
where innom=%ld and god=%d and mes=%d",
  g1,m1,podd,hzt,hna,ATOFM(VV->VVOD_SPISOK_return_data(1)),iceb_t_getuid(),vrem,in,g,m);
 }

if(sql_zap(&bd,strsql) != 0)
 {
  sprintf(strsql,"Ошибка ввода записи !\n%s\n",sql_error(&bd));
  error2(20,0,1,strsql);
  goto naz;
 }

}

/*******/
/*Шапка*/
/*******/
void shus7(long in,int podd,double sumzap,
double bs,double iz,double bs1,double iz1,double iz11,
short dt,short mt,short gt)
{
int		X,Y;

move(0,0);

printw("%s\n",
gettext("Ввод и корректировка амортотчислений для налогового учета"));
if(in > 0)
  printw("%s %ld %s %d",
  gettext("Инвентарный номер"),
  in,
  gettext("Подразделение"),
  podd);
else
 {
  printw("%s %ld",
  gettext("Группа"),
  in*(-1));
 }
printw(" %s:%.2f\n",gettext("Сумма всех записей"),sumzap);

move(Y=3,X=COLS-30);
printw(gettext("Расшифровка полей:"));
move(++Y,X);
printw("1-%s",gettext("дата"));
move(++Y,X);
printw("2-%s",gettext("сумма"));
move(++Y,X);
printw("3-%s",gettext("подразделение"));
move(++Y,X);
printw("4-%s",gettext("шифр затрат"));
move(++Y,X);
printw("5-%s",gettext("шифр н. аморт-отч."));
move(++Y,X);
printw("6-%s",gettext("кто записал"));

move(Y+=2,X);
printw(gettext("Бал.стоимость   Износ"));
move(++Y,X);
printw("%10.2f %10.2f",bs,iz);
move(++Y,X);
printw("%10.2f %10.2f",bs1,iz1);
move(++Y,X);
printw("%s:%9.2f",gettext("Амортизация"),iz11);
move(++Y,X);
printw("%10.2f %10.2f",bs+bs1,iz+iz1+iz11);

move(++Y,X);
printw("%11s:%9.2f",gettext("Остаток"),(bs+bs1)-(iz+iz1+iz11));
move(++Y,X-2);
printw("%11s:%02d.%02d.%d",gettext("Дата остатка"),dt,mt,gt);

move(3,0);
printw("    1         2       3    4   5    6");

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("запись"),
"F3",gettext("удалить"),
"F4",gettext("расчет"),
"F5",gettext("печать"),
"F6",gettext("док."),
"F7",gettext("прот."),
"F8",gettext("см.даты"),
"F10",gettext("выход"),NULL);
}
/*********************************/
/*выбор просмотра*/
/********************************/
void diramort_vp(const char *imafprot,const char *imafprot_am)
{

int kom=0;
VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите нужное"));

MENU.VVOD_SPISOK_add_MD(gettext("Просмотр протокола расчёта балансовой стоимости и износа"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Просмотр протокола расчёта амортизации"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//13
for(;;)
 {
  clear();

  if(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0)
   continue;

  switch (kom)
   {
    case 2:
    case -1 :
      return;
    case 0:
      vizred(imafprot);
      return;
    case 1:
      vizred(imafprot_am);
      return;
   }
 }


}
