/* $Id: diramortby.c,v 5.41 2011-08-29 07:08:59 sasa Exp $ */
/*22.12.2009    06.12.2000      Белых А.И.      diramortby.c
Просмотр амортизации для бухгалтерского учета
*/
#include        <pwd.h>
#include        <errno.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void            vus7by(VVOD*,short,long,short,short,int,const char*,const char*);
void            shus7by(long,int,double,double,double,double,double,double,short,short,short);
void            uosrsd(long);
void diramort_vp1(const char *imafprot,const char *imafprot_am);

extern char     *organ;/*Наименование организации*/
extern short    startgoduos; /*Стартовый год*/

void diramortby(long in,int podd,const char *hzt,const char *hna)
{
class spis_oth oth;
char            bros[512];
short           i;
short           x=0,y=4;
struct  tm      *bf;
time_t          tmm;
FILE            *ff;
int             K;
short           kom=0,kom1=0;
double          sao=0.;
char            imaf[32];
short           d1,m1,g1;
double		sumzap;
double          bs,iz;
double          bs1,iz1,iz11;
double          bsby,izby;
double          bs1by,iz1by,iz11by;
long		pozz,pozz1;
long		kolstr;
SQL_str         row;
char		strsql[512];
int		prc;
class iceb_tu_str vstr("");
int podraz=0,kodol=0;
short metka_ras_amort=0;
class iceb_t_mstr spis_menu(0);

short dt,mt,gt;
poltekdat(&dt,&mt,&gt);
dt=1;

VVOD VV(0);
VVOD VVOD1(2);
VVOD DANET(1);
DANET.VVOD_SPISOK_add_MD(gettext("Удалить ? Вы уверены ?"));

 
iz11=pozz=0;
bs=iz=sumzap=0.;
char imaf_prot[56];
char imaf_prot_am[56];
sprintf(imaf_prot,"bsiz%d.lst",getpid());
sprintf(imaf_prot_am,"bsiza%d.lst",getpid());

unlink(imaf_prot);
unlink(imaf_prot_am);

naz1:;

clear();
GDITE();
short           kls=LINES-8;
time_t vremz[kls];
int ktozap[kls];

ff=NULL; //обязательно

if(metka_ras_amort == 0)
 {
  if((ff = fopen(imaf_prot,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }
  startfil(ff);
 }

bsiz(in,podd,dt,mt,gt,&bs,&iz,&bs1,&iz1,&iz11,&bsby,&izby,&bs1by,&iz1by,&iz11by,ff);

if(metka_ras_amort == 0)
  fclose(ff);

metka_ras_amort=0;

K=0;

sprintf(strsql,"select * from Uosamor1 where innom=%ld and god >= %d \
order by god,mes asc",in,startgoduos);
/*
printw("\n%s\n",strsql);
refresh();
*/
SQLCURSOR cur;

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
 
if(kolstr == 0)
 {
lll:;

  shus7by(in,podd,sumzap,bsby,izby,bs1by,iz1by,iz11by,dt,mt,gt);

  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  K=soobshw(&SOOB,stdscr,-1,-1,1,1);

  if(K == SFK2 || K == FK3 || K == FK5)
      goto lll;
  goto vper;
 }
else
 {
  sumzap=0.;
  while(cur.read_cursor(&row) != 0)
   sumzap+=atof(row[6]);
 }
naz:;
GDITE();
clear();

if(kolstr != 0 && pozz > kolstr)
  pozz = kolstr-1;

cur.poz_cursor(pozz);
pozz1=0;
spis_menu.spis_str.free_class();
for(i=0;i<=kls-1;)
 {
  if(cur.read_cursor(&row) == 0)
    break;
  pozz1++;
  
  vremz[i]=atol(row[8]);
  ktozap[i]=atoi(row[7]);
    
  sprintf(strsql,"%2s.%s|%10.2f|%-3s|%-*s|%-4s|%s",
  row[1],row[2],
  atof(row[6]),
  row[3],
  iceb_tu_kolbait(4,row[4]),row[4],
  row[5],row[7]);
  
  spis_menu.spis_str.plus(strsql);
  i++;

 }
/***************************
if(i == 0)
 goto lll;

if(i < kls)
  spis_menu.spis_str.plus(gettext("Конец списка"));

if(kom >= i)
  kom=i-1;

if(kom < 0)
 kom=0;
if(i == 0)
 {
  if(kolstr != 0 && pozz != 0)
   {
    //Если записи есть но не подходят по условиям поиска
    pozz--;
    goto naz;
   }
  goto lll;
 }
*******************/
if(kom >= i)
  kom=i-1;

if(kom < 0)
 kom=0;

if(i <=kls-1)
  spis_menu.spis_str.plus(gettext("Конец списка"));

if(i == 0)
 {
  if(kolstr != 0 && pozz != 0)
   {
    //Если записи есть но не подходят по условиям поиска
    pozz--;
    goto naz;
   }
  goto lll;
 }

shus7by(in,podd,sumzap,bsby,izby,bs1by,iz1by,iz11by,dt,mt,gt);

prc=(pozz+pozz1)*100/kolstr;
memset(strsql,'\0',sizeof(strsql));
kom=spis_menu.menu(kom,y,x,NULL,strsql,prc,&K,"",0);

if(kom == -7)
 goto naz1;
 
if(kom == -3) /*Стрелка вниз*/
 {
  if(i < kls)
   {
    beep();
    goto naz;
   }
  if(i == kls)
    pozz++;
  kom=kls;
  goto naz;
 }
if(kom == -2) /*Стрелка вверх*/
 {
  if(pozz == 0)
   {
    beep();
    goto naz;
   }
  if(pozz != 0)
    pozz--;
  goto naz;
 }
 
if(kom == -5) /*Страница вниз*/
 {
  if(i == kls)
    pozz+=kls;
  else
    beep();
/*
  printw("\n вперед pozz=%d\n",pozz);
  OSTANOV();
*/
  goto naz;

 }

if(kom == -4) /*Страница вверх*/
 {
  pozz-=kls;
  if(pozz < 0)  
   {
    beep();
    pozz=0;
   }
/*
  printw("\n назад pozz=%d\n",pozz);
  OSTANOV();
*/
  goto naz;
 }

if(kom >= 0)
 {
  if(SRAV(gettext("Конец списка"),spis_menu.spis_str.ravno(kom),0) == 0)
     goto naz;
  if(pozz+kom >= kolstr)
   goto naz; /*Стали на конец списка*/
  POLE(spis_menu.spis_str.ravno(kom),bros,1,'|');
  rsdat1(&m1,&g1,bros);
  POLE(spis_menu.spis_str.ravno(kom),bros,2,'|');
  sao=ATOFM(bros);
 }

vper:;

switch (K)
 {
  case FK10: /*Выход*/
  case ESC: /*Выход*/
     unlink(imaf_prot);
     unlink(imaf_prot_am);
     return;

  case FK1: /*помощь*/
    GDITE();
    iceb_t_pdoc("uos8.txt");
    clear();
    goto naz1;


  case FK2:    /*Ввести запись*/
  case PLU:    /*Ввести запись*/
    VV.VVOD_delete();
    VV.VVOD_SPISOK_add_data(8);
    VV.VVOD_SPISOK_add_data(20);

    vus7by(&VV,0,in,0,0,podd,hzt,hna);
    goto naz1;

  case SFK2: /*Корректировать запись*/
  case ENTER: /*Корректировать запись*/

    VV.VVOD_delete();

    kzvz(ktozap[kom],vremz[kom],&VV);
    
    sprintf(strsql,"%d.%d",m1,g1);
    VV.VVOD_SPISOK_add_data(strsql,8);

    sprintf(strsql,"%.2f",sao);
    VV.VVOD_SPISOK_add_data(strsql,20);


    vus7by(&VV,1,in,m1,g1,podd,hzt,hna);
    goto naz1;

  case FK3:   /*Удалить запись*/
//    sprintf(strsql,"%s",iceb_t_imafnsi("bluos.alx"));
    if(iceb_t_pbpds(m1,g1) != 0)
      goto naz;

    if(danet(&DANET,2,stdscr) == 1)
     {
      sprintf(strsql,"delete from Uosamor1 where innom=%ld and god=%d \
and mes=%d",in,g1,m1);
/*    printw("\nstrsql=%s\n",strsql);*/
      if(sql_zap(&bd,strsql) != 0)
       {
        sprintf(strsql,"Ошибка удаления записи !\n%s\n",sql_error(&bd));
        error2(20,0,1,strsql);
       }
      goto naz1;
     }

    goto naz;


  case FK4:   /*Расчет амортизации*/

    memset(bros,'\0',sizeof(bros));
    m1=g1=0;

nazz1:;
    helstr(LINES-1,0," F10 ",gettext("выход"),NULL);
    
    sprintf(bros,"%d.%d",mt,gt);
    vstr.new_plus(bros);    
    VVOD1.VVOD_delete();
    VVOD1.VVOD_SPISOK_add_MD(gettext("Введите дату (м.г)"));

    if((kom1=vvod1(&vstr,8,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
     {
      if(kolstr > 0)
       goto naz;
      else
       goto lll;
     }
    if(kom1 == ESC)
     {
      if(kolstr > 0)
       goto naz;
      else
       goto lll;
     }
     

    if(rsdat1(&m1,&g1,vstr.ravno()) != 0)
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto nazz1;
     }

//    sprintf(strsql,"%s",iceb_t_imafnsi("bluos.alx"));

    if(iceb_t_pbpds(m1,g1) != 0)
     {
      if(kolstr > 0)
       goto naz;
      else
       goto lll;
     }
    GDITE();
    
    metka_ras_amort=1;
    
    if((ff = fopen(imaf_prot_am,"w")) == NULL)
     {
      error_op_nfil(imaf_prot_am,errno,"");
      return;
     }
    startfil(ff);

    if(amortby(in,m1,g1,1,hna,ff) != 0)
	OSTANOV();
    fclose(ff); 
    goto naz1;

  case FK5:   /*Распечатать*/

    clear();

    sprintf(imaf,"amort%d.lst",getpid());
    if((ff = fopen(imaf,"w")) == NULL)
     {
      error_op_nfil(imaf,errno,"");
      return;
     }
    time(&tmm);
    bf=localtime(&tmm);

    fprintf(ff,"%s\n\n%s\n\
%s %ld %s %d\n\
%s %d.%d.%d%s %s: %d:%d\n\
---------------------------------------------------\n",
    organ,
    gettext("Амортотчисления"),
    gettext("Инвентарный номер"),
    in,
    gettext("Подразделение"),
    podd,
    gettext("По состоянию на"),
    bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
    gettext("г."),
    gettext("Время"),
    bf->tm_hour,bf->tm_min);
    
    i=0;
    cur.poz_cursor(0);
    while(cur.read_cursor(&row) != 0)
     {
      i++;
      fprintf(ff,"%2s.%s %10.2f\n",row[1],row[2],atof(row[6]));
     }
    fprintf(ff,"\
---------------------------------------------------\n\
%s %d\n",gettext("Количество записей"),i);
    fclose(ff);

    oth.clear();
    oth.spis_imaf.plus(imaf);
    oth.spis_naim.plus(gettext("Распечатка амортотчислений"));
    iceb_t_ustpeh(imaf,3);
    iceb_t_rabfil(&oth,"");
    goto naz;

  case FK6:   /*Распечатка документов*/

    uosrsd(in);

    if(kolstr > 0)
      goto naz;
    else
      goto lll;

  case FK7:   /*Просмотр протокола расчета амортизации*/
    diramort_vp1(imaf_prot,imaf_prot_am);
     
    if(kolstr > 0)
      goto naz;
    else
      goto lll;

  case FK8:   //Смена даты получения остатка

    VVOD1.VVOD_delete();
    VVOD1.VVOD_SPISOK_add_MD(gettext("Введите дату, на которую рассчитать остаток (д.м.г)"));
    vstr.new_plus("");
    if((kom1=vvod1(&vstr,11,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
     {
      if(kolstr > 0)
       goto naz;
      else
       goto lll;
     }
    if(kom1 == ESC)
     {
      if(kolstr > 0)
       goto naz;
      else
       goto lll;
     }
     

    if(rsdat(&d1,&m1,&g1,vstr.ravno(),1) != 0)
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
     }
    else
     {
      dt=d1; mt=m1; gt=g1;
     }     
    /*Узнаём где числится на эту дату*/
    
    if(poiin(in,dt,mt,gt,&podraz,&kodol) == 0)
     podd=podraz;
      
    goto naz1;

  default:
    if(kolstr > 0)
      goto naz;
    else
      goto lll;
 }
}

/*******/
/*Ввод */
/*******/

void vus7by(VVOD *VV,short mt, //0-ввести новое 1-корректировать
long in,short m,short g,int podd,
const char *hzt,const char *hna)
{
int             par;
short           m1,g1;
char		strsql[512];
time_t		vrem;

VV->VVOD_SPISOK_add_MD(gettext("Дата.......(м.г)......."));
VV->VVOD_SPISOK_add_MD(gettext("Сумма амортотчислений.."));

naz:;

helstr(LINES-1,0,"F2/+",gettext("запись"),
"F10",gettext("выход"),NULL);

par=VV->vvod(0,1,1,-1,-1);

switch(par)
 {
  
  case FK2:
  case PLU:
    break;
  case FK10:
  case ESC:
    return;
  default:
   goto naz;
 }

if(VV->VVOD_SPISOK_return_data(0)[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введен месяц !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

//m1=(short)ATOFM(VV->VVOD_SPISOK_return_data(0));

if(rsdat1(&m1,&g1,VV->VVOD_SPISOK_return_data(0)) != 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Неверно введена дата !"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

//sprintf(strsql,"%s",iceb_t_imafnsi("bluos.alx"));
if(iceb_t_pbpds(m1,g1) != 0)
  goto naz;

if(VV->VVOD_SPISOK_return_data(1)[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введена сумма амортотчислений !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

time(&vrem);

if(mt == 0)
 {
  sprintf(strsql,"insert into Uosamor1 \
values (%ld,%d,%d,%d,'%s','%s',%.2f,%d,%ld)",
  in,m1,g1,podd,hzt,hna,ATOFM(VV->VVOD_SPISOK_return_data(1)),iceb_t_getuid(),vrem);
 }


if(mt == 1)
 {
//  sprintf(strsql,"%s",iceb_t_imafnsi("bluos.alx"));
  if(iceb_t_pbpds(m,g) != 0)
    goto naz;
  sprintf(strsql,"update Uosamor1 \
set \
god=%d,\
mes=%d,\
podr=%d,\
hzt='%s',\
hna='%s',\
suma=%.2f,\
ktoz=%d,\
vrem=%ld \
where innom=%ld and god=%d and mes=%d",
  g1,m1,podd,hzt,hna,ATOFM(VV->VVOD_SPISOK_return_data(1)),iceb_t_getuid(),vrem,in,g,m);
 }

if(sql_zap(&bd,strsql) != 0)
 {
  sprintf(strsql,"Ошибка ввода записи !\n%s\n",sql_error(&bd));
  error2(20,0,1,strsql);
  goto naz;
 }

}

/*******/
/*Шапка*/
/*******/
void            shus7by(long in,int podd,double sumzap,
double bs,double iz,double bs1,double iz1,double iz11,
short dt,short mt,short gt)
{
int		X,Y;

move(0,0);

printw("%s\n",
gettext("Ввод и корректировка амортотчислений для бухгалтерского учета"));
printw("%s %ld %s:%d",
gettext("Инвентарный номер"),
in,
gettext("Подразделение"),
podd);

printw(" %s:%.2f\n",gettext("Сумма всех записей"),sumzap);

move(Y=3,X=COLS-30);
printw(gettext("Расшифровка полей:"));

move(++Y,X);
printw("1-%s",gettext("дата"));

move(++Y,X);
printw("2-%s",gettext("сумма"));

move(++Y,X);
printw("3-%s",gettext("подразделение"));

move(++Y,X);
printw("4-%s",gettext("шифр затрат"));

move(++Y,X);
printw("5-%s",gettext("шифр н. аморт-отч."));

move(++Y,X);
printw("6-%s",gettext("кто записал"));

move(Y+=2,X);
printw(gettext("Бал.стоимость   Износ"));
move(++Y,X);
printw("%10.2f %10.2f",bs,iz);
move(++Y,X);
printw("%10.2f %10.2f",bs1,iz1);
move(++Y,X);
printw("%s:%9.2f",gettext("Амортизация"),iz11);
move(++Y,X);
printw("%10.2f %10.2f",bs+bs1,iz+iz1+iz11);
move(++Y,X);
printw("%11s:%9.2f",gettext("Остаток"),(bs+bs1)-(iz+iz1+iz11));

move(++Y,X-2);
printw("%11s:%02d.%02d.%d",gettext("Дата остатка"),dt,mt,gt);

move(3,0);
printw("    1         2       3    4   5    6");

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("запись"),
"F3",gettext("удалить"),
"F4",gettext("расчет"),
"F5",gettext("печать"),
"F6",gettext("док."),
"F7",gettext("прот."),
"F8",gettext("см.даты"),
"F10",gettext("выход"),NULL);
}
/*********************************/
/*выбор просмотра*/
/********************************/
void diramort_vp1(const char *imafprot,const char *imafprot_am)
{

int kom=0;
VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите нужное"));

MENU.VVOD_SPISOK_add_MD(gettext("Просмотр протокола расчёта балансовой стоимости и износа"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Просмотр протокола расчёта амортизации"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//13
for(;;)
 {
  clear();

  if(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0)
   continue;

  switch (kom)
   {
    case 2:
    case -1 :
      return;
    case 0:
      vizred(imafprot);
      return;
    case 1:
      vizred(imafprot_am);
      return;
   }
 }


}
