/*$Id: dirost.c,v 5.30 2011-01-13 13:43:21 sasa1 Exp $*/
/*22.12.2009	23.05.2003	Белых А.И.	dirost.c
Программа работы со списком объектов списания топлива подсистема "Учет путевых листов"
*/
#include        <pwd.h>
#include        <errno.h>
#include        <time.h>
#include        <ctype.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void		sapkaost(int,const char*,const char*,const char*);
int             vvodost(class iceb_tu_str*);
int		polkod(void);
int             zapost(const char*,const char*,VVOD*);
int             puost(const char*);
int             pupost(SQL_str,const char*,const char*);
void            rasost(SQLCURSOR*);
int             korkost(const char*,const char*);

extern char	*organ;

int dirost(class iceb_tu_str *kodos,class iceb_tu_str *nai,int mk)//0-ввод 1-выбор
{
class iceb_tu_str vstr("");
class iceb_t_mstr spis_menu(0);
char		strsql[512];
char		bros[312];
long		kolstr=0;
int		poz,komv;
char		poi[32];
SQL_str		row,row1;
int		K=0;
class iceb_tu_str naimpoi(nai->ravno());
class iceb_tu_str kodmv(""); //Код вновь введенного объекта
long		pozz=0,pozz1=0;
short		mspz;
int		i=0,prc=0;
int		kom=0;
int             X=0,Y=4;
class iceb_tu_str naigrup("");
class iceb_tu_str kodgrpoi("");
int		kom1=0;
SQLCURSOR curr;


//Создаем класс меню
VVOD DANET(1);
VVOD VVOD1(2);
VVOD VV(0);

naz1:;
GDITE();

short           kls=LINES-7;

sprintf(strsql,"select * from Uplost order by kod asc");
SQLCURSOR cur;

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,"",strsql);
  return(1);
 }

if(kolstr == 0)
 {
lll:;
  sapkaost(mk,naimpoi.ravno(),kodgrpoi.ravno(),naigrup.ravno());

  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  K=soobshw(&SOOB,stdscr,-1,-1,1,1);

  if(K == FK3 || K == SFK9 || K == SFK3 || K == ENTER)
     goto lll;
  if(K == KEY_RESIZE)
    goto naz1;
  goto vper;
 }

if(naimpoi.ravno()[0] == '\0' && kodmv.getdlinna() > 1 && kolstr > kls  && \
 pozz < kolstr-kls)
 {
  pozz=poivcur(kodmv.ravno(),0,&cur);
  kodmv.new_plus("");
 }

naz:;
GDITE();
clear();

if(kolstr != 0 && pozz > kolstr)
  pozz = kolstr-1;


cur.poz_cursor(pozz);
mspz=2;
pozz1=0;
spis_menu.spis_str.free_class();
for(i=0; i < kls ;)
 {

  if(cur.read_cursor(&row) == 0)
    break;
  pozz1++;
  if(pupost(row,naimpoi.ravno(),kodgrpoi.ravno()) != 0)
    continue;

  sprintf(strsql,"%-4s|%-2s|%-*.*s|%-*s",
  row[0],row[1],
  iceb_tu_kolbait(30,row[2]),iceb_tu_kolbait(30,row[2]),row[2],
  iceb_tu_kolbait(4,row[3]),row[3]);

  spis_menu.spis_str.plus(strsql);
  i++;

  if(pozz1 == 1) /*Первая запись удовлетворяет условиям поиска*/
     mspz=1;

 }

if(kom >= i)
  kom=i-1;

if(kom < 0)
 kom=0;

if(i == 0)
 {
  if(kolstr > 0 && pozz > 0)
   {
    pozz--;
    goto naz;
   }
  goto lll;
 }

if(i <= kls-1)
  spis_menu.spis_str.plus(gettext("Конец списка"));

sapkaost(mk,naimpoi.ravno(),kodgrpoi.ravno(),naigrup.ravno());

prc=(pozz+pozz1)*100/kolstr;
memset(strsql,'\0',sizeof(strsql));
kom=spis_menu.menu(kom,Y,X,NULL,strsql,prc,&K,"",0);


if(kom == -7) //Изменение размеров экрана
 goto naz1;
 
if(kom == -3) /*Стрелка вниз*/
 {
  if(i <kls)
   {
    beep();
    goto naz;
   }
  GDITE();
  for(i=0; i < mspz  ; )
   {
    pozz++;

    cur.poz_cursor(pozz);
    if(cur.read_cursor(&row) == 0)
      break;

//    if(provusl(kodgrpoi,row[1],naimpoi.ravno(),row[2],mpro,row[0]) != 0)
//      continue;
    i++;
   }
  kom=kls;
  goto naz;
 }
if(kom == -2) /*Стрелка вверх*/
 {
  GDITE();
  for(i=0; i < 1 ; )
   {

    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    cur.read_cursor(&row);

//    if(provusl(kodgrpoi,row[1],naimpoi.ravno(),row[2],mpro,row[0]) != 0)
//      continue;
    i++;
   }

  goto naz;
 }
 
if(kom == -5) /*Страница вниз*/
 {
  if(pozz + kls == kolstr)
   {
    pozz=kolstr-1;
    beep();
    goto naz;  
   }
  if(i == kls)
    pozz+=pozz1;
  else
    beep();
  if(pozz >= kolstr)
   {
    pozz=kolstr-pozz1;
    beep();
    goto naz;  
   }
/*  
  printw("\n вперед pozz=%d\n",pozz);
  OSTANOV();
*/
  goto naz;

 }

if(kom == -4) /*Страница вверх*/
 {
/*
  printw("\npozz=%d\n",pozz);
  refresh();
*/
  GDITE();
  for(i=0; i<kls ; )
   {
    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    cur.read_cursor(&row);

//    if(provusl(kodgrpoi,row[1],naimpoi.ravno(),row[2],mpro,row[0]) != 0)
//      continue;
    i++;
   }
  goto naz;
 }

if(kom >= 0)
 {
  if(SRAV(gettext("Конец списка"),spis_menu.spis_str.ravno(kom),0) == 0)
     goto naz;
  if(pozz+kom >= kolstr)
   goto naz;
  polen(spis_menu.spis_str.ravno(kom),kodos,1,'|');

 }

vper:;

switch (K)
 {
  case FK1:  /*Получить подсказку*/
    GDITE();
    iceb_t_pdoc("upl3_7.txt");
    goto naz;

  case FK10: /*Выход*/
  case ESC : /*Выход*/
     return(1);

  case ENTER: /*Выход*/
     if(mk == 0)
       goto sfk2;
     return(0);

  case FK2: //Ввести новую запись
    kodmv.new_plus("");
    if(vvodost(&kodmv) != 0)
      kodmv.new_plus("");
    
    goto naz1;

  case SFK2: //Корректировать запись
sfk2:;
    vvodost(kodos);
    goto naz1;

  case FK3:       /*Удалить запись*/

    DANET.VVOD_delete();
    DANET.VVOD_SPISOK_add_MD(gettext("Удалить ? Вы уверены ?"));

    if(danet(&DANET,2,stdscr) == 2)
      goto naz;
    if(puost(kodos->ravno()) != 0)
      goto naz;

    kodmv.new_plus("");
    if(pozz == kolstr-1)
     pozz=0;

    goto naz1;
    
  case FK4:     //Поиск по наименованию

     helstr(LINES-1,0," F10 ",gettext("выход"),NULL);
     
     naimpoi.new_plus("");
     
     VVOD1.VVOD_delete();
     VVOD1.VVOD_SPISOK_add_MD(gettext("Введите образец для поиска"));

     vvod1(&naimpoi,32,&VVOD1,NULL,stdscr,-1,-1);

     kom=pozz=0;
     if(kolstr == 0)
       goto lll;
     else
       goto naz;

  case FK5:     //Распечатка
     rasost(&cur);
     goto naz1;
     
  case FK6:       /*Стать на номер */

    helstr(LINES-1,0," F10 ",gettext("выход"),NULL);
    
    
    VVOD1.VVOD_delete();
    VVOD1.VVOD_SPISOK_add_MD(gettext("Введите код"));
    vstr.new_plus("");
    if((kom1=vvod1(&vstr,16,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
      goto naz;
    if(kom1 == ESC)
      goto naz;
    if(vstr.ravno()[0] == '\0')
      goto naz;
      
    naimpoi.new_plus("");
    pozz=0;
    kom=0;
    pozz=poivcur(vstr.ravno(),0,&cur);
    if(pozz == kolstr)
     {
      VVOD SOOB(1);
      sprintf(bros,"%s %s !",gettext("Не найден код объекта списания топлива"),strsql);
      SOOB.VVOD_SPISOK_add_MD(bros);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      pozz=0;
     }
    goto naz;
           

  case FK9:       /*Просмотр по группе*/


    helstr(LINES-1,0," F10 ",gettext("выход"),NULL);
     
    kodgrpoi.new_plus("");
    naigrup.new_plus("");
     
    VVOD1.VVOD_delete();
    VVOD1.VVOD_SPISOK_add_MD(gettext("Введите код или наименование"));

    if((i=vvod1(&kodgrpoi,40,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
     {
      if(kolstr == 0)
        goto lll;
      else
        goto naz;
     }
    if(i == FK10)
     {
      if(kolstr == 0)
        goto lll;
      else
        goto naz;
     }

    if(kodgrpoi.getdlinna() <= 1 || isdigit(kodgrpoi.ravno()[0]) == 0)
     {
      clear();
      naigrup.new_plus("");
      kodgrpoi.new_plus("");
      poz=komv=0;
      poi[0]='\0';
      if(dirmat1("Uplgost",&kodgrpoi,&naigrup,15,0,3,1,&poz,&komv,poi,"\0") != 0)
       {
        if(kolstr == 0)
          goto lll;
        else
          goto naz;
       }
     }

    /*Читаем код группы материалла*/
    sprintf(strsql,"select naik from Uplgost where kod=%s",kodgrpoi.ravno());

    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      kodgrpoi.new_plus("");
      naigrup.new_plus("");
      VVOD SOOB(1);
      sprintf(strsql,gettext("Нет группы материалла %s !"),kodgrpoi.ravno());
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      if(kolstr == 0)
        goto lll;
      else
        goto naz;
     }
   naigrup.new_plus(row1[0]);
   kom=pozz=0;
   if(kolstr == 0)
     goto lll;
   else
     goto naz;
    
  default:
   if(kolstr > 0)
     goto naz;
   else
     goto lll;

 }
 
}
/**************/
/*Шапка */
/**************/
void sapkaost(int mk, //0-ввод 1-выбор
const char *nm,const char *kodgrpoi,const char *naigrup)
{
int	Y,X;

clear();
printw(gettext("Ввод и корректировка объектов списания топлива"));
move(3,0);
printw("    1   2               3                  4");

move(Y=3,X=COLS-21);
printw(gettext("Расшифровка полей:"));
mvprintw(++Y,X,"1 %s",gettext("дата документа"));
mvprintw(++Y,X,"2 %s",gettext("код группы"));
mvprintw(++Y,X,"3 %s",gettext("наименование"));
mvprintw(++Y,X,"4 %s",gettext("счет"));

if(nm[0] != '\0' || kodgrpoi[0] != '\0')
 {
  attron(A_BLINK);
  Y++;
  mvprintw(++Y,X,gettext("Поиск:"));
  if(nm[0] != '\0')
    mvprintw(++Y,X,"%s:%s",gettext("Нимен."),nm);
  if(kodgrpoi[0] != '\0')
    mvprintw(++Y,X,"%s:%s",gettext("К.группы"),kodgrpoi);
  attroff(A_BLINK);
 }


if(kodgrpoi[0] != '\0')
 {
  clearstr(1,0);
  attron(A_BLINK);
  printw(gettext("Поиск группы: %s %s"),kodgrpoi,naigrup);
  attroff(A_BLINK);
 }

if(nm[0] != '\0')
 {
  clearstr(2,0);
  attron(A_BLINK);
  printw("%s:%s",gettext("Найдено по образцу"),nm);
  attroff(A_BLINK);
 }

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("запись"),
"F3",gettext("удалить"),
"F4",gettext("поиск"),
"F5",gettext("печать"),
"F6",gettext("код"),
"F9",gettext("груп."),
"F10",gettext("выход"),NULL);

}

/*****************************/
/*Ввод и корректировка записи*/
/******************************/
//Если вернули 0-записали 1-нет
int   vvodost(class iceb_tu_str *kod)
{
char		strsql[512];
SQL_str		row;
class iceb_tu_str kodgr("");
char		kodgrz[24];
time_t		vrem=0;
int		N=1;
int             K=0;
int		poz,komv;
char		poi[32];
class iceb_tu_str naim("");
short		metkor=0;
SQLCURSOR curr;

VVOD VV(0);
VV.VVOD_SPISOK_add_data(10);
VV.VVOD_SPISOK_add_data(80);
VV.VVOD_SPISOK_add_data(80);
VV.VVOD_SPISOK_add_data(10);


if(kod->ravno()[0] == '\0')
 {
  VV.VVOD_SPISOK_add_ZAG(gettext("Ввод новой записи"));
  sprintf(strsql,"%d",polkod());
  VV.VVOD_SPISOK_zapis_data(0,strsql);
  
 }
else
 {
  VV.VVOD_SPISOK_add_ZAG(gettext("Коректировка записи"));
  sprintf(strsql,"select * from Uplost where kod=%s",kod->ravno());
  if(sql_readkey(&bd,strsql,&row,&curr) != 1)
    return(1);  
  VV.VVOD_SPISOK_zapis_data(0,row[0]);
  kodgr.new_plus(row[1]);
  VV.VVOD_SPISOK_zapis_data(2,row[2]);
  VV.VVOD_SPISOK_zapis_data(3,row[3]);
  int kt=atoi(row[4]);
  vrem=atol(row[5]);  

  sprintf(strsql,"select naik from Uplgost where kod=%s",kodgr.ravno());
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    VV.VVOD_SPISOK_zapis_data(1,row[0]);

  kzvz(kt,vrem,&VV);
           
 }


VV.VVOD_SPISOK_add_MD(gettext("Код..................."));
VV.VVOD_SPISOK_add_MD(gettext("Группа................"));
VV.VVOD_SPISOK_add_MD(gettext("Наименование объекта.."));
VV.VVOD_SPISOK_add_MD(gettext("Счет списания........."));

naz:;

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("запись"),
"F4",gettext("найти код"),
"F10",gettext("выход"),NULL);


VV.vramka(-1,-1,1);

refresh();
for(;;)
 {


  attron(VV.VVOD_return_cs(iceb_CFS)); 
  VV.vprintw(N,stdscr);

  K=getch();

  attroff(VV.VVOD_return_cs(iceb_CFS));
  attron(VV.VVOD_return_cs(iceb_CFM));

  VV.vprintw(N,stdscr);

  if(K == KEY_RESIZE)
   {
    getch();
    goto naz;
   }

  if(K == KEY_MOUSE)
    K=mouseklic(&N,VV.PY,VV.PX,VV.MDLS,VV.KLST,stdscr);

  if(K == ENTER)
   {
    attroff(VV.VVOD_return_cs(iceb_CFM));
    attron(VV.VVOD_return_cs(iceb_CFV));

    VV.vprintw_clear(N,stdscr);

    if(N == 1)  //Группа объекта
     {
      VV.VVOD_SPISOK_zapis_data(N,"");
      strcpy(kodgrz,kodgr.ravno());
      naim.new_plus("");
      kodgr.new_plus("");
      poz=komv=0;
      poi[0]='\0';
      if(dirmat1("Uplgost",&kodgr,&naim,15,-1,-1,2,&poz,&komv,poi,"\0") != 0)
       {
	kodgr.new_plus(kodgrz);
       }
      else
       {
        VV.VVOD_SPISOK_zapis_data(N,naim.ravno());
       }
      N++;
      goto naz;
     }

//    mygetstr(VV.VVOD_SPISOK_return_data(N),VV.VVOD_SPISOK_return_dls(N),stdscr);
    VV.vgetstr(N,stdscr);

    if(N == 0 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Код объекта
     {
      if(SRAV(kod->ravno(),VV.VVOD_SPISOK_return_data(N),0) != 0)
       {
        sprintf(strsql,"select kod from Uplost where kod=%s",VV.VVOD_SPISOK_return_data(0));
        if(sql_readkey(&bd,strsql,&row,&curr) > 0)
         {
          attroff(VV.VVOD_return_cs(iceb_CFM));
          VVOD SOOB(1);
          sprintf(strsql,gettext("Код %s уже есть в списке !"),VV.VVOD_SPISOK_return_data(0));
          SOOB.VVOD_SPISOK_add_MD(strsql);
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto naz;
         }
       }
     }

    if(N == 3 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Счет списания
     {
      attroff(VV.VVOD_return_cs(iceb_CFM));
      struct OPSHET	shetv;
      if(prsh1(VV.VVOD_SPISOK_return_data(N),&shetv) != 0)
       goto naz;

     }

    attroff(VV.VVOD_return_cs(iceb_CFV));
    attron(VV.VVOD_return_cs(iceb_CFM));

    VV.vprintw(N,stdscr);

    N++;
   }
  if(K==SDN) /*Стрелка вниз*/
   {
    N++;
   }
  if(K==SUP) /*Стрелка вверх*/
   {
    N--;
   }
  if(N > VV.KLST-1)
   {
    N=0;
   }
  if(N < 0)
   {
    N=VV.KLST-1;
   }

  if(K == ESC || K == FK10)
   {
     attroff(VV.VVOD_return_cs(iceb_CFS));
     attron(VV.VVOD_return_cs(iceb_CFM));
    N=-1;
    return(1);
   }

  if(K == FK2 || K == PLU) /*Записываем*/
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    attron(VV.VVOD_return_cs(iceb_CFM));
    metkor=0;
    if(kod->ravno()[0] != '\0' && SRAV(kod->ravno(),VV.VVOD_SPISOK_return_data(0),0) != '\0')
     {
      VVOD		DANET(1);
      DANET.VVOD_SPISOK_add_MD(gettext("Корректировать код ? Вы уверены ?"));
      if(danet(&DANET,2,stdscr) == 2)
        goto naz;
      metkor=1;
     }

    if(zapost(kod->ravno(),kodgr.ravno(),&VV) != 0)
      goto naz;

    if(metkor == 1)
      korkost(kod->ravno(),VV.VVOD_SPISOK_return_data(0));

    kod->new_plus(VV.VVOD_SPISOK_return_data(0));
    return(0);
   }
 }

}
/****************************************************/
/*Получение свободного кода объекта списания топлива*/
/****************************************************/

int	polkod()
{
char	strsql[512];
int  kod;
for(kod=1; ; kod++)
 {
  sprintf(strsql,"select kod from Uplost where kod=%d",kod);
  if(sql_readkey(&bd,strsql) != 1)
   break;
 }
return(kod);

}
/**************************/
/*Запись                   */
/***************************/
//Если вернули 0- записали 1-нет
int  zapost(const char *kod,const char *kodgr,VVOD *VV)
{
char	strsql[512];
SQL_str row=NULL;
time_t  vrem=0;
struct OPSHET	shetv;

if(VV->VVOD_SPISOK_return_data(0)[0] == '\0' || ATOFM(VV->VVOD_SPISOK_return_data(0)) == 0.)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введен код !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
if(ATOFM(VV->VVOD_SPISOK_return_data(0)) < 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Код не может быть отрицательным !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
if(VV->VVOD_SPISOK_return_data(1)[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введена группа !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

if(VV->VVOD_SPISOK_return_data(2)[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введено наименование !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

if(VV->VVOD_SPISOK_return_data(3)[0] != '\0') //Счет списания
 if(prsh1(VV->VVOD_SPISOK_return_data(3),&shetv) != 0)
  return(1);

char    naim[strlen(VV->VVOD_SPISOK_return_data(2))*2+1];
strcpy(naim,VV->VVOD_SPISOK_return_data(2));
sqlfiltr(naim,sizeof(naim));

if(kod[0] == '\0')
 {
  sprintf(strsql,"select kod from Uplost where kod=%s",VV->VVOD_SPISOK_return_data(0));
  if(sql_readkey(&bd,strsql) > 0)
   {
    VVOD SOOB(1);
    sprintf(strsql,gettext("Код %s уже есть в списке !"),VV->VVOD_SPISOK_return_data(0));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return(1);
   }

  sprintf(strsql,"select kod from Uplost where naik='%s'",naim);
  if(sql_readkey(&bd,strsql) > 0)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %s",gettext("Такое наименование уже введено. Код"),row[0]);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return(1);
   }
 }
 
time(&vrem);

if(kod[0] == '\0')  //Новая запись
 {
  sprintf(strsql,"insert into Uplost \
values (%s,%s,'%s','%s',%d,%ld)",
  VV->VVOD_SPISOK_return_data(0),
  kodgr,
  naim,
  VV->VVOD_SPISOK_return_data(3),
  iceb_t_getuid(),vrem);
 }
else
 {
  sprintf(strsql,"update Uplost \
set \
kod=%s,\
kgr=%s,\
naik='%s',\
shet='%s',\
ktoz=%d,\
vrem=%ld \
where kod=%s",
  VV->VVOD_SPISOK_return_data(0),
  kodgr,
  naim,
  VV->VVOD_SPISOK_return_data(3),
  iceb_t_getuid(),vrem,
  kod);
 }

return(sql_zapis(strsql,0,0));


}
/*********************************/
/*Проверка возможности удаления записи*/
/**************************************/
//если вернули 0-можно удалять 1-нет

int	puost(const char *kod)
{
char	strsql[512];

VVOD SOOBN(1);
SOOBN.VVOD_SPISOK_add_MD(gettext("Выполняется проверка возможности удаления записи"));
soobsh(&SOOBN,-1,-1,1);

GDITE();

sprintf(strsql,"select ko from Upldok2 where ko=%s limit 1",kod);
if(sql_readkey(&bd,strsql) > 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Запись удалить невозможно !"));
  sprintf(strsql,"%s Upldok2",gettext("Информация с этим кодом введена в таблицу"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

sprintf(strsql,"delete from Uplost where kod=%s",kod);
return(sql_zapis(strsql,1,0));

}
/*************************************************/
/*Проверка записи на соответствие условиям поиска*/
/*************************************************/
//Если вернули 0-подходит
int   pupost(SQL_str row,const char *naimpoi,const char *kodgr)
{

if(naimpoi[0] != '\0')
 if(strstrm(row[2],naimpoi) == 0)
  return(1);

if(kodgr[0] != '\0')
 if(SRAV(row[1],kodgr,0) != 0)
  return(1);

return(0);

}
/*********************************************/
/*Распечатка списка объектов списания топлива*/
/*********************************************/
void	rasost(SQLCURSOR *cur)
{
FILE	*ff;
char    imaf[30];
SQL_str row;
time_t  vrem;
struct  tm      *bf;

GDITE();
time(&vrem);
bf=localtime(&vrem);

sprintf(imaf,"ost%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

zagolov(gettext("Распечатка списка объектов списания топлива"),bf,0,0,0,0,0,0,organ,ff);

fprintf(ff,"\
-----------------------------------------------------------\n");
fprintf(ff,"\
К/о|К/г|Наименование объекта списания топлива   | Счет\n");
fprintf(ff,"\
-----------------------------------------------------------\n");

cur->poz_cursor(0);

while(cur->read_cursor(&row) != 0)
 {
  fprintf(ff,"%3s %3s %-*.*s %s\n",
  row[0],row[1],
  iceb_tu_kolbait(40,row[2]),iceb_tu_kolbait(40,row[2]),row[2],
  row[3]);
  
 }
fprintf(ff,"\
-----------------------------------------------------------\n");

podpis(ff);
fclose(ff);
class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Распечатка списка объектов списания топлива"));
iceb_t_ustpeh(imaf,3);
iceb_t_rabfil(&oth,"");

}

/*********************************************/
/*Корректировка кода объекта списания топлива*/
/*********************************************/
//Если вернули 0-корректировка состоялась
int	korkost(const char *kods,const char *kodn)
{
char strsql[512];

VVOD SOOBN(1);
SOOBN.VVOD_SPISOK_add_MD(gettext("Выполняется каскадная корректировка кода в таблицах !"));
soobsh(&SOOBN,-1,-1,1);

GDITE();

sprintf(strsql,"update Upldok2 set ko=%s where ko=%s",kodn,kods);
return(sql_zapis(strsql,0,0));

}
