/* $Id: dirsaldo.c,v 5.41 2011-01-13 13:43:21 sasa1 Exp $ */
/*13.01.2010    17.09.1993      Белых А.И.      dirsaldo.c
Ввод и корректировка сальдо по счетам и организациям
*/
#include        <sys/stat.h>
#include        <pwd.h>
#include        <errno.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif
class dirsaldo_poi
 {
  public:
    char shetpoi[20];
    char kontrpoi[20];
    char godpoi[5];
    char grupapoi[32];
    int	 metpoi;

  dirsaldo_poi()
   {
    clear();
   }
   
  void clear()
   {
    memset(shetpoi,'\0',sizeof(shetpoi));
    memset(kontrpoi,'\0',sizeof(kontrpoi));
    memset(godpoi,'\0',sizeof(godpoi));
    memset(grupapoi,'\0',sizeof(grupapoi));
    metpoi=0;
   }
 };
 
void dirsaldo_vz(const char *kkk,short god_k,const char *shet_k,const char *kontr_k);
void            shbh4(const char*,double,double,class dirsaldo_poi*);
int	poisaldo(SQL_str,class dirsaldo_poi*);
void dirsaldo_uzs(SQLCURSOR *cur,int kolstr,class dirsaldo_poi*);
void dirsaldo_zg(const char *kkk);
void dirsaldo_rs(class SQLCURSOR *cur,class dirsaldo_poi *rpoi,const char *tz);

extern char     *organ;

int dirsaldo(const char *tz)
{
class iceb_t_mstr spis_menu(0);
class dirsaldo_poi rpoi;
short           y=2,x=0;
char            sin[24]; /*Счет */
char            korg[24]; /*Код организации */
short           godd=0; /*Год*/
char            bros[512];
int             K;
int		prc;
short           i;
int             kom=0,kom1=0;
class iceb_tu_str sh1("");
class iceb_tu_str sh2("");
double		deb,kre;
long		kolstr;
long		pozz,pozz1;
SQL_str         row,row1;
char		strsql[512];
double		dos=0.,kos=0.;
struct OPSHET	shetv;
int		kl=0;
int		mspz=0;
char		naim[512];
short dt,mt,gt;



pozz=kom=K=0;

//Создаем класс меню
VVOD VV(0);
VVOD DANET(1);
VVOD VVOD1(2);
VVOD PAR(2);

naz1:;

short           kls=LINES-5;
int		ktozap[kls];
time_t		vremzap[kls];


sprintf(strsql,"select * from Saldo where kkk='%s' order by gs,ns asc",tz);

deb=kre=0.;
SQLCURSOR cur;
SQLCURSOR cur1;

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
lll:;
  shbh4(tz,deb,kre,&rpoi);
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  K=soobshw(&SOOB,stdscr,-1,-1,1,1);

  if(K == FK6 || K == SFK2 || K == ENTER || K == FK3 || K == FK5)
    goto lll;
  if(K == KEY_RESIZE)
   goto naz1;   
  goto vper;
 }
else
 {
  while(cur.read_cursor(&row) != 0)
  {
   if(rpoi.metpoi == 1)
   if(poisaldo(row,&rpoi) != 0)
     continue;
   
   deb+=atof(row[4]);
   kre+=atof(row[5]);
  }

 }
if(kolstr != 0 && pozz > kolstr)
  pozz = kolstr-1;
naz:;



cur.poz_cursor(pozz);
mspz=2;
pozz1=0;
char strmenu[500];
spis_menu.spis_str.free_class();
for(i=0;i<=kls-1;)
 {
  if(cur.read_cursor(&row) == 0)
    break;
  pozz1++;

  if(rpoi.metpoi == 1)
   if(poisaldo(row,&rpoi) != 0)
    continue;
  
  ktozap[i]=atoi(row[6]);
  vremzap[i]=atoi(row[7]);
  memset(strmenu,'\0',sizeof(strmenu));
  if(tz[0] == '0')
    sprintf(strmenu,"%s|%-*s|%10.2f|%10.2f",
    row[1],
    iceb_tu_kolbait(10,row[2]),row[2],
    atof(row[4]),atof(row[5]));
  
  if(tz[0] == '1')
   {
    memset(naim,'\0',sizeof(naim));
    sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",row[3]);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
      strncpy(naim,row1[0],sizeof(naim)-1);

    sprintf(strmenu,"%s|%-*s|%-*s|%-*.*s|%10.2f|%10.2f",
    row[1],
    iceb_tu_kolbait(6,row[2]),row[2],
    iceb_tu_kolbait(6,row[3]),row[3],
    iceb_tu_kolbait(15,naim),iceb_tu_kolbait(15,naim),naim,
    atof(row[4]),atof(row[5]));
   }

  spis_menu.spis_str.plus(strmenu);
  i++;

  if(pozz1 == 1) /*Первая запись удовлетворяет условиям поиска*/
   mspz=1;

 }
if(i == 0)
 {
  if(kolstr != 0 && pozz > 0)
   {
    pozz--;
    goto naz;
   }
  goto lll;
 }  
if(kom >= i)
  kom=i-1;

if(kom < 0)
 kom=0;

if(i <=kls-1)
  spis_menu.spis_str.plus(gettext("Конец списка"));


shbh4(tz,deb,kre,&rpoi);

prc=(pozz+pozz1)*100/kolstr;
memset(strsql,'\0',sizeof(strsql));
kom=spis_menu.menu(kom,y,x,NULL,strsql,prc,&K,"",0);


if(kom == -7) //Изменение границы экрана
  goto naz1;
if(kom == -3) /*Стрелка вниз*/
 {
  if(i <kls)
   {
    beep();
    goto naz;
   }
  for(i=0; i< mspz   ; )
   {
    pozz++;
    if(pozz >= kolstr)
     {
      pozz=kolstr-1;
      break;
     }
    cur.poz_cursor(pozz);
    if(cur.read_cursor(&row) == 0)
      break;
    if(rpoi.metpoi == 1)
     if(poisaldo(row,&rpoi) != 0)
      continue;

    i++;
   }
  kom=kls-1;
  goto naz;
 }
if(kom == -2) /*Стрелка вверх*/
 {
  for(i=0; i < 1 ; )
   {

    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    cur.read_cursor(&row);

    if(rpoi.metpoi == 1)
     if(poisaldo(row,&rpoi) != 0)
      continue;

    i++;
   }

  goto naz;
 }
 
if(kom == -5) /*Страница вниз*/
 {
  if(pozz + kls == kolstr)
   {
    pozz=kolstr-1;
    beep();
    goto naz;  
   }
  if(i == kls)
    pozz+=pozz1;
  else
    beep();
  if(pozz >= kolstr)
   {
    pozz=kolstr-pozz1;
    beep();
    goto naz;  
   }
/*  
  printw("\n вперед pozz=%d kolstr=%ld\n",pozz,kolstr);
  OSTANOV();
*/
  goto naz;

 }

if(kom == -4) /*Страница вверх*/
 {
/*
  printw("\npozz=%d\n",pozz);
  refresh();
*/
  for(i=0; i<kls ; )
   {
    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    if(cur.read_cursor(&row) == 0)
      break;

    if(rpoi.metpoi == 1)
     if(poisaldo(row,&rpoi) != 0)
      continue;

    i++;
   }
  goto naz;
 }

if(kom >= 0)
 {
  if(SRAV(gettext("Конец списка"),spis_menu.spis_str.ravno(kom),0) == 0)
     goto naz;
  if(pozz+kom >= kolstr)
   goto naz; /*Стали на конец списка*/

  POLE(spis_menu.spis_str.ravno(kom),bros,1,'|');
  godd=(short)ATOFM(bros);

  memset(sin,'\0',sizeof(sin));
  POLE(spis_menu.spis_str.ravno(kom),sin,2,'|');
 
  memset(korg,'\0',sizeof(korg));
  if(tz[0] == '0')
   {
    POLE(spis_menu.spis_str.ravno(kom),bros,3,'|');
    dos=ATOFM(bros);

    POLE(spis_menu.spis_str.ravno(kom),bros,4,'|');
    kos=ATOFM(bros);
   }

  if(tz[0] == '1')
   {
    memset(korg,'\0',sizeof(korg));
    POLE(spis_menu.spis_str.ravno(kom),korg,3,'|');

    POLE(spis_menu.spis_str.ravno(kom),bros,5,'|');
    dos=ATOFM(bros);

    POLE(spis_menu.spis_str.ravno(kom),bros,6,'|');
    kos=ATOFM(bros);
   }
 }

vper:;

switch (K)
 {
  case FK10: /*Выход*/
  case ESC : /*Выход*/
     return(1);
     break;

  case FK1:  /*Получить подсказку*/
    GDITE();
    if(tz[0] == '0')
      sprintf(strsql,"%s","buhg4_4.txt");
    if(tz[0] == '1')
      sprintf(strsql,"%s","buhg4_5.txt");

    iceb_t_pdoc(strsql);
    goto naz;

  case SFK2:   /*Корректировать*/
  case ENTER:
    dirsaldo_vz(tz,godd,sin,korg);

    goto naz1;

  case FK2:  /*Ввести запись*/
  case PLU:
    dirsaldo_vz(tz,0,"","");
    goto naz1;

  case FK3:       /*Удалить запись*/

    if(iceb_t_pvglkni(1,godd) != 0)
     goto naz1;
    if(iceb_t_pbsh(1,godd,sin,"","") != 0)
     goto naz1;
     
    DANET.VVOD_delete();
    DANET.VVOD_SPISOK_add_MD(gettext("Удалить ? Вы уверены ?"));

    if(danet(&DANET,2,stdscr) == 2)
     goto naz;
   
    sprintf(strsql,"delete from Saldo where kkk='%s' and gs=%d and \
ns='%s' and kodkon='%s' and deb=%.2f and kre=%.2f",
    tz,godd,sin,korg,dos,kos);

    if(sql_zap(&bd,strsql) != 0)
     {
       if(sql_nerror(&bd) == ER_DBACCESS_DENIED_ERROR) //Только чтение
        {
         VVOD SOOB(1);
         SOOB.VVOD_SPISOK_add_MD(gettext("У вас нет полномочий для выполнения этой операции !"));
         soobshw(&SOOB,stdscr,-1,-1,0,1);
        }
       else
        msql_error(&bd,gettext("Ошибка удаления записи !"),strsql);
      }      
     goto naz1;

  case SFK3:       /*Удалить запись*/

    DANET.VVOD_delete();
    DANET.VVOD_SPISOK_add_MD(gettext("Удалить все записи ? Вы уверены ?"));

    if(danet(&DANET,2,stdscr) == 2)
     goto naz1;
    poltekdat(&dt,&mt,&gt);
    PAR.VVOD_delete();
    PAR.VVOD_SPISOK_add_MD(gettext("Введите пароль"));
    if(parolv(&PAR,dt,mt,gt,0) != 0)
      goto naz1;

    dirsaldo_uzs(&cur,kolstr,&rpoi);

    goto naz1;

  case FK4:       /*Поиск*/
    VV.VVOD_delete();

    VV.VVOD_SPISOK_add_ZAG(gettext("Введите данные для поиска"));
    VV.VVOD_SPISOK_add_MD(  gettext("Счет..............."));
    VV.VVOD_SPISOK_add_MD(  gettext("Год................"));
    VV.VVOD_SPISOK_add_data(rpoi.shetpoi,10);
    VV.VVOD_SPISOK_add_data(rpoi.godpoi,5);
    if(SRAV(tz,"1",0) == 0)
     {
      VV.VVOD_SPISOK_add_MD(gettext("Контрагент.........."));
      VV.VVOD_SPISOK_add_MD(gettext("Группа контрагента.."));
      VV.VVOD_SPISOK_add_data(rpoi.kontrpoi,10);
      VV.VVOD_SPISOK_add_data(rpoi.grupapoi,sizeof(rpoi.grupapoi));
     }    
    
fk4:;
    rpoi.metpoi=0;

    helstr(LINES-1,0,"F2/+",gettext("поиск"),
//    "F3",gettext("реквизиты"),
    "F4",gettext("очистить"),
    "F10",gettext("выход"),NULL);

    kl=VV.vvod(0,1,1,-1,-1);

    switch(kl)
     {
      case FK10:
      case ESC:
        rpoi.metpoi=0;
        pozz=0;
        goto naz1;
        
      case FK2:
      case PLU:
        GDITE();
        strcpy(rpoi.shetpoi,VV.VVOD_SPISOK_return_data(0));
        strcpy(rpoi.godpoi,VV.VVOD_SPISOK_return_data(1));

        if(SRAV(tz,"1",0) == 0)
         {
          strcpy(rpoi.kontrpoi,VV.VVOD_SPISOK_return_data(2));
          strcpy(rpoi.grupapoi,VV.VVOD_SPISOK_return_data(3));
         }

        rpoi.metpoi=1;
        pozz=0;
        goto naz1;

      case FK4:
        VV.VVOD_clear_data();
        goto fk4;
        
      default :
        goto fk4;
     }
    goto naz1;

  case FK5:       /*Распечатать*/
    dirsaldo_rs(&cur,&rpoi,tz);
    goto naz;

  case FK6:       /*Сменить счет*/

    clear(); /*Очистить экран и закрасить фоновым цветом*/
    printw(gettext("Смена номера счета"));

    helstr(LINES-1,0,"F10",gettext("выход"),NULL);
        
    sh1.new_plus("");
    sh2.new_plus("");
    VVOD1.VVOD_delete();
    VVOD1.VVOD_SPISOK_add_MD(gettext("Введите счет, который нужно сменить"));

    if((kom1=vvod1(&sh1,16,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
     goto naz;
    if(kom1 == ESC)
     goto naz;

    VVOD1.VVOD_delete();
    VVOD1.VVOD_SPISOK_add_MD(gettext("Введите счет, на который нужно сменить"));

    if((kom1=vvod1(&sh2,sizeof(sh2),&VVOD1,NULL,stdscr,-1,-1)) == FK10)
     goto naz;
    if(kom1 == ESC)
     goto naz;
     
    if(sh1.getdlinna() <= 1 || sh2.getdlinna() <= 1)
      goto naz;

    if(prsh(sh1.ravno(),&shetv) == 0)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не найден счет %s в плане счетов !"),sh1.ravno());
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }

    if(prsh(sh2.ravno(),&shetv) == 0)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не найден счет %s в плане счетов !"),sh2.ravno());
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }
    clearstr(LINES-1,0);

    DANET.VVOD_delete();
    DANET.VVOD_SPISOK_add_MD(gettext("Выполнить корректировку ? Вы уверены ?"));

    if(danet(&DANET,2,stdscr) == 2)
       goto naz;

    GDITE();
   
    sprintf(strsql,"update Saldo set ns='%s' where ns='%s'",
    sh2.ravno(),sh1.ravno());
    if(sql_zap(&bd,strsql) != 0)
     {
       if(sql_nerror(&bd) == ER_DBACCESS_DENIED_ERROR) //Только чтение
        {
         VVOD SOOB(1);
         SOOB.VVOD_SPISOK_add_MD(gettext("У вас нет полномочий для выполнения этой операции !"));
         soobshw(&SOOB,stdscr,-1,-1,0,1);
        }
       else
        msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
     }    
    goto naz1;

  case SFK10: //Загрузка сальдо
    dirsaldo_zg(tz);
    goto naz1;

  default:
    goto naz;
    break;
 }
}

/***********************/
/*Шапка*/
/****************/
void shbh4(const char *tz,double deb,double kre,class dirsaldo_poi *rpoi)
{
short		y=2;
short           x=COLS-20;
move(0,0);
clear();
if(tz[0] == '0')
 {
  printw(gettext("Ввод и коректировка сальдо по счетам"));
  mvprintw(1,0,"   1       2          3          4 ");
  mvprintw(y++,x,gettext("Наименование полей:"));
  mvprintw(y++,x,gettext("1-год"));
  mvprintw(y++,x,gettext("2-счет"));
  mvprintw(y++,x,gettext("3-дебет"));
  mvprintw(y++,x,gettext("4-кредит"));
 }
if(tz[0] == '1')
 {
  printw(gettext("Ввод и коректировка сальдо по контрагентам"));
  mvprintw(1,0,"   1      2     3          4             5          6");
  mvprintw(y++,x,gettext("Наименование полей:"));
  mvprintw(y++,x,gettext("1-год"));
  mvprintw(y++,x,gettext("2-счет"));
  mvprintw(y++,x,gettext("3-код контрагента"));
  mvprintw(y++,x,gettext("4-наим.конт-та"));
  mvprintw(y++,x,gettext("5-дебет"));
  mvprintw(y++,x,gettext("6-кредит"));
 }
move(y+=2,x);
printw("%-6s:%10.2f",
gettext("Дебет"),deb);
move(++y,x);
printw("%-6s:%10.2f",
gettext("Кредит"),kre);
if(rpoi->metpoi == 1)
 {
  attron(A_BLINK);
  move(++y,x);
  printw(gettext("Поиск:"));
  if(rpoi->shetpoi[0] != '\0')
   {
    move(++y,x);
    printw("%s",rpoi->shetpoi);
   }
  if(rpoi->kontrpoi[0] != '\0')
   {
    move(++y,x);
    printw("%s",rpoi->kontrpoi);
   }
  if(rpoi->godpoi[0] != '\0')
   {
    move(++y,x);
    printw("%s",rpoi->godpoi);
   }
  if(rpoi->grupapoi[0] != '\0')
   {
    move(++y,x);
    printw("%s",rpoi->grupapoi);
   }
  attroff(A_BLINK);
 }
helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("запись"),
"F3",gettext("удалить"),
"F4",gettext("поиск"),
"F5",gettext("печать"),
"F6",gettext("смена счета"),
"F10",gettext("выход"),NULL);

}
/*************************/
/*Проверка условий поиска*/
/*************************/
int	poisaldo(SQL_str row,class dirsaldo_poi *rpoi)
{
if(proverka(rpoi->shetpoi,row[2],1,0) != 0)
 return(1);
if(proverka(rpoi->kontrpoi,row[3],0,0) != 0)
 return(1);
if(proverka(rpoi->godpoi,row[1],0,0) != 0)
 return(1);

if(rpoi->grupapoi[0] != '\0')
 {
  SQLCURSOR cur;
  SQL_str   row1;
  char      strsql[512];
  sprintf(strsql,"select grup from Kontragent where kodkon='%s'",row[3]);
  if(sql_readkey(&bd,strsql,&row1,&cur) == 1)
   if(proverka(rpoi->grupapoi,row1[0],0,0) != 0)
     return(1);
 }
return(0);

}
/************************************/
/*Удаление записей*/
/**********************/
void dirsaldo_uzs(SQLCURSOR *cur,
int kolstr,
class dirsaldo_poi *rpoi)
{


SQL_str row;
char strsql[512];
int kolstr1=0;
cur->poz_cursor(0);
while(cur->read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(rpoi->metpoi == 1)
   if(poisaldo(row,rpoi) != 0)
    continue;

  sprintf(strsql,"delete from Saldo where kkk='%s' and gs=%s and ns='%s'",
  row[0],row[1],row[2]);
//  printw("strsql=%s\n",strsql);
  
  sql_zapis(strsql,1,0);
 }

}
/********************************/
/*Загрузка сальдо из файла*/
/**************************/
void dirsaldo_zg(const char *kkk)
{
struct stat work;
int kom=0;
static class iceb_tu_str imafim("");
static char	imafprom[40];
FILE		*ff,*ffprom;
char            strsql[512];

VVOD VVOD1(2);
clear();
VVOD1.VVOD_SPISOK_add_ZAG(gettext("Импорт стартового сальдо по счетам"));
VVOD1.VVOD_SPISOK_add_MD(gettext("Введите имя файла"));

naz:;

clear();

helstr(LINES-1,0,
"F1",gettext("помощь"),
"F2/+",gettext("загруз."),
"F3",gettext("просмотр"),
"F10",gettext("выход"),NULL);

if((kom=vvod1(&imafim,56,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
  return;
if(kom == ESC)
  return;

switch(kom)
 {
  case FK1:
    GDITE();
    iceb_t_pdoc("buhg4_4_1.txt");
    clear();
    goto naz;

  case ENTER:
  case FK2:
  case PLU:
    if(imafim.getdlinna() <= 1)
     {
      dirkatl(&imafim);
      goto naz;
     }
    break;

  case FK3:
   GDITE();
   if(stat(imafim.ravno(),&work) != 0)
    {
     VVOD SOOB(1);
     sprintf(strsql,"%s !",gettext("Нет такого файла"));
     SOOB.VVOD_SPISOK_add_MD(strsql);
     soobshw(&SOOB,stdscr,-1,-1,0,1);
     goto naz;
    }
    vizred(imafim.ravno());
    goto naz;

  default:
    goto naz;
 }

clear();
move(LINES-1,0);
GDITE();
time_t tmm;
struct tm *bf;

time(&tmm);
bf=localtime(&tmm);

if(stat(imafim.ravno(),&work) != 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s !",gettext("Нет такого файла"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }


if((ff = fopen(imafim.ravno(),"r")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s:%d !",
  gettext("Ошибка окрытия файла"),imafim.ravno(),errno);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
sprintf(imafprom,"prom%d.tmp",getpid());
if((ffprom = fopen(imafprom,"w")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s:%d !",
  gettext("Ошибка окрытия файла"),imafprom,errno);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

int razmer=0;
char strok[1024];
int  i=0;
char god[24];
char shet[56];
char deb[56];
char kre[56];
char kontr[56];
OPSHET ops;
time_t vrem;
time(&vrem);

while(fgets(strok,sizeof(strok),ff) != NULL)
 {
  i=strlen(strok);
  razmer+=i;
  if(strok[i-2] == '\r') //Возврат каретки меняем на пробел
   strok[i-2]=' ';

  printw("%s",strok);
  strzag(LINES-1,0,work.st_size,razmer);
  
  memset(kontr,'\0',sizeof(kontr));
  
  if(polen(strok,god,sizeof(god),1,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }
  if(atoi(god) == 0 || atoi(god) < 1900)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s !",gettext("Неправильно введён год"));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);

    fprintf(ffprom,"%s",strok);
    fprintf(ffprom,"%s !\n",gettext("Неправильно введён год"));
    continue;
   }
  polen(strok,shet,sizeof(shet),2,'|');
  polen(strok,deb,sizeof(deb),3,'|');
  polen(strok,kre,sizeof(kre),4,'|');
  polen(strok,kontr,sizeof(kontr),5,'|');
  //проверяем счёт 
  if(prsh1(shet,&ops) != 0)
   {
    fprintf(ff,"%s\n",gettext("Не правильно введён счёт !"));
    fprintf(ffprom,"%s",strok);
    continue;
   }    

  if(ops.saldo == 3) //Счёт с развёрнутым сальдо
   {
    if(kontr[0] == '\0')
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s",gettext("Не введён код контаргента !"));
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);

      fprintf(ffprom,"%s",strok);
      fprintf(ffprom,"%s\n",gettext("Не введён код контаргента !"));
      continue;
     }
    //проверяем код контрагента
    sprintf(strsql,"select kodkon from Kontragent where kodkon='%s'",kontr);
    if(readkey(strsql) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s %s !",gettext("Не найден код контрагента"),kontr);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);

      fprintf(ffprom,"%s",strok);
      fprintf(ff,"%s %s !\n",gettext("Не найден код контрагента"),kontr);
      continue;
     }
    //Проверяем есть ли контрагент в списке счёта
    sprintf(strsql,"select kodkon from Skontr where ns='%s' and kodkon='%s'",shet,kontr);
    if(readkey(strsql) < 1)
     {
      //записываем контраген в список счёта
      sprintf(strsql,"insert into Skontr values ('%s','%s',%d,%ld)",shet,kontr,iceb_t_getuid(),vrem);
      sql_zapis(strsql,1,0);
     }
   }

  //Удаляем старую запись если она есть (нет уникального ключа)
  if(ops.saldo == 3)
   sprintf(strsql,"delete from Saldo where kkk='%s' and gs=%d and ns='%s' and kodkon='%s'",
   kkk,atoi(god),shet,kontr);
  else
   sprintf(strsql,"delete from Saldo where kkk='%s' and gs=%d and ns='%s'",
   kkk,atoi(god),shet);

  sql_zapis(strsql,1,0);
     
  //записываем стартовое сальдо
  sprintf(strsql,"replace into Saldo values ('%s',%d,'%s','%s',%.2f,%.2f,%d,%ld)",
  kkk,atoi(god),shet,kontr,atof(deb),atof(kre),iceb_t_getuid(),vrem);
  printw("%s\n",strsql);
  
  sql_zapis(strsql,1,0);
  

 }

fclose(ff);
fclose(ffprom);
unlink(imafim.ravno());

rename(imafprom,imafim.ravno());
}
/*************************/
/*Распечатка*/
/*********************/
void dirsaldo_rs(class SQLCURSOR *cur,class dirsaldo_poi *rpoi,const char *tz)
{
char imaf[56];
FILE *ff;

sprintf(imaf,"saldo.lst");
if((ff = fopen(imaf,"w")) == (char)NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

zagolov(gettext("Стартовое сальдо по счетам"),0,0,0,0,0,0,organ,ff);

//fprintf(ff,"%s\n\n",organ);
//fprintf(ff,"%s\n",gettext("Список сальдо по счетам"));
fprintf(ff,"-----------------------------------------------------------------\n");

char strsql[512];
double  deb=0.,kre=0.;
cur->poz_cursor(0);
SQL_str row,row1;
class SQLCURSOR cur1;
char naim[112];
while(cur->read_cursor(&row) != 0)
 {
  if(rpoi->metpoi == 1)
   if(poisaldo(row,rpoi) != 0)
    continue;

  if(tz[0] == '1')
   {
    memset(naim,'\0',sizeof(naim));
    sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",row[3]);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
      strncpy(naim,row1[0],sizeof(naim)-1);

    fprintf(ff,"%s %s %-*s %-*s %-*.*s %10.2f %10.2f\n",
    row[0],
    row[1],
    iceb_tu_kolbait(5,row[2]),row[2],
    iceb_tu_kolbait(5,row[3]),row[3],
    iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim,
    atof(row[4]),atof(row[5]));
   }
  else
   {
    fprintf(ff,"%s %s %-*s %-*s %10.2f %10.2f\n",
    row[0],row[1],
    iceb_tu_kolbait(5,row[2]),row[2],
    iceb_tu_kolbait(5,row[3]),row[3],
    atof(row[4]),atof(row[5]));
   }

  deb+=atof(row[4]);
  kre+=atof(row[5]);

 }
fprintf(ff,"-----------------------------------------------------------------\n");
    
if(tz[0] == '1')
  fprintf(ff,"%*s %10.2f %10.2f\n",iceb_tu_kolbait(49,gettext("Итого:")),gettext("Итого:"),deb,kre);
else    
  fprintf(ff,"%*s %10.2f %10.2f\n",iceb_tu_kolbait(18,gettext("Итого:")),gettext("Итого:"),deb,kre);

fclose(ff);
class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Стартовое сальдо по счетам"));
iceb_t_ustpeh(imaf,3);
iceb_t_rabfil(&oth,"");
}
/*******************************/
/*Ввод и корректировка */
/**************************/
void dirsaldo_vz(const char *kkk,short god_k,const char *shet_k,const char *kontr_k)
{
int             par;
static  char    godz[5],shetz[16];
struct OPSHET	shetv;
int		ktoi=iceb_t_getuid();
time_t		vrem;
char		strsql[512];
int		i;
class iceb_tu_str kod("");
class iceb_tu_str naim("");
double		deb,kre;
SQL_str row;
class SQLCURSOR cur;

class VVOD VV(0);

VV.VVOD_SPISOK_add_data(5);
VV.VVOD_SPISOK_add_data(20);
VV.VVOD_SPISOK_add_data(20);
VV.VVOD_SPISOK_add_data(20);
VV.VVOD_SPISOK_add_data(20);


if(god_k == 0)
  VV.data_plus(0,godz);
else
 {
  sprintf(strsql,"select * from Saldo where kkk='%s' and gs=%d and ns='%s' and kodkon='%s'",
  kkk,god_k,shet_k,kontr_k);
  if(readkey(strsql,&row,&cur) != 1)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не нашли запись для корректировки !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return;
   }

  
  VV.data_plus(0,row[1]);
  VV.data_plus(1,row[2]);
  if(kkk[0] == '0')
   {
    VV.data_plus(2,row[4]);
    VV.data_plus(3,row[5]);

   }
  else
   {
    VV.data_plus(2,row[3]);
    VV.data_plus(3,row[4]);
    VV.data_plus(4,row[5]);

   }
  kzvz(atoi(row[6]),atol(row[7]),&VV);

 }

if(kkk[0] == '0')
 {
  VV.VVOD_SPISOK_add_MD(gettext("Год....."));
  VV.VVOD_SPISOK_add_MD(gettext("Счет...."));
  VV.VVOD_SPISOK_add_MD(gettext("Дебет..."));
  VV.VVOD_SPISOK_add_MD(gettext("Кредит.."));

 }
if(kkk[0] == '1')
 {
  if(god_k == 0 && VV.VVOD_SPISOK_return_data(1)[0] == '\0')
    VV.data_plus(1,shetz);
  VV.VVOD_SPISOK_add_MD(gettext("Год.............."));
  VV.VVOD_SPISOK_add_MD(gettext("Счет............."));
  VV.VVOD_SPISOK_add_MD(gettext("Код контрагента.."));
  VV.VVOD_SPISOK_add_MD(gettext("Дебет............"));
  VV.VVOD_SPISOK_add_MD(gettext("Кредит..........."));
 }

naz:;

if(kkk[0] == '0')
  helstr(LINES-1,0,"F2/+",gettext("записать"),
  "F10",gettext("выход"),NULL);

if(kkk[0] == '1')
  helstr(LINES-1,0,"F2/+",gettext("записать"),
  "F3",gettext("контрагенты"),
  "F10",gettext("выход"),NULL);

par=0;
if(VV.VVOD_SPISOK_return_data(0)[0] != '\0')
  par = 1;
if(VV.VVOD_SPISOK_return_data(1)[0] != '\0')
  par = 2;

par=VV.vvod(par,1,1,-1,-1);

strncpy(godz,VV.VVOD_SPISOK_return_data(0),sizeof(godz)-1);
strncpy(shetz,VV.VVOD_SPISOK_return_data(1),sizeof(shetz)-1);

int metka_prov=0;

switch(par)
 {
  case FK10:
  case ESC:
    break; 

  case FK2:
  case PLU:
    GDITE();
    if(VV.VVOD_SPISOK_return_data(1)[0] == '\0')
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Не введен счет !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }
    if(VV.VVOD_SPISOK_return_data(0)[0] == '\0')
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Не введен год !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }

    if((i=prsh(VV.VVOD_SPISOK_return_data(1),&shetv)) == 0)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Нет счета %s в плане счетов !"),VV.VVOD_SPISOK_return_data(1));
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }

    if(i == 2)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Счет %s имеет субсчета. Введите нужный субсчет."),VV.VVOD_SPISOK_return_data(1));
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }

    if(kkk[0] == '0' && shetv.saldo == 3)
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Счет с развернутым сальдо. Сальдо вводиться по контрагентам !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }

    if(kkk[0] == '1' && shetv.saldo != 3)
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Счет не с развернутым сальдо !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }

    time(&vrem);

    if(kkk[0] == '1')
     {
      /*Читаем наименование организации*/
      sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",VV.VVOD_SPISOK_return_data(2));
      if(readkey(strsql) != 1)
       {
        VVOD SOOB(1);
        sprintf(strsql,"%s %s",gettext("Не найден код контрагента"),
        VV.VVOD_SPISOK_return_data(2));
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);

        goto naz;
       }

      sprintf(strsql,"select kodkon from Skontr where ns='%s' and \
kodkon='%s'",VV.VVOD_SPISOK_return_data(1),VV.VVOD_SPISOK_return_data(2));

      if(readkey(strsql) < 1)
       {
        sprintf(strsql,"insert into Skontr \
values ('%s','%s',%d,%ld)",VV.VVOD_SPISOK_return_data(1),VV.VVOD_SPISOK_return_data(2),ktoi,vrem);
        /*
          printw("\nstrsql=%s\n",strsql);
          OSTANOV();
        */
          GDITE();
          if(sql_zap(&bd,strsql) != 0)
           {
           if(sql_nerror(&bd) == ER_DBACCESS_DENIED_ERROR) //Только чтение
            {
             VVOD SOOB(1);
             SOOB.VVOD_SPISOK_add_MD(gettext("У вас нет полномочий для выполнения этой операции !"));
             soobshw(&SOOB,stdscr,-1,-1,0,1);
             goto naz;
            }
           else
            {
             msql_error(&bd,gettext("Ошибка ввода записи"),strsql);
             goto naz;
            }
           }
       }
     }
    
    metka_prov=0;
    /*Проверяем может сальдо уже введено*/
    if(kkk[0] == '0')
     {    
      if(god_k != VV.data_ravno_atoi(0) || SRAV(shet_k,VV.data_ravno(1),0) != 0 )
       metka_prov=1;
     } 
    else
      if(god_k != VV.data_ravno_atoi(0) || SRAV(shet_k,VV.data_ravno(1),0) != 0 || SRAV(kontr_k,VV.data_ravno(2),0) != 0 )
       metka_prov=1;    
    
    if(metka_prov == 1)
     {
      if(kkk[0] == '0')
       sprintf(strsql,"select gs from Saldo \
where kkk='%s' and gs='%s' and ns='%s' and kodkon='%s'",
       kkk,VV.VVOD_SPISOK_return_data(0),VV.VVOD_SPISOK_return_data(1),"\0");

      if(kkk[0] == '1')
       sprintf(strsql,"select gs from Saldo \
where kkk='%s' and gs='%s' and ns='%s' and kodkon='%s'",
       kkk,VV.VVOD_SPISOK_return_data(0),VV.VVOD_SPISOK_return_data(1),VV.VVOD_SPISOK_return_data(2));

      if(readkey(strsql) >= 1)
       {
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Такая запись уже есть !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        goto naz;
       }

     }

    /*Проверяем блокировку*/
    if(iceb_t_pvglkni(1,VV.data_ravno_atoi(0)) != 0)
     goto naz;

    if(iceb_t_pbsh(1,VV.data_ravno_atoi(0),VV.data_ravno(1),shet_k,"") != 0)
     goto naz;

    if(god_k != 0 && god_k != VV.data_ravno_atoi(0))
     {
      if(iceb_t_pvglkni(1,god_k) != 0)
       goto naz;
     }

    
    /*Записываем*/
    if(god_k == 0)
     {

      if(kkk[0] == '0')
       {
        deb=ATOFM(VV.VVOD_SPISOK_return_data(2));
        kre=ATOFM(VV.VVOD_SPISOK_return_data(3));
        sprintf(strsql,"insert into Saldo \
values ('%s',%s,'%s','%s',%.2f,%.2f,%d,%ld)",
        kkk,VV.VVOD_SPISOK_return_data(0),VV.VVOD_SPISOK_return_data(1),"\0",deb,kre,ktoi,vrem);
       }
      if(kkk[0] == '1')
       {
        deb=ATOFM(VV.VVOD_SPISOK_return_data(3));
        kre=ATOFM(VV.VVOD_SPISOK_return_data(4));
        sprintf(strsql,"insert into Saldo \
values ('%s',%s,'%s','%s',%.2f,%.2f,%d,%ld)",
        kkk,VV.VVOD_SPISOK_return_data(0),VV.VVOD_SPISOK_return_data(1),VV.VVOD_SPISOK_return_data(2),deb,kre,ktoi,vrem);
       }
     }

    if(god_k != 0)
     {
      if(kkk[0] == '0')
       {
        deb=ATOFM(VV.VVOD_SPISOK_return_data(2));
        kre=ATOFM(VV.VVOD_SPISOK_return_data(3));
        sprintf(strsql,"update Saldo \
set kkk='%s',gs=%s,ns='%s',kodkon='%s',deb=%.2f,kre=%.2f,ktoi=%d,\
vrem=%ld where kkk='%s' and gs=%d and ns='%s' and kodkon='%s'",
        kkk,VV.VVOD_SPISOK_return_data(0),VV.VVOD_SPISOK_return_data(1),"\0",deb,kre,ktoi,vrem,
        kkk,god_k,shet_k,kontr_k);
       }

      if(kkk[0] == '1')
       {
        deb=ATOFM(VV.VVOD_SPISOK_return_data(3));
        kre=ATOFM(VV.VVOD_SPISOK_return_data(4));
        sprintf(strsql,"update Saldo \
set kkk='%s',gs=%s,ns='%s',kodkon='%s',deb=%.2f,kre=%.2f,ktoi=%d, \
vrem=%ld where kkk='%s' and gs=%d and ns='%s' and kodkon='%s'",
        kkk,VV.VVOD_SPISOK_return_data(0),VV.VVOD_SPISOK_return_data(1),VV.VVOD_SPISOK_return_data(2),deb,kre,ktoi,vrem,
        kkk,god_k,shet_k,kontr_k);
       }
     }
     
    /*
      printw("\nstrsql=%s\n",strsql);
      OSTANOV();
    */
      GDITE();
      if(sql_zap(&bd,strsql) != 0)
       {
        if(sql_nerror(&bd) == ER_DBACCESS_DENIED_ERROR) //Только чтение
         {
          VVOD SOOB(1);
          SOOB.VVOD_SPISOK_add_MD(gettext("У вас нет полномочий для выполнения этой операции !"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto naz;
         }
        else
         {
          msql_error(&bd,gettext("Ошибка ввода записи"),strsql);
          goto naz;
         }
       }
     break;

  case FK3:  /*Просмотр списка контрагентов*/
    if(kkk[0] == '0')
     goto naz;  

    kod.new_plus("");
    naim.new_plus("");
    if(dirkontr(&kod,&naim,1) == 0)
     {
      VV.data_plus(2,kod.ravno());
     }  
    goto naz;

  default:
   goto naz;

 }  

}
