/* $Id: dirtabel.c,v 5.37 2011-06-07 08:47:12 sasa Exp $ */
/*14.01.2010    15.05.1995      Белых А.И.      dirtabel.c
Просмотр ввод и корректировка отработанного времени для конкретного 
табельного номера
*/
#include        <pwd.h>
#include        <time.h>
#include        "buhg.h"

int             zapktabel(VVOD*,short,short,long,const char*,const char*,int,float,float);
void		sozzapktabel(VVOD*);
void		shzr6(short,short,long,const char*,float,float,float,double,float,float);

extern float	dnei; /*Количество рабочих дней в месяце*/
extern float    hasov; /*Количество рабочих часов в текущем месяце*/

void dirtabel(short mp,short gp, //Дата
long tabn, //Табельный номер
const char *fam) //Фамилия
{
char            bros[1024];
char            kod[64]; /*Код */
short           x=0,y=4;
int             K;
short           kom;
short           i;
class iceb_tu_str n("");
class iceb_tu_str n1("");
float		kd,kh,kkd;
long		pozz,pozz1;
long		kolstr;
SQL_str         row,row1;
char		strsql[1024];
int		prc;
char		nait[512];
float		dneii=0.,has=0.,kdnei=0.;
short		dn,mn,gn;
short		dk,mk,gk;
int		poz,komv;
char		poi[512];
double		oklad=0.; /*Найденный оклад*/
float		has1=0.;   /*Количество часов в одном рабочем дне*/
float		kof=0.;   /*Коэффициент оплаты ставки*/
int		met=0;   /*0-оклад 1-часовая ставка 2-не пересчитываемый оклад*/
int		koddo=0; /*Код должносного оклада*/
int		metka=0; /*0-нет метки 1-есть Метка пересчета на процент выполнения плана подразделением*/
int		metka1=0; /*0-расчет выполнять по отработанным часам 1-дням*/
float		kolrd=0.; /*Количество рабочих дней в месяце*/
class iceb_t_mstr spis_menu(0);
float		kolrh=0.; /*Количество рабочих часов в смене*/
char strmenu[1024];
class iceb_tu_str shet_do("");
int metka_no=0;
SQLCURSOR curr;
SQLCURSOR cur;

clear();
dn=mn=gn=dk=mk=gk=K=pozz=pozz1=kom=0;

//Создаем класс меню
VVOD DANET(1);
VVOD VV(0);

redkal(mp,gp,&dnei,&hasov);

dolhn1(tabn,&oklad,&has1,&kof,&met,&koddo,&metka,&metka1,&shet_do,&metka_no,NULL);



naz1:;

clear();
short           kls=LINES-5;
short		nomzap[kls];
kd=kh=kkd=0.;


sprintf(strsql,"select kodt,dnei,has,kdnei,datn,datk,kolrd,kolrh,nomz,kom \
from Ztab where god=%d and mes=%d and tabn=%ld order by kodt asc",
gp,mp,tabn);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
 
if(kolstr == 0)
 {

lll:;

  shzr6(mp,gp,tabn,fam,kd,kh,kkd,oklad,has1,kof);
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  K=soobshw(&SOOB,stdscr,-1,-1,1,1);

  if(K != FK2 && K != FK10 && K != ESC && K != PLU)
      goto lll;
  if(K == KEY_RESIZE)
   goto naz1;
   
  goto vper;
 }

naz:;

cur.poz_cursor(pozz);
pozz1=0;
spis_menu.spis_str.free_class();
for(i=0;i<=kls-1;)
 {
  if(cur.read_cursor(&row) == 0)
    break;
  pozz1++;

/*
    printw("zr6.gd=%d zr6.ms=%d zr6.tbn=%ld zr6.vt=%d\n",
    zr6.gd,zr6.ms,zr6.tbn,zr6.vt);
  */

  /*Читаем наименование табеля*/
  memset(nait,'\0',sizeof(nait));
  sprintf(strsql,"select naik from Tabel where kod=%s",row[0]);
  
  if(readkey(strsql,&row1,&curr) != 1)
   {
    beep();
    printw("%s %s !\n",gettext("Не найден код табеля"),row[0]);
    OSTANOV();
   }
  else
    strncpy(nait,row1[0],sizeof(nait)-1);
  
  dneii=atof(row[1]);
  has=atof(row[2]);
  kdnei=atof(row[3]);
  memset(bros,'\0',sizeof(bros));
  memset(strsql,'\0',sizeof(strsql));
  rsdat(&dn,&mn,&gn,row[4],2);    
  rsdat(&dk,&mk,&gk,row[5],2);    
  kolrd=atof(row[6]);
  kolrh=atof(row[7]);
  nomzap[i]=atoi(row[8]);
  if(dn != 0)
   sprintf(bros,"%d.%d.%d",dn,mn,gn);
  if(dk != 0)
    sprintf(strsql,"%d.%d.%d",dk,mk,gk);

  sprintf(strmenu,"%-2s|%-*.*s|%-3.5g|%-4.5g|%-3.5g|%-2.5g|\
%-2.5g|%-10s|%-10s|%.1s",
  row[0],
  iceb_tu_kolbait(25,nait),iceb_tu_kolbait(25,nait),nait,
  dneii,has,kdnei,kolrd,kolrh,bros,strsql,row[9]);

  kd+=dneii;
  kh+=has;
  kkd+=kdnei;

  spis_menu.spis_str.plus(strmenu);
  i++;

 }

if(kom >= i)
  kom=i-1;

if(kom < 0)
 kom=0;

if(i <=kls-1)
  spis_menu.spis_str.plus(gettext("Конец списка"));

shzr6(mp,gp,tabn,fam,kd,kh,kkd,oklad,has1,kof);


prc=(pozz+pozz1)*100/kolstr;
memset(strsql,'\0',sizeof(strsql));
kom=spis_menu.menu(kom,y,x,NULL,strsql,prc,&K,"",0);


if(kom == -7) //Изменение размеров экрана
  goto naz1;
  
if(kom == -3) /*Стрелка вниз*/
 {
  if(i < kls)
   {
    beep();
    goto naz;
   }
  if(i == kls)
    pozz++;
  kom=kls;
  goto naz;
 }
if(kom == -2) /*Стрелка вверх*/
 {
  if(pozz == 0)
   {
    beep();
    goto naz;
   }
  if(pozz != 0)
    pozz--;
  goto naz;
 }

if(kom == -5) /*Страница вниз*/
 {
  if(i == kls)
    pozz+=kls;
  else
    beep();
/*
  printw("\n вперед pozz=%d\n",pozz);
  OSTANOV();
*/
  goto naz;

 }

if(kom == -4) /*Страница вверх*/
 {
  pozz-=kls;
  if(pozz < 0)
   {
    beep();
    pozz=0;
   }
/*
  printw("\n назад pozz=%d\n",pozz);
  OSTANOV();
*/
  goto naz;
 }

if(kom >= 0)
 {
  class iceb_tu_str str_out(spis_menu.spis_str.ravno(kom));
  if(SRAV(gettext("Конец списка"),str_out.ravno(),0) == 0)
     goto naz;
  if(pozz+kom >= kolstr)
   goto naz;

  POLE(str_out.ravno(),kod,1,'|');
  polen(str_out.ravno(),&n1,2,'|');
  POLE(str_out.ravno(),bros,3,'|');
  dneii=(float)atof(bros);
  POLE(str_out.ravno(),bros,4,'|');
  has=(float)atof(bros);
  POLE(str_out.ravno(),bros,5,'|');
  kdnei=(float)atof(bros);

  POLE(str_out.ravno(),bros,6,'|');
  kolrd=(float)atof(bros);

  POLE(str_out.ravno(),bros,7,'|');
  kolrh=(float)atof(bros);

  POLE(str_out.ravno(),bros,8,'|');
  rsdat(&dn,&mn,&gn,bros,1);
  POLE(str_out.ravno(),bros,9,'|');
  rsdat(&dk,&mk,&gk,bros,1);
 }

vper:;

switch (K)
 {
  case ESC : /*Выход*/
  case FK10 : /*Выход*/
     break;

  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp2_4.txt");
   clear();
   if(kolstr > 0)
     goto naz;
   else
     goto lll;



  case FK2:   /*Добавить запись*/
  case PLU:   /*Добавить запись*/

  n.new_plus("");
  n1.new_plus("");
  poz=komv=0;
  poi[0]='\0';
  if(dirmat1("Tabel",&n,&n1,0,-1,-1,2,&poz,&komv,poi,"\0") == 0)
   {
    VV.VVOD_delete();
    sozzapktabel(&VV);
    zapktabel(&VV,mp,gp,tabn,n.ravno(),n1.ravno(),0,has1,kof);
   }

  goto naz1;
  break;

  case SFK2:   /*Корректировать запись*/
  case ENTER:
    VV.VVOD_delete();
    sozzapktabel(&VV);

  sprintf(strsql,"%.6g",dneii);
  VV.VVOD_SPISOK_zapis_data(0,strsql);
  sprintf(strsql,"%.6g",has);
  VV.VVOD_SPISOK_zapis_data(1,strsql);
  sprintf(strsql,"%.6g",kdnei);
  VV.VVOD_SPISOK_zapis_data(2,strsql);
  if(kolrd != 0)
   {
    sprintf(strsql,"%.5g",kolrd);
    VV.VVOD_SPISOK_zapis_data(3,strsql);
   }
  if(kolrh != 0)
   {
    sprintf(strsql,"%.5g",kolrh);
    VV.VVOD_SPISOK_zapis_data(4,strsql);
   }
  if(dn != 0)
   {
    sprintf(strsql,"%d.%d.%d",dn,mn,gn);
    VV.VVOD_SPISOK_zapis_data(5,strsql);
   }
  if(dk != 0)
   {
    sprintf(strsql,"%d.%d.%d",dk,mk,gk);
    VV.VVOD_SPISOK_zapis_data(6,strsql);
   }  
  if(nomzap[kom] != 0)
   {
    sprintf(strsql,"%d",nomzap[kom]);
    VV.VVOD_SPISOK_zapis_data(8,strsql);
   }
  //Читаем комментарий
  sprintf(strsql,"select kom from Ztab where tabn=%ld and god=%d and \
mes=%d and kodt=%d and nomz=%d",tabn,gp,mp,atoi(kod),nomzap[kom]);
  if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
    VV.VVOD_SPISOK_zapis_data(7,row1[0]);

  zapktabel(&VV,mp,gp,tabn,kod,n1.ravno(),1,has1,kof);
  goto naz1;
  break;

  case FK3:   /*Удалить*/

    DANET.VVOD_delete();
    DANET.VVOD_SPISOK_add_MD(gettext("Удалить ? Вы уверены ?"));

    if(danet(&DANET,2,stdscr) == 1)
     {
/*
      sprintf(strsql,"delete from Ztab where god=%d and mes=%d and \
tabn=%ld and kodt=%s and dnei=%.2f and has=%.2f and kdnei=%.2f",
      gp,mp,tabn,kod,dneii,has,kdnei);
*/
      sprintf(strsql,"delete from Ztab where god=%d and mes=%d and \
tabn=%ld and kodt=%s and nomz=%d",
      gp,mp,tabn,kod,nomzap[kom]);
/*
      printw("\nstrsql=%s\n",strsql);
      OSTANOV();
*/
      if(sql_zap(&bd,strsql) != 0)
        msql_error(&bd,gettext("Ошибка удаления записи !"),strsql);

      clear();
      goto naz1;
     }
    clear(); /*Очистить экран и закрасить фоновым цветом*/
    goto naz;

  default:
   if(kolstr > 0)
     goto naz;
   else
     goto lll;
 }
printw("999999999999999999999999999\n");
refresh();

}

/******************************/
/*Ввод и корректировка записей*/
/******************************/
/*Если вернули 0 запись сделана
               1 нет
*/
int zapktabel(VVOD *VV,short mp,short gp,long tabn,const char *tz,
const char *n1,int mz, /*0-ввод новой 1-корректировка*/
float has1,float kof)
{
short		dn,mn,gn;
short		dk,mk,gk;
short		d,m,g;
int		K,N;
double		bb;
short		maxkkd; /*Максимальное количество календарных дней*/
char		bros[512];
char		snomz[112];
char		strsql[512];
short		dnp=0,mnp=0,gnp=0;
short		dkp=0,mkp=0,gkp=0;

dn=mn=gn=dk=mk=gk=maxkkd=K=N=0;
m=mp; g=gp;
memset(snomz,'\0',sizeof(snomz));
strcpy(snomz,VV->VVOD_SPISOK_return_data(8));
dpm(&maxkkd,&m,&g,5);
sprintf(bros,"%s %s",tz,n1);

VV->VVOD_SPISOK_add_ZAG(bros);

VV->VVOD_SPISOK_add_MD(gettext("Количество дней.............."));//0
VV->VVOD_SPISOK_add_MD(gettext("Количество часов (ч:м)......."));//1
VV->VVOD_SPISOK_add_MD(gettext("Количество календарных дней.."));//2
VV->VVOD_SPISOK_add_MD(gettext("Колич. раб. дней в месяце...."));//3
VV->VVOD_SPISOK_add_MD(gettext("Колич. часов в рабочем дне..."));//4
VV->VVOD_SPISOK_add_MD(gettext("Дата начала.................."));//5
VV->VVOD_SPISOK_add_MD(gettext("Дата конца..................."));//6
VV->VVOD_SPISOK_add_MD(gettext("Коментарий..................."));//7
VV->VVOD_SPISOK_add_MD(gettext("Номер записи................."));//8

rsdat(&dnp,&mnp,&gnp,VV->VVOD_SPISOK_return_data(5),1);
rsdat(&dkp,&mkp,&gkp,VV->VVOD_SPISOK_return_data(6),1);

naz:;

helstr(LINES-1,0,
//"F1",gettext("помощь"),
"F2/+",gettext("запись"),
"F10",gettext("выход"),NULL);


VV->vramka(-1,-1,0);

attron(VV->VVOD_return_cs(iceb_CFS)); 

VV->vprintw(N,stdscr);

for(;;)
 {
  refresh();
  K=getch();

  attroff(VV->VVOD_return_cs(iceb_CFS));
  attron(VV->VVOD_return_cs(iceb_CFM));

  VV->vprintw(N,stdscr);

  if(K == KEY_MOUSE)
    K=mouseklic(&N,VV->PY,VV->PX,VV->MDLS,VV->KLST,stdscr);

  if(K == ENTER)
   {
    attroff(VV->VVOD_return_cs(iceb_CFM));
    attron(VV->VVOD_return_cs(iceb_CFV));
    VV->vprintw_clear(N,stdscr);

//    mygetstr(VV->VVOD_SPISOK_return_data(N),VV->VVOD_SPISOK_return_dls(N),stdscr);
    VV->vgetstr(N,stdscr);
    
    attroff(VV->VVOD_return_cs(iceb_CFV));
    attron(VV->VVOD_return_cs(iceb_CFM));

    if(N == 0) /*Количество отработанных дней*/
     {
      if(VV->VVOD_SPISOK_return_data(N)[0] != '\0')
       {
        if(VV->VVOD_SPISOK_return_data(1)[0] == '\0')
         {
          if(has1 != 0.)
            bb=ATOFM(VV->VVOD_SPISOK_return_data(N))*has1*kof;
          else
           {
            if(ATOFM(VV->VVOD_SPISOK_return_data(N)) == dnei && hasov > 0.)
             bb=hasov;
            else
             bb=ATOFM(VV->VVOD_SPISOK_return_data(N))*8;
           }
          bb=okrug(bb,0.01);
          VV->data_plus(1,bb);
         }
        if(VV->VVOD_SPISOK_return_data(2)[0] == '\0' && dnei == ATOFM(VV->VVOD_SPISOK_return_data(0)))
         {
          VV->data_plus(2,maxkkd);
         }
//        printw("\ndnei=%d %d\n",dnei,(int)ATOFM(VV->VVOD_SPISOK_return_data(0)));
//        OSTANOV();
        N++;
        goto naz;
       }
     }
    if(N == 1) /*Количество отработанных часов*/
     {

      bb=ATOFM(VV->VVOD_SPISOK_return_data(N));
      if(polen(VV->VVOD_SPISOK_return_data(N),bros,sizeof(bros),2,':') == 0)
       {
        bb=(bb*60+ATOFM(bros))/60;
       }
      if(bb != 0.)
       VV->data_plus(N,bb);
      N++;
      goto naz;
     }

    if(N == 2) /*Количество отработанных календарных дней*/
     {
      d=(short)ATOFM(VV->VVOD_SPISOK_return_data(N));
      if(d > maxkkd)
       {
        VVOD SOOB(1);
        sprintf(strsql,gettext("В этом месяце календарных дней не может быть больше %d !"),maxkkd);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        goto naz;
       }
     }

    if(N == 5 && VV->VVOD_SPISOK_return_data(N)[0] != '\0') //Дата начала периода
     {
      if(rsdat(&dnp,&mnp,&gnp,VV->VVOD_SPISOK_return_data(N),1) != 0)
       {
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        goto naz;
       }
     }
    if(N == 6 && VV->VVOD_SPISOK_return_data(N)[0] != '\0') //Дата конца периода
     {
      if(rsdat(&dkp,&mkp,&gkp,VV->VVOD_SPISOK_return_data(N),1) != 0)
       {
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конца !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        goto naz;
       }
      if(dnp != 0 && dkp != 0)
       {
        sprintf(strsql,"%d",period(dnp,mnp,gnp,dkp,mkp,gkp,0));
        VV->VVOD_SPISOK_zapis_data(2,strsql);
        sprintf(strsql,"%d",krdvp(dnp,mnp,gnp,dkp,mkp,gkp));
        VV->VVOD_SPISOK_zapis_data(0,strsql);
        goto naz;
       }
     }


    VV->vprintw(N,stdscr);
    N++;
   }
  if(K==SDN) /*Стрелка вниз*/
   {
    N++;
   }
  if(K==SUP) /*Стрелка вверх*/
   {
    N--;
   }
  if(N > VV->KLST-1)
   {
    N=0;
   }
  if(N < 0)
   {
    N=VV->KLST-1;
   }
  attron(VV->VVOD_return_cs(iceb_CFS));
  VV->vprintw(N,stdscr);

   if(K == ESC || K == FK10)
    {
      attroff(VV->VVOD_return_cs(iceb_CFS));
      attron(VV->VVOD_return_cs(iceb_CFM));
     N=-1;
     return(1);
    }
   if(K == FK2 || K == PLU) /*Записываем*/
    {
     attroff(VV->VVOD_return_cs(iceb_CFS));
     attron(VV->VVOD_return_cs(iceb_CFM));

     if(VV->VVOD_SPISOK_return_data(5)[0] != '\0')
     if(rsdat(&dn,&mn,&gn,VV->VVOD_SPISOK_return_data(5),1) != 0)
      {
       VVOD SOOB(1);
       SOOB.VVOD_SPISOK_add_MD(gettext("Не верно ведена дата начала !"));
       soobshw(&SOOB,stdscr,-1,-1,0,1);
       goto naz;
      }
     if(VV->VVOD_SPISOK_return_data(6)[0] != '\0')
     if(rsdat(&dk,&mk,&gk,VV->VVOD_SPISOK_return_data(6),1) != 0)
      {
       VVOD SOOB(1);
       SOOB.VVOD_SPISOK_add_MD(gettext("Не верно ведена дата конца !"));
       soobshw(&SOOB,stdscr,-1,-1,0,1);
       goto naz;
      }
     strcpy(bros,VV->VVOD_SPISOK_return_data(7));
     sqlfiltr(bros,sizeof(bros));
     if(zaptabel(mz,mp,gp,tabn,atoi(tz),atof(VV->VVOD_SPISOK_return_data(0)),atof(VV->VVOD_SPISOK_return_data(1)),
     atof(VV->VVOD_SPISOK_return_data(2)),dn,mn,gn,dk,mk,gk,atof(VV->VVOD_SPISOK_return_data(3)),atof(VV->VVOD_SPISOK_return_data(4)),bros,
     atoi(VV->VVOD_SPISOK_return_data(8)),atoi(snomz)) != 0)
       goto naz;

     return(0);
    }
 }
}


/********/
/*Шапка */
/*********/
void shzr6(short mp,short gp,long tn,const char *fam,float kd,
float kh,float kkd,
double oklad, //Найденный оклад
float has1,   //Количество часов в одном рабочем дне
float kof) //Коэффициент оплаты ставки
{

move(0,0);

printw(gettext("Ввод и корректировка табеля.\n"));
printw("%s:%d.%d%s %s N-%d\n",gettext("Дата"),mp,gp,
gettext("г."),fam,tn);

printw("%s %.6g %s %.6g %s %.6g",
gettext("Дней"),kd,
gettext("Часов"),kh,
gettext("Кал-рных дней"),kkd);
if(oklad != 0.)
 printw(" %s:%.2f/%.2f/%.2f",gettext("Оклад"),oklad,has1,kof);
move(3,0);

printw(gettext("\
 Код    Наименование           Дни Час. К/д Нор Ч    Дата нач. Дата кон."));

helstr(LINES-1,0,"F1",gettext("допомога"),
"F2/+",gettext("запись"),
"F3",gettext("удалить"),
"F10",gettext("выход"),NULL);

}
/**************************************/
void sozzapktabel(VVOD *VV)
{
VV->VVOD_SPISOK_add_data(3);
VV->VVOD_SPISOK_add_data(6);
VV->VVOD_SPISOK_add_data(3);
VV->VVOD_SPISOK_add_data(3);
VV->VVOD_SPISOK_add_data(3);
VV->VVOD_SPISOK_add_data(11);
VV->VVOD_SPISOK_add_data(11);
VV->VVOD_SPISOK_add_data(40);
VV->VVOD_SPISOK_add_data(3);

}
