/*$Id: dirzardk.c,v 5.28 2011-01-13 13:43:21 sasa1 Exp $*/
/*14.01.2010	29.05.2006	Белых А.И.	dirzardk.c
Работа со списком документов в подсистеме "Заработная плата"
*/
#include <errno.h>
#include        <time.h>
#include        <pwd.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

class poi_dirzardk
 {
  public:
  char datan[11];
  char datak[11];
  char nomdok[32];
  char podr[112];
  char koment[112];
  short metka_poi; //0-без поиска 1- с поиском
  
  poi_dirzardk()
   {
    clear_data();
   }
  
  void clear_data()
   {
    memset(datan,'\0',sizeof(datan));
    memset(datak,'\0',sizeof(datak));
    memset(podr,'\0',sizeof(podr));
    memset(nomdok,'\0',sizeof(nomdok));
    memset(koment,'\0',sizeof(koment));
    metka_poi=0;
   }
 };

int dirzardk_prov(SQL_str row,class poi_dirzardk *poisk);
void dirzardk_poi(class poi_dirzardk *poisk);
void dirzardk_sap(class poi_dirzardk*);
int zapzardk(short dd,short md,short gd,const char *nomdok,int podr,const char *koment,short prn);
void dirzardk_ras(SQLCURSOR *cur,int kolstr,class poi_dirzardk *poisk);

extern short	startgodz; /*Стаpтовый год для расчета сальдо*/
extern char *organ;

void dirzardk()
{
long pozz=0,pozz1=0;
int  x=0,y=3; /*Точка начала вывода меню*/
int  kom=0,kom1=0;
int K=0;
SQLCURSOR cur;
SQL_str row;
SQLCURSOR cur1;
SQL_str row1;
char strsql[512];
int kolstr;
class iceb_t_mstr spis_menu(0);
short dn=1,mn=1,gn=startgodz;
short dk=0,mk=0,gk=0;
short dd,md,gd;
short d,m,g;
short dv=0,mv=0,gv=0; //Дата только что введённого документа
class iceb_tu_str nomdok_v(""); //номер документа только что введённого
short mspz; /*метка соответствия первой записи*/
int prc=0;
class iceb_tu_str nomdok("");
double suma_dok=0.;
class poi_dirzardk poisk;
char naim_podr[512];
short prn=0;

if(gn == 0)
 {
  poltekdat(&d,&m,&g);
  gn=g;
 }
VVOD MENU(3);

naz1:;
clear();

int             kls=LINES-y-3; /*Количество строк в окне*/

if(dk != 0)
  sprintf(strsql,"select * from Zardok where datd >='%04d-%02d-%02d' and \
datd <= '%04d-%02d-%02d' order by datd,nomd asc",gn,mn,dn,gk,mk,dk);
else
  sprintf(strsql,"select * from Zardok where datd >='%04d-%02d-%02d' order by datd,nomd asc",gn,mn,dn);


if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {

lll:;

   dirzardk_sap(&poisk);
 
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
    K=soobshw(&SOOB,stdscr,-1,-1,1,1);

    if(K == FK3 || K == SFK3 || K == FK5 || K == ENTER)
      goto lll;
    if(K == KEY_RESIZE)
     goto naz1;
           
    goto vper;

 }

if(dv != 0) //поиск только что введённого документа
 {
  poisk.metka_poi=0;
  int nomer_str=0;
  while(cur.read_cursor(&row) != 0)
   {
    rsdat(&d,&m,&g,row[1],2);
    if(sravmydat(d,m,g,dv,mv,gv) == 0  && SRAV(nomdok_v.ravno(),row[2],0) == 0)
     {
      pozz=nomer_str;
      break;
     }
    nomer_str++;
   }
 }
dv=mv=gv=0;
nomdok_v.new_plus("");

naz:;
GDITE();

if(kolstr != 0 && pozz > kolstr)
  pozz = kolstr-1;

cur.poz_cursor(pozz);
mspz=2;
pozz1=0;
int i;
spis_menu.spis_str.free_class();
char metka_zap[4];
for(i=0; i<kls ; )
 {
  if(cur.read_cursor(&row) == 0)
    break;


  pozz1++;

  if(dirzardk_prov(row,&poisk) != 0)
   continue;

  rsdat(&d,&m,&g,row[1],2);

  memset(naim_podr,'\0',sizeof(naim_podr));
  sprintf(strsql,"select naik from Podr where kod=%s",row[3]);
  if(readkey(strsql,&row1,&cur1) == 1)
   strncpy(naim_podr,row1[0],sizeof(naim_podr)-1);
  
  suma_dok=0.;
  //Узнаём сумму по документа
  sprintf(strsql,"select SUM(suma) from Zarp where datz='%s' and nd='%s'",row[1],row[2]);
  
  if(readkey(strsql,&row1,&cur1) == 1)
   {
    if(row1[0] != NULL)
     suma_dok=atof(row1[0]);
   }
  memset(metka_zap,'\0',sizeof(metka_zap));
  
  if(row[7][0] == '2')
   strcpy(metka_zap,"-");
  else
   strcpy(metka_zap,"+");  /*именно так потому что были документы 0 до доработки*/
   
  sprintf(strsql,"%02d.%02d.%04d|%-*s|%8.2f|%-4s|%s",d,m,g,
  iceb_tu_kolbait(4,row[2]),row[2],
  suma_dok,row[3],metka_zap);

  spis_menu.spis_str.plus(strsql);
  i++;


  if(pozz1 == 1) /*Первая запись удовлетворяет условиям поиска*/
   mspz=1;

 }

if(kom >= i)
  kom=i-1;

if(kom < 0)
 kom=0;

if(i <=kls-1)
  spis_menu.spis_str.plus(gettext("Конец списка"));
if(i == 0)
 {
  if(kolstr != 0 && pozz != 0)
   {
    //Если записи есть но не подходят по условиям поиска
    pozz--;
    goto naz;
   }
  goto lll;
 }



dirzardk_sap(&poisk);

prc=(pozz+pozz1)*100/kolstr;
memset(strsql,'\0',sizeof(strsql));
kom=spis_menu.menu(kom,y,x,NULL,strsql,prc,&K,"",0);

if(kom == -7) //Изменение размеров экрана
 goto naz1;
 
if(kom == -3) /*Стрелка вниз*/
 {
  if(i <kls)
   {
    beep();
    goto naz;
   }
  for(i=0; i< mspz   ; )
   {
    pozz++;
    if(pozz >= kolstr)
     {
      pozz=kolstr-1;
      break;
     }
    cur.poz_cursor(pozz);
    if(cur.read_cursor(&row) == 0)
      break;

    if(dirzardk_prov(row,&poisk) != 0)
     continue;

    i++;
   }
  kom=kls-1;
  goto naz;
 }
if(kom == -2) /*Стрелка вверх*/
 {
  GDITE();
  for(i=0; i < 1 ; )
   {

    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    cur.read_cursor(&row);


    if(dirzardk_prov(row,&poisk) != 0)
     continue;

    i++;
   }

  goto naz;
 }
 
if(kom == -5) /*Страница вниз*/
 {
  if(pozz + kls == kolstr)
   {
    pozz=kolstr-1;
    beep();
    goto naz;  
   }
  if(i == kls)
    pozz+=pozz1;
  else
    beep();
  if(pozz >= kolstr)
   {
    pozz=kolstr-pozz1;
    beep();
    goto naz;  
   }
/*  
  printw("\n вперед pozz=%d kolstr=%ld\n",pozz,kolstr);
  OSTANOV();
*/
  goto naz;

 }

if(kom == -4) /*Страница вверх*/
 {
/*
  printw("\npozz=%d\n",pozz);
  refresh();
*/
  GDITE();
  for(i=0; i<kls ; )
   {
    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    if(cur.read_cursor(&row) == 0)
      break;


    if(dirzardk_prov(row,&poisk) != 0)
     continue;

    i++;
   }
  goto naz;
 }

if(kom >= 0)
 {
  if(SRAV(gettext("Конец списка"),spis_menu.spis_str.ravno(kom),0) == 0)
     goto naz;
  if(pozz+kom >= kolstr)
   goto naz; /*Стали на конец списка*/

  polen(spis_menu.spis_str.ravno(kom),strsql,sizeof(strsql),1,'|');
  rsdat(&dd,&md,&gd,strsql,1);
  polen(spis_menu.spis_str.ravno(kom),&nomdok,2,'|');
  polen(spis_menu.spis_str.ravno(kom),metka_zap,sizeof(metka_zap),5,'|');
  prn=0;
  if(metka_zap[0] == '+')
   prn=1;
  if(metka_zap[0] == '-')
   prn=2;
      
 } 

vper:;

switch(K)
 {

  case ENTER:
   dirzardkz(prn,dd,md,gd,&nomdok);
   goto naz1;

  case ESC:
  case FK10:
    GDITE();
    return;

  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp2_11.txt");
   clear();
   if(kolstr > 0)
     goto naz;
   else
     goto lll;
     
  case PLU: //ввод нового документа
  case FK2: //ввод нового документа
  
  
    MENU.VVOD_delete();

    MENU.VVOD_SPISOK_add_MD(gettext("Ввод начислений"));
    MENU.VVOD_SPISOK_add_MD(gettext("Ввод удержаний"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 2 :
      case -1:
        goto naz;
    
      case 0 :
        prn=1;
        break;

      case 1 :
        prn=2;
        break;
     }
  
    dv=mv=gv=0;
    nomdok_v.new_plus("");  

    dirzardk_vvod(prn,&dv,&mv,&gv,&nomdok_v);

    poisk.metka_poi=0;

    goto naz1;

  case FK4: //поиск
    dirzardk_poi(&poisk);
    if(poisk.metka_poi == 1)
     {
      if(poisk.datan[0] != '\0')
        rsdat(&dn,&mn,&gn,poisk.datan,1);
      if(poisk.datak[0] != '\0')
        rsdat(&dk,&mk,&gk,poisk.datak,1);
     }
    pozz=0;
    goto naz1;


  case FK5: //печать
    dirzardk_ras(&cur,kolstr,&poisk);
    goto naz;
      
  default:
    if(kolstr > 0)
      goto naz;
    else
      goto lll;
 }

}
/**************/
/*Выдача шапки*/
/**************/

void dirzardk_sap(class poi_dirzardk *poisk)
{
int		Y,X;

move(0,0);
printw("%s",gettext("Просмотр списка нарядов"));

move(2,0);
printw("    1         2      3      4       5");

mvprintw(Y=1,X=COLS-20,gettext("Расшифровка полей:"));
mvprintw(++Y,X,"1-%s",gettext("дата"));
mvprintw(++Y,X,"2-%s",gettext("ном.док"));
mvprintw(++Y,X,"3-%s",gettext("сумма"));
mvprintw(++Y,X,"4-%s",gettext("код подразделения"));
mvprintw(++Y,X,"5-%s",gettext("наим.подразделения"));

if(poisk->metka_poi == 1)
 {
//  attron(A_BLINK);
  mvprintw(Y+=2,X,gettext("Поиск:"));
  if(poisk->datan[0] != '\0')
    mvprintw(++Y,X,"%s:%.12s",gettext("Дата п."),poisk->datan);
  if(poisk->datak[0] != '\0')
    mvprintw(++Y,X,"%s:%.12s",gettext("Дата к."),poisk->datak);
  if(poisk->nomdok[0] != '\0')
    mvprintw(++Y,X,"%s:%.12s",gettext("Документ"),poisk->nomdok);
  if(poisk->podr[0] != '\0')
    mvprintw(++Y,X,"%s:%.12s",gettext("Подр."),poisk->podr);
  if(poisk->koment[0] != '\0')
    mvprintw(++Y,X,"%s:%.12s",gettext("Комент."),poisk->koment);

//  attroff(A_BLINK);
  
 }


helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("ввод"),
"F4",gettext("поиск"),
"F10",gettext("выход"),NULL);
}




/**************************/
/*Ввод и корректировка документа*/
/********************************/
//Если вернули 0- записали 1-нет
int dirzardk_vvod(short prn,short *dd,short *md,short *gd,class iceb_tu_str *nomdk)
{
char strsql[512];
char naim[512];
short d,m,g;
SQLCURSOR cur;
SQL_str row;
static char dat1[11];
char podr_zap[20];
memset(podr_zap,'\0',sizeof(podr_zap));

VVOD VV(0);

VV.VVOD_SPISOK_add_data(11); //0 дата документа
VV.VVOD_SPISOK_add_data(10); //1 номер документа
VV.VVOD_SPISOK_add_data(10); //2 подразделение
VV.VVOD_SPISOK_add_data(100);//3 комментарий

if(nomdk->getdlinna() > 1)
 {
  sprintf(strsql,"select * from Zardok where nomd='%s' and datd='%04d-%02d-%02d'",nomdk->ravno(),*gd,*md,*dd);
  if(readkey(strsql,&row,&cur) != 1)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено запись для корректировки !"));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,1,1);
  
    return(1);
   }  
  rsdat(&d,&m,&g,row[1],2);
  sprintf(strsql,"%d.%d.%d",d,m,g);
  VV.data_plus(0,strsql);
  VV.data_plus(1,row[2]);
  VV.data_plus(2,row[3]);
  strncpy(podr_zap,row[3],sizeof(podr_zap)-1);
  VV.data_plus(3,row[4]);
    
//  int ktov=atoi(row[5]);
  time_t vrem=atol(row[6]);
    
  kzvz(atoi(row[5]),vrem,&VV);
 }
else
 {
  short dt,mt,gt;
  poltekdat(&dt,&mt,&gt);
  
  if(dat1[0] == '\0')
   sprintf(dat1,"%d.%d.%d",dt,mt,gt);
  VV.data_plus(0,dat1);

  sprintf(strsql,"%d",nomdok(gt,"Zardok"));
  VV.data_plus(1,strsql);
  
 }

VV.VVOD_SPISOK_add_MD(gettext("Дата документа....."));//0
VV.VVOD_SPISOK_add_MD(gettext("Номер документа...."));//1
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения.."));//2
VV.VVOD_SPISOK_add_MD(gettext("Коментарий........."));//3


naz:;
    

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("запись"),
"F3",gettext("подразделения"),
"F4",gettext("ном.док."),
"F10",gettext("выход"),NULL);


int kom=VV.vvod(0,1,1,-1,-1);

GDITE();
short ddv,mdv,gdv;

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp2_11_1.txt");
   goto naz;

  case FK2:
  case PLU:
     
    break;

  case FK3:
    memset(strsql,'\0',sizeof(strsql));
    memset(naim,'\0',sizeof(naim));
    
    if(vibrek("Podr",strsql,sizeof(strsql),naim) == 0)
     VV.data_plus(2,strsql);
    
    goto naz;

  case FK4: //получение нового номера документа
    if(rsdat(&ddv,&mdv,&gdv,VV.data_ravno(0),1) != 0)
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Неправильно введена дата !"));
      soobshw(&SOOB,stdscr,-1,-1,1,1);
      goto naz;
     }
    
    sprintf(strsql,"%d",nomdok(gdv,"Zardok"));
    VV.data_plus(1,strsql);
    goto naz;

  case FK10:
  case ESC:
    return(1);

  default:
   goto naz;
 }



if(rsdat(&ddv,&mdv,&gdv,VV.data_ravno(0),1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Неправильно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,1,1);
  goto naz;
 }

//проверяем вновь введённую дату
if(iceb_t_pbpds(mdv,gdv) != 0)
 goto naz;

if(*dd != 0)
 {
  //проверяем старую дату
  if(dirnuprovb(*md,*gd,0) != 0)
     goto naz;
 }
//проверяем подразделение
if(VV.data_ravno_atoi(2) != 0)
 {
  sprintf(strsql,"select kod from Podr where kod=%d",VV.data_ravno_atoi(2));
  if(readkey(strsql) != 1)
   {
     VVOD SOOB(1);
     sprintf(strsql,"%s %d !",gettext("Не найден код подразделения"),VV.data_ravno_atoi(2));
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
    }
 }
 
class lock_tables blok_tabl("LOCK TABLE Zardok WRITE,icebuser READ");
if(*gd != gdv || SRAV(nomdk->ravno(),VV.data_ravno(1),0) != 0 )
 {  
  //Проверяем можен документ с таким номером уже есть 
  sprintf(strsql,"select god from Zardok where nomd='%s' and god=%d",VV.data_ravno(1),gdv);
  if(readkey(strsql) > 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Документ с таким номером уже есть !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
 }

if(*dd == 0) //ввод новой записи
 {
  //фильтрование внутри подпрограммы
  if(zapzardk(ddv,mdv,gdv,VV.data_ravno(1),VV.data_ravno_atoi(2),VV.data_ravno(3),prn) != 0)
   goto naz;
 }
else //корректировка старой
 {
  time_t vrem;
  time(&vrem);
  
  char koment1[strlen(VV.data_ravno(3))*2];
  strcpy(koment1,VV.data_ravno(3));
  sqlfiltr(koment1,sizeof(koment1));
  
  sprintf(strsql,"update Zardok set \
god=%d,\
datd='%04d-%02d-%02d',\
nomd='%s',\
pd=%d,\
koment='%s',\
ktoi=%d,\
vrem=%ld,\
td=%d \
where god=%d and nomd='%s'",
  gdv,
  gdv,mdv,ddv,
  VV.data_ravno(1),
  VV.data_ravno_atoi(2),
  koment1,
  iceb_t_getuid(),
  vrem,
  prn,
  *gd,nomdk->ravno());  


  if(sql_zapis(strsql,0,0) != 0)
   goto naz;
  
  blok_tabl.unlock();
  
  //Корректируем записи в документе
  if(sravmydat(*dd,*md,*gd,ddv,mdv,gdv) != 0 || SRAV(nomdk->ravno(),VV.data_ravno(1),0) != 0 )
   {
    sprintf(strsql,"select datz,tabn,prn,knah,godn,mesn,podr,shet,nomz from Zarp where \
datz='%04d-%02d-%02d' and nd='%s' and prn='%d'", *gd,*md,*dd,nomdk->ravno(),prn);
    int kolstr=0;
    
    if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
        msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    if(kolstr > 0)
     while(cur.read_cursor(&row) != NULL)
      {

       for(int nomer=atoi(row[8]); nomer < 1000; nomer++)
        {          
         sprintf(strsql,"update Zarp set \
datz='%04d-%02d-%02d',\
nd='%s',\
nomz=%d \
where datz='%s' and tabn=%s and prn='%s' and knah=%s and godn=%s and mesn=%s \
and podr=%s and shet='%s' and nomz=%s",
         gdv,mdv,ddv,
         VV.data_ravno(1),
         nomer,
         row[0],row[1],row[2],row[3],row[4],row[5],row[6],row[7],row[8]);

         
         if(sql_zapis(strsql,1,1) == 0)
          break; 
        }

      }


   if(sravmydat(*dd,*md,*gd,ddv,mdv,gdv) != 0 ) //Корректируем проводки
    {
     //дата и номер документа уже изменены
     sprintf(strsql,"select distinct tabn from Zarp where datz='%04d-%02d-%02d' and nd='%s' and prn='%d'",
     gdv,mdv,ddv,VV.data_ravno(1),prn);

     if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
        msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
     if(kolstr > 0)
      {
       while(cur.read_cursor(&row) != 0)
        {          
         zarsoc(mdv,gdv,atoi(row[0]),NULL);
         zaravpr(atol(row[0]),mdv,gdv,NULL);
         if(*md != mdv || *gd != gdv)
          {
           zarsoc(*md,*gd,atoi(row[0]),NULL);
           zaravpr(atol(row[0]),*md,*gd,NULL);
          }
        }
      }         
    }

   }
 }
*dd=ddv;
*md=mdv;
*gd=gdv;
nomdk->new_plus(VV.data_ravno(1));
return(0);
}

/****************************/
/*Поиск*/
/***************************/
void dirzardk_poi(class poi_dirzardk *poisk)
{
short ddv,mdv,gdv;
char naim[512];

VVOD VV(0);

VV.data_sp_plus(poisk->datan,sizeof(poisk->datan));
VV.data_sp_plus(poisk->datak,sizeof(poisk->datak));
VV.data_sp_plus(poisk->nomdok,sizeof(poisk->nomdok));
VV.data_sp_plus(poisk->podr,sizeof(poisk->podr));
VV.data_sp_plus(poisk->koment,sizeof(poisk->koment));

VV.VVOD_SPISOK_add_ZAG(gettext("Поиск документов"));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала............."));//0
VV.VVOD_SPISOK_add_MD(gettext("Дата конца ............."));//1
VV.VVOD_SPISOK_add_MD(gettext("Номер документа........."));//2
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения.(,,).."));//3
VV.VVOD_SPISOK_add_MD(gettext("Коментарий.............."));//4


naz:;
    

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("пошук"),
"F3",gettext("подразделения"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);


int kom=VV.vvod(0,1,1,-1,-1);

GDITE();
strncpy(poisk->datan,VV.data_ravno(0),sizeof(poisk->datan)-1);
strncpy(poisk->datak,VV.data_ravno(1),sizeof(poisk->datak)-1);
strncpy(poisk->nomdok,VV.data_ravno(2),sizeof(poisk->nomdok)-1);
strncpy(poisk->podr,VV.data_ravno(3),sizeof(poisk->podr)-1);
strncpy(poisk->koment,VV.data_ravno(4),sizeof(poisk->koment)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp2_11_2.txt");
   goto naz;

  case FK2:
  case PLU:

    if(VV.data_ravno(0)[0] != '\0')
    if(rsdat(&ddv,&mdv,&gdv,VV.data_ravno(0),1) != 0)
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Неправильно введена дата начала !"));
      soobshw(&SOOB,stdscr,-1,-1,1,1);
      goto naz;
     }

    if(VV.data_ravno(1)[0] != '\0')
    if(rsdat(&ddv,&mdv,&gdv,VV.data_ravno(1),1) != 0)
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Неправильно введена дата конца !"));
      soobshw(&SOOB,stdscr,-1,-1,1,1);
      goto naz;
     }
    
    poisk->metka_poi=1;     
    return;

  case FK3:
    memset(naim,'\0',sizeof(naim));
    
    if(vibrek("Podr",poisk->podr,sizeof(poisk->podr),naim) == 0)
     VV.data_plus(3,poisk->podr);
    
    goto naz;

  case FK4:
    VV.VVOD_clear_data();
    goto naz;
    
  case FK10:
  case ESC:
    poisk->metka_poi=0;
    return;

  default:
   goto naz;
 }






}

/************************************/
/*Проверка на условия поиска*/
/****************************/

int dirzardk_prov(SQL_str row,class poi_dirzardk *poisk)
{
if(poisk->metka_poi == 0)
 return(0);
 
if(poisk->nomdok[0] != '\0')
  if(strstrm(row[2],poisk->nomdok) == 0)
        return(1);

if(poisk->koment[0] != '\0')
  if(strstrm(row[4],poisk->koment) == 0)
        return(1);

if(proverka(poisk->podr,row[3],0,0) != 0)
 return(1);

return(0);

}

/**************************/
/*распечатка списка нарядов*/
/**************************/
void dirzardk_ras(SQLCURSOR *cur,int kolstr,class poi_dirzardk *poisk)
{

FILE *ff;
char imaf[56];
sprintf(imaf,"snar%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }
zagolov(gettext("Распечатка списка документов"),0,0,0,0,0,0,organ,ff);


fprintf(ff,"\
-------------------------------------------------------------------\n");

fprintf(ff,gettext("\
Дата док. |Номер д.|  Сумма   |Код п.|Наименование подразделения\n"));
/*
1234567890 12345678 1234567890 123456
*/

fprintf(ff,"\
-------------------------------------------------------------------\n");

//fprintf(ff,"\x1B\x4D"); /*12-знаков*/
char naim_podr[50];
double suma_dok=0.;
char strsql[512];
SQL_str row;
SQL_str row1;
SQLCURSOR cur1;
short d,m,g;
int kolstr1=0;
double itogo=0.;
cur->poz_cursor(0);
while(cur->read_cursor(&row) != NULL)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(dirzardk_prov(row,poisk) != 0)
   continue;

  rsdat(&d,&m,&g,row[1],2);

  memset(naim_podr,'\0',sizeof(naim_podr));
  sprintf(strsql,"select naik from Podr where kod=%s",row[3]);
  if(readkey(strsql,&row1,&cur1) == 1)
   strncpy(naim_podr,row1[0],sizeof(naim_podr)-1);
  
  suma_dok=0.;
  //Узнаём сумму по документа
  sprintf(strsql,"select SUM(suma) from Zarp where datz='%s' and nd='%s'",row[1],row[2]);
  
  if(readkey(strsql,&row1,&cur1) == 1)
   {
    if(row1[0] != NULL)
     suma_dok=atof(row1[0]);
   }

  fprintf(ff,"%02d.%02d.%04d %-8s %10.2f %-6s %s\n",d,m,g,row[2],suma_dok,row[3],naim_podr);
  itogo+=suma_dok;
 }

fprintf(ff,"\
-------------------------------------------------------------------\n");

fprintf(ff,"\
%19s %10.2f\n",gettext("Итого"),itogo);

podpis(ff);
fclose(ff);

class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Распечатка спискa нарядов"));
iceb_t_ustpeh(imaf,3);
iceb_t_rabfil(&oth,"");

}


