/* $Id: dolhn1.c,v 5.14 2011-03-15 09:25:29 sasa Exp $ */
/*29.11.2010	11.03.2000	Белых А.И.	dolhn1.c
Поиск по табельному номеру нужной строки
Если вернули 0 строку нашли
             1 нет
*/

#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


int dolhn1(int tabn,//Табельный номер который ищем
double *oklad, //Найденный оклад
float *has,    //Количество часов в одном рабочем дне
float *kof,    //Коэффициент оплаты ставки
int *met,      //0-оклад 1-часовая ставка 2-тарифный розряд
int *koddo,    //Код должносного оклада
int *metka,    //0-нет метки 1-есть Метка пересчета на процент выполнения плана подразделением
int *metka1,   //0-расчет выполнять по отработанным часам 1-дням
class iceb_tu_str *shet,
int *metka_no,  /*0-оклад пересчитывается на отработанное время 1-нет*/
FILE *ff_prot)
{
int		tn;
char		bros[1024];
char		bros1[1024];
char strsql[1024];
int		i;
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
*metka_no=*koddo=*metka1=*metka=*met=0;
*oklad=*has=0.;
*kof=1.;

sprintf(strsql,"select str from Alx where fil='zardolhn.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Не найдены настройки zardolhn.alx\n");
  return(1);
 }
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;

  if(polen(row_alx[0],bros,sizeof(bros),1,'|')  == 0)
   {
    if(SRAV(bros,"Код должносного оклада",0) == 0)
     {
      polen(row_alx[0],bros,sizeof(bros),2,'|');
      *koddo=atoi(bros);
      continue;
     }


    tn=atoi(bros);
    if(tn == tabn)
     {
      polen(row_alx[0],bros,sizeof(bros),2,'|');
      i=strlen(bros);
      *oklad=ATOFM(bros);
       
      if(strstrm(bros,"Ч") == 1)
        *met=1;
//      if(bros[i-1] == 'Ч' || bros[i-1] == 'ч')
//	*met=1;

      if(bros[i-1] == 'r' || bros[i-1] == 'R')
	*met=2;

      memset(bros,'\0',sizeof(bros));
      polen(row_alx[0],bros,sizeof(bros),3,'|');

      if(bros[0] == '*')
       *metka_no=1;
      else
       {
        if(polen(bros,bros1,sizeof(bros1),1,'*') != 0)
         {
          *has=(float)ATOFM(bros);
          if(polen(bros,bros1,sizeof(bros1),2,':') == 0)
           {
            *has=(*has*60+ATOFM(bros1))/60;
           }
         }
        else
         {
          *has=(float)ATOFM(bros1);
          if(polen(bros,bros1,sizeof(bros1),2,':') == 0)
           {
            *has=(*has*60+ATOFM(bros1))/60;
           }
          polen(bros,bros1,sizeof(bros1),2,'*');
          *kof=(float)ATOFM(bros1);
         }
       }
      polen(row_alx[0],bros,sizeof(bros),4,'|');
      if(strstrm(bros,"*") == 1)
        *metka=1;
      if(strstrm(bros,"Д") == 1)
        *metka1=1;

      polen(row_alx[0],shet,5,'|');

      return(0);
     }

   }

 }

if(ff_prot != NULL)
 fprintf(ff_prot,"Не нашли настройку на табельный номер %d\n",tabn);
return(1);
}

