/* $Id: doocr.c,v 5.35 2011-01-13 13:43:22 sasa1 Exp $ */
/*16.12.2009	05.03.2001	Белых А.И.	doocr.c
Программа дооценки полученных материалов
Если вернули 0- дооценка сделана
             1-нет
*/
#include        <pwd.h>
#include        <math.h>
#include        <errno.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern double	okrcn;
extern short	vtara; /*Код группы возвратная тара*/

int doocr(short dd,short md,short gd,const char *nomdok,int skl,
short dr,short mr,short gr,double sumadoo,const char *osnov,const char *kodmat)
{
int		*nomkar; //Номера карточек
int		*kodm;  //Коды материалов
double		*kolih; //Количество материалла в документе
double		*kolihok; //Количество материалла в остатке на карточке
double		*suma;  //Сумма на количество остатка
double		sumai=0.;
int		kolstr;
SQL_str         row,row1;
char		strsql[512];
int		nomstr=0;
double		kolihdok=0;
double		kolihost=0;
char		kodopdooc[32];
int		prov1,prov2;
char		nomd1[32]; //Номер приходного документа
char		nomd2[32]; //Номер расходного документа
time_t		tmm;
char		kontr[32];
char		rnd[40];
char		nomz[112]; //номер заказа
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);

SQLCURSOR cur;
SQLCURSOR cur1;

GDITE();
clear();
memset(rnd,'\0',sizeof(rnd));

//sprintf(strsql,"%s",iceb_t_imafnsi("blokmak.alx"));
if(iceb_t_pbpds(mr,gr) != 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Дата %d.%dг. заблокирована !"),mr,gr);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

memset(kodopdooc,'\0',sizeof(kodopdooc));

//sprintf(strsql,"%s",iceb_t_imafnsi("matnast.alx"));
if(iceb_t_poldan("Код операции автоматической дооценки",kodopdooc,"matnast.alx") != 0)
 {
kkkk:;
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("В файле настройки не введен код операции автоматической дооценки !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
if(kodopdooc[0] == '\0')
  goto kkkk;

//Проверяем есть ли код операции в списке приходов и расходов
sprintf(strsql,"select prov from Prihod where kod='%s'",kodopdooc);
if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Не найден код %s в списке операций приходов !"),kodopdooc);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);

 }
prov1=atoi(row[0]);
sprintf(strsql,"select prov from Rashod where kod='%s'",kodopdooc);
if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Не найден код %s в списке операций расходов !"),kodopdooc);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);

 }

prov2=atoi(row[0]);

clear();
GDITE();

sprintf(strsql,"select nomkar,kodm,kolih,cena from Dokummat1 \
where datd='%04d-%02d-%02d' and sklad=%d and nomd='%s' and tipz=1 \
and nomkar != 0 and voztar=0  order by kodm asc",gd,md,dd,skl,nomdok);
//printw("\n%s\n",strsql);
//OSTANOV();
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

nomkar=new int[kolstr];
kodm=new int[kolstr];
kolih=new double[kolstr];
kolihok=new double[kolstr];
suma=new double[kolstr];
class ostatokt ost;
sprintf(strsql,"LOCK TABLES Kart READ,Zkart READ,Material READ,icebuser READ");
if(sql_zap(&bd,strsql) != 0)
 {
  msql_error(&bd,gettext("Ошибка блокировки таблицы !"),strsql);
  return(1);
 }

while(cur.read_cursor(&row) != 0)
 {
  if(proverka(kodmat,row[1],0,0) != 0)
    continue;    

  sprintf(strsql,"select kodgr from Material where kodm=%s",row[1]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
   if(vtara == atoi(row1[0]))
     continue;

  nomkar[nomstr]=atoi(row[0]);
  kodm[nomstr]=atoi(row[1]);
  kolihdok+=kolih[nomstr]=atof(row[2]);
  sumai+=suma[nomstr]=kolih[nomstr]*atof(row[3]);
  ostkar(1,1,gt,dt,mt,gt,skl,nomkar[nomstr],&ost);
  kolihost+=kolihok[nomstr]=ost.ostg[3];  
  
  nomstr++;
 }

if(kolihdok - kolihost > 0.009)
 {
  clearstr(LINES-1,0);

  VVOD DANET(1);

  DANET.VVOD_SPISOK_add_MD(gettext("Остаки на карточках не равны количеству в документе !"));

  sprintf(strsql,"%s:%d.%d.%d %s:%f != %s:%f",
  gettext("Дата"),
  dt,mt,gt,gettext("Документ"),
  kolihdok,gettext("Карточки"),kolihost);

  DANET.VVOD_SPISOK_add_MD(strsql);

  DANET.VVOD_SPISOK_add_MD(gettext("Сделать дооценку на остатки ?"));

  if(danet(&DANET,2,stdscr) == 2)
   {
    sprintf(strsql,"UNLOCK TABLES");
    if(sql_zap(&bd,strsql) != 0)
      msql_error(&bd,gettext("Ошибка разблокировки таблицы !"),strsql);
    return(1);
   }
 }

sprintf(strsql,"LOCK TABLES Dokummat WRITE,Dokummat1 WRITE,\
Dokummat2 WRITE,Kart WRITE,icebuser READ");
if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка блокировки таблицы !"),strsql);

//Определяем номера документов
char	sklad[20];
sprintf(sklad,"%d",skl);
nomnak(gr,sklad,nomd1,1,0,0);
nomnak(gr,sklad,nomd2,2,0,0);
sprintf(kontr,"00-%d",skl);

time(&tmm);

if(zap_s_mudok(1,dr,mr,gr,skl,kontr,nomd1,"",kodopdooc,0,prov1,nomd2,0,0,0,1) != 0)
 return(1);
if(zap_s_mudok(2,dr,mr,gr,skl,kontr,nomd2,"",kodopdooc,0,prov2,nomd1,0,0,0,1) != 0)
 return(1);

sprintf(strsql,"insert into Dokummat2 \
values (%d,%s,'%s',3,'%s %s')",gr,sklad,nomd1,nomdok,osnov);
sql_zap(&bd,strsql);


sprintf(strsql,"insert into Dokummat2 \
values (%d,%s,'%s',3,'%s %s')",gr,sklad,nomd2,nomdok,osnov);
sql_zap(&bd,strsql);

printw("nomd1=%s nomd2=%s\n",nomd1,nomd2);
refresh();

double	cena=0.;
double	kof=0.;
kof=(sumai+sumadoo)/sumai;
printw("kof=%f=(%.2f+%.2f)/%.2f\n",kof,sumai,sumadoo,sumai);
char shetu[20],ei[32],nds[10],mnds[10],krat[20];
int	nomk=0;
double cenakar=0.;
short denv=0,mesv=0,godv=0;
char innom[16];
innom[0]='\0';
short deng,mesg,godg;

//Формируем записи приходного документа
for(int i=0 ; i < kolstr ; i++)
 {
  printw("%4d %4d %8.8g %8.8g %8.8g\n",
  nomkar[i],kodm[i],kolih[i],kolihok[i],suma[i]);
  refresh();
  
  if(kolih[i] == 0. || suma[i] == 0.)
    continue;

  cena=(suma[i]*kof)/kolih[i];
  printw("cena=(%f*%f)/%f=%f\n",suma[i],kof,kolih[i],cena);
  cena=okrug(cena,okrcn);
  
  memset(shetu,'\0',sizeof(shetu));
  memset(ei,'\0',sizeof(ei));
  memset(nds,'\0',sizeof(nds));
  memset(mnds,'\0',sizeof(mnds));
  memset(krat,'\0',sizeof(krat));


  //  Читаем реквизиты карточки
  sprintf(strsql,"select shetu,ei,nds,krat,mnds,cena,innom,rnd,nomz,dat_god from \
Kart where sklad=%d and nomk=%d",skl,nomkar[i]);
  if(sql_readkey(&bd,strsql,&row,&cur1) != 1)
   {
    printw("Не нашли карточку %d на складе %d !\n",nomkar[i],skl);
    OSTANOV();
    continue;
   }

  strncpy(shetu,row[0],sizeof(shetu)-1);
  strncpy(ei,row[1],sizeof(ei)-1);
  strncpy(nds,row[2],sizeof(nds)-1);
  strncpy(krat,row[3],sizeof(krat)-1);
  strncpy(mnds,row[4],sizeof(mnds)-1);
  cenakar=atof(row[5]);
  cenakar=okrug(cenakar,okrcn);
  strncpy(innom,row[6],sizeof(innom)-1);
  strncpy(rnd,row[7],sizeof(rnd)-1);
  strncpy(nomz,row[8],sizeof(nomz)-1);
  rsdat(&deng,&mesg,&godg,row[9],2);
  
  //Проверяем может карточка с введенными уникальными реквизитами уже есть на складе
  sprintf(strsql,"select nomk from Kart where kodm=%d and sklad=%d \
  and shetu='%s' and cena=%.10g and ei='%s' and nds=%s and cenap=%.10g \
  and krat=%s and mnds=%s and dat_god='%04d-%02d-%02d'",
  kodm[i],skl,shetu,cena,ei,nds,0.,krat,mnds,godg,mesg,godg);

  /*
  printw("\n%s\n",strsql);
  OSTANOV();
  */
  if(sql_readkey(&bd,strsql,&row,&cur1) > 0)
   {
    nomk=atoi(row[0]);
    zapvdok(dr,mr,gr,skl,nomk,kodm[i],nomd1,kolih[i],cena,
    ei,atof(nds),atoi(mnds),0,1,nomkar[i],"",nomz);
   }
  else
   {
    nomk=nomkr(skl);
//    printw("nds=%s shbm=%s\n",nds,shetu);
//    refresh();
         
    if(zapkar(skl,nomk,kodm[i],cena,ei,shetu,atof(krat),0.,0,
    atof(nds),atoi(mnds),0.,denv,mesv,godv,innom,rnd,nomz,deng,mesg,godg,0) == 0)
      zapvdok(dr,mr,gr,skl,nomk,kodm[i],nomd1,kolih[i],cena,
      ei,atof(nds),atoi(mnds),0,1,nomkar[i],"",nomz);
   }

  //Формируем запись расходного документа
  zapvdok(dr,mr,gr,skl,nomkar[i],kodm[i],nomd2,kolih[i],cenakar,
  ei,atof(nds),atoi(mnds),0,2,nomk,"",nomz);

 }

sprintf(strsql,"UNLOCK TABLES");
if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка разблокировки таблицы !"),strsql);

delete [] nomkar;
delete [] kodm;
delete [] kolih;
delete [] kolihok;
delete [] suma;

VVOD SOOB(1);

sprintf(strsql,"%s: %s",
gettext("Номер расходного документа"),nomd2);
SOOB.VVOD_SPISOK_add_MD(strsql);

sprintf(strsql,"%s: %s",
gettext("Номер приходного документа"),nomd1);
SOOB.VVOD_SPISOK_add_MD(strsql);

soobshw(&SOOB,stdscr,-1,-1,0,1);

return(0);
}
