/*$Id: gosss.c,v 5.13 2011-02-04 11:32:38 sasa1 Exp $*/
/*30.12.2010	02.09.2009	Белых А.И.	gosss.c
Расчёт журнала-ордера со свёрнутым сальдо
*/
#include        <math.h>
#include        <time.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void buhmesshet(class SPISOK *mes,class masiv_din_double *mes_shet,class SPISOK *sheta,FILE *ff);
void gosss_rspsk(const char *shetg,const char *naim_shet,short dn,short mn,short gn,short dk,short mk,short gk,class SPISOK *mes_shet,class masiv_din_double *mes_deb,class masiv_din_double *mes_kre,double debs,double kres,double debp,double krep,char *imaf);
void gosss_itogoprov(double debs,double kres,double debp,double krep,double dendebet,double denkredit,int metka,int *kolstrok,int *nomlist,FILE *ff);
void gosss_sap_prov(int *nomlist,int *kolstrok,FILE *ff);
void gosss_shet_prov(int *kolstrok,int *nomlist,FILE *ff);
int  gosss_dni(const char *imaf_dni,const char *shet,const char *naim_shet,class SPISOK *den_shet_period,class SPISOK *sheta_deb,class SPISOK *sheta_kre,class masiv_din_double *den_shet_deb_suma,class masiv_din_double *den_shet_kre_suma,double debs,double kres,double debp,double krep,int metka_a3_a4);

extern char     *organ;
extern short	startgodb; /*Стартовый год*/
extern short	vplsh; /*0-двух уровневый план счетов 1-многоуровневый*/
extern int kol_strok_na_liste;

int gosss(const char *shet, //Номер счета
short dn,short mn,short gn,
short dk,short mk,short gk,
short vds,  //0-счет 1-субсчет
class spis_oth *oth)
{
static class iceb_tu_str max_kz("");
struct  tm      *bf;
int sub=0;
time_t tmmn;
int kolih_znak=0;
char shet_s_mdkz[32]; /*Cчёт с максимально-допустимым количеством знаков*/

short godn=startgodb;
if(startgodb == 0 || startgodb > gn)
 godn=gn;

clear(); /*Очистить экран и закрасить фоновым цветом*/

VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите режим"));

MENU.VVOD_SPISOK_add_MD(gettext("Расчитать по субсчетам"));
MENU.VVOD_SPISOK_add_MD(gettext("Расчитать по счетам"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

while(menu3w(stdscr,&MENU,&sub,-1,-1,0) != 0);
  
if(sub == 2 || sub == -1)
 return(1);

if(sub == 1)
 {
  
  int kom1=0;
  VVOD VVOD1(2);
  VVOD1.VVOD_SPISOK_add_MD(gettext("Введите максимальное количество знаков в номере счёта"));

  if((kom1=vvod1(&max_kz,8,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
   return(1);
  if(kom1 == ESC)
   return(1);    
  kolih_znak=max_kz.ravno_atoi();
  if(kolih_znak <= 0)
   {
    iceb_t_soob(gettext("Количество знаков не может быть нулевой!"));
    return(1);    
   }
 }



time(&tmmn);
bf=localtime(&tmmn);

clear();
GDITE();
char strsql[512];
SQL_str row,row1;
class SQLCURSOR cur,cur1;
/*Узнаём наименование счёта*/
class iceb_tu_str naim_shet("");
sprintf(strsql,"select nais from Plansh where ns='%s'",shet);
if(readkey(strsql,&row,&cur) == 1)
 naim_shet.new_plus(row[0]);

printw("%s %s\n",shet,naim_shet.ravno());
printw("%02d.%02d.%d -> %02d.%02d.%d\n",dn,mn,gn,dk,mk,gk);

int kolstr=0;
double debs=0.;
double kres=0.;
double debp=0.;
double krep=0.;


/*Узнаем начальное сальдо по счету*/

/*Отчет для многопорядкового плана счетов*/
if(vplsh == 1)
 sprintf(strsql,"select ns,deb,kre from Saldo where kkk='0' and gs=%d and \
ns like '%s%%'",godn,shet);

/*Отчет по субсчету двух-порядковый план счетов*/
if(vds == 1 && vplsh == 0)
 sprintf(strsql,"select ns,deb,kre from Saldo where kkk='0' and gs=%d and \
ns='%s'",godn,shet);

/*Отчет по счету двух-порядковый план счетов*/
if(vds == 0 && vplsh == 0)
 sprintf(strsql,"select ns,deb,kre from Saldo where kkk='0' and gs=%d and \
ns like '%s%%'",godn,shet);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
while(cur.read_cursor(&row) != 0)
 {
  debs+=atof(row[1]);
  kres+=atof(row[2]);
 }


printw("%s %.2f %.2f %d\n",gettext("Стартовое сальдо"),debs,kres,godn);

char imaf_prov[56];
sprintf(imaf_prov,"goprov%d.lst",getpid());
FILE *ff_prov;
if((ff_prov=fopen(imaf_prov,"w")) == NULL)
 {
  error_op_nfil(imaf_prov,errno,"");
  return(1);
 }

char imaf_prov_iden[56];
sprintf(imaf_prov_iden,"goprovi%d.lst",getpid());
FILE *ff_prov_iden;
if((ff_prov_iden=fopen(imaf_prov_iden,"w")) == NULL)
 {
  error_op_nfil(imaf_prov_iden,errno,"");
  return(1);
 }
zagolov(gettext("Расчет журнала-ордера по счету"),dn,mn,gn,dk,mk,gk,organ,ff_prov);
zagolov(gettext("Расчет журнала-ордера по счету"),dn,mn,gn,dk,mk,gk,organ,ff_prov_iden);

fprintf(ff_prov,"\n%s:%s %s\n",gettext("Счет"),shet,naim_shet.ravno());
fprintf(ff_prov_iden,"\n%s:%s %s\n",gettext("Счет"),shet,naim_shet.ravno());

int kolstr_prov_iden=5+2;
int kolstr_prov=5+2;
int kollist_prov=0;
int kollist_prov_iden=0;


gosss_sap_prov(&kollist_prov,&kolstr_prov,ff_prov);
gosss_sap_prov(&kollist_prov_iden,&kolstr_prov_iden,ff_prov_iden);

class SPISOK sheta_deb;
class SPISOK sheta_kre;

int kolih_mes_v_per=period(dn,mn,gn,dk,mk,gk,1);

class SPISOK den_shet[kolih_mes_v_per];
class masiv_din_double den_shet_deb[kolih_mes_v_per];
class masiv_din_double den_shet_kre[kolih_mes_v_per];


double deb=0.;
double kre=0.;
int kolstr1=0;
int kolih_den=period(1,1,godn,dk,mk,gk,0);
int nomer_den_shet=0;
int nomer_mes_shet=0;
int nomer_mes_v_per=-1;

char koment[512];
char naikon[512];

short d=1,m=1,g=godn;
int metka_perioda=0;
double ideb_den=0.;
double ikre_den=0.;
short den_zap=0;
short mes_zap=0;
char shet_zap[20];

printw("%s %s\n",gettext("Реестр проводок по счёту"),shet);
refresh();
while(sravmydat(d,m,g,dk,mk,gk) <= 0)
 {
  strzag(LINES-1,0,kolih_den,++kolstr1);
  
  
  //Для многопорядкового плана счетов
  if(vplsh == 1)
    sprintf(strsql,"select shk,kodkon,kto,nomd,oper,deb,kre,ktoi,komen from Prov \
where val=0 and datp = '%04d-%02d-%02d' and sh like '%s%%' order by shk asc",g,m,d,shet);

  /*Отчет по субсчету для двухпорядкового плана счетов*/
  if(vds == 1 && vplsh == 0)
    sprintf(strsql,"select shk,kodkon,kto,nomd,oper,deb,kre,ktoi,komen from Prov \
where val=0 and datp = '%04d-%02d-%02d' and sh='%s' order by shk asc",g,m,d,shet);

  /*Отчет по счету для двухпорядкового плана счетов*/
  if(vds == 0 && vplsh == 0)
    sprintf(strsql,"select shk,kodkon,kto,nomd,oper,deb,kre,ktoi,komen from Prov \
where val=0 and datp = '%04d-%02d-%02d' and sh like '%s%%' order by shk asc",g,m,d,shet);


  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    return(1);
   }

  if(sravmydat(d,m,g,dn,mn,gn) >= 0)
  if(mes_zap != m)
   {
    nomer_mes_v_per++;
    mes_zap=m;
   }            


  memset(shet_zap,'\0',sizeof(shet_zap));
  if(kolstr > 0)
  while(cur.read_cursor(&row) != 0)
   {
    deb=atof(row[5]);
    kre=atof(row[6]);
    
    if(sravmydat(d,m,g,dn,mn,gn) < 0) /*До периода*/
     {
      debs+=deb;
      kres+=kre;
     }
    else /*Период*/
     {
      if(metka_perioda == 0)
       {
        gosss_shet_prov(&kolstr_prov,&kollist_prov,ff_prov);
        gosss_shet_prov(&kolstr_prov_iden,&kollist_prov_iden,ff_prov_iden);
        if(debs > kres)
         {
          fprintf(ff_prov,"%*s:%10.2f\n",iceb_tu_kolbait(42,gettext("Сальдо начальное")),gettext("Сальдо начальное"),debs-kres);
          fprintf(ff_prov_iden,"%*s:%10.2f\n",iceb_tu_kolbait(42,gettext("Сальдо начальное")),gettext("Сальдо начальное"),debs-kres);
         }
        else
         {
          fprintf(ff_prov,"%*s:%10s %10.2f\n",iceb_tu_kolbait(42,gettext("Сальдо начальное")),gettext("Сальдо начальное")," ",kres-debs);
          fprintf(ff_prov_iden,"%*s:%10s %10.2f\n",iceb_tu_kolbait(42,gettext("Сальдо начальное")),gettext("Сальдо начальное")," ",kres-debs);
         }        
        metka_perioda=1;
       }

      if(den_zap != d)
       {
        if(den_zap != 0)
         gosss_itogoprov(debs,kres,debp,krep,ideb_den,ikre_den,1,&kolstr_prov_iden,&kollist_prov_iden,ff_prov_iden);
        ideb_den=ikre_den=0.;
        den_zap=d;
       }


      debp+=deb;
      krep+=kre;
      ideb_den+=deb;
      ikre_den+=kre;
      memset(shet_s_mdkz,'\0',sizeof(shet_s_mdkz));

      if(kolih_znak == 0)
       strncpy(shet_s_mdkz,row[0],sizeof(shet_s_mdkz));
      else
       sprintf(shet_s_mdkz,"%.*s",
       iceb_tu_kolbait(kolih_znak,row[0]),row[0]);
       
      sprintf(strsql,"%02d.%02d.%04d|%s",d,m,g,shet_s_mdkz);

      if(iceb_tu_srav_r(shet_zap,shet_s_mdkz,0) != 0) /*День не меняется*/
       {
        if((nomer_den_shet=den_shet[nomer_mes_v_per].find_r(strsql)) < 0)
         den_shet[nomer_mes_v_per].plus(strsql);

        den_shet_deb[nomer_mes_v_per].plus(deb,nomer_den_shet);      
        den_shet_kre[nomer_mes_v_per].plus(kre,nomer_den_shet);      
        if(nomer_den_shet < 0) /*Вообщето такого не может быть*/
         nomer_den_shet=den_shet[nomer_mes_v_per].kolih()-1; /*Нужен номер куда записало для дальнейшего использования*/
        strcpy(shet_zap,shet_s_mdkz);
       }
      else
       {
        den_shet_deb[nomer_mes_v_per].plus(deb,nomer_den_shet);      
        den_shet_kre[nomer_mes_v_per].plus(kre,nomer_den_shet);      
       }
       
//      sprintf(strsql,"%02d.%04d|%s",m,g,shet_s_mdkz);


      if(fabs(deb) > 0.009)
       {
        if(sheta_deb.find_r(shet_s_mdkz,sub) < 0)
         sheta_deb.plus(shet_s_mdkz);
       }
      else
       if(sheta_kre.find_r(shet_s_mdkz,sub) < 0)
        sheta_kre.plus(shet_s_mdkz);

      memset(naikon,'\0',sizeof(naikon));;
      if(row[1][0] != '\0')
       {  
        sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",row[1]);
        if(readkey(strsql,&row1,&cur1) == 1)
         strncpy(naikon,row1[0],sizeof(naikon)-1);
       }       

      sozkom(koment,sizeof(koment),row[8],row[2],row[4]);

      gosss_shet_prov(&kolstr_prov,&kollist_prov,ff_prov);

      fprintf(ff_prov,"%02d.%02d.%4d %-*s %-*s %-*s%*s %-*s %10s",
      d,m,g,
      iceb_tu_kolbait(6,row[0]),row[0],
      iceb_tu_kolbait(5,row[1]),row[1],
      iceb_tu_kolbait(3,row[2]),row[2],
      iceb_tu_kolbait(4,row[7]),row[7],
      iceb_tu_kolbait(10,row[3]),row[3],
      prnbr(deb));

      fprintf(ff_prov," %10s %s %-*s %s\n",prnbr(kre),row[4],iceb_tu_kolbait(32,koment),koment,naikon);

      gosss_shet_prov(&kolstr_prov_iden,&kollist_prov_iden,ff_prov_iden);

      fprintf(ff_prov_iden,"%02d.%02d.%4d %-*s %-*s %-*s%*s %-*s %10s",
      d,m,g,
      iceb_tu_kolbait(6,row[0]),row[0],
      iceb_tu_kolbait(5,row[1]),row[1],
      iceb_tu_kolbait(3,row[2]),row[2],
      iceb_tu_kolbait(4,row[7]),row[7],
      iceb_tu_kolbait(10,row[3]),row[3],
      prnbr(deb));

      fprintf(ff_prov_iden," %10s %s %-*s %s\n",prnbr(kre),row[4],iceb_tu_kolbait(32,koment),koment,naikon);
     }
     
   }



  dpm(&d,&m,&g,1);
 }

GDITE();

gosss_itogoprov(debs,kres,debp,krep,0.,0.,0,&kolstr_prov,&kollist_prov,ff_prov);
gosss_itogoprov(debs,kres,debp,krep,ideb_den,ikre_den,1,&kolstr_prov_iden,&kollist_prov_iden,ff_prov_iden);

fprintf(ff_prov,"\n%s_______________________\n",gettext("Главный бухгалтер"));
podpis(ff_prov);
fclose(ff_prov);

fprintf(ff_prov_iden,"\n%s___________________\n",gettext("Главный бухгалтер"));
podpis(ff_prov_iden);
fclose(ff_prov_iden);



int kolih_deb=sheta_deb.kolih();
int kolih_kre=sheta_kre.kolih();


class SPISOK den_shet_period;
d=dn;
m=mn;
g=gn;
while(sravmydat(d,m,g,dk,mk,gk) <= 0)
 {
  sprintf(strsql,"%02d.%02d.%04d",d,m,g);
  den_shet_period.plus(strsql);
  dpm(&d,&m,&g,1);
 }  

kolih_den=den_shet_period.kolih();

class masiv_din_double den_shet_deb_suma;
class masiv_din_double den_shet_kre_suma;

den_shet_deb_suma.make_class(kolih_den*kolih_deb);
den_shet_kre_suma.make_class(kolih_den*kolih_kre);


int nomer_den_shet_period=0;
int nomer_sheta=0;
char data[20];
char shet_d[20];
char messhet[32];
class SPISOK mes_shet;
class masiv_din_double mes_shet_deb;
class masiv_din_double mes_shet_kre;

for(nomer_mes_v_per=0; nomer_mes_v_per < kolih_mes_v_per; nomer_mes_v_per++)
for(int nomer_den_shet=0; nomer_den_shet < den_shet[nomer_mes_v_per].kolih(); nomer_den_shet++)
 {
  polen(den_shet[nomer_mes_v_per].ravno(nomer_den_shet),data,sizeof(data),1,'|');    
  polen(den_shet[nomer_mes_v_per].ravno(nomer_den_shet),shet_d,sizeof(shet_d),2,'|');    

  nomer_den_shet_period=den_shet_period.find(data);

  deb=den_shet_deb[nomer_mes_v_per].ravno(nomer_den_shet);
  kre=den_shet_kre[nomer_mes_v_per].ravno(nomer_den_shet);

  if((nomer_sheta=sheta_deb.find_r(shet_d)) >= 0)  
    den_shet_deb_suma.plus(deb,nomer_den_shet_period*kolih_deb+nomer_sheta);
  if((nomer_sheta=sheta_kre.find_r(shet_d)) >= 0)  
    den_shet_kre_suma.plus(kre,nomer_den_shet_period*kolih_kre+nomer_sheta);

   memset(messhet,'\0',sizeof(messhet));
   strcpy(messhet,&data[3]);

   
   sprintf(strsql,"%s|%s",messhet,shet_d);
   if((nomer_mes_shet=mes_shet.find_r(strsql)) < 0)
     mes_shet.plus(strsql);

   mes_shet_deb.plus(deb,nomer_mes_shet);      
   mes_shet_kre.plus(kre,nomer_mes_shet);      
 }


char imaf_dni[64];
sprintf(imaf_dni,"gpd%d.lst",getpid());

/*распечатка журнала на А4*/
gosss_dni(imaf_dni,shet,naim_shet.ravno(),&den_shet_period,&sheta_deb,&sheta_kre,&den_shet_deb_suma,&den_shet_kre_suma,debs,kres,debp,krep,0);

char imaf_dni_a3[64];
sprintf(imaf_dni_a3,"gpda%d.lst",getpid());

/*распечатка журнала на А3*/
gosss_dni(imaf_dni_a3,shet,naim_shet.ravno(),&den_shet_period,&sheta_deb,&sheta_kre,&den_shet_deb_suma,&den_shet_kre_suma,debs,kres,debp,krep,1);

/*Распечатка месячных итогов*/
/******************************************************************/


class SPISOK mes_shet_period;
d=dn;
m=mn;
g=gn;
while(sravmydat(d,m,g,dk,mk,gk) <= 0)
 {
  sprintf(strsql,"%02d.%04d",m,g);
  mes_shet_period.plus(strsql);
  dpm(&d,&m,&g,3);
 }  


class masiv_din_double mes_shet_deb_suma;
class masiv_din_double mes_shet_kre_suma;

int kolih_mes=mes_shet_period.kolih();
mes_shet_deb_suma.make_class(kolih_mes*kolih_deb);
mes_shet_kre_suma.make_class(kolih_mes*kolih_kre);
int nomer_mes_shet_period=0;

for(int nomer_mes_shet=0; nomer_mes_shet < mes_shet.kolih(); nomer_mes_shet++)
 {
  polen(mes_shet.ravno(nomer_mes_shet),data,sizeof(data),1,'|');    
  polen(mes_shet.ravno(nomer_mes_shet),shet_d,sizeof(shet_d),2,'|');    

  nomer_mes_shet_period=mes_shet_period.find(data);
  
  if((nomer_sheta=sheta_deb.find_r(shet_d)) >= 0)  
    mes_shet_deb_suma.plus(mes_shet_deb.ravno(nomer_mes_shet),nomer_mes_shet_period*kolih_deb+nomer_sheta);
  if((nomer_sheta=sheta_kre.find_r(shet_d)) >= 0)  
    mes_shet_kre_suma.plus(mes_shet_kre.ravno(nomer_mes_shet),nomer_mes_shet_period*kolih_kre+nomer_sheta);
 }



FILE *ff_mes;
char imaf_mes[56];
sprintf(imaf_mes,"gpdm%d.lst",getpid());
if((ff_mes = fopen(imaf_mes,"w")) == NULL)
 {
  error_op_nfil(imaf_mes,errno,"");
  return(1);
 }
fprintf(ff_mes,"\x1B%s\x1E\n","3"); /*Изменение межстрочного интервала*/

printw("%s %s\n",gettext("Месячные итоги по счёту"),shet);
refresh();


fprintf(ff_mes,"%s\n%s %s %s\n",organ,
gettext("Месячные итоги по счёту"),shet,naim_shet.ravno());

fprintf(ff_mes,"%s %s ",gettext("Оборот по дебету счета"),shet);

fprintf(ff_mes,"%s %d.%d.%d%s %s: %d:%d\n",
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);



buhmesshet(&mes_shet_period,&mes_shet_deb_suma,&sheta_deb,ff_mes);

fprintf(ff_mes,"\n%s %s \n",gettext("Оборот по кредиту счета"),shet);

buhmesshet(&mes_shet_period,&mes_shet_kre_suma,&sheta_kre,ff_mes);


podpis(ff_mes);
fclose(ff_mes);

printw("%s %s\n",gettext("Итоги по счетам корреспондентам для счёта"),shet);
refresh();
char imaf_shk[50];
gosss_rspsk(shet,naim_shet.ravno(),dn,mn,gn,dk,mk,gk,&mes_shet,&mes_shet_deb,&mes_shet_kre,debs,kres,debp,krep,imaf_shk);




/*На экран тоже самое*/

printw("\
                               %s           %s\n",
gettext("Дебет"),
gettext("Кредит"));
sprintf(strsql,"%s %02d.%02d.%d",gettext("Сальдо на"),dn,mn,gn);

int kolznak=iceb_tu_strlen(strsql);

deb=kre=0.;
if(debs >= kres)
 {
  deb=debs-kres;
  printw("%s:%15s\n",strsql,prnbr(deb));
 }
else
 {
  kre=kres-debs;
  printw("%s:%15s  %15s\n",strsql," ",prnbr(kre));
 }
int kolb=iceb_tu_kolbait(kolznak,gettext("Оборот за период"));
printw("%*s:%15s",kolb,gettext("Оборот за период"),prnbr(debp));

printw("  %15s\n",prnbr(krep));

printw("\
%*s:%15s",iceb_tu_kolbait(kolznak,gettext("Сальдо роз-нутое")),gettext("Сальдо роз-нутое"),prnbr(deb+debp));

printw("  %15s\n",prnbr(kre+krep));

sprintf(strsql,"%s %02d.%02d.%d",gettext("Сальдо на"),dk,mk,gk);
if(debs+debp >=  kres+krep)
 {
  deb=(debs+debp)-(kres+krep);
  printw("%s:%15s\n",strsql,prnbr(deb));
 }
else
 {
  kre=(kres+krep)-(debs+debp);
  printw("%s:%15s  %15s\n",strsql," ",prnbr(kre));
 }


oth->spis_imaf.plus(imaf_dni);
sprintf(strsql,"%s %s A4",gettext("Журнал-ордер по счёту"),shet);
oth->spis_naim.plus(strsql);

oth->spis_imaf.plus(imaf_dni_a3);
sprintf(strsql,"%s %s A3",gettext("Журнал-ордер по счёту"),shet);
oth->spis_naim.plus(strsql);

oth->spis_imaf.plus(imaf_mes);
sprintf(strsql,"%s %s",gettext("Месячные итоги по счёту"),shet);
oth->spis_naim.plus(strsql);

oth->spis_imaf.plus(imaf_shk);
sprintf(strsql,"%s %s",gettext("Итоги по счетам корреспондентам для счёта"),shet);
oth->spis_naim.plus(strsql);

oth->spis_imaf.plus(imaf_prov);
sprintf(strsql,"%s %s",gettext("Реестр проводок по счёту"),shet);
oth->spis_naim.plus(strsql);

oth->spis_imaf.plus(imaf_prov_iden);
sprintf(strsql,"%s %s",gettext("Реестр проводок с дневными итогами по счёту"),shet);
oth->spis_naim.plus(strsql);

for(int nomer=0; nomer < oth->spis_imaf.kolih(); nomer++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nomer),1);
 
printw_vr(tmmn);
OSTANOV();

return(0);
}


/***********************************/
/*Распечатка свода по счетам корреспондентам*/
/*******************************************/

void gosss_rspsk(const char *shetg,
const char *naim_shet,
short dn,short mn,short gn,
short dk,short mk,short gk,
class SPISOK *mes_shet,
class masiv_din_double *mes_deb,
class masiv_din_double *mes_kre,
double debs,
double kres,
double debp,
double krep,
char *imaf)
{
class SPISOK sheta;
class masiv_din_double deb;
class masiv_din_double kre;
char shet[32];
int nomer_sheta=0;
for(int nomer=0; nomer < mes_shet->kolih(); nomer++)
 {
  polen(mes_shet->ravno(nomer),shet,sizeof(shet),2,'|');
  if((nomer_sheta=sheta.find_r(shet)) < 0)
   sheta.plus(shet);
  deb.plus(mes_deb->ravno(nomer),nomer_sheta);
  kre.plus(mes_kre->ravno(nomer),nomer_sheta);
 }

sprintf(imaf,"spsk%d.lst",getpid());
FILE *ff;
if((ff=fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

zagolov(gettext("Расчет журнала-ордера по счету"),dn,mn,gn,dk,mk,gk,organ,ff);
fprintf(ff,"\n%s:%s %s\n",gettext("Счет"),shetg,naim_shet);

fprintf(ff,"\
--------------------------------------------------------------\n");
fprintf(ff,gettext("\
  Счет  |     Наименование счета       |  Дебет   | Кредит   |\n"));
fprintf(ff,"\
--------------------------------------------------------------\n");

if(debs > kres)
 {
  fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(39,gettext("Сальдо начальное")),gettext("Сальдо начальное"),debs-kres);
 }
else
 {
  fprintf(ff,"%*s:%10s %10.2f\n",iceb_tu_kolbait(39,gettext("Сальдо начальное")),gettext("Сальдо начальное"),"",kres-debs);
 }
SQL_str row;
class SQLCURSOR cur;
char strsql[512];
char naimshet[512];
for(int nomer=0; nomer < sheta.kolih(); nomer++)
 {
  sprintf(strsql,"select nais from Plansh where ns='%s'",sheta.ravno(nomer));
  memset(naimshet,'\0',sizeof(naimshet));
  if(sql_readkey(&bd,strsql,&row,&cur) == 1)
    strncpy(naimshet,row[0],sizeof(naimshet)-1);
  
  fprintf(ff,"%*s %-*.*s %10.2f %10.2f\n",
  iceb_tu_kolbait(8,sheta.ravno(nomer)),sheta.ravno(nomer),
  iceb_tu_kolbait(30,naimshet),iceb_tu_kolbait(30,naimshet),naimshet,
  deb.ravno(nomer),
  kre.ravno(nomer));      
  
  if(iceb_tu_strlen(naimshet) > 30)
   fprintf(ff,"%8s %s\n","",iceb_tu_adrsimv(30,naimshet));
 }

fprintf(ff,"\
--------------------------------------------------------------\n");

fprintf(ff,"%*s:%10.2f %10.2f\n",
iceb_tu_kolbait(39,gettext("Оборот за период")),gettext("Оборот за период"),debp,krep);

fprintf(ff,"%*s:%10.2f %10.2f\n",
iceb_tu_kolbait(39,gettext("Сальдо развернутое")),
gettext("Сальдо развернутое"),
debp+debs,krep+kres);

if(debs+debp > kres+krep)
 {
  fprintf(ff,"%*s:%10.2f\n",
  iceb_tu_kolbait(39,gettext("Сальдо свернутое")),
  gettext("Сальдо свернутое"),
  debs+debp-kres-krep);
 }  
else
 {
  fprintf(ff,"%*s:%10s %10.2f\n",
  iceb_tu_kolbait(39,gettext("Сальдо свернутое")),
  gettext("Сальдо свернутое"),
  " ",
  kres+krep-debs-debp);
 }

fprintf(ff,"\n%s_______________________\n",gettext("Главный бухгалтер"));


podpis(ff);


fclose(ff);

}
/*****************/
/*Шапка рапечатки*/
/*****************/

void gosss_sap_prov(int *nomlist,int *kolstrok,FILE *ff)
{

*nomlist+=1;
fprintf(ff,"%90s %s%d\n"," ",gettext("Лист N"),*nomlist);

fprintf(ff,"\
----------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("  Дата    |Сч.к-т|Конт.| Кто   |Номер док.|   Дебет  |  Кредит  |      К о м е н т а р и й       |Наименование контрагента|\n"));

fprintf(ff,"\
----------------------------------------------------------------------------------------------------------------------------------\n");
*kolstrok+=4;

}

/***************/
/*Счетчик строк*/
/***************/
void gosss_shet_prov(int *kolstrok,int *nomlist,FILE *ff)
{
*kolstrok+=1;
if(*kolstrok <= kol_strok_na_liste)
 return;

*kolstrok=1;
fprintf(ff,"\f");
gosss_sap_prov(nomlist,kolstrok,ff);

}

/***************/
/*Выдача итога*/
/**************/
void gosss_itogoprov(double debs,double kres,
double debp,double krep,
double dendebet,double denkredit,
int metka, //0-без дневного оборота
int *kolstrok,int *nomlist,
FILE *ff)
{

gosss_shet_prov(kolstrok,nomlist,ff);

fprintf(ff,"\
----------------------------------------------------------------------------------------------------------------------------------\n");
if(metka == 1)
 {
  gosss_shet_prov(kolstrok,nomlist,ff);
  fprintf(ff,"%*s:%10.2f %10.2f\n",iceb_tu_kolbait(42,gettext("Итого за день")),gettext("Итого за день"),
  dendebet,denkredit);
 }
gosss_shet_prov(kolstrok,nomlist,ff);

fprintf(ff,"%*s:%10.2f %10.2f\n",iceb_tu_kolbait(42,gettext("Оборот за период")),gettext("Оборот за период"),debp,krep);

double debet=debs+debp;
double kredit=kres+krep;

gosss_shet_prov(kolstrok,nomlist,ff);

fprintf(ff,"%*s:%10.2f %10.2f\n",
iceb_tu_kolbait(42,gettext("Сальдо развернутое")),gettext("Сальдо развернутое"),debet,kredit);

gosss_shet_prov(kolstrok,nomlist,ff);
if(debet > kredit)
 {
  fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(42,gettext("Сальдо свернутое")),gettext("Сальдо свернутое"),debet-kredit);
 }  
else
 {
  fprintf(ff,"%*s:%10s %10.2f\n",iceb_tu_kolbait(42,gettext("Сальдо свернутое")),gettext("Сальдо свернутое")," ",kredit-debet);
 }

gosss_shet_prov(kolstrok,nomlist,ff);
fprintf(ff,"\n");

}

/*******************************************/
/*Распечатка по дням*/
/******************************/
int  gosss_dni(const char *imaf_dni,
const char *shet,const char *naim_shet,
class SPISOK *den_shet_period,
class SPISOK *sheta_deb,
class SPISOK *sheta_kre,
class masiv_din_double *den_shet_deb_suma,
class masiv_din_double *den_shet_kre_suma,
double debs,
double kres,
double debp,
double krep,
int metka_a3_a4) /*0-a4 1-a3*/
{
struct  tm      *bf;
char strsql[512];
time_t tmmn;
time(&tmmn);

bf=localtime(&tmmn);


FILE *ff_dni;
//char imaf_dni[64];
//sprintf(imaf_dni,"gpd%d.lst",getpid());
if((ff_dni = fopen(imaf_dni,"w")) == NULL)
 {
  error_op_nfil(imaf_dni,errno,"");
  return(1);
 }
fprintf(ff_dni,"\x1B%s\x1E\n","3"); /*Изменение межстрочного интервала*/


printw("%s\n",gettext("Распечатка по дням"));
refresh();


fprintf(ff_dni,"%s\n%s %s %s\n",organ,
gettext("Журнал-ордер по счёту"),shet,naim_shet);

sprintf(strsql,"%s %s %s %d.%d.%d%s %s: %d:%d",
gettext("Оборот по дебету счета"),shet,
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);



buhdenshet(strsql,den_shet_period,sheta_deb,den_shet_deb_suma,metka_a3_a4,ff_dni);
podpis(ff_dni);

fprintf(ff_dni,"\f");

fprintf(ff_dni,"%s\n%s %s %s\n",organ,
gettext("Журнал-ордер по счёту"),shet,naim_shet);

sprintf(strsql,"%s %s %s %d.%d.%d%s %s: %d:%d",
gettext("Оборот по кредиту счета"),shet,
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

buhdenshet(strsql,den_shet_period,sheta_kre,den_shet_kre_suma,metka_a3_a4,ff_dni);


fprintf(ff_dni,"\
                           %s           %s\n",
gettext("Дебет"),
gettext("Кредит"));

if(debs >= kres)
 fprintf(ff_dni,"\
%*s:%15.2f\n",iceb_tu_kolbait(18,gettext("Сальдо начальное")),gettext("Сальдо начальное"),debs-kres);
else
  fprintf(ff_dni,"\
%*s:%15s  %15.2f\n",iceb_tu_kolbait(18,gettext("Сальдо начальное")),gettext("Сальдо начальное")," ",kres-debs);

fprintf(ff_dni,"\
%*s:%15.2f  %15.2f\n",iceb_tu_kolbait(18,gettext("Оборот за период")),gettext("Оборот за период"),debp,krep);

if(debs+debp >=  kres+krep)
  fprintf(ff_dni,"\
%*s:%15.2f\n",iceb_tu_kolbait(18,gettext("Сальдо конечное")),gettext("Сальдо конечное"),(debs+debp)-(kres+krep));
else
  fprintf(ff_dni,"\
%*s:%15s  %15.2f\n",iceb_tu_kolbait(18,gettext("Сальдо конечное")),gettext("Сальдо конечное")," ",(kres+krep)-(debs+debp));

fprintf(ff_dni,"\n%s________________  %s________________\n",
gettext("Главный бухгалтер"),
gettext("Исполнитель"));

fprintf(ff_dni,"\x1B\x32"); /*Межстрочный интервал 1/6 дюйма*/

fclose(ff_dni);
return(0);

}