/*$Id: i_admint.c,v 5.21 2011-08-29 07:08:59 sasa Exp $*/
/*07.09.2010	18.09.2009	Белых А.И.	i_admint.c
 Администриврование баз 
*/
#define DVERSIQ "10.08.2011"
#include <pwd.h>
#include <errno.h>
#include <glib.h>
#include        <locale.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void  i_admint_rb();
void crtabl(char *imabaz);
void i_admint_sd(char *host);
int admin_cp_alx(const char *from_alx,const char *to_alx);
void admin_alter();
void admin_newuser(const char *imabazr,const char *user);
void i_admin_infosys(int y,int x,const char *host,const char *verss,const char *dvers,short ddd,short mmm,short ggg,const char *imabaz,const char *nameprinter);

int dirduser();
int dirbaz();
class iceb_tu_str kzkb;
SQL_baza	bd;
extern char *putnansi;
extern int iceb_kod_podsystem;
extern int metka_utf8;
  
int main(int argc,char **argv,char **envp)
{
iceb_kod_podsystem=ICEB_PS_ABD;
char strsql[512];
int kom=0;
char login[32];
char rootparol[32];
char host[56];
memset(login,'\0',sizeof(login));
memset(rootparol,'\0',sizeof(rootparol));
memset(host,'\0',sizeof(host));
strcpy(host,"localhost");
kzkb.plus("koi8u");
metka_utf8=0;
if(strstrm(setlocale(LC_ALL,""),"utf") == 1)
 {
  kzkb.new_plus("utf8");
  metka_utf8=1;
 } 
(void)setlocale(LC_NUMERIC,"C"); //Переменная среды определяющая чем 
                                 //разделяется целая и дробная часть числа

init_screen();


/*Определяем путь на файлы настройки*/
if((putnansi=getenv("PUTNANSI")) == NULL)
 {
  int i=strlen(CONFIG_PATH)+1;
  if((putnansi=(char *)malloc(i*sizeof(char))) == NULL)
    iceb_t_soob("Не могу выделить пямять для пути !");
  else
    strcpy(putnansi,CONFIG_PATH);
 }  




VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Администрирование баз данных"));

sprintf(strsql,"%s %s %s",gettext("Версия"),gettext("от"),DVERSIQ);
VV.VVOD_SPISOK_add_ZAG(strsql);

VV.VVOD_SPISOK_add_MD(gettext("Введите логин................"));
VV.VVOD_SPISOK_add_MD(gettext("Хост на базу................."));
VV.VVOD_SPISOK_add_MD(gettext("Кодировка запросов к базе...."));
VV.VVOD_SPISOK_add_MD(gettext("Путь на настроечные файлы...."));

VV.VVOD_SPISOK_add_data(login,sizeof(login));
VV.VVOD_SPISOK_add_data(host,sizeof(host));
VV.VVOD_SPISOK_add_data(kzkb.ravno(),20);
VV.VVOD_SPISOK_add_data(putnansi,112);

naz:;

clear();
 
helstr(LINES-1,0,
//"F1",gettext("помощь"),
"F2/+","ввод",
"F4","очистить",
"F10","выход",NULL);

kom=VV.vvod(0,1,1,-1,-1);

move(LINES-1,0);

strcpy(login,VV.VVOD_SPISOK_return_data(0));
strcpy(host,VV.VVOD_SPISOK_return_data(1));
kzkb.new_plus(VV.VVOD_SPISOK_return_data(2));

//if(putnansi != NULL)
//  free(putnansi);
if((putnansi=(char *)malloc((strlen(VV.data_ravno(3))+1)*sizeof(char))) == NULL)
  iceb_t_soob("Не могу выделить пямять для пути !");
else
  strcpy(putnansi,VV.data_ravno(3));

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
//   prosf(strsql);
   goto naz;

  case ESC:
  case FK10:
    refresh();
    endwin();
    return(0);

  case FK2:
  case PLU:
     break;


  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }

VVOD PAROL(2);
PAROL.VVOD_SPISOK_add_ZAG(gettext("Введите пароль для доступа к базе данных mysql"));
if(vparol(&PAROL,rootparol,20,stdscr,-1,-1,1) != 0)
 goto naz;





if(mysql_init(&bd) == NULL)
 {
  msql_error(&bd,"Ошибка инициализации базы данных !","");
  endwin();
  exit(10);
 }

//printw("Связываемся с демоном базы.\n");
/*                                                   порт */
if(mysql_real_connect(&bd,host,login,rootparol,"mysql",0,NULL,0) == NULL)
/*                                                   именованій порт*/
 { 
  msql_error(&bd,"Ошибка установки связи с демоном базы !","");
  memset(rootparol,'\0',sizeof(rootparol));
  goto naz;
 } 

sprintf(strsql,"SET NAMES %s",kzkb.ravno());
sql_zap(&bd,strsql);

SQL_str row;
class SQLCURSOR cur;
class iceb_tu_str version("");
if(readkey("select VERSION()",&row,&cur) > 0)
 version.new_plus(row[0]);


VVOD MENU(4);

for(;;)
 {
  clear();

  MENU.VVOD_delete();

  MENU.VVOD_SPISOK_add_ZAG(gettext("Администрирование баз данных"));
  sprintf(strsql,"%s MySQL:%s %s/%d",gettext("Версия"),version.ravno(),kzkb.ravno(),metka_utf8);
  MENU.VVOD_SPISOK_add_ZAG(strsql);
   
  MENU.VVOD_SPISOK_add_MD(gettext("Разметить новую базу данных для iceB")); //0
  MENU.VVOD_SPISOK_add_MD(gettext("Разрешить доступ к базе данных"));     //1
  MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка разрешённых доступов к базе данных"));//2
  MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка существующих баз"));   //3
  MENU.VVOD_SPISOK_add_MD(gettext("Преобразование баз для новой версии системы"));//4
  MENU.VVOD_SPISOK_add_MD(gettext("Конец работы"));//5

  znak(0,COLS-26);
  i_admin_infosys(12,COLS-27,host,VERSION,DVERSIQ,0,0,0,"","");

  if(menu3(&MENU,&kom,1,0,0) != 0)
   continue;
   
  switch (kom)
   {

    case 5 :
    case -1 :
      exit_iceb(0);
      break;

    case 0:
      i_admint_rb();
      break;

    case 1:
      i_admint_sd(host);
      break;
    case 2:
      dirduser();
      break;
    case 3:
      dirbaz();
      break;

    case 4:
      admin_alter();
      break;

    default:
       kom=0;
       break;   
   }
 }
exit_iceb(0);





return(0);

}
/************************************/
/*Разметить базу*/
/*****************************/
void  i_admint_rb()
{
char imabaz[40];
char kodirovka[32];
class iceb_tu_str put_from_alx;
class iceb_tu_str put_to_alx;
class iceb_tu_str put_from_doc;

memset(imabaz,'\0',sizeof(imabaz));
memset(kodirovka,'\0',sizeof(kodirovka));
strcpy(kodirovka,"koi8u");
put_from_alx.plus(".");
put_from_alx.plus(G_DIR_SEPARATOR_S,"bx");

put_from_doc.plus(".");
put_from_doc.plus(G_DIR_SEPARATOR_S,"doc");

put_to_alx.plus(putnansi);

VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Разметить новую базу данных"));

VV.VVOD_SPISOK_add_MD(gettext("Имя базы........................................"));
VV.VVOD_SPISOK_add_MD(gettext("Кодировка хранения данных......................."));
VV.VVOD_SPISOK_add_MD(gettext("Каталог откуда импортировать настроечные файлы.."));
VV.VVOD_SPISOK_add_MD(gettext("Каталог откуда импортировать документацию......."));

VV.VVOD_SPISOK_add_data(imabaz,sizeof(imabaz));
VV.VVOD_SPISOK_add_data(kodirovka,sizeof(kodirovka));
VV.VVOD_SPISOK_add_data(put_from_alx.ravno(),112);
VV.VVOD_SPISOK_add_data(put_from_doc.ravno(),112);

naz:;

clear();
 
helstr(LINES-1,0,
//"F1",gettext("помощь"),
"F2/+",gettext("разметить"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

int kom=VV.vvod(0,1,1,-1,-1);

move(LINES-1,0);

strcpy(imabaz,VV.VVOD_SPISOK_return_data(0));
strcpy(kodirovka,VV.VVOD_SPISOK_return_data(1));
put_from_alx.new_plus(VV.data_ravno(2));
put_from_doc.new_plus(VV.data_ravno(3));
//put_to_alx.new_plus(VV.data_ravno(4));

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   /*Не выбрана база данных -негде взять файл с документацией*/
//   iceb_t_pdoc("admin1.txt");
   goto naz;

  case ESC:
  case FK10:
    return;

  case FK2:
  case PLU:
     break;


  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }

/*Проверяем возможность открытия настроечного файла*/   
class iceb_tu_str imafilprov(put_from_alx.ravno());
imafilprov.plus(G_DIR_SEPARATOR_S,"nastsys.alx");

FILE *ff;
if((ff = fopen(imafilprov.ravno(),"r")) == NULL)
 {
  error_op_nfil(imafilprov.ravno(),errno,gettext("Неправильно указан путь откуда брать настроечные файлы!"));
  goto naz;
 }
fclose(ff);

/*Проверяем возможность открытия файла с документацией*/   
imafilprov.new_plus(put_from_doc.ravno());
imafilprov.plus(G_DIR_SEPARATOR_S,"buhg.txt");

if((ff = fopen(imafilprov.ravno(),"r")) == NULL)
 {
  error_op_nfil(imafilprov.ravno(),errno,gettext("Неправильно указан путь на документацию!"));
  goto naz;
 }
fclose(ff);

/*Настроечные файлы теперь не устанавливаются в отдельный каталог*/
//admin_cp_alx(put_from_alx.ravno(),put_to_alx.ravno());

char strsql[512];


printw("Создаем базу данных\n");
if(kodirovka[0] == '\0')
  sprintf(strsql,"create database %s",imabaz);
else
 sprintf(strsql,"create database %s DEFAULT CHARACTER SET '%s'",imabaz,kodirovka);

if(sql_zapis(strsql,0,0) != 0)
 {
  if(sql_nerror(&bd) != ER_DB_CREATE_EXISTS) /*База уже есть*/
   goto naz;
 }


crtabl(imabaz); /*размечаем таблицы*/

/*Загружаем настроечные файлы*/
alxin(put_from_alx.ravno(),0,stdscr);
/*Загружаем документацию*/
printw("Загружаем документацию\n");
refresh();
docin(put_from_doc.ravno(),stdscr);

VVOD SOOB(1);
SOOB.VVOD_SPISOK_add_MD(gettext("Разметка базы данных закончена"));  
soobshw(&SOOB,stdscr,-1,-1,0,1);

}

/*********************************/
/*Создать доступ к базе данных*/
/*******************************/

void i_admint_sd(char *host)
{
char strsql[1024];
int par=0;
char parolpol[32];
char hostpol[80];
char imapol[32];
char dostup[8];
char imabaz[32];
int fk4=0;
VVOD VV(0);

VV.VVOD_SPISOK_add_data(sizeof(imapol));
VV.VVOD_SPISOK_add_data(sizeof(parolpol));
VV.VVOD_SPISOK_add_data(sizeof(imabaz));
VV.VVOD_SPISOK_add_data("localhost",sizeof(hostpol));
VV.VVOD_SPISOK_add_data(2);

VV.VVOD_SPISOK_add_ZAG(gettext("Установка полномочий для работы с базой данных"));

VV.VVOD_SPISOK_add_MD(gettext("Логин оператора..."));//0
VV.VVOD_SPISOK_add_MD(gettext("Пароль оператора.."));//1
VV.VVOD_SPISOK_add_MD(gettext("Имя базы.........."));//2
VV.VVOD_SPISOK_add_MD(gettext("Хост оператора...."));//3
VV.VVOD_SPISOK_add_MD(gettext("Доступ...(r,w)...."));//4

naz:;
clear();

fk4=0;

helstr(LINES-1,0,
"F1",gettext("помощь"),
"F2/+",gettext("установить"),
"F4",gettext("проверить"),
"F10",gettext("выход"),NULL);

par=VV.vvod(0,1,1,-1,-1);

switch(par)
 {
  case FK10:
  case ESC:
    return;
  case FK1:
   clear();
   printw("\n\n\
    Программа позволяет как ввести нового пользователя с нужными полномочиями,\n\
  так и перустановить пароль и права доступа для уже введенного\n\
  пользователя.\n\
    В реквизит \"Хост пользователя\" вводиться хост с которого пользователю\n\
  будет разрешен доступ к базе данных. База данных MySQL позволяет ввести\n\
  любое количество хостов, с которых пользователь может получить доступ к базе\n\
  данных.\n\
    Если вы вводите нового пользователя и хост пользователя не будет введен,\n\
  то пользователь получит доступ к базе с любого хоста.\n\
    При переустановке пароля или прав доступа должен быть обязательно правильно\n\
  введен хост, с которого пользователю уже разрешен доступ, иначе полномочия\n\
  не будут переустановлены.\n");

    
    OSTANOV();
   goto naz;
   
  case PLU:
  case FK2:
   break;

  case FK4: /*проверить есть ли введённый пользоватеть для введённой базы*/
    fk4=1;
    break;

  default:
    goto naz;     
 }

strncpy(imapol,VV.VVOD_SPISOK_return_data(0),sizeof(imapol)-1);
strncpy(parolpol,VV.VVOD_SPISOK_return_data(1),sizeof(parolpol)-1);
strncpy(imabaz,VV.VVOD_SPISOK_return_data(2),sizeof(imabaz)-1);
strncpy(hostpol,VV.VVOD_SPISOK_return_data(3),sizeof(hostpol)-1);
strncpy(dostup,VV.VVOD_SPISOK_return_data(4),sizeof(dostup)-1);

if(VV.VVOD_SPISOK_return_data(2)[0] == '\0')
 {
  iceb_t_soob(gettext("Не введено имя базы данных !"));  
  goto naz;     
 }
if(VV.VVOD_SPISOK_return_data(0)[0] == '\0')
 {
  iceb_t_soob(gettext("Не введен логин оператора!"));  
  goto naz;     
 }
/*проверяем существует ли база данных с таким именем*/
/****************
if(readkey(strsql) <= 0)
 {
  printw("\n%s\n",strsql);
  iceb_t_soob(gettext("Нет базы данных с таким именем!"));
  goto naz;
 }
****************/
SQL_str row;
int kolstr=0;
class SQLCURSOR cur;
sprintf(strsql,"show databases");
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
 }
int metka_nb=0;
if(kolstr > 0)
while(cur.read_cursor(&row) != 0)
 {
  if(SRAV(imabaz,row[0],0) == 0)
   {
    metka_nb=1;
    break;
   }
 }

if(metka_nb == 0)
 {
  iceb_t_soob(gettext("Нет базы данных с таким именем!"));
  goto naz;
 }

if(fk4 != 0)
 {
  
  sprintf(strsql,"select User from db where Db='%s' and User='%s'",imabaz,imapol);
  if(readkey(strsql) > 0) /*Запись уже есть*/
    iceb_t_soob(gettext("Такой логин для этой базы уже введён!"));
  else
    iceb_t_soob(gettext("Такого логина для этой базы ещё нет"));
  
  goto naz;
 }

if(VV.VVOD_SPISOK_return_data(1)[0] == '\0')
 {
  iceb_t_soob(gettext("Не введён пароль оператора !"));
  goto naz;     
 }

if(VV.VVOD_SPISOK_return_data(4)[0] == '\0')
 {
  iceb_t_soob(gettext("Не введён реквизит Доступ !"));  
  goto naz;     
 }

if(VV.VVOD_SPISOK_return_data(4)[0] != 'r' && \
VV.VVOD_SPISOK_return_data(4)[0] != 'w' && \
VV.VVOD_SPISOK_return_data(4)[0] != 'R' && \
VV.VVOD_SPISOK_return_data(4)[0] != 'W')
 {
  iceb_t_soob(gettext("Не правильный код доступа !"));
  goto naz;     
 }

int metka_ver=0;
sql_readkey(&bd,"select VERSION()",&row,&cur);
if(SRAV(row[0],"3.",1) != 0)
  metka_ver=1;  


sprintf(strsql,"select User from db where Db='%s' and User='%s' and \
Host='%s'",imabaz,imapol,host);
if(sql_readkey(&bd,strsql) > 0) /*Запись уже есть*/
 {
  
  if(parolpol[0] != '\0')
   {
     /****************
    Пароль переназначается для всех баз к которым у пользователя есть доступ
    Если нужно запретить пользователю работать с какойто из баз к которым у него 
    есть доступ, то нужно удалить соответствующюю запись в таблице db в базе mysql
    ******************/
    
    sprintf(strsql,"SET PASSWORD FOR %s@%s = PASSWORD('%s')",imapol,hostpol,parolpol);
    sql_zapis(strsql,1,0);
   }

  if(hostpol[0] != '\0')
   {
    if(dostup[0] == 'w')
     {
      if(metka_ver == 0)
        sprintf(strsql,"GRANT INSERT,SELECT,DELETE,UPDATE,CREATE,DROP ON \
%s.* TO '%s'@'%s'",imabaz,imapol,hostpol);
      if(metka_ver == 1)
        sprintf(strsql,"GRANT INSERT,SELECT,DELETE,UPDATE,CREATE,DROP,LOCK TABLES,CREATE TEMPORARY TABLES ON \
%s.* TO '%s'@'%s'",imabaz,imapol,hostpol);
     }
    if(dostup[0] == 'r')
      sprintf(strsql,"REVOKE INSERT,DELETE,UPDATE,CREATE,DROP ON \
%s.* FROM %s@%s",imabaz,imapol,hostpol);
   }
  else
   {
    if(dostup[0] == 'w')
     {
      if(metka_ver == 0)
        sprintf(strsql,"GRANT INSERT,SELECT,DELETE,UPDATE,CREATE,DROP ON \
%s.* TO '%s'",imabaz,imapol);
      if(metka_ver == 1)
        sprintf(strsql,"GRANT INSERT,SELECT,DELETE,UPDATE,CREATE,DROP,LOCK TABLES,CREATE TEMPORARY TABLES ON \
%s.* TO '%s'",imabaz,imapol);
     }
    if(dostup[0] == 'r')
      sprintf(strsql,"REVOKE INSERT,DELETE,UPDATE,CREATE,DROP ON \
%s.* FROM '%s'",imabaz,imapol);
   }
 }
else
 {
  if(hostpol[0] != '\0')
   {
    if(dostup[0] == 'w')
     {
      
      if(metka_ver == 0)
        sprintf(strsql,"GRANT INSERT,SELECT,DELETE,UPDATE,CREATE,DROP ON \
%s.* TO '%s'@'%s' IDENTIFIED BY '%s'",imabaz,imapol,hostpol,parolpol);
      if(metka_ver == 1)
        sprintf(strsql,"GRANT INSERT,SELECT,DELETE,UPDATE,CREATE,DROP,LOCK TABLES,CREATE TEMPORARY TABLES ON \
%s.* TO '%s'@'%s' IDENTIFIED BY '%s'",imabaz,imapol,hostpol,parolpol);
     }
    if(dostup[0] == 'r')
      sprintf(strsql,"GRANT SELECT ON \
%s.* TO '%s'@'%s' IDENTIFIED BY '%s'",imabaz,imapol,hostpol,parolpol);
   }
  else
   {
    if(dostup[0] == 'w')
     {
      if(metka_ver == 0)
       sprintf(strsql,"GRANT INSERT,SELECT,DELETE,UPDATE,CREATE,DROP ON \
%s.* TO '%s' IDENTIFIED BY '%s'",imabaz,imapol,parolpol);

      if(metka_ver == 1)
       sprintf(strsql,"GRANT INSERT,SELECT,DELETE,UPDATE,CREATE,DROP,LOCK TABLES,CREATE TEMPORARY TABLES ON \
%s.* TO '%s' IDENTIFIED BY '%s'",imabaz,imapol,parolpol);
     }
    if(dostup[0] == 'r')
      sprintf(strsql,"GRANT SELECT ON \
%s.* TO '%s' IDENTIFIED BY '%s'",imabaz,imapol,parolpol);
   }
  
 
 }
GDITE();
if(sql_zapis(strsql,1,1) == 0)
 {
  iceb_t_soob(gettext("Полномочия оператору установлены"));
  /*Записываем оператора в таблицу операторов если его там нет*/
  admin_newuser(imabaz,imapol);
 }
sql_zapis("FLUSH PRIVILEGES",1,1);

goto naz;

}

/****************************/
/******************************/
void i_admin_infosys(int y,int x,const char *host,const char *verss,
const char *dvers,short ddd,short mmm,short ggg,
const char *imabaz,const char *nameprinter)
{

struct  passwd  *ktor; /*Кто работает*/
pid_t	mypid;

ktor=getpwuid(getuid());

mypid=getpid();
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);

move(y=12,x=COLS-29);
if(ddd == 0 && mmm == 0 && ggg == 0)
 {
  printw("%s %d.%d.%d%s",gettext("Текущая дата"),dt,mt,gt,
  gettext("г."));
 }
else
 if(ddd != 0)
  {
   printw("%s %d.%d.%d%s",gettext("Текущая дата"),ddd,mmm,ggg,
   gettext("г."));
  }
 else
  printw("%s %d.%d%s",gettext("Текущая дата"),mmm,ggg,
  gettext("г."));

if(imabaz[0] != '\0')
 {
  move(++y,x);
  printw("%s%s",gettext("База:"),imabaz);
 }
move(++y,x);
printw("%s:%s",gettext("Хост"),host);

move(++y,x);
printw("%s:%d",gettext("Номер процесса"),mypid);

move(++y,x);
printw("%s:%d %s",gettext("Логин"),ktor->pw_uid,ktor->pw_name);

move(++y,x);
printw("%s:%-20.20s",gettext("Имя"),ktor->pw_gecos);

move(++y,x);
if(nameprinter != NULL)
 printw("%s:%-20.20s",gettext("Принтер"),nameprinter);
else
 printw("%s:%-20.20s",gettext("Принтер"),gettext("По умолчанию"));

move(y+=2,x);
//printw("copyright (c) %s 2010",gettext("Белых А.И."));
printw("copyright © %s 2010",gettext("Белых А.И."));

move(++y,x);
printw("%s/0432/512973",gettext("г. Винница т."));

move(++y,x);
printw("%s +380676654526",gettext("Мобиль. тел."));

move(++y,x);
//printw("www.iceb.vc.ukrtel.net");
printw("%s",ICEBSAIT);

mvprintw(LINES-1,0,"%s %s %s %s%s",gettext("Версия"),verss,
gettext("от"),dvers,
gettext("г."));

//move(LINES-1,x-2);
//printw("http://www.iceb.vinnitsa.com");

}
