/*$Id: impmatdok.c,v 5.49 2011-01-13 13:43:22 sasa1 Exp $*/
/*15.06.2010	06.07.2001	Белых А.И.	impmatdok.c
Импорт документов в материальный учет из файла
*/
#include        <errno.h>
#include        <math.h>
#include        <time.h>
#include        <sys/types.h>
#include        <sys/stat.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char     *organ;
extern double	okrcn;  /*Округление цены*/

void	impmatdok(void)
{
struct stat work;
char		strsql[512];
SQL_str		row,row1;
SQLCURSOR       cur1;
static class iceb_tu_str imafim("");
int		kom=0;
int		razmer=0;
FILE		*ff;
char		nomdok[32];
short		dd=0,md=0,gd=0;
char		strok[1024];
time_t 		tmm;
struct tm	*bf;
int		i;
int		tipz=0;
int		sklad=0;
char		kontr[32];
char		nomnalnak[32];
char		kodop[32];
char		nomvstdok[32];
int		koloh=0;
double		kolih,cena,nds;
int		vtara,ndsvkl;
int		kodmat;
char		eiz[32];
int		metkaproh=0; //метка номера прохода
char		naim[512];
int		nomz=0;
int		koldok=0;
char		naimat[512];
short		dpnn=0,mpnn=0,gpnn=0; //Дата выдачи налоговой накладной
char		shetu[32];
char		innom[32];
char		rnd[32]; //Регистрационный номер для медпрепаратов
char		nomzak[32]; //Номер заказа
struct OPSHET	shetv;

memset(innom,'\0',sizeof(innom));
memset(rnd,'\0',sizeof(rnd));
memset(shetu,'\0',sizeof(shetu));

VVOD VVOD1(2);
VVOD1.VVOD_SPISOK_add_ZAG(gettext("Импорт документов из файла"));
VVOD1.VVOD_SPISOK_add_MD(gettext("Введите имя файла с документами"));

naz:;

clear();

helstr(LINES-1,0,
"F1",gettext("помощь"),
"F2/+",gettext("загруз."),
"F3",gettext("просмотр"),
"F10",gettext("выход"),NULL);

if((kom=vvod1(&imafim,COLS-6,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
  return;
if(kom == ESC)
  return;

switch(kom)
 {
  case FK1:
    GDITE();
    iceb_t_pdoc("matu2_5.txt");
    clear();
    goto naz;

  case ENTER:
    if(imafim.ravno()[0] == '\0')
     {
      dirkatl(&imafim);
      goto naz;
     }
    break;

  case FK3:
   GDITE();
   if(stat(imafim.ravno(),&work) != 0)
    {
     VVOD SOOB(1);
     sprintf(strsql,"%s !",gettext("Нет такого файла"));
     SOOB.VVOD_SPISOK_add_MD(strsql);
     soobshw(&SOOB,stdscr,-1,-1,0,1);
     goto naz;
    }
    vizred(imafim.ravno());
    goto naz;

  default:
    goto naz;
 }


clear();
move(LINES-1,0);
GDITE();
time(&tmm);
bf=localtime(&tmm);

if(stat(imafim.ravno(),&work) != 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s !",gettext("Нет такого файла"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }



char kodiopuc[100];
int kodopuc=0; //Метка операции списания по учетной цене
//sprintf(strsql,"%s",iceb_t_imafnsi("matnast.alx"));
iceb_t_poldan("Коды операций расхода по учетным ценам",kodiopuc,"matnast.alx");


nazad:;


if((ff = fopen(imafim.ravno(),"r")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %d !",gettext("Ошибка окрытия файла"),errno);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }


if(metkaproh == 0)
 printw("%s\n",gettext("Проверяем записи в файле"));
if(metkaproh == 1)
 printw("\n\n%s\n\n",gettext("Загружаем документы из файла"));

razmer=0;
memset(nomdok,'\0',sizeof(nomdok));
koldok=0;
int kodusl=0;
while(fgets(strok,sizeof(strok),ff) != NULL)
 {
  i=strlen(strok);
  razmer+=i;
  if(strok[i-2] == '\r') //Возврат каректки меняем на пробел
   strok[i-2]=' ';

  printw("%s",strok);
  strzag(LINES-1,0,work.st_size,razmer);

  if(SRAV(strok,"DOC|",1) == 0)
   {
    if(koldok > 0 && metkaproh > 0 && nomdok[0] != '\0')
     {
      podtdok1(dd,md,gd,sklad,nomdok,tipz,dd,md,gd,1);
      podvdok(dd,md,gd,nomdok,sklad);
     }     
    koldok++;
    
    memset(nomdok,'\0',sizeof(nomdok));
    dd=md=gd=0;
    tipz=0;

    polen(strok,strsql,sizeof(strsql),2,'|');

    if(strsql[0] == '+')
      tipz=1;
    if(strsql[0] == '-')
      tipz=2;

    if(tipz == 0)
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Не определен вид документа (приход/расход) !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }

    polen(strok,strsql,sizeof(strsql),3,'|');
    if(rsdat(&dd,&md,&gd,strsql,1) != 0)
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата!"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }
    polen(strok,strsql,sizeof(strsql),4,'|');
    sklad=atoi(strsql);
    sprintf(strsql,"select kod from Sklad where kod=%d",sklad);
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не найден склад %d в списке складов !"),sklad);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }

    polen(strok,kontr,sizeof(kontr),5,'|');
    sprintf(strsql,"select kodkon from Kontragent where kodkon='%s'",
    kontr);
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s %s !",
      gettext("Не найден код контрагента"),
      kontr);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }


    polen(strok,nomnalnak,sizeof(nomnalnak),7,'|');

    if(tipz == 2 && nomnalnak[0] != '\0')
     {
      sprintf(strsql,"select datd,nomd from Dokummat where tip=%d and \
datd >= '%04d-01-01' and datd <= '%04d-12-31' and nomnn='%s'",
      tipz,gd,gd,nomnalnak);
      if(sql_readkey(&bd,strsql,&row1,&cur1) >= 1)
       {
        VVOD SOOB(1);
        sprintf(strsql,gettext("С номером %s налоговая накладная уже есть !"),nomnalnak);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        sprintf(strsql,"%s %s %s",gettext("Материальный учет"),row1[0],row1[1]);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        koloh++;
        continue;
       }

      sprintf(strsql,"select datd,nomd from Usldokum where tp=%d and \
datd >= '%04d-01-01' and datd <= '%04d-12-31' and nomnn='%s'",
      tipz,gd,gd,nomnalnak);
      if(sql_readkey(&bd,strsql,&row1,&cur1) >= 1)
       {
        VVOD SOOB(1);
        sprintf(strsql,gettext("С номером %s налоговая накладная уже есть !"),nomnalnak);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        sprintf(strsql,"%s %s %s",gettext("В учете услуг"),row1[0],row1[1]);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        koloh++;
        continue;
       }
     }

    polen(strok,kodop,sizeof(kodop),8,'|');
    if(tipz == 1)
      sprintf(strsql,"select kod from Prihod where kod='%s'",
      kodop);
    if(tipz == 2)
      sprintf(strsql,"select kod from Rashod where kod='%s'",
      kodop);

    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не найден код операции %s !"),
      kodop);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }

    polen(strok,nomvstdok,sizeof(nomvstdok),9,'|');

    dpnn=mpnn=gpnn=0;
    if(nomnalnak[0] != '\0')
     {
      polen(strok,strsql,sizeof(strsql),10,'|');
      
      if(strsql[0] != '\0')
       {
        if(rsdat(&dpnn,&mpnn,&gpnn,strsql,1) != 0)
         {
          VVOD SOOB(1);
          if(tipz == 1)
            sprintf(strsql,gettext("Не верно введена дата получения налоговой накладной !"));
          if(tipz == 2)
            sprintf(strsql,gettext("Не верно введена дата выдачи налоговой накладной !"));
          SOOB.VVOD_SPISOK_add_MD(strsql);
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          koloh++;
          continue;
         }
       }
      else
       {
        dpnn=dd; mpnn=md; gpnn=gd;
       }
     }

    
    //Номер документа определяем последним так как он является индикатором
    //наличия шапки документа
    polen(strok,nomdok,sizeof(nomdok),6,'|');
//  printw("***nomdok=%s %d\n",nomdok,metkaproh);
 
    sprintf(strsql,"select nomd from Dokummat where tip=%d and \
datd >= '%04d-01-01' and datd <= '%04d-12-31' and sklad=%d and nomd='%s'",
    tipz,gd,gd,sklad,nomdok);
    if(sql_readkey(&bd,strsql,&row,&cur1) >= 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("С номером %s документ уже есть !"),nomdok);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }

    //Запись в базу
    if(metkaproh != 0 && nomdok[0] != '\0')
     {
      zap_s_mudok(tipz,dd,md,gd,sklad,kontr,nomdok,nomnalnak,kodop,0,0,nomvstdok,dpnn,mpnn,gpnn,0);

     }        

   }

  //Строка записи в документе
  if(SRAV(strok,"ZP1|",1) == 0)
   {

    polen(strok,strsql,sizeof(strsql),2,'|');
    kodmat=atoi(strsql);    
    sprintf(strsql,"select kodm from Material where kodm=%d",kodmat);
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s %d !",gettext("Не найден код материалла"),kodmat);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }
    polen(strok,strsql,sizeof(strsql),3,'|');
    kolih=atof(strsql);
    if(kolih == 0)
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s !",gettext("В записи нулевое количество материалла"));
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }

    polen(strok,strsql,sizeof(strsql),4,'|');
    cena=atof(strsql);
    cena=okrug(cena,okrcn);

    polen(strok,eiz,sizeof(eiz),5,'|');
    sprintf(strsql,"select kod from Edizmer where kod='%s'",eiz);
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не найдено единицу измерения %s !"),eiz);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }

    polen(strok,strsql,sizeof(strsql),6,'|');
    vtara=atoi(strsql);

    polen(strok,strsql,sizeof(strsql),7,'|');
    nds=atof(strsql);

    polen(strok,strsql,sizeof(strsql),8,'|');
    ndsvkl=atoi(strsql);

    shetu[0]='\0';

    polen(strok,shetu,sizeof(shetu),9,'|'); //Для расходных документов не обязательный реквизит
    if(tipz == 1 || (tipz == 2  && shetu[0] != '\0'))
      if(prsh1(shetu,&shetv) != 0)
       {
        koloh++;
        continue;
       }

    polen(strok,nomzak,sizeof(nomzak),10,'|');
   
    if(metkaproh != 0 && nomdok[0] != '\0')
     {
//      printw("%d.%d.%d %d %d %s %.10g %.10g %s %f %d %d %d\n",
//      dd,md,gd,sklad,kodmat,nomdok,kolih,cena,eiz,nds,ndsvkl,vtara,tipz);      

      //Проверяем может такой код материалла уже есть в накладной
      if(tipz == 2)
       {
        //char bros[512];
        kodopuc=0;
        if(proverka(kodiopuc,kodop,0,1) == 0)
           kodopuc=1;  //Списание по учетной цене

        sprintf(strsql,"select kodm from Dokummat1 where tipz=%d and \
  datd >= '%04d-01-01' and datd <= '%04d-12-31' and sklad=%d and nomd='%s' \
  and kodm=%d",tipz,gd,gd,sklad,nomdok,kodmat);
        if(sql_readkey(&bd,strsql,&row,&cur1) > 0)
         {
          memset(naimat,'\0',sizeof(naimat)-1);
          sprintf(strsql,"select naimat from Material where kodm=%d",
          kodmat);
          if(sql_readkey(&bd,strsql,&row,&cur1) > 0)
            strncpy(naimat,row[0],sizeof(naimat)-1);

          VVOD SOOB(1);
          sprintf(strsql,"%s %d %s",
          gettext("Код материалла"),kodmat,naimat);
          SOOB.VVOD_SPISOK_add_MD(strsql);
          sprintf(strsql,gettext("Такая запись в документе уже есть !"));
          SOOB.VVOD_SPISOK_add_MD(strsql);
          sprintf(strsql,"%s N%s",gettext("Документ"),nomdok);
          SOOB.VVOD_SPISOK_add_MD(strsql);
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          continue;
         }
       }

      if(tipz == 1)      
       {
        zap_prihod(dd,md,gd,nomdok,sklad,kodmat,kolih,cena,eiz,shetu,nds,vtara,ndsvkl,nomzak,"");

       }

      if(tipz == 2)
       {
        priv_k_kart(dd,md,gd,nomdok,sklad,kodmat,kolih,cena,shetu,eiz,nds,ndsvkl,vtara,nomzak,kodopuc,"");
       }
     }
   }

  //Строка записи услуг
  if(SRAV(strok,"ZP2|",1) == 0)
   {
    polen(strok,eiz,sizeof(eiz),2,'|');
    sprintf(strsql,"select kod from Edizmer where kod='%s'",eiz);
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не найдено единицу измерения %s !"),eiz);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      koloh++;
      continue;
     }
    polen(strok,strsql,sizeof(strsql),3,'|');
    kolih=atof(strsql);

    polen(strok,strsql,sizeof(strsql),4,'|');
    cena=atof(strsql);
    cena=okrug(cena,okrcn);
    polen(strok,strsql,sizeof(strsql),5,'|');
    nds=atof(strsql);

    memset(naim,'\0',sizeof(naim));
    polen(strok,naim,sizeof(naim),6,'|');

    if(metkaproh != 0 && nomdok[0] != '\0')
     {
      sprintf(strsql,"insert into Dokummat3 (datd,sklad,nomd,ei,kolih,cena,nds,naimu,ktoi,vrem,ku)\
values ('%04d-%02d-%02d',%d,'%s','%s',%.10g,%.10g,%.10g,'%s',%d,%ld,%d)",
      gd,md,dd,sklad,nomdok,eiz,kolih,cena,nds,naim,
      iceb_t_getuid(),tmm,kodusl);
//      printw("%s\n",strsql);
      if(sql_zap(&bd,strsql) != 0)
        msql_error(&bd,gettext("Ошибка записи !"),strsql);
     }
   }

  //Строка записи дополнительной информации к документа
  if(SRAV(strok,"ZP3|",1) == 0)
   {
    polen(strok,strsql,sizeof(strsql),2,'|');
    nomz=atoi(strsql);
    if(nomz == 0)
      continue;    
    polen(strok,naim,sizeof(naim),3,'|');

    if(nomz == 8)
     {
      sprintf(strsql,"select kod from Foroplat where kod='%s'",naim);
      if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
       {
        VVOD SOOB(1);
        sprintf(strsql,gettext("Не найдена форма оплаты %s !"),naim);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        koloh++;
        continue;
       }

     }

    if(metkaproh != 0 && nomdok[0] != '\0')
     {
      sprintf(strsql,"insert into Dokummat2 \
values (%d,%d,'%s',%d,'%s')",
      gd,sklad,nomdok,nomz,naim);
//      printw("%s\n",strsql);
      if(sql_zap(&bd,strsql) != 0)
        msql_error(&bd,gettext("Ошибка записи !"),strsql);
     }    
   }
 }

fclose(ff);
if(koldok > 0 && metkaproh > 0 && nomdok[0] != '\0')
 {
  podtdok1(dd,md,gd,sklad,nomdok,tipz,dd,md,gd,1);
  podvdok(dd,md,gd,nomdok,sklad);
 }

if(koloh != 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s:%d",gettext("Количество ошибок"),koloh);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  sprintf(strsql,gettext("Импорт документов осуществляется если нет ни одной ошибки"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

if(koldok == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одного документа"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

if(metkaproh == 0)
 {
  metkaproh=1;
  goto nazad;
 }

VVOD SOOB(1);
sprintf(strsql,"%s",gettext("Загрузка завершена"));
SOOB.VVOD_SPISOK_add_MD(strsql);
sprintf(strsql,"%s:%d",gettext("Количество документов"),koldok);
SOOB.VVOD_SPISOK_add_MD(strsql);
soobshw(&SOOB,stdscr,-1,-1,0,1);

}
