/*$Id: impprov.c,v 5.21 2011-01-13 13:43:22 sasa1 Exp $*/
/*17.11.2008	10.07.2002	Белых А.И.	impprov.c
Импорт проводок из файла в "Главную книгу"
*/
#include        <errno.h>
#include        <math.h>
#include        <time.h>
#include        <sys/types.h>
#include        <sys/stat.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char     *organ;
extern char	*imabaz;

void	impprov(void)
{
struct stat work;
char		strsql[512];
static iceb_tu_str imafim("");
static char	imafprom[40];
int		kom=0;
int		razmer=0;
FILE		*ff,*ffprom;
char		strok[1024];
char		bros[512];
time_t 		tmm;
struct tm	*bf;
int		i;
struct OPSHET	shetv;
int kekv=0;

VVOD VVOD1(2);
VVOD1.VVOD_SPISOK_add_ZAG(organ);
VVOD1.VVOD_SPISOK_add_ZAG(gettext("Импорт проводок из файла"));
VVOD1.VVOD_SPISOK_add_MD(gettext("Введите имя файла"));

naz:;

clear();

helstr(LINES-1,0,
"F1",gettext("помощь"),
"F2/+",gettext("загруз."),
"F3",gettext("просмотр"),
"F10",gettext("выход"),NULL);

if((kom=vvod1(&imafim,COLS-6,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
  return;
if(kom == ESC)
  return;

switch(kom)
 {
  case FK1:
    GDITE();
    iceb_t_pdoc("buhg3_5.txt");
    clear();
    goto naz;

  case ENTER:
  case FK2:
  case PLU:
    if(imafim.getdlinna() <= 1)
     {
      dirkatl(&imafim);
      goto naz;
     }
    break;

  case FK3:
   GDITE();
   if(stat(imafim.ravno(),&work) != 0)
    {
     VVOD SOOB(1);
     sprintf(strsql,"%s !",gettext("Нет такого файла"));
     SOOB.VVOD_SPISOK_add_MD(strsql);
     soobshw(&SOOB,stdscr,-1,-1,0,1);
     goto naz;
    }
    vizred(imafim.ravno());
    goto naz;

  default:
    goto naz;
 }


clear();
move(LINES-1,0);
GDITE();
time(&tmm);
bf=localtime(&tmm);

if(stat(imafim.ravno(),&work) != 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s !",gettext("Нет такого файла"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }


if((ff = fopen(imafim.ravno(),"r")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s:%d !",
  gettext("Ошибка окрытия файла"),imafim.ravno(),errno);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
sprintf(imafprom,"prom%d.tmp",getpid());
if((ffprom = fopen(imafprom,"w")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s:%d !",
  gettext("Ошибка окрытия файла"),imafprom,errno);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

int  val=0;
short d,m,g;
char  shet[32];
char  shetk[30];
char  kontrsh[30];
char  kontrshk[30];
time_t  vrem;
double  deb=0.,kre=0.;
char	koment[512];

int  kolprov=0;
razmer=0;
while(fgets(strok,sizeof(strok),ff) != NULL)
 {
  i=strlen(strok);
  razmer+=i;
  if(strok[i-2] == '\r') //Возврат каретки меняем на пробел
   strok[i-2]=' ';

  printw("%s",strok);
  strzag(LINES-1,0,work.st_size,razmer);

  if(polen(strok,bros,sizeof(bros),1,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }

  if(bros[0] == '\0')
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }

  val=atoi(bros);
  if(val != 0 && val != -1)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не правильная метка проводки !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    fprintf(ffprom,"%s",strok);
    continue;

   }
  //Берем дату проводки
  if(polen(strok,bros,sizeof(bros),2,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }
  if(rsdat(&d,&m,&g,bros,1) != 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата проводки !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    fprintf(ffprom,"%s",strok);
    continue;
   }
  if(iceb_t_pvglkni(m,g) != 0)
   continue;


  //Берем счет
  if(polen(strok,shet,sizeof(shet),3,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }

  if(prsh1(shet,&shetv) != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }
  memset(kontrsh,'\0',sizeof(kontrsh));
  if(shetv.saldo == 3)
   { 
    if(polen(strok,kontrsh,sizeof(kontrsh),4,'|') != 0)
     {
      fprintf(ffprom,"%s",strok);
      continue;
     }
    //Проверяем введен ли этот контрагент в список счета
    sprintf(strsql,"select kodkon from Skontr where ns='%s' and \
kodkon='%s'",shet,kontrsh);
    if(sql_readkey(&bd,strsql) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не найден код контрагента %s в списке счета %s !"),
      kontrsh,shet);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      fprintf(ffprom,"%s",strok);
      continue;
     }
   }

  if(val == 0)
   {     
    //Берем счет корреспондент     
    if(polen(strok,shetk,sizeof(shetk),5,'|') != 0)
     {
      fprintf(ffprom,"%s",strok);
      continue;
     }

    if(prsh1(shetk,&shetv) != 0)
     {
      fprintf(ffprom,"%s",strok);
      continue;
     }
    memset(kontrshk,'\0',sizeof(kontrshk));

    if(shetv.saldo == 3)
     { 
      if(polen(strok,kontrshk,sizeof(kontrshk),6,'|') != 0)
       {
        fprintf(ffprom,"%s",strok);
        continue;
       }
      //Проверяем введен ли этот контрагент в список счета
      sprintf(strsql,"select kodkon from Skontr where ns='%s' and \
kodkon='%s'",shetk,kontrshk);
      if(sql_readkey(&bd,strsql) != 1)
       {
        VVOD SOOB(1);
        sprintf(strsql,gettext("Не найден код контрагента %s в списке счета %s !"),
        kontrshk,shetk);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        fprintf(ffprom,"%s",strok);
        continue;
       }
     }
   }

  //Берем дебет     
  if(polen(strok,bros,sizeof(bros),7,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }
  deb=atof(bros);

  //Берем кредит     
  if(polen(strok,bros,sizeof(bros),8,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }
  kre=atof(bros);

  if(deb+kre == 0.)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не введен ни дебет ни кредит !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    fprintf(ffprom,"%s",strok);
    continue;
   }

  if( deb != 0. && kre != 0.)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Введен и дебет и кредит !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    fprintf(ffprom,"%s",strok);
    continue;
   }

  //Берем комментарий
  if(polen(strok,koment,sizeof(koment),9,'|') != 0)
   {
    fprintf(ffprom,"%s",strok);
    continue;
   }

  time(&vrem);
  kolprov++;
  zapprov(val,g,m,d,shet,shetk,kontrsh,kontrshk,"","","",deb,kre,koment,2,0,vrem,0,0,0,0,kekv);
  

 }

fclose(ff);
fclose(ffprom);
unlink(imafim.ravno());

rename(imafprom,imafim.ravno());

VVOD SOOB(1);
SOOB.VVOD_SPISOK_add_MD(gettext("Загрузка завершена"));
sprintf(strsql,"%s:%d",gettext("Количество загруженых проводок"),kolprov);
SOOB.VVOD_SPISOK_add_MD(strsql);
soobshw(&SOOB,stdscr,-1,-1,0,1);

}
