/* $Id: kasoth.c,v 5.20 2011-01-13 13:43:22 sasa1 Exp $ */
/*31.10.2009	07.10.2000	Белых А.И.	kasoth.c
Распечатка списка ордеров за любой период времени
*/
#include        <errno.h>
#include        <time.h>
#include        "buhg.h"

int kasothr(short,short,short,short,short,short,char[],char[],char[],char[],char[],class spis_oth*);
int kasothr1(short,short,short,short,short,short,char[],char[],char[],char[],char*,class spis_oth*);


int kasoth(int metka,class spis_oth *oth)
{
static char	dat1[11];
static char	dat2[11];
static char	shet[112];
static char	kassa[112];
static char	kodop[112];
static char	vpr[4];
static char kontr[112];
int		kom,kom1;
char		naimp[512];
short		dn,mn,gn,dk,mk,gk;

VVOD MENU(3);
VVOD VV(0);
if(metka == 0)
 VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка списка кассовых ордеров"));
if(metka == 1)
 VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка свода по операциям"));

VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(dat2,11);
VV.VVOD_SPISOK_add_data(kassa,sizeof(kassa));
VV.VVOD_SPISOK_add_data(kodop,sizeof(kodop));
VV.VVOD_SPISOK_add_data(shet,sizeof(shet));
VV.VVOD_SPISOK_add_data(vpr,2);
VV.VVOD_SPISOK_add_data(kontr,sizeof(kontr));


VV.VVOD_SPISOK_add_MD(gettext("Дата начала..(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца...(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Код кассы....(,,)....."));
VV.VVOD_SPISOK_add_MD(gettext("Код операции.(,,)....."));
VV.VVOD_SPISOK_add_MD(gettext("Счет.........(,,)....."));
VV.VVOD_SPISOK_add_MD(gettext("Приход/расход.(+/-)..."));
VV.VVOD_SPISOK_add_MD(gettext("Код контрагента (,,).."));

naz:;
clear(); 

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(kassa,VV.VVOD_SPISOK_return_data(2),sizeof(kassa)-1);
strncpy(kodop,VV.VVOD_SPISOK_return_data(3),sizeof(kodop)-1);
strncpy(shet,VV.VVOD_SPISOK_return_data(4),sizeof(shet)-1);
strncpy(vpr,VV.VVOD_SPISOK_return_data(5),sizeof(vpr)-1);
strncpy(kontr,VV.VVOD_SPISOK_return_data(6),sizeof(kontr)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("kas4_1.txt");
   goto naz;

  case FK10:
  case ESC:
   return(1);

  case FK5:
  case FK2:
  case PLU:
   break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка касс"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций приходов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций расходов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка контрагентов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;   
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 5 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Kas",kassa,sizeof(kassa),naimp);      
        VV.VVOD_SPISOK_zapis_data(2,kassa);
        goto naz;

      case 1 :
        vibrek("Kasop1",kodop,sizeof(kodop),naimp);      
        VV.VVOD_SPISOK_zapis_data(3,kodop);
        goto naz;

      case 2 :
        vibrek("Kasop2",kodop,sizeof(kodop),naimp);      
        VV.VVOD_SPISOK_zapis_data(3,kodop);
        goto naz;
      
      case 3 :
        vibrek("Plansh",shet,sizeof(shet),naimp);      
        VV.VVOD_SPISOK_zapis_data(4,shet);
        goto naz;

      case 4 :
        vibrek("Kontragent",kontr,sizeof(kontr),naimp);      
        VV.VVOD_SPISOK_zapis_data(6,kontr);
        goto naz;
      
     }

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
    goto naz;
 }

if(rsdatp(&dn,&mn,&gn,VV.VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
 goto naz;

clear();

if(metka == 0)
 return(kasothr(dn,mn,gn,dk,mk,gk,kassa,kodop,shet,vpr,kontr,oth));

if(metka == 1)
 return(kasothr1(dn,mn,gn,dk,mk,gk,kassa,kodop,shet,vpr,kontr,oth));

return(1);

}
