/* $Id: kasothr.c,v 5.56 2011-01-13 13:43:22 sasa1 Exp $ */
/*10.06.2010	07.10.2000	Белых А.И.	kasothr.c
Распечатка списка кассовых ордеров
*/
#include        <time.h>
#include        <errno.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif
#define		KOLSTRHAP 9 //Количество строк в шапке

void	sapkasord(short,short,short,int,const char *zagolov,FILE*);
void   hgrkd(FILE *ff);
void kasothr_ss(int metka,short dd,short md,short gd,int *nomlist,int *kolstr,double itpri,double itras,FILE *ffva,FILE *ffok,FILE *ff_prot);

extern char	*organ;
extern int kol_strok_na_liste;

int kasothr(short dn,short mn,short gn,//Дата начала
short dk,short mk,short gk, //Дата конца
char kassa[],char kodop[],char shet[],char vpr[],char *kod_kontr,
class spis_oth *oth)
{
FILE *ff_prot=NULL;
char imaf_prot[32];
FILE            *ff,*ffva,*ffok,*ff2;
char		imaf[32],imaf1[32],imafok[32],imaf2[32];
SQL_str		row,row1;
int		kolstr,kolstr1;
char		strsql[512];
struct  tm      *bf;
time_t		tmm;
char		vpr1[4];
short		dd,md,gd;
short		d,m,g;
short		tipz;
double		sumd,sumpod;
double		isumd,isumpod;
char		fio[512];
char		naimop[512];
double		saldon=0.; //Сальдо на начало периода
double		saldoden; //Сальдо на начало дня
double		itpri,itras;
int		kollist=0;//Количество листов с начала года
int		kolstrok=0;
char		nomdz[24];
int		koldn=0;
double          suma_p=0.;
double          suma_r=0.;
double itogp=0.;
double itogr=0.;
char kod_edr[32];
double kolih_prih_dok=0; //Количество приходных документов
double kolih_rash_dok=0; //Количество расходных документов

SQLCURSOR curr;
time(&tmm);
bf=localtime(&tmm);

printw("%d.%d.%d%s => %d.%d.%d%s\n",
dn,mn,gn,gettext("г."),
dk,mk,gk,gettext("г."));
GDITE();

memset(kod_edr,'\0',sizeof(kod_edr));
//Читаем код
sprintf(strsql,"select kod from Kontragent where kodkon='00'");
if(readkey(strsql,&row,&curr) == 1)
 strncpy(kod_edr,row[0],sizeof(kod_edr)-1);


sprintf(imaf,"kassa%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }
sprintf(imaf_prot,"kassapr%d.lst",getpid());

if((ff_prot = fopen(imaf_prot,"w")) == NULL)
 {
  error_op_nfil(imaf_prot,errno,"");
  return(1);
 }
sprintf(imaf1,"kasg%d.lst",getpid());
if((ffva = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return(1);
 }

sprintf(imafok,"kasok%d.lst",getpid());
if((ffok = fopen(imafok,"w")) == NULL)
 {
  error_op_nfil(imafok,errno,"");
  return(1);
 }


sprintf(imaf2,"kassf%d.lst",getpid());
if((ff2 = fopen(imaf2,"w")) == NULL)
 {
  error_op_nfil(imaf2,errno,"");
  return(1);
 }

if(sravmydat(dn,mn,gn,16,6,2009) < 0)
 {
  fprintf(ff2,"%s\n",organ);
  fprintf(ff2,"%55s Типова форма N КО-3а\n"," ");
  fprintf(ff2,"%55s ЗАТВЕРДЖЕНА\n"," ");
  fprintf(ff2,"%55s Наказом Мінстату України\n"," ");
  fprintf(ff2,"%55s від 15 лютого 1996р. N51\n"," ");

  fprintf(ff2,"%s %s\n",gettext("Идентификационный код по ЕГРПОУ"),kod_edr);
 }
else
 {
  fprintf(ff2,"\
                                     Додаток 4\n\
                                     до Положення про ведення касових операцій\n\
                                     у національній валюті в Україні\n\
                                     Типова форма N КО-3a\n");
  fprintf(ff2,"\n\
%-*s Ідентифікаційний код ЄДРПОУ %s\n",iceb_tu_kolbait(30,organ),organ,kod_edr);  
 }
fprintf(ff2,"\n%30s %s\n","",gettext("ЖУРНАЛ"));
fprintf(ff2,"%7s %s\n","",gettext("регистрации приходных и расходных кассовых документов"));

zagolov("",bf,dn,mn,gn,dk,mk,gk,"",ff2);
  

//Вычисляем сальдо на начало периода
saldon=0.;

sprintf(strsql,"select kassa,tp,datd,nomd,suma from Kasord1 where \
datd >= '%04d-01-01' and datd < '%04d-%d-%d' and datp <> '0000-00-00' order by datd,nomd asc",
gn,gn,mn,dn);
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
//printw("%s\n",strsql);
//OSTANOV();
 
d=m=g=dd=md=gd=0;
memset(nomdz,'\0',sizeof(nomdz));

kollist=1; 
kolstrok=KOLSTRHAP;
kolstr1=0;
int koldok=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(kassa,row[0],0,0) != 0)
    continue;
  rsdat(&dd,&md,&gd,row[2],2);


  if(SRAV("000",row[3],0) == 0)
   {
    if(gd == gn)
     {
      saldon+=atof(row[4]);
     }
    continue;
   }
  if(sravmydat(d,m,g,dd,md,gd) != 0)
   {
    if(d != 0)
     {
      /*Вывод шапки так как поменялься день*/
      kasothr_ss(1,dd, md, gd,&kollist,&kolstrok,0.,0.,NULL,NULL,ff_prot);
      if(d != dd)
        kasothr_ss(0,dd, md, gd,&kollist,&kolstrok,0.,0.,NULL,NULL,ff_prot);/*строка сальдо*/
     
     }
    else
      kasothr_ss(0,dd, md, gd,&kollist,&kolstrok,0.,0.,NULL,NULL,ff_prot); /*остаток на начало дня*/
  
     
    d=dd; m=md; g=gd;
   }      

  if(vpr[0] != '\0')
   {
    if(vpr[0] == '+' && row[1][0] == '2')
      continue;
    if(vpr[0] == '-' && row[1][0] == '1')
      continue;
   }

  if(SRAV(nomdz,row[3],0) != 0)
   {
    koldok++;
    kasothr_ss(0,dd, md, gd,&kollist,&kolstrok,0.,0.,NULL,NULL,ff_prot);

    if(ff_prot != NULL)
     fprintf(ff_prot,"%s %s %s %s %s kolstrok=%d\n",row[0],row[1],row[2],row[3],row[4],kolstrok);

    strcpy(nomdz,row[3]);
   }    


  if(row[1][0] == '1')
   {
    saldon+=atof(row[4]);
   }
  else
   {
    saldon-=atof(row[4]);
   }
 }

if(ff_prot != NULL)
  fprintf(ff_prot,"===Количество строк=%d Номер листа =%d\n",kolstrok,kollist);
saldoden=saldon;

printw("%s %02d.%02d.%d :%.2f\n",
gettext("Сальдо на"),dn,mn,gn,saldon);
refresh();

sprintf(strsql,"select kassa,tp,datd,nomd,shetk,kodop,fio,osnov,dopol,nb \
from Kasord where datd >= '%04d-%d-%d' and datd <= '%04d-%d-%d' and podt=1 \
order by datd,tp,nomd asc",
gn,mn,dn,gk,mk,dk);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(-1);
 }
if(kolstr <= 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  fprintf(ff,"%s\n",gettext("Не найдено ни одной записи !"));
  return(1);
 }


if(vpr[0] == '\0')
  strcpy(strsql,gettext("Регистрация кассовых ордеров."));
if(vpr[0] == '+')
  strcpy(strsql,gettext("Регистрация приходних кассовых ордеров."));
if(vpr[0] == '-')
  strcpy(strsql,gettext("Регистрация расходных кассовых ордеров."));
  

zagolov(strsql,bf,dn,mn,gn,dk,mk,gk,organ,ff);

hgrkd(ff2);


if(kassa[0] != '\0')
  fprintf(ff,"%s:%s\n",gettext("Касса"),kassa);
if(kodop[0] != '\0')
  fprintf(ff,"%s:%s\n",gettext("Код операции"),kodop);
if(shet[0] != '\0')
  fprintf(ff,"%s:%s\n",gettext("Счет"),shet);

fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
Касса|+/-|Номер док.|Дата док. |Сумм док.|Номер бланка |            Фамилия           |Операция \n"));
fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------------\n");



d=m=g=dd=md=gd=0;
class SQLCURSOR cur1;

itpri=itras=isumd=isumpod=0.;
kolstr1=0;
if(koldok > 0)
  kollist+=1;

int metka_sap=0;

kolstrok=KOLSTRHAP;
int kollist_nah=kollist;

while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(kassa,row[0],0,0) != 0)
    continue;
  if(proverka(kodop,row[5],0,0) != 0)
    continue;
  rsdat(&dd,&md,&gd,row[2],2);

  if(metka_sap == 0) /*Нужно взять дату первого документа для первой шапки*/
   {
    sapkasord(dd,md,gd,kollist,gettext("Вкладной лист кассовой книги"),ffva);
    sapkasord(dd,md,gd,kollist,gettext("Отчёт кассира"),ffok);
    metka_sap++;
   }  

  if(kod_kontr[0] != '\0')
   {
    sprintf(strsql,"select kontr from Kasord1 where kassa=%s and god=%d and tp=%s and nomd='%s'",
    row[0],gd,row[1],row[3]);

    if(cur1.make_cursor(&bd,strsql) < 0)
      msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    int metka_kontr=0;
    while(cur1.read_cursor(&row1) != 0)
     {
      if(proverka(kod_kontr,row1[0],0,0) == 0)
       {
        metka_kontr=1;
        break;
        
       } 
     }
    if(metka_kontr == 0)
     continue;
   }
  
  tipz=atoi(row[1]);
  
  if(sravmydat(d,m,g,dd,md,gd) != 0)
   {
    if(d != 0)
     {
      /*Выводим шапку так как поменялся день*/
      kasothr_ss(1,dd, md, gd,&kollist,&kolstrok,itpri,itras,ffva,ffok,ff_prot);
      if(d != dd)
       {
        kasothr_ss(0,dd, md, gd,&kollist,&kolstrok,itpri,itras,ffva,ffok,ff_prot);
        fprintf(ffva,"%*s:%10.2f\n",
        iceb_tu_kolbait(50,gettext("Сальдо")),gettext("Сальдо"),isumd+saldon);
        fprintf(ffok,"%*s:%10.2f\n",
        iceb_tu_kolbait(50,gettext("Сальдо")),gettext("Сальдо"),isumd+saldon);
       }      
     }

    if(d == 0)    
     {
      if(SRAV("000",row[3],0) == 0)
       {
        sumkasor(row[0],tipz,row[3],gd,&sumd,&sumpod);
        if(tipz == 2)
          sumd*=-1;

        saldoden+=sumd;
        saldon+=sumd;
       }

      kasothr_ss(0,dd, md, gd,&kollist,&kolstrok,itpri,itras,ffva,ffok,ff_prot);
      sprintf(strsql,"%s",gettext("Остаток на начало дня"));
      fprintf(ffva,"%*s:%10.2f\n",iceb_tu_kolbait(50,strsql),strsql,saldoden);
      fprintf(ffok,"%*s:%10.2f\n",iceb_tu_kolbait(50,strsql),strsql,saldoden);
     }

    d=dd; m=md; g=gd;
    if(SRAV("000",row[3],0) == 0)
      continue;
   }      

  
  
  if(vpr[0] != '\0')
   {
    if(vpr[0] == '+' && tipz == 2)
      continue;
    if(vpr[0] == '-' && tipz == 1)
      continue;
   }

  if(proverka(shet,row[4],0,0) != 0)
    continue;
 
 
  memset(vpr1,'\0',sizeof(vpr1));
  if(tipz == 1)
   vpr1[0]='+';
  if(tipz == 2)
   vpr1[0]='-';
  rsdat(&dd,&md,&gd,row[2],2);
  
  memset(fio,'\0',sizeof(fio));
  strncpy(fio,row[6],sizeof(fio)-1);
  if(fio[0] == '\0')
   {
    sprintf(strsql,"select kontr from Kasord1 where kassa=%s and \
god=%d and tp=%d and nomd='%s'",row[0],gd,tipz,row[3]);
    if(sql_readkey(&bd,strsql,&row1,&curr) >= 1)
     {
       /*Читаем наименование контрагента*/
      sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",row1[0]);
      if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
        strncpy(fio,row1[0],sizeof(fio)-1);
     }
   }
  /*Читаем наименование операции*/
  memset(naimop,'\0',sizeof(naimop));
  if(tipz == 1)
   sprintf(strsql,"select naik from Kasop1 where kod='%s'",row[5]);       
  if(tipz == 2)
   sprintf(strsql,"select naik from Kasop2 where kod='%s'",row[5]);       
   if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
    {
     strncpy(naimop,row1[0],sizeof(naimop)-1);
    }


  sumkasor(row[0],tipz,row[3],gd,&sumd,&sumpod);

  if(tipz == 2)
   {
    suma_r+=sumd;

    fprintf(ff2,"%42s %02d.%02d.%d %-*s %10.2f %-*.*s\n",
    " ",dd,md,gd,
    iceb_tu_kolbait(8,row[3]),row[3],
    sumd,
    iceb_tu_kolbait(10,row[7]),iceb_tu_kolbait(10,row[7]),row[7]);

    for(int ii=10; ii < iceb_tu_strlen(row[7]); ii+=10)
     fprintf(ff2,"%73s %-*.*s\n",
     "",
     iceb_tu_kolbait(10,iceb_tu_adrsimv(ii,row[7])),
     iceb_tu_kolbait(10,iceb_tu_adrsimv(ii,row[7])),
     iceb_tu_adrsimv(ii,row[7]));

    sumd*=-1;
    itras+=sumd;
    kolih_rash_dok++;
   } 
  else
   {
    suma_p+=sumd;

    fprintf(ff2," %02d.%02d.%d %-*s %10.2f %-*.*s\n",
    dd,md,gd,
    iceb_tu_kolbait(8,row[3]),row[3],
    sumd,
    iceb_tu_kolbait(10,row[7]),iceb_tu_kolbait(10,row[7]),row[7]);

    for(unsigned int ii=10; ii < strlen(row[7]); ii+=10)
     fprintf(ff2,"%31s %-*.*s\n",
     "",
     iceb_tu_kolbait(10,iceb_tu_adrsimv(ii,row[7])),
     iceb_tu_kolbait(10,iceb_tu_adrsimv(ii,row[7])),
     iceb_tu_adrsimv(ii,row[7]));

    itpri+=sumd;
    kolih_prih_dok++;
   }
  saldoden+=sumd;    
  isumd+=sumd;
  isumpod+=sumpod;  

  if(tipz == 1)
   itogp+=sumd;

  if(tipz == 2)
   itogr+=sumd;
   

  fprintf(ff,"%-5s %-3s %-*s %02d.%02d.%d %10.2f %-*s %-*.*s %s %s\n",
  row[0],
  vpr1,
  iceb_tu_kolbait(10,row[3]),row[3],
  dd,md,gd,sumd,
  iceb_tu_kolbait(13,row[9]),row[9],
  iceb_tu_kolbait(30,fio),iceb_tu_kolbait(30,fio),fio,
  row[7],
  row[8]);


  kasothr_ss(0,dd, md, gd,&kollist,&kolstrok,itpri,itras,ffva,ffok,ff_prot);
  if(ff_prot != NULL)
   fprintf(ff_prot,"%s %s %s %s %s %s kolstrok=%d\n",row[0],row[1],row[2],row[3],row[4],row[5],kolstrok);
  if(tipz == 1)
   {
    fprintf(ffva,"%-*s %-*.*s %-10.10s %10.2f\n",
    iceb_tu_kolbait(8,row[3]),row[3],
    iceb_tu_kolbait(30,fio),iceb_tu_kolbait(30,fio),fio,
    row[4],sumd);

    fprintf(ffok,"%-*s %-*.*s %-*.*s %10.2f\n",
    iceb_tu_kolbait(8,row[3]),row[3],
    iceb_tu_kolbait(30,fio),iceb_tu_kolbait(30,fio),fio,
    iceb_tu_kolbait(10,row[4]),iceb_tu_kolbait(10,row[4]),row[4],
    sumd);
   }
  if(tipz == 2)
   {
    fprintf(ffva,"%-*s %-*.*s %-*.*s %10s %10.2f\n",
    iceb_tu_kolbait(8,row[3]),row[3],
    iceb_tu_kolbait(30,fio),iceb_tu_kolbait(30,fio),fio,
    iceb_tu_kolbait(10,row[4]),iceb_tu_kolbait(10,row[4]),row[4],
    " ",sumd*-1);

    fprintf(ffok,"%-*s %-*.*s %-*.*s %10s %10.2f\n",
    iceb_tu_kolbait(8,row[3]),row[3],
    iceb_tu_kolbait(30,fio),iceb_tu_kolbait(30,fio),fio,
    iceb_tu_kolbait(10,row[4]),iceb_tu_kolbait(10,row[4]),row[4],
    " ",sumd*-1);
   }
 } 

fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(31,gettext("Итого приход")),gettext("Итого приход"),itogp);
fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(31,gettext("Итого расход")),gettext("Итого расход"),itogr);

fprintf(ffva,"\
-------------------------------------------------------------------------\n");

fprintf(ffva,"%*s|%10.2f|%10.2f|\n",iceb_tu_kolbait(50,gettext("Итого за день")),gettext("Итого за день"),itpri,itras*-1);
fprintf(ffva,"%50s|---------------------|\n"," ");
fprintf(ffva,"%*s|%10.2f|\n",iceb_tu_kolbait(50,gettext("Остаток на конец дня")),gettext("Остаток на конец дня"),isumd+saldon);
fprintf(ffva,"%50s|----------|\n"," ");
fprintf(ffva,"%*s|%10s|\n",iceb_tu_kolbait(50,gettext("В том числе на зарплату")),gettext("В том числе на зарплату")," ");
fprintf(ffva,"%50s|----------|\n"," ");

fprintf(ffok,"\
-------------------------------------------------------------------------\n");
fprintf(ffok,"%*s|%10.2f|%10.2f|\n",iceb_tu_kolbait(50,gettext("Итого за день")),gettext("Итого за день"),itpri,itras*-1);
fprintf(ffok,"%50s|---------------------|\n"," ");
fprintf(ffok,"%*s|%10.2f|\n",iceb_tu_kolbait(50,gettext("Остаток на конец дня")),gettext("Остаток на конец дня"),isumd+saldon);
fprintf(ffok,"%50s|----------|\n"," ");
fprintf(ffok,"%*s|%10s|\n",iceb_tu_kolbait(50,gettext("В том числе на зарплату")),gettext("В том числе на зарплату")," ");
fprintf(ffok,"%50s|----------|\n"," ");

koldn=period(dn,mn,gn,dk,mk,gk,0);
if(koldn == 1)
 {
  fprintf(ffva,"%s:%d\n",gettext("Количество листов"),kollist-kollist_nah+1);
  fprintf(ffok,"%s:%d\n",gettext("Количество листов"),kollist-kollist_nah+1);
 }
else
 {
  fprintf(ffva,"%s %02d.%02d.%d%s %s %02d.%02d.%d%s\n",
  gettext("С"),
  dn,mn,gn,
  gettext("г."),
  gettext("по"),
  dk,mk,gk,
  gettext("г."));

  fprintf(ffva,"%s %d %s.\n",
  gettext("распечатано"),
  kollist,
  gettext("листов кассовой книги"));

  fprintf(ffok,"%s %02d.%02d.%d%s %s %02d.%02d.%d%s\n",
  gettext("С"),
  dn,mn,gn,
  gettext("г."),
  gettext("по"),
  dk,mk,gk,
  gettext("г."));

  fprintf(ffok,"%s %d %s.\n",
  gettext("распечатано"),
  kollist,
  gettext("листов кассовой книги"));
 }  
char propis_prih[50];
char propis_rash[50];
memset(propis_prih,'\0',sizeof(propis_prih));
memset(propis_rash,'\0',sizeof(propis_rash));

preobr(kolih_prih_dok,propis_prih,2);
preobr(kolih_rash_dok,propis_rash,2);

fprintf(ffva,"\n%s_________________\n\n",gettext("Кассир"));

fprintf(ffva,"%s\n",gettext("Записи в касовой книге проверил, и документы в количестве"));

fprintf(ffva,"%s %s\n",propis_prih,gettext("приходных и"));
fprintf(ffva,"%s %s\n",propis_rash,gettext("расходных получил"));

fprintf(ffva,"\n%s_______________\n",gettext("Бухгалтер"));



fprintf(ffok,"\n%s_________________\n\n",gettext("Кассир"));

//fprintf(ffok,"%-66.66s\n",strsql);
//fprintf(ffok,"%s",&strsql[66]);
fprintf(ffok,"%s\n",gettext("Записи в касовой книге проверил, и документы в количестве"));

fprintf(ffok,"%s %s\n",propis_prih,gettext("приходных и"));
fprintf(ffok,"%s %s\n",propis_rash,gettext("расходных получил"));


fprintf(ffok,"\n%s_______________\n",gettext("Бухгалтер"));

fprintf(ff2,"\
-----------------------------------------------------------------------------------\n");
fprintf(ff2,"%*s:%10.2f %30s %10.2f\n",iceb_tu_kolbait(20,gettext("Итого")),gettext("Итого"),suma_p," ",suma_r);

podpis(ff);

podpis(ffva);
podpis(ffok);

podpis(ff2);


fclose(ff);
fclose(ffva);
fclose(ffok);
fclose(ff2);
if(ff_prot != NULL)
 fclose(ff_prot);
printw_vr(tmm);


OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Распечатка списка кассовых ордеров"));
oth->spis_imaf.plus(imaf1);
oth->spis_naim.plus(gettext("Вкладной лист кассовой книги"));
oth->spis_imaf.plus(imafok);
oth->spis_naim.plus(gettext("Отчёт кассира"));
oth->spis_imaf.plus(imaf2);

sprintf(strsql,"%s %s",gettext("ЖУРНАЛ"),
gettext("регистрации приходных и расходных кассовых документов"));

oth->spis_naim.plus(strsql);
if(ff_prot != NULL)
 {
  oth->spis_imaf.plus(imaf_prot);
  oth->spis_naim.plus("Протокол хода расчёта");
 }

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),1);

return(0);
}

/*******/
/*Шапка*/
/*******/

void sapkasord(short dd,short md,short gd,int nomlist,const char *zagol,FILE *ffva)
{

char mesqc[32];
memset(mesqc,'\0',sizeof(mesqc));
mesc(md,1,mesqc);

fprintf(ffva,"%s\n",zagol);

fprintf(ffva,"%s \"%02d\" %s %d%s                     %s %d\n",
gettext("Касса за"),
dd,mesqc,gd,
gettext("г."),
gettext("Лист"),nomlist);

fprintf(ffva,"\
-------------------------------------------------------------------------\n");
fprintf(ffva,"\
 Номер  |  Від кого отримано чи кому   |  Номер   |  Надход- | Видаток  |\n\
докумен-|         видано               |кореспон- |  ження   |          |\n\
  та    |                              |дуючого   |          |          |\n\
        |                              |рахунку,  |          |          |\n\
        |                              |субрахунку|          |          |\n");
fprintf(ffva,"\
-------------------------------------------------------------------------\n");
/*
12345678 123456789012345678901234567890 1234567890 1234567890 1234567890
*/

}
/***************************/
/*Шапка журнала регистрации кассовых документов*/
/***********************************************/

void   hgrkd(FILE *ff)
{
fprintf(ff,"\
-------------------------------------------------------------------------------------\n\
|Прибутковий докум. |          |          |Видатковий докум.  |          |          |\n\
---------------------  Сума    |Примітки  |--------------------  Сума    |Примітки  |\n\
|  дата    | номер  |          |          |  дата    | номер  |          |          |\n\
-------------------------------------------------------------------------------------\n");
}
/*************************/
/*Счётчик строк*/
/*******************/
void kasothr_ss(int metka, //0-счётчик применять 1-не применять
short dd,short md,short gd,int *nomlist,int *kolstr,double itpri,double itras,FILE *ffva,FILE *ffok,FILE *ff_prot)
{
if(metka == 0)
 {
  *kolstr+=1;
  if(*kolstr <= kol_strok_na_liste-1)
   return;
  *kolstr=1;
 }
else
 *kolstr=0;
 
*nomlist+=1;
*kolstr+=KOLSTRHAP;
if(ffva != NULL)
 {
  fprintf(ffva,"%*s:%10.2f %10.2f\n",
  iceb_tu_kolbait(50,gettext("Перенос")),gettext("Перенос"),itpri,itras*-1);
  fprintf(ffva,"\f");
  sapkasord(dd,md,gd,*nomlist,gettext("Вкладной лист кассовой книги"),ffva);
 }
if(ffok != NULL)
 {
  fprintf(ffok,"%*s:%10.2f %10.2f\n",
  iceb_tu_kolbait(50,gettext("Перенос")),gettext("Перенос"),itpri,itras*-1);
  fprintf(ffok,"\f");
  sapkasord(dd,md,gd,*nomlist,gettext("Отчет кассира"),ffok);
 }
if(ff_prot != NULL)
 fprintf(ff_prot,"Вывели шапку kolstr=%d nomlist=%d\n",*kolstr,*nomlist); 
}
