/* $Id: korprovnbs.c,v 5.16 2011-01-13 13:43:22 sasa1 Exp $ */
/*14.01.2010	07.06.2001	Белых А.И.	korprovnbs.c
Корректировка проводок для небалансовых счетов
*/
#include        <pwd.h>
#include        <sys/types.h>
#include        <time.h>
#include        "buhg.h"


void            korprovnbs(VVOD *VV,short d,short m,short g, //Дата
const char *sh,  //Счет
const char *kor, //Код контрагента
time_t vrem,  //время записи
int ktoi,
const char *kto)
{
char		strsql[512];
char            orgz[40];
SQL_str   	row;
SQLCURSOR       cur;
time_t		vremm;
struct  tm      *bf;
short           d1,m1,g1;
double		deb,kre;
short		i;
char		kontr[32];
char		naik[512];
char		komentz[512];
char		bros[512];

bf=localtime(&vrem);
memset(kontr,'\0',sizeof(kontr));

strcpy(komentz,VV->VVOD_SPISOK_return_data(2));
deb=ATOFM(VV->VVOD_SPISOK_return_data(3));
deb=okrug(deb,0.01);
kre=ATOFM(VV->VVOD_SPISOK_return_data(4));
kre=okrug(kre,0.01);

strcpy(orgz,VV->VVOD_SPISOK_return_data(5));
VV->VVOD_SPISOK_add_MD(gettext("Счет........"));
VV->VVOD_SPISOK_add_MD(gettext("Дата........"));
VV->VVOD_SPISOK_add_MD(gettext("Коментарий.."));
VV->VVOD_SPISOK_add_MD(gettext("Дебет......."));
VV->VVOD_SPISOK_add_MD(gettext("Кредит......"));
VV->VVOD_SPISOK_add_MD(gettext("Код контр. ."));

naz:;


memset(bros,'\0',sizeof(bros));
if(VV->VVOD_SPISOK_return_data(5)[0] != '\0')
 {
  memset(naik,'\0',sizeof(naik));
  memset(kontr,'\0',sizeof(kontr));
  strcpy(kontr,VV->VVOD_SPISOK_return_data(5));

  sprintf(bros,"select naikon from Kontragent where kodkon='%s'",
  kontr);
  if(sql_readkey(&bd,bros,&row,&cur) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"1 %s %s !",gettext("Не найден код контрагента"),kontr);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
    strncpy(naik,row[0],sizeof(naik)-1);

 }

VV->VVOD_delete_ZAG();

sprintf(strsql,"%s %d.%d.%d%s %s: %d:%d:%d",
gettext("Дата ввода проводки"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min,bf->tm_sec);
VV->VVOD_SPISOK_add_ZAG(strsql);
/**************
if((ktoz=getpwuid(ktoi)) != NULL)
  sprintf(strsql,"%s: %d %s",gettext("Проводку записал"),ktoi,ktoz->pw_gecos);
else
  sprintf(strsql,"%s %d !",gettext("Неизвестный логин !"),ktoi);
**************/
sprintf(strsql,"%s: %s",gettext("Записал"),iceb_t_kszap(ktoi));
VV->VVOD_SPISOK_add_ZAG(strsql);

if(kontr[0] != '\0')  
 {
  sprintf(strsql,gettext("Контрагент: %s %s"),kontr,naik);
  VV->VVOD_SPISOK_add_ZAG(strsql);
 }

int PY=-1; 
int PX=-1; /*Координаты вывода меню*/


helstr(LINES-1,0,"F2/+",gettext("запись"),
"F3",gettext("контрагенты"),
"F10",gettext("выход"),NULL);

int par=VV->vvod(0,1,1,PY,PX);

GDITE();

if(par == FK2 || par == PLU)
 {
  if(VV->VVOD_SPISOK_return_data(0)[0] == '\0')
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не введен счет !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }

  if(rsdat(&d1,&m1,&g1,VV->VVOD_SPISOK_return_data(1),0) != 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не верно ведена дата проводки !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }

  if(ATOFM(VV->VVOD_SPISOK_return_data(3)) != 0. && ATOFM(VV->VVOD_SPISOK_return_data(4)) != 0.)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Введено дебет и кредит !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
  if(iceb_t_pvglkni(m,g) != 0)
   goto naz;
   

   if(prvkp(kto) != 0)
     goto naz;

   memset(kontr,'\0',sizeof(kontr));
   if(VV->VVOD_SPISOK_return_data(5)[0] != '\0')
     strcpy(kontr,VV->VVOD_SPISOK_return_data(5));

  /*Проверяем есть ли счет в списке счетов*/
  OPSHET shetv;
  if(prsh1(VV->VVOD_SPISOK_return_data(0),&shetv) != 0)
    goto naz;

  if(shetv.stat == 0)
   {
    VVOD SOOB(1);
    sprintf(strsql,gettext("Счет %s балансовый !"),VV->VVOD_SPISOK_return_data(0));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;

   }
  if(shetv.saldo == 3 && kontr[0] == '\0')
   {
    VVOD SOOB(1);
    sprintf(strsql,gettext("Не введен контрагент для счета %s !"),VV->VVOD_SPISOK_return_data(0));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }


  /*Проверяем есть ли такой код контрагента*/
  if(shetv.saldo == 3)
  if(kontr[0] != '\0')
   {
    sprintf(strsql,"select kodkon from Skontr where ns='%s' and \
kodkon='%s'",VV->VVOD_SPISOK_return_data(0),kontr);
    if(sql_readkey(&bd,strsql,&row,&cur) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Нет кода контрагента %s для счета %s !"),kontr,VV->VVOD_SPISOK_return_data(0));
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     } 
   }



  if( shetv.saldo == 3 && kontr[0] == '\0' )
   {  
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не введен код контрагента !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
  if(shetv.saldo < 3 && kontr[0] != '\0')
   {  
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Счет не с развернутым сальдо !"));
    SOOB.VVOD_SPISOK_add_MD(gettext("Код контрагента не вводится !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }

  if(iceb_t_pbsh(m,g,sh,"","") != 0)
   goto naz;
     
  sqlfiltr(komentz,sizeof(komentz));
  if(udprov(-1,g,m,d,sh,"",vrem,deb,kre,komentz,1) != 0)
     return;

  rsdat(&d1,&m1,&g1,VV->VVOD_SPISOK_return_data(1),0);
  deb=ATOFM(VV->VVOD_SPISOK_return_data(3));
  i=2;
  if(VV->VVOD_SPISOK_return_data(3)[0] == '-')
    i++;
  if(POLE(VV->VVOD_SPISOK_return_data(3),bros,i,'-') == 0)
    deb-=ATOFM(bros);
  if(POLE(VV->VVOD_SPISOK_return_data(3),bros,2,'+') == 0)
    deb+=ATOFM(bros);
  if(POLE(VV->VVOD_SPISOK_return_data(3),bros,2,'/') == 0)
    deb/=ATOFM(bros);
  if(POLE(VV->VVOD_SPISOK_return_data(3),bros,2,'*') == 0)
    deb*=ATOFM(bros);

  kre=ATOFM(VV->VVOD_SPISOK_return_data(4));
  i=2;
  if(VV->VVOD_SPISOK_return_data(4)[0] == '-')
    i++;
  if(POLE(VV->VVOD_SPISOK_return_data(4),bros,i,'-') == 0)
    kre-=ATOFM(bros);
  if(POLE(VV->VVOD_SPISOK_return_data(4),bros,2,'+') == 0)
    kre+=ATOFM(bros);
  if(POLE(VV->VVOD_SPISOK_return_data(4),bros,2,'/') == 0)
    kre/=ATOFM(bros);
  if(POLE(VV->VVOD_SPISOK_return_data(4),bros,2,'*') == 0)
    kre*=ATOFM(bros);

  deb=okrug(deb,0.01);
  kre=okrug(kre,0.01);
  memset(bros,'\0',sizeof(bros));
//  sqlfiltr(VV->VVOD_SPISOK_return_data(2),sizeof(VV->VVOD_SPISOK_return_data(2)));
  time(&vremm);
  zapprov(-1,g1,m1,d1,VV->VVOD_SPISOK_return_data(0)," ",kontr,kontr,kto,bros,bros,deb,kre,VV->data_ravno_filtr(2),1,0,vremm,0,0,0,0,0);
 }

if(par == FK3)
 {
  clear();
  class iceb_tu_str kodkontr("");
  class iceb_tu_str naimkontr("");

  dirkontr(&kodkontr,&naimkontr,1);

  clear();

  goto naz;
 }
clear();
GDITE();
}
void	sozkorprovnbs(VVOD *VV)
{
VV->VVOD_SPISOK_add_data(10);
VV->VVOD_SPISOK_add_data(11);
VV->VVOD_SPISOK_add_data(100);
VV->VVOD_SPISOK_add_data(20);
VV->VVOD_SPISOK_add_data(20);
VV->VVOD_SPISOK_add_data(20);
}
