/*$Id: kriost.c,v 5.18 2011-01-13 13:43:22 sasa1 Exp $*/
/*15.12.2009	12.06.2003	Белых А.И.	kriost.c
Получение списка материалов у которых остаток меньше или равен критическому
*/
#include        <errno.h>
#include        <string.h>
#include        <time.h>
#include        <math.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif
#define		KOLSTRLIST 63

void            krisap(int*,int*,FILE*);

extern char     *organ;

int kriost(class spis_oth *oth)
{
char		bros[312];
char		strsql[512];
static char	dat1[11];
static char	skladi[112];
static char	grupi[112];
static char	sheta[112];
static char	kodm[112];
short		dos,mos,gos;
char		naim[512];
int		i=0;
int		kom1=0;
int		kgr=0;

if(dat1[0] == '\0')
 {
  short dt,mt,gt;
  poltekdat(&dt,&mt,&gt);
  sprintf(dat1,"%d.%d.%d",dt,mt,gt);
 }
VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_data(skladi,sizeof(skladi));
VV.VVOD_SPISOK_add_data(grupi,sizeof(grupi));
VV.VVOD_SPISOK_add_data(sheta,sizeof(sheta));
VV.VVOD_SPISOK_add_data(kodm,sizeof(kodm));
VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));

VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка материалов имеющих критический остаток."));

VV.VVOD_SPISOK_add_MD(gettext("Склад.(,,)......."));
VV.VVOD_SPISOK_add_MD(gettext("Группа..(,,)....."));
VV.VVOD_SPISOK_add_MD(gettext("Счет....(,,)....."));
VV.VVOD_SPISOK_add_MD(gettext("Материал.(,,/*).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата остатка....."));

naz:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

int par=VV.vvod(0,1,1,-1,-1);

strncpy(skladi,VV.VVOD_SPISOK_return_data(0),sizeof(skladi)-1);
strncpy(grupi,VV.VVOD_SPISOK_return_data(1),sizeof(grupi)-1);
strncpy(sheta,VV.VVOD_SPISOK_return_data(2),sizeof(sheta)-1);
strncpy(kodm,VV.VVOD_SPISOK_return_data(3),sizeof(kodm)-1);
strncpy(dat1,VV.VVOD_SPISOK_return_data(4),sizeof(dat1)-1);
class iceb_tu_str kods("");
class iceb_tu_str naims("");
switch(par)
 {
  case ESC:
  case FK10:
    return(1);
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("matu5_17.txt");
   clear();
   goto naz;

  case FK2:
  case PLU:
  case OTN:
    break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка складов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка материалов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));

    clearstr(LINES-1,0);
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 4 :
      case -1:
       goto naz;

      case 0 :
        //vibrek("Sklad",skladi,sizeof(skladi),naim);
        if(dirsklad(1,&kods,&naims) == 0)
         VV.data_z_plus(0,kods.ravno());
        goto naz;

      case 1 :
        vibrek("Grup",grupi,sizeof(grupi),naim);
        VV.VVOD_SPISOK_zapis_data(1,grupi);
        goto naz;

      case 2 :
        bros[0]='\0';
        kgr=0;
        if(dirmatr(&kgr,&i,&naims,1,0,bros,0,0) == 0)
         {
          VV.data_z_plus(3,i);
         }
        
        goto naz;

      case 3 :
        vibrek("Plansh",sheta,sizeof(sheta),naim);
        VV.VVOD_SPISOK_zapis_data(2,sheta);
        goto naz;
     }

  case FK4: /*Очистка меню*/
    VV.VVOD_clear_data();
    goto naz;    

  default:
    goto naz;    
 }


if(dat1[0] == '\0' || rsdat(&dos,&mos,&gos,dat1,0) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

time_t 		tmm;
struct  tm      *bf;
time(&tmm);
bf=localtime(&tmm);

clear();
printw("%s\n",gettext("Распечатка материалов имеющих критический остаток."));
printw("%s:%d.%d.%d\n",gettext("Остатки вычислены на"),dos,mos,gos);

GDITE();
SQLCURSOR cur;
SQLCURSOR cur1;
int kolstr=0;
SQL_str row,row1;
double kriost=0.;

sprintf(strsql,"select kodm,kodgr,naimat,kriost from Material");

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

FILE *ff;
char imaf[30];

int kolstr1=0;
int kolstr2=0;
class ostatokt ost;
double   ostmat=0.;
int kolstrlist=0;
sprintf(imaf,"kro%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

zagolov(gettext("Распечатка материалов имеющих критический остаток."),bf,0,0,0,0,0,0,organ,ff);
kolstrlist=5;

fprintf(ff,"%s:%d.%d.%d\n",gettext("Остатки вычислены на"),dos,mos,gos);
kolstrlist++;

if(skladi[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Склад"),skladi);
  kolstrlist++;
 }

if(grupi[0] != '\0')
 {
  fprintf(ff,gettext("Групы: %s\n"),grupi);
  kolstrlist++;
 }
if(sheta[0] != '\0')
 {
  fprintf(ff,gettext("Счета учета: %s\n"),sheta);
  kolstrlist++;
 }
if(kodm[0] != '\0')
 {
  fprintf(ff,gettext("Код материалла: %s\n"),kodm);
  kolstrlist++;
 }

int kollist=0;
krisap(&kollist,&kolstrlist,ff);

while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s %s %s\n",row[0],row[1],row[2],row[3]);
//  refresh();
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(proverka(kodm,row[0],0,0) != 0)
    continue;
  if(proverka(grupi,row[1],0,0) != 0)
    continue;

  kriost=0.;
  if(row[3] != NULL)
    kriost=atof(row[3]);
  ostmat=0.;  
  sprintf(strsql,"select sklad,nomk,shetu from Kart where kodm=%s",row[0]);

  if((kolstr2=cur1.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    break;
   }
  int metka=0;
  while(cur1.read_cursor(&row1) != 0)
   {
//    printw("%s %s %s\n",row1[0],row1[1],row1[2]);
//    refresh();
    if(proverka(skladi,row1[0],0,0) != 0)
      continue;
    if(proverka(sheta,row1[2],0,0) != 0)
      continue;

    ostkar(1,1,gos,dos,mos,gos,atoi(row1[0]),atoi(row1[1]),&ost);
    metka=1;
    ostmat+=ost.ostg[3];    

   }
  if(metka == 0)
    continue;   

  if(ostmat > kriost)
   continue;  
  kolstrlist++;

  if(kolstrlist > KOLSTRLIST)
   {
    fprintf(ff,"\f");
    kolstrlist=1; //Строка которая будет выведена
    krisap(&kollist,&kolstrlist,ff);
   }

  fprintf(ff,"%-5s|%-*.*s|%10.2f|%10.2f\n",
  row[0],
  iceb_tu_kolbait(30,row[2]),iceb_tu_kolbait(30,row[2]),row[2],kriost,ostmat);
 }

podpis(ff);

fclose(ff);

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Распечатка материалов имеющих критический остаток."));
iceb_t_ustpeh(oth->spis_imaf.ravno(0),0);
return(0);
}

/**********************************/
/*Шапка распечатки                */
/**********************************/

void  krisap(int *kollist,int *kolstrlist,FILE *ff)
{
*kollist+=1;
*kolstrlist+=4;
fprintf(ff,"%50s%s%d\n","",gettext("Лист N"),*kollist);
fprintf(ff,"\
-----------------------------------------------------------\n");
fprintf(ff,gettext("\
 Код |   Наименование               |Кр.остаток| Остаток  |\n"));
fprintf(ff,"\
-----------------------------------------------------------\n");

}
