/* $Id: makkor.c,v 5.12 2011-01-13 13:43:22 sasa1 Exp $ */
/*12.12.2010	20.01.1999	Белых А.И.	makkor.c
Работа с файлом настройки для корректировки суммы по документа
Если все в норме возвращаем 0
                            1- ошибка
*/
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


int makkor(VVOD *MENU,
short tr, //1-создать меню 2-взять настройку для выбранной корректировки
char naikor[], //Наименование корректировки*/
double **maskor,
const char imaf[])
{
char		br[1024],br1[1024];
short		ns,i,i1;


SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];

sprintf(strsql,"select str from Alx where fil='%s' order by ns asc",imaf);
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),imaf);
  iceb_t_soob(strsql);
  return(1);
 }


if(tr == 1)
 {
  ns=0;
  while(cur_alx.read_cursor(&row_alx) != 0)
   {
    if(row_alx[0][0] == '#')
     continue;
    if(SRAV(row_alx[0],"Наименование корректировки",1) == 0)
     {
      POLE(row_alx[0],br,2,'|');
      MENU->VVOD_SPISOK_add_MD(br);
//      strcpy(LL.MD[ns],br);
      ns++;
     }
   }
 }

if(tr == 2)
 {
  while(cur_alx.read_cursor(&row_alx) != 0)
   {
    if(row_alx[0][0] == '#')
     continue;
    if(SRAV(row_alx[0],"Наименование корректировки",1) == 0)
     {
      POLE(row_alx[0],br,2,'|');
      if(SRAV(naikor,br,0) == 0)
       {
        if((*maskor) != NULL)
         {
          free(*maskor);
          *maskor=NULL;
         }
        cur_alx.read_cursor(&row_alx);
        POLE(row_alx[0],br,2,'|');
        ns=pole2(br,',');        
        if(ns == 0 && br[0] != '\0')
         ns=1;
        
        if((*maskor=(double *)calloc(ns*2+1,sizeof(double))) == NULL)
         {
          error2(20,0,1,"Не могу выделить память для maskor !!!");
          return(1);
         }
        (*maskor[0])=ns;
        for(i=1; i < ns+1; i++)
         {
          if(POLE(br,br1,i,',') != 0)
            strcpy(br1,br); 
          (*maskor)[i]=ATOFM(br1);          
/*
          printw("i=%d mas=%.2f\n",i,*maskor[i]); 
          refresh();
*/
         }
        cur_alx.read_cursor(&row_alx);
        POLE(row_alx[0],br,2,'|');
        i1=1;
        for(i=ns+1; i < ns*2+1; i++)
         {
          memset(br1,'\0',sizeof(br1));
          if(POLE(br,br1,i1,',') != 0)
            strcpy(br1,br); 
          i1++;
          (*maskor)[i]=ATOFM(br1);          
/*
          printw("i=%d mas=%.2f br1=%s\n",i,(*maskor)[i],br1); 
          refresh();
  */
         }
/*
        printw("ns=%d\n",ns);
        refresh();
        for(i=0; i < ns*2+1; i++)
         {
          printw("mas=%.2f\n",(*maskor)[i]); 
         }
        OSTANOV();         
*/
       }
     }
    
   }
 }
return(0);
}
