/* $Id: matspor.c,v 5.12 2011-01-13 13:43:22 sasa1 Exp $ */
/*04.11.2007    03.06.1997      Белых А.И.      matspor.c
Распечатка ранее созданных и заполенных массивов
*/
#include	"buhg.h"

void            sappk(int,int,char[],long,long,short,double[],FILE*,short,short);
void            ppppp(int,int,double[],double[],double[],int,FILE*,short,short);
void		rasgraf(int,int,double[],double[],double[],int[],FILE*,short);

extern char            *spoprp;/*Массив с перечнем операций приходов*/
extern char            *spoprr;/*Массив с перечнем операций расходов*/
extern int             *mko;  /*Массив кодов материалов*/
extern double          *mkm1p; /*Массив количества материалла для прихода*/
extern double          *mkm2p; /*Массив веса материалла для прихода*/
extern double          *mkm3p; /*Массив цены материалла для прихода*/
extern double          *mkm1r; /*Массив количества материалла для расхода*/
extern double          *mkm2r; /*Массив веса материалла для расхода*/
extern double          *mkm3r; /*Массив цены материалла для расхода*/
extern double          *mko1r; /*Массив количества отхода материалла для расхода*/
extern double          *mko2r; /*Массив веса отхода материалла для расхода*/
extern double          *mko3r; /*Массив цены отхода материалла для расхода*/
extern int             *mkg;  /*Массив кодов групп материалов*/
extern double          *mkg1p; /*Массив количества материалла по группе для прихода*/
extern double          *mkg2p; /*Массив веса материалла по группе для прихода*/
extern double          *mkg3p; /*Массив цены материалла по группе для прихода*/
extern double          *mkg1r; /*Массив количества материалла по группе для прихода*/
extern double          *mkg2r; /*Массив веса материалла по группе для прихода*/
extern double          *mkg3r; /*Массив цены материалла по группе*/


void            matspor(int kolopp, //Количество операций приходов
int kolopr, //Количество операций расходов
int kolmat, //Количество материалов
int kolgru, //Количество групп материалов
FILE *kaw,FILE *ff1,short mo)
{
printw(gettext("matspor-начал работу\n"));
refresh();

/*Печатаем приходы на матерниалы*/
ppppp(kolopp,kolmat,mkm1p,mkm2p,mkm3p,1,kaw,0,mo);

rasgraf(kolopp,kolmat,mkm1p,mkm2p,mkm3p,mko,kaw,0);

/*Печатаем приходы на группы материалов*/
ppppp(kolopp,kolgru,mkg1p,mkg2p,mkg3p,1,ff1,2,mo);

/*Распечатка в графическом виде группы материалов*/
rasgraf(kolopp,kolgru,mkg1p,mkg2p,mkg3p,mkg,ff1,1);

/*Печатаем расходы материалов*/
ppppp(kolopr,kolmat,mkm1r,mkm2r,mkm3r,2,kaw,0,mo);
rasgraf(kolopr,kolmat,mkm1r,mkm2r,mkm3r,mko,kaw,0);

/*Печатаем отходы материалов*/
ppppp(kolopr,kolmat,mko1r,mko2r,mko3r,2,kaw,1,mo);

/*Печатаем расходы на группы материалов*/
ppppp(kolopr,kolgru,mkg1r,mkg2r,mkg3r,2,ff1,2,mo);
rasgraf(kolopr,kolgru,mkg1r,mkg2r,mkg3r,mkg,ff1,1);


if(kolopp > 0)
 free(spoprp);
if(kolopr > 0)
 free(spoprr);

if(kolmat > 0)
 free(mko);
if(kolgru > 0)
 free(mkg);

if(kolmat > 0 && kolopp > 0)
 {
  free(mkm1p);
  free(mkm2p);
  free(mkm3p);
 }

if(kolmat > 0 && kolopr > 0)
 {
  free(mkm1r);
  free(mkm2r);
  free(mkm3r);
  free(mko1r);
  free(mko2r);
  free(mko3r);
 }

if(kolgru > 0 && kolopp > 0)
 {
  free(mkg1p);
  free(mkg2p);
  free(mkg3p);
 }

if(kolgru > 0 && kolopr > 0)
 {
  free(mkg1r);
  free(mkg2r);
  free(mkg3r);
 }
printw(gettext("matspor-закончила работу.\n"));
refresh();

}
/***********************************/
void            ppppp(int kka,int kon,double nao[],double nao1[],
double nao2[],
int tz, //1-приход 2-расход
FILE *kaw,short tt,short mo)
{
short           kkol=5; /*Количество колонок в распечатке*/
double          br1,br2,br3,br11,br12,sn,sn1,sn2;
long            ii,i2,i1,i,skn;
short		nums; /*Нумерация строки*/
short		kolpr; /*Количество проходов*/
short		kod;
SQL_str         row;
SQLCURSOR       cur;
char		strsql[512];
char            bros[512];
char		st[1024];

//iceb_t_poldan("Н.Д.С.",bros,"matnast.alx");
//float pnds=ATOFM(bros);
float pnds=iceb_t_pnds();

/*Распечатываем*/
sn=sn1=sn2=0.;
nums=0;
for(ii=0 ; ii < kka; ii += kkol)
 {
/*  printw("ii-%d kka-%d \n",ii,kka);*/
  refresh();
  /*Проверяем если все равно нулю то печатаем следующюю группу столбиков*/
  i2=0; br2=0;
  for(i=ii; i<ii+kkol+i2 && i < kka;i++)
   {
    br1=0.;
    for(skn=i;skn< kka*(kon-1)+ii+kkol && skn<kka*kon; skn+=kka)
     {
      if((br1+=nao[skn]) != 0.)
        break;
     }
    if(br1 == 0.)
     i2++;
    br2+=br1;
   }
  if(br2 == 0.)
    continue;
  memset(st,'\0',sizeof(st));

  sappk(tz,kka,st,ii,(ii+kkol),kon,nao,kaw,tt,mo);

  br1=0.;
  for(i=0 ; i<kon;i++)
   {
    /*Проверяем если по горизонтали сумма нулевая то строчку не печатаем*/
/*  printw("\ni-%d kka-%d\n",i,kka);*/
    br1=0.;
     for(skn=0;skn< kka ; skn++)
      {
/*     printw("skn-%d nao[%d]=%.2f\n",skn,skn+i*kka,nao[skn+i*kka]);*/
       if((br1+=nao[skn+i*kka]) != 0.)
        break;
      }
/*  printw("\n\n");
    OSTANOV();   */
    if(br1 == 0.)
      continue;
    
    if(tt == 0 || tt == 1)
     {
      kod=mko[i];
      sprintf(strsql,"select naimat from Material where kodm=%d",
      mko[i]);
      if(sql_readkey(&bd,strsql,&row,&cur) != 1)
        {
         error2(20,0,1,gettext("ppppp-Не найдено наименование материалла !"));
        }
      strcpy(bros,row[0]);
     }
    else
     {
      kod=mkg[i];
      sprintf(strsql,"select naik from Grup where kod=%d",
      mkg[i]);
      if(sql_readkey(&bd,strsql,&row,&cur) != 1)
       {
        error2(20,0,1,gettext("ppppp-Не найдена группа материалла !"));
       }
      strcpy(bros,row[0]);
     }    
    nums++;
    fprintf(kaw,"%3d|%3d|%-*.*s",
    nums,
    kod,
    iceb_tu_kolbait(30,bros),iceb_tu_kolbait(30,bros),bros);
  
    /*Предыдущая информация*/
    br1=br11=br12=0.;
    if(ii > 0 )
     {
      for(skn=i*kka; skn<i*kka+ii && skn < kka*kon ;skn++)
       {
	/*printw(" skn=%d",skn);*/
	 br1+=nao[skn];
	 br11+=nao1[skn];
	 br12+=nao2[skn];
       }
      /*printw("br1=%.2f\n",br1);
      refresh();*/
     }
    i2=0;
    kolpr=0;
    for(skn=i*kka+ii; skn<i*kka+ii+kkol+i2 && skn < i*kka+kka ;skn++)
     {

      /*Если колонка нулевая не печатать*/
      br2=0.;
      for(i1=skn-(i*kka); i1< kka*kon ; i1+=kka)
	 br2+=nao[i1];

      if(br2 != 0.)
       {
	/*printw("skn-%d (%d) br2=%.2f %d  \n",skn,i*kka+ii+kkk+i2,br2,kka*kon);*/
        kolpr++;
	fprintf(kaw,"|%12.2f|%12.2f|%12.2f",nao[skn],nao1[skn],nao2[skn]);
       }
      else
       {
	i2++;
       }
      br1+=nao[skn];
      br11+=nao1[skn];
      br12+=nao2[skn];
     }
    if(kolpr > 1 || ii > 0)
      fprintf(kaw,"|%12.2f|%12.2f|%12.2f\n",br1,br11,br12);
    else
      fprintf(kaw,"\n");
    
    /*printw("%3d %-30s %.2f\n",zr2.tn,nai,br1);*/
   }
  fprintf(kaw,"%s\n",st);

  fprintf(kaw,"%-38s",gettext(" Итого"));

  i2=0;
  kolpr=0;
  for(i=ii; i<ii+kkol+i2 && i < kka ;i++)
   {
    br1=br2=br3=0.;
    for(skn=i;skn < kka*(kon-1)+ii+kkol+i2 && skn< kka*kon ; skn+=kka)
     {
      br1+=nao[skn];
      br2+=nao1[skn];
      br3+=nao2[skn];
     }
    if(br1 != 0.)
     {
       kolpr++;
       fprintf(kaw,"|%12.2f|%12.2f|%12.2f",br1,br2,br3);
     }
    else
      i2++;
    sn+=br1;
    sn1+=br2;
    sn2+=br3;
   }
  if(kolpr > 1 || ii > 0)
    fprintf(kaw,"|%12.2f|%12.2f|%12.2f\n",sn,sn1,sn2);
  else
      fprintf(kaw,"\n");

  printw(" %12.2f %12.2f %12.2f\n",sn,sn1,sn2);

  fprintf(kaw,"%s\n",st);
  fprintf(kaw,gettext("Сумма с НДС : %.10g\n"),sn2+sn2*pnds/100.);

  if(i == kka)
   break;
  ii+=i2;
 }
}

/***************/
/*Шапка таблицы*/
/***************/
void            sappk(int kk,int kka,char st[],
long pn, //Позиция начала
long pk, //Позиция конца
short konu, //Количество начислений или удержаний
double nao[],FILE *kaw,short tt,short mo)
{
int             i,i1,i2;
double          br1,br2;
short		kolpr;
SQL_str         row;
SQLCURSOR       cur;
char		strsql[512];
char		bros[512];

if(tt == 0)
 {
  if(kk == 1)
   {
    printw("%s\n---------------------------------------\n",
    gettext("Распечатываем приходы"));
    fprintf(kaw,"\n%s\n",gettext("Приходы."));
   }
  if(kk == 2)
   {
    printw("%s\n---------------------------------------\n",
    gettext("Распечатываем расходы"));
    fprintf(kaw,"\n%s\n",gettext("Расходы."));
   }
 }

if(tt == 1)
 {
  if(kk == 2)
   {
    printw("Розруковуем відходи\n---------------------------------------\n");
    fprintf(kaw,"\nОтходы.\n");
   }
  
 }
if(tt == 2)
 {
  if(kk == 1)
   {
    printw("%s\n---------------------------------------\n",
    gettext("Распечатываем группы материалов (приходы)."));
    fprintf(kaw,"\n%s\n",gettext("Группы (приходы)."));
   }
  if(kk == 2)
   {
    printw("%s\n---------------------------------------\n",
    gettext("Распечатываем группы материалов (расходы)."));
    fprintf(kaw,"\n%s\n",gettext("Группы (расходы)."));
   }
  
 }
refresh();
/*Формируем строку подчеркивания*/
/*Полка над наименованием*/
memset(st,'\0',sizeof(st));
strcpy(st,"--------------------------------------");
kolpr=i2=0;
for(i=pn; i< pk+i2 && i < kka; i++)
 {
  /*Если колонка нулевая не печатать*/
  br2=0.;
  for(i1=i; i1< kka*konu ; i1+=kka)
   {
     br2+=nao[i1];
   }
  if(br2 != 0. )
   {
    kolpr++;
    strcat(st,"-------------");
    strcat(st,"-------------");
    strcat(st,"-------------");
   }
  else
   i2++;
 }
/*Полка над ИТОГО*/
if(kolpr > 1 || i > 0)
 {
  strcat(st,"-------------");
  strcat(st,"-------------");
  strcat(st,"-------------");
 }
fprintf(kaw,"%s\n",st);
/*
if(tt == 2)
  fprintf(kaw," N |Код|%-30s","Найменування групи матеріала");
else
  fprintf(kaw," N |Код|%-30s","Найменування матеріала");
*/
if(tt == 2)
  fprintf(kaw,"%s%-*s",gettext(" N |Код|"),
  iceb_tu_kolbait(30,gettext("Наименование группы материалла")),gettext("Наименование группы материалла"));
else
  fprintf(kaw,"%s%-*s",gettext(" N |Код|"),
  iceb_tu_kolbait(30,gettext("Наименование материалла")),gettext("Наименование материалла"));

i2=0;

for(i=pn; i< pk+i2 && i < kka; i++)
 {
  /*Если колонка нулевая не печатать*/
  br2=0.;
  for(i1=i; i1< kka*konu ; i1+=kka)
   {
     br2+=nao[i1];
   }
  if(br2 == 0.)
   {
    i2++;
    continue;
   }
  if(kk == 1)
   {
    POLE(spoprp,bros,i+1,'#');
    sprintf(strsql,"select naik from Prihod where kod='%s'",
    bros);
   }
  if(kk == 2)
   {
    POLE(spoprr,bros,i+1,'#');
    sprintf(strsql,"select naik from Rashod where kod='%s'",
    bros);
   }
  if(sql_readkey(&bd,strsql,&row,&cur) != 1)
   {
    error2(20,0,1,"sapppk-Не найдена операция !");
   }

  fprintf(kaw,"| %-37.37s",row[0]);
 }

if(kolpr > 1 || i > 0) 
 {
  fprintf(kaw,"|%-38s\n",gettext(" Итого"));
 }
else
 fprintf(kaw,"|\n");

fprintf(kaw,"   |   |%-30s"," ");
   
i2=0;
for(i=pn; i< pk+i2 && i < kka; i++)
 {
  /*Если колонка нулевая не печатать*/
  br1=0.;
  for(i1=i; i1< kka*konu ; i1+=kka)
   {
    if((br1+=nao[i1]) != 0.)
     break;
   }
  if(br1 != 0.)
   { 
    if(mo < 2)
      fprintf(kaw,"| %-*s| %-*s| %-*s",
      iceb_tu_kolbait(11,gettext("Количетсво")),gettext("Количетсво"),
      iceb_tu_kolbait(11,gettext("Килограммы")),gettext("Килограммы"),
      iceb_tu_kolbait(11,gettext("Сумма (грн)")),gettext("Сумма (грн)"));
    if(mo == 2)
      fprintf(kaw,"| %-*s| %-*s| %-*s",
      iceb_tu_kolbait(11,gettext("Количетсво")),gettext("Количетсво"),
      iceb_tu_kolbait(11,gettext("Прибыль")),gettext("Прибыль"),
      iceb_tu_kolbait(11,gettext("Сумма (грн)")),gettext("Сумма (грн)"));
   }
  else
   i2++;
 }

if(kolpr > 1 || i > 0 )
 {
  if(mo < 2 )
      fprintf(kaw,"| %-*s| %-*s| %-*s\n",
      iceb_tu_kolbait(11,gettext("Количетсво")),gettext("Количетсво"),
      iceb_tu_kolbait(11,gettext("Килограммы")),gettext("Килограммы"),
      iceb_tu_kolbait(11,gettext("Сумма (грн)")),gettext("Сумма (грн)"));
  if(mo == 2)
      fprintf(kaw,"| %-*s| %-*s| %-*s\n",
      iceb_tu_kolbait(11,gettext("Количетсво")),gettext("Количетсво"),
      iceb_tu_kolbait(11,gettext("Прибыль")),gettext("Прибыль"),
      iceb_tu_kolbait(11,gettext("Сумма (грн)")),gettext("Сумма (грн)"));
 }
else
 fprintf(kaw,"|\n");

fprintf(kaw,"%s\n",st);
/*
printw("Шапка закончена.\n");
refresh();
*/
}

/*************************************************/
/*Программа печати информации в графическом виде*/
/*************************************************/
void		rasgraf(int kka, //Количество по горизонтали
int kon, //Количество по вертикали
double nao[],double nao1[],
double nao2[],int mkk[],FILE *kaw,short mm) //Метка массива 0-материалы 1-группы
{
unsigned short	i=0,i1=0,i2=0,i3=0,i4=0,i5=0,ii=0;
double		sbk; /*Самая большое количество*/
double		sbs; /*Самая большая сумма*/
double          sbkg; /*Самый больщой вес*/
double		br,br1,br2;
short		kod=0;
short		nums;
short		pr;
double		it1,it2,it3;
SQL_str         row;
SQLCURSOR        cur;
char		strsql[512];
char		bros[512];


/*Определить самую большую сумму по горизонтали для 
масштабирования остальных сумм*/

pr=0;
sbkg=sbs=sbk=0.;
for(i=0 ; i < kon; i++)
 {
  br=br1=br2=0.;
  for(i1=0; i1 < kka ; i1++)
   {
    br+=nao[i1+i*kka];
    br2+=nao1[i1+i*kka];
    br1+=nao2[i1+i*kka];
   }
  if(sbk < br)
   sbk=br;
  if(sbkg < br2)
   sbkg=br2;
  if(sbs < br1)
   sbs=br1;
 }
/*
printw("Найбільша кількість %.2f Найбільша сумма %.2f\n",sbk,sbs);
refresh();
*/

/*Распечатываем*/
nums=0;
for(ii=0; ii < 3; ii++)
 {
  pr=0;
  it1=it2=it3=nums=0;
  for(i=0 ; i < kon; i++)
   {
    br=br1=br2=0.;
    for(i1=0; i1 < kka ; i1++)
     {
      br+=nao[i1+i*kka];
      br1+=nao2[i1+i*kka];
      br2+=nao1[i1+i*kka];
     }
    if(br == 0.)
     continue;
    if(ii == 1 && br2 == 0.)
     continue;
  
    if(pr == 0)
      fprintf(kaw,"\
----------------------------------------------------------------------------------------------------------------\n");
    pr++;
    
    i2=(int)(br*50/sbk);
    i4=(int)(br1*50/sbs);    
    if(br2 != 0.)
      i5=(int)(br2*50/sbkg);  

    if(mm == 1)
     { 
      kod=mkk[i];
      sprintf(strsql,"select naik from Grup where kod=%d",
      mkk[i]);
      if(sql_readkey(&bd,strsql,&row,&cur) != 1)
       {
        error2(20,0,1,"rasgraf-Не найдена группа материалла !");
       }
      strcpy(bros,row[0]);

     }

    if(mm == 0)
     {
      kod=mko[i];
      sprintf(strsql,"select naimat from Material where kodm=%d",
      mko[i]);
      if(sql_readkey(&bd,strsql,&row,&cur) != 1)
        {
         error2(20,0,1,"rasgraf-Не найдено наименование материалла !");
        }
      strcpy(bros,row[0]);
     }      

    nums++;
    if(ii == 0)
     {
      fprintf(kaw,"%3d|%4d|%-*.*s|%*.*s|%15s|",
      nums,kod,
      iceb_tu_kolbait(30,bros),iceb_tu_kolbait(30,bros),bros,
      iceb_tu_kolbait(5,gettext("Колич")),iceb_tu_kolbait(5,gettext("Колич")),gettext("Колич"),
      prnbr(br));
      
      for(i3=0; i3 < i2 ; i3++) 
       fprintf(kaw,"*");
      
      fprintf(kaw,"\n"); 
      it1+=br;
     }
 
    if(ii == 1)
     {
      fprintf(kaw,"%3d|%4d|%-*.*s|%*.*s|%15s|",
      nums,
      kod,
      iceb_tu_kolbait(30,bros),iceb_tu_kolbait(30,bros),bros,
      iceb_tu_kolbait(5,gettext(" Кг. ")),iceb_tu_kolbait(5,gettext(" Кг. ")),gettext(" Кг. "),
      prnbr(br2));
      
      for(i3=0; i3 < i5 ; i3++) 
       fprintf(kaw,"*");
      fprintf(kaw,"\n"); 
      it1+=br2;
     }

    if(ii == 2)
     {
      fprintf(kaw,"%3d|%4d|%-*.*s|%*.*s|%15s|",
      nums,
      kod,
      iceb_tu_kolbait(30,bros),iceb_tu_kolbait(30,bros),bros,
      iceb_tu_kolbait(5,gettext("Рубл.")),iceb_tu_kolbait(5,gettext("Рубл.")),gettext("Рубл."),
      prnbr(br1));
      
      for(i3=0; i3 < i4 ; i3++) 
       fprintf(kaw,"*");
      
      fprintf(kaw,"\n"); 
      it1+=br1;
     }
   }
  if(pr != 0)
    fprintf(kaw,"\
-----------------------------------------------------------------------------------------------------------------\n\
%*s %15s\n",iceb_tu_kolbait(45,gettext("Итого")),gettext("Итого"),prnbr(it1));
 }


}
