/* $Id: matstat.c,v 5.2 2011-01-13 13:43:22 sasa1 Exp $ */
/*27.06.2001	17.03.1998	Белых А.И. makstat.c
Открытие массива для графического отображение динамики реализации
товаров за любой период времени
Если вернули 0 - массив выделен
             1 - нет
*/
#include        "buhg.h"

double		*mkdp; /*Массив динамики приходов*/
double		*mkdr; /*Массив динамики расходов*/

int		matstat(short dn,short mn,short gn,short dk,short mk,
short gk)
{
int             rmdp; /*Размер массива динамики продаж*/

/*В нулевой ячейке записан размер самого массива*/
rmdp=(31*12)*(gk-gn+1)+1;
/*
printw("rmdr=%d gk=%d gn=%d\n",rmdp,gk,gn);
OSTANOV();
*/
if((mkdp=(double*)calloc(rmdp,sizeof(double))) == NULL)
 { 
  error2(20,0,1,"Не могу выделить память для mkdp!!");
  return(1);
 }
if((mkdr=(double*)calloc(rmdp,sizeof(double))) == NULL)
 { 
  error2(20,0,1,"Не могу выделить память для mkdr!!");
  return(1);
 }

mkdp[0]=rmdp;
mkdr[0]=rmdp;

return(0);

}
