/*$Id: mord12.c,v 5.9 2011-01-13 13:43:22 sasa1 Exp $*/
/*12.10.2010	29.08.2007	Белых А.И.	mord12.c
Расчёт и распечатка мемориального ордера N12
*/
#include <errno.h>
#include <buhg.h>
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char     *organ;/*Наименование организации*/
extern short	startgodb; /*Стартовый год*/

int mord12(class spis_oth *oth)
{
char strsql[512];
static char shet_or[32];
static char dat1[11];
static char dat2[11];
int kom=0;

if(shet_or[0] == '\0')
 strcpy(shet_or,"232");

VVOD VV(0);

VV.VVOD_SPISOK_add_ZAG(organ,40);

VV.VVOD_SPISOK_add_ZAG(gettext("Расчет мемориального ордера N12."));

VV.VVOD_SPISOK_add_MD(gettext("Номер счета.................."));//0
VV.VVOD_SPISOK_add_MD(gettext("Дата начала........(д.м.г)..."));//1
VV.VVOD_SPISOK_add_MD(gettext("Дата конца.........(д.м.г)..."));//2

VV.VVOD_SPISOK_add_data(shet_or,sizeof(shet_or));
VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2));

naz:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F4",gettext("очистить"),
//"F5",gettext("настройка"),
"F10",gettext("выход"),NULL);      


kom=VV.vvod(0,1,1,-1,-1);

strncpy(shet_or,VV.VVOD_SPISOK_return_data(0),sizeof(shet_or)-1);
strncpy(dat1,VV.VVOD_SPISOK_return_data(1),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(2),sizeof(dat2)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
//   prosf(bros);
   goto naz;
 
  case FK2:
  case PLU:
    break;

  case FK4:
    VV.VVOD_clear_data();         
    goto naz;

  case FK5:
    goto naz;

  case FK10:
  case ESC:
    return(1);
     
  default:
   kom=0;
   goto naz;
 }

GDITE();

short dn,mn,gn;
short dk,mk,gk;

if(rsdatp(&dn,&mn,&gn,dat1,&dk,&mk,&gk,dat2) != 0)
  goto naz;



sprintf(strsql,"select sh,shk,kre,pod from Prov where datp >= '%04d-%02d-%02d' \
and datp <= '%04d-%02d-%02d' and sh like '%s%%' and kre <> 0. order by datp,nomd asc",gn,mn,dn,gk,mk,dk,shet_or);
int kolstr=0;

SQLCURSOR cur ;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

char imaf[56];
sprintf(imaf,"mord%d.lst",getpid());
FILE *ff;
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

fprintf(ff,"%s\n",organ);

fprintf(ff,"%32sТипова форма N 411-авт (бюджет)\n","");

iceb_t_insfil("mord_start.alx",ff);
fprintf(ff,"\n%15s Меморіальний ордер N12\n","");

fprintf(ff,"%5s за період з %02d.%02d.%d р. по %02d.%02d.%d р.\n","",dn,mn,gn,dk,mk,gk);

fprintf(ff,"\n\
   Зведення накопичувальних відомостей про витрачання\n\
                 продуктів харчування\n\n");

fprintf(ff,"\x1B\x4D"); /*12-знаков*/
//fprintf(ff,"\x0F");  /*Ужатый режим*/

fprintf(ff,"\
--------------------------------------------------------------------------------\n");
fprintf(ff,"\
  N  |Матеріально відповідальна особа (установа)|Кредіт суб.|Дебет  |  Сумма    |\n\
 з/п |                                          |%-*.*s|суб-ків|          |\n",
iceb_tu_kolbait(11,shet_or),iceb_tu_kolbait(11,shet_or),shet_or);
/*
12345 123456789012345678901234567890123456789012 12345678901 1234567 1234567890
*/
fprintf(ff,"\
--------------------------------------------------------------------------------\n");
int kolstr1=0;
class SPISOK shet_deb;
class SPISOK shet_kre;
class masiv_din_double sum_deb;
class masiv_din_double sum_kre;
SQL_str row,row1;
class SQLCURSOR cur1;
double itogo=0.;
int nomer_sh=0;
double suma=0.;
char mat_otv[100];
int nom_zap=0;

while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s %s %s\n",row[0],row[1],row[2],row[3]);
  
  strzag(LINES-1,0,kolstr,++kolstr1);
  memset(mat_otv,'\0',sizeof(mat_otv));  
  //Узнаём материально-ответственного
  sprintf(strsql,"select naik,fmol from Sklad where kod=%s",row[3]);
  if(readkey(strsql,&row1,&cur1) == 1)
    {
     if(row1[1][0] != '\0')
      strncpy(mat_otv,row1[1],sizeof(mat_otv)-1);    
     else
      strncpy(mat_otv,row1[0],sizeof(mat_otv)-1);    
    }
           
  suma=atof(row[2]);
  
  itogo+=suma;
    
  fprintf(ff,"%5d %-*.*s %-*s %-*s %10.2f\n",
  ++nom_zap,
  iceb_tu_kolbait(42,mat_otv),iceb_tu_kolbait(42,mat_otv),mat_otv,
  iceb_tu_kolbait(11,row[0]),row[0],
  iceb_tu_kolbait(7,row[1]),row[1],
  suma);


  if((nomer_sh=shet_deb.find(row[1])) < 0)
   shet_deb.plus(row[1]);        
  sum_deb.plus(suma,nomer_sh);

  if((nomer_sh=shet_kre.find(row[0])) < 0)
   shet_kre.plus(row[0]);        
  sum_kre.plus(suma,nomer_sh);

 }


fprintf(ff,"\
--------------------------------------------------------------------------------\n");
fprintf(ff,"%*s %10.2f\n",iceb_tu_kolbait(68,"Разом"),"Разом",itogo);

fprintf(ff,"\nУсього до кредіту субрахунків: Субсчёт   Сумма\n");
itogo=0.;                               
for(int ii=0; ii < shet_kre.kolih(); ii++)
 {
  fprintf(ff,"%30s %-*s %10.2f\n",
  "",
  iceb_tu_kolbait(10,shet_kre.ravno(ii)),shet_kre.ravno(ii),
  sum_kre.ravno(ii));
  itogo+=sum_kre.ravno(ii);
  
 }

fprintf(ff,"%30s ---------------------\n","");
fprintf(ff,"%30s %-*s %10.2f\n","",iceb_tu_kolbait(10,"Разом"),"Разом",itogo);


fprintf(ff,"\nУсього до дебету субрахунків: Субсчёт   Сумма\n");
itogo=0.;
for(int ii=0; ii < shet_deb.kolih(); ii++)
 {
  fprintf(ff,"%30s %-*s %10.2f\n",
  "",
  iceb_tu_kolbait(10,shet_deb.ravno(ii)),shet_deb.ravno(ii),
  sum_deb.ravno(ii));
  itogo+=sum_deb.ravno(ii);
  
 }

fprintf(ff,"%30s ---------------------\n","");
fprintf(ff,"%30s %-*s %10.2f\n","",iceb_tu_kolbait(10,"Разом"),"Разом",itogo);


//imafn("mord_end.alx",&imaf_alx);

fprintf(ff,"\n\n");
iceb_t_insfil("mord_end.alx",ff);
podpis(ff);
fclose(ff);

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus("Меморіальний ордер N12");

iceb_t_ustpeh(oth->spis_imaf.ravno(0),0);

return(0);


}



