/*$Id: muinv.c,v 5.35 2011-08-29 07:08:59 sasa Exp $*/
/*01.08.2011	10.08.2003	Белых А.И.	muinv.c
Распечатка инвентаризационных ведомостей для материального учета
*/

#include        <time.h>
#include        <math.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


extern double	okrg1;  /*Округление 1*/
extern double	okrcn;  /*Округление цены*/
extern char     *organ;/*Наименование организации*/

int muinv(class spis_oth *oth)
{
class ostatokt ost;
char		bros[512];
extern char	*maskmat; /*Массив кодов отмеченных материалов*/
struct  tm      *bf;
time_t          tmm;
static char	dat1[11];
static char	skladi[112];
static char	grupi[112];
static char	sheta[112];
static char	kodm[112];
short		dos,mos,gos;
int		kom=0,kom1=0;
int             metkainnom=0;
char		naim[512];
int		kgr=0,i=0;
char		strsql[512];

time(&tmm);
bf=localtime(&tmm);


if(dat1[0] == '\0')
  sprintf(dat1,"%d.%d.%d",bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900);

VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_data(skladi,sizeof(skladi));
VV.VVOD_SPISOK_add_data(grupi,sizeof(grupi));
VV.VVOD_SPISOK_add_data(sheta,sizeof(sheta));
VV.VVOD_SPISOK_add_data(kodm,sizeof(kodm));
VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));

VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка инвентаризационных ведомостей"));

VV.VVOD_SPISOK_add_MD(gettext("Склад.(,,)......."));
VV.VVOD_SPISOK_add_MD(gettext("Группа..(,,)....."));
VV.VVOD_SPISOK_add_MD(gettext("Счет....(,,)....."));
VV.VVOD_SPISOK_add_MD(gettext("Материал.(,,/*).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата остатка....."));

naz:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F5",gettext("доп.инфор."),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(skladi,VV.VVOD_SPISOK_return_data(0),sizeof(skladi)-1);
strncpy(grupi,VV.VVOD_SPISOK_return_data(1),sizeof(grupi)-1);
strncpy(sheta,VV.VVOD_SPISOK_return_data(2),sizeof(sheta)-1);
strncpy(kodm,VV.VVOD_SPISOK_return_data(3),sizeof(kodm)-1);
strncpy(dat1,VV.VVOD_SPISOK_return_data(4),sizeof(dat1)-1);
class iceb_tu_str kods("");
class iceb_tu_str naims("");
switch(kom)
 {
  case ESC:
  case FK10:
    return(1);
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("matu5_18.txt");
   clear();
   goto naz;

  case FK2:
  case PLU:
    break;

  case FK6: //Только карточки с инвентарными номеррами
    metkainnom=1;
    break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка складов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка материалов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 4 :
      case -1:
       goto naz;

      case 0 :
        //vibrek("Sklad",skladi,sizeof(skladi),naim);
        if(dirsklad(1,&kods,&naims) == 0)
         VV.data_z_plus(0,kods.ravno());
        goto naz;

      case 1 :
        vibrek("Grup",grupi,sizeof(grupi),naim);
        VV.VVOD_SPISOK_zapis_data(1,grupi);
        goto naz;

      case 2 :
        bros[0]='\0';
        if(dirmatr(&kgr,&i,&naims,1,0,bros,0,0) == 0)
         {
          VV.data_z_plus(3,i);
         }
        
        goto naz;

      case 3 :
        vibrek("Plansh",sheta,sizeof(sheta),naim);
        VV.VVOD_SPISOK_zapis_data(2,sheta);
        goto naz;
     }

  case FK4: /*Очистка меню*/
    VV.VVOD_clear_data();
    goto naz;    

  case FK5: /*Ввод дополнительной информации в шапку инвентаризационной ведомости*/
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите  нужное и нажмите Enter"));

    MENU.VVOD_SPISOK_add_MD(gettext("Настройка начала документа"));
    MENU.VVOD_SPISOK_add_MD(gettext("Настройка конца Приложения 12"));
    MENU.VVOD_SPISOK_add_MD(gettext("Настройка конца инвентаризационной описи"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;

      case 0 :
        iceb_redfil("inventm.alx",0);
        goto naz;

      case 1 :
        iceb_redfil("in_d12_end.alx",0);
        goto naz;

      case 2 :
        iceb_redfil("inved_end.alx",0);
        goto naz;

     }
    goto naz;    

  default:
    goto naz;    
 }


if(dat1[0] == '\0' || rsdat(&dos,&mos,&gos,dat1,0) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

GDITE();

time(&tmm);
bf=localtime(&tmm);

int kolstr=0;

sprintf(strsql,"select sklad,nomk,kodm,ei,shetu,cena,innom,datv,rnd from Kart order by sklad,shetu asc");
SQLCURSOR cur;
SQLCURSOR cur1;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной карточки !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
char imaf[56];
char imafipsh[56];
FILE *ff,*fftmp;
FILE *ffipsh;
char dopstr[1024];
char innom[32];
char regnom[32];
double cena=0.;
double summa=0.;
double ostatok=0.;
SQL_str row,row1;
int kgrm=0;
int i1=0;
int nk=0;
char ei[32];
short  dv,mv,gv;
int kolstriv=0,kollistiv=0;
int nomerstr=0;
char sklad[32];
char shetu[32];
double  kolihsklad=0.;
double  sumasklad=0.;
double  kolihshet=0.;
double  sumashet=0.;
char matot[512];
char mesqc[32];
char naish[512];
char artikul[64];
char imaftmp[32];

memset(matot,'\0',sizeof(matot));
memset(sklad,'\0',sizeof(sklad));
memset(shetu,'\0',sizeof(shetu));


memset(mesqc,'\0',sizeof(mesqc));
mesc(mos,1,mesqc);



sprintf(imaftmp,"iv%d.tmp",getpid());

if((fftmp = fopen(imaftmp,"w")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }

int kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);  

  if(proverka(skladi,row[0],0,0) != 0)
    continue;

  if(kodm[0] != '\0')
   {
    if(kodm[0] == '*' && maskmat != NULL)
     {
      if(proverka(maskmat,row[2],0,0) != 0)
        continue;
     }
    else
      if(proverka(kodm,row[2],0,0) != 0)
        continue;
   }

  if(proverka(sheta,row[4],0,0) != 0)
    continue;

  if(metkainnom == 1)
   if(row[6][0] == '\0')
     continue;

  memset(naim,'\0',sizeof(naim));
  memset(artikul,'\0',sizeof(artikul));
  kgrm=0;
  /*Узнаем наименование материалла*/
  sprintf(strsql,"select * from Material where kodm=%s",
  row[2]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    beep();
    printw("Не нашли наименование материалла по коду %s\n",row[2]);
    OSTANOV();
   }
  else
   {
    strncpy(naim,row1[2],sizeof(naim)-1);
    kgrm=atoi(row1[1]);
    strncpy(artikul,row1[14],sizeof(artikul)-1);
   }

  if(grupi[0] != '\0')
   {
    sprintf(bros,"%d",kgrm);
    if(pole1(grupi,bros,',',0,&i1) != 0)
     if(SRAV(grupi,bros,0) != 0)
        continue;
   }

  nk=atoi(row[1]);

  memset(ei,'\0',sizeof(ei));
  strncpy(ei,row[3],sizeof(ei)-1);
  ostkar(1,1,gos,dos,mos,gos,atoi(row[0]),nk,&ost);

  if(ost.ostg[3] < -0.0000001)
   {

    VVOD SOOB(1);
    sprintf(strsql,"%s !!!",gettext("Внимание"));
    SOOB.VVOD_SPISOK_add_MD(strsql);

    sprintf(strsql,"%s:%s %s:%d",gettext("Склад"),
    row[0],gettext("Карточка"),nk);
    SOOB.VVOD_SPISOK_add_MD(strsql);

    SOOB.VVOD_SPISOK_add_MD(gettext("Отрицательный остаток"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);

   }

  if(fabs(ost.ostg[3]) < 0.0000001 )
    continue;   
  
  fprintf(fftmp,"%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%10.10g|\n",
  row[0],row[4],naim,row[1],row[2],row[3],row[5],row[6],row[7],row[8],artikul,ost.ostg[3]);
//  1      2     3    4       5      6      7      8      9      10     11

//  sklad,nomk,kodm,ei,shetu,cena,innom,datv,rnd  
//    0    1    2   3    4     5    6    7    8 

 }
GDITE();
fclose(fftmp);

//Сортировка предпринята для того чтобы отсортировать и по наименованию
//sprintf(strsql,"sort -o %s -t\\|  +0n -1 +1n -2 +2 -3 %s",imaftmp,imaftmp);
sprintf(strsql,"sort -o %s -t\\|  -k1,2n -k2,3n -k3,4 %s",imaftmp,imaftmp);
runsystem1(strsql,1);


if((fftmp = fopen(imaftmp,"r")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }
unlink(imaftmp);

sprintf(imaf,"iv%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

sprintf(imafipsh,"ivs%d.lst",getpid());

if((ffipsh = fopen(imafipsh,"w")) == NULL)
 {
  error_op_nfil(imafipsh,errno,"");
  return(1);
 }

in_d12_start(ffipsh);

class SPISOK sp_shet;
class masiv_din_double sum_shet;
class masiv_din_double kol_shet;
class iceb_tu_str naim_skl("");
char stroka[1024];
char skladf[32];
char shetuf[32];
char cenaf[32];
char datvf[16];
int nomer_sheta;
while(fgets(stroka,sizeof(stroka),fftmp) != NULL)
 {
//  printw("%s",stroka);
//  OSTANOV();

  polen(stroka,skladf,sizeof(skladf),1,'|');
  polen(stroka,shetuf,sizeof(shetuf),2,'|');
  polen(stroka,naim,sizeof(naim),3,'|');
  polen(stroka,ei,sizeof(ei),6,'|');

  polen(stroka,cenaf,sizeof(cenaf),7,'|');
  polen(stroka,innom,sizeof(innom),8,'|');
  polen(stroka,datvf,sizeof(datvf),9,'|');
  polen(stroka,regnom,sizeof(regnom),10,'|');
  polen(stroka,artikul,sizeof(artikul),11,'|');
  polen(stroka,strsql,sizeof(strsql),12,'|');
  ostatok=atof(strsql);
  
  if(SRAV(sklad,skladf,0) != 0)
   {
    
    if(sklad[0] != '\0')
     {

      sapkk1iv(&kolstriv,&kollistiv,ff);
      fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
      sapkk1iv(&kolstriv,&kollistiv,ff);
      fprintf(ff,"%-*s %10.10g %10.2f\n",iceb_tu_kolbait(62,gettext("Итого по счету")),gettext("Итого по счету"),kolihshet,sumashet);

      //fprintf(ffipsh,"%-20s %10.10g %10.2f\n",gettext("Итого по счету"),kolihshet,sumashet);
      if((nomer_sheta=sp_shet.find(shetu)) < 0)
       sp_shet.plus(shetu);
      sum_shet.plus(sumashet,nomer_sheta);      
      kol_shet.plus(kolihshet,nomer_sheta);      

      sapkk1iv(&kolstriv,&kollistiv,ff);
      fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
      sapkk1iv(&kolstriv,&kollistiv,ff);
      fprintf(ff,"%-*s %10.10g %10.2f\n",iceb_tu_kolbait(62,gettext("Итого по складу")),gettext("Итого по складу"),kolihsklad,sumasklad);

//      fprintf(ffipsh,"%-20s %10.10g %10.2f\n",gettext("Итого по складу"),kolihsklad,sumasklad);

      koncinv(mesqc,gos,ff);

      fprintf(ff,"\f");
     }
    naim_skl.new_plus("");
    memset(matot,'\0',sizeof(matot));
    sprintf(strsql,"select naik,fmol from Sklad where kod=%s",skladf);
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не найден склад %d в списке складов !"),atoi(skladf));
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
     }
    else
     {
      strncpy(matot,row1[1],sizeof(matot)-1);
      naim_skl.new_plus(row1[0]);
     }
    sprintf(strsql,"%s:%s %s",gettext("Склад"),skladf,naim_skl.ravno());     
    kolstriv=0;
    sapvin(matot,mesqc,gos,gos,&kolstriv,&kollistiv,strsql,ff);


    kolihsklad=sumasklad=0.;
    strcpy(sklad,skladf);
    memset(shetu,'\0',sizeof(shetu));
   }

  if(SRAV(shetu,shetuf,0) != 0)
   {
    if(shetu[0] != '\0')
     {
      sapkk1iv(&kolstriv,&kollistiv,ff);
      fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
      sapkk1iv(&kolstriv,&kollistiv,ff);
      fprintf(ff,"%-*s %10.10g %10.2f\n",iceb_tu_kolbait(62,gettext("Итого по счету")),gettext("Итого по счету"),kolihshet,sumashet);
      if((nomer_sheta=sp_shet.find(shetu)) < 0)
       sp_shet.plus(shetu);
      sum_shet.plus(sumashet,nomer_sheta);      
      kol_shet.plus(kolihshet,nomer_sheta);      
     }
    memset(naish,'\0',sizeof(naish));
    //Читаем наименование счета
    sprintf(strsql,"select nais from Plansh where ns='%s'",shetuf);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
      strncpy(naish,row1[0],sizeof(naish)-1);
                  
    sapkk1iv(&kolstriv,&kollistiv,ff);
    fprintf(ff,"\n");
    sapkk1iv(&kolstriv,&kollistiv,ff);

    fprintf(ff,"%s: %s %s\n",gettext("Счет"),shetuf,naish);

//    fprintf(ffipsh,"%s: %s %s\n",gettext("Счет"),shetuf,naish);

    kolihshet=sumashet=0.;
    strcpy(shetu,shetuf);
   }

  cena=atof(cenaf);
  cena=okrug(cena,okrcn);
  
  summa=ostatok*cena;
  summa=okrug(summa,okrg1);
  
  kolihsklad+=ostatok;
  sumasklad+=summa;
  kolihshet+=ostatok;
  sumashet+=summa;
  
  
  rsdat(&dv,&mv,&gv,datvf,2);

  memset(dopstr,'\0',sizeof(dopstr));
  
  if(innom[0] != '\0')
   {
    if( regnom[0] == '\0')
     {
      sprintf(dopstr,"%s:%s",gettext("Инвентарный номер"),innom);
      if(dv != 0)
       {
        memset(bros,'\0',sizeof(bros));
        sprintf(bros," %s:%d.%d.%d%s",
        gettext("Дата ввода в эксплуатацию"),
        dv,mv,gv,gettext("г."));
        strcat(dopstr,bros);
       }
     }
    else
     {
      sprintf(dopstr,"%s:%s",gettext("Регистрационный номер"),regnom);
      memset(bros,'\0',sizeof(bros));
      sprintf(bros," %s:%s",gettext("Серия"),innom);
      strcat(dopstr,bros);
      if(dv != 0)
       {
        memset(bros,'\0',sizeof(bros));
        sprintf(bros," %s:%d.%d.%d%s",
        gettext("Дата регистрации"),
        dv,mv,gv,gettext("г."));
        strcat(dopstr,bros);
       }
     }
   }
  if(artikul[0] != '\0')
   {
    sprintf(strsql," %s:%s",gettext("Артикул"),artikul);
    strcat(dopstr,strsql);
   }

  sapkk1iv(&kolstriv,&kollistiv,ff);
  
  fprintf(ff,"%4d|%-*.*s|%-*s|%10.10g|%10.10g|%10.2f|%10s|%10s|%10s|%10s|\n",
  ++nomerstr,
  iceb_tu_kolbait(39,naim),iceb_tu_kolbait(39,naim),naim,
  iceb_tu_kolbait(6,ei),ei,
  cena,ostatok,summa," "," "," "," ");

  if(dopstr[0] != '\0')
   {
    sapkk1iv(&kolstriv,&kollistiv,ff);
    fprintf(ff,"%s\n",dopstr);
   }
  sapkk1iv(&kolstriv,&kollistiv,ff);
  fprintf(ff,"\
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");



 }
fclose(fftmp);
fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,"\
%-*s %10.10g %10.2f\n",iceb_tu_kolbait(62,gettext("Итого по счету")),gettext("Итого по счету"),kolihshet,sumashet);

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,"\
%-*s %10.10g %10.2f\n",iceb_tu_kolbait(62,gettext("Итого по складу")),gettext("Итого по складу"),kolihsklad,sumasklad);


/*Распечатка формы додаток 12*/
in_d12_it(&sp_shet,&kol_shet,&sum_shet,ffipsh);

koncinv(mesqc,gos,ff);
podpis(ff);

fclose(ff);

iceb_t_insfil("in_d12_end.alx",ffipsh);
podpis(ffipsh);
fclose(ffipsh);

sprintf(strsql,"%s %s",imaf,imafipsh);

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Распечатка инвентаризационных ведомостей"));
oth->spis_imaf.plus(imafipsh);
oth->spis_naim.plus(gettext("Дополнение 12"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);
}





