/*$Id: opss.c,v 5.29 2011-01-13 13:43:22 sasa1 Exp $*/
/*03.12.2010	20.03.2005	Белых А.И.	opss.c
Отчёт по счетам списания материаллов
*/
#include        <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif
class opss_svt
 {
  public:
   class masiv_din_int kod_mat;
   class SPISOK sheta_spis;
   class masiv_din_double sum_svt;
  
 };

class opss_kodm_ei
 {
  public:
   class SPISOK kodm_ei;
   class SPISOK sheta_spis;
   class masiv_din_double suma;
   class masiv_din_double kolih;
   class masiv_din_double gori_kolih;  
   class masiv_din_double gori_suma;  
 };
class opss_svt_shet
 {
  public:
   class SPISOK kod_gr_shet;
   class SPISOK sheta_spis;
   class masiv_din_double sum_svt;
  
 };
 

void opss_h(int *nomlist,int *kol_str,FILE *ff);
void opss_itogo(int metka,char *kod,double itog,FILE *ff);
void opps_shet_str(int *nomlist,int *kol_str,FILE *ff);
void opss_rrp(int *kol_str,const char *sklad_p,const char *shets_p,const char *shetu_p,const char *grupa_p,const char *kodmat_p,const char *kodop_p,const char *kontr_p,const char *artikul,FILE *ff);
void opss_rsvt(int metka_oth,short dn,short mn,short gn,short dk,short mk,short gk,class opss_svt *svt,const char *sklad_p,const char *shets_p,const char *shetu_p,const char *grupa_p,const char *kodmat_p,const char *kodop_p,const char *kontr_p,const char *artikul,char *imaf);
void opss_rsvt_shet(short dn,short mn,short gn,short dk,short mk,short gk,class opss_svt_shet *svt,const char *sklad_p,const char *shets_p,const char *shetu_p,const char *grupa_p,const char *kodmat_p,const char *kodop_p,const char *kontr_p,const char *artikul,char *imaf);
void opss_ei_kolih(short dn,short mn,short gn,short dk,short mk,short gk,class opss_kodm_ei *svt,const char *sklad_p,const char *shets_p,const char *shetu_p,const char *grupa_p,const char *kodmat_p,const char *kodop_p,const char *kontr_p,const char *artikul,char *imaf);

extern char     *organ;/*Наименование организации*/
extern double	okrcn;  /*Округление цены*/
extern double	okrg1;  /*Округление 1*/
extern int kol_strok_na_liste;

int opss(class spis_oth *oth)
{
static char     dat1[11],dat2[11];
static class iceb_tu_str sklad_p("");
static class iceb_tu_str shets_p(""); //Счёт списания 
static class iceb_tu_str shetu_p(""); //Счёт учёта
static class iceb_tu_str grupa_p("");
static class iceb_tu_str kodmat_p("");
static class iceb_tu_str kodop_p("");
static class iceb_tu_str kontr_p("");;
static class iceb_tu_str artikul("");;
class iceb_tu_str naim("");
int kodm;
int kgr;
char strsql[512];
int kom=0;
int kom1=0;

VVOD MENU(3);
VVOD VV(0);

VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(dat2,11);
VV.VVOD_SPISOK_add_data(shets_p.ravno(),112);
VV.VVOD_SPISOK_add_data(shetu_p.ravno(),112);
VV.VVOD_SPISOK_add_data(sklad_p.ravno(),112);
VV.VVOD_SPISOK_add_data(grupa_p.ravno(),112);
VV.VVOD_SPISOK_add_data(kodmat_p.ravno(),112);
VV.VVOD_SPISOK_add_data(kodop_p.ravno(),112);
VV.VVOD_SPISOK_add_data(kontr_p.ravno(),112);
VV.VVOD_SPISOK_add_data(artikul.ravno(),112);

VV.VVOD_SPISOK_add_ZAG(gettext("Движение товарно-материальных ценностей по счетам списания"));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала...(д.м.г)..."));//0
VV.VVOD_SPISOK_add_MD(gettext("Дата конца....(д.м.г)..."));//1
VV.VVOD_SPISOK_add_MD(gettext("Счет списания.(,,)......"));//2
VV.VVOD_SPISOK_add_MD(gettext("Счет учёта..(,,)........"));//3
VV.VVOD_SPISOK_add_MD(gettext("Склад..(,,)............."));//4
VV.VVOD_SPISOK_add_MD(gettext("Группа материалов.(,,).."));//5
VV.VVOD_SPISOK_add_MD(gettext("Код материалла...(,,)..."));//6
VV.VVOD_SPISOK_add_MD(gettext("Код операции....(,,)...."));//7
VV.VVOD_SPISOK_add_MD(gettext("Код контрагента.(,,)...."));//8
VV.VVOD_SPISOK_add_MD(gettext("Артикул.........(,,)...."));//9



naz:;
clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,0,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
shets_p.new_plus(VV.VVOD_SPISOK_return_data(2));
shetu_p.new_plus(VV.VVOD_SPISOK_return_data(3));
sklad_p.new_plus(VV.VVOD_SPISOK_return_data(4));
grupa_p.new_plus(VV.VVOD_SPISOK_return_data(5));
kodmat_p.new_plus(VV.VVOD_SPISOK_return_data(6));
kodop_p.new_plus(VV.VVOD_SPISOK_return_data(7));
kontr_p.new_plus(VV.VVOD_SPISOK_return_data(8));
artikul.new_plus(VV.VVOD_SPISOK_return_data(9));
class iceb_tu_str kods("");
class iceb_tu_str naims("");
switch (kom)
 {

  case FK10:
  case ESC:
   return(1);

  case FK1:
    GDITE();
    iceb_t_pdoc("matu5_19.txt");
    clear();
    goto naz;

  case FK2:
  case PLU:
    break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка складов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка контрагентов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операцій расходов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка материалов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 6 :
      case -1:
       goto naz;

      case 0 :
        if(dirsklad(1,&kods,&naims) == 0)
         VV.data_z_plus(4,kods.ravno());
        goto naz;

      case 1 :
        vibrek("Kontragent",&kontr_p,&naim);
        VV.VVOD_SPISOK_zapis_data(8,kontr_p.ravno());
        goto naz;

      case 2 :
        vibrek("Grup",&grupa_p,&naim);
        VV.VVOD_SPISOK_zapis_data(5,grupa_p.ravno());
        goto naz;

      case 3 :
        vibrek("Rashod",&kodop_p,&naim);
        VV.VVOD_SPISOK_zapis_data(7,kodop_p.ravno());
        goto naz;
        
      case 4 :
        strsql[0]='\0';
        if(dirmatr(&kgr,&kodm,&naims,1,0,strsql,0,0) == 0)
         {
          VV.data_z_plus(6,kodm);
         }
        
        goto naz;

      case 5 :
        vibrek("Plansh",&naims,&naim);
        goto naz;

     }
    goto naz;

  case FK4:
    VV.VVOD_clear_data();
    goto naz;
     
  default:
    goto naz;
 }
short dn,mn,gn;
short dk,mk,gk;

if(rsdatp(&dn,&mn,&gn,VV.VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
  goto naz;

sprintf(strsql,"select datd,sklad,nomd,nomkar,kodm,kolih,cena,ei,shet from Dokummat1 \
where datd >= '%04d-%02d-%02d' and datd <= '%04d-%02d-%02d' and \
nomkar <> 0 and tipz=2 order by shet asc",
gn,mn,dn,gk,mk,dk);

int kolstr;
SQL_str row;
SQLCURSOR cur;
SQL_str row1;
SQLCURSOR cur1;

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
char imaf_tmp[56];

sprintf(imaf_tmp,"opss%d.tmp",getpid());
FILE *ff_tmp;

if((ff_tmp = fopen(imaf_tmp,"w")) == NULL)
 {
  error_op_nfil(imaf_tmp,errno,"");
  return(1);
 }

char kodop[32];
char kontr[32];
char shet_uheta[56];
char shet_sp[24];
double kolih;
short dd,md,gd;
char kod_grup[24];
int kolstr1=0;
class opss_svt svt; //по кодам материалов
class opss_svt svtg; //по группам материалов
class opss_kodm_ei svt_ei; /*по кодам материалов-единиц измерения */

class opss_svt_shet svtg_shets; //по группам материалов и счетам учёта



while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);  

  if(proverka(shets_p.ravno(),row[8],1,0) != 0)
    continue;  
  if(proverka(sklad_p.ravno(),row[1],0,0) != 0)
    continue;  

  if(proverka(kodmat_p.ravno(),row[4],0,0) != 0)
    continue;  

  //читаем материал
  naim.new_plus("");
  memset(kod_grup,'\0',sizeof(kod_grup));
  sprintf(strsql,"select kodgr,naimat,artikul from Material where kodm=%s",row[4]);
  if(readkey(strsql,&row1,&cur1) == 1)
   {
    naim.new_plus(row1[1]);
    if(proverka(grupa_p.ravno(),row1[0],0,0) != 0)
      continue;  
    if(proverka(artikul.ravno(),row1[2],0,0) != 0)
      continue;  
    strncpy(kod_grup,row1[0],sizeof(kod_grup)-1);
   }
  memset(kodop,'\0',sizeof(kodop));
  memset(kontr,'\0',sizeof(kontr));
  
  //читаем шапку документа
  sprintf(strsql,"select kontr,kodop from Dokummat where datd='%s' and sklad=%s and \
nomd='%s'",row[0],row[1],row[2]);
  if(readkey(strsql,&row1,&cur1) == 1)
   {
    if(proverka(kodop_p.ravno(),row1[1],0,0) != 0)
      continue;  
    if(proverka(kontr_p.ravno(),row1[0],0,0) != 0)
      continue;  
    strncpy(kodop,row1[1],sizeof(kodop)-1);
    strncpy(kontr,row1[0],sizeof(kontr)-1);
   }

  rsdat(&dd,&md,&gd,row[0],2);
  kolih=readkolk(atoi(row[1]),atoi(row[3]),dd,md,gd,row[2]);  
  if(kolih == 0.)
   continue;
   
  memset(shet_uheta,'\0',sizeof(shet_uheta));

  sprintf(strsql,"select shetu from Kart where sklad=%s and nomk=%s",row[1],row[3]);
  if(readkey(strsql,&row1,&cur1) == 1)
   {
     if(proverka(shetu_p.ravno(),row1[0],1,0) != 0)
      continue;  
    strncpy(shet_uheta,row1[0],sizeof(shet_uheta)-1);    
   }
  else
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найденa карточка !"));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }

  memset(shet_sp,'\0',sizeof(shet_sp));
  strncpy(shet_sp,row[8],sizeof(shet_sp)-1);
  if(shet_sp[0] == '\0')
   strcpy(shet_sp,"???");

  fprintf(ff_tmp,"%s|%s|%s|%s|%s|%s|%s|%s|%.10g|%s|%s|%s|%s|%s|\n",
  shet_sp,kod_grup,shet_uheta,
  row[0],row[1],row[2],row[3],row[4],kolih,row[6],row[7],
  kodop,kontr,naim.ravno());

  if(svt.kod_mat.find(row[4]) < 0)
   svt.kod_mat.plus(row[4]);
  if(svt.sheta_spis.find(shet_sp) < 0)
   svt.sheta_spis.plus(shet_sp);

  if(svtg.kod_mat.find(kod_grup) < 0)
   svtg.kod_mat.plus(kod_grup);
  if(svtg.sheta_spis.find(shet_sp) < 0)
   svtg.sheta_spis.plus(shet_sp);
   
  sprintf(strsql,"%s|%s",kod_grup,shet_uheta);
  if(svtg_shets.kod_gr_shet.find(strsql) < 0)
   svtg_shets.kod_gr_shet.plus(strsql);
  if(svtg_shets.sheta_spis.find(shet_sp) < 0)
   svtg_shets.sheta_spis.plus(shet_sp);

  sprintf(strsql,"%s|%s",row[4],row[7]);
  if(svt_ei.kodm_ei.find(strsql) < 0)
   svt_ei.kodm_ei.plus(strsql);   
  if(svt_ei.sheta_spis.find(shet_sp) < 0)
   svt_ei.sheta_spis.plus(shet_sp);   
  
 }

fclose(ff_tmp);

//sprintf(strsql,"sort -o %s -t\\| -n +0 -3 %s",imaf_tmp,imaf_tmp);
//runsystem1(strsql,1);
sprintf(strsql,"sort -o %s -t\\| -n -k1,4 %s",imaf_tmp,imaf_tmp);
iceb_t_system(strsql,0);

if((ff_tmp = fopen(imaf_tmp,"r")) == NULL)
 {
  error_op_nfil(imaf_tmp,errno,"");
  return(1);
 }
unlink(imaf_tmp);
char imaf[56];
FILE *ff;

sprintf(imaf,"opss%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }
int kol_str=0;

zagolov(gettext("Движение товарно-материальных ценностей по счетам списания"),dn,mn,gn,dk,mk,gk,organ,ff);
kol_str=5;

//Распечатка реквизитов поиска
opss_rrp(&kol_str,sklad_p.ravno(),shets_p.ravno(),shetu_p.ravno(),grupa_p.ravno(),kodmat_p.ravno(),kodop_p.ravno(),kontr_p.ravno(),artikul.ravno(),ff);

int nomlist=0;

//Шапка 

opss_h(&nomlist,&kol_str,ff);


double suma;
double cena;
char shet_sp_z[24];
char shet_uheta_z[24];
memset(shet_sp_z,'\0',sizeof(shet_sp_z));
memset(shet_uheta_z,'\0',sizeof(shet_uheta_z));
double itogo_shetu=0.;
double itogo_shets=0.;
double itogo_kod_grup=0.;
char stroka[1024];
char datd[24];
char sklad[24];
char nomd[24];
char kodmat[24];
char ei[32];
char kod_grup_z[24];
memset(kod_grup_z,'\0',sizeof(kod_grup_z));

svt.sum_svt.make_class(svt.kod_mat.kolih()*svt.sheta_spis.kolih());
svtg.sum_svt.make_class(svtg.kod_mat.kolih()*svtg.sheta_spis.kolih());
svtg_shets.sum_svt.make_class(svtg_shets.kod_gr_shet.kolih()*svtg_shets.sheta_spis.kolih());

svt_ei.kolih.make_class(svt_ei.kodm_ei.kolih()*svt_ei.sheta_spis.kolih());
svt_ei.suma.make_class(svt_ei.kodm_ei.kolih()*svt_ei.sheta_spis.kolih());
svt_ei.gori_kolih.make_class(svt_ei.sheta_spis.kolih());
svt_ei.gori_suma.make_class(svt_ei.sheta_spis.kolih());
int nomer_kod_mat=0;
int nomer_sheta_spis=0;

while(fgets(stroka,sizeof(stroka),ff_tmp) != NULL)
 {
//  printw("%s",stroka);
  polen(stroka,shet_sp,sizeof(shet_sp),1,'|');
  polen(stroka,kod_grup,sizeof(kod_grup),2,'|');
  polen(stroka,shet_uheta,sizeof(shet_uheta),3,'|');


  polen(stroka,datd,sizeof(datd),4,'|');
  rsdat(&dd,&md,&gd,datd,2);

  polen(stroka,sklad,sizeof(sklad),5,'|');
  polen(stroka,nomd,sizeof(nomd),6,'|');

  polen(stroka,kodmat,sizeof(kodmat),8,'|');

  polen(stroka,strsql,sizeof(strsql),9,'|');
  kolih=atof(strsql);

  polen(stroka,strsql,sizeof(strsql),10,'|');
  cena=atof(strsql);

  polen(stroka,ei,sizeof(ei),11,'|');

  polen(stroka,kodop,sizeof(kodop),12,'|');

  polen(stroka,kontr,sizeof(kontr),13,'|');

  polen(stroka,&naim,14,'|');

  if(SRAV(kod_grup_z,kod_grup,0) != 0)
   {
    if(kod_grup_z[0] != '\0')
     {

      opps_shet_str(&nomlist,&kol_str,ff);
      opss_itogo(3,kod_grup_z,itogo_kod_grup,ff);
      itogo_kod_grup=0.;

     }    
    strcpy(kod_grup_z,kod_grup);
   }

  if(SRAV(shet_uheta_z,shet_uheta,0) != 0)
   {
    if(shet_uheta_z[0] != '\0')
     {

      opps_shet_str(&nomlist,&kol_str,ff);
      opss_itogo(1,shet_uheta_z,itogo_shetu,ff);
      itogo_shetu=0.;

      opps_shet_str(&nomlist,&kol_str,ff);
      fprintf(ff,"\n");
     }    
    strcpy(shet_uheta_z,shet_uheta);
   }

  if(SRAV(shet_sp_z,shet_sp,0) != 0)
   {
    if(shet_sp_z[0] != '\0')
     {

      opps_shet_str(&nomlist,&kol_str,ff);
      opss_itogo(1,shet_uheta_z,itogo_shetu,ff);
      itogo_shetu=0.;

      
      opps_shet_str(&nomlist,&kol_str,ff);
      opss_itogo(3,kod_grup_z,itogo_kod_grup,ff);
      itogo_kod_grup=0.;

      opps_shet_str(&nomlist,&kol_str,ff);
      opss_itogo(2,shet_sp_z,itogo_shets,ff);
      itogo_shets=0.;

      
//      memset(kod_grup_z,'\0',sizeof(kod_grup_z));
      
      opps_shet_str(&nomlist,&kol_str,ff);
      fprintf(ff,"\n");
     }    
    strcpy(shet_sp_z,shet_sp);
   }

  
  cena=okrug(cena,okrcn);
  
  suma=cena*kolih;
  suma=okrug(suma,okrg1);
  itogo_shetu+=suma;
  itogo_shets+=suma;  
  itogo_kod_grup+=suma;
  
  opps_shet_str(&nomlist,&kol_str,ff);

  fprintf(ff,"%-8s %-*.*s %-*s %-*s %10.2f %-6s %8.8g %10.10g %02d.%02d.%d %-*s %-5s %-*s %-*s\n",
  kodmat,
  iceb_tu_kolbait(20,naim.ravno()),iceb_tu_kolbait(20,naim.ravno()),naim.ravno(),
  iceb_tu_kolbait(10,shet_sp),shet_sp,
  iceb_tu_kolbait(10,shet_uheta),shet_uheta,
  suma,ei,kolih,cena,dd,md,gd,
  iceb_tu_kolbait(9,nomd),nomd,
  sklad,
  iceb_tu_kolbait(6,kodop),kodop,
  iceb_tu_kolbait(7,kontr),kontr);

  nomer_kod_mat=svt.kod_mat.find(kodmat);
  nomer_sheta_spis=svt.sheta_spis.find(shet_sp);
  svt.sum_svt.plus(suma,nomer_kod_mat*svt.sheta_spis.kolih()+nomer_sheta_spis);

  nomer_kod_mat=svtg.kod_mat.find(kod_grup);
  nomer_sheta_spis=svtg.sheta_spis.find(shet_sp);
  svtg.sum_svt.plus(suma,nomer_kod_mat*svtg.sheta_spis.kolih()+nomer_sheta_spis);
  
  sprintf(strsql,"%s|%s",kod_grup,shet_uheta);
  nomer_kod_mat=svtg_shets.kod_gr_shet.find(strsql);
  nomer_sheta_spis=svtg_shets.sheta_spis.find(shet_sp);
  svtg_shets.sum_svt.plus(suma,nomer_kod_mat*svtg_shets.sheta_spis.kolih()+nomer_sheta_spis);

  sprintf(strsql,"%s|%s",kodmat,ei);
  nomer_kod_mat=svt_ei.kodm_ei.find(strsql);
  nomer_sheta_spis=svt_ei.sheta_spis.find(shet_sp);
  svt_ei.suma.plus(suma,nomer_kod_mat*svt_ei.sheta_spis.kolih()+nomer_sheta_spis);
  svt_ei.kolih.plus(kolih,nomer_kod_mat*svt_ei.sheta_spis.kolih()+nomer_sheta_spis);
  svt_ei.gori_kolih.plus(kolih,nomer_sheta_spis);    
  svt_ei.gori_suma.plus(suma,nomer_sheta_spis);    
 }

GDITE();

fclose(ff_tmp);



opss_itogo(3,kod_grup_z,itogo_kod_grup,ff);
opss_itogo(1,shet_uheta_z,itogo_shetu,ff);
opss_itogo(2,shet_sp_z,itogo_shets,ff);

podpis(ff);

fclose(ff);

char imaf_svt[56];
opss_rsvt(0,dn,mn,gn,dk,mk,gk,&svt,sklad_p.ravno(),shets_p.ravno(),shetu_p.ravno(),grupa_p.ravno(),kodmat_p.ravno(),kodop_p.ravno(),kontr_p.ravno(),artikul.ravno(),imaf_svt);


char imaf_svtg[56];
opss_rsvt(1,dn,mn,gn,dk,mk,gk,&svtg,sklad_p.ravno(),shets_p.ravno(),shetu_p.ravno(),grupa_p.ravno(),kodmat_p.ravno(),kodop_p.ravno(),kontr_p.ravno(),artikul.ravno(),imaf_svtg);

char imaf_svtg_shet[56];
opss_rsvt_shet(dn,mn,gn,dk,mk,gk,&svtg_shets,sklad_p.ravno(),shets_p.ravno(),shetu_p.ravno(),grupa_p.ravno(),kodmat_p.ravno(),kodop_p.ravno(),kontr_p.ravno(),artikul.ravno(),imaf_svtg_shet);

char imaf_ei[56];
opss_ei_kolih(dn,mn,gn,dk,mk,gk,&svt_ei,sklad_p.ravno(),shets_p.ravno(),shetu_p.ravno(),grupa_p.ravno(),kodmat_p.ravno(),kodop_p.ravno(),kontr_p.ravno(),artikul.ravno(),imaf_ei);

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Движение товарно-материальных ценностей по счетам списания"));
oth->spis_imaf.plus(imaf_svt);
oth->spis_naim.plus(gettext("Общий итог"));

oth->spis_imaf.plus(imaf_svtg);
oth->spis_naim.plus(gettext("Общий итог по группам материалла"));
oth->spis_imaf.plus(imaf_svtg_shet);
oth->spis_naim.plus(gettext("Общий итог по счетам учёта-счетам списания"));
oth->spis_imaf.plus(imaf_ei);
oth->spis_naim.plus(gettext("Общий итог по счетам с количеством"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);
 
}

/********************************/
/*шапка*/
/**********************************/

void opss_h(int *nomlist,int *kol_str,FILE *ff)
{
*nomlist+=1;
fprintf(ff,"%110s%s N%d\n","",gettext("Лист"),*nomlist);
fprintf(ff,"\
------------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,gettext("\
  Код   |    Наименование    |  Счёт    |   Счёт   |   Сумма  |Един. |Количec-|   Цена   |   Дата   |Номер    |Склад|Опера-|Контра-|\n"));
fprintf(ff,gettext("\
материа.|     материалла     |списания  |  учёта   |          |измер.|  тво   |          | документа|документа|     |ция   |гент   |\n"));

fprintf(ff,"\
------------------------------------------------------------------------------------------------------------------------------------\n");
*kol_str+=5;


}

/*****************************/
/*Выдача итога*/
/*****************************/

void opss_itogo(int metka, //1-счёт учёта 2-счёт списания 3-по коду группы
char *kod,double itog,FILE *ff)
{
if(itog == 0.)
 return;
 
char bros[512];
if(metka == 1)
  sprintf(bros,"%s %s",gettext("Итого по счёту учёта"),kod);
if(metka == 2)
  sprintf(bros,"%s %s",gettext("Итого по счёту списания"),kod);

if(metka == 3) //По коду группы
 {
  SQL_str row;
  class SQLCURSOR cur;
  char strsql[512];
  char naim[112];
  memset(naim,'\0',sizeof(naim));
  sprintf(strsql,"select naik from Grup where kod=%s",kod);
  if(readkey(strsql,&row,&cur) == 1)
    strncpy(naim,row[0],sizeof(naim)-1);
  sprintf(bros,"%s %s %s",gettext("Итого по группе"),kod,naim);

 }

fprintf(ff,"%*.*s:%10.2f\n",
iceb_tu_kolbait(51,bros),iceb_tu_kolbait(51,bros),bros,itog);

}
/************************/
/*Счётчик строк*/
/*************************/

void opps_shet_str(int *nomlist,int *kol_str,FILE *ff)
{
*kol_str+=1;
if(*kol_str <= kol_strok_na_liste)
 return;

fprintf(ff,"\f");
*kol_str=0;
opss_h(nomlist,kol_str,ff);
*kol_str+=1;
}
/********************************/
/*Распечатка сводной таблицы*/
/******************************/
void opss_rsvt(int metka_oth, //0-по кодам материалов 1-по кодам групп материалов
short dn,short mn,short gn,
short dk,short mk,short gk,
class opss_svt *svt,
const char *sklad_p,
const char *shets_p,
const char *shetu_p,
const char *grupa_p,
const char *kodmat_p,
const char *kodop_p,
const char *kontr_p,
const char *artikul,
char *imaf)
{
FILE *ff;
if(metka_oth == 0)
  sprintf(imaf,"opss_sv%d.lst",getpid());
if(metka_oth == 1)
 sprintf(imaf,"opss_svg%d.lst",getpid());
if((ff=fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

zagolov(gettext("Движение товарно-материальных ценностей по счетам списания"),dn,mn,gn,dk,mk,gk,organ,ff);

int kol_str=0;

//Распечатка реквизитов поиска
opss_rrp(&kol_str,sklad_p,shets_p,shetu_p,grupa_p,kodmat_p,kodop_p,kontr_p,artikul,ff);

int kolih_shet=svt->sheta_spis.kolih();
int kolih_kod_mat=svt->kod_mat.kolih();

class iceb_tu_str liniq;
liniq.plus("-------------------------------------");
//          1234567890123456789012345678901234567

for(int ii=0; ii <= kolih_shet; ii++)
  liniq.plus("-----------");
//            12345678901

fprintf(ff,"%s\n",liniq.ravno());

if(metka_oth == 0)
 fprintf(ff,"%-*s|%-*.*s|",
 iceb_tu_kolbait(5,gettext("Код")),gettext("Код"),
 iceb_tu_kolbait(30,gettext("Наименование материалла")),
 iceb_tu_kolbait(30,gettext("Наименование материалла")),
 gettext("Наименование материалла"));

if(metka_oth == 1)
 fprintf(ff,"%-*s|%-*.*s|",
 iceb_tu_kolbait(5,gettext("Код")),gettext("Код"),
 iceb_tu_kolbait(30,gettext("Наименование группы материалла")),
 iceb_tu_kolbait(30,gettext("Наименование группы материалла")),
 gettext("Наименование группы материалла"));

for(int ii=0; ii < kolih_shet; ii++)
 fprintf(ff,"%-*s|",iceb_tu_kolbait(10,svt->sheta_spis.ravno(ii)),svt->sheta_spis.ravno(ii));

fprintf(ff,"%*s|\n",iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"));

fprintf(ff,"%s\n",liniq.ravno());

char naim_kod_mat[112];
char strsql[512];
SQL_str row;
class SQLCURSOR cur;
double itogo_gor=0.;

for(int ii=0; ii < kolih_kod_mat; ii++)
 {
  memset(naim_kod_mat,'\0',sizeof(naim_kod_mat));
  if(metka_oth == 0)  
   sprintf(strsql,"select naimat from Material where kodm=%d",svt->kod_mat.ravno(ii));

  if(metka_oth == 1)  
   sprintf(strsql,"select naik from Grup where kod=%d",svt->kod_mat.ravno(ii));
  
  if(readkey(strsql,&row,&cur) == 1)
   strncpy(naim_kod_mat,row[0],sizeof(naim_kod_mat)-1);  
  
  fprintf(ff,"%5d %-*.*s",svt->kod_mat.ravno(ii),
  iceb_tu_kolbait(30,naim_kod_mat),iceb_tu_kolbait(30,naim_kod_mat),naim_kod_mat);
  itogo_gor=0.;
    
  for(int kk=0; kk < kolih_shet; kk++)
   {
    fprintf(ff," %10.2f",svt->sum_svt.ravno(ii*kolih_shet+kk)); 
    itogo_gor+=svt->sum_svt.ravno(ii*kolih_shet+kk);
   }
  fprintf(ff," %10.2f\n",itogo_gor);
 }
fprintf(ff,"%s\n",liniq.ravno());
fprintf(ff,"%*s",iceb_tu_kolbait(36,gettext("Итого")),gettext("Итого"));
itogo_gor=0;
double itogo_kol=0;
for(int ii=0; ii < kolih_shet; ii++)
 {
  itogo_kol=0.;  
  //считаем колонку по вертикали
  for(int kk=0; kk < kolih_kod_mat; kk++)
    itogo_kol+=svt->sum_svt.ravno(kk*kolih_shet+ii);    
  fprintf(ff," %10.2f",itogo_kol);
  itogo_gor+=itogo_kol;
 }
fprintf(ff," %10.2f\n",itogo_gor);


podpis(ff);
fclose(ff);






}
/***********************/
/*Распечатка реквизитов поиска*/
/*****************************/
void opss_rrp(int *kol_str,
const char *sklad_p,
const char *shets_p,
const char *shetu_p,
const char *grupa_p,
const char *kodmat_p,
const char *kodop_p,
const char *kontr_p,
const char *artikul,
FILE *ff)
{

if(sklad_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Склад"),sklad_p);
  *kol_str+=1;
 }
if(shets_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Счёт списания"),shets_p);
  *kol_str+=1;
 }
if(shetu_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Счёт учёта"),shetu_p);
  *kol_str+=1;
 }
if(grupa_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Группа"),grupa_p);
  *kol_str+=1;
 }
if(kodmat_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Код материалла"),kodmat_p);
  *kol_str+=1;
 }
if(kodop_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Код операции"),kodop_p);
  *kol_str+=1;
 }
if(kontr_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Контрагент"),kontr_p);
  *kol_str+=1;
 }
if(artikul[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Артикул"),kontr_p);
  *kol_str+=1;
 }
}

/********************************/
/*Распечатка сводной таблицы по группам и счетам учёта*/
/******************************/
void opss_rsvt_shet(short dn,short mn,short gn,
short dk,short mk,short gk,
class opss_svt_shet *svt,
const char *sklad_p,
const char *shets_p,
const char *shetu_p,
const char *grupa_p,
const char *kodmat_p,
const char *kodop_p,
const char *kontr_p,
const char *artikul,
char *imaf)
{
FILE *ff;
sprintf(imaf,"opss_svg_sh%d.lst",getpid());
if((ff=fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

zagolov(gettext("Движение товарно-материальных ценностей по счетам списания"),dn,mn,gn,dk,mk,gk,organ,ff);

int kol_str=0;

//Распечатка реквизитов поиска
opss_rrp(&kol_str,sklad_p,shets_p,shetu_p,grupa_p,kodmat_p,kodop_p,kontr_p,artikul,ff);

int kolih_shet=svt->sheta_spis.kolih();
int kolih_kod_mat=svt->kod_gr_shet.kolih();

class iceb_tu_str liniq;
liniq.plus("----------------------------------------------");
//          1234567890123456789012345678901234567

for(int ii=0; ii <= kolih_shet; ii++)
  liniq.plus("-----------");
//            12345678901

fprintf(ff,"%s\n",liniq.ravno());

fprintf(ff,"%-*s|%-*.*s|%-*.*s|",
iceb_tu_kolbait(5,gettext("Код")),gettext("Код"),
iceb_tu_kolbait(30,gettext("Наименование группы материалла")),
iceb_tu_kolbait(30,gettext("Наименование группы материалла")),
gettext("Наименование группы материалла"),
iceb_tu_kolbait(8,gettext("Счёт")),
iceb_tu_kolbait(8,gettext("Счёт")),
gettext("Счёт"));

for(int ii=0; ii < kolih_shet; ii++)
 fprintf(ff,"%-*s|",iceb_tu_kolbait(10,svt->sheta_spis.ravno(ii)),svt->sheta_spis.ravno(ii));

fprintf(ff,"%*s|\n",iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"));

fprintf(ff,"%s\n",liniq.ravno());

char naim_kod_mat[112];
char strsql[512];
SQL_str row;
class SQLCURSOR cur;
double itogo_gor=0.;
char kod_gr[24];
char shet_uheta[24];

for(int ii=0; ii < kolih_kod_mat; ii++)
 {
  memset(naim_kod_mat,'\0',sizeof(naim_kod_mat));
  polen(svt->kod_gr_shet.ravno(ii),kod_gr,sizeof(kod_gr),1,'|');
  polen(svt->kod_gr_shet.ravno(ii),shet_uheta,sizeof(shet_uheta),2,'|');
    

  sprintf(strsql,"select naik from Grup where kod=%s",kod_gr);
  
  if(readkey(strsql,&row,&cur) == 1)
   strncpy(naim_kod_mat,row[0],sizeof(naim_kod_mat)-1);  
  
  fprintf(ff,"%5s %-*.*s %-*.*s",
  kod_gr,
  iceb_tu_kolbait(30,naim_kod_mat),iceb_tu_kolbait(30,naim_kod_mat),naim_kod_mat,
  iceb_tu_kolbait(8,shet_uheta),iceb_tu_kolbait(8,shet_uheta),shet_uheta);
  
  itogo_gor=0.;
    
  for(int kk=0; kk < kolih_shet; kk++)
   {
    fprintf(ff," %10.2f",svt->sum_svt.ravno(ii*kolih_shet+kk)); 
    itogo_gor+=svt->sum_svt.ravno(ii*kolih_shet+kk);
   }
  fprintf(ff," %10.2f\n",itogo_gor);
 }
fprintf(ff,"%s\n",liniq.ravno());
fprintf(ff,"%*s",iceb_tu_kolbait(45,gettext("Итого")),gettext("Итого"));
itogo_gor=0;
double itogo_kol=0;
for(int ii=0; ii < kolih_shet; ii++)
 {
  itogo_kol=0.;  
  //считаем колонку по вертикали
  for(int kk=0; kk < kolih_kod_mat; kk++)
    itogo_kol+=svt->sum_svt.ravno(kk*kolih_shet+ii);    
  fprintf(ff," %10.2f",itogo_kol);
  itogo_gor+=itogo_kol;
 }
fprintf(ff," %10.2f\n",itogo_gor);


podpis(ff);
fclose(ff);

}
/*********************************/
/*Распечатка сводной таблицы по кодам материалов-единицам измерения с количеством и суммами*/
/**********************************/
void opss_ei_kolih(short dn,short mn,short gn,
short dk,short mk,short gk,
class opss_kodm_ei *svt,
const char *sklad_p,
const char *shets_p,
const char *shetu_p,
const char *grupa_p,
const char *kodmat_p,
const char *kodop_p,
const char *kontr_p,
const char *artikul,
char *imaf)
{
FILE *ff;
sprintf(imaf,"opss_eik%d.lst",getpid());
if((ff=fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

zagolov(gettext("Движение товарно-материальных ценностей по счетам списания"),dn,mn,gn,dk,mk,gk,organ,ff);

int kol_str=0;

//Распечатка реквизитов поиска
opss_rrp(&kol_str,sklad_p,shets_p,shetu_p,grupa_p,kodmat_p,kodop_p,kontr_p,artikul,ff);

int kolih_shet=svt->sheta_spis.kolih();
int kolih_km_ei=svt->kodm_ei.kolih();

class iceb_tu_str liniq;
liniq.plus("--------------------------------------------");
//          1234567890123456789012345678901234567

for(int ii=0; ii <= kolih_shet; ii++)
  liniq.plus("----------------------");
//            12345678901

fprintf(ff,"%s\n",liniq.ravno());

fprintf(ff,"%-*s|%-*.*s|%-*.*s|",
iceb_tu_kolbait(5,gettext("Код")),gettext("Код"),
iceb_tu_kolbait(30,gettext("Наименование материалла")),
iceb_tu_kolbait(30,gettext("Наименование материалла")),
gettext("Наименование материалла"),
iceb_tu_kolbait(6,gettext("Единица")),
iceb_tu_kolbait(6,gettext("Единица")),
gettext("Единица"));


for(int ii=0; ii < kolih_shet; ii++)
 fprintf(ff,"%-*s|",iceb_tu_kolbait(21,svt->sheta_spis.ravno(ii)),svt->sheta_spis.ravno(ii));

fprintf(ff,"%-*s|\n",iceb_tu_kolbait(21,gettext("Итого")),gettext("Итого"));



fprintf(ff,"%5s|%30s|%*.*s|","","",
iceb_tu_kolbait(6,gettext("измерения")),
iceb_tu_kolbait(6,gettext("измерения")),
gettext("измерения"));

for(int ii=0; ii < kolih_shet+1; ii++)
 fprintf(ff,"%-*.*s|%-*.*s|",
 iceb_tu_kolbait(10,gettext("Количество")),
 iceb_tu_kolbait(10,gettext("Количество")),
 gettext("Количество"),
 iceb_tu_kolbait(10,gettext("Сумма")),
 iceb_tu_kolbait(10,gettext("Сумма")),
 gettext("Сумма"));

fprintf(ff,"\n");


fprintf(ff,"%s\n",liniq.ravno());
char ei[32];
int kodmat=0;
char naim_kod_mat[112];
char strsql[512];
SQL_str row;
class SQLCURSOR cur;
double itogo_gor_kolih=0.;
double itogo_gor_suma=0.;
double kolih=0.;
double suma=0.;
for(int nom_km_ei=0; nom_km_ei < kolih_km_ei; nom_km_ei++)
 {
  memset(naim_kod_mat,'\0',sizeof(naim_kod_mat));
  polen(svt->kodm_ei.ravno(nom_km_ei),&kodmat,1,'|');
  polen(svt->kodm_ei.ravno(nom_km_ei),ei,sizeof(ei),2,'|');
    

  sprintf(strsql,"select naimat from Material where kodm=%d",kodmat);
  
  if(readkey(strsql,&row,&cur) == 1)
   strncpy(naim_kod_mat,row[0],sizeof(naim_kod_mat)-1);  
  
  fprintf(ff,"%5d|%-*.*s|%-*.*s|",
  kodmat,
  iceb_tu_kolbait(30,naim_kod_mat),iceb_tu_kolbait(30,naim_kod_mat),naim_kod_mat,
  iceb_tu_kolbait(6,ei),iceb_tu_kolbait(6,ei),ei);
  
  itogo_gor_kolih=itogo_gor_suma=0.;
    
  for(int nom_shet=0; nom_shet < kolih_shet; nom_shet++)
   {
    suma=svt->suma.ravno(nom_km_ei*kolih_shet+nom_shet);
    kolih=svt->kolih.ravno(nom_km_ei*kolih_shet+nom_shet);
    if(kolih != 0. || suma != 0.)
     {    
      fprintf(ff,"%10.2f|%10.2f|",kolih,suma);
      itogo_gor_kolih+=kolih;
      itogo_gor_suma+=suma;
     }
    else
     fprintf(ff,"%10s|%10s|","","");
   }
  fprintf(ff,"%10.2f|%10.2f|\n",itogo_gor_kolih,itogo_gor_suma);
 }
fprintf(ff,"%s\n",liniq.ravno());
fprintf(ff,"%*s|",iceb_tu_kolbait(43,gettext("Итого")),gettext("Итого"));

for(int nom_shet=0; nom_shet < kolih_shet; nom_shet++)
 fprintf(ff,"%10.2f|%10.2f|",svt->gori_kolih.ravno(nom_shet),svt->gori_suma.ravno(nom_shet));
 
fprintf(ff,"%10.2f|%10.2f|\n",svt->gori_kolih.suma(),svt->gori_suma.suma());

podpis(ff);
fclose(ff);

}
