/*$Id: opss_u.c,v 5.22 2011-02-04 11:32:38 sasa1 Exp $*/
/*04.02.2011	20.03.2005	Белых А.И.	opss_u.c
Отчёт по счетам списания услуг
*/
#include        <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void opss_h(int *nomlist,int *kol_str,FILE *ff);
void opss_itogo(int metka,const char *kod,double itog,FILE *ff,FILE *ffi);
void opps_shet_str(int *nomlist,int *kol_str,FILE *ff);
void opss_u_svod(FILE *ff,class SPISOK *shet_kodzap,class masiv_din_double *shet_kodzap_suma,class masiv_din_double *shet_kodzap_kolih);

extern char     *organ;/*Наименование организации*/
extern double	okrcn;  /*Округление цены*/
extern double	okrg1;  /*Округление 1*/
extern int kol_strok_na_liste;

int opss_u(int metka, //1-по счетам приобретения 2-по счетам списания
class spis_oth *oth)
{
static char     dat1[11],dat2[11];
static char sklad_p[112];
static char shets_p[512]; //Счёт списания 
static char shetu_p[512]; //Счёт учёта
static char grupa_p[112];
static char kodmat_p[512];
static char kodop_p[112];
static char kontr_p[112];
static class iceb_tu_str artikul("");
class iceb_tu_str naik("");
char naim[512];
int kodm;
int kgr;
char strsql[512];
int kom=0;
int kom1=0;

VVOD MENU(3);
VVOD VV(0);

VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(dat2,11);
VV.VVOD_SPISOK_add_data(shets_p,sizeof(shets_p));
VV.VVOD_SPISOK_add_data(shetu_p,sizeof(shets_p));
VV.VVOD_SPISOK_add_data(sklad_p,sizeof(sklad_p));
VV.VVOD_SPISOK_add_data(grupa_p,sizeof(grupa_p));
VV.VVOD_SPISOK_add_data(kodmat_p,sizeof(kodmat_p));
VV.VVOD_SPISOK_add_data(kodop_p,sizeof(kodop_p));
VV.VVOD_SPISOK_add_data(kontr_p,sizeof(kontr_p));
VV.VVOD_SPISOK_add_data(artikul.ravno(),128);

if(metka == 1)
 VV.VVOD_SPISOK_add_ZAG(gettext("Распечатать движение услуг по счетам получения"));

if(metka == 2)
 VV.VVOD_SPISOK_add_ZAG(gettext("Распечатать движение услуг по счетам списания"));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала...(д.м.г)..."));//0
VV.VVOD_SPISOK_add_MD(gettext("Дата конца....(д.м.г)..."));//1

if(metka == 1)
VV.VVOD_SPISOK_add_MD(gettext("Счет приобретения.(,,).."));//2
if(metka == 2)
VV.VVOD_SPISOK_add_MD(gettext("Счет списания...(,,)...."));//2

VV.VVOD_SPISOK_add_MD(gettext("Счет учёта......(,,)...."));//3
VV.VVOD_SPISOK_add_MD(gettext("Подразделение...(,,)...."));//4
VV.VVOD_SPISOK_add_MD(gettext("Группа услуг....(,,)...."));//5
VV.VVOD_SPISOK_add_MD(gettext("Код услуги......(,,)...."));//6
VV.VVOD_SPISOK_add_MD(gettext("Код операции....(,,)...."));//7
VV.VVOD_SPISOK_add_MD(gettext("Код контрагента.(,,)...."));//8
VV.VVOD_SPISOK_add_MD(gettext("Артикул.........(,,)...."));//9



naz:;
clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,0,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(shets_p,VV.VVOD_SPISOK_return_data(2),sizeof(shets_p)-1);
strncpy(shetu_p,VV.VVOD_SPISOK_return_data(3),sizeof(shetu_p)-1);
strncpy(sklad_p,VV.VVOD_SPISOK_return_data(4),sizeof(sklad_p)-1);
strncpy(grupa_p,VV.VVOD_SPISOK_return_data(5),sizeof(grupa_p)-1);
strncpy(kodmat_p,VV.VVOD_SPISOK_return_data(6),sizeof(kodmat_p)-1);
strncpy(kodop_p,VV.VVOD_SPISOK_return_data(7),sizeof(kodop_p)-1);
strncpy(kontr_p,VV.VVOD_SPISOK_return_data(8),sizeof(kontr_p)-1);
artikul.new_plus(VV.data_ravno(9));

switch (kom)
 {

  case FK10:
  case ESC:
   return(1);

  case FK1:
    GDITE();
    iceb_t_pdoc("matu5_19.txt");
    clear();
    goto naz;

  case FK2:
  case PLU:
    break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка контрагентов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп"));
    if(metka == 1)
      MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций приходов"));
    if(metka == 2)
      MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций расходов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка услуг"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 6 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Uslpodr",sklad_p,sizeof(sklad_p),naim);
        VV.VVOD_SPISOK_zapis_data(4,sklad_p);
        goto naz;

      case 1 :
        vibrek("Kontragent",kontr_p,sizeof(kontr_p),naim);
        VV.VVOD_SPISOK_zapis_data(8,kontr_p);
        goto naz;

      case 2 :
        vibrek("Uslgrup",grupa_p,sizeof(grupa_p),naim);
        VV.VVOD_SPISOK_zapis_data(5,grupa_p);
        goto naz;

      case 3 :
        if(metka == 1)
         vibrek("Usloper1",kodop_p,sizeof(kodop_p),naim);
        if(metka == 2)
         vibrek("Usloper2",kodop_p,sizeof(kodop_p),naim);
        VV.VVOD_SPISOK_zapis_data(7,kodop_p);
        goto naz;
        
      case 4 :
        naik.new_plus("");
        if(dirusl(&kgr,&kodm,&naik,1,"") == 0)
         {
          if(kodmat_p[0] == '\0')
            sprintf(kodmat_p,"%d",kodm);
          else
           {
            sprintf(strsql,"%d",kodm);
            if(strlen(kodmat_p)+strlen(strsql)+1 < sizeof(kodmat_p)-1)
             {
              strcat(kodmat_p,",");
              strcat(kodmat_p,strsql);
             }
           }
          VV.VVOD_SPISOK_zapis_data(6,kodmat_p);
         }
        
        goto naz;

      case 5 :
        memset(strsql,'\0',sizeof(strsql));    
        vibrek("Plansh",strsql,sizeof(strsql),naim);
//        VV.VVOD_SPISOK_zapis_data(9,shetz);
        goto naz;

     }
    goto naz;

  case FK4:
    VV.VVOD_clear_data();
    goto naz;
     
  default:
    goto naz;
 }
short dn,mn,gn;
short dk,mk,gk;

if(rsdatp(&dn,&mn,&gn,VV.VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
  goto naz;


sprintf(strsql,"select datd,podr,nomd,metka,kodzap,kolih,cena,ei,shsp,shetu,nz from Usldokum1 \
where datd >= '%04d-%02d-%02d' and datd <= '%04d-%02d-%02d' and tp=%d order by shsp asc",
gn,mn,dn,gk,mk,dk,metka);

int kolstr;
SQL_str row;
SQLCURSOR cur;
SQL_str row1;
SQLCURSOR cur1;

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
char imaf_tmp[50];

sprintf(imaf_tmp,"opss%d.tmp",getpid());
FILE *ff_tmp;

if((ff_tmp = fopen(imaf_tmp,"w")) == NULL)
 {
  error_op_nfil(imaf_tmp,errno,"");
  return(1);
 }

char kodop[32];
char kontr[32];
char shet_uheta[56];
char shet_sp[24];
double kolih;
short dd,md,gd;

int kolstr1=0;

while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);  

  if(proverka(shets_p,row[8],1,0) != 0)
    continue;  
  if(proverka(shetu_p,row[9],1,0) != 0)
    continue;  
  if(proverka(sklad_p,row[1],0,0) != 0)
    continue;  

  if(proverka(kodmat_p,row[4],0,0) != 0)
    continue;  

  //читаем материал
  memset(naim,'\0',sizeof(naim));
  if(row[3][0] == '0')
    sprintf(strsql,"select kodgr,naimat,artikul from Material where kodm=%s",row[4]);
  if(row[3][0] == '1')
    sprintf(strsql,"select kodgr,naius,art from Uslugi where kodus=%s",row[4]);

  if(readkey(strsql,&row1,&cur1) == 1)
   {
    strncpy(naim,row1[1],sizeof(naim)-1);
    if(proverka(grupa_p,row1[0],0,0) != 0)
      continue;  
    if(proverka(artikul.ravno(),row1[2],0,0) != 0)
      continue;  

   }

  rsdat(&dd,&md,&gd,row[0],2);
  kolih=readkolu(dd,md,gd,atoi(row[1]),row[2],metka,atoi(row[3]),atoi(row[4]),atoi(row[10]));
  if(kolih == 0.)
   continue;  

  memset(kodop,'\0',sizeof(kodop));
  memset(kontr,'\0',sizeof(kontr));
  
  //читаем шапку документа
  sprintf(strsql,"select kontr,kodop from Usldokum where datd='%s' and podr=%s and \
nomd='%s' and tp=%d",row[0],row[1],row[2],metka);
  if(readkey(strsql,&row1,&cur1) == 1)
   {
    if(proverka(kodop_p,row1[1],0,0) != 0)
      continue;  
    if(proverka(kontr_p,row1[0],0,0) != 0)
      continue;  
    strncpy(kodop,row1[1],sizeof(kodop)-1);
    strncpy(kontr,row1[0],sizeof(kontr)-1);
   }

  memset(shet_sp,'\0',sizeof(shet_sp));
  strncpy(shet_sp,row[8],sizeof(shet_sp)-1);
  if(shet_sp[0] == '\0')
   strcpy(shet_sp,"???");

  fprintf(ff_tmp,"%s|%s|%s|%s|%s|%s|%s|%.10g|%s|%s|%s|%s|%s|\n",
  shet_sp,row[9],
  row[0],row[1],row[2],row[3],row[4],kolih,row[6],row[7],
  kodop,kontr,naim);
 }

fclose(ff_tmp);

//sprintf(strsql,"sort -o %s -t\\| -n +0 -2 %s",imaf_tmp,imaf_tmp);
sprintf(strsql,"sort -o %s -t\\| -n -k1,3 %s",imaf_tmp,imaf_tmp);
runsystem1(strsql,1);

if((ff_tmp = fopen(imaf_tmp,"r")) == NULL)
 {
  error_op_nfil(imaf_tmp,errno,"");
  return(1);
 }
unlink(imaf_tmp);

char imaf[56];
FILE *ff;

sprintf(imaf,"opss%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

char imafi[56];
FILE *ffi;

sprintf(imafi,"opssi%d.lst",getpid());

if((ffi = fopen(imafi,"w")) == NULL)
 {
  error_op_nfil(imafi,errno,"");
  return(1);
 }

int kol_str=0;

char imaf_svod[56];
sprintf(imaf_svod,"opsss%d.lst",getpid());
FILE *ff_svod;
if((ff_svod = fopen(imaf_svod,"w")) == NULL)
 {
  error_op_nfil(imaf_svod,errno,"");
  return(1);
 }


if(metka == 1)
 {
  zagolov(gettext("Движение услуг по счетам получения"),dn,mn,gn,dk,mk,gk,organ,ff);
  zagolov(gettext("Движение услуг по счетам получения"),dn,mn,gn,dk,mk,gk,organ,ffi);
  zagolov(gettext("Движение услуг по счетам получения"),dn,mn,gn,dk,mk,gk,organ,ff_svod);
 }
if(metka == 2)
 {
  zagolov(gettext("Движение услуг по счетам списания"),dn,mn,gn,dk,mk,gk,organ,ff);
  zagolov(gettext("Движение услуг по счетам списания"),dn,mn,gn,dk,mk,gk,organ,ffi);
  zagolov(gettext("Движение услуг по счетам списания"),dn,mn,gn,dk,mk,gk,organ,ff_svod);
 }
kol_str=5;

if(sklad_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Склад"),sklad_p);
  fprintf(ffi,"%s:%s\n",gettext("Склад"),sklad_p);
  fprintf(ff_svod,"%s:%s\n",gettext("Склад"),sklad_p);
  kol_str++;
 }
if(shets_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Счёт списания"),shets_p);
  fprintf(ffi,"%s:%s\n",gettext("Счёт списания"),shets_p);
  fprintf(ff_svod,"%s:%s\n",gettext("Счёт списания"),shets_p);
  kol_str++;
 }
if(shetu_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Счёт учёта"),shetu_p);
  fprintf(ffi,"%s:%s\n",gettext("Счёт учёта"),shetu_p);
  fprintf(ff_svod,"%s:%s\n",gettext("Счёт учёта"),shetu_p);
  kol_str++;
 }
if(grupa_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Группа"),grupa_p);
  fprintf(ffi,"%s:%s\n",gettext("Группа"),grupa_p);
  fprintf(ff_svod,"%s:%s\n",gettext("Группа"),grupa_p);
  kol_str++;
 }
if(kodmat_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Код материалла"),kodmat_p);
  fprintf(ffi,"%s:%s\n",gettext("Код материалла"),kodmat_p);
  fprintf(ff_svod,"%s:%s\n",gettext("Код материалла"),kodmat_p);
  kol_str++;
 }
if(kodop_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Код операции"),kodop_p);
  fprintf(ffi,"%s:%s\n",gettext("Код операции"),kodop_p);
  fprintf(ff_svod,"%s:%s\n",gettext("Код операции"),kodop_p);
  kol_str++;
 }
if(kontr_p[0] != '\0')
 {
  fprintf(ff,"%s:%s\n",gettext("Контрагент"),kontr_p);
  fprintf(ffi,"%s:%s\n",gettext("Контрагент"),kontr_p);
  fprintf(ff_svod,"%s:%s\n",gettext("Контрагент"),kontr_p);
  kol_str++;
 }

if(artikul.getdlinna() > 1)
 {
  fprintf(ff,"%s:%s\n",gettext("Артикул"),artikul.ravno());
  fprintf(ffi,"%s:%s\n",gettext("Артикул"),artikul.ravno());
  fprintf(ff_svod,"%s:%s\n",gettext("Артикул"),artikul.ravno());
  kol_str++;
 }

int nomlist=0;

//Шапка 

opss_h(&nomlist,&kol_str,ff);

fprintf(ffi,"----------------------\n");
fprintf(ffi,gettext("  Счёт    |   Сумма  |\n"));
fprintf(ffi,"----------------------\n");

double suma;
double cena;
char shet_sp_z[24];
char shet_uheta_z[24];
memset(shet_sp_z,'\0',sizeof(shet_sp_z));
memset(shet_uheta_z,'\0',sizeof(shet_uheta_z));
double itogo_shetu=0.;
double itogo_shets=0.;
double itogo_shets_o=0.;

char stroka[1024];
char datd[24];
char sklad[24];
char nomd[24];
char kodmat[24];
char ei[32];

class SPISOK shet_kodzap;
class masiv_din_double shet_kodzap_suma;
class masiv_din_double shet_kodzap_kolih;

int nomer_shet_kodzap=0;

while(fgets(stroka,sizeof(stroka),ff_tmp) != NULL)
 {
//  printw("%s\n",stroka);
  polen(stroka,shet_sp,sizeof(shet_sp),1,'|');
  polen(stroka,shet_uheta,sizeof(shet_uheta),2,'|');

  polen(stroka,datd,sizeof(datd),3,'|');
  rsdat(&dd,&md,&gd,datd,2);

  polen(stroka,sklad,sizeof(sklad),4,'|');
  polen(stroka,nomd,sizeof(nomd),5,'|');

  polen(stroka,kodmat,sizeof(kodmat),7,'|');

  polen(stroka,strsql,sizeof(strsql),8,'|');
  kolih=atof(strsql);

  polen(stroka,strsql,sizeof(strsql),9,'|');
  cena=atof(strsql);

  polen(stroka,ei,sizeof(ei),10,'|');

  polen(stroka,kodop,sizeof(kodop),11,'|');

  polen(stroka,kontr,sizeof(kontr),12,'|');

  polen(stroka,naim,sizeof(naim),13,'|');

  if(SRAV(shet_uheta_z,shet_uheta,0) != 0)
   {
    if(shet_uheta_z[0] != '\0')
     {

      opps_shet_str(&nomlist,&kol_str,ff);
      opss_itogo(1,shet_uheta_z,itogo_shetu,ff,ffi);

      opps_shet_str(&nomlist,&kol_str,ff);
      fprintf(ff,"\n");
     }    
    itogo_shetu=0.;
    strcpy(shet_uheta_z,shet_uheta);
   }

  if(SRAV(shet_sp_z,shet_sp,0) != 0)
   {
    if(shet_sp_z[0] != '\0')
     {

      opps_shet_str(&nomlist,&kol_str,ff);
      opss_itogo(1,shet_uheta_z,itogo_shetu,ff,ffi);
      itogo_shetu=0.;

      opps_shet_str(&nomlist,&kol_str,ff);
      opss_itogo(2,shet_sp_z,itogo_shets,ff,ffi);

      opps_shet_str(&nomlist,&kol_str,ff);
      fprintf(ff,"\n");
     }    
    itogo_shets_o+=itogo_shets;
    itogo_shets=0.;
    strcpy(shet_sp_z,shet_sp);
   }

  
  cena=okrug(cena,okrcn);
  
  suma=cena*kolih;
  suma=okrug(suma,okrg1);
  itogo_shetu+=suma;
  itogo_shets+=suma;  

  sprintf(strsql,"%s|%s",shet_sp,kodmat);
  
  if((nomer_shet_kodzap=shet_kodzap.find(strsql)) < 0)
    shet_kodzap.plus(strsql);
  
  shet_kodzap_kolih.plus(kolih,nomer_shet_kodzap);
  shet_kodzap_suma.plus(suma,nomer_shet_kodzap);
  
  opps_shet_str(&nomlist,&kol_str,ff);

  fprintf(ff,"%-8s %-*.*s %-*s %-*s %10.2f %-*s %8.8g %10.10g %02d.%02d.%d %-9s %-5s %-*s %-*s\n",
  kodmat,
  iceb_tu_kolbait(20,naim),iceb_tu_kolbait(20,naim),naim,
  iceb_tu_kolbait(10,shet_sp),shet_sp,
  iceb_tu_kolbait(10,shet_uheta),shet_uheta,
  suma,
  iceb_tu_kolbait(6,ei),ei,
  kolih,cena,dd,md,gd,nomd,sklad,
  iceb_tu_kolbait(6,kodop),kodop,
  iceb_tu_kolbait(6,kontr),kontr);
 }

fclose(ff_tmp);



itogo_shets_o+=itogo_shets;

opss_itogo(1,shet_uheta_z,itogo_shetu,ff,ffi);
opss_itogo(2,shet_sp_z,itogo_shets,ff,ffi);
opss_itogo(3,"",itogo_shets_o,ff,ffi);

podpis(ff);
podpis(ffi);

fclose(ff);
fclose(ffi);

opss_u_svod(ff_svod,&shet_kodzap,&shet_kodzap_suma,&shet_kodzap_kolih);

fclose(ff_svod);


oth->spis_imaf.plus(imaf);
if(metka == 1)
 oth->spis_naim.plus(gettext("Движение услуг по счетам получения"));
if(metka == 2)
 oth->spis_naim.plus(gettext("Движение услуг по счетам списания"));
oth->spis_imaf.plus(imafi);
oth->spis_naim.plus(gettext("Общие итоги"));

oth->spis_imaf.plus(imaf_svod);
oth->spis_naim.plus(gettext("Свод по кодам услуг и счетам"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);
 
}

/********************************/
/*шапка*/
/**********************************/

void opss_h(int *nomlist,int *kol_str,FILE *ff)
{
*nomlist+=1;
fprintf(ff,"%110s%s N%d\n","",gettext("Лист"),*nomlist);
fprintf(ff,"\
------------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,gettext("\
  Код   |    Наименование    |Счёт спис.|   Счёт   |   Сумма  |Един. |Количec-|   Цена   |   Дата   |Номер    |Склад|Опера-|Контра-|\n\
материа.|     материалла     |/получения|  учёта   |          |измер.|  тво   |          | документа|документа|     |ция   |гент   |\n"));

fprintf(ff,"\
------------------------------------------------------------------------------------------------------------------------------------\n");
*kol_str+=5;


}

/*****************************/
/*Выдача итога*/
/*****************************/

void opss_itogo(int metka, //1-счёт учёта 2-счёт списания
const char *kod,double itog,FILE *ff,FILE *ffi)
{
if(itog == 0.)
 return;
 
char bros[312];
if(metka == 1)
  sprintf(bros,"%s %s",gettext("Итого по счёту учёта"),kod);

if(metka == 2)
 {
  sprintf(bros,"%s %s",gettext("Итого по счёту списания"),kod);
  fprintf(ffi,"%-10s %10.2f\n",kod,itog);
 }

if(metka == 3)
 {
  sprintf(bros,"%s",gettext("Общий итог"));
  fprintf(ffi,"%*.*s %10.2f\n",
  iceb_tu_kolbait(10,gettext("Итого")),
  iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),itog);
 }
fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(51,bros),bros,itog);

}
/************************/
/*Счётчик строк*/
/*************************/

void opps_shet_str(int *nomlist,int *kol_str,FILE *ff)
{
*kol_str+=1;
if(*kol_str <= kol_strok_na_liste)
 return;

fprintf(ff,"\f");
*kol_str=0;
opss_h(nomlist,kol_str,ff);
*kol_str+=1;
}

/**************************************/
/*Распечатываем свод по услугам*/
/******************************/
void opss_u_svod(FILE *ff,class SPISOK *shet_kodzap,
class masiv_din_double *shet_kodzap_suma,
class masiv_din_double *shet_kodzap_kolih)
{

fprintf(ff,"\
-------------------------------------------------------------\n");

fprintf(ff,gettext("\
  Код   |    Наименование    |Счёт спис.|   Сумма  |Количec-|\n\
 услуги |      услуги        |/получения|          |  тво   |\n"));

/*
12345678 12345678901234567890 1234567890 1234567890 12345678
*/

fprintf(ff,"\
-------------------------------------------------------------\n");

char kodzap[24];
char shet_spis[24];
double suma;
double kolih;
char naim[112];
SQL_str row1;
SQLCURSOR cur1;
char strsql[512];
double itogo_suma=0.;
double itogo_kolih=0.;
char shet_zap[32];
memset(shet_zap,'\0',sizeof(shet_zap));
double itogo_suma_shet=0.;
double itogo_kolih_shet=0.;
for(int i=0; i < shet_kodzap->kolih(); i++)
 {
  polen(shet_kodzap->ravno(i),shet_spis,sizeof(shet_spis),1,'|');
  polen(shet_kodzap->ravno(i),kodzap,sizeof(kodzap),2,'|');

  if(SRAV(shet_zap,shet_spis,0) != 0)
   {
    if(shet_zap[0] != '\0')
     {
      sprintf(strsql,"%s %s",gettext("Итого по счёту"),shet_zap);
      fprintf(ff,"%40s:%10.2f %8.2f\n",strsql,itogo_suma_shet,itogo_kolih_shet);
     }
    itogo_suma_shet=itogo_kolih_shet=0.;
    strncpy(shet_zap,shet_spis,sizeof(shet_zap)-1);
    
   }

  memset(naim,'\0',sizeof(naim));
  
  //читаем материал
  memset(naim,'\0',sizeof(naim));
  sprintf(strsql,"select naius from Uslugi where kodus=%s",kodzap);
  if(readkey(strsql,&row1,&cur1) == 1)
   {
    strncpy(naim,row1[0],sizeof(naim)-1);
   }
  else
   {
    sprintf(strsql,"select naimat from Material where kodm=%s",kodzap);
    if(readkey(strsql,&row1,&cur1) == 1)
      strncpy(naim,row1[0],sizeof(naim)-1);
   } 
  suma=shet_kodzap_suma->ravno(i);
  kolih=shet_kodzap_kolih->ravno(i);
  
  itogo_suma+=suma;
  itogo_kolih+=kolih;
  
  itogo_suma_shet+=suma;
  itogo_kolih_shet+=kolih;
    
  fprintf(ff,"%-8s %-*.*s %-*s %10.2f %8.2f\n",
  kodzap,
  iceb_tu_kolbait(20,naim),iceb_tu_kolbait(20,naim),naim,
  iceb_tu_kolbait(10,shet_spis),shet_spis,
  suma,kolih);

 }

sprintf(strsql,"%s %s",gettext("Итого по счёту"),shet_spis);
fprintf(ff,"%*s:%10.2f %8.2f\n",
iceb_tu_kolbait(40,strsql),strsql,
itogo_suma_shet,itogo_kolih_shet);

fprintf(ff,"\
-------------------------------------------------------------\n");
fprintf(ff,"%*s:%10.2f %8.2f\n",iceb_tu_kolbait(40,gettext("Итого")),gettext("Итого"),itogo_suma,itogo_kolih);

podpis(ff);

}
