/* $Id: peshetn.c,v 5.17 2011-01-13 13:43:22 sasa1 Exp $ */
/*31.10.2009    25.10.1994      Белых А.И.      peshetn.c
Печать счетов
*/
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif

extern double   okrg1; /*Округление*/
extern short    shetg; /*1-счет для железной дороги 0-нет*/

void            peshetn()
{
char            str[1024];
char            naior[512]; /*Наименование организации*/
char            gorod[512]; /*Город*/
char            kod[32];   /*Почтовый код*/
char            naiban[512];/*Наименование банка*/
char            mfo[32];   /*МФО*/
char            nsh[40];   /*Номер счета в банке*/

char            naior1[512]; /*Наименование организации*/
char            gorod1[512]; /*Город*/
char            kod1[32];   /*Почтовый код*/
char            naiban1[512];/*Наименование банка*/
char            mfo1[32];   /*МФО*/
char            nsh1[40];   /*Номер счета в банке*/

char            imaf[32];
FILE            *ff;
short           kk;
char            sh[32];
double          kol,cena,itog;
double          nac;  /*Наценка*/
char            datt[32];
short           np;
double          bb;
double nds1=0.;
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);


clear(); /*Очистить экран и закрасить фоновым цветом*/
VVOD VV(0);

VV.VVOD_SPISOK_add_ZAG(gettext("Печать счетов"));

VV.VVOD_SPISOK_add_MD(gettext("Номер счета.."));
VV.VVOD_SPISOK_add_MD(gettext("Наценка......"));
VV.VVOD_SPISOK_add_MD(gettext("Дата........."));
VV.VVOD_SPISOK_add_data(10);
VV.VVOD_SPISOK_add_data(5);
VV.VVOD_SPISOK_add_data(20);

helstr(LINES-1,0,"F2/+",gettext("запись"),
"F10",gettext("выход"),NULL);

kk=VV.vvod(0,1,1,-1,-1);

if(kk != FK2 && kk != PLU)
  return;

clear(); /*Очистить экран и закрасить фоновым цветом*/

strcpy(sh,VV.VVOD_SPISOK_return_data(0));
nac=ATOFM(VV.VVOD_SPISOK_return_data(1));
strcpy(datt,VV.VVOD_SPISOK_return_data(2));

nds1=iceb_t_pnds(datt);

iceb_redfil("platpor.alx",0);

SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];

sprintf(strsql,"select str from Alx where fil='platpor.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"platpor.alx");
  iceb_t_soob(strsql);
  return;
 }



for(int nom=0; nom < 6 ; nom++)
  cur_alx.read_cursor(&row_alx);

memset(naior,'\0',sizeof(naior));
memset(gorod,'\0',sizeof(gorod));
memset(kod,'\0',sizeof(kod));
memset(naiban,'\0',sizeof(naiban));
memset(nsh,'\0',sizeof(nsh));

memset(naior1,'\0',sizeof(naior1));
memset(gorod1,'\0',sizeof(gorod1));
memset(kod1,'\0',sizeof(kod1));
memset(naiban1,'\0',sizeof(naiban1));
memset(nsh1,'\0',sizeof(nsh1));

if(POLE(str,naior,2,'|') != 0)
 {
  beep();
  printw(gettext("Файл организаций искажен !!!\nАварийное завершение.\n"));
  OSTANOV();
  return;
 }

POLE(str,gorod,3,'|');

POLE(str,kod,4,'|');

POLE(str,naiban,5,'|');

POLE(str,mfo,6,'|');

POLE(str,nsh,7,'|');

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  if(row_alx[0][0] == '+')
   {
    POLE(row_alx[0],naior1,2,'|');

    POLE(row_alx[0],gorod1,3,'|');

    POLE(row_alx[0],kod1,4,'|');

    POLE(row_alx[0],naiban1,5,'|');

    POLE(row_alx[0],mfo1,6,'|');

    POLE(row_alx[0],nsh1,7,'|');
    break;
   }
 }

sprintf(imaf,"sh%s.lst",sh);
if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }

fprintf(ff,"\x1b\x6C%c",10); /*Установка левого поля*/

fprintf(ff,"\
%s:%s\n\
%s %s\n\
%s%s\n\
%s %s %s %s %s %s\n",
gettext("Поставщик"),
naior,
gettext("Код:"),
kod,
gettext("Расчетный счет N"),
nsh,
gettext("в банке"),
naiban,
gettext("г."),
gorod,
gettext("МФО"),
mfo);

fprintf(ff,"\
==================================================================\n");

fprintf(ff,"\
		 %s  %s\n\
		  %s %s%s\n\
%s %d%s\n",
gettext("С ч е т N"),
sh,
gettext("от"),
datt,
gettext("г."),
gettext("Заказ/Наряд N ___________ от __________"),
gt,gettext("г."));

fprintf(ff,"\
==================================================================\n");

fprintf(ff,"\
%s %s\n\
%s %s\n\
%s%s\n\
%s %s %s %s %s %s\n",
gettext("Плательщик:"),
naior1,
gettext("Код:"),
kod1,
gettext("Расчетный счет N"),
nsh1,
gettext("в банке"),
naiban1,
gettext("г."),
gorod1,
gettext("МФО"),
mfo1);

if(shetg == 1)
 {
  fprintf(ff,"\
------------------------------------------------------------------\n");
  fprintf(ff,gettext("На ст._________________ со ст. _______________ Квит.нак. N________\n"));
  fprintf(ff,gettext("Отпр.____________ 199  г. Способ отпр._________ Контр.вагон N_____\n"));
  fprintf(ff,gettext("Упаковка_________________ Число месяц____________ Вес ____________\n"));
 }
fprintf(ff,"\x0F");
fprintf(ff,"\
-----------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,gettext(" N |                 Наименование                     |Ед.из|Количество|        Цена        |     Сумма\n"));

fprintf(ff,"\
-----------------------------------------------------------------------------------------------------------------\n");

itog=0.;
np=0;
VV.VVOD_delete();
VV.VVOD_SPISOK_add_ZAG(gettext("Печать счетов."));

VV.VVOD_SPISOK_add_MD(gettext("Наименование........"));
VV.VVOD_SPISOK_add_MD(gettext("Единица измерения..."));
VV.VVOD_SPISOK_add_MD(gettext("Количество.........."));
VV.VVOD_SPISOK_add_MD(gettext("Цена................"));
VV.VVOD_SPISOK_add_data(50);
VV.VVOD_SPISOK_add_data(5);
VV.VVOD_SPISOK_add_data(10);
VV.VVOD_SPISOK_add_data(20);

for(;;)
 {

  helstr(LINES-1,0,"F2/+",gettext("запись"),
  "F10",gettext("выход"),NULL);
//  kk=vvod(&LL,0,0,3);
  kk=VV.vvod(0,1,1,-1,-1);

  if(kk == ESC || kk == FK10)
    break;

  if(kk == FK2 || kk == PLU)
   {
    np++;
    cena=ATOFM(VV.VVOD_SPISOK_return_data(3));
    kol=ATOFM(VV.VVOD_SPISOK_return_data(2));
    bb=kol*cena;
    bb=okrug(bb,okrg1);
    itog+=bb;
    
    fprintf(ff,"%3d %-*s %-*s %10.10g %20s %20.2f\n",
    np,
    iceb_tu_kolbait(50,VV.VVOD_SPISOK_return_data(0)),VV.VVOD_SPISOK_return_data(0),
    iceb_tu_kolbait(5,VV.VVOD_SPISOK_return_data(1)),VV.VVOD_SPISOK_return_data(1),
    kol,
    prcn(cena),
    bb);
    
    VV.VVOD_clear_data();
   }
 }

fprintf(ff,"\
-----------------------------------------------------------------------------------------------------------------\n\
%*s: %15.2f\n",iceb_tu_kolbait(96,gettext("Итого")),gettext("Итого"),itog);

if(nac > 0.)
 {
  sprintf(str,"%s %.2f%% :",gettext("Наценка"),nac);
  bb=itog*nac/100.;
  bb=okrug(bb,okrg1);
  fprintf(ff,"%*s %15.2f\n",iceb_tu_kolbait(97,str),str,bb);
  itog+=bb;
  fprintf(ff,"%*s %15.2f\n",iceb_tu_kolbait(97,gettext("Итого")),gettext("Итого"),itog);
 }

  bb=itog*nds1/100.;
  sprintf(str,"%s %.f%% :",gettext("НДС"),nds1);
  bb=okrug(bb,okrg1);
  fprintf(ff,"%*s %15.2f\n",iceb_tu_kolbait(79,str),str,bb);
  itog+=bb;
  fprintf(ff,"%*s %15.2f\n",iceb_tu_kolbait(97,gettext("Итого к оплате:")),gettext("Итого к оплате:"),itog);


memset(str,'\0',sizeof(str));
preobr(itog,str,0);

fprintf(ff,"\n%s: %s\n\n",gettext("Сумма прописью"),str);


fprintf(ff,"\n\n\
     %s\n\n\
     %s\n",
gettext("     Руководитель________________"),
gettext("Главный бухгалтер________________"));



fclose(ff);

move(19,0);
printw("%s %s\n",gettext("Распечатка выгружена в файл"),imaf);
OSTANOV();

class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Счет для оплаты"));
iceb_t_ustpeh(oth.spis_imaf.ravno(0),0);
iceb_t_rabfil(&oth,"");

}
