/* $Id: platdok.c,v 5.98 2011-03-28 06:53:58 sasa Exp $ */
/*22.09.2010    12.04.1993      Белых А.И.      platdok.c
Подпрограмма получения нового платежного поручения
*/
#include        <errno.h>
#include        "buhg.h"
#include        "dok4.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void		smpld(const char*,short,int);
int 		pgpld(const char*,class spis_oth*);
void		sozkom(char*,double,double);
int		paspddos(const char*);
void		bnadra(const char*);
void		b_privatinvest(const char*);
void		b_pervinv(const char*);
void		b_b2_bank_on_line(const char*);
void		baval(const char*);
int		bukrinbank(const char*);
int		b_brokbiznes(const char*);
int		b_soft_review(const char*);
int		b_ukrprom(const char*);
int		b_ukrexim(const char*);
int		b_ukrsoc(const char*);
int		b_iBank_2_UA(const char*);
int		b_privat(const char*);
int		b_tiny(const char*);
int		b_skarb(const char*);
int		dirbank(int*,char*,char*,class iceb_tu_str*,char*,class iceb_tu_str*,class iceb_tu_str*);
void platdok_pp(int kom,const char *tabl);
int b_ukrbiznes(const char *tabl);

extern struct REC rec;
extern double   okrg1; /*Округление*/
extern short	startgodd;
extern short    kp;    /*Количество повторов*/
extern char	*organ;

void  platdok(const char *tabl) //Имя таблицы
{
class iceb_tu_str vstr("");
char            bros[1024];
char		dt0[16],dt1[24],dt2[24];
int             par;
char            imaf[112];
short           i;
int             npp;  /*Номер платежного поручения*/
static char     kop[32];
class iceb_tu_str kod("");
class iceb_tu_str naim("");
char            mescc[32];
int             kom=0;
char            dat1[24];
short		mpo; /*0-искать реквизиты в файле 1-в базе данных*/
class iceb_tu_str kodo("");
class iceb_tu_str naimk("");
SQL_str         row;
SQLCURSOR       cur;
char		strsql[1024];
char		tabl1[16];
int		poz,komv;
char		poi[512];
short		godn;
double nds1=iceb_t_pnds();

int tipz=0;

short dt,mt,gt;
short dtp,mtp,gtp;

poltekdat(&dt,&mt,&gt);

dtp=dt;
mtp=mt;
gtp=gt;

kom=0;
nnn:;

clear();
VVOD MENU(3);
VVOD SOOB(1);

if(SRAV(tabl,"Pltp",0) == 0)
 {
  MENU.VVOD_SPISOK_add_ZAG(organ);
  MENU.VVOD_SPISOK_add_ZAG(gettext("Работа с платежными поручениями"));
  
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод нового платежного поручения"));//0
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод с использованием типового платежного поручения"));//1
  MENU.VVOD_SPISOK_add_MD(gettext("Поиск платежного поручения"));//2
  MENU.VVOD_SPISOK_add_MD(gettext("Просмотр журнала платежных поручений"));//3

  sprintf(strsql,"%s %d.%d.%d%s",gettext("Просмотр журнала платежных поручений за"),//4
  dt,mt,gt,gettext("г."));
  MENU.VVOD_SPISOK_add_MD(strsql);

  MENU.VVOD_SPISOK_add_MD(gettext("Распечатка журнала платежных поручений"));//5
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка контрагентов в файл"));//6
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка контрагентов в базу"));//7
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка операций"));//8
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка типовых платежных поручений"));//9
  MENU.VVOD_SPISOK_add_MD(gettext("Переслать файл платёжек для передачи в банк"));//10
  MENU.VVOD_SPISOK_add_MD(gettext("Установить/снять блокировку"));//11
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список годов за которые введена информация"));//12
  MENU.VVOD_SPISOK_add_MD(gettext("Настройка выполнения проводок"));//13
  MENU.VVOD_SPISOK_add_MD(gettext("Настройка списка банков для передачи документов"));//14
  MENU.VVOD_SPISOK_add_MD(gettext("Записать файл платёжек (для импорта) на DOS-дискету"));//15
  MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//16
  tipz=2;
 }

if(SRAV(tabl,"Pltt",0) == 0)
 {
  MENU.VVOD_SPISOK_add_ZAG(organ);
  MENU.VVOD_SPISOK_add_ZAG(gettext("Работа с платежными требованиями"));

  MENU.VVOD_SPISOK_add_MD(gettext("Ввод нового платежного требования"));//0
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод c использованием типового платежного требования"));//1
  MENU.VVOD_SPISOK_add_MD(gettext("Поиск платежного требования"));//2
  MENU.VVOD_SPISOK_add_MD(gettext("Просмотр журнала платежных требований"));//3

  sprintf(strsql,"%s %d.%d.%d%s",gettext("Просмотр журнала платежных требований за"),
  dt,mt,gt,gettext("г."));//4
  MENU.VVOD_SPISOK_add_MD(strsql);

  MENU.VVOD_SPISOK_add_MD(gettext("Распечатка журнала платежных требований"));//5
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка контрагентов у файл"));//6
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка контрагентов в базу"));//7
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка операций"));//8
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка типовых платежных требований"));//9
  MENU.VVOD_SPISOK_add_MD(gettext("Переслать файл платежных требований для передачи в банк"));//10
  MENU.VVOD_SPISOK_add_MD(gettext("Установка/снятие блокировки"));//11
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список годов за которые введена информация"));//12
  MENU.VVOD_SPISOK_add_MD(gettext("Настройка выполнения проводок"));//13
  MENU.VVOD_SPISOK_add_MD(gettext("Настройка списка банков для передачи документов"));//14
  MENU.VVOD_SPISOK_add_MD(gettext("Записать файл платёжек (для импорта) на DOS-дискету"));//15
  MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//16
  tipz=1;
 }

while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

memset(&rec,'\0',sizeof(rec));
class spis_oth oth;
switch (kom)
 {
  case 16 :
  case -1 :
   sprintf(bros,"pl%d.tmp",getpid());
   unlink(bros);
   return;

  case 0 :
   break;
   
  case 1 :
    clear();
    if(SRAV(tabl,"Pltp",0) == 0)
     strcpy(tabl1,"Tpltp");
    if(SRAV(tabl,"Pltt",0) == 0)
     strcpy(tabl1,"Tpltt");

    kod.new_plus("");
    naim.new_plus("");

    if(SRAV(tabl,"Pltp",0) == 0)
     strcpy(bros,"Ktnp");
    if(SRAV(tabl,"Pltt",0) == 0)
     strcpy(bros,"Ktnt");
    poz=komv=0;
    poi[0]='\0';    
    if(dirmat1(bros,&kod,&naim,LINES-5,0,2,1,&poz,&komv,poi,"\0") == 0)
     {
      if(readpdok(tabl1,0,kod.ravno()) != 0)
       {
        SOOB.VVOD_delete();
        SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено типового документа !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        goto nnn;
       }
      VVOD VVOD1(2);
      sprintf(strsql,"%d.%d.%d",dtp,mtp,gtp);
      vstr.new_plus(strsql);
     
      VVOD1.VVOD_SPISOK_add_ZAG(gettext("Введите дату"));
      int kom1=0;     

naz_dat:;
      if((kom1=vvod1(&vstr,11,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
       {
        goto nnn;
       }
      if(kom1 == ESC)
       {
        goto nnn;
       }

      if(rsdat(&rec.dd,&rec.md,&rec.gd,vstr.ravno(),1) != 0)
       {
        SOOB.VVOD_delete();
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);

        goto naz_dat;
       }



      dtp=rec.dd; mtp=rec.md; gtp=rec.gd;

      rec.tipz=tipz;

      sprintf(rec.nomdk,"%d",nomdok(gt,tabl));
      
      pld(kp,tabl);
      
      clear();      
     }
    goto nnn;

  case 2 :
    poiplatdok(tabl);
    goto nnn;

  case 3 :
    godn=startgodd;
    if(godn == 0)
     godn=gt;
    smpld(tabl,godn,0);
    goto nnn;

  case 4 :
    godn=startgodd;
    if(godn == 0)
     godn=gt;
    smpld(tabl,godn,1);
    goto nnn;

  case 5 :
    if(pgpld(tabl,&oth) == 0)
      iceb_t_rabfil(&oth,"");

    goto nnn;

  case 6 :
    iceb_redfil("platpor.alx",0);
    goto nnn;

  case 7 :

    naimk.new_plus("");
    dirkontr(&kodo,&naimk,0);
    goto nnn;

  case 8 :
    clear();
    kod.new_plus("");
    naim.new_plus("");
    poz=komv=0;
    poi[0]='\0';    

    if(SRAV(tabl,"Pltp",0) == 0)
      dirmat1("Opltp",&kod,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
    
    if(SRAV(tabl,"Pltt",0) == 0)
      dirmat1("Opltt",&kod,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");

    goto nnn;

  case 9 :
    clear();
    i=1;
    if(SRAV(tabl,"Pltp",0) == 0)
     strcpy(tabl1,"Tpltp");
    if(SRAV(tabl,"Pltt",0) == 0)
     strcpy(tabl1,"Tpltt");

    kod.new_plus("");
    naim.new_plus("");

    if(SRAV(tabl,"Pltp",0) == 0)
     strcpy(bros,"Ktnp");
    if(SRAV(tabl,"Pltt",0) == 0)
     strcpy(bros,"Ktnt");
    
    poz=komv=0;
    poi[0]='\0';    
    
    while(dirmat1(bros,&kod,&naim,LINES-5,0,2,1,&poz,&komv,poi,"\0") == 0)
     {
      if(readpdok(tabl1,0,kod.ravno()) != 0)
       {
        /*Создаем новую платежку*/
        i=0;
        vzrkbz();
        sozkom(imaf,0.,0.);
        rec.nds=0.;
        rec.sumd=0.;
        strcpy(rec.nomdk,kod.ravno());
       }
      rec.dd=rec.md=rec.gd=0;
    
      pld(kp,tabl1);
      clear();      
      kod.new_plus("");
      naim.new_plus("");
     }

    goto nnn;

  case 10 :
  case 15 :
    
    platdok_pp(kom,tabl);

    goto nnn;

  case 11 :
      iceb_tl_blok();
      goto nnn;

  case 12:
      if(SRAV(tabl,"Pltp",0) == 0)
        poigod(5);
      
      if(SRAV(tabl,"Pltt",0) == 0)
        poigod(6);
     goto nnn;

  case 13:
      if(SRAV(tabl,"Pltp",0) == 0)
        iceb_redfil("avtprodok.alx",0);
      if(SRAV(tabl,"Pltt",0) == 0)
        iceb_redfil("avtprodokt.alx",0);
      clear();
      goto nnn;

  case 14 :
    iceb_redfil("banki.alx",0);
    goto nnn;
     
    default:
      kom=0;
      goto nnn;
 }

iceb_t_poldan("Поиск организаций в базе",bros,"nastdok.alx");
mpo=0;
if(SRAV(bros,"Вкл",1) == 0)
  mpo=1;

npp=0;

memset(mescc,'\0',sizeof(mescc));
mesc(mt,1,mescc);
sprintf(dat1,"%02d %s %d%s",dt,mescc,gt,gettext("г."));

clear();
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(organ);

VV.VVOD_SPISOK_add_MD(gettext("Номер пл. документа.."));
VV.VVOD_SPISOK_add_MD(gettext("Операция............."));
VV.VVOD_SPISOK_add_MD(gettext("Сумма платежа........"));
VV.VVOD_SPISOK_add_MD(gettext("Дата платежа........."));
VV.VVOD_SPISOK_add_MD(gettext("Н.Д.С. .............."));
VV.VVOD_SPISOK_add_MD(gettext("Количетво копий......"));
VV.VVOD_SPISOK_add_MD(gettext("Дата валютирования..."));
VV.VVOD_SPISOK_add_MD(gettext("Код нерезидента......"));

VV.VVOD_SPISOK_add_data(20);
VV.VVOD_SPISOK_add_data(10);
VV.VVOD_SPISOK_add_data(20);
VV.VVOD_SPISOK_add_data(20);
VV.VVOD_SPISOK_add_data(10);
VV.VVOD_SPISOK_add_data(3);
VV.VVOD_SPISOK_add_data(11);
VV.VVOD_SPISOK_add_data(9);

naim.new_plus("");

for(;;)
 {
  
   npp=nomdok(gt,tabl);

  VV.data_plus(0,npp);

  VV.data_plus(1,kop);

  VV.data_plus(3,dat1);

  /*Вторую не обнуляем*/
  if(kp > 0)
    VV.data_plus(5,kp);
  par=0;
  if(VV.VVOD_SPISOK_return_data(0)[0] != '\0')
   par=1;
  if(VV.VVOD_SPISOK_return_data(1)[0] != '\0')
   par=2;

naz:;

  VV.VVOD_delete_ZAG();
  VV.VVOD_SPISOK_add_ZAG(organ);
  if(SRAV(tabl,"Pltp",0) == 0)
     VV.VVOD_SPISOK_add_ZAG(gettext("Ввод платежного поручения"));
  if(SRAV(tabl,"Pltt",0) == 0)
     VV.VVOD_SPISOK_add_ZAG(gettext("Ввод платежного требования"));

  sprintf(strsql,"%s %d.%d.%d%s",gettext("Текущая дата"),
  dt,mt,gt,gettext("г."));
  VV.VVOD_SPISOK_add_ZAG(strsql);

  if(naim.getdlinna() > 1)
   {
    sprintf(strsql,"%s:%s",gettext("Операция"),naim.ravno());
    VV.VVOD_SPISOK_add_ZAG(strsql);
   }

  clear(); /*Очистить экран и закрасить фоновым цветом*/


  helstr(LINES-1,0,"F1",gettext("помощь"),
  "F2/+",gettext("запись"),
  "F3",gettext("операции"),
  "F4",gettext("НДС"),
  "F10",gettext("выход"),NULL);

  par=VV.vvod(par,1,1,-1,-1);

  npp=(long)ATOFM(VV.VVOD_SPISOK_return_data(0));
  strcpy(kop,VV.VVOD_SPISOK_return_data(1));

  switch(par)
   {
    case FK10:
    case ESC:
      goto nnn;

    case FK1:   /*Помощь*/
      GDITE();
      iceb_t_pdoc("dokum2_1.txt");
      clear();
      par=0;
      goto naz;

    case FK2:
    case PLU:
      GDITE();
      memset(&rec,'\0',sizeof(rec));
      if(VV.VVOD_SPISOK_return_data(0)[0] == '\0')
       {
        SOOB.VVOD_delete();
        SOOB.VVOD_SPISOK_add_MD(gettext("Не введен номер документа !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        par=0;
        goto naz;
       }

      /*Проверяем код операции*/
      if(VV.VVOD_SPISOK_return_data(1)[0] == '\0')
       {
        SOOB.VVOD_delete();
        SOOB.VVOD_SPISOK_add_MD(gettext("Не введена операция !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        par=1;
        goto naz;
       }

      if(SRAV(tabl,"Pltp",0) == 0)
       sprintf(strsql,"select naik from Opltp where kod='%s'",VV.VVOD_SPISOK_return_data(1));    

      if(SRAV(tabl,"Pltt",0) == 0)
       sprintf(strsql,"select naik from Opltt where kod='%s'",VV.VVOD_SPISOK_return_data(1));    

      if(sql_readkey(&bd,strsql,&row,&cur) != 1)
       {
        SOOB.VVOD_delete();
        sprintf(strsql,gettext("Не найден код операции %s !"),VV.VVOD_SPISOK_return_data(1));
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        par=1;
        goto naz;
       }

      if(rsdat(&rec.dd,&rec.md,&rec.gd,VV.VVOD_SPISOK_return_data(3),0) != 0)
       {
        SOOB.VVOD_delete();
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        par=3;
        goto naz;
       }

      if(VV.VVOD_SPISOK_return_data(6)[0] != '\0')
      if(rsdat(&rec.dv,&rec.mv,&rec.gv,VV.VVOD_SPISOK_return_data(6),0) != 0)
       {
        SOOB.VVOD_delete();
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата валютирования !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        par=3;
        goto naz;
       }

      strcpy(dat1,VV.VVOD_SPISOK_return_data(3));
      if(ATOFM(VV.VVOD_SPISOK_return_data(2)) == 0.)
       {
        SOOB.VVOD_delete();
        SOOB.VVOD_SPISOK_add_MD(gettext("Не введена сумма платежа !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        par=2;
        goto naz;
       }

      kp=(short)ATOFM(VV.VVOD_SPISOK_return_data(5));
      if(kp == 0)
       {
        SOOB.VVOD_delete();
        SOOB.VVOD_SPISOK_add_MD(gettext("Не введено количество копий !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        par=4;
        goto naz;
       }

      /*Проверяем номер платежного поручения*/

      sprintf(strsql,"select nomd from %s where datd >= '%04d-01-01' and \
datd <= '%04d-12-31' and nomd='%s'",tabl,rec.gd,rec.gd,VV.VVOD_SPISOK_return_data(0));

      if(sql_readkey(&bd,strsql,&row,&cur) >= 1)
       {
        par=0;
        SOOB.VVOD_delete();
        SOOB.VVOD_SPISOK_add_MD(gettext("Документ с таким номером уже есть !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        goto naz;
       }

      memset(rec.nomdk,'\0',sizeof(rec.nomdk));
      strncpy(rec.nomdk,VV.VVOD_SPISOK_return_data(0),sizeof(rec.nomdk)-1);
      strncpy(rec.kodnr,VV.VVOD_SPISOK_return_data(7),sizeof(rec.kodnr)-1);

      rec.nds=ATOFM(VV.VVOD_SPISOK_return_data(4));
      rec.sumd=ATOFM(VV.VVOD_SPISOK_return_data(2));
      if(rec.nds != 0.)
        rec.nds=okrug(rec.nds,okrg1);
      
      rec.sumd=okrug(rec.sumd,okrg1);
      
      rec.tipz=tipz;
      strcpy(rec.kodop,VV.VVOD_SPISOK_return_data(1));
      if(mpo == 0)
       {
        /*Берем реквизиты организации из файла*/
        iceb_redfil("platpor.alx",0);
        vzrkf();
       }
      else
       {
        /*Берем реквизиты организации из базы*/
        vzrkbz();
       }

      sozkom(imaf,rec.nds,rec.sumd);


      vizred(imaf);
      
      strcpy(dt0,VV.VVOD_SPISOK_return_data(0));
      strcpy(dt1,VV.VVOD_SPISOK_return_data(2));
      strcpy(dt2,VV.VVOD_SPISOK_return_data(3));

      pld(kp,tabl);

      VV.VVOD_SPISOK_zapis_data(2,"");
      VV.VVOD_SPISOK_zapis_data(4,"");
      continue;
    
    case FK3:

      clear();
      kod.new_plus("");
      naim.new_plus("");

      if(SRAV(tabl,"Pltp",0) == 0)
       sprintf(bros,"Opltp");

      if(SRAV(tabl,"Pltt",0) == 0)
       sprintf(bros,"Opltt");

      poz=komv=0;
      poi[0]='\0';    
      if(dirmat1(bros,&kod,&naim,LINES-5,0,2,1,&poz,&komv,poi,"\0") == 0)
       {
        strcpy(kop,kod.ravno());
        VV.data_plus(1,kod.ravno());
        par=2;
        goto naz;
       }

      par=2;
      goto naz;

   
    case FK4:
      par=3;
      if(dat1[0] != '\0')
        nds1=iceb_t_pnds(dat1);
      rec.nds=ATOFM(VV.VVOD_SPISOK_return_data(2))*nds1/(nds1+100);
      rec.nds=okrug(rec.nds,okrg1);
      if(rec.nds != 0.)
        VV.data_plus(4,rec.nds);
      goto naz;

    default:
      par=0;
      if(VV.VVOD_SPISOK_return_data(0)[0] != '\0')
       par=1;
      if(VV.VVOD_SPISOK_return_data(1)[0] != '\0')
       par=2;
      goto naz;
   }
  
 }

}

/******************************/
/*Создание пустого комментария*/
/******************************/
void		sozkom(char imaf[],double nds,double sumad)
{
FILE            *ff2;
char            shban[20]; /*Банковский счет*/
//char		strsql[512];
double		smp;
extern double   smp0,smp1;
char		MD[3][80];
char            bros[512];
int		metkas=0;

/*Создаем комментарий*/
sprintf(imaf,"pl%d.tmp",getpid());
if((ff2 = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

memset(MD,0,sizeof(MD));
memset(shban,'\0',sizeof(shban));
//sprintf(strsql,"%s",iceb_t_imafnsi("nastdok.alx"));
iceb_t_poldan("Банковский счет",shban,"nastdok.alx");

iceb_t_poldan("Сумма без НДС в платежку",bros,"nastdok.alx");
metkas=0;
if(SRAV(bros,"Вкл",1) == 0)
  metkas=1;


if(shban[0] != '\0')
 {
  sprintf(MD[0],"N1");
  smp=smp0;
  if(SRAV(rec.mfo,rec.mfo1,0) != 0)
    smp=smp1;
  if(smp == 0)
    sprintf(MD[2],gettext("N2 За расчетное обслуживание"));
  else
    sprintf(MD[2],"%s %.2f",gettext("N2 За расчетное обслуживание"),smp);
  
 }
if(metkas == 1 && sumad != 0.)
  sprintf(MD[1],"%s-%.2fгрн. ",gettext("Сумма без НДС"),sumad-nds);

if(nds > 0.009   )
 {
  sprintf(bros,"%s-%.2fгрн.",gettext("НДС"),nds);
  strcat(MD[1],bros);
 }

fprintf(ff2,"%s\n%s\n%s\n\n\n\
#----------------------------------------------------------------------------\n\
#%s\n",
MD[0],MD[1],MD[2],
gettext("Введите назначение платежа и другую необходимую информацию"));

fclose(ff2);
}
/************************************************/
/*Передача платёжек*/
/**********************************************/
void platdok_pp(int kom,const char *tabl)
{
class iceb_tu_str script("");
class iceb_tu_str comanda;
char parol[32];
class iceb_tu_str imafil("");
char imamah[312];
char katalog[512];
char bros[1024];
char strsql[1024];
FILE *ff;
int kolstr=0;
SQL_str row;
class SQLCURSOR cur;
short d,m,g;

sprintf(strsql,"select datd,nomd from %s where vidpl='1'",tabl);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одного документа отмеченного для передчи в банк"));
  return;
 }

/*Выгрузка в файл сделана чтобы не переписывать все подпрограммы которые формируют файл для конкретного банка*/
const char *imaf_tmp={"platp.txt"};

if((ff = fopen(imaf_tmp,"w")) == NULL)
 {
 if(errno == ENOENT)
  {  
   iceb_t_soob(gettext("Не найден файл platp.txt !"));
   return;
  }
 else
   {
    error_op_nfil(imaf_tmp,errno,"");
    return;
   }
 }

while(cur.read_cursor(&row) != 0)
 {
  rsdat(&d,&m,&g,row[0],2);
  
  fprintf(ff,"%d.%d.%d|%s\n",d,m,g,row[1]);
 }

fclose(ff);

//if(iceb_t_cp(imaf_tmp,"plat.txt",0) != 0)
// return;
int nomerb=0;
if(dirbank(&nomerb,imamah,katalog,&imafil,parol,&comanda,&script) != 0)
  return;

if(script.getdlinna() <= 1)
 script.new_plus("bankcp");
/*******
printw("\nnomerb=%d imamah=%s katalog=%s imafil=%s\n",
nomerb,imamah,katalog,imafil);
OSTANOV();
**********/
if(nomerb == 1) //Проминвест банк
  paspddos(tabl);
if(nomerb == 2) //Банк Надра
  bnadra(tabl);
if(nomerb == 3) //Банк Аваль
  baval(tabl);
if(nomerb == 4) //Укринбанк
  bukrinbank(tabl);
if(nomerb == 5) //Приватинвест
  b_privatinvest(tabl);
if(nomerb == 6) //Брокбизнесбатк
  b_brokbiznes(tabl);
if(nomerb == 7) //Первый инвестиционный
  b_pervinv(tabl);

if(nomerb == 8) //Укрпромбанк
 {
  
  b_ukrprom(tabl);

  //Узнаём номер дня недели
  struct tm *bf;
  time_t vrem;
  time(&vrem);
  bf=localtime(&vrem);
  strcpy(bros,imafil.ravno());
  sprintf(strsql,"%d",bf->tm_wday+1); //Нумерация дней недели начинаестся с ноля
  //Третий знак в имени файла номер дня недели
  bros[2]=strsql[0];
  imafil.new_plus(bros);
      //      imafil[2]=strsql[0]; 

  VVOD VVOD1(2);
 
  VVOD1.VVOD_SPISOK_add_ZAG(gettext("Введите имя файла"));
  int kom1=0;     

  if((kom1=vvod1(&imafil,112,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
   {
    return;
   }
  if(kom1 == ESC)
   {
    return;
   }

       
 }

if(nomerb == 9) //УкрЕсим банк
  b_ukrexim(tabl);

if(nomerb == 10) //Б2 bank on line
  b_b2_bank_on_line(tabl);

if(nomerb == 11) //Укрсоцбанк
  b_ukrsoc(tabl);

if(nomerb == 12) //iBank 2 UA
  b_iBank_2_UA(tabl);

if(nomerb == 13) //Приват Банк
 {
  if(b_privat(tabl) == 0)
   {
    iceb_t_soob("Платёжки записаны в таблицу JBKL_SND !");
    unlink("plat.txt");
//    unlink(imaf_tmp);

    /*Снимаем метку передачи в банк*/
    sprintf(strsql,"update %s set vidpl='' where vidpl='1'",tabl);
    sql_zapis(strsql,1,0);
   }
  unlink(imaf_tmp);
  return;
      
 }

if(nomerb == 14) //финансы и кредит
  b_soft_review(tabl);

if(nomerb == 15) //система клиент-банк "Tiny"
  b_tiny(tabl);

if(nomerb == 16) /*система клиент-банк АБС "СКАРБ"*/
  b_skarb(tabl);

if(nomerb == 17) /*система клиент-банк Укрбизнесбанк*/
 b_ukrbiznes(tabl);

clear();
GDITE();    
int kodoh=0;
if(kom == 10)
 {
  if(comanda.getdlinna() <= 1)
   {
    sprintf(bros,"%s %s %s %s %s %s",script.ravno(),imamah,"plat.txt",imafil.ravno(),katalog,parol);
      //        printw("bsos=%s\n",bros);
       //        OSTANOV();
    kodoh=system(bros);
   }
  else
   {
    kodoh=system(comanda.ravno());
   }
  class iceb_tu_str repl("");
  if(kodoh != 0)
   {
    sprintf(strsql,gettext("Передача файла не произошла ! Код ошибки %d"),kodoh);
    repl.new_plus(strsql);
    if(comanda.getdlinna() <= 1)
      sprintf(strsql,"%d %s %s %s %s %s %s",nomerb,imamah,"plat.txt",imafil.ravno(),katalog,parol,script.ravno());
    else
     strncpy(strsql,comanda.ravno(),sizeof(strsql)-1);
    repl.ps_plus(strsql);
   }
  if(kodoh == 0)
   {
    repl.new_plus(gettext("Передача файла произошла успешно"));
    if(comanda.getdlinna() <= 1)
      repl.ps_plus(imafil.ravno());
    
    unlink("plat.txt");
//    unlink(imaf_tmp);

    /*Снимаем метку передачи в банк*/
    sprintf(strsql,"update %s set vidpl='' where vidpl='1'",tabl);
    sql_zapis(strsql,1,0);
   }     

  iceb_t_soob(repl.ravno());
 }

if(kom == 15)
 {
  rename("plat.txt",imafil.ravno());
  if(mydoscopy(imafil.ravno()) == 0)
   {
    /*Снимаем метку передачи в банк*/
    sprintf(strsql,"update %s set vidpl='' where vidpl='1'",tabl);
    sql_zapis(strsql,1,0);
//    unlink(imaf_tmp);
   }
//  unlink(imafil.ravno());
 }

unlink(imaf_tmp);

}
