/* $Id: prognoz.c,v 5.31 2011-01-13 13:43:22 sasa1 Exp $ */
/*15.12.2009	16.04.1998	Белых А.И.	prognoz.c
Расчет завоза товара
Смотрим реализацию за заказанный период времени
Вычисляем среднюю реализацию за день
Делим остаток на эту реализацию и вычисляем на сколько 
дней торговли хватит товара
*/
#include        <errno.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char     *organ;
extern double	okrg1;  /*Округление 1*/
extern double	okrcn;  /*Округление цены*/

int prognoz(class spis_oth *oth)
{
char		bros[512];
struct  tm      *bf;
time_t          tmm;
FILE            *ff;
char            imaf[32];
static char     dat1[11],dat2[11];
static char     sklz[10];
static char     grz[112];
static char     kodmz[112];
static char	koldneih[24]; //Количество дней на которые надо расчитать завоз
int		koldnei=0; //Количество дней на которые надо расчитать завоз
int		skl;
int           kom,kom1;
short           d,m,g;
short           dn,mn,gn;
short           dk,mk,gk;
double		real,srzd;
int		kold,kdn;
int		i;
long		kolstr,kolstr1,kolstr2;
SQL_str         row,row1;
char		strsql[512];
char		naimat[512];
double		ost;
char		naiskl[512];
int		kgr,kodm;
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);
VVOD MENU(3);
VVOD VV(0);

VV.VVOD_SPISOK_add_ZAG(gettext("Расчет прогноза реализации"));

VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(dat2,11);
VV.VVOD_SPISOK_add_data(sklz,sizeof(sklz));
VV.VVOD_SPISOK_add_data(grz,sizeof(grz));
VV.VVOD_SPISOK_add_data(kodmz,sizeof(kodmz));
VV.VVOD_SPISOK_add_data(koldneih,4);

VV.VVOD_SPISOK_add_MD(gettext("Дата начала........."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца.........."));
VV.VVOD_SPISOK_add_MD(gettext("Склад..............."));
VV.VVOD_SPISOK_add_MD(gettext("Группа.....(,,)....."));
VV.VVOD_SPISOK_add_MD(gettext("Код материалла.(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Количество дней....."));

naz:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(sklz,VV.VVOD_SPISOK_return_data(2),sizeof(sklz)-1);
strncpy(grz,VV.VVOD_SPISOK_return_data(3),sizeof(grz)-1);
strncpy(kodmz,VV.VVOD_SPISOK_return_data(4),sizeof(kodmz)-1);
strncpy(koldneih,VV.VVOD_SPISOK_return_data(5),sizeof(koldneih)-1);
class iceb_tu_str kods("");
class iceb_tu_str naims("");
switch (kom)
 {

  case FK10:
  case ESC:
   return(1);

  case FK1:
    GDITE();
    iceb_t_pdoc("matu5_11.txt");
    clear();
    goto naz;

  case FK2:
  case PLU:
    break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка складов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка материалов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;

      case 0 :
        memset(bros,'\0',sizeof(bros));
        //if(vibrek("Sklad",bros,sizeof(bros),naimat) == 0)
        if(dirsklad(1,&kods,&naims) == 0)
          VV.data_z_plus(2,kods.ravno());
        goto naz;

      case 1 :
        vibrek("Grup",grz,sizeof(grz),naimat);
        VV.VVOD_SPISOK_zapis_data(3,grz);
        goto naz;

      case 2 :
        bros[0]='\0';
        if(dirmatr(&kgr,&kodm,&naims,1,0,bros,0,0) == 0)
         {
          VV.data_z_plus(4,kodm);
         }
        
        goto naz;
     }
    goto naz;

  case FK4:
    VV.VVOD_clear_data();
    goto naz;
     
  default:
    goto naz;
 }

if((skl=(int)ATOFM(VV.VVOD_SPISOK_return_data(2))) == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введен склад !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
SQLCURSOR cur;

sprintf(strsql,"select * from Sklad where kod=%d",
skl);
if(sql_readkey(&bd,strsql,&row1,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Не найден склад %d в списке складов !"),skl);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

koldnei=(int)ATOFM(koldneih);

strncpy(naiskl,row1[1],sizeof(naiskl)-1);

if(rsdatp(&dn,&mn,&gn,VV.VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
  goto naz;

/*Расчитываем количество дней в периоде*/

printw("%d.%d.%d %d.%d.%d\n",dn,mn,gn,dk,mk,gk);
refresh();

kold=period(dn,mn,gn,dk,mk,gk,0);

if(kold == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Количество дней в периоде равно нолю !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

clear();
GDITE();
time(&tmm);
bf=localtime(&tmm);

sprintf(strsql,"select kodm,naimat,kodgr from Material order by kodgr,naimat asc");
if((kolstr2=cur.make_cursor(&bd,strsql)) < 0)
 {
  printw("%s\n",sql_error(&bd));
  OSTANOV();
 }



if(kolstr2 == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }


sprintf(imaf,"zav%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

printw(gettext("Период с %d.%d.%d до %d.%d.%d Склад %d Количество дней %d\n"),
dn,mn,gn,dk,mk,gk,skl,kold);
refresh();


fprintf(ff,"\
%s\n\n%s %d %s\n\
%s %d.%d.%d%s %s %d.%d.%d%s\n\
%s %d.%d.%d%s  %s - %d:%d\n",
organ,
gettext("Склад"),
skl,naiskl,
gettext("Расчет прогнозируемой реализации на основании реализации\nза период c"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

fprintf(ff,gettext("Эталонный период %d дней.\n"),kold);
fprintf(ff,gettext("Расчетный период %d дней.\n"),koldnei);
fprintf(ff,"\
-----------------------------------------------------------------------------------------------\n");

fprintf(ff,gettext("\
 К/м | Наименование товара    | Остаток |Реализация|Средняя|Кол. |   Дата   |Спрогнозированый\n"));
fprintf(ff,gettext("\
     |                        |         |за период |за день|дней |          |завоз товара\n"));
fprintf(ff,"\
-----------------------------------------------------------------------------------------------\n");
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
/*
  printw("%s %s\n",row[0],row[1]);
  refresh();
*/  
  strzag(LINES-1,0,kolstr2,kolstr1++);
  
  kodm=atoi(row[0]);
  strncpy(naimat,row[1],sizeof(naimat)-1);
  if(proverka(kodmz,row[0],0,0) != 0)
    continue;
  if(proverka(grz,row[2],0,0) != 0)
    continue;
  ost=ostdok1(dt,mt,mt,skl,kodm);

  sprintf(strsql,"select kolih from Dokummat1 where \
kodm=%d and sklad=%d and tipz=%d and \
datd >= '%d-%02d-%02d' and datd <= '%d-%02d-%02d'",
  kodm,skl,2,gn,mn,dn,gk,mk,dk);
/*
  printw("strsql=%s\n",strsql);
*/    
  SQLCURSOR cur1;
  if((kolstr=cur1.make_cursor(&bd,strsql)) < 0)
   {
    printw("%s\n",sql_error(&bd));
    OSTANOV();
   }
/*    printw("kolstr=%ld\n",kolstr);*/
  if(kolstr == 0)
    continue;

  real=0.;
  while(cur1.read_cursor(&row1) != 0)
   {
/*  
    printw("%s %s\n",row1[0],row1[1]);
    refresh();
*/
    real+=atof(row1[0]);
   }

  
  srzd=real/kold;

  kdn=0;
  if(srzd > 0.)
    kdn=(int)(ost/srzd);        

  d=dt; m=mt; g=gt;
  for(i=0; i < kdn; i++)
    dpm(&d,&m,&g,1);

  printw("%-5d %-*.*s %9.9g %-10d %02d.%02d.%d\n",
  kodm,
  iceb_tu_kolbait(24,naimat),iceb_tu_kolbait(24,naimat),naimat,
  ost,kdn,d,m,g);

  refresh();

  if(kdn > 0)
    sprintf(bros,"%02d.%02d.%d",d,m,g);
  else
    strcpy(bros,"**********");

  koldneih[0]='\0';
  if(koldnei != 0)
    sprintf(koldneih,"%.10g",koldnei*srzd);
        
  fprintf(ff,"%-5d %-*.*s %9.9g %10.10g %7.2f %-5d %s %s\n",
  kodm,
  iceb_tu_kolbait(24,naimat),iceb_tu_kolbait(24,naimat),naimat,
  ost,real,srzd,kdn,bros,koldneih);
    
 }
fprintf(ff,"\
-----------------------------------------------------------------------------------------------\n");

podpis(ff);
fclose(ff);

OSTANOV();
oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Прогноз реализации"));

iceb_t_ustpeh(oth->spis_imaf.ravno(0),0);

return(0);

}
