/*$Id: pvbanks.c,v 5.45 2011-01-13 13:43:22 sasa1 Exp $*/
/*05.12.2010	06.10.2003	Белых А.И.	pvbanks.c
Расчет перечисления в банк на карт счета на основе конечного сальдо
*/
#include        <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void pvbavks_pib(SPISOK *KONT,int metkadk,double *deb,double *kre,const char *glavbuh,const char *rukov,int dlpris,const char *pris,const char *grupk,const char *shet,const char *shet_kor,short dr,short mr,short gr,int kod_banka);
void pvbavks_uks(SPISOK *KONT,int metkadk,double *deb,double *kre,const char *glavbuh,const char *rukov,int dlpris,const char *pris,const char *grupk,const char *shet,const char *shet_kor,short dr,short mr,short gr,int kod_banka);

void pvbanks_txt(int metkabk,SPISOK *KONT,int metkadk,double *deb,double *kre,const char *glavbuh,const char *rukov,int dlpris,const char *pris,const char *grupk,const char *shet,const char *shet_kor,short dr,short mr,short gr,const char *kod00,int kod_banka);

void pbanks_dbf(int,SPISOK *KONT,int metkadk,double *deb,double *kre,const char *glavbuh,const char *rukov,int dlpris,const char *pris,const char *grupk,const char *shet,const char *shet_kor,short dr,short mr,short gr,int kod_banka);

int pvbanks_rozn(class iceb_tu_str *shet_kor,short *dr,short *mr,short *gr);
void pvbanks_make_prov(const char*shet,const char*shet_kor,short dr,short mr,short gr,int metkadk,const char*kontr,const char*fio,double sum);

extern short	startgodb; /*Стартовый год*/
extern char     *organ;

void	pvbanks()
{
char bros[512];
char strsql[512];
int kolstr;
int kolkontr=0,kolstr1=0;
SPISOK KONT;
SQLCURSOR cur;
short dk,mk,gk;
static char shet[112];
static char kontr[112];
static char dat2[11];
static char grupk[112];
char naim[512];
int kom=0,kom1=0;
short       gods=startgodb;
int metka_rozn=0;

int metkadk=0;

VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка документов для перечисления на карт-счета"));

VV.VVOD_SPISOK_add_MD(gettext("Счет.................(,,)..."));//0
VV.VVOD_SPISOK_add_MD(gettext("Дата сальдо........(д.м.г).."));//1
VV.VVOD_SPISOK_add_MD(gettext("Код контрагента........(,,)."));//2
VV.VVOD_SPISOK_add_MD(gettext("Код группы контрагента.(,,)."));//3

VV.VVOD_SPISOK_add_data(shet,sizeof(shet));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2)); 
VV.VVOD_SPISOK_add_data(kontr,sizeof(kontr)); 
VV.VVOD_SPISOK_add_data(grupk,sizeof(grupk)); 

naz:;
clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F6",gettext("расчитать"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strcpy(shet,VV.VVOD_SPISOK_return_data(0));
strcpy(dat2,VV.VVOD_SPISOK_return_data(1));
strcpy(kontr,VV.VVOD_SPISOK_return_data(2));
strcpy(grupk,VV.VVOD_SPISOK_return_data(3));

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("buhg5_5_1.txt");
   goto naz;

  case ESC:
  case FK10:
   return;

  case FK2:
  case PLU:
     break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп контрагентов"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка контрагентов"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//3

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Gkont",grupk,sizeof(grupk),naim);
        VV.VVOD_SPISOK_zapis_data(3,grupk);
      
        goto naz;


      case 1 :
        vibrek("Plansh",shet,sizeof(shet),naim);
        VV.VVOD_SPISOK_zapis_data(0,shet);
        goto naz;

      case 2 :
        vibrek("Kontragent",kontr,sizeof(kontr),naim);
        VV.VVOD_SPISOK_zapis_data(2,kontr);
        goto naz;
     }

  case FK6:
     metka_rozn=1;
     break;


  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }

if(shet[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введен счет !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(rsdat(&dk,&mk,&gk,dat2,1) != 0)
 goto naz;

short dr=0,mr=0,gr=0;
class iceb_tu_str shet_kor;

if(metka_rozn == 1) /*расчёт с выполнением проводок*/
 {
  struct OPSHET rek_shet;
  if(prsh1(shet,&rek_shet) != 0)
   goto naz;

  if(rek_shet.saldo != 3)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Счёт имеет свёрнутое сальдо!"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }

  if(pvbanks_rozn(&shet_kor,&dr,&mr,&gr) != 0)
   goto naz;

 }


if(gods == 0)
 gods=gk;

MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите нужное и нажмите Enter"));

MENU.VVOD_SPISOK_add_MD(gettext("Дебет"));
MENU.VVOD_SPISOK_add_MD(gettext("Кредит"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
metkadk=0;
while(menu3w(stdscr,&MENU,&metkadk,-1,-1,0) != 0);
switch (metkadk)
 {
  case  2 :
  case -1 :
   goto naz;

 }
int metka_bank=0;
int kod_banka=0;
class iceb_tu_str kod00("00");
if((metka_bank=zarbanks(&kod00,&kod_banka)) <= 0)
  goto naz;
          
GDITE();

int kolshet=pole2(shet,',');

//Составляем список всех контрагентов
if(kolshet == 0)
  sprintf(strsql,"select ns,kodkon from Skontr where ns='%s'",shet);
else
  sprintf(strsql,"select ns,kodkon from Skontr");

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }
SQL_str row;
kolkontr=0;
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(shet,row[0],0,0) != 0)
    continue;
  if(proverka(kontr,row[1],0,0) != 0)
    continue;
  if(KONT.find_r(row[1]) < 0)
   {
    kolkontr++;
    KONT.plus(row[1]);
   }
 }
GDITE();
double deb[kolkontr];
double kre[kolkontr];
memset(&deb,'\0',sizeof(deb));
memset(&kre,'\0',sizeof(kre));

//Читаем сальдо
if(kolshet == 0)
  sprintf(strsql,"select ns,kodkon,deb,kre from Saldo where kkk=1 and gs=%d and ns='%s'",gods,shet);
else
  sprintf(strsql,"select ns,kodkon,deb,kre from Saldo where kkk=1 and gs=%d",gods);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
int nomer=0;
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(shet,row[0],0,0) != 0)
    continue;
  if(proverka(kontr,row[1],0,0) != 0)
    continue;
//  printw("%s %s %s %s\n",row[0],row[1],row[2],row[3]);

  nomer=KONT.find_r(row[1]);
  deb[nomer]+=atof(row[2]);
  kre[nomer]+=atof(row[3]);
 }
GDITE();
//Читаем все проводки
if(kolshet == 0)
  sprintf(strsql,"select sh,kodkon,deb,kre from Prov where datp >= '%d-%d-%d' \
and datp <= '%d-%d-%d' and kodkon <> '' and sh='%s'",gods,1,1,gk,mk,dk,shet);
else
  sprintf(strsql,"select sh,kodkon,deb,kre from Prov where datp >= '%d-%d-%d' \
and datp <= '%d-%d-%d' and kodkon <> ''",gods,1,1,gk,mk,dk);

//printw("%s\n",strsql);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(shet,row[0],0,0) != 0)
    continue;
  if(proverka(kontr,row[1],0,0) != 0)
    continue;

  nomer=KONT.find_r(row[1]);
  deb[nomer]+=atof(row[2]);
  kre[nomer]+=atof(row[3]);
 }

char rukov[512];
char glavbuh[40];
int dlpris;
char  pris[60];
SQL_str row1;
SQLCURSOR cur1;

memset(rukov,'\0',sizeof(rukov));
memset(glavbuh,'\0',sizeof(glavbuh));

//sprintf(strsql,"%s",iceb_t_imafnsi("zarnast.alx"));
iceb_t_poldan("Приставка к табельному номеру",pris,"zarnast.alx");
dlpris=strlen(pris);
iceb_t_poldan("Табельный номер руководителя",bros,"zarnast.alx");
if(bros[0] != '\0')
 {
  sprintf(strsql,"select fio from Kartb where tabn=%s",bros);
  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
    strncpy(rukov,row1[0],sizeof(rukov)-1);
 } 

//sprintf(strsql,"%s",iceb_t_imafnsi("zarnast.alx"));
iceb_t_poldan("Табельный номер бухгалтера",bros,"zarnast.alx");
if(bros[0] != '\0')
 {
  sprintf(strsql,"select fio from Kartb where tabn=%s",bros);
  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
    strncpy(glavbuh,row1[0],sizeof(glavbuh)-1);
 }
switch(metka_bank)
 {
  case 1: //Проминвестбанк
   pvbavks_pib(&KONT,metkadk,deb,kre,glavbuh,rukov,dlpris,pris,grupk,shet,shet_kor.ravno(),dr,mr,gr,kod_banka);
   break;

  case 3: //Укрсоцбанк
   pvbavks_uks(&KONT,metkadk,deb,kre,glavbuh,rukov,dlpris,pris,grupk,shet,shet_kor.ravno(),dr,mr,gr,kod_banka);
   break;



  case 4: //Укрсиббанк
   pbanks_dbf(1,&KONT,metkadk,deb,kre,glavbuh,rukov,dlpris,pris,grupk,shet,shet_kor.ravno(),dr,mr,gr,kod_banka);
   break;

  case 7: //Укрэксимбанк
   pvbanks_txt(metka_bank,&KONT,metkadk,deb,kre,glavbuh,rukov,dlpris,pris,grupk,shet,shet_kor.ravno(),dr,mr,gr,kod00.ravno(),kod_banka);
   break;

  case 8: /*хресщатик*/
   pvbanks_txt(metka_bank,&KONT,metkadk,deb,kre,glavbuh,rukov,dlpris,pris,grupk,shet,shet_kor.ravno(),dr,mr,gr,kod00.ravno(),kod_banka);
   break;

  case 9: /*ibank2ua*/
   pvbanks_txt(metka_bank,&KONT,metkadk,deb,kre,glavbuh,rukov,dlpris,pris,grupk,shet,shet_kor.ravno(),dr,mr,gr,kod00.ravno(),kod_banka);
   break;

  case 11: //Укргазбанк
   pbanks_dbf(2,&KONT,metkadk,deb,kre,glavbuh,rukov,dlpris,pris,grupk,shet,shet_kor.ravno(),dr,mr,gr,kod_banka);
   break;

  default:
   iceb_t_soob("Для этого банка режим не реализован!");
   break;

 }


}

/***************************/
/*Распечатка для банка ПИБ*/
/***************************/
void pvbavks_pib(SPISOK *KONT,int metkadk,double *deb,double *kre,const char *glavbuh,const char *rukov,int dlpris,const char *pris,const char *grupk,
const char *shet,
const char *shet_kor,
short dr,short mr,short gr,int kod_banka)
{
int  kolstrkartr=0;
FILE *ffsp;
FILE *ffdis;
char imafsp[30];
char imafdis[30];
char  bankshet[32];
char  fio[512];
char tabnom[20];
double sumalist=0;
double sum=0;
double itogoo=0.;
SQLCURSOR cur1;


sprintf(imafsp,"pib%d.lst",getpid());
sprintf(imafdis,"pibd%d.txt",getpid());

if((ffsp = fopen(imafsp,"w")) == NULL)
 {
  error_op_nfil(imafsp,errno,"");
  return;
 }
hrvnks(ffsp,&kolstrkartr);

if((ffdis = fopen(imafdis,"w")) == NULL)
 {
  error_op_nfil(imafdis,errno,"");
  return;
 }
int kolh=0;
int kolkontr=KONT->kolih();
int kol_na_liste=0;
char inn[15];

for(int snom=0 ; snom < kolkontr; snom++)
 {
  memset(fio,'\0',sizeof(fio));
  memset(bankshet,'\0',sizeof(bankshet));
  memset(inn,'\0',sizeof(inn));
  memset(tabnom,'\0',sizeof(tabnom));
  
  if(pvbanks_kprov(KONT,snom,pris,metkadk,&sum,tabnom,deb,kre,dlpris,fio,bankshet,inn,grupk,kod_banka) != 0)
   continue;

  pib_itl(&kolstrkartr,&sumalist,&kol_na_liste,rukov,glavbuh,ffsp);

  sumalist+=sum;
  itogoo+=sum;
  kolh++;
  
  pib_str(kolh,bankshet,sum,fio,inn,ffsp);    
  
  kol_na_liste++;
  
  fprintf(ffdis,"%-16s %8.2f %s\n",bankshet,sum,fio);
  if(dr != 0) /*нужно делать проводки*/
    pvbanks_make_prov(shet,shet_kor,dr,mr,gr,metkadk,KONT->ravno(snom),fio, sum);
 }

pib_end_dok(kol_na_liste,sumalist,itogoo,kolh,rukov,glavbuh,ffsp);

fclose(ffsp);
fclose(ffdis);

//Записываем шапку и концовку
hdisk(kolh,itogoo,imafdis);

class spis_oth oth;

oth.spis_imaf.plus(imafsp);
oth.spis_naim.plus(gettext("Распечатка документов для перечисления на карт-счета"));

oth.spis_imaf.plus(imafdis);
oth.spis_naim.plus(gettext("Документ в электронном формате"));

iceb_t_ustpeh(oth.spis_imaf.ravno(0),1);

iceb_t_rabfil(&oth,"");

}
/***************************/
/*Распечатка для Укрсоцбанка*/
/***************************/
void pvbavks_uks(SPISOK *KONT,int metkadk,double *deb,double *kre,const char *glavbuh,const char *rukov,int dlpris,const char *pris,const char *grupk,
const char *shet,
const char *shet_kor,
short dr,short mr,short gr,int kod_banka)
{
FILE *ff;
FILE *fftmp;
char imaf[30];
char imaftmp[30];
char imafzag[30];
char  bankshet[32];
char  fio[512];
char tabnom[20];
double sumalist=0;
double sum=0;
double itogoo=0.;
char strsql[512];
SQLCURSOR cur1;


sprintf(imaftmp,"ukrsoc%d.tmp",getpid());
if((fftmp = fopen(imaftmp,"w")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return;
 }

sprintf(imaf,"ukrsoc%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

time_t          vrem;

time(&vrem);
struct tm *bf=localtime(&vrem);

fprintf(ff,"\
   Зведена відомість сум для зарахування на спеціальні карткові рахунки N_____\n\
------------------------------------------------------------------------------\n\
| Дата                             |             %02d.%02d.%04d                  |\n\
| Назва організації                |%-41.41s|\n\
| Назва та N філії АКБ \"Укрсоцбанк\"|Вінницька облана філія N050              |\n\
| Додаткова інформація             |                                         |\n\
------------------------------------------------------------------------------\n",
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
organ);

fprintf(ff,"\
--------------------------------------------------------------------------------------\n\
 N  |     Призвище, ім'я по батькові         | Картковий счёт |Сумма до зарахування|\n\
--------------------------------------------------------------------------------------\n"); 
int kolh=0;
int kolkontr=KONT->kolih();
char inn[30];
int nomerstr=0;

for(int snom=0 ; snom < kolkontr; snom++)
 {
  memset(fio,'\0',sizeof(fio));
  memset(bankshet,'\0',sizeof(bankshet));
  memset(inn,'\0',sizeof(inn));
  memset(tabnom,'\0',sizeof(tabnom));

  if(pvbanks_kprov(KONT,snom,pris,metkadk,&sum,tabnom,deb,kre,dlpris,fio,bankshet,inn,grupk,kod_banka) != 0)
   continue;

  sumalist+=sum;
  itogoo+=sum;
  kolh++;
    

  fprintf(ff,"%-4d %-40.40s %-19.19s %10.2f\n",
  ++nomerstr,fio,bankshet,sum);
  fprintf(fftmp,"@%s,0,%.2f\n",bankshet,sum);

  if(dr != 0) /*нужно делать проводки*/
    pvbanks_make_prov(shet,shet_kor,dr,mr,gr,metkadk,KONT->ravno(snom),fio,sum);

 }
fprintf(ff,"\
--------------------------------------------------------------------------------------\n"); 

fprintf(ff,"\
                                                          Всього: %10.2f\n",itogoo);

fprintf(ff,"\
Керівник           _____________________ %s\n\n\
Головний бухгалтер _____________________ %s\n",rukov,glavbuh);

fprintf(ff,"\n\
Відмітки банку:\n\
Дата приймання Зведеної відомості на паперовому носії та магнітному носії_____________\n\
Посада та призвище, ім'я та по батькові працівника Банку, який прийняв Зведену відомість\n\n\
_____________________________________________________\n\n\
_____________________________________________________\n\n\
підпис_______________________________________________\n");

podpis(ff);

fclose(ff);
fclose(fftmp);

if((fftmp = fopen(imaftmp,"r")) == NULL)
   {
    error_op_nfil(imaftmp,errno,"");
    return;
   }

sprintf(imafzag,"ukrsoc%d.txt",getpid());
if((ff = fopen(imafzag,"w")) == NULL)
   {
    error_op_nfil(imafzag,errno,"");
    return;
   }

fprintf(ff,"@29244050010001,0,%.2f\n\
@302010,0,0,0.00\n",itogoo);

while(fgets(strsql,sizeof(strsql),fftmp) != NULL)
  fprintf(ff,"%s",strsql);
  
fclose(ff);
fclose(fftmp);
unlink(imaftmp);

class spis_oth oth;

oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Распечатка документов для перечисления на карт-счета"));

oth.spis_imaf.plus(imafzag);
oth.spis_naim.plus(gettext("Документ в электронном формате"));

iceb_t_ustpeh(oth.spis_imaf.ravno(0),1);

iceb_t_rabfil(&oth,"");

}
/**************************************/
/*Для Укрексимбанка*/
/****************************************/

void pvbanks_txt(int metkabk,SPISOK *KONT,int metkadk,double *deb,double *kre,const char *glavbuh,const char *rukov,int dlpris,const char *pris,const char *grupk,
const char *shet,
const char *shet_kor,
short dr,short mr,short gr,
const char *kod00,
int kod_banka)
{
char imafsp[32];
char imafdis[32];
class iceb_tu_str vidnahis("");
short d_pp=0,m_pp=0,g_pp=0; /*Дата платёжки*/
double sumai=0.;
double sum=0.;
char  fio[512];
char  bankshet[32];
char inn[15];
char tabnom[24];

int kolkontr=KONT->kolih();

char imaftmp[32];
FILE *ffr;
FILE *fftmp;

if(metkabk == 7) /*Укрэксим*/
  if(ukreksim_hap(imafsp,imaftmp,&fftmp,&ffr) != 0)
   return;

if(metkabk == 8) /*Хресщатик*/
 {
  for(int snom=0 ; snom < kolkontr; snom++)
   {
    if(pvbanks_kprov(KONT,snom,pris,metkadk,&sum,tabnom,deb,kre,dlpris,fio,bankshet,inn,grupk,kod_banka) != 0)
     continue;

    sumai+=sum;
   }
  if(zvb_hreshatik_start(imafsp,imafdis,sumai,&d_pp,&m_pp,&g_pp,&fftmp,&ffr) != 0)
   return;
 }

if(metkabk == 9) /*ibank2ua*/
 if(zvb_ibank2ua_start(imafsp,imafdis,&vidnahis,kod00,&fftmp,&ffr) != 0)
  return;

sum=0.;
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);
int nomer=0;
sumai=0.;

for(int snom=0 ; snom < kolkontr; snom++)
 {
  memset(fio,'\0',sizeof(fio));
  memset(bankshet,'\0',sizeof(bankshet));
  memset(inn,'\0',sizeof(inn));
  memset(tabnom,'\0',sizeof(tabnom));

  if(pvbanks_kprov(KONT,snom,pris,metkadk,&sum,tabnom,deb,kre,dlpris,fio,bankshet,inn,grupk,kod_banka) != 0)
   continue;

  sumai+=sum;

  if(metkabk == 7) /*укрэксим*/
   ukreksim_zstr(fftmp,ffr,&nomer,sum,fio,bankshet,tabnom,dt,mt,gt);

  if(metkabk == 8) /*Хресщатик*/
    zvb_hreshatik_str(d_pp,m_pp,g_pp,&nomer,fio,bankshet,inn,sum,fftmp,ffr);

  if(metkabk == 9) /*ibank2ua*/
   zvb_ibank2ua_str(&nomer,fio,bankshet,inn,sum,fftmp,ffr);
   
  if(dr != 0) /*нужно делать проводки*/
   pvbanks_make_prov(shet,shet_kor,dr,mr,gr,metkadk,KONT->ravno(snom),fio,sum);

 }

if(metkabk == 7) /*укрэксим*/
  ukreksim_end(nomer,imaftmp,imafdis,sumai,rukov,glavbuh,fftmp,ffr);

if(metkabk == 8) /*Хресщатик*/
 zvb_hreshatik_end(sumai,nomer,ffr,fftmp);

if(metkabk == 9) /*ibank2ua*/
 zvb_ibank2ua_end(sumai,vidnahis.ravno(),ffr,fftmp);

class spis_oth oth;

oth.spis_imaf.plus(imafsp);
oth.spis_naim.plus(gettext("Распечатка документов для перечисления на карт-счета"));

oth.spis_imaf.plus(imafdis);
oth.spis_naim.plus(gettext("Документ в электронном формате"));

iceb_t_ustpeh(oth.spis_imaf.ravno(0),1);

iceb_t_rabfil(&oth,"");

}
/**************************************/
/*Для банков у которых електронный формат dbf*/
/****************************************/

void pbanks_dbf(int metka_banka, /*1-ukrsib 2-ukrgaz*/
SPISOK *KONT,int metkadk,double *deb,double *kre,const char *glavbuh,const char *rukov,int dlpris,const char *pris,const char *grupk,
const char *shet,
const char *shet_kor,
short dr,short mr,short gr,int kod_banka)
{
char imafsp[30];
char imafdis[30];

int kolkontr=KONT->kolih();

char imaftmp[30];
FILE *ffr;
FILE *fftmp;
class iceb_tu_str ope_tor("");

if(metka_banka == 1)
 ukrsib_start(imafsp,imaftmp,&ope_tor,&fftmp,&ffr);

if(metka_banka == 2)
  zvb_ukrgaz_start(imafsp,imafdis,imaftmp,&fftmp,&ffr);

double sum=0.;
char  fio[512];
char  bankshet[32];
char inn[15];
char tabnom[20];
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);
int nomer=0;
double sumai=0.;

for(int snom=0 ; snom < kolkontr; snom++)
 {
  memset(fio,'\0',sizeof(fio));
  memset(bankshet,'\0',sizeof(bankshet));
  memset(inn,'\0',sizeof(inn));
  memset(tabnom,'\0',sizeof(tabnom));

  if(pvbanks_kprov(KONT,snom,pris,metkadk,&sum,tabnom,deb,kre,dlpris,fio,bankshet,inn,grupk,kod_banka) != 0)
   continue;

  sumai+=sum;
  if(metka_banka == 1)
    ukrsib_str(dt,mt,gt,sum,bankshet,fio,&nomer,tabnom,ope_tor.ravno(),ffr,fftmp);
  if(metka_banka == 2)
    zvb_ukrgaz_str(++nomer,fio,bankshet,sum,inn,tabnom,fftmp,ffr);

  if(dr != 0) /*нужно делать проводки*/
      pvbanks_make_prov(shet,shet_kor,dr,mr,gr,metkadk,KONT->ravno(snom),fio,sum);
 }

if(metka_banka == 1)
  ukrsib_end(imafdis,imaftmp,sumai,nomer,rukov,glavbuh,ffr,fftmp);
if(metka_banka == 2)
  zvb_ukrgaz_end(imafdis,imaftmp,sumai,nomer,ffr,fftmp);

class spis_oth oth;

oth.spis_imaf.plus(imafsp);
oth.spis_naim.plus(gettext("Распечатка документов для перечисления на карт-счета"));

oth.spis_imaf.plus(imafdis);
oth.spis_naim.plus(gettext("Документ в электронном формате"));

iceb_t_ustpeh(oth.spis_imaf.ravno(0),1);

iceb_t_rabfil(&oth,"");

}


/***************************/
/*Ввод счёта кореспонданта и даты розноски*/
/*****************************************/
/*Если вернули 0-розносим 1-нет*/
int pvbanks_rozn(class iceb_tu_str *shet_kor,
short *dr,short *mr,short *gr)
{
static char shet_k[20];
static char dat1[11];


VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG("Введите дополнительные данные для розноски");

VV.VVOD_SPISOK_add_MD(gettext("Счет корреспондент.........."));
VV.VVOD_SPISOK_add_MD(gettext("Дата перечисления (д.м.г).."));


VV.VVOD_SPISOK_add_data(shet_k,sizeof(shet_k));
VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1)); 

naz:;
clear();

helstr(LINES-1,0,
//"F1",gettext("помощь"),
"F2/+",gettext("расчёт"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

int kom=VV.vvod(0,1,1,-1,-1);

strcpy(shet_k,VV.VVOD_SPISOK_return_data(0));
strcpy(dat1,VV.VVOD_SPISOK_return_data(1));

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
//   prosf(strsql);
   goto naz;

  case ESC:
  case FK10:
   return(1);

  case FK2:
  case PLU:
     break;


  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }

if(rsdat(dr,mr,gr,dat1,1) != 0)
 goto naz;

struct OPSHET rek_sh;
if(prsh1(VV.data_ravno(0),&rek_sh) != 0)
 goto naz;

shet_kor->new_plus(VV.data_ravno(0));
return(0);



}
/*************************************/
/*Выполнение проводок*/
/***************************/
void pvbanks_make_prov(const char *shet,
const char *shet_kor,
short dr,short mr,short gr,
int metkadk,
const char *kontr,
const char *fio,
double sum)
{

double deb=0.;
double kre=0.;
char kontr1[20];
char kontr2[20];
memset(kontr1,'\0',sizeof(kontr1));
strncpy(kontr1,kontr,sizeof(kontr1)-1);
strncpy(kontr2,kontr,sizeof(kontr2)-1);

if(metkadk == 0) /*Дебет*/
 kre=sum;
if(metkadk == 1) /*кредит*/
 deb=sum;
char koment[512];
sprintf(koment,"%s %s",gettext("Перечислено"),fio);
 
zapprov(0,gr,mr,dr,shet,shet_kor,kontr1,kontr2,"","","",deb,kre,koment,2,0,time(NULL),0,0,0,0,0);
}
