/* $Id: rasnaln.c,v 5.46 2011-06-07 08:47:12 sasa Exp $ */
/*06.06.2011    22.01.1994      Белых А.И.      rasnaln.c
Распечатка налоговых накладных в Материальном учёте
*/
#include        <errno.h>
#include	"buhg.h"
#define		KOLSTRLIST 105 /*Для старой налоговой накладной*/
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void rasnaln_old(short dd,short md,short gd,int skl,const char *nomdok,const char *imaf,short tipnn);
int rasnaln21122010(short dd,short md,short gd,int skl,const char *nomdok,const char *imaf,short tipnn);


extern double   okrg1; /*Округление*/
extern double	okrcn;  /*Округление цены*/

int rasnaln(short dd,short md,short gd,int skl,const char *nomdok,
const char *imaf,short tipnn) //Тип документа
{
if(sravmydat(dd,md,gd,10,1,2011) < 0) /*Дата начала действия изменённой распечатки налоговых накладных, приказ от 21.12.2010 г N696*/
 {
  rasnaln_old(dd,md,gd,skl,nomdok,imaf,tipnn);
  return(0);
 }
else
  return(rasnaln21122010(dd,md,gd,skl,nomdok,imaf,tipnn));

}
/******************************************************************/
/*Новая налоговая накладная*/
/******************************************************************/
int rasnaln21122010(short dd,short md,short gd,int skl,const char *nomdok,
const char *imaf,short tipnn) //Тип документа
{
SQL_str         row,row1;
int		kolstr;
char		strsql[512];
FILE            *ff=NULL,*f1=NULL;
double          itogo;
double          bb,bb2;
short           d,m,g;
char		datop[16];
double		sumt; /*Сумма по возвратной таре*/
short		vt;
double		sumkor;
char		bros[512];
char		kpos[32];
char		frop[32];
char		uspr[512];
char		osnov[512];
short		tipz;
char		nomnn[32]; /*Номер налоговой накладной*/
class iceb_tu_str naim("");
short		kgrm;
double		cena,kolih;
short		vtar;
char		ei[32];
char		str[1024];
char		imaf1[32];
short		metz;
short		kolstdok=0;
//short		kollist=1;
short		dnn,mnn,gnn;
char kodop[56];
class iceb_tu_str imaf_nast("matnast.alx");

//imafn("matnast.alx",&imaf_nast);

sumt=0.;
vt=0;
memset(bros,'\0',sizeof(bros));
iceb_t_poldan("Код группы возвратная тара",bros,imaf_nast.ravno());
vt=(short)ATOFM(bros);


SQLCURSOR cur,cur1;

/*Читаем шапку документа*/
sprintf(strsql,"select * from Dokummat \
where datd='%04d-%02d-%02d' and sklad=%d and nomd='%s'",
gd,md,dd,skl,nomdok);

if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  clearstr(20,0);
  printw("Год=%d Документ=%s Склад=%d",gd,nomdok,skl);  
  error2(21,0,1,"rasnaln-Не найден документ !");
  return(1);
 }
float pnds=atof(row[13]);

strcpy(kpos,row[3]);
tipz=atoi(row[0]);
nomnn[0]='\0';
strncpy(nomnn,row[5],sizeof(nomnn)-1);
strncpy(kodop,row[6],sizeof(kodop)-1);
rsdat(&dnn,&mnn,&gnn,row[12],2);

sprintf(strsql,"select nomerz,sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d",
gd,nomdok,skl);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

memset(frop,'\0',sizeof(frop));
memset(uspr,'\0',sizeof(uspr));
memset(osnov,'\0',sizeof(osnov));
memset(datop,'\0',sizeof(datop));
sumkor=0.;


if(kolstr != 0)
while(cur.read_cursor(&row) != 0)
 {
  metz=atoi(row[0]);
  if(metz == 3)
    strncpy(osnov,row[1],sizeof(osnov)-1);
  if(metz == 7)
    strncpy(uspr,row[1],sizeof(uspr)-1);
  if(metz == 8)
    strncpy(frop,row[1],sizeof(frop)-1);
  if(metz == 9)
   {
    rsdat(&d,&m,&g,row[1],0);
    if(d != 0 && SRAV1(g,m,d,gd,md,dd) > 0)
     sprintf(datop,"%02d.%02d.%d",d,m,g);
   }
  if(metz == 13)
   {
    sumkor=ATOFM(row[1]);
    sumkor=okrug(sumkor,0.01);
   }
 }

if(datop[0] == '\0')
 {
  memset(bros,'\0',sizeof(bros));
  iceb_t_poldan("Дату отгрузки в налоговой накладной ставить всегда",bros,imaf_nast.ravno());
  if(SRAV(bros,"Вкл",1) == 0)
   sprintf(datop,"%02d.%02d.%d",dnn,mnn,gnn);
 }


int nomer_str=0;
int metka_kop=0;
//Печатаем шапку документа
if(iceb_t_nalnaks(imaf,&nomer_str,dd,md,gd,dnn,mnn,gnn,nomnn,osnov,uspr,frop,kpos,tipz,metka_kop,&f1) != 0)
 return(1);

nomer_str+=iceb_t_insfil("nalnakst.alx",f1);
/*Готовим отсортированный файл*/

sortnak(dd,md,gd,skl,nomdok);

sprintf(imaf1,"sn%d.tmp",getpid());
if((ff = fopen(imaf1,"r")) == NULL)
 {
  if(errno != ENOENT) //Нет такого файла
   {
    error_op_nfil(imaf1,errno,"");
    return(1);
   }
 }
itogo=0.;
bb2=0.;
int metka_data_opl=0;
kolstdok=nomer_str;
char razdel[8];
strcpy(razdel," I");
if(ff != NULL)
while(fgets(str,sizeof(str),ff) != NULL)
 {

  POLE(str,bros,1,'|');
  kgrm=atoi(bros);

  polen(str,&naim,2,'|');


  POLE(str,bros,5,'|');
  cena=atof(bros);
  cena=okrug(cena,okrcn);

  POLE(str,ei,7,'|');

  POLE(str,bros,8,'|');
  vtar=atoi(bros);  

  POLE(str,bros,10,'|');
  kolih=atof(bros);

  bb=cena*kolih;
  bb=okrug(bb,okrg1);
  if(kgrm == vt || vtar == 1)
   {
    sumt+=bb;
    continue;
   }
  metka_data_opl++;
  kolstdok++;
/****************
  if(kolstdok >= KOLSTRLIST)
   {
    fprintf(f1,"\x1B\x33%c",20-kor);
    fprintf(f1,"\f %s %d.%d.%d%s %100s %s%d\n",
    nomnn,dd,md,gd,
    gettext("г."),
    " ",
    gettext("Лист N"),++kollist);

    iceb_t_insfil("nakls.alx",f1);
    fprintf(f1,"\x1B\x33%c",24-kor);
    kolstdok=21; //На самом деле 14 но делаем больше чтобы уместился второй лист это связано с изменением межстрочного растояния при выводе второй шапки
   }
**********************/
  if(metka_data_opl == 2)
   {
    memset(datop,'\0',sizeof(datop));
    memset(razdel,'\0',sizeof(razdel));
   }    
  /*Разпечатка строки*/
  iceb_t_nalnak_str(0,tipnn,razdel,datop,naim.ravno(),ei,kolih,cena,bb,f1);

  itogo+=bb;


 }
if(ff != NULL)
  fclose(ff);
unlink(imaf1);

/*Распечатываем услуги*/
sprintf(strsql,"select * from Dokummat3 where \
datd='%04d-%02d-%02d' and sklad=%d and nomd='%s'",gd,md,dd,skl,nomdok);
/*printw("\nstrsql=%s\n",strsql);*/

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
char naiusl[512];

if(kolstr != 0)
while(cur.read_cursor(&row) != 0)
 {
  kolih=atof(row[4]);
  cena=atof(row[5]);
  cena=okrug(cena,okrcn);

  if(kolih > 0)
    bb=cena*kolih;
  else
    bb=cena;

  bb=okrug(bb,okrg1);

  memset(naiusl,'\0',sizeof(naiusl));
  if(atoi(row[10]) != 0)
   {
    sprintf(strsql,"select naius from Uslugi where kodus=%s",row[10]);
    if(readkey(strsql,&row1,&cur1) == 1)
     strncpy(naiusl,row1[0],sizeof(naiusl));
   }  
  if(naiusl[0] == '\0')
   strncpy(naiusl,row[7],sizeof(naiusl)-1);  
  else
   {
    strcat(naiusl," ");
    strcat(naiusl,row[7]);
   }

  /*Разпечатка строки*/
  iceb_t_nalnak_str(0,tipnn,"","",naiusl,ei,kolih,cena,bb,f1);
/**********
  fprintf(f1,"|%4s|%10s|%-*.*s|%-*.*s|%9.9g|%10s",
  " "," ",
  iceb_tu_kolbait(40,naiusl),iceb_tu_kolbait(40,naiusl),naiusl,
  iceb_tu_kolbait(7,row[3]),iceb_tu_kolbait(7,row[3]),row[3],
  kolih,prcn(cena));

  if(tipnn == 0)
    fprintf(f1,"|%10s|%9s|%9s|%9s|%11s|\n",
     prcn(bb)," "," "," "," ");

  if(tipnn == 1)
    fprintf(f1,"|%10s|%9s|%9s|%9s|%11s|\n",
    " ",prcn(bb)," "," "," ");

  if(tipnn == 2)
    fprintf(f1,"|%10s|%9s|%9s|%9s|%11s|\n",
    " "," ",prcn(bb)," "," ");

  if(tipnn == 3)
    fprintf(f1,"|%10s|%9s|%9s|%9s|%11s|\n",
    " "," "," ",prcn(bb)," ");
*****************/
  itogo+=bb;
 }

//Печатаем концовку налоговой накладной
iceb_t_nalnake(tipz,tipnn,itogo,sumkor,"",0.,pnds,"matnast.alx",kodop,okrg1,sumt,kpos,f1);
iceb_t_ustpeh(imaf,3);

return(0);
}


/******************************************************************/
/*Старая налоговая накладная*/
/******************************************************************/

void rasnaln_old(short dd,short md,short gd,int skl,const char *nomdok,
const char *imaf,short tipnn) //Тип документа
{
SQL_str         row,row1;
int		kolstr;
char		strsql[512];
FILE            *ff=NULL,*f1=NULL,*f2=NULL;
short           i;
double          itogo;
double          bb,bb2;
short           d,m,g;
char		datop[16];
double		sumt; /*Сумма по возвратной таре*/
short		vt;
int		kor;
double		sumkor;
char		bros[512];
char		kpos[32];
char		frop[32];
char		uspr[512];
char		osnov[512];
short		tipz;
char		nomnn[32]; /*Номер налоговой накладной*/
class iceb_tu_str naim("");
short		kgrm;
double		cena,kolih;
short		vtar;
char		ei[32];
char		str[1024];
char		imaf1[32];
short		metz;
short		kolstdok=0;
short		kollist=1;
short		dnn,mnn,gnn;
char kodop[56];
class iceb_tu_str imaf_nast("matnast.alx");

//imafn("matnast.alx",&imaf_nast);

sumt=0.;
vt=0;
memset(bros,'\0',sizeof(bros));
iceb_t_poldan("Код группы возвратная тара",bros,imaf_nast.ravno());
vt=(short)ATOFM(bros);


SQLCURSOR cur,cur1;

/*Читаем шапку документа*/
sprintf(strsql,"select * from Dokummat \
where datd='%04d-%02d-%02d' and sklad=%d and nomd='%s'",
gd,md,dd,skl,nomdok);

if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  clearstr(20,0);
  printw("Год=%d Документ=%s Склад=%d",gd,nomdok,skl);  
  error2(21,0,1,"rasnaln-Не найден документ !");
  return;
 }
float pnds=atof(row[13]);

strcpy(kpos,row[3]);
tipz=atoi(row[0]);
nomnn[0]='\0';
strncpy(nomnn,row[5],sizeof(nomnn)-1);
strncpy(kodop,row[6],sizeof(kodop)-1);
rsdat(&dnn,&mnn,&gnn,row[12],2);

sprintf(strsql,"select nomerz,sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d",
gd,nomdok,skl);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

memset(frop,'\0',sizeof(frop));
memset(uspr,'\0',sizeof(uspr));
memset(osnov,'\0',sizeof(osnov));
memset(datop,'\0',sizeof(datop));
sumkor=0.;


if(kolstr != 0)
while(cur.read_cursor(&row) != 0)
 {
  metz=atoi(row[0]);
  if(metz == 3)
    strncpy(osnov,row[1],sizeof(osnov)-1);
  if(metz == 7)
    strncpy(uspr,row[1],sizeof(uspr)-1);
  if(metz == 8)
    strncpy(frop,row[1],sizeof(frop)-1);
  if(metz == 9)
   {
    rsdat(&d,&m,&g,row[1],0);
    if(d != 0 && SRAV1(g,m,d,gd,md,dd) > 0)
     sprintf(datop,"%02d.%02d.%d",d,m,g);
   }
  if(metz == 13)
   {
    sumkor=ATOFM(row[1]);
    sumkor=okrug(sumkor,0.01);
   }
 }

if(datop[0] == '\0')
 {
  memset(bros,'\0',sizeof(bros));
  iceb_t_poldan("Дату отгрузки в налоговой накладной ставить всегда",bros,imaf_nast.ravno());
  if(SRAV(bros,"Вкл",1) == 0)
   sprintf(datop,"%02d.%02d.%d",dd,md,gd);
 }


int nomer_str=0;

//Печатаем шапку документа
rasnaln1(imaf,&nomer_str,&kor,dd,md,gd,dnn,mnn,gnn,nomnn,osnov,uspr,frop,kpos,tipz,&f1,&f2);

/*Готовим отсортированный файл*/

sortnak(dd,md,gd,skl,nomdok);

sprintf(imaf1,"sn%d.tmp",getpid());
if((ff = fopen(imaf1,"r")) == NULL)
if(errno != ENOENT) //Нет такого файла
 {
  error_op_nfil(imaf1,errno,"");
  return;
 }
itogo=0.;
bb2=0.;
i=0;
kolstdok=nomer_str;
char razdel[8];
strcpy(razdel," I");
if(ff != NULL)
while(fgets(str,sizeof(str),ff) != NULL)
 {

  POLE(str,bros,1,'|');
  kgrm=atoi(bros);

  polen(str,&naim,2,'|');


  POLE(str,bros,5,'|');
  cena=atof(bros);
  cena=okrug(cena,okrcn);

  POLE(str,ei,7,'|');

  POLE(str,bros,8,'|');
  vtar=atoi(bros);  

  POLE(str,bros,10,'|');
  kolih=atof(bros);

  bb=cena*kolih;
  bb=okrug(bb,okrg1);
  if(kgrm == vt || vtar == 1)
   {
    sumt+=bb;
    continue;
   }

  i++;
  kolstdok++;
  if(kolstdok >= KOLSTRLIST)
   {
    fprintf(f1,"\x1B\x33%c",20-kor);
    fprintf(f1,"\f %s %d.%d.%d%s %100s %s%d\n",
    nomnn,dd,md,gd,
    gettext("г."),
    " ",
    gettext("Лист N"),++kollist);

    iceb_t_insfil("nakls.alx",f1);
    fprintf(f1,"\x1B\x33%c",24-kor);
    kolstdok=21; //На самом деле 14 но делаем больше чтобы уместился второй лист это связано с изменением межстрочного растояния при выводе второй шапки
   }

  if(i == 2)
   {
    memset(datop,'\0',sizeof(datop));
    memset(razdel,'\0',sizeof(razdel));
   }    
  fprintf(f1,"|%-4s|%-10s|%-*.*s|%-*.*s|%9.9g|%10s",
  razdel,datop,
  iceb_tu_kolbait(40,naim.ravno()),iceb_tu_kolbait(40,naim.ravno()),naim.ravno(),
  iceb_tu_kolbait(7,ei),iceb_tu_kolbait(7,ei),ei,
  kolih,prcn(cena));

  if(tipnn == 0)
    fprintf(f1,"|%9s|%9s|%9s|%9s|%11s|\n",
     prcn(bb)," "," "," "," ");

  if(tipnn == 1)
    fprintf(f1,"|%9s|%9s|%9s|%9s|%11s|\n",
    " ",prcn(bb)," "," "," ");

  if(tipnn == 2)
    fprintf(f1,"|%9s|%9s|%9s|%9s|%11s|\n",
    " "," ",prcn(bb)," "," ");

  if(tipnn == 3)
    fprintf(f1,"|%9s|%9s|%9s|%9s|%11s|\n",
    " "," "," ",prcn(bb)," ");

  for(int nom=40; nom < iceb_tu_strlen(naim.ravno()); nom+=40)
   fprintf(f1,"|%4s|%-10s|%-*.*s|%-7.7s|%9.9s|%10s|%9s|%9s|%9s|%9s|%11s|\n",
    " "," ",
    iceb_tu_kolbait(40,iceb_tu_adrsimv(nom,naim.ravno())),
    iceb_tu_kolbait(40,iceb_tu_adrsimv(nom,naim.ravno())),
    iceb_tu_adrsimv(nom,naim.ravno()),
    " "," "," "," "," "," "," "," ");

  itogo+=bb;


 }
if(ff != NULL)
  fclose(ff);
unlink(imaf1);

/*Распечатываем услуги*/
sprintf(strsql,"select * from Dokummat3 where \
datd='%04d-%02d-%02d' and sklad=%d and nomd='%s'",gd,md,dd,skl,nomdok);
/*printw("\nstrsql=%s\n",strsql);*/

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
char naiusl[500];

if(kolstr != 0)
while(cur.read_cursor(&row) != 0)
 {
  kolih=atof(row[4]);
  cena=atof(row[5]);
  cena=okrug(cena,okrcn);

  if(kolih > 0)
    bb=cena*kolih;
  else
    bb=cena;

  bb=okrug(bb,okrg1);

  memset(naiusl,'\0',sizeof(naiusl));
  if(atoi(row[10]) != 0)
   {
    sprintf(strsql,"select naius from Uslugi where kodus=%s",row[10]);
    if(readkey(strsql,&row1,&cur1) == 1)
     strncpy(naiusl,row1[0],sizeof(naiusl));
   }  
  if(naiusl[0] == '\0')
   strncpy(naiusl,row[7],sizeof(naiusl)-1);  
  else
   {
    strcat(naiusl," ");
    strcat(naiusl,row[7]);
   }

  fprintf(f1,"|%4s|%10s|%-*.*s|%-*.*s|%9.9g|%10s",
  " "," ",
  iceb_tu_kolbait(40,naiusl),iceb_tu_kolbait(40,naiusl),naiusl,
  iceb_tu_kolbait(7,row[3]),iceb_tu_kolbait(7,row[3]),row[3],
  kolih,prcn(cena));

  if(tipnn == 0)
    fprintf(f1,"|%9s|%9s|%9s|%9s|%11s|\n",
     prcn(bb)," "," "," "," ");

  if(tipnn == 1)
    fprintf(f1,"|%9s|%9s|%9s|%9s|%11s|\n",
    " ",prcn(bb)," "," "," ");

  if(tipnn == 2)
    fprintf(f1,"|%9s|%9s|%9s|%9s|%11s|\n",
    " "," ",prcn(bb)," "," ");

  if(tipnn == 3)
    fprintf(f1,"|%9s|%9s|%9s|%9s|%11s|\n",
    " "," "," ",prcn(bb)," ");

  itogo+=bb;
 }

//Печатаем концовку налоговой накладной
rasnaln2(nomer_str,kor,tipnn,itogo,sumkor,"",0.,pnds,"matnast.alx",kodop,okrg1,sumt,f1,f2);

}
