/* $Id: rasnalnu.c,v 5.48 2011-06-07 08:47:12 sasa Exp $ */
/*10.01.2011    22.01.1994      Белых А.И.      rasnalnu.c
Распечатка налоговых накладных для услуг
*/
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


void rasnalnu_old(short dd,short md,short gd,int podr,const char nomdok[],const char imaf[],short tipnn);
int rasnalnu21122010(short dd,short md,short gd,int podr,const char nomdok[],const char imaf[],short tipnn);

extern double   okrg1; /*Округление*/
extern double	okrcn;  /*Округление цены*/

int rasnalnu(short dd,short md,short gd,int podr,
const char nomdok[],const char imaf[],
short tipnn) //Тип накладной
{

if(sravmydat(dd,md,gd,10,1,2011) < 0)  /*Дата начала действия изменённой распечатки налоговых накладных, приказ от 21.12.2010 г N696*/
 {
  rasnalnu_old(dd,md,gd,podr,nomdok,imaf,tipnn);
  return(0);
 }
else
 return(rasnalnu21122010(dd,md,gd,podr,nomdok,imaf,tipnn));

}
/***************************************************/
/*Новая налоговая накладная*/
/***************************************************/
int rasnalnu21122010(short dd,short md,short gd,int podr,
const char nomdok[],const char imaf[],
short tipnn) //Тип накладной
{
SQL_str         row,row1;
int		kolstr;
char		strsql[512];
FILE            *f1;
short           i;
double          itogo;
double          bb,bb2;
char		datop[16];
double		sumkor;
char		bros[512];
char		kpos[32];
char		frop[512];
char		uspr[512];
char		osnov[512];
int		tipz;
char		nomnn[32]; /*Номер налоговой накладной*/
class iceb_tu_str naim("");
double		cena,kolih;
char		ei[32];
short 		metka;
int		kodzap;
short		d,m,g;
short		dnn,mnn,gnn; //Дата налоговой накладной
char		kodop[32];
float		procent=0.;
char		naimnal[512];

float pnds=0.;

SQLCURSOR curr;		
SQLCURSOR cur;		


/*Читаем шапку документа*/
sprintf(strsql,"select kontr,tp,sumkor,datop,nomnn,forop,uslpr,osnov,datpnn,kodop,pn \
from Usldokum where datd='%04d-%02d-%02d' and podr=%d and nomd='%s'",
gd,md,dd,podr,nomdok);

if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD("rasnalnu-Не найден документ !"),
  sprintf(strsql,"Дата:%d.%d.%d Документ:%s Подразделение:%d",
  dd,md,gd,nomdok,podr);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);

  return(1);
 }
pnds=atof(row[10]);
memset(frop,'\0',sizeof(frop));
memset(uspr,'\0',sizeof(uspr));
memset(osnov,'\0',sizeof(osnov));
memset(datop,'\0',sizeof(datop));
sumkor=0.;

strncpy(kpos,row[0],sizeof(kpos)-1);
tipz=atoi(row[1]);
sumkor=atof(row[2]);
if(row[3][0] != '0')
 {
  rsdat(&d,&m,&g,row[3],2);
  sprintf(datop,"%02d.%02d.%d",d,m,g);
 }
rsdat(&dnn,&mnn,&gnn,row[8],2);

if(datop[0] == '\0')
 {
  
  memset(bros,'\0',sizeof(bros));
  iceb_t_poldan("Дату отгрузки в налоговой накладной ставить всегда",bros,"matnast.alx");
  if(SRAV(bros,"Вкл",1) == 0)
   sprintf(datop,"%02d.%02d.%d",dnn,mnn,gnn);
 }

class iceb_tu_str kod_ei_usl;
iceb_t_poldan("Код единицы измерения услуги",&kod_ei_usl,"uslnast.alx");

strncpy(nomnn,row[4],sizeof(nomnn)-1);
strncpy(frop,row[5],sizeof(frop)-1);
strncpy(uspr,row[6],sizeof(uspr)-1);
strncpy(osnov,row[7],sizeof(osnov)-1);
strncpy(kodop,row[9],sizeof(kodop)-1);

usldopnal(tipz,kodop,&procent,naimnal,sizeof(naimnal));
int nomer_str=0;
int metka_kop=0;
//печатаем заголовок налоговой накладной
if(iceb_t_nalnaks(imaf,&nomer_str,dd,md,gd,dnn,mnn,gnn,nomnn,osnov,uspr,frop,kpos,tipz,metka_kop,&f1) != 0)
 return(1);
nomer_str+=iceb_t_insfil("nalnakst.alx",f1);

sprintf(strsql,"select metka,kodzap,kolih,cena,ei,dnaim from Usldokum1 \
where datd='%d-%02d-%02d' and podr=%d and nomd='%s' and tp=%d order by metka,kodzap asc",
gd,md,dd,podr,nomdok,tipz);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
char razdel[8];
strcpy(razdel," I");
itogo=0.;
bb2=0.;
i=0;
while(cur.read_cursor(&row) != 0)
 {
  i++;

  metka=atoi(row[0]);
  kodzap=atoi(row[1]);
  kolih=atof(row[2]);
  cena=atof(row[3]);
  cena=okrug(cena,okrcn);

  /*Читаем наименование материалла*/
  naim.new_plus("");

  if(metka == 0)
   sprintf(strsql,"select naimat from Material where kodm=%d",
   kodzap);

  if(metka == 1)
   sprintf(strsql,"select naius from Uslugi where kodus=%d",
   kodzap);

  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    printw("%s\n",strsql);
    if(metka == 0)
     printw("%s %d !\n",gettext("Не найден код материалла"),kodzap);
    if(metka == 1)
     printw("%s %d !\n",gettext("Не найден код услуги"),kodzap);
    OSTANOV();
   }
  else
   {
    naim.new_plus(row1[0]);
    if(row[5][0] != '\0')
     {
      naim.plus(" ",row[5]);
     }
   }
  
  strncpy(ei,row[4],sizeof(ei)-1);

  bb=cena*kolih;
  bb=okrug(bb,okrg1);

  if(i == 2)
   {
    memset(datop,'\0',sizeof(datop));
    memset(razdel,'\0',sizeof(razdel));
   }  
  /*Разпечатка строки*/
  if(proverka(kod_ei_usl.ravno(),ei,0,1) == 0 && kolih == 1.)
    iceb_t_nalnak_str(1,tipnn,razdel,datop,naim.ravno(),ei,kolih,cena,bb,f1);
  else
    iceb_t_nalnak_str(0,tipnn,razdel,datop,naim.ravno(),ei,kolih,cena,bb,f1);

  itogo+=bb;


 }

//Печатаем концовку налоговой накладной
iceb_t_nalnake(tipz,tipnn,itogo,sumkor,naimnal,procent,pnds,"uslnast.alx",kodop,okrg1,0.,kpos,f1);
iceb_t_ustpeh(imaf,3);
return(0);
}





/***************************************************/
/*Старая налоговая накладная*/
/***************************************************/
void rasnalnu_old(short dd,short md,short gd,int podr,
const char nomdok[],const char imaf[],
short tipnn) //Тип накладной
{
SQL_str         row,row1;
int		kolstr;
char		strsql[512];
FILE            *f1,*f2;
short           i;
double          itogo;
double          bb,bb2;
char		datop[16];
double		sumkor;
char		bros[512];
char		kpos[32];
char		frop[512];
char		uspr[512];
char		osnov[512];
int		tipz;
char		nomnn[32]; /*Номер налоговой накладной*/
class iceb_tu_str naim("");
double		cena,kolih;
char		ei[32];
short 		metka;
int		kodzap;
short		d,m,g;
short		dnn,mnn,gnn; //Дата налоговой накладной
char		kodop[32];
float		procent=0.;
char		naimnal[512];
int kor=0;

float pnds=0.;

SQLCURSOR curr;		
SQLCURSOR cur;		


/*Читаем шапку документа*/
sprintf(strsql,"select kontr,tp,sumkor,datop,nomnn,forop,uslpr,osnov,datpnn,kodop,pn \
from Usldokum where datd='%04d-%02d-%02d' and podr=%d and nomd='%s'",
gd,md,dd,podr,nomdok);

if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD("rasnalnu-Не найден документ !"),
  sprintf(strsql,"Дата:%d.%d.%d Документ:%s Подразделение:%d",
  dd,md,gd,nomdok,podr);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);

  return;
 }
pnds=atof(row[10]);
memset(frop,'\0',sizeof(frop));
memset(uspr,'\0',sizeof(uspr));
memset(osnov,'\0',sizeof(osnov));
memset(datop,'\0',sizeof(datop));
sumkor=0.;

strncpy(kpos,row[0],sizeof(kpos)-1);
tipz=atoi(row[1]);
sumkor=atof(row[2]);
if(row[3][0] != '0')
 {
  rsdat(&d,&m,&g,row[3],2);
  sprintf(datop,"%02d.%02d.%d",d,m,g);
 }

if(datop[0] == '\0')
 {
  
  memset(bros,'\0',sizeof(bros));
  iceb_t_poldan("Дату отгрузки в налоговой накладной ставить всегда",bros,"matnast.alx");
  if(SRAV(bros,"Вкл",1) == 0)
   sprintf(datop,"%02d.%02d.%d",dd,md,gd);
 }

//class iceb_tu_str imaf_usl_nast;

//imafn("uslnast.alx",&imaf_usl_nast);
class iceb_tu_str kod_ei_usl;
iceb_t_poldan("Код единицы измерения услуги",&kod_ei_usl,"uslnast.alx");

strncpy(nomnn,row[4],sizeof(nomnn)-1);
strncpy(frop,row[5],sizeof(frop)-1);
strncpy(uspr,row[6],sizeof(uspr)-1);
strncpy(osnov,row[7],sizeof(osnov)-1);
rsdat(&dnn,&mnn,&gnn,row[8],2);
strncpy(kodop,row[9],sizeof(kodop)-1);

usldopnal(tipz,kodop,&procent,naimnal,sizeof(naimnal));
int nomer_str=0;

//печатаем заголовок налоговой накладной
rasnaln1(imaf,&nomer_str,&kor,dd,md,gd,dnn,mnn,gnn,nomnn,osnov,uspr,frop,kpos,tipz,&f1,&f2);


sprintf(strsql,"select metka,kodzap,kolih,cena,ei,dnaim from Usldokum1 \
where datd='%d-%02d-%02d' and podr=%d and nomd='%s' and tp=%d order by metka,kodzap asc",
gd,md,dd,podr,nomdok,tipz);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
char razdel[8];
strcpy(razdel," I");
itogo=0.;
bb2=0.;
i=0;
while(cur.read_cursor(&row) != 0)
 {
  i++;

  metka=atoi(row[0]);
  kodzap=atoi(row[1]);
  kolih=atof(row[2]);
  cena=atof(row[3]);
  cena=okrug(cena,okrcn);

  /*Читаем наименование материалла*/
  naim.new_plus("");

  if(metka == 0)
   sprintf(strsql,"select naimat from Material where kodm=%d",
   kodzap);

  if(metka == 1)
   sprintf(strsql,"select naius from Uslugi where kodus=%d",
   kodzap);

  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    printw("%s\n",strsql);
    if(metka == 0)
     printw("%s %d !\n",gettext("Не найден код материалла"),kodzap);
    if(metka == 1)
     printw("%s %d !\n",gettext("Не найден код услуги"),kodzap);
    OSTANOV();
   }
  else
   {
    naim.new_plus(row1[0]);
    if(row[5][0] != '\0')
     {
      naim.plus(" ",row[5]);
     }
   }
  
  strncpy(ei,row[4],sizeof(ei)-1);

  bb=cena*kolih;
  bb=okrug(bb,okrg1);

  if(i == 2)
   {
    memset(datop,'\0',sizeof(datop));
    memset(razdel,'\0',sizeof(razdel));
   }  
  if(proverka(kod_ei_usl.ravno(),ei,0,1) == 0 && kolih == 1.)
    fprintf(f1,"|%-4s|%-10s|%-*.*s|%-*s|%-*.*s|%10s",
    razdel,datop,
    iceb_tu_kolbait(40,naim.ravno()),iceb_tu_kolbait(40,naim.ravno()),naim.ravno(),
    iceb_tu_kolbait(7,gettext("грн.")),gettext("грн."),
    iceb_tu_kolbait(9,gettext("Послуга")),iceb_tu_kolbait(9,gettext("Послуга")),gettext("Послуга"),
    prcn(cena));
  else
    fprintf(f1,"|%-4s|%-10s|%-*.*s|%-*.*s|%9.9g|%10s",
    razdel,datop,
    iceb_tu_kolbait(40,naim.ravno()),iceb_tu_kolbait(40,naim.ravno()),naim.ravno(),
    iceb_tu_kolbait(7,ei),iceb_tu_kolbait(7,ei),ei,
    kolih,prcn(cena));

  if(tipnn == 0)
    fprintf(f1,"|%9s|%9s|%9s|%9s|%11s|\n",
     prcn(bb)," "," "," "," ");

  if(tipnn == 1)
    fprintf(f1,"|%9s|%9s|%9s|%9s|%11s|\n",
    " ",prcn(bb)," "," "," ");

  if(tipnn == 2)
    fprintf(f1,"|%9s|%9s|%9s|%9s|%11s|\n",
    " "," ",prcn(bb)," "," ");

  if(tipnn == 3)
    fprintf(f1,"|%9s|%9s|%9s|%9s|%11s|\n",
    " "," "," ",prcn(bb)," ");

  for(int nom=40; nom < iceb_tu_strlen(naim.ravno()); nom+=40)
   fprintf(f1,"|%4s|%-10s|%-*.*s|%-7.7s|%9.9s|%10s|%9s|%9s|%9s|%9s|%11s|\n",
    " "," ",
    iceb_tu_kolbait(nom,iceb_tu_adrsimv(nom,naim.ravno())),
    iceb_tu_kolbait(nom,iceb_tu_adrsimv(nom,naim.ravno())),
    iceb_tu_adrsimv(nom,naim.ravno()),
    " "," "," "," "," "," "," "," ");

  itogo+=bb;


 }

//Печатаем концовку налоговой накладной
rasnaln2(nomer_str,kor,tipnn,itogo,sumkor,naimnal,procent,pnds,"uslnast.alx",kodop,okrg1,0.,f1,f2);

}
