/* $Id: rasosmat.c,v 5.29 2011-01-13 13:43:23 sasa1 Exp $ */
/*15.12.2009	31.05.1999	Белых А.И.	rasosmat.c
Распечатка абсолютного остатка
*/
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char     *organ;/*Наименование организации*/
extern char	*maskmat; /*Массив кодов отмеченных материалов*/

int rasosmat(class spis_oth *oth)
{
struct  tm      *bf;
time_t          tmm;
int		kom,kom1;
short		dp,mp,gp;
short		dn,mn,gn;
short		dk,mk,gk;
char		imaf[32],imaf1[32],imaf2[32];
int		sklad,kodm;
char		naim[64];
FILE		*ff,*ff1,*ff2;
char		bros[512];
char		str[312];
double		ost=0.;
short		kgrm,kgrm1;
static char	skladi[112];
static char	grupi[112];
static char	kodmz[112];
static char	dat1[11];
double		itog,itogs;
short		kolskl,ii;
long		kolstr,kolstr1,kolstr2;
SQL_str         row,row1;
char		strsql[512];
char		nm[512];
int		kgr;
class iceb_tu_str naik("");
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);

SQLCURSOR curr;
if(dat1[0] == '\0')
  sprintf(dat1,"%d.%d.%d",dt,mt,gt);
VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_data(skladi,sizeof(skladi));
VV.VVOD_SPISOK_add_data(grupi,sizeof(grupi));
VV.VVOD_SPISOK_add_data(kodmz,sizeof(kodmz));
VV.VVOD_SPISOK_add_data(dat1,11);

VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка абсолютных остатков по материаллам."));

VV.VVOD_SPISOK_add_MD(gettext("Склад..(,,).........."));
VV.VVOD_SPISOK_add_MD(gettext("Группа.(,,).........."));
VV.VVOD_SPISOK_add_MD(gettext("Код материалла (,,*).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата остатка.(д.м.г)."));


naz:;

clear();


helstr(LINES-1,0,"F2/+",gettext("расчет"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(skladi,VV.VVOD_SPISOK_return_data(0),sizeof(skladi)-1);
strncpy(grupi,VV.VVOD_SPISOK_return_data(1),sizeof(grupi)-1);
strncpy(kodmz,VV.VVOD_SPISOK_return_data(2),sizeof(kodmz)-1);
strncpy(dat1,VV.VVOD_SPISOK_return_data(3),sizeof(dat1)-1);
class iceb_tu_str kods("");
class iceb_tu_str naims("");
switch(kom)
 {
  case FK2:
  case PLU:
    break;
  case FK10:
  case ESC:
    return(1);
  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списку складів."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списку груп."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списку матеріалів."));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 8 :
      case -1:
       goto naz;

      case 0 :
        if(dirsklad(1,&kods,&naims) == 0)
         VV.data_z_plus(0,kods.ravno()); 
        goto naz;

      case 1 :
        vibrek("Grup",grupi,sizeof(grupi),nm);
        VV.VVOD_SPISOK_zapis_data(1,grupi);
        goto naz;

      case 2 :

        naik.new_plus("");
        bros[0]='\0';
        if(dirmatr1(&kgr,&kodm,&naik,0,bros,0,0,0) == 0)
         {
          VV.data_z_plus(2,kodm);
         }

        clear();
        goto naz;
     }
  case FK4:
    VV.VVOD_clear_data();
    goto naz;
 default:
    goto naz;
 }

if(VV.VVOD_SPISOK_return_data(0)[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введен склад !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(rsdat(&dn,&mn,&gn,dat1,1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

clear();
GDITE();

time(&tmm);
bf=localtime(&tmm);

sklad=(int)ATOFM(VV.VVOD_SPISOK_return_data(0));

dp=dk=dn;
mp=mk=mn;
gp=gk=gn;

dpm(&dp,&mp,&gp,2);

sprintf(strsql,"select kodm,kodgr,naimat from Material order by kodm asc");
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  printw("%s\n",sql_error(&bd));
  OSTANOV();
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одного материалла !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }  

sprintf(imaf,"dv%d.tmp",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

printw("%s\n",gettext("Просматриваем список материалов."));
refresh();
kolstr2=kolstr1=0;

while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(grupi,row[1],0,0) != 0)
    continue;
  if(kodmz[0] != '\0')
   {
    if(kodmz[0] != '*')
     {
      if(proverka(kodmz,row[0],0,0) != 0)
        continue;
      }
    else
     if(maskmat != NULL)
      if(proverka(maskmat,row[0],0,0) != 0)
        continue;
   }
  kolstr2++;    
  fprintf(ff,"%s|%s|%s\n",row[1],row[2],row[0]);

 }

fclose(ff);
printw("%s\n",gettext("Сортируем записи."));
refresh();
sprintf(bros,"sort -o %s -n -t\\| %s",imaf,imaf);
runsystem(bros);
printw(gettext("Печатаем.\n"));
refresh();

if((ff = fopen(imaf,"r")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

sprintf(imaf1,"ostm%d.lst",getpid());

if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return(1);
 }

sprintf(imaf2,"ostm1_%d.lst",getpid());

if((ff2 = fopen(imaf2,"w")) == NULL)
 {
  error_op_nfil(imaf2,errno,"");
  return(1);
 }

fprintf(ff1,"\x1B\x33%c",28); /*Уменьшаем межстрочный интервал*/

fprintf(ff2,"\x1B\x33%c",28); /*Уменьшаем межстрочный интервал*/

kolskl=pole2(skladi,',');
if(kolskl == 0)
 kolskl=1;

fprintf(ff1,"%s\n",organ);


printw(gettext("Склад %d\n"),sklad);
refresh();

fprintf(ff1,"\n%s %s\n\
%s %d.%d.%d%s  %s %d.%d.%d%s %s: %d:%d\n",
gettext("Абсолютный остаток по складу"),
skladi,
gettext("На"),
dn,mn,gn,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

fprintf(ff2,"\n%s %s\n\
%s %d.%d.%d%s  %s %d.%d.%d%s %s: %d:%d\n",
gettext("Абсолютный остаток по складу"),
skladi,
gettext("На"),
dn,mn,gn,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

if(grupi[0] != '\0')
 {
  fprintf(ff1,"%s: %s\n",gettext("Группа"),grupi);
  fprintf(ff2,"%s: %s\n",gettext("Группа"),grupi);
 }

if(kodmz[0] != '\0')
 {
  if(kodmz[0] != '*')
   {
    fprintf(ff1,"%s: %s\n",gettext("Код материалла"),kodmz);
    fprintf(ff2,"%s: %s\n",gettext("Код материалла"),kodmz);
   }
  else
   {
    fprintf(ff1,"%s: %s\n",gettext("Код материалла"),maskmat);
    fprintf(ff2,"%s: %s\n",gettext("Код материалла"),maskmat);
   }
 }



itog=itogs=0.;
kgrm=kgrm1=0;
kolstr1=0;

while(fgets(str,sizeof(str),ff) != NULL)
 {
    strzag(LINES-1,0,kolstr2,++kolstr1);
    POLE(str,bros,1,'|');
    kgrm=atoi(bros);
    if(kgrm1 != kgrm)
     {
      if(kgrm1 != 0)
       {
        printw("%s %10.10g\n",gettext("Итого по группе"),itog);
        GDITE();
        fprintf(ff1,"\
------------------------------------------------------------------------------------------------------------------------------------\n\
%*s %8.8g\n",iceb_tu_kolbait(56,gettext("Итого по группе")),gettext("Итого по группе"),itog);
        fprintf(ff2,"\
-----------------------------------------------------------------\n\
%*s %8.8g\n",iceb_tu_kolbait(56,gettext("Итого по группе")),gettext("Итого по группе"),itog);
        itog=0.;
       }
      memset(nm,'\0',sizeof(nm));
      sprintf(strsql,"select naik from Grup where kod=%d",
      kgrm);
      if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
       {
        beep();
        printw("%s %d !\n",gettext("Не найдена группа"),kgrm);
        OSTANOV();
       }    
      else
        strncpy(nm,row1[0],sizeof(nm)-1);
      printw("Група %d %s\n",kgrm,nm);
      GDITE();
      fprintf(ff1,"\n%s %d %s\n\
------------------------------------------------------------------------------------------------------------------------------------\n",
      gettext("Группа"),kgrm,nm);
      fprintf(ff2,"\n%s %d %s\n\
-----------------------------------------------------------------\n",
      gettext("Группа"),kgrm,nm);
      kgrm1=kgrm;
     } 
    POLE(str,naim,2,'|');
    POLE(str,bros,3,'|');
    kodm=atoi(bros);

    ost=0.;
    for(ii=1; ii <= kolskl ; ii++)
     {
      if(kolskl > 1)
       {
        POLE(skladi,bros,ii,',');
        sklad=(int)ATOFM(bros);
       }
      else
        sklad=(int)ATOFM(skladi);

      ost+=ostdok1(dp,mp,gp,sklad,kodm);
     }

    if(ost != 0)
     {
      fprintf(ff1,"%-5d %-*s %8.8g|          |          |          |          |          |          |\n",
      kodm,
      iceb_tu_kolbait(50,naim),naim,
      ost);
      fprintf(ff1,"\
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - \n");
      fprintf(ff2,"%-5d %-*s %8.8g\n",
      kodm,
      iceb_tu_kolbait(50,naim),naim,
      ost);
      
      itog+=ost;
      itogs+=ost;
     }
 }
rewind(ff);
printw("%s:%10.10g\n",gettext("Итого по группе"),itog);
printw("%s:%10.10g\n",gettext("Общий итог"),itogs);
fprintf(ff1,"\
------------------------------------------------------------------------------------------------------------------------------------\n\
%*s %8.8g\n",iceb_tu_kolbait(56,gettext("Итого по группе")),gettext("Итого по группе"),itog);
fprintf(ff2,"\
-----------------------------------------------------------------\n\
%*s %8.8g\n",iceb_tu_kolbait(56,gettext("Итого по группе")),gettext("Итого по группе"),itog);

fprintf(ff1,"\
------------------------------------------------------------------------------------------------------------------------------------\n\
%*s %8.8g\n",iceb_tu_kolbait(56,gettext("Общий итог")),gettext("Общий итог"),itogs);
fprintf(ff2,"\
-----------------------------------------------------------------\n\
%*s %8.8g\n",iceb_tu_kolbait(56,gettext("Общий итог")),gettext("Общий итог"),itogs);

podpis(ff1);
podpis(ff2);


fclose(ff);
fclose(ff1);
fclose(ff2);
unlink(imaf);
printw_vr(tmm);


OSTANOV();

oth->spis_imaf.plus(imaf2);
oth->spis_naim.plus(gettext("Распечатка абсолютных остатков по материаллам."));
oth->spis_imaf.plus(imaf1);
oth->spis_naim.plus(gettext("Пустографка"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);
 
return(0); 
}
