/* $Id: raspol.c,v 5.21 2011-01-13 13:43:23 sasa1 Exp $ */
/*01.11.2009	08.05.2001	Белых А.И.	raspol.c
Получение отчета по начисленной зарплате мужчины/женщины
*/
#include        <errno.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char	*organ;
extern short	mmm,ggg;

int raspol(class spis_oth *oth)
{
struct  tm      *bf;
time_t          tmm;
int		kom1;
static class iceb_tu_str dat1("");
char		strsql[512];
SQL_str		row,row1,row2;
int		kolstr,kolstr1,kolstr2;
FILE		*ff;
char		imaf[32];
short		mn,gn;
short		dkm=0;
double		tablic[4][3]; 
short		pol=0; //0-мужчина 1-женщина
double		sum=0.;
int		kolmug=0;
int		kolgen=0;
int		kolmug_s=0;
int		kolgen_s=0;
int		koltabel=0;
int		kodt,i;
char 		naimtab[512];
int		kolnah=0;
int		s1,s2,s3;
SQLCURSOR curr;
if(dat1.ravno()[0] == '\0')
 {
  sprintf(strsql,"%d.%d",mmm,ggg);
  dat1.new_plus(strsql);
 }
VVOD VVOD1(2);
VVOD1.VVOD_SPISOK_add_ZAG(gettext("Расчет распределения начислений мужчина/женщина"));
VVOD1.VVOD_SPISOK_add_MD(gettext("Введите дату (м.г)"));

naz:;

clear();

helstr(LINES-1,0," F10 ",gettext("выход"),NULL);


if((kom1=vvod1(&dat1,8,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
 return(1);
if(kom1 == ESC)
 return(1);

if(rsdat1(&mn,&gn,dat1.ravno()) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

GDITE();
clear();

time(&tmm);
bf=localtime(&tmm);


//Создаем массивы для видов табеля

class masiv_din_int TABEL;

sprintf(strsql,"select kod from Tabel");


class SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены виды табеля !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);  
 }

while(cur.read_cursor(&row) != 0)
 {
  koltabel++;
  TABEL.plus(atoi(row[0]),-1);
 }

class masiv_din_int DNIMUG;
class masiv_din_int HASMUG;
class masiv_din_int KDNMUG;
class masiv_din_int DNIMUG_S;
class masiv_din_int HASMUG_S;
class masiv_din_int KDNMUG_S;

class masiv_din_int DNIGEN;
class masiv_din_int HASGEN;
class masiv_din_int KDNGEN;
class masiv_din_int DNIGEN_S;
class masiv_din_int HASGEN_S;
class masiv_din_int KDNGEN_S;

DNIMUG.make_class(koltabel);
HASMUG.make_class(koltabel);
KDNMUG.make_class(koltabel);
DNIMUG_S.make_class(koltabel);
HASMUG_S.make_class(koltabel);
KDNMUG_S.make_class(koltabel);

DNIGEN.make_class(koltabel);
HASGEN.make_class(koltabel);
KDNGEN.make_class(koltabel);

DNIGEN_S.make_class(koltabel);
HASGEN_S.make_class(koltabel);
KDNGEN_S.make_class(koltabel);


//Создаем массивы для видов начислений

class masiv_din_int NASH;

sprintf(strsql,"select kod from Nash");
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены начисления !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);  
 }

while(cur.read_cursor(&row) != 0)
 {
  kolnah++;
  NASH.plus(atoi(row[0]),-1);
 }

class masiv_din_double ZNAHMUG;
class masiv_din_double ZNAHMUG_S;
class masiv_din_double ZNAHGEN;
class masiv_din_double ZNAHGEN_S;
ZNAHMUG.make_class(kolnah);
ZNAHMUG_S.make_class(kolnah);
ZNAHGEN.make_class(kolnah);
ZNAHGEN_S.make_class(kolnah);

memset(&tablic,'\0',sizeof(tablic));
sprintf(strsql,"select tabn,datk,sovm from Zarn where god=%d and mes=%d",gn,mn);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);  
 }

char imaf_prot[50];
sprintf(imaf_prot,"pol%d.lst",getpid());
FILE *ff_prot;
if((ff_prot = fopen(imaf_prot,"w")) == NULL)
 {
  error_op_nfil(imaf_prot,errno,"");
  return(1);
 }
short du,mu,gu;
short metka_sovm=0;

kolstr1=0;
  class SQLCURSOR cur1;  
while(cur.read_cursor(&row) != 0)
 {
  printw("%s\n",row[0]);
  strzag(LINES-1,0,kolstr,++kolstr1);
  rsdat(&du,&mu,&gu,row[1],2);

  if(du != 0)
   if(sravmydat(du,mu,gu,1,mn,gn) < 0)
    continue;
  metka_sovm=atoi(row[2]);
  
  sprintf(strsql,"select pl,fio from Kartb where tabn=%s",row[0]);
  pol=0;
  
  if(readkey(strsql,&row1,&curr) == 1)
    pol=atoi(row1[0]);
  else
   {
    printw("Не найден табельный номер %s\n",row[0]);
    OSTANOV();
    continue;
   }
  if(pol == 0)
   {
    kolmug++;  
    if(metka_sovm == 1)
     kolmug_s++;
   }
  if(pol == 1)
   {
    kolgen++;  
    if(metka_sovm == 1)
     kolgen_s++;
   }
  if(pol == 0)
   fprintf(ff_prot,"%-5s %-*.*s мужчина\n",row[0],iceb_tu_kolbait(30,row1[1]),iceb_tu_kolbait(30,row1[1]),row1[1]);
  if(pol == 1)
   fprintf(ff_prot,"%-5s %-*.*s женщина\n",row[0],iceb_tu_kolbait(30,row1[1]),iceb_tu_kolbait(30,row1[1]),row1[1]);
   
  //Читаем отработанное время
  sprintf(strsql,"select kodt,dnei,has,kdnei from Ztab where god=%d and \
mes=%d and tabn=%s",gn,mn,row[0]);
  if((kolstr2=cur1.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }
  while(cur1.read_cursor(&row1) != 0)
   {
    kodt=atoi(row1[0]);
    i=TABEL.find(kodt);
    if(pol == 0)
     {
      DNIMUG.plus(atoi(row1[1]),i);
      HASMUG.plus(atoi(row1[2]),i);
      KDNMUG.plus(atoi(row1[3]),i);
      if(metka_sovm == 1)
       {
        DNIMUG_S.plus(atoi(row1[1]),i);
        HASMUG_S.plus(atoi(row1[2]),i);
        KDNMUG_S.plus(atoi(row1[3]),i);
       }
     }
    if(pol == 1)
     {
      DNIGEN.plus(atoi(row1[1]),i);
      HASGEN.plus(atoi(row1[2]),i);
      KDNGEN.plus(atoi(row1[3]),i);
      if(metka_sovm == 1)
       {
        DNIGEN_S.plus(atoi(row1[1]),i);
        HASGEN_S.plus(atoi(row1[2]),i);
        KDNGEN_S.plus(atoi(row1[3]),i);
       }
     }
   }


  sprintf(strsql,"select knah,suma from Zarp where datz >= '%d-%d-1' \
and datz <= '%d-%d-31' and tabn=%s and prn='1' and suma <> 0.",
  gn,mn,gn,mn,row[0]);

  if((kolstr2=cur1.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }
  while(cur1.read_cursor(&row1) != 0)
   {
//    printw("%s %s\n",row1[0],row1[1]);
//    refresh();
    sum=atof(row1[1]);
    sprintf(strsql,"select vidn from Nash where kod=%s",row1[0]);
    if(readkey(strsql,&row2,&curr) != 1)
     {
      printw("%s %s !",gettext("Не найден код начисления"),row1[0]);
      OSTANOV();
     }
    kom1=atoi(row2[0]);
    tablic[pol][kom1]+=sum;
    if(metka_sovm == 1)
     tablic[pol+2][kom1]+=sum;
    
    i=NASH.find(atoi(row1[0]));
    if(pol == 0)
     { 
      ZNAHMUG.plus(sum,i);
      if(metka_sovm == 1)
       ZNAHMUG_S.plus(sum,i);
     }
    if(pol == 1)
     { 
      ZNAHGEN.plus(sum,i);
      if(metka_sovm == 1)
        ZNAHGEN_S.plus(sum,i);
      
     }

   }    
 }
fclose(ff_prot);
GDITE();

sprintf(imaf,"m-g%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }
dpm(&dkm,&mn,&gn,5);

fprintf(ff,"%s\n\n\
%s 1.%d.%d %s %d.%d.%d\n\
%s %d.%d.%d%s  %s:%02d:%02d\n",
organ,
gettext("Расчет распределения начислений мужчина/женщина"),
mn,gn,
gettext("до"),
dkm,mn,gn,
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

fprintf(ff,"\n%s\n",gettext("Пол:мужчина"));
fprintf(ff,"----------------------------------------------------------\n");

fprintf(ff,"\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10d\n\n",
iceb_tu_kolbait(10,gettext("Основная")),gettext("Основная"),
tablic[0][0],
iceb_tu_kolbait(10,gettext("Дополнительная")),gettext("Дополнительная"),
tablic[0][1],
iceb_tu_kolbait(10,gettext("Прочая")),gettext("Прочая"),
tablic[0][2],
iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),
tablic[0][0]+tablic[0][1]+tablic[0][2],
iceb_tu_kolbait(10,gettext("Количество")),gettext("Количество"),kolmug);

s1=s2=s3=0;
for(i=0; i < koltabel; i++)
 {
  kodt=TABEL.ravno(i);
  sprintf(strsql,"select naik from Tabel where kod=%d",kodt);
  memset(naimtab,'\0',sizeof(naimtab));
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strncpy(naimtab,row[0],sizeof(naimtab)-1);

  fprintf(ff,"%3d %-*.*s %10d %10d %10d\n",
  kodt,
  iceb_tu_kolbait(30,naimtab),iceb_tu_kolbait(30,naimtab),naimtab,
  DNIMUG.ravno(i),HASMUG.ravno(i),
  KDNMUG.ravno(i));
  s1+=DNIMUG.ravno(i);
  s2+=HASMUG.ravno(i);
  s3+=KDNMUG.ravno(i);

 }
fprintf(ff,"%3s %*s %10d %10d %10d\n\n",
" ",iceb_tu_kolbait(30,gettext("Итого")),gettext("Итого"),s1,s2,s3);

sum=0.;
for(i=0; i < kolnah; i++)
 {
  if(ZNAHMUG.ravno(i) == 0.)
    continue;
  kodt=NASH.ravno(i);
  sprintf(strsql,"select naik from Nash where kod=%d",kodt);
  memset(naimtab,'\0',sizeof(naimtab));
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strncpy(naimtab,row[0],sizeof(naimtab)-1);

  fprintf(ff,"%3d %-*.*s %10.2f\n",
  kodt,
  iceb_tu_kolbait(30,naimtab),iceb_tu_kolbait(30,naimtab),naimtab,
  ZNAHMUG.ravno(i));
  sum+=ZNAHMUG.ravno(i);
 }

fprintf(ff,"%3s %*s %10.2f\n"," ",iceb_tu_kolbait(30,gettext("Итого")),gettext("Итого"),sum);

fprintf(ff,"\n%s\n",gettext("Мужчины совместители"));
fprintf(ff,"----------------------------------------------------------\n");

fprintf(ff,"\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10d\n\n",
iceb_tu_kolbait(10,gettext("Основная")),gettext("Основная"),
tablic[2][0],
iceb_tu_kolbait(10,gettext("Дополнительная")),gettext("Дополнительная"),
tablic[2][1],
iceb_tu_kolbait(10,gettext("Прочая")),gettext("Прочая"),
tablic[2][2],
iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),
tablic[2][0]+tablic[2][1]+tablic[2][2],
iceb_tu_kolbait(10,gettext("Количество")),gettext("Количество"),kolmug_s);
s1=s2=s3=0;
for(i=0; i < koltabel; i++)
 {
  kodt=TABEL.ravno(i);
  sprintf(strsql,"select naik from Tabel where kod=%d",kodt);
  memset(naimtab,'\0',sizeof(naimtab));
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strncpy(naimtab,row[0],sizeof(naimtab)-1);

  fprintf(ff,"%3d %-*.*s %10d %10d %10d\n",
  kodt,
  iceb_tu_kolbait(30,naimtab),iceb_tu_kolbait(30,naimtab),naimtab,
  DNIMUG_S.ravno(i),
  HASMUG_S.ravno(i),
  KDNMUG_S.ravno(i));
  s1+=DNIMUG_S.ravno(i);
  s2+=HASMUG_S.ravno(i);
  s3+=KDNMUG_S.ravno(i);

 }
fprintf(ff,"%3s %*s %10d %10d %10d\n\n"," ",iceb_tu_kolbait(30,gettext("Итого")),gettext("Итого"),s1,s2,s3);

sum=0.;
for(i=0; i < kolnah; i++)
 {
  if(ZNAHMUG_S.ravno(i) == 0.)
    continue;
  kodt=NASH.ravno(i);
  sprintf(strsql,"select naik from Nash where kod=%d",kodt);
  memset(naimtab,'\0',sizeof(naimtab));
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strncpy(naimtab,row[0],sizeof(naimtab)-1);

  fprintf(ff,"%3d %-*.*s %10.2f\n",
  kodt,
  iceb_tu_kolbait(30,naimtab),iceb_tu_kolbait(30,naimtab),naimtab,
  ZNAHMUG_S.ravno(i));
  sum+=ZNAHMUG_S.ravno(i);
 }
fprintf(ff,"%3s %*s %10.2f\n"," ",iceb_tu_kolbait(30,gettext("Итого")),gettext("Итого"),sum);

printw("\n%s\n",gettext("Пол:мужчина"));
printw("---------------------------------\n");

printw("\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10d\n",
iceb_tu_kolbait(10,gettext("Основная")),gettext("Основная"),
tablic[0][0],
iceb_tu_kolbait(10,gettext("Дополнительная")),gettext("Дополнительная"),
tablic[0][1],
iceb_tu_kolbait(10,gettext("Прочая")),gettext("Прочая"),
tablic[0][2],
iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),
tablic[0][0]+tablic[0][1]+tablic[0][2],
iceb_tu_kolbait(10,gettext("Количество")),gettext("Количество"),kolmug);

fprintf(ff,"\n%s\n",gettext("Пол:женщина"));
fprintf(ff,"----------------------------------------------------------\n");

fprintf(ff,"\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10d\n",
iceb_tu_kolbait(10,gettext("Основная")),gettext("Основная"),
tablic[1][0],
iceb_tu_kolbait(10,gettext("Дополнительная")),gettext("Дополнительная"),
tablic[1][1],
iceb_tu_kolbait(10,gettext("Прочая")),gettext("Прочая"),
tablic[1][2],
iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),
tablic[1][0]+tablic[1][1]+tablic[1][2],
iceb_tu_kolbait(10,gettext("Количество")),gettext("Количество"),kolgen);

s1=s2=s3=0;
for(i=0; i < koltabel; i++)
 {
  kodt=TABEL.ravno(i);
  sprintf(strsql,"select naik from Tabel where kod=%d",kodt);
  memset(naimtab,'\0',sizeof(naimtab));
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strncpy(naimtab,row[0],sizeof(naimtab)-1);

  fprintf(ff,"%3d %-*.*s %10d %10d %10d\n",
  kodt,
  iceb_tu_kolbait(30,naimtab),iceb_tu_kolbait(30,naimtab),naimtab,
  DNIGEN.ravno(i),HASGEN.ravno(i),
  KDNGEN.ravno(i));
  s1+=DNIGEN.ravno(i);
  s2+=HASGEN.ravno(i);
  s3+=KDNGEN.ravno(i);
 }

fprintf(ff,"%3s %*s %10d %10d %10d\n\n"," ",iceb_tu_kolbait(30,gettext("Итого")),gettext("Итого"),s1,s2,s3);

sum=0.;
for(i=0; i < kolnah; i++)
 {
  if(ZNAHGEN.ravno(i) == 0.)
    continue;
  kodt=NASH.ravno(i);
  sprintf(strsql,"select naik from Nash where kod=%d",kodt);
  memset(naimtab,'\0',sizeof(naimtab));
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strncpy(naimtab,row[0],sizeof(naimtab)-1);

  fprintf(ff,"%3d %-*.*s %10.2f\n",
  kodt,
  iceb_tu_kolbait(30,naimtab),iceb_tu_kolbait(30,naimtab),naimtab,
  ZNAHGEN.ravno(i));
  sum+=ZNAHGEN.ravno(i);
 }

fprintf(ff,"%3s %*s %10.2f\n"," ",iceb_tu_kolbait(30,gettext("Итого")),gettext("Итого"),sum);

fprintf(ff,"\n%s\n",gettext("Женщины совместители"));
fprintf(ff,"----------------------------------------------------------\n");

fprintf(ff,"\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10d\n",
iceb_tu_kolbait(10,gettext("Основная")),gettext("Основная"),
tablic[3][0],
iceb_tu_kolbait(10,gettext("Дополнительная")),gettext("Дополнительная"),
tablic[3][1],
iceb_tu_kolbait(10,gettext("Прочая")),gettext("Прочая"),
tablic[3][2],
iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),
tablic[3][0]+tablic[3][1]+tablic[3][2],
iceb_tu_kolbait(10,gettext("Количество")),gettext("Количество"),kolgen_s);
s1=s2=s3=0;
for(i=0; i < koltabel; i++)
 {
  kodt=TABEL.ravno(i);
  sprintf(strsql,"select naik from Tabel where kod=%d",kodt);
  memset(naimtab,'\0',sizeof(naimtab));
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strncpy(naimtab,row[0],sizeof(naimtab)-1);

  fprintf(ff,"%2d %-*.*s %10d %10d %10d\n",
  kodt,
  iceb_tu_kolbait(30,naimtab),iceb_tu_kolbait(30,naimtab),naimtab,
  DNIGEN_S.ravno(i),HASGEN_S.ravno(i),
  KDNGEN_S.ravno(i));
  s1+=DNIGEN_S.ravno(i);
  s2+=HASGEN_S.ravno(i);
  s3+=KDNGEN_S.ravno(i);
 }

fprintf(ff,"%2s %*s %10d %10d %10d\n\n",
" ",iceb_tu_kolbait(30,gettext("Итого")),gettext("Итого"),s1,s2,s3);

sum=0.;
for(i=0; i < kolnah; i++)
 {
  if(ZNAHGEN_S.ravno(i) == 0.)
    continue;
  kodt=NASH.ravno(i);
  sprintf(strsql,"select naik from Nash where kod=%d",kodt);
  memset(naimtab,'\0',sizeof(naimtab));
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strncpy(naimtab,row[0],sizeof(naimtab)-1);

  fprintf(ff,"%3d %-*.*s %10.2f\n",
  kodt,
  iceb_tu_kolbait(30,naimtab),iceb_tu_kolbait(30,naimtab),naimtab,
  ZNAHGEN_S.ravno(i));
  sum+=ZNAHGEN_S.ravno(i);
 }

fprintf(ff,"%3s %*s %10.2f\n",
" ",iceb_tu_kolbait(30,gettext("Итого")),gettext("Итого"),sum);

printw("\n%s\n",gettext("Пол:женщина"));
printw("---------------------------------\n");

printw("\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10d\n",
iceb_tu_kolbait(10,gettext("Основная")),gettext("Основная"),
tablic[1][0],
iceb_tu_kolbait(10,gettext("Дополнительная")),gettext("Дополнительная"),
tablic[1][1],
iceb_tu_kolbait(10,gettext("Прочая")),gettext("Прочая"),
tablic[1][2],
iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),
tablic[1][0]+tablic[1][1]+tablic[1][2],
iceb_tu_kolbait(10,gettext("Количество")),gettext("Количество"),kolgen);



podpis(ff);
fclose(ff);
OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчет распределения начислений мужчина/женщина"));
oth->spis_imaf.plus(imaf_prot);
oth->spis_naim.plus(gettext("Протокол расчёта"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);

}
