/* $Id: rasprop.c,v 5.17 2011-08-29 07:08:59 sasa Exp $ */
/*23.12.2009	13.06.2000	Белых А.И.	rasprop.c
Распечатка пропуска для вывоза полученного товара-материалла
*/
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern double   okrg1; /*Округление*/
extern double	okrcn;  /*Округление цены*/

void rasprop(short dd,short md,short gd,int skl,const char *nomdok)
{
SQL_str         row;
int		kolstr;
char		strsql[512];
FILE            *ff,*f1;
char		kontr[64];
int		tipz;
char		uspr[64];
char		datop[12];
short		metz;
short		d,m,g;
char		bros[512];
char		naiskl[512];
char		imaf[64],imaf1[64];
char		str[1024];
int		kodm;
double		kratn;
char		ein[64];
double		kolih,kolihi;
int		nomerz;
double		mest,mesti;
char		naim[512];
SQLCURSOR cur;

/*Читаем шапку документа*/
sprintf(strsql,"select * from Dokummat \
where datd='%d-%02d-%02d' and sklad=%d and nomd='%s'",
gd,md,dd,skl,nomdok);

if(readkey(strsql,&row,&cur) != 1)
 {
  clearstr(20,0);
  printw("Год=%d Документ=%s Склад=%d",gd,nomdok,skl);  
  error2(21,0,1,"rasnaln-Не найден документ !");
  return;
 }

strcpy(kontr,row[3]);
tipz=atoi(row[0]);


sprintf(strsql,"select nomerz,sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d",
gd,nomdok,skl);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  printw("**%s\n",sql_error(&bd));
  OSTANOV();
 }

memset(uspr,'\0',sizeof(uspr));
memset(datop,'\0',sizeof(datop));


if(kolstr != 0)
while(cur.read_cursor(&row) != 0)
 {
  metz=atoi(row[0]);
//  if(metz == 3)
//    strncpy(osnov,row[1],sizeof(osnov)-1);
  if(metz == 7)
    strncpy(uspr,row[1],sizeof(uspr)-1);
/*
  if(metz == 8)
    strncpy(frop,row[1],sizeof(frop)-1);
*/
  if(metz == 9)
   {
    rsdat(&d,&m,&g,row[1],0);
    if(d != 0 && SRAV1(g,m,d,gd,md,dd) > 0)
     sprintf(datop,"%02d.%02d.%d",d,m,g);
   }
/*
  if(metz == 13)
   {
    sumkor=ATOFM(row[1]);
    sumkor=okrug(sumkor,0.01);
   }
*/
 }

sprintf(strsql,"%d",getpid());
memset(imaf,'\0',sizeof(imaf));
sprintf(imaf,"prp%.6s.lst",strsql);

if((f1 = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }
int kolstrok=0;

rashap(tipz,&kolstrok,"00",kontr,0,0,f1);
fprintf(f1,"\x1B\x50"); /*10-знаков*/

/*Читаем наименование склада*/
sprintf(strsql,"select naik from Sklad where kod=%d",
skl);
naiskl[0]='\0';

if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  move(20,0);
  beep();
  printw(gettext("Не найден склад %d в списке складов !"),skl);
  printw("\n");
  OSTANOV();
 }
else
  strncpy(naiskl,row[0],sizeof(naiskl)-1);

fprintf(f1,"\n%s\n\n",naiskl);

fprintf(f1,"         %s N%s\n",
gettext("ПРОПУСК к расходной накладной"),nomdok);

memset(strsql,'\0',sizeof(strsql));
mesc(md,1,strsql);
fprintf(f1,"\
                      %d %s %d%s\n",
dd,strsql,gd,gettext("г."));

/*Читаем доверенность*/
sprintf(strsql,"select sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d and nomerz=%d",
gd,nomdok,skl,1);

if(sql_readkey(&bd,strsql,&row,&cur) == 1)
 {
  fprintf(f1,"%s N",gettext("Доверенность"));
  POLE(row[0],bros,1,'#');
  fprintf(f1," %s",bros);
  POLE(row[0],bros,2,'#');
  fprintf(f1," %s %s",gettext("от"),bros);
 }
fprintf(f1,"\n");


/*Читаем через кого*/
sprintf(strsql,"select sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d and nomerz=%d",
gd,nomdok,skl,2);

if(sql_readkey(&bd,strsql,&row,&cur) == 1)
  fprintf(f1,"Через кого: %s\n",row[0]);

fprintf(f1,"\x0F"); /*Включение ужатого режима печати*/

fprintf(f1,"\
--------------------------------------------------------------------------------\n");
fprintf(f1,gettext(" N |       Наименование продукции                 |Ед. |Количество| Кол. |Крат-|\n"));
fprintf(f1,gettext("   |              (товару)                        |изм.|          | м-ст |ность|\n"));
fprintf(f1,"\
--------------------------------------------------------------------------------\n");

/*Готовим отсортированный файл*/

sortnak(dd,md,gd,skl,nomdok);
sprintf(imaf1,"sn%d.tmp",getpid());
if((ff = fopen(imaf1,"r")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return;
 }
kolihi=mesti=0.;
nomerz=0;
while(fgets(str,sizeof(str),ff) != NULL)
 {
  polen(str,naim,sizeof(naim),2,'|');
  POLE(str,bros,3,'|');
  kodm=atoi(bros);

  polen(str,&kratn,6,'|');
//  kratn=atof(bros);

  POLE(str,ein,7,'|');

  POLE(str,bros,10,'|');
  kolih=atof(bros);
  kolihi+=kolih;
  mest=0.;
  if(kratn != 0.)
   {
    mest=kolih/kratn;
    mest=okrug(mest,0.1);
   }
  mesti+=mest;
  fprintf(f1,"%3d %-*.*s %-*s %10.10g %6.6g %4.4g\n",
  ++nomerz,
  iceb_tu_kolbait(46,naim),iceb_tu_kolbait(46,naim),naim,
  iceb_tu_kolbait(4,ein),ein,
  kolih,mest,kratn);

 }
fprintf(f1,"\
--------------------------------------------------------------------------------\n");
fprintf(f1,"%*s:%10.10g %6.6g\n",
iceb_tu_kolbait(55,gettext("Итого")),gettext("Итого"),kolihi,mesti);


fprintf(f1,"\n\%s%s\n",gettext("\
Директор______________________        Главный  бухгалтер_______________\n\n"),
gettext("\
Отпустил______________________        Принял__________________________"));

fclose(f1);
fclose(ff);
unlink(imaf1);
class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Распечатка пропуска"));
iceb_t_ustpeh(imaf,1);
iceb_t_rabfil(&oth,"");

}
