/*$Id: rasspec.c,v 5.24 2011-01-13 13:43:23 sasa1 Exp $*/
/*22.12.2009	18.01.2000	Белых А.И.	rasspec.c
Распечатка спецификации изделия
*/
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


void		rasspec(int kodiz) //Код изделия
{
SQL_str         row,row1;
char		strsql[512];
int		kolnuz;
char		naim[512];
char		imaf[24];
char		bros[512];
FILE            *ff;
int		kodizr;
int		suz,zsuz;
int		kolstr;
int		kodd;

zsuz=0;
kodizr=kodiz;

sprintf(imaf,"spec%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }
 
class iceb_t_razuz_data data;
data.kod_izd=kodiz;
/*Определяем входящие узлы*/

kolnuz=razuz(&data);

/*
printw("Разузловка завершена.\n");
refresh();
*/
SQLCURSOR cur;

SQLCURSOR cur1;

naz:;


memset(naim,'\0',sizeof(naim));
for(int metka_zap=0; metka_zap < 2; metka_zap++)
 {
  if(metka_zap == 0)
    sprintf(strsql,"select naimat from Material where kodm=%d",kodizr);
  if(metka_zap == 1)
    sprintf(strsql,"select naius from Uslugi where kodus=%d",kodizr);
  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    if(metka_zap == 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s %d !",gettext("Не найден код записи"),kodizr);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
     }
   }  
  else
   { 
    strncpy(naim,row1[0],sizeof(naim)-1);
    break;
   }
 }
 
if(kodiz == kodizr)
 {
  fprintf(ff,"%s %d %s\n\
--------------------------------------------------------------------\n",
  gettext("Спецификация на изделие"),
  kodizr,naim);
 }
else
 {
  fprintf(ff,"\n%s %d %s\n\
--------------------------------------------------------------------\n",
  gettext("Спецификация на узел"), 
  kodizr,naim);
 }

sprintf(strsql,"select kodd,kolih,ei,kz from Specif where kodi=%d",kodizr);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  printw("%s\n",sql_error(&bd));
  OSTANOV();
 }

if(kolstr == 0 )
 {
  /*В изделии нет ни одной записи*/
  printw("rasspec-Нет ни одной записи в изделии !!!\n%s\n",strsql);
  OSTANOV();
  fclose(ff);
  return;
 }

while(cur.read_cursor(&row) != 0)
 {
  kodd=atoi(row[0]);
  memset(naim,'\0',sizeof(naim));
  if(row[3][0] == '0')
   sprintf(strsql,"select naimat from Material where kodm=%s",row[0]);
  if(row[3][0] == '1')
   sprintf(strsql,"select naius from Uslugi where kodus=%s",row[0]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    VVOD SOOB(1);
    if(row[3][0] == '0')
      sprintf(strsql,"%s %d !",gettext("Не найден код материалла"),kodd);
    if(row[3][0] == '1')
      sprintf(strsql,"%s %d !",gettext("Не найден код услуги"),kodd);

    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }  
  else
   {
    strncpy(naim,row1[0],sizeof(naim)-1);
   }
  memset(bros,'\0',sizeof(bros));
  if(data.kod_uz.find(kodd) != -1)
     strcpy(bros,gettext("Узел"));
  fprintf(ff,"%-4s %-*s %*s %*s %10.10g\n",
  row[0],
  iceb_tu_kolbait(40,naim),naim,
  iceb_tu_kolbait(5,row[2]),row[2],
  iceb_tu_kolbait(5,bros),bros,
  atof(row[1]));

 }

for(suz=zsuz ; suz < kolnuz ; suz++)
 {
  kodizr=data.kod_uz.ravno(suz);
  zsuz++;
  goto naz;
 }

podpis(ff);

fclose(ff);

class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Спецификация на изделие"));
iceb_t_ustpeh(imaf,3);
iceb_t_rabfil(&oth,"");
}
