/* $Id: raszkar.c,v 5.19 2011-01-13 13:43:23 sasa1 Exp $ */
/*27.05.2010    28.01.1994      Белых А.И.      raszkar.c
Распечатка карточки материалов в файл
*/
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

int		poizkart(char[],char[],char[],char[],char[],char[],int,int);

extern char     *organ;

void raszkar(SQLCURSOR *cur,int skl,int nk,short dn,
short mn,short gn,short dk,short mk,short gk,char nomdp[],char kontrp[],
char kodop[],int tipzz)
{
class ostatokt ost;
short		dp,mp,gp;
short		d,m,g;
double		kolih,cena,cenar;
short		tp;
char		bros[512];
SQL_str         row,row1;
char		strsql[512];
struct  tm      *bf;
time_t          tmm;
FILE            *f1;
char            imaf[56];
double          it;
char		br1[4];
char		naiskl[512];
char		naim[512];
char		naimg[512];
int		kodm,kgrm,kodt;
double		nds,fas,krt;
char		shu[32];
char		ei[32];
char		kop[32],kor[32];
char		nomz[112]; //Номер заказа
char		innom[32]; //Инвентарный номер / Серия для мед-препаратов
short		dv=0,mv=0,gv=0; //Дата ввода в эксплуатацию малоценки/дата регистрации мед препарата
char		rnd[32]; //регистрационный номер для мед-препарата
SQLCURSOR       cur1;
clear();
GDITE();

memset(rnd,'\0',sizeof(rnd));

/*Узнаем наименование склада материалла*/
sprintf(strsql,"select naik from Sklad where kod=%d",
skl);
if(sql_readkey(&bd,strsql,&row,&cur1) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("dirzkar-Не найден склад %d !"),skl);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }
strncpy(naiskl,row[0],sizeof(naimg)-1);


/*Читаем реквизиты карточки материалла*/
sprintf(strsql,"select * from Kart where sklad=%d and nomk=%d",
skl,nk);
if(sql_readkey(&bd,strsql,&row,&cur1) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("dirzkar-Не найдена карточка материалла %d на складе %d !"),nk,skl);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

ei[0]='\0';
strcpy(ei,row[4]);
fas=atof(row[10]);
krt=atof(row[8]);
kodm=atoi(row[2]);
kodt=atoi(row[11]);
cena=atof(row[6]);
cenar=atof(row[7]);
strncpy(shu,row[5],sizeof(shu)-1);
nds=atof(row[9]);
rsdat(&dv,&mv,&gv,row[14],2);
strncpy(innom,row[15],sizeof(innom)-1);
strncpy(rnd,row[16],sizeof(rnd)-1);
strncpy(nomz,row[17],sizeof(nomz)-1);

/*Узнаем наименование материалла*/
sprintf(strsql,"select kodgr,naimat  from Material where kodm=%d",
kodm);
if(sql_readkey(&bd,strsql,&row,&cur1) != 1)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("dirzkar-Не найден код материалла в списке материалов !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

kgrm=atoi(row[0]);
strncpy(naim,row[1],sizeof(naim)-1);


/*Узнаем наименование группы материалла*/
sprintf(strsql,"select naik from Grup where kod=%d",
kgrm);
if(sql_readkey(&bd,strsql,&row,&cur1) != 1)
 {
  error2(20,0,1,gettext("dirzkar-Не найдена группа материалла !"));
  return;
 }

strncpy(naimg,row[0],sizeof(naimg)-1);

memset(imaf,'\0',sizeof(imaf));
sprintf(imaf,"k%d.lst",getpid());
if((f1 = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }

time(&tmm);
bf=localtime(&tmm);

fprintf(f1,"%s\n",organ);
fprintf(f1,gettext("Распечатка карточки %d склада %s.\n"),
nk,naiskl);

fprintf(f1,"\
%s %d.%d.%d%s %s - %d:%d\n\n",
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

fprintf(f1,"%s - %d %s",gettext("Группа"),kgrm,naimg);
fprintf(f1,"\n");
fprintf(f1,gettext("Материал - %d %s\n"),kodm,naim);
fprintf(f1,gettext("Цена учетная - %.6g Цена реализации - %.6g\n"),cena,cenar);
fprintf(f1,gettext("Счет - %s. НДС - %.10g Код тары - %d\n"),shu,nds,kodt);
fprintf(f1,gettext("Единица измерения - %s Фасовка - %f Кратность - %f\n"),
ei,fas,krt);

fprintf(f1,"%s:%s\n",gettext("Номер заказа"),nomz);
if(rnd[0] == '\0')
 {
  fprintf(f1,"%s:%s\n",gettext("Инвентарный номер"),innom);
  fprintf(f1,"%s:%d.%d.%d\n",gettext("Дата ввода в эксплуатацию"),dv,mv,gv);
 }
else
 {
  fprintf(f1,"%s:%s\n",gettext("Регистрационный номер"),rnd);
  fprintf(f1,"%s:%s\n",gettext("Серия"),innom);
  fprintf(f1,"%s:%d.%d.%d\n",gettext("Дата регистрации"),dv,mv,gv);
 }

ostkar(dn,mn,gn,dk,mk,gk,skl,nk,&ost);

fprintf(f1,"\n%s %10.10g %15.2f %10.10g %15.2f\n",gettext("Остаток"),ost.ostg[0],ost.ostgc[0],ost.ostm[0],ost.ostmc[0]);
fprintf(f1,"%s %10.10g %15.2f %10.10g %15.2f\n",gettext("Приход "),ost.ostg[1],ost.ostgc[1],ost.ostm[1],ost.ostmc[1]);
fprintf(f1,"%s %10.10g %15.2f %10.10g %15.2f\n",gettext("Расход "),ost.ostg[2],ost.ostgc[2],ost.ostm[2],ost.ostmc[2]);
fprintf(f1,"%s %10.10g %15.2f %10.10g %15.2f\n",gettext("Остаток"),ost.ostg[3],ost.ostgc[3],ost.ostm[3],ost.ostmc[3]);

fprintf(f1,gettext("Движение за период %d.%d.%d => %d.%d.%d\n"),dn,mn,gn,dk,mk,gk);
if(nomdp[0] != '\0')
 fprintf(f1,gettext("Номер документа: %s\n"),nomdp);
if(kontrp[0] != '\0')
 fprintf(f1,gettext("Котнтрагент: %s\n"),kontrp);
if(kodop[0] != '\0')
 fprintf(f1,"%s: %s\n",gettext("Код операции"),kodop);
if(tipzz == 1)
 fprintf(f1,gettext("Только приходы.\n"));
if(tipzz == 2)
 fprintf(f1,gettext("Только расходы.\n"));

fprintf(f1,"\n\
--------------------------------------------------------------------------------------------------------\n");
fprintf(f1,gettext("Дата подт.|Дата док. | Ном. доку. |Операц.  |Код конт.|Наименование контра.|  Количество |     Цена    |\n"));
fprintf(f1,"\
--------------------------------------------------------------------------------------------------------\n");


it=0.;
cur->poz_cursor(0);

while(cur->read_cursor(&row) != 0)
 {

  /*Читаем код организации, код операции*/
  sprintf(strsql,"select tip,kodop,kontr from Dokummat \
where datd='%s' and sklad=%d and nomd='%s'",
  row[4],skl,row[2]);

  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
      clearstr(22,0);
      printw("Не знайден документ ! \
Дата-%s Склад-%d Кар.-%d Док.-%s",
      row[4],skl,nk,row[2]);
    OSTANOV();
    continue;
   }
  tp=atoi(row1[0]);
  strcpy(kop,row1[1]);
  strcpy(kor,row1[2]);    

  if(poizkart(nomdp,row[2],kontrp,kor,kodop,kop,tipzz,tp) != 0)
   continue;

  memset(bros,'\0',sizeof(bros));
  if(ATOFM(kor) == 0. && POLE(kor,bros,2,'-') == 0 && kor[0] == '0')
    strncpy(bros,"00",sizeof(bros)-1);
  else
    strncpy(bros,kor,sizeof(bros)-1);

  sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",
  bros);
  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
     beep();
     printw("Не найден контрагент - %s\n",kor);
     OSTANOV();
    }
  strcpy(bros,row1[0]);

  strcpy(br1,"+");
  if(tp == 2)
   {  
    strcpy(br1,"-");
    kolih*=(-1);
   }
  rsdat(&dp,&mp,&gp,row[3],2);
  rsdat(&d,&m,&g,row[4],2);

  //Пропускаем промежуточные стартовые остатки
  if(SRAV(row[2],"000",0) == 0)
   if(sravmydat(d,m,g,dn,mn,gn) != 0)
     continue;

  kolih=atof(row[6]);  
  cena=atof(row[7]);  
  if(row[5][0] == '2')
    kolih*=-1;

  it+=kolih;
  
  fprintf(f1,"%02d.%02d.%d|%02d.%02d.%d|%-*s|%-*s %s|%-*s|%-*.*s|\
%13.13g|%13.10g\n",
  dp,mp,gp,d,m,g,
  iceb_tu_kolbait(12,row[2]),row[2],
  iceb_tu_kolbait(7,kop),kop,
  br1,
  iceb_tu_kolbait(9,kor),kor,
  iceb_tu_kolbait(20,bros),iceb_tu_kolbait(20,bros),bros,
  kolih,cena);
/*
  fprintf(f1,"%02d.%02d.%d|%02d.%02d.%d|%-12s|%-7s %s|%-9s|%-20.20s|
%13.13g|%13.10g\n",
  mk10.dp,mk10.mp,mk10.gp,mk10.d,mk10.m,mk10.g,mk10.nn,mk1.kop,br1,
  mk1.kor,bros,mk10.kolih,mk10.cena);
*/
 }


if(fabs(it) < 0.0000000001)
  it=0.;
fprintf(f1,"\
--------------------------------------------------------------------------------------------------------\n\
%*s: %13.10g\n",iceb_tu_kolbait(74,gettext("Итого")),gettext("Итого"),it);

podpis(f1);
fclose(f1);

class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Распечатка карточки."));
iceb_t_ustpeh(oth.spis_imaf.ravno(0),0);
iceb_t_rabfil(&oth,"");
}
