/* $Id: readdok.c,v 5.11 2011-01-13 13:43:23 sasa1 Exp $ */
/*29.11.2009    16.04.1997      Белых А.И.      readdok.c
Поиск реквизитов документа в материальном учете по номеру
Если вернули 0-нашли
	     1-нет
*/
#include	"buhg.h"

extern char	*kodopsrvc; //Код операции расчета средневзвешенной цены

int readdok(short *dd,short *md,short *gd,//Дата документа
const char *nomdok, //Номер документа
int skk,       //Код склада
int *tipz,     //1-приход 2-расход
char kpos[],   //Контрагент
char naimo[],  //Наименование контрагента
class iceb_tu_str *kprr,   //Код операции
char naimpr[], //Наименование операции
int *metkaprov, //0-выполнять проводки для операции 1-нет
char naiskl[], //Наименование склада
int *skl1,     //Код встречного склада
int *lnds,     //Метка льгот по НДС
short *mvnp,  //0-внешняя 1 -внутреняя 2-изменение стоимости
short *mdd,   //0-обычный документ 1-двойной
int *pro,     //0-не выполнены проводки 1-выполнены
int *ktoi,    //Кто записал
char nomnn[], //Номер налоговой накладной
char nomon[], //Номер ответной накладной
char sheta[], //Счета по операции
int *blokpid, //Кто заблокировал документ
int *loginrash, //Кто распечатал чек
short *dpnn,short *mpnn,short *gpnn, //дата получения налоговой накладной
double *sumandspr, //Сумма НДС для приходного документа введенная вручную
float *pnds,
time_t *vrem)
{
char		strsql[512];
SQL_str         row;
char		bros[512];
int		i;
short		d,m,g;
SQLCURSOR       cur;
/*Читаем шапку документа*/
/*
move(10,0);
printw("Читаем шапку документа.\n");
refresh();
*/

*sumandspr=*metkaprov=*loginrash=0;

if(*dd != 0)
 sprintf(strsql,"select * from Dokummat \
where datd='%d-%02d-%02d' and sklad=%d and nomd='%s'",
 *gd,*md,*dd,skk,nomdok);
else /*передали только год*/
 sprintf(strsql,"select * from Dokummat \
where datd >= '%d-01-01' and datd <= '%d-12-31' and sklad=%d and \
nomd='%s'",
 *gd,*gd,skk,nomdok);

if(sql_readkey(&bd,strsql,&row,&cur) < 1)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найден документ !"));

  if(*dd != 0)
   sprintf(strsql,gettext("Дата=%d.%d.%d Документ=%s Склад=%d"),
   *dd,*md,*gd,nomdok,skk);
  else
   sprintf(strsql,gettext("Документ=%s Склад=%d"),
   nomdok,skk);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  
  return(1);
 }

if(*dd == 0)
 {
  rsdat(&d,&m,&g,row[1],2);
  *dd=d;
  *md=m;
  *gd=g;
 } 
sprintf(kpos,"%s",row[3]);
kprr->new_plus(row[6]);
*tipz=atoi(row[0]);
*pro=atoi(row[8]);
*ktoi=atoi(row[9]);
strcpy(nomnn,row[5]);
*vrem=atol(row[10]);
strcpy(nomon,row[11]);
rsdat(dpnn,mpnn,gpnn,row[12],2);
*pnds=(float)atof(row[13]);

*mdd=0;
if(kodopsrvc != NULL)
if(SRAV(kprr->ravno(),kodopsrvc,0) == 0)
 *mdd=1;
/*Для внутреннего перемещения*/
*skl1=0;
if(ATOFM(kpos) == 0. && POLE(kpos,bros,2,'-') == 0 && kpos[0] == '0')
 {
  *mdd=1;
  POLE(kpos,bros,2,'-');
  *skl1=(int)ATOFM(bros);
 }


/*
printw("mdd=%d kpos=%s\n",*mdd,kpos);
OSTANOV();
*/

/*Читаем наименование организации*/
memset(bros,'\0',sizeof(bros));
if(ATOFM(kpos) == 0. && POLE(kpos,bros,2,'-') == 0 && kpos[0] == '0')
    strcpy(bros,"00");
else
    strncpy(bros,kpos,sizeof(bros)-1);

sprintf(strsql,"select naikon from Kontragent \
where kodkon='%s'",
bros);
naimo[0]='\0';

if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  beep();
  printw(gettext("readdok-Не найден контагент %s !"),bros);
  printw("\n");
  OSTANOV();
 }
else
 strcpy(naimo,row[0]);


/*Читаем наименование операции*/
/*
printw("Читаем наименование операции.\n");
refresh();
*/
if(*tipz == 1)
 strcpy(bros,"Prihod");
if(*tipz == 2)
 strcpy(bros,"Rashod");
 
sprintf(strsql,"select * from %s \
where kod='%s'",
bros,kprr->ravno());
naimpr[0]='\0';
sheta[0]='\0';

if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  sprintf(strsql,gettext("readdok-Не найден код операции %s в таблице %s !"),
  kprr->ravno(),bros);
  error2(20,0,1,strsql);
 }
else
 {
  strcpy(naimpr,row[1]);
  if(*tipz == 2)
   {
    strcpy(sheta,row[5]);
    *metkaprov=atoi(row[6]);
   }
  else
    *metkaprov=atoi(row[5]);
  *mvnp=atoi(row[4]);
 }


/*Читаем наименование склада*/
/*
printw("Читаем наименование склада.\n");
refresh();
*/
sprintf(strsql,"select naik from Sklad \
where kod=%d",
skk);
naiskl[0]='\0';

if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  beep();
  printw(gettext("readdok-Не найден склад %d !"),skk);
  printw("\n");
  OSTANOV();  
 }
else
 strcpy(naiskl,row[0]);

/*Читаем логин распечатавшего чек на кассе*/
sprintf(strsql,"select sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d and nomerz=5",
*gd,nomdok,skk);

if((i=sql_readkey(&bd,strsql,&row,&cur)) == 1)
 *loginrash=atoi(row[0]);

if(*tipz == 1)
 {
  /*Читаем сумму НДС введенную вручную*/
  sprintf(strsql,"select sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d and nomerz=6",
  *gd,nomdok,skk);

  if((i=sql_readkey(&bd,strsql,&row,&cur)) == 1)
   *sumandspr=atof(row[0]);
 }
/*Читаем метку НДС*/
/*
printw("Читаем метку НДС.\n");
refresh();
*/
sprintf(strsql,"select sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d and nomerz=11",
*gd,nomdok,skk);
*lnds=0;

if((i=sql_readkey(&bd,strsql,&row,&cur)) == 1)
 *lnds=atoi(row[0]);

/*Читаем кто заблокировал*/
sprintf(strsql,"select sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d and nomerz=12",
*gd,nomdok,skk);
*blokpid=0;

if((i=sql_readkey(&bd,strsql,&row,&cur)) == 1)
 *blokpid=atoi(row[0]);


/*
printw("strsql=%s\ni=%d row=%s\nlnds=%d\n",strsql,i,row[0],*lnds);
OSTANOV();
*/
return(0);

}
