/* $Id: rozkor.c,v 5.24 2011-01-13 13:43:23 sasa1 Exp $ */
/*29.11.2009	22.10.1998	Белых А.И.	rozkor.c
Расчет корректировки количественных показателей к налоговой
накладной
Расчет выполняется для возвратных накладных в которых.
Необходимо знать номер накладной на отпуск материалла

*/
#include        <math.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


void rozkor(const char *nn, //Номер документа
short d,short m,short g,int skl)
{
char		bros[512];
char		str[1024];
short		i;
char		imaf[32];
short		kom;
short		god;
char		nnn[32];
int             kodm; /*Код материалла*/
int             nk;  /*Номер карточки*/
short		di,mi,gi; /*Дата исходной накладной*/
char		nin[32]; /*Номер исходной накладной*/
double		kolih,kolih1;
FILE		*ff,*ff1;
char		nai[512],nai1[512];
char		inn[32],inn1[32];
char		adr[512],adr1[512];
char		telef[112],telef1[112];
char		nspdv[32],nspdv1[32];
char		uslpr[512]; /*Условие продажи*/
char		forop[40]; /*Форма оплаты*/
char		nomr[32]; /*Номер расчета*/
char		fam[512];
char		prish[32];
char		nomdog[12];
char		datdog[12];
short		shet; /*Счетчик строк*/
double		bb,bb1;
double		it1,it2;
double		cenaz;
long		kolstr,kolstr1;
SQL_str         row,row1;
char		strsql[512];
char		kontr[32];
char		naimat[512];
char		ei[32];
int		lnds1=0;
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);

clear();
/*
printw("rozkor-%d.%d.%d %s %d\n",d,m,g,nn,skl);
refresh();
*/
VVOD VV(0);

VV.VVOD_SPISOK_add_ZAG("Расчет корректировки количественных показателей !");
sprintf(strsql,"Накладная N %s",nn);
VV.VVOD_SPISOK_add_ZAG(strsql);

VV.VVOD_SPISOK_add_data(12);
VV.VVOD_SPISOK_add_data(12);
VV.VVOD_SPISOK_add_data(32);
VV.VVOD_SPISOK_add_data(30);
VV.VVOD_SPISOK_add_data(12);
VV.VVOD_SPISOK_add_data(11);
sprintf(strsql,"%d",gt);
VV.VVOD_SPISOK_add_data(strsql,5);

VV.VVOD_SPISOK_add_MD("Номер расчета................");
VV.VVOD_SPISOK_add_MD("Номер налоговой накладной....");
VV.VVOD_SPISOK_add_MD("Кто выполняет расчет.........");
VV.VVOD_SPISOK_add_MD("Причина корректировки........");
VV.VVOD_SPISOK_add_MD("Номер договора...............");
VV.VVOD_SPISOK_add_MD("Дата договора................");
VV.VVOD_SPISOK_add_MD("Год налоговой накладной......");

naz:;

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2",gettext("расчитать"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strcpy(nomr,VV.VVOD_SPISOK_return_data(0));
strcpy(nnn,VV.VVOD_SPISOK_return_data(1));
strcpy(fam,VV.VVOD_SPISOK_return_data(2));
strcpy(prish,VV.VVOD_SPISOK_return_data(3));
strcpy(nomdog,VV.VVOD_SPISOK_return_data(4));
strcpy(datdog,VV.VVOD_SPISOK_return_data(5));
god=(short)ATOFM(VV.VVOD_SPISOK_return_data(6));

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("matu2_1_2c.txt");
   clear();
   goto naz;
   
  case FK10 :
   return;

  case FK2 :
  case PLU :
   break;
  default:
   goto naz;
 }       

SQLCURSOR cur;

/*Проверяем есть ли такая накладная*/
sprintf(strsql,"select datd,sklad,nomd,kontr,pn from Dokummat where \
datd >= '%04d-01-01' and datd <= '%04d-12-31' and nomnn='%s'",god,god,nnn);

if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"Не найден документ с номером налоговой накладной %s !",nnn);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
float pnds=atof(row[4]);

rsdat(&di,&mi,&gi,row[0],2);
if(SRAV1(g,m,d,gi,mi,di) > 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"Дата налоговой накладной %d.%d.%d больше даты возврата %d.%d.%d !",
  di,mi,gi,d,m,g);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;

 }

strncpy(nin,row[2],sizeof(nin)-1);
strncpy(kontr,row[3],sizeof(kontr)-1);


//Узнаем с каким НДС
sprintf(strsql,"select sodz from Dokummat2 where god=%d and sklad=%s and \
nomd='%s' and nomerz=11",god,row[1],row[2]);

if(sql_readkey(&bd,strsql,&row,&cur) > 0)
   lnds1=atoi(row[0]);

/*Читаем условие продажи*/
memset(uslpr,'\0',sizeof(uslpr));

sprintf(strsql,"select sodz from Dokummat2 where god=%d and \
nomd='%s' and sklad=%d and nomerz=7",god,nin,skl);

if(sql_readkey(&bd,strsql,&row,&cur) == 1)
  strncpy(uslpr,row[0],sizeof(uslpr)-1);


/*Читаем форму оплаты*/
memset(forop,'\0',sizeof(forop));
sprintf(strsql,"select sodz from Dokummat2 where god=%d and \
nomd='%s' and sklad=%d and nomerz=8",god,nin,skl);

if(sql_readkey(&bd,strsql,&row,&cur) == 1)
  strncpy(forop,row[0],sizeof(forop)-1);
if(forop[0] != '\0')
 {
  sprintf(strsql,"select naik from Foroplat where kod='%s'",forop);
  memset(forop,'\0',sizeof(forop));

  if(sql_readkey(&bd,strsql,&row,&cur) == 1)
    strncpy(forop,row[0],sizeof(forop)-1);
 }
 
/*Читаем реквизиты организации свои */
sprintf(bros,"select naikon,adres,innn,nspnds,telef from Kontragent \
where kodkon='00'");
if(sql_readkey(&bd,bros,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найден код организации 00 !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

strncpy(nai,row[0],sizeof(nai)-1);
strncpy(adr,row[1],sizeof(adr)-1);
strncpy(inn,row[2],sizeof(inn)-1);
strncpy(nspdv,row[3],sizeof(nspdv)-1);
strncpy(telef,row[4],sizeof(telef)-1);

sprintf(bros,"select naikon,adres,innn,nspnds,telef from Kontragent \
where kodkon='%s'",kontr);
if(sql_readkey(&bd,bros,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s !",gettext("Не найден код контрагента !"),kontr);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

strncpy(nai1,row[0],sizeof(nai1)-1);
strncpy(adr1,row[1],sizeof(adr1)-1);
strncpy(inn1,row[2],sizeof(inn1)-1);
strncpy(nspdv1,row[3],sizeof(nspdv1)-1);
strncpy(telef1,row[4],sizeof(telef1)-1);

/*Читаем документ*/
sprintf(strsql,"select kodm,nomkar,kolih,ei from Dokummat1 where sklad=%d and nomd='%s' \
and datd='%d-%d-%d'",skl,nn,g,m,d);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  printw("%s\n",sql_error(&bd));
  OSTANOV();
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }       

if(iceb_t_alxout("dokrozr.alx") != 0)
 return;
if((ff1 = fopen("dokrozr.alx","r")) == NULL)
 {
 if(errno == ENOENT)
  {
   VVOD SOOB(1);
   sprintf(strsql,"%s %s !",gettext("Не найден файл:"),strsql);
   SOOB.VVOD_SPISOK_add_MD("dokrozr.alx");
   soobshw(&SOOB,stdscr,-1,-1,0,1);
   return;
  }
 else
   {
    error_op_nfil("dokrozr.alx",errno,"");
    return;
   }
 }
//imafl(nn,bros);
sprintf(imaf,"rz%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }
/*Начинаем формирование нового документа*/
fprintf(ff,"\x1B\x33%c",28); /*Уменьшаем межстрочный интервал*/

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
fprintf(ff,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
fprintf(ff,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
sprintf(bros,"%s / %s",nomr,nnn);
BSTAB(str,bros,121,145,1);
fprintf(ff,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
fprintf(ff,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
sprintf(bros,"%d.%d.%d",di,mi,gi);
BSTAB(str,bros,78,89,1);
BSTAB(str,nnn,94,106,1);
BSTAB(str,datdog,124,136,1);
BSTAB(str,nomdog,140,155,1);
fprintf(ff,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
fprintf(ff,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
fprintf(ff,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
BSTAB(str,nai,36,76,1);
BSTAB(str,nai1,155,194,1);
fprintf(ff,"%s",str);

for(i=0; i < 3 ; i++)
 {
  memset(str,'\0',sizeof(str));
  fgets(str,sizeof(str),ff1);
  fprintf(ff,"%s",str);
 }

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
BSTAB(str,inn,13,14,1);
BSTAB(str,&inn[1],17,18,1);
BSTAB(str,&inn[2],21,22,1);
BSTAB(str,&inn[3],25,26,1);
BSTAB(str,&inn[4],29,30,1);
BSTAB(str,&inn[5],33,34,1);
BSTAB(str,&inn[6],37,38,1);
BSTAB(str,&inn[7],41,42,1);
BSTAB(str,&inn[8],45,46,1);
BSTAB(str,&inn[9],49,50,1);
BSTAB(str,&inn[10],53,54,1);
BSTAB(str,&inn[11],57,58,1);

BSTAB(str,inn1,139,140,1);
BSTAB(str,&inn1[1],143,144,1);
BSTAB(str,&inn1[2],147,148,1);
BSTAB(str,&inn1[3],151,152,1);
BSTAB(str,&inn1[4],155,156,1);
BSTAB(str,&inn1[5],159,160,1);
BSTAB(str,&inn1[6],163,164,1);
BSTAB(str,&inn1[7],167,168,1);
BSTAB(str,&inn1[8],171,172,1);
BSTAB(str,&inn1[9],175,176,1);
BSTAB(str,&inn1[10],179,180,1);
BSTAB(str,&inn1[11],183,184,1);

fprintf(ff,"%s",str);

for(i=0; i < 2 ; i++)
 {
  memset(str,'\0',sizeof(str));
  fgets(str,sizeof(str),ff1);
  fprintf(ff,"%s",str);
 }

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
BSTAB(str,adr,25,65,1);
BSTAB(str,adr1,120,160,1);
fprintf(ff,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
BSTAB(str,telef,17,57,1);
BSTAB(str,telef1,150,190,1);
fprintf(ff,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
fprintf(ff,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
BSTAB(str,nspdv,45,65,1);
BSTAB(str,nspdv1,138,158,1);
fprintf(ff,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
fprintf(ff,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
BSTAB(str,uslpr,20,60,1);
fprintf(ff,"%s",str);

for(i=0; i < 2 ; i++)
 {
  memset(str,'\0',sizeof(str));
  fgets(str,sizeof(str),ff1);
  fprintf(ff,"%s",str);
 }

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
BSTAB(str,forop,30,70,1);
fprintf(ff,"%s",str);

memset(str,'\0',sizeof(str));
fgets(str,sizeof(str),ff1);
BSTAB(str,fam,40,70,1);
fprintf(ff,"%s",str);

fprintf(ff,"\x1B\x33%c",20); /*Уменьшаем межстрочный интервал*/
for(i=0; i < 19 ; i++)
 {
  memset(str,'\0',sizeof(str));
  fgets(str,sizeof(str),ff1);
  fprintf(ff,"%s",str);
 }
fprintf(ff,"\x1B\x33%c",28); /*Уменьшаем межстрочный интервал*/

clear();
printw("Номер накладной %s Номер налоговой накладной %s\n",
nin,nnn);

fprintf(ff,"\x1B\x2D\x31"); /*Включить подчеркивание*/
SQLCURSOR cur1;
it1=it2=0.;
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  kolstr1++;
  strzag(LINES-1,0,kolstr,kolstr1);  
  kodm=atoi(row[0]);
  nk=atoi(row[1]);
  kolih=atof(row[2]);
  memset(ei,'\0',sizeof(ei));
  strncpy(ei,row[3],sizeof(ei)-1);
      
  /*Узнаем наименование материалла*/
  memset(naimat,'\0',sizeof(naimat));
  sprintf(strsql,"select naimat from Material where kodm=%s",
  row[0]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
    {
     beep();
     printw(gettext("Не найдено наименование материалла !"));
     printw("\n");
     OSTANOV();
    }
  else
    strncpy(naimat,row1[0],sizeof(naimat)-1);


  printw("%4d %4d %-*.*s %.8g\n",
  kodm,nk,
  iceb_tu_kolbait(30,naimat),iceb_tu_kolbait(30,naimat),naimat,kolih);
  refresh();  

  /*Проверяем есть ли материал в исходной накладной и если есть то 
  сколько по количеству*/
  sprintf(strsql,"select kolih,cena from Dokummat1 where \
sklad=%d and nomd='%s' and datd='%d-%d-%d' and kodm=%d and nomkar=%d",
skl,nin,gi,mi,di,kodm,nk);
  if(readkey(strsql,&row1,&cur1) != 1)
   {
    beep();
    printw("Нет такого материалла в исходной накладной !\n");
    OSTANOV();
    continue;
   }

  kolih1=atof(row1[0]);
  cenaz=atof(row1[1]);

  if(kolih1-kolih < 0.)
   {
    beep();
    printw("В исходной накладной количество меньше чем в приходной (%.8g) !\n",kolih1);
    OSTANOV();
    continue;
   } 

  bb1=kolih*cenaz*(-1);
  bb1=okrug(bb1,0.01);
  it1+=bb1;
  
  bb=kolih*cenaz*pnds/100.*(-1);
  bb=okrug(bb,0.01);
  it2+=bb;     
  if(lnds1 == 0)
   fprintf(ff,"|%02d.%02d.%d|%-*.*s|%-*.*s|%-*s|%10.2f|%10.2f|%10s|\
%10s|%10.2f|%10s|%10s|%11.2f|%11.2f|%11s|%11s|\n",
   d,m,g,
   iceb_tu_kolbait(20,prish),iceb_tu_kolbait(20,prish),prish,
   iceb_tu_kolbait(30,naimat),iceb_tu_kolbait(30,naimat),naimat,
   iceb_tu_kolbait(5,ei),ei,
   kolih*(-1),cenaz," "," ",
   bb1," "," ",bb,bb," "," ");

  if(lnds1 == 3)
   fprintf(ff,"|%02d.%02d.%d|%-*.*s|%-*.*s|%-*s|%10.2f|%10.2f|%10s|\
%10s|%10s|%10s|%10.2f|%11s|%11s|%11s|%11s|\n",
   d,m,g,
   iceb_tu_kolbait(20,prish),iceb_tu_kolbait(20,prish),prish,
   iceb_tu_kolbait(30,naimat),iceb_tu_kolbait(30,naimat),naimat,
   iceb_tu_kolbait(5,ei),ei,
   kolih*(-1),cenaz," "," ",
   " "," ",bb1," "," "," "," ");


/*
|    1     |          2         |               3              |  4  |    5     |    6     |    7     |    8     |     9    |    10    |    11    |    12     |     13    |     14    |    15     |
*/     
   
 }
if(lnds1 == 0)
  fprintf(ff,"%*s: %10.2f %21s %11.2f %11.2f\n",
  iceb_tu_kolbait(112,gettext("Итого")),gettext("Итого"),it1," ",it2,it2);

if(lnds1 == 3)
  fprintf(ff,"%*s: %10.2f %11s %11s\n",
  iceb_tu_kolbait(134,gettext("Итого")),gettext("Итого"),it1," "," ");

fprintf(ff,"\x1B\x2D\x30"); /*Выключить подчеркивание*/

shet=1;
memset(str,'\0',sizeof(str));
while(fgets(str,sizeof(str),ff1) != NULL)
 { 
  if(shet == 3)
    BSTAB(str,fam,160,190,1);
  if(shet == 8)
   {
    sprintf(bros,"%d.%d.%d",d,m,g);
    BSTAB(str,bros,30,42,1);
    BSTAB(str,nomr,48,60,1);
    sprintf(bros,"%d.%d.%d",di,mi,gi);
    BSTAB(str,bros,89,102,1);
    BSTAB(str,nnn,106,118,1);
   }
  fprintf(ff,"%s",str);
  shet++;
  memset(str,'\0',sizeof(str));
 }  
  
fclose(ff);
fclose(ff1);
unlink("dokrozr.alx");

printw("\nРаспечатка выгружена в файл %s\n",imaf);

OSTANOV();
//rabfil("Расчет корректировки налоговой накладной.",imaf);
class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus("Расчет корректировки налоговой накладной");
iceb_t_ustpeh(imaf,1);
iceb_t_rabfil(&oth,"");


}
