/* $Id: rozn.c,v 5.53 2011-01-13 13:43:23 sasa1 Exp $ */
/*22.12.2008	01.02.1998	Белых А.И.	rozn.c
Программа розничной торговли
*/
#define         DVERSIQ "22.12.2008"
#include        <pwd.h>
#include        <sys/types.h>
#include        <sys/stat.h>
#include        <time.h>
#include        <ctype.h>
#include        <locale.h>
#ifdef HAVE_TORGDEV
#include	<libdev.h>
#endif
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


pid_t		mypid;
extern char	*organ;
int		kassa=0;
short           mdd;  /*0-обычный документ 1-двойной для расход*/
extern char	*imabaz;
SQL_baza	bd;
char		mylogin[L_cuserid];
int		ktorab=0;
extern char	*nameprinter;
char		fio[512];

int             main(int argc,char **argv,char **envp)
{
struct  passwd  *ktor; /*Кто работает*/
int		regim;
SQL_str   	row,row1;
short		i;
int		kom;
char		bros[512];
char		kto[16];
char		*host=NULL;
char		*parol=NULL;
int		skl=0;
char		strsql[512];
char		naiot[512];
char		grup[512];
KASSA		kasr;
int uid=0;
class iceb_tu_str fioop;
SQLCURSOR curr; 
short dt,mt,gt;

ktor=getpwuid(getuid());
ktorab=ktor->pw_uid;

mypid=getpid();
(void)setlocale(LC_ALL,"");
(void)setlocale(LC_NUMERIC,"C"); //Переменная среды определяющая чем 
                                 //разделяется целая и дробная часть числа


init_screen();  /*Запуск экранного режима*/
VVOD MENU(4);
VVOD VVOD1(2);
umask(ICEB_UMASK); /*Установка маски для записи и чтения группы*/

strcpy(kto,ktor->pw_name);

/*Читаем ключи запуска программы*/
readkey_par(argc,argv,&parol,&imabaz,&host,&regim);

/*
printw("kto=%s parol=%s imabaz=%s regim=%d\n",
kto,parol,imabaz,regim);
OSTANOV();
*/

/* прочитать инициализационный файл (параметры устройств) */
//read_ini();


if(sql_openbaz(&bd,imabaz,host,kto,parol) != 0)
  eropbaz(imabaz,ktor->pw_uid,ktor->pw_name,0);
icebstart_rf();

clear();
kasr.handle = -1;
/* прочитаем параметры кассового регистратора из файла настройки	*/
#ifdef HAVE_TORGDEV
if (nastrmariq(1, &kasr) == 0) 
 {
/*************   
   printw("handle = %d; sklad = %d; nomer = %d; \n\
   host = %s; password = %s; port = %s; prod = %s;\n",
   kasr.handle, kasr.sklad, kasr.nomer, kasr.host, kasr.parol, kasr.port, kasr.prodavec);
   OSTANOV();
***************/   
   /* если успешно - пытаемся связаться с кассовым сервером		*/
   if ((kasr.handle=iceb_open_server(kasr.host, kasr.port)) < 0)
      errorkan(kasr.handle); // ошибка открытия связи
   else 
    {		     // успешно
     skl = kasr.sklad;
     kassa = kasr.nomer;
    }
 }
#endif

if(skl == 0)
 {
  class iceb_tu_str kod_v("");
  class iceb_tu_str naim_v("");
  if(dirsklad(2,&kod_v,&naim_v) != 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не выбран отдел !"));  
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto kon;
   }
  skl=kod_v.ravno_atoi();
 }
sprintf(strsql,"select naik from Sklad where kod=%d",skl);
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найден код отдела !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto kon;
 }
strcpy(naiot,row[0]);

if(kassa == 0)
 {
  helstr(LINES-1,0,"F10",gettext("выход"),NULL);
  bros[0]='\0';

  VVOD1.VVOD_delete();
  VVOD1.VVOD_SPISOK_add_MD(gettext("Введите номер рабочего места."));
  class iceb_tu_str vstr("");
  if((kom=vvod1(&vstr,3,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
   {
    goto kon;
   }
  if(kom == ESC)
   {
    goto kon;
   }
  if((kassa=vstr.ravno_atoi()) == 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не определен номер рабочего места !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto kon;
   }
 }
 
helstr(LINES-1,0,"F10",gettext("выход"),NULL);

bros[0]='\0';
memset(fio,'\0',sizeof(fio));
ktor=getpwuid(ktorab);
strncpy(fio,ktor->pw_gecos,sizeof(fio)-1);

/************************
VVOD1.VVOD_delete();
VVOD1.VVOD_SPISOK_add_MD(gettext("Введите Фамилию, Имя, Отчетство."));
if((kom=vvod1(fio,sizeof(fio),&VVOD1,NULL,stdscr,-1,-1)) == FK10)
 {
  goto kon;
 }
if(kom == ESC)
 {
  goto kon;
 }

************************/

/*Читаем наименование организации*/
sprintf(bros,"select naikon from Kontragent where kodkon='00'");
if(sql_readkey(&bd,bros,&row1,&curr) != 1)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найден код организации 00 !"));  
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }
else
 {
  i=strlen(row1[0])+1;
  if((organ=(char *)malloc(i*sizeof(char))) == NULL)
       error2(20,0,1,"Не могу выделить пямять для organ !");
  strcpy(organ,row1[0]);
 }

/*Читаем нормативно-справочную информацию*/
nastsys();
matnast();

/*Читаем какие группы настроены для склада*/
sprintf(bros,"Группы для склада %d",skl);
memset(grup,'\0',sizeof(grup));

iceb_t_poldan(bros,grup,"matnast.alx");


kom=0;

MENU.VVOD_SPISOK_add_ZAG(gettext("Программа розничной торговли."));
MENU.VVOD_SPISOK_add_ZAG(organ,40);
sprintf(strsql,"%d %s",skl,naiot);
MENU.VVOD_SPISOK_add_ZAG(strsql);
sprintf(strsql,"%s %d",gettext("Номер рабочего места:"),kassa);
MENU.VVOD_SPISOK_add_ZAG(strsql);

MENU.VVOD_SPISOK_add_MD(gettext("Розничная продажа."));
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать все продажи."));
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод всех продаж."));
MENU.VVOD_SPISOK_add_MD(gettext("Конец работы."));


uid=iceb_t_getuid();
fioop.plus(iceb_t_getfioop());
 
for(;;)
 {

  clear();

  znak(0,COLS-26);
  infosys(12,COLS-27,host,VERSION,DVERSIQ,0,0,0,imabaz,nameprinter,uid,fioop.ravno());

  move(LINES-1,0);
  printw("%s %s %s %s%s",gettext("Версия"),VERSION,
  gettext("от"),DVERSIQ,
  gettext("г."));

  if(menu3(&MENU,&kom,1,0,0) != 0)
   continue;

  switch (kom)
   {
    case 3 :
    case -1 :
	   goto kon;

    case 0 :

     poltekdat(&dt,&mt,&gt);
     rozprod(dt,mt,gt,kassa,0,skl,grup,regim,kasr);
     break;

    case 1 :

     poltekdat(&dt,&mt,&gt);
     rozvse(dt,mt,gt,kassa,fio);
     break;
    case 2 :

     poltekdat(&dt,&mt,&gt);
     rozsvod(dt,mt,gt,kassa,fio);
     break;
    default:
     kom=0;
     break;
   }
 }

kon:;


sql_closebaz(&bd);
#ifdef HAVE_TORGDEV
if (kasr.handle >= 0) iceb_close_server(kasr.handle);
#endif

VVOD SOOBN(1);
SOOBN.VVOD_SPISOK_add_MD(gettext("База закрыта. Программа закончила работу."));
soobsh(&SOOBN,-1,-1,1);

refresh();
endwin();
return(0);
}
