/* $Id: rppvo1.c,v 5.47 2011-01-13 13:43:23 sasa1 Exp $ */
/*14.03.2010    19.10.1994      Белых А.И.      rppvo1.c
Материальный учет реестр проводок по видам операций
Сортировка проводок и выдача распечатки
Возвращаем 0 - если нет проводок
	   1 - если есть
*/
#include        <time.h>
#include        <math.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void            gsapr(short,short,short,short,short,short,int *,int *,int,char[],FILE*);
void            rasid(double,short,short,short,short,short,short,int,char[],int*,int*,FILE*);
void            rasio(char[],double,short,short,short,short,short,short,int,char[],char[],SPISOK*,masiv_din_double*,int*,int*,FILE*);
void            rasis(char[],double,short,short,short,short,short,short,int,char[],char[],SPISOK*,masiv_din_double*,SPISOK*,masiv_din_double*,int*,int*,FILE*);
void            rasoi(SPISOK *mssi,masiv_din_double *mspsi,short dn,short mn,short gn,short dk,short mk,short gk,int *sli,int *kst,int skl1,char *naiskl,FILE *ff);
void  rppvo1_sapit(short dn,short mn,short gn,short dk,short mk,short gk,int *sli,int *kst,int skl1,char *naiskl,FILE *ff);
void rppvo1_s(int skl1,char *naiskl,short dn,short mn,short gn,short dk,short mk,short gk,int *sl,int *kst,FILE *ff);


extern int      ddd,mmm,ggg;
extern char     *organ;/*Наименование организации*/
extern int kol_strok_na_liste;

int rppvo1(VVOD *VV,class spis_oth *oth)
{
int           kst,sli;
SPISOK           mso; /*Массив счетов по организации*/
masiv_din_double mspo; /*Массив сумм проводок по организации*/
SPISOK           mss; /*Массив счетов по складу*/
masiv_din_double msps; /*Массив сумм проводок по складу*/
SPISOK           mssi; /*Массив счетов по всем складам*/
masiv_din_double mspsi; /*Массив сумм проводок по всем складам по операции*/
SPISOK           mssio; /*Массив счетов по всем складам и всем операциям*/
masiv_din_double mspsio; /*Массив сумм проводок по всем складам по всем операциям*/
FILE            *ff;
char		bros[512];
char		str[512];
FILE            *ff1;
struct  tm      *bf;
time_t          tmm;
time_t          tmmn;
short           kom;
char		kome[512]; /*Коментарий*/
short           dp,mp,gp;
short           dd,md,gd;
char            orgn[32];
char            imaf[56],imaftmp[56];
char            sh1[32];
char            shett[112];
char            shett1[112];
double          itd; /*Итого по счету*/
int             i;
double          k1;
short           tipzz;
int		tz; /*1-Приход 2-расход*/
short           klr;
short           dn,mn,gn;
short           dk,mk,gk;
double		deb;
long		kolstr,kolstr1,kolstr2;
SQL_str         row,row1;
char		strsql[512];
char		kop[32];
int		skl=0,skl1=0;
char		naik[512];
char		naimpr[512];
char		naiskl[512];
char		nomdok[112],nomdokv[112];
short		tp;
char		kprr[32],kprr1[32];
char		kpos[32];
char		datd[16];
char		nn1[32];
char		kor[32];		
char 		nomnalnak[32];
char imafitog[56];
FILE *ffitog;

time(&tmm);
bf=localtime(&tmm);

if(rsdatp(&dn,&mn,&gn,VV->VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV->VVOD_SPISOK_return_data(1)) != 0)
  return(1);

time(&tmmn);
printw("%s %d.%d.%d => %d.%d.%d\n",gettext("Даты поиска:"),dn,mn,gn,dk,mk,gk);
GDITE();


tz=0;
if(VV->VVOD_SPISOK_return_data(4)[0] == '+')
  tz=1;
if(VV->VVOD_SPISOK_return_data(4)[0] == '-')
  tz=2;

  
sprintf(strsql,"select * from Prov where val=0 and \
datp >= '%04d-%02d-%02d' and \
datp <= '%04d-%02d-%02d' and kto='%s' and deb != 0.",
gn,mn,dn,gk,mk,dk,gettext("МУ"));
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }    

sprintf(imaftmp,"vidop%d.tmp",getpid());
if((ff1 = fopen(imaftmp,"w")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }

printw(gettext("Сортируем проводки.\n"));

kolstr2=kolstr1=0;
SQLCURSOR cur1;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);  

  /*Смотрим только дебеты*/
//  if( fabs(atof(row[10])) > 0.009)
//   continue;

  /*Склад*/
  if(proverka(VV->VVOD_SPISOK_return_data(2),row[7],0,0) != 0)
    continue;
   
  /*Читаем документ*/
  sprintf(strsql,"select * from Dokummat where datd='%s' and \
sklad=%s and nomd='%s'",row[14],row[7],row[6]);
/*  printw("strsql=%s\n",strsql);*/
  if(readkey(strsql,&row1,&cur1) != 1)
   {
    beep();  
    printw(gettext("Не найден документ N %s Склад %s Дата=%s\n"),
    row[6],row[7],row[14]);
    printw("%s %s %s %s\n",gettext("Проводка"),
    row[1],row[2],row[3]);
    OSTANOV();
    continue;
   }

  char nomnalnak[20];
  memset(nomnalnak,'\0',sizeof(nomnalnak));
  strncpy(nomnalnak,row1[5],sizeof(nomnalnak)-1);    
  
  tp=atoi(row1[0]);
  strncpy(kor,row1[3],sizeof(kor)-1);    
  strncpy(kop,row1[6],sizeof(kop)-1);    
  strncpy(nn1,row1[11],sizeof(nn1)-1);    
  strncpy(datd,row1[1],sizeof(datd)-1);    
  
  if(tz != 0 && tz != tp)
   continue;

  /*Организация*/
  if(proverka(VV->VVOD_SPISOK_return_data(3),kor,0,0) != 0)
    continue;
   
  /*Операция*/
  if(proverka(VV->VVOD_SPISOK_return_data(5),kop,0,0) != 0)
    continue;

  /*Счет*/
  if(proverka(VV->VVOD_SPISOK_return_data(6),row[2],0,0) != 0)
    if(proverka(VV->VVOD_SPISOK_return_data(6),row[3],0,0) != 0)
      continue;
  /*Группа контрагента*/
  if(VV->data_ravno(8)[0] != '\0')
   {
    if(SRAV(kor,"00-",1) == 0)
      sprintf(strsql,"select grup from Kontragent where kodkon='00'");
    else
      sprintf(strsql,"select grup from Kontragent where kodkon='%s'",kor);
    if(readkey(strsql,&row1,&cur1) == 1)
     {
      if(proverka(VV->data_ravno(8),row1[0],0,0) != 0)
       continue;
     }
   }
  kolstr2++;
//             1   2  3 4   5    6    7   8  9  10 11
  fprintf(ff1,"%d|%s|%s|%s|%s %s|%s|%s,%s|%s|%s|%s|%s|\n",
  tp,kop,row[7],kor,row[6],nn1,row[1],
  row[2],row[3],datd,row[9],row[13],nomnalnak);

 }

fclose(ff1);

//sprintf(strsql,"sort -o %s -t\\| +0n -1 +1 -2 +2n -3 +3 -4 +4 -5 %s",imaftmp,imaftmp);
sprintf(strsql,"sort -o %s -t\\| -k1,2n -k2,3 -k3,4n -k4,5 -k5 %s",imaftmp,imaftmp);
//runsystem(strsql);
iceb_t_system(strsql,0);

sprintf(imafitog,"itog%d.lst",getpid());
if((ffitog = fopen(imafitog,"w")) == NULL)
 {
  error_op_nfil(imafitog,errno,"");
  return(1);
 }

zagolov(gettext("Реестр проводок по видам операций."),bf,dn,mn,gn,dk,mk,gk,organ,ffitog);

if((ff1 = fopen(imaftmp,"r")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }

sprintf(imaf,"rp%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

kst=0;


if(VV->VVOD_SPISOK_return_data(2)[0] != '\0')
 {
  kst++;
  fprintf(ff,gettext("Склад: %s\n"),VV->VVOD_SPISOK_return_data(2));
  fprintf(ffitog,gettext("Склад: %s\n"),VV->VVOD_SPISOK_return_data(2));
 }

if(VV->VVOD_SPISOK_return_data(3)[0] != '\0')
 {
  kst++;
  fprintf(ff,"%s: %s\n",gettext("Контрагент"),VV->VVOD_SPISOK_return_data(3));
  fprintf(ffitog,"%s: %s\n",gettext("Контрагент"),VV->VVOD_SPISOK_return_data(3));
 }
if(VV->VVOD_SPISOK_return_data(4)[0] != '\0')
 {
  kst++;
  fprintf(ff,"%s: %s\n",gettext("Вид операции"),VV->VVOD_SPISOK_return_data(4));
  fprintf(ffitog,"%s: %s\n",gettext("Вид операции"),VV->VVOD_SPISOK_return_data(4));
 }
if(VV->VVOD_SPISOK_return_data(5)[0] != '\0')
 {
  kst++;
  fprintf(ff,"%s: %s\n",gettext("Код операции"),VV->VVOD_SPISOK_return_data(5));
  fprintf(ffitog,"%s: %s\n",gettext("Код операции"),VV->VVOD_SPISOK_return_data(5));
 }
if(VV->VVOD_SPISOK_return_data(6)[0] != '\0')
 {
  kst++;
  fprintf(ff,"%s: %s\n",gettext("Счет"),VV->VVOD_SPISOK_return_data(6));
  fprintf(ffitog,"%s: %s\n",gettext("Счет"),VV->VVOD_SPISOK_return_data(6));
 }
if(VV->data_ravno(8)[0] != '\0')
 {
  kst++;
  fprintf(ff,"%s: %s\n",gettext("Код группы контрагента"),VV->data_ravno(8));
  fprintf(ffitog,"%s: %s\n",gettext("Код группы контрагента"),VV->data_ravno(8));
 }

skl=0;
memset(kpos,'\0',sizeof(kpos));
memset(sh1,'\0',sizeof(sh1));
memset(nomdok,'\0',sizeof(nomdok));
memset(nomdokv,'\0',sizeof(nomdokv));
memset(kprr1,'\0',sizeof(kprr1));
memset(naik,'\0',sizeof(naik));
memset(naimpr,'\0',sizeof(naimpr));
memset(naiskl,'\0',sizeof(naiskl));

tipzz=kom=0;
kolstr1=klr=sli=0;
itd=0.;
kome[0]='\0';

while(FGETSS(str,sizeof(str),ff1) != 0)
 {
  strzag(LINES-1,0,kolstr2,++kolstr1);
/*  printw("kprr-%s kprr1-%s tipzz=%d tz=%d\n",kprr,kprr1,tipzz,tz);*/
  POLE(str,bros,1,'|');
  tz=(int)ATOFM(bros);

  POLE(str,kprr,2,'|');

  POLE(str,bros,3,'|');
  skl1=(int)ATOFM(bros);

  POLE(str,orgn,4,'|');

  POLE(str,nomdok,5,'|');

  POLE(str,bros,6,'|');
  rsdat(&dp,&mp,&gp,bros,2);

  POLE(str,shett,7,'|');

  POLE(str,bros,8,'|');
  rsdat(&dd,&md,&gd,bros,2);

  POLE(str,bros,9,'|');
  deb=ATOFM(bros);

  polen(str,kome,sizeof(kome),10,'|');
  polen(str,nomnalnak,sizeof(nomnalnak),11,'|');
   
  if(SRAV(kprr,kprr1,0) != 0 || tipzz != tz)
   {
    if(kprr1[0] != '\0' )
     {
      rasis(orgn,itd,dn,mn,gn,dk,mk,gk,skl,naiskl,naik,&mso,&mspo,&mss,&msps,&sli,&kst,ff);
      itd=0.;
      rasoi(&mssi,&mspsi,dn,mn,gn,dk,mk,gk,&sli,&kst,skl1,naiskl,ff);

      fprintf(ff,"\f");
      kst=0;
     }
    skl=0;
    memset(nomdokv,'\0',sizeof(nomdokv));
    memset(kpos,'\0',sizeof(kpos));

    /*Определяем наименоввание операции*/
    if(tz == 1)
     sprintf(strsql,"select naik from Prihod where kod='%s'",
     kprr);
    if(tz == 2)
     sprintf(strsql,"select naik from Rashod where kod='%s'",
     kprr);
    
    naimpr[0]='\0';
    
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
       beep();
       printw("Не нашли операцию %s\n",kprr);
       OSTANOV();
     }
    else
      strncpy(naimpr,row1[0],sizeof(naimpr)-1);
    
    strcpy(kprr1,kprr);
    tipzz=tz;
    /*move(5,0); */
    printw("%d/%s %s\n",tz,kprr,naimpr);
    if(tz == 1)
     strcpy(bros,gettext("(приход)"));
    if(tz == 2)
     strcpy(bros,gettext("(расход)"));

    /*Определяем наименование склада*/
     sprintf(strsql,"select naik from Sklad where kod=%d",
     skl1);
    
    naiskl[0]='\0';
    
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
       beep();
       printw("Не нашли склад %d\n",skl1);
       OSTANOV();
     }
    else
      strncpy(naiskl,row1[0],sizeof(naiskl)-1);

    fprintf(ff,"%s\n\
%s %s - \"%s\" %s %s %d.%d.%d%s %s %d.%d.%d%s\n\
%s %d.%d.%d%s  %s: %d:%d\n",
organ,gettext("Реестр по виду операции"),
kprr,naimpr,bros,
gettext("за период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

    kst+=3;
    klr+=sli;
    sli=0;
    rppvo1_s(skl1,naiskl,dn,mn,gn,dk,mk,gk,&sli,&kst,ff);

   }

  if(skl != skl1)
   {
    if(skl != 0)
     {
      rasis(orgn,itd,dn,mn,gn,dk,mk,gk,skl,naiskl,naik,&mso,&mspo,&mss,&msps,&sli,&kst,ff);
      itd=0.;
      kst=0;
//      klr+=sli;
//      sli=0;
      fprintf(ff,"\f");
     }
    memset(nomdokv,'\0',sizeof(nomdokv));
    memset(kpos,'\0',sizeof(kpos));
    kom=1;

    /*Определяем наименование склада*/
    sprintf(strsql,"select naik from Sklad where kod=%d",skl1);
    
    naiskl[0]='\0';
    
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
       beep();
       printw(gettext("Не нашли склад %d в списке складов !"),skl1);
       printw("\n");
       OSTANOV();
     }
    else
      strncpy(naiskl,row1[0],sizeof(naiskl)-1);

    printw("%s: %d %s\n",gettext("Склад"),skl1,naiskl);

    if(skl != 0)
      rppvo1_s(skl1,naiskl,dn,mn,gn,dk,mk,gk,&sli,&kst,ff);

    skl=skl1;
   }

  if(SRAV(kpos,orgn,0) != 0)
   {
    if(kpos[0] != '\0')
     {
      rasio(orgn,itd,dn,mn,gn,dk,mk,gk,skl1,naiskl,naik,&mso,&mspo,&sli,&kst,ff);
      itd=0.;
     }
    memset(nomdokv,'\0',sizeof(nomdokv));
    kom=1;
    /*Читаем наименование организации*/
    memset(kor,'\0',sizeof(kor));
    if(ATOFM(orgn) == 0. && POLE(orgn,bros,2,'-') == 0 && orgn[0] == '0')
     { 
      strcpy(kor,bros);
      sprintf(bros,"select naik from Sklad where kod=%s",
      kor);
     }
    else
     {
      strcpy(kor,orgn);
      sprintf(bros,"select naikon from Kontragent where kodkon='%s'",
      kor);
     }

    memset(naik,'\0',sizeof(naik));
    
    if(sql_readkey(&bd,bros,&row1,&cur1) != 1)
     {
      beep();
      printw("%s %s\n",
      gettext("Не нашли код контрагента"),kor);
      OSTANOV(); 
     }
    else
      strncpy(naik,row1[0],sizeof(naik)-1);

    printw(gettext("Контрагент %s\n"),orgn);
    strcpy(kpos,orgn);
   }

  if(SRAV(nomdok,nomdokv,0) != 0)
   {
    if(nomdokv[0] != '\0')
     {
      rasid(itd,dn,mn,gn,dk,mk,gk,skl1,naiskl,&sli,&kst,ff);
      itd=0.;
     }
    strcpy(nomdokv,nomdok);
   }


  /*Записываем в массив организаций*/
  if((i=mso.find(shett)) < 0)
     mso.plus(shett);
  mspo.plus(deb,i);

   /*Записываем в массив по складу*/
  if((i=mss.find(shett)) < 0)
     mss.plus(shett);
  msps.plus(deb,i);

   /*Записываем в массив по складам */
  if((i=mssi.find(shett)) < 0)
     mssi.plus(shett);
  mspsi.plus(deb,i);
   
   /*Записываем в массив по складам и операциям*/
  if((i=mssio.find(shett)) < 0)
     mssio.plus(shett);
  mspsio.plus(deb,i);
   

  printw("%02d.%02d.%4d %02d.%02d.%4d %-*s %-*s %-*s %15.2f\n",
  dp,mp,gp,dd,md,gd,
  iceb_tu_kolbait(11,nomdok),nomdok,
  iceb_tu_kolbait(6,nomnalnak),nomnalnak,
  iceb_tu_kolbait(10,shett),shett,
  deb);
  memset(bros,'\0',sizeof(bros));

  gsapr(dn,mn,gn,dk,mk,gk,&sli,&kst,skl1,naiskl,ff);
  if(kom == 1)
     fprintf(ff,"\
%-7s %-40.40s %02d.%02d.%4d %02d.%02d.%4d %-*s %-*s %-*s %20s %.13s\n",
     orgn,naik,dd,md,gd,dp,mp,gp,
      iceb_tu_kolbait(11,nomdok),nomdok,
      iceb_tu_kolbait(6,nomnalnak),nomnalnak,
      iceb_tu_kolbait(10,shett),shett,
     prnbr(deb),kome);

  if(kom == 0)
     fprintf(ff,"\
%48s %02d.%02d.%4d %02d.%02d.%4d %-*s %-*s %-*s %20s %.13s\n",
    " ",dd,md,gd,dp,mp,gp,
      iceb_tu_kolbait(11,nomdok),nomdok,
      iceb_tu_kolbait(6,nomnalnak),nomnalnak,
      iceb_tu_kolbait(10,shett),shett,
    prnbr(deb),kome);

  itd+=deb;
  kom=0;

 }
fclose(ff1);
unlink(imaftmp);

rasis(orgn,itd,dn,mn,gn,dk,mk,gk,skl,naiskl,naik,&mso,&mspo,&mss,&msps,&sli,&kst,ff);
rasoi(&mssi,&mspsi,dn,mn,gn,dk,mk,gk,&sli,&kst,skl1,naiskl,ff);


char shdeb[32];
char shkre[32];

if(VV->VVOD_SPISOK_return_data(5)[0] == '\0' || ( VV->VVOD_SPISOK_return_data(5)[0] != '\0' && POLE(VV->VVOD_SPISOK_return_data(5),shett1,2,',') == 0))
 {
  k1=0.;
  fprintf(ff,"\n==================================================\n\
%s\n",gettext("Общий итог по всем операциям:"));
  rppvo1_sapit(dn,mn,gn,dk,mk,gk,&sli,&kst,skl1,naiskl,ff);
  for(i=0; i< mssio.kolih() ;i++)
   {
    strncpy(shett1,mssio.ravno(i),sizeof(shett1)-1);
    POLE(shett1,shdeb,1,',');
    POLE(shett1,shkre,2,',');

    fprintf(ff,"%-*s %-*s %15s\n",
    iceb_tu_kolbait(6,shdeb),shdeb,
    iceb_tu_kolbait(6,shkre),shkre,
    prnbr(mspsio.ravno(i)));

    k1+=mspsio.ravno(i);
   }
  fprintf(ff,"%*s:%15s\n",iceb_tu_kolbait(13,gettext("Итого")),gettext("Итого"),prnbr(k1));
 }


printw("\n%s\n",gettext("Общий итог по всем операциям:"));

fprintf(ffitog,"\n%s\n",gettext("Общий итог по всем операциям:"));

k1=0.;
fprintf(ffitog,"\
------------------------------\n");
fprintf(ffitog,gettext("Дебет |Кредит|    Сумма      |\n"));
fprintf(ffitog,"\
------------------------------\n");

for(i=0; i< mssio.kolih() ;i++)
 {
  strncpy(shett1,mssio.ravno(i),sizeof(shett1)-1);
  printw("%-15s - %15s\n",shett1,prnbr(mspsio.ravno(i)));
  POLE(shett1,shdeb,1,',');
  POLE(shett1,shkre,2,',');
  fprintf(ffitog,"%-*s %-*s %15s\n",
    iceb_tu_kolbait(6,shdeb),shdeb,
    iceb_tu_kolbait(6,shkre),shkre,
  prnbr(mspsio.ravno(i)));
  k1+=mspsio.ravno(i);
 }
fprintf(ffitog,"%*s:%15s\n",iceb_tu_kolbait(13,gettext("Итого")),gettext("Итого"),prnbr(k1));

podpis(ffitog);
podpis(ff);

fclose(ffitog);
fclose(ff);

printw_vr(tmmn);

OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Реестр проводок по видам операций."));
oth->spis_imaf.plus(imafitog);
oth->spis_naim.plus(gettext("Общие итоги"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),1);
 
return(0);
}
/*******/
/*Шапка*/
/*******/
void gsapr(short dn,short mn,short gn,short dk,short mk,
short gk,int *sl,int *kst,int skl1,char naiskl[],FILE *ff)
{
*kst+=1;

if(*kst <=  kol_strok_na_liste)
 return;

fprintf(ff,"\f");
*kst=1;
rppvo1_s(skl1,naiskl,dn,mn,gn,dk,mk,gk,sl,kst,ff);
  

}

/*******************************/
/*Распечатка итога по документа*/
/*******************************/
void            rasid(double itd,short dn,short mn,short gn,short dk,
short mk,short gk,int skl1,char naiskl[],int *sli,int *kst,FILE *ff)
{
gsapr(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);

fprintf(ff,"%*s %20s\n",iceb_tu_kolbait(100,gettext("Итого по документу:")),gettext("Итого по документу:"),prnbr(itd));

}

/*******************************/
/*Распечатка итога по контрагенту*/
/*******************************/
void            rasio(char orgn[],double itd,short dn,short mn,short gn,
short dk,short mk,short gk,int skl1,char naiskl[],char naik[],
SPISOK *mso,
masiv_din_double *mspo,
int *sli, 
int *kst,
FILE *ff)
{
short           i;
char            shett1[112];
double          bb;
char		shdeb[56];
char		shkre[56];


rasid(itd,dn,mn,gn,dk,mk,gk,skl1,naiskl,sli,kst,ff);

/*Распечатываем результаты по организации*/
bb=0.;
if(mso->kolih() > 0)
 {
  gsapr(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
  fprintf(ff,"%s \"%s\":\n",gettext("Итого по контрагенту"),naik);
 }
/*printw("kso- %d\n",kso);*/

rppvo1_sapit(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);

for(i=0; i< mso->kolih() ;i++)
 {
  strncpy(shett1,mso->ravno(i),sizeof(shett1)-1);
  POLE(shett1,shdeb,1,',');
  POLE(shett1,shkre,2,',');

  gsapr(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
  fprintf(ff,"%-*s %-*s %15s\n",
  iceb_tu_kolbait(6,shdeb),shdeb,
  iceb_tu_kolbait(6,shkre),shkre,
  prnbr(mspo->ravno(i)));

  bb+=mspo->ravno(i);
 }
if(mso->kolih() > 0)
 {
  gsapr(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
  fprintf(ff,"%*s:%15s\n",iceb_tu_kolbait(13,gettext("Итого")),gettext("Итого"),prnbr(bb));

  gsapr(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
  fprintf(ff,"\
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .\n");
 }

mso->free_class();
mspo->free_class();
}
/*******************************/
/*Распечатка итога по складу*/
/*******************************/
void            rasis(char orgn[],double itd,short dn,short mn,short gn,
short dk,short mk,short gk,int skl1,char naiskl[],char naik[],
SPISOK *mso,
masiv_din_double *mspo,
SPISOK *mss,
masiv_din_double *msps,
int *sli,
int *kst,
FILE *ff)
{
short           i;
char            shett1[112];
double          bb;
char		shdeb[56];
char		shkre[56];

rasio(orgn,itd,dn,mn,gn,dk,mk,gk,skl1,naiskl,naik,mso,mspo,sli,kst,ff);

/*Распечатываем результаты по складу*/
gsapr(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
fprintf(ff,"%s \"%s\":\n",gettext("Итого по складу"),naiskl);

rppvo1_sapit(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);

bb=0.;
for(i=0; i< mss->kolih() ;i++)
 {
//  POLE(mss,shett1,i+1,' ');
  strncpy(shett1,mss->ravno(i),sizeof(shett1)-1);

  POLE(shett1,shdeb,1,',');
  POLE(shett1,shkre,2,',');
  gsapr(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
  fprintf(ff,"%-*s %-*s %15s\n",
  iceb_tu_kolbait(6,shdeb),shdeb,
  iceb_tu_kolbait(6,shkre),shkre,
  prnbr(msps->ravno(i)));

  bb+=msps->ravno(i);
 }

gsapr(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
fprintf(ff,"%*s:%15s\n",iceb_tu_kolbait(13,gettext("Итого")),gettext("Итого"),prnbr(bb));

gsapr(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
fprintf(ff,"\
......................................................................................................................................\n");

mss->free_class();
msps->free_class();
}

/*************************/
/*Распечатка общего итога*/
/*************************/
void            rasoi(SPISOK *mssi,
masiv_din_double *mspsi,
short dn,short mn,short gn,short dk,short mk,short gk,
int *sli,int *kst,int skl1,char *naiskl,
FILE *ff)
{
double          k1;
short           i;
char            shett1[112];
char		shdeb[56];
char		shkre[56];


k1=0.;
fprintf(ff,"\n%s:\n",gettext("Общий итог"));

rppvo1_sapit(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
for(i=0; i< mssi->kolih() ;i++)
 {
  strncpy(shett1,mssi->ravno(i),sizeof(shett1)-1);
  POLE(shett1,shdeb,1,',');
  POLE(shett1,shkre,2,',');
  fprintf(ff,"%-*s %-*s %15s\n",
  iceb_tu_kolbait(6,shdeb),shdeb,
  iceb_tu_kolbait(6,shkre),shkre,
  prnbr(mspsi->ravno(i)));
  k1+=mspsi->ravno(i);
 }
fprintf(ff,"%*s:%15s\n",iceb_tu_kolbait(13,gettext("Итого")),gettext("Итого"),prnbr(k1));


mspsi->free_class();
mssi->free_class();
}

/******************************/
/* Шапка итога по счетам      */
 /******************************/

void  rppvo1_sapit(short dn,short mn,short gn,short dk,short mk,short gk,
int *sli,int *kst,int skl1,char *naiskl,FILE *ff)
{
gsapr(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
fprintf(ff,"\
------------------------------\n");

gsapr(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);

fprintf(ff,gettext("Дебет |Кредит|    Сумма      |\n"));


gsapr(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
fprintf(ff,"\
------------------------------\n");

}
/************************************/
/*Шапка*/
/************************************/
void rppvo1_s(int skl1,char *naiskl,
short dn,short mn,short gn,
short dk,short mk,short gk,
int *sl,
int *kst,
FILE *ff)
{
*sl+=1;
*kst+=4;

fprintf(ff,"\
%s%-2d %-30s %s %02d.%02d.%4d%s %s %02d.%02d.%4d%s %*s%d\n",
gettext("Склад N"),
skl1,naiskl,
gettext("Период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
iceb_tu_kolbait(30,gettext("Лист N")),gettext("Лист N"),
*sl);

fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,gettext(
" 	 Контрагент                              |Дата док. |Дата пров.|N документа|Nнал.н|  Счета   |       Сумма        |Коментарий\n"));

fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------------------------------\n");

}
