/*$Id: rpvnn_ps.c,v 5.13 2011-02-21 07:47:07 sasa Exp $*/
/*17.02.2011	30.08.2005	Белых А.И.	rpvnn_ps.c
Печать шапки реестра налоговых накладных
возвращаем количество строк в шапке
*/
#include <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

int rpvnn_ps0(short dn,short mn,short gn,short dk,short mk,short gk,FILE *ff);
int rpvnn_ps1(short dn,short mn,short gn,short dk,short mk,short gk,FILE *ff);
int rpvnn_ps2(short dn,short mn,short gn,short dk,short mk,short gk,FILE *ff);


int rpvnn_ps(short dn,short mn,short gn,
short dk,short mk,short gk,
FILE *ff)
{
if(sravmydat(dn,mn,gn,1,1,2010) < 0)
  return(rpvnn_ps0(dn,mn,gn,dk,mk,gk,ff));
if(sravmydat(dn,mn,gn,1,1,2010) >= 0 and sravmydat(dn,mn,gn,1,1,2011) < 0)
  return(rpvnn_ps1(dn,mn,gn,dk,mk,gk,ff));
if(sravmydat(dn,mn,gn,1,1,2011) >= 0)
  return(rpvnn_ps2(dn,mn,gn,dk,mk,gk,ff));
return(1);
}
/**********************************/

int rpvnn_ps2(short dn,short mn,short gn,short dk,short mk,short gk,FILE *ff)
{
char strok[1024];
char strsql[512];
SQL_str row;
SQLCURSOR cur;
char naiorg[512];
char inn[24];
char nspnds[32];
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
memset(naiorg,'\0',sizeof(naiorg));
memset(inn,'\0',sizeof(inn));
memset(nspnds,'\0',sizeof(nspnds));


sprintf(strsql,"select naikon,pnaim,innn,nspnds from Kontragent where kodkon='00'");

if(readkey(strsql,&row,&cur) == 1)
 {
  if(row[1][0] != '\0')
   strncpy(naiorg,row[1],sizeof(naiorg)-1);
  else
   strncpy(naiorg,row[0],sizeof(naiorg)-1);

  strncpy(inn,row[2],sizeof(inn)-1);

  strncpy(nspnds,row[3],sizeof(nspnds)-1);
  
 }

sprintf(strsql,"select str from Alx where fil='rpvnn0_2.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(0);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"rpvnn0_2.alx");
  iceb_t_soob(strsql);
  return(0);
 }


int nomer_str=0;
 
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  nomer_str++;
  memset(strok,'\0',sizeof(strok));
  strncpy(strok,row_alx[0],sizeof(strok)-1);
  switch(nomer_str)
   {
    case 29:
      BSTAB(strok,naiorg,15,106,1);
//      sprintf(strsql,"%02d.%02d.%d",dn,mn,gn);
//      BSTAB(strok,strsql,123,135,1);
      break;    

    case 35:
      BSTAB(strok,inn,76,100,1);
//      sprintf(strsql,"%02d.%02d.%d",dk,mk,gk);
//      BSTAB(strok,strsql,123,135,1);
      break;    

    case 39:
      BSTAB(strok,nspnds,76,100,1);
      break;    

   }
 
  fprintf(ff,"%s",strok);
  
 }
return(nomer_str); 
}


/******************************/

int rpvnn_ps0(short dn,short mn,short gn,short dk,short mk,short gk,FILE *ff)
{
char strok[1024];
char strsql[512];
SQL_str row;
SQLCURSOR cur;
char naiorg[512];
char inn[32];
char nspnds[32];
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
memset(naiorg,'\0',sizeof(naiorg));
memset(inn,'\0',sizeof(inn));
memset(nspnds,'\0',sizeof(nspnds));


sprintf(strsql,"select naikon,pnaim,innn,nspnds from Kontragent where kodkon='00'");

if(readkey(strsql,&row,&cur) == 1)
 {
  if(row[1][0] != '\0')
   strncpy(naiorg,row[1],sizeof(naiorg)-1);
  else
   strncpy(naiorg,row[0],sizeof(naiorg)-1);

  strncpy(inn,row[2],sizeof(inn)-1);

  strncpy(nspnds,row[3],sizeof(nspnds)-1);
  
 }

sprintf(strsql,"select str from Alx where fil='rpvnn0.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(0);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"rpvnn0.alx");
  iceb_t_soob(strsql);
  return(0);
 }

int nomer_str=0;
 
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  nomer_str++;
  memset(strok,'\0',sizeof(strok));
  strncpy(strok,row_alx[0],sizeof(strok)-1);
  switch(nomer_str)
   {
    case 5:
      BSTAB(strok,naiorg,26,90,1);
      sprintf(strsql,"%02d.%02d.%d",dn,mn,gn);
      BSTAB(strok,strsql,107,120,1);
      break;    

    case 6:
      BSTAB(strok,inn,35,90,1);
      sprintf(strsql,"%02d.%02d.%d",dk,mk,gk);
      BSTAB(strok,strsql,107,120,1);
      break;    

    case 7:
      BSTAB(strok,nspnds,64,90,1);
      break;    

   }
 
  fprintf(ff,"%s",strok);
  
 }
return(nomer_str); 
}
/**********************************/

int rpvnn_ps1(short dn,short mn,short gn,short dk,short mk,short gk,FILE *ff)
{
char strok[1024];
char strsql[512];
SQL_str row;
SQLCURSOR cur;
char naiorg[512];
char inn[24];
char nspnds[32];
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
memset(naiorg,'\0',sizeof(naiorg));
memset(inn,'\0',sizeof(inn));
memset(nspnds,'\0',sizeof(nspnds));


sprintf(strsql,"select naikon,pnaim,innn,nspnds from Kontragent where kodkon='00'");

if(readkey(strsql,&row,&cur) == 1)
 {
  if(row[1][0] != '\0')
   strncpy(naiorg,row[1],sizeof(naiorg)-1);
  else
   strncpy(naiorg,row[0],sizeof(naiorg)-1);

  strncpy(inn,row[2],sizeof(inn)-1);

  strncpy(nspnds,row[3],sizeof(nspnds)-1);
  
 }

sprintf(strsql,"select str from Alx where fil='rpvnn0_1.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(0);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"rpvnn0_1.alx");
  iceb_t_soob(strsql);
  return(0);
 }


int nomer_str=0;
 
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  nomer_str++;
  memset(strok,'\0',sizeof(strok));
  strncpy(strok,row_alx[0],sizeof(strok)-1);
  switch(nomer_str)
   {
    case 7:
      BSTAB(strok,naiorg,39,106,1);
      sprintf(strsql,"%02d.%02d.%d",dn,mn,gn);
      BSTAB(strok,strsql,123,135,1);
      break;    

    case 8:
      BSTAB(strok,inn,32,90,1);
      sprintf(strsql,"%02d.%02d.%d",dk,mk,gk);
      BSTAB(strok,strsql,123,135,1);
      break;    

    case 9:
      BSTAB(strok,nspnds,61,90,1);
      break;    

   }
 
  fprintf(ff,"%s",strok);
  
 }
return(nomer_str); 
}

