/*$Id: rudnfv.c,v 5.5 2010-02-14 16:34:07 sasa1 Exp $*/
/*01.08.2004	01.08.2004	Белых А.И.	rudnfv.c
Расчёт увеличения дохода при неденежных формах начисления зарплаты
*/
#include        "buhg.h"

extern double   okrg;
extern float  ppn; //Процент подоходного налога


void rudnfv(double *suma_zar,double suma_ndfnz,FILE *ffp)
{
if(suma_ndfnz == 0.)
 return;

float suma_ud=0.;
 
double suma_snn=0; //Сумма с которой должен начисляться налог
suma_snn=suma_ndfnz*(100/(100-ppn));
suma_snn=okrug(suma_snn,okrg);
//вычисляем сумму увеличения дохода
suma_ud=suma_snn-suma_ndfnz;
   
if(ffp != NULL)
 {
  fprintf(ffp,"%s-Неденежные формы пачисления зарплаты !!!\n",__FUNCTION__);
  fprintf(ffp,"Сумма с которой нужно начислять налог=%.2f*(100/(100-%f))=%.2f\n",
  suma_ndfnz,ppn, suma_snn);

  fprintf(ffp,"Увеличение дохода на %.2f-%.2f=%.2f\n",suma_snn, suma_ndfnz, suma_ud);    

  fprintf(ffp,"Увеличиваем сумму облагаемого налогом дохода=%.2f+%.2f=%.2f\n",
  *suma_zar,suma_ud,*suma_zar+suma_ud);
 }

*suma_zar+=suma_ud;

}
