/* $Id: salallk.c,v 5.44 2011-01-13 13:43:23 sasa1 Exp $ */
/*18.12.2009	08.08.1998	Белых А.И.	salallk.c
Получение сальдо по всем организациям по всем счетам
*/
#define	   KOLST  77 /*Количество строк на листе*/
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void            saloro2(double[],char[],short,short,short,short,short,short,short);
int  saloro3(const char*,short,short,short,short,short,short,short,const char*,const char*,SPISOK*,class spis_oth*);
void            sstrsl(short*,short*,FILE*,FILE*);
void            sstrsl1(short*,short*,FILE*);
void		sal1(short,FILE*,FILE*);
void		sal2(short,FILE*);

extern char     *organ;/*Наименование организации*/
extern short	startgodb; /*Стартовый год*/

int salallk(class spis_oth *oth)
{
static char     dat1[11],dat2[11];
static char	sheta[112];
static char	grupa[112];
static char	kontr[112];
short           par;
short           vds,tps;
short           metn,ks;
short           dn,mn,gn;
short           dk,mk,gk;
char            sh[32];
time_t          tmm;
struct  tm      *bf;
long		kolstr;
SQL_str         row;
char		strsql[512];
long		pozz;
char		naim[512];
int		kom1=0;
VVOD MENU(3);
VVOD VV(0);

memset(naim,'\0',sizeof(naim));
if(dat1[0] == '\0')
 {
  short    dt,mt,gt;
  poltekdat(&dt,&mt,&gt);
  sprintf(dat1,"01.01.%d",gt);
  sprintf(dat2,"%02d.%02d.%d",dt,mt,gt);
 } 

VV.VVOD_SPISOK_add_ZAG(gettext("Расчет сальдо по всем конт-там и по всем счетам с развернутым сальдо"));

VV.VVOD_SPISOK_add_MD(gettext("Начальная дата..."));
VV.VVOD_SPISOK_add_MD(gettext("Конечная дата...."));
VV.VVOD_SPISOK_add_MD(gettext("Счет.......(,,).."));
VV.VVOD_SPISOK_add_MD(gettext("Группа.....(,,).."));
VV.VVOD_SPISOK_add_MD(gettext("Контрагент.(,,).."));

VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2));
VV.VVOD_SPISOK_add_data(sheta,sizeof(sheta));
VV.VVOD_SPISOK_add_data(grupa,sizeof(grupa));
VV.VVOD_SPISOK_add_data(kontr,sizeof(kontr));

naz:;
clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

nazz:;

par=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(sheta,VV.VVOD_SPISOK_return_data(2),sizeof(sheta)-1);
strncpy(grupa,VV.VVOD_SPISOK_return_data(3),sizeof(grupa)-1);
strncpy(kontr,VV.VVOD_SPISOK_return_data(4),sizeof(kontr)-1);


switch(par)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("buhg5_3.txt");
   clear();
   goto naz;
   
  case PLU:
  case FK2:
   break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите  нужное и нажмите Enter"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка контрагентов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;
      case 0 :
        vibrek("Plansh",sheta,sizeof(sheta),naim);
        VV.VVOD_SPISOK_zapis_data(2,sheta);
        goto naz;
      case 1 :
        vibrek("Gkont",grupa,sizeof(grupa),naim);
        VV.VVOD_SPISOK_zapis_data(3,grupa);
        goto naz;
      case 2 :
        vibrek("Kontragent",kontr,sizeof(kontr),naim);
        VV.VVOD_SPISOK_zapis_data(4,kontr);
        goto naz;
      }
     goto naz;
     
  case ESC:
  case FK10:
   return(1);

  case FK4:
    VV.VVOD_clear_data();
    goto naz;
   
  default:
   goto nazz;
 }

if(rsdatp(&dn,&mn,&gn,dat1,&dk,&mk,&gk,dat2) != 0)
  goto naz;

par=0;
VVOD DANET(1);
DANET.VVOD_SPISOK_add_MD(gettext("Встречные проводки учесть ?"));

if(danet(&DANET,1,stdscr) == 2)
  par=1;

/*Просматриваем план счетов, находим все счета с развернутым
сальдо и заряжаем в массив*/

time(&tmm);
bf=localtime(&tmm);

clear();
GDITE();

move(0,0);
sprintf(strsql,"select ns from Plansh where saldo=3 and stat=0 \
order by ns asc");
//printw("strsql=%s\n",strsql);
//refresh();
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не нашли счетов с развернутым сальдо !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
class SPISOK sheta_srs;
vds=tps=metn=ks=0;
pozz=0;
while(cur.read_cursor(&row) != 0)
 {
/*
  printw("%s %s %s\n",row[0],row[1],row[2]);
  refresh();
*/
  strncpy(sh,row[0],sizeof(sh)-1);
  if( pozz < kolstr-1)
   {
    cur.poz_cursor(pozz+1);
    cur.read_cursor(&row);

    /*Если нет субсчетов запоминаем счет*/
    if(SRAV(sh,row[0],1) != 0)
     {
      cur.poz_cursor(pozz);
      cur.read_cursor(&row);
     }
   }
  pozz++;
  sheta_srs.plus(row[0]);
 }

printw(gettext("Расчет сальдо по всем контрагентам и по всем счетам с развернутым сальдо"));

printw("\n%s %d.%d.%d %s %d.%d.%d\n",
gettext("Период с"),
dn,mn,gn,
gettext("до"),
dk,mk,gk);

printw(gettext("Количество счетов с развернутым сальдо - %d\n"),sheta_srs.kolih());

return(saloro3(sheta,dn,mn,gn,dk,mk,gk,par,grupa,kontr,&sheta_srs,oth));
}

/******************************/
/*Подпрограмма быстрого отчета*/
/******************************/
int saloro3(const char *sheta,
short dn,short mn,
short gn,short dk,short mk,short gk,
short mks, //0-все проводки 1-без взаимно кореспондирующих
const char *grupa,
const char *kontr,
class SPISOK *sheta_srs,
class spis_oth *oth)
{
int kls=sheta_srs->kolih(); //Количество счетов с развернутым сальдо
long		kolstr,kolstr1;
SQL_str         row,row1;
char		strsql[512];
time_t          tmm;
struct  tm      *bf;
short		mro,mrodeb,mrokre;
char		imaf[32],imaf1[32],imafdeb[32],imafkre[32];
FILE		*ff,*ff1,*ffdeb,*ffkre;
long		koo=0;
long		i,i1,i2;
char		sh[16];
double		db,kr;
char		kor[32];
long		rzm;
double		mas1[6],mas2[6];
short		kli=0,kst=0;
short		klideb,kstdeb;
short		klikre,kstkre;
short		d,m,g;
char		bros[512];
short		godn;
double		itdeb,itkre;
SQLCURSOR cur;
SQLCURSOR cur1;

GDITE();

time(&tmm);
bf=localtime(&tmm);

godn=startgodb;
if(startgodb == 0 || startgodb > gn)
 godn=gn;


/*Определяем все организации и открываем массивы дебетов и
кредитов организаций
*/
class SPISOK spkontr;

/*Смотрим по каким контрагентам введено сальдо*/
sprintf(strsql,"select kodkon from Saldo where kkk=1 and gs=%d",godn);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

while(cur.read_cursor(&row) != 0)
 {
  if(proverka(kontr,row[0],0,0) != 0)
    continue;
  if(grupa[0] != '\0')
   {
    sprintf(strsql,"select grup from Kontragent where kodkon='%s'",row[0]);
    if(readkey(strsql,&row1,&cur1) != 1)
     {
      sprintf(strsql,"%s %s!",gettext("Не найден код контрагента"),row[0]);
      iceb_t_soob(strsql);
      continue;
     }
    if(proverka(grupa,row1[0],0,0) != 0)
      continue;
   }
  spkontr.plus(row[0]);
 }

/*Смотрим по каким контрагентам были сделаны проводки*/
sprintf(strsql,"select distinct kodkon from Prov where datp >= '%04d-1-1' and \
datp <= '%04d-%02d-%02d'and kodkon <> ''",godn,gk,mk,dk);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }


while(cur.read_cursor(&row) != 0)
 {
  if(proverka(kontr,row[0],0,0) != 0)
    continue;
  if(grupa[0] != '\0')
   {
    sprintf(strsql,"select grup from Kontragent where kodkon='%s'",row[0]);
    if(readkey(strsql,&row1,&cur1) != 1)
     {
      sprintf(strsql,"%s %s!",gettext("Не найден код контрагента"),row[0]);
      iceb_t_soob(strsql);
      continue;
     }
    if(proverka(grupa,row1[0],0,0) != 0)
      continue;
   }
  if(spkontr.find_r(row[0]) < 0)
    spkontr.plus(row[0]);
 }

koo=spkontr.kolih();

printw("%s: %d\n",
gettext("Количество контрагентов"),koo);

if(koo == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одного контрагента !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

rzm=koo*kls*4;
class masiv_din_double mdo;
mdo.make_class(rzm);

printw(gettext("Вычисляем стартовое сальдо по всем контрагентам\n"));
GDITE();
sprintf(strsql,"select ns,kodkon,deb,kre from Saldo where kkk='%d' and gs=%d",
1,godn);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
if(kolstr > 0)
while(cur.read_cursor(&row) != 0)
 {
  if((i=sheta_srs->find(row[0])) < 0)
   continue;

  if(proverka(kontr,row[1],0,0) != 0)
    continue;

  if(grupa[0] != '\0')
   {
    sprintf(strsql,"select grup from Kontragent where kodkon='%s'",row[1]);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)    
     if(proverka(grupa,row1[0],0,0) != 0)
       continue;
   }
   
  if((i1=spkontr.find_r(row[1])) >= 0)
   {
    rzm=(i1*kls*4)+(i*4);
    mdo.plus(atof(row[2]),rzm);
    mdo.plus(atof(row[3]),rzm+1);

   }
  else
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %s %s",
    gettext("Не найден код контрагента"),
    row[1],
    gettext("в массиве кодов"));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);

   }
 }

printw(gettext("Просматриваем проводки\n"));
GDITE();
sprintf(strsql,"select datp,sh,shk,kodkon,deb,kre from Prov \
where val=0 and datp >= '%04d-%02d-%02d' and datp <= '%04d-%02d-%02d' \
order by datp,sh asc",godn,1,1,gk,mk,dk);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  beep();
  printw(gettext("Нет проводок за %d год.\n"),gn);
  OSTANOV();
  return(1);
 } 
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  kolstr1++;
  strzag(LINES-1,0,kolstr,kolstr1);
  if((i=sheta_srs->find(row[1])) < 0)
    continue;  

  if(proverka(kontr,row[3],0,0) != 0)
    continue;

  if(grupa[0] != '\0' )
   {
    sprintf(strsql,"select grup from Kontragent where kodkon='%s'",row[3]);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)    
     if(proverka(grupa,row1[0],0,0) != 0)
       continue;
   }

  if((i1=spkontr.find_r(row[3])) < 0)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %s %s",
    gettext("Не найден код контрагента"),
    row[3],
    gettext("в массиве кодов"));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    sprintf(strsql,"%s %s %s %s %s %s",row[0],row[1],row[2],row[3],row[4],
    row[5]);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);

    continue;
   }   
  if(mks == 1)
   {
    if(SRAV(row[1],row[2],1) == 0 || sheta_srs->find(row[2]) >= 0)
     continue;
   }
  rsdat(&d,&m,&g,row[0],2);
  
  rzm=(i1*kls*4)+(i*4);

   /*Период*/

  if(SRAV1(g,m,d,gn,mn,dn) <= 0)
   if(SRAV1(gk,mk,dk,g,m,d) <= 0)
    {
     mdo.plus(atof(row[4]),rzm+2);
     mdo.plus(atof(row[5]),rzm+3);
    }

   /*До периода*/
  if(SRAV1(g,m,d,gn,mn,dn) > 0)
    {
     mdo.plus(atof(row[4]),rzm);
     mdo.plus(atof(row[5]),rzm+1);
    }

 }
printw(gettext("Распечатываем результат\n"));
GDITE();

sprintf(imaf,"sl%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

sprintf(imaf1,"slk%d.lst",getpid());
if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return(1);
 }

sprintf(imafdeb,"sldeb%d.lst",getpid());
if((ffdeb = fopen(imafdeb,"w")) == NULL)
 {
  error_op_nfil(imafdeb,errno,"");
  return(1);
 }

sprintf(imafkre,"slkre%d.lst",getpid());
if((ffkre = fopen(imafkre,"w")) == NULL)
 {
  error_op_nfil(imafkre,errno,"");
  return(1);
 }

fprintf(ff,"\x1B\x33%c",30); /*Уменьшаем межстрочный интервал*/

fprintf(ff1,"\x1B\x33%c",30); /*Уменьшаем межстрочный интервал*/

fprintf(ffdeb,"\x1B\x33%c",30); /*Уменьшаем межстрочный интервал*/

fprintf(ffkre,"\x1B\x33%c",30); /*Уменьшаем межстрочный интервал*/

zagolov(gettext("Сальдо по всем контрагентам"),bf,dn,mn,gn,dk,mk,gk,organ,ff);
zagolov(gettext("Сальдо по всем контрагентам"),bf,dn,mn,gn,dk,mk,gk,organ,ff1);
zagolov(gettext("Контрагенты дебиторы"),bf,dn,mn,gn,dk,mk,gk,organ,ffdeb);
zagolov(gettext("Контрагенты кредиторы"),bf,dn,mn,gn,dk,mk,gk,organ,ffkre);

kst=kstdeb=kstkre=5;
kli=klideb=klikre=1;
if(sheta[0] != '\0')
 {
  kst++; kstdeb++; kstkre++;
  fprintf(ff,"%s:%s\n",gettext("Счет"),sheta);
  fprintf(ff1,"%s:%s\n",gettext("Счет"),sheta);
  fprintf(ffdeb,"%s:%s\n",gettext("Счет"),sheta);
  fprintf(ffkre,"%s:%s\n",gettext("Счет"),sheta);
 }
if(grupa[0] != '\0')
 {
  kst++; kstdeb++; kstkre++;
  fprintf(ff,"%s:%s\n",gettext("Группа"),grupa);
  fprintf(ff1,"%s:%s\n",gettext("Группа"),grupa);
  fprintf(ffdeb,"%s:%s\n",gettext("Группа"),grupa);
  fprintf(ffkre,"%s:%s\n",gettext("Группа"),grupa);
 }
if(kontr[0] != '\0')
 {
  kst++; kstdeb++; kstkre++;
  fprintf(ff,"%s:%s\n",gettext("Контрагент"),kontr);
  fprintf(ff1,"%s:%s\n",gettext("Контрагент"),kontr);
  fprintf(ffdeb,"%s:%s\n",gettext("Контрагент"),kontr);
  fprintf(ffkre,"%s:%s\n",gettext("Контрагент"),kontr);
 }

sal1(kli,ff,ff1);
sal2(klideb,ffdeb);
sal2(klikre,ffkre);

kst+=5;
kstdeb+=5;
kstkre+=5; //Увеличиваем на шапку


for(i=0; i< 6 ;i++)
  mas2[i]=0.;

for(i1=0;i1<koo;i1++)
 {
//  strzag(LINES-1,0,koo,i1);

  for(i2=0; i2< 6 ;i2++)
    mas1[i2]=0.;
  mro=mrodeb=mrokre=0;
  itdeb=itkre=db=kr=0;
  memset(kor,'\0',sizeof(kor));
  strncpy(kor,spkontr.ravno(i1),sizeof(kor)-1);

  for(i=0; i < kls; i++)
   {
    strncpy(sh,sheta_srs->ravno(i),sizeof(sh)-1);
    if(proverka(sheta,sh,1,0) != 0)
     continue;
     
    rzm=(i1*kls*4)+(i*4);

    if(fabs(mdo.ravno(rzm)) < 0.009 && 
       fabs(mdo.ravno(rzm+1)) < 0.009 &&
       fabs(mdo.ravno(rzm+2)) < 0.009 &&
       fabs(mdo.ravno(rzm+3)) < 0.009)
        continue;
    if(fabs(mdo.ravno(rzm)-mdo.ravno(rzm+1)) < 0.009 && 
       fabs(mdo.ravno(rzm+2)) < 0.009 &&
       fabs(mdo.ravno(rzm+3)) < 0.009)
        continue;

     mas1[2]+=mdo.ravno(rzm+2);
     mas1[3]+=mdo.ravno(rzm+3);

    if(mro == 0)
     {
      sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",
      kor);
      if(sql_readkey(&bd,strsql,&row,&cur1) != 1)
       {
         beep();
         printw("%s %s !\n",
         gettext("Не найден код контрагента"),kor);
         OSTANOV();
         break;
       }

      strncpy(bros,row[0],sizeof(bros)-1);
      if(mdo.ravno(rzm) > mdo.ravno(rzm+1))
       {
        fprintf(ff,"%*s %-*.*s %-*s %11.2f %11s %11.2f %11.2f",
        iceb_tu_kolbait(7,kor),kor,
        iceb_tu_kolbait(25,bros),iceb_tu_kolbait(25,bros),bros,
        iceb_tu_kolbait(5,sh),sh,
        mdo.ravno(rzm)-mdo.ravno(rzm+1)," ",mdo.ravno(rzm+2),mdo.ravno(rzm+3));
        mas1[0]+=mdo.ravno(rzm)-mdo.ravno(rzm+1);
       }
      else
       {
        fprintf(ff,"%*s %-*.*s %-*s %11s %11.2f %11.2f %11.2f",
        iceb_tu_kolbait(7,kor),kor,
        iceb_tu_kolbait(25,bros),iceb_tu_kolbait(25,bros),bros,
        iceb_tu_kolbait(5,sh),sh,
        " ",mdo.ravno(rzm+1)-mdo.ravno(rzm),mdo.ravno(rzm+2),mdo.ravno(rzm+3));
        mas1[1]+=mdo.ravno(rzm+1)-mdo.ravno(rzm);
       } 
/*
      printw("%4s %-30.30s %-5s %10.10f %10.10f\n",
      kor,bros,sh,mdo[rzm]+mdo[rzm+2],mdo[rzm+1]+mdo[rzm+3]);
*/	
     }
    else
     {
      if(mdo.ravno(rzm) > mdo.ravno(rzm+1))
       {
        fprintf(ff,"%7s %-25.25s %-*s %11.2f %11s %11.2f %11.2f",
        " "," ",
        iceb_tu_kolbait(5,sh),sh,
        mdo.ravno(rzm)-mdo.ravno(rzm+1)," ",mdo.ravno(rzm+2),mdo.ravno(rzm+3));
        mas1[0]+=mdo.ravno(rzm)-mdo.ravno(rzm+1);
       }
      else
       {
        fprintf(ff,"%7s %-25.25s %-*s %11s %11.2f %11.2f %11.2f",
        " "," ",
        iceb_tu_kolbait(5,sh),sh," ",mdo.ravno(rzm+1)-mdo.ravno(rzm),mdo.ravno(rzm+2),mdo.ravno(rzm+3));
        mas1[1]+=mdo.ravno(rzm+1)-mdo.ravno(rzm);
/*
      printw("%4s %-30.30s %-5s %10.10f %10.10f\n",
      " "," ",sh,mdo[rzm]+mdo[rzm+2],mdo[rzm+1]+mdo[rzm+3]);
*/
       }
     }    

    if(mdo.ravno(rzm)+mdo.ravno(rzm+2) > mdo.ravno(rzm+1)+mdo.ravno(rzm+3))
     {
      if(mro == 0)
       {
        fprintf(ff1,"%*s %-*.*s %-*s %11.2f\n",
        iceb_tu_kolbait(7,kor),kor,
        iceb_tu_kolbait(25,bros),iceb_tu_kolbait(25,bros),bros,
        iceb_tu_kolbait(5,sh),sh,
        (mdo.ravno(rzm)+mdo.ravno(rzm+2))-(mdo.ravno(rzm+1)+mdo.ravno(rzm+3)));
       }
      else
       {
        fprintf(ff1,"%7s %-25.25s %-*s %11.2f\n",
        " "," ",iceb_tu_kolbait(5,sh),sh,
        (mdo.ravno(rzm)+mdo.ravno(rzm+2))-(mdo.ravno(rzm+1)+mdo.ravno(rzm+3)));

       }

      if(fabs((mdo.ravno(rzm)+mdo.ravno(rzm+2))-(mdo.ravno(rzm+1)+mdo.ravno(rzm+3))) > 0.009)
       {
        itdeb+=(mdo.ravno(rzm)+mdo.ravno(rzm+2))-(mdo.ravno(rzm+1)+mdo.ravno(rzm+3));
        if(mrodeb == 0)
         {
          fprintf(ffdeb,"%*s %-*.*s %-*s %11.2f\n",
          iceb_tu_kolbait(7,kor),kor,
          iceb_tu_kolbait(25,bros),iceb_tu_kolbait(25,bros),bros,
          iceb_tu_kolbait(5,sh),sh,
          (mdo.ravno(rzm)+mdo.ravno(rzm+2))-(mdo.ravno(rzm+1)+mdo.ravno(rzm+3)));
         }
        else
         {
          fprintf(ffdeb,"%7s %-25.25s %-*s %11.2f\n",
          " "," ",iceb_tu_kolbait(5,sh),sh,
          (mdo.ravno(rzm)+mdo.ravno(rzm+2))-(mdo.ravno(rzm+1)+mdo.ravno(rzm+3)));
         }
        mrodeb++;
        sstrsl1(&kstdeb,&klideb,ffdeb);
       }        
      fprintf(ff," %11.2f\n",(mdo.ravno(rzm)+mdo.ravno(rzm+2))-(mdo.ravno(rzm+1)+mdo.ravno(rzm+3)));
      mas1[4]+=(mdo.ravno(rzm)+mdo.ravno(rzm+2))-(mdo.ravno(rzm+1)+mdo.ravno(rzm+3));
     }
    else
     {
      if(mro == 0)
       {
        fprintf(ff1,"%*s %-*.*s %-*s %11s %11.2f\n",
        iceb_tu_kolbait(7,kor),kor,
        iceb_tu_kolbait(25,bros),iceb_tu_kolbait(25,bros),bros,
        iceb_tu_kolbait(5,sh),sh,
        " ",
        (mdo.ravno(rzm+1)+mdo.ravno(rzm+3))-(mdo.ravno(rzm)+mdo.ravno(rzm+2)));
       }
      else
       {
        fprintf(ff1,"%7s %-25.25s %-*s %11s %11.2f\n",
        " "," ",iceb_tu_kolbait(5,sh),sh," ",
        (mdo.ravno(rzm+1)+mdo.ravno(rzm+3))-(mdo.ravno(rzm)+mdo.ravno(rzm+2)));

       }

      if(fabs((mdo.ravno(rzm+1)+mdo.ravno(rzm+3))-(mdo.ravno(rzm)+mdo.ravno(rzm+2))) > 0.009)
       {
        itkre+=(mdo.ravno(rzm+1)+mdo.ravno(rzm+3))-(mdo.ravno(rzm)+mdo.ravno(rzm+2));

        if(mrokre == 0)
         {
          fprintf(ffkre,"%*s %-*.*s %-*s %11s %11.2f\n",
          iceb_tu_kolbait(7,kor),kor,
          iceb_tu_kolbait(25,bros),iceb_tu_kolbait(25,bros),bros,
          iceb_tu_kolbait(5,sh),sh,
          " ",
          (mdo.ravno(rzm+1)+mdo.ravno(rzm+3))-(mdo.ravno(rzm)+mdo.ravno(rzm+2)));
         }
        else
         {
          fprintf(ffkre,"%7s %-25.25s %-*s %11s %11.2f\n",
          " "," ",iceb_tu_kolbait(5,sh),sh," ",
          (mdo.ravno(rzm+1)+mdo.ravno(rzm+3))-(mdo.ravno(rzm)+mdo.ravno(rzm+2)));

         }
        mrokre++;

        sstrsl1(&kstkre,&klikre,ffkre);
       }      
      fprintf(ff," %11s %11.2f\n"," ",(mdo.ravno(rzm+1)+mdo.ravno(rzm+3))-(mdo.ravno(rzm)+mdo.ravno(rzm+2)));
      mas1[5]+=(mdo.ravno(rzm+1)+mdo.ravno(rzm+3))-(mdo.ravno(rzm)+mdo.ravno(rzm+2));
     }
    sstrsl(&kst,&kli,ff,ff1);
    mro++;
   }

  if(mro > 1)
   {
    sprintf(bros,"------%s %s :",gettext("Итого по"),kor);
    if(mas1[0] > mas1[1])
     {
      fprintf(ff,"%*s %11.2f %11s %11.2f %11.2f",
      iceb_tu_kolbait(39,bros),bros,mas1[0]-mas1[1]," ",mas1[2],mas1[3]);
     }
    else
     {
      fprintf(ff,"%*s %11s %11.2f %11.2f %11.2f",
      iceb_tu_kolbait(39,bros),bros," ",mas1[1]-mas1[0],mas1[2],mas1[3]);
     }

    if(mas1[0]+mas1[2] > mas1[1]+mas1[3])
     {
      fprintf(ff1,"%*s %11.2f\n",
      iceb_tu_kolbait(39,bros),bros,
      (mas1[0]+mas1[2])-(mas1[1]+mas1[3]));
      fprintf(ff," %11.2f\n",(mas1[0]+mas1[2])-(mas1[1]+mas1[3]));

     }
    else
     {
      fprintf(ff1,"%*s %11s %11.2f\n",
      iceb_tu_kolbait(39,bros),bros," ",
      (mas1[1]+mas1[3])-(mas1[0]+mas1[2]));
      fprintf(ff," %11s %11.2f\n"," ",(mas1[1]+mas1[3])-(mas1[0]+mas1[2]));
     }
    sstrsl(&kst,&kli,ff,ff1);

   }

  if(mrodeb > 1)
   {
    sprintf(bros,"------%s %s :",gettext("Итого по"),kor);
    fprintf(ffdeb,"%*s %11.2f\n",
    iceb_tu_kolbait(39,bros),bros,itdeb);
    sstrsl1(&kstdeb,&klideb,ffdeb);
   }
  if(mrokre > 1)
   {
    sprintf(bros,"------%s %s :",gettext("Итого по"),kor);
      fprintf(ffkre,"%*s %11s %11.2f\n",
      iceb_tu_kolbait(39,bros),bros," ",itkre);
      sstrsl1(&kstkre,&klikre,ffkre);
   }
  mas2[0]+=mas1[0];
  mas2[1]+=mas1[1];
  mas2[2]+=mas1[2];
  mas2[3]+=mas1[3];
  mas2[4]+=mas1[4];
  mas2[5]+=mas1[5];

 }
fprintf(ff,"\
----------------------------------------------------------------------------------------------------------------\n");

fprintf(ff1,"\
----------------------------------------------------------------\n");
fprintf(ffdeb,"\
----------------------------------------------------------------\n");
fprintf(ffkre,"\
----------------------------------------------------------------\n");

printw("\n%20s",prnbr(mas2[0]));
printw(" %20s\n",prnbr(mas2[1]));
printw("%20s",prnbr(mas2[2]));
printw(" %20s\n",prnbr(mas2[3]));
printw("%20s",prnbr(mas2[4]));
printw(" %20s\n",prnbr(mas2[5]));

fprintf(ff,"%*s %11.2f %11.2f %11.2f %11.2f %11.2f %11.2f\n",
iceb_tu_kolbait(39,gettext("Итого :")),gettext("Итого :"),mas2[0],mas2[1],mas2[2],mas2[3],mas2[4],mas2[5]);

fprintf(ff1,"%*s %11.2f %11.2f\n",
iceb_tu_kolbait(39,gettext("Итого :")),gettext("Итого :"),mas2[4],mas2[5]);

fprintf(ffdeb,"%*s %11.2f\n",
iceb_tu_kolbait(39,gettext("Итого :")),gettext("Итого :"),mas2[4]);

fprintf(ffkre,"%*s %11s %11.2f\n",
iceb_tu_kolbait(39,gettext("Итого :")),gettext("Итого :")," ",mas2[5]);

if(mas2[0] > mas2[1])
    fprintf(ff,"%*s %11.2f %11s %11.2f %11.2f",
    iceb_tu_kolbait(39,gettext("Итого (свернуто):")),gettext("Итого (свернуто):"),mas2[0]-mas2[1]," ",mas2[2],mas2[3]);
  else
    fprintf(ff,"%*s %11s %11.2f %11.2f %11.2f",
    iceb_tu_kolbait(39,gettext("Итого (свернуто):")),gettext("Итого (свернуто):")," ",mas2[1]-mas2[0],mas2[2],mas2[3]);
if(mas2[0]+mas2[2] > mas2[1]+mas2[3])
 {
  fprintf(ff1,"%*s %11.2f\n",
  iceb_tu_kolbait(39,gettext("Итого (свернуто):")),gettext("Итого (свернуто):"),
  (mas2[0]+mas2[2])-(mas2[1]+mas2[3]));
  fprintf(ff," %11.2f\n",(mas2[0]+mas2[2])-(mas2[1]+mas2[3]));

 }
else
 {
  fprintf(ff1,"%*s %11s %11.2f\n",
  iceb_tu_kolbait(39,gettext("Итого (свернуто):")),gettext("Итого (свернуто):")," ",
  (mas2[1]+mas2[3])-(mas2[0]+mas2[2]));
  fprintf(ff," %11s %11.2f\n"," ",(mas2[1]+mas2[3])-(mas2[0]+mas2[2]));
 }
podpis(ff);

podpis(ff1);

podpis(ffdeb);

podpis(ffkre);


fclose(ff);
fclose(ff1);
fclose(ffdeb);
fclose(ffkre);

printw_vr(tmm);
OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчёт оборотов по всем контрагентам"));

oth->spis_imaf.plus(imaf1);
oth->spis_naim.plus(gettext("Расчёт сальдо по всем контрагентам"));

oth->spis_imaf.plus(imafdeb);
oth->spis_naim.plus(gettext("Список контрагентов с дебетовым сальдо"));

oth->spis_imaf.plus(imafkre);
oth->spis_naim.plus(gettext("Список контрагентов с кредитовым сальдо"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),1);

return(0);
}

/*************************/
/*Счетчик строк и листов*/
/*************************/
void            sstrsl(short *kst, //Количество строк
short *kli, //Количество листов
FILE *ff,FILE *ff1)
{

*kst+=1;
if(*kst >= KOLST)
 {
  fprintf(ff,"\f");
  fprintf(ff1,"\f");
  *kli=*kli+1;
  sal1(*kli,ff,ff1);
  *kst=5;
 }  

}

/**********/
/*Шапка 1*/
/*********/
void		sal1(short kli,FILE *ff,FILE *ff1)
{

fprintf(ff,"%90s%s%d\n","",gettext("Лист N"),kli);

fprintf(ff,"\
----------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,gettext(" Код   | Наименование организации|Счет |  Сальдо начальное     |  Оборот за период     |    Сальдо конечное    |\n"));
fprintf(ff,gettext("       |                         |     |   Дебет   |  Кредит   |   Дебет   |  Кредит   |   Дебет   |  Кредит   |\n"));

fprintf(ff,"\
----------------------------------------------------------------------------------------------------------------\n");

fprintf(ff1,"%50s%s%d\n","",gettext("Лист N"),kli);
fprintf(ff1,"\
----------------------------------------------------------------\n");

fprintf(ff1,gettext("  Код  | Наименование организации|Счет |    Сальдо конечное    |\n"));
fprintf(ff1,gettext("       |                         |     |   Дебет   |  Кредит   |\n"));

fprintf(ff1,"\
----------------------------------------------------------------\n");
}
/*************************/
/*Счетчик строк и листов*/
/*************************/
void            sstrsl1(short *kst, //Количество строк
short *kli, //Количество листов
FILE *ff)
{

*kst+=1;
if(*kst >= KOLST)
 {
  fprintf(ff,"\f");
  *kli+=1;
  sal2(*kli,ff);
  *kst=5;
 }  

}

/**********/
/*Шапка 2*/
/*********/
void		sal2(short kli,FILE *ff1)
{

fprintf(ff1,"%50s%s%d\n","",gettext("Лист N"),kli);
fprintf(ff1,"\
----------------------------------------------------------------\n");

fprintf(ff1,gettext("  Код  | Наименование организации|Счет |    Сальдо конечное    |\n"));
fprintf(ff1,gettext("       |                         |     |   Дебет    | Кредит   |\n"));

fprintf(ff1,"\
----------------------------------------------------------------\n");
}
