/*$Id: shet_fak_sap.c,v 5.9 2011-01-13 13:43:23 sasa1 Exp $*/
/*12.12.2010	21.12.2005	Белых А.И.	shet_fak_sap.c
Распечатка шапки счёта-фактуры
*/
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


int shet_fak_sap(short dd,short md,short gd,
const char *nomdok,
const char *ras_shet,
const char *mfo,
const char *kod,
const char *naim_kontr,
const char *dover,
const char *herez,
FILE *ff)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];
char stroka[1024];
char bros[512];
int kol_str_ots=0;
//читаем количество сторок отступа для логотипа
if(iceb_t_poldan("Количество строк отступа для счёта с логотипом",bros,"uslnast.alx") == 0)
  kol_str_ots=atoi(bros);

for(int i=0; i < kol_str_ots; i++)
 fprintf(ff,"\n");

sprintf(strsql,"select str from Alx where fil='usl_shet_fak.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"usl_shet_fak.alx");
  iceb_t_soob(strsql);
  return(1);
 }



int nomer_str=0;
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  nomer_str++;
  memset(stroka,'\0',sizeof(stroka));
  strncpy(stroka,row_alx[0],sizeof(stroka)-1);
  switch(nomer_str)
   {
    case 2:
     BSTAB(stroka,ras_shet,15,68,1);
     break;

    case 3:
     BSTAB(stroka,mfo,15,68,1);
     break;

    case 4:
     BSTAB(stroka,kod,15,68,1);
     break;

    case 6:
     BSTAB(stroka,nomdok,21,40,1);
     sprintf(bros,"%02d.%02d.%d",dd,md,gd);     
     BSTAB(stroka,bros,58,70,1);
     break;

    case 8:
     BSTAB(stroka,naim_kontr,12,68,1);
     break;

    case 11:
     BSTAB(stroka,dover,16,28,1);
     BSTAB(stroka,herez,34,68,1);
     break;
     
   }
  fprintf(ff,"%s",stroka);
 }

return(0);
}
