/* $Id: smdok.c,v 5.43 2011-01-13 13:43:23 sasa1 Exp $ */
/*14.01.2010    15.04.1997      Белых А.И.      smdok.c
Просмотр списка документов для материального учета
*/
#include        <time.h>
#include        <pwd.h>
#include        <sys/types.h>
#include	"buhg.h"

class smdok_poi
 {
  public:
   short dn,mn,gn;
   short dk,mk,gk;
   char nomdokv[56];
   char dat1[12];
   char dat2[12];
   char kps[112];
   char kprrz[112];
   char skl11[112];
   int tipzz;
   char dover[112];
   char nomnalnak[56];

   short mpn;    /*0-все 1-не подтвержденный 2-без проводок*/
   short metpoi; /*0-не задан поиск 1-задан*/
   short metka_opl; /*0-все 1-только оплаченные 2 - только не оплаченные*/

  smdok_poi()
   {
    clear();
    mpn=0;
    metpoi=0;
    metka_opl=0;
    dn=mn=gn=dk=mk=gk=0;
   }

  void clear()
   {
    memset(nomdokv,'\0',sizeof(nomdokv));
    memset(dat1,'\0',sizeof(dat1));
    memset(dat2,'\0',sizeof(dat2));
    memset(kps,'\0',sizeof(kps));
    memset(kprrz,'\0',sizeof(kprrz));
    memset(skl11,'\0',sizeof(skl11));
    memset(dover,'\0',sizeof(dover));
    memset(nomnalnak,'\0',sizeof(nomnalnak));
    tipzz=0;    
   }   
 };


void shsmn(class smdok_poi *poisk);
int sravdok(SQL_str row,class smdok_poi *poisk);
void smdok_vk(class smdok_poi *poisk,SQLCURSOR *cur);

extern char *organ;

void smdok(short dnp,short mnp,short gnp) //Дата начала поиска
{
class smdok_poi poisk;
long		kolstr;
long		pozz=0; /*Позиция первой строчки меню*/
long            pozz1=0; /*Количество строк прочитанных для заполнения меню*/
SQL_str         row,row1;
char		strsql[512];
struct  tm      *bf;
short		d,m,g;
int             K;
short           x=0,y=2;
int             i,kom,kom1;
int		prc;
int		skld=0;
short		kl;
class iceb_tu_str nomdokd("");
char		bros[512];
int		tipzd=0;
char		naimo[512];
char            naiskl[512],naimpr[512];
time_t		tmm;
short		mspz=0; /*метка соответствия первой записи*/
char		kontr[32];
char		oper[32];
char		skladch[32];
char		ktozap[32];
class iceb_t_mstr spis_menu(0);
int metka_naim_skl=0;
char naim_skl[512];
char str_menu[1024];

short dt,mt,gt;
poltekdat(&dt,&mt,&gt);

kom=0;

if(dnp != 0)
 poisk.metpoi=1;
 
 
poisk.dn=dnp;
poisk.mn=mnp;
poisk.gn=gnp;


dnp=0;
pozz=0;
//Создаем класс меню
VVOD SOOB(1);
VVOD VV(0);
VVOD MENU(3);
VVOD DANET(1);

naz1:;

clear();
GDITE();

short           kls=LINES-5;

if(poisk.gn == 0)
 poisk.gn=gt;

sprintf(strsql,"select * from Dokummat where datd >= '%04d-01-01' \
order by datd asc",poisk.gn);

if(poisk.dn != 0)
  sprintf(strsql,"select * from Dokummat where datd >= '%04d-%02d-%02d' \
order by datd asc",poisk.gn,poisk.mn,poisk.dn);

if(poisk.dn != 0 && poisk.dk != 0)
  sprintf(strsql,"select * from Dokummat \
where datd >= '%04d-%02d-%02d' and datd <= '%04d-%02d-%02d' \
order by datd asc",poisk.gn,poisk.mn,poisk.dn,poisk.gk,poisk.mk,poisk.dk);

SQLCURSOR cur;
SQLCURSOR cur1;

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {

lll:;

  shsmn(&poisk);

  SOOB.VVOD_delete();
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одного документа !"));
  K=soobshw(&SOOB,stdscr,-1,-1,1,1);
  
  if(K == FK5 || K == SFK2 || K == SFK3 || K == ENTER)
     goto lll;
  if(K == KEY_RESIZE)
   goto naz1;
     
  goto vper;
 }

naz:;
GDITE();

if(kolstr != 0 && pozz >= kolstr)
  pozz = kolstr-1;

/*MM5.clearMEN5();*/

cur.poz_cursor(pozz);
mspz=2;
pozz1=0;
spis_menu.spis_str.free_class();
for(i=0; i < kls ; )
 {
  
  if(cur.read_cursor(&row) == 0)
    break;
/*
  printw("%s %s %s %s\n",row[0],row[1],row[2],row[3]);
  refresh();
*/
  pozz1++;

  if(sravdok(row,&poisk) != 0)
    continue;
  
  memset(naim_skl,'\0',sizeof(naim_skl));
  if(metka_naim_skl == 1)
   {
    sprintf(strsql,"select naik from Sklad where kod=%s",row[2]);
    if(readkey(strsql,&row1,&cur1) == 1)
     strncpy(naim_skl,row1[0],sizeof(naim_skl)-1);
   }

  if(row[0][0] == '1')
   strcpy(bros,"+");
  if(row[0][0] == '2')
   strcpy(bros,"-"); 
  if(row[7][0] == '0')
   strcat(bros,"?");
  if(row[8][0] == '0')
   strcat(bros,"*");
  if(row[14][0] == '0')
   strcat(bros,"$");
  
  rsdat(&d,&m,&g,row[1],2);
  if(metka_naim_skl == 0)  
   sprintf(str_menu,"%02d.%02d.%d|%-*s|%-*s|%-*s|%-*s|%-*s|%-*s|%-3s|%s",
   d,m,g,
   iceb_tu_kolbait(8,row[4]),row[4],
   iceb_tu_kolbait(4,row[3]),row[3],
   iceb_tu_kolbait(3,row[6]),row[6],
   iceb_tu_kolbait(2,row[2]),row[2],
   iceb_tu_kolbait(4,row[5]),row[5],
   iceb_tu_kolbait(6,row[11]),row[11],
   row[9],bros);
  if(metka_naim_skl == 1)  
   sprintf(str_menu,"%02d.%02d.%d|%-*s|%-*s|%-*s|%-*s|%-*s|%-*s|%-3s|%s|%s",
   d,m,g,
   iceb_tu_kolbait(8,row[4]),row[4],
   iceb_tu_kolbait(4,row[3]),row[3],
   iceb_tu_kolbait(3,row[6]),row[6],
   iceb_tu_kolbait(2,row[2]),row[2],
   iceb_tu_kolbait(4,row[5]),row[5],
   iceb_tu_kolbait(6,row[11]),row[11],
   row[9],bros,naim_skl);


  spis_menu.spis_str.plus(str_menu);
  i++;

  if(pozz1 == 1) /*Первая запись удовлетворяет условиям поиска*/
   mspz=1;

 }

if(kom >= i)
  kom=i-1;

if(kom < 0)
 kom=0;

if(i <=kls-1)
  spis_menu.spis_str.plus(gettext("Конец списка"));

if(i == 0)
 {
  if(kolstr != 0 && pozz != 0)
   {
    //Если записи есть но не подходят по условиям поиска
    pozz--;
    goto naz;
   }
  goto lll;
 }
shsmn(&poisk);

prc=(pozz+pozz1)*100/kolstr;
memset(strsql,'\0',sizeof(strsql));
kom=spis_menu.menu(kom,y,x,NULL,strsql,prc,&K,"",0);


if(kom == -7) //Изменение размера экрана
  goto naz1;
  
if(kom == -3) /*Стрелка вниз*/
 {
/*****************
  if(i <kls)
   {
    beep();
    goto naz;
   }
  for(i=0; i< mspz  ; )
   {
    pozz++;
    if(pozz >= kolstr)
     {
      pozz=kolstr-1;
      break;
     }
    cur.poz_cursor(pozz);
    if(cur.read_cursor(&row) == 0)
      break;

      continue;
    i++;
   }
  kom=kls-1;
  goto naz;
**********************/
  if(i <kls)
   {
    beep();
    goto naz;
   }
  GDITE();
  for(i=0; i < mspz  ; )
   {
    pozz++;
    cur.poz_cursor(pozz);
    if(cur.read_cursor(&row) == 0)
      break;

    if(sravdok(row,&poisk) != 0)
      continue;
    i++;
   }
  kom=kls;
  goto naz;




 }
if(kom == -2) /*Стрелка вверх*/
 {
  for(i=0; i < 1 ; )
   {

    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    cur.read_cursor(&row);

    if(sravdok(row,&poisk) != 0)
      continue;
    i++;
   }

  goto naz;
 }
 
if(kom == -5) /*Страница вниз*/
 {
  if(i <kls)
   {
    beep();
    goto naz;
   }
  if(pozz + kls >= kolstr)
   {
    pozz=kolstr-1;
    beep();
    goto naz;  
   }
  if(i == kls)
    pozz+=pozz1;
  else
    beep();
  if(pozz >= kolstr)
   {
    pozz=kolstr-pozz1;
    beep();
    goto naz;  
   }
  goto naz;

 }

if(kom == -4) /*Страница вверх*/
 {
  GDITE();
  for(i=0; i<kls ; )
   {
    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    if(cur.read_cursor(&row) == 0)
      break;
    if(sravdok(row,&poisk) != 0)
      continue;

    i++;
   }
  goto naz;
 }

if(kom >= 0)
 {
  if(SRAV(gettext("Конец списка"),spis_menu.spis_str.ravno(kom),0) == 0)
     goto naz;
  if(pozz+kom >= kolstr)
   goto naz;

  polen(spis_menu.spis_str.ravno(kom),bros,sizeof(bros),1,'|');
  rsdat(&dnp,&mnp,&gnp,bros,0);

  polen(spis_menu.spis_str.ravno(kom),bros,sizeof(bros),5,'|');
  skld=atoi(bros);

  polen(spis_menu.spis_str.ravno(kom),&nomdokd,2,'|');
  polen(spis_menu.spis_str.ravno(kom),kontr,sizeof(kontr),3,'|');
  polen(spis_menu.spis_str.ravno(kom),oper,sizeof(oper),4,'|');
  polen(spis_menu.spis_str.ravno(kom),skladch,sizeof(skladch),5,'|');

  polen(spis_menu.spis_str.ravno(kom),ktozap,sizeof(ktozap),8,'|');

  polen(spis_menu.spis_str.ravno(kom),bros,sizeof(bros),9,'|');
  if(bros[0] == '+')
    tipzd=1;  
  if(bros[0] == '-')
    tipzd=2;  

 }

vper:;
class iceb_tu_str kods("");
class iceb_tu_str naims("");
switch(K)
 {  
  case ENTER:
  
     clear();
     dirdok(dnp,mnp,gnp,tipzd,skld,&nomdokd);
     dnp=mnp=gnp=0;
     
     clear();
    
     goto naz1;

  case FK10:
  case ESC:
    return;

  case FK1: /*Помощь*/
    GDITE();
    iceb_t_pdoc("matu2_3.txt");
    if(kolstr > 0)
      goto naz;
    else
      goto lll;

  case FK2:  /*Не подтвержденные накладные*/
    if(poisk.mpn == 1)
      poisk.mpn=0;
    else
      poisk.mpn=1;  

    if(kolstr > 0)
      goto naz;
    else
      goto lll;

  case SFK2:  /*Снять метку не подтвержденного документа*/

    DANET.VVOD_delete();
    DANET.VVOD_SPISOK_add_MD(gettext("Снять отметку не подтвержденного документа ? Вы уверены ?"));

    if(danet(&DANET,2,stdscr) == 2)
     goto naz;

    sprintf(strsql,"update Dokummat \
set \
pod=1 \
where datd='%d-%02d-%02d' and sklad=%d and nomd='%s'",
    gnp,mnp,dnp,skld,nomdokd.ravno());

    if(sql_zap(&bd,strsql) != 0)
     {
      sprintf(strsql,"%s\n%s\n",
      gettext("Ошибка записи !"),
      sql_error(&bd));
      error2(20,0,1,strsql);
     }
    goto naz1;

  case FK3:  /*Накладные без проводок*/
    if(poisk.mpn == 2)
      poisk.mpn=0;
    else
      poisk.mpn=2;  

    if(kolstr > 0)
      goto naz;
    else
      goto lll;

  case SFK3:  /*Снять отметку о не выполненых проводках*/
    DANET.VVOD_delete();
    DANET.VVOD_SPISOK_add_MD(gettext("Снять отметку о невыполненых проводках ? Вы уверены ?"));

    if(danet(&DANET,2,stdscr) == 2)
     goto naz;


    sprintf(strsql,"update Dokummat \
set \
pro=1 \
where datd='%d-%02d-%02d' and sklad=%d and nomd='%s'",
    gnp,mnp,dnp,skld,nomdokd.ravno());

    if(sql_zap(&bd,strsql) != 0)
     {
      sprintf(strsql,"%s\n%s\n",
      gettext("Ошибка записи !"),
      sql_error(&bd));
      error2(20,0,1,strsql);
     }
    goto naz1;


  case FK4:  /*Поиск*/
    VV.VVOD_delete();
    VV.VVOD_SPISOK_add_ZAG(gettext("Введите данные для поиска документов"));

    VV.VVOD_SPISOK_add_MD(gettext("Номер документа.....(,,).."));//0
    VV.VVOD_SPISOK_add_MD(gettext("Дата начала поиска........"));//1
    VV.VVOD_SPISOK_add_MD(gettext("Дата конца поиска........."));//2
    VV.VVOD_SPISOK_add_MD(gettext("Код контрагента.....(,,).."));//3
    VV.VVOD_SPISOK_add_MD(gettext("Код прихода/расхода.(,,).."));//4
    VV.VVOD_SPISOK_add_MD(gettext("Код склада..........(,,).."));//5
    VV.VVOD_SPISOK_add_MD(gettext("Приход/расход (+/-)......."));//6
    VV.VVOD_SPISOK_add_MD(gettext("Довереность.........(,,).."));//7
    VV.VVOD_SPISOK_add_MD(gettext("Номер нал. накладной.(,,)."));//8

    VV.VVOD_SPISOK_add_data(poisk.nomdokv,sizeof(poisk.nomdokv));
    VV.VVOD_SPISOK_add_data(poisk.dat1,11);
    VV.VVOD_SPISOK_add_data(poisk.dat2,11);
    VV.VVOD_SPISOK_add_data(poisk.kps,sizeof(poisk.kps));
    VV.VVOD_SPISOK_add_data(poisk.kprrz,sizeof(poisk.kprrz));
    VV.VVOD_SPISOK_add_data(poisk.skl11,sizeof(poisk.skl11));
    VV.VVOD_SPISOK_add_data(2);
    VV.VVOD_SPISOK_add_data(poisk.dover,sizeof(poisk.dover));
    VV.VVOD_SPISOK_add_data(poisk.nomnalnak,sizeof(poisk.nomnalnak));


naz2:;
    poisk.metpoi=0;

    helstr(LINES-1,0,"F2/+",gettext("поиск"),
    "F3",gettext("реквизиты"),
    "F4",gettext("очистить"),
    "F10",gettext("выход"),NULL);
    
    kl=VV.vvod(0,1,1,-1,-1);

    switch(kl)
     {
      case FK10:
      case ESC:
        break;
        
      case FK2:
      case PLU:
        GDITE();
        strcpy(poisk.dat1,VV.VVOD_SPISOK_return_data(1));
        strcpy(poisk.dat2,VV.VVOD_SPISOK_return_data(2));
        strcpy(poisk.nomdokv,VV.VVOD_SPISOK_return_data(0));

        if(poisk.dat1[0] != '\0')
         {
          if(rsdat(&d,&m,&g,poisk.dat1,0) != 0)
           {
            SOOB.VVOD_delete();
            SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
            soobshw(&SOOB,stdscr,-1,-1,0,1);
            goto naz2;
           }
          poisk.dk=poisk.dn=d; poisk.mn=poisk.mk=m; poisk.gn=poisk.gk=g;
         }

        if(poisk.dat2[0] == '\0')
         {
          dpm(&poisk.dk,&poisk.mk,&poisk.gk,5); 
         }
        else
         if(rsdat(&d,&m,&g,poisk.dat2,0) != 0)
          {
           SOOB.VVOD_delete();
           SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конца !"));
           soobshw(&SOOB,stdscr,-1,-1,0,1);
           goto naz2;
          }
         else
          {
           poisk.dk=d; poisk.mk=m; poisk.gk=g;
          }
         

        strcpy(poisk.kps,VV.VVOD_SPISOK_return_data(3));
        strcpy(poisk.kprrz,VV.VVOD_SPISOK_return_data(4));
        strcpy(poisk.skl11,VV.data_ravno(5));
        poisk.tipzz=0;
        if(VV.VVOD_SPISOK_return_data(6)[0] == '+')
          poisk.tipzz=1;
        if(VV.VVOD_SPISOK_return_data(6)[0] == '-')
          poisk.tipzz=2;
      
        strcpy(poisk.dover,VV.VVOD_SPISOK_return_data(7));
        strcpy(poisk.nomnalnak,VV.VVOD_SPISOK_return_data(8));

        if(VV.VVOD_SPISOK_return_data(0)[0] != '\0' || VV.VVOD_SPISOK_return_data(1)[0] != '\0' || VV.VVOD_SPISOK_return_data(2)[0] != '\0' || \
        VV.VVOD_SPISOK_return_data(3)[0] != '\0' || VV.VVOD_SPISOK_return_data(4)[0] != '\0' || VV.VVOD_SPISOK_return_data(5)[0] != '\0' || \
        VV.VVOD_SPISOK_return_data(6)[0] != '\0' || VV.VVOD_SPISOK_return_data(7)[0] != '\0' || VV.VVOD_SPISOK_return_data(8)[0] != '\0')
         poisk.metpoi=1;
        pozz=0;
        goto naz1;

      case FK3:
        MENU.VVOD_delete();
        MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка складов"));
        MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка контрагентов"));
        MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций приходов"));
        MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций расходов"));
        MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

        clearstr(LINES-1,0);
        kom1=0;        
        while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

        switch (kom1)
         {
          case 4 :
          case -1:
           goto naz2;

          case 0 :
            clear();
//            memset(naimo,'\0',sizeof(naimo));
            //vibrek("Sklad",VV.VVOD_SPISOK_return_data(5),VV.VVOD_SPISOK_return_dls(5),naimo);
            if(dirsklad(1,&kods,&naims) == 0)
             VV.data_z_plus(5,kods.ravno());
            clear();
            goto naz2;

          case 1 :
            clear();
//            memset(naimo,'\0',sizeof(naimo));
//            vibrek("Kontragent",VV.VVOD_SPISOK_return_data(3),VV.VVOD_SPISOK_return_dls(3),naimo);
            if(vibrek("Kontragent",&kods) == 0)
             VV.data_plus(3,kods.ravno());
            clear();
            goto naz2;

          case 2 :
            clear();
//            memset(naimo,'\0',sizeof(naimo));
//            vibrek("Prihod",VV.VVOD_SPISOK_return_data(4),VV.VVOD_SPISOK_return_dls(4),naimo);
            if(vibrek("Prihod",&kods) == 0)
             VV.data_plus(4,kods.ravno());
            clear();
            goto naz2;

          case 3 :
            clear();
//            memset(naimo,'\0',sizeof(naimo));
//            vibrek("Rashod",VV.VVOD_SPISOK_return_data(4),VV.VVOD_SPISOK_return_dls(4),naimo);
            if(vibrek("Rashod",&kods) == 0)
             VV.data_plus(4,kods.ravno());
            clear();
            goto naz2;
         }

        clear();
        goto naz2;

      case FK4:
        VV.VVOD_clear_data();
        goto naz2;
                   
      default:
        goto naz2;
     }

    goto naz1;

  case FK5: /*Расшифровка*/

    /*Читаем наименование организации*/
    naimo[0]='\0';

    if(kontr[0] == '0' && kontr[1] == '0' && kontr[2] == '-')
      POLE(kontr,bros,1,'-');
    else
      strcpy(bros,kontr);

    sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",
    bros);
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
      beep();
      printw("\n%s %s\n",gettext("Не найден код контрагента"),kontr);
      OSTANOV();
     }
    else
     {
      strncpy(naimo,row1[0],sizeof(naimo)-1);
     } 

    /*Читаем наименование операции*/
    if(tipzd == 1)
      sprintf(bros,"Prihod");
    if(tipzd == 2)
      sprintf(bros,"Rashod");
    naimpr[0]='\0';
    sprintf(strsql,"select naik from %s where kod='%s'",
    bros,oper);
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
      beep();
      printw(gettext("Не найден код операции %s !"),oper);
      printw("\n");
      OSTANOV();
     }
    else
     {
      strncpy(naimpr,row1[0],sizeof(naimpr)-1);
     } 

    /*Читаем наименование склада*/
    naiskl[0]='\0';
    sprintf(strsql,"select naik from Sklad where kod=%s",
    skladch);
    if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
     {
      beep();
      printw(gettext("Не найден склад %d в списке складов !"),atoi(skladch));
      printw("\n");
      OSTANOV();
     }
    else
     {
      strncpy(naiskl,row1[0],sizeof(naiskl)-1);
     } 
    SOOB.VVOD_delete();
    
    sprintf(strsql,"%s %d.%d.%d",gettext("Дата докум. :"),dnp,mnp,gnp);
    SOOB.VVOD_SPISOK_add_MD(strsql);

    sprintf(strsql,"%s %s",gettext("Документ    :"),nomdokd.ravno());
    SOOB.VVOD_SPISOK_add_MD(strsql);

    sprintf(strsql,"%s %s %s",gettext("Склад       :"),skladch,naiskl);
    SOOB.VVOD_SPISOK_add_MD(strsql);             

    sprintf(strsql,"%s %s %s",gettext("Контрагент  :"),kontr,naimo);
    SOOB.VVOD_SPISOK_add_MD(strsql);

    sprintf(strsql,"%s %s %s",gettext("Операция    :"),oper,naimpr);
    SOOB.VVOD_SPISOK_add_MD(strsql);             

    if(atoi(ktozap) != 0)
     {
/************
      i1=atoi(ktozap);      
      if((ktoz=getpwuid(i1)) != NULL)
        sprintf(strsql,"%s %d %s",gettext("Записал     :"),i1,ktoz->pw_gecos);
      else
        sprintf(strsql,gettext("Неизвестный логин %d !"),i1);
****************/
      sprintf(strsql,"%s %s",gettext("Записал     :"),iceb_t_kszap(ktozap));
      SOOB.VVOD_SPISOK_add_MD(strsql);             
     }
    /*Читаем время записи*/
    sprintf(strsql,"select vrem from Dokummat where tip=%d and \
datd='%04d-%d-%d' and sklad=%s and nomd='%s'",
    tipzd,gnp,mnp,dnp,skladch,nomdokd.ravno());

    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
    if(atoi(row1[0]) > 0)
     {
      tmm=atoi(row1[0]);
      bf=localtime(&tmm);
      sprintf(strsql,"%s %d.%d.%d%s %s: %d:%d:%d",
      gettext("Дата записи :"),
      bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
      gettext("г."),
      gettext("Время"),
      bf->tm_hour,bf->tm_min,bf->tm_sec);
      SOOB.VVOD_SPISOK_add_MD(strsql);
     }
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;

  case FK6: /*Просмотр от текущего дня*/
      smdok_vk(&poisk,&cur);
      goto naz1;

  case FK7: //День назад
      poisk.metpoi=1;
      dpm(&poisk.dn,&poisk.mn,&poisk.gn,2);
      poisk.dk=poisk.dn; poisk.mk=poisk.mn; poisk.gk=poisk.gn;
      goto naz1;

  case SFK7: //День вперед
      poisk.metpoi=1;
      dpm(&poisk.dn,&poisk.mn,&poisk.gn,1);
      poisk.dk=poisk.dn; poisk.mk=poisk.mn; poisk.gk=poisk.gn;
      goto naz1;

  case FK8: /*с наименованием склада*/
    metka_naim_skl++;
    if(metka_naim_skl > 1)
     metka_naim_skl=0;
    goto naz1;

  case FK9: /*переключение просмотра оплаченных и неоплаченных документов*/
    poisk.metka_opl++;
    if(poisk.metka_opl > 2)
     poisk.metka_opl=0;
    goto naz1;
           
  default:
    if(kolstr > 0)
      goto naz;
    else
      goto lll; 
 }

}

/*******/
/*Шапка*/
/*******/
void shsmn(class smdok_poi *poisk)
{
int		i1;
int		X;
clear();

move(0,0);

if(poisk->mpn == 0)
  printw(gettext("Просмотр документов"));
if(poisk->mpn == 1)
 {
  attron(A_BLINK); /*Влючение мерцания*/
  printw(gettext("Просмотр неподтвержднных документов"));
  attroff(A_BLINK); /*Выключение мерцания*/
 }
if(poisk->mpn == 2)
 {
  attron(A_BLINK); /*Влючение мерцания*/
  printw(gettext("Просмотр документов без проводок"));
  attroff(A_BLINK); /*Выключение мерцания*/
 }
printw(" %s:%d%s",gettext("Стартовый год"),poisk->gn,
gettext("г."));

move(1,0);
printw("      1          2     3    4  5   6     7     8");

move(i1=2,X=COLS-21);
printw(gettext("Расшифровка полей:"));
move(++i1,X);
printw("1 %s",gettext("дата документа"));
move(++i1,X);
printw("2 %s",gettext("номер документа"));
move(++i1,X);
printw(gettext("3 код контрагента"));
move(++i1,X);
printw(gettext("4 код приход./расхода"));
move(++i1,X);
printw("5 %s",gettext("код склада"));
move(++i1,X);
printw(gettext("6 номер нал. накл."));
move(++i1,X);
printw(gettext("7 номер парн.докум."));
move(++i1,X);
printw(gettext("8 кто ввел"));
move(++i1,X);
printw(gettext("+/- приход/расход"));
move(++i1,X);
printw(gettext("? не подтвержден"));
move(++i1,X);
printw(gettext("* не вып-ны проводки"));
move(++i1,X);
printw("$ %s",gettext("не оплачено"));

move(i1+=2,X=COLS-21);
if(poisk->metpoi == 1)
 {
  attron(A_BLINK);
  printw(gettext("Поиск:"));
  if(poisk->nomdokv[0] != '\0')
   {
    move(++i1,X);
    printw("%s %s",gettext("Н.д."),poisk->nomdokv);
   }

  if(poisk->dn != 0)
   {
    move(++i1,X);
    printw("%s %d.%d.%d",gettext("Дата н."),poisk->dn,poisk->mn,poisk->gn);
   }

  if(poisk->dk != 0)
   {
    move(++i1,X);
    printw("%s %d.%d.%d",gettext("Дата к."),poisk->dk,poisk->mk,poisk->gk);
   }

  if(poisk->kps[0] != '\0')
   {
    move(++i1,X);
    printw("%s %s",gettext("Код кон."),poisk->kps);
   }
  if(poisk->kprrz[0] != '\0')
   {
    move(++i1,X);
    printw("%s %s",gettext("Код оп."),poisk->kprrz);
   }
  if(poisk->skl11[0] != '\0')
   {
    move(++i1,X);
    printw("%s %s",gettext("Склад"),poisk->skl11);
   }
  if(poisk->tipzz != 0)
   {
    move(++i1,X);
    if(poisk->tipzz == 1)
      printw(gettext("ТОЛЬКО ПРИХОДЫ"));
    if(poisk->tipzz == 2)
      printw(gettext("ТОЛЬКО РАСХОДЫ"));
   }
  if(poisk->dover[0] != '\0')
   {
    move(++i1,X);
    printw("%s %s",gettext("Довер."),poisk->dover);
   }  
  if(poisk->nomnalnak[0] != '\0')
   {
    move(++i1,X);
    printw("%s %s",gettext("Нал.накладная"),poisk->nomnalnak);
   }  
  attroff(A_BLINK);
 }

if(poisk->metka_opl == 1)
 {
  move(++i1,X);
  printw("%s",gettext("Только оплаченные"));
 }

if(poisk->metka_opl == 2)
 {
  move(++i1,X);
  printw("%s",gettext("Только неоплаченные"));
 }

helstr(LINES-1,0,
"F1",gettext("помощь"),
"F2"," ? ",
"F3"," * ",
"F4",gettext("поиск"),
"F5",gettext("расшифровка"),
"F6",gettext("экспорт"),
"F7",gettext("пред.день"),
"F8",gettext("расшифровка"),
"F9",gettext("оплата"),
"F10",gettext("выход"),NULL);
}

/*****************************
Проверка реквизитов поиска
Возвращяем 0- если все равно
           1-если не совпадает
*******************************/           
int sravdok(SQL_str row, //Строка для проверки
class smdok_poi *poisk)
{
short		d,m,g;
SQL_str         row1;
int		tipz1;
char		strsql[100];
char		bros[512];
short		pro,pod;

/*
printw("sravdok-mpn=%d pro=%d\n",mpn,pro);
OSTANOV();
*/
pro=atoi(row[8]);
int metka_opl=atoi(row[14]);

if(poisk->metka_opl == 1 && metka_opl != 1)
 return(1);

if(poisk->metka_opl == 2 && metka_opl != 0)
 return(1);

if(poisk->mpn == 2 && pro == 1)
   return(1);
  
pod=atoi(row[7]);
if(poisk->mpn == 1 && pod == 1)
   return(1);

if(poisk->metpoi == 0)
 return(0);
 
tipz1=atoi(row[0]);
rsdat(&d,&m,&g,row[1],2);

if(poisk->dn != 0)
 if(SRAV1(poisk->gn,poisk->mn,poisk->dn,g,m,d) < 0)
   return(1);

if(poisk->dk != 0)
 if(SRAV1(poisk->gk,poisk->mk,poisk->dk,g,m,d) > 0)
   return(1);
  
if(proverka(poisk->kps,row[3],0,0) != 0)
  return(1);

if(proverka(poisk->kprrz,row[6],0,0) != 0)
  return(1);

if(proverka(poisk->skl11,row[2],0,0) != 0)
 return(1);

if(poisk->tipzz != 0 && poisk->tipzz != tipz1)
   return(1);

if(proverka(poisk->nomdokv,row[4],0,0) != 0)
 if(proverka(poisk->nomdokv,row[11],0,0) != 0)
  return(1);

if(poisk->dover[0] != '\0')
 {
  SQLCURSOR cur1;
  /*Читаем номер доверенности*/
  sprintf(strsql,"select sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%s and nomerz=1",
  g,row[4],row[2]);
  bros[0]='\0';

  if(readkey(strsql,&row1,&cur1) == 1)
   { 
/*
    printw("row=%s\n",row1[0]);
    OSTANOV();
*/
    polen(row1[0],bros,sizeof(bros),1,'#');
    if(proverka(poisk->dover,bros,0,0) != 0)
     return(1);
   }
  else
   return(1);
 }

if(proverka(poisk->nomnalnak,row[5],0,0) != 0)
 return(1);


return(0);

}
/*************************/
/*Создание кассовых ордеров*/
/**************************/
void smdok_ko(int tipz, /*1-приходный 2-расходный*/
class smdok_poi *poisk,SQLCURSOR *cur)
{
int tipz_mat=0;
char		strsql[512];
SQL_str		row,row1;
static char	kassa[10];
static char	dat1[11];
static char	kodop[32];
int		kom=0,kom1=0;
char		kod[32];
char		naimkas[512];
char		naimop[512];
short		dko,mko,gko;
char		shetk[32];
SQLCURSOR 	cur1;
memset(naimkas,'\0',sizeof(naimkas));
memset(naimop,'\0',sizeof(naimop));
memset(kod,'\0',sizeof(kod));



VVOD VV(0);
VVOD MENU(3);

VV.VVOD_SPISOK_add_MD(gettext("Касса..........."));
VV.VVOD_SPISOK_add_MD(gettext("Дата...(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Код операции...."));

VV.VVOD_SPISOK_add_data(kassa,sizeof(kassa));
VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(kodop,sizeof(kodop));

naz:;
clear();

VV.VVOD_delete_ZAG();
VV.VVOD_SPISOK_add_ZAG(gettext("Экспорт кассовых ордеров в подсистему \"Учёт кассовых ордеров\""));
if(naimkas[0] != '\0')
  VV.VVOD_SPISOK_add_ZAG(naimkas);
if(naimop[0] != '\0')
  VV.VVOD_SPISOK_add_ZAG(naimop);

helstr(LINES-1,0,
//"F1",gettext("помощь"),
"F2/+",gettext("загруз."),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strcpy(kassa,VV.VVOD_SPISOK_return_data(0));
strcpy(dat1,VV.VVOD_SPISOK_return_data(1));
strcpy(kodop,VV.VVOD_SPISOK_return_data(2));

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
//   prosf(strsql);
   goto naz;

  case ESC:
  case FK10:
   return;

  case FK2:
  case PLU:
    break;

  case FK3:

    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка касс"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка операций"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 2 :
      case -1:
       goto naz;

      case 0 :
        memset(kod,'\0',sizeof(kod));
        vibrek("Kas",kod,sizeof(kod),naimkas);
        VV.VVOD_SPISOK_zapis_data(0,kod);
        goto naz;

      case 1 :
        memset(kod,'\0',sizeof(kod));
        if(tipz == 1)
          vibrek("Kasop1",kod,sizeof(kod),naimop);
        if(tipz == 2)
          vibrek("Kasop2",kod,sizeof(kod),naimop);
        VV.VVOD_SPISOK_zapis_data(2,kod);
        goto naz;

     }

    break;
         
  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }

//Проверяем кассу
sprintf(strsql,"select kod from Kas where kod=%s",VV.VVOD_SPISOK_return_data(0));
if(sql_readkey(&bd,strsql,&row,&cur1) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s !",gettext("Не найдена касса"),VV.VVOD_SPISOK_return_data(0));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

//Проверяем код операции
if(tipz == 1)
 sprintf(strsql,"select naik,shetkor from Kasop1 where kod='%s'",VV.VVOD_SPISOK_return_data(2));
if(tipz == 2)
 sprintf(strsql,"select naik,shetkor from Kasop2 where kod='%s'",VV.VVOD_SPISOK_return_data(2));

if(readkey(strsql,&row,&cur1) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Не найден код операции %s !"),VV.VVOD_SPISOK_return_data(2));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

memset(naimop,'\0',sizeof(naimop));
strncpy(naimop,row[0],sizeof(naimop)-1);
strncpy(shetk,row[1],sizeof(shetk)-1);

//Проверяем дату
if(rsdat(&dko,&mko,&gko,VV.VVOD_SPISOK_return_data(1),1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }


MENU.VVOD_delete();

MENU.VVOD_SPISOK_add_MD(gettext("Для каждого документа отдельный кассовый ордер"));
MENU.VVOD_SPISOK_add_MD(gettext("Все документы в один кассовый оредр"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

clearstr(LINES-1,0);
int metka_ks=0; /*0-ордер для каждого документа 1- все в одном*/
while(menu3w(stdscr,&MENU,&metka_ks,-1,-1,0) != 0);
switch (metka_ks)
 {
  case 2 :
  case -1:
   return;

 }

short vt=0;
iceb_t_poldan("Код группы возвратная тара",strsql,"matnast.alx");
vt=atoi(strsql);

class SPISOK kod_kontr;
class SPISOK koment_kontr;
class masiv_din_double suma_kontr;



char nomd[20];


char koment[512];
double suma=0.;
double sumabn=0.;
double sumkor=0.;
short d,m,g;
int lnds=0;
double kolih=0.;
double suma_nds=0.;
double suma_dok=0.;
float pnds=0.;
if(tipz == 1)
 tipz_mat=2;
else
 tipz_mat=1;
int nomer_kontr=0;
cur->poz_cursor(0);
while(cur->read_cursor(&row) != 0)
 {
  if(tipz == atoi(row[0])) /*Если приходный кассовый ордер то нам нужны расходные документы и наооборот*/
   continue;
  
  if(sravdok(row,poisk) != 0)
    continue;
  
  rsdat(&d,&m,&g,row[1],2);

  pnds=atof(row[13]);

  /*Узнаем НДС документа*/
  lnds=0;
  sprintf(strsql,"select sodz from Dokummat2 where god=%d and nomd='%s' and sklad=%s and nomerz=11",g,row[4],row[3]);

  if(readkey(strsql,&row1,&cur1) == 1)
    lnds=atoi(row1[0]);
  suma_nds=0.;
  if(lnds == 0)
   {
    /*Узнаем сумму НДС документа*/
    sprintf(strsql,"select sodz from Dokummat2 where god=%d and nomd='%s' \
and sklad=%s and nomerz=6",g,row[4],row[3]);

    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
      suma_nds=atof(row1[0]);
   }

  sumzap1(d,m,g,row[4],atoi(row[2]),&suma,&sumabn,lnds,vt,&sumkor,tipz_mat,&kolih);

  if(lnds == 0 && suma_nds == 0.)
    suma_nds=(suma+sumkor)*pnds/100.;
  
/*  printw("suma=%f sumabn=%f sumkor=%f\n",suma,sumabn,sumkor);*/
  suma_dok=suma+sumkor+suma_nds+sumabn;
    
  sprintf(koment,"%s:%.10g",gettext("Количество"),kolih);  


  if(metka_ks == 0)
   {
    lock_tables("LOCK TABLES Kasord WRITE,icebuser READ");
    nomnak(gko,kassa,nomd,tipz,2,1);
    zaphkor(0,kassa,tipz,dko,mko,gko,nomd,shetk,kodop,naimop,"","","","","",0,0,0,"","");
    printw("%s:%s\n",gettext("Кассовый ордер"),nomd);

    zapzkor(0,kassa,tipz,dko,mko,gko,nomd,row[4],suma_dok,"",koment);
   }
  else
   {
    if((nomer_kontr=kod_kontr.find_r(row[3])) < 0)
     {
      kod_kontr.plus(row[3]);
      koment_kontr.plus(koment);
     }

    suma_kontr.plus(suma_dok,nomer_kontr);


   }  

 }

if(metka_ks == 1)
 {
  lock_tables("LOCK TABLES Kasord WRITE,icebuser READ");
  nomnak(gko,kassa,nomd,tipz,2,1);
  zaphkor(0,kassa,tipz,dko,mko,gko,nomd,shetk,kodop,naimop,"","","","","",0,0,0,"","");
  printw("%s:%s\n",gettext("Кассовый ордер"),nomd);

  for(nomer_kontr=0; nomer_kontr < kod_kontr.kolih(); nomer_kontr++)
   {
    
    zapzkor(0,kassa,tipz,dko,mko,gko,nomd,kod_kontr.ravno(nomer_kontr),suma_kontr.ravno(nomer_kontr),"",koment_kontr.ravno(nomer_kontr));
   }
 }
OSTANOV();

}
/**********************/
/*Выбор типа кассового ордера*/
/*****************************/
void smdok_vk(class smdok_poi *poisk,SQLCURSOR *cur)
{
int tipz=0;
int kom=0;
VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Виберите нужное и нажми те Enter"));

MENU.VVOD_SPISOK_add_MD(gettext("Експортировать кассовые ордера для приходных документов"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Експортировать кассовые ордера для расходных документов"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//2

while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

switch (kom)
 {
  case 2:
  case -1 :
    return;

  case 0:
    tipz=2;
    break;

  case 1:
    tipz=1;
    break;
 }
smdok_ko(tipz,poisk,cur);

}
