/* $Id: sprsov1.c,v 5.25 2011-03-28 06:53:58 sasa Exp $ */
/*15.12.2009    23.11.1993      Белых А.И.    sprsov.c
Получение справки по совместителям для предоставления в налоговую
инспекцию
За период
*/
#include        <errno.h>
#include        <math.h>
#include        "buhg.h"
#include        "zar11.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif
#define 	razmerspr 43
#define		RAZMVDZ  48 //Размер массивов в структуре VDZ

struct VDZ
 {
  short denv[RAZMVDZ];       //День последней выплаты дохода в месяце
  short mesv[RAZMVDZ];       //Месяц когда был выплачен доход
  short godv[RAZMVDZ];       //Год когда был выплачен доход
  short mes[RAZMVDZ];        //Mесяц начисления зарплаты
  short god[RAZMVDZ];        //Год начисления зарплаты
  double sumana[RAZMVDZ];  //Начисленная сумма      
  double sumapod[RAZMVDZ]; //Сумма подоходного налога
  double sumabez[RAZMVDZ]; //Сумма в фонд безработицы
  double sumaobud[RAZMVDZ];  //Сумма обязательных удержаний
  double sumavid[RAZMVDZ]; //Выданная сумма в счет месяца начисления
  double sumamp[RAZMVDZ];  //Сумма материальной помощи
  int kol;                 //Количество записанных месяцев
 };

void            sprsap1(FILE *,char[],short,char[]);
void            konr1(FILE *,char[],char[],int);
void            twokol1(char[]);
int		vidzar1(long,short,short,short,short,short,short,struct VDZ*,int);
void		druksov1(char*,char*,char*,char*,char*,char*,char*,char*,\
char*,char*,char*,double,double,double,int,double,FILE*,int,double);

extern struct ZAR zar;
extern double   okrg;
extern short    kodbzr;  /*Код отчисления на безработицу*/
extern  short   mmm,ggg;
extern char     *organ;
extern short    *kodmp;   /*Коды материальной помощи*/
extern short	*obud; /*Обязательные удержания*/
//extern short     kodpn;   /*Код подоходного налога*/
extern class iceb_tu_str kodpn_all;

int sprsov1(class spis_oth *oth)
{
char            bros[512];
char            st[1024];
FILE            *f,*f1,*f2,*ffprot;
char            tn[40];
char            fam[512];
char            rab[56];
char            ins[56];
char            adr[512];
char            pasp[512];
char            mescc[35];
double          nah,nah1;
double		sumabez=0.;
long            tnno;
char            imaf[32],imaf1[32],imaf2[32],imafprot[40];
int		metkaglb=0; //Если равна 1 вместо подписи главного бухгалтера подпись директора
char            fmbuh[512];
char            telef[112];
short           np; /*Номер по порядку*/
short           mpl; /*Метка прогона листа*/
double          matdp;
int             i;
short           mvh; /*0-выдать шапку 1-нет*/
char            rajon[40];
short		kodg,kodgz;
short		kols;
char		nre[32]; /*Индивидуальный налоговый номер*/
char		kod[32];
long		kolstr,kolstr1;
SQL_str         row,row1;
char		strsql[512];
long		tbn;
short		mn,gn;
short		mk,gk;
static char     datvp[300];
static char     dat1[8];
static char     dat2[8];
static char	tabnom[112];
static char	kodkontp[112];
char		naimp[512];
short		metkap; /*1-в двеколонки 2-нет*/
double		koefvid=0.; //Коэффициент полноты выплаты зарплаты
struct VDZ 	sov;
int		i2;
int		sovmest=0;
char		shethp[112];
short		dp,mp,gp;
double		dohod=0.;
int		kom1=0;
class iceb_tu_str fiov("");
SQLCURSOR curr;
tnno=0;
VVOD VV(0);
VVOD MENU(3);

VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2));
VV.VVOD_SPISOK_add_data(tabnom,sizeof(tabnom));
VV.VVOD_SPISOK_add_data(kodkontp,sizeof(kodkontp));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала....(м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца.....(м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Табельний номер.(,,).."));
VV.VVOD_SPISOK_add_MD(gettext("Код контрагента.(,,).."));

VV.VVOD_SPISOK_add_ZAG(gettext("Получение справки и реестра выплат по совместителям."));

sprintf(strsql,"%s %d.%d%s",gettext("Текущая дата"),mmm,ggg,
gettext("г."));

VV.VVOD_SPISOK_add_ZAG(strsql);
VV.VVOD_SPISOK_add_ZAG(gettext("Если табельний номер не вводится, расчет выполняется по всем совместителям."));

naz:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

i=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(tabnom,VV.VVOD_SPISOK_return_data(2),sizeof(tabnom));
strncpy(kodkontp,VV.VVOD_SPISOK_return_data(3),sizeof(kodkontp));

switch(i)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp4_3_8.txt");
   goto naz;

  case FK2:
  case PLU:
   break;
  case FK10:
   return(1);

  case FK3:

    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка работников."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка контрагентов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 2 :
      case -1:
       goto naz;


      case 0:
       {
        fiov.new_plus("");
        int tmm=0;
        if(dirtab(&tmm,&fiov,0,1) == 0)
         {
          if(tabnom[0] == '\0')
            sprintf(tabnom,"%d",tmm);
          else
           {
            if(strlen(tabnom)+strlen(kod)+1 < sizeof(tabnom)-1)
             {
              strcat(tabnom,",");
              sprintf(bros,"%d",tmm);
              strcat(tabnom,bros);
             }
           }
          VV.VVOD_SPISOK_zapis_data(1,tabnom);
          goto naz;
         }
        break;
      }
      
      case 1 :
        naimp[0]='\0';   
        if(vibrek("Kontragent",kodkontp,sizeof(kodkontp),naimp) == 0)
          VV.VVOD_SPISOK_zapis_data(2,kodkontp);
        break;
     }

   goto naz;   

  case FK4:
    VV.VVOD_clear_data();
    goto naz;
      
  default:
   goto naz;
 }

if(rsdat1(&mn,&gn,dat1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(rsdat1(&mk,&gk,dat2) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конца !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

VVOD DANET(1);

DANET.VVOD_SPISOK_add_MD(gettext("Распечатать справку в две колонки ?"));

metkap=danet(&DANET,2,stdscr);

clear();
printw("%s\n",gettext("Получение справки и реестра выплат по совместителям."));
printw("%s:%d.%d%s => %d.%d%s\n",
gettext("Дата"),
mn,gn,gettext("г."),
mk,gk,gettext("г."));

GDITE();

sprintf(strsql,"select distinct tabn from Zarn where god >= %d and mes >= %d and \
god <= %d and mes <= %d ",gn,mn,gk,mk);

SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %d.%d%s => %d.%d%s !",
  gettext("Не найдено ни одного совместителя"),
  mn,gn,gettext("г."),
  mk,gk,gettext("г."));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

sprintf(imaf2,"sovm%d.tmp",getpid());
if((f = fopen(imaf2,"w")) == NULL)
 {
  error_op_nfil(imaf2,errno,"");
  return(1);
 }

kols=0;
kolstr1=0;

if(tabnom[0] != '\0' || kodkontp[0] == '\0')
while(cur.read_cursor(&row) != 0)
 {
//  printw("%s\n",row[0]);
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(proverka(tabnom,row[0],0,0) != 0)
   continue;

  tbn=atol(row[0]);

  if(vidzar1(tbn,1,mn,gn,31,mk,gk,&sov,1) != 0)
   {
//    printw("Немає нарахувань.\n");
    continue;
   }

  sovmest=0;

  for(i2=0; i2 < sov.kol ; i2++)
   {
    //Проверяем был ли совместителем в месяце начисления 
    sprintf(strsql,"select sovm from Zarn where tabn=%ld and god=%d \
and mes=%d and sovm=1",tbn,sov.god[i2],sov.mes[i2]);
    if(sql_readkey(&bd,strsql) <= 0)
      continue;
    sovmest++;
   }

  if(sovmest == 0)
    continue;

  sprintf(strsql,"select inn,adres,nomp,vidan,harac,kodg,fio from Kartb \
where tabn=%ld",tbn);
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %ld !",gettext("Не найден табельный номер"),tbn);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    continue;
   }

  kodg=atoi(row1[5]);
  memset(fam,'\0',sizeof(fam));
  strncpy(fam,row1[6],sizeof(fam)-1);
  /*Индивидуальный налоговый номер*/

  memset(nre,'\0',sizeof(nre));
  strncpy(nre,row1[0],sizeof(nre)-1);

  /*Адрес*/
  memset(adr,'\0',sizeof(adr));
  if(POLE(row1[1],bros,1,'$') == 0)
   {
    sprintf(adr,"%s ",bros);
    POLE(row1[1],bros,2,'$');
    strcat(adr,bros);
   }
  else
    strncpy(adr,row1[1],sizeof(adr)-1);

  /*Номер паспорта*/
  memset(tn,'\0',sizeof(tn));
  strncpy(tn,row1[2],sizeof(tn)-1);

  /*Выдан*/

  memset(pasp,'\0',sizeof(pasp));
  if(POLE(row1[3],bros,1,'$') == 0)
   {
    if(bros[0] != '\0')
     {
      sprintf(pasp,"%s ",bros);
      POLE(row1[3],bros,2,'$');
      strcat(pasp,bros);
     }
   }
  else
    strncpy(pasp,row1[3],sizeof(pasp)-1);

  /*Работа*/

  memset(rab,'\0',sizeof(rab));
  strncpy(rab,row1[4],sizeof(rab)-1);

  /*Город нал. испекции*/

  if(kodg != 0)
   {
    sprintf(strsql,"select naik from Gnali where kod=%d",kodg);
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s %d %s %ld",
      gettext("Не найден код города налоговой инспекции"),
      kodg,gettext("для"),tbn);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
     }
   }
  else
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %ld",
    gettext("Не введен код города налоговой инспекции для"),
    tbn);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }

  if(kodg != 0)
   {
    kols++;
    fprintf(f,"%d|%.39s|%ld|%s|%s|%s %s|%s|\n",kodg,fam,tbn,rab,adr,tn,pasp,nre);
   }
 }

GDITE();

shethp[0]='\0';
iceb_t_poldan("Счет учета частных предпринимателей",shethp,"zarnast.alx");
printw("Счет учета частных предпринимателей:%s\n",shethp);
refresh();
if(shethp[0] != '\0' && (tabnom[0] == '\0' || kodkontp[0] != '\0'))
 {
  SPISOK  kontr(0); //Список контрагентов
  SPISOK  datp(0);  //Список дат платежей
  char   naikont[512];
  
  //Смотрим частных предпринимателей
  sprintf(strsql,"select kodkon from Kontragent where regnom <> ''");

  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

  double debet[kolstr];
  memset(&debet,'\0',sizeof(debet));
  kolstr1=0;
  while(cur.read_cursor(&row) != 0)
   {
    strzag(LINES-1,0,kolstr,++kolstr1);
    if(proverka(kodkontp,row[0],0,0) != 0)
      continue;

    kontr.plus(row[0]);
    datp.plus(11);
   }
  GDITE();
  spdfo(1,mn,gn,31,mk,gk,&kontr,&datp,debet,shethp);

  for(int nm=0; nm < kolstr; nm++)
   {  

    if((nah=debet[nm]) == 0.)
     continue;

    sprintf(strsql,"select naikon,kod,adres from Kontragent \
where kodkon='%s'",kontr.ravno(nm));
    if(sql_readkey(&bd,strsql,&row,&curr) != 1)
      continue;

    memset(naikont,'\0',sizeof(naikont));
    strncpy(naikont,row[0],sizeof(naikont)-1);
    
    memset(nre,'\0',sizeof(nre));
    strncpy(nre,row[1],sizeof(nre)-1);

    memset(adr,'\0',sizeof(adr));
    strncpy(adr,row[2],sizeof(adr)-1);

    printw("%s %s %.2f\n",kontr.ravno(nm),naikont,nah);
    refresh();
    
    if(nre[0] == '\0')
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s ЧП %s",
      gettext("Не найден идентификационный номер"),
      kontr.ravno(nm));
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      continue;
     }
         
    memset(pasp,'\0',sizeof(pasp));
    sprintf(strsql,"select zapis from Kontragent1 where kodkon='%s' \
  and zapis like 'Паспорт выдан%%'",kontr.ravno(nm));
    if(sql_readkey(&bd,strsql,&row1,&curr) > 0)
      polen(row1[0],pasp,sizeof(pasp),2,'|');


    memset(tn,'\0',sizeof(tn));
    sprintf(strsql,"select zapis from Kontragent1 where kodkon='%s' \
  and zapis like 'Номер паспорта%%'",kontr.ravno(nm));
    if(sql_readkey(&bd,strsql,&row1,&curr) > 0)
      polen(row1[0],tn,sizeof(tn),2,'|');

    kodg=0;
    sprintf(strsql,"select zapis from Kontragent1 where kodkon='%s' \
  and zapis like 'Код города налоговой инспекции%%'",kontr.ravno(nm));
    if(sql_readkey(&bd,strsql,&row1,&curr) > 0)
     {
      polen(row1[0],bros,sizeof(bros),2,'|');
      kodg=atoi(bros);
     }
    if(kodg != 0)
     {
      sprintf(strsql,"select naik from Gnali where kod=%d",kodg);
      if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
       {
        VVOD SOOB(1);
        sprintf(strsql,"%s %d %s ЧП %s",
        gettext("Не найден код города налоговой инспекции"),
        kodg,gettext("для"),kontr.ravno(nm));
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        continue;
       }
     }
    else
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s ЧП %s",
      gettext("Не введен код города налоговой инспекции для"),
      kontr.ravno(nm));
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      continue;
     }
    rsdat(&dp,&mp,&gp,datp.ravno(nm),2);
    kols++;
    fprintf(f,"%d|%.*s|0|%s|%s|%s %s|%s|%.2f|%d|\n",
    kodg,
    iceb_tu_kolbait(39,naikont),naikont,
    "За товари та послуги.",adr,tn,pasp,nre,nah,dp);

   }
 }


fclose(f);
if(kols == 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %d.%d%s => %d.%d%s !",
  gettext("Не найдено ни одного совместителя"),
  mn,gn,gettext("г."),
  mk,gk,gettext("г."));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  unlink(imaf2);
  return(1);
 }
memset(fmbuh,'\0',sizeof(fmbuh));
bros[0]='\0';
iceb_t_poldan("Табельный номер бухгалтера",bros,"zarnast.alx");

/*Читаем фамилию*/
if(bros[0] != '\0')
 {
  sprintf(strsql,"select fio from Kartb where tabn=%s",bros);
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,gettext("Не найдена карточка %s главного бухгалтера !"),bros);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    fmbuh[0]='\0';
   }
  else
   strncpy(fmbuh,row1[0],sizeof(fmbuh)-1);
 }
else
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введен табельний номер главного бухгалтера !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);

  fmbuh[0]='\0';
  metkaglb=1;
  bros[0]='\0';
  iceb_t_poldan("Табельный номер руководителя",bros,"zarnast.alx");
  if(bros[0] != '\0')
   {
    sprintf(strsql,"select fio from Kartb where tabn=%s",bros);
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Не найдена карточка %s руководителя !"),bros);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      fmbuh[0]='\0';
     }
    else
     strncpy(fmbuh,row1[0],sizeof(fmbuh)-1);
   }
  else
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не введен табельний номер руководителя !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    fmbuh[0]='\0';
   } 
 }

memset(telef,'\0',sizeof(telef));
memset(kod,'\0',sizeof(kod));

sprintf(bros,"select telef,kod from Kontragent where kodkon='00'");
if(sql_readkey(&bd,bros,&row,&curr) == 1)
 {
  strncpy(telef,row[0],sizeof(telef)-1);
  strncpy(kod,row[1],sizeof(kod)-1);
 }
else
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найден код контрагента 00 !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }

sprintf(bros,"sort -o %s %s",imaf2,imaf2);
runsystem(bros);

if((f = fopen(imaf2,"r")) == NULL)
 {
  error_op_nfil(imaf2,errno,"");
  return(1);
 }

sprintf(imaf,"sovm%d.lst",getpid());

if((f1 = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

sprintf(imaf1,"sovr%d.lst",getpid());

if((f2 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return(1);
 }
sprintf(imafprot,"sovpr%d.lst",getpid());
if((ffprot = fopen(imafprot,"w")) == NULL)
 {
  error_op_nfil(imafprot,errno,"");
  return(1);
 }

fprintf(ffprot,"Протокол хода расчета справок на совместителей.\n");

//mesc(mz,0,mescc);
if(mn < 4)
 sprintf(mescc,"перший квартал");
if(mn >= 4 && mn <= 6)
 sprintf(mescc,"другий квартал");
if(mn >= 7 && mn <= 9)
 sprintf(mescc,"третій квартал");
if(mn >= 10)
 sprintf(mescc,"четвертий квартал");

/*fprintf(f1,"Распечатка по всем совместителям.\n");*/

fprintf(f2,"\x1b\x6C%c",8); /*Установка левого поля*/

fprintf(f2,"\x0F");
kodgz=mvh=mpl=np=0;
while(fgets(st,sizeof(st),f) != (char) NULL )
 {
//  printw("%s",st);
  memset(tn,'\0',sizeof(tn));
  if(POLE(st,bros,1,'|') != 0)
    continue;

  kodg=atoi(bros);

  polen(st,fam,sizeof(fam),2,'|');

  if(POLE(st,bros,3,'|') == 0)
    tnno=(long)atof(bros);


  printw("%ld %s\n",tnno,fam);
  refresh();
  
  sprintf(strsql,"select naik from Gnali where kod=%d",kodg);
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"*%s %d %s %ld",
    gettext("Не найден код города налоговой инспекции"),
    kodg,gettext("для"),tnno);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    continue;
   }

  strncpy(rajon,row1[0],sizeof(rajon)-1);    
  strncpy(ins,row1[0],sizeof(ins)-1);    

  POLE(st,rab,4,'|');
  memset(adr,'\0',sizeof(adr));
  POLE(st,adr,5,'|');

  memset(pasp,'\0',sizeof(pasp));
  POLE(st,pasp,6,'|');
  POLE(st,nre,7,'|');

  if(tnno != 0)
   {
    if(vidzar1(tnno,1,mn,gn,31,mk,gk,&sov,0) != 0)
     {
      printw("Немає нарахувань.\n");
      continue;
     }

    fprintf(ffprot,"\n%ld %s:\n",
    tnno,fam);
    memset(datvp,'\0',sizeof(datvp));
    sumabez=dohod=matdp=nah=nah1=0.;
    short mesz=0;
    for(i2=0; i2 < sov.kol ; i2++)
     {
      //Проверяем был ли совместителем в месяце начисления 
      sprintf(strsql,"select sovm from Zarn where tabn=%ld and god=%d \
and mes=%d and sovm=1",tnno,sov.god[i2],sov.mes[i2]);
//      printw("%s\n",strsql);
//      OSTANOV();
      if(sql_readkey(&bd,strsql,&row,&curr) <= 0)
        continue;
              
      koefvid=sov.sumavid[i2]/(sov.sumana[i2]+sov.sumaobud[i2]);
      koefvid=fabs(koefvid);
      double dohodz=sov.sumana[i2]+sov.sumaobud[i2];
      fprintf(ffprot,"\n\
Дата выплаты    зарплаты      :%d.%d\n\
Дата начисления зарплаты      :%d.%d\n\
День последней выдачи зарплаты:%d\n\
Сумма материальной помощи     :%8.2f\n\
Сумма подоходного налога      :%8.2f\n\
Сумма в фонд безработицы      :%8.2f\n\
Начисленная сумма             :%8.2f\n\
Сумма обязательных удержаний  :%8.2f\n\
                              :%8.2f\n\
Выданная сумма                :%8.2f\n\
Коэффициент выдачи            :%f\n",
      sov.mesv[i2],sov.godv[i2],
      sov.mes[i2],sov.god[i2],
      sov.denv[i2],
      sov.sumamp[i2],
      sov.sumapod[i2],
      sov.sumabez[i2],
      sov.sumana[i2],
      sov.sumaobud[i2],
      dohodz,
      sov.sumavid[i2],
      koefvid);
      if(dohodz - sov.sumavid[i2] < 0.)
       {
        VVOD SOOB(1);
        sprintf(strsql,"%ld %s",tnno,fam);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        SOOB.VVOD_SPISOK_add_MD("Выплачено больше чем положенная сумма к выплате !");
        sprintf(strsql,"%d.%dг. %.2f > %.2f",sov.mes[i2],sov.god[i2],dohodz,sov.sumavid[i2]);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        continue;
       }

//      mesc(sov.mes[i2],0,mesqc);

      nah1+=sov.sumana[i2]*koefvid;
      nah+=sov.sumapod[i2]*koefvid*-1;
      sumabez+=sov.sumabez[i2]*koefvid*-1;
      
      dohod+=dohodz*koefvid;
      matdp+=sov.sumamp[i2]*koefvid;
      if(mesz != sov.mesv[i2])
       {
        sprintf(strsql,"%d.%d.%d ",sov.denv[i2],sov.mesv[i2],sov.godv[i2]);
        strcat(datvp,strsql);
        mesz=sov.mesv[i2];
       }
     }

    druksov1(fmbuh,datvp,kod,telef,ins,mescc,nre,fam,
    adr,rab,pasp,nah,nah1,matdp,metkap,dohod,f1,metkaglb,sumabez);

    //Чтобы не выдавала шапку на совместителях у которых ничего не начислено
    if(kodgz != kodg)
     {
      if(kodgz != 0)
       {
        konr1(f2,fmbuh,datvp,metkaglb);
        fprintf(f2,"\f");
       }

      mvh=0;
      mpl++;
      kodgz=kodg;
     }

    np++;

    if(mvh == 0)
     {
      sprsap1(f2,mescc,ggg,rajon);
      np=1;
      mvh=1;
     }
    fprintf(f2,"\n%3d %-*.*s %-*.*s %15.2f %10.2f %13.2f\n",
    np,
    iceb_tu_kolbait(30,fam),iceb_tu_kolbait(30,fam),fam,
    iceb_tu_kolbait(40,adr),iceb_tu_kolbait(40,adr),adr,
    nah1,nah,matdp);

    for(int nom=40; nom < iceb_tu_strlen(adr); nom+= 40)
      fprintf(f2,"%3s %30s %s\n",
      " "," ",
      iceb_tu_adrsimv(nom,adr));

    continue;
   }
  else
   {
    polen(st,bros,sizeof(bros),8,'|');
    dohod=atof(bros);    
    nah1=0.;
    nah=0.;
    polen(st,bros,sizeof(bros),9,'|');
    dp=atoi(bros);
    matdp=0.;
    memset(datvp,'\0',sizeof(datvp));
    
    druksov1(fmbuh,datvp,kod,telef,ins,mescc,nre,fam,
    adr,rab,pasp,nah,nah1,matdp,metkap,dohod,f1,metkaglb,0);
   }



  //Чтобы не выдавала шапку на совместителях у которых ничего не начислено
  if(kodgz != kodg)
   {
    if(kodgz != 0)
     {
      konr1(f2,fmbuh,datvp,metkaglb);
      fprintf(f2,"\f");
     }

     mvh=0;
     mpl++;
     kodgz=kodg;
   }

  if(dohod == 0. && nah == 0. && matdp == 0.)
    continue;

  np++;

  if(mvh == 0)
   {
    sprsap1(f2,mescc,ggg,rajon);
    np=1;
    mvh=1;
   }

  fprintf(f2,"\n%3d %-*.*s %-*.*s %15.2f %10.2f %13.2f\n",
  np,
  iceb_tu_kolbait(30,fam),iceb_tu_kolbait(30,fam),fam,
  iceb_tu_kolbait(40,adr),iceb_tu_kolbait(40,adr),adr,
  dohod,nah,matdp);

  for(int nom=40; nom < iceb_tu_strlen(adr); nom+= 40)
    fprintf(f2,"%3s %30s %s\n",
    " "," ",
    iceb_tu_adrsimv(nom,adr));

 }
if(mvh != 0)
  konr1(f2,fmbuh,datvp,metkaglb);

fclose(f);

fclose(f1);

podpis(f2);
fclose(f2);

fclose(ffprot);
unlink(imaf2);

if(metkap == 1)
  twokol1(imaf);

printw("\n%s - %d\n",gettext("Количество реестров"),mpl);
printw("%s %s\n",gettext("Реестр выгружено в файл"),imaf1);
printw("%s %s\n\n",gettext("Справки выгружены в файл"),imaf);
OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Справки по совместителям."));
oth->spis_imaf.plus(imaf1);
oth->spis_naim.plus(gettext("Реестр справок"));
oth->spis_imaf.plus(imafprot);
oth->spis_naim.plus(gettext("Протокол расчёта"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),1);

return(0);

}

/********/
/*Шапка */
/********/
void            sprsap1(FILE *f2,char mescc[],short ggg,char tn[])
{
fprintf(f2,"%s\n\n\
						Р е є с т р\n\n\
			   довiдок, поданих Державнiй податковiй iнспекцiї по %s\n\n\
			   про суму виплаченого доходу i утриманого податку не за мiсцем основної\n\n\
			   роботи, в т. ч. за сумiсництвом та цивiльно-правових договорах.\n\n\
					    за %s %dр.\n\n",organ,tn,mescc,ggg);
fprintf(f2,"\
---------------------------------------------------------------------------------------------------------------------\n\
 N | Прiзвище, ім'я, по-батьковi  |            А д р е с а                 |    Дохiд      | Податок  |В тому числi |\n\
   |                              |                                        |               |          |мат. допомога|\n\
---------------------------------------------------------------------------------------------------------------------\n");
}

/***********************/
void            konr1(FILE *f2,char fmbuh[],char datvp[],int metkaglb)
{
fprintf(f2,"\n\
--------------------------------------------------------------------------------------------------------------------\n\n\n");
if(metkaglb == 0)
  fprintf(f2,"\
	   М.П.             Головний бухгалтер____________________/%s/\n\n",fmbuh);
if(metkaglb == 1)
  fprintf(f2,"\
	   М.П.             Директор____________________/%s/\n\n",fmbuh);

//fprintf(f2,"\nВиплата здiйснена %s\n",datvp);
}
/********************************/
/*Создание файла из двух колонок*/
/********************************/
void            twokol1(char imaf[])
{
FILE            *f2,*f1;
char            kol1[50][80];
char            kol2[50][80];
short           i,i1;
short           mmm;
char		imafiltmp[30];
mmm=0;

if((f2 = fopen(imaf,"r")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

sprintf(imafiltmp,"sov%d.tmp",getpid());
if((f1 = fopen(imafiltmp,"w")) == NULL)
 {
  error_op_nfil(imafiltmp,errno,"");
  return;
 }


for(i1=0;;i1++)
 {

  memset(kol1,'\0',sizeof(kol1));
  memset(kol2,'\0',sizeof(kol2));

  for(i=0; i < razmerspr; i++)
   {
    if(FGETSS(kol1[i],sizeof(kol1[0]),f2) == 0)
      goto kon;
   }

  for(i=0; i < razmerspr; i++)
   {
    if(FGETSS(kol2[i],sizeof(kol2[0]),f2) == 0)
      goto kon;
   }

  if(i1 > 0)
   fprintf(f1,"\f");

  mmm=1;

  for(i=0; i<razmerspr ;i++)
   fprintf(f1,"%-*s %s\n",iceb_tu_kolbait(100,kol1[i]),kol1[i],kol2[i]);

 }

kon:;

  if(strlen(kol1[2]) != 0 )
  if(mmm == 1)
   fprintf(f1,"\f");

for(i=0; i<razmerspr ;i++)
 {

  if(strlen(kol1[2]) == 0 && i == 0)
    break;

//  fprintf(f1,"%-100s %s\n",kol1[i],kol2[i]);
  fprintf(f1,"%-*s %s\n",iceb_tu_kolbait(100,kol1[i]),kol1[i],kol2[i]);
 }


fclose(f1);
fclose(f2);
rename(imafiltmp,imaf);
}
/**********************************************
Определение в счет каких месяцев была выдача, сумму начисленной
зарплаты, к выдаче в этих месяцах
Если вернули 0 выдача была 
             1-нет
**********************************************/
int	vidzar1(long tabn, //Табельный номер
short dn,short mn,short gn, //Месяц начала
short dk,short mk,short gk, //Месяц конца
struct VDZ *sov, //Структура данных
int metkar) //0-смотрим все 1-смотрим только выдачу
{
short	dd,mm,gg;
int     knah=0;
double  sym=0.,sumi=0.;
short   mz=0,gz=0;
int	kolstr;
char	strsql[512];
SQL_str	row;
int	i2;

//Смотрим в счет каких месяцев и сколько выдано

memset(sov,'\0',sizeof(*sov));

sprintf(strsql,"select datz,knah,suma,mesn,godn from Zarp where \
datz >= '%d-%02d-%d' and datz <= '%d-%02d-%d' and tabn=%ld and prn='2' \
and suma <> 0. order by datz asc",
gn,mn,dn,gk,mk,dk,tabn);

SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,"vidzar1-Ошибка создания курсора.",strsql);
  return(1);
 }
if(kolstr == 0)
 return(1);
 
while(cur.read_cursor(&row) != 0)
 {
  
  knah=atoi(row[1]);

  if(provkod(obud,knah) >= 0)
    continue;
//  printw("%s %s %s %s %s\n",row[0],row[1],row[2],row[3],row[4]);

  sym=atof(row[2]);
  if(sym > 0.)
    continue;

  rsdat(&dd,&mm,&gg,row[0],2);
  mz=atoi(row[3]);
  gz=atoi(row[4]);

  for(i2=0; i2 < RAZMVDZ ; i2++)
   {
    if(sov->mes[i2] == 0 || \
    (sov->mes[i2] == mz && sov->god[i2] == gz && \
     sov->mesv[i2] == mm && sov->godv[i2] == gg))
     {
      if(sov->mes[i2] == 0)
        sov->kol++;

      sov->mes[i2]=mz;
      sov->god[i2]=gz;
      sov->sumavid[i2]+=sym;
      sumi+=sym;
      sov->denv[i2]=dd;
      sov->mesv[i2]=mm;
      sov->godv[i2]=gg;
      break;
     }
   }

 }

if(sumi == 0.)
  return(1);
if(metkar == 1)
  return(0);

sumi=0.;

//Определяем начисленную сумму и сумму обязательных удержаний
for(i2=0; i2 < sov->kol ; i2++)
 {

  sprintf(strsql,"select prn,knah,suma from Zarp where \
datz >= '%d-%02d-01' and datz <= '%d-%02d-31' and tabn=%ld and \
suma <> 0. order by prn,knah asc",
  sov->god[i2],sov->mes[i2],sov->god[i2],sov->mes[i2],tabn);
//  printw("%s\n",strsql);

  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,"vidzar1-2 Ошибка создания курсора.",strsql);
    continue;
   }

  sumi=0.;
  while(cur.read_cursor(&row) != 0)
   {
//    printw("%s %s %s\n",row[0],row[1],row[2]);
    knah=atoi(row[1]);
    sym=atof(row[2]);
    if(atoi(row[0]) == 1)
     {
      sumi+=sym;
      sov->sumana[i2]+=sym;
      if(provkod(kodmp,knah) >= 0)
       {
         sov->sumamp[i2]+=sym;
//        printw("\nМатериальная помощь:%.2f\n",sym);
//        OSTANOV();
       }         
     }
    else
     {
//      if(knah == kodpn)
      if(proverka(kodpn_all.ravno(),knah,0,1) == 0)
        sov->sumapod[i2]+=sym;

      if(knah == kodbzr)
        sov->sumabez[i2]+=sym;

      if(provkod(obud,knah) >= 0)
       {      
        sov->sumaobud[i2]+=sym;
       }
//      printw("sov->sumaobud=%f sym=%f\n",sov->sumaobud[i2],sym);


     }    
   }

  if(sumi == 0.)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %ld",gettext("Табельный номер"),tabn);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    sprintf(strsql,"vidzar1 %s %d.%d%s %s !",
    gettext("В счет"),
    sov->mes[i2],sov->god[i2],gettext("г."),
    gettext("есть выплаты, а начислений в этом месяце нет"));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }  

 }
//OSTANOV();
return(0);
}
/********************/
/*Распечатка справки*/
/********************/
void	druksov1(char *fmbuh,char *datvp,
char *kod,
char *telef,
char *ins,
char *mesqc,
char *nre,
char *fam,
char *adr,
char *rab,
char *pasp,
double nah, //Сумма подоходного налога
double nah1, //Сумма начисленного дохода
double matdp,
int metkap,
double dohod, //Сумма полученного дохода
FILE *f1,
int metkaglb, //0-подпись гл.бухгалтера 1-руководителя
double sumabez) //Сумма отчисления в фонд безработицы
{
char	str[300];
      
   fprintf(f1,"\
\n\n\
    Штамп пiдприємства               ----------------------\n\
(назва, код юридичної особи за       |вхiдний N__________ |\n\
%s ЄДРПОУ, номер телефону)            |по алфавiту N______ |\n\
%s                                    ----------------------\n\
Код ЄДРПОУ %s\n\
т.%s\n\
%s                             Державнiй податковiй iнспекцiї\n\
%s                             по %s\n\
\n\
%25sДовiдка\n\
про суму виплаченого доходу i утриманого податку за %s %dр.\n\
не за мiсцем основної роботи, в т.ч. за сумicництвом та по\n\
             цивiльно-правових договорах.\n\
\n\
                       Ідентифікаційний номер %s\n\
----------------------------------------------------------------\n\
|   |                |                                         |\n\
| 1 | Прiзвище, iм'я | %-*.*s|\n\
|   | та по-батьковi |                                         |\n",
" "," ",kod,telef," "," ",ins," ",mesqc,ggg,nre,
    iceb_tu_kolbait(40,fam),iceb_tu_kolbait(40,fam),fam);

    memset(str,'\0',sizeof(str));
     
    slstr(adr,40,str);

    fprintf(f1,"\
| 2 | Адреса постiй- | %-*.*s|\n",iceb_tu_kolbait(40,str),iceb_tu_kolbait(40,str),str);

    if(iceb_tu_strlen(str) > 40)
     {
//      fprintf(f2,"%3s %30s %s\n"," "," ",&str[40]);
      fprintf(f1,"\
|   | ного мiсця про-| %-*.*s|\n",
      iceb_tu_kolbait(40,iceb_tu_adrsimv(40,str)),
      iceb_tu_kolbait(40,iceb_tu_adrsimv(40,str)),
      iceb_tu_adrsimv(40,str) );
     }
    else
     {
      fprintf(f1,"\
|   | ного мiсця про-| %-40.40s|\n"," ");
     }

    if(iceb_tu_strlen(str) > 80)
     {
//      fprintf(f2,"%3s %30s %s\n"," "," ",&str[80]);
      fprintf(f1,"\
|   | живання        | %-*.*s|\n",
      iceb_tu_kolbait(40,iceb_tu_adrsimv(80,str)),
      iceb_tu_kolbait(40,iceb_tu_adrsimv(80,str)),
      iceb_tu_adrsimv(80,str) );
     }
    else
      fprintf(f1,"\
|   | живання        | %-40.40s|\n"," ");

    if(nah1 != 0.)
      fprintf(f1,"\
| 3 | Сумма  нарахова-| %-40.2f|\n",nah1);
    else
      fprintf(f1,"\
| 3 | Сумма  нарахова-| %40s|\n"," ");


    if(matdp == 0.)
      fprintf(f1,"\
|   | ного доходу (в |                                         |\n");

    if(matdp != 0.)
      fprintf(f1,"\
|   | ного доходу (в | Мат. допомога в т.ч. %-19.2f|\n",matdp);

    if(nah != 0.)
      fprintf(f1,"\
|   | грн.) за кварт.|                                         |\n\
| 4 | Сумма  утриман- | %-40.2f|\n\
|   | ного податку   |                                         |\n\
|   |  (грн)         |                                         |\n",
    nah);
    else
      fprintf(f1,"\
|   | грн.) за кварт.|                                         |\n\
| 4 | Сумма  утриман- | %40s|\n\
|   | ного податку   |                                         |\n\
|   |  (грн)         |                                         |\n",
    " ");

    fprintf(f1,"\
| 5 |Сумма виплаченого| %-40.2f|\n\
|   |    доходу.     |                                         |\n\
|   |Дата виплати.   | %-40.40s|\n",
    dohod,datvp);

    fprintf(f1,"\
| 6 | За що (роботи, | %-*.*s|\n\
|   | послуги та iн.)|                                         |\n\
|   | зроблено вип-  |                                         |\n\
|   |  лату          |                                         |\n",
    iceb_tu_kolbait(40,rab),iceb_tu_kolbait(40,rab),rab);

    memset(str,'\0',sizeof(str));
    slstr(pasp,40,str);

    fprintf(f1,"\
| 7 | Додаткові      | %-*.*s|\n",iceb_tu_kolbait(40,str),iceb_tu_kolbait(40,str),str);

    if(iceb_tu_strlen(str) > 40)
     fprintf(f1,"\
|   | відомості      | %-*.*s|\n",
      iceb_tu_kolbait(40,iceb_tu_adrsimv(40,str)),
      iceb_tu_kolbait(40,iceb_tu_adrsimv(40,str)),
      iceb_tu_adrsimv(40,str) );
    else
     fprintf(f1,"\
|   | відомості      |                                         |\n");

    if(sumabez != 0.)    
     {
      sprintf(str,"Ф.Б. %.2f",sumabez);
      fprintf(f1,"\
|   |                | %-*.*s|\n",iceb_tu_kolbait(40,str),iceb_tu_kolbait(40,str),str);
     }
    else
      fprintf(f1,"\
|   |                |                                         |\n");

    fprintf(f1,"\
----------------------------------------------------------------\n\n");

    if(metkaglb == 0)
     fprintf(f1,"\
  М.П.   Головний бухгалтер_____________/%s/\n",fmbuh);
    if(metkaglb == 1)
     fprintf(f1,"\
  М.П.   Директор__________________/%s/\n",fmbuh);

    if(metkap == 2)
     fprintf(f1,"\f");

}
