/*$Id: sprtab.c,v 5.24 2011-01-13 13:43:23 sasa1 Exp $*/
/*28.12.2009	01.01.2003	Белых А.И.	sprtab.c
Меню для получения справок по табельному номеру
*/
#include        "buhg.h"

int zarsprpr(long,short,short,short,short,class spis_oth*);
void		zarsprvmn(long,short,short,short,short);
void		rlop(long,short,short,short,short);
int sprtabotp(int,short,short,short,short,class spis_oth*);
int zarsrbol(short,short,short,short,short,short,char*,char*,char*,class spis_oth*);
int zarsrbold(short,short,short,short,short,short,char*,char*,char*,class spis_oth*);
int zarsruv(short,short,short,short,short,short,char*,char*,char*,class spis_oth*);


void	sprtab(int metkaoth)
//Если metkaoth= 1 - расчет справки о зарплате
//               2 - расчет средней зарплаты для больничного
//               3 - расчет справки для уволенного для соцстраха
//               4 - расчет справок по датам в счет которых были сделаны начисления
//               5 - расчет средней зарплаты для больничного по беременности и родам
//               6 - расчет отпускных
{
static char     dat1[11],dat2[11];
static int	tabn;
char		fam[512];
char		inn[24];
char		strsql[512];
SQL_str		row;
SQLCURSOR curr;
int		ttn1=0;
short		dn,mn,gn;
short		dk,mk,gk;
int		N=0,K=0;
int		konec=0;
class iceb_tu_str fiov("");
memset(fam,'\0',sizeof(fam));

VVOD VV(0);
if(tabn == 0)
 VV.VVOD_SPISOK_add_data(10);
else
 {
  sprintf(strsql,"%d",tabn);
  VV.VVOD_SPISOK_add_data(strsql,10);

  sprintf(strsql,"select fio from Kartb where tabn=%d",tabn);
  if(sql_readkey(&bd,strsql,&row,&curr) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %d !",
    gettext("Не найден табельный номер"),tabn);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    strncpy(fam,row[0],sizeof(fam)-1);
   }
 }

VV.VVOD_SPISOK_add_data(dat1,8);
VV.VVOD_SPISOK_add_data(dat2,8);

VV.VVOD_SPISOK_add_MD(gettext("Табельний номер....."));
VV.VVOD_SPISOK_add_MD(gettext("Дата начала.(м.г)..."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца..(м.г)..."));

naz:;


clear();

VV.VVOD_delete_ZAG();

if(metkaoth == 1)
  VV.VVOD_SPISOK_add_ZAG(gettext("Расчет справок о зарплате"));
if(metkaoth == 2)
  VV.VVOD_SPISOK_add_ZAG(gettext("Расчет средней зарплаты для начисления больничного"));
if(metkaoth == 3)
  VV.VVOD_SPISOK_add_ZAG(gettext("Расчет средней зарплаты для социальной помощи"));

if(metkaoth == 4)
  VV.VVOD_SPISOK_add_ZAG(gettext("Расчет справок о зарплате"));

if(metkaoth == 5)
  VV.VVOD_SPISOK_add_ZAG(gettext("Распечатать расчёт больничного по беременности и родам"));

if(metkaoth == 6)
  VV.VVOD_SPISOK_add_ZAG(gettext("Распечатать расчет отпускных"));

if(fam[0] != '\0')
 {
  VV.VVOD_SPISOK_add_ZAG(fam);
 }

if(metkaoth == 2 || metkaoth == 5 || metkaoth == 6)
 {
  helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("таб.номер"),
"F4",gettext("очистить"),
"F5",gettext("настройка"),
"F10",gettext("выход"),NULL);
 }
else
  helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("таб.номер"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);


VV.vramka(-1,-1,0);


while(konec == 0)
 {
  if(N > VV.KLST-1)
    N=0;

  if(N < 0)
    N=VV.KLST-1;

  tabn=atol(VV.VVOD_SPISOK_return_data(0));
  strncpy(dat1,VV.VVOD_SPISOK_return_data(1),sizeof(dat1)-1);
  strncpy(dat2,VV.VVOD_SPISOK_return_data(2),sizeof(dat2)-1);

  attron(VV.VVOD_return_cs(iceb_CFS)); 

  VV.vprintw(N,stdscr);
  
  K=getch();

  attroff(VV.VVOD_return_cs(iceb_CFS));
  attron(VV.VVOD_return_cs(iceb_CFM));

  VV.vprintw(N,stdscr);

  if(K == KEY_MOUSE)
    K=mouseklic(&N,VV.PY,VV.PX,VV.MDLS,VV.KLST,stdscr);


  switch(K)
   {

    case KEY_RESIZE: //Изменение размеров экрана
      getch();
      goto naz;

    case ENTER:

      attroff(VV.VVOD_return_cs(iceb_CFM));
      attron(VV.VVOD_return_cs(iceb_CFV));
      VV.vprintw_clear(N,stdscr);

//      mygetstr(VV.VVOD_SPISOK_return_data(N),VV.VVOD_SPISOK_return_dls(N),stdscr);
      VV.vgetstr(N,stdscr);
      
      attroff(VV.VVOD_return_cs(iceb_CFV));
      attron(VV.VVOD_return_cs(iceb_CFM));

      if(N == 0 && VV.VVOD_SPISOK_return_data(N)[0] != '\0') //Табельный номер
       {
        memset(fam,'\0',sizeof(fam));

        sprintf(strsql,"select fio from Kartb where tabn=%s",VV.VVOD_SPISOK_return_data(N));
        if(sql_readkey(&bd,strsql,&row,&curr) != 1)
         {
          VVOD SOOB(1);
          sprintf(strsql,"%s %s !",
          gettext("Не найден табельный номер"),VV.VVOD_SPISOK_return_data(N));
          SOOB.VVOD_SPISOK_add_MD(strsql);
          soobshw(&SOOB,stdscr,-1,-1,0,1);
         }
        else
         {
          strncpy(fam,row[0],sizeof(fam)-1);
         }

        N++;
        goto naz;
       }

      if(N == 1 && VV.VVOD_SPISOK_return_data(N)[0] != '\0') //Дата начала
       {
        if(rsdat1(&mn,&gn,VV.VVOD_SPISOK_return_data(N)) != 0)
         {
          VVOD SOOB(1);
          SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto naz;
         }
       }
      if(N == 2 && VV.VVOD_SPISOK_return_data(N)[0] != '\0') //Дата начала
       {
        if(rsdat1(&mk,&gk,VV.VVOD_SPISOK_return_data(N)) != 0)
         {
          VVOD SOOB(1);
          SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конца !"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto naz;
         }
       }
      VV.vprintw(N,stdscr);
      N++;

      break;
      
    case SDN: //Стрелка вниз
     N++;
     break;

    case SUP:  //Стрелка вверх
      N--;
      break;

    case FK1:
      GDITE();
      if(metkaoth == 1)
        sprintf(strsql,"%s","zarp4_3_2_1.txt");
      if(metkaoth == 2)
        sprintf(strsql,"%s","zarp4_3_2_2.txt");
      if(metkaoth == 3)
        sprintf(strsql,"%s","zarp4_3_2_5.txt");

      if(metkaoth == 4)
       sprintf(strsql,"%s","zarp4_3_2_3.txt");


      if(metkaoth == 6)
        sprintf(strsql,"%s","zarp4_3_2_6.txt");
      if(metkaoth == 5)
        sprintf(strsql,"%s","zarp4_3_2_2.txt");

      iceb_t_pdoc(strsql);
      goto naz;

    case FK2:
    case PLU:
     konec=1;
     break;

    case FK3:
     clear();
      ttn1=0;
      fiov.new_plus("");
      if(dirtab(&ttn1,&fiov,0,1) == 0)
       {
        tabn=ttn1;           
        sprintf(strsql,"%d",ttn1);
        VV.VVOD_SPISOK_zapis_data(0,strsql);
       }
       
      goto naz;

    case FK5:

      if(metkaoth == 2 )
       iceb_redfil("zarsrbol.alx",0);
      if(metkaoth == 6 )
       iceb_redfil("zarotp.alx",0);
      if(metkaoth == 5 )
       iceb_redfil("zarsrbold.alx",0);

      goto naz;

    case FK4:
     VV.VVOD_clear_data();
     memset(fam,'\0',sizeof(fam));
     goto naz;

    case FK10:
     return;

   }

 }

konec=0; //Чтобы не зациклило


if(VV.VVOD_SPISOK_return_data(0)[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введен табельный номер !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(rsdat1(&mn,&gn,VV.VVOD_SPISOK_return_data(1)) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(VV.VVOD_SPISOK_return_data(2)[0] != '\0')
 {
  if(rsdat1(&mk,&gk,VV.VVOD_SPISOK_return_data(2)) != 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конца !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
 }
else
 {
  mk=mn;
  gk=gn;
 } 

sprintf(strsql,"select fio,inn from Kartb where tabn=%d",tabn);
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %d !",
  gettext("Не найден табельный номер"),tabn);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

strncpy(fam,row[0],sizeof(fam)-1);
strncpy(inn,row[1],sizeof(inn)-1);
class spis_oth oth;

if(metkaoth == 1)
 if(zarsprpr(tabn,mn,gn,mk,gk,&oth) == 0)
  iceb_t_rabfil(&oth,"");

dn=1;
dpm(&dk,&mk,&gk,5);
char tabnom[24];

sprintf(tabnom,"%d",tabn);
if(metkaoth == 2)
  if(zarsrbol(dn,mn,gn,dk,mk,gk,tabnom,fam,inn,&oth) == 0)
   iceb_t_rabfil(&oth,"");

if(metkaoth == 3)
  if(zarsruv(dn,mn,gn,dk,mk,gk,tabnom,fam,inn,&oth) == 0)
   iceb_t_rabfil(&oth,"");

if(metkaoth == 4)
  zarsprvmn(tabn,mn,gn,mk,gk);

if(metkaoth == 5)
  if(zarsrbold(dn,mn,gn,dk,mk,gk,tabnom,fam,inn,&oth) == 0)
   iceb_t_rabfil(&oth,"");


if(metkaoth == 6)
  if(sprtabotp(tabn,mn,gn,mk,gk,&oth) == 0)
   iceb_t_rabfil(&oth,"");


}
