/* $Id: srvcen.c,v 5.21 2011-01-13 13:43:23 sasa1 Exp $ */
/*04.11.2007	23.02.2001	Белых А.И	srvcen.c	
Программа определения средневзвешенной цены на материал
  Стартовое меню
*/
#include        <errno.h>
#include        "buhg.h"

void	srvcenr(short,short,char[],char[],char[],char[]);

extern struct M2 LL;
extern char     data[24][80]; /*Данные для отображения или ввода*/
extern short    dls[24]; /*Массив для определения длинны данных*/
extern char	*kodopsrvc; //Код операции расчета средневзвешенной цены
extern char	*maskmat; /*Массив кодов отмеченных материалов*/
extern char	*imabaz;

void	srvcen()
{
char	strsql[512];
SQL_str row;
static char     dat1[11];
static char     sklz[112];
static char     shbz[112];
static char     kodmz[112];
static char	kgrmz[112];
int		kom=0;
int		kom1=0;
char		nm[512],kod[32];
char		bros[512];
int		kgr,kodm;
short		mr,gr;

VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Расчет средневзвешенных цен на материалы."));

VV.VVOD_SPISOK_add_data(dat1,8);
VV.VVOD_SPISOK_add_data(shbz,50);
VV.VVOD_SPISOK_add_data(sklz,50);
VV.VVOD_SPISOK_add_data(kgrmz,50);
VV.VVOD_SPISOK_add_data(kodmz,50);

VV.VVOD_SPISOK_add_MD(gettext("Дата расчета (м.г)......"));
VV.VVOD_SPISOK_add_MD(gettext("Счет..(,,).............."));
VV.VVOD_SPISOK_add_MD(gettext("Склад..(,,)............."));
VV.VVOD_SPISOK_add_MD(gettext("Группа материалов..(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Код материалла.(,,/*)...."));

naz:;
clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strcpy(dat1,VV.VVOD_SPISOK_return_data(0));
strcpy(shbz,VV.VVOD_SPISOK_return_data(1));
strcpy(sklz,VV.VVOD_SPISOK_return_data(2));
strcpy(kgrmz,VV.VVOD_SPISOK_return_data(3));
strcpy(kodmz,VV.VVOD_SPISOK_return_data(4));
class iceb_tu_str kods("");
class iceb_tu_str naims("");
switch (kom)
 {
  case ESC:
  case FK10:
     return;
     break;

  case FK1:
    GDITE();
    iceb_t_pdoc("matu2_4.txt");
    clear();
    goto naz;

  case PLU:
  case FK2:
     break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите  нужное и нажмите Enter."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка складов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка материалов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов."));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 4 :
      case -1:
       goto naz;


      case 0 :
        //vibrek("Sklad",sklz,sizeof(sklz),nm);
        if(dirsklad(1,&kods,&naims) == 0)
         MENU.data_z_plus(2,kods.ravno());
        goto naz;

      case 1 :
        vibrek("Grup",kgrmz,sizeof(kgrmz),nm);
        MENU.VVOD_SPISOK_zapis_data(3,kgrmz);
        goto naz;

      case 2 :

        memset(kod,'\0',sizeof(kod));
        bros[0]='\0';
        if(dirmatr(&kgr,&kodm,&naims,1,0,bros,0,0) == 0)
         {
          MENU.data_z_plus(4,kodm);
         }

        clear();
        goto naz;

      case 3 :
        vibrek("Plansh",shbz,sizeof(shbz),nm);
        MENU.VVOD_SPISOK_zapis_data(1,shbz);
        goto naz;
     }

  case FK4:
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
    break;
 }

if(rsdat1(&mr,&gr,dat1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

//sprintf(strsql,"%s",iceb_t_imafnsi("blokmak.alx"));
if(iceb_t_pbpds(mr,gr) != 0)
  goto naz;

if(kodopsrvc == NULL || kodopsrvc[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("В файле настройки не введен код операции расчета"));
  SOOB.VVOD_SPISOK_add_MD(gettext("средневзвешенной цены !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
SQLCURSOR cur;
//Проверяем есть ли код операции в списке приходов и расходов
sprintf(strsql,"select kod from Prihod where kod='%s'",kodopsrvc);
if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Не найден код %s в списке операций приходов !"),kodopsrvc);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;

 }
sprintf(strsql,"select kod from Rashod where kod='%s'",kodopsrvc);
if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Не найден код %s в списке операций расходов !"),kodopsrvc);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;

 }
if(kodmz[0] == '*' && maskmat == NULL)
 { 
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не сделан список материалов !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 } 

srvcenr(mr,gr,shbz,kgrmz,kodmz,sklz);

}
