/*$Id: tovshek.c,v 5.12 2011-01-13 13:43:23 sasa1 Exp $*/
/*03.11.2009	18.04.2003	Белых А.И.	tovshek.c
Печать товарного чека
*/
#include	<errno.h>
#include	<buhg.h>
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


void	tovshek(SQLCURSOR *cur)
{
FILE            *ff;
char           	imaf[32];
SQL_str         row,row1;
char		strsql[512];
char            nmo[512];  /*Наименование организации*/
char            gor[512]; /*Адрес*/
char            pkod[32]; /*Почтовый код*/
char            nmb[512];  /*Наименование банка*/
char            mfo[32];  /*МФО*/
char            nsh[32];  /*Номер счета*/
char            inn[32];  /*Индивидуальный налоговый номер*/
char		grb[512];  /*Город банка*/
char		npnds[32]; /*Номер плательщика НДС*/
char		tel[112];    /*Номер телефона*/
SQLCURSOR curr;
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);


sprintf(strsql,"select * from Kontragent where kodkon='00'");
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найден код организации 00 !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }
else
 {
  strncpy(nmo,row[1],sizeof(nmo)-1);
  strncpy(gor,row[3],sizeof(gor)-1);
  strncpy(pkod,row[5],sizeof(pkod)-1);
  strncpy(nmb,row[2],sizeof(nmb)-1);
  strncpy(mfo,row[6],sizeof(mfo)-1);
  strncpy(nsh,row[7],sizeof(nsh)-1);
  strncpy(inn,row[8],sizeof(inn)-1);
  strncpy(grb,row[4],sizeof(grb)-1);
  strncpy(npnds,row[9],sizeof(npnds)-1);
  strncpy(tel,row[10],sizeof(tel)-1);
 } 



sprintf(imaf,"tsh%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }


fprintf(ff,"%s\n",nmo);

fprintf(ff,"%s %s\n",gettext("Адрес"),gor);
fprintf(ff,"%s %s\n",gettext("Код ОКПО"),pkod);

fprintf(ff,"%s %s %s %s\n",gettext("Р/С"),nsh,
gettext("МФО"),mfo);

fprintf(ff,"%s %s %s %s\n",gettext("в"),nmb,
gettext("г."),grb);

fprintf(ff,"%s %s\n",gettext("Налоговый номер"),inn);
fprintf(ff,"%s %s\n",gettext("Номер сви-ства плательщика НДС"),npnds);
fprintf(ff,"%s %s\n",gettext("Телефон"),tel);

fprintf(ff,"%20s%s N\n"," ",gettext("Товарный чек"));
fprintf(ff,"%20s%02d.%02d.%d%s\n"," ",dt,mt,gt,gettext("г."));

fprintf(ff,"\
-------------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
Н/п|       Наименование товара              |Ед.из.|Колич.|  Цена  |  Сумма   |\n"));
fprintf(ff,"\
-------------------------------------------------------------------------------\n");

cur->poz_cursor(0);
int nomer=0;
double kolih=0.;
double cena=0.;
double suma=0.;
double sumai=0.;
char   naim[512];

while(cur->read_cursor(&row) != 0)
 {
  memset(naim,'\0',sizeof(naim));
  /*Читаем наименование материалла*/
   sprintf(strsql,"select naimat from Material where kodm=%s",
   row[4]);
   if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
     strncpy(naim,row1[0],sizeof(naim)-1);
     
  kolih=atof(row[6]);
  cena=atof(row[7]);
  cena=okrug(cena,0.01);
  suma=kolih*cena;
  suma=okrug(suma,0.01);
  sumai+=suma;  

  fprintf(ff,"%3d %-*.*s %-*s %6.6g %8.2f %10.2f\n",
  ++nomer,
  iceb_tu_kolbait(40,naim),iceb_tu_kolbait(40,naim),naim,
  iceb_tu_kolbait(6,row[5]),row[5],
  kolih,cena,suma);
  
 }
fprintf(ff,"\
-------------------------------------------------------------------------------\n");
fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(67,gettext("Итого")),gettext("Итого"),sumai);

memset(strsql,'\0',sizeof(strsql));
preobr(sumai,strsql,0);
fprintf(ff,"%s:%s\n",gettext("Сумма прописью"),strsql);

fprintf(ff,"\n        %s_______________\n",gettext("Продавец"));

fclose(ff);
class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Товарный чек"));

iceb_t_ustpeh(imaf,0);

iceb_t_rabfil(&oth,"");

}
