/*$Id: uos.h,v 5.11 2011-08-29 07:08:59 sasa Exp $*/
/*16.12.2009    29.06.1996      Белых А.И.      uos.h
*/
struct UOS
 {
/*Данные по документам*/

short           tipz; /*приход/расход*/
short           tipzv; /*приход/расход встречный при внутреннем перемещении*/
char            datpr[24]; /*дата документа*/
char            kontr[56]; /*Код поставщика/получателя*/
char            naimo[512]; /*Наименование организации*/

class iceb_tu_str kprr;   /*Код прихода/расхода*/
class iceb_tu_str naimpr; /*Наименование прихода/расхода*/

int             pod;    /*Код подразделения*/
int             pod1;   /*Код встречного подразделения*/
char            naipod[512]; /*Наименование подразделения*/
char            naipod1[512]; /*Наименование встречного подразделения*/

int		kodol;      /*Код ответственного лица*/
int		kodol1;     /*Код встречного ответственного лица*/
char		naikol[512]; /*Наименование ответственного лица*/
char		naikol1[512];  /*Наименование встречного ответственного лица*/

char            nomdok[56]; /*Номер документа*/
char            nomdokp[56]; /*Номер встречного документа*/

char            osn[512]; /*Основание*/
char		dover[512];
short           dvd,mvd,gvd; //Дата выдачи доверенности
char		forop[56]; //Код формы оплаты
char		naiforop[512]; //Наименование формы оплаты
class iceb_tu_str vid_dog; /*вид договора*/
char            nomnn[56]; //Номер налоговой накладной
short		dnn,mnn,gnn; //Дата выдачи налоговой накладной
short           dvnn,mvnn,gvnn; /*Дата выписки налоговой накладной*/
char		sherez[512]; //Через кого
short		dop,mop,gop; //Дата оплаты
float           pnds; //Процент НДС действовавший на момент создания документа
short		nds;
/*
                    0 20% НДС.
                    1 0% НДС реализация на територии Украины.
                    2 0% НДС экспорт.
                    3 0% Освобождение от НДС статья 5.
*/

/*Постоянные данные по инвентарному номеру*/

short		godv;      /*Год выпуска*/
char		naim[512]; /*Нименование инвентарного номера*/
char		zaviz[512]; /*Завод изготовитель*/
char		pasp[512];  /*Паспорт*/
char		model[512]; /*Модель*/
char		zavnom[512]; /*Заводской номер*/
short		dv,mv,gv;   /*Дата ввода в эксплуатацию*/

/*Переменные данные по инвентарному номеру*/

char		shetu[56]; /*Счет учета*/
char		hzt[56];   /*Шифр затрат*/
char		hau[56];   /*Шифр аналитического учета*/
char		hna[56];   /*Шифр нормы амортотчислений для налогового учета*/
float		popkf;   /*Поправочный коэффициент  для налогового учета*/
char		hnaby[56];   /*Шифр нормы амортотчислений для бухгалтерского учета*/
float		popkfby;   /*Поправочный коэффициент*/
int		soso;    /*Состояние объекта 
                             0-амортизация считается для бухучета и налогового учета
                             1-амортизация не считается для бух.учета и налогового учета
                             2-считается для бух.учета и не считается для налогового
                             3-не считается для бух учета и считается для налогового
                           */
                           
char		nomz[512];  /*Номерной знак*/
 };
