/*$Id: uos_fomtr.c,v 5.24 2011-01-13 13:43:23 sasa1 Exp $*/
/*11.01.2010	20.10.2005	Белых А.И.	uos_fomtr.c
Форма обліку матеріально-технічних ресурсів. Додаток 3 до наказу МВС України
*/
#include        <sys/stat.h>
#include <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

int uos_fomtr_read_alx(class masiv_din_int *kodgr,class SPISOK *sp_uos_gr);
void uos_fomtr_sapka(short dn,short mn,short gn,short dk,short mk,short gk,int *kollist,int *kolstr,FILE *ff);
int uos_fomtr_prov(char *grup,class masiv_din_int *kodgr,class SPISOK *sp_uos_gr);
void uos_fomtr_shet(short dn,short mn,short gn,short dk,short mk,short gk,int *kollist,int *kolstr,FILE *ff);

extern char     *organ;
extern int kol_strok_na_liste;
extern short	startgoduos; /*Стартовый год*/

int uos_fomtr(class spis_oth *oth)
{
static  char    dat1[11],dat2[11];
static char inv_nom[112];
int kom=1;

VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Расчёт формы учёта материально-технических ресурсов."));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала....(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца.....(д.м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Инвентарный номер (,,).."));

VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2)); 
VV.VVOD_SPISOK_add_data(inv_nom,sizeof(inv_nom)); 

naz:;

clear();
 
helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F4",gettext("очистить"),
"F5",gettext("настройка"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

move(LINES-1,0);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat1)-1);
strncpy(inv_nom,VV.VVOD_SPISOK_return_data(2),sizeof(inv_nom)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
//   prosf(strsql);
   goto naz;

  case ESC:
  case FK10:
   return(1);

  case FK2:
  case PLU:
     break;


  case FK5:
     iceb_redfil("uos_fomtr.alx",0);
     goto naz;

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }
GDITE(); 

short dn,mn,gn;
short dk,mk,gk;

if(rsdatp(&dn,&mn,&gn,dat1,&dk,&mk,&gk,dat2) != 0)
 goto naz;

class masiv_din_int kodgr;
class SPISOK sp_uos_gr;

if(uos_fomtr_read_alx(&kodgr,&sp_uos_gr) != 0)
 goto naz;

char strsql[512];
int kolstr;
SQL_str row;
SQL_str row1;
SQLCURSOR cur;

//printw("Период %d.%d.%d > %d.%d.%d\n",dn,mn,gn,dk,mk,gk);
//printw("%s\n",gettext("Сортируем записи."));

sprintf(strsql,"select innom,god,naim,datvv from Uosin");
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);  
 }
char imaftmp[56];
sprintf(imaftmp,"uos_fomtr%d.tmp",getpid());
FILE *ff;

if((ff = fopen(imaftmp,"w")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }
int kolstr1=0;
int kolstr2=0;
short m1,g1;
char shetu[32];
char hzt[24],hau[24],hna[24],hnaby[32];
char nomz[112];
int soso;
float popkf,popkfby;
int kodos=0; //Код основного средства
while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s\n",row[0],row[1]);
  kolstr1++;
  strzag(LINES-1,0,kolstr,kolstr1);  
  if(proverka(inv_nom,row[0],0,0) != 0)
   continue;
   
  sprintf(strsql,"select podr from Uosdok1 where innom=%s \
and datd >= '%04d-01-01' and datd <= '%04d-%d-%d' and podt=1 \
order by datd desc,tipz asc",
  row[0],startgoduos,gk,mk,dk);
  SQLCURSOR cur1;
  if((kolstr2=cur1.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }

  if(kolstr2 == 0)
   {
    /*Возможно инвентарный номер пришел позже заказанного периода*/
    continue;
   }

  while(cur1.read_cursor(&row1) != 0)
   {

    poiinpd(atol(row[0]),mk,gk,shetu,hzt,hau,hna,&popkf,&soso,nomz,&m1,&g1,hnaby,&popkfby);

    kodos=uos_fomtr_prov(hna,&kodgr,&sp_uos_gr);

    fprintf(ff,"%d|%s|%s|%s|%s|%s|\n",kodos,row[0],row1[0],row[1],row[2],row[3]);
   }

 }
GDITE(); 
fclose(ff);

//Сортировка с удалением дублированных записей
//sprintf(strsql,"sort -o %s -t\\| +0 -1n +1 -2n -u %s",imaftmp,imaftmp);
sprintf(strsql,"sort -o %s -t\\| -k1,2n -k2,3n -u %s",imaftmp,imaftmp);
runsystem(strsql);

//printw("%s.\n",gettext("Сортировка завершена"));


struct stat work;

stat(imaftmp,&work);
FILE *ff1;

if((ff1 = fopen(imaftmp,"r")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }
unlink(imaftmp);

char imaf[32];
sprintf(imaf,"uos_fomtr%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

kolstr=0;
char strr[500];
char bros[512];
int podr=0;
long innom=0;
char naim[512];
short god_iz;
short dvv,mvv,gvv;
int nomzap=0;
int kolstrok=0;
int kollist=0;

fprintf(ff,"\
                                Форма обліку матеріально-технічних ресурсів.\n\
                                %s\n",organ);
kolstrok=2;

uos_fomtr_sapka(dn,mn,gn,dk,mk,gk,&kollist,&kolstrok,ff);
                                

class bsiz_data ost_in;
while(fgets(strr,sizeof(strr),ff1) != NULL)
 {
  kolstr+=strlen(strr);
  strzag(LINES-1,0,work.st_size,kolstr);
  
  polen(strr,bros,sizeof(bros),1,'|');
  kodos=atoi(bros);

  polen(strr,bros,sizeof(bros),2,'|');
  innom=atol(bros);
  
  polen(strr,bros,sizeof(bros),3,'|');
  podr=atoi(bros);
  
  polen(strr,bros,sizeof(bros),4,'|');
  god_iz=atoi(bros);

  polen(strr,naim,sizeof(naim),5,'|');

  polen(strr,bros,sizeof(bros),6,'|');
  rsdat(&dvv,&mvv,&gvv,bros,2);
  
//  ostuos(innom,podr,dn,mn,gn,dk,mk,gk,0,"",&ost_in);
  bsizp(innom,podr,dn,mn,gn,dk,mk,gk,&ost_in,NULL);

  //Если начальная балынсовая стоимость, за период и конечная равны нолю - значит списан
  if(ost_in.nu.bs_nah_per == 0. && ost_in.nu.bs_kon_per == 0. && \
  ost_in.nu.bs_prih_za_per == 0. && ost_in.nu.bs_rash_za_per == 0.)
   continue;

//Счётчик строк для разбивки по листам закомментирован по просьбе клиента   
//  uos_fomtr_shet(dn,mn,gn,dk,mk,gk,&kollist,&kolstrok,ff);

  fprintf(ff,"%-5d %-6d %-30.30s %7s ",
  ++nomzap,kodos,naim,"");

  double spis_iznos=0.;
  double spis_bs=0.;
  if(ost_in.nu.bs_kon_per == 0.)
//  if(ost_in.nu.bs_rash_za_per != 0.)
   {
    spis_iznos=ost_in.nu.iznos_rash_za_per*-1;
    spis_bs=ost_in.nu.bs_nah_per-spis_iznos;
   }
  double prih_iz=0.;
  double prih_bs=0.;
  if(ost_in.nu.bs_nah_per == 0.)
   {
    prih_bs=ost_in.nu.bs_prih_za_per;
    prih_iz=ost_in.nu.iznos_prih_za_per;
   }
  double iznos_kon=ost_in.nu.izmen_iznosa_kon_per+ost_in.nu.amort_kon_per;
  if(ost_in.nu.bs_kon_per == 0.)
    iznos_kon=0.;
    
  if(ost_in.nu.bs_nah_per != 0. || ost_in.nu.izmen_iznosa_nah_per+ost_in.nu.amort_nah_per != 0.)
    fprintf(ff,"\
%-10d %02d.%02d.%04d %10.2f %10.2f \
%10s %10s %10.f %10.2f \
%10.2f %10.2f %10s %10s \
%10.2f %10.2f\n",
    god_iz,dvv,mvv,gvv,ost_in.nu.bs_nah_per,ost_in.nu.izmen_iznosa_nah_per+ost_in.nu.amort_nah_per,
    "","", prih_bs,prih_iz,
    spis_bs, spis_iznos,"","",
    ost_in.nu.bs_kon_per,iznos_kon);
  else
    fprintf(ff,"\
%-10s %10s %10s %10s \
%-10d %02d.%02d.%04d %10.f %10.2f \
%10.2f %10.2f %10s %10s \
%10.2f %10.2f\n",
    "","","","",
    god_iz,dvv,mvv,gvv, prih_bs,prih_iz,
    spis_bs, spis_iznos,"","",
    ost_in.nu.bs_kon_per,iznos_kon);

 }
fclose(ff1);

podpis(ff);
fclose(ff);

/****************
VVOD SOOB(1);

sprintf(strsql,"%s %d",gettext("Количество страниц"),kollist);
SOOB.VVOD_SPISOK_add_MD(strsql);
soobshw(&SOOB,stdscr,-1,-1,0,1);
**************/
oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчёт формы учёта материально-технических ресурсов"));
iceb_t_ustpeh(imaf,3);
return(0);
}


/************************************/
/*Чтение настроечного файла*/
/****************************/
int uos_fomtr_read_alx(class masiv_din_int *kodgr,class SPISOK *sp_uos_gr)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];

sprintf(strsql,"select str from Alx where fil='uos_fomtr.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"uos_fomtr.alx");
  iceb_t_soob(strsql);
  return(1);
 }



char stroka_kodgr[512];
char kod_gr[512];

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  if(polen(row_alx[0],kod_gr,sizeof(kod_gr),1,'|') != 0)
   continue;
  if(atoi(kod_gr) == 0)
   continue;
   
  if(polen(row_alx[0],stroka_kodgr,sizeof(stroka_kodgr),3,'|') != 0)
   continue;
   
  kodgr->plus(atoi(kod_gr),-1);
  sp_uos_gr->plus(stroka_kodgr);
 }
 
return(0);
}


/***********************************/
/*Проверка принадлежности*/
/***********************************/

int uos_fomtr_prov(char *grup,
class masiv_din_int *kodgr,class SPISOK *sp_uos_gr)
{
//printw("\ngrup=%s\n",grup);

for(int i=0; i < kodgr->kolih(); i++)
 {
//  printw("%d/%d=%s\n",i,kodgr->ravno(i),sp_uos_gr->ravno(i));
  if(proverka(sp_uos_gr->ravno(i),grup,0,1) == 0)
   return(kodgr->ravno(i));

 }

return(0);
}
/***********************/
/*Счётчик строк */
/*********************/
void uos_fomtr_shet(short dn,short mn,short gn,
short dk,short mk,short gk,
int *kollist,
int *kolstr,
FILE *ff)
{
*kolstr+=1;
if(*kolstr <= kol_strok_na_liste)
 return;

fprintf(ff,"\f");
*kolstr=1;
uos_fomtr_sapka(dn,mn,gn,dk,mk,gk,kollist,kolstr,ff);


}
/***************************************/
/*Шапка документа*/
/***************************************/

void uos_fomtr_sapka(short dn,short mn,short gn,
short dk,short mk,short gk,
int *kollist,
int *kolstr,
FILE *ff)
{

*kollist+=1;
*kolstr+=10;

fprintf(ff,"\
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n\
     | Код  |           Повне              |Норма- |                                           |                                           |                  Вибуло                   |                     |        |\n\
     |основ-|        найменування          |тивний |         Залишок на %02d.%02d.%04d             |            Надходження                    |-------------------------------------------|Залишок на %02d.%02d.%04d|        |\n\
     |ного  |         тип,марка            |термін |                                           |                                           |       Списано       |      Передано       |                     |        |\n\
     |засобу|                              |експлу-|---------------------------------------------------------------------------------------------------------------------------------------------------------|        |\n\
 Н/п |      |                              |атації |Дата виго-|Дата вве- |Первісна  |  Сумма    |Дата виго-|Дата вве- |Первісна  |  Сумма    |Балансова |  Сумма    |Первісна  |  Сумма    |Первісна  |  Сумма    |Примітка|\n\
     |      |                              |(років)| товлення |дення в   |вартість  | зносу    | товлення |дення в   |вартість  | зносу    |вартість  |  зносу   |вартість  | зносу    |вартість  | зносу    |        |\n\
     |      |                              |       |          |експлуата-|  грн.    |  грн.    |          |експлуата-|  грн.    |  грн.    |   грн.   |   грн.   |  грн.    |  грн.    |  грн.    |  грн.    |        |\n\
     |      |                              |       |          |  цію     |          |          |          |  цію     |          |          |          |          |          |          |          |          |        |\n\
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n",
dn,mn,gn,dk,mk,gk);

/*
12345 123456 123456789012345678901234567890 1234567 1234567890 1234567890 
*/

}
