/* $Id: uosact.c,v 5.25 2011-01-13 13:43:23 sasa1 Exp $ */
/*12.12.2010    17.02.1997      Белых А.И.      uosact.c
Распечатка акта приема передачи основных средств
*/
#include        <ctype.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char     *organ;/*Наименование организации*/

void            uosact(short d,short m,short g, //Дата документа
char ndk[]) //номер документа
{
char            bros[512];
char            str[1024];
FILE            *ff1;
char            imaf1[40];
long            in;
int             pdr;
double          sbs,siz,bs,iz,iz1;
double          sbsby,sizby,bsby,izby,iz1by;
double		pbs;
long		kolstr;
SQL_str         row,row1;
char		strsql[512];
char		shetu[32]; /*Счет учета*/
char		hzt[32];   /*Шифр затрат*/
char		hau[32];   /*Шифр аналитического учета*/
char		hna[32];   /*Шифр нормы амортотчислений*/
float		popkf;   /*Поправочный коэффициент*/
char		hnaby[32];   /*Шифр нормы амортотчислений*/
float		popkfby;   /*Поправочный коэффициент*/
int		soso;    /*Состояние объекта*/
char		nomz[112];  /*Номерной знак*/
short		mz,gz;   /*дата записи*/
float		kof;
short		dv,mv,gv;
short		god;
char		pasp[512];
char		naim[512];
char		model[512];
short		tipz;
char		osnov[512];
char		kpos[32];
char		datpr[11];
char		kprr[32];
char		zavnom[512];
int		kkk=0;
char		godchar[5];
char		mesqc[32];
char		kodol[32];
SQL_str row_alx;
class SQLCURSOR cur_alx;
SQLCURSOR cur;
SQLCURSOR curr;
char kodedrpou[20];
memset(kodedrpou,'\0',sizeof(kodedrpou));

/*Узнаём код */
sprintf(strsql,"select kod from Kontragent where kodkon='00'");
if(readkey(strsql,&row1,&cur) == 1)
 strncpy(kodedrpou,row1[0],sizeof(kodedrpou)-1);

sprintf(godchar,"%d",g);
/*Читаем шапку документа*/
sprintf(strsql,"select tipz,kontr,osnov,kodop,kodol from Uosdok where datd='%d.%02d.%02d' and \
nomd='%s'",g,m,d,ndk);

if(readkey(strsql,&row1,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s %d.%d.%d%s",
  gettext("Не найден документ !"),ndk,d,m,g,
  gettext("г."));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }
else
 {
  tipz=atoi(row1[0]);
  strncpy(kpos,row1[1],sizeof(kpos)-1);
  strncpy(osnov,row1[2],sizeof(osnov)-1);
  strncpy(kprr,row1[3],sizeof(kprr)-1);
  strncpy(kodol,row1[4],sizeof(kodol)-1);
 }  

//imafl(ndk,bros);
sprintf(bros,"%d",getpid());
if(tipz == 1)
  sprintf(imaf1,"acp%s.lst",bros);
if(tipz == 2)
  sprintf(imaf1,"acr%s.lst",bros);

errno=0;
if((ff1 = fopen(imaf1,"r")) == NULL)
 if(errno != ENOENT)
   {
    error_op_nfil(imaf1,errno,"");
    return;
   }

if(errno != ENOENT) /*Файл сущесвует*/
 {
  fclose(ff1);
  VVOD DANET(1);
  DANET.VVOD_SPISOK_add_MD(gettext("Распечатка уже есть. Переформировать ?"));

  if(danet(&DANET,2,stdscr) == 2)
   {
    class spis_oth oth;
    oth.spis_imaf.plus(imaf1);
    oth.spis_naim.plus(gettext("Распечатка акта приёмки/передачи основных средств."));
    iceb_t_rabfil(&oth,"");
    return;
   }
 }

sprintf(datpr,"%d.%d.%d",d,m,g);


sprintf(strsql,"select innom,podr,bsby from Uosdok1 where datd='%d.%02d.%02d' and \
nomd='%s'",g,m,d,ndk);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

sprintf(strsql,"select str from Alx where fil='uosact.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"uosact.alx");
  iceb_t_soob(strsql);
  return;
 }


if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return;
 }
//Два раза подряд для ландшафтной ориентации


kkk=0;
memset(str,'\0',sizeof(str));
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  kkk++;
  memset(str,'\0',sizeof(str));
  strncpy(str,row_alx[0],sizeof(str)-1);
  switch(kkk)
   {
    case 1 :
     BSTAB(str,organ,0,40,1);
     break;

   case 3 :
     BSTAB(str,kodedrpou,29,49,1);
     break;

    case 6 :
     memset(mesqc,'\0',sizeof(mesqc));
     mesc(m,1,mesqc);
     sprintf(strsql,"%02d %s %04dр.",d,mesqc,g);

     BSTAB(str,strsql,123,150,1);
     break;

    case 14 :
     BSTAB(str,ndk,130,141,1);
     BSTAB(str,datpr,142,153,1);
     BSTAB(str,kodol,155,170,1);
     BSTAB(str,kprr,172,179,1);
     break;

    case 28 :
      while(cur.read_cursor(&row) != 0)
       {
        
        in=atol(row[0]);
        pdr=atoi(row[1]);
        pbs=atof(row[2]);
        

        bsiz(in,pdr,d,m,g,&sbs,&siz,&bs,&iz,&iz1,&sbsby,&sizby,&bsby,&izby,&iz1by,0);


        bsby+=sbsby;
        izby+=sizby;
        izby+=iz1by;

        /*Читаем переменные данные*/
        poiinpd(in,m,g,shetu,hzt,hau,hna,&popkf,&soso,nomz,&mz,&gz,hnaby,&popkfby);

        /*Читаем поправочный коэффициент*/
        kof=0.;
        sprintf(strsql,"select kof from Uosgrup1 where kod='%s'",hnaby);

        if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
         {
          VVOD SOOB(1);
          sprintf(strsql,"%s %s !",gettext("Не найден код группы"),hnaby);
          SOOB.VVOD_SPISOK_add_MD(strsql);
          soobshw(&SOOB,stdscr,-1,-1,0,1);
         }
        else
         kof=atof(row1[0]);

        god=0;
        memset(pasp,'\0',sizeof(pasp));
        dv=mv=gv=0;
        memset(zavnom,'\0',sizeof(zavnom));
        memset(naim,'\0',sizeof(naim));
        memset(model,'\0',sizeof(model));
        
        /*Читаем постоянную часть*/   
        sprintf(strsql,"select god,pasp,datvv,zavnom,naim,model \
from Uosin where innom=%ld",in);

        if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
         {
          beep();
          printw("%s %ld !\n",gettext("Не найден инвентарный номер"),in);
          OSTANOV();
         }
        else
         {
          god=atoi(row1[0]);
          strncpy(pasp,row1[1],sizeof(pasp)-1);
          rsdat(&dv,&mv,&gv,row1[2],2);
          strncpy(zavnom,row1[3],sizeof(zavnom)-1);
          strncpy(naim,row1[4],sizeof(naim)-1);
          strncpy(model,row1[5],sizeof(model)-1);
         }

        if(tipz == 1)
         fprintf(ff1," %4.4s %5.5d %5.5s %9.9s %5.5s %9.9s %9.9g %10ld\
 %10.10s %17.17s %6.6s %8.8g %8.8g %6.6g %5.5s %7.7s %11.11g %4d %02d.%04d\
 %-14.14s\n",
         kpos,pdr,shetu,hau," "," ",pbs,in,zavnom,hzt,hnaby,kof,0.,
         popkf," "," ",izby,god,mv,gv,pasp);

        if(tipz == 2)
         fprintf(ff1," %4.4d %5.5s %5.5s %9.9s %5.5s %9.9s %9.9g %10ld\
 %10.10s %17.17s %6.6s %8.8g %8.8g %6.6g %5.5s %7.7s %11.11g %4d %02d.%04d\
 %-14.14s\n",
         pdr,kpos," "," ",shetu,hau,pbs,in,zavnom,hzt,hnaby,kof,0.,
         popkf," "," ",izby*(-1),god,mv,gv,pasp);
       }
     break;

    case 29 :
     BSTAB(str,osnov,34,74,1);
     break;

    case 33 :
     memset(bros,'\0',sizeof(bros));
     sprintf(bros,"%s %s",naim,model);
     BSTAB(str,bros,62,140,1);
     break;

    case 31 :
     BSTAB(str,godchar,22,28,1);
     break;

    case 41 :
//     fprintf(ff1,"\x1b\x6C%c",1); /*Установка левого поля*/
     fprintf(ff1,"\f\n");
     continue;

    case 61 :
     memset(mesqc,'\0',sizeof(mesqc));
     mesc(m,1,mesqc);
     sprintf(strsql,"%02d %s %04dр.",d,mesqc,g);

     BSTAB(str,strsql,69,90,1);

     break;
   }

  fprintf(ff1,"%s",str);
  memset(str,'\0',sizeof(str));

 }

podpis(ff1);

fclose(ff1);

class spis_oth oth;
oth.spis_imaf.plus(imaf1);
oth.spis_naim.plus(gettext("Распечатка акта приёмки/передачи основных средств"));

iceb_t_ustpeh(imaf1,0);

iceb_t_rabfil(&oth,"");

}
