/* $Id: uosrp1.c,v 5.22 2011-01-13 13:43:24 sasa1 Exp $ */
/*04.11.2009    19.10.1994      Белых А.И.      uosrp1.c
Сортировка проводок и выдача распечатки
Возвращаем 0 - если нет проводок
	   1 - если есть
*/
#include        <time.h>
#include        <math.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


void            uosrp1_shetchik(short,short,short,short,short,short,int*,int*,int,char[],FILE*);
void            rasid(double,short,short,short,short,short,short,int,char[],int*,int*,FILE*);
void            rasio(char[],double,short,short,short,short,short,short,int,char[],char[],int*,int*,class SPISOK *mso,class masiv_din_double *mspo,FILE*);
void            rasis(char[],double,short,short,short,short,short,short,int,char[],char[],int*,int*,class SPISOK *mso,class masiv_din_double *mspo,class SPISOK *mss,class masiv_din_double *msps,FILE*);
void            rasoi(class SPISOK*,class masiv_din_double*,FILE*);
void uosrp1_sapka(int skl1,const char *naiskl,short dn,short mn,short gn,short dk,short mk,short gk,int *kollist,int *kolstrok,FILE *ff);

extern short    ddd,mmm,ggg;
extern char     *organ;/*Наименование организации*/
extern int kol_strok_na_liste;

int uosrp1(VVOD *VV,class spis_oth *oth)
{
class SPISOK mso;
class masiv_din_double mspo;
class SPISOK mss;  /*Массив счетов по складу*/
class masiv_din_double msps; /*Массив сумм по складу*/
class SPISOK mssi; /*Массив счетов по всем складам*/
class masiv_din_double mspsi; /*Массив сумм проводок по всем складам по операции*/
class SPISOK mssio; /*Массив счетов по всем складам и всем операциям*/
class masiv_din_double mspsio; /*Массив сумм проводок по всем складам по всем операциям*/

int           kst=0,sli=0;
FILE            *ff;
FILE            *ffitog;
FILE            *ff1;
char            kop[112];
char		str[1024];
char		bros[512];
char		naiskl[512];
struct  tm      *bf;
time_t          tmm;
time_t          tmmn;
time_t          tmmk;
short           kom;
char		kome[512]; /*Коментарий*/
long            muf; /*Количество записей в файле*/
short           dp,mp,gp;
short           d,m,g;
short           dd,md,gd;
char            orgn[32];
char            imaf[32],imaftmp[32],imafitog[32];
char            sh1[32];
char            shett[32];
char            shett1[32];
char            shettz[32];
double          itd; /*Итого по счету*/
int             i;
double          k1,s1;
short           tipzz;
int		tz; /*1-Приход 2-расход*/
short           klr;
short           dn,mn,gn;
short           dk,mk,gk;
double		deb;
int		skl=0,skl1=0;
char		nomdok[56];
char		nomdokv[56];
char		kprr[32],kprr1[32];		
char		naimpr[512];
long		kolstr,kolstr1;
SQL_str         row,row1;
char		strsql[512];
char		kontr[32];
int		tipz;
char		naikont[512];
SQLCURSOR curr;
clear();
GDITE();

time(&tmmn);


tz=0;
if(VV->VVOD_SPISOK_return_data(4)[0] == '+')
  tz=1;
if(VV->VVOD_SPISOK_return_data(4)[0] == '-')
  tz=2;

if(rsdatp(&dn,&mn,&gn,VV->VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV->VVOD_SPISOK_return_data(1)) != 0)
  return(1);

sprintf(strsql,"select datp,sh,shk,kodkon,nomd,pod,oper,deb,kre,\
datd,komen from Prov where val=0 and datp>='%d-%d-%d' and \
datp <= '%d-%d-%d' and kto='%s' and deb <> 0. order by datp asc",
gn,mn,dn,gk,mk,dk,gettext("УОС"));
/*
printw("\n%s\n",strsql);
refresh();
*/
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);  
 }

sprintf(imaftmp,"uosrp%d.tmp",getpid());

if((ff1 = fopen(imaftmp,"w")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }

printw("%s: %d.%d.%d%s => %d.%d.%d%s\n",
gettext("Дата"),
dn,mn,gn,
gettext("г."),
dk,mk,gk,
gettext("г."));

printw(gettext("Сортируем проводки.\n"));

refresh();
kolstr1=muf=0;
while(cur.read_cursor(&row) != 0)
 {
/*
  printw("%s %s %s %s %s %s %s %s %s %s %s\n",
  row[0],row[1],row[2],row[3],row[4],row[5],row[6],row[7],row[8],
  row[9],row[10]);
*/
  strzag(LINES-1,0,kolstr,++kolstr1);
  
  /*Смотрим только дебеты*/
/*
  if( fabs(atof(row[8])) > 0.009)
    continue;
*/    

  /*Подразделение*/
  if(proverka(VV->VVOD_SPISOK_return_data(2),row[5],0,0) != 0)
    continue;
   
  /*Читаем документ*/
  sprintf(strsql,"select tipz,kodop,kontr,nomdv \
from Uosdok where datd='%s' and nomd='%s'",
  row[9],row[4]);
  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    beep();  
    printw("%s N%s %s %s !",gettext("Не найден документ !"),
    row[4],gettext("Дата"),row[9]);
    OSTANOV();
    continue;
   }  
  tipz=atoi(row1[0]);
  strncpy(kprr,row1[1],sizeof(kprr)-1);
  strncpy(kontr,row1[2],sizeof(kontr)-1);
  strncpy(nomdokv,row1[3],sizeof(nomdokv)-1);
  if(tz != 0 && tz != tipz)
   continue;

  /*Организация*/
  if(proverka(VV->VVOD_SPISOK_return_data(3),kontr,0,0) != 0)
    continue;

  /*Операция*/
  if(proverka(VV->VVOD_SPISOK_return_data(5),kprr,0,0) != 0)
    continue;


  /*Счет*/
  if(proverka(VV->VVOD_SPISOK_return_data(6),row[1],0,0) != 0)
    continue;
      
  muf++;  
  rsdat(&d,&m,&g,row[0],2);
  rsdat(&dd,&md,&gd,row[9],2);
  
  fprintf(ff1,"%d|%s|%s|%s|%s %s|%d|%d|%d|%s,%s|%d|%d|%d|%.2f|%s|\n",
  tipz,kprr,row[5],kontr,row[4],nomdokv,g,m,d,
  row[1],row[2],dd,md,gd,atof(row[7]),row[10]);

 }

fclose(ff1);

if(muf == 0)
 {
  unlink(imaftmp);
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

//sprintf(strsql,"sort -o %s -t\\| +0n +1 +2n +3n +4 %s",imaftmp,imaftmp);
sprintf(strsql,"sort -o %s -t\\| -k1,2n -k2,1 -k3,4n -k4,3n -k5 %s",imaftmp,imaftmp);
//runsystem(strsql);
iceb_t_system(strsql,0);

if((ff1 = fopen(imaftmp,"r")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }

sprintf(imaf,"rp%d%d.lst",mn,mk);

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }


time(&tmm);
bf=localtime(&tmm);
kst=0;

if(VV->VVOD_SPISOK_return_data(2)[0] != '\0')
 {
  kst++;
  fprintf(ff,"%s: %s\n",gettext("Подразделение"),VV->VVOD_SPISOK_return_data(2));
 }
if(VV->VVOD_SPISOK_return_data(3)[0] != '\0')
 {
  kst++;
 fprintf(ff,"%s: %s\n",gettext("Код контрагента"),VV->VVOD_SPISOK_return_data(3));
 }
if(VV->VVOD_SPISOK_return_data(4)[0] != '\0')
 {
  kst++;
  fprintf(ff,"%s: %s\n",gettext("Вид операции"),VV->VVOD_SPISOK_return_data(4));
 }
if(VV->VVOD_SPISOK_return_data(5)[0] != '\0')
 {
  kst++;
  fprintf(ff,"%s: %s\n",gettext("Код операции"),VV->VVOD_SPISOK_return_data(5));
 }
if(VV->VVOD_SPISOK_return_data(6)[0] != '\0')
 {
  kst++;
  fprintf(ff,"%s: %s\n",gettext("Счет"),VV->VVOD_SPISOK_return_data(6));
 }
if(VV->VVOD_SPISOK_return_data(7)[0] != '\0')
 {
  kst++;
  fprintf(ff,gettext("Набор операций: %s\n"),VV->VVOD_SPISOK_return_data(7));
 }



skl=0;
memset(kontr,'\0',sizeof(kontr));
memset(sh1,'\0',sizeof(sh1));
memset(nomdok,'\0',sizeof(nomdok));
memset(nomdokv,'\0',sizeof(nomdokv));
memset(kprr1,'\0',sizeof(kprr1));

tipzz=kom=0;
klr=sli=0;
itd=0.;
kome[0]='\0';

kolstr1=0;
while(fgets(str,sizeof(str),ff1) != NULL)
 {
  kolstr1++;
  strzag(LINES-1,0,muf,kolstr1);

  polen(str,&tz,1,'|');

  polen(str,kprr,sizeof(kprr),2,'|');

  polen(str,&skl1,3,'|');

  polen(str,orgn,sizeof(orgn),4,'|');

  polen(str,nomdok,sizeof(nomdok),5,'|');

  polen(str,&gp,6,'|');

  polen(str,&mp,7,'|');

  polen(str,&dp,8,'|');

  polen(str,shett,sizeof(shett),9,'|');

  polen(str,&dd,10,'|');

  polen(str,&md,11,'|');

  polen(str,&gd,12,'|');

  polen(str,&deb,13,'|');

  polen(str,kome,sizeof(kome),14,'|');
   
  if(SRAV(kprr,kprr1,0) != 0 || tipzz != tz)
   {
    if(kprr1[0] != '\0' )
     {
      rasis(orgn,itd,dn,mn,gn,dk,mk,gk,skl1,naikont,naiskl,&sli,&kst,&mso,&mspo,&mss,&msps,ff);
      itd=0.;
      rasoi(&mssi,&mspsi,ff);


      fprintf(ff,"\f");
     }
    skl=0;
    memset(nomdokv,'\0',sizeof(nomdokv));
    memset(kontr,'\0',sizeof(kontr));

    /*Читаем наименование операции*/
    memset(naimpr,'\0',sizeof(naimpr));
    if(tz == 1)
     sprintf(strsql,"select naik from Uospri where kod='%s'",kprr);
    if(tz == 2)
     sprintf(strsql,"select naik from Uosras where kod='%s'",kprr);

    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      beep();
      printw(gettext("Не нашли код операции %s !"),kprr);
      printw("\n");
      fprintf(ff,gettext("Не нашли код операции %s !"),kprr);
      fprintf(ff,"\n");
      OSTANOV();
     }
    else
     strncpy(naimpr,row1[0],sizeof(naimpr)-1);
     
    strcpy(kprr1,kprr);
    tipzz=tz;
    /*move(5,0); */
    printw("%d/%s %s\n",tz,kprr,naimpr);
//    refresh();
    if(tz == 1)
     strcpy(bros,gettext("(приход)"));
    if(tz == 2)
     strcpy(bros,gettext("(расход)"));

    /*Читаем наименование подразделения*/
    memset(naiskl,'\0',sizeof(naiskl));
    sprintf(strsql,"select naik from Uospod where kod=%d",skl1);

    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      beep();
      printw("%s %d !\n",gettext("Нет найден код подразделения"),skl1);
      fprintf(ff,"%s %d !\n",gettext("Нет найден код подразделения"),skl1);
      OSTANOV();
     }
    else
     strncpy(naiskl,row1[0],sizeof(naiskl)-1);
          
    fprintf(ff,"%s\n\
%s %s - \"%s\" (%s) %s %d.%d.%d%s %s %d.%d.%d%s\n\
%s %d.%d.%d%s  %s: %d:%d\n",
organ,
gettext("Реестр проводок по виду операции"),
kprr,naimpr,bros,
gettext("за период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

    kst+=3;
    klr+=sli;
    sli=0;
    uosrp1_sapka(skl1,naiskl,dn,mn,gn,dk,mk,gk,&sli,&kst,ff);

   }

  if(skl != skl1)
   {
    if(skl != 0)
     {
      rasis(orgn,itd,dn,mn,gn,dk,mk,gk,skl1,naikont,naiskl,&sli,&kst,&mso,&mspo,&mss,&msps,ff);
      itd=0.;
      kst=0;
      klr+=sli;
      sli=0;
      fprintf(ff,"\f");
     }
    memset(shettz,'\0',sizeof(shettz));
    memset(nomdokv,'\0',sizeof(nomdokv));
    memset(kontr,'\0',sizeof(kontr));
    kom=1;


    /*Читаем наименование подразделения*/
    memset(naiskl,'\0',sizeof(naiskl));
    sprintf(strsql,"select naik from Uospod where kod=%d",skl1);

    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      beep();
      printw("%s %d !\n",gettext("Нет найден код подразделения"),skl1);
      fprintf(ff,"%s %d !\n",gettext("Нет найден код подразделения"),skl1);
      OSTANOV();
     }
    else
     strncpy(naiskl,row1[0],sizeof(naiskl)-1);

    printw("%s %d %s\n",gettext("Подразделение"),skl1,naiskl);
//    refresh();
    skl=skl1;
   }

  if(SRAV(kontr,orgn,0) != 0)
   {
    if(kontr[0] != '\0')
     {
      rasio(orgn,itd,dn,mn,gn,dk,mk,gk,skl1,naikont,naiskl,&sli,&kst,&mso,&mspo,ff);
      itd=0.;
     }
    memset(nomdokv,'\0',sizeof(nomdokv));
    memset(shettz,'\0',sizeof(shettz));
    kom=1;

    memset(bros,'\0',sizeof(bros));
    memset(kop,'\0',sizeof(kop));
    if(ATOFM(orgn) == 0. && POLE(orgn,bros,1,'-') == 0 && orgn[0] == '0')
     strcpy(kop,bros);
    else
     strcpy(kop,orgn);

    memset(naikont,'\0',sizeof(naikont)-1);

    sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",kop);

    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      beep();
      printw("%s %s !\n",gettext("Не нашли код контрагента"),kop);
      OSTANOV(); 
     }
    else
     strncpy(naikont,row1[0],sizeof(naikont)-1);

    printw(gettext("Контрагент %s %s"),orgn,naikont);
    printw("\n");
//    refresh();
    strcpy(kontr,orgn);
   }
  if(SRAV(nomdok,nomdokv,0) != 0)
   {
      if(nomdokv[0] != '\0')
       {
	rasid(itd,dn,mn,gn,dk,mk,gk,skl1,naiskl,&sli,&kst,ff);
	itd=0.;
       }
      strcpy(nomdokv,nomdok);
   }



     /*Записываем в массив организаций*/
   if((i=mso.find(shett)) < 0)
    mso.plus(shett);
   mspo.plus(deb,i);

   /*Записываем в массив по складу*/
   if((i=mss.find(shett)) < 0)
    mss.plus(shett);
   msps.plus(deb,i);

   /*Записываем в массив по складам */
   if((i=mssi.find(shett)) < 0)
    mssi.plus(shett);
    
   mspsi.plus(deb,i);

   /*Записываем в массив по складам и операциям*/
   if((i=mssio.find(shett)) < 0)
    mssio.plus(shett);
   mspsio.plus(deb,i);

   uosrp1_shetchik(dn,mn,gn,dk,mk,gk,&sli,&kst,skl1,naiskl,ff);

   printw("%02d.%02d.%4d %02d.%02d.%4d %-11s %-11s %15.2f\n",
   dp,mp,gp,dd,md,gd,nomdok,shett,deb);
//   refresh();
   if(kom == 1)
     fprintf(ff,"\
%-*s %-*s %02d.%02d.%4d %02d.%02d.%4d %-*s %-*s %20s\n",
     iceb_tu_kolbait(7,orgn),orgn,
     iceb_tu_kolbait(52,naikont),naikont,
     dd,md,gd,dp,mp,gp,
     iceb_tu_kolbait(11,nomdok),nomdok,
     iceb_tu_kolbait(11,shett),shett,
     prnbr(deb));

   if(kom == 0)
     fprintf(ff,"\
%60s %02d.%02d.%4d %02d.%02d.%4d %-*s %-*s %20s %s\n",
    " ",dd,md,gd,dp,mp,gp,
     iceb_tu_kolbait(11,nomdok),nomdok,
     iceb_tu_kolbait(11,shett),shett,
    prnbr(deb),kome);

   itd+=deb;
   kom=0;

 }
rasis(orgn,itd,dn,mn,gn,dk,mk,gk,skl1,naikont,naiskl,&sli,&kst,&mso,&mspo,&mss,&msps,ff);
rasoi(&mssi,&mspsi,ff);

if(VV->VVOD_SPISOK_return_data(5)[0] == '\0' || ( VV->VVOD_SPISOK_return_data(5)[0] != '\0' && POLE(VV->VVOD_SPISOK_return_data(5),shett1,2,',') == 0))
 {
  k1=0.;
  fprintf(ff,"\n==================================================\n\
%s:\n",
  gettext("Общий итог по всем операциям"));
  for(i=0; i< mssio.kolih() ;i++)
   {
    //POLE(mssio,shett1,i+1,' ');
    fprintf(ff,"%-*s - %20s\n",iceb_tu_kolbait(10,mssio.ravno(i)),mssio.ravno(i),prnbr(mspsio.ravno(i)));
    k1+=mspsio.ravno(i);
   }
  fprintf(ff,"%-*s - %20s\n",iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),prnbr(k1));
 }

unlink(imaftmp);


podpis(ff);
fclose(ff);

sprintf(imafitog,"rpit%d.lst",getpid());

if((ffitog = fopen(imafitog,"w")) == NULL)
   {
    error_op_nfil(imafitog,errno,"");
    return(1);
   }
zagolov(gettext("Реестр проводок по виду операции"),bf,dn,mn,gn,dk,mk,gk,organ,ffitog);

if(VV->VVOD_SPISOK_return_data(2)[0] != '\0')
 fprintf(ffitog,"%s: %s\n",gettext("Подразделение"),VV->VVOD_SPISOK_return_data(2));
if(VV->VVOD_SPISOK_return_data(3)[0] != '\0')
 fprintf(ffitog,"%s: %s\n",gettext("Код контрагента"),VV->VVOD_SPISOK_return_data(3));
if(VV->VVOD_SPISOK_return_data(4)[0] != '\0')
 fprintf(ffitog,"%s: %s\n",gettext("Вид операции"),VV->VVOD_SPISOK_return_data(4));
if(VV->VVOD_SPISOK_return_data(5)[0] != '\0')
 fprintf(ffitog,"%s: %s\n",gettext("Код операции"),VV->VVOD_SPISOK_return_data(5));
if(VV->VVOD_SPISOK_return_data(6)[0] != '\0')
 fprintf(ffitog,"%s: %s\n",gettext("Счет"),VV->VVOD_SPISOK_return_data(6));
if(VV->VVOD_SPISOK_return_data(7)[0] != '\0')
 fprintf(ffitog,gettext("Набор операций: %s\n"),VV->VVOD_SPISOK_return_data(7));


k1=0.;
fprintf(ffitog,"\n==================================================\n\
%s:\n",
gettext("Общий итог по всем операциям"));
for(i=0; i< mssio.kolih() ;i++)
 {
  fprintf(ffitog,"%-*s - %20s\n",iceb_tu_kolbait(10,mssio.ravno(i)),mssio.ravno(i),prnbr(mspsio.ravno(i)));
  k1+=mspsio.ravno(i);
 }
fprintf(ffitog,"%-*s - %20s\n",iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),prnbr(k1));

podpis(ffitog);
fclose(ffitog);


klr+=sli;

printw("%s: %d\n",
gettext("Количество листов"),klr);

time(&tmmk);
k1=(tmmk-tmmn)/60.;
k1=modf(k1,&s1);

printw("\n%s %.f%s %.f%s\n",
gettext("Время расчета"),
s1,
gettext("мин."),
k1*60.,
gettext("сек."));


OSTANOV();

sprintf(strsql,"%s %s",imaf,imafitog);

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Реестр проводок по видам операций."));
oth->spis_imaf.plus(imafitog);
oth->spis_naim.plus(gettext("Общие итоги"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),1);


return(0);
}


/*******/
/*Шапка*/
/*******/
void uosrp1_sapka(int skl1,const char *naiskl,
short dn,short mn,short gn,
short dk,short mk,short gk,
int *kollist,int *kolstrok,FILE *ff)
{
*kolstrok+=4;
*kollist+=1;

fprintf(ff,"\
%s N%-2d %-30s %s %02d.%02d.%4d%s %s %02d.%02d.%4d%s                               %s%d\n",
gettext("Подразделение"),
skl1,naiskl,
gettext("Период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("Лист N"),
*kollist);

fprintf(ff,"\
------------------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
	        Контрагент                                  |Дата док. |Дата пров.|N документа|  Счета   |       Сумма        |Коментарий\n"));
fprintf(ff,"\
------------------------------------------------------------------------------------------------------------------------------------------\n");

}

/*******/
/*Счётчик строк*/
/*******/
void uosrp1_shetchik(short dn,short mn,short gn,short dk,short mk,
short gk,int *sl,int *kst,int skl1,char naiskl[],FILE *ff)
{
*kst+=1;

if(*kst <=  kol_strok_na_liste)
 return;

*kst=1;
uosrp1_sapka(skl1,naiskl,dn,mn,gn,dk,mk,gk,sl,kst,ff);


}

/*******************************/
/*Распечатка итога по документа*/
/*******************************/
void            rasid(double itd,short dn,short mn,short gn,short dk,
short mk,short gk,int skl1,char naiskl[],int *sli,int *kst,FILE *ff)
{
 fprintf(ff,"%*s %20s\n",iceb_tu_kolbait(106,gettext("Итого по документа:")),gettext("Итого по документа:"),prnbr(itd));
 uosrp1_shetchik(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
}

/*******************************/
/*Распечатка итога по организации*/
/*******************************/
void            rasio(char orgn[],double itd,short dn,short mn,short gn,
short dk,short mk,short gk,int skl1,
char naikont[], //Наименование контрагента
char naiskl[],  //Наименование подразделения
int *sli,int *kst,
class SPISOK *mso,
class masiv_din_double *mspo,
FILE *ff)
{
short           i;
double          bb;

rasid(itd,dn,mn,gn,dk,mk,gk,skl1,naiskl,sli,kst,ff);

/*Распечатываем результаты по организации*/
bb=0.;
if(mso->kolih() > 0)
 {
  uosrp1_shetchik(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
  fprintf(ff,"%s \"%s\":\n",gettext("Итого по контрагенту"),naikont);
 }
/*printw("kso- %d\n",kso);*/

for(i=0; i < mso->kolih() ;i++)
 {
  uosrp1_shetchik(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
  fprintf(ff,"%-*s - %20s\n",iceb_tu_kolbait(10,mso->ravno(i)),mso->ravno(i),prnbr(mspo->ravno(i)));
  bb+=mspo->ravno(i);
 }
if(mso->kolih() > 0)
 {
  fprintf(ff,"%-*s - %20s\n",iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),prnbr(bb));
  kst++;
  fprintf(ff,"\
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .\n");
  uosrp1_shetchik(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
 }
mso->free_class();
mspo->free_class();
}
/*******************************/
/*Распечатка итога по складу*/
/*******************************/
void rasis(char orgn[],double itd,short dn,short mn,short gn,
short dk,short mk,short gk,int skl1,char naikont[],char naiskl[],
int *sli,int *kst,
class SPISOK *mso,
class masiv_din_double *mspo,
class SPISOK *mss,
class masiv_din_double *msps,
FILE *ff)
{
short           i;
double          bb;

rasio(orgn,itd,dn,mn,gn,dk,mk,gk,skl1,naikont,naiskl,sli,kst,mso,mspo,ff);

/*Распечатываем результаты по складу*/
uosrp1_shetchik(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
fprintf(ff,"%s \"%s\":\n",gettext("Итого по подразделению"),naiskl);
bb=0.;
for(i=0; i< msps->kolih() ;i++)
 {
  uosrp1_shetchik(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
  fprintf(ff,"%-*s - %20s\n",iceb_tu_kolbait(10,mss->ravno(i)),mss->ravno(i),prnbr(msps->ravno(i)));
  bb+=msps->ravno(i);
 }
fprintf(ff,"%-*s - %20s\n",iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),prnbr(bb));

fprintf(ff,"\
...............................................................................................................................\n");
uosrp1_shetchik(dn,mn,gn,dk,mk,gk,sli,kst,skl1,naiskl,ff);
mss->free_class();
msps->free_class();
}

/*************************/
/*Распечатка общего итога*/
/*************************/
void            rasoi(class SPISOK *mssi,class masiv_din_double *mspsi,FILE *ff)
{
double          k1;
short           i;

k1=0.;
fprintf(ff,"\n%s:\n",gettext("Общий итог"));
for(i=0; i< mssi->kolih() ;i++)
 {
  fprintf(ff,"%-*s - %20s\n",iceb_tu_kolbait(10,mssi->ravno(i)),mssi->ravno(i),prnbr(mspsi->ravno(i)));
  k1+=mspsi->ravno(i);
 }
fprintf(ff,"%-*s - %20s\n",iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),prnbr(k1));
mssi->free_class();
mspsi->free_class();
}
