/* $Id: uosrsd.c,v 5.16 2011-01-13 13:43:24 sasa1 Exp $ */
/*04.11.2009    22.08.1997      Белых А.И.      uosrsd.c
Распечатка перечня документов по группе 2 и 3 или инвентарному
номеру
*/
#include        <time.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char     *organ;

int uosrsd(long in)
{
struct  tm      *bf;
time_t 		tmm;
long		innom;
FILE		*ff;
char		imaf[32];
long		kolstr;
SQL_str         row,row1;
SQLCURSOR curr;
char		strsql[512];
char		shetu[32]; /*Счет учета*/
char		hzt[32];   /*Шифр затрат*/
char		hau[32];   /*Шифр аналитического учета*/
char		hna[32],hna1[32];   /*Шифр нормы амортотчислений*/
float		popkf;   /*Поправочный коэффициент*/
char		hna1by[32];   /*Шифр нормы амортотчислений*/
float		popkfby;   /*Поправочный коэффициент*/
int		soso;    /*Состояние объекта*/
char		nomz[112];  /*Номерной знак*/
short		mz,gz;   /*дата записи*/
short		d,m,g;
short		tp;
char		kontr[32];
char		kodop[32];
short		podt=0;
double		bs,iz,bsby,izby;
double		ibs=0.,iiz=0.;
double		ibsby=0.,iizby=0.;

sprintf(hna,"%ld",in*(-1));

if(in < 0)
 sprintf(strsql,"select datd,innom,tipz,nomd,bs,iz,bsby,izby \
from Uosdok1");
else
 sprintf(strsql,"select datd,innom,tipz,nomd,bs,iz,bsby,izby \
from Uosdok1 where innom=%ld",in);

class SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
   msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }



clear();
GDITE();
time(&tmm);
bf=localtime(&tmm);

sprintf(imaf,"us%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return(1);
   }

zagolov(gettext("Распечатка записей документов."),bf,0,0,0,0,0,0,organ,ff);
if(in < 0)
 printw("%s %ld\n",gettext("Группа"),in*(-1));
else
 printw("%s %ld\n",gettext("Инвентарный номер"),in);

printw("\
--------------------------------------------------------------------------\n");

printw(gettext("\
Инвент.|О|  Дата    |Номер|Опе|Контр|Налоговый учет   |Бухгалтерский уч.|\n"));

printw(gettext("\
номер  | | документа|докум|рац|агент|Бал.ст. | Износ  |Бал.ст. | Износ  |\n"));

printw("\
--------------------------------------------------------------------------\n");
if(in < 0)
  fprintf(ff,"%s %ld\n",gettext("Группа"),in*(-1));
else
 fprintf(ff,"%s %ld\n",gettext("Инвентарный номер"),in);

fprintf(ff,"\
---------------------------------------------------------------------------------\n");

fprintf(ff,gettext("\
Инвент.|О|  Дата    |Номер|Опе|Контр|Налоговый учет   |Бухгалтерский уч.|\n"));

fprintf(ff,gettext("\
номер  | | документа|докум|рац|агент|Бал.ст. | Износ  |Бал.ст. | Износ  |\n"));

fprintf(ff,"\
---------------------------------------------------------------------------------\n");

refresh();
while(cur.read_cursor(&row) != 0)
 {
  rsdat(&d,&m,&g,row[0],2);
  innom=atol(row[1]);
  
  /*Читаем переменные данные*/

  poiinpd(innom,m,g,shetu,hzt,hau,hna1,&popkf,&soso,nomz,&mz,&gz,hna1by,&popkfby);

  if(in < 0)
   if(SRAV(hna,hna1,0) != 0)
    continue;

  tp=atoi(row[2]);
  bs=atof(row[4]);
  iz=atof(row[5]);
  bsby=atof(row[6]);
  izby=atof(row[7]);
  if(tp == 2)
   {
    bs*=-1;
    bsby*=-1;
    izby*=-1;
   }  

  /*Читаем шапку документа*/
  sprintf(strsql,"select kontr,kodop,podt from Uosdok where datd='%d.%02d.%02d' and \
  nomd='%s'",g,m,d,row[3]);

  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %s %d.%d.%d%s",
    gettext("Не найден документ !"),row[3],d,m,g,
    gettext("г."));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    strncpy(kontr,row1[0],sizeof(kontr)-1);
    strncpy(kodop,row1[1],sizeof(kodop)-1);
    podt=atoi(row1[2]);
   }  

  printw("%7ld ",innom);
  fprintf(ff,"%7ld ",innom);

  if(tp == 1)
   {
    printw("+");
    fprintf(ff,"+");
   }
  if(tp == 2)
   {
    printw("-");
    fprintf(ff,"-");
   }

  printw(" %02d.%02d.%d %-*s %-*s %-*s %8.2f %8.2f %8.2f %8.2f",
  d,m,g,
  iceb_tu_kolbait(5,row[3]),row[3],
  iceb_tu_kolbait(3,kodop),kodop,
  iceb_tu_kolbait(5,kontr),kontr,
  bs,iz,bsby,izby);
  refresh();
  
  fprintf(ff," %02d.%02d.%d %-*s %-*s %-*s %8.2f %8.2f %8.2f %8.2f",
  d,m,g,
  iceb_tu_kolbait(5,row[3]),row[3],
  iceb_tu_kolbait(3,kodop),kodop,
  iceb_tu_kolbait(5,kontr),kontr,
  bs,iz,bsby,izby);
  
  ibs+=bs;
  iiz+=iz;
  ibsby+=bsby;
  iizby+=izby;
  if(podt == 0)
   {
    printw(" %5.5s\n",gettext("Не подтвержден"));
    fprintf(ff," %s\n",gettext("Не подтвержден"));
   }
  if(podt == 1)
   {
    printw(" %5.5s\n",gettext("Подтвержден"));
    fprintf(ff," %s\n",gettext("Подтвержден"));
   }
 }

printw("%*s %8.2f %8.2f %8.2f %8.2f\n",iceb_tu_kolbait(36,gettext("Итого")),gettext("Итого"),ibs,iiz,ibsby,iizby);
fprintf(ff,"%*s %8.2f %8.2f %8.2f %8.2f\n",iceb_tu_kolbait(36,gettext("Итого")),gettext("Итого"),ibs,iiz,ibsby,iiz);

fclose(ff);

OSTANOV();

class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Список документов"));
iceb_t_ustpeh(imaf,1);

iceb_t_ustpeh(imaf,0);

iceb_t_rabfil(&oth,"");
return(0);
}
