/* $Id: uosvamotby.c,v 5.58 2011-07-21 12:42:32 sasa Exp $ */
/*16.12.2009    06.12.2000      Белых А.И.      uosvamotby.c
Получение ведомости амортизационных отчислений для бухучета
*/
#include        <time.h>
#include        <math.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void strms(short,short,short,FILE*);
void strpod(short,short,short,FILE*);
void rasmes(short,short,double[],double,char[],FILE*);
void uosshapbu(short mn,short gn,short mk,short gk,struct tm *bf,short *sl,short mr,FILE *ffi,short *kst);
void shvambu(short mn,short gn,short mk,short gk,short *sl,short *kst,int orient,short mr,FILE *ff,struct tm *bf);
void itamobu(short mn,short mk,double itg[],short mr,double maotpo[12],FILE *ff,FILE *ffi);
void itambu(short mn,short gn,short mk,short gk,double itg[],char nai[],int orient,short mr,double maotp[12],FILE *ff,FILE *ffi,short *sli,short *kst,struct tm *bf);
void itamhbu(short mn,short gn,short mk,short gk,double itg[],char *kod,char *nai,int orient,short mr,double maotph[12],FILE *ff,FILE *ffi,int metkaitog,short *sli,short *kst,struct tm *bf);

extern char     *organ;/*Наименование организации*/
extern int      kol_strok_na_liste; //Количество строк на листе в портретной ориентации
extern int      kol_strok_na_liste_l; //Количество строк на листе в ландшафтной ориентации
extern class iceb_tu_str spis_print_a3;

int uosvamotby(class spis_oth *oth)
{
struct  tm      *bf;
double          maotp[12];
double          maotph[12];
double          maotpo[12];
FILE            *ff,*ffi;
char            bros[512];
double          maot[12];
time_t          tmm;
int           kom,kom1;
short           d,mn,gn,mk,gk,mp,gp;
int             pod,pod1;
char            imaf[56],imafi[56];
short           sli=0,kst=0;
short           slii=0,ksti=0;
long            in,in1;
int             i;
double          sbs,siz,bs,iz,iz0;
double          sbsby,sizby,bsby,izby,iz0by;
double          god=0,mes=0;
short           mvr; /*Метка выдачи результата*/
const int RAZMER_MAS=6;
double          itg[RAZMER_MAS];
double          itg1[RAZMER_MAS];
double          itg2[RAZMER_MAS];
static char     dat1[8],dat2[8];
char            naimhz[512];
char            naipod[512];
double          ostt=0;
char		hna[56],hnaz1[56];
char		hzt1[56],hzt2[56]; /*Шифр затрат*/
static char     hnaz[112];
static char     hzt[112];
static char     podd[112];
static char	godd[5];
static char     invnom[112];
static char     shetu_poi[112];
static char  kod_mat_ot[112];
short		mr; /*Метка распечатки*/
char		naios[512]; /*Наименование основного средства*/
char		invn[32];
float		kof;
short		m1,g1;
short		m=0,g=0;
long		kolstr,kolstr1;
SQL_str         row,row1;
char		strsql[512];

double		sao;
SQLCURSOR curr;
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);
/*Переменные данные по инвентарному номеру*/
char		shetu[32]; /*Счет учета*/
char		hztp[32];   /*Шифр затрат*/
char		haup[32];   /*Шифр аналитического учета*/
char		hnap[32];   /*Шифр нормы амортотчислений*/
float		ppkf;   /*Поправочный коэффициент*/
char		hnapby[32];   /*Шифр нормы амортотчислений*/
float		ppkfby;   /*Поправочный коэффициент*/
int		soso;    /*Состояние объекта*/
char		nomz[112];  /*Номерной знак*/
char            gvve[5]; //Год ввода в эксплуатацию

VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка ведомости амортотчислений для бух.учета"));
VV.VVOD_SPISOK_add_data(dat1,3);
VV.VVOD_SPISOK_add_data(dat2,3);
if(godd[0] == '\0')
  sprintf(godd,"%d",gt);
VV.VVOD_SPISOK_add_data(godd,5);
VV.VVOD_SPISOK_add_data(hzt,sizeof(hzt));
VV.VVOD_SPISOK_add_data(podd,sizeof(podd));
VV.VVOD_SPISOK_add_data(hnaz,sizeof(hnaz));
VV.VVOD_SPISOK_add_data(invnom,sizeof(invnom));
VV.VVOD_SPISOK_add_data(shetu_poi,sizeof(shetu_poi));
VV.VVOD_SPISOK_add_data(kod_mat_ot,sizeof(kod_mat_ot));

VV.VVOD_SPISOK_add_MD(gettext("Месяц начала.(м)..."));//0
VV.VVOD_SPISOK_add_MD(gettext("Месяц конца..(м)..."));//1
VV.VVOD_SPISOK_add_MD(gettext("Год................"));//2
VV.VVOD_SPISOK_add_MD(gettext("Шифр затрат...(,,)."));//3
VV.VVOD_SPISOK_add_MD(gettext("Подразделение.(,,)."));//4
VV.VVOD_SPISOK_add_MD(gettext("Группа........(,,)."));//5
VV.VVOD_SPISOK_add_MD(gettext("Инв-ный номер.(,,)."));//6
VV.VVOD_SPISOK_add_MD(gettext("Счёт учёта....(,,)."));//7
VV.VVOD_SPISOK_add_MD(gettext("Код мат.ответ.(,,)."));//8

naz:;

clear();

helstr(LINES-1,0,"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(godd,VV.VVOD_SPISOK_return_data(2),sizeof(godd)-1);
memset(hzt,'\0',sizeof(hzt));
strncpy(hzt,VV.VVOD_SPISOK_return_data(3),sizeof(hzt)-1);

memset(podd,'\0',sizeof(podd));
strncpy(podd,VV.VVOD_SPISOK_return_data(4),sizeof(podd)-1);

memset(hnaz,'\0',sizeof(hnaz));
strncpy(hnaz,VV.VVOD_SPISOK_return_data(5),sizeof(hnaz)-1);
strncpy(invnom,VV.VVOD_SPISOK_return_data(6),sizeof(invnom)-1);
strncpy(shetu_poi,VV.VVOD_SPISOK_return_data(7),sizeof(shetu_poi)-1);
strncpy(kod_mat_ot,VV.VVOD_SPISOK_return_data(8),sizeof(kod_mat_ot)-1);

class iceb_tu_str kod_v("");
class iceb_tu_str naim_v("");
switch(kom)
 {
  case FK10:
  case ESC:
   return(1);
  case FK2:
  case PLU:
   break;

  case FK3:  /*Просмотр реквизитов*/
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка шифров затрат"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Uosgrup1",hnaz,sizeof(hnaz),naipod);
        VV.VVOD_SPISOK_zapis_data(5,hnaz);
        goto naz;
         
      case 1 :
        if(diruospod(1,&kod_v,&naim_v,0) == 0)
         VV.data_z_plus(4,kod_v.ravno());
        goto naz;

      case 2 :
        vibrek("Uoshz",hzt,sizeof(hzt),naipod);
        VV.VVOD_SPISOK_zapis_data(3,hzt);
        goto naz;

     }
    goto naz;
    

  case FK4: /*Очистить меню*/

    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
 }

sprintf(bros,"%s.%s",VV.VVOD_SPISOK_return_data(0),VV.VVOD_SPISOK_return_data(2));
if(rsdat1(&mn,&gn,bros) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
if(VV.VVOD_SPISOK_return_data(1)[0] != '\0')
 {
  sprintf(bros,"%s.%s",VV.VVOD_SPISOK_return_data(1),VV.VVOD_SPISOK_return_data(2));
  if(rsdat1(&mk,&gk,bros) != 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конца !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
 }
else
 {
  mk=mn; gk=gn;
 }

time(&tmm);
bf=localtime(&tmm);

clear();

GDITE();


int kol_mes_v_per=period(1,mn,gn,1,mk,gk,1);

if(kol_mes_v_per <=3)
 mr=1;
else
 mr=0;

int max_dlin_str=0;

if(mr == 1)
 max_dlin_str=141+(kol_mes_v_per+1)*11;
else
 max_dlin_str=72+(kol_mes_v_per+1)*11;

if(kol_mes_v_per == 1)
  max_dlin_str=141+11;

d=1;
mp=mn; gp=gn;
dpm(&d,&mp,&gp,2);


printw("%s %d.%d%s %s %d.%d%s (%d.%d)\n",
gettext("Период с"),
mn,gn,
gettext("г."),
gettext("до"),
mk,gk,
gettext("г."),
mp,gp);
refresh();

sprintf(strsql,"select innom,mes,god,podr,hzt,hna,suma from Uosamor1 \
where god = %d and mes >= %d and mes <= %d order by \
hzt,podr,innom,god,mes asc",
gn,mn,mk);
class SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);  
 }

short pdm=0;
dpm(&pdm,&mk,&gk,5);

sprintf(imaf,"vaoby%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }
int orient=1;
if(proverka(spis_print_a3.ravno(),getenv("PRINTER"),0,1) == 0)
  orient=0; /*Если принтер А4 то ориентация портрет*/


zagolov(gettext("Ведомость амортизационных отчислений"),1,mn,gn,pdm,mk,gk,organ,ff);

fprintf(ff,"%s\n",gettext("Бухгалтерский учет"));
kst=6;

if(hnaz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Група"),hnaz);
  kst++;
 }
if(podd[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Подразделение"),podd);
  kst++;
 }
if(hzt[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Шифр затрат"),podd);
  kst++;
 }
if(invnom[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Инвентарный номер"),invnom);
  kst++;
 }
if(shetu_poi[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Счёт"),shetu_poi);
  kst++;
 }
if(kod_mat_ot[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Код материально-ответсвенного"),kod_mat_ot);
  kst++;
 }

sprintf(imafi,"vaobyi%d.lst",getpid());

if((ffi = fopen(imafi,"w")) == NULL)
 {
  error_op_nfil(imafi,errno,"");
  return(1);
 }



zagolov(gettext("Ведомость амортизационных отчислений"),1,mn,gn,pdm,mk,gk,organ,ffi);


fprintf(ffi,"%s\n",gettext("Бухгалтерский учет"));

if(hnaz[0] != '\0')
 {
  fprintf(ffi,"%s: %s\n",gettext("Група"),hnaz);
 }
if(podd[0] != '\0')
 {
  fprintf(ffi,"%s: %s\n",gettext("Подразделение"),podd);
 }
if(hzt[0] != '\0')
 {
  fprintf(ffi,"%s: %s\n",gettext("Шифр затрат"),podd);
 }
if(invnom[0] != '\0')
 {
  fprintf(ffi,"%s: %s\n",gettext("Инвентарный номер"),invnom);
 }
if(shetu_poi[0] != '\0')
 {
  fprintf(ffi,"%s: %s\n",gettext("Счёт"),shetu_poi);
 }


uosshapbu(mn,gn,mk,gk,bf,&slii,mr,ffi,&ksti);

memset(hzt2,'\0',sizeof(hzt2));
in=0;
for(i=0; i< 12; i++)
    maot[i]=maotp[i]=maotph[i]=maotpo[i]=0.;
for(i=0;i<RAZMER_MAS;i++)
  itg[i]=itg1[i]=itg2[i]=0.;
naipod[0]=naimhz[0]='\0';

strncpy(naipod,organ,sizeof(naipod)-1);
memset(nomz,'\0',sizeof(nomz));
pod1=-100;
kolstr1=in1=mvr=0;
int vrabu; //Вариант расчета амотизации бухгалтерского учета

while(cur.read_cursor(&row) != 0)
 {
/****************
  if(SRAV("4000428",row[0],0) == 0)
   {
    printw("%s*%s*%s*%s*%s*%s*%s\n",
    row[0],row[1],row[2],row[3],row[4],row[5],row[6]);
    OSTANOV();
   }
***********/
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(proverka(invnom,row[0],0,0) != 0)
    continue;

  if(proverka(hzt,row[4],0,0) != 0)
    continue;

  if(proverka(podd,row[3],0,0) != 0)
    continue;

  if(proverka(hnaz,row[5],0,0) != 0)
    continue;

  in=atol(row[0]);
  m=atoi(row[1]);
  g=atoi(row[2]);
  pod=atoi(row[3]);
  strncpy(hzt1,row[4],sizeof(hzt1)-1);
  strncpy(hna,row[5],sizeof(hna)-1);
  sao=atof(row[6]);

  if(SRAV(hzt2,hzt1,0) != 0)
   {

    if(hzt2[0] != '\0')
     {
      rasmes(mn,mk,maot,ostt,hnaz1,ff);
      mvr=0;

      itambu(mn,gn,mk,gk,itg1,naipod,orient,mr,maotp,ff,ffi,&sli,&kst,bf);
      itamhbu(mn,gn,mk,gk,itg2,hzt2,naimhz,orient,mr,maotph,ff,ffi,1,&sli,&kst,bf);
      for(i=0;i<RAZMER_MAS;i++)
	itg1[i]=itg2[i]=0.;
      fprintf(ff,"\f");
      kst=0;
      pod1=0;
     }

    /*Читаем шифр производственных затрат*/
    memset(naimhz,'\0',sizeof(naimhz));
    sprintf(strsql,"select naik from Uoshz where kod='%s'",hzt1);
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      beep();
      printw("%s %s !",gettext("Не найден шифр производственных затрат"),hzt1);
      OSTANOV();
     }
    else
     {
      strncpy(naimhz,row1[0],sizeof(naimhz)-1);
     }          
    printw("%s: %s %s\n",gettext("Шифр производственных затрат"),hzt1,naimhz);
//    refresh(); 

    shvambu(mn,gn,mk,gk,&sli,&kst,orient,mr,ff,bf);

    fprintf(ff,"%s: %s %s\n",gettext("Шифр производственных затрат"),hzt1,naimhz);
    uosshapbu(mn,gn,mk,gk,bf,&sli,mr,ff,&kst);

    for(i=0; i< 12; i++)
     maotp[i]=maotph[i]=0.;

    strcpy(hzt2,hzt1);
   }
/*
    printw("pod1=%d pod=%d row[3]=%s\n",pod1,pod,row[3]);
    refresh();
*/
  if(pod1 != pod)
   {
//    printw("mvr=%d pod1=%d\n",mvr,pod1);
//    OSTANOV();
//    if(mvr > 0 && pod1 != 0)
    if(mvr > 0 )
     {
      rasmes(mn,mk,maot,ostt,hnaz1,ff);
      mvr=0;

      itambu(mn,gn,mk,gk,itg1,naipod,orient,mr,maotp,ff,ffi,&sli,&kst,bf);
      for(i=0;i<RAZMER_MAS;i++)
	itg1[i]=0.;
     }
    /*Читаем наименование подразделения*/
    memset(naipod,'\0',sizeof(naipod));
    if(in > 0)
     {
      sprintf(strsql,"select naik from Uospod where kod=%d",pod);
      if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
       {
        beep();
        printw("%s %d !\n",gettext("Не найден код подразделения"),pod);
        OSTANOV();
       }
      else
       strncpy(naipod,row1[0],sizeof(naipod)-1);
     }
    else
      strncpy(naipod,organ,sizeof(naipod)-1);

    printw("%s %d %s\n",gettext("Подразделение"),pod,naipod);
//    refresh();

    shvambu(mn,gn,mk,gk,&sli,&kst,orient,mr,ff,bf);
    fprintf(ff,"%s %d %s\n",gettext("Подразделение"),pod,naipod);

    shvambu(mn,gn,mk,gk,&sli,&kst,orient,mr,ff,bf);
    fprintf(ff,"------------------------------------\n");

    for(i=0; i< 12; i++)
     maotp[i]=0.;

    pod1=pod;
   }
  /*Узнаем поправочный коэффициент счёт учёта в данном месяце*/
  if(poiinpd(in,m,g,shetu,hztp,haup,hnap,&ppkf,&soso,nomz,&m1,&g1,hnapby,&ppkfby) != 0)
   {
    beep();
    printw("%ld инвентарный номер не числится %d.%dг. !!!\n",in,m,g);
    refresh();

    shvambu(mn,gn,mk,gk,&sli,&kst,orient,mr,ff,bf);
    fprintf(ff,"%ld инвентарный номер не числится %d.%dг. !!!\n",in,m,g);

   }

  if(proverka(shetu_poi,shetu,0,0) != 0)
    continue;

  if(in1 != in)
   {
//    printw("mvr=%d in1=%ld\n",mvr,in1);
//    refresh();
    if(kod_mat_ot[0] != '\0')
     {
      int podr=0;
      int kod_ot=0;
      poiin(in,1,mn,gn,&podr,&kod_ot);
      if(proverka(kod_mat_ot,kod_ot,0,0) != 0)
        continue;
     }

    if(mvr > 0 && in1 != 0)
     {
      rasmes(mn,mk,maot,ostt,hnaz1,ff);
      mvr=0;
     }
    in1=in;

    for(i=0; i< 12; i++)
     maot[i]=0.;

    memset(naios,'\0',sizeof(naios));
    memset(gvve,'\0',sizeof(gvve));

    /*Читаем наименование объекта*/
    memset(naios,'\0',sizeof(naios));
    sprintf(strsql,"select naim,datvv from Uosin where innom=%ld",in);
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      beep();
      printw("%s %ld !\n",
      gettext("Не найден инвентарный номер"),in);
      OSTANOV();
     }
    else
     {
      strncpy(naios,row1[0],sizeof(naios)-1);
      if(row1[1][0] != '\0')
       {
        short dv,mv,gv;
        rsdat(&dv,&mv,&gv,row1[1],2);
        sprintf(gvve,"%d",gv);
//        strcat(naios," ");
//        strcat(naios,strsql);
       }
     }

    /*Читаем коэффициент*/

    sprintf(bros,"%s",hnapby);

    sprintf(strsql,"select naik,kof from Uosgrup1 where kod='%s'",bros);

    kof=0;
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      beep();
      printw("%ld %s %s !\n",in,gettext("Не найдено группу"),bros);
//      printw("В таблице Uosgrup1 !\n");
      OSTANOV();
      continue;
     }
    else
     {
      kof=atof(row1[1]);
     }

    /*На начало периода*/

    bsiz(in,pod1,1,mn,gn,&sbs,&siz,&bs,&iz,&iz0,&sbsby,&sizby,&bsby,&izby,&iz0by,0);
    bsby+=sbsby;
    izby+=iz0by+sizby;
    vrabu=uosprovar(hnapby,1);
    ostt=bsby-izby;

    double lik_st=uosgetls(in,1,mn,gn,1);

    if(vrabu == 1)
       god=(bsby-izby)*kof/100.;
    if(vrabu == 0)
       god=(bsby-lik_st)*kof/100.;

    mes=0.;
    if(god != 0.)
      mes=god/12.;


    itg[0]+=bsby;
    itg[1]+=izby;
    itg[2]+=ostt;
    itg[3]+=lik_st;    
    itg[4]+=god;
    itg[5]+=mes;

    itg1[0]+=bsby;
    itg1[1]+=izby;
    itg1[2]+=ostt;
    itg1[3]+=lik_st;
    itg1[4]+=god;
    itg1[5]+=mes;

    itg2[0]+=bsby;
    itg2[1]+=izby;
    itg2[2]+=ostt;
    itg2[3]+=lik_st;
    itg2[4]+=god;
    itg2[5]+=mes;

    sprintf(invn,"%ld",in);

    shvambu(mn,gn,mk,gk,&sli,&kst,orient,mr,ff,bf);

    fprintf(ff,"%-8s|%-*.*s|%4s|%-*.*s|%-*s|",
    invn,
    iceb_tu_kolbait(40,naios),iceb_tu_kolbait(40,naios),naios,
    gvve,
    iceb_tu_kolbait(10,nomz),iceb_tu_kolbait(10,nomz),nomz,
    iceb_tu_kolbait(5,hnapby),hnapby);

    if(mr == 1)
      fprintf(ff,"%5.2f|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5.2f|",kof,bsby,izby,ostt,lik_st,god,mes,ppkfby);
/*
    printw("*************mr=%d\n",mr);
    OSTANOV();
*/    
    mvr++;
    strcpy(hnaz1,hna);
   }

  maot[m-1]=sao;
  maotp[m-1]=maotp[m-1]+sao;
  maotph[m-1]=maotph[m-1]+sao;
  maotpo[m-1]=maotpo[m-1]+sao;
 }

rasmes(mn,mk,maot,ostt,hnaz,ff);

itambu(mn,gn,mk,gk,itg1,naipod,orient,mr,maotp,ff,ffi,&sli,&kst,bf);
itamhbu(mn,gn,mk,gk,itg2,hzt2,naimhz,orient,mr,maotph,ff,ffi,1,&sli,&kst,bf);
itamobu(mn,mk,itg,mr,maotpo,ff,ffi);

podpis(ff);
fclose(ff);

podpis(ffi);
fclose(ffi);

printw_vr(tmm);



OSTANOV();
oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Распечатка ведомости амортотчислений для бух.учета"));
oth->spis_imaf.plus(imafi);
oth->spis_naim.plus(gettext("Общие итоги"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),3);
 
return(0);

}
/*************************************************/
/*Шапка*/
/*************************************************/

void	uosshapbu(short mn,short gn,short mk,short gk,struct tm *bf,
short *sl,short mr,FILE *ffi,short *kst)
{
*sl+=1;
*kst+=5;

fprintf(ffi,"\
%s %d.%d.%d %s %s %d:%d %90s%s N%d\n",
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min,
"",gettext("Лист"),
*sl);

fprintf(ffi,"\
------------------------------------------------------------------------");
if(mr == 1)
 fprintf(ffi,"\
--------------------------------------------------------------------------------");

strpod(mn,mk,11,ffi);

fprintf(ffi,gettext("\
Инв-рный|        Н а и м е н о в а н и е         |Рік | Номерной |Шифр |"));

if(mr == 1)
  fprintf(ffi,gettext("Норма|Балансовая|   Износ  |Остаточная|Ликвидаци.|Годов. сумма|Мес. сумма|Коэфи|"));

strms(0,mn,mk,ffi);
fprintf(ffi,gettext("\
 номер  |             объекта                    |    |   знак   |н.ам.|"));
if(mr == 1)
  fprintf(ffi,gettext("а.отч|стоимость |          |бал. с-сть|стоимость |амортотчисл.|амортотчи.|циент|"));

strms(1,mn,mk,ffi);

fprintf(ffi,"\
------------------------------------------------------------------------");
if(mr == 1)
  fprintf(ffi,"\
--------------------------------------------------------------------------------");
strpod(mn,mk,11,ffi);
}
/*****************/
/*Шапка документа*/
/*****************/
void shvambu(short mn,short gn,short mk,short gk,short *sl,
short *kst,int orient,short mr,FILE *ff,struct tm *bf)
{

*kst+=1;
if(orient == 0) /*портрет*/
 {
  if(*kst <= kol_strok_na_liste)
    return;
 }
else /*ландшафт*/
  if(*kst <= kol_strok_na_liste_l)
   return;
  
fprintf(ff,"\f");

*kst=1;

uosshapbu(mn,gn,mk,gk,bf,sl,mr,ff,kst);

}
/*******************************/
/*Выдача итога по подразделению*/
/*******************************/
void itambu(short mn,short gn,short mk,short gk,double itg[],char nai[],int orient,short mr,
double maotp[12],FILE *ff,FILE *ffi,short *sli,short *kst,
struct tm *bf)

{
short           i;
double          vs;
char		bros[512];

shvambu(mn,gn,mk,gk,sli,kst,orient,mr,ff,bf);
fprintf(ff,"\
------------------------------------------------------------------------");
fprintf(ffi,"\
------------------------------------------------------------------------");
if(mr == 1)
 {
  fprintf(ff,"\
--------------------------------------------------------------------------------");
  fprintf(ffi,"\
--------------------------------------------------------------------------------");
 }

strpod(mn,mk,11,ff);
strpod(mn,mk,11,ffi);

memset(bros,'\0',sizeof(bros));
sprintf(bros,"%s %s",gettext("Итого по подразделению"),nai);

shvambu(mn,gn,mk,gk,sli,kst,orient,mr,ff,bf);

fprintf(ff,"%-*.*s|",iceb_tu_kolbait(71,bros),iceb_tu_kolbait(71,bros),bros);
fprintf(ffi,"%-*.*s|",iceb_tu_kolbait(71,bros),iceb_tu_kolbait(71,bros),bros);


if(mr == 1)
 {
  fprintf(ff,"%5s|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5s|",
" ",itg[0],itg[1],itg[2],itg[3],itg[4],itg[5]," ");
  fprintf(ffi,"%5s|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5s|",
" ",itg[0],itg[1],itg[2],itg[3],itg[4],itg[5]," ");
 }
vs=0.;
for(i=mn-1 ;i<mk ;i++)
 {
  vs+=maotp[i];
  fprintf(ff,"%10.2f|",maotp[i]);
  fprintf(ffi,"%10.2f|",maotp[i]);
 }
if(mn != mk)
 {
  fprintf(ff,"%10.2f|",vs);
  fprintf(ffi,"%10.2f|",vs);
  printw("%s: %.2f\n",gettext("Итого по подразделению"),vs);
 }
else
  printw("%s: %.2f\n",gettext("Итого по подразделению"),maotp[mn-1]);

fprintf(ff,"\n");
fprintf(ffi,"\n");

}
/*******************************/
/*Выдача итога по шифру нормы амортотчислений или группе*/
/*******************************/
void itamhbu(short mn,short gn,short mk,short gk,double itg[],
char *kod,
char *nai,
int orient,
short mr,
double maotph[12],FILE *ff,FILE *ffi,
int metkaitog,  //0-по группе 1-по шифру
short *sli,short *kst,
struct tm *bf)
{
short           i;
double          vs;
char		bros[512];

shvambu(mn,gn,mk,gk,sli,kst,orient,mr,ff,bf);
fprintf(ff,"\
------------------------------------------------------------------------");
fprintf(ffi,"\
------------------------------------------------------------------------");

if(mr == 1)
 {
  fprintf(ff,"\
--------------------------------------------------------------------------------");
  fprintf(ffi,"\
--------------------------------------------------------------------------------");
 }
strpod(mn,mk,11,ff);
strpod(mn,mk,11,ffi);
if(metkaitog == 0)
  sprintf(bros,"%s %s %s",gettext("Итого по группе"),kod,nai);
if(metkaitog == 1)
  sprintf(bros,"%s %s %s",gettext("Итого по шифру"),kod,nai);

shvambu(mn,gn,mk,gk,sli,kst,orient,mr,ff,bf);
fprintf(ff,"%-*.*s|",iceb_tu_kolbait(71,bros),iceb_tu_kolbait(71,bros),bros);
fprintf(ffi,"%-*.*s|",iceb_tu_kolbait(71,bros),iceb_tu_kolbait(71,bros),bros);

if(mr == 1)
 {
  fprintf(ff,"%5s|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5s|",
" ",itg[0],itg[1],itg[2],itg[3],itg[4],itg[5]," ");
  fprintf(ffi,"%5s|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5s|",
" ",itg[0],itg[1],itg[2],itg[3],itg[4],itg[5]," ");
 }
vs=0.;
for(i=mn-1 ;i<mk ;i++)
 {
  vs+=maotph[i];
  fprintf(ff,"%10.2f|",maotph[i]);
  fprintf(ffi,"%10.2f|",maotph[i]);
 }

if(mn != mk)
 {
  fprintf(ff,"%10.2f|",vs);
  fprintf(ffi,"%10.2f|",vs);
  printw("%s: %.2f\n",bros,vs);
 }
else
  printw("%s: %.2f\n",bros,maotph[mn-1]);

fprintf(ff,"\n");
fprintf(ffi,"\n");

}
/*******************************/
/*Выдача итога по организации*/
/*******************************/
void itamobu(short mn,short mk,double itg[],short mr,
double maotpo[12],FILE *ff,FILE *ffi)
{
short           i;
double          vs;
char		bros[512];

fprintf(ff,"\
------------------------------------------------------------------------");
fprintf(ffi,"\
------------------------------------------------------------------------");
if(mr == 1)
 {
  fprintf(ff,"\
--------------------------------------------------------------------------------");
  fprintf(ffi,"\
--------------------------------------------------------------------------------");
 }
strpod(mn,mk,11,ff);
strpod(mn,mk,11,ffi);

sprintf(bros,gettext("Общий итог"));

fprintf(ff,"%-*.*s|",iceb_tu_kolbait(71,bros),iceb_tu_kolbait(71,bros),bros);
fprintf(ffi,"%-*.*s|",iceb_tu_kolbait(71,bros),iceb_tu_kolbait(71,bros),bros);


if(mr == 1)
 {
  fprintf(ff,"%5s|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5s|",
" ",itg[0],itg[1],itg[2],itg[3],itg[4],itg[5]," ");
  fprintf(ffi,"%5s|%10.2f|%10.2f|%10.2f|%10.2f|%12.2f|%10.2f|%5s|",
" ",itg[0],itg[1],itg[2],itg[3],itg[4],itg[5]," ");
 }
vs=0.;
for(i=mn-1 ;i<mk ;i++)
 {
  vs+=maotpo[i];
  fprintf(ff,"%10.2f|",maotpo[i]);
  fprintf(ffi,"%10.2f|",maotpo[i]);
 }

if(mn != mk)
 {
  fprintf(ff,"%10.2f|",vs);
  fprintf(ffi,"%10.2f|",vs);
  printw("%s: %.2f\n",bros,vs);
 }
else
  printw("%s: %.2f\n",bros,maotpo[mn-1]);

fprintf(ff,"\n");
fprintf(ffi,"\n");

}
