/* $Id: uosvosii.c,v 5.78 2011-08-29 07:08:59 sasa Exp $ */
/*05.07.2011	19.11.1999	Белых А.И.	uosvosii.c
Получение ведомости остаточной стоимости и износа
*/
#include        <time.h>
#include        <math.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern int      kol_strok_na_liste_l; //Количество строк на стандартном листе в ландшафтной ориентации
#define         KOLSTSH  6  /*Количество строк в шапке*/

void ithz(const char*,double,double,double,double,double,double,short,short*,double*,class bsiz_per *data_hz,FILE*,FILE*,FILE*,FILE*,FILE*);
void gsapphna(short,short,short,short,short,short,short *,short *,int,char*,short,FILE*,FILE*);
void haphna(short,short,short,short,short,short,short,short*,int,const char*,short,FILE*,FILE*,FILE*,FILE*);
void porgup(char *kodgr,short dn,short mn,short gn,short dk,short mk,short gk,double*,double*,FILE *ff,FILE*,FILE*,FILE*,FILE*);
void pogrup_s(short dn,short mn,short gn,short dk,short mk,short gk,short sli,short *kst,char*,double*,double*,FILE *ff,FILE*,FILE*,FILE*,FILE*);

void uosvosii_start(short dn,short mn,short gn,short dk,short mk,short gk,int viduh,int metr,int metka_sort,
short *kst,char *podrz,char *hnaz,char *hnabyz,char *kodolz,char *hauz,char *shetupoi,char *innomp,char *hztz,char*,char *kod_op,int,FILE *ff);
int uosvosii_poi(int in,const char *naim,int viduh,int metr,int metka_sort,short dn,short mn,short gn,short dk,short mk,short gk,const char *podrz,const char *kodolz,const char *shetupoi,const char *hztz,const char *hnaz,const char *hnabyz,const char *hauz,const char *sosob,int *kolstr3,FILE *ff);

extern char	*organ;
extern short	startgoduos; /*Стартовый год*/

int uosvosii(int viduh, //0-налоговый учет 1-бухгалтерский
class spis_oth *oth)
{
char		naimos[80];
char		strr[312];
struct  tm      *bf;
time_t          tmm;
FILE		*ff,*ff1,*ffhpz;
char		bros[512];
static char     dat1[11],dat2[11];
int           kom,kom1;
static char     podrz[112]; /*Код подразделения*/
static char	kodolz[112]; /*Коды ответственных лиц*/
static char	hnaz[112];
static char	hnabyz[112];
static char	hauz[112];
static char	shetupoi[112];
static char	innomp[112];
static char	hztz[112];
static char  sosob[2];
static char kod_op[112];
short           dn,mn,gn;
short           dk,mk,gk;
short		dp,mp,gp;
char            imaf[32],imaftmp[32],imafhpz[32];;
int		kolstr,kolstr1,kolstr3;
SQL_str         row,row1;
char		strsql[1024];
int		pod=0,podz=0;
int		in;
int		metr; /*0-по подразделениям 1-по мат.-ответственным*/
double          bs1,bs2,bs3;
double		s1,s2,s3;
double          ss1,ss2,ss3,ss4;
double		s11,s21,s31;
double		bs11,bs21,bs31;
double          bss1,bss2,bss3;
double		osts;
double		bsn,izn;
double		pr1=0.,pr2=0.,pr11=0.,pr22=0.;
char		hna1[32];
char		naipod[512];
short		sli,kst;
char		naigrup[512];
short		mvsh; /*0-шапку не печатать, если больше печатать*/
short		mvsi; /*0-шифр не печатать*/
int		podrp=0;
int 		kolos=0; //Количество основных средств попавших в отчет
SQLCURSOR curr;
char		hna[32];   /*Шифр нормы амортотчислений*/
char		nomz[124];  /*Номерной знак*/
int             metka_sort=0; //0-сортировка по группам 1-по счетам учёта

VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_data(dat1,11);
VV.VVOD_SPISOK_add_data(dat2,11);
VV.VVOD_SPISOK_add_data(hnaz,sizeof(hnaz));
VV.VVOD_SPISOK_add_data(hnabyz,sizeof(hnabyz));
VV.VVOD_SPISOK_add_data(podrz,sizeof(podrz));
VV.VVOD_SPISOK_add_data(kodolz,sizeof(kodolz));
VV.VVOD_SPISOK_add_data(hauz,sizeof(hauz));
VV.VVOD_SPISOK_add_data(shetupoi,sizeof(shetupoi));
VV.VVOD_SPISOK_add_data(innomp,sizeof(innomp));
VV.VVOD_SPISOK_add_data(hztz,sizeof(hztz));
VV.VVOD_SPISOK_add_data(sosob,sizeof(sosob));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала...(д.м.г)..."));//0
VV.VVOD_SPISOK_add_MD(gettext("Дата конца....(д.м.г)..."));//1
VV.VVOD_SPISOK_add_MD(gettext("Группа нал.учета..(,,).."));//2
VV.VVOD_SPISOK_add_MD(gettext("Группа бух.учета..(,,).."));//3
VV.VVOD_SPISOK_add_MD(gettext("Подразделение (,,)......"));//4
VV.VVOD_SPISOK_add_MD(gettext("Мат.ответственный (,,).."));//5
VV.VVOD_SPISOK_add_MD(gettext("Шифр анал. учета..(,,).."));//6
VV.VVOD_SPISOK_add_MD(gettext("Счет учета........(,,).."));//7
VV.VVOD_SPISOK_add_MD(gettext("Инвентарный номер.(,,).."));//8
VV.VVOD_SPISOK_add_MD(gettext("Шифр затрат.......(,,).."));//9
VV.VVOD_SPISOK_add_MD(gettext("Состояние объекта.(+/-)."));//10

if(viduh == 0)
 VV.VVOD_SPISOK_add_ZAG(gettext("Расчет ведомости остаточной стоимости и износа (налоговый учет)"));
if(viduh == 1)
 VV.VVOD_SPISOK_add_ZAG(gettext("Расчет ведомости остаточной стоимости и износа (бухгалтерский учет)"));
VV.VVOD_SPISOK_add_ZAG(gettext("Введите данные"));

naz:;

clear();

helstr(LINES-1,0,"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);

memset(hnaz,'\0',sizeof(hnaz));
strncpy(hnaz,VV.VVOD_SPISOK_return_data(2),sizeof(hnaz)-1);

memset(hnabyz,'\0',sizeof(hnabyz));
strncpy(hnabyz,VV.VVOD_SPISOK_return_data(3),sizeof(hnabyz)-1);

memset(podrz,'\0',sizeof(podrz));
strncpy(podrz,VV.VVOD_SPISOK_return_data(4),sizeof(podrz)-1);
memset(kodolz,'\0',sizeof(kodolz));
strncpy(kodolz,VV.VVOD_SPISOK_return_data(5),sizeof(kodolz)-1);
strncpy(hauz,VV.VVOD_SPISOK_return_data(6),sizeof(hauz)-1);
strncpy(shetupoi,VV.VVOD_SPISOK_return_data(7),sizeof(shetupoi)-1);
strncpy(innomp,VV.VVOD_SPISOK_return_data(8),sizeof(innomp)-1);
strncpy(hztz,VV.VVOD_SPISOK_return_data(9),sizeof(hztz)-1);
strncpy(sosob,VV.VVOD_SPISOK_return_data(10),sizeof(sosob)-1);
class iceb_tu_str kod_v("");
class iceb_tu_str naim_v("");
switch(kom)
 {
  case FK10:
  case ESC:
   return(1);
  case FK2:
  case PLU:
   break;

  case FK3:  /*Просмотр реквизитов*/
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп налогового учета"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп бухгалтерского учета"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка мат.-ответственны"));//3
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка шифров аналитического учета"));//4
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка шифров затрат"));//5
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 6 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Uosgrup",hnaz,sizeof(hnaz),naipod);
        VV.VVOD_SPISOK_zapis_data(2,hnaz);
        goto naz;

      case 1 :
        vibrek("Uosgrup1",hnabyz,sizeof(hnabyz),naipod);
        VV.VVOD_SPISOK_zapis_data(3,hnabyz);
        goto naz;

      case 2 :
        if(diruospod(1,&kod_v,&naim_v,0) == 0)
         VV.data_z_plus(4,kod_v.ravno());
        goto naz;

      case 3 :
        if(dirmatot(1,&kod_v,&naim_v,0) == 0)
         VV.data_z_plus(5,kod_v.ravno());
        goto naz;

      case 4 :
        vibrek("Uoshau",hauz,sizeof(hauz),naipod);
        VV.VVOD_SPISOK_zapis_data(6,hauz);
        goto naz;

      case 5 :
        vibrek("Uoshz",hztz,sizeof(hztz),naipod);
        VV.VVOD_SPISOK_zapis_data(9,hztz);
        goto naz;
     }
    goto naz;
    

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
 }


if(rsdatp(&dn,&mn,&gn,VV.VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
    goto naz;

dp=dk;
mp=mk;
gp=gk;
dpm(&dp,&mp,&gp,1);

MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите нужное и нажмите Enter"));

MENU.VVOD_SPISOK_add_MD(gettext("Расчитать по подразделениям"));
MENU.VVOD_SPISOK_add_MD(gettext("Расчитать по мат.-ответственным"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
metr=0;
while(menu3w(stdscr,&MENU,&metr,-1,-1,0) != 0);
if(metr == -1 || metr == 2)
 return(1);

MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите нужное и нажмите Enter"));

MENU.VVOD_SPISOK_add_MD(gettext("Все основные средства"));
MENU.VVOD_SPISOK_add_MD(gettext("Основные средства с нулевой остаточной стоимостью"));
MENU.VVOD_SPISOK_add_MD(gettext("Основные средства с ненулевой остаточной стоимостью"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

int metkaost=0;

while(menu3w(stdscr,&MENU,&metkaost,-1,-1,0) != 0);

if(metkaost == -1 || metkaost == 3)
 return(1);

MENU.VVOD_delete();
MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите нужное и нажмите Enter"));
MENU.VVOD_SPISOK_add_MD(gettext("Сортировка по группам"));
MENU.VVOD_SPISOK_add_MD(gettext("Сортировать по счетам учёта"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));
while(menu3w(stdscr,&MENU,&metka_sort,-1,-1,0) != 0);
if(metka_sort == -1 || metka_sort == 2)
 return(1);
 
clear();
refresh();
printw("%s %d.%d.%d%s > %d.%d.%d%s\n",
gettext("Период с"),
dn,mn,gn,
gettext("г."),
dk,mk,gk,
gettext("г."));
printw("%s\n",gettext("Сортируем"));
time(&tmm);
bf=localtime(&tmm);

GDITE(); 
sprintf(strsql,"select innom,naim from Uosin");

SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);  
 }

sprintf(imaftmp,"uos%d.tmp",getpid());

if((ff = fopen(imaftmp,"w")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }
kolstr3=kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);  
  if(proverka(innomp,row[0],0,0) != 0)
    continue;
    
  in=atoi(row[0]);
  /*Смотрим обязательно на две даты, так как основное средство может в периоде уйти или прийти*/
  uosvosii_poi(in,row[1],viduh,metr,metka_sort,dn,mn,gn,dk,mk,gk,podrz,kodolz,shetupoi,hztz,hnaz,hnabyz,hauz,sosob,&kolstr3,ff);

 }

GDITE(); 
fclose(ff);

//sprintf(strsql,"sort -o %s -t\\| -u +0 -1 +1 -2 %s",imaftmp,imaftmp);
sprintf(strsql,"sort -o %s -t\\| -u -k1,3 %s",imaftmp,imaftmp);
runsystem(strsql);
printw("%s.\n",gettext("Сортировка завершена"));
GDITE(); 

if((ff1 = fopen(imaftmp,"r")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }

if(metr == 0)
 sprintf(imaf,"iznosp%d.lst",getpid());
if(metr == 1)
 sprintf(imaf,"iznosm%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

char imaf_f[32];

if(metr == 0)
 sprintf(imaf_f,"viiosp%d.lst",getpid());
if(metr == 1)
 sprintf(imaf_f,"viiosm%d.lst",getpid());

FILE *ff_f=NULL;
if((ff_f = fopen(imaf_f,"w")) == NULL)
 {
  error_op_nfil(imaf_f,errno,"");
  return(1);
 }


char imaf_fi[32];

if(metr == 0)
 sprintf(imaf_fi,"viiospi%d.lst",getpid());
if(metr == 1)
 sprintf(imaf_fi,"viiosmi%d.lst",getpid());

FILE *ff_fi=NULL;
if((ff_fi = fopen(imaf_fi,"w")) == NULL)
 {
  error_op_nfil(imaf_fi,errno,"");
  return(1);
 }


//Отчёт без итогов по подразделению, только по шифрам затрат
char imaf_fis[32];

if(metr == 0)
 sprintf(imaf_fis,"visn%d.lst",getpid());
if(metr == 1)
 sprintf(imaf_fis,"visb%d.lst",getpid());

FILE *ff_fis=NULL;
if((ff_fis = fopen(imaf_fis,"w")) == NULL)
 {
  error_op_nfil(imaf_fis,errno,"");
  return(1);
 }


if(metr == 0)
 sprintf(imafhpz,"iznospi%d.lst",getpid());
if(metr == 1)
 sprintf(imafhpz,"iznosmi%d.lst",getpid());

if((ffhpz = fopen(imafhpz,"w")) == NULL)
 {
  error_op_nfil(imafhpz,errno,"");
  return(1);
 }


uosvosii_start(dn,mn,gn,dk,mk,gk,viduh,metr,metka_sort,&kst,podrz,hnaz,hnabyz,kodolz,hauz,shetupoi,innomp,hztz,sosob,kod_op,metkaost,ff);

uosvosii_start(dn,mn,gn,dk,mk,gk,viduh,metr,metka_sort,&kst,podrz,hnaz,hnabyz,kodolz,hauz,shetupoi,innomp,hztz,sosob,kod_op,metkaost,ffhpz);

uosvosii_start(dn,mn,gn,dk,mk,gk,viduh,metr,metka_sort,&kst,podrz,hnaz,hnabyz,kodolz,hauz,shetupoi,innomp,hztz,sosob,kod_op,metkaost,ff_f);

uosvosii_start(dn,mn,gn,dk,mk,gk,viduh,metr,metka_sort,&kst,podrz,hnaz,hnabyz,kodolz,hauz,shetupoi,innomp,hztz,sosob,kod_op,metkaost,ff_fi);

uosvosii_start(dn,mn,gn,dk,mk,gk,viduh,metr,metka_sort,&kst,podrz,hnaz,hnabyz,kodolz,hauz,shetupoi,innomp,hztz,sosob,kod_op,metkaost,ff_fis);

 
short kstt=0;
haphna(dn,mn,gn,dk,mk,gk,1,&kstt,0,"",metr,ffhpz,NULL,ff_fi,ff_fis);

bs1=bs2=bs3=bss1=bss2=bss3=0.;
s1=ss1=s2=ss2=s3=ss3=ss4=0.;
bs11=bs21=bs31=s11=s21=s31=0.;
mvsi=mvsh=in=0;
sli=1;
podz=kolstr1=0;
memset(hna1,'\0',sizeof(hna1));
memset(naipod,'\0',sizeof(naipod));
memset(hna,'\0',sizeof(hna));
double iznos_per[2];
double i_iznos_per[2];
double iznos_per_pod[2];
double iznos_per_hna[2];
memset(&i_iznos_per,'\0',sizeof(i_iznos_per));
memset(&iznos_per,'\0',sizeof(iznos_per));
memset(&iznos_per_pod,'\0',sizeof(iznos_per_pod));
memset(&iznos_per_hna,'\0',sizeof(iznos_per_hna));

class bsiz_per data_podr; //Итоги по подразделению
class bsiz_per data_hz;   //Итоги по шифру затрат
class bsiz_per data_oi;   //Общий итог по всему отчёту
class bsiz_per data_shet; //Итог по счёту

while(fgets(strr,sizeof(strr),ff1) != NULL)
 {

//  printw("%s",strr);
//  OSTANOV();

  strzag(LINES-1,0,kolstr3,++kolstr1);
  polen(strr,hna,sizeof(hna),1,'|');
  polen(strr,bros,sizeof(bros),2,'|');
  podrp=pod=atoi(bros);
  polen(strr,bros,sizeof(bros),3,'|');
  in=atol(bros);
  polen(strr,naimos,sizeof(naimos),4,'|');
  if(metr == 1) /*По мат-отв*/
   {
    polen(strr,bros,sizeof(bros),5,'|');
    podrp=atoi(bros);
   }

  polen(strr,nomz,sizeof(nomz),6,'|');

  memset(&iznos_per,'\0',sizeof(iznos_per));

  double bs_prih_za_per=0.;
  double bs_rash_za_per=0.;
  
  class bsiz_data data_per;
  
  bsizp(in,podrp,dn,mn,gn,dk,mk,gk,&data_per,NULL);
  
  
  if(viduh == 0)
   {
    pr1=data_per.nu.bs_nah_per; //Балансовая стоимость на начало периода
    pr2=data_per.nu.izmen_iznosa_nah_per+data_per.nu.amort_nah_per;  //Износ на начало периода
      
    pr11=data_per.nu.bs_kon_per; //Балансовая стоимость на конец периода
    
    pr22=data_per.nu.izmen_iznosa_kon_per+data_per.nu.amort_kon_per;  //Износ на конец периода
    
    iznos_per[0]+=data_per.nu.amort_raznica;     //Амортизация за период
    iznos_per[1]+=data_per.nu.izmen_iznosa_raznica; //Изменение износа за период
    bs_prih_za_per=data_per.nu.bs_prih_za_per;
    bs_rash_za_per=data_per.nu.bs_rash_za_per;
   }
  
  if(viduh == 1)
   {
    pr1=data_per.bu.bs_nah_per; //Балансовая стоимость на начало периода
    pr2=data_per.bu.izmen_iznosa_nah_per+data_per.bu.amort_nah_per;  //Износ на начало периода
    
    pr11=data_per.bu.bs_kon_per; //Балансовая стоимость на конец периода
    
    pr22=data_per.bu.izmen_iznosa_kon_per+data_per.bu.amort_kon_per;  //Износ на конец периода
    
    iznos_per[0]+=data_per.bu.amort_raznica;     //Амортизация за период
    iznos_per[1]+=data_per.bu.izmen_iznosa_raznica; //Изменение износа за период
    bs_prih_za_per=data_per.bu.bs_prih_za_per;
    bs_rash_za_per=data_per.bu.bs_rash_za_per;

   }
    
  
  
  if(fabs(pr1) < 0.01 && fabs(pr11) < 0.01) //Значит уже продан или списан или передан в другое подразделение
   {
//    printw("in=%d %d.%d.%d %d.%d.%d\n",in,dn,mn,gn,dp,mp,gp);
//    printw("pr1=%.2f pr2=%.2f pr11=%.2f pr22=%.2f\n",
//    pr1,pr2,pr11,pr22);
//    OSTANOV();
    continue;
   }

  if(metr == 0 && kodolz[0] != '\0') /*По подразделениям*/
   {
    //Может быть движение внутри подразделения по разным материально-ответственным лицам
    //в этом случае балансовая стоимость не равна нулю
    //Проверяем числился ли у этого мат. ответственного
    int pp=0,kk=0;
    if(poiin(in,dk,mk,gk,&pp,&kk) != 0)
      continue;
    sprintf(strsql,"%d",kk);
    if(proverka(kodolz,strsql,0,0) != 0)
      continue;
   }
  
  if(metr == 1) /*По мат. ответственным лицам*/
   {
    
    //Проверяем есть числился ли у этого мат. ответственного
    int pp=0,kk=0;
    int metkapr=0; //метка присутствия в периоде
     //Должно быть на начало или на конец периода
    if(poiin(in,dn,mn,gn,&pp,&kk) == 0)
     {
      metkapr++;
      //На начало периода должен числиться у материальноответственного
      if(pod != kk)
       continue; 
     }

    if(poiin(in,dk,mk,gk,&pp,&kk) == 0)
     {
      metkapr++;
     }
//    printw("metkapr=%d\n",metkapr);
    if(metkapr == 0)
      continue;
      
   }



  if(podz != pod)
   {
    if(podz != 0)
     {
      sprintf(bros,"%d",podz);
      ithz(bros,bss1,bss2,bss3,ss1,ss2,ss3,0,&kst,iznos_per_pod,&data_podr,ff,ffhpz,ff_f,ff_fi,ff_fis);
      memset(&iznos_per_pod,'\0',sizeof(iznos_per_pod));
      bss1=bss2=bss3=0.;
      ss1=ss2=ss3=ss4=0.;
     }

    if(metr == 0)
     {
      /*Читаем наименование подразделения*/
      memset(naipod,'\0',sizeof(naipod));
      sprintf(strsql,"select naik from Uospod where kod=%d",pod);
      if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
       {
        beep();
        printw("%s %d !\n",gettext("Не найден код подразделения"),pod);
        fprintf(ff,"%s %d !\n",gettext("Не найден код подразделения"),pod);
        OSTANOV();
       }
      else
        strncpy(naipod,row1[0],sizeof(naipod)-1);
     }

    if(metr == 1)
     {
      /*Читаем мат.-ответственного*/
      memset(naipod,'\0',sizeof(naipod));
      sprintf(strsql,"select naik from Uosol where kod=%d",pod);
      if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
       {
        beep();
        printw("%s %d !\n",gettext("Не найден мат.-ответственный"),pod);
        fprintf(ff,"%s %d !\n",gettext("Не найден мат.-ответственный"),pod);
        OSTANOV();
       }
      else
        strncpy(naipod,row1[0],sizeof(naipod)-1);
     }

    mvsh++;
             
    podz=pod;
    if(metr == 0)
     printw("\n%s - %d/%s\n",gettext("Подразделение"),podz,naipod);
    if(metr == 1)
     printw("\n%s - %d/%s\n",gettext("Мат.-ответственный"),podz,naipod);
   }

  if(SRAV(hna1,hna,0) != 0)
   {
    if(hna1[0] != '\0')
     {
      if(metka_sort == 0)
       ithz(hna1,bs1,bs2,bs3,s1,s2,s3,1,&kst,iznos_per_hna,&data_hz,ff,ffhpz,ff_f,ff_fi,ff_fis);
      if(metka_sort == 1)
       ithz(hna1,bs1,bs2,bs3,s1,s2,s3,3,&kst,iznos_per_hna,&data_shet,ff,ffhpz,ff_f,ff_fi,ff_fis);
      memset(&iznos_per_hna,'\0',sizeof(iznos_per_hna));
      bs1=bs2=bs3=s1=s2=s3=0.;
     }
    
    if(metka_sort == 0)
     {
      /*Уэнаем наименование шифра нормы аморт. отчисления*/
      memset(naigrup,'\0',sizeof(naigrup));
      if(SRAV(hna,"???",0) != 0)
       {
        if(viduh == 0)
          sprintf(strsql,"select naik from Uosgrup where kod='%s'",hna);
        if(viduh == 1)
          sprintf(strsql,"select naik from Uosgrup1 where kod='%s'",hna);

        if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
         {
          beep();
          printw("%s %s !\n",gettext("Не найдено группу"),hna);
          fprintf(ff,"%s %s !\n",gettext("Не найдено группу"),hna);
          OSTANOV();
         }
        else
          strncpy(naigrup,row1[0],sizeof(naigrup)-1);
       }
      else
       strcpy(naigrup,"Не введена в карточку группа");
      printw("\n%s %s \"%s\"\n",gettext("Группа"),hna,naigrup);
     }
    if(metka_sort == 1)
     {
      sprintf(strsql,"select nais from Plansh where ns='%s'",hna);
      memset(naigrup,'\0',sizeof(naigrup));
      if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
        strncpy(naigrup,row1[0],sizeof(naigrup)-1);
     
      printw("\n%s %s \"%s\"\n",
      gettext("Счёт учёта"),hna,naigrup);
     }
    mvsi++;


    strcpy(hna1,hna);

   }
  if(mvsh > 0 || mvsi > 0) 
   {  
    if(kst > kol_strok_na_liste_l-KOLSTSH-5)
     {
      fprintf(ff,"\f");
      fprintf(ff_f,"\f");
      sli++;
      kst=0;
     }
    if(mvsi > 0)
     {
      if(metka_sort == 0)
       {
        fprintf(ff,"\n%s %s \"%s\"\n",gettext("Группа"),hna,naigrup);
        fprintf(ff_f,"\n%s %s \"%s\"\n",gettext("Группа"),hna,naigrup);
       }
      if(metka_sort == 1)
       {
        fprintf(ff,"\n%s %s \"%s\"\n",
        gettext("Счёт учёта"),hna,naigrup);
        fprintf(ff_f,"\n%s %s \"%s\"\n",
        gettext("Счёт учёта"),hna,naigrup);
       }
      mvsi=0;
      kst+=2;
     } 
    haphna(dn,mn,gn,dk,mk,gk,sli,&kst,pod,naipod,metr,ff,ff_f,NULL,NULL);
    mvsh=0;
   }

  if(viduh == 0)
   {
    data_podr.plus(&data_per.nu);
    data_oi.plus(&data_per.nu);
    data_hz.plus(&data_per.nu);
    data_shet.plus(&data_per.nu);
   }
  if(viduh == 1)
   {
    data_podr.plus(&data_per.bu);
    data_oi.plus(&data_per.bu);
    data_hz.plus(&data_per.bu);
    data_shet.plus(&data_per.bu);
   }
  izn=pr2;
  bsn=pr1;
  osts=bsn-izn;

  if(osts >  0.009 && metkaost == 1)
   continue;

  if(osts ==  0. && metkaost == 2)
   continue;

  i_iznos_per[0]+=iznos_per[0];  
  i_iznos_per[1]+=iznos_per[1];  

  iznos_per_pod[0]+=iznos_per[0];  
  iznos_per_pod[1]+=iznos_per[1];  

  iznos_per_hna[0]+=iznos_per[0];  
  iznos_per_hna[1]+=iznos_per[1];  

  bss1+=bsn;
  bss2+=pr11-pr1;
  bss3+=bsn+(pr11-pr1);
  ss1+=izn;
  ss2+=pr22-pr2;
  ss3+=izn+pr22-pr2;

  bs1+=bsn;
  bs2+=pr11-pr1;
  bs3+=bsn+(pr11-pr1);
  s1+= izn;
  s2+= pr22-pr2;
  s3+= izn+pr22-pr2;

  bs11+=bsn;
  bs21+=pr11-pr1;
  bs31+=bsn+(pr11-pr1);
  s11+= izn;
  s21+= pr22-pr2;
  s31+= izn+pr22-pr2;


  double izpr=pr22-pr2;


  if(fabs(bsn+izn+osts+pr11-pr1+pr22-pr2+bsn+pr11-pr1+izn+pr22+pr2+(bsn+pr11-pr1)+(izn+pr22-pr2)) > 0.009)
   {
    gsapphna(dn,mn,gn,dk,mk,gk,&sli,&kst,pod,naipod,metr,ff,ff_f);

    fprintf(ff,"\
%11d %-*.*s %-*.*s %15.2f %12.2f %12.2f %12.2f %12.2f %15.2f %12.2f %12.2f\n",
    in,
    iceb_tu_kolbait(30,naimos),iceb_tu_kolbait(30,naimos),naimos,
    iceb_tu_kolbait(10,nomz),iceb_tu_kolbait(10,nomz),nomz,
    bsn,izn,osts,pr11-pr1,izpr,bsn+pr11-pr1,izn+pr22-pr2,(bsn+pr11-pr1)-(izn+pr22-pr2));

    fprintf(ff_f,"\
%11d %-*.*s %-*.*s %15.2f %12.2f %12.2f %12.2f %12.2f %10.2f %10.2f %15.2f %12.2f %12.2f\n",
    in,
    iceb_tu_kolbait(30,naimos),iceb_tu_kolbait(30,naimos),naimos,
    iceb_tu_kolbait(10,nomz),iceb_tu_kolbait(10,nomz),nomz,
    bsn,izn,osts,
    bs_prih_za_per,
    bs_rash_za_per,
    iznos_per[0],
    iznos_per[1],
    bsn+pr11-pr1,
    izn+pr22-pr2,
    (bsn+pr11-pr1)-(izn+pr22-pr2));

    if(iceb_tu_strlen(naimos) > 30)
     {
      gsapphna(dn,mn,gn,dk,mk,gk,&sli,&kst,pod,naipod,metr,ff,ff_f);
      fprintf(ff,"%11s %s\n","",iceb_tu_adrsimv(30,naimos));
      fprintf(ff_f,"%11s %s\n","",iceb_tu_adrsimv(30,naimos));
     }
    kolos++;
   }
 }

GDITE();

fclose(ff1);

unlink(imaftmp);


sprintf(bros,"%d",pod);
ithz(bros,bss1,bss2,bss3,ss1,ss2,ss3,0,&kst,iznos_per_pod,&data_podr,ff,ffhpz,ff_f,ff_fi,ff_fis);

if(metka_sort == 0)
  ithz(hna,bs1,bs2,bs3,s1,s2,s3,1,&kst,iznos_per_hna,&data_hz,ff,ffhpz,ff_f,ff_fi,ff_fis);
if(metka_sort == 1)
  ithz(hna1,bs1,bs2,bs3,s1,s2,s3,3,&kst,iznos_per_hna,&data_shet,ff,ffhpz,ff_f,ff_fi,ff_fis);

/*Итог Общий*/
ithz(" ",bs11,bs21,bs31,s11,s21,s31,2,&kst,i_iznos_per,&data_oi,ff,ffhpz,ff_f,ff_fi,ff_fis);

if(sravmydat(dn,mn,gn,1,4,2011) < 0) /*В целом по группе было только до этой даты*/
if(viduh == 0) //распечатка по группам с общегрупповой амортизацией
 {
  double suma_pogr[9];
  double iznos[2];
  memset(suma_pogr,'\0',sizeof(suma_pogr));
  memset(iznos,'\0',sizeof(iznos));

  pogrup_s(dn,mn,gn,dk,mk,gk,sli,&kst,hnaz,suma_pogr,iznos,ff,ffhpz,ff_f,ff_fi,ff_fis);

  suma_pogr[0]+=bs11;
  suma_pogr[1]+=s11;
  suma_pogr[2]+=bs11-s11;
  //suma_pogr[3]+=bs21;
  suma_pogr[3]+=data_oi.bs_prih_za_per;
  suma_pogr[4]+=data_oi.bs_rash_za_per;
  
  suma_pogr[5]+=s21;
  suma_pogr[6]+=bs31;
  suma_pogr[7]+=s31;
  suma_pogr[8]+=bs31-s31;
  
  iznos[0]+=i_iznos_per[0];
  iznos[1]+=i_iznos_per[1];
  
  char str[512];
  memset(str,'\0',sizeof(str));
  memset(str,'-',164);

  fprintf(ff,"%s\n",str);
  fprintf(ff,"\
%*s %15.2f %12.2f %12.2f %12.2f %12.2f %15.2f %12.2f %12.2f\n",
  iceb_tu_kolbait(53,gettext("Общий итог")),gettext("Общий итог"),
  suma_pogr[0],
  suma_pogr[1],
  suma_pogr[2],
  suma_pogr[3]+suma_pogr[4],
  suma_pogr[5],
  suma_pogr[6],
  suma_pogr[7],
  suma_pogr[8]);

  fprintf(ff_f,"\
%*s %15.2f %12.2f %12.2f %12.2f %12.2f %10.2f %10.2f %15.2f %12.2f %12.2f\n",
  iceb_tu_kolbait(53,gettext("Общий итог")),gettext("Общий итог"),
  suma_pogr[0],
  suma_pogr[1],
  suma_pogr[2],
  suma_pogr[3],
  suma_pogr[4],
  iznos[0],
  iznos[1],
  suma_pogr[6],
  suma_pogr[7],
  suma_pogr[8]);

  fprintf(ff_fi,"\
%*s %15.2f %12.2f %12.2f %12.2f %12.2f %10.2f %10.2f %15.2f %12.2f %12.2f\n",
  iceb_tu_kolbait(53,gettext("Общий итог")),gettext("Общий итог"),
  suma_pogr[0],
  suma_pogr[1],
  suma_pogr[2],
  suma_pogr[3],
  suma_pogr[4],
  iznos[0],
  iznos[1],
  suma_pogr[6],
  suma_pogr[7],
  suma_pogr[8]);

  fprintf(ff_fis,"\
%*s %15.2f %12.2f %12.2f %12.2f %12.2f %10.2f %10.2f %10.2f %15.2f %12.2f %12.2f\n",
  iceb_tu_kolbait(53,gettext("Общий итог")),gettext("Общий итог"),
  suma_pogr[0],
  suma_pogr[1],
  suma_pogr[2],
  suma_pogr[3],
  suma_pogr[4],
  iznos[0],
  iznos[1],
  suma_pogr[4]-iznos[1],
  suma_pogr[6],
  suma_pogr[7],
  suma_pogr[8]);

  fprintf(ffhpz,"%s\n",str);
  fprintf(ffhpz,"\
%53s %15.2f %12.2f %12.2f %12.2f %12.2f %15.2f %12.2f %12.2f\n",
  gettext("Общий итог"),
  suma_pogr[0],
  suma_pogr[1],
  suma_pogr[2],
  suma_pogr[3]+suma_pogr[4],
  suma_pogr[5],
  suma_pogr[6],
  suma_pogr[7],
  suma_pogr[8]);

 }





printw("\n%s:%d\n",gettext("Количество основных средств"),kolos);
fprintf(ff,"\n%s:%d\n",gettext("Количество основных средств"),kolos);
fprintf(ff_f,"\n%s:%d\n",gettext("Количество основных средств"),kolos);
fprintf(ff_fi,"\n%s:%d\n",gettext("Количество основных средств"),kolos);
fprintf(ff_fis,"\n%s:%d\n",gettext("Количество основных средств"),kolos);
fprintf(ffhpz,"\n%s:%d\n",gettext("Количество основных средств"),kolos);

podpis(ff);
podpis(ff_f);
podpis(ff_fi);
podpis(ff_fis);
podpis(ffhpz);

fclose(ff);
fclose(ff_f);
fclose(ff_fi);
fclose(ff_fis);
fclose(ffhpz);

printw_vr(tmm);


OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Ведомость износа и остаточной стоимости основных средств"));

oth->spis_imaf.plus(imafhpz);
oth->spis_naim.plus(gettext("Общие итоги"));

oth->spis_imaf.plus(imaf_f);
oth->spis_naim.plus(gettext("Ведомость с расшифровкой изменения балансовой стоимости и износа"));
oth->spis_imaf.plus(imaf_fi);
oth->spis_naim.plus(gettext("Общие итоги по ведомости с расшифровкой"));
oth->spis_imaf.plus(imaf_fis);
oth->spis_naim.plus(gettext("Общие итоги по ведомости с расшифровкой+остаточ.бал.стои"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);

}
/****************/
/*Итого по шифру и подразделению для износа*/
/****************/
void            ithz(const char *sh,double k1,double k2,double k3,double s1,
double s2,double s3,
short mt,  //0-по подразделению 1- по шифру 2-общий итог 3-по счету учёта
short *kst,
double *iznos_per,
class bsiz_per *data_i,
FILE *ff,FILE *ffhpz,FILE *ff_f,FILE *ff_fi,FILE *ff_fis)
{
char		bros[512];
char		str[312];

memset(str,'\0',sizeof(str));
memset(str,'-',164);

if(mt == 2)
 {
  sprintf(bros,gettext("Общий итог"));
 }

if(mt == 1)
 {
  if(sh[0] == '\0')
   return;
  sprintf(bros,"%s %s",gettext("Итого по шифру"),sh);
fprintf(ffhpz,"%s\n\
%11s %-*s %10s %15.2f %12.2f %12.2f %12.2f %12.2f \
%15.2f %12.2f %12.2f\n",str," ",iceb_tu_kolbait(30,bros),bros," ",
k1,s1,k1-s1,k2,s2,k3,s3,k3-s3);
 }

if(mt == 0)
 {
  if(k1+s1+(k1-s1)+k2+s2+k3+s3+(k3-s3) < 0.0001)
   return;
  sprintf(bros,"%s %s",gettext("Итого по подразделению"),sh);
 }

if(mt == 3)
 {
  if(k1+s1+(k1-s1)+k2+s2+k3+s3+(k3-s3) < 0.0001)
   return;
  sprintf(bros,"%s %s",gettext("Итого по счёту"),sh);
 }

fprintf(ff,"%s\n\
%11s %-*s %10s %15.2f %12.2f %12.2f %12.2f %12.2f \
%15.2f %12.2f %12.2f\n",str," ",iceb_tu_kolbait(30,bros),bros," ",
k1,s1,k1-s1,k2,s2,k3,s3,k3-s3);

fprintf(ff_f,"\
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff_f,"\
%11s %-*s %10s %15.2f %12.2f %12.2f %12.2f %12.2f %10.2f %10.2f\
%15.2f %12.2f %12.2f\n"," ",iceb_tu_kolbait(30,bros),bros," ",
k1,s1,k1-s1,data_i->bs_prih_za_per,data_i->bs_rash_za_per,
iznos_per[0],iznos_per[1],k3,s3,k3-s3);

fprintf(ff_fi,"\
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff_fi,"\
%11s %-*s %10s %15.2f %12.2f %12.2f %12.2f %12.2f %10.2f %10.2f\
%15.2f %12.2f %12.2f\n"," ",iceb_tu_kolbait(30,bros),bros," ",
k1,s1,k1-s1,data_i->bs_prih_za_per,data_i->bs_rash_za_per,
iznos_per[0],iznos_per[1],k3,s3,k3-s3);

if(mt != 0)
 {
  fprintf(ff_fis,"\
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");

  fprintf(ff_fis,"\
%11s %-*s %10s %15.2f %12.2f %12.2f %12.2f %12.2f %10.2f %10.2f %10.2f \
%15.2f %12.2f %12.2f\n"," ",iceb_tu_kolbait(30,bros),bros," ",
  k1,s1,k1-s1,data_i->bs_prih_za_per,data_i->bs_rash_za_per,
  iznos_per[0],iznos_per[1],data_i->bs_rash_za_per-iznos_per[1],k3,s3,k3-s3);
 }
 
if(mt == 2 || mt == 3)
  fprintf(ffhpz,"%s\n\
%11s %-*s %10s %15.2f %12.2f %12.2f %12.2f %12.2f \
%15.2f %12.2f %12.2f\n",str," ",iceb_tu_kolbait(30,bros),bros," ",
k1,s1,k1-s1,k2,s2,k3,s3,k3-s3);

*kst=*kst+2;

printw("\n%s:\n\
%s %15.2f %15.2f %15.2f\n\
%s %15.2f %15.2f\n\
%s %15.2f %15.2f %15.2f\n",
bros,
gettext("Баланс. ст./Износ/Ост.ст.:"),
k1,s1,k1-s1,
gettext("Измен бал. ст./Износ     :"),
k2,s2,
gettext("Баланс. ст./Износ/Ост.ст.:"),
k3,s3,k3-s3);

data_i->clear_data(); //обнуляем массив

}

/*******/
/*Счетчик строк*/
/*******/
void gsapphna(short dn,short mn,short gn,
short dk,short mk,short gk,
short *sl,  //Счетчик листов
short *kst, //Счетчик строк
int skl,char nai[],
short mt,   //0-по подразделению 1-по материально-ответств
FILE *ff,FILE *ff_f)
{

*kst=*kst+1;

if(*kst <= kol_strok_na_liste_l)
 return;

*sl=*sl+1;
*kst=1;
fprintf(ff,"\f");
fprintf(ff_f,"\f");

haphna(dn,mn,gn,dk,mk,gk,*sl,kst,skl,nai,mt,ff,ff_f,NULL,NULL);


}

/********/
/*Шапка*/
/*******/

void haphna(short dn,short mn,short gn,
short dk,short mk,short gk,
short sl, //Счетчик листов
short *kst,  //Счетчик строк
int skl,const char *nai,
short mt,  //0-по подразделению 1-по материально-ответств
FILE *ff,
FILE *ff_f,
FILE *ff_fi,FILE *ff_fis)
{
char		str[312];
char		bros[312];

if(mt == 0)
 sprintf(bros,"%s %d %s",gettext("Подразделение"),skl,nai);

if(mt == 1)
 sprintf(bros,"%s %d %s",gettext("Мат.-ответственный"),skl,nai);

if(mt == 2)
 sprintf(bros,"%s",nai);

memset(str,'\0',sizeof(str));
memset(str,'-',164);

fprintf(ff,"\
%-*s %s N%d\n\%s\n",
iceb_tu_kolbait(150,bros),bros,
gettext("Лист"),
sl,str);

fprintf(ff,gettext("\
Инвентарный|     Наименование             |          |  Балансовая   |   Износ    | Остаточная | Изменение  |    Износ   |   Балансова   |    Износ   | Остаточная |\n"));
fprintf(ff,gettext("\
  номер    |                              |  Номер   | стоимость на  |    на      |стоимость на| балансовой |    за      | стоимость  на |    на      |стоимость на|\n"));
fprintf(ff,gettext("\
	   |                              |          | %02d.%02d.%dг.  |%02d.%02d.%dг.|%02d.%02d.%dг.| стоимости  |   период   |  %02d.%02d.%dг. |%02d.%02d.%dг.|%02d.%02d.%dг.|\n"),
dn,mn,gn,dn,mn,gn,dn,mn,gn,dk,mk,gk,dk,mk,gk,dk,mk,gk);

fprintf(ff,"%s\n",str);

if(ff_f != NULL)
 {
  fprintf(ff_f,"\
%-*s %s N%d\n",
  iceb_tu_kolbait(150,bros),bros,
  gettext("Лист"),
  sl);

  fprintf(ff_f,"\
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");

  fprintf(ff_f,"\
Инвентарный|     Наименование             |          |  Балансовая   |   Износ    | Остаточная | Приход     |  Расход    |Амортизац.|Изменение |   Балансовая  |   Износ    | Остаточная |\n");
  fprintf(ff_f,"\
  номер    |                              |  Номер   | стоимасть на  |    на      |стоимость на| балансовой | балансовой |   за     |износа за | стоимость  на |    на      |стоимость на|\n");
  fprintf(ff_f,"\
	   |                              |          | %02d.%02d.%dг.  |%02d.%02d.%dг.|%02d.%02d.%dг.| стоимости  | стоимости  | период   |  период  |  %02d.%02d.%dг. |%02d.%02d.%dг.|%02d.%02d.%dг.|\n",
  dn,mn,gn,dn,mn,gn,dn,mn,gn,dk,mk,gk,dk,mk,gk,dk,mk,gk);


  fprintf(ff_f,"\
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
 }

if(ff_fi != NULL)
 {
  fprintf(ff_fi,"\
%-*s %s N%d\n",
  iceb_tu_kolbait(150,bros),bros,
  gettext("Лист"),
  sl);

  fprintf(ff_fi,"\
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");

  fprintf(ff_fi,"\
Инвентарный|     Наименование             |          |  Балансовая   |   Износ    | Остаточная | Приход     |  Расход    |Амортизац.|Изменение |   Балансовая  |   Износ    | Остаточная |\n");
  fprintf(ff_fi,"\
  номер    |                              |  Номер   | стоимость на  |    на      |стоимость на| балансовой | балансовой |   за     |износа за | стоимость  на |    на      |стоимость на|\n");
  fprintf(ff_fi,"\
	   |                              |          | %02d.%02d.%dг.  |%02d.%02d.%dг.|%02d.%02d.%dг.| стоимости  | стоимости  | период   |  период  |  %02d.%02d.%dг. |%02d.%02d.%dг.|%02d.%02d.%dг.|\n",
  dn,mn,gn,dn,mn,gn,dn,mn,gn,dk,mk,gk,dk,mk,gk,dk,mk,gk);


  fprintf(ff_fi,"\
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
 }

if(ff_fis != NULL)
 {
  fprintf(ff_fis,"\
%-*s %s N%d\n",
  iceb_tu_kolbait(150,bros),bros,
  gettext("Лист"),
  sl);

  fprintf(ff_fis,"\
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");

  fprintf(ff_fis,"\
Инвентарный|     Наименование             |          |  Балансовая   |   Износ    | Остаточная | Приход     |  Расход    |Амортизац.|Изменение |Изменение |   Балансовая  |   Износ    | Остаточная |\n");
  fprintf(ff_fis,"\
  номер    |                              |  Номер   | стоимость на  |    на      |стоимость на| балансовой | балансовой |   за     |износа за |остаточной| стоимость  на |    на      |стоимость на|\n");
  fprintf(ff_fis,"\
	   |                              |          | %02d.%02d.%dг.  |%02d.%02d.%dг.|%02d.%02d.%dг.| стоимости  | стоимости  | период   |  период  |стоимости |  %02d.%02d.%dг. |%02d.%02d.%dг.|%02d.%02d.%dг.|\n",
  dn,mn,gn,dn,mn,gn,dn,mn,gn,dk,mk,gk,dk,mk,gk,dk,mk,gk);


  fprintf(ff_fis,"\
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
 }
 
*kst=*kst+KOLSTSH;

}
/********************************/
/*Распечатка в целом по группе по списку групп*/
/*******************************/

void pogrup_s(short dn,short mn,short gn,
short dk,short mk,short gk,
short sli,
short *kst,
char *hnaz,
double *suma_pogr,
double *iznos,
FILE *ff,FILE *ffhpz,FILE *ff_f,FILE *ff_fi,FILE *ff_fis)
{
SQL_str row;
class SQLCURSOR cur;
int kolstr;
char strsql[512];
sprintf(strsql,"select kod from Uosgrup where ta=1");


if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
  return;  

fprintf(ff,"\n\n");
haphna(dn,mn,gn,dk,mk,gk,sli,kst,0,"Группы с амортизацией в целом по группе",2,ff,ff_f,NULL,NULL);

fprintf(ffhpz,"\n\n");
haphna(dn,mn,gn,dk,mk,gk,sli,kst,0,"Группы с амортизацией в целом по группе",2,ffhpz,NULL,NULL,NULL);

while(cur.read_cursor(&row) != 0)
 {
  if(proverka(hnaz,row[0],0,0) != 0)
   continue;

  porgup(row[0],dn,mn,gn,dk,mk,gk,suma_pogr,iznos,ff,ffhpz,ff_f,ff_fi,ff_fis);
 }

char str[200];
memset(str,'\0',sizeof(str));
memset(str,'-',164);

fprintf(ff,"%s\n",str);
fprintf(ff,"\
%*s %15.2f %12.2f %12.2f %12.2f %12.2f %15.2f %12.2f %12.2f\n",
iceb_tu_kolbait(53,gettext("Итого")),gettext("Итого"),
suma_pogr[0],
suma_pogr[1],
suma_pogr[2],
suma_pogr[3]+suma_pogr[4],
suma_pogr[5],
suma_pogr[6],
suma_pogr[7],
suma_pogr[8]);

fprintf(ff_f,"\
%*s %15.2f %12.2f %12.2f %12.2f %12.2f %10.2f %10.2f %15.2f %12.2f %12.2f\n",
iceb_tu_kolbait(53,gettext("Итого")),gettext("Итого"),
suma_pogr[0],
suma_pogr[1],
suma_pogr[2],
suma_pogr[3],
suma_pogr[4],
iznos[0],
iznos[1],
suma_pogr[6],
suma_pogr[7],
suma_pogr[8]);

fprintf(ff_fi,"\
%*s %15.2f %12.2f %12.2f %12.2f %12.2f %10.2f %10.2f %15.2f %12.2f %12.2f\n",
iceb_tu_kolbait(53,gettext("Итого")),gettext("Итого"),
suma_pogr[0],
suma_pogr[1],
suma_pogr[2],
suma_pogr[3],
suma_pogr[4],
iznos[0],
iznos[1],
suma_pogr[6],
suma_pogr[7],
suma_pogr[8]);

fprintf(ff_fis,"\
%*s %15.2f %12.2f %12.2f %12.2f %12.2f %10.2f %10.2f %10.2f %15.2f %12.2f %12.2f\n",
iceb_tu_kolbait(53,gettext("Итого")),gettext("Итого"),
suma_pogr[0],
suma_pogr[1],
suma_pogr[2],
suma_pogr[3],
suma_pogr[4],
iznos[0],
iznos[1],
suma_pogr[4]-iznos[1],
suma_pogr[6],
suma_pogr[7],
suma_pogr[8]);
 
fprintf(ffhpz,"%s\n",str);
fprintf(ffhpz,"\
%*s %15.2f %12.2f %12.2f %12.2f %12.2f %15.2f %12.2f %12.2f\n",
iceb_tu_kolbait(53,gettext("Итого")),gettext("Итого"),
suma_pogr[0],
suma_pogr[1],
suma_pogr[2],
suma_pogr[3]+suma_pogr[4],
suma_pogr[5],
suma_pogr[6],
suma_pogr[7],
suma_pogr[8]);
 


}
/****************/
/*Распечатка одной группы налогового учёта для которой амартизация считается в целом по группе*/
/******************************************/

void porgup(char *kodgr,
short dn,short mn,short gn,
short dk,short mk,short gk,
double *suma_pogr,
double *iznos,
FILE *ff,FILE *ffhpz,FILE *ff_f,FILE *ff_fi,FILE *ff_fis)
{
char naigrup[512];
SQL_str row;
SQLCURSOR cur;
char strsql[512];

memset(naigrup,'\0',sizeof(naigrup));

sprintf(strsql,"select naik from Uosgrup where kod='%s'",kodgr);
if(sql_readkey(&bd,strsql,&row,&cur) == 1)
 strncpy(naigrup,row[0],sizeof(naigrup)-1);
  
class bsiz_data data;
bsiz23p(kodgr,dn,mn,gn,dk,mk,gk,&data);

fprintf(ff,"\
%11s %-*.*s %-10.10s %15.2f %12.2f %12.2f %12.2f %12.2f %15.2f %12.2f %12.2f\n",
kodgr,
iceb_tu_kolbait(30,naigrup),iceb_tu_kolbait(30,naigrup),naigrup,
"",
data.nu.bs_nah_per,
data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per,
data.nu.bs_nah_per-(data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per),

data.nu.bs_kon_per-data.nu.bs_nah_per,
data.nu.izmen_iznosa_raznica+data.nu.amort_raznica,

data.nu.bs_kon_per,
data.nu.izmen_iznosa_kon_per+data.nu.amort_kon_per,
data.nu.bs_kon_per-(data.nu.izmen_iznosa_kon_per+data.nu.amort_kon_per));


fprintf(ff_f,"\
%11s %-*.*s %-10.10s %15.2f %12.2f %12.2f %12.2f %12.2f %10.2f %10.2f %15.2f %12.2f %12.2f\n",
kodgr,
iceb_tu_kolbait(30,naigrup),iceb_tu_kolbait(30,naigrup),naigrup,
"",

data.nu.bs_nah_per,
data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per,
data.nu.bs_nah_per-(data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per),
data.nu.bs_prih_za_per,
data.nu.bs_rash_za_per,
data.nu.amort_raznica,
data.nu.izmen_iznosa_raznica,

data.nu.bs_kon_per,
data.nu.izmen_iznosa_kon_per+data.nu.amort_kon_per,
data.nu.bs_kon_per-(data.nu.izmen_iznosa_kon_per+data.nu.amort_kon_per));

fprintf(ff_fi,"\
%11s %-*.*s %-10.10s %15.2f %12.2f %12.2f %12.2f %12.2f %10.2f %10.2f %15.2f %12.2f %12.2f\n",
kodgr,
iceb_tu_kolbait(30,naigrup),iceb_tu_kolbait(30,naigrup),naigrup,
"",

data.nu.bs_nah_per,
data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per,
data.nu.bs_nah_per-(data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per),
data.nu.bs_prih_za_per,
data.nu.bs_rash_za_per,
data.nu.amort_raznica,
data.nu.izmen_iznosa_raznica,

data.nu.bs_kon_per,
data.nu.izmen_iznosa_kon_per+data.nu.amort_kon_per,
data.nu.bs_kon_per-(data.nu.izmen_iznosa_kon_per+data.nu.amort_kon_per));

fprintf(ff_fis,"\
%11s %-*.*s %-10.10s %15.2f %12.2f %12.2f %12.2f %12.2f %10.2f %10.2f %10.2f %15.2f %12.2f %12.2f\n",
kodgr,
iceb_tu_kolbait(30,naigrup),iceb_tu_kolbait(30,naigrup),naigrup,
"",

data.nu.bs_nah_per,
data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per,
data.nu.bs_nah_per-(data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per),
data.nu.bs_prih_za_per,
data.nu.bs_rash_za_per,
data.nu.amort_raznica,
data.nu.izmen_iznosa_raznica,
data.nu.bs_rash_za_per-data.nu.izmen_iznosa_raznica,

data.nu.bs_kon_per,
data.nu.izmen_iznosa_kon_per+data.nu.amort_kon_per,
data.nu.bs_kon_per-(data.nu.izmen_iznosa_kon_per+data.nu.amort_kon_per));


fprintf(ffhpz,"\
%11s %-*.*s %-10.10s %15.2f %12.2f %12.2f %12.2f %12.2f %15.2f %12.2f %12.2f\n",
kodgr,
iceb_tu_kolbait(30,naigrup),iceb_tu_kolbait(30,naigrup),naigrup,
"",

data.nu.bs_nah_per,
data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per,
data.nu.bs_nah_per-(data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per),

data.nu.bs_kon_per-data.nu.bs_nah_per,
data.nu.izmen_iznosa_raznica+data.nu.amort_raznica,

data.nu.bs_kon_per,
data.nu.izmen_iznosa_kon_per+data.nu.amort_kon_per,
data.nu.bs_kon_per-(data.nu.izmen_iznosa_kon_per+data.nu.amort_kon_per));

suma_pogr[0]+=data.nu.bs_nah_per;
suma_pogr[1]+=data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per;
suma_pogr[2]+=data.nu.bs_nah_per-(data.nu.izmen_iznosa_nah_per+data.nu.amort_nah_per);
//suma_pogr[3]+=data.nu.bs_kon_per-data.nu.bs_nah_per;
suma_pogr[3]+=data.nu.bs_prih_za_per;
suma_pogr[4]+=data.nu.bs_rash_za_per;

suma_pogr[5]+=data.nu.izmen_iznosa_raznica+data.nu.amort_raznica;
suma_pogr[6]+=data.nu.bs_kon_per;
suma_pogr[7]+=data.nu.izmen_iznosa_kon_per+data.nu.amort_kon_per;
suma_pogr[8]+=data.nu.bs_kon_per-(data.nu.izmen_iznosa_kon_per+data.nu.amort_kon_per);

iznos[0]+=data.nu.amort_raznica;
iznos[1]+=data.nu.izmen_iznosa_raznica;

}
/**********************************/
/*Начало отчётов*/
/***********************************/

void uosvosii_start(short dn,short mn,short gn,
short dk,short mk,short gk,
int viduh,
int metr,
int metka_sort,
short *kst,
char *podrz,
char *hnaz,
char *hnabyz,
char *kodolz,
char *hauz,
char *shetupoi,
char *innomp,
char *hztz,
char *sosob,
char *kod_op,
int metkaost,
FILE *ff)
{

*kst=5;

zagolov(gettext("Ведомость износа и остаточной стоимости основных средств"),dn,mn,gn,dk,mk,gk,organ,ff);

*kst+=1;

if(viduh == 0)
 {
  fprintf(ff,"%s.\n",gettext("Налоговый учет"));
 }
if(viduh == 1)
 {
  fprintf(ff,"%s.\n",gettext("Бухгалтерский учет"));
 }

int klst=0;
if(podrz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Подразделение"),podrz);
  printcod(ff,"Uospod","kod","naik",0,podrz,&klst);
  *kst+=klst+1;
 }

if(hnaz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Группа налогового учета"),hnaz);
  printcod(ff,"Uosgrup","kod","naik",1,hnaz,&klst);
  *kst+=klst+1;
 }
if(hnabyz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Группа бухгалтерского учета"),hnabyz);
  printcod(ff,"Uosgrup1","kod","naik",1,hnabyz,&klst);
  *kst+=klst+1;
 }
if(kodolz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Мат.-ответственный"),kodolz);
  printcod(ff,"Uosol","kod","naik",1,kodolz,&klst);
  *kst+=klst+1;
 }
if(hauz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Шифр аналитического учета"),hauz);
  printcod(ff,"Uoshau","kod","naik",0,hauz,&klst);
  *kst+=klst+1;
 }
if(shetupoi[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Счет"),shetupoi);
  *kst+=1;
 }

if(innomp[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Инвентарный номер"),innomp);
  *kst+=1;
 }

if(hztz[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Шифр затрат"),hztz);
  *kst+=1;
 }

if(sosob[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Состояние объекта"),sosob);
  *kst+=1;
 }

if(kod_op[0] != '\0')
 {
  fprintf(ff,"%s: %s\n",gettext("Код операции"),kod_op);
  *kst+=1;
 }
if(metkaost == 1)
 {
  fprintf(ff,"%s\n",gettext("Основные средства с нулевою остаточной стоимостью"));
  *kst+=1;
 }
if(metkaost == 2)
 {
  fprintf(ff,"%s\n",gettext("Основные средства с ненулевой остаточной стоимостью"));
  *kst+=1;
 }
*kst+=1;
if(metr == 0)
 fprintf(ff,"%s\n",gettext("По подразделениям"));
if(metr == 1)
 fprintf(ff,"%s\n",gettext("По материально-ответственным"));

*kst+=1;
if(metka_sort == 0)
 fprintf(ff,"%s\n",gettext("Сортировка по группам"));
if(metka_sort == 1)
 fprintf(ff,"%s\n",gettext("Сортировать по счетам учёта"));

}
/****************************/
/*проверка реквизитов поиска*/
/*****************************/
int uosvosii_rek(int in,
const char *naim,
int viduh,
int metr,
int metka_sort,
short mn,short gn,
const char *podrz,
const char *kodolz,
const char *shetupoi,
const char *hztz,
const char *hnaz,
const char *hnabyz,
const char *hauz,
const char *sosob,
int *kolstr3,
int poddz,
int kodotl,
FILE *ff)
{
/*Переменные данные по инвентарному номеру*/
char		shetu[32]; /*Счет учета*/
char		hzt[32];   /*Шифр затрат*/
char		hau[24];   /*Шифр аналитического учета*/
char		hna[32];   /*Шифр нормы амортотчислений*/
float		popkf;   /*Поправочный коэффициент*/
char		hnaby[32];   /*Шифр нормы амортотчислений*/
float		popkfby;   /*Поправочный коэффициент*/
int		soso;    /*Состояние объекта*/
char		nomz[112];  /*Номерной знак*/
short		m1,g1;
/****************/

poiinpd(in,mn,gn,shetu,hzt,hau,hna,&popkf,&soso,nomz,&m1,&g1,hnaby,&popkfby);
   

if(viduh == 0) //Пропускаем все основные средства если для них амортизазия считается в целом по группе
 if(uosprovgr(hna) == 1)
    return(1);

if(viduh == 0 ) //Налоговый учёт
 {
  if(soso == 0 || soso == 3) //амортизация считается
   if(sosob[0] == '-')
    return(1);
  if(soso == 1 || soso == 2) //амортизация не считаестя
   if(sosob[0] == '+')
    return(1);
  
 }
if(viduh == 1 ) //Бух.учёт
 {
  if(soso == 0 || soso == 2) //амортизация считается
   if(sosob[0] == '-')
    return(1);
  if(soso == 1 || soso == 3) //амортизация не считаестя
   if(sosob[0] == '+')
    return(1);
  
 }
if(proverka(shetupoi,shetu,0,0) != 0)
  return(1);

if(proverka(hztz,hzt,0,0) != 0)
  return(1);

if(proverka(hnaz,hna,0,0) != 0)
  return(1);

if(proverka(hnabyz,hnaby,0,0) != 0)
  return(1);

if(proverka(hauz,hau,0,0) != 0)
  return(1);

*kolstr3+=1;
char pole1[50];
memset(pole1,'\0',sizeof(pole1));      
if(metr == 0) //По подразделениям
 {
    
    if(metka_sort == 0)
     {
      if(viduh == 0) //налоговый учёт
        strcpy(pole1,hna);
      if(viduh == 1) //бухгалтерский учёт
        strcpy(pole1,hnaby);

      if(pole1[0] == '\0')
       strcpy(pole1,"???");
      fprintf(ff,"%s|%d|%d|%s|%d|%s|\n",pole1,poddz,in,naim,kodotl,nomz);
     }
    if(metka_sort == 1)
      fprintf(ff,"%s|%d|%d|%s|%d|%s|\n",shetu,poddz,in,naim,kodotl,nomz);
  
 }

if(metr == 1) //По материально-ответственным
 {

    if(metka_sort == 0)
     {
      if(viduh == 0) //Налоговый учет
        strcpy(pole1,hna);
      if(viduh == 1) //Бухгалтерский учет
        strcpy(pole1,hnaby);

      if(pole1[0] == '\0')
       strcpy(pole1,"???");

      fprintf(ff,"%s|%d|%d|%s|%d|%s|\n",pole1,kodotl,in,naim,poddz,nomz);
     }
    if(metka_sort == 1)
      fprintf(ff,"%s|%d|%d|%s|%d|%s|\n",shetu,kodotl,in,naim,poddz,nomz);
 }

return(0);
}
/*********************************/
/*определение где и с какими реквизитами числится основное средство на указанную дату*/
/*************************************/
int uosvosii_poi(int in,
const char *naim,
int viduh,
int metr,
int metka_sort,
short dn,short mn,short gn,
short dk,short mk,short gk,
const char *podrz,
const char *kodolz,
const char *shetupoi,
const char *hztz,
const char *hnaz,
const char *hnabyz,
const char *hauz,
const char *sosob,
int *kolstr3,
FILE *ff)
{
SQL_str row,row1;
class SQLCURSOR cur,cur1;
int kolstr=0;
char strsql[512];
int poddz=0;
int kodotl=0;
if(poiin(in,dn,mn,gn,&poddz,&kodotl) == 0) 
 {
  if(proverka(podrz,poddz,0,0) == 0)
   if(proverka(kodolz,kodotl,0,0) == 0)
     uosvosii_rek(in,naim,viduh,metr,metka_sort,mn,gn,podrz,kodolz,shetupoi,hztz,hnaz,hnabyz,hauz,sosob,kolstr3,poddz,kodotl,ff);
 }

/*просмотриваем период -может быть куча внутренних перемещений*/

sprintf(strsql,"select datd,podr,nomd from Uosdok1 where \
datd >= '%04d-%d-%d' and datd <= '%04d-%d-%d' and innom=%d and podt=1 \
order by datd asc, tipz desc",gn,mn,dn,gk,mk,dk,in);


if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
short d,m,g;
while(cur.read_cursor(&row) != 0)
 {
  if(proverka(podrz,row[1],0,0) != 0)
   continue;
  poddz=atoi(row[1]);
  rsdat(&d,&m,&g,row[0],2);
  /**************Читаем документ*/
  sprintf(strsql,"select kodol from Uosdok where datd='%s' and \
  nomd='%s'",row[0],row[2]);

  //printw("%s\n",strsql);

  if(readkey(strsql,&row1,&cur1) != 1)
   {
    sprintf(strsql,"Не найден документ N%s от %s !",row[2],row[0]);
    iceb_t_soob(strsql);
    continue;
   }
  kodotl=atoi(row1[0]);
  if(proverka(kodolz,row1[0],0,0) != 0)
   continue;

  uosvosii_rek(in,naim,viduh,metr,metka_sort,m,g,podrz,kodolz,shetupoi,hztz,hnaz,hnabyz,hauz,sosob,kolstr3,poddz,kodotl,ff);
 }




/***********************
if(poiin(in,dn,mn,gn,&poddz,&kodotl) != 0) 
  return(2); //не числится на указанную дату
  
if(proverka(podrz,poddz,0,0) != 0)
  return(1);

if(proverka(kodolz,kodotl,0,0) != 0)
  return(1);

return(uosvosii_rek(in,naim,viduh,metr,metka_sort,dn,mn,gn,podrz,kodolz,shetupoi,hztz,hnaz,hnabyz,hauz,sosob,kolstr3,ff));

***********************/  
return(0);
}
