/*$Id: upl_rplpa.c,v 5.28 2011-01-13 13:43:24 sasa1 Exp $*/
/*06.02.2010	08.06.2005	Белых А.И.	upl_rplpa.c
Реестр путевых листов по автомобилям
*/
#include        <errno.h>
#include        <math.h>
#include        <time.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void upl_rplpv_nad(short dn,short mn,short gn,short dk,short mk,short gk,char*,char *naimavt,char *rnavt,FILE *ff);
double per_top_avt(short dn,short mn,short gn,short dk,short mk,short gk,char *kodavt,double ost2,FILE *ff_vse);
double upl_rplpa_pt(short dpp,short mpp,short gpp,short dk,short mk,short gk,char *kodavt,double ost2,FILE *ff_vse);

extern char *organ;

int upl_rplpa(short dn,short mn,short gn,
short dk,short mk,short gk,
char *kodavt,
char *kodvod,
char *podr,
class spis_oth *oth)
{
char strsql[512];
int	kolstr=0;
SQL_str row,row1;
time_t  tmmn;
time(&tmmn);

clear();
printw("%s\n",gettext("Реестр путевых листов"));
printw("%d.%d.%d => %d.%d.%d\n",dn,mn,gn,dk,mk,gk);
GDITE();


//Определяем список aвтомобилей
/********
sprintf(strsql,"select distinct ka from Upldok1 where datd >= '%d-%d-%d' and \
datd <= '%d-%d-%d' order by kv,ka asc",gn,mn,dn,gk,mk,dk);
**********/
sprintf(strsql,"select distinct ka from Upldok1 where datd >= '%d-%d-%d' and \
datd <= '%d-%d-%d'",gn,mn,dn,gk,mk,dk);

SQLCURSOR cur;
SQLCURSOR cur1;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Нет записей по заданным реквизитам поиска !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }  

SPISOK avtomobil;

int kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s\n",row[0],row[1]);
  
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(kodavt,row[0],0,0) != 0)
   continue;

  avtomobil.plus(row[0]);

 }

char imaf_vse[40];
FILE *ff_vse;

sprintf(imaf_vse,"rplpa%d.lst",getpid());

if((ff_vse = fopen(imaf_vse,"w")) == NULL)
 {
  error_op_nfil(imaf_vse,errno,"");
  return(1);
 }

char naimavt[512];
char rnavt[32];
char kodav[32];
int     nomstr=0;
int probeg=0;
double tono_kil;
int itogo_probeg=0;
double itogo_vesgr=0.0;
double itogo_tk=0.0;
double itogo_has=0.0;
double gor_nor,zagor_nor,gruz_nor,mhas_nor;
double gor_fak,zagor_fak,gruz_fak,mhas_fak;
double raznica;
double itog_nor[5];
double itog_fak[6];
memset(&itog_nor,'\0',sizeof(itog_nor));
memset(&itog_fak,'\0',sizeof(itog_fak));
double kolihi=0.;
double kolih=0.;
int nomer1=0;
int kol=avtomobil.kolih();
kolstr1=0;
int kolstr2=0;
double prin=0.;
double poluh=0.;
double iprin=0.;
double ipoluh=0.;
double iperedano=0.;

for(int nomer=0; nomer < kol; nomer++)
 {
  strzag(LINES-1,0,kol,++kolstr2);
  iperedano=0.;
  itogo_vesgr=0.0;
  itogo_tk=0.;
  itogo_has=0.;
  itogo_probeg=0;
  double  iprobeg=0.;
  double  iprobeg_zg=0.;
  double ost1=0.,ost2=0.;
  double  ividano=0.;
  double  irash=0.;
  memset(&itog_nor,'\0',sizeof(itog_nor));
  memset(&itog_fak,'\0',sizeof(itog_fak));

  iprin=0.;
  ipoluh=0.;

  strncpy(kodav,avtomobil.ravno(nomer),sizeof(kodav)-1);

  SPISOK KZMT; //Код заправки|марка топлива
  masiv_din_double SMT;

  //Читаем автомобиль
  memset(rnavt,'\0',sizeof(rnavt));
  memset(naimavt,'\0',sizeof(naimavt));
  sprintf(strsql,"select nomz,naik from Uplavt where kod=%s",kodav);
  if(sql_readkey(&bd,strsql,&row,&cur1) == 1)  
   {
    strncpy(rnavt,row[0],sizeof(rnavt)-1);
    strncpy(naimavt,row[1],sizeof(naimavt)-1);
   }

  if(nomer != 0)
    fprintf(ff_vse,"\f");

  upl_rplpv_nad(dn,mn,gn,dk,mk,gk,kodav,naimavt,rnavt,ff_vse);

  fprintf(ff_vse,"\
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");

  fprintf(ff_vse,gettext("\
Номер  |  Дата    |Показ.спидом.|Пробег| Груз |Выполнено |Норма |Отраб.|Н.с.  |Пробег|Норма |Пробег|Норма |Остаток|Приня- |Получе-|Затраты|Переда-|Остаток|Затраты топлива (по норме/факт)| Итого  | Разница|\n\
п.листа|          |выезд |возвр.|      |      | т/км     | т/км |м/час |м/час |город |спис. |за гор|спис. |       |  то   |  но   |       |  но   |       |По гор.|За гор.|На груз|М/час  |        |        |\n"));
//1        2         3      4      5      6        7         8     9      10     11    12     13      14     15       16     17      18     19        20     21      22     23      24       25       26                                          
  fprintf(ff_vse,"\
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");

  sprintf(strsql,"select datd,kp,nomd,psv,psz,ztfa,prob,nst,ztfazg,probzg,nstzg,\
vesg,ztvsn,ztvsf,vrr,ztvrn,ztvrf,tk,kv,nz,otmet from Upldok where \
datd >= '%d-%d-%d' and datd <= '%d-%d-%d' and ka=%s order by datd,nomd asc",
  gn,mn,dn,gk,mk,dk,kodav); 

  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }
  printw("\n%s=%s\n",
  gettext("Код автомобиля"),
  kodav);
  refresh();    
  short dd=0,md=0,gd=0;  
  short dp=0,mp=0,gp=0;  
  nomstr=0;  
  int nom_zap=0;
  while(cur.read_cursor(&row) != 0)
   {
    nomstr++;
    if(proverka(podr,row[1],0,0) != 0)
     continue;
    if(proverka(kodvod,row[18],0,0) != 0)
     continue;

    rsdat(&dd,&md,&gd,row[0],2);
    nom_zap=atoi(row[19]);
    printw("%02d.%02d.%d %2s %s\n",dd,md,gd,row[1],row[2]);
    refresh();    
/************************
   Несколько передач топлива с одной машины на другие в течение одного дня не должно быть
   а если будут то пусть она их все покажет после первого путевого листа в общей сумме
*********************/
    if(dp != 0 && sravmydat(dp,mp,gp,dd,md,gd) != 0)
     {
//      printw("111111111111\n");
      //смотрим былали передача топлива между двумя путевыми листами
      iperedano+=per_top_avt(dp,mp,gp,dd,md,gd,kodav,ost2,ff_vse);
     }
    dp=dd;
    mp=md;
    gp=gd;

    sprintf(strsql,"select kodsp,kodtp,kolih,tz,kap,ka from Upldok1 where datd='%s' and kp=%s \
and nomd='%s'",row[0],row[1],row[2]);

    if((kolstr1=cur1.make_cursor(&bd,strsql)) < 0)
     {
      msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
      continue;
     }
    ost1=ostva(dd,md,gd,"",kodav,nom_zap,NULL,NULL);
//      printw("\nost1=%.2f\n",ost1);      
//      OSTANOV();

    kolihi=0.;
    double kolspis=0;
    prin=poluh=0.;    
    while(cur1.read_cursor(&row1) != 0)
     {
//      printw("*****%s %s %s %s %s %s\n",row1[0],row1[1],row1[2],row1[3],row1[4],row1[5]);
      if(row1[3][0] == '1')
       {
        if(atoi(row1[4]) != 0)
         {
          if(SRAV(row1[4],row1[5],0) == 0) //игнорируем передачи топлива между водителями на одной машине
           {
            printw("Игнорируем передачи топлива между водителями на одной машине.\n");
            continue;
           }
          fprintf(ff_vse,"%106s %2s %4s %7.7g\n",
          " ",row1[0],row1[1],atof(row1[2]));

         }         
        else        
          fprintf(ff_vse,"%106s %2s %4s %7s %7.7g\n",
          " ",row1[0],row1[1]," ",atof(row1[2]));
        
        kolih=atof(row1[2]);

        if(atoi(row1[4]) != 0)
         prin+=kolih;
        else
         poluh+=kolih;
         
        kolihi+=kolih;
        sprintf(strsql,"%s|%s",row1[0],row1[1]);

        if((nomer1=KZMT.find(strsql)) < 0)
          KZMT.plus(strsql);
        SMT.plus(kolih,nomer1);
      }
     else
      {
       kolspis+=atof(row1[2]);
      }
     }
    iprin+=prin;
    ipoluh+=poluh;
    
    ost2=ost1+kolihi-kolspis;
    ost2=okrug(ost2,0.001);
    
    iprobeg+=atof(row[6]);
    iprobeg_zg+=atof(row[9]);
    ividano+=kolihi;
    irash+=kolspis;



    probeg=atoi(row[4])-atoi(row[3]);
    itogo_probeg+=probeg;
    
    tono_kil=atof(row[17]);    
    itogo_tk+=tono_kil;

    itogo_vesgr+=atof(row[11]);
    itogo_has+=atof(row[14]);
    
    gor_nor=atof(row[6])*atof(row[7])/100.;
    gor_nor=okrug(gor_nor,0.001);
    
    zagor_nor=atof(row[9])*atof(row[10])/100.;
    zagor_nor=okrug(zagor_nor,0.001);
    
    gruz_nor=tono_kil*atof(row[12])/100.;
    gruz_nor=okrug(gruz_nor,0.001);

    mhas_nor=atof(row[14])*atof(row[15]);
    mhas_nor=okrug(mhas_nor,0.001);

    itog_nor[0]+=gor_nor;
    itog_nor[1]+=zagor_nor;
    itog_nor[2]+=gruz_nor;
    itog_nor[3]+=mhas_nor;
    itog_nor[4]+=gor_nor+zagor_nor+gruz_nor+mhas_nor;
        
    gor_fak=atof(row[5]);
    zagor_fak=atof(row[8]);
    gruz_fak=atof(row[13]);
    mhas_fak=atof(row[16]);

    raznica=(gor_fak+zagor_fak+gruz_fak+mhas_fak)-(gor_nor+zagor_nor+gruz_nor+mhas_nor);
    raznica=okrug(raznica,0.001);
    
    itog_fak[0]+=gor_fak;
    itog_fak[1]+=zagor_fak;
    itog_fak[2]+=gruz_fak;
    itog_fak[3]+=mhas_fak;
    itog_fak[4]+=gor_fak+zagor_fak+gruz_fak+mhas_fak;
    itog_fak[5]+=raznica;






    fprintf(ff_vse,"%*s %02d.%02d.%d %6s %6s \
%6d %6.7g %10.10g %6.7g %6.7g %6.7g \
%6s %6.10g %6s %6.7g %7.7g %7.7g %7.7g %7.7g %7s %7.7g \
%7.7g %7.7g %7.7g %7.7g %8.8g %s\n",
    iceb_tu_kolbait(7,row[2]),row[2],dd,md,gd,row[3],row[4],
    probeg,atof(row[11]),tono_kil,atof(row[12]),atof(row[14]),atof(row[15]),
    row[6],atof(row[7]),row[9],atof(row[10]),
    ost1,prin,poluh,kolspis," ",ost2,
    gor_nor,zagor_nor,gruz_nor,mhas_nor,
    gor_nor+zagor_nor+gruz_nor+mhas_nor,row[20]);

    
    fprintf(ff_vse,"%154s %7.10g %7.10g %7.10g %7.10g %8.10g %8.10g\n",
    " ",gor_fak,zagor_fak,gruz_fak,mhas_fak,
    gor_fak+zagor_fak+gruz_fak+mhas_fak,
    raznica);
    
    if(nomstr < kolstr)
      fprintf(ff_vse,"\
 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .\n");
   }
  if(dd != 0)
   iperedano+=upl_rplpa_pt(dd,md,gd,dk,mk,gk,kodav,ost2,ff_vse);
   
/********************
  if(dp != 0 && sravmydat(dp,mp,gp,dk,mk,gk) != 0)
   {
    printw("Второй вызов.\n");
    iperedano+=per_top_avt(dp,mp,gp,dk,mk,gk,kodav,ost2,1,ff_vse);
   }
**********************/
  fprintf(ff_vse,"\
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
  fprintf(ff_vse,"%*s \
%6d %6.7g %10.10g %6s %6.7g %6s \
%6.6g %6s %6.6g        %7s %7.7g %7.7g %7.7g %7.7g %7s \
%7.7g %7.7g %7.7g %7.7g %8.8g\n",
  iceb_tu_kolbait(32,gettext("Итого")),gettext("Итого"),
  itogo_probeg,itogo_vesgr,itogo_tk," ",itogo_has," ",
  iprobeg," ",iprobeg_zg," ",iprin,ipoluh,irash,iperedano," ",
  itog_nor[0],itog_nor[1],itog_nor[2],itog_nor[3],itog_nor[4]);

  fprintf(ff_vse,"%154s %7.7g %7.7g %7.8g %7.7g %8.8g %8.8g\n",
  " ",itog_fak[0],itog_fak[1],itog_fak[2],itog_fak[3],itog_fak[4],itog_fak[5]);


  int kol1=KZMT.kolih();
  char kodvd[30];
  char naimvod[512];

  uplrpl_sapi(ff_vse); //uplrpl.c

  for(nomer1=0; nomer1 < kol1; nomer1++)
    {
     polen(KZMT.ravno(nomer1),kodvd,sizeof(kodvd),1,'|');
     polen(KZMT.ravno(nomer1),kodav,sizeof(kodav),2,'|');

     //Читаем поставщика
     memset(naimvod,'\0',sizeof(naimvod));
     sprintf(strsql,"select naik from Uplouot where kod=%s",kodvd);
     if(sql_readkey(&bd,strsql,&row,&cur1) == 1)  
       strncpy(naimvod,row[0],sizeof(naimvod)-1);

     fprintf(ff_vse,"%3s %-*.*s %-13.13s %10.10g\n",
     kodvd,
     iceb_tu_kolbait(23,naimvod),iceb_tu_kolbait(23,naimvod),naimvod,
     kodav,SMT.ravno(nomer1));  
    }

  fprintf(ff_vse,"\
-----------------------------------------------------\n");

  fprintf(ff_vse,"\n%s__________________\n",gettext("Бухгалтер"));


 }

podpis(ff_vse);
fclose(ff_vse);

printw_vr(tmmn);


OSTANOV();
oth->spis_imaf.plus(imaf_vse);
oth->spis_naim.plus(gettext("Реестр путевых листов"));

iceb_t_ustpeh(imaf_vse,0);

return(0); 
}
/**************************/
/*Надпись над шапкой*/
/**************************/
void upl_rplpv_nad(short dn,short mn,short gn,
short dk,short mk,short gk,
char *kodavt,
char *naimavt,
char *rnavt,
FILE *ff)
{

zagolov(gettext("Реестр путевых листов по автомобилям"),dn,mn,gn,dk,mk,gk,organ,ff);

fprintf(ff,"\n\
%s %s %s %s %s\n",
gettext("Автомобиль"),
kodavt,
naimavt,
gettext("регистрационный номер"),
rnavt);
}
/*******************************/
/*Смотрим былали передача топлива между предыдущей путёвкой и настоящей*/
/****************************************/
double per_top_avt(short dn,short mn,short gn,
short dk,short mk,short gk,
char *kodavt,
double ost2,
FILE *ff_vse)
{
SQL_str row;
SQLCURSOR cur;
int kolstr;
char strsql[512];
double suma=0.;
short d,m,g;
double isuma=0.;


sprintf(strsql,"select datd,nomd,kolih from Upldok1 where datd >= '%d-%d-%d' and \
datd < '%d-%d-%d' and kap=%s and tz=1 and ka <> '%s'",
gn,mn,dn,gk,mk,dk,kodavt,kodavt);

//printw("strsql=%s\n",strsql);


if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(0.);
 }
while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s %s\n",row[0],row[1],row[2]);  
  suma=atof(row[2]);
  isuma+=suma;
  rsdat(&d,&m,&g,row[0],2);
  
  fprintf(ff_vse,"%*s %02d.%02d.%04d %118s %8.8g %7.7g\n",
  iceb_tu_kolbait(7,row[1]),row[1],d,m,g," ",suma,ost2-isuma);
 }

return(isuma);

}

/*************************/
/*Смотрим от дня последней путёвки в периоде до конца заданного периода - не было ли передач топлива*/
/********************************************/
double upl_rplpa_pt(short dpp,short mpp,short gpp,
short dk,short mk,short gk,
char *kodavt,
double ost2,
FILE *ff_vse)
{
SQL_str row;
SQLCURSOR cur;
int kolstr;
char strsql[512];
double suma=0.;
short d,m,g;
double isuma=0.;

sprintf(strsql,"select datd,nomd,kolih from Upldok1 where datd >= '%d-%d-%d' \
and datd <= '%d-%d-%d' and kap=%s and tz=1 and ka <> '%s'",
gpp,mpp,dpp,gk,mk,dk,kodavt,kodavt);

//printw("strsql=%s\n",strsql);


if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(0.);
 }

while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s %s\n",row[0],row[1],row[2]);  
  suma=atof(row[2]);
  isuma+=suma;
  rsdat(&d,&m,&g,row[0],2);
  
  fprintf(ff_vse,"%*s %02d.%02d.%04d %118s %8.8g %7.7g\n",
  iceb_tu_kolbait(7,row[1]),row[1],d,m,g," ",suma,ost2-isuma);
 }

return(isuma);

}

