/*$Id: uplnast.c,v 5.19 2011-01-13 13:43:24 sasa1 Exp $*/
/*04.11.2009	21.03.2003	Белых А.И. 	uplnast.c
Чтение настроек для подсистемы "Учет путевых листов"
*/
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


short		vplsh; /*0-двух уровневый план счетов 1-многоуровневый*/
short		startgodupl=0; //Стартовый год для "Учета путевых листов"
short		startgodb=0; /*Стартовый год просмотров главной книги*/

int	uplnast(void)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];
char	bros[512];
char	st1[1024];

startgodupl=0;

sprintf(strsql,"select str from Alx where fil='uplnast.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"uplnast.alx");
  iceb_t_soob(strsql);
  return(1);
 }


while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  polen(row_alx[0],st1,sizeof(st1),1,'|');

  if(SRAV(st1,"Стартовый год",0) == 0)
   {
    polen(row_alx[0],st1,sizeof(st1),2,'|');
    startgodupl=(short)ATOFM(st1); 
    continue;
   }
 }


iceb_t_poldan("Многопорядковый план счетов",bros,"nastrb.alx");
if(SRAV(bros,"Вкл",1) == 0)
 vplsh=1;

memset(bros,'\0',sizeof(bros));
startgodb=0;
if(iceb_t_poldan("Стартовый год",bros,"nastrb.alx") == 0)
 {
  startgodb=(short)ATOFM(bros);
 }

return(0);

}
