/*$Id: uplovrp.c,v 5.39 2011-01-13 13:43:24 sasa1 Exp $*/
/*04.11.2009	27.04.2003	Белых А.И.	uplovrp.c
Распечатать оборотную ведомость движения топлива по автомобилям
*/
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void hpov(short,short,short,short,short,short,FILE*,FILE*);
void uplovrp_n(short dn,short mn,short gn,short dk,short mk,short gk,char *kodvod,char *kodavt,char *podr,char *nadp,FILE *ff);

extern char     *organ;/*Наименование организации*/

int uplovrp(short dn,short mn,short gn,
short dk,short mk,short gk,
char *kodavt,
char *kodvod,
char *podr,
class spis_oth *oth)
{
char	strsql[512];
int	kolstr=0;
SQL_str row,row1;
char	imaf[32];
FILE    *ff;
char	imaf_f[32];
FILE    *ff_f;
time_t  tmmn;
struct  tm      *bf;
SQLCURSOR curr;
time(&tmmn);
bf=localtime(&tmmn);
clear();
printw("%s\n",gettext("Оборотная ведомость движения топлива по автомобилям."));
printw("%d.%d.%d => %d.%d.%d\n",dn,mn,gn,dk,mk,gk);
GDITE();

//Определяем список автомобилей

sprintf(strsql,"select distinct kv,ka from Upldok1 where datd >= '%d-%d-%d' and \
datd <= '%d-%d-%d' order by ka,kv asc",gn,mn,dn,gk,mk,dk);

SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Нет записей по заданным реквизитам поиска !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }  
SPISOK KVKA;  //код водителя|код автомобиля
masiv_din_int kod_avt;  //коды автомобилей
#define OST_AVTOMOBIL 9
masiv_din_double ost_avt[OST_AVTOMOBIL]; //остатки по автомобилям

masiv_din_int kod_vod;  //коды водителей
#define OST_VODITEL 9
masiv_din_double ost_vod[OST_VODITEL]; //остатки по водителям


int kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s\n",row[0],row[1]);
  
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(kodvod,row[0],0,0) != 0)
   continue;

  if(proverka(kodavt,row[1],0,0) != 0)
   continue;

  sprintf(strsql,"%s|%s",row[0],row[1]);
  KVKA.plus(strsql);
  
  if(kod_avt.find(atoi(row[1])) < 0)
   kod_avt.plus(atoi(row[1]),-1);

  if(kod_vod.find(atoi(row[0])) < 0)
   kod_vod.plus(atoi(row[0]),-1);
 }

kolstr1=kod_avt.kolih();

for(int i=0 ; i < OST_AVTOMOBIL; i++)
 ost_avt[i].make_class(kolstr1);

kolstr1=kod_vod.kolih();

for(int i=0 ; i < OST_VODITEL; i++)
 ost_vod[i].make_class(kolstr1);

sprintf(imaf,"rpl%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

uplovrp_n(dn,mn,gn,dk,mk,gk,kodvod,kodavt,podr,gettext("Оботротная ведомость движения топлива по автомобилям."),ff);

sprintf(imaf_f,"rplf%d.lst",getpid());

if((ff_f = fopen(imaf_f,"w")) == NULL)
 {
  error_op_nfil(imaf_f,errno,"");
  return(1);
 }

uplovrp_n(dn,mn,gn,dk,mk,gk,kodvod,kodavt,podr,gettext("Оботротная ведомость движения топлива по автомобилям."),ff_f);

hpov(dn,mn,gn,dk,mk,gk,ff,ff_f);

int kol=KVKA.kolih();
//printw("kol=%d\n",kol);
char kodvd[32];
char kodav[32];
char naimvod[512];
char naimavt[512];
char rnavt[40];
double kolih=0.;

double rt_za_gor=0.;
double rt_po_gor=0.;
double rt_na_gruz=0.;
double rt_na_vrem=0.;

double irt_za_gor=0.;
double irt_po_gor=0.;
double irt_na_gruz=0.;
double irt_na_vrem=0.;

double dvig[4];
memset(&dvig,'\0',sizeof(dvig));
double idvig[4];
memset(&idvig,'\0',sizeof(idvig));
int nomer_avt=0;
char nomdok[32];
char datd[24];
char kp[32];
double peredano=0.;
double iperedano=0.;
char otmet[512];
int kolstr2=0;
for(int nomer=0; nomer < kol; nomer++)
 {

  polen(KVKA.ravno(nomer),kodvd,sizeof(kodav),1,'|');
  polen(KVKA.ravno(nomer),kodav,sizeof(kodvd),2,'|');

  printw("\n%s=%s %s=%s\n",
  gettext("Код водителя"),
  kodvd,
  gettext("Код автомобиля"),
  kodav);

  strzag(LINES-1,0,kol,++kolstr2);
  
//  printw("%s %s\n",kodav,kodvd);
  //Читаем водителя
  memset(naimvod,'\0',sizeof(naimvod));
  strcpy(naimvod,kodvd);
  sprintf(strsql,"select naik from Uplouot where kod=%s",kodvd);
//  printw("%s\n",strsql);
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)  
   {
    strcat(naimvod," ");
    strcat(naimvod,row[0]);
   }
  //Читаем автомобиль
  memset(rnavt,'\0',sizeof(rnavt));
  memset(naimavt,'\0',sizeof(naimavt));
  strcpy(naimavt,kodav);
  sprintf(strsql,"select nomz,naik from Uplavt where kod=%s",kodav);
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)  
   {
    strncpy(rnavt,row[0],sizeof(rnavt)-1);
    strcat(naimavt," ");
    strcat(naimavt,row[1]);
   }

  sprintf(strsql,"select kp,tz,kolih,datd,nomd,nz,kap from Upldok1 where datd >= '%d-%d-%d' \
and datd <= '%d-%d-%d' and kv=%s and ka=%s order by datd,nomd asc",
  gn,mn,dn,gk,mk,dk,kodvd,kodav);

  if((kolstr1=cur.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }
  memset(&dvig,'\0',sizeof(dvig));



  memset(nomdok,'\0',sizeof(nomdok));
  rt_za_gor=rt_po_gor=rt_na_gruz=rt_na_vrem=0.;
  int sh_str=0;
  while(cur.read_cursor(&row) != 0)
   {
    if(sh_str == 0)
     {
      dvig[0]=ostva(dn,mn,gn,kodvd,kodav,atoi(row[5]),NULL,NULL);
      sh_str=1;
     }
//    printw("%s %s %s %s %s\n",row[0],row[1],row[2],row[3],row[4]);
    if(proverka(podr,row[0],0,0) != 0)
     continue;
    kolih=atof(row[2]);               
    if(row[1][0] == '1')
     {
      if(atoi(row[6]) != 0)
        dvig[1]+=kolih;      
      else
        dvig[2]+=kolih;      
     }
    else
     {
      dvig[3]+=kolih;      
     }
    if(SRAV(nomdok,row[4],0) != 0)
     {
      memset(otmet,'\0',sizeof(otmet));
      if(nomdok[0] != '\0')
       {
        //читаем фактические затраты топлива в шапке документа
        sprintf(strsql,"select ztfa,ztfazg,ztvsf,ztvrf,otmet from Upldok where datd='%s' and kp=%s and nomd='%s'",
        datd,kp,nomdok);
//        printw("strsql=%s\n",strsql);
        
        if(readkey(strsql,&row1,&curr) == 1)
         {
          rt_po_gor+=atof(row1[0]);
          rt_za_gor+=atof(row1[1]);
          rt_na_gruz+=atof(row1[2]);
          rt_na_vrem+=atof(row1[3]);
          strncpy(otmet,row1[4],sizeof(otmet)-1);
         }
        else
         {
          VVOD SOOB(1);
          SOOB.VVOD_SPISOK_add_MD(gettext("Не найдена шапка документа !"));
          sprintf(strsql,"%s %s",datd,nomdok);
          SOOB.VVOD_SPISOK_add_MD(strsql);
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          
         }
       }
      strncpy(nomdok,row[4],sizeof(nomdok)-1); 
      strncpy(datd,row[3],sizeof(datd)-1); 
      strncpy(kp,row[0],sizeof(kp)-1); 
     }    
   }
  if(kolstr1 != 0)
   {
    //читаем фактические затраты топлива в шапке документа
    sprintf(strsql,"select ztfa,ztfazg,ztvsf,ztvrf from Upldok where datd='%s' and kp=%s and nomd='%s'",
    datd,kp,nomdok);
//    printw("*strsql=%s\n",strsql);
    if(readkey(strsql,&row1,&curr) == 1)
     {
      rt_po_gor+=atof(row1[0]);
      rt_za_gor+=atof(row1[1]);
      rt_na_gruz+=atof(row1[2]);
      rt_na_vrem+=atof(row1[3]);
     }
    else
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Не найдена шапка документа !"));
      sprintf(strsql,"%s %s",datd,nomdok);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      
     }
   }

  peredano=upl_pt(dn,mn,gn,dk,mk,gk,kodav,kodvd);
  iperedano+=peredano;
  
  kolih=dvig[0]+dvig[1]+dvig[2]-dvig[3]-peredano;

  nomer_avt=kod_avt.find(atoi(kodav));
  
  ost_avt[0].plus(dvig[0],nomer_avt);
  ost_avt[1].plus(dvig[1],nomer_avt);
  ost_avt[2].plus(dvig[2],nomer_avt);
  ost_avt[3].plus(dvig[3],nomer_avt);
  ost_avt[4].plus(peredano,nomer_avt);
  ost_avt[5].plus(rt_po_gor,nomer_avt);
  ost_avt[6].plus(rt_za_gor,nomer_avt);
  ost_avt[7].plus(rt_na_gruz,nomer_avt);
  ost_avt[8].plus(rt_na_vrem,nomer_avt);

  nomer_avt=kod_vod.find(atoi(kodvd));

  ost_vod[0].plus(dvig[0],nomer_avt);
  ost_vod[1].plus(dvig[1],nomer_avt);
  ost_vod[2].plus(dvig[2],nomer_avt);
  ost_vod[3].plus(dvig[3],nomer_avt);
  ost_vod[4].plus(peredano,nomer_avt);
  ost_vod[5].plus(rt_po_gor,nomer_avt);
  ost_vod[6].plus(rt_za_gor,nomer_avt);
  ost_vod[7].plus(rt_na_gruz,nomer_avt);
  ost_vod[8].plus(rt_na_vrem,nomer_avt);
  
  fprintf(ff,"%-*.*s %-*.*s %-*.*s %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %s\n",
  iceb_tu_kolbait(15,naimavt),iceb_tu_kolbait(15,naimavt),naimavt,
  iceb_tu_kolbait(15,rnavt),iceb_tu_kolbait(15,rnavt),rnavt,
  iceb_tu_kolbait(20,naimvod),iceb_tu_kolbait(20,naimvod),naimvod,
  dvig[0],dvig[1],dvig[2],dvig[3],peredano,kolih,otmet);

  fprintf(ff_f,"%-*.*s %-*.*s %-*.*s %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %s\n",
  iceb_tu_kolbait(15,naimavt),iceb_tu_kolbait(15,naimavt),naimavt,
  iceb_tu_kolbait(15,rnavt),iceb_tu_kolbait(15,rnavt),rnavt,
  iceb_tu_kolbait(20,naimvod),iceb_tu_kolbait(20,naimvod),naimvod,
  dvig[0],dvig[1],dvig[2],dvig[3],peredano,kolih,
  rt_po_gor,rt_za_gor,rt_na_gruz,rt_na_vrem,
  rt_po_gor+rt_za_gor+rt_na_gruz+rt_na_vrem,otmet);
  
  idvig[0]+=dvig[0];
  idvig[1]+=dvig[1];
  idvig[2]+=dvig[2];
  idvig[3]+=dvig[3];

  irt_za_gor+=rt_za_gor;
  irt_po_gor+=rt_po_gor;
  irt_na_gruz+=rt_na_gruz;
  irt_na_vrem+=rt_na_vrem;

 }
fprintf(ff,"\
-----------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff_f,"\
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");

kolih=idvig[0]+idvig[1]+idvig[2]-idvig[3]-iperedano;

fprintf(ff,"\
%*s:%10.2f %10.2f %10.2f %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(52,gettext("Итого")),gettext("Итого"),
idvig[0],idvig[1],idvig[2],idvig[3],iperedano,kolih);

fprintf(ff_f,"\
%*s:%10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(52,gettext("Итого")),gettext("Итого"),
idvig[0],idvig[1],idvig[2],idvig[3],iperedano,kolih,
irt_po_gor,irt_za_gor,irt_na_gruz,irt_na_vrem,
irt_po_gor+irt_za_gor+irt_na_gruz+irt_na_vrem);

podpis(ff);
fclose(ff);

podpis(ff_f);
fclose(ff_f);


//Распечатка только по автомобилям
char imaf_avt[30];
char imaf_avt_f[30];

sprintf(imaf_avt,"ostavt%d.lst",getpid());

if((ff = fopen(imaf_avt,"w")) == NULL)
 {
  error_op_nfil(imaf_avt,errno,"");
  return(1);
 }

uplovrp_n(dn,mn,gn,dk,mk,gk,kodvod,kodavt,podr,gettext("Оботротная ведомость движения топлива по автомобилям."),ff);

sprintf(imaf_avt_f,"ostavtf%d.lst",getpid());

if((ff_f = fopen(imaf_avt_f,"w")) == NULL)
 {
  error_op_nfil(imaf_avt_f,errno,"");
  return(1);
 }

uplovrp_n(dn,mn,gn,dk,mk,gk,kodvod,kodavt,podr,gettext("Оботротная ведомость движения топлива по автомобилям."),ff_f);


fprintf(ff,"\
-------------------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
Код |           Автомобиль          | Остаток  |    Движение топлива за период             | Остаток  |\n\
авт.|      Марка    |Государс. номер|%02d.%02d.%04d| Принято  | Получено |Потрачено | Передано |%02d.%02d.%04d|\n"),
dn,mn,gn,dk,mk,gk);

fprintf(ff,"\
-------------------------------------------------------------------------------------------------------\n");

fprintf(ff_f,"\
--------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff_f,gettext("\
Код |           Автомобиль          | Остаток  |      Движение топлива за период           | Остаток  |             Фактические затраты                      |\n\
авт.|      Марка    |Государс. номер|%02d.%02d.%04d| Принято  | Получено |Потрачено | Передано |%02d.%02d.%04d|По городу |За городом|На груз   |На мот.час|  Итого   |\n"),
dn,mn,gn,dk,mk,gk);
fprintf(ff_f,"\
--------------------------------------------------------------------------------------------------------------------------------------------------------------\n");



kol=kod_avt.kolih();
int kavt;
irt_za_gor=0.;
irt_po_gor=0.;
irt_na_gruz=0.;
irt_na_vrem=0.;

for(int nomer=0; nomer < kol; nomer++)
 {
  kavt=kod_avt.ravno(nomer);
  //Читаем автомобиль
  memset(rnavt,'\0',sizeof(rnavt));
  memset(naimavt,'\0',sizeof(naimavt));
  
  sprintf(strsql,"select nomz,naik from Uplavt where kod=%d",kavt);
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)  
   {
    strncpy(rnavt,row[0],sizeof(rnavt)-1);
    strncpy(naimavt,row[1],sizeof(naimavt)-1);
   }

  kolih=ost_avt[0].ravno(nomer)+ost_avt[1].ravno(nomer)+ost_avt[2].ravno(nomer)-\
  ost_avt[3].ravno(nomer)-ost_avt[4].ravno(nomer);

  fprintf(ff,"%4d %-*s %-*.*s %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f\n",
  kavt,
  iceb_tu_kolbait(15,naimavt),naimavt,
  iceb_tu_kolbait(15,rnavt),iceb_tu_kolbait(15,rnavt),rnavt,
  ost_avt[0].ravno(nomer),
  ost_avt[1].ravno(nomer),
  ost_avt[2].ravno(nomer),
  ost_avt[3].ravno(nomer),
  ost_avt[4].ravno(nomer),
  kolih);

  fprintf(ff_f,"%4d %-*s %-*.*s %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f\n",
  kavt,
  iceb_tu_kolbait(15,naimavt),naimavt,
  iceb_tu_kolbait(15,rnavt),iceb_tu_kolbait(15,rnavt),rnavt,
  ost_avt[0].ravno(nomer),
  ost_avt[1].ravno(nomer),
  ost_avt[2].ravno(nomer),
  ost_avt[3].ravno(nomer),
  ost_avt[4].ravno(nomer),
  kolih,
  ost_avt[5].ravno(nomer),
  ost_avt[6].ravno(nomer),
  ost_avt[7].ravno(nomer),
  ost_avt[8].ravno(nomer),
  ost_avt[5].ravno(nomer)+ ost_avt[6].ravno(nomer)+ ost_avt[7].ravno(nomer)+ost_avt[8].ravno(nomer));

 }


podpis(ff);
fclose(ff);

podpis(ff_f);
fclose(ff_f);

//Распечатка только по водителям
char imaf_vod[30];
char imaf_vod_f[30];

sprintf(imaf_vod,"ostvod%d.lst",getpid());

if((ff = fopen(imaf_vod,"w")) == NULL)
 {
  error_op_nfil(imaf_vod,errno,"");
  return(1);
 }

uplovrp_n(dn,mn,gn,dk,mk,gk,kodvod,kodavt,podr,gettext("Оботротная ведомость движения топлива по водителям"),ff);

sprintf(imaf_vod_f,"ostvodf%d.lst",getpid());

if((ff_f = fopen(imaf_vod_f,"w")) == NULL)
 {
  error_op_nfil(imaf_vod_f,errno,"");
  return(1);
 }

uplovrp_n(dn,mn,gn,dk,mk,gk,kodvod,kodavt,podr,gettext("Оботротная ведомость движения топлива по водителям"),ff_f);

fprintf(ff,"\
-------------------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
Код |       Фамилия водителя        | Остаток  |           Движение топлива за период      | Остаток  |\n\
вод.|                               |%02d.%02d.%04d| Принято  | Получено |Потрачено | Передано |%02d.%02d.%04d|\n"),
dn,mn,gn,dk,mk,gk);
fprintf(ff,"\
-------------------------------------------------------------------------------------------------------\n");

fprintf(ff_f,"\
-------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff_f,gettext("\
Код |       Фамилия водителя       | Остаток  |           Движение топлива за период      | Остаток  |             Фактические затраты                      |\n\
вод.|                              |%02d.%02d.%04d| Принято  | Получено |Потрачено | Передано |%02d.%02d.%04d|По городу |За городом|На груз   |На мот.час|  Итого   |\n"),
dn,mn,gn,dk,mk,gk);
fprintf(ff_f,"\
-------------------------------------------------------------------------------------------------------------------------------------------------------------\n");


kol=kod_vod.kolih();

for(int nomer=0; nomer < kol; nomer++)
 {
  kavt=kod_vod.ravno(nomer);

  //Читаем водителя
  memset(naimvod,'\0',sizeof(naimvod));
  sprintf(strsql,"select naik from Uplouot where kod=%d",kavt);
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)  
   {
    strncpy(naimvod,row[0],sizeof(naimvod)-1);
   }
  kolih=ost_vod[0].ravno(nomer)+ost_vod[1].ravno(nomer)+ost_vod[2].ravno(nomer)-ost_vod[3].ravno(nomer)-ost_vod[4].ravno(nomer);

  fprintf(ff,"%4d %-*.*s %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f\n",
  kavt,
  iceb_tu_kolbait(31,naimvod),iceb_tu_kolbait(31,naimvod),naimvod,
  ost_vod[0].ravno(nomer),
  ost_vod[1].ravno(nomer),
  ost_vod[2].ravno(nomer),
  ost_vod[3].ravno(nomer),
  ost_vod[4].ravno(nomer),
  kolih);

  fprintf(ff_f,"%4d %-*.*s %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f\n",
  kavt,
  iceb_tu_kolbait(30,naimvod),iceb_tu_kolbait(30,naimvod),naimvod,
  ost_vod[0].ravno(nomer),
  ost_vod[1].ravno(nomer),
  ost_vod[2].ravno(nomer),
  ost_vod[3].ravno(nomer),
  ost_vod[4].ravno(nomer),
  kolih,
  ost_vod[5].ravno(nomer),
  ost_vod[6].ravno(nomer),
  ost_vod[7].ravno(nomer),
  ost_vod[8].ravno(nomer),
  ost_vod[5].ravno(nomer)+ ost_vod[6].ravno(nomer)+ ost_vod[7].ravno(nomer)+ost_vod[8].ravno(nomer));

 }


podpis(ff);
fclose(ff);

podpis(ff_f);
fclose(ff_f);

printw_vr(tmmn);


OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Оборотная ведомость движения топлива по водителям и автомобилям"));

oth->spis_imaf.plus(imaf_avt);
oth->spis_naim.plus(gettext("Оборотная ведомость движения топлива по автомобилям"));

oth->spis_imaf.plus(imaf_vod);
oth->spis_naim.plus(gettext("Оборотная ведомость движения топлива по водителям"));


oth->spis_imaf.plus(imaf_f);

sprintf(strsql,"%s+%s",
gettext("Оборотная ведомость движения топлива по водителям и автомобилям"),
gettext("фактические затраты"));
oth->spis_naim.plus(strsql);

oth->spis_imaf.plus(imaf_avt_f);

sprintf(strsql,"%s+%s",
gettext("Оборотная ведомость движения топлива по автомобилям"),
gettext("фактические затраты"));
oth->spis_naim.plus(strsql);

oth->spis_imaf.plus(imaf_vod_f);

sprintf(strsql,"%s+%s",
gettext("Оборотная ведомость движения топлива по водителям"),
gettext("фактические затраты"));
oth->spis_naim.plus(strsql);

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);

}
/**************************/
/*Шапка                   */
/**************************/

void hpov(short dn,short mn,short gn,
short dk,short mk,short gk,
FILE *ff,FILE *ff_f)
{
fprintf(ff,"\
-----------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
           Автомобиль          |      Водитель      | Остаток  |           Движение топлива за период      | Остаток  |\n\
      Марка    |Государс. номер|                    |%02d.%02d.%04d| Принято  | Получено |Потрачено | Передано |%02d.%02d.%04d|\n"),
dn,mn,gn,dk,mk,gk);
fprintf(ff,"\
-----------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff_f,"\
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
fprintf(ff_f,gettext("\
           Автомобиль          |      Водитель      | Остаток  |           Движение топлива за период      | Остаток  |       Фактические затраты                            |\n\
      Марка    |Государс. номер|                    |%02d.%02d.%04d| Принято  | Получено |Потрачено | Передано |%02d.%02d.%04d|По городу |За городом|На груз   |На мот.час|  Итого   |\n"),
dn,mn,gn,dk,mk,gk);
fprintf(ff_f,"\
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\n");

}
/******************/
/*Надпись         */
/******************/

void uplovrp_n(short dn,short mn,short gn,
short dk,short mk,short gk,
char *kodvod,
char *kodavt,
char *podr,
char *nadp,
FILE *ff)
{
zagolov(nadp,dn,mn,gn,dk,mk,gk,organ,ff);

if(kodvod[0] != '\0')
  fprintf(ff,"%s:%s\n",gettext("Водитель"),kodvod);
if(kodavt[0] != '\0')
  fprintf(ff,"%s:%s\n",gettext("Автомобиль"),kodavt);
if(podr[0] != '\0')
  fprintf(ff,"%s:%s\n",gettext("Подразделение"),podr);
}
