/*$Id: uplvst.c,v 5.33 2011-01-13 13:43:24 sasa1 Exp $*/
/*17.12.2009	27.05.2003	Белых А.И.	uplvst.c
Ведомость списания топлива по водителям и счетам
*/
#include        <time.h>
#include        <math.h>
#include        <string.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void  itogvst(int,char*,double,double,double,double,double,double,FILE*,FILE*);
void     shetvst(int*,int*,FILE*);
void     svst(int*,int*,FILE*);
void uplvst_rp(int *kolstrok,char *toplivo,char *voditel,char *shet,char*,FILE *ff);

extern char     *organ;
extern int      kol_strok_na_liste;

int uplvst(class spis_oth *oth)
{
static char	dat1[11];
static char	dat2[11];
static char	toplivo[112];
static char	voditel[112];
static char	shet[112];
static char kod_avtom[112];
int		kom=0,kom1=0;
short		dn,mn,gn;
short		dk,mk,gk;
char		naim[512];
char	strsql[512];
class iceb_tu_str kodn("");
class iceb_tu_str naimn("");
SQLCURSOR cur1;
VVOD VV(0);
VVOD MENU(3);

VV.VVOD_SPISOK_add_data(dat1,sizeof(dat1));
VV.VVOD_SPISOK_add_data(dat2,sizeof(dat2));
VV.VVOD_SPISOK_add_data(toplivo,sizeof(toplivo));
VV.VVOD_SPISOK_add_data(voditel,sizeof(voditel));
VV.VVOD_SPISOK_add_data(shet,sizeof(shet));
VV.VVOD_SPISOK_add_data(kod_avtom,sizeof(kod_avtom));

VV.VVOD_SPISOK_add_ZAG(gettext("Распечатать ведомость списания топлива по водителям и счетам"));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала.(д.м.г)."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца..(д.м.г)."));
VV.VVOD_SPISOK_add_MD(gettext("Марка топлива..(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Код водителя...(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Счет...........(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Код автомобиля.(,,)."));

naz:;

clear();


helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(toplivo,VV.VVOD_SPISOK_return_data(2),sizeof(toplivo)-1);
strncpy(voditel,VV.VVOD_SPISOK_return_data(3),sizeof(voditel)-1);
strncpy(shet,VV.VVOD_SPISOK_return_data(4),sizeof(shet)-1);
strncpy(kod_avtom,VV.VVOD_SPISOK_return_data(5),sizeof(kod_avtom)-1);

switch(kom)
 {
  case FK1:
    GDITE();
    iceb_t_pdoc("upl4_3.txt");
    clear();
    goto naz;
  case FK10:
  case ESC:
   return(1);
  case FK2:
  case PLU:
   break;

  case FK3:  /*Просмотр реквизитов*/
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка марок топлива"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка водителей"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка автомобилей"));//3
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));//4

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 4 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Uplmt",toplivo,sizeof(toplivo),naim);
        VV.data_plus(2,toplivo);
        goto naz;

      case 1 :
        naimn.new_plus("");
        
        if(dirout(&kodn,&naimn,1,2) == 0)
          VV.data_z_plus(3,kodn.ravno());
        goto naz;

      case 2 :
        vibrek("Plansh",shet,sizeof(shet),naim);
        VV.data_plus(4,shet);
        goto naz;

      case 3 :
        naimn.new_plus("");
        if(diravt(&kodn,&naimn,1) == 0)
         VV.data_z_plus(5,kodn.ravno());
        goto naz;

     }
    goto naz;
    

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
 }

if(rsdatp(&dn,&mn,&gn,VV.VVOD_SPISOK_return_data(0),&dk,&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
  goto naz;

clear();
time_t tmm;
time(&tmm);
printw("%s:%d.%d.%d => %d.%d.%d \n",
gettext("Диапазон поиска"),
dn,mn,gn,dk,mk,gk);

GDITE();

long	kolstr=0;
SQL_str row,row1;
FILE    *ff;
char    imaf[32];
int	kollist=0;
int	kolstrok=0;
short   d,m,g;

sprintf(strsql,"select * from Upldok2 where datd >= '%d-%d-%d' and \
datd <= '%d-%d-%d' order by shet,kv,kt,datd asc",gn,mn,dn,gk,mk,dk);

SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);  
 }

sprintf(imaf,"vst%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }


kolstrok=5;
zagolov(gettext("Ведомость списания топлива по счетам и водителям."),dn,mn,gn,dk,mk,gk,organ,ff);

uplvst_rp(&kolstrok,toplivo,voditel,shet,kod_avtom,ff);

char imaf_shet[32];
FILE *ff_shet;
sprintf(imaf_shet,"vsts%d.lst",getpid());

if((ff_shet = fopen(imaf_shet,"w")) == NULL)
 {
  error_op_nfil(imaf_shet,errno,"");
  return(1);
 }


zagolov(gettext("Cписание топлива по счетам."),dn,mn,gn,dk,mk,gk,organ,ff_shet);

uplvst_rp(&kolstrok,toplivo,voditel,shet,kod_avtom,ff_shet);

fprintf(ff_shet,"\
----------------------------------------------------------------------------------\n");
fprintf(ff_shet,gettext("\
 Счёт |Наименование счёта  |Пробег|Фак.з.т.|По норме| Часы |Недорасход|Перерасход|\n"));
fprintf(ff_shet,"\
----------------------------------------------------------------------------------\n");




svst(&kollist,&kolstrok,ff);

double iprobeg[3];
double itoplivo[3];
double ihas[3];
double izat_top_nor[3];
double  sprobeg=0.;
double stoplivo=0.;
double shas=0.;
char naimvod[512];

memset(&iprobeg,'\0',sizeof(iprobeg));
memset(&itoplivo,'\0',sizeof(itoplivo));
memset(&ihas,'\0',sizeof(ihas));
memset(&izat_top_nor,'\0',sizeof(izat_top_nor));

char kodvod[32];
char kodmt[32];
char shetz[32];
char nomdok[56];

memset(kodvod,'\0',sizeof(kodvod));
memset(kodmt,'\0',sizeof(kodmt));
memset(shetz,'\0',sizeof(shetz));
memset(nomdok,'\0',sizeof(nomdok));

long kolstr1=0;
double nst,nstzg,ztvsn,ztvrn;
double zat_top_nor=0.;
double raznica=0.;
double nedorashod_top=0.,pererashod_top=0.;
double nedorashod_vod=0.,pererashod_vod=0.;
double nedorashod_shet=0.,pererashod_shet=0.;

while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(proverka(toplivo,row[3],0,0) != 0)
   continue;

  if(proverka(voditel,row[9],0,0) != 0)
   continue;

  if(proverka(kod_avtom,row[10],0,0) != 0)
   continue;

  if(proverka(shet,row[4],0,0) != 0)
   continue;
     

  if(SRAV(kodmt,row[3],0) != 0)
   {
    if(kodmt[0] != '\0')
     {
      shetvst(&kolstrok,&kollist,ff);
      itogvst(0,kodmt,iprobeg[0],itoplivo[0],izat_top_nor[0],ihas[0],nedorashod_top,pererashod_top,ff,NULL);
     }
    nedorashod_top=pererashod_top=0.;
    iprobeg[0]=0.;
    itoplivo[0]=ihas[0]=0.;
    izat_top_nor[0]=0.;
    strcpy(kodmt,row[3]);
   }

  if(SRAV(kodvod,row[9],0) != 0)
   {
    if(kodvod[0] != '\0')
     {
      shetvst(&kolstrok,&kollist,ff);
      itogvst(0,kodmt,iprobeg[0],itoplivo[0],izat_top_nor[0],ihas[0],nedorashod_top,pererashod_top,ff,NULL);

      shetvst(&kolstrok,&kollist,ff);
      itogvst(1,kodvod,iprobeg[1],itoplivo[1],izat_top_nor[1],ihas[1],nedorashod_vod,pererashod_vod,ff,NULL);
     }
    nedorashod_top=pererashod_top=0.;
    nedorashod_vod=pererashod_vod=0.;

    iprobeg[0]=0.;
    itoplivo[0]=ihas[0]=0.;
    izat_top_nor[0]=0.;

    iprobeg[1]=0.;
    itoplivo[1]=ihas[1]=0.;
    izat_top_nor[1]=0.;

    strcpy(kodvod,row[9]);

    memset(naimvod,'\0',sizeof(naimvod));
    sprintf(strsql,"select naik from Uplouot where kod=%s",kodvod);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
     strncpy(naimvod,row1[0],sizeof(naimvod)-1);    
   }

  if(SRAV(shetz,row[4],0) != 0)
   {
    if(shetz[0] != '\0')
     {
      shetvst(&kolstrok,&kollist,ff);
      itogvst(0,kodmt,iprobeg[0],itoplivo[0],izat_top_nor[0],ihas[0],nedorashod_top,pererashod_top,ff,NULL);

      shetvst(&kolstrok,&kollist,ff);
      itogvst(1,kodvod,iprobeg[1],itoplivo[1],izat_top_nor[1],ihas[1],nedorashod_vod,pererashod_vod,ff,NULL);

      shetvst(&kolstrok,&kollist,ff);
      itogvst(2,shetz,iprobeg[2],itoplivo[2],izat_top_nor[2],ihas[2],nedorashod_shet,pererashod_shet,ff,ff_shet);

     }
    nedorashod_top=pererashod_top=0.;
    nedorashod_vod=pererashod_vod=0.;
    nedorashod_shet=pererashod_shet=0.;
    memset(&iprobeg,'\0',sizeof(iprobeg));
    memset(&itoplivo,'\0',sizeof(itoplivo));
    memset(&ihas,'\0',sizeof(ihas));
    memset(&izat_top_nor,'\0',sizeof(izat_top_nor));

    strcpy(shetz,row[4]);
   }
  //читаем нормы расхода топлива
  nst=nstzg=ztvsn=ztvrn=0.;
  sprobeg=0.;
  sprintf(strsql,"select nst,nstzg,ztvsn,ztvrn,psv,psz from Upldok \
where datd='%s' and kp=%s and nomd='%s'",row[0],row[1],row[2]);
  if(readkey(strsql,&row1,&cur1) == 1)
   {
    nst=atof(row1[0]);
    nstzg=atof(row1[1]);
    ztvsn=atof(row1[2]);
    ztvrn=atof(row1[3]);
//    sprobeg=atoi(row1[5])-atoi(row1[4]);
   }  
  else
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдена шапка документа !"));
    sprintf(strsql,"%s %s",row[0],row[2]);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    continue;    
   }

  sprobeg=atof(row[6])+atof(row[13]);

  rsdat(&d,&m,&g,row[0],2);

  shetvst(&kolstrok,&kollist,ff);


  stoplivo=atof(row[7])+atof(row[14])+atof(row[15])+atof(row[16]);
  stoplivo=okrug(stoplivo,0.001);  

  //определяем затраты топлива по норме
  zat_top_nor=atof(row[6])*nst/100.+atof(row[13])*nstzg/100.+atof(row[17])*ztvsn/100.+atof(row[18])*ztvrn;
  zat_top_nor=okrug(zat_top_nor,0.001);

  raznica=stoplivo-zat_top_nor;
  raznica=okrug(raznica,0.001);
  
  fprintf(ff,"%-*s %-*s %-*.*s %-*s %02d.%02d.%04d %-8s %6.6g %8.8g %8.8g %6s",
  iceb_tu_kolbait(6,row[4]),row[4],
  iceb_tu_kolbait(4,row[9]),row[9],
  iceb_tu_kolbait(16,naimvod),iceb_tu_kolbait(16,naimvod),naimvod,
  iceb_tu_kolbait(6,row[3]),row[3],
  d,m,g,row[2],sprobeg,stoplivo,zat_top_nor,row[8]);  

  if(raznica < 0)
   {
    fprintf(ff," %10.10g\n",raznica);
    nedorashod_top+=raznica;
    nedorashod_vod+=raznica;
    nedorashod_shet+=raznica;
   }
  else
   {
    fprintf(ff," %10s %10.10g\n"," ",raznica);
    pererashod_top+=raznica;    
    pererashod_vod+=raznica;    
    pererashod_shet+=raznica;    
   }
  
  shas=atof(row[8]);

  iprobeg[0]+=sprobeg;
  itoplivo[0]+=stoplivo;
  ihas[0]+=shas;
  izat_top_nor[0]+=zat_top_nor;
  
  iprobeg[1]+=sprobeg;
  itoplivo[1]+=stoplivo;
  ihas[1]+=shas;
  izat_top_nor[1]+=zat_top_nor;

  iprobeg[2]+=sprobeg;
  itoplivo[2]+=stoplivo;
  ihas[2]+=shas;
  izat_top_nor[2]+=zat_top_nor;

 }

itogvst(0,kodmt,iprobeg[0],itoplivo[0],izat_top_nor[0],ihas[0],nedorashod_top,pererashod_top,ff,NULL);
itogvst(1,kodvod,iprobeg[1],itoplivo[1],izat_top_nor[1],ihas[1],nedorashod_vod,pererashod_vod,ff,NULL);
itogvst(2,shetz,iprobeg[2],itoplivo[2],izat_top_nor[2],ihas[2],nedorashod_shet,pererashod_shet,ff,ff_shet);

podpis(ff);
podpis(ff_shet);
fclose(ff);
fclose(ff_shet);

printw("%s:%d\n",gettext("Количество листов"),kollist);
printw_vr(tmm);

OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Ведомость списания топлива по счетам и водителям."));
oth->spis_imaf.plus(imaf_shet);
oth->spis_naim.plus(gettext("Общие итоги"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);
}
/*************************************/
/*Шапка                              */
/*************************************/

void    svst(int *kollist,int *kolstrok,FILE *ff)
{
*kollist+=1;
*kolstrok+=4;

fprintf(ff,"%70s%s%d\n","",gettext("Лист N"),*kollist);

fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
 Счет |К/в |Фамилия водителя|К.топ.|  Дата    |Ном.док.|Пробег|Фак.з.т.|По норме| Часы |Недорасход|Перерасход|\n"));
fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------\n");
//123456 1234 1234567890123456 123456 1234567890 12345678 123456 12345678 1234
}

/************************************/
/*Итоговая строка                   */
/************************************/

void  itogvst(int metkai, //0-Итог по топливу 1-по водителю 2-по счету
char *kodi, //Код итога
double probeg,double toplivo,
double zat_top_nor,
double has,
double ned,
double per,
FILE *ff,
FILE *ff_shet)
{
char  strsql[512];
char  stroka[1024];
SQL_str  row;
SQLCURSOR curr;
if(probeg == 0. && toplivo == 0. && has == 0.)
  return;
  
memset(stroka,'\0',sizeof(stroka));

if(metkai == 0) //По топливу
 sprintf(stroka,"%s %s %s",
 gettext("Итого"),
 gettext("по"),
 kodi);

if(metkai == 1) //По водителю
 {
  sprintf(stroka,"%s %s %s ",
  gettext("Итого"),
  gettext("по"),
  kodi);

  sprintf(strsql,"select naik from Uplouot where kod=%s",kodi);
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strcat(stroka,row[0]);
 }

if(metkai == 2) //По счету
 {
  sprintf(stroka,"%s %s %s ",
  gettext("Итого"),
  gettext("по"),
  kodi);

  sprintf(strsql,"select nais from Plansh where ns='%s'",kodi);
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
    strcat(stroka,row[0]);

  fprintf(ff_shet,"%6s %*.*s %6.6g %8.8g %8.8g %6.2f %10.10g %10.10g\n",
  kodi,
  iceb_tu_kolbait(20,row[0]),
  iceb_tu_kolbait(20,row[0]),
  row[0],
  probeg,toplivo,zat_top_nor,has,ned,per);

 }
 
fprintf(ff,"%*s:%6.6g %8.8g %8.8g %6.2f %10.10g %10.10g\n",
iceb_tu_kolbait(55,stroka),stroka,probeg,toplivo,zat_top_nor,has,ned,per);

}

/********************************/
/*Счетчик                       */
/********************************/
void     shetvst(int *kolstrok,int *kollist,FILE *ff)
{
*kolstrok+=1;
if(*kolstrok > kol_strok_na_liste)
 {
  fprintf(ff,"\f");
  *kolstrok=0;
  svst(kollist,kolstrok,ff);
 }  

}
/*********************************/
/*Реквизиты поиска */
/****************************/
void uplvst_rp(int *kolstrok,char *toplivo,
char *voditel,
char *shet,
char *kod_avtom,
FILE *ff)
{
if(toplivo[0] != '\0')
 {
  *kolstrok+=1;
  fprintf(ff,"%s:%s\n",gettext("Код топлива"),toplivo);  
 }

if(voditel[0] != '\0')
 {
  *kolstrok+=1;
  fprintf(ff,"%s:%s\n",gettext("Код водителя"),voditel);  
 }

if(shet[0] != '\0')
 {
  *kolstrok+=1;
  fprintf(ff,"%s:%s\n",gettext("Счет"),shet);  
 }
if(kod_avtom[0] != '\0')
 {
  *kolstrok+=1;
  fprintf(ff,"%s:%s\n",gettext("Код автомобиля"),kod_avtom);  
 }
}
