/*$Id: uslnast.c,v 5.21 2011-01-13 13:43:24 sasa1 Exp $*/
/*23.04.2010	11.02.2000	Белых А.И.	uslnast.c
Чтение настроек для услуг
Если вернули 0 файл прочитан
	     1 файл не прочитан
*/
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

short		vplsh; /*0-двух уровневый план счетов 1-многоуровневый*/
short		startgodus=0; /*Стартовый год просмотров услуг*/
short		startgodb=0; /*Стартовый год Главной книги*/
short		startgod; //Стартовый год просмотров в материальном учёте

char		*bndsu1; /*0% НДС реализация на територии Украины.*/
char            *bndsu2; /*0% НДС экспорт.*/
char            *bndsu3; /*0% Освобождение от НДС статья 5.*/
double		okrcn;  /*Округление цены*/
double		okrg1;  /*Округление 1*/
short           mfnn; /*Метка формирования номера накладной
                      -1 - Автоматическая нумерация выключена
                       0 - Приходы и расходы - нумерация общая
                       1 - Приходы отдельно расходы отдельно
                       */
double		kursue=0.;/*Курс условной единицы*/

int		uslnast()
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
char strsql[512];
int kolstr=0;
char		st1[1024];
char		bros[1024];
int		i;
short		voz;

printw("\n%s\n",
gettext("Чтение нормативно-справочной информации."));
refresh();

startgod=0;
//cnsnds=cnsndsu=0;
okrg1=okrcn=0.;
//nds1=0.;
vplsh=startgodus=0;
mfnn=(-1);
kursue=0.;
if(bndsu1 != NULL)
 {
  free(bndsu1);
  bndsu1=NULL;
 }

if(bndsu2 != NULL)
 {
  free(bndsu2);
  bndsu2=NULL;
 }

if(bndsu3 != NULL)
 {
  free(bndsu3);
  bndsu3=NULL;
 }

sprintf(strsql,"select str from Alx where fil='uslnast.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"uslnast.alx");
  iceb_t_soob(strsql);
  return(1);
 }

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;

  polen(row_alx[0],st1,sizeof(st1),1,'|');
  if(SRAV(st1,"Раздельная нумерация документов",0) == 0)
    {
     mfnn=0;
     
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     if(st1[0] == '\0' || st1[0] == '\n')
      mfnn=(-1);
      
     if(SRAV(st1,"Вкл",1) == 0)
       mfnn=1;
     continue;
    }

  if(SRAV(st1,"Стартовый год",0) == 0)
    {
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     startgodus=(short)ATOFM(st1); 
     continue;
    }
  if(SRAV(st1,"0% НДС реализация на територии Украины",0) == 0)
    {
     memset(bros,'\0',sizeof(bros));
     polen(row_alx[0],bros,sizeof(bros),2,'|');
     i=strlen(bros)+1;
     if((bndsu1=(char *)malloc(i*sizeof(char))) == NULL)
       error2(20,0,1,"Не могу выделить пямять для bndsu1 !");
     strcpy(bndsu1,bros);
     continue;
    }
  if(SRAV(st1,"0% НДС экспорт",0) == 0)
    {
     memset(bros,'\0',sizeof(bros));
     polen(row_alx[0],bros,sizeof(bros),2,'|');
     i=strlen(bros)+1;
     if((bndsu2=(char *)malloc(i*sizeof(char))) == NULL)
       error2(20,0,1,"Не могу выделить пямять для bndsu2 !");
     strcpy(bndsu2,bros);
     continue;
    }
  if(SRAV(st1,"Освобождение от НДС",0) == 0)
    {
     memset(bros,'\0',sizeof(bros));
     polen(row_alx[0],bros,sizeof(bros),2,'|');
     i=strlen(bros)+1;
     if((bndsu3=(char *)malloc(i*sizeof(char))) == NULL)
       error2(20,0,1,"Не могу выделить пямять для bndsu3 !");
     strcpy(bndsu3,bros);
     continue;
    }
 }


sprintf(strsql,"select str from Alx where fil='matnast.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"matnast.alx");
  iceb_t_soob(strsql);
  return(1);
 }

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;

  polen(row_alx[0],st1,sizeof(st1),1,'|');
  if(SRAV(st1,"Стартовый год",0) == 0)
    {
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     startgod=(short)ATOFM(st1); 
     continue;
    }
  if(SRAV(st1,"Округление цены",0) == 0)
   {
    polen(row_alx[0],st1,sizeof(st1),2,'|');
    okrcn=ATOFM(st1);
    continue;
   }

  if(SRAV(st1,"Округление 1",0) == 0)
    {
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     okrg1=ATOFM(st1);
     continue;
    }
  if(SRAV(st1,"Курс УЕ",0) == 0)
    {
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     kursue=ATOFM(st1);
     continue;
    }
 }
vplsh=0;
iceb_t_poldan("Многопорядковый план счетов",st1,"nastrb.alx");
if(SRAV(st1,"Вкл",1) == 0)
 vplsh=1;

memset(st1,'\0',sizeof(st1));
startgodb=0;
if(iceb_t_poldan("Стартовый год",st1,"nastrb.alx") == 0)
 {
  startgodb=(short)ATOFM(st1);
 }

voz=0;
if(okrcn == 0.)
 {
  beep();
  voz++;
  printw(gettext("Не введено \"Округление цены\" !\n"));
 }

if(okrg1 == 0.)
 {
  beep();
  voz++;
  printw(gettext("Не введено \"Округление 1\" !\n"));
 }

if(voz != 0)
 OSTANOV();

return(0);

}
