/*$Id: vedprz1.c,v 5.25 2011-01-13 13:43:24 sasa1 Exp $*/
/*04.11.2009	18.01.2004	Белых А.И.	vedprz1.c
Новая форма ведомости производственных затрат
*/
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void veprz1r(short,short,short,short,short,short,struct tm *,FILE *,SPISOK *,SPISOK *,masiv_din_double *,char*);
void veprz1rn(short,short,short,short,short,short,struct tm *,FILE *,SPISOK *,SPISOK *,
masiv_din_double *,
masiv_din_double *,
masiv_din_double *,
masiv_din_double *,
masiv_din_double *,char*);
void vedprz1_sap(char *podr,char *grupap,char *sheta,char *prih_rash,FILE *ff);

extern short mmm,ggg;
extern char     *organ;/*Наименование организации*/
extern char	*shetb; /*Бюджетные счета начислений*/
extern char	*shetbu; /*Бюджетные счета удержаний*/

int vedprz1(class spis_oth *oth)
{
char		strsql[512];
static char	podrz[112];
static char	grupap[112];
static char	dat1[11];
static char	dat2[11];
static char	sheta[100];
static char	prih_rash[2];
short metka_prih_rash=0;

int kom=0,kom1=0;
char            naim[512];

VVOD MENU(3);

if(dat1[0] == '\0')
 sprintf(dat1,"%d.%d",mmm,ggg);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Расчет ведомости производственных затрат."));

VV.VVOD_SPISOK_add_data(dat1,8);
VV.VVOD_SPISOK_add_data(dat2,8);
VV.VVOD_SPISOK_add_data(podrz,sizeof(podrz));
VV.VVOD_SPISOK_add_data(grupap,sizeof(grupap));
VV.VVOD_SPISOK_add_data(sheta,sizeof(sheta));
VV.VVOD_SPISOK_add_data(prih_rash,sizeof(prih_rash));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала..(м.г)......"));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца...(м.г)......"));
VV.VVOD_SPISOK_add_MD(gettext("Подразделение......(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Код группы под-ния.(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Счёт...............(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Начисл./удержан. .(+/-)."));

naz:;
clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("подразделения"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat1)-1);
strncpy(podrz,VV.VVOD_SPISOK_return_data(2),sizeof(podrz)-1);
strncpy(grupap,VV.VVOD_SPISOK_return_data(3),sizeof(grupap)-1);
strncpy(sheta,VV.VVOD_SPISOK_return_data(4),sizeof(sheta)-1);
strncpy(prih_rash,VV.VVOD_SPISOK_return_data(5),sizeof(prih_rash)-1);

switch (kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp4_5_1.txt");
   goto naz;
  case ESC:
  case FK10:
     return(1);
     break;

  case PLU:
  case FK2:
     break;

  case FK3:

    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка cчетов"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);

    kom1=0;    

    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;

      case 0 :
       if(vibrek("Podr",podrz,sizeof(podrz),naim) == 0)
          VV.VVOD_SPISOK_zapis_data(2,podrz);
       break;

      case 1 :
       if(vibrek("Zargrupp",grupap,sizeof(grupap),naim) == 0)
          VV.VVOD_SPISOK_zapis_data(3,grupap);

      case 2:
       if(vibrek("Plansh",sheta,sizeof(sheta),naim) == 0)
          VV.VVOD_SPISOK_zapis_data(4,sheta);
       
       break;
     }
    goto naz;
    
  case FK4:
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
    break;
 }
short dn=1,mn=0,gn=0;
short dk=31,mk=0,gk=0;

if(prih_rash[0] == '+')
 metka_prih_rash=1;
if(prih_rash[0] == '-')
 metka_prih_rash=2;
 
if(rsdat1(&mn,&gn,dat1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(dat2[0] != '\0')
 {
  if(rsdat1(&mk,&gk,dat2) != 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конца !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }

 }
else
 {
  mk=mn;
  gk=gn;
 }

GDITE();
char bros[512];
SQL_str   row,row1;
SQLCURSOR cur;
SQLCURSOR cur1;

char glavbuh[100];
memset(glavbuh,'\0',sizeof(glavbuh));

iceb_t_poldan("Табельный номер бухгалтера",bros,"zarnast.alx");

if(bros[0] != '\0')
 {
  sprintf(strsql,"select fio from Kartb where tabn=%s",bros);
  if(sql_readkey(&bd,strsql,&row,&cur1) != 1)
   {
    beep();
    printw("Не знайдено табельного номера %s головного бухгалтера!\n",bros);
    OSTANOV();
   }
  else
   {
    strncpy(glavbuh,row[0],sizeof(glavbuh)-1);
   }
 }

struct tm *bf;
time_t vremn;
time(&vremn);
bf=localtime(&vremn);


//Определяем список счетов для начислений и удержаний
class SPISOK sp_shet_nah; //Список всех счетов начислений в порядке возростания
class SPISOK sp_shet_uder; //Список всех счетов удержаний в порядке возростания
class SPISOK shet_nah;     //Счет+начисление
class SPISOK shet_uder;    //Счет + удержание

class masiv_din_double shet_nah_suma; //Суммы для Счет+начисление
class masiv_din_double shet_nah_suma_os; //Суммы для Счет+начисление основная зарплата
class masiv_din_double shet_nah_suma_do; //Суммы для Счет+начисление дополнительная зарплата
class masiv_din_double shet_nah_suma_dr; //Суммы для Счет+начисление другая зарплата
class masiv_din_double shet_nah_suma_fz; //Суммы для Счет+начисление входящие в фонд зарплаты
class masiv_din_double shet_uder_suma; //Суммы для Счет+удержание

class masiv_din_double shet_nah_suma_bt; //Суммы для Счет+начисление бюджет
class masiv_din_double shet_nah_suma_os_bt; //Суммы для Счет+начисление основная зарплата бюджет
class masiv_din_double shet_nah_suma_do_bt; //Суммы для Счет+начисление дополнительная зарплата бюджет
class masiv_din_double shet_nah_suma_dr_bt; //Суммы для Счет+начисление другая зарплата  бюджет
class masiv_din_double shet_nah_suma_fz_bt; //Суммы для Счет+начисление входящие в фонд зарплаты  бюджет
class masiv_din_double shet_uder_suma_bt; //Суммы для Счет+удержание  бюджет

class masiv_din_double shet_nah_suma_ht; //Суммы для Счет+начисление хозрасчет
class masiv_din_double shet_nah_suma_os_ht; //Суммы для Счет+начисление основная зарплата хозрасчет
class masiv_din_double shet_nah_suma_do_ht; //Суммы для Счет+начисление дополнительная зарплата хозрасчет
class masiv_din_double shet_nah_suma_dr_ht; //Суммы для Счет+начисление другая зарплата хозрасчет
class masiv_din_double shet_nah_suma_fz_ht; //Суммы для Счет+начисление входящие в фонд зарплаты хозрасчет
class masiv_din_double shet_uder_suma_ht; //Суммы для Счет+удержание  хозрасчет

int       kol_shet_nah=0;
int       kol_shet_uder=0;


//Определяем список счетов для начислений
sprintf(strsql,"select distinct shet from Zarp where datz >= '%d-%d-%d' and \
datz <= '%d-%d-%d' and prn='1' and suma <> 0. order by shet asc",gn,mn,dn,gk,mk,dk);

if((kol_shet_nah=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kol_shet_nah == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

while(cur.read_cursor(&row) != 0)
  sp_shet_nah.plus(row[0]);

//Определяем список счетов для удержаний
sprintf(strsql,"select distinct shet from Zarp where datz >= '%d-%d-%d' and \
datz <= '%d-%d-%d' and prn='2' and suma <> 0. order by shet asc",gn,mn,dn,gk,mk,dk);

if((kol_shet_uder=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }


while(cur.read_cursor(&row) != 0)
  sp_shet_uder.plus(row[0]);


sprintf(strsql,"select prn,knah,suma,shet,podr from Zarp where datz >= '%d-%d-%d' and \
datz <= '%d-%d-%d' and suma <> 0.",gn,mn,dn,gk,mk,dk);
int kolstr=0;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

//printw("%s\n",strsql);

int kolstr1=0;
int nomer=0;
double suma=0.;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,kolstr1++);
    
  if(proverka(podrz,row[4],0,0) != 0)
   continue;
  if(grupap[0] != '\0')
   {
    sprintf(strsql,"select grup from Podr where kod=%s",row[4]);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
     if(proverka(grupap,row1[0],0,0) != 0)
      continue;
   }
  
//  printw("%s %s %s %s %s\n",row[0],row[1],row[2],row[3],row[4]);
  
  suma=atof(row[2]);
  if(atoi(row[0]) ==  1) //Начисление
   {
    sprintf(strsql,"%s|%s",row[3],row[1]);
    if((nomer = shet_nah.find(strsql)) < 0)
      shet_nah.plus(strsql);

    shet_nah_suma.plus(suma,nomer);

    if(proverka(shetb,row[3],0,0) == 0)
     {
      shet_nah_suma_bt.plus(suma,nomer);
      shet_nah_suma_ht.plus(0.,nomer);
     }
    else
     {
      shet_nah_suma_ht.plus(suma,nomer);
      shet_nah_suma_bt.plus(0.,nomer);
     }
    
    //читаем начисление
    short vn=0;
    short fz=0;
    
    sprintf(strsql,"select vidn,fz from Nash where kod=%s",row[1]);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
     {
      vn=atoi(row1[0]);
      fz=atoi(row1[1]);
     }     

    if(vn == 0)
      shet_nah_suma_os.plus(suma,nomer);
    else
      shet_nah_suma_os.plus(0.,nomer);
    
    if(vn == 1)
      shet_nah_suma_do.plus(suma,nomer);
    else
      shet_nah_suma_do.plus(0.,nomer);

    if(vn == 2)
      shet_nah_suma_dr.plus(suma,nomer);
    else
      shet_nah_suma_dr.plus(0.,nomer);

    if(fz == 0)
      shet_nah_suma_fz.plus(suma,nomer);
    else
      shet_nah_suma_fz.plus(0.,nomer);

    if(proverka(shetb,row[3],0,0) == 0)
     {
      if(vn == 0)
        shet_nah_suma_os_bt.plus(suma,nomer);
      else
        shet_nah_suma_os_bt.plus(0.,nomer);
      shet_nah_suma_os_ht.plus(0.,nomer);
      
      if(vn == 1)
        shet_nah_suma_do_bt.plus(suma,nomer);
      else
        shet_nah_suma_do_bt.plus(0.,nomer);
      shet_nah_suma_do_ht.plus(0.,nomer);

      if(vn == 2)
        shet_nah_suma_dr_bt.plus(suma,nomer);
      else
        shet_nah_suma_dr_bt.plus(0.,nomer);
      shet_nah_suma_dr_ht.plus(0.,nomer);

      if(fz == 0)
        shet_nah_suma_fz_bt.plus(suma,nomer);
      else
        shet_nah_suma_fz_bt.plus(0.,nomer);
      shet_nah_suma_fz_ht.plus(0.,nomer);
      

     }
    else
     {
      if(vn == 0)
        shet_nah_suma_os_ht.plus(suma,nomer);
      else
        shet_nah_suma_os_ht.plus(0.,nomer);
      shet_nah_suma_os_bt.plus(0.,nomer);
      
      if(vn == 1)
        shet_nah_suma_do_ht.plus(suma,nomer);
      else
        shet_nah_suma_do_ht.plus(0.,nomer);
      shet_nah_suma_do_bt.plus(0.,nomer);

      if(vn == 2)
        shet_nah_suma_dr_ht.plus(suma,nomer);
      else
        shet_nah_suma_dr_ht.plus(0.,nomer);
      shet_nah_suma_dr_bt.plus(0.,nomer);

      if(fz == 0)
        shet_nah_suma_fz_ht.plus(suma,nomer);
      else
        shet_nah_suma_fz_ht.plus(0.,nomer);
      shet_nah_suma_fz_bt.plus(0.,nomer);

     }          
   }   
  else  //Удержание
   {
    sprintf(strsql,"%s|%s",row[3],row[1]);
    if((nomer = shet_uder.find(strsql)) < 0)
      shet_uder.plus(strsql);
    shet_uder_suma.plus(suma,nomer);

    if(proverka(shetbu,row[3],0,0) == 0)
     {
      shet_uder_suma_bt.plus(suma,nomer);
      shet_uder_suma_ht.plus(0.,nomer);
     }
    else
     {
      shet_uder_suma_ht.plus(suma,nomer);
      shet_uder_suma_bt.plus(0.,nomer);
     }
   }

 }
GDITE();
FILE *ffbt=NULL;
FILE *ffht=NULL;
char imafbt[30];
char imafht[30];

if(shetb != NULL)
 { 
  sprintf(imafbt,"vpzbt%d.lst",getpid());
  sprintf(imafht,"vpzht%d.lst",getpid());

  if((ffbt = fopen(imafbt,"w")) == NULL)
   {
    error_op_nfil(imafbt,errno,"");
    return(1);
   }

  zagolov(gettext("Расчет ведомости производственных затрат"),bf,dn,mn,gn,dk,mk,gk,organ,ffbt);
  fprintf(ffbt,"%s\n",gettext("Бюджет"));
  if((ffht = fopen(imafht,"w")) == NULL)
   {
    error_op_nfil(imafht,errno,"");
    return(1);
   }

  zagolov(gettext("Расчет ведомости производственных затрат"),bf,dn,mn,gn,dk,mk,gk,organ,ffht);
  fprintf(ffht,"%s\n",gettext("Хозрасчет"));
 }
 
char imaf[30];
sprintf(imaf,"vpz%d.lst",getpid());
FILE *ff;

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }
 
zagolov(gettext("Расчет ведомости производственных затрат"),bf,dn,mn,gn,dk,mk,gk,organ,ff);

vedprz1_sap(podrz,grupap,sheta,prih_rash,ff);


if(metka_prih_rash == 0 || metka_prih_rash == 1)
  veprz1rn(dn,mn,gn,dk,mk,gk,bf,ff,&sp_shet_nah,&shet_nah,&shet_nah_suma,&shet_nah_suma_os,&shet_nah_suma_do,
  &shet_nah_suma_dr,&shet_nah_suma_fz,sheta);

if(metka_prih_rash == 0 || metka_prih_rash == 2)
 {
  fprintf(ff,"\n%s\n",gettext("Удержания"));
  veprz1r(dn,mn,gn,dk,mk,gk,bf,ff,&sp_shet_uder,&shet_uder,&shet_uder_suma,sheta);
 }

fprintf(ff,"%s____________________%s\n",gettext("Главный бухгалтер"),
glavbuh);

podpis(ff);
fclose(ff);


if(ffbt != NULL)
 {
 
   vedprz1_sap(podrz,grupap,sheta,prih_rash,ffbt);

  if(metka_prih_rash == 0 || metka_prih_rash == 1)
    veprz1rn(dn,mn,gn,dk,mk,gk,bf,ffbt,&sp_shet_nah,&shet_nah,&shet_nah_suma_bt,
    &shet_nah_suma_os_bt,&shet_nah_suma_do_bt,&shet_nah_suma_dr_bt,&shet_nah_suma_fz_bt,sheta);

  if(metka_prih_rash == 0 || metka_prih_rash == 2)
   {
    fprintf(ffbt,"\n%s\n",gettext("Удержания"));
    veprz1r(dn,mn,gn,dk,mk,gk,bf,ffbt,&sp_shet_uder,&shet_uder,&shet_uder_suma_bt,sheta);
   }

  fprintf(ffbt,"%s____________________%s\n",gettext("Главный бухгалтер"),
  glavbuh);
  podpis(ffbt);
  fclose(ffbt);

 }

if(ffht != NULL)
 {
 
   vedprz1_sap(podrz,grupap,sheta,prih_rash,ffht);

  if(metka_prih_rash == 0 || metka_prih_rash == 1)
    veprz1rn(dn,mn,gn,dk,mk,gk,bf,ffht,&sp_shet_nah,&shet_nah,&shet_nah_suma_ht,
    &shet_nah_suma_os_ht,&shet_nah_suma_do_ht,&shet_nah_suma_dr_ht,&shet_nah_suma_fz_ht,sheta);

  if(metka_prih_rash == 0 || metka_prih_rash == 2)
   {
    fprintf(ffht,"\n%s\n",gettext("Удержания"));
    veprz1r(dn,mn,gn,dk,mk,gk,bf,ffht,&sp_shet_uder,&shet_uder,&shet_uder_suma_ht,sheta);
   }
  fprintf(ffht,"%s____________________%s\n",gettext("Главный бухгалтер"),
  glavbuh);
  podpis(ffht);
  fclose(ffht);

 }


oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчет ведомости производственных затрат"));
if(ffbt != NULL)
 {
  oth->spis_imaf.plus(imafbt);
  
  sprintf(strsql,"%s (%s)",
  gettext("Расчет ведомости производственных затрат"),
  gettext("Бюджет"));
  oth->spis_naim.plus(strsql);
  
  oth->spis_imaf.plus(imafht);

  sprintf(strsql,"%s (%s)",
  gettext("Расчет ведомости производственных затрат"),
  gettext("Хозрасчёт"));
  oth->spis_naim.plus(strsql);

 }
for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),3);
return(0);
}

/************************************/
/*Распечатка удержаний    */
/*************************************/

void veprz1r(short dn,short mn,short gn,
short dk,short mk,short gk,
struct tm *bf,
FILE *ff,
SPISOK *sp_shet_nah,
SPISOK *shet_nah,
class masiv_din_double *shet_nah_suma,char *sheta)
{
SQL_str row;
SQLCURSOR curr;
char strsql[512];

char shet[32];
char shet1[20];
char knah[20];
char naimshet[512];
char naimnah[100];
double itogo=0.;
double itogos=0.;

int kol_par=shet_nah->kolih();
//printw("kol_par=%d\n",kol_par);
double suma=0.;

int nomerp=0;
int kol_shet_nah=sp_shet_nah->kolih();


fprintf(ff,"\
------------------------------------------------------------------------------------\n");

fprintf(ff,gettext("\
Счет  |     Наименование счета       |Код|  Наименование удержания      | Сумма    |\n"));

fprintf(ff,"\
------------------------------------------------------------------------------------\n");


for(int nomersh=0; nomersh < kol_shet_nah; nomersh++)
 {
  strncpy(shet,sp_shet_nah->ravno(nomersh),sizeof(shet)-1);

  if(proverka(sheta,shet,0,0) != 0)
   continue;

  nomerp=0;
  itogos=0.;
  for(int nomer=0; nomer < kol_par; nomer++)
   {
    
    polen(shet_nah->ravno(nomer),shet1,sizeof(shet1),1,'|');
//    printw("%s\n",shet1);
    if(SRAV(shet,shet1,0) != 0)
      continue;
    polen(shet_nah->ravno(nomer),knah,sizeof(knah),2,'|');

    //Читаем наименование начисления
    memset(naimnah,'\0',sizeof(naimnah));

    sprintf(strsql,"select naik from Uder where kod=%s",knah);

    if(sql_readkey(&bd,strsql,&row,&curr) == 1)
      strncpy(naimnah,row[0],sizeof(naimnah)-1);
    
    suma=shet_nah_suma->ravno(nomer);
    if(suma == 0.)
     continue;
    itogo+=suma;    
    itogos+=suma;    
    if(nomerp == 0)
     {
      //Читаем наименование счета
      memset(naimshet,'\0',sizeof(naimshet));
      sprintf(strsql,"select nais from Plansh where ns='%s'",shet1);                

      if(sql_readkey(&bd,strsql,&row,&curr) == 1)
       strncpy(naimshet,row[0],sizeof(naimshet)-1);

      fprintf(ff,"%-*s %-*.*s %3s %-*.*s %10.2f\n",
      iceb_tu_kolbait(6,shet1),shet1,
      iceb_tu_kolbait(30,naimshet),iceb_tu_kolbait(30,naimshet),naimshet,
      knah,
      iceb_tu_kolbait(30,naimnah),iceb_tu_kolbait(30,naimnah),naimnah,
      suma);
     }
    else
     {
      fprintf(ff,"%6s %-30.30s %3s %-*.*s %10.2f\n",
      " "," ",knah,
      iceb_tu_kolbait(30,naimnah),iceb_tu_kolbait(30,naimnah),naimnah,
      suma);

     }
    nomerp++;
   }
  if(nomerp > 0)
   {
    fprintf(ff,"%*s%10.2f\n",iceb_tu_kolbait(73,gettext("Итого")),gettext("Итого"),itogos);
    fprintf(ff,"\
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . \n");
   }
 }
fprintf(ff,"\
------------------------------------------------------------------------------------\n");

fprintf(ff,"%*s%10.2f\n",iceb_tu_kolbait(73,gettext("Итого")),gettext("Итого"),itogo);


}

/************************************/
/*Распечатка начислений    */
/*************************************/

void veprz1rn(short dn,short mn,short gn,
short dk,short mk,short gk,
struct tm *bf,
FILE *ff,
SPISOK *sp_shet_nah,
SPISOK *shet_nah,
class masiv_din_double *shet_nah_suma,
class masiv_din_double *shet_nah_suma_os,
class masiv_din_double *shet_nah_suma_do,
class masiv_din_double *shet_nah_suma_dr,
class masiv_din_double *shet_nah_suma_fz,
char *sheta)

{
SQL_str row;
SQLCURSOR curr;
char strsql[512];

char shet[32];
char shet1[20];
char knah[20];
char naimshet[512];
char naimnah[100];
double itogo=0.;
double itogo_os=0.;
double itogo_do=0.;
double itogo_dr=0.;
double itogo_fz=0.;
double itogos=0.;
double itogos_os=0.;
double itogos_do=0.;
double itogos_dr=0.;
double itogos_fz=0.;

int kol_par=shet_nah->kolih();
//printw("kol_par=%d\n",kol_par);
double suma=0.;
double suma_os=0.;
double suma_do=0.;
double suma_dr=0.;
double suma_fz=0.;

int nomerp=0;
int kol_shet_nah=sp_shet_nah->kolih();


fprintf(ff,"\
----------------------------------------------------------------------------------------------------\n");

fprintf(ff,gettext("\
Счет  |Наименование счета  |Код|Наи-ние начисления  | Сумма    |Основная|Доп-ная |Другая  |Фонд з/п|\n"));

fprintf(ff,"\
----------------------------------------------------------------------------------------------------\n");


for(int nomersh=0; nomersh < kol_shet_nah; nomersh++)
 {
  strncpy(shet,sp_shet_nah->ravno(nomersh),sizeof(shet)-1);

  if(proverka(sheta,shet,0,0) != 0)
   continue;

  nomerp=0;
  itogos=0.;
  itogos_os=0.;
  itogos_do=0.;
  itogos_dr=0.;
  itogos_fz=0.;
  for(int nomer=0; nomer < kol_par; nomer++)
   {
    
    polen(shet_nah->ravno(nomer),shet1,sizeof(shet1),1,'|');
//    printw("%s\n",shet1);
    if(SRAV(shet,shet1,0) != 0)
      continue;
    polen(shet_nah->ravno(nomer),knah,sizeof(knah),2,'|');

    //Читаем наименование начисления
    memset(naimnah,'\0',sizeof(naimnah));

    sprintf(strsql,"select naik from Nash where kod=%s",knah);


    if(sql_readkey(&bd,strsql,&row,&curr) == 1)
      strncpy(naimnah,row[0],sizeof(naimnah)-1);
    
    suma=shet_nah_suma->ravno(nomer);
    if(suma == 0.)
     continue;
    suma_os=shet_nah_suma_os->ravno(nomer);
    suma_do=shet_nah_suma_do->ravno(nomer);
    suma_dr=shet_nah_suma_dr->ravno(nomer);
    suma_fz=shet_nah_suma_fz->ravno(nomer);

    itogo+=suma;    
    itogo_os+=suma_os;    
    itogo_do+=suma_do;    
    itogo_dr+=suma_dr;    
    itogo_fz+=suma_fz;    

    itogos+=suma;    
    itogos_os+=suma_os;    
    itogos_do+=suma_do;    
    itogos_dr+=suma_dr;    
    itogos_fz+=suma_fz;    
    if(nomerp == 0)
     {
      //Читаем наименование счета
      memset(naimshet,'\0',sizeof(naimshet));
      sprintf(strsql,"select nais from Plansh where ns='%s'",shet1);                

      if(sql_readkey(&bd,strsql,&row,&curr) == 1)
       strncpy(naimshet,row[0],sizeof(naimshet)-1);

      fprintf(ff,"%-*s %-*.*s %3s %-*.*s %10.2f %8.2f %8.2f %8.2f %8.2f\n",
      iceb_tu_kolbait(6,shet1),shet1,
      iceb_tu_kolbait(20,naimshet),iceb_tu_kolbait(20,naimshet),naimshet,
      knah,
      iceb_tu_kolbait(20,naimnah),iceb_tu_kolbait(20,naimnah),naimnah,
      suma,suma_os,suma_do,suma_dr,suma_fz);
     }
    else
     {
      fprintf(ff,"%6s %-20.20s %3s %-*.*s %10.2f %8.2f %8.2f %8.2f %8.2f\n",
      " "," ",knah,
      iceb_tu_kolbait(20,naimnah),iceb_tu_kolbait(20,naimnah),naimnah,
      suma,suma_os,suma_do,suma_dr,suma_fz);

     }
    nomerp++;
   }
  if(nomerp > 0)
   {
    fprintf(ff,"%*s%10.2f %8.2f %8.2f %8.2f %8.2f\n",
    iceb_tu_kolbait(53,gettext("Итого")),gettext("Итого"),
    itogos,
    itogos_os,
    itogos_do,
    itogos_dr,
    itogos_fz);

    fprintf(ff,"\
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . \n");
   }
 }
fprintf(ff,"\
----------------------------------------------------------------------------------------------------\n");

fprintf(ff,"%*s%10.2f %8.2f %8.2f %8.2f %8.2f\n",
iceb_tu_kolbait(53,gettext("Итого")),gettext("Итого"),
itogo,
itogo_os,
itogo_do,
itogo_dr,
itogo_fz);



}
/****************************/
/*Печать реквизитов поиска*/
/*****************************/
void vedprz1_sap(char *podr,char *grupap,char *sheta,char *prih_rash,FILE *ff)
{
if(podr[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Подразделение"),podr);

if(grupap[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Группа"),grupap);

if(sheta[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Счёт"),sheta);

if(prih_rash[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Начисления/удержания"),prih_rash);

}
