/* $Id: xkas.c,v 5.149 2011-01-13 13:43:24 sasa1 Exp $ */
/*11.10.2010	19.09.2000	Белых А.И.	xkas.c
Прграмма учета кассовых ордеров на приход и расход
*/
#define DVERSIQ "24.11.2010"
#include        "buhg.h"

void		rabkord(void);
void		rabkord1(void);
int		kasnast(void);
int  kasoth(int,class spis_oth*);
void		udkasordg(void);
void	        raspoth(void);
void dirnomved(void);
void dirkcnsl(void);
int  kasothcn(class spis_oth*);
void imp_kasord(void);
void saldokaskcn();

short   	mfnn=1; /*Метка формирования номера накладной
                      -1 - Автоматическая нумерация выключена
                       0 - Приходы и расходы - нумерация общая
                       1 - Приходы отдельно расходы отдельно
                      */
extern char     *organ;/*Наименование организации*/
extern int	iscolor;
extern char	*imabaz;
extern char	*host;
extern char	*parol_pol;
SQL_baza	bd;
int		regim; /*Номер кассы, 0-доступ к данным всех касс*/
extern char	*nameprinter;
extern int iceb_kod_podsystem;

int main(int argc,char **argv,char **envp)
{
int kom=0;
char bros[512];
iceb_kod_podsystem=ICEB_PS_UKO;
icebstart(argc,argv);

VVOD MENU(4);

/*Ищем настройку*/
if(nastsys() != 0)
  exit_iceb(1);
if(kasnast() != 0)
  exit_iceb(1);


MENU.VVOD_SPISOK_add_MD(gettext("Работа с ордерами"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Ввод нормативно-справочной информации"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать отчеты"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Работа с файлами распечаток"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Удаление документов за год"));//4
MENU.VVOD_SPISOK_add_MD(gettext("Работа с журналом платёжных ведомостей"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Сменить базу"));//6
MENU.VVOD_SPISOK_add_MD(gettext("Сменить принтер"));//7
MENU.VVOD_SPISOK_add_MD(gettext("Конец работы"));//8
int uid=0;
class iceb_tu_str fioop;

uid=iceb_t_getuid();
fioop.plus(iceb_t_getfioop());

for(;;)
 {

  clear(); /*Очистить экран и закрасить фоновым цветом*/
  MENU.VVOD_delete_ZAG();
  MENU.VVOD_SPISOK_add_ZAG(gettext("Учет кассовых ордеров"));
  if(organ != NULL)
   {
    sprintf(bros,"%.*s",iceb_tu_kolbait(40,organ),organ);
    MENU.VVOD_SPISOK_add_ZAG(bros);
   }

  znak(0,COLS-26);
  infosys(12,COLS-27,host,VERSION,DVERSIQ,0,0,0,imabaz,nameprinter,uid,fioop.ravno());

  if(menu3(&MENU,&kom,1,0,0) != 0)
   continue;

  switch (kom)
   {
    case 8 :
    case -1 :
      goto kon;
      break;

    case 0 :
      rabkord1();
      break;

    case 1 :
      rabkord();
      break;

    case 2:
      raspoth();
      break;     

    case 3:

      strcpy(bros,"lst");
      dirlst(bros);
      break;

    case 4:
      udkasordg();
      break;

    case 5:
      dirnomved();
      break;
      
    case 6:
      if(smenabaz(1) == 0)
       {
        if(nastsys() != 0)
         goto kon;
        if(kasnast() != 0)
          goto kon;
       }
      break;


    case 7:
       mprintcap();
       break;

    default:
      kom=0;
      break;
   }
 }

kon:;

sql_closebaz(&bd);
VVOD SOOBN(1);
SOOBN.VVOD_SPISOK_add_MD(gettext("База закрыта. Программа закончила работу"));
soobsh(&SOOBN,-1,-1,1);

refresh();
endwin();


}
/*******************/
/*Работа с НСИ*/
/*******************/
void		rabkord()
{
int		kom=0,kom1=0;
int		poz,komv;
char		poi[32];
//char		kod[32];
//char		naim[512];
class iceb_tu_str kods("");
class iceb_tu_str naims("");

VVOD MENU(3);
VVOD MENU2(3);

kom=0;
MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Ввод и корректировка нормативно-справочной информации"));

MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка касс")); //0
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка целевых назначений"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка операций приходов"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка операций расходов"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка сальдо по кодам целевого назначения"));//4
MENU.VVOD_SPISOK_add_MD(gettext("Работа с файлом настройки"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Настpойка автоматического выполнения пpоводок"));//6
MENU.VVOD_SPISOK_add_MD(gettext("Перенесення сальдо по кодам целевого назначения"));//7
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//8


for(;;)
 {
  clear();
  while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);
  switch (kom)
   {
    case 8 :
    case -1 :
      return;
      break;
    case 0:
      clear();
      poz=komv=0;
      poi[0]='\0';
      kods.new_plus("");
      naims.new_plus("");
      dirmat1("Kas",&kods,&naims,LINES-5,0,2,0,&poz,&komv,poi,"\0");
      break;

    case 1:
      kods.new_plus("");
      naims.new_plus("");
      dirkcn(0,&kods,&naims);
      break;
      
    case 2:
      clear();
      poz=komv=0;
      poi[0]='\0';
      kods.new_plus("");
      naims.new_plus("");
      dirmat1("Kasop1",&kods,&naims,LINES-5,0,2,0,&poz,&komv,poi,"\0");
      break;

    case 3:
      clear();
      poz=komv=0;
      poi[0]='\0';
      kods.new_plus("");
      naims.new_plus("");
      dirmat1("Kasop2",&kods,&naims,LINES-5,0,2,0,&poz,&komv,poi,"\0");
      break;
    
    case 4:
      dirkcnsl();
      break;

    case 5:
      iceb_redfil("kasnast.alx",0);
      break;

    case 6 :
      MENU2.VVOD_delete();
      MENU2.VVOD_SPISOK_add_ZAG(gettext("Выберите нужное и нажмите Enter"));

      MENU2.VVOD_SPISOK_add_MD(gettext("Настpойка автоматического выполнения пpоводок для приходных кассовых оредров"));
      MENU2.VVOD_SPISOK_add_MD(gettext("Настpойка автоматического выполнения пpоводок для расходных кассовых ордеров"));
      MENU2.VVOD_SPISOK_add_MD(gettext("Выход"));

      kom1=0;
      while(menu3w(stdscr,&MENU2,&kom1,-1,-1,0) != 0);
      switch(kom1)
       {
        case 2:
        case -1:
          break;
        case 0:
          iceb_redfil("avtprokasp.alx",0);
          break;
        case 1:
          iceb_redfil("avtprokasr.alx",0);
          break;
       }
      break;
      
    case 7:
      saldokaskcn();
      break;
    default:
      kom=0;
      break;
   }
 }

}
/*******************/
/*Работа с ордерами*/
/*******************/
void		rabkord1()
{
int		kom;
short		dd,md,gd;
class iceb_tu_str nomd("");
class iceb_tu_str kassa("");

char bros[512];
poltekdat(&dd,&md,&gd);
VVOD MENU(3);
VVOD VV(0);

kom=0;
MENU.VVOD_SPISOK_add_ZAG(organ,40);

MENU.VVOD_SPISOK_add_ZAG(gettext("Работа с документами"));

MENU.VVOD_SPISOK_add_MD(gettext("Ввод нового ордера на расход"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Ввод нового ордера на приход"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Поиск кассового ордера"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка ордеров"));//3

sprintf(bros,"%s %d.%d.%d%s",gettext("Просмотр кассовых ордеров за"),dd,md,gd,gettext("г."));//4
MENU.VVOD_SPISOK_add_MD(bros);

MENU.VVOD_SPISOK_add_MD(gettext("Установить/снять блокировку дат"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Импорт кассовых ордеров"));//6
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//7


for(;;)
 {
  clear();

  while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

  switch (kom)
   {
    case 7 :
    case -1 :
      return;
      break;
 
    case 0:
      if(vkasord(2,0,&kassa,&nomd,&dd,&md,&gd) == 0)
        dirkasord(kassa.ravno(),nomd.ravno(),dd,md,gd,2);

     break;   
 
      
    case 1:
      if(vkasord(1,0,&kassa,&nomd,&dd,&md,&gd) == 0)
        dirkasord(kassa.ravno(),nomd.ravno(),dd,md,gd,1);
     break;   

    case 2:
      poikasdok();
      break;

    case 3:
      dirkasords(0,0,0);
      break;   

    case 4:
      dirkasords(dd,md,gd);
      break;   

    case 5 :
      iceb_tl_blok();
      break;

    case 6 :
      imp_kasord();
      break;

    default:
     kom=0;
     break;
   }
 }

}

/*************************/
/*Распечатка отчетов     */
/*************************/
void	raspoth()
{
int kom=0;

VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Распечатка отчетов"));

MENU.VVOD_SPISOK_add_MD(gettext("Распечатка списка документов"));
MENU.VVOD_SPISOK_add_MD(gettext("Распечатка свода по видам операций"));
MENU.VVOD_SPISOK_add_MD(gettext("Распечатка целевой кассовой книги"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));


for(;;)
 {
  clear();
  while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);
  class spis_oth oth;
  switch (kom)
   {
    case 3 :
    case -1 :
      return;
      break;
    case 0:
      if(kasoth(0,&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;
    case 1:
      if(kasoth(1,&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;
    case 2:
      if(kasothcn(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;
   }
 }
}
