/* $Id: xmu.c,v 5.406 2011-08-29 07:09:00 sasa Exp $ */
/*24.12.2010	25.01.1999	Белых А.И.	xmu.c
Программа материального учета под SQL
*/
#define DVERSIQ "18.08.2011"
#include	"buhg.h"

void            smdok(short,short,short);
void		optimbaz(void);
void            matuddok(void);
void            matnastp(void);
void            rasmat(void);
void            rasgrup(short);
int dvtmcf1(class spis_oth*);
int dvtmcf2(class spis_oth*);
int motpk(class spis_oth*);
int rasspdok(class spis_oth*);
void            rppvo(void);
int rasnds(class spis_oth*);
int prognoz(class spis_oth*);
void            poimatdok(void);
void		srvcen(void);
void		doocsum(void);
void		impmatdok(void);
void		matulk(void);
void		rasosdk(void);
int kriost(class spis_oth*);
int		muinv(class spis_oth*);
int opss(class spis_oth*);
void dok_dover(void);
int spis_p_kontr(class spis_oth*);
int ost_skl_shet(class spis_oth*);
int dvusl_mu(class spis_oth*);
int xmurspd(class spis_oth*);
int mudmc(class spis_oth*);
int mumo(class spis_oth*);
int murfn(class spis_oth*);
void saldomu();
int dirnalog(int nomnal);
int muodk(class spis_oth *oth);

extern char		*organ;
int		kassa=0;
extern char     *imabaz; /*Имя базы данных*/
extern short	startgod; /*Стартовый год просмотров*/
extern char	*nameprinter; /*Имя принтера с которым будет работать программа lpr*/
extern char	*host;
extern char	*parol_pol;
SQL_baza	bd;
extern int iceb_kod_podsystem;

int             main(int argc,char **argv,char **envp)
{
int		kom;
class iceb_tu_str bros("");
int		skl,nk;
iceb_kod_podsystem=ICEB_PS_MU;
int uid=0;
class iceb_tu_str fioop;
short dt,mt,gt;

icebstart(argc,argv);


read_ini();

VVOD MENU(4);
VVOD PAR(2);
VVOD DANET(1);

/*Читаем нормативно-справочную информацию*/
if(nastsys() != 0)
 exit_iceb(1);
if(matnast() != 0)
 exit_iceb(1);

if(iceb_t_perzap(1) != 0) /*Проверка на первичный запуск в текущем дне и удаление *.lst */
 exit_iceb(1);

uid=iceb_t_getuid();
fioop.plus(iceb_t_getfioop());

kom=0;
for(;;)
 {

  clear();

  MENU.VVOD_delete();

  MENU.VVOD_SPISOK_add_ZAG(gettext("Программа товарно-материального учета"));
  if(organ != NULL)
   {
    MENU.VVOD_SPISOK_add_ZAG(organ,40);
   } 

  MENU.VVOD_SPISOK_add_MD(gettext("Работа с товарно-материальными документами"));//0
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод нормативно-справочной информации"));//1
  MENU.VVOD_SPISOK_add_MD(gettext("Получение отчетов"));//2
  MENU.VVOD_SPISOK_add_MD(gettext("Работа с файлами распечаток"));//3
  MENU.VVOD_SPISOK_add_MD(gettext("Удалить все записи розничной торговли"));//4
  MENU.VVOD_SPISOK_add_MD(gettext("Просмотр карточки материалла"));//5
  MENU.VVOD_SPISOK_add_MD(gettext("Оптимизация базы данных"));//6
  MENU.VVOD_SPISOK_add_MD(gettext("Удаление документов за год"));//7
  MENU.VVOD_SPISOK_add_MD(gettext("Сменить базу"));//8
  MENU.VVOD_SPISOK_add_MD(gettext("Сменить принтер"));//9
  MENU.VVOD_SPISOK_add_MD(gettext("Конец работы"));//10 

  znak(0,COLS-26);
  infosys(12,COLS-27,host,VERSION,DVERSIQ,0,0,0,imabaz,nameprinter,uid,fioop.ravno());

  if(menu3(&MENU,&kom,1,0,0) != 0)
    continue;

  switch (kom)
   {
    case 10 :
    case -1 :
     exit_iceb(0);

    case 0 :
     rabdokm();
     break;

    case 1 :
     nsimatu();
     break;
    case 2 :
     rasoth();
     break;

    case 3:

      bros.new_plus("lst");
      dirlst(bros.ravno());
      break;

    case 4:

      DANET.VVOD_delete();
      DANET.VVOD_SPISOK_add_MD(gettext("Удалить все записи в розничной торговле ? Вы уверены ?"));

      if(danet(&DANET,2,stdscr) == 2)
        break;
      poltekdat(&dt,&mt,&gt);
      PAR.VVOD_delete();
      PAR.VVOD_SPISOK_add_MD(gettext("Введите пароль"));
      if(parolv(&PAR,dt,mt,gt,1) != 0)
        break;
        
      GDITE();

      if(sql_zap(&bd,"delete from Roznica") != 0)
       msql_error(&bd,gettext("Ошибка удаления записей !"),"delete from Roznica");

      break;

    case 5:
      clear();
      mvprintw(0,0,gettext("Просмотр карточки материалла"));
      helstr(LINES-1,0," F10 ",gettext("выход"),NULL);

      bros.new_plus("");
      PAR.VVOD_delete();
      PAR.VVOD_SPISOK_add_MD(gettext("Введите номер склада"));

      if(vvod1(&bros,16,&PAR,NULL,stdscr,-1,-1) == FK10)
        break;
      skl=bros.ravno_atoi();
      if(skl == 0)
        break;


      PAR.VVOD_delete();
      PAR.VVOD_SPISOK_add_MD(gettext("Введите номер карточки"));

      bros.new_plus("");
      if(vvod1(&bros,16,&PAR,NULL,stdscr,-1,-1) == FK10)
        break;

      nk=bros.ravno_atoi();
      if(nk == 0)
        break;
        
      dirzkart(skl,nk);
      
      break;

    case 6:
      optimbaz();
      break;

    case 7:
      matuddok();
      break;

    case 8:
      if(smenabaz(1) == 0)
       {
        if(nastsys() != 0)
          exit_iceb(0);
        if(matnast() != 0)
          exit_iceb(0);
       }       
      break;

    case 9:
       mprintcap();
       break;

    default:
      kom=0;
      break;    
   }
 }

exit_iceb(0);
}

/***************************************/
/*Ввод нормативно-справочной информации*/
/***************************************/

void    nsimatu()
{
int             kom=0;
int             kgr,kodm;
char		tabl[24];
char		bros[512];
int		poz,komv;
char		poi[32];
class iceb_tu_str kods;
class iceb_tu_str naim;

int kodiz=0,kodizv=0;
int urov=0;

VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Ввод и корректировка нормативно-справочной информации"));

MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка групп товаров и материалов"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка единиц измерения"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка товаров и материалов"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка операций приходов"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка операций расходов"));//4
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка складов"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка форм оплаты"));//6
MENU.VVOD_SPISOK_add_MD(gettext("Работа с файлом настройки"));//7
MENU.VVOD_SPISOK_add_MD(gettext("Работа со списком контрагентов"));//8
MENU.VVOD_SPISOK_add_MD(gettext("Работа с планом счетов"));//9
MENU.VVOD_SPISOK_add_MD(gettext("Работа со списком коректировок на сумму документа"));//10
MENU.VVOD_SPISOK_add_MD(gettext("Просмотр прочитанных настроек"));//11
MENU.VVOD_SPISOK_add_MD(gettext("Настpойка автоматического выполнения пpоводок"));//12
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка спецификаций на изделия"));//13
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка концовки счёта"));//14
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка концовки накладной"));//15
MENU.VVOD_SPISOK_add_MD(gettext("Перенос стартовых остатков по материалам"));//16
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка НДС"));//17
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//18

kom=0;
for(;;)
 {

  clear();

  while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);
  kods.new_plus("");
  naim.new_plus("");
  switch (kom)
   {
    case 18 :
    case -1 :
      return;
    case 0 :
      clear();
      memset(tabl,'\0',sizeof(tabl));
      strcpy(tabl,"Grup");
      poz=komv=0;
      poi[0]='\0';
      dirmat1(tabl,&kods,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
      break;
    case 1 :
      clear();
      memset(tabl,'\0',sizeof(tabl));
      strcpy(tabl,"Edizmer");
      poz=komv=0;
      poi[0]='\0';
      dirmat1(tabl,&kods,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
 
      break;

    case 2 :
      clear();
      naim.new_plus("");
      bros[0]='\0';
      dirmatr(&kgr,&kodm,&naim,0,0,bros,0,0);
 
      break;

    case 3 :
      clear();
      memset(tabl,'\0',sizeof(tabl));
      strcpy(tabl,"Prihod");
      poz=komv=0;
      poi[0]='\0';
      dirmat1(tabl,&kods,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
 
      break;

    case 4 :
      clear();
      memset(tabl,'\0',sizeof(tabl));
      strcpy(tabl,"Rashod");
      poz=komv=0;
      poi[0]='\0';
      dirmat1(tabl,&kods,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
 
      break;

    case 5 :
      dirsklad(0,&kods,&naim);
      
      break;

    case 6 :
      clear();
      memset(tabl,'\0',sizeof(tabl));
      strcpy(tabl,"Foroplat");
      poz=komv=0;
      poi[0]='\0';
      dirmat1(tabl,&kods,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");

      break;

    case 7 :
      if(iceb_redfil("matnast.alx",0) == 0)
        matnast();
      break;

    case 8 :
      clear();
      kods.new_plus("");
      naim.new_plus("");

      dirkontr(&kods,&naim,0);

      break;

    case 9 :
      clear();
      kods.new_plus("");
      naim.new_plus("");

      dirshet(&kods,&naim,0);

      break;

    case 10 :
      iceb_redfil("makkor.alx",0);
      break;

    case 11 :
      matnastp();
      break;
    case 12 :
      menuvnp(1,0);
      break;

    case 13 :
      kodiz=0;kodizv=0;
      urov=0;
      
      dirspec(kodiz,&kodizv,"","",&urov,0);
      break;

    case 14 :
      iceb_redfil("matshetend.alx",0);
      break;

    case 15 :
      iceb_redfil("matnakend.alx",0);
      break;

    case 16 :
      saldomu();
      break;

    case 17 :
      dirnalog(0);
      break;

    default:
      kom=0;
      break;
   }
 }
}

/********************/
/*Распечатка отчетов*/
/********************/   

void		rasoth()
{
int		kom=0,kom1=0;
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);
VVOD MENU(3);

for(;;)
 {
  MENU.VVOD_delete();

  MENU.VVOD_SPISOK_add_ZAG(organ,40);

  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать остатки на карточках"));//0
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать движение товарно-материальных ценностей"));//1
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать заготовку для отчета"));//2
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список документов"));//3
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список документов по датам подтверждения"));//4
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать реестр проводок по видам операций"));//5
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать распределение НДС по видам операций"));//6
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать прогноз реализации товаров"));//7
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать розничную реализацию по торговым местам"));//8
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод розничной реализации"));//9
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список годов за которые введена информация"));//10
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать суммы выполненых автоматических дооценок"));//11
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать материалы имеющие критический остаток "));//12
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать движение услуг"));//13
  MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//14

  while(menu3w(stdscr,&MENU,&kom,-1,-1,1) != 0);
  class spis_oth oth;
  switch (kom)
   {
    case 14 :
    case -1 :
      return;


    case 0 :
      MENU.VVOD_delete();
      MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите нужное и нажмите Enter"));

      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать остатки на всех карточках"));//0
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать остатки на карточках по конкретному материалу"));//1
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать остатки на карточках по конкретной группе материалла"));//2
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать инвентаризационные ведомости"));//3
      MENU.VVOD_SPISOK_add_MD(gettext("Расчёт остатков по складам и счетам учёта"));//4
      MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//5
      kom1=0;
      while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

      switch (kom1)
       {
        case 5 :
        case -1 :
          break;
        case 0 :
          if(rasoskr(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          break;
        case 1 :
          rasmat();
          break;
        case 2 :
          rasgrup(0);
          break;
        case 3 :
          if(muinv(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          
          break;
        case 4 :
          if(ost_skl_shet(&oth) == 0)
           iceb_t_rabfil(&oth,"");
           
          break;
       }
      break;

    case 1 :
      MENU.VVOD_delete();
      MENU.VVOD_SPISOK_add_ZAG(organ);
   
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать движение по конкретному материалу"));//0
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать движение товарно-материальных ценностей (форма 1)"));//1
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать движение товарно-материальных ценностей (форма 2)"));//2
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать движение товарно-материальных ценностей (форма 3)"));//3
      MENU.VVOD_SPISOK_add_MD(gettext("Распечатать движение товарно-материальных ценностей по счетам списания"));//4
      MENU.VVOD_SPISOK_add_MD(gettext("Расчёт списания/получения материаллов по контрагентам"));//5
      MENU.VVOD_SPISOK_add_MD(gettext("Расчёт движения по кодам материалов"));//6
      MENU.VVOD_SPISOK_add_MD(gettext("Расчёт материального отчёта"));//7
      MENU.VVOD_SPISOK_add_MD(gettext("Расчёт процента наценки"));//8
      MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//9
      kom1=0;
  naz:;

      clear();
       
      while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);
      oth.clear();
      switch (kom1)
       {

        case 9 :
        case -1 :
          break;

        case 0 :
          rasosdk();
          goto naz;

        case 1 :
          if(dvtmcf1(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto naz;

        case 2 :
          if(dvtmcf2(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto naz;

        case 3 :
          if(motpk(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto naz;

        case 4 :
          if(opss(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto naz;

        case 5 :
          if(spis_p_kontr(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto naz;
        case 6:
          if(mudmc(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto naz;
        case 7:
          if(mumo(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto naz;
        case 8:
          if(murfn(&oth) == 0)
           iceb_t_rabfil(&oth,"");
          goto naz;
       }
      break;

    case 2 :
      if(muodk(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 3 :
      if(rasspdok(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 4 :
      if(xmurspd(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 5 :
      rppvo();
      break;

    case 6 :
      if(rasnds(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 7 :
      if(prognoz(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 8 :
      rozvse(dt,mt,gt,0,"\0");
      break;

    case 9 :
      rozsvod(dt,mt,gt,0,"\0");
      break;

    case 10 :
      poigod(2);
      break;

    case 11 :
      doocsum();
      break;

    case 12 :
      if(kriost(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    case 13 :
      if(dvusl_mu(&oth) == 0)
       iceb_t_rabfil(&oth,"");
      break;

    default:
      break;
   }
 }
}
/********************/
/*Работа с документами*/
/********************/
void            rabdokm()
{
int             kom;
short		godn;
char		bros[512];
FILE            *ffs=NULL;
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);
VVOD MENU(3);

MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Работа с товарно-материальными документами"));

MENU.VVOD_SPISOK_add_MD(gettext("Ввод нового документа"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Поиск введеного документа"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Просмотр всех введеных документов"));//2
sprintf(bros,"%s %d.%d.%d%s",gettext("Просмотр документов начиная с"),\
dt,mt,gt,gettext("г."));//3
MENU.VVOD_SPISOK_add_MD(bros);
MENU.VVOD_SPISOK_add_MD(gettext("Расчет средневзвешенных цен на материалы"));//4
MENU.VVOD_SPISOK_add_MD(gettext("Импорт документов"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Списание розничной торговли"));//6
MENU.VVOD_SPISOK_add_MD(gettext("Установить/снять блокировку дат"));//7
MENU.VVOD_SPISOK_add_MD(gettext("Проверка логической целосности базы данных"));//8
MENU.VVOD_SPISOK_add_MD(gettext("Выписка доверенности"));//9
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//10

kom=0;

for(;;)
 {
  clear();

  while(menu3(&MENU,&kom,1,-1,-1) != 0);


  switch (kom)
   {
    case 10:
    case -1 :
      return;
      break;

    case 0 :
      vvoddok();
      break;

    case 1 :
      poimatdok();
      break;

    case 2 :
      godn=startgod;
      if(godn == 0)
       godn=gt;
      smdok(0,0,godn);
      break;

    case 3 :
      smdok(dt,mt,gt);
      break;

    case 4 :
      srvcen();
      break;

    case 5 :
      impmatdok();
      break;

    case 6 :
      sprozn(0,ffs);
      break;

    case 7 :
      iceb_tl_blok();
      break;

    case 8 :
      matulk();
      break;

    case 9:
       dok_dover();
       break;

    default:
      kom=0;
      break;
   }
 }
}
