/*$Id: xukr.c,v 5.86 2011-06-23 09:58:02 sasa Exp $*/
/*06.09.2010	22.10.2002	Белых А.И.	xukr.c
Подсистема "Учет командировочных расходов"
*/
#define DVERSIQ "09.06.2011"
#include        "buhg.h"

void		xukrnsi(void);
int		ukrnast(void);
void	        xukrrsd(void);
void		poikrdok(void);
void		dirdokskr(int);
int  rppvokr(class spis_oth*);
void		xukrro(void);
int  ukrras(class spis_oth*);
int  kprik(class spis_oth*);
int  ukrskk(class spis_oth*);
int  ukrspdok(class spis_oth*);
int  ukrspdok1(class spis_oth*);

extern char     *organ;/*Наименование организации*/
extern int	iscolor;
extern char	*imabaz;
extern char	*host;
extern char	*parol_pol;
SQL_baza	bd;
extern char	*nameprinter;
extern short    startgod;
extern int iceb_kod_podsystem;

int             main(int argc,char **argv,char **envp)
{
iceb_kod_podsystem=ICEB_PS_UKR;
int             kom;
char            bros1[512];

icebstart(argc,argv);

VVOD MENU(4);

/*Ищем настройку*/

if(nastsys() != 0)
  exit_iceb(1);
if(ukrnast() != 0)
  exit_iceb(1);

iceb_t_perzap(1); /*Проверка на первичный запуск в текущем дне и удаление *.lst */

int uid=0;
class iceb_tu_str fioop;

uid=iceb_t_getuid();
fioop.plus(iceb_t_getfioop());


kom = 0;

for(;;)
 {

  clear(); /*Очистить экран и закрасить фоновым цветом*/
  MENU.VVOD_delete();

  MENU.VVOD_SPISOK_add_ZAG(gettext("Учет командировочных расходов"));
  if(organ != NULL)
   {
    sprintf(bros1,"%.*s",iceb_tu_kolbait(40,organ),organ);
    MENU.VVOD_SPISOK_add_ZAG(bros1);
   }

  MENU.VVOD_SPISOK_add_MD(gettext("Работа с документами"));
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод нормативно-справочной информации"));
  MENU.VVOD_SPISOK_add_MD(gettext("Распечатать отчеты"));
  MENU.VVOD_SPISOK_add_MD(gettext("Работа с файлами распечаток"));
  MENU.VVOD_SPISOK_add_MD(gettext("Сменить базу"));
  MENU.VVOD_SPISOK_add_MD(gettext("Сменить принтер"));
  MENU.VVOD_SPISOK_add_MD(gettext("Конец работы"));

  znak(0,COLS-26);
  infosys(12,COLS-27,host,VERSION,DVERSIQ,0,0,0,imabaz,nameprinter,uid,fioop.ravno());


  if(menu3(&MENU,&kom,1,0,0) != 0)
   continue;

  switch (kom)
   {

    case 6:
    case -1 :
      goto kon;
      break;

    case 0:
      xukrrsd();
      break;

    case 1:
      xukrnsi();
      break;

    case 2:
      xukrro();
      break;
      
    case 3:

      strcpy(bros1,"lst");
      dirlst(bros1);
      break;


    case 4:
      if(smenabaz(1) == 0)
       {
        if(nastsys() != 0)
         goto kon;
        if(ukrnast() != 0)
          goto kon;
       }
      break;

    case 5:
       mprintcap();
       break;

    default:
       kom=0;
       break;   
   }
 }

kon:;

sql_closebaz(&bd);

VVOD SOOBN(1);
SOOBN.VVOD_SPISOK_add_MD(gettext("База закрыта. Программа закончила работу"));
soobsh(&SOOBN,-1,-1,1);

refresh();
endwin();
}

/***************************************/
/*Ввод нормативно-справочной информации*/
/***************************************/

void xukrnsi()
{
int		kom=0;
//char            kod[24],naim[112];
int		poz,komv;
char		poi[32];
class iceb_tu_str kodn("");
class iceb_tu_str naimn("");
VVOD VVOD1(2);

VVOD MENU(3);
MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Учет командировочных расходов"));
MENU.VVOD_SPISOK_add_ZAG(gettext("Ввод и корректировка нормативно-справочной информации"));

MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка групп командивочных расходов"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка единиц измерения"));  //1
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка расходов на командировку"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка видов командировок"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка контрагентов"));//4
MENU.VVOD_SPISOK_add_MD(gettext("Работа с файлом настройки"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Настpойка автоматического выполнения пpоводок"));//6
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//7

for(;;)
 {
  clear();

  while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

  switch (kom)
   {
    case 7:
    case -1:
      return;
      break;

    case 0:
      clear();
      naimn.new_plus("");
      poz=komv=0;
      poi[0]='\0';
      dirmat1("Ukrgrup",&kodn,&naimn,LINES-5,0,2,0,&poz,&komv,poi,"\0");
      break;

    case 1:
      clear();
      naimn.new_plus("");
      poz=komv=0;
      poi[0]='\0';
      dirmat1("Edizmer",&kodn,&naimn,LINES-5,0,2,0,&poz,&komv,poi,"\0");
      break;

    case 2:
      naimn.new_plus("");
      dirkkr(&kodn,&naimn,0);
      break;

    case 3:
      clear();
      naimn.new_plus("");
      poz=komv=0;
      poi[0]='\0';
      dirmat1("Ukrvkr",&kodn,&naimn,LINES-5,0,2,0,&poz,&komv,poi,"\0");
      break;

    case 4:
      clear(); /*Очистить экран */
      naimn.new_plus("");
      dirkontr(&kodn,&naimn,0);
      break;

      
    case 5:
      if(iceb_redfil("ukrnast.alx",0) == 0)
        ukrnast();
      break;

    case 6 :
      iceb_redfil("avtprukr.alx",0);
      break;

    default:
      kom=0;
      break;
  }
 }
}

/*******************************/
/*Работа с документами         */
/*******************************/

void	xukrrsd()
{
int             kom=0;
char		bros[512];
short		dd,md,gd;
class iceb_tu_str nomdok("");
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);
VVOD MENU(3);

MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Работа с документами командировочных расходов"));

MENU.VVOD_SPISOK_add_MD(gettext("Ввод нового документа"));
MENU.VVOD_SPISOK_add_MD(gettext("Поиск введеного документа"));
MENU.VVOD_SPISOK_add_MD(gettext("Просмотр всех введеных документов"));
sprintf(bros,"%s %d.%d.%d%s",gettext("Просмотр документов начиная с"),
dt,mt,gt,gettext("г."));
MENU.VVOD_SPISOK_add_MD(bros);
MENU.VVOD_SPISOK_add_MD(gettext("Установить/снять блокировку дат"));
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

kom=0;

for(;;)
 {
  clear();

  while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

  switch (kom)
   {
    case 5:
    case -1 :
      return;
      break;

    case 0 :
      nomdok.new_plus("");
      dd=md=gd=0;
      if(vdkr(&dd,&md,&gd,&nomdok) == 0)
        dirdokkr(dd,md,gd,&nomdok);
      break;

    case 1 :
      poikrdok();
      break;

    case 2 :
      dirdokskr(0);
      break;

    case 3 :
      dirdokskr(1);
      break;

    case 4 :
      iceb_tl_blok();
       break;

    default:
      kom=0;
      break;
   }
 }

}

/***********************************/
/*Распечатка отчетов               */
/***********************************/

void		xukrro()
{
int		kom;

VVOD MENU(3);

kom=0;
MENU.VVOD_SPISOK_add_ZAG(organ,40);

MENU.VVOD_SPISOK_add_MD(gettext("Распечатать реестр проводок по видам командировок"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод по контрагентам"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Распечатка приказов на командировки"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать свод счёт-код расхода"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список документов по датам документов"));//4
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список документов по датам приказов"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//6


while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);
class spis_oth oth;
switch (kom)
 {
  case 6:
  case -1 :
    return;


  case 0:
   if(rppvokr(&oth) == 0)
    iceb_t_rabfil(&oth,"");
   break;

  case 1:
   if(ukrras(&oth) == 0)
     iceb_t_rabfil(&oth,"");
   break;

  case 2:
   if(kprik(&oth) == 0)
    iceb_t_rabfil(&oth,"");
   break;

  case 3:
   if(ukrskk(&oth) == 0)
    iceb_t_rabfil(&oth,"");
   break;

  case 4:
   if(ukrspdok(&oth) == 0)
    iceb_t_rabfil(&oth,"");
   break;

  case 5:
   if(ukrspdok1(&oth) == 0)
    iceb_t_rabfil(&oth,"");
   break;

  default:
    kom=0;
    break;
 }

}
