/*$Id: xusl.c,v 5.188 2011-08-29 07:09:00 sasa Exp $*/
/*08.09.2010	10.02.2000	Белых А.И.	xusl.c
Программа выписки счетов на услуги
*/
#define DVERSIQ "24.07.2011"
#include        "buhg.h"

void		normspi(void);
void            rabdoku(void);
void		rasotus(void);
int		uslnast(void);
void		poiusldok(void);
int  dvuslf2(class spis_oth*);
int  rasspdoku(class spis_oth*);
int  rppvou(class spis_oth*);
void		uddusl(void);
void 		impusldok(void);
int  opss_u(int,class spis_oth*);

extern char     data[24][80]; /*Данные для отображения или ввода*/
extern char     *organ;/*Наименование организации*/
pid_t           mypid;
extern int	iscolor;
extern char	*imabaz;
extern char	*host;
extern char	*parol_pol;
extern short	startgodus; /*Стартовый год просмотров услуг*/
SQL_baza	bd;
extern char	*nameprinter;
int             kassa=0;
extern int iceb_kod_podsystem;

int  main(int argc,char *argv[],char *envp[])
{
iceb_kod_podsystem=ICEB_PS_UU;
int             kom=0;
char		bros1[512];

icebstart(argc,argv);

VVOD MENU(4);

/*Ищем настройку*/
if(nastsys() != 0)
  exit_iceb(1);

if(uslnast() != 0)
 exit_iceb(1);


MENU.VVOD_SPISOK_add_MD(gettext("Работа с документами"));
MENU.VVOD_SPISOK_add_MD(gettext("Ввод нормативно-справочной информации"));
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать отчеты"));
MENU.VVOD_SPISOK_add_MD(gettext("Работа с файлами распечаток"));
MENU.VVOD_SPISOK_add_MD(gettext("Сменить базу"));
MENU.VVOD_SPISOK_add_MD(gettext("Сменить принтер"));
MENU.VVOD_SPISOK_add_MD(gettext("Конец работы"));

int uid=0;
class iceb_tu_str fioop;

uid=iceb_t_getuid();
fioop.plus(iceb_t_getfioop());

for(;;)
 {

  clear();

  MENU.VVOD_delete_ZAG();
  MENU.VVOD_SPISOK_add_ZAG(gettext("Программа работы с услугами"));
  if(organ != NULL)
   {
    sprintf(bros1,"%.*s",iceb_tu_kolbait(40,organ),organ);
    MENU.VVOD_SPISOK_add_ZAG(bros1);
   }

  znak(0,COLS-26);
  infosys(12,COLS-27,host,VERSION,DVERSIQ,0,0,0,imabaz,nameprinter,uid,fioop.ravno());

  if(menu3(&MENU,&kom,1,0,0) != 0)
    continue;

  switch (kom)
   {
    case 6 :
    case -1 :
      goto kon;
      break;

    case 0:
      rabdoku();
      break;

    case 2:
      rasotus();
      break;

    case 1:
      normspi();
      break;

    case 3:

      strcpy(bros1,"lst");
      dirlst(bros1);
      break;

    case 4:
      if(smenabaz(1) == 0)
       {
        if(nastsys() != 0)
          goto kon;

        if(uslnast() != 0)
          goto kon;
       }
      break;

    case 5:
      mprintcap();
      break;

    default:
      kom=0;
      break;
   }
 }

kon:;

sql_closebaz(&bd);

VVOD SOOBN(1);
SOOBN.VVOD_SPISOK_add_MD(gettext("База закрыта. Программа закончила работу"));
soobsh(&SOOBN,-1,-1,1);

refresh();
endwin();
}

/***************************************/
/*Ввод нормативно-справочной информации*/
/***************************************/   

void		normspi()
{
int             kom=0;
char		tabl[24];
int		poz,komv;
char		poi[36];
int		kodgr,kodus;
char		grup[40];
class iceb_tu_str kodn("");
class iceb_tu_str naim("");
VVOD MENU(3);

kom=0;
for(;;)
 {

  clear();

  MENU.VVOD_delete();
  MENU.VVOD_SPISOK_add_ZAG(organ,40);
  MENU.VVOD_SPISOK_add_ZAG(gettext("Ввод и корректировка нормативно-справочной информации"));

  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка групп услуг"));//0
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка единиц измерения"));//1
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка услуг"));//2
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка операций на приход"));//3
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка операций на расход"));//4
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка подразделений"));//5
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и корректировка списка форм оплаты"));//6
  MENU.VVOD_SPISOK_add_MD(gettext("Работа со списком контрагентов"));//7
  MENU.VVOD_SPISOK_add_MD(gettext("Работа с планом счетов"));//8
  MENU.VVOD_SPISOK_add_MD(gettext("Работа с файлом настройки"));//9
  MENU.VVOD_SPISOK_add_MD(gettext("Работа со списком коректировок на сумму документа"));//10
  MENU.VVOD_SPISOK_add_MD(gettext("Настpойка автоматического выполнения пpоводок"));//11
  MENU.VVOD_SPISOK_add_MD(gettext("Ввод и коректировка концовки счёта-фактури"));//12
  MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//13

  while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);

  switch (kom)
   {
    case 13 :
    case -1 :
      return;
    case 0 :
      clear();
      memset(tabl,'\0',sizeof(tabl));
      kodn.new_plus("");
      naim.new_plus("");
      strcpy(tabl,"Uslgrup");
      poz=komv=0;
      poi[0]='\0';
      dirmat1(tabl,&kodn,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
      break;

    case 2 :
      kodgr=kodus=0;
      naim.new_plus("");
      memset(grup,'\0',sizeof(grup));
      dirusl(&kodgr,&kodus,&naim,0,grup);
      break;

    case 1 :
      clear();
      kodn.new_plus("");
      naim.new_plus("");
      memset(tabl,'\0',sizeof(tabl));
      strcpy(tabl,"Edizmer");
      poz=komv=0;
      poi[0]='\0';
      dirmat1(tabl,&kodn,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
 
      break;

    case 3 :
      clear();
      kodn.new_plus("");
      naim.new_plus("");
      memset(tabl,'\0',sizeof(tabl));
      strcpy(tabl,"Usloper1");
      poz=komv=0;
      poi[0]='\0';
      dirmat1(tabl,&kodn,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
 
      break;

    case 4 :
      clear();
      kodn.new_plus("");
      naim.new_plus("");
      memset(tabl,'\0',sizeof(tabl));
      strcpy(tabl,"Usloper2");
      poz=komv=0;
      poi[0]='\0';
      dirmat1(tabl,&kodn,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
 
      break;

   case 5 :
      clear();
      kodn.new_plus("");
      naim.new_plus("");
      memset(tabl,'\0',sizeof(tabl));
      strcpy(tabl,"Uslpodr");
      poz=komv=0;
      poi[0]='\0';
      dirmat1(tabl,&kodn,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");
 
      break;

    case 6 :
      clear();
      kodn.new_plus("");
      naim.new_plus("");
      memset(tabl,'\0',sizeof(tabl));
      strcpy(tabl,"Foroplat");
      poz=komv=0;
      poi[0]='\0';
      dirmat1(tabl,&kodn,&naim,LINES-5,0,2,0,&poz,&komv,poi,"\0");

      break;

    case 7 :
      clear();
      naim.new_plus("");
      dirkontr(&kodn,&naim,0);

      break;

    case 8 :
      clear();
      kodn.new_plus("");
      naim.new_plus("");
      dirshet(&kodn,&naim,0);

      break;

    case 9 :
      if(iceb_redfil("uslnast.alx",0) == 0)
        uslnast();
      break;

    case 10 :
      iceb_redfil("uslkor.alx",0);
      break;

    case 11 :
      menuvnp(2,0);
      break;

    case 12 :
      iceb_redfil("usl_shet_fak_end.alx",0);
      break;

    default:
      kom=0;
      break;
   }
 }
}
/********************/
/*Работа с документами*/
/********************/
void            rabdoku()
{
int             kom;
int		podr=0;
short		godn;
short		dd,md,gd;
char		strsql[512];
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);
VVOD MENU(3);
VVOD VV(0);
godn=startgodus;
if(godn == 0)
 godn=gt;

kom=0;

MENU.VVOD_SPISOK_add_ZAG(organ,40);
MENU.VVOD_SPISOK_add_ZAG(gettext("Работа с документами"));

MENU.VVOD_SPISOK_add_MD(gettext("Ввод нового документа на оказание услуг"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Ввод нового документа на получение услуг"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Поиск введеного документа"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Просмотр всех введеных документов"));//3
sprintf(strsql,"%s %d.%d.%d%s",gettext("Просмотр документов начиная с"),//4
  dt,mt,gt,gettext("г."));
MENU.VVOD_SPISOK_add_MD(strsql);
MENU.VVOD_SPISOK_add_MD(gettext("Установить/снять блокировку дат"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Удаление всех документов за год"));//6
MENU.VVOD_SPISOK_add_MD(gettext("Импорт документов"));//7
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//8



for(;;)
 {
  clear();

  while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);
  
  dd=md=gd=0;
  class iceb_tu_str nomdok("");
  switch (kom)
   {
    case 8:
    case -1 :
      return;
      break;

    case 0 :

      if(vdnu(&dd,&md,&gd,&podr,&nomdok,2) == 0)
        dirudok(dd,md,gd,2,podr,nomdok.ravno());

      break;

    case 1 :
      if(vdnu(&dd,&md,&gd,&podr,&nomdok,1) == 0)
        dirudok(dd,md,gd,1,podr,nomdok.ravno());

      break;

    case 2 :
      poiusldok();
      break;

    case 3 :
      dirusdok(0,0,godn);
      break;

    case 4 :
      dirusdok(dt,mt,gt);
      break;

    case 5 :
      iceb_tl_blok();
       break;

    case 6 :
       uddusl();
       break;

    case 7 :
       impusldok();
       break;

    default:
      kom=0;
      break;
   }
 }
}

/********************/
/*Распечатка отчетов*/
/**********************/

void		rasotus()
{
int		kom;

VVOD MENU(3);

kom=0;
MENU.VVOD_SPISOK_add_ZAG(organ,40);

MENU.VVOD_SPISOK_add_MD(gettext("Распечатать движение услуг"));//0
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список документов"));//1
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать реестр проводок по видам операций"));//2
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать список годов за которые введена информация"));//3
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать движение услуг по счетам получения"));//4
MENU.VVOD_SPISOK_add_MD(gettext("Распечатать движение услуг по счетам списания"));//5
MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//6


while(menu3w(stdscr,&MENU,&kom,-1,-1,0) != 0);
class spis_oth oth;
switch (kom)
 {
  case 6 :
  case -1 :
    return;


  case 0:
   if(dvuslf2(&oth) == 0)
    iceb_t_rabfil(&oth,"");
   break;

  case 1:
   if(rasspdoku(&oth) == 0)
    iceb_t_rabfil(&oth,"");
   break;

  case 2:
   if(rppvou(&oth) == 0)
    iceb_t_rabfil(&oth,"");
   break;

  case 3:
   poigod(8);
   break;

  case 4:
   if(opss_u(1,&oth) == 0)
    iceb_t_rabfil(&oth,"");
   break;

  case 5:
   if(opss_u(2,&oth) == 0)
    iceb_t_rabfil(&oth,"");
   break;

  default:
    kom=0;
    break;
 }
}
