/*$Id: zar_oklad.c,v 5.8 2011-01-13 13:43:25 sasa1 Exp $*/
/*04.11.2009	27.11.2008	Белых А.И.	zar_oklad.c
Ввод и корректировка оклада
*/

#include <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char *imabaz;

void zar_oklad(int tabn)
{
if(iceb_t_prn() != 0)
 return;
 
char strsql[512];
memset(strsql,'\0',sizeof(strsql));
/*Проверяем не работает ли кто в режиме редактирования файла*/
sprintf(strsql,"%s%s",imabaz,"zardolhn.alx");
class icebt_sql_flag flag;

if(flag.flag_on(strsql) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("С файлом уже работает другой оператор !"));
  sprintf(strsql,"%s","zardolhn.alx");
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

flag.flag_off();

char flag_edit[112]; /*флаг, который выствляется для невозможности войти в режим редактирования*/
memset(flag_edit,'\0',sizeof(flag_edit));
//sprintf(flag_edit,"%szar_oklad_edit");
sprintf(flag_edit,"%szaroklad_edit",imabaz);
class icebt_sql_flag flagedit(flag_edit);


FILE *ff;
class iceb_tu_str imaf_nast("zardolhn.alx");

if(iceb_t_alxout(imaf_nast.ravno()) != 0)
 return;
/*открываем на чтение и читаем настройку если она есть*/
if((ff=fopen(imaf_nast.ravno(),"r")) == NULL)
 {
  error_op_nfil(imaf_nast.ravno(),errno,"");
  return;
 }

char stroka[1024];
class iceb_tu_str tbn("");
class iceb_tu_str oklad("");
class iceb_tu_str hasi("");
class iceb_tu_str metka_ras("");
class iceb_tu_str shet("");
while(fgets(stroka,sizeof(stroka),ff) != NULL)
 {
  
  if(stroka[0] == '#')
   continue;
  
  if(polen(stroka,&tbn,1,'|') != 0)
   continue;
  if(tbn.ravno_atoi() <= 0)
   continue;

  if(tbn.ravno_atoi() == tabn)
   {
    polen(stroka,&oklad,2,'|');
    polen(stroka,&hasi,3,'|');
    polen(stroka,&metka_ras,4,'|');
    polen(stroka,&shet,5,'|');
        
    break;
   }
 }
fclose(ff);
VVOD VV(0);


VV.VVOD_SPISOK_add_ZAG(gettext("Ввод и корректировка настройки расчёта должностного оклада"));

VV.VVOD_SPISOK_add_data(oklad.ravno(),20);
VV.VVOD_SPISOK_add_data(hasi.ravno(),20);
VV.VVOD_SPISOK_add_data(metka_ras.ravno(),10);
VV.VVOD_SPISOK_add_data(shet.ravno(),20);

VV.VVOD_SPISOK_add_MD(gettext("Оклад............."));//0
VV.VVOD_SPISOK_add_MD(gettext("Часы*коэффициент.."));//1
VV.VVOD_SPISOK_add_MD(gettext("Метка расчёта....."));//2
VV.VVOD_SPISOK_add_MD(gettext("Счёт.............."));//3

naz:;

helstr(LINES-1,0,"F2/+",gettext("записать"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);



int kom=VV.vvod(0,1,1,-1,-1);

oklad.new_plus(VV.data_ravno(0));
hasi.new_plus(VV.data_ravno(1));
metka_ras.new_plus(VV.data_ravno(2));
shet.new_plus(VV.data_ravno(3));

switch (kom)
 {
  case ESC:
  case FK10:
     return;

  case FK1:
    goto naz;

  case PLU:
  case FK2:
     break;

  default:
   goto naz;
 }
/*записываем в файл*/

/*Выставляем флаг записи в файл*/
sprintf(stroka,"%szar_oklad_zap",imabaz);
class icebt_sql_flag flagz;

while(flagz.flag_on(stroka) != 0)
 sleep(1);


/*открываем промежуточный файл*/
FILE *ff_tmp;
class iceb_tu_str imaf_tmp; /*из текущего каталога не перенести файл, так как нужно указывать полный путь*/
imafn(stroka,&imaf_tmp);

if((ff_tmp=fopen(imaf_tmp.ravno(),"w")) == NULL)
 {
  error_op_nfil(imaf_tmp.ravno(),errno,"");
  goto naz;
 }

if((ff=fopen(imaf_nast.ravno(),"r")) == NULL)
 {
  error_op_nfil(imaf_nast.ravno(),errno,"");
  goto naz;
 }


int metka_zap=0;
while(fgets(stroka,sizeof(stroka),ff) != NULL)
 {
  polen(stroka,&tbn,1,'|');

  if(tbn.ravno_atoi() == tabn)
   {
    fprintf(ff_tmp,"%-9d|%-12s|%-17s|%-14s|%-6s|\n",tabn,oklad.ravno(),hasi.ravno(),metka_ras.ravno(),shet.ravno());
    metka_zap++;
    continue;
   }  
  fprintf(ff_tmp,"%s",stroka);
 }

if(metka_zap == 0)
  fprintf(ff_tmp,"%-9d|%-12s|%-17s|%-14s|%-6s|\n",tabn,oklad.ravno(),hasi.ravno(),metka_ras.ravno(),shet.ravno());

fclose(ff);
fclose(ff_tmp);

if(rename(imaf_tmp.ravno(),imaf_nast.ravno()) != 0)
 {
  VVOD SOOB(1);

  sprintf(stroka,"Переименовываем %s -> %s",imaf_tmp.ravno(),imaf_nast.ravno());
  SOOB.VVOD_SPISOK_add_MD(stroka);

  sprintf(stroka,"%s %d",strerror(errno),errno);
  SOOB.VVOD_SPISOK_add_MD(stroka);

  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 } 
iceb_t_alxin(imaf_nast.ravno());
unlink(imaf_nast.ravno());

}
