/*$Id: zarkart.c,v 1.42 2011-01-13 13:43:25 sasa1 Exp $*/
/*16.03.2010	15.02.2002	Белых А.И.	zarkart.c
Распечатка карточки по начислениям/удержаниям за период
*/
#include        <sys/stat.h>
#include        <errno.h>
#include        <time.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

struct kk
 {
  char		fio[512];
  char		dolg[512];
  char          inn[32];
  int		podr;
  int		sovm;
  short		dn,mn,gn;
  short		dk,mk,gk;
 };

int zarkartr(short,short,short,short,char*,char*,char*,class spis_oth*);
int sprmatpom(short,short,short,short,char*,char*,char*,class spis_oth*);

void   	zarkartp(long,struct kk,short,short,int,masiv_din_int*,
masiv_din_int*,masiv_din_double*,masiv_din_double*,double*,
class SPISOK*,masiv_din_double*,double*,double*,class SPISOK*,
masiv_din_double*,double*,double*,int,FILE*,FILE*,FILE*,FILE*);

void   zarkartpr(short,short,int,masiv_din_int*,masiv_din_double*,
double*,int,FILE*);

void	vidtab(short,short,long,masiv_din_int*,masiv_din_double*,
masiv_din_double*,masiv_din_double*,int,int);

void	rasotrvr(short,short,int,masiv_din_int*,masiv_din_double*,int,FILE*);

void   zarkartprs(short,short,int,class SPISOK*,masiv_din_double*,
double*,double*,int,int,FILE*);

extern char	*shetb; /*Бюджетные счета начислений*/
extern char	*shetbu; /*Бюджетные счета удержаний*/
extern char *organ;

void		zarkart(int metka) //0-карточки 1-материальная помощь
{
static char	dat1[11];
static char	dat2[11];
static char     podr[112];
static char     kategr[112];
static char	tabnom[112];
int		kom=0,kom1=0;
char		naimp[512];
char		bros[512];
short		mn,gn;
short		mk,gk;
class iceb_tu_str fiov("");
VVOD MENU(3);
VVOD VV(0);

if(metka == 0)
  VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка карточек с начислениями/удержаниями по работникам"));
if(metka == 1)
  VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка списка работников, которым начислена материальная помощь"));
VV.VVOD_SPISOK_add_MD(gettext("Дата начала.....(м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца......(м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения.(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Код категории.....(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Табельный номер..(,,).."));
VV.VVOD_SPISOK_add_data(dat1,8);
VV.VVOD_SPISOK_add_data(dat2,8);
VV.VVOD_SPISOK_add_data(podr,sizeof(podr));
VV.VVOD_SPISOK_add_data(kategr,sizeof(kategr));
VV.VVOD_SPISOK_add_data(tabnom,sizeof(tabnom));

naz:;

clear(); 

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(podr,VV.VVOD_SPISOK_return_data(2),sizeof(podr)-1);
strncpy(kategr,VV.VVOD_SPISOK_return_data(3),sizeof(kategr)-1);
strncpy(tabnom,VV.VVOD_SPISOK_return_data(4),sizeof(tabnom)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   if(metka == 0)
     sprintf(bros,"%s","zarp4_3_12.txt");
   if(metka == 1)
     sprintf(bros,"%s","zarp4_3_11.txt");

   iceb_t_pdoc(bros);
   goto naz;

  case FK10:
  case ESC:
   return;

  case FK5:
  case FK2:
  case PLU:
   break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка категорий"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка табельных номеров"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Podr",podr,sizeof(podr),naimp);
        VV.VVOD_SPISOK_zapis_data(2,podr);
        goto naz;

      case 1 :
        vibrek("Kateg",kategr,sizeof(kategr),naimp);
        VV.VVOD_SPISOK_zapis_data(3,kategr);
        goto naz;

      case 2 :
      
        fiov.new_plus("");
        int tmm=0;
        if(dirtab(&tmm,&fiov,0,1) == 0)
         {
          if(tabnom[0] == '\0')
            sprintf(tabnom,"%d",tmm);
          else
           {
            sprintf(bros,"%d",tmm);
            if(strlen(tabnom)+strlen(bros)+1 < sizeof(tabnom)-1)
             {
              strcat(tabnom,",");
              strcat(tabnom,bros);
             }
           }
          VV.VVOD_SPISOK_zapis_data(4,tabnom);
         }
        goto naz;

     }

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
 }

if(rsdat1(&mn,&gn,dat1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(rsdat1(&mk,&gk,dat2) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конца !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
class spis_oth oth;

if(metka == 0)
  if(zarkartr(mn,gn,mk,gk,podr,kategr,tabnom,&oth) == 0)
   iceb_t_rabfil(&oth,"");
if(metka == 1)
  if(sprmatpom(mn,gn,mk,gk,podr,kategr,tabnom,&oth) == 0)
   iceb_t_rabfil(&oth,"");

}
/**********************/
/*Расчет с распечаткой*/
/**********************/
int zarkartr(short mn,short gn,short mk,short gk,
char *podr,char *kateg,char *tabnom,class spis_oth *oth)
{
int	        kon=0,kou=0;
char		strsql[512];
SQL_str		row,row1;
int		kolstr=0,kolstr1=0;
short		prn=0;
int		knah=0;
short		d,m,g;
double		suma;
int		nommes=0;
int		kolmes=0;
long		tabn=0,tabnz=0;
short		mesqc=0;
int		nomq=0;
FILE		*ff,*ff_spiso,*ffo=NULL,*ffb=NULL;
char		imaf[40],imafo[40],imafb[40];
struct kk kart;
time_t		tmmn=0;
time_t		tmmk=0;
int		kolns=0,kolus=0;
time(&tmmn);

clear();
printw("%s\n",gettext("Распечатка карточек с начислениями/удержаниями по работникам"));
printw("%d.%d => %d.%d\n",mn,gn,mk,gk);
GDITE();
/*Определяем количество начислений и удержаний*/
sprintf(strsql,"select kod from Nash order by kod asc");
SQLCURSOR cur;
SQLCURSOR cur1;
if((kon=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kon == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены начисления !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

masiv_din_int MKN; //Массив кодов начислений
while(cur.read_cursor(&row) != 0)
  MKN.plus(atoi(row[0]),-1);

sprintf(strsql,"select kod from Uder order by kod asc");

if((kou=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kou == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не введены удержания !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

masiv_din_int MKU(0); //Массив кодов удержаний

while(cur.read_cursor(&row) != 0)
  MKU.plus(atoi(row[0]),-1);

masiv_din_double MKND; //Данные начислений
masiv_din_double MKUD; //Данные удержаний

kolmes=period(1,mn,gn,30,mk,gk,1);

MKND.make_class(kon*kolmes);
MKUD.make_class(kou*kolmes);
sprintf(strsql,"select kod from Tabel order by kod asc");

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s !",gettext("Не введен список видов табелей"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }
masiv_din_int MVT(0); //Массив кодов удержаний

while(cur.read_cursor(&row) != 0)
  MVT.plus(atoi(row[0]),-1);

masiv_din_double MVTRD; //Массив рабочих дней
masiv_din_double MVTHS; //Массив часов
masiv_din_double MVTKD; //Массив календарных дней

MVTRD.make_class(kolstr*kolmes);
MVTHS.make_class(kolstr*kolmes);
MVTKD.make_class(kolstr*kolmes);

class SPISOK MKNS; //массив начислений/счет
class SPISOK MKUS; //массив удержаний/счет
masiv_din_double MKNSD; //данные начислений/счет
masiv_din_double MKUSD; //данные удержания/счет

memset(imafo,'\0',sizeof(imafo));
memset(imafb,'\0',sizeof(imafb));

if(shetb != NULL &&  shetbu != NULL)
 {

  sprintf(strsql,"select distinct prn,knah,shet from Zarp where \
datz >= '%04d-%d-1' and datz <= '%04d-%d-31' and suma <> 0.",gn,mn,gk,mk);

  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    return(1);
   }
  if(kolstr == 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return(1);
   }

  while(cur.read_cursor(&row) != 0)
   {
    prn=atoi(row[0]);
    sprintf(strsql,"%s|%s",row[1],row[2]);
    if(prn == 1)
     { 
      MKNS.plus(strsql);
      kolns++;
     }
    if(prn == 2)
     {
      MKUS.plus(strsql);
      kolus++;
     }
   }
  MKNSD.make_class(kolns*kolmes);
  MKUSD.make_class(kolus*kolmes);

  sprintf(imafo,"krb%d-%d_%d.lst",mn,mk,getpid());

  if((ffo = fopen(imafo,"w")) == NULL)
   {
    error_op_nfil(imafo,errno,"");
    return(1);
   }

  sprintf(imafb,"krn%d-%d_%d.lst",mn,mk,getpid());

  if((ffb = fopen(imafb,"w")) == NULL)
   {
    error_op_nfil(imafb,errno,"");
    return(1);
   }
  
 }

FILE *fftmp;
char imaftmp[30];
sprintf(imaftmp,"krt%d.tmp",getpid());

if((fftmp = fopen(imaftmp,"w")) == NULL)
   {
    error_op_nfil(imaftmp,errno,"");
    return(1);
   }

sprintf(strsql,"select datz,tabn,prn,knah,suma,shet from Zarp where \
datz >= '%d-%d-1' and datz <= '%d-%d-31' and suma <> 0. \
order by tabn,datz asc",gn,mn,gk,mk);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
char fio[512];
kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  memset(fio,'\0',sizeof(fio));
  sprintf(strsql,"select fio from Kartb where tabn=%s",row[1]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
    strncpy(fio,row1[0],sizeof(fio));

  fprintf(fftmp,"%s|%s|%s|%s|%s|%s|%s|\n",
  fio,row[0],row[1],row[2],row[3],row[4],row[5]);
 }

fclose(fftmp);
/*Нужно сортировать по фамилиям и табельным номерам так как могут быть тёзки*/
sprintf(strsql,"sort -o %s -t\\| -k1,2 -k2,3n %s",imaftmp,imaftmp);
iceb_t_system(strsql,1);

struct stat work;
if(stat(imaftmp,&work) != 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s !",gettext("Нет такого файла"));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

if((fftmp = fopen(imaftmp,"r")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }
unlink(imaftmp);


sprintf(imaf,"krt%d-%d_%d.lst",mn,mk,getpid());

if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return(1);
   }


char imaf_spiso[50];
sprintf(imaf_spiso,"krtso%d-%d_%d.lst",mn,mk,getpid());

if((ff_spiso = fopen(imaf_spiso,"w")) == NULL)
 {
  error_op_nfil(imaf_spiso,errno,"");
  return(1);
 }
short dkm=1;
dpm(&dkm,&mk,&gk,5);

zagolov(gettext("Список работников"),1,mn,gn,dkm,mk,gk,organ,ff_spiso);

fprintf(ff_spiso,"\
---------------------------------------------------\n");

fprintf(ff_spiso,gettext("\
  N   |Таб.ном.|Инд.нал.но| Фамилия  Имя  Отчество\n"));
fprintf(ff_spiso,"\
---------------------------------------------------\n");


double	saldon[kolmes];
double	saldono1[kolmes];
double	saldonb1[kolmes];
double	saldono2[kolmes];
double	saldonb2[kolmes];
memset(&saldon,'\0',sizeof(saldon));
memset(&saldono1,'\0',sizeof(saldono1));
memset(&saldonb1,'\0',sizeof(saldonb1));
memset(&saldono2,'\0',sizeof(saldono2));
memset(&saldonb2,'\0',sizeof(saldonb2));

double saldb=0;
kolstr1=0;
char stroka[1024];
char tabnom1[30];
char shet[32];
SQLCURSOR curr;
int nomer_zap=0;
int razmer=0;
//while(cur.read_cursor(&row) != 0)
while(fgets(stroka,sizeof(stroka),fftmp) != NULL)
 {
  razmer+=strlen(stroka);
  strzag(LINES-1,0,work.st_size,razmer);

  polen(stroka,tabnom1,sizeof(tabnom1),3,'|');

  if(proverka(tabnom,tabnom1,0,0) != 0)
    continue;
//  printw("%s %s %s %s %s\n",row[0],row[1],row[2],row[3],row[4]);
  tabn=atol(tabnom1);

  polen(stroka,strsql,sizeof(strsql),2,'|');
  rsdat(&d,&m,&g,strsql,2);    

  if(tabnz != tabn)
   {
    if(tabnz != 0)
     {
      zarkartp(tabnz,kart,mn,gn,kolmes,&MKN,&MKU,&MKND,&MKUD,saldon,
      &MKNS,&MKNSD,saldono1,saldonb1,&MKUS,&MKUSD,saldono2,saldonb2,++nomer_zap,
      ff,ffb,ffo,ff_spiso);
      rasotrvr(mn,gn,kolmes,&MVT,&MVTRD,1,ff);
      rasotrvr(mn,gn,kolmes,&MVT,&MVTHS,2,ff);
      rasotrvr(mn,gn,kolmes,&MVT,&MVTKD,3,ff);

      fprintf(ff,"\f");

      if(ffo != NULL)
       fprintf(ffo,"\f");
      if(ffb != NULL)
       fprintf(ffb,"\f");

      MKND.clear_class();
      MKUD.clear_class();
      MVTRD.clear_class();
      MVTHS.clear_class();
      MVTKD.clear_class();

      memset(&saldon,'\0',sizeof(saldon));
      memset(&saldono1,'\0',sizeof(saldono1));
      memset(&saldonb1,'\0',sizeof(saldonb1));
      memset(&saldono2,'\0',sizeof(saldono2));
      memset(&saldonb2,'\0',sizeof(saldonb2));
     }
    memset(&kart,'\0',sizeof(kart));
    sprintf(strsql,"select * from Kartb where tabn=%s",tabnom1);
    if(sql_readkey(&bd,strsql,&row1,&curr) < 1)
     {
      printw("Не найден табельный номер %s\n",tabnom1);
      OSTANOV();
     }  
    else
     {    
      if(proverka(podr,row1[4],0,0) != 0)
       {
        tabnz=0;
        continue;
       }
      if(proverka(kateg,row1[5],0,0) != 0)
       {
        tabnz=0;
        continue;
       }    
      strncpy(kart.fio,row1[1],sizeof(kart.fio)-1);
      strncpy(kart.dolg,row1[2],sizeof(kart.dolg)-1);
      kart.podr=atoi(row1[4]);
      rsdat(&kart.dn,&kart.mn,&kart.gn,row1[6],2);
      rsdat(&kart.dk,&kart.mk,&kart.gk,row1[7],2);
      strncpy(kart.inn,row1[10],sizeof(kart.inn)-1);
      kart.sovm=atoi(row1[9]);    
     }    
    tabnz=tabn;
   }

  if(mesqc != m)
   {
    nommes=period(1,mn,gn,30,m,g,1);
    saldon[nommes-1]=zarsald(1,m,g,tabn,&saldb);
    saldono1[nommes-1]=saldon[nommes-1];
    saldonb1[nommes-1]=saldb;
    saldono2[nommes-1]=saldon[nommes-1];
    saldonb2[nommes-1]=saldb;
    vidtab(m,g,tabn,&MVT,&MVTRD,&MVTHS,&MVTKD,nommes,kolmes);
    mesqc=m;
   }
  polen(stroka,strsql,sizeof(strsql),4,'|');
  prn=atoi(strsql);
  polen(stroka,strsql,sizeof(strsql),5,'|');
  knah=atoi(strsql);
  polen(stroka,strsql,sizeof(strsql),6,'|');
  suma=atof(strsql);
  polen(stroka,shet,sizeof(shet),7,'|');

  if(prn == 1)
   {
    nomq=MKN.find(knah);
//    printw("prn=%d %d.%d kolmes=%d nomq=%d nommes=%d\n",prn,m,g,kolmes,nomq,nommes);
    MKND.plus(suma,kolmes*nomq+nommes-1);
    if(shetb != NULL &&  shetbu != NULL)
     {
      sprintf(strsql,"%d|%s",knah,shet);
      nomq=MKNS.find(strsql);
//      printw("kolns=%d nomq=%d nommes=%d\n",kolns,nomq,nommes);
      MKNSD.plus(suma,kolmes*nomq+nommes-1);
     }
   }
  if(prn == 2)
   {
    nomq=MKU.find(knah);
//    printw("prn=%d %d.%d kolmes=%d nomq=%d nommes=%d\n",prn,m,g,kolmes,nomq,nommes);
    MKUD.plus(suma,kolmes*nomq+nommes-1);
    if(shetb != NULL &&  shetbu != NULL)
     {
      sprintf(strsql,"%d|%s",knah,shet);
      nomq=MKUS.find(strsql);
//      printw("kolus=%d nomq=%d nommes=%d\n",kolus,nomq,nommes);
      MKUSD.plus(suma,kolmes*nomq+nommes-1);
     }
   }
 }

fclose(fftmp);

if(tabnz != 0)
 {
  zarkartp(tabnz,kart,mn,gn,kolmes,&MKN,&MKU,&MKND,&MKUD,saldon,
  &MKNS,&MKNSD,saldono1,saldonb1,&MKUS,&MKUSD,saldono2,saldonb2,++nomer_zap,
  ff,ffb,ffo,ff_spiso);
  rasotrvr(mn,gn,kolmes,&MVT,&MVTRD,1,ff);
  rasotrvr(mn,gn,kolmes,&MVT,&MVTHS,2,ff);
  rasotrvr(mn,gn,kolmes,&MVT,&MVTKD,3,ff);
 }
podpis(ff);
podpis(ff_spiso);


fclose(ff);
fclose(ff_spiso);

if(shetb != NULL &&  shetbu != NULL)
 {
  podpis(ffo);

  podpis(ffb);

  fclose(ffo);
  fclose(ffb);
 }

time(&tmmk);
double kii=0.;
double dii=(tmmk-tmmn)/60.;
dii=modf(dii,&kii);

printw("\n%s %.f%s %.f%s\n",
gettext("Время расчета"),
kii,
gettext("мин."),
dii*60.,
gettext("сек."));

OSTANOV();

oth->spis_imaf.plus(imaf);

oth->spis_naim.plus(gettext("Распечатка карточек с начислениями/удержаниями по работникам"));

oth->spis_imaf.plus(imaf_spiso);

oth->spis_naim.plus(gettext("Список работников"));

if(shetb != NULL &&  shetbu != NULL)
 {
  oth->spis_imaf.plus(imafo);
  oth->spis_naim.plus(gettext("Хозрасчёт"));
  oth->spis_imaf.plus(imafb);
  oth->spis_naim.plus(gettext("Бюджет"));
 }

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),0);

return(0);

}

/************************/
/*Распечатка содержимого*/
/************************/
void zarkartp(long tabn,
struct kk kart,
short mn,short gn,
int kolmes,
masiv_din_int *MKN,
masiv_din_int *MKU,
masiv_din_double *MKND,
masiv_din_double *MKUD,
double *saldon,
class SPISOK *MKNS,
masiv_din_double *MKNSD,
double *saldono1,
double *saldonb1,
class SPISOK *MKUS,
masiv_din_double *MKUSD,
double *saldono2,
double *saldonb2,
int nomer_zap,
FILE *ff,
FILE *ffb,
FILE *ffo,
FILE *ff_spiso)
{

printw("\n%5ld %s\n",tabn,kart.fio);
refresh();

fprintf(ff,"%s\n%s: %ld %s\n",organ,gettext("Табельный номер"),
tabn,kart.fio);

fprintf(ff_spiso,"%6d %8ld %10s %s\n",nomer_zap,tabn,kart.inn,kart.fio);

fprintf(ff,"%s:%s\n",gettext("Индивидуальный налоговый номер"),
kart.inn);
fprintf(ff,"%s:%s\n",gettext("Должность"),kart.dolg);
if(kart.sovm == 1)
  fprintf(ff,"%s\n",gettext("Совместитель"));

if(kart.dn != 0)
  fprintf(ff,"%s:%02d.%02d.%d%s\n",gettext("Дата начала работы"),
  kart.dn,kart.mn,kart.gn,gettext("г."));

if(kart.dk != 0)
  fprintf(ff,"%s:%02d.%02d.%d%s\n",gettext("Дата увольнения"),
  kart.dk,kart.mk,kart.gk,gettext("г."));
  
zarkartpr(mn,gn,kolmes,MKN,MKND,saldon,1,ff);
zarkartpr(mn,gn,kolmes,MKU,MKUD,saldon,2,ff);

if(shetb != NULL &&  shetbu != NULL)
 {
  fprintf(ffb,"%s: %ld %s\n",gettext("Табельный номер"),
  tabn,kart.fio);

  fprintf(ffb,"%s:%s\n",gettext("Индивидуальный налоговый номер"),
  kart.inn);
  fprintf(ffb,"%s:%s\n",gettext("Должность"),kart.dolg);
  if(kart.sovm == 1)
    fprintf(ffb,"%s\n",gettext("Совместитель"));

  if(kart.dn != 0)
    fprintf(ffb,"%s:%02d.%02d.%d%s\n",gettext("Дата начала работы"),
    kart.dn,kart.mn,kart.gn,gettext("г."));

  if(kart.dk != 0)
    fprintf(ffb,"%s:%02d.%02d.%d%s\n",gettext("Дата увольнения"),
    kart.dk,kart.mk,kart.gk,gettext("г."));
  fprintf(ffb,"%s.\n",gettext("Бюджет"));
  zarkartprs(mn,gn,kolmes,MKNS,MKNSD,saldono1,saldonb1,1,1,ffb);
  zarkartprs(mn,gn,kolmes,MKUS,MKUSD,saldono1,saldonb1,2,1,ffb);

  fprintf(ffo,"%s: %ld %s\n",gettext("Табельный номер"),
  tabn,kart.fio);

  fprintf(ffo,"%s:%s\n",gettext("Индивидуальный налоговый номер"),
  kart.inn);
  fprintf(ffo,"%s:%s\n",gettext("Должность"),kart.dolg);
  if(kart.sovm == 1)
    fprintf(ffo,"%s\n",gettext("Совместитель"));

  if(kart.dn != 0)
    fprintf(ffo,"%s:%02d.%02d.%d%s\n",gettext("Дата начала работы"),
    kart.dn,kart.mn,kart.gn,gettext("г."));

  if(kart.dk != 0)
    fprintf(ffo,"%s:%02d.%02d.%d%s\n",gettext("Дата увольнения"),
    kart.dk,kart.mk,kart.gk,gettext("г."));
  fprintf(ffo,"%s.\n",gettext("Небюджет"));
  zarkartprs(mn,gn,kolmes,MKNS,MKNSD,saldono2,saldonb2,1,2,ffo);
  zarkartprs(mn,gn,kolmes,MKUS,MKUSD,saldono2,saldonb2,2,2,ffo);

  MKNSD->clear_class();
  MKUSD->clear_class();
 }

}
/********************************/
/*Распечатка конкретного массива*/
/********************************/
void   zarkartpr(short mn,short gn,
int kolmes,
masiv_din_int *MKN,
masiv_din_double *MKND,
double *saldo,
int metka, //1-начисления 2-удержания
FILE *ff)
{
char		stroka[40+(kolmes+1)*9];
short		d,m,g;
int		kon=0;
int		i,ii;
int		nome=0;
char		strsql[512];
SQL_str		row;
char		naim[512];
double		suma;
double		sumai[kolmes];
double		sumagor=0.,sumagori=0.;
SQLCURSOR curr;
memset(stroka,'\0',sizeof(stroka));

strcpy(stroka,"-----------------------------------");

for(i=0 ; i < kolmes+1; i++)
  strcat(stroka,"---------");


fprintf(ff,"%s\n",stroka);
if(metka == 1)
  fprintf(ff,gettext("Код|   Наименование начисления    |"));
if(metka == 2)
  fprintf(ff,gettext("Код|   Наименование удержания     |"));
d=1; m=mn; g=gn;

for(i=0 ; i < kolmes; i++)
 {
  fprintf(ff," %.02d.%d|",m,g);
  dpm(&d,&m,&g,3);
 }
fprintf(ff,"%*s|\n",iceb_tu_kolbait(8,gettext("Итого")),gettext("Итого"));
memset(&sumai,'\0',sizeof(sumai));

fprintf(ff,"%s\n",stroka);
if(metka == 1)
 {
  fprintf(ff,"%*.*s|",
  iceb_tu_kolbait(34,gettext("Сальдо начальное")),iceb_tu_kolbait(34,gettext("Сальдо начальное")),gettext("Сальдо начальное"));
  suma=0.;
  for(ii=0 ; ii < kolmes; ii++)
   { 
    fprintf(ff,"%8.2f|",saldo[ii]);
    suma+=saldo[ii];
//    sumai[ii]+=saldo[ii];
   }
  fprintf(ff,"%8.2f|\n",suma);
  fprintf(ff,"%s\n",stroka);
 }

kon=MKN->kolih();
for(i=0; i < kon; i++)
 {
  suma=0.;
  for(ii=0 ; ii < kolmes; ii++)
    if((suma=MKND->ravno(kolmes*i+ii)) != 0.)
     break;
  if(suma == 0.)
    continue;

  memset(naim,'\0',sizeof(naim));
  nome=MKN->ravno(i);
  if(metka == 1)
    sprintf(strsql,"select naik from Nash where kod=%d",nome);
  if(metka == 2)
    sprintf(strsql,"select naik from Uder where kod=%d",nome);
  if(sql_readkey(&bd,strsql,&row,&curr) > 0)
   strcpy(naim,row[0]);      
  
  sumagor=0.;
  fprintf(ff,"%3d %-*.*s|",nome,iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim);
  for(ii=0 ; ii < kolmes; ii++)
   {
    suma=MKND->ravno(kolmes*i+ii);
    if(metka == 2)
     suma*=-1;
    sumai[ii]+=suma;
    sumagor+=suma;
    fprintf(ff,"%8.2f|",suma);
   }
  fprintf(ff,"%8.2f|\n",sumagor);
  sumagori+=sumagor;
 }
fprintf(ff,"%s\n",stroka);

if(metka == 1)
 fprintf(ff,"%*s|",iceb_tu_kolbait(34,gettext("Итого начислено")),gettext("Итого начислено"));
if(metka == 2)
 fprintf(ff,"%*s|",iceb_tu_kolbait(34,gettext("Итого удержано")),gettext("Итого удержано"));

for(ii=0 ; ii < kolmes; ii++)
 {
  fprintf(ff,"%8.2f|",sumai[ii]);
  if(metka == 1)
   saldo[ii]+=sumai[ii];
  if(metka == 2)
   saldo[ii]-=sumai[ii];
 }
fprintf(ff,"%8.2f|\n\n",sumagori);

if(metka == 2)
 {
  fprintf(ff,"%s\n",stroka);
  fprintf(ff,"%*.*s|",
  iceb_tu_kolbait(34,gettext("Сальдо конечное")),iceb_tu_kolbait(34,gettext("Сальдо конечное")),gettext("Сальдо конечное"));
  suma=0.;
  for(ii=0 ; ii < kolmes; ii++)
   { 
    fprintf(ff,"%8.2f|",saldo[ii]);
    suma+=saldo[ii];
   }
  fprintf(ff,"%8.2f|\n",suma);
  fprintf(ff,"%s\n",stroka);
 }

}
/***********************************/
/*Определение отработанного времени*/
/***********************************/

void	vidtab(short mr,short gr,long tabnom,
masiv_din_int *MVT,
masiv_din_double *MVTRD,
masiv_din_double *MVTHS,
masiv_din_double *MVTKD,
int nommes,
int kolmes)
{
char		strsql[512];
SQL_str		row;
int		kolstr;
int		kodt=0;
int		nomq=0;

sprintf(strsql,"select kodt,dnei,has,kdnei from Ztab where god=%d and \
mes=%d and tabn=%ld",gr,mr,tabnom);
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 return;

while(cur.read_cursor(&row) != 0)
 {
  kodt=atoi(row[0]);
  nomq=MVT->find(kodt);
  MVTRD->plus(atof(row[1]),kolmes*nomq+nommes-1);
  MVTHS->plus(atof(row[2]),kolmes*nomq+nommes-1);
  MVTKD->plus(atof(row[3]),kolmes*nomq+nommes-1);
 }

}
/**********************************/
/*Распечатка отработанного времени*/
/**********************************/
void	rasotrvr(short mn,short gn,int kolmes,
masiv_din_int *MVT,
masiv_din_double *MVTRD,
int metka, //1-рабочие дни 2-часы 3-календарные дни
FILE *ff)
{
char		stroka[40+(kolmes+1)*8];
short		d,m,g;
double		sumai[kolmes];
double		sumagor=0.,sumagori=0.;
int		i=0,ii=0;
int		koltb;
double		suma=0.;
char		strsql[512];
SQL_str		row;
char		naim[512];
int		nome;
SQLCURSOR curr;

koltb=MVT->kolih();
for(i=0; i < koltb*kolmes; i++)
 if((suma=MVTRD->ravno(i)) != 0.)
     break;
if(suma == 0.)
  return;
suma=0.;  
memset(stroka,'\0',sizeof(stroka));
if(metka == 1)
 fprintf(ff,"%s:\n",gettext("Свод отработанных рабочих дней"));
if(metka == 2)
 fprintf(ff,"%s:\n",gettext("Свод отработанных часов"));
if(metka == 3)
 fprintf(ff,"%s:\n",gettext("Свод календарных дней"));

strcpy(stroka,"-----------------------------------");

for(i=0 ; i < kolmes+1; i++)
  strcat(stroka,"--------");


fprintf(ff,"%s\n",stroka);
fprintf(ff,gettext("Код|   Наименование табеля        |"));

d=1; m=mn; g=gn;

for(i=0 ; i < kolmes; i++)
 {
  fprintf(ff,"%.02d.%d|",m,g);
  dpm(&d,&m,&g,3);
 }
fprintf(ff,"%*s|\n",iceb_tu_kolbait(7,gettext("Итого")),gettext("Итого"));
fprintf(ff,"%s\n",stroka);
memset(&sumai,'\0',sizeof(sumai));


for(i=0; i < koltb; i++)
 {
  suma=0.;
  for(ii=0 ; ii < kolmes; ii++)
    if((suma=MVTRD->ravno(kolmes*i+ii)) != 0.)
     break;
  if(suma == 0.)
    continue;

  memset(naim,'\0',sizeof(naim));
  nome=MVT->ravno(i);
  sprintf(strsql,"select naik from Tabel where kod=%d",nome);
  if(sql_readkey(&bd,strsql,&row,&curr) > 0)
   strcpy(naim,row[0]);      
  
  sumagor=0.;
  fprintf(ff,"%3d %-*.*s|",nome,iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim);
  for(ii=0 ; ii < kolmes; ii++)
   {
    suma=MVTRD->ravno(kolmes*i+ii);
    sumai[ii]+=suma;
    sumagor+=suma;
    fprintf(ff,"%7.f|",suma);
   }
  fprintf(ff,"%7.f|\n",sumagor);
  sumagori+=sumagor;
 }
fprintf(ff,"%s\n",stroka);

fprintf(ff,"%*s|",iceb_tu_kolbait(34,gettext("Итого")),gettext("Итого"));

for(ii=0 ; ii < kolmes; ii++)
 {
  fprintf(ff,"%7.f|",sumai[ii]);
 }
fprintf(ff,"%7.f|\n\n",sumagori);

}
/********************************/
/*Распечатка конкретного массива счет*/
/********************************/
void   zarkartprs(short mn,short gn,
int kolmes,
class SPISOK *MKN,
masiv_din_double *MKND,
double *saldo,
double *saldob,
int metka, //1-начисления 2-удержания
int metkab, //1-бюджет 2-небюджет
FILE *ff)
{
char		stroka[40+(kolmes+1)*9];
short		d,m,g;
int		kon=0;
int		i,ii;
char		strsql[512];
SQL_str		row;
char		naim[512];
double		suma;
double		sumai[kolmes];
double		sumagor=0.,sumagori=0.;
char		bros[512];
char		knah[20];
char		shet[32];
SQLCURSOR curr;
  
memset(stroka,'\0',sizeof(stroka));

strcpy(stroka,"-----------------------------------");

for(i=0 ; i < kolmes+1; i++)
  strcat(stroka,"---------");


fprintf(ff,"%s\n",stroka);
if(metka == 1)
  fprintf(ff,gettext("Код|Наименование начисления |Счет |"));
if(metka == 2)
  fprintf(ff,gettext("Код|Наименование удержания  |Счет |"));
d=1; m=mn; g=gn;

for(i=0 ; i < kolmes; i++)
 {
  fprintf(ff," %.02d.%d|",m,g);
  dpm(&d,&m,&g,3);
 }
fprintf(ff,"%*s|\n",iceb_tu_kolbait(8,gettext("Итого")),gettext("Итого"));
memset(&sumai,'\0',sizeof(sumai));

fprintf(ff,"%s\n",stroka);
if(metka == 1)
 {
  fprintf(ff,"%*.*s|",
  iceb_tu_kolbait(34,gettext("Сальдо начальное")),
  iceb_tu_kolbait(34,gettext("Сальдо начальное")),
  gettext("Сальдо начальное"));
  suma=0.;
  for(ii=0 ; ii < kolmes; ii++)
   { 
    if(metkab == 1)
     {
      fprintf(ff,"%8.2f|",saldob[ii]);
      suma+=saldob[ii];
     }
    if(metkab == 2)
     {
      fprintf(ff,"%8.2f|",saldo[ii]-saldob[ii]);
      suma+=saldo[ii]-saldob[ii];
     }
   }
  fprintf(ff,"%8.2f|\n",suma);
  fprintf(ff,"%s\n",stroka);
 }

//kon=MKN->kolelem_masiv_char();
kon=MKN->kolih();
for(i=0; i < kon; i++)
 {
  suma=0.;
  for(ii=0 ; ii < kolmes; ii++)
    if((suma=MKND->ravno(kolmes*i+ii)) != 0.)
     break;
  if(suma == 0.)
    continue;

  strncpy(bros,MKN->ravno(i),sizeof(bros)-1);
  polen(bros,knah,sizeof(knah),1,'|');
  polen(bros,shet,sizeof(shet),2,'|');

  if(metka == 1) //начисления
   if(metkab == 1) //бюджет
    if(proverka(shetb,shet,0,0) != 0)
      continue;
  if(metka == 1) //начисления
   if(metkab == 2) //не бюджет
    if(proverka(shetb,shet,0,0) == 0)
      continue;

  if(metka == 2) //удержания
  if(metkab == 1) //бюджет
    if(proverka(shetbu,shet,0,0) != 0)
      continue;

  if(metka == 2) //удержания
  if(metkab == 2) //Не бюджет
    if(proverka(shetbu,shet,0,0) == 0)
      continue;

  memset(naim,'\0',sizeof(naim));
    
  if(metka == 1)
    sprintf(strsql,"select naik from Nash where kod=%s",knah);
  if(metka == 2)
    sprintf(strsql,"select naik from Uder where kod=%s",knah);
  if(sql_readkey(&bd,strsql,&row,&curr) > 0)
   strcpy(naim,row[0]);      
  
  sumagor=0.;
  fprintf(ff,"%3s %-*.*s|%-*s|",
  knah,
  iceb_tu_kolbait(24,naim),iceb_tu_kolbait(24,naim),naim,
  iceb_tu_kolbait(5,shet),shet);
  
  for(ii=0 ; ii < kolmes; ii++)
   {
    suma=MKND->ravno(kolmes*i+ii);
    if(metka == 2)
     suma*=-1;
    sumai[ii]+=suma;
    sumagor+=suma;
    fprintf(ff,"%8.2f|",suma);
   }
  fprintf(ff,"%8.2f|\n",sumagor);
  sumagori+=sumagor;
 }
fprintf(ff,"%s\n",stroka);

if(metka == 1)
 fprintf(ff,"%*s|",iceb_tu_kolbait(34,gettext("Итого начислено")),gettext("Итого начислено"));
if(metka == 2)
 fprintf(ff,"%*s|",iceb_tu_kolbait(34,gettext("Итого удержано")),gettext("Итого удержано"));

for(ii=0 ; ii < kolmes; ii++)
 {
  fprintf(ff,"%8.2f|",sumai[ii]);
  if(metka == 1)
   {
    saldo[ii]+=sumai[ii];
    if(metkab == 1)
      saldob[ii]+=sumai[ii];
   }
  if(metka == 2)
   {
    saldo[ii]-=sumai[ii];
    if(metkab == 1)
      saldob[ii]-=sumai[ii];
   }
 }
fprintf(ff,"%8.2f|\n\n",sumagori);

if(metka == 2)
 {
  fprintf(ff,"%s\n",stroka);
  fprintf(ff,"%*.*s|",
  iceb_tu_kolbait(34,gettext("Сальдо конечное")),
  iceb_tu_kolbait(34,gettext("Сальдо конечное")),
  gettext("Сальдо конечное"));
  suma=0.;
  for(ii=0 ; ii < kolmes; ii++)
   { 
    if(metkab == 1)
     {
      fprintf(ff,"%8.2f|",saldob[ii]);
      suma+=saldo[ii];
     }
    if(metkab == 2)
     {
      fprintf(ff,"%8.2f|",saldo[ii]-saldob[ii]);
      suma+=saldo[ii]-saldob[ii];
     }
   }
  fprintf(ff,"%8.2f|\n",suma);
  fprintf(ff,"%s\n",stroka);
 }

}
