/*$Id: zarlgot.c,v 5.13 2011-04-18 09:10:57 sasa Exp $*/
/*14.04.2011	26.04.2004	Белых А.И.	zarlgot.c
Чтение процента льгот по подоходному налогу
*/
#include <errno.h>
#include <buhg.h>
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif

extern int metka_psl; /*Метка применения социальной льготы 0-применяется 1-нет*/

float zarlgot(long tabn,short mr,short gr,int *kollgot,class iceb_tu_str *kod_lgot,FILE *ff_prot)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];
char bros[512];

*kollgot=0;
kod_lgot->new_plus("");

if(metka_psl == 1)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"%s-Расчёт без применения социальных льгот!!!\n",__FUNCTION__);
  return(0.);
 }

sprintf(strsql,"select str from Alx where fil='zarlgot.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(0.);
 }

if(kolstr == 0)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Не найдены настройки zarlgot.alx\n");
  return(0.);
 }

long tabnom;
float procent=0.;
short d,m,g;
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
    continue;
  if(polen(row_alx[0],bros,sizeof(bros),1,'|') != 0)
    continue;

  tabnom=atol(bros);

  if(tabnom != tabn)
    continue;

  polen(row_alx[0],bros,sizeof(bros),3,'|');

  if(bros[0] != '\0')
   {
    d=m=g=0;
    rsdat(&d,&m,&g,bros,1);
    if(sravmydat(1,mr,gr,d,m,g) < 0)
     continue;
   }   
  
  if(polen(row_alx[0],bros,sizeof(bros),2,'|') != 0)
    continue;
  
  procent=ATOFM(bros);
  
  polen(row_alx[0],kollgot,4,'|');
  polen(row_alx[0],kod_lgot,5,'|');

  if(procent != 0. && *kollgot == 0)
   *kollgot=1;   
 }


if(ff_prot != NULL)
   fprintf(ff_prot,"Льгота %.f%%\n",procent);

return(procent);

}
