/*$Id: zarpensm.c,v 5.19 2011-07-21 12:42:32 sasa Exp $*/
/*13.09.2010 	21.01.2010	Белых А.И.	zarpensm.c
Ф.ІНДАНІ - М3-06 Місячний звіт до системи персоніфікованного обліку відомостей про
застрахованих осіб
*/
#include <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif
#include        "dbfhead.h"

class zarpensm_nastr
 {
  public: 
   class iceb_tu_str kodpfu; /*код пенсионного фонда Украины*/
   class iceb_tu_str kodfil; /*код филиала*/
   class iceb_tu_str kodzvna; /*код звания неатестованых*/
   class iceb_tu_str ktn1;
   class iceb_tu_str ktn2;
   class iceb_tu_str ktn3;
   class iceb_tu_str ktn4;
   class iceb_tu_str ktn5;
   class iceb_tu_str ktn6;
   class iceb_tu_str ktn7;
   class iceb_tu_str ktn8;
   class iceb_tu_str ktn9;
   
  zarpensm_nastr()
   {
    kodpfu.new_plus("");
    kodfil.new_plus("");
    kodzvna.new_plus("");
    ktn1.new_plus("");    
    ktn2.new_plus("");    
    ktn3.new_plus("");    
    ktn4.new_plus("");    
    ktn5.new_plus("");    
    ktn6.new_plus("");    
    ktn7.new_plus("");    
    ktn8.new_plus("");    
    ktn9.new_plus("");    
   }
 };
const char *version_dok={"B"};

int zarpensm_read_nast(class zarpensm_nastr *nastr);
void zarpensm_xml_sap(short mr,short gr,const char *kodpfu,const char *imaf,const char *c_doc_sub,FILE *ff_xml);
void zarpensm_kon_lst(int kolstr,const char *inn_ker,const char *fio_ker,const char *inn_gb,const char *fio_gb,FILE *ff);
void zarpensm_tab6_dbf(const char *imaf,int kolz);
void zarpensm_tab7_dbf(const char *imaf,int kolz);
void zarpensm_tab5_dbf(const char *imaf,int kolz);

extern char *organ;
extern short kodpen;  /*Код пенсионных отчислений*/
extern short *kodnvpen; /*Коды не входящие в расчет пенсионного отчисления*/
//extern float  max_sum_for_soc; //Максимальная сумма с которой начисляются соц.отчисления

int zarpensm(class spis_oth *oth)
{
char imaf_pfz[56];
const char *imaf_tab5_dbf={"P04t05b.dbf"};
const char *imaf_tab6_dbf={"P04t06b.dbf"};
const char *imaf_tab7_dbf={"P04t07b.dbf"};
const char *imaf_tab5_dbf_tmp={"P04t05b.tmp"};
const char *imaf_tab6_dbf_tmp={"P04t06b.tmp"};
const char *imaf_tab7_dbf_tmp={"P04t07b.tmp"};
FILE *ff_tab5_dbf,*ff_tab6_dbf,*ff_tab7_dbf;
FILE *ff_tab5,*ff_tab5_xml,*ff_tab6,*ff_tab6_xml,*ff_tab7,*ff_tab7_xml,*ff_prot=NULL;
FILE *ff_tab8_xml=NULL;
FILE *ff_tabnom=NULL;
FILE *ff_tab8=NULL;
char imaf_tabnom[32];
char imaf_tab5[32],imaf_tab5_xml[32],imaf_tab6[32],imaf_tab6_xml[32],imaf_tab7[32],imaf_tab7_xml[32],imaf_prot[32];
char imaf_tab8[32];
char imaf_tab8_xml[32];
SQL_str row,row1;
class SQLCURSOR cur,cur1;
int kolstr=0,kolstr1=0;
char strsql[1024];
int kom=0;
static class iceb_tu_str dat1("");
static class iceb_tu_str tabnom("");
class iceb_tu_str fio("");
class iceb_tu_str inn("");
class iceb_tu_str inn_or("");
class zarpensm_nastr nastr; 
class iceb_tu_str edrpou("");
int tbn=0;

VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Расчет месячного отчётa для пенсионного персонифицированного учёта"));

VV.VVOD_SPISOK_add_data(dat1.ravno(),8);
VV.VVOD_SPISOK_add_data(tabnom.ravno(),112);

VV.VVOD_SPISOK_add_MD(gettext("Дата........(м.г)....."));//0
VV.VVOD_SPISOK_add_MD(gettext("Табельный номер.(,,).."));//1

naz:;
clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("таб.номер"),
"F4",gettext("очистить"),
"F5",gettext("настройка"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

dat1.new_plus(VV.data_ravno(0));
tabnom.new_plus(VV.data_ravno(1));

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
//   iceb_t_pdoc("zarp4_7_1_1.txt"));
   goto naz;

  case FK2:
  case PLU:
    break;
      
  case FK3: //Просмотр списка табельных номеров
    tbn=0;
    fio.new_plus("");
    if(dirtab(&tbn,&fio,0,1) == 0)
     {
      VV.data_z_plus(1,tbn);
     }    
    goto naz;

  case FK4:
    VV.VVOD_clear_data();
    goto naz;

  case FK5 :  
    iceb_redfil("zarpensm.alx",0);
    goto naz;

  case FK10:
  case ESC:
    return(1);

  default:
    goto naz;
 }
short mr,gr;
if(rsdat1(&mr,&gr,dat1.ravno()) != 0)
 {
  iceb_t_soob(gettext("Неправильно введена дата!"));
  goto naz;
 }

class SPISOK tab7; /*код типа начисления|месяц.год*/
class masiv_din_double tab7_osum;
class masiv_din_double tab7_msum;
class masiv_din_double tab7_psum;

zarpensm_read_nast(&nastr); /*Читаем настройки*/

sprintf(strsql,"select distinct tabn from Zarp where datz >= '%04d-%02d-%02d' and \
datz <= '%04d-%02d-%02d' and prn='1' and suma <> 0.",
gr,mr,1,gr,mr,31);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной записи !"));
  return(1);
 }

if(readkey("select kod from Kontragent where kodkon='00'",&row1,&cur1) == 1)
 {
  inn_or.new_plus(row1[0]);
 } 

sprintf(imaf_tabnom,"tabnom%d.lst",getpid());
if((ff_tabnom = fopen(imaf_tabnom,"w")) == NULL)
 {
  error_op_nfil(imaf_tabnom,errno,"");
  return(1);
 }
zagolov("Таблица 6",1,mr,gr,31,mr,gr,organ,ff_tabnom);

sprintf(imaf_tab5,"P04T05_%d.lst",getpid());
if((ff_tab5 = fopen(imaf_tab5,"w")) == NULL)
 {
  error_op_nfil(imaf_tab5,errno,"");
  return(1);
 }

sprintf(imaf_tab6,"P04T06_%d.lst",getpid());
if((ff_tab6 = fopen(imaf_tab6,"w")) == NULL)
 {
  error_op_nfil(imaf_tab6,errno,"");
  return(1);
 }


sprintf(imaf_tab7,"P04T07_%d.lst",getpid());
if((ff_tab7 = fopen(imaf_tab7,"w")) == NULL)
 {
  error_op_nfil(imaf_tab7,errno,"");
  return(1);
 }
sprintf(imaf_tab8,"P04T08_%d.lst",getpid());
if((ff_tab8 = fopen(imaf_tab8,"w")) == NULL)
 {
  error_op_nfil(imaf_tab8,errno,"");
  return(1);
 }

sprintf(imaf_tab5_xml,"P04T05%s.xml",version_dok);
if((ff_tab5_xml = fopen(imaf_tab5_xml,"w")) == NULL)
 {
  error_op_nfil(imaf_tab5_xml,errno,"");
  return(1);
 }

if((ff_tab5_dbf = fopen(imaf_tab5_dbf_tmp,"w")) == NULL)
 {
  error_op_nfil(imaf_tab5_dbf_tmp,errno,"");
  return(1);
 }

sprintf(imaf_tab6_xml,"P04T06%s.xml",version_dok);
if((ff_tab6_xml = fopen(imaf_tab6_xml,"w")) == NULL)
 {
  error_op_nfil(imaf_tab6_xml,errno,"");
  return(1);
 }

if((ff_tab6_dbf = fopen(imaf_tab6_dbf_tmp,"w")) == NULL)
 {
  error_op_nfil(imaf_tab6_dbf_tmp,errno,"");
  return(1);
 }



sprintf(imaf_tab7_xml,"P04T07%s.xml",version_dok);
if((ff_tab7_xml = fopen(imaf_tab7_xml,"w")) == NULL)
 {
  error_op_nfil(imaf_tab7_xml,errno,"");
  return(1);
 }
if((ff_tab7_dbf = fopen(imaf_tab7_dbf_tmp,"w")) == NULL)
 {
  error_op_nfil(imaf_tab7_dbf_tmp,errno,"");
  return(1);
 }
sprintf(imaf_tab8_xml,"P04T08%s.xml",version_dok);
if((ff_tab8_xml = fopen(imaf_tab8_xml,"w")) == NULL)
 {
  error_op_nfil(imaf_tab8_xml,errno,"");
  return(1);
 }

sprintf(imaf_prot,"prot%d.lst",getpid());

if((ff_prot = fopen(imaf_prot,"w")) == NULL)
 {
  error_op_nfil(imaf_prot,errno,"");
  return(1);
 }

if(ff_prot != NULL)
 {
  fprintf(ff_prot,"Коды не входящие в расчёт пенсионного:\n");
  if(kodnvpen != NULL)
   {
    for(int nom=1; nom < kodnvpen[0]; nom++)
     fprintf(ff_prot," %d",kodnvpen[nom]);
    fprintf(ff_prot,"\n");
   }
  fprintf(ff_prot,"Коды начислений для кода типа начисления 1:%s\n",nastr.ktn1.ravno());
  fprintf(ff_prot,"Коды начислений для кода типа начисления 2:%s\n",nastr.ktn2.ravno());
  fprintf(ff_prot,"Коды начислений для кода типа начисления 3:%s\n",nastr.ktn3.ravno());
  fprintf(ff_prot,"Коды начислений для кода типа начисления 4:%s\n",nastr.ktn4.ravno());
  fprintf(ff_prot,"Коды начислений для кода типа начисления 5:%s\n",nastr.ktn5.ravno());
  fprintf(ff_prot,"Коды начислений для кода типа начисления 6:%s\n",nastr.ktn6.ravno());
  fprintf(ff_prot,"Коды начислений для кода типа начисления 7:%s\n",nastr.ktn7.ravno());
  fprintf(ff_prot,"Коды начислений для кода типа начисления 8:%s\n",nastr.ktn8.ravno());
  fprintf(ff_prot,"Коды начислений для кода типа начисления 9:%s\n",nastr.ktn9.ravno());
  fprintf(ff_prot,"Коды званий неатестованых:%s\n",nastr.kodzvna.ravno());
 }

class zar_read_tn1h nastr_mz;
zar_read_tn1(1,mr,gr,&nastr_mz,NULL);

short dkm=1;
dpm(&dkm,&mr,&gr,5);

 

fprintf(ff_tab5,"\
Вихідний No у страхувальника__________ No аркушу звіту___________________\n");
fprintf(ff_tab5,"\n\
         Таблиця 5. Трудові відносини застрахованих осіб\n\n");
fprintf(ff_tab5,"\
Код за ЄДРПОУ/ %-10s        Філія за реєстрацією %s\n\
індефікаційний номер        в органі Пенсійного фонду\n\n",
inn_or.ravno(),nastr.kodpfu.ravno());
fprintf(ff_tab5,"Назва страхувальника:%s\n",organ);
fprintf(ff_tab5,"Звітний місяць:%d    рік:%d           Тип:\n",mr,gr);

fprintf(ff_tab5,"\
--------------------------------------------------------------------------\n");
fprintf(ff_tab5,"\
  N  |Ном.обл.к.|       Призвище, ім'я, по батькові      |Трудові віднос.|\n\
     |          |                                        |Дата п.|Дата к.|\n");

fprintf(ff_tab5,"\
--------------------------------------------------------------------------\n");



fprintf(ff_tab6,"\
Вихідний No у страхувальника__________ No аркушу звіту___________________\n");
fprintf(ff_tab6,"\n\
Таблиця 6. Відомості про нарахування заробітку (доходу) застрахованим особам\n\n");
fprintf(ff_tab6,"\
Код за ЄДРПОУ/ %-10s        Філія за реєстрацією %s\n\
індефікаційний номер        в органі Пенсійного фонду\n\n",
inn_or.ravno(),nastr.kodpfu.ravno());
fprintf(ff_tab6,"Назва страхувальника:%s\n",organ);
fprintf(ff_tab6,"Звітний місяць:%d    рік:%d           Тип:\n",mr,gr);
fprintf(ff_tab6,"\
---------------------------------------------------------------------------------------------------\n");
fprintf(ff_tab6,"\
  N  |Номер облі|   Призвище та ініціали ЗО    |Код |Код |Сума нарах|Сума нарах|Сума стр|Озна|Озна|\n\
     |кової карт|                              |кате|типу|увань заро|увань заро|ахових  |ка  |ка  |\n\
     |ки застра-|                              |грії|став|бітку/дохо|бітку/дохо|внесків |наяв|наяв|\n\
     |хованої   |                              | ЗО |ки  |ду за відп|ду, в межа|за звітн|ност|ност|\n\
     |особи (ЗО)|                              |    |стра|овідний   |х максимал|   ний  |і тр|і сп|\n\
     |за ДРФО   |                              |    |хово|місяць    |ьної велич|місяць  |удов|ецст|\n\
     |   ДПА    |                              |    |го  |          |ини на яку|(із заро|ої к|ажу |\n\
     |          |                              |    |внес|          |нараховуют|бітку/до|нижк|(1-т|\n\
     |          |                              |    |ку  |          |ься страхо|ходу)   |и   |ак,0|\n\
     |          |                              |    |    |          |ві внески |1-5%%**  |(1-т|-ні)|\n\
     |          |                              |    |    |          |          |        |ак,0|    |\n\
     |          |                              |    |    |          |          |        |-ні)|    |\n");
fprintf(ff_tab6,"\
---------------------------------------------------------------------------------------------------\n");





fprintf(ff_tab7,"\
Вихідний No у страхувальника___________________                    No аркушу звіту___________________\n");
fprintf(ff_tab7,"\n\
  Таблиця 7. Суми, нарахованы за дні тимчасової непрацездатності, щорічні та додаткові відпустки, та суми,\n\
                                нараховані у минулих періодах\n\n");
fprintf(ff_tab7,"\
Код за ЄДРПОУ/індефікаційний номер %-10s   Філія за реєстрацією в органі Пенсійного фонду %s\n",
inn_or.ravno(),nastr.kodpfu.ravno());
fprintf(ff_tab7,"Назва страхувальника:%s\n",organ);
fprintf(ff_tab7,"Звітний місяць:%d    рік:%d           Тип:\n",mr,gr);
fprintf(ff_tab7,"\
----------------------------------------------------------------------------------------------------------------\n");
fprintf(ff_tab7,"\
  N  |Номер облі|   Призвище та ініціали ЗО    |Код |Код |Місяць |Тип |Сума нарах|Сума нарах|Сума стр|Озна|Озна|\n\
     |кової карт|                              |кате|типу|та рік |нара|увань заро|увань заро|ахових  |ка  |ка  |\n\
     |ки застра-|                              |грії|став|за який|хува|бітку/дохо|бітку/дохо|внесків |наяв|наяв|\n\
     |хованої   |                              | ЗО |ки  |проведе|ння*|ду за відп|ду, в межа|за відпо|ност|ност|\n\
     |особи (ЗО)|                              |    |стра|но нара|    |овідний   |х максимал|відний  |і тр|і сп|\n\
     |за ДРФО   |                              |    |хово|хування|    |місяць    |ьної велич|місяць  |удов|ецст|\n\
     |   ДПА    |                              |    |го  |       |    |          |ини на яку|(із заро|ої к|ажу |\n\
     |          |                              |    |внес|       |    |          |нараховуют|бітку/до|нижк|(1-т|\n\
     |          |                              |    |ку  |       |    |          |ься страхо|ходу)   |и   |ак,0|\n\
     |          |                              |    |    |       |    |          |ві внески |1-5%%**  |(1-т|-ні)|\n\
     |          |                              |    |    |       |    |          |          |        |ак,0|    |\n\
     |          |                              |    |    |       |    |          |          |        |-ні)|    |\n");
fprintf(ff_tab7,"\
----------------------------------------------------------------------------------------------------------------\n");

sprintf(strsql,"P04T05%s",version_dok);
zarpensm_xml_sap(mr,gr,nastr.kodpfu.ravno(),strsql,"T05",ff_tab5_xml);

sprintf(strsql,"P04T06%s",version_dok);
zarpensm_xml_sap(mr,gr,nastr.kodpfu.ravno(),strsql,"T06",ff_tab6_xml);

sprintf(strsql,"P04T07%s",version_dok);
zarpensm_xml_sap(mr,gr,nastr.kodpfu.ravno(),strsql,"T07",ff_tab7_xml);

sprintf(strsql,"P04T08%s",version_dok);
zarpensm_xml_sap(mr,gr,nastr.kodpfu.ravno(),strsql,"T08",ff_tab8_xml);
  
double suma_nah=0.;   

double suma=0.,isuma=0.;
double sumapv=0.,isumapv=0.;
int nomer_str_tab6=0;
double suma_obh=0.;
double isuma_obh=0.;
int metka_otk=1; /*метка наличия трудовой книжки 0-нет трудовой 1-есть*/
int metka_exp=0; /*метка наличия спецстажа 0-нет 1-есть*/
int nomer_vsp=0;
int nomer_str_tab7=0;
short mv,gv;
int kodtipnah=0;
short dpnr=0; /*День приёма на работу*/
short dusr=0; /*День увольнения с работы*/
short dnr,mnr,gnr; /*Дата начала работы*/
short dkr,mkr,gkr; /*Дата конца работы*/
int nomer_str_tab5=0;
int nomer_str_tab8=0;
char prizv[112];
char ima[112];
char othestvo[112];
double iosum_tab7=0.;
double imsum_tab7=0.;
double ipsum_tab7=0.;
int metka_tabl7=0;
int kodzvna=0;
double penst7=0.; /*Пенсионное отчисление в таблицу 7 для 4 и 5*/
double suma_pens_ktn5=0.;
double suma_pens_ktn4=0.;
double suma_max=0.;
char kodss[56];
short dn=1;
short dk=1;
dpm(&dk,&mr,&gr,5);
short koldn=dk-dn+1;

while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);

  if(proverka(tabnom.ravno(),row[0],0,0) != 0)
   continue;


  sprintf(strsql,"select knah,suma,godn,mesn from Zarp where datz >= '%04d-%02d-%02d' and \
datz <= '%04d-%02d-%02d' and tabn=%s and prn='1' and suma <> 0.",
  gr,mr,1,gr,mr,31,row[0]);

  if(ff_prot != NULL)
   {
    fprintf(ff_prot,"\n\nТабельный номер %s\n",row[0]);
    fprintf(ff_prot,"%s\n",strsql);
   }
  if(cur1.make_cursor(&bd,strsql) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }
  suma_obh=0.;
  suma=0.;
  tab7.free_class();
  tab7_osum.free_class();  
  tab7_msum.free_class();  
  tab7_psum.free_class();  
  suma_pens_ktn4=suma_pens_ktn5=0.;
  
  while(cur1.read_cursor(&row1) != 0)
   {
    if(ff_prot != NULL)
      fprintf(ff_prot,"%s %s %s %s\n",row1[0],row1[1],row1[2],row1[3]);
    if(provkod(kodnvpen,atoi(row1[0])) >= 0)
     {
      if(ff_prot != NULL)
        fprintf(ff_prot,"Не входит в расчёт\n");
      continue;
     }    

    suma_nah=atof(row1[1]);   
    metka_tabl7=0;    
    if(proverka(nastr.ktn1.ravno(),row1[0],0,1) == 0)
     {
      if(ff_prot != NULL)
        fprintf(ff_prot,"Подходит для кода типа начисления 1\n");
      sprintf(strsql,"1|%s.%s",row1[3],row1[2]);
      if((nomer_vsp=tab7.find(strsql)) < 0)
       tab7.plus(strsql);
      tab7_osum.plus(suma_nah,nomer_vsp);
      tab7_msum.plus(suma_nah,nomer_vsp);
      tab7_psum.plus(0.,nomer_vsp);
      metka_tabl7=1;
     }

    if(proverka(nastr.ktn2.ravno(),row1[0],0,1) == 0)
     {
      if(ff_prot != NULL)
       fprintf(ff_prot,"Подходит для кода типа начисления 2\n");
      sprintf(strsql,"2|%s.%s",row1[3],row1[2]);
      if((nomer_vsp=tab7.find(strsql)) < 0)
       tab7.plus(strsql);
      tab7_osum.plus(suma_nah,nomer_vsp);
      tab7_msum.plus(suma_nah,nomer_vsp);
      tab7_psum.plus(0.,nomer_vsp);
      metka_tabl7=1;
     }

    if(proverka(nastr.ktn3.ravno(),row1[0],0,1) == 0)
     {
      if(ff_prot != NULL)
       fprintf(ff_prot,"Подходит для кода типа начисления 3\n");
      sprintf(strsql,"3|%s.%s",row1[3],row1[2]);
      if((nomer_vsp=tab7.find(strsql)) < 0)
       tab7.plus(strsql);
      tab7_osum.plus(suma_nah,nomer_vsp);
      tab7_msum.plus(suma_nah,nomer_vsp);
      tab7_psum.plus(0.,nomer_vsp);
    
      metka_tabl7=1;
     }

    if(proverka(nastr.ktn4.ravno(),row1[0],0,1) == 0)
     {
      if(ff_prot != NULL)
       fprintf(ff_prot,"Подходит для кода типа начисления 4\n");
      sprintf(strsql,"4|%s.%s",row1[3],row1[2]);
      if((nomer_vsp=tab7.find(strsql)) < 0)
       tab7.plus(strsql);
      tab7_osum.plus(suma_nah,nomer_vsp);

      tab7_msum.plus(suma_nah,nomer_vsp);

      penst7=pens(atoi(row[0]),mr,gr,suma_nah,NULL);

      tab7_psum.plus(penst7,nomer_vsp);
      suma_pens_ktn4+=suma_nah;
      metka_tabl7=1;
     }

    if(proverka(nastr.ktn5.ravno(),row1[0],0,1) == 0)
     {
      if(ff_prot != NULL)
       fprintf(ff_prot,"Подходит для кода типа начисления 5\n");

      sprintf(strsql,"5|%s.%s",row1[3],row1[2]);

      if((nomer_vsp=tab7.find(strsql)) < 0)
       tab7.plus(strsql);

      tab7_osum.plus(suma_nah,nomer_vsp);

      tab7_msum.plus(suma_nah,nomer_vsp);

      penst7=pens(atoi(row[0]),mr,gr,suma_nah,NULL);

      tab7_psum.plus(penst7,nomer_vsp);

      suma_pens_ktn5+=suma_nah;
      metka_tabl7=1;
     }

    if(proverka(nastr.ktn6.ravno(),row1[0],0,1) == 0)
     {
      if(ff_prot != NULL)
       fprintf(ff_prot,"Подходит для кода типа начисления 6\n");
      sprintf(strsql,"6|%s.%s",row1[3],row1[2]);
      if((nomer_vsp=tab7.find(strsql)) < 0)
       tab7.plus(strsql);
      tab7_osum.plus(suma_nah,nomer_vsp);
      tab7_msum.plus(suma_nah,nomer_vsp);
      tab7_psum.plus(0.,nomer_vsp);
      metka_tabl7=1;
     }

    if(proverka(nastr.ktn7.ravno(),row1[0],0,1) == 0)
     {
      if(ff_prot != NULL)
       fprintf(ff_prot,"Подходит для кода типа начисления 7\n");
      sprintf(strsql,"7|%s.%s",row1[3],row1[2]);
      if((nomer_vsp=tab7.find(strsql)) < 0)
       tab7.plus(strsql);
      tab7_osum.plus(suma_nah,nomer_vsp);
      tab7_msum.plus(suma_nah,nomer_vsp);
      tab7_psum.plus(0.,nomer_vsp);
      metka_tabl7=1;
     }

    if(proverka(nastr.ktn8.ravno(),row1[0],0,1) == 0)
     {
      if(ff_prot != NULL)
       fprintf(ff_prot,"Подходит для кода типа начисления 8\n");
      sprintf(strsql,"8|%s.%s",row1[3],row1[2]);
      if((nomer_vsp=tab7.find(strsql)) < 0)
       tab7.plus(strsql);
      tab7_osum.plus(suma_nah,nomer_vsp);
      tab7_msum.plus(suma_nah,nomer_vsp);
      tab7_psum.plus(0.,nomer_vsp);
      metka_tabl7=1;
     }

    if(proverka(nastr.ktn9.ravno(),row1[0],0,1) == 0)
     {
      if(ff_prot != NULL)
       fprintf(ff_prot,"Подходит для кода типа начисления 9\n");
      sprintf(strsql,"9|%s.%s",row1[3],row1[2]);
      if((nomer_vsp=tab7.find(strsql)) < 0)
       tab7.plus(strsql);
      tab7_osum.plus(suma_nah,nomer_vsp);
      tab7_msum.plus(suma_nah,nomer_vsp);
      tab7_psum.plus(0.,nomer_vsp);
      metka_tabl7=1;
     }

    if(metka_tabl7 == 0)    
     {
      suma+=suma_nah;
      suma_obh+=suma_nah;
     }
   }

  if(suma > nastr_mz.max_sum_for_soc)
   suma=nastr_mz.max_sum_for_soc;




  sprintf(strsql,"select suma from Zarp where datz >= '%04d-%02d-%02d' and \
datz <= '%04d-%02d-%02d' and tabn=%s and prn='2' and knah=%d and suma <> 0.",
  gr,mr,1,gr,mr,31,row[0],kodpen);

  if(cur1.make_cursor(&bd,strsql) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }
  sumapv=0.;
  while(cur1.read_cursor(&row1) != 0)
   {
    
    sumapv+=atof(row1[0])*-1;   
   }

  if(sumapv == 0.)
   {
    if(ff_prot != NULL)
     fprintf(ff_prot,"Нет пенсионного удержания!\n");
    continue;
   }

  if(ff_prot != NULL)
   fprintf(ff_prot,"Уменьшаем на сумму кода типа начисления 4 %.2f-%.2f=%.2f\n",sumapv,suma_pens_ktn4,sumapv-suma_pens_ktn4);
  sumapv-=suma_pens_ktn4;
  if(sumapv < 0.)
   sumapv=0.;

  if(ff_prot != NULL)
   fprintf(ff_prot,"Сумма пенсионного в 6 таблицу=%.2f\n",sumapv);


  
  fio.new_plus("");
  inn.new_plus("");
  memset(prizv,'\0',sizeof(prizv));
  memset(ima,'\0',sizeof(ima));
  memset(othestvo,'\0',sizeof(othestvo));
    
  metka_otk=1;  
  
  dpnr=dusr=0;
  kodzvna=0;  
  memset(kodss,'\0',sizeof(kodss));
  sprintf(strsql,"select fio,datn,datk,sovm,inn,zvan,kss from Kartb where tabn=%s",row[0]);
  if(readkey(strsql,&row1,&cur1) == 1)
   {
    fio.new_plus(row1[0]);
    inn.new_plus(row1[4]);
    if(atoi(row1[3]) == 1)
     metka_otk=0;
    kodzvna=atoi(row1[5]);

    if(pole3(row1[0],prizv,1,' ') != 0)
     strncpy(prizv,row1[0],sizeof(prizv)-1);

    pole3(row1[0],ima,2,' ');
    pole3(row1[0],othestvo,3,' ');
    strncpy(kodss,row1[6],sizeof(kodss)-1);
    dnr=mnr=gnr=0;
    dkr=mkr=gkr=0;
    rsdat(&dnr,&mnr,&gnr,row1[1],2);
    rsdat(&dkr,&mkr,&gkr,row1[2],2);

    if(sravmydat(1,mnr,gnr,1,mr,gr) == 0)
     dpnr=dnr;
    if(sravmydat(1,mkr,gkr,1,mr,gr) == 0)
     dusr=dkr;

    if(ff_prot != NULL)
     {
      fprintf(ff_prot,"Фамилия-%s\n",fio.ravno()); 
      fprintf(ff_prot,"Дата начала работы:%d.%d.%d\n",dnr,mnr,gnr);
      fprintf(ff_prot,"Дата конца работы:%d.%d.%d\n",dkr,mkr,gkr);

     }    
   }
  else
   {
     if(ff_prot != NULL)
      fprintf(ff_prot,"Не найдена карточка работника %d!\n",atoi(row[0]));
    continue;
   }

  if(proverka(nastr.kodzvna.ravno(),kodzvna,0,0) != 0)
   {
    if(ff_prot != NULL)
     fprintf(ff_prot,"Атестованный - в отчёт не входит!\n");
    continue;
   }

  if(inn.getdlinna() <= 1)
   {
    sprintf(strsql,"%s %s\n%s",row[0],fio.ravno(),gettext("Не введён идентификационный номер"));
    iceb_t_soob(strsql);
   }
  /*здесь сумируем так как может не войти*/
  isuma+=suma;
  isuma_obh+=suma_obh;
  isumapv+=sumapv;

  if(dpnr != 0 || dusr != 0)
   {
    nomer_str_tab5++;

    fprintf(ff_tab5,"%5d|%10s|%-*.*s|%7d|%7d|\n",
    nomer_str_tab5,
    inn.ravno(),
    iceb_tu_kolbait(40,fio.ravno()), 
    iceb_tu_kolbait(40,fio.ravno()), 
    fio.ravno(),
    dpnr,
    dusr);

    fprintf(ff_tab5_xml,"\
    <ROW>\n\
     <ROWNUM>%d</ROWNUM>\n",nomer_str_tab5);

    if(inn.getdlinna() <= 1)
     fprintf(ff_tab5_xml,"\
     <NUMIDENT xsi:nil=\"true\">%s</NUMIDENT>\n",inn.ravno());
    else
     fprintf(ff_tab5_xml,"\
     <NUMIDENT>%s</NUMIDENT>\n",inn.ravno());

    if(prizv[0] != '\0')    
     fprintf(ff_tab5_xml,"\
     <LN>%s</LN>\n",iceb_tu_filtr_xml(prizv));
    else
     fprintf(ff_tab5_xml,"\
     <LN xsi:nil=\"true\"></LN>\n");
    
    if(ima[0] != '\0')
     fprintf(ff_tab5_xml,"\
     <NM>%s</NM>\n",iceb_tu_filtr_xml(ima));
    else
     fprintf(ff_tab5_xml,"\
     <NM xsi:nil=\"true\"></NM>\n");
    
    if(othestvo[0] != '\0')
     fprintf(ff_tab5_xml,"\
     <FTN>%s</FTN>\n",iceb_tu_filtr_xml(othestvo));
    else
     fprintf(ff_tab5_xml,"\
     <FTN xsi:nil=\"true\"></FTN>\n");
    
    fprintf(ff_tab5_xml,"\
     <START_DT>%d</START_DT>\n\
     <END_DT>%d</END_DT>\n\
    </ROW>\n",
    dpnr,
    dusr);      
   }
  int zo=1;
  int zic=1;
  if(zarprtn(mr, gr,atoi(row[0]),"zarinv.alx",NULL) == 1)
   {
    zo=2;
    zic=2;
   }  
  metka_exp=0;
  if(kodss[0] != '\0')
   metka_exp=1;   

  nomer_str_tab6++;  

  fprintf(ff_tab6,"%5d|%10s|%-*.*s|%4d|%4d|%10.2f|%10.2f|%8.2f|%4d|%4d|\n",
  nomer_str_tab6,
  inn.ravno(),
  iceb_tu_kolbait(30,fio.ravno()), 
  iceb_tu_kolbait(30,fio.ravno()), 
  fio.ravno(),
  zo,
  zic,
  suma_obh,suma,sumapv,metka_otk,metka_exp);

  fprintf(ff_tabnom,"%5s|%10s|%-*.*s|%4d|%4d|%10.2f|%10.2f|%8.2f|%4d|%4d|\n",
  row[0],
  inn.ravno(),
  iceb_tu_kolbait(30,fio.ravno()), 
  iceb_tu_kolbait(30,fio.ravno()), 
  fio.ravno(),
  zo,
  zic,
  suma_obh,suma,sumapv,metka_otk,metka_exp);

  fprintf(ff_tab6_dbf," %10d%-10.10s%-251.251s%-251.251s%-251.251s%1d%1d%16.2f%16.2f%16.2f%d%d",
  nomer_str_tab6,
  inn.ravno(),
  prizv,
  ima,
  othestvo,
  zo,
  zic,
  suma_obh,suma,sumapv,metka_otk,metka_exp);
  
    

  fprintf(ff_tab6_xml,"\
    <ROW>\n\
     <ROWNUM>%d</ROWNUM>\n",nomer_str_tab6);

  if(inn.getdlinna() <= 1)
    fprintf(ff_tab6_xml,"\
     <NUMIDENT xsi:nil=\"true\">%s</NUMIDENT>\n",inn.ravno());
  else
    fprintf(ff_tab6_xml,"\
     <NUMIDENT>%s</NUMIDENT>\n",inn.ravno());

  fprintf(ff_tab6_xml,"\
     <ZO>%d</ZO>\n\
     <ZIC>%d</ZIC>\n",
  zo,zic);

  if(prizv[0] != '\0')    
   fprintf(ff_tab6_xml,"\
     <LN>%s</LN>\n",iceb_tu_filtr_xml(prizv));
  else
   fprintf(ff_tab6_xml,"\
     <LN xsi:nil=\"true\"></LN>\n");
  
  if(ima[0] != '\0')
   fprintf(ff_tab6_xml,"\
     <NM>%s</NM>\n",iceb_tu_filtr_xml(ima));
  else
   fprintf(ff_tab6_xml,"\
     <NM xsi:nil=\"true\"></NM>\n");
  
  if(othestvo[0] != '\0')
   fprintf(ff_tab6_xml,"\
     <FTN>%s</FTN>\n",iceb_tu_filtr_xml(othestvo));
  else
   fprintf(ff_tab6_xml,"\
     <FTN xsi:nil=\"true\"></FTN>\n");


  fprintf(ff_tab6_xml,"\
     <SUM_TOTAL>%.2f</SUM_TOTAL>\n\
     <SUM_MAX>%.2f</SUM_MAX>\n\
     <SUM_INS>%.2f</SUM_INS>\n\
     <OTK>%d</OTK>\n\
     <EXP>%d</EXP>\n\
    </ROW>\n",
  suma_obh,
  suma,
  sumapv,
  metka_otk,
  metka_exp);
/*****************************
  fprintf(ff_tab6_xml,"  <NUMIDENT ROWNUM=\"%d\">%s</NUMIDENT>\n",nomer_str_tab6,inn.ravno());
  fprintf(ff_tab6_xml,"  <ZO ROWNUM=\"%d\">1</ZO>\n",nomer_str_tab6);
  fprintf(ff_tab6_xml,"  <ZIC ROWNUM=\"%d\">1</ZIC>\n",nomer_str_tab6);
  fprintf(ff_tab6_xml,"  <LN ROWNUM=\"%d\">%s</LN>\n",nomer_str_tab6,iceb_tu_filtr_xml(prizv));
  fprintf(ff_tab6_xml,"  <NM ROWNUM=\"%d\">%s</NM>\n",nomer_str_tab6,iceb_tu_filtr_xml(ima));
  fprintf(ff_tab6_xml,"  <FTN ROWNUM=\"%d\">%s</FTN>\n",nomer_str_tab6,iceb_tu_filtr_xml(othestvo));


  fprintf(ff_tab6_xml,"  <SUM_TOTAL ROWNUM=\"%d\">%.2f</SUM_TOTAL>\n",nomer_str_tab6,suma_obh);
  fprintf(ff_tab6_xml,"  <SUM_MAX ROWNUM=\"%d\">%.2f</SUM_MAX>\n",nomer_str_tab6,suma);
  fprintf(ff_tab6_xml,"  <SUM_INS ROWNUM=\"%d\">%.2f</SUM_INS>\n",nomer_str_tab6,sumapv);
  fprintf(ff_tab6_xml,"  <OTK ROWNUM=\"%d\">%d</OTK>\n",nomer_str_tab6,metka_otk);
  fprintf(ff_tab6_xml,"  <EXP ROWNUM=\"%d\">%d</EXP>\n",nomer_str_tab6,metka_exp);
********************/


  if(ff_prot != NULL)
    fprintf(ff_prot,"Количество записей для таблицы 7=%d\n",tab7.kolih());
  for(int nomer=0; nomer < tab7.kolih(); nomer++)
   {    

    if(ff_prot != NULL)
      fprintf(ff_prot,"Запись:%s\n",tab7.ravno(nomer));
    
    polen(tab7.ravno(nomer),&kodtipnah,1,'|');
    polen(tab7.ravno(nomer),strsql,sizeof(strsql),2,'|');
    rsdat1(&mv,&gv,strsql);
    nomer_str_tab7++;

//  N  |Ном.обл.к.| Призвище та ініціали         |К.к.|К.т.с.|Місяць |Т.н.|Нараховано|В межах   |Стр.внес|Т.к.|C.с.|\n");
    suma_max=tab7_msum.ravno(nomer);
    if(suma_max > nastr_mz.max_sum_for_soc)
     suma_max=nastr_mz.max_sum_for_soc;
    imsum_tab7+=suma_max;

    fprintf(ff_tab7,"%5d|%10s|%-*.*s|%4d|%4d|%02d.%04d|%4d|%10.2f|%10.2f|%8.2f|%4d|%4d|\n",
    nomer_str_tab7,
    inn.ravno(),
    iceb_tu_kolbait(30,fio.ravno()), 
    iceb_tu_kolbait(30,fio.ravno()), 
    fio.ravno(),
    zo,
    zic,
    mv,gv,
    kodtipnah,
    tab7_osum.ravno(nomer),
    suma_max,
    tab7_psum.ravno(nomer),
    metka_otk,
    metka_exp);

    fprintf(ff_tab7_xml,"\
    <ROW>\n\
     <ROWNUM>%d</ROWNUM>\n",nomer_str_tab7);

    if(inn.getdlinna() <= 1)
      fprintf(ff_tab7_xml,"\
       <NUMIDENT xsi:nil=\"true\">%s</NUMIDENT>\n",inn.ravno());
    else
      fprintf(ff_tab7_xml,"\
     <NUMIDENT>%s</NUMIDENT>\n",inn.ravno());

    fprintf(ff_tab7_xml,"\
     <ZO>%d</ZO>\n\
     <ZIC>%d</ZIC>\n",zo,zic);



    if(prizv[0] != '\0')    
     fprintf(ff_tab7_xml,"\
     <LN>%s</LN>\n",iceb_tu_filtr_xml(prizv));
    else
     fprintf(ff_tab7_xml,"\
     <LN xsi:nil=\"true\"></LN>\n");
    
    if(ima[0] != '\0')
     fprintf(ff_tab7_xml,"\
     <NM>%s</NM>\n",iceb_tu_filtr_xml(ima));
    else
     fprintf(ff_tab7_xml,"\
     <NM xsi:nil=\"true\"></NM>\n");
    
    if(othestvo[0] != '\0')
     fprintf(ff_tab7_xml,"\
     <FTN>%s</FTN>\n",iceb_tu_filtr_xml(othestvo));
    else
     fprintf(ff_tab7_xml,"\
     <FTN xsi:nil=\"true\"></FTN>\n");


    fprintf(ff_tab7_xml,"\
     <PAY_MNTH>%d</PAY_MNTH>\n\
     <PAY_YEAR>%d</PAY_YEAR>\n\
     <PAY_TP>%d</PAY_TP>\n",
    mv,
    gv,
    kodtipnah);


    fprintf(ff_tab7_xml,"\
     <SUM_TOTAL>%.2f</SUM_TOTAL>\n\
     <SUM_MAX>%.2f</SUM_MAX>\n\
     <SUM_INS>%.2f</SUM_INS>\n\
     <OTK>%d</OTK>\n\
     <EXP>%d</EXP>\n\
    </ROW>\n",
    tab7_osum.ravno(nomer),
    tab7_msum.ravno(nomer),
    tab7_psum.ravno(nomer),
    metka_otk,
    metka_exp);
/*****************************
    fprintf(ff_tab7_xml,"  <NUMIDENT ROWNUM=\"%d\">%s</NUMIDENT>\n",nomer_str_tab7,inn.ravno());
    fprintf(ff_tab7_xml,"  <ZO ROWNUM=\"%d\">1</ZO>\n",nomer_str_tab7);
    fprintf(ff_tab7_xml,"  <ZIC ROWNUM=\"%d\">1</ZIC>\n",nomer_str_tab7);
    fprintf(ff_tab7_xml,"  <PAY_MNTN ROWNUM=\"%d\">%d</PAY_MNTN>\n",nomer_str_tab7,mv);
    fprintf(ff_tab7_xml,"  <PAY_YEAR ROWNUM=\"%d\">%d</PAY_YEAR>\n",nomer_str_tab7,gv);
    fprintf(ff_tab7_xml,"  <PAY_TP ROWNUM=\"%d\">%d</PAY_TP>\n",nomer_str_tab7,kodtipnah);
    fprintf(ff_tab7_xml,"  <SUM_TOTAL ROWNUM=\"%d\">%.2f</SUM_TOTAL>\n",nomer_str_tab7,tab7_osum.ravno(nomer));
    fprintf(ff_tab7_xml,"  <SUM_MAX ROWNUM=\"%d\">%.2f</SUM_MAX>\n",nomer_str_tab7,suma_max);
    fprintf(ff_tab7_xml,"  <SUM_INS ROWNUM=\"%d\">%.2f</SUM_INS>\n",nomer_str_tab7,tab7_psum.ravno(nomer));
    fprintf(ff_tab7_xml,"  <OTK ROWNUM=\"%d\">%d</OTK>\n",nomer_str_tab7,metka_otk);
    fprintf(ff_tab7_xml,"  <EXP ROWNUM=\"%d\">%d</EXP>\n",nomer_str_tab7,metka_exp);
******************/     

    fprintf(ff_tab7_dbf," %10d%-10.10s%-251.251s%-251.251s%-251.251s%d%d%02d%04d%d%16.2f%16.2f%16.2f%d%d",
    nomer_str_tab7,inn.ravno(),prizv,ima,othestvo,
    zo,zic,
    mv,gv,kodtipnah,
    tab7_osum.ravno(nomer),
    suma_max,
    tab7_psum.ravno(nomer),
    metka_otk,
    metka_exp);

    
   }
 
  iosum_tab7+=tab7_osum.suma();
  ipsum_tab7+=tab7_psum.suma();

  if(ff_prot != NULL)
   fprintf(ff_prot,"Код спецстажа=%s\n",kodss);
   
  if(kodss[0] != '\0') /*Таблица 8*/
   {
    nomer_str_tab8++;
    fprintf(ff_tab8,"%5d %10s %-30.30s %s \n",
    nomer_str_tab8,inn.ravno(),fio.ravno(),kodss);
    fprintf(ff_tab8_xml,"\
    <ROW>\n\
     <ROWNUM>%d</ROWNUM>\n",nomer_str_tab8);

    if(inn.getdlinna() <= 1)
     fprintf(ff_tab8_xml,"\
     <NUMIDENT xsi:nil=\"true\">%s</NUMIDENT>\n",inn.ravno());
    else
     fprintf(ff_tab8_xml,"\
     <NUMIDENT>%s</NUMIDENT>\n",inn.ravno());



    fprintf(ff_tab8_xml,"\
     <C_PID>%s</C_PID>\n\
     <START_DT>%d</START_DT>\n\
     <STOP_DT>%d</STOP_DT>\n\
     <DAYS>%d</DAYS>\n\
     <NORMZ>%d</NORMZ>\n\
     <HH>%d</HH>\n\
     <MM>%d</MM>\n\
     <NORMA>%d</NORMA>\n\
     <SEASON>%d</SEASON>\n",
     kodss,
     dn,
     dk,
     koldn,
     0,
     0,
     0,
     koldn,
     0);

    if(prizv[0] != '\0')    
     fprintf(ff_tab8_xml,"\
     <LN>%s</LN>\n",iceb_tu_filtr_xml(prizv));
    else
     fprintf(ff_tab8_xml,"\
     <LN xsi:nil=\"true\"></LN>\n");
    
    if(ima[0] != '\0')
     fprintf(ff_tab8_xml,"\
     <NM>%s</NM>\n",iceb_tu_filtr_xml(ima));
    else
     fprintf(ff_tab8_xml,"\
     <NM xsi:nil=\"true\"></NM>\n");
    
    if(othestvo[0] != '\0')
     fprintf(ff_tab8_xml,"\
     <FTN>%s</FTN>\n",iceb_tu_filtr_xml(othestvo));
    else
     fprintf(ff_tab8_xml,"\
     <FTN xsi:nil=\"true\"></FTN>\n");


    fprintf(ff_tab8_xml,"\
    </ROW>\n");
     
   }
    
 }
GDITE();
class iceb_t_fioruk_rk kerivnik;
class iceb_t_fioruk_rk glavbuh;
iceb_t_fioruk(1,&kerivnik);
iceb_t_fioruk(2,&glavbuh);

fprintf(ff_tab5,"\
--------------------------------------------------------------------------\n");
zarpensm_kon_lst(nomer_str_tab5,kerivnik.inn.ravno(),kerivnik.fio.ravno(),glavbuh.inn.ravno(),glavbuh.fio.ravno(),ff_tab5);

fprintf(ff_tab6,"\
---------------------------------------------------------------------------------------------------\n");
fprintf(ff_tab6,"%*s:%10.2f %10.2f %8.2f\n",
iceb_tu_kolbait(57,gettext("Итого")),
gettext("Итого"),
isuma_obh,isuma,isumapv);

fprintf(ff_tab6,"\
*Графа 12 включає суми страхових внесків за відповідний місяць (із заробітку/доходу) 1-5%%, у тому\n\
числі із сум оплаты перших п'яти днів тимчасової непрацездатності, яка здійснюється за счёт коштів\n\
роботодавця, допомогу у зв'язку з тимчасовою непрацездатностю (лікарняні за счёт Фонду соціального\n\
старахування з тимчасової втрати працездатності), заробітку (доходу) за дні відпустки та суми, яка\n\
пов'язана з уточненням кількості відпрацьованого часу з тимчасової непрацездатності.\n");

zarpensm_kon_lst(nomer_str_tab6,kerivnik.inn.ravno(),kerivnik.fio.ravno(),glavbuh.inn.ravno(),glavbuh.fio.ravno(),ff_tab6);

fprintf(ff_tab7,"\
----------------------------------------------------------------------------------------------------------------\n");
fprintf(ff_tab7,"%*s:%10.2f %10.2f %8.2f\n",
iceb_tu_kolbait(70,gettext("Итого")),
gettext("Итого"),
iosum_tab7,
imsum_tab7,
ipsum_tab7);

fprintf(ff_tab7,"\
* код типу нарахувань 1 - нарахована сумма оплаты перших п'яти днів тимчасової непрацездатності (ліканяні за счёт\n\
коштів роботодавця); код типу нарахувать 2 - нарахована сумма допомоги у зв'язку з тимчасовою непрацездатністю\n\
(лікарняні за рахунок Фонду соціального страхування з тимчасової втрати працездатності); код типу нарахувать 3 -\n\
нарахована сумма заробітку (доходу) за дні відпустки; код типу нарахувань 4 - сумма заробітку (доходу), нарахована\n\
на підставі бухгалтерських та інших документів, відповідно до яких провадиться нарахування (обчислення) або які\n\
підтверджують нарахуваня (обчислення) заробітної плати (доходу), грошового забезпечення у попередніх періодах, на\n\
яку страхувальником або органом Пенсійного фонду донараховано страхові внески відповідно до чинного законодавства;\n\
код тиру нарахувань 5 - сумма заробітку (доходу),нарахована на підставі бухгалтерських та інших документів,\n\
відповідно до яких проводиться нарахування (обчислення) або які підтверджують нарахування (обчислення) заробітної\n\
плати (доходу), грошового забезпечення у попередніх періодах, на яку страхуватьником помилково нараховано страхові\n\
внески; код типу нарахувань 6 - суми перерахунків заробітку (доходу), пов'язані з уточненням кількості\n\
відпрацьованого часу з тимчасової непрацездатності.\n\
** Графа 14 не заповнюэться для кодыв типу нарахувань 1,2,3,6\n\n");

zarpensm_kon_lst(nomer_str_tab7,kerivnik.inn.ravno(),kerivnik.fio.ravno(),glavbuh.inn.ravno(),glavbuh.fio.ravno(),ff_tab7);

fprintf(ff_tab5_xml,"\
   </TABLE>\n\
   <FOOTER>\n\
    <ROWS>%d</ROWS>\n\
    <BOSS_NUMIDENT>%s</BOSS_NUMIDENT>\n\
    <FIRM_BOSS>%s %s</FIRM_BOSS>\n",
nomer_str_tab5,
kerivnik.inn.ravno(),
iceb_tu_filtr_xml(kerivnik.famil.ravno()),
kerivnik.inic);

fprintf(ff_tab5_xml,"\
    <BUH_NUMIDENT>%s</BUH_NUMIDENT>\n\
    <FIRM_BUH>%s %s</FIRM_BUH>\n\
   </FOOTER>\n\
  </PAGE>\n\
 </DECLARBODY>\n\
</DECLAR>\n",
glavbuh.inn.ravno(),
iceb_tu_filtr_xml(glavbuh.famil.ravno()),
glavbuh.inic);
    


fprintf(ff_tab6_xml,"\
   </TABLE>\n\
   <FOOTER>\n\
    <PAGE_SUM_TOTAL>%.2f</PAGE_SUM_TOTAL>\n\
    <PAGE_SUM_MAX>%.2f</PAGE_SUM_MAX>\n\
    <PAGE_SUM_INS>%.2f</PAGE_SUM_INS>\n\
    <ROWS>%d</ROWS>\n\
    <BOSS_NUMIDENT>%s</BOSS_NUMIDENT>\n\
    <FIRM_BOSS>%s %s</FIRM_BOSS>\n",
isuma_obh,
isuma,
isumapv,
nomer_str_tab6,
kerivnik.inn.ravno(),
iceb_tu_filtr_xml(kerivnik.famil.ravno()),
kerivnik.inic);

fprintf(ff_tab6_xml,"\
    <BUH_NUMIDENT>%s</BUH_NUMIDENT>\n\
    <FIRM_BUH>%s %s</FIRM_BUH>\n\
   </FOOTER>\n\
  </PAGE>\n\
 </DECLARBODY>\n\
</DECLAR>\n",
glavbuh.inn.ravno(),
iceb_tu_filtr_xml(glavbuh.famil.ravno()),
glavbuh.inic);
/*******************************

fprintf(ff_tab6_xml,"  <PAGE_SUM_TOTAL>%.2f</PAGE_SUM_TOTAL>\n",isuma_obh);
fprintf(ff_tab6_xml,"  <PAGE_SUM_MAX>%.2f</PAGE_SUM_MAX>\n",isuma);
fprintf(ff_tab6_xml,"  <PAGE_SUM_INS>%.2f</PAGE_SUM_INS>\n",isumapv);
fprintf(ff_tab6_xml,"  <ROWS>%d</ROWS>\n",nomer_str_tab6);
fprintf(ff_tab6_xml,"  <BOSS_NUMIDENT>%s</BOSS_NUMIDENT>\n",kerivnik.inn.ravno());
fprintf(ff_tab6_xml,"  <FIRM_BOSS>%s %s</FIRM_BOSS>\n",iceb_tu_filtr_xml(kerivnik.famil.ravno()),kerivnik.inic);
fprintf(ff_tab6_xml,"  <BUH_NUMIDENT>%s</BUH_NUMIDENT>\n",glavbuh.inn.ravno());
fprintf(ff_tab6_xml,"  <FIRM_BUH>%s %s</FIRM_BUH>\n",iceb_tu_filtr_xml(glavbuh.famil.ravno()),glavbuh.inic);
fprintf(ff_tab6_xml," </DECLARBODY>\n");
fprintf(ff_tab6_xml,"</DECLAR>\n");

*************************/
fprintf(ff_tab7_xml,"\
   </TABLE>\n\
   <FOOTER>\n\
    <PAGE_SUM_TOTAL>%.2f</PAGE_SUM_TOTAL>\n\
    <PAGE_SUM_MAX>%.2f</PAGE_SUM_MAX>\n\
    <PAGE_SUM_INS>%.2f</PAGE_SUM_INS>\n\
    <ROWS>%d</ROWS>\n\
    <BOSS_NUMIDENT>%s</BOSS_NUMIDENT>\n\
    <FIRM_BOSS>%s %s</FIRM_BOSS>\n",
tab7_osum.suma(),
tab7_msum.suma(),
tab7_psum.suma(),
nomer_str_tab7,
kerivnik.inn.ravno(),
iceb_tu_filtr_xml(kerivnik.famil.ravno()),
kerivnik.inic);

fprintf(ff_tab7_xml,"\
    <BUH_NUMIDENT>%s</BUH_NUMIDENT>\n\
    <FIRM_BUH>%s %s</FIRM_BUH>\n\
   </FOOTER>\n\
  </PAGE>\n\
 </DECLARBODY>\n\
</DECLAR>\n",
glavbuh.inn.ravno(),
iceb_tu_filtr_xml(glavbuh.famil.ravno()),
glavbuh.inic);

/******************************
fprintf(ff_tab7_xml,"  <PAGE_SUM_TOTAL>%.2f</PAGE_SUM_TOTAL>\n",tab7_osum.suma());
fprintf(ff_tab7_xml,"  <PAGE_SUM_MAX>%.2f</PAGE_SUM_MAX>\n",tab7_msum.suma());
fprintf(ff_tab7_xml,"  <PAGE_SUM_INS>%.2f</PAGE_SUM_INS>\n",tab7_psum.suma());
fprintf(ff_tab7_xml,"  <ROWS>%d</ROWS>\n",nomer_str_tab7);
fprintf(ff_tab7_xml,"  <BOSS_NUMIDENT>%s</BOSS_NUMIDENT>\n",kerivnik.inn.ravno());
fprintf(ff_tab7_xml,"  <FIRM_BOSS>%s %s</FIRM_BOSS>\n",iceb_tu_filtr_xml(kerivnik.famil.ravno()),kerivnik.inic);
fprintf(ff_tab7_xml,"  <BUH_NUMIDENT>%s</BUH_NUMIDENT>\n",glavbuh.inn.ravno());
fprintf(ff_tab7_xml,"  <FIRM_BUH>%s %s</FIRM_BUH>\n",iceb_tu_filtr_xml(glavbuh.famil.ravno()),glavbuh.inic);
fprintf(ff_tab7_xml," </DECLARBODY>\n");
fprintf(ff_tab7_xml,"</DECLAR>\n");
*********************/
fprintf(ff_tab8_xml,"\
    <ROWS>%d</ROWS>\n\
   </TABLE>\n\
   <FOOTER>\n\
    <BOSS_NUMIDENT>%s</BOSS_NUMIDENT>\n\
    <FIRM_BOSS>%s %s</FIRM_BOSS>\n",
nomer_str_tab8,
kerivnik.inn.ravno(),
iceb_tu_filtr_xml(kerivnik.famil.ravno()),
kerivnik.inic);

fprintf(ff_tab8_xml,"\
    <BUH_NUMIDENT>%s</BUH_NUMIDENT>\n\
    <FIRM_BUH>%s %s</FIRM_BUH>\n\
   </FOOTER>\n\
  </PAGE>\n\
 </DECLARBODY>\n\
</DECLAR>\n",
glavbuh.inn.ravno(),
iceb_tu_filtr_xml(glavbuh.famil.ravno()),
glavbuh.inic);

podpis(ff_tab5);
podpis(ff_tab6);
podpis(ff_tab7);
podpis(ff_tab8);
podpis(ff_tabnom);

fclose(ff_tab5);
fclose(ff_tabnom);
fclose(ff_tab6);
fclose(ff_tab7);
fclose(ff_tab8);
fclose(ff_tab5_xml);
fclose(ff_tab6_xml);
fclose(ff_tab7_xml);
fclose(ff_tab8_xml);

if(ff_prot != NULL)
 fclose(ff_prot);

fputc(26, ff_tab5_dbf);
fclose(ff_tab5_dbf);
fputc(26, ff_tab6_dbf);
fclose(ff_tab6_dbf);
fputc(26, ff_tab7_dbf);
fclose(ff_tab7_dbf);


perecod(1,imaf_tab5_dbf_tmp);
perecod(1,imaf_tab6_dbf_tmp);
perecod(1,imaf_tab7_dbf_tmp);

zarpensm_tab5_dbf(imaf_tab5_dbf,nomer_str_tab5);
zarpensm_tab6_dbf(imaf_tab6_dbf,nomer_str_tab6);
zarpensm_tab7_dbf(imaf_tab7_dbf,nomer_str_tab7);

/*Сливаем два файла*/
iceb_t_cat(imaf_tab5_dbf,imaf_tab5_dbf_tmp);
iceb_t_cat(imaf_tab6_dbf,imaf_tab6_dbf_tmp);
iceb_t_cat(imaf_tab7_dbf,imaf_tab7_dbf_tmp);

unlink(imaf_tab5_dbf_tmp);
unlink(imaf_tab6_dbf_tmp);
unlink(imaf_tab7_dbf_tmp);


time_t vrem;
time(&vrem);
struct tm *bf;
bf=localtime(&vrem);

char kodedrp[16];
memset(kodedrp,'\0',sizeof(kodedrp));
strncpy(kodedrp,inn_or.ravno(),10);
for(int nom=0; nom < 10; nom++)
 if(kodedrp[nom] == '\0')
  kodedrp[nom]='Z';
char datadok[16];
sprintf(datadok,"%02d%02d%04d",bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900);
char vremdok[16];
sprintf(vremdok,"%02d%02d%02d",bf->tm_hour,bf->tm_min,bf->tm_sec);

char kodfil[8];
memset(kodfil,'\0',sizeof(kodfil));
strncpy(kodfil,nastr.kodfil.ravno(),5);
for(int nom=0; nom < 5; nom++)
 if(kodfil[nom] == '\0')
  kodfil[nom]='Z';

sprintf(imaf_pfz,"%05d%10.10s%5.5s%8s%6sP04A0.pfz",
nastr.kodpfu.ravno_atoi(),kodedrp,kodfil,datadok,vremdok);

char imaf_tmp[56];
sprintf(imaf_tmp,"zarpensm%d.tmp",getpid());
if(nomer_str_tab5 > 0)
 {
  iceb_t_cp(imaf_tab5_xml,imaf_tmp,0);
  perecod(2,imaf_tab5_xml);
  inn.new_plus("zip");
  inn.plus(" ",imaf_pfz);
  inn.plus(" ",imaf_tab5_xml);
  iceb_t_system(inn.ravno(),0);
  rename(imaf_tmp,imaf_tab5_xml);
  
 }
if(nomer_str_tab6 > 0)
 {
  iceb_t_cp(imaf_tab6_xml,imaf_tmp,0);
  perecod(2,imaf_tab6_xml);
  inn.new_plus("zip");
  inn.plus(" ",imaf_pfz);
  inn.plus(" ",imaf_tab6_xml);
  iceb_t_system(inn.ravno(),0);
  rename(imaf_tmp,imaf_tab6_xml);
 }
if(nomer_str_tab7 > 0)
 {
  iceb_t_cp(imaf_tab7_xml,imaf_tmp,0);
  perecod(2,imaf_tab7_xml);
  inn.new_plus("zip");
  inn.plus(" ",imaf_pfz);
  inn.plus(" ",imaf_tab7_xml);
  iceb_t_system(inn.ravno(),0);
  rename(imaf_tmp,imaf_tab7_xml);
 }
if(nomer_str_tab8 > 0)
 {
  iceb_t_cp(imaf_tab8_xml,imaf_tmp,0);
  perecod(2,imaf_tab8_xml);
  inn.new_plus("zip");
  inn.plus(" ",imaf_pfz);
  inn.plus(" ",imaf_tab8_xml);
  iceb_t_system(inn.ravno(),0);
  rename(imaf_tmp,imaf_tab8_xml);
 }

 
oth->spis_imaf.plus(imaf_tab5);
oth->spis_naim.plus("Таблиця 5");

oth->spis_imaf.plus(imaf_tab6);
oth->spis_naim.plus("Таблиця 6");

oth->spis_imaf.plus(imaf_tab7);
oth->spis_naim.plus("Таблиця 7");

oth->spis_imaf.plus(imaf_tabnom);
oth->spis_naim.plus("Отчёт с табельными номерами");

oth->spis_imaf.plus(imaf_tab8);
oth->spis_naim.plus("Таблиця 8");

if(ff_prot != NULL)
 {
  oth->spis_imaf.plus(imaf_prot);
  oth->spis_naim.plus("Протокол хода расчёта");
 }

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),1);

oth->spis_imaf.plus(imaf_tab5_xml);
oth->spis_naim.plus("Таблиця 5 в форматі xml");

oth->spis_imaf.plus(imaf_tab6_xml);
oth->spis_naim.plus("Таблиця 6 в форматі xml");


oth->spis_imaf.plus(imaf_tab7_xml);
oth->spis_naim.plus("Таблиця 7 в форматі xml");

oth->spis_imaf.plus(imaf_tab8_xml);
oth->spis_naim.plus("Таблиця 8 в форматі xml");

oth->spis_imaf.plus(imaf_tab5_dbf);
oth->spis_naim.plus("Таблиця 5 в форматі dbf");

oth->spis_imaf.plus(imaf_tab6_dbf);
oth->spis_naim.plus("Таблиця 6 в форматі dbf");

oth->spis_imaf.plus(imaf_tab7_dbf);
oth->spis_naim.plus("Таблиця 7 в форматі dbf");

oth->spis_imaf.plus(imaf_pfz);
oth->spis_naim.plus("Архив файлов xml");

return(0);

}
/********************************/
/*Чтение настроек*/
/********************************/
int zarpensm_read_nast(class zarpensm_nastr *nastr)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];
class iceb_tu_str naim("");

sprintf(strsql,"select str from Alx where fil='zarpensm.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"zarpensm.alx");
  iceb_t_soob(strsql);
  return(1);
 }


while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  if(polen(row_alx[0],&naim,1,'|') != 0)
   continue;  
  if(SRAV("Код отделения пенсионного фонда Украины",naim.ravno(),0) == 0)
   {
    polen(row_alx[0],&nastr->kodpfu,2,'|');
    continue;
   }
  if(SRAV("Код филиала пенсионного фонда",naim.ravno(),0) == 0)
   {
    polen(row_alx[0],&nastr->kodfil,2,'|');
    continue;
   }
  if(SRAV("Коды начислений для кода типа начисления 1",naim.ravno(),0) == 0)
   {
    polen(row_alx[0],&nastr->ktn1,2,'|');
    continue;
   }
  if(SRAV("Коды начислений для кода типа начисления 2",naim.ravno(),0) == 0)
   {
    polen(row_alx[0],&nastr->ktn2,2,'|');
    continue;
   }
  if(SRAV("Коды начислений для кода типа начисления 3",naim.ravno(),0) == 0)
   {
    polen(row_alx[0],&nastr->ktn3,2,'|');
    continue;
   }
  if(SRAV("Коды начислений для кода типа начисления 4",naim.ravno(),0) == 0)
   {
    polen(row_alx[0],&nastr->ktn4,2,'|');
    continue;
   }
  if(SRAV("Коды начислений для кода типа начисления 5",naim.ravno(),0) == 0)
   {
    polen(row_alx[0],&nastr->ktn5,2,'|');
    continue;
   }
  if(SRAV("Коды начислений для кода типа начисления 6",naim.ravno(),0) == 0)
   {
    polen(row_alx[0],&nastr->ktn6,2,'|');
    continue;
   }
  if(SRAV("Коды начислений для кода типа начисления 7",naim.ravno(),0) == 0)
   {
    polen(row_alx[0],&nastr->ktn7,2,'|');
    continue;
   }
  if(SRAV("Коды начислений для кода типа начисления 8",naim.ravno(),0) == 0)
   {
    polen(row_alx[0],&nastr->ktn8,2,'|');
    continue;
   }
  if(SRAV("Коды начислений для кода типа начисления 9",naim.ravno(),0) == 0)
   {
    polen(row_alx[0],&nastr->ktn9,2,'|');
    continue;
   }
  if(SRAV("Коды звания неатестованых",naim.ravno(),0) == 0)
   {
    polen(row_alx[0],&nastr->kodzvna,2,'|');
    continue;
   }
 }
return(0);
}
/**************************************/
void zarpensm_xml_sap(short mr,short gr,
const char *kodpfu,
const char *imaf,
const char *c_doc_sub,
FILE *ff_xml)
{
class iceb_tu_str naim_or("");
short dt,mt,gt;
class iceb_tu_str inn("");
poltekdat(&dt,&mt,&gt);
SQL_str row;
class SQLCURSOR cur;

if(readkey("select naikon,kod from Kontragent where kodkon='00'",&row,&cur) == 1)
 {
  inn.new_plus(row[1]);
  naim_or.new_plus(row[0]);
 } 

fprintf(ff_xml,"\
<?xml version=\"1.0\" encoding=\"windows-1251\" ?>\n\
<DECLAR xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:noNamespaceSchemaLocation=\"%s.xsd\">\n",imaf);

fprintf(ff_xml,"\
 <DECLARHEAD>\n\
  <VER>1.1</VER>\n\
  <C_DOC>P04</C_DOC>\n\
  <C_DOC_SUB>%s</C_DOC_SUB>\n\
  <C_DOC_VER>%s</C_DOC_VER>\n",
  c_doc_sub,version_dok);

if(kodpfu[0] != '\0')  
 fprintf(ff_xml,"  <C_PFU>%s</C_PFU>\n",kodpfu);
else
 fprintf(ff_xml,"  <C_PFU/>\n");

fprintf(ff_xml,"\
  <SOFTWARE>iceB %s</SOFTWARE>\n\
  <TIN>%s</TIN>\n\
  <PERIOD_MONTH>%d</PERIOD_MONTH>\n\
  <PERIOD_YEAR>%d</PERIOD_YEAR>\n\
  <DATA_FILL>%02d%02d%d</DATA_FILL>\n\
 </DECLARHEAD>\n",
VERSION,inn.ravno(),mr,gr,dt,mt,gt);

fprintf(ff_xml,"\
 <DECLARBODY>\n\
  <PAGE>\n\
   <HEADER>\n\
    <FIRM_EDRPOU>%s</FIRM_EDRPOU>\n\
    <FIRM_FIL></FIRM_FIL>\n\
    <FORM_TYPE>1</FORM_TYPE>\n\
    <FIRM_NAME>%s</FIRM_NAME>\n\
    <PAGE_NUM>1</PAGE_NUM>\n\
   </HEADER>\n\
   <TABLE>\n",
inn.ravno(),iceb_tu_filtr_xml(naim_or.ravno()));
/************
fprintf(ff_xml,"\
 <DECLARBODY>\n\
  <FIRM_EDRPOU>%s</FIRM_EDRPOU>\n\
  <FORM_TYPE>1</FORM_TYPE>\n\
  <FIRM_NAME>%s</FIRM_NAME>\n",
inn.ravno(),iceb_tu_filtr_xml(naim_or.ravno()));
*************/
}
/************************************/
/*концовка распечатки*/
/*************************************/

void zarpensm_kon_lst(int kolstr,
const char *inn_ker,
const char *fio_ker,
const char *inn_gb,
const char *fio_gb,
FILE *ff)
{
short dt,mt,gt;
poltekdat(&dt,&mt,&gt);

fprintf(ff,"\
Кількість заповнених рядків %d\n\
Дата формування звіту у страхувальника %d.%d.%d \n\n\
Керівник           %-10s _______________ %s\n\n\
M.П.\n\n\
Головний бухгалтер %-10s ________________ %s\n",
kolstr,
dt,mt,gt,
inn_ker,
fio_ker,
inn_gb,
fio_gb); 


}
/******************************/
/*Создаем заголовок файла dbf*/
/******************************/
void zarpensm_f(DBASE_FIELD *f,const char *fn,char  ft,int l1,int l2,
int *header_len,int *rec_len)
{

strncpy(f->name, fn, 11);
f->type = ft;
f->length = l1;
f->dec_point = l2;
*header_len=*header_len+sizeof(DBASE_FIELD);
*rec_len=*rec_len+l1;
}

/***********************************************/
void zarpensm_tab5_dbf(const char *imaf,int kolz)
{
time_t		tmm;
struct  tm      *bf;
FILE		*ff;
DBASE_HEAD  h;
int fd;
int i;
int header_len, rec_len;
const int kolpol=7;
DBASE_FIELD f[kolpol];
memset(&f, '\0', sizeof(f));

if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }

memset(&h,'\0',sizeof(h));

h.version = 3;

time(&tmm);
bf=localtime(&tmm);

h.l_update[0] = bf->tm_year;       /* yymmdd for last update*/
h.l_update[1] = bf->tm_mon+1;       /* yymmdd for last update*/
h.l_update[2] = bf->tm_mday;       /* yymmdd for last update*/

h.count = kolz;              /* number of records in file*/

header_len = sizeof(h);
rec_len = 0;
int shetshik=0;
zarpensm_f(&f[shetshik++],"ROWNUM", 'N', 10, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"NUMIDENT", 'C', 10, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"LN", 'C',100, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"NM", 'C',100, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"FTN", 'C',100, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"START_DT", 'N',2, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"END_DT", 'N', 2, 0,&header_len,&rec_len);


h.header = header_len + 1;/* length of the header
                           * includes the \r at end
                           */
h.lrecl= rec_len + 1;     /* length of a record
                           * includes the delete
                           * byte
                          */
/*
 printw("h.header=%d h.lrecl=%d\n",h.header,h.lrecl);
*/


fd = fileno(ff);

write(fd, &h, sizeof(h));
for(i=0; i < kolpol; i++) 
 {
  write(fd, &f[i], sizeof(DBASE_FIELD));
 }
fputc('\r', ff);

fclose(ff);

}

/***********************************************/
void zarpensm_tab6_dbf(const char *imaf,int kolz)
{
time_t		tmm;
struct  tm      *bf;
FILE		*ff;
DBASE_HEAD  h;
int fd;
int i;
int header_len, rec_len;
const int kolpol=12;
DBASE_FIELD f[kolpol];
memset(&f, '\0', sizeof(f));

if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }

memset(&h,'\0',sizeof(h));

h.version = 3;

time(&tmm);
bf=localtime(&tmm);

h.l_update[0] = bf->tm_year;       /* yymmdd for last update*/
h.l_update[1] = bf->tm_mon+1;       /* yymmdd for last update*/
h.l_update[2] = bf->tm_mday;       /* yymmdd for last update*/

h.count = kolz;              /* number of records in file*/

header_len = sizeof(h);
rec_len = 0;
int shetshik=0;
zarpensm_f(&f[shetshik++],"ROWNUM", 'N', 10, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"NUMIDENT", 'C', 10, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"LN", 'C',251, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"NM", 'C',251, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"FTN", 'C',251, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"ZO", 'N',2, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"ZIC", 'N', 2, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"SUM_TOTAL", 'N',16, 2,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"SUM_MAX", 'N', 16, 2,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"SUM_INS", 'N', 16, 2, &header_len,&rec_len);
zarpensm_f(&f[shetshik++],"OTK", 'N', 1, 0, &header_len,&rec_len);
zarpensm_f(&f[shetshik++],"EXP", 'N', 1, 0, &header_len,&rec_len);


h.header = header_len + 1;/* length of the header
                           * includes the \r at end
                           */
h.lrecl= rec_len + 1;     /* length of a record
                           * includes the delete
                           * byte
                          */
/*
 printw("h.header=%d h.lrecl=%d\n",h.header,h.lrecl);
*/


fd = fileno(ff);

write(fd, &h, sizeof(h));
for(i=0; i < kolpol; i++) 
 {
  write(fd, &f[i], sizeof(DBASE_FIELD));
 }
fputc('\r', ff);

fclose(ff);

}

/***********************************************/
void zarpensm_tab7_dbf(const char *imaf,int kolz)
{
time_t		tmm;
struct  tm      *bf;
FILE		*ff;
DBASE_HEAD  h;
int fd;
int i;
int header_len, rec_len;
const int kolpol=15;
DBASE_FIELD f[kolpol];
memset(&f, '\0', sizeof(f));

if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }

memset(&h,'\0',sizeof(h));

h.version = 3;

time(&tmm);
bf=localtime(&tmm);

h.l_update[0] = bf->tm_year;       /* yymmdd for last update*/
h.l_update[1] = bf->tm_mon+1;       /* yymmdd for last update*/
h.l_update[2] = bf->tm_mday;       /* yymmdd for last update*/

h.count = kolz;              /* number of records in file*/

header_len = sizeof(h);
rec_len = 0;
int shetshik=0;
zarpensm_f(&f[shetshik++],"ROWNUM", 'N', 10, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"NUMIDENT", 'C', 10, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"LN", 'C',251, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"NM", 'C',251, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"FTN", 'C',251, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"ZO", 'N',2, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"ZIC", 'N', 2, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"PAY_MNTH", 'N',2, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"PAY_YEAR", 'N',4, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"PAY_TP", 'N',1, 0,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"SUM_TOTAL", 'N',16, 2,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"SUM_MAX", 'N', 16, 2,&header_len,&rec_len);
zarpensm_f(&f[shetshik++],"SUM_INS", 'N', 16, 2, &header_len,&rec_len);
zarpensm_f(&f[shetshik++],"OTK", 'N', 1, 0, &header_len,&rec_len);
zarpensm_f(&f[shetshik++],"EXP", 'N', 1, 0, &header_len,&rec_len);


h.header = header_len + 1;/* length of the header
                           * includes the \r at end
                           */
h.lrecl= rec_len + 1;     /* length of a record
                           * includes the delete
                           * byte
                          */
/*
 printw("h.header=%d h.lrecl=%d\n",h.header,h.lrecl);
*/


fd = fileno(ff);

write(fd, &h, sizeof(h));
for(i=0; i < kolpol; i++) 
 {
  write(fd, &f[i], sizeof(DBASE_FIELD));
 }
fputc('\r', ff);

fclose(ff);

}
