/*$Id: zarrnesvp.c,v 5.2 2011-05-06 08:29:23 sasa Exp $*/
/*28.04.2011	08.04.2011	Белых А.И.	zarrnesvp.c
Чтение процентов для расчёта удержаний с работника
*/
#include "buhg.h"


extern int kodf_esv; /*Код фонда удержания единого социального взноса*/
extern int kodf_esv_bol; /*Код фонда удержания единого социального взноса*/
extern int kodf_esv_inv; /*Код фонда удержания единого социального взноса*/
extern int kodf_esv_dog; /*Код фонда удержания единого социального взноса*/
extern int kodf_esv_vs;

void zarrnesvp(short mr,short gr,class zarrnesvp_rek *all_proc,FILE *ff_prot)
{
char strsql[512];
SQL_str row;
class SQLCURSOR cur;

/*читаем процент*/
sprintf(strsql,"select pr1 from Zaresv where kf=%d and datnd <='%04d-%02d-01' order by datnd desc limit 1",kodf_esv,gr,mr);
if(readkey(strsql,&row,&cur) != 1)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Не найден процент удержания единого социального взноса!\n\%s\n",strsql);
 }
else
  all_proc->proc_esv=atof(row[0]);

sprintf(strsql,"select pr1 from Zaresv where kf=%d and datnd <='%04d-%02d-01' order by datnd desc limit 1",kodf_esv_bol,gr,mr);
if(readkey(strsql,&row,&cur) != 1)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Не найден процент удержания единого социального взноса для больничного!\n\%s\n",strsql);
 }
else
   all_proc->proc_esv_bol=atof(row[0]);


sprintf(strsql,"select pr1 from Zaresv where kf=%d and datnd <='%04d-%02d-01' order by datnd desc limit 1",kodf_esv_inv,gr,mr);
if(readkey(strsql,&row,&cur) != 1)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Не найден процент удержания единого социального взноса для инвалидов!\n\%s\n",strsql);
 }
else
   all_proc->proc_esv_inv=atof(row[0]);

sprintf(strsql,"select pr1 from Zaresv where kf=%d and datnd <='%04d-%02d-01' order by datnd desc limit 1",kodf_esv_dog,gr,mr);
if(readkey(strsql,&row,&cur) != 1)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Не найден процент удержания единого социального взноса для договоров!\n\%s\n",strsql);
 }
else
   all_proc->proc_esv_dog=atof(row[0]);

sprintf(strsql,"select pr1 from Zaresv where kf=%d and datnd <='%04d-%02d-01' order by datnd desc limit 1",kodf_esv_vs,gr,mr);
if(readkey(strsql,&row,&cur) != 1)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Не найден процент удержания единого социального взноса для военных!\n\%s\n",strsql);
 }
else
   all_proc->proc_esv_vs=atof(row[0]);

if(ff_prot != NULL)
 fprintf(ff_prot,"%s-Прочитали настройки\n\
Процент удержания единого социального взноса:%.2f\n\
Процент удержания единого социального взноса для больничного:%.2f\n\
Процент удержания единого социального взноса для инвалидов:%.2f\n\
Процент удержания единого социального взноса для договоров:%.2f\n\
Процент удержания единого социального взноса для военных:%.2f\n",
  __FUNCTION__,
  all_proc->proc_esv,
  all_proc->proc_esv_bol,
  all_proc->proc_esv_inv,
  all_proc->proc_esv_dog,
  all_proc->proc_esv_vs);

}
