/*$Id: zarsdf1df.c,v 5.22 2011-04-01 07:51:48 sasa Exp $*/
/*27.02.2009	01.04.2004	Белых А.И.	zarsdf1df.c
Чтение списка кодов признаков доходов с кодами начислений которые к ним относятся.
*/
#include <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif
#include "sprkvrt1.h"


void zarsdf1df(class sprkvrt1_nast *nast)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];

//char stroka[1024];
char bros[1024];
char kodd[1024];

sprintf(strsql,"select str from Alx where fil='zarsdf1df.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"zarsdf1df.alx");
  iceb_t_soob(strsql);
  return;
 }


while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  memset(kodd,'\0',sizeof(kodd));
  if(polen(row_alx[0],kodd,sizeof(kodd),1,'|') != 0)
   continue;
  
  if(SRAV(kodd,"Коды не входящие в форму 1ДФ",0) == 0)
   {
    sozmas(&nast->kodnvf8dr,row_alx[0]);
    continue;
   }
  if(SRAV(kodd,"Коды удержаний не входящие в форму 1ДФ",0) == 0)
   {
    sozmas(&nast->kodud,row_alx[0]);
    continue;
   }

  if(SRAV("Счета для поиска доходов по коду",kodd,1) == 0)
   {
  
    polen(row_alx[0],bros,sizeof(bros),2,'|');
    if(bros[0] == '\0')
     continue;

    iceb_t_fplus(1,bros,&nast->sheta,&cur_alx);
     
    polen(row_alx[0],bros,sizeof(bros),7,' ');
    nast->kodi_pd_prov.plus(atoi(bros),-1);

    continue;
   }
  if(SRAV("Физическое лицо",kodd,0) == 0)
   {
    polen(row_alx[0],bros,sizeof(bros),2,'|');
    if(SRAV(bros,"Вкл",1) == 0)
     {
      nast->TYP=1;
     }
    continue;
   }

  if(atoi(kodd) == 0)
   continue;

  if(atoi(kodd) == 133)
   {
    polen(row_alx[0],bros,sizeof(bros),2,'|');
    strncpy(nast->gosstrah,bros,sizeof(nast->gosstrah));
    continue;
   }   

  nast->kodi_pd.plus(atoi(kodd),-1);
  polen(row_alx[0],kodd,sizeof(kodd),2,'|');
  nast->kodi_nah.plus(kodd);    

 }

}
