/* $Id: zarspi.c,v 5.34 2011-03-09 08:16:56 sasa Exp $ */
/*15.12.2009    11.11.1993      Белых А.И.      zarspi.c
Подпрограмма получения ведомости на зарплату
на основании произвольного списка записанного
в файл
*/
#include        <time.h>
#include        <errno.h>
#include        "buhg.h"

extern short    mmm,ggg;
extern char     *organ;/*Наименование организации*/
extern char     shrpz[16];

int zarspi(class spis_oth *oth)
{
struct  tm      *bf;
time_t          tmm;
FILE            *kaw,*kaw1;
char            imaf1[24];
char            str[1024];
char		naimp[512];
char            bros[512];
long            tabn;
double          itogo;
double          it,in,iu,ius;
int           kom,kom1;
short           mkvk; /*0 не выдано кассой 1-выдано кассой*/
short           uhsl; /*Учет сальдо в распечатке ведомости на зарплату 0-включено 1-выключено*/
double		sal;
long		kolstr;
SQL_str         row,row1;
char		strsql[512];
char		fio[512];
short		d,m,g;
short		mz,gz;
short		prn;
int		knah;
double		sym;
static char	dat1[11];
static char	nahis[112];
static char     imaf[24];
short		mn,gn;
double		sumabu;
double		saldb;

VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка зарплаты по произвольному списку."));

VV.VVOD_SPISOK_add_MD(gettext("Дата расчета...(м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Имя файла со списком.."));
VV.VVOD_SPISOK_add_MD(gettext("Код начисления (,,)..."));

VV.VVOD_SPISOK_add_data(8);
VV.VVOD_SPISOK_add_data(20);
VV.VVOD_SPISOK_add_data(50);


if(dat1[0] == '\0')
 { 
  sprintf(strsql,"%d.%d",mmm,ggg);
  VV.data_plus(0,strsql);
 }
else 
 VV.data_plus(0,dat1);

VV.data_plus(1,imaf);
VV.data_plus(2,nahis);

naz:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);


strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(imaf,VV.VVOD_SPISOK_return_data(1),sizeof(imaf)-1);
strncpy(nahis,VV.VVOD_SPISOK_return_data(2),sizeof(nahis)-1);

switch(kom)
 {
  case FK10:
  case ESC:
   return(1);

  case FK1:
    GDITE();
    iceb_t_pdoc("zarp4_1_2.txt");
    goto naz;

  case FK2:
  case PLU:
   break;

  case FK3:

    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка начислений."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр файла со списком для расчета."));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 2 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Nash",nahis,sizeof(nahis),naimp);
        VV.VVOD_SPISOK_zapis_data(2,nahis);
        goto naz;

      case 1 :
        GDITE();
        if(imaf[0] == '\0')
         {
          VVOD SOOB(1);
          SOOB.VVOD_SPISOK_add_MD(gettext("Не задано имя файла со списком !"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto naz;

         }        
        vizred(imaf);        
        goto naz;

     }

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
    goto naz;
 }

if(rsdat1(&mn,&gn,VV.VVOD_SPISOK_return_data(0)) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(imaf[0] == '\0')
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не задано имя файла со списком !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
 

if((kaw = fopen(imaf,"r")) == NULL)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s %d !",gettext("Ошибка открытия файла"),imaf,errno);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
clear();
GDITE();
bros[0]='\0';
uhsl=0;
if(iceb_t_poldan("Учет сальдо в распечатке",bros,"zarnast.alx") == 0)
 if(SRAV(bros,"Вык",1) == 0)
   uhsl=1;

if(POLE(imaf,bros,1,'.') == 0)
  sprintf(imaf1,"%s.lst",bros);
else
  sprintf(imaf1,"%s.lst",imaf);

if((kaw1 = fopen(imaf1,"w")) == NULL)
   {
    error_op_nfil(imaf1,errno,"");
    return(1);
   }

mesc(mn,0,bros);
time(&tmm);
bf=localtime(&tmm);



int kol=0;
if(zarstfn53("",mn,gn,shrpz,"",&kol,kaw1) != 0)
 return(1);
sspp1(kaw1,1,&kol);
int nomer_ved=0;


itogo=0.;
SQLCURSOR curr;
while(fgets(str,sizeof(str),kaw) != NULL)
 {
  memset(bros,'\0',sizeof(bros));
  tabn=(long)ATOFM(str);
  if(tabn != 0)
   {
    it=in=iu=ius=0.;

    sprintf(strsql,"select fio from Kartb where tabn=%ld",tabn);
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      beep();
      printw("%s %ld !\n",
      gettext("Не найден табельный номер"),tabn);
      OSTANOV();
      continue;
     }

    strncpy(fio,row1[0],sizeof(fio));

    /*Чтение сальдо*/
    sal=0.;
    sal=zarsald(1,mn,gn,tabn,&saldb);

    sprintf(strsql,"select * from Zarp where datz >= '%d-%02d-01' and \
datz <= '%d-%02d-31' and tabn=%ld order by prn,knah asc",
    gn,mn,gn,mn,tabn);
    SQLCURSOR cur;
    if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
     {
      printw("%s\n",sql_error(&bd));
      OSTANOV();
     }

    if(kolstr == 0)
     {
      beep();
      printw("%s %ld !\n",
      gettext("Нет данных для"),tabn);
      continue;
     }

    while(cur.read_cursor(&row) != 0)
     {
      rsdat(&d,&m,&g,row[0],2);
      prn=atoi(row[2]);
      if(prn == 1 && nahis[0] != '\0')
       if(proverka(nahis,row1[3],0,0) != 0)
          continue;
      knah=atoi(row[3]);
      sym=atof(row[4]);
      gz=atoi(row[6]);
      mz=atoi(row[7]);
      if(prn == 1)
       {
	in+=sym;
       }

      mkvk=0;
      if(prn == 2)
       {
        if(gz != gn || mz != mn)
  	  mkvk=1;

        if(mkvk == 0)
	 ius+=sym;
	iu+=sym;
       }
     }

    if(uhsl == 0)
      it=in+iu+ sal;
    if(uhsl == 1)
      it=in+ius+prbper(mn,gn,bf->tm_mon+1,bf->tm_year+1900,tabn,&sumabu,0,NULL);

    if(it < 0.)
     it=0.;
    itogo+=it;

    memset(bros,'\0',sizeof(bros));
    prnb(it,bros);

    printw("%-7ld %-*s %15s\n",
    tabn,
    iceb_tu_kolbait(30,fio),fio,
    bros);

    if(it != 0.)
      fprintf(kaw1,"%-3d %-7ld %-*s %15s\n\
...................................................................\n",
      ++nomer_ved,tabn,
      iceb_tu_kolbait(30,fio),fio,
      bros);
   }
 }
memset(bros,'\0',sizeof(bros));
prnb(itogo,bros);

/*********
fprintf(kaw1,"\
----------------------------------------------------------------\n\
%38s:%15s\n",gettext("Итого"),bros);
****************/

printw("\n%s: %s\n",gettext("Итого"),bros);


itog(kaw1,itogo);
podpis(kaw1);



fclose(kaw);
fclose(kaw1);
OSTANOV();
oth->spis_imaf.plus(imaf1);
oth->spis_naim.plus(gettext("Ведомость зарплаты по произвольному списку"));
iceb_t_ustpeh(imaf1,1);
return(0);
}
