/* $Id: zarstomn.c,v 5.24 2011-01-13 13:43:25 sasa1 Exp $ */
/*15.12.2009	25.03.2000	Белых А.И.	zarstomn.c
Меню для запуска определения доли бюджетных денег в выдаче на руки и в
платежах (удержаниях).
Отчет разработан для бюджетных организаций
*/
#include        <time.h>
#include        <errno.h>
#include        <math.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void		zarstom(short,short,short,short,char*,char*,char*,FILE*,FILE*,FILE*);

extern short	mmm,ggg;

int zarstomn(class spis_oth *oth)
{
static char	dat1[11];
static char	dat2[11];
static char     podr[112];
static char     tabn[112];
static char     grupap[112];
int		kom=0,kom1=0;
char		naimp[512];
short		mn,gn,mk,gk;
FILE		*kaw;
FILE		*ffhoz;
FILE		*ffbud;
char		imaf[32];
char		imafhoz[32];
char		imafbud[32];
class iceb_tu_str fiov("");
time_t		tmm;
int tabnom=0;
int pod=0;
char bros[512];

VVOD MENU(3);

if(dat1[0] == '\0')
 sprintf(dat1,"%d.%d",mmm,ggg);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Расчет долей бюджетных счетов."));

VV.VVOD_SPISOK_add_data(dat1,8);
VV.VVOD_SPISOK_add_data(dat2,8);
VV.VVOD_SPISOK_add_data(podr,sizeof(podr));
VV.VVOD_SPISOK_add_data(tabn,sizeof(tabn));
VV.VVOD_SPISOK_add_data(grupap,sizeof(grupap));

VV.VVOD_SPISOK_add_MD(gettext("Дата начала.....(м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Дата конца......(м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения.(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Табельный номер...(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Группа под-ния....(,,)."));

naz:;

clear(); 

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчет"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(dat2,VV.VVOD_SPISOK_return_data(1),sizeof(dat2)-1);
strncpy(podr,VV.VVOD_SPISOK_return_data(2),sizeof(podr)-1);
strncpy(tabn,VV.VVOD_SPISOK_return_data(3),sizeof(tabn)-1);
strncpy(grupap,VV.VVOD_SPISOK_return_data(4),sizeof(grupap)-1);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp4_5_3.txt");
   goto naz;

  case FK10:
  case ESC:
   return(1);

  case FK5:
  case FK2:
  case PLU:
   break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка табельных номеров."));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп."));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход."));
    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3 :
      case -1:
       goto naz;

      case 0 :
       if(vibrek("Podr",podr,sizeof(podr),naimp) == 0)
          VV.VVOD_SPISOK_zapis_data(2,podr);
       break;

      case 1 :
       fiov.new_plus("");
       if(dirtab(&tabnom,&fiov,pod,1) == 0)
        {
         sprintf(bros,"%d",tabnom);
          VV.VVOD_SPISOK_zapis_data(3,bros);
                  
        }
       break;
       
      case 2 :
       if(vibrek("Zargrupp",grupap,sizeof(grupap),naimp) == 0)
          VV.VVOD_SPISOK_zapis_data(4,grupap);
       
       break;
     }
    goto naz;
    

  case FK4: /*Очистить меню*/
  
    memset(dat1,'\0',sizeof(dat1));
    memset(dat2,'\0',sizeof(dat2));
    memset(podr,'\0',sizeof(podr));
    goto naz;

  default:
    goto naz;
 }

if(rsdat1(&mn,&gn,dat1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата начала !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
if(dat2[0] == '\0')
 {
  mk=mn; gk=gn;
 }
else
 if(rsdat1(&mk,&gk,dat2) != 0)
  {
   VVOD SOOB(1);
   SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата конца !"));
   soobshw(&SOOB,stdscr,-1,-1,0,1);
   goto naz;
  }

time(&tmm);
clear();

sprintf(imaf,"stom%d.lst",getpid());
if((kaw = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return(1);
   }

sprintf(imafhoz,"hoz%d.lst",getpid());
if((ffhoz = fopen(imafhoz,"w")) == NULL)
   {
    error_op_nfil(imafhoz,errno,"");
    return(1);
   }

sprintf(imafbud,"bud%d.lst",getpid());
if((ffbud = fopen(imafbud,"w")) == NULL)
   {
    error_op_nfil(imafbud,errno,"");
    return(1);
   }


zarstom(mn,gn,mk,gk,podr,tabn,grupap,kaw,ffhoz,ffbud);



fclose(kaw);
fclose(ffhoz);
fclose(ffbud);

iceb_t_ustpeh(imaf,0);
iceb_t_ustpeh(imafhoz,0);
iceb_t_ustpeh(imafbud,0);

printw_vr(tmm);


OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчет долей бюджетных счетов."));
oth->spis_imaf.plus(imafhoz);
oth->spis_naim.plus(gettext("Хозрасчёт"));
oth->spis_imaf.plus(imafbud);
oth->spis_naim.plus(gettext("Бюджет"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),3);
 
return(0);

}
