/*$Id: zvb_ibank2ua_start.c,v 5.9 2011-01-13 13:43:25 sasa1 Exp $*/
/*19.09.2008	18.09.2008	Белых А.И. 	zvb_ibank2ua_start.c
Начало формирования данных для зачисления на карт-счета для системы iBank2 UA
Если вернули 0-шапка сформирована
             1-нет
*/

#include        <errno.h>
#include    "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


extern char *organ;

int zvb_ibank2ua_start(char *imafr,//имя файла распечатки
char *imaf, //имя файла в электронном виде
class iceb_tu_str *vidnahis,
const char *kod00,
FILE **ff,  //Файл в электонном виде
FILE **ffr) //Файл распечатки
{
short d_pp=0,m_pp=0,g_pp=0; //Дата платёжки
static char data_pp[11];
static char nomer_pp[24];
static char data_zp[8];
static char vid_nah[112];

strcpy(vid_nah,"Заробітна плата та аванси");

VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG("Формирование файлов для системы iBank2 UA");

VV.VVOD_SPISOK_add_MD("Дата документа.............");
VV.VVOD_SPISOK_add_MD("Номер документа............");
VV.VVOD_SPISOK_add_MD("Заработная плата за (м.г)..");
VV.VVOD_SPISOK_add_MD("Вид начисления.............");

VV.VVOD_SPISOK_add_data(data_pp,sizeof(data_pp));
VV.VVOD_SPISOK_add_data(nomer_pp,sizeof(nomer_pp));
VV.VVOD_SPISOK_add_data(data_zp,sizeof(data_zp));
VV.VVOD_SPISOK_add_data(vid_nah,sizeof(vid_nah));


naz:;

helstr(LINES-1,0,\
//"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);


int kom=VV.vvod(0,1,1,-1,-1);

move(LINES-1,0);

strcpy(data_pp,VV.VVOD_SPISOK_return_data(0));
strcpy(nomer_pp,VV.VVOD_SPISOK_return_data(1));
strcpy(data_zp,VV.VVOD_SPISOK_return_data(2));
strcpy(vid_nah,VV.VVOD_SPISOK_return_data(3));

vidnahis->new_plus(vid_nah);

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
//   prosf(strsql);
   goto naz;

  case ESC:
  case FK10:
   return(1);

  case FK2:
  case PLU:
     break;

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }

if(rsdat(&d_pp,&m_pp,&g_pp,VV.data_ravno(0),1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не правильно введена дата документа!"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
   
 }
short mz,gz;
if(rsdat1(&mz,&gz,VV.data_ravno(2)) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD("Не правильно введена дата зарплаты!");
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
   
 }

time_t vrem;
struct tm *bf;
time(&vrem);
bf=localtime(&vrem);


//int suma_kop=(int)(suma*100.);
sprintf(imaf,"ibank2ua.txt");
if((*ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }
sprintf(imafr,"ibank2ua%d.txt",getpid());
if((*ffr = fopen(imafr,"w")) == NULL)
 {
  error_op_nfil(imafr,errno,"");
  return(1);
 }

fprintf(*ffr,"%s\n\n",organ);



fprintf(*ffr,"\
          ЗВЕДЕНА ВІДОМІСТЬ,\n\
      працівників %s \n\
      по заробітній платі за %02d місяць %d р.,\n\
      перерахований за платіжним дорученням N%s\n\
      від %02d.%02d.%d р.\n",organ,mz,gz,nomer_pp,d_pp,m_pp,g_pp);

fprintf(*ffr,"\
-------------------------------------------------------------------------\n");
fprintf(*ffr,"\
 Н/п | Призвище,і'мя, по батькові   |   ІНН    |Номер рахунку|  Сумма    |\n");
/*
12345 123456789012345678901234567890 1234567890 1234567890123 1234567890
*/
fprintf(*ffr,"\
-------------------------------------------------------------------------\n");
class iceb_tu_str naim_kontr("");
class iceb_tu_str mfo("");
class iceb_tu_str naim_bank("");
class iceb_tu_str shet_sp("");
SQL_str row;
class SQLCURSOR cur;
char strsql[512];
/*узнаём реквизиты организации*/
sprintf(strsql,"select naikon,naiban,mfo,nomsh from Kontragent where kodkon='%s'",kod00);
if(readkey(strsql,&row,&cur) == 1)
 {
  naim_kontr.new_plus(row[0]);
  naim_bank.new_plus(row[1]);
  mfo.new_plus(row[2]);
  shet_sp.new_plus(row[3]);
 }

fprintf(*ff,"\
Content-Type=doc/pay_sheet\n\n\
DATE_DOC=%02d.%02d.%04d\n\
NUM_DOC=%s\n\
CLN_NAME=%s\n\
PAYER_BANK_MFO=%s\n\
PAYER_BANK_NAME=%s\n\
PAYER_ACCOUNT=%s\n",
d_pp,m_pp,g_pp,
nomer_pp,
naim_kontr.ravno(),
mfo.ravno(),
naim_bank.ravno(),
shet_sp.ravno());





return(0);
}
