/*$Id: zvb_nadra.c,v 5.19 2011-01-13 13:43:25 sasa1 Exp $*/
/*21.09.2007	26.09.2003	Белых А.И.	zvb_nadra.c
Получение распечатки для передачи данных по зарплате в банк Надра
*/
#include        <errno.h>
#include    "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern char *organ;

void	zvb_nadra(short prn,char *zapros,struct dirnupoi *poisk)
{
char		strsql[512];
int		kolstr=0;
SQL_str		row,row1;
SQLCURSOR curr;
char		bros[512];
char		rukov[512];
char            glavbuh[512];
FILE		*ff;
char            imaf[32];

memset(rukov,'\0',sizeof(rukov));
memset(glavbuh,'\0',sizeof(glavbuh));

iceb_t_poldan("Табельный номер руководителя",bros,"zarnast.alx");
if(bros[0] != '\0')
 {
  sprintf(strsql,"select fio from Kartb where tabn=%s",bros);
  if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
    strncpy(rukov,row1[0],sizeof(rukov)-1);
 } 

iceb_t_poldan("Табельный номер бухгалтера",bros,"zarnast.alx");

if(bros[0] != '\0')
 {
  sprintf(strsql,"select fio,inn,telef from Kartb where tabn=%s",bros);
  if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
    strncpy(glavbuh,row1[0],sizeof(glavbuh)-1);
 }

SQLCURSOR cur;

if((kolstr=cur.make_cursor(&bd,zapros)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),zapros);
  return;
 }

sprintf(imaf,"nadra%d.lst",iceb_t_getuid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

fprintf(ff,"\
                                      до Договору про надання послуг\n\
                                      N___________\"____\"________2003р.\n\n\
      Підприємство %s\n\n\
                     Зведена відомість N_____від \"_____\"____________р.\n\n",organ);
                     

fprintf(ff,"\
----------------------------------------------------------------------------\n\
 N  |N картрахунку|  Тип картки  |          ПІБ                 |   Сумма  |\n\
----------------------------------------------------------------------------\n"); 
double suma=0;
char fio[512];
char kshet[32];
double itogo=0.;
char tipkk[32];

int kolstr1=0;
int nomer=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(poidirnu(row,poisk,fio) != 0)
     continue;

  memset(fio,'\0',sizeof(fio));
  memset(kshet,'\0',sizeof(kshet));
  memset(tipkk,'\0',sizeof(tipkk));
  //Читем карточку
  sprintf(strsql,"select fio,bankshet,tipkk from Kartb where tabn=%s",row[1]);
  if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
   {
    strncpy(fio,row1[0],sizeof(fio)-1);
    strncpy(kshet,row1[1],sizeof(kshet)-1);
    strncpy(tipkk,row1[2],sizeof(tipkk)-1);
   }
  suma=atof(row[4]);
  
  if(prn == 2)
   suma*=-1;
   
  itogo+=suma;
    
  fprintf(ff,"%-4d %-13s %-14s %-*.*s %10.2f\n",
  ++nomer,kshet,tipkk,
  iceb_tu_kolbait(30,fio),iceb_tu_kolbait(30,fio),fio,
  suma);

 }
fprintf(ff,"\
----------------------------------------------------------------------------\n");

fprintf(ff,"\
Загальна сумма до виплати, грн.                                   %10.2f\n",itogo);

fprintf(ff,"\
Сумма коміссії Банку, грн.\n\
Загальна сумма для перерахування в банк, грн.\n\
Дата виплати заробітної плати,\n\n");

fprintf(ff,"\
Керівник           _____________________ %s\n\n\
Головний бухгалтер _____________________ %s\n",rukov,glavbuh);

fclose(ff);

class spis_oth oth;

oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Распечатка документов для перечисления на карт-счета"));

iceb_t_ustpeh(imaf,3);

iceb_t_rabfil(&oth,"");

}

