/*$Id: dirkatl.c,v 5.8 2011-01-13 13:43:30 sasa1 Exp $*/
/*17.10.2010	27.04.2001	Белых А.И.	dirkatl.c
Просмотр текущего каталога файлов с целью выбора нужного
файла
Если вернули 0 - выбрали файл
             1 - нет
*/
#include        <sys/types.h>
#include        <sys/stat.h>
#include        <time.h>
#include        <string.h>
#include	"buhl.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


int dirkatl(class iceb_tu_str *imafil)
{
struct  tm      *bf;
struct stat work;
class SPISOK	masfil; /*Массив с именами файлов*/
int		kolfil=0;
int		prc;
char		name[512];
int		K=0;
char		metkafil[6];
class iceb_t_mstr spis_menu(0);
char		bros[512];

naz1:;

kolfil=dirfajl("*",0,&masfil);

if(kolfil == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одного файла !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

spis_menu.spis_str.free_class();
int ns=0;
for(int ii=0 ; ii < kolfil ; ii++)
 {
  strcpy(name,masfil.ravno(ii));  
  if(stat(name,&work) != 0)
   {
//    beep();
//    printw("\nИмя файла - %s\n",name);
//    OSTANOV();
    return(1);
   }
  memset(metkafil,'\0',sizeof(metkafil));
  switch(work.st_mode & S_IFMT)
   {
    case S_IFREG: //Обычный файл
      break;
    case S_IFDIR: //Каталог
      strcpy(metkafil,"/");
      break;
   }
  bf=localtime(&work.st_mtime);

  sprintf(bros,"%s%-*s %6ld %02d:%02d %02d.%02d.%d",
  metkafil,
  iceb_tu_kolbait(20,name),name,
  work.st_size,bf->tm_hour,
  bf->tm_min,bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900);
  ns++;
  spis_menu.spis_str.plus(bros);

 }


naz:;

prc=100;

helstr(LINES-1,0,"F1",gettext("помощь"),
"F10",gettext("выход"),NULL);
memset(bros,'\0',sizeof(bros));
int nomer=spis_menu.menu(0,0,0,NULL,bros,prc,&K,gettext("Выберите файл"),0);


switch(K)
 {
  case ENTER: 
    pole3(spis_menu.spis_str.ravno(nomer),imafil,1,' ');
 
    if(imafil->ravno()[0] == '/')
     {
      sprintf(bros,"%s",iceb_tu_adrsimv(1,imafil->ravno()));
      if(chdir(bros) != 0)
       {
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD("Не могу сменить каталог !");
        SOOB.VVOD_SPISOK_add_MD(bros);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
       }
      goto naz1;
     }
    return(0);

  case FK10: 
  case ESC: 
    return(1);  
  default:
    goto naz;
 }

}
