/* $Id: dirshet.c,v 5.59 2011-01-13 13:43:30 sasa1 Exp $ */
/*12.12.2010    18.02.1993      Белых А.И.      dirshet.c
Подпрограмма просмотра плана счетов
Если вернули 0 значит выбрали
*/
#include        <errno.h>
#include	"buhl.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif
class dirshet_poi
 {
  public:
   class iceb_tu_str naim;
   class iceb_tu_str shet;
   class iceb_tu_str kod_subbal;
   short metka_poi; //0-не искать 1-искать
   int vplsh; /*0-двух уровневый план счетов 1-многоуровневый*/
   dirshet_poi()
    {
      clear_data();
     vplsh=0;
    }
   void clear_data()
    {
     metka_poi=0;
      naim.new_plus("");
      shet.new_plus("");
      kod_subbal.new_plus("");
    }
 };
 
void            shbh1(int,class dirshet_poi*);
void		korshet(const char*,const char*);
void		vsn(int,int,int,int,uid_t,time_t,VVOD*);
int dirshet_prov(SQL_str row,class dirshet_poi *poir);
void dirshet_vrp(class dirshet_poi *poir);
void dirshet_vksb(const char *shet,int);
void dirshet_ras(int kolstr,class SQLCURSOR *cur,class dirshet_poi *poir);

extern char     *organ;/*Наименование организации*/

int dirshet(class iceb_tu_str *ns, //Номер счета
class iceb_tu_str *naimshet, //Наименование счета
int vp) //0-ввод и корректировка 1-просмотр с выбором
{
int             x=0,y=2;  /*Позиция вывода списка*/
class iceb_tu_str na(""); /*Наименование счета*/
int             tipsh=0; /*Тип счета*/
int             vidsh=0; /*Вид счета*/
int		saldo=0; /*0-свернутое 3-развернутое*/
int             i,prc;
int             kom;
char            tip[40];
char            vid[40];
int             tp;
int             vd;
int             K;
char            zns[40];
SQL_str         row;
int		kolstr,pozz1;
long    	pozz;
char		strsql[512];
short		mspz;
char		bros[512];
time_t		vrem=0;
uid_t		ktoi=0;
char		msald[32];
short		status=0;
class dirshet_poi poir;
class iceb_t_mstr spis_menu(0);
//class iceb_tu_str imaf_n;

//imafn("nastrb.alx",&imaf_n);
if(iceb_t_poldan("Многопорядковый план счетов",strsql,"nastrb.alx") == 0)
 if(SRAV("Вкл",strsql,1) == 0)
  poir.vplsh=1;

VVOD DANET(1);
VVOD VVOD1(2);
VVOD VV(0);


kom=pozz=0;

naz1:;
clear();

GDITE();
short           kls=LINES-5; /*Количество строк в меню*/

K=0;
sprintf(strsql,"select * from Plansh order by ns asc");
SQLCURSOR cur;
SQLCURSOR cur1;

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,"",strsql);
  return(1);
 }  
if(kolstr == 0)
 {
lll:;
  shbh1(vp,&poir);

  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  K=soobshw(&SOOB,stdscr,-1,-1,1,1);

  if(K == FK2 || K == PLU || K == FK1 || K == FK4 || K == FK10 \
  || K == ESC)
    goto vper;

  if(K == KEY_RESIZE)
    goto naz1;
    
  goto lll;
 }
 
naz:;
GDITE();
clear();
if(kolstr != 0 && pozz > kolstr)
  pozz = kolstr-1;

memset(zns,'\0',sizeof(zns));



cur.poz_cursor(pozz);
mspz=2;
pozz1=0;
char kod_subbal[10];

spis_menu.spis_str.free_class();
for(i=0;i<=kls-1;)
 {
  if(cur.read_cursor(&row) == 0)
    break;
  pozz1++;

  if(dirshet_prov(row,&poir) != 0)
   continue;
  
  tp=atoi(row[2]);
  vd=atoi(row[3]);
  
  memset(tip,'\0',sizeof(tip));
  if(tp == 0)
    strcpy(tip,gettext("Активный"));
  if(tp == 1)
    strcpy(tip,gettext("Пасивный"));
  if(tp == 2)
    strcpy(tip,gettext("Ак.-пас."));

  memset(msald,'\0',sizeof(msald));
  if(row[6][0] == '3')
    strcpy(msald,gettext("Р/с"));

  memset(vid,'\0',sizeof(vid));
  if(row[7][0] == '1')
   strcpy(vid,"*");   
  if(vd == 0)
    strcat(vid,gettext("Счет"));
  if(vd == 1)
    strcat(vid,gettext("Субс."));
  memset(kod_subbal,'\0',sizeof(kod_subbal));
  if(row[9][0] != '0')
   strcpy(kod_subbal,row[9]);
/*
  sprintf(LL.MD[i++],"%-6s|%-40.40s|%-6.6s|%-3s|%s",
  row[0],row[1],vid,msald,tip);
*/
  sprintf(strsql,"%-*s|%-*.*s|%-*.*s|%-*s|%s|%s",
  iceb_tu_kolbait(6,row[0]),row[0],
  iceb_tu_kolbait(40,row[1]),iceb_tu_kolbait(40,row[1]),row[1],
  iceb_tu_kolbait(6,vid),iceb_tu_kolbait(6,vid),vid,
  iceb_tu_kolbait(3,msald),msald,
  tip,kod_subbal);

  i++;
  spis_menu.spis_str.plus(strsql);

  if(pozz1 == 1) /*Первая запись удовлетворяет условиям поиска*/
     mspz=1;
 }

if(kom >= i)
  kom=i-1;

if(kom < 0)
 kom=0;

if(i == 0)
 {
  if(kolstr > 0 && pozz > 0)
   {
    pozz--;
    goto naz;
   }
  goto lll;
 }
if(i <=kls-1)
  spis_menu.spis_str.plus(gettext("Конец списка"));

shbh1(vp,&poir);

prc=(pozz1+pozz)*100/kolstr;
memset(strsql,'\0',sizeof(strsql));
kom=spis_menu.menu(kom,y,x,NULL,strsql,prc,&K,"",0);


if(kom == -7) //Изменение размеров экрана
  goto naz1;
  
if(kom == -3) /*Стрелка вниз*/
 {
  if(i <kls)
   {
    beep();
    goto naz;
   }
  for(i=0; i < mspz  ; )
   {
    pozz++;

    cur.poz_cursor(pozz);
    if(cur.read_cursor(&row) == 0)
      break;

//    if(poisk[0] != '\0' && strstrm(row[1],poisk) == 0)
//      continue;
    if(dirshet_prov(row,&poir) != 0)
     continue;
    i++;
   }
  kom=kls;
  goto naz;
 }
if(kom == -2) /*Стрелка вверх*/
 {
  for(i=0; i < 1 ; )
   {

    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    cur.read_cursor(&row);

//    if(poisk[0] != '\0' && strstrm(row[1],poisk) == 0)
//      continue;
    if(dirshet_prov(row,&poir) != 0)
     continue;
    i++;
   }

  goto naz;
 }
 
if(kom == -5) /*Страница вниз*/
 {
  if(pozz + kls == kolstr)
   {
    pozz=kolstr-1;
    beep();
    goto naz;  
   }
  if(i == kls)
    pozz+=pozz1;
  else
    beep();
  if(pozz >= kolstr)
   {
    pozz=kolstr-pozz1;
    beep();
    goto naz;  
   }
/*  
  printw("\n вперед pozz=%d\n",pozz);
  OSTANOV();
*/
  goto naz;

 }

if(kom == -4) /*Страница вверх*/
 {
/*
  printw("\npozz=%d\n",pozz);
  refresh();
*/
  for(i=0; i<kls ; )
   {
    pozz--;

    if(pozz <= 0)
     {
      beep();
      pozz=0;
      goto naz;
     }

    cur.poz_cursor(pozz);
    cur.read_cursor(&row);

//    if(poisk[0] != '\0' && strstrm(row[1],poisk) == 0)
//      continue;
    if(dirshet_prov(row,&poir) != 0)
     continue;
    i++;
   }
  goto naz;
 }

if(kom >= 0)
 {
  if(SRAV(gettext("Конец списка"),spis_menu.spis_str.ravno(kom),0) == 0)
     goto naz;
  if(pozz+kom >= kolstr)
   goto naz; /*Стали на конец списка*/
 
  polen(spis_menu.spis_str.ravno(kom),bros,sizeof(bros),1,'|');
  sprintf(strsql,"select * from Plansh where ns='%s'",bros);
  if(sql_readkey(&bd,strsql,&row,&cur1) != 1)
   {

    sprintf(strsql,gettext("Не найден счет %s в плане счетов !"),bros);

    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
  ns->new_plus(row[0]);
  na.new_plus(row[1]);
  ktoi=atoi(row[4]);
  vrem=atol(row[5]);
  tipsh=atoi(row[2]); 
  vidsh=atoi(row[3]); 
  saldo=atoi(row[6]);
  status=atoi(row[7]);
 }

vper:;

switch (K)
 {
  case FK10: /*Выход*/
  case ESC : /*Выход*/
     return(1);
  case ENTER : /*Выход*/
     if(vp == 0)
       goto sfk2;          

     if(naimshet != NULL)
       naimshet->new_plus(na.ravno());

     return(0);

  case FK1:   /*Получить подсказку*/
   
   GDITE();
   iceb_t_pdoc("buhg4_1.txt");
   clear();
   goto naz;

  case SFK2:   /*Корректировать*/

sfk2:;
    VV.VVOD_delete();
    VV.VVOD_SPISOK_add_data(ns->ravno(),24);
    VV.VVOD_SPISOK_add_data(na.ravno(),56);
    VV.VVOD_SPISOK_add_data(24);
    VV.VVOD_SPISOK_add_data(24);
    VV.VVOD_SPISOK_add_data(32);
    VV.VVOD_SPISOK_add_data(32);

    if(tipsh == 0)
      VV.VVOD_SPISOK_zapis_data(2,gettext("Активный"));
    if(tipsh == 1)
      VV.VVOD_SPISOK_zapis_data(2,gettext("Пасивный"));
    if(tipsh == 2)
      VV.VVOD_SPISOK_zapis_data(2,gettext("Активно-пасивный"));

    if(vidsh == 0)
      VV.VVOD_SPISOK_zapis_data(3,gettext("Счет"));
    if(vidsh == 1)
      VV.VVOD_SPISOK_zapis_data(3,gettext("Субсчет"));

    if(saldo == 0)
      VV.VVOD_SPISOK_zapis_data(4,gettext("Свернутое"));
    if(saldo == 3)
      VV.VVOD_SPISOK_zapis_data(4,gettext("Развернутое"));

    if(status == 0)
      VV.VVOD_SPISOK_zapis_data(5,gettext("Балансовый")); 
    if(status == 1)
      VV.VVOD_SPISOK_zapis_data(5,gettext("Внебалансовый")); 

    vsn(1,tipsh,vidsh,saldo,ktoi,vrem,&VV);

    goto naz1;

  case FK2:  /*Ввести */
  case PLU:

    VV.VVOD_delete();
    VV.VVOD_SPISOK_add_data(20);
    VV.VVOD_SPISOK_add_data(50);
    VV.VVOD_SPISOK_add_data(20);
    VV.VVOD_SPISOK_add_data(20);
    VV.VVOD_SPISOK_add_data(30);
    VV.VVOD_SPISOK_add_data(gettext("Балансовый"),30);
  

    vsn(0,0,0,0,iceb_t_getuid(),0,&VV);
  
    goto naz1;

  case FK3: /*Удалить*/

    DANET.VVOD_delete();
    DANET.VVOD_SPISOK_add_MD(gettext("Удалить ? Вы уверены ?"));

    if(danet(&DANET,2,stdscr) == 1)
     {
      if(provud("Plansh",ns->ravno(),1) != 0)
        goto naz;
      sprintf(strsql,"delete from Plansh where ns='%s'",ns->ravno());
      if(sql_zap(&bd,strsql) != 0)
       {
       if(sql_nerror(&bd) == ER_DBACCESS_DENIED_ERROR) //Толко чтение
        {
         VVOD SOOB(1);
         SOOB.VVOD_SPISOK_add_MD(gettext("У вас нет полномочий для выполнения этой операции !"));
         soobshw(&SOOB,stdscr,-1,-1,0,1);
        }
       else
        msql_error(&bd,gettext("Ошибка удаления записи !"),strsql);
       }
     }
    clear();

    goto naz1;

  case FK4:     //ввод реквизитов поиска
    dirshet_vrp(&poir);

    clear();
    kom=pozz=0;
    if(kolstr == 0)
       goto lll;
    else
       goto naz;

  case FK5: /*Распечатка*/
    dirshet_ras(kolstr,&cur,&poir);
    clear(); /*Очистить экран и закрасить фоновым цветом*/
    goto naz;

  case FK6: //Ввести код суббаланса
    dirshet_vksb(ns->ravno(),poir.vplsh);
    goto naz1;
      
  default:
    if(kolstr > 0)
     goto naz;
    else
     goto lll;
 }
}

/****************************/
/*Ввод и корректировка счета*/
/****************************/

void    vsn(int mk, //0-ввод нового 1-корректировка старого
int tips,int vids,int saldo,uid_t ktoi,time_t vremv,VVOD *VV)
{
int             st;
int             N;
int             PR;
int             K;
char		shz[20];
time_t  	vrem;
char		bros[512];
int		kl,dan;
char		strsql[512];
char		naishet[1024];
short		metkor;
int		saldoz=saldo;
short		status=0,statusz=0;

strcpy(shz,VV->VVOD_SPISOK_return_data(0));

status=statusz=0;
if(SRAV(VV->VVOD_SPISOK_return_data(5),gettext("Внебалансовый"),0) == 0)
 status=statusz=1;
metkor=N=0;

VV->VVOD_SPISOK_add_ZAG(gettext("Ввод и корректировка счетов"));
kzvz(ktoi,vremv,VV);

VV->VVOD_SPISOK_add_MD(gettext("Номер счета........"));
VV->VVOD_SPISOK_add_MD(gettext("Наименование счета."));
VV->VVOD_SPISOK_add_MD(gettext("Тип счета.........."));
VV->VVOD_SPISOK_add_MD(gettext("Вид счета.........."));
VV->VVOD_SPISOK_add_MD(gettext("Сальдо............."));
VV->VVOD_SPISOK_add_MD(gettext("Статус............."));

ooo:;


helstr(LINES-1,0,"F2/+",gettext("запись"),"F10",
gettext("выход"),NULL);


VV->vramka(-1,-1,0);

attron(VV->VVOD_return_cs(iceb_CFS)); 


PR=0;
VV->vprintw(N,stdscr);

for(;;)
 {
  K=getch();
  attroff(VV->VVOD_return_cs(iceb_CFS));
  attron(VV->VVOD_return_cs(iceb_CFM));

  VV->vprintw(N,stdscr);

  if(K == KEY_MOUSE)
    K=mouseklic(&N,VV->PY,VV->PX,VV->MDLS,VV->KLST,stdscr);

  if(K == ENTER)
   {
    attroff(VV->VVOD_return_cs(iceb_CFM));
    attron(VV->VVOD_return_cs(iceb_CFV));
    VV->vprintw_clear(N,stdscr);

    if(N == 0)  /*Номер счета*/
     {
//      mygetstr(VV->VVOD_SPISOK_return_data(N),VV->VVOD_SPISOK_return_dls(N),stdscr);
      VV->vgetstr(N,stdscr);
      
      /*Убираем пробелы в конце счета*/
      if((kl=strlen(VV->VVOD_SPISOK_return_data(N))) > 0)
      {
       memset(bros,'\0',sizeof(bros));
       strcpy(bros,VV->VVOD_SPISOK_return_data(N));
       for(dan=kl-1; bros[dan] == ' '|| bros[dan] == '\t';dan--)
	bros[dan]='\0';

       VV->VVOD_SPISOK_zapis_data(N,bros);
      }

      N++;
      attroff(VV->VVOD_return_cs(iceb_CFV));
      attron(VV->VVOD_return_cs(iceb_CFM));
      goto ooo;
     }

    if(N == 1)   /*Наименование счета*/
     {
//      mygetstr(VV->VVOD_SPISOK_return_data(N),VV->VVOD_SPISOK_return_dls(N),stdscr);
      VV->vgetstr(N,stdscr);
      N++;
      attroff(VV->VVOD_return_cs(iceb_CFV));
      attron(VV->VVOD_return_cs(iceb_CFM));
      goto ooo;
     }

    if(N == 2)   /*Тип счета*/
     {
      attroff(VV->VVOD_return_cs(iceb_CFV));
      attron(VV->VVOD_return_cs(iceb_CFM));

      clearstr(LINES-1,0);

      VVOD MENUW(3);
      MENUW.VVOD_SPISOK_add_ZAG(gettext("Выберите тип счета"));

      MENUW.VVOD_SPISOK_add_MD(gettext("Активный"));
      MENUW.VVOD_SPISOK_add_MD(gettext("Пасивный"));
      MENUW.VVOD_SPISOK_add_MD(gettext("Активно-пасивный"));
      st=0;
      if(menu3w(stdscr,&MENUW,&st,-1,-1,0) != 0)
       goto ooo;
      if(st < 0)
       goto ooo;
             
      VV->VVOD_SPISOK_zapis_data(N,MENUW.VVOD_SPISOK_return_MD(st));
      
      tips=st;
      N++;
      attroff(VV->VVOD_return_cs(iceb_CFV));
      attron(VV->VVOD_return_cs(iceb_CFM));
      goto ooo;
     }
    if(N == 3)   /*Вид счета*/
     {
      attroff(VV->VVOD_return_cs(iceb_CFV));
      attron(VV->VVOD_return_cs(iceb_CFM));
      
      clearstr(LINES-1,0);
      VVOD MENUW(3);
      MENUW.VVOD_SPISOK_add_ZAG(gettext("Выберите вид счета"));
      MENUW.VVOD_SPISOK_add_MD(gettext("Счет"));
      MENUW.VVOD_SPISOK_add_MD(gettext("Субсчет"));
      st=0;
      if(menu3w(stdscr,&MENUW,&st,-1,-1,0) != 0)
       goto ooo;
      if(st < 0)
       goto ooo;

      VV->VVOD_SPISOK_zapis_data(N,MENUW.VVOD_SPISOK_return_MD(st));
      vids=st;
      N++;
      goto ooo;
     }

    if(N == 4)   /*Сальдо*/
     {
      attroff(VV->VVOD_return_cs(iceb_CFV));
      attron(VV->VVOD_return_cs(iceb_CFM));

      clearstr(LINES-1,0);
      VVOD MENUW(3);
      MENUW.VVOD_SPISOK_add_ZAG(gettext("Выберите тип сальдо"));
      MENUW.VVOD_SPISOK_add_MD(gettext("Свернутое"));
      MENUW.VVOD_SPISOK_add_MD(gettext("Развернутое"));
      st=0;
      if(menu3w(stdscr,&MENUW,&st,-1,-1,0) != 0)
       goto ooo;
      if(st < 0)
       goto ooo;

      VV->VVOD_SPISOK_zapis_data(N,MENUW.VVOD_SPISOK_return_MD(st));
      
      saldo=st;
      if(st == 1)
       saldo=3;
      if(saldoz == 0 && saldo == 3 && shz[0] != '\0')
       {
        GDITE();
        //Проверяем есть ли проводки по этому счету
        sprintf(strsql,"select distinct sh from Prov where sh='%s' \
and kodkon='' limit 1",shz);
        if(sql_readkey(&bd,strsql) > 0)
         {
          VVOD SOOB(1);
          SOOB.VVOD_SPISOK_add_MD(gettext("По этому счету уже введены проводки без кода контрагента !"));
          SOOB.VVOD_SPISOK_add_MD(gettext("Сальдо можно развернуть после удаления этих проводок"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          saldo=0;
          VV->VVOD_SPISOK_zapis_data(N,gettext("Свернутое"));
         }
       }       
      goto ooo;
     }
    if(N == 5)   /*Статус счета*/
     {
      attroff(VV->VVOD_return_cs(iceb_CFV));
      attron(VV->VVOD_return_cs(iceb_CFM));

      clearstr(LINES-1,0);
      VVOD MENUW(3);
      MENUW.VVOD_SPISOK_add_MD(gettext("Балансовый"));
      MENUW.VVOD_SPISOK_add_MD(gettext("Внебалансовый"));
      MENUW.VVOD_SPISOK_add_ZAG(gettext("Выберите статус счета"));
      st=0;
      if(menu3w(stdscr,&MENUW,&st,-1,-1,0) != 0)
       goto ooo;
      if(st < 0)
       goto ooo;

      VV->VVOD_SPISOK_zapis_data(N,MENUW.VVOD_SPISOK_return_MD(st));
      status=st;
      if(statusz != status)
       {
        GDITE();
        //Проверяем есть ли проводки по этому счету
        sprintf(strsql,"select distinct sh from Prov where sh='%s' limit 1",
        shz);
        if(sql_readkey(&bd,strsql) > 0)
         {
          VVOD SOOB(1);
          SOOB.VVOD_SPISOK_add_MD(gettext("По этому счету уже введены проводки !"));
          SOOB.VVOD_SPISOK_add_MD(gettext("Статус можно изменить только после удаления всех проводок по этому счету"));
          soobshw(&SOOB,stdscr,-1,-1,0,1);
          if(statusz == 0)
           {
            status=0;
            VV->VVOD_SPISOK_zapis_data(N,gettext("Балансовый"));
           }
          if(statusz == 1)
           {
            status=1;
            VV->VVOD_SPISOK_zapis_data(N,gettext("Внебалансовый"));
           }
         }
       }       
      goto ooo;
     }
    attroff(VV->VVOD_return_cs(iceb_CFV));
    attron(VV->VVOD_return_cs(iceb_CFM));
   }
  if(K==SDN) /*Стрелка вниз*/
   {
    N++;
   }
  if(K==SUP) /*Стрелка вверх*/
   {
    N--;
   }
  if(N > VV->KLST-1)
   {
    N=0;
   }
  if(N < 0)
   {
    N=VV->KLST-1;
   }
  attron(VV->VVOD_return_cs(iceb_CFS)); 
  VV->vprintw(N,stdscr);

  if(K == FK10)
   {
    attroff(VV->VVOD_return_cs(iceb_CFS));
    attron(VV->VVOD_return_cs(iceb_CFM));
    break;
   }
  if(K == ESC)
   {
    attroff(VV->VVOD_return_cs(iceb_CFS));
    attron(VV->VVOD_return_cs(iceb_CFM));
#ifndef M_UNIX
      getch();
#endif
    N=-1;
    break;
   }
  if(K == FK2 || K == PLU) /*Записать*/
   {
    attroff(VV->VVOD_return_cs(iceb_CFS));
    attron(VV->VVOD_return_cs(iceb_CFM));
    
    if(VV->VVOD_SPISOK_return_data(0)[0] == '\0')
     {
      VVOD SOOB(1);
      SOOB.VVOD_SPISOK_add_MD(gettext("Не введен номер счета !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto ooo;
     }

    if(mk == 0)
     {
      /*Проверяем есть ли такой счет в плане счетов*/
      sprintf(strsql,"select ns from Plansh where ns='%s'",
      VV->VVOD_SPISOK_return_data(0));

      if(sql_readkey(&bd,strsql) >= 1)
       {
        sprintf(strsql,
        gettext("Счет %s уже есть в плане счетов !"),
        VV->VVOD_SPISOK_return_data(0));
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        goto ooo;
       }      
     }
    metkor=0;
    if(mk == 1 && SRAV(VV->VVOD_SPISOK_return_data(0),shz,0) != 0)
     {
      /*Проверяем есть ли такой счет в плане счетов*/
      sprintf(strsql,"select ns from Plansh where ns='%s'",
      VV->VVOD_SPISOK_return_data(0));

      if(sql_readkey(&bd,strsql) >= 1)
       {
        sprintf(strsql,
        gettext("Счет %s уже есть в плане счетов !"),
        VV->VVOD_SPISOK_return_data(0));

        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        goto ooo;
       }      

      VVOD DANET(1);
      DANET.VVOD_SPISOK_add_MD(gettext("Кооректировать номер счета ? Вы уверены !"));

      if(danet(&DANET,2,stdscr) == 2)
        goto ooo;

      metkor=1;
      
     }

    time(&vrem);
    
    strncpy(naishet,VV->VVOD_SPISOK_return_data(1),sizeof(naishet));
        
    sqlfiltr(naishet,sizeof(naishet));


    if(mk == 0)        
      sprintf(strsql,"insert into Plansh \
values ('%s','%s',%d,%d,%d,%ld,%d,%d,%d,%d)",
      VV->VVOD_SPISOK_return_data(0),naishet,tips,vids,iceb_t_getuid(),
      vrem,saldo,status,0,0);

    if(mk == 1)
      sprintf(strsql,"update Plansh \
set \
ns='%s',\
nais='%s',\
tips=%d,\
vids=%d,\
ktoi=%d,\
vrem=%ld,\
saldo=%d,\
stat=%d,\
val=%d \
where ns='%s'",
       VV->VVOD_SPISOK_return_data(0),naishet,tips,vids,iceb_t_getuid(),
       vrem,saldo,status,0,shz);
/*
    printw("\nstrsql=%s\n",strsql);
    refresh();
    OSTANOV();
*/
    GDITE();
    if(sql_zap(&bd,strsql) != 0)
     {
     if(sql_nerror(&bd) == ER_DBACCESS_DENIED_ERROR) //Толко чтение
      {
       VVOD SOOB(1);
       SOOB.VVOD_SPISOK_add_MD(gettext("У вас нет полномочий для выполнения этой операции !"));
       soobshw(&SOOB,stdscr,-1,-1,0,1);
       goto ooo;
      }
     else
      {
       msql_error(&bd,gettext("Ошибка записи !"),strsql);
       goto ooo;
      }
     }
    if(metkor == 1)
      korshet(shz,VV->VVOD_SPISOK_return_data(0));

    break;
   }
 }
attroff(VV->VVOD_return_cs(iceb_CFS));

attron(VV->VVOD_return_cs(iceb_CB));
}

/********************/
/*Шапка плана счетов*/
/********************/
void shbh1(int vp, //0-ввод и корректировка 1-просмотр с выбором
class dirshet_poi *poir)
{
/*set 11*/
if(vp == 0)
 {
  mvprintw(0,0,gettext("Ввод и корректировка плана счетов"));
  printw("  ");
  if(poir->vplsh == 0)
   printw(gettext("Двухпорядковый"));
  if(poir->vplsh == 1)
   printw(gettext("Многопорядковый"));
   
 }
if(vp == 1)
  mvprintw(0,0,gettext("Выберите счет с которым вы будете работать"));
int YY=1;
if(poir->metka_poi == 1)
 {
//  attron(A_BLINK);
  mvprintw(YY++,COLS-20,"%20s",gettext("Поиск:"));
  if(poir->naim.getdlinna() > 1)
   mvprintw(YY++,COLS-20,"%20s",poir->naim.ravno());
  if(poir->shet.getdlinna() > 1)
   mvprintw(YY++,COLS-20,"%20s",poir->shet.ravno());
  if(poir->kod_subbal.getdlinna() > 1)
   mvprintw(YY++,COLS-20,"%20s",poir->kod_subbal.ravno());


//  attroff(A_BLINK);
 }
helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("запись"),
"F3",gettext("удалить"),
"F4",gettext("поиск"),
"F5",gettext("печать"),
"F6",gettext("код суббаланса"),
"F10",gettext("выход."),NULL);
}
/*******************************************************************/
/*Подпрограмма каскадной корректировки номера счета во всех таблицах*/
/**********************************************************************/

void korshet(const char *sshet, //Старый номер счета
const char *nshet)  //Новый номер счета
{
char		strsql[512];

VVOD SOOBN(1);
SOOBN.VVOD_SPISOK_add_MD(gettext("Выполняется каскадная корректировка номера счета в таблицах !"));
soobsh(&SOOBN,-1,-1,1);

GDITE();

sprintf(strsql,"update Skontr set ns='%s' where ns='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
 {
 if(sql_nerror(&bd) == ER_DBACCESS_DENIED_ERROR) //Толко чтение
  {
   VVOD SOOB(1);
   SOOB.VVOD_SPISOK_add_MD(gettext("У вас нет полномочий для выполнения этой операции !"));
   soobshw(&SOOB,stdscr,-1,-1,0,1);
   return;
  }
 else
  {
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
   return;
  }
 }
sprintf(strsql,"update Saldo set ns='%s' where ns='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);


sprintf(strsql,"update Prov set sh='%s' where sh='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Prov set shk='%s' where shk='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Kart set shetu='%s' where shetu='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);


sprintf(strsql,"update Kartb set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Nash set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);


sprintf(strsql,"update Uder set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);


sprintf(strsql,"update Zarp set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);


sprintf(strsql,"update Zarn set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Zarn1 set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Zarsoc set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Zarsocz set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Uosinp set shetu='%s' where shetu='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Uslugi set shetu='%s' where shetu='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
sprintf(strsql,"update Usldokum1 set shetu='%s' where shetu='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
sprintf(strsql,"update Usldokum2 set shetu='%s' where shetu='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Kas set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Kasop1 set shetkas='%s' where shetkas='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Kasop1 set shetkor='%s' where shetkor='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Kasop2 set shetkas='%s' where shetkas='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Kasop2 set shetkor='%s' where shetkor='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Kasord set shetk='%s' where shetk='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Ukrkras set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
  if(sql_nerror(&bd) != ER_NO_SUCH_TABLE)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Ukrdok1 set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
  if(sql_nerror(&bd) != ER_NO_SUCH_TABLE)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Upldok2 set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
  if(sql_nerror(&bd) != ER_NO_SUCH_TABLE)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Uplost set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
  if(sql_nerror(&bd) != ER_NO_SUCH_TABLE)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

sprintf(strsql,"update Opldok set shet='%s' where shet='%s'",nshet,sshet);

if(sql_zap(&bd,strsql) != 0)
  if(sql_nerror(&bd) != ER_NO_SUCH_TABLE)
   msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

}
/****************************************/
/*Ввод и корректировка реквизитов поиска*/
/****************************************/

void dirshet_vrp(class dirshet_poi *poir)
{

VVOD  VV(0);


VV.VVOD_SPISOK_add_ZAG(gettext("Введите данные для поиска"));

VV.VVOD_SPISOK_add_MD(gettext("Наименование счёта..."));//0
VV.VVOD_SPISOK_add_MD(gettext("Номер счёта.........."));//1
VV.VVOD_SPISOK_add_MD(gettext("Код суббаланса..(,,)."));//2



VV.VVOD_SPISOK_add_data(poir->naim.ravno(),100);//0
VV.VVOD_SPISOK_add_data(poir->shet.ravno(),20);//1
VV.VVOD_SPISOK_add_data(poir->kod_subbal.ravno(),100);//2

naz:;

helstr(LINES-1,0,"F2/+",gettext("поиск"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

int kl=VV.vvod(0,1,1,-1,-1);

poir->naim.new_plus(VV.VVOD_SPISOK_return_data(0));
poir->shet.new_plus(VV.VVOD_SPISOK_return_data(1));
poir->kod_subbal.new_plus(VV.VVOD_SPISOK_return_data(2));

switch(kl)
 {
  case FK10:
  case ESC:
     poir->metka_poi=0;
     break;

  case FK2:
  case PLU:
     poir->metka_poi=1;
     break;

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();
    goto naz;      

  default:
    goto naz;

 }

}
/****************************/
/*Проверка на условия поиска*/
/****************************/

int dirshet_prov(SQL_str row,class dirshet_poi *poir)
{
if(poir->metka_poi == 0)
 return(0);
 
if(poir->naim.getdlinna() > 1)
  if(strstrm(row[1],poir->naim.ravno()) == 0)
   return(1);

if(poir->shet.getdlinna() > 1)
 if(SRAV(poir->shet.ravno(),row[0],1) != 0)
  return(1);
if(proverka(poir->kod_subbal.ravno(),row[9],0,0) != 0)
 return(1);
    
return(0);

}
/****************************/
/*Ввод кода суббаланса для счёта*/
/********************************/

void dirshet_vksb(const char *shet,int vplsh)
{
char strsql[512];
SQL_str row;
class SQLCURSOR cur;
class iceb_tu_str kod("");
class iceb_tu_str naim("");

sprintf(strsql,"select vids,ksb from Plansh where ns like '%s%%' \
order by ns asc",shet);

if(readkey(strsql,&row,&cur) > 1)
 {
   if(vplsh == 0 && atoi(row[0]) == 0) //Двух-порядковый план счетов
    {
     VVOD SOOB(1);
     SOOB.VVOD_SPISOK_add_MD(gettext("Счёт имеет субсчета !"));
     soobshw(&SOOB,stdscr,-1,-1,0,1);
     return;     
    }

   if(vplsh == 1) //многопорядковый план счетов
    {
     VVOD SOOB(1);
     SOOB.VVOD_SPISOK_add_MD(gettext("Счёт имеет субсчета !"));
     soobshw(&SOOB,stdscr,-1,-1,0,1);
     return;     
    }
 }
class iceb_tu_str kod_subbal("");
if(atoi(row[1]) != 0)
 kod_subbal.new_plus(row[1]);


VVOD  VVOD1(2);
sprintf(strsql,"%s %s",gettext("Введите код суббаланса для счёта"),shet);
VVOD1.VVOD_SPISOK_add_MD(strsql);

naz:;

helstr(LINES-1,0,
"F3",gettext("код суббаланса"),
"F10",gettext("выход"),NULL);

int kom=0;

kom=vvod1(&kod_subbal,32,&VVOD1,NULL,stdscr,-1,-1);

switch(kom)
 {
  case ENTER:
    break;
  case FK3:
   kod.new_plus("");
   naim.new_plus("");
   
   if(dirsubbal(2,&kod,&naim) == 0)
    kod_subbal.new_plus(kod.ravno());
//   clear();
   goto naz;
   
  case FK10:
   return;
  
  default:
   goto naz;
 }

//проверяем код суббаланса
if(kod_subbal.getdlinna() > 1)
 {
  sprintf(strsql,"select kod from Glksubbal where kod=%s",kod_subbal.ravno());
  if(readkey(strsql) <= 0)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %s !",gettext("Не найден код суббаланса"),kod_subbal.ravno());
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    goto naz;
   }
 }
sprintf(strsql,"update Plansh set ksb=%d,vrem=%ld,ktoi=%d where ns='%s'",
kod_subbal.ravno_atoi(),
time(NULL),
iceb_t_getuid(),
shet);
sql_zapis(strsql,0,0);

}


/***********************/
/*Распечатка*/
/********************/
void dirshet_ras(int kolstr,class SQLCURSOR *cur,class dirshet_poi *poir)
{
FILE *ff;
char imaf[56];
struct  tm      *bf;
time_t          tmm;
char bros[312];

  sprintf(imaf,"plsh%d.lst",getpid());

  if((ff = fopen(imaf,"w")) == NULL)
    {
     error_op_nfil(imaf,errno,"");
     return;
    }
  time(&tmm);
  bf=localtime(&tmm);

  memset(bros,'\0',sizeof(bros));
  if(poir->vplsh == 0)
   strcpy(bros,gettext("Двухпорядковый"));
  if(poir->vplsh == 1)
   strcpy(bros,gettext("Многопорядковый"));

  fprintf(ff,"%s\n\n%s %s\n\
%s %d.%d.%d  %s: %02d:%02d:%02d\n\n",
  organ,gettext("План счетов"),
  bros,  
  gettext("По состоянию на"),
  bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
  gettext("Время"),
  bf->tm_hour,bf->tm_min,bf->tm_sec);
  fprintf(ff,"\
---------------------------------------------------------------------------------------------------------\n");  
  fprintf(ff,gettext("\
Номер |   Тип    |Сал|    Вид        |    Статус     |К.с.|Наименование\n"));
  fprintf(ff,gettext("\
счета |  счета   |ьдо|   счета       |     счета     |    |   счета\n"));

  fprintf(ff,"\
---------------------------------------------------------------------------------------------------------\n");  
int kolstr1=0;

cur->poz_cursor(0);
if(poir->kod_subbal.getdlinna() > 1)
   fprintf(ff,"%s:%s\n",gettext("Код суббалансу"),poir->kod_subbal.ravno());
SQL_str row;
int             tipsh; /*Тип счета*/
int             vidsh; /*Вид счета*/
char            tip[112];
char            vid[112];
char		msald[112];

while(cur->read_cursor(&row) != 0)
 {
    strzag(LINES-1,0,kolstr,++kolstr1);
    if(dirshet_prov(row,poir) != 0)
     continue;

    tipsh=atoi(row[2]);
    vidsh=atoi(row[3]);

    memset(tip,'\0',sizeof(tip));
    if(tipsh == 0)
      strcpy(tip,gettext("Активный"));
    if(tipsh == 1)
      strcpy(tip,gettext("Пасивный"));
    if(tipsh == 2)
      strcpy(tip,gettext("Ак.-пас."));

    memset(msald,'\0',sizeof(msald));
    if(row[6][0] == '3')
      strcpy(msald,gettext("Р/с"));

    memset(vid,'\0',sizeof(vid));
    if(vidsh == 0)
      strcpy(vid,gettext("Счет"));
    if(vidsh == 1)
      strcpy(vid,gettext("Субсчет"));
    if(row[7][0] == '0')
      strcpy(bros,gettext("Балансовый"));
    if(row[7][0] == '1')
      strcpy(bros,gettext("Внебалансовый"));

    fprintf(ff,"%-*s %-*s %-*s %-*s %-*s %-*s %s\n",
    iceb_tu_kolbait(6,row[0]),row[0],
    iceb_tu_kolbait(10,vid),vid,
    iceb_tu_kolbait(3,msald),msald,
    iceb_tu_kolbait(15,tip),tip,
    iceb_tu_kolbait(15,bros),bros,
    iceb_tu_kolbait(4,row[9]),row[9],
    row[1]);

 }
fprintf(ff,"\
---------------------------------------------------------------------------------------------------------\n");  
fprintf(ff,"%s: %d\n",gettext("Количество счетов"),kolstr);
podpis(ff);
fclose(ff);

class spis_oth oth;

oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Распечатка плана счетов"));
iceb_t_ustpeh(imaf,3);
iceb_t_rabfil(&oth,"");

}
