/* $Id: iceb_t_perzap.c,v 5.8 2011-01-13 13:43:31 sasa1 Exp $ */
/*24.03.2010	05.01.2000	Белых А.И.	perzap.c
Определение первого запуска программы в текущем дне
Если файла нет или дата в нем не равна текущей дате - значит
первый запуск,удаляем все файлы *.lst, и в файл записываем текущюю дату
Если вернули 0- всё впорядке
             1- нет
*/
#include        <errno.h>
#include        <time.h>
#include        "buhl.h"

int iceb_t_perzap1(short d,short m,short g,const char *imaf,int metka_udf);

extern char *imabaz;

int iceb_t_perzap(int metka) //0-удалять всегда 1-проверять включено удаление или нет
{
FILE		*ff;
char		imaf[56];
char		str[512];
short		d,m,g;
char		bros[512],bros1[512];
int metka_udf=0; /*0-удалять файлы 1-нет*/
if(metka == 1)
 {
  iceb_t_poldan("Удаление распечаток",bros,"nastsys.alx");
  if(SRAV(bros,"Вкл",1) != 0)
   {
    memset(bros1,'\0',sizeof(bros1));
    sprintf(bros1,"%s",".iceb_nastr.alx");
    poldan("Удаление распечаток",bros,bros1);
    if(SRAV(bros,"Вкл",1) != 0)
      metka_udf=1;
   }
 }

strcpy(imaf,".iceb.dat");
if((ff = fopen(imaf,"r")) == NULL)
 {
  if(errno != ENOENT)
   {
    error_op_nfil(imaf,errno,gettext("Аварийное завершение работы программы !"));
    return(1);
   }
  else
   return(iceb_t_perzap1(0,0,0,imaf,metka_udf));
 }

fgets(str,sizeof(str),ff);  
rsdat(&d,&m,&g,str,1);
fclose(ff);
return(iceb_t_perzap1(d,m,g,imaf,metka_udf));
return(0);
}
/************************/
/*************************/
int iceb_t_perzap1(short d,short m,short g,const char *imaf,int metka_udf)
{
struct  tm      *bf;
FILE *ff;

time_t tmm=time(&tmm);
bf=localtime(&tmm);

if((ff = fopen(imaf,"w")) == NULL)
 {
  if(errno == EACCES) /*Permission denied*/
   {
    error_op_nfil(imaf,errno,"Программа должна запускаться из домашнего каталога оператора!");
   }
  else
    error_op_nfil(imaf,errno,"");
  return(1);
 }
fprintf(ff,"%d.%d.%d\n%d:%d:%d\n",
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
bf->tm_hour,bf->tm_min,bf->tm_sec);

fprintf(ff,"NAMEBAZ|%s\n",imabaz);

fclose(ff);


if(d != bf->tm_mday || m != bf->tm_mon+1 || g != bf->tm_year+1900)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Здравcтвуйте!"));
  SOOB.VVOD_SPISOK_add_MD(gettext("Удачной вам работы и хорошего настроения!"));

  if(bf->tm_mday == 16 && bf->tm_mon+1 == 6)
   {
    SOOB.VVOD_SPISOK_add_MD(gettext("Можете поздравить с Днем рождения моего разработчика: Белых Александрa Ивановича"));
   }
  soobshw(&SOOB,stdscr,-1,-1,0,1);

  if(metka_udf == 0)
    iceb_t_delfil(".","lst,lst~,tmp,tmp~");
 }
return(0);
}

