/*$Id: iceb_t_spis_komp.c,v 5.10 2011-01-13 13:43:31 sasa1 Exp $*/
/*20.03.2010	13.12.2006	Белых А.И.	iceb_t_spis_komp.c
Подпрограмма для передачи файла на компъютер работающий под Windows
Если вернули 0 - файл передан 
             1 - нет
*/
#include <glib.h>
#include <errno.h>
#include <pwd.h>
#include	"buhl.h"

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

int iceb_t_vperecod(const char *imaf);


int iceb_t_spis_komp(const char *imaf)
{
char bros[1024];
char strok[1024];
class SPISOK str_nast;
class SPISOK naim_komp;
int metka_perecod=0; /*0-как есть 1-cp866 2-cp1251*/
char imaf_copy[56];

struct passwd *rek_login;

if((metka_perecod=iceb_t_vperecod(imaf))  < 0)
 return(1);



rek_login=getpwuid(getuid());

class iceb_tu_str imaf_nast;

imaf_nast.plus(rek_login->pw_dir);
imaf_nast.plus(G_DIR_SEPARATOR_S,".iceB");
imaf_nast.plus(G_DIR_SEPARATOR_S,"spis_komp.alx");

FILE *ff;

if((ff = fopen(imaf_nast.ravno(),"r")) == NULL)
 {
  error_op_nfil(imaf_nast.ravno(),errno,"");
  return(1);
 }

while(fgets(strok,sizeof(strok),ff) != NULL)
 {
  if(strok[0] == '#')
   continue;
  if(polen(strok,bros,sizeof(bros),1,'|') != 0)
   continue;
  if(bros[0] == '\0')
   continue;
  naim_komp.plus(bros);
  str_nast.plus(strok);   
 }
fclose(ff);
class iceb_tu_str ima_mah;
class iceb_tu_str ima_kat;
class iceb_tu_str parol;
class iceb_tu_str prog;

if(naim_komp.kolih() == 0)
 {
  iceb_t_soob(gettext("Не найдено настроек !"));
  return(1);
 }

int voz=0;
if(naim_komp.kolih() > 1)
 {
  int kod_kl=0;
  voz=dirmasiv(&naim_komp,-1,-1,0,gettext("Выберите куда копировать"),1,&kod_kl);
  if(voz < 0 || kod_kl != ENTER)
   return(1);
 }


if(metka_perecod > 0)
 {
  sprintf(imaf_copy,"iceb_t_spis_komp%d.tmp",getpid());
  iceb_t_cp(imaf,imaf_copy,0);
  perecod(metka_perecod,imaf);
 } 
polen(str_nast.ravno(voz),&ima_mah,2,'|');   
polen(str_nast.ravno(voz),&ima_kat,3,'|');   
polen(str_nast.ravno(voz),&parol,4,'|');   
polen(str_nast.ravno(voz),&prog,5,'|');   

sprintf(bros,"%s %s %s %s %s %s",prog.ravno(),ima_mah.ravno(),imaf,imaf,ima_kat.ravno(),parol.ravno());

int i=system(bros);

if(i != 0)
 {
  strcat(bros,"\n");
  sprintf(strok,gettext("Передача файла не произошла ! Код ошибки %d"),i);
  strcat(bros,strok);
  iceb_t_soob(bros);
 }
if(i == 0)
 {
  iceb_t_soob(gettext("Передача файла произошла успешно"));
 }     

if(metka_perecod > 0)
 rename(imaf_copy,imaf);
return(i);
}

