/*$Id: korkod.c,v 5.25 2011-01-21 09:14:15 sasa1 Exp $*/
/*27.03.2008	30.03.2000	Белых А.И.	korkod.c
Программа замены одного кода на другой во всех таблицах
*/
#include	"buhl.h"


void korkod(const char *tabl, //Имя таблицы
const char *skod, //Старый код
const char *nkod) //Новый код
{
char		strsql[512];

VVOD SOOBN(1);
SOOBN.VVOD_SPISOK_add_MD(gettext("Выполняется каскадная корректировка кода в таблицах !"));
soobsh(&SOOBN,-1,-1,1);

GDITE();

if(SRAV(tabl,"Kasop1",0) == 0)
 {
  sprintf(strsql,"update Kasord set kodop='%s' where kodop='%s' and tp=1",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
   {
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
    return;
   }
  sprintf(strsql,"update Prov set oper='%s' where oper='%s' and tz=1 and kto='%s'",nkod,skod,gettext("КО"));
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  return;
 }

if(SRAV(tabl,"Kasop2",0) == 0)
 {
  sprintf(strsql,"update Kasord set kodop='%s' where kodop='%s' and tp=2",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
   {
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
    return;
   }
  sprintf(strsql,"update Prov set oper='%s' where oper='%s' and tz=2 and kto='%s'",nkod,skod,gettext("КО"));
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  return;
 }

if(SRAV(tabl,"Usloper1",0) == 0)
 {
  sprintf(strsql,"update Usldokum set kodop='%s' where kodop='%s' and tp=1",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
   {
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
    return;
   }

  sprintf(strsql,"update Prov set oper='%s' where oper='%s' and tz=1 and kto='%s'",nkod,skod,gettext("УСЛ"));
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Reenn1 set ko='%s' where ko='%s'and mi=2",nkod,skod);
  sql_zapis(strsql,1,0);

  return;
 }

if(SRAV(tabl,"Usloper2",0) == 0)
 {
  sprintf(strsql,"update Usldokum set kodop='%s' where kodop='%s' and tp=2",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
   {
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
    return;
   }

  sprintf(strsql,"update Prov set oper='%s' where oper='%s' and tz=2 and kto='%s'",nkod,skod,gettext("УСЛ"));
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Reenn set ko='%s' where ko='%s' and mi=2",nkod,skod);
  sql_zapis(strsql,1,0);

  return;
 }

if(SRAV(tabl,"Uospri",0) == 0)
 {
  sprintf(strsql,"update Uosdok set kodop='%s' where kodop='%s' and tipz=1",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
   {
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
    return;
   }

  sprintf(strsql,"update Prov set oper='%s' where oper='%s' and tz=1 and kto='%s'",nkod,skod,gettext("УОС"));
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);


  sprintf(strsql,"update Reenn1 set ko='%s' where ko='%s'and mi=3",nkod,skod);
  sql_zapis(strsql,1,0);

  return;
 }

if(SRAV(tabl,"Uosras",0) == 0)
 {
  sprintf(strsql,"update Uosdok set kodop='%s' where kodop='%s' and tipz=2",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
   {
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
    return;
   }

  sprintf(strsql,"update Prov set oper='%s' where oper='%s' and tz=2 and kto='%s'",nkod,skod,gettext("УОС"));
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);


  sprintf(strsql,"update Reenn set ko='%s' where ko='%s'and mi=3",nkod,skod);
  sql_zapis(strsql,1,0);

  return;
 }

if(SRAV(tabl,"Rashod",0) == 0)
 {
  sprintf(strsql,"update Dokummat set kodop='%s' where kodop='%s' and tip=2",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
   {
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
    return;
   }

  sprintf(strsql,"update Prov set oper='%s' where oper='%s' and tz=2 and kto='%s'",nkod,skod,gettext("МУ"));
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Reenn set ko='%s' where ko='%s' and mi=1",nkod,skod);
  sql_zapis(strsql,1,0);


  return;
 }

if(SRAV(tabl,"Prihod",0) == 0)
 {

  sprintf(strsql,"update Dokummat set kodop='%s' where kodop='%s' and tip=1",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
   {
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
    return;
   }

  sprintf(strsql,"update Prov set oper='%s' where oper='%s' and tz=1 and kto='%s'",nkod,skod,gettext("МУ"));
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);


  sprintf(strsql,"update Reenn1 set ko='%s' where ko='%s'and mi=1",nkod,skod);
  sql_zapis(strsql,1,0);

  return;
 }

if(SRAV(tabl,"Uoshz",0) == 0)
 {
  sprintf(strsql,"update Uosinp set hzt='%s' where hzt='%s'",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Uosamor set hzt='%s' where hzt='%s'",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Uosamor1 set hzt='%s' where hzt='%s'",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
  return;
 }

if(SRAV(tabl,"Uoshau",0) == 0)
 {
  sprintf(strsql,"update Uosinp set hau='%s' where hau='%s'",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  return;
 }

if(SRAV(tabl,"Nash",0) == 0)
 {
  sprintf(strsql,"update Zarp set knah=%s where prn='1' and knah=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Zarn1 set knah=%s where prn='1' and knah=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
  return;
 }


if(SRAV(tabl,"Podr",0) == 0)
 {
  sprintf(strsql,"update Kartb set podr=%s where podr=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Zarn set podr=%s where podr=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Zarp set podr=%s where podr=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
  return;

 }

if(SRAV(tabl,"Kateg",0) == 0)
 {
  sprintf(strsql,"update Kartb set kateg=%s where kateg=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Zarn set kateg=%s where kateg=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  return;
 }

if(SRAV(tabl,"Zvan",0) == 0)
 {
  sprintf(strsql,"update Kartb set zvan=%s where zvan=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Zarn set zvan=%s where zvan=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  return;
 }

if(SRAV(tabl,"Tabel",0) == 0)
 {
  sprintf(strsql,"update Ztab set kodt=%s where kodt=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Nash set kodt=%s where kodt=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  return;
 }

if(SRAV(tabl,"Ktnp",0) == 0)
 {
  sprintf(strsql,"update Tpltp set nomd=%s where nomd=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Tpltpz set nomd=%s where nomd=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
  return;
 }

if(SRAV(tabl,"Ktnt",0) == 0)
 {
  sprintf(strsql,"update Tpltt set nomd=%s where nomd=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Tplttz set nomd=%s where nomd=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
  return;
 }

if(SRAV(tabl,"Edizmer",0) == 0)
 {
  sprintf(strsql,"update Material set ei='%s' where ei='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Roznica set ei='%s' where ei='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Dokummat1 set ei='%s' where ei='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Dokummat3 set ei='%s' where ei='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Kart set ei='%s' where ei='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Uslugi set ei='%s' where ei='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Usldokum1 set ei='%s' where ei='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Usldokum2 set ei='%s' where ei='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Ukrkras set eiz='%s' where eiz='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    if(sql_nerror(&bd) != ER_NO_SUCH_TABLE)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Ukrdok1 set ediz='%s' where ediz='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    if(sql_nerror(&bd) != ER_NO_SUCH_TABLE)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
  return;
 }

if(SRAV(tabl,"Grup",0) == 0)
 {
  sprintf(strsql,"update Material set kodgr=%s where kodgr=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
  return;
 }

if(SRAV(tabl,"Gkont",0) == 0)
 {
  sprintf(strsql,"update Kontragent set grup='%s' where grup='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
  return;
 }

if(SRAV(tabl,"Uslgrup",0) == 0)
 {
  sprintf(strsql,"update Uslugi set kodgr=%s where kodgr=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
  return;
 }

if(SRAV(tabl,"Uplgost",0) == 0)
 {
  sprintf(strsql,"update Uplost set kgr=%s where kgr=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
  return;
 }

if(SRAV(tabl,"Uosgrup",0) == 0)
 {
  sprintf(strsql,"update Uosinp set hna=%s where hna=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Uosamor set hna=%s where hna=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
  return;
 }

if(SRAV(tabl,"Uosgrup1",0) == 0)
 {
  sprintf(strsql,"update Uosinp set hnabu=%s where hnabu=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Uosamor1 set hna=%s where hna=%s",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
  return;
 }


if(SRAV(tabl,"Opltp",0) == 0)
 {
  sprintf(strsql,"update Pltp set oper='%s' where oper='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Tpltp set oper='%s' where oper='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Prov set oper='%s' where oper='%s' and tz=2 and kto='%s'",nkod,skod,gettext("ПЛТ"));
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  return;
 }

if(SRAV(tabl,"Opltt",0) == 0)
 {
  sprintf(strsql,"update Pltt set oper='%s' where oper='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Tpltt set oper='%s' where oper='%s'",
  nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  sprintf(strsql,"update Prov set oper='%s' where oper='%s' and tz=1 and kto='%s'",nkod,skod,gettext("ТРЕ"));
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);
  return;
 }

if(SRAV(tabl,"Reegrup1",0) == 0)
 {
  sprintf(strsql,"update Reenn set gr='%s' where gr='%s' and tp=1",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  return;
 }
if(SRAV(tabl,"Reegrup2",0) == 0)
 {
  sprintf(strsql,"update Reenn set gr='%s' where gr='%s' and tp=2",nkod,skod);
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка корректировки записи !"),strsql);

  return;
 }
 
VVOD SOOB(1);
SOOB.VVOD_SPISOK_add_MD("Для этой таблицы не предусмотрена корректировка !!!");
SOOB.VVOD_SPISOK_add_MD(tabl);
soobshw(&SOOB,stdscr,-1,-1,0,1);


}
