/*$Id: nastsys.c,v 5.13 2011-01-13 13:43:31 sasa1 Exp $*/
/*09.12.2010	23.09.1999	Белых А.И.	nastsys.c
Чтение системных настроек
Если вернули 0 файл прочитан
	     1-файл не найден
*/
#include        <errno.h>
#include "buhl.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

char *nameprinter=NULL; /*Имя принтера с которым будет работать программа lpr*/
int  kol_strok_na_liste=64; //Количесво строк на стандартном листе
int  kol_strok_na_liste_l=47; //Количесво строк на стандартном листе в ориентации ландшафт
class iceb_tu_str spis_print_a3; /*Список принтеров формата А3*/
extern int metka_utf8; /*0-односимвольная кодировка 1-utf8*/
extern class iceb_tu_str kodirovka_iceb; /*Определяется в icebstart.c*/

extern int iceb_kod_podsystem;

int nastsys()
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];
char		st1[1024];

if(iceb_kod_podsystem != 0)
 if(iceb_t_prr() != 0) /*проверка-разрешено ли работать с этой подсистемой оператору*/
  return(1);

kol_strok_na_liste=64;
kol_strok_na_liste_l=47;
spis_print_a3.new_plus("");

sprintf(strsql,"select str from Alx where fil='nastsys.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  iceb_t_soob("Не найдены настройки nastsys.alx");
  return(1);
 }

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  POLE(row_alx[0],st1,1,'|');

  if(SRAV(st1,"Количество строк на стандартном листе",0) == 0)
    {
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     kol_strok_na_liste=atoi(st1);
     continue;
    }

  if(SRAV(st1,"Количество строк на стандартном листе в ориентации ландшафт",0) == 0)
    {
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     kol_strok_na_liste_l=atoi(st1);
     continue;
    }
  if(SRAV(st1,"Список принтеров формата А3",0) == 0)
    {
     polen(row_alx[0],&spis_print_a3,2,'|');
     continue;
    }

  if(SRAV(st1,"Кодировка в которой работает iceB",0) == 0)
   {
    polen(row_alx[0],st1,sizeof(st1),2,'|');
    if(st1[0] != '\0')
     {
      kodirovka_iceb.new_plus(st1);
      if(strstrm(kodirovka_iceb.ravno(),"utf") == 1)
        metka_utf8=1;
     }
    continue;
   }
 }


if(kodirovka_iceb.getdlinna() <= 1)
 {
  kodirovka_iceb.new_plus("koi8u");
 }

nameprinter = getenv("PRINTER");

return(0);

}
