/*$Id: poigod.c,v 5.8 2011-01-13 13:43:31 sasa1 Exp $*/
/*05.11.2007	24.06.2000	Белых А.И.	poigod.c
Определение за какие годы введена в базу информация
*/
#include        <errno.h>
#include        "buhl.h"


void		poigod(int zapros)
/*
int		zapros; 
                          0-запрос по всем базам
			  1-главная книга
                          2-материальный учет
                          3-расчет зарплаты
                          4-учет основных средств
                          5-платежные поручения
                          6-платежные требования
                          7-объявки в банк
                          8-учет услуг
                          */
{
long		kolstr=0,kolstr1=0;
SQL_str         row;
char		strsql[512];
short		god,d,m,g;

clear();
printw("%s.\n",gettext("Перечень годов за которые имеется информация в базе данных"));
GDITE();
SQLCURSOR cur;
if(zapros == 1 || zapros == 0)
 {
  sprintf(strsql,"select distinct datp from Prov order by datp asc");
  /*
  printw("\n%s\n",strsql);
  refresh();
  */
  
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    printw("%s\n",sql_error(&bd));
    OSTANOV();
   }
  printw("%s.\n",gettext("База данных главной книги"));
  
  if(kolstr == 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    kolstr1=god=0;
    while(cur.read_cursor(&row) != 0)
     {
      kolstr1++;
      strzag(LINES-1,0,kolstr,kolstr1);
      rsdat(&d,&m,&g,row[0],2);
      if(god != g)
       {
        printw("%d\n",g);
        god=g;
       }
     }
   }
 }

if(zapros == 2 || zapros == 0)
 {
  sprintf(strsql,"select distinct datd from Dokummat order by datd asc");
  /*
  printw("\n%s\n",strsql);
  refresh();
  */
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    printw("%s\n",sql_error(&bd));
    OSTANOV();
   }
  printw("%s.\n",gettext("База данных материального учета"));
  
  if(kolstr == 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    kolstr1=god=0;
    while(cur.read_cursor(&row) != 0)
     {
      kolstr1++;
      strzag(LINES-1,0,kolstr,kolstr1);
      rsdat(&d,&m,&g,row[0],2);
      if(god != g)
       {
        printw("%d\n",g);
        god=g;
       }
     }
   }
 }

if(zapros == 3 || zapros == 0)
 {
  GDITE();
  sprintf(strsql,"select distinct god from Zarn order by god asc");
  /*
  printw("\n%s\n",strsql);
  refresh();
  */
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    printw("%s\n",sql_error(&bd));
    OSTANOV();
   }
  printw("%s.\n",gettext("База данных заработной платы"));

  if(kolstr == 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    while(cur.read_cursor(&row) != 0)
     printw("%s\n",row[0]);
   }
 }

if(zapros == 4 || zapros == 0)
 {
  sprintf(strsql,"select distinct datd from Uosdok order by datd asc");
  /*
  printw("\n%s\n",strsql);
  refresh();
  */
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    printw("%s\n",sql_error(&bd));
    OSTANOV();
   }
  printw("%s.\n",gettext("База данных учета основных средств"));
  
  if(kolstr == 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    kolstr1=god=0;
    while(cur.read_cursor(&row) != 0)
     {
      kolstr1++;
      strzag(LINES-1,0,kolstr,kolstr1);
      rsdat(&d,&m,&g,row[0],2);
      if(god != g)
       {
        printw("%d\n",g);
        god=g;
       }
     }
   }
 }

if(zapros == 5 || zapros == 0)
 {
  sprintf(strsql,"select distinct datd from Pltp order by datd asc");
  /*
  printw("\n%s\n",strsql);
  refresh();
  */
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    printw("%s\n",sql_error(&bd));
    OSTANOV();
   }
  printw("%s.\n",gettext("База данных платежных поручений"));
  
  if(kolstr == 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    kolstr1=god=0;
    while(cur.read_cursor(&row) != 0)
     {
      kolstr1++;
      strzag(LINES-1,0,kolstr,kolstr1);
      rsdat(&d,&m,&g,row[0],2);
      if(god != g)
       {
        printw("%d\n",g);
        god=g;
       }
     }
   }
  }

if(zapros == 6 || zapros == 0)
 {
  sprintf(strsql,"select distinct datd from Pltt order by datd asc");
  /*
  printw("\n%s\n",strsql);
  refresh();
  */
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    printw("%s\n",sql_error(&bd));
    OSTANOV();
   }
  printw("%s.\n",gettext("База данных платежных требований"));
  
  if(kolstr == 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    kolstr1=god=0;
    while(cur.read_cursor(&row) != 0)
     {
      kolstr1++;
      strzag(LINES-1,0,kolstr,kolstr1);
      rsdat(&d,&m,&g,row[0],2);
      if(god != g)
       {
        printw("%d\n",g);
        god=g;
       }
     }
   }
 }

if(zapros == 7 || zapros == 0)
 {
  sprintf(strsql,"select distinct datd from Obqvka order by datd asc");
  /*
  printw("\n%s\n",strsql);
  refresh();
  */
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    printw("%s\n",sql_error(&bd));
    OSTANOV();
   }
  printw("%s.\n",gettext("База данных объявок о сдаче наличных в банк"));
  
  if(kolstr == 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    kolstr1=god=0;
    while(cur.read_cursor(&row) != 0)
     {
      kolstr1++;
      strzag(LINES-1,0,kolstr,kolstr1);
      rsdat(&d,&m,&g,row[0],2);
      if(god != g)
       {
        printw("%d\n",g);
        god=g;
       }
     }
   }
 }

if(zapros == 8 || zapros == 0)
 {
  sprintf(strsql,"select distinct datd from Usldokum order by datd asc");
  /*
  printw("\n%s\n",strsql);
  refresh();
  */
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    printw("%s\n",sql_error(&bd));
    OSTANOV();
   }
  printw("%s.\n",gettext("База данных учета услуг"));
  
  if(kolstr == 0)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    kolstr1=god=0;
    while(cur.read_cursor(&row) != 0)
     {
      kolstr1++;
      strzag(LINES-1,0,kolstr,kolstr1);
      rsdat(&d,&m,&g,row[0],2);
      if(god != g)
       {
        printw("%d\n",g);
        god=g;
       }
     }
   }
 }

if(kolstr != 0)
  OSTANOV();

}
