/*$Id: zapmpr1.c,v 5.18 2011-03-09 08:17:05 sasa Exp $*/
/*04.09.2009	32.09.1998	Белых А.И.	zapmpr1.c
Запись проводок из пямяти в базу
*/
#include        <math.h>
#include        "buhl.h"


void zapmpr1(const char *nn, //Номер документа
const char *kop, //Код операции
int skk,    //Код склада/подразделения
time_t vrem, //Время записи
const char *kto, //Метка подсистемы
short dd,short md,short gd, //Дата документа
int tipz, //1-приход 2-расход 0-не определено
class SPISOK *sp_prov, /*Список проводок*/
class masiv_din_double *sum_prov_dk, /*Суммы по дебету/кредиту проводов*/
FILE *ff_prot)
{
short		i;
short		d,m,g;
char		datpr[20];
char		sh[40],shk[40];
char		kor1[40],kor2[40];
char		kom[1024];
double		deb,kre;
double		bb;
int		kolpr=0;
int		metkaprov=0;
int             kekv=0;

int kp=sp_prov->kolih();

if(kp == 0)
 return;
if(ff_prot != NULL)
  printw("\n%s-kp=%d nn=%s kto=%s kop=%s Дата:%d.%d.%d\n",
  __FUNCTION__,kp,nn,kto,kop,dd,md,gd);

for(i=0 ; i < kp; i++)
 {

  polen(sp_prov->ravno(i),datpr,sizeof(datpr),1,'|');
  rsdat(&d,&m,&g,datpr,0);

  polen(sp_prov->ravno(i),sh,sizeof(sh),2,'|');

  polen(sp_prov->ravno(i),shk,sizeof(shk),3,'|');

  polen(sp_prov->ravno(i),kor1,sizeof(kor1),4,'|');

  polen(sp_prov->ravno(i),kor2,sizeof(kor2),5,'|');

  polen(sp_prov->ravno(i),kom,sizeof(kom),6,'|');
  polen(sp_prov->ravno(i),&kolpr,7,'|');

  polen(sp_prov->ravno(i),&metkaprov,8,'|');

  polen(sp_prov->ravno(i),&kekv,10,'|');
    
  if(ff_prot != NULL)    
   fprintf(ff_prot,"%s:%d.%d.%d %-4s %-4s %-4s %-4s %8.2f %8.2f %s\n",
   __FUNCTION__,d,m,g,sh,shk,kor1,kor2,sum_prov_dk->ravno(i*2),sum_prov_dk->ravno(i*2+1),kom);

  sqlfiltr(kom,sizeof(kom));
  bb=sumvpr(sh,shk,dd,md,gd,nn,skk,kom,vrem,metkaprov,kto);

  deb=sum_prov_dk->ravno(i*2);
  kre=sum_prov_dk->ravno(i*2+1);
  if(fabs(deb) > 0.009)
   deb-=bb;
  if(fabs(kre) > 0.009)
   kre-=bb;

  deb=okrug(deb,0.01);
  kre=okrug(kre,0.01);
         
  if(fabs(kre) > 0.009 || fabs(deb) > 0.009 )
   {
    if(ff_prot != NULL)
     fprintf(ff_prot,"%s:Записываем проводку: deb=%f kre=%f\n",__FUNCTION__,deb,kre);     
    zapprov(metkaprov,g,m,d,sh,shk,kor1,kor2,kto,nn,kop,deb,kre,kom,kolpr,skk,vrem,gd,md,dd,tipz,kekv);
   }
 }

}
