/* $Id: util.h,v 5.109 2011-08-29 07:09:09 sasa Exp $ */
/*05.07.2011	04.03.1999	Белых А.И.	util.h
Описание подпрограмм утилит
*/
#include <scr.h>
#include <time.h>
#include <string.h>
#include "masiv.h"
#include "spisok.h"
#include "iceb_tu_str.h"
#include "iceb_tu_int.h"
#include "iceb_tu_file.h"

extern int 	vstavfil(const char*,FILE*);
extern void	kodkontr(char*,char*,const char*,const char*);
extern double	ATOFM(const char*);
extern void	BSTAB(char*,const char*,int,int,int);
extern void	BSTAB(char*,int,int,int,int);
extern int	dirmak1(char*,char*,int,int);
extern int	dirmak(char *name,char *proekt);
extern void	dpm(short*,short*,short*,short);
extern void	mesc(short,short,char*);
extern double	okrug(double,double);
extern short	period(short,short,short,short,short,short,short);
extern int	POLE(const char*,char*,int,char);
extern int	polen(char const*,char*,int,int,char);
extern int	polen(char const*,class SPISOK*,int,char);
extern int	polen(char const*,class masiv_din_int*,int,char);
extern int	polen(char const*,int*,int,char);
extern int	polen(char const*,short*,int,char);
extern int	polen(char const*,long*,int,char);
extern int	polen(char const*,double*,int,char);
extern int	polen(char const*,float*,int,char);
extern int	polen(char const*,class iceb_tu_str*,int,char);
extern short	pole1(const char*,const char*,char,short,int*);
extern int	pole2(const char*,char);
extern int	pole3(const char*,char*,int,char);
extern int	pole3(const char*,class iceb_tu_str*,int,char);
extern short	pole4(char*,char*,char);
extern void	preobr(double,char*,short);
extern void	prnb(double,char*);
extern void	prnb1(double,char*);
extern char	*prnbr(double);
extern int	rsdat(short*,short*,short*,char*,int);
extern int	rsdat(short*,short*,short*,const char*,int);
extern short	rsdat1(short*,short*,const char*);
extern void	slstr(char*,short,char*);
extern int	SRAV(const char*,const char*,int);
extern int	SRAV1(short,short,short,short,short,short);
extern int	strstrm(const char*,const char*);
extern int	FGETSS(char*,int,FILE*);
extern char	*prcn(double);
extern int	runsystem(const char*);
extern int	runsystem1(const char*,int);
extern int	readkey(int,char**,char**,char**,char**,int*,FILE*);
extern void	denrog(short*,short*,short*,int);
extern void 	sozdmas(char*,char**,long*,char);
extern void	sozmas(short**,char*);
extern void	sozmas(short**,char*,FILE*);
extern int	sravmydat(short,short,short,short,short,short);
extern int	sravmydat(const char *data1,const char *data2);
extern int	sravmydat(const char *data1,const char *data2,int metka);
extern int 	proverka(const char*,const char*,int,int);
extern int 	proverka(const char*,int,int,int);
extern void	zagolov(const char*,const char *datan,const char *datak,const char*,FILE*);
extern void	zagolov(const char*,struct tm*,short,short,short,short,short,short,const char*,FILE*);
extern void	zagolov(const char*,short,short,short,short,short,short,const char*,FILE*);
extern void	startfil(FILE*);
extern char	*workid();
extern int      rstime(short*,short*,short*,const char*);
extern void poltekdat(short *dt,short *mt,short *gt);
extern int kol_str(int max_kol_std_na_liste,int ras_kol_str);
extern int kol_str_l(int max_kol_std_na_liste,int ras_kol_str);
extern void    ud_lp(char *stroka);
extern void    ud_simv(char *stroka,const char*);
extern void iceb_tu_ekrs(char *stroka,int razmer,char ekran,const char *simv);
extern void iceb_tu_z_plus(char *stroka_in,int dlinna,char *stroka_plus);
extern void iceb_tu_tolower_str(char*);
extern void iceb_tu_toupper_str(char*);
extern int  iceb_tu_srav_r(const char*,const char*,int);
extern void iceb_tu_fplus(const char *stroka,class iceb_tu_str *stroka1,FILE *ff);
extern void iceb_tu_fplus(int metka_sp,const char *stroka,class SPISOK *stroka1,FILE *ff);
extern const char *iceb_tu_datzap(const char *data);
extern void iceb_tu_fio(const char *fio,class iceb_tu_str *fio_in);
extern int iceb_tu_zvstr(class iceb_tu_str *stroka,const char *obr,const char *zamena);
extern void iceb_tu_cpbstr(char *strin,int dlstrin,const char *strout,const char *udstr);
extern void iceb_tu_cpbstr(class iceb_tu_str *strin,const char *strout,const char *udstr);
extern void iceb_tu_cpbstr(class SPISOK *strin,const char *strout,const char *udstr);
extern int iceb_tu_ustpeh(int dlinna_stroki,int orient,FILE *ff);
extern int iceb_tu_cp(const char *imaf_out,const char *imaf_in);
extern int iceb_tu_cat(const char *imaf1,const char *imaf2);
extern const char *iceb_tu_adrsimv(int nomer_simv,const char *str);
extern int iceb_tu_kolbait(int kolih_simv,const char *str);
extern int iceb_tu_strlen(const char *stroka);
extern int poldan(const char *obr,char *str,const char *imaf);
extern int poldan(const char *obr,class iceb_tu_str *str,const char *imaf);
extern void iceb_tu_udsimv(char *stroka,int nomer_us);
void iceb_tu_vsimv(char *stroka,int dlinastr,int poz,const char *kodsimv);
extern void iceb_tu_zsimv(char *stroka,int dlinastr,int poz,const char *simvol);
extern const char *iceb_tu_dattosql(const char *data);
extern const char *iceb_tu_sqldata(const char *data);
extern const char *iceb_tu_vremzap(char *vrem);
extern const char *iceb_tu_vremzap(time_t vrem);
extern const char *iceb_tu_kszap(char *kto);
extern const char *iceb_tu_kszap(int kto);
extern const char *iceb_tu_getlogin();
const char *iceb_tu_sqlfiltr(const char *stroka);
const char *iceb_tu_filtr_xml(const char *stroka);
const char *iceb_tu_nofwords(double number);
const char *iceb_tu_propis(double hs,int metka_1s);


